# -*- coding: utf-8 -*- #
"""Cloud SDK static completion CLI tree."""
# pylint: disable=line-too-long,bad-continuation
STATIC_COMPLETION_CLI_TREE = {
  "commands": {
    "access-approval": {
      "commands": {
        "requests": {
          "commands": {
            "approve": {
              "commands": {},
              "flags": {}
            },
            "dismiss": {
              "commands": {},
              "flags": {}
            },
            "get": {
              "commands": {},
              "flags": {}
            },
            "invalidate": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--state": "value"
              }
            }
          },
          "flags": {}
        },
        "service-account": {
          "commands": {
            "get": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "value"
              }
            }
          },
          "flags": {}
        },
        "settings": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "value"
              }
            },
            "get": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--active_key_version": "value",
                "--enrolled_services": "value",
                "--folder": "value",
                "--notification_emails": "value",
                "--notification_pubsub_topic": "value",
                "--organization": "value",
                "--prefer_no_broad_approval_requests": "value",
                "--preferred_request_expiration_days": "value",
                "--request_scope_max_width_preference": [
                  "FOLDER",
                  "ORGANIZATION",
                  "PROJECT"
                ],
                "--require_customer_visible_justification": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "access-context-manager": {
      "commands": {
        "authorized-orgs": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--asset_type": [
                  "asset-type-credential-strength",
                  "asset-type-device",
                  "asset-type-unspecified"
                ],
                "--async": "bool",
                "--authorization_direction": [
                  "authorization-direction-from",
                  "authorization-direction-to",
                  "authorization-direction-unspecified"
                ],
                "--authorization_type": [
                  "authorization-type-trust",
                  "authorization-type-unspecified"
                ],
                "--orgs": "value",
                "--policy": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--policy": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--policy": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--policy": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-orgs": "value",
                "--clear-orgs": "bool",
                "--policy": "value",
                "--remove-orgs": "value",
                "--set-orgs": "value"
              }
            }
          },
          "flags": {}
        },
        "cloud-bindings": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--binding-file": "value",
                "--dry-run-level": "value",
                "--group-key": "value",
                "--level": "value",
                "--organization": "value",
                "--session-length": "value",
                "--session-reauth-method": [
                  "login",
                  "password",
                  "security-key"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--binding": "value",
                "--organization": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--binding": "value",
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--append": "bool",
                "--binding": "value",
                "--binding-file": "value",
                "--dry-run-level": "value",
                "--level": "value",
                "--organization": "value",
                "--session-length": "value",
                "--session-reauth-method": [
                  "login",
                  "password",
                  "security-key"
                ]
              }
            }
          },
          "flags": {}
        },
        "levels": {
          "commands": {
            "conditions": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--level": "value",
                    "--policy": "value"
                  }
                }
              },
              "flags": {}
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--basic-level-spec": "value",
                "--combine-function": [
                  "and",
                  "or"
                ],
                "--custom-level-spec": "value",
                "--description": "value",
                "--policy": "value",
                "--title": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--policy": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--policy": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--policy": "value",
                "--sort-by": "value"
              }
            },
            "replace-all": {
              "commands": {},
              "flags": {
                "--etag": "value",
                "--source-file": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--basic-level-spec": "value",
                "--combine-function": [
                  "and",
                  "or"
                ],
                "--custom-level-spec": "value",
                "--description": "value",
                "--policy": "value",
                "--title": "value"
              }
            }
          },
          "flags": {}
        },
        "perimeters": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--access-levels": "value",
                "--async": "bool",
                "--description": "value",
                "--egress-policies": "value",
                "--enable-vpc-accessible-services": "bool",
                "--ingress-policies": "value",
                "--perimeter-type": [
                  "bridge",
                  "regular"
                ],
                "--policy": "value",
                "--resources": "value",
                "--restricted-services": "value",
                "--title": "value",
                "--vpc-allowed-services": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--policy": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--policy": "value"
              }
            },
            "dry-run": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--access-levels": "value",
                    "--async": "bool",
                    "--egress-policies": "value",
                    "--enable-vpc-accessible-services": "bool",
                    "--ingress-policies": "value",
                    "--perimeter-access-levels": "value",
                    "--perimeter-description": "value",
                    "--perimeter-egress-policies": "value",
                    "--perimeter-enable-vpc-accessible-services": "bool",
                    "--perimeter-ingress-policies": "value",
                    "--perimeter-resources": "value",
                    "--perimeter-restricted-services": "value",
                    "--perimeter-title": "value",
                    "--perimeter-type": "value",
                    "--perimeter-vpc-allowed-services": "value",
                    "--policy": "value",
                    "--resources": "value",
                    "--restricted-services": "value",
                    "--vpc-allowed-services": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--policy": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--policy": "value"
                  }
                },
                "drop": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--policy": "value"
                  }
                },
                "enforce": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--policy": "value"
                  }
                },
                "enforce-all": {
                  "commands": {},
                  "flags": {
                    "--etag": "value",
                    "--policy": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--policy": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-access-levels": "value",
                    "--add-resources": "value",
                    "--add-restricted-services": "value",
                    "--add-vpc-allowed-services": "value",
                    "--async": "bool",
                    "--clear-access-levels": "bool",
                    "--clear-egress-policies": "bool",
                    "--clear-ingress-policies": "bool",
                    "--clear-resources": "bool",
                    "--clear-restricted-services": "bool",
                    "--clear-vpc-allowed-services": "bool",
                    "--enable-vpc-accessible-services": "bool",
                    "--etag": "value",
                    "--policy": "value",
                    "--remove-access-levels": "value",
                    "--remove-resources": "value",
                    "--remove-restricted-services": "value",
                    "--remove-vpc-allowed-services": "value",
                    "--set-egress-policies": "value",
                    "--set-ingress-policies": "value"
                  }
                }
              },
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--policy": "value",
                "--sort-by": "value"
              }
            },
            "replace-all": {
              "commands": {},
              "flags": {
                "--etag": "value",
                "--source-file": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-access-levels": "value",
                "--add-resources": "value",
                "--add-restricted-services": "value",
                "--add-vpc-allowed-services": "value",
                "--clear-access-levels": "bool",
                "--clear-egress-policies": "bool",
                "--clear-ingress-policies": "bool",
                "--clear-resources": "bool",
                "--clear-restricted-services": "bool",
                "--clear-vpc-allowed-services": "bool",
                "--description": "value",
                "--enable-vpc-accessible-services": "bool",
                "--etag": "value",
                "--policy": "value",
                "--remove-access-levels": "value",
                "--remove-resources": "value",
                "--remove-restricted-services": "value",
                "--remove-vpc-allowed-services": "value",
                "--set-access-levels": "value",
                "--set-egress-policies": "value",
                "--set-ingress-policies": "value",
                "--set-resources": "value",
                "--set-restricted-services": "value",
                "--title": "value",
                "--type": [
                  "bridge",
                  "regular"
                ]
              }
            }
          },
          "flags": {}
        },
        "policies": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--organization": "value",
                "--scopes": "value",
                "--title": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--title": "value"
              }
            }
          },
          "flags": {}
        },
        "supported-services": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "active-directory": {
      "commands": {
        "domains": {
          "commands": {
            "backups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--domain": "value",
                    "--labels": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--domain": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--domain": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--domain": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--domain": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "create": {
              "commands": {},
              "flags": {
                "--admin-name": "value",
                "--async": "bool",
                "--authorized-networks": "value",
                "--enable-audit-logs": "bool",
                "--labels": "value",
                "--region": "value",
                "--reserved-ip-range": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "describe-ldaps-settings": {
              "commands": {},
              "flags": {}
            },
            "extend-schema": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--ldif-file": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "reset-admin-password": {
              "commands": {},
              "flags": {}
            },
            "restore": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--backup": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {}
            },
            "trusts": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--direction": [
                      "bidirectional",
                      "inbound",
                      "outbound",
                      "trust-direction-unspecified"
                    ],
                    "--handshake-secret": "value",
                    "--selective-authentication": "bool",
                    "--target-dns-ip-addresses": "value",
                    "--target-domain-name": "value",
                    "--type": [
                      "external",
                      "forest",
                      "trust-type-unspecified"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--target-domain-name": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--target-dns-ip-addresses": "value",
                    "--target-domain-name": "value"
                  }
                },
                "validate-state": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--target-domain-name": "value"
                  }
                }
              },
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-authorized-networks": "value",
                "--add-region": "value",
                "--async": "bool",
                "--clear-labels": "bool",
                "--enable-audit-logs": "bool",
                "--remove-authorized-networks": "value",
                "--remove-labels": "value",
                "--remove-region": "value",
                "--update-labels": "value"
              }
            },
            "update-ldaps-settings": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--certificate-password": "value",
                "--certificate-pfx-file": "value",
                "--clear-certificates": "bool"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            }
          },
          "flags": {}
        },
        "peerings": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--authorized-network": "value",
                "--domain": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-labels": "bool",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "ai": {
      "commands": {
        "custom-jobs": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--args": "value",
                "--command": "value",
                "--config": "value",
                "--display-name": "value",
                "--enable-dashboard-access": "bool",
                "--enable-web-access": "bool",
                "--kms-key": "dynamic",
                "--kms-keyring": "dynamic",
                "--kms-location": "dynamic",
                "--kms-project": "dynamic",
                "--labels": "value",
                "--network": "value",
                "--persistent-resource-id": "value",
                "--python-package-uris": "value",
                "--region": "value",
                "--service-account": "value",
                "--worker-pool-spec": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "local-run": {
              "commands": {},
              "flags": {
                "--executor-image-uri": "value",
                "--extra-dirs": "value",
                "--extra-packages": "value",
                "--gpu": "bool",
                "--local-package-path": "value",
                "--output-image-uri": "value",
                "--python-module": "value",
                "--requirements": "value",
                "--script": "value",
                "--service-account-key-file": "value"
              }
            },
            "stream-logs": {
              "commands": {},
              "flags": {
                "--allow-multiline-logs": "bool",
                "--polling-interval": "value",
                "--region": "dynamic",
                "--task-name": "value"
              }
            }
          },
          "flags": {}
        },
        "endpoints": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--display-name": "value",
                "--encryption-kms-key-name": "value",
                "--endpoint-id": "value",
                "--labels": "value",
                "--network": "value",
                "--region": "value",
                "--request-response-logging-rate": "value",
                "--request-response-logging-table": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "deploy-model": {
              "commands": {},
              "flags": {
                "--accelerator": "value",
                "--autoscaling-metric-specs": "value",
                "--deployed-model-id": "value",
                "--disable-container-logging": "bool",
                "--display-name": "value",
                "--enable-access-logging": "bool",
                "--machine-type": "value",
                "--max-replica-count": "value",
                "--min-replica-count": "value",
                "--model": "value",
                "--region": "dynamic",
                "--reservation-affinity": "value",
                "--service-account": "value",
                "--spot": "bool",
                "--traffic-split": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "direct-predict": {
              "commands": {},
              "flags": {
                "--json-request": "value",
                "--region": "dynamic"
              }
            },
            "direct-raw-predict": {
              "commands": {},
              "flags": {
                "--json-request": "value",
                "--region": "dynamic"
              }
            },
            "explain": {
              "commands": {},
              "flags": {
                "--deployed-model-id": "value",
                "--json-request": "value",
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "predict": {
              "commands": {},
              "flags": {
                "--json-request": "value",
                "--region": "dynamic"
              }
            },
            "raw-predict": {
              "commands": {},
              "flags": {
                "--http-headers": "value",
                "--region": "dynamic",
                "--request": "value"
              }
            },
            "stream-direct-predict": {
              "commands": {},
              "flags": {
                "--json-request": "value",
                "--region": "dynamic"
              }
            },
            "stream-direct-raw-predict": {
              "commands": {},
              "flags": {
                "--json-request": "value",
                "--region": "dynamic"
              }
            },
            "stream-raw-predict": {
              "commands": {},
              "flags": {
                "--http-headers": "value",
                "--region": "dynamic",
                "--request": "value"
              }
            },
            "undeploy-model": {
              "commands": {},
              "flags": {
                "--deployed-model-id": "value",
                "--region": "dynamic",
                "--traffic-split": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-labels": "bool",
                "--clear-traffic-split": "bool",
                "--description": "value",
                "--disable-request-response-logging": "bool",
                "--display-name": "value",
                "--region": "dynamic",
                "--remove-labels": "value",
                "--request-response-logging-rate": "value",
                "--request-response-logging-table": "value",
                "--traffic-split": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "hp-tuning-jobs": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--algorithm": [
                  "algorithm-unspecified",
                  "grid-search",
                  "random-search"
                ],
                "--config": "value",
                "--display-name": "value",
                "--enable-dashboard-access": "bool",
                "--enable-web-access": "bool",
                "--kms-key": "dynamic",
                "--kms-keyring": "dynamic",
                "--kms-location": "dynamic",
                "--kms-project": "dynamic",
                "--labels": "value",
                "--max-trial-count": "value",
                "--network": "value",
                "--parallel-trial-count": "value",
                "--region": "value",
                "--service-account": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "stream-logs": {
              "commands": {},
              "flags": {
                "--allow-multiline-logs": "bool",
                "--polling-interval": "value",
                "--region": "dynamic",
                "--task-name": "value"
              }
            }
          },
          "flags": {}
        },
        "index-endpoints": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--display-name": "value",
                "--enable-private-service-connect": "bool",
                "--encryption-kms-key-name": "value",
                "--labels": "value",
                "--network": "value",
                "--project-allowlist": "value",
                "--public-endpoint-enabled": "bool",
                "--region": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "deploy-index": {
              "commands": {},
              "flags": {
                "--allowed-issuers": "value",
                "--audiences": "value",
                "--deployed-index-id": "value",
                "--deployment-group": "value",
                "--display-name": "value",
                "--enable-access-logging": "bool",
                "--index": "value",
                "--machine-type": "value",
                "--max-replica-count": "value",
                "--min-replica-count": "value",
                "--psc-automation-configs": "value",
                "--region": "dynamic",
                "--reserved-ip-ranges": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "mutate-deployed-index": {
              "commands": {},
              "flags": {
                "--allowed-issuers": "value",
                "--audiences": "value",
                "--deployed-index-id": "value",
                "--deployment-group": "value",
                "--enable-access-logging": "bool",
                "--machine-type": "value",
                "--max-replica-count": "value",
                "--min-replica-count": "value",
                "--region": "dynamic",
                "--reserved-ip-ranges": "value"
              }
            },
            "undeploy-index": {
              "commands": {},
              "flags": {
                "--deployed-index-id": "value",
                "--region": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-labels": "bool",
                "--description": "value",
                "--display-name": "value",
                "--region": "dynamic",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "indexes": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--display-name": "value",
                "--encryption-kms-key-name": "value",
                "--index-update-method": [
                  "batch-update",
                  "stream-update"
                ],
                "--labels": "value",
                "--metadata-file": "value",
                "--metadata-schema-uri": "value",
                "--region": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-datapoints": {
              "commands": {},
              "flags": {
                "--datapoint-ids": "value",
                "--datapoints-from-file": "value",
                "--region": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-labels": "bool",
                "--description": "value",
                "--display-name": "value",
                "--metadata-file": "value",
                "--region": "dynamic",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            },
            "upsert-datapoints": {
              "commands": {},
              "flags": {
                "--datapoints-from-file": "value",
                "--region": "dynamic",
                "--update-mask": "value"
              }
            }
          },
          "flags": {}
        },
        "model-monitoring-jobs": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--analysis-instance-schema": "value",
                "--anomaly-cloud-logging": "bool",
                "--bigquery-uri": "value",
                "--data-format": "value",
                "--dataset": "value",
                "--display-name": "value",
                "--emails": "value",
                "--endpoint": "value",
                "--feature-attribution-thresholds": "value",
                "--feature-thresholds": "value",
                "--gcs-uris": "value",
                "--kms-key": "dynamic",
                "--kms-keyring": "dynamic",
                "--kms-location": "dynamic",
                "--kms-project": "dynamic",
                "--labels": "value",
                "--log-ttl": "value",
                "--monitoring-config-from-file": "value",
                "--monitoring-frequency": "value",
                "--notification-channels": "value",
                "--predict-instance-schema": "value",
                "--prediction-sampling-rate": "value",
                "--region": "value",
                "--sample-predict-request": "value",
                "--target-field": "value",
                "--training-sampling-rate": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "pause": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "resume": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--analysis-instance-schema": "value",
                "--anomaly-cloud-logging": "bool",
                "--clear-labels": "bool",
                "--display-name": "value",
                "--emails": "value",
                "--feature-attribution-thresholds": "value",
                "--feature-thresholds": "value",
                "--log-ttl": "value",
                "--monitoring-config-from-file": "value",
                "--monitoring-frequency": "value",
                "--notification-channels": "value",
                "--prediction-sampling-rate": "value",
                "--region": "dynamic",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "models": {
          "commands": {
            "copy": {
              "commands": {},
              "flags": {
                "--destination-model-id": "value",
                "--destination-parent-model": "value",
                "--kms-key-name": "value",
                "--region": "value",
                "--source-model": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "delete-version": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "list-version": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "upload": {
              "commands": {},
              "flags": {
                "--artifact-uri": "value",
                "--container-args": "value",
                "--container-command": "value",
                "--container-deployment-timeout-seconds": "value",
                "--container-env-vars": "value",
                "--container-grpc-ports": "value",
                "--container-health-probe-exec": "value",
                "--container-health-probe-period-seconds": "value",
                "--container-health-probe-timeout-seconds": "value",
                "--container-health-route": "value",
                "--container-image-uri": "value",
                "--container-ports": "value",
                "--container-predict-route": "value",
                "--container-shared-memory-size-mb": "value",
                "--container-startup-probe-exec": "value",
                "--container-startup-probe-period-seconds": "value",
                "--container-startup-probe-timeout-seconds": "value",
                "--description": "value",
                "--display-name": "value",
                "--explanation-metadata-file": "value",
                "--explanation-method": "value",
                "--explanation-path-count": "value",
                "--explanation-step-count": "value",
                "--labels": "value",
                "--model-id": "value",
                "--parent-model": "value",
                "--region": "value",
                "--smooth-grad-noise-sigma": "value",
                "--smooth-grad-noise-sigma-by-feature": "value",
                "--smooth-grad-noisy-sample-count": "value",
                "--version-aliases": "value",
                "--version-description": "value"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--index": "value",
                "--index-endpoint": "value",
                "--region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "persistent-resources": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--config": "value",
                "--display-name": "value",
                "--enable-custom-service-account": "bool",
                "--kms-key": "dynamic",
                "--kms-keyring": "dynamic",
                "--kms-location": "dynamic",
                "--kms-project": "dynamic",
                "--labels": "value",
                "--network": "value",
                "--persistent-resource-id": "value",
                "--region": "value",
                "--resource-pool-spec": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "reboot": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "tensorboards": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--display-name": "value",
                "--kms-key": "dynamic",
                "--kms-keyring": "dynamic",
                "--kms-location": "dynamic",
                "--kms-project": "dynamic",
                "--labels": "value",
                "--region": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-labels": "bool",
                "--description": "value",
                "--display-name": "value",
                "--region": "dynamic",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "ai-platform": {
      "commands": {
        "jobs": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {
                "--summarize": "bool"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "stream-logs": {
              "commands": {},
              "flags": {
                "--allow-multiline-logs": "bool",
                "--polling-interval": "value",
                "--task-name": "value"
              }
            },
            "submit": {
              "commands": {
                "prediction": {
                  "commands": {},
                  "flags": {
                    "--batch-size": "value",
                    "--data-format": [
                      "text",
                      "tf-record",
                      "tf-record-gzip"
                    ],
                    "--input-paths": "value",
                    "--labels": "value",
                    "--max-worker-count": "value",
                    "--model": "value",
                    "--model-dir": "value",
                    "--output-path": "value",
                    "--region": "value",
                    "--runtime-version": "value",
                    "--signature-name": "value"
                  }
                },
                "training": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--config": "value",
                    "--enable-web-access": "bool",
                    "--job-dir": "value",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--master-accelerator": "value",
                    "--master-image-uri": "value",
                    "--master-machine-type": "value",
                    "--module-name": "value",
                    "--package-path": "value",
                    "--packages": "value",
                    "--parameter-server-accelerator": "value",
                    "--parameter-server-count": "value",
                    "--parameter-server-image-uri": "value",
                    "--parameter-server-machine-type": "value",
                    "--python-version": "value",
                    "--region": "dynamic",
                    "--runtime-version": "value",
                    "--scale-tier": [
                      "basic",
                      "basic-gpu",
                      "basic-tpu",
                      "custom",
                      "premium-1",
                      "standard-1"
                    ],
                    "--service-account": "value",
                    "--staging-bucket": "value",
                    "--stream-logs": "bool",
                    "--use-chief-in-tf-config": "value",
                    "--worker-accelerator": "value",
                    "--worker-count": "value",
                    "--worker-image-uri": "value",
                    "--worker-machine-type": "value"
                  }
                }
              },
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-labels": "bool",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "local": {
          "commands": {
            "predict": {
              "commands": {},
              "flags": {
                "--framework": [
                  "scikit-learn",
                  "tensorflow",
                  "xgboost"
                ],
                "--json-instances": "value",
                "--json-request": "value",
                "--model-dir": "value",
                "--signature-name": "value",
                "--text-instances": "value"
              }
            },
            "train": {
              "commands": {},
              "flags": {
                "--distributed": "bool",
                "--evaluator-count": "value",
                "--job-dir": "value",
                "--module-name": "value",
                "--package-path": "value",
                "--parameter-server-count": "value",
                "--start-port": "value",
                "--worker-count": "value"
              }
            }
          },
          "flags": {}
        },
        "models": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--enable-logging": "bool",
                "--labels": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--regions": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ]
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ]
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--role": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ]
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-labels": "bool",
                "--description": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ]
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ]
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "wait": {
              "commands": {},
              "flags": {
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ]
              }
            }
          },
          "flags": {}
        },
        "predict": {
          "commands": {},
          "flags": {
            "--json-instances": "value",
            "--json-request": "value",
            "--model": "value",
            "--region": [
              "asia-east1",
              "asia-northeast1",
              "asia-southeast1",
              "australia-southeast1",
              "europe-west1",
              "europe-west2",
              "europe-west3",
              "europe-west4",
              "global",
              "northamerica-northeast1",
              "us-central1",
              "us-east1",
              "us-east4",
              "us-west1"
            ],
            "--signature-name": "value",
            "--text-instances": "value"
          }
        },
        "versions": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--accelerator": "value",
                "--async": "bool",
                "--config": "value",
                "--description": "value",
                "--framework": [
                  "scikit-learn",
                  "tensorflow",
                  "xgboost"
                ],
                "--labels": "value",
                "--machine-type": "value",
                "--max-nodes": "value",
                "--metric-targets": "value",
                "--min-nodes": "value",
                "--model": "value",
                "--origin": "value",
                "--python-version": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--runtime-version": "value",
                "--staging-bucket": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--model": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ]
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--model": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ]
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--model": "value",
                "--page-size": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "set-default": {
              "commands": {},
              "flags": {
                "--model": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ]
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-labels": "bool",
                "--config": "value",
                "--description": "value",
                "--model": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "alloydb": {
      "commands": {
        "backups": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--cluster": "value",
                "--kms-key": "dynamic",
                "--kms-keyring": "dynamic",
                "--kms-location": "dynamic",
                "--kms-project": "dynamic",
                "--region": "value",
                "--tags": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "clusters": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--allocated-ip-range-name": "value",
                "--async": "bool",
                "--automated-backup-days-of-week": "value",
                "--automated-backup-encryption-key": "dynamic",
                "--automated-backup-encryption-key-keyring": "dynamic",
                "--automated-backup-encryption-key-location": "dynamic",
                "--automated-backup-encryption-key-project": "dynamic",
                "--automated-backup-retention-count": "value",
                "--automated-backup-retention-period": "value",
                "--automated-backup-start-times": "value",
                "--automated-backup-window": "value",
                "--continuous-backup-encryption-key": "dynamic",
                "--continuous-backup-encryption-key-keyring": "dynamic",
                "--continuous-backup-encryption-key-location": "dynamic",
                "--continuous-backup-encryption-key-project": "dynamic",
                "--continuous-backup-recovery-window-days": "value",
                "--database-version": [
                  "POSTGRES_14",
                  "POSTGRES_15",
                  "POSTGRES_16"
                ],
                "--disable-automated-backup": "bool",
                "--enable-continuous-backup": "bool",
                "--enable-private-service-connect": "bool",
                "--kms-key": "dynamic",
                "--kms-keyring": "dynamic",
                "--kms-location": "dynamic",
                "--kms-project": "dynamic",
                "--maintenance-window-day": [
                  "MONDAY",
                  "TUESDAY",
                  "WEDNESDAY",
                  "THURSDAY",
                  "FRIDAY",
                  "SATURDAY",
                  "SUNDAY"
                ],
                "--maintenance-window-hour": "value",
                "--network": "value",
                "--password": "value",
                "--region": "value",
                "--subscription-type": [
                  "STANDARD",
                  "TRIAL"
                ],
                "--tags": "value"
              }
            },
            "create-secondary": {
              "commands": {},
              "flags": {
                "--allocated-ip-range-name": "value",
                "--async": "bool",
                "--automated-backup-days-of-week": "value",
                "--automated-backup-encryption-key": "dynamic",
                "--automated-backup-encryption-key-keyring": "dynamic",
                "--automated-backup-encryption-key-location": "dynamic",
                "--automated-backup-encryption-key-project": "dynamic",
                "--automated-backup-retention-count": "value",
                "--automated-backup-retention-period": "value",
                "--automated-backup-start-times": "value",
                "--automated-backup-window": "value",
                "--continuous-backup-encryption-key": "dynamic",
                "--continuous-backup-encryption-key-keyring": "dynamic",
                "--continuous-backup-encryption-key-location": "dynamic",
                "--continuous-backup-encryption-key-project": "dynamic",
                "--continuous-backup-recovery-window-days": "value",
                "--enable-automated-backup": "bool",
                "--enable-continuous-backup": "bool",
                "--kms-key": "dynamic",
                "--kms-keyring": "dynamic",
                "--kms-location": "dynamic",
                "--kms-project": "dynamic",
                "--primary-cluster": "value",
                "--region": "value",
                "--tags": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--force": "bool",
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clean-target-objects": "bool",
                "--csv": "bool",
                "--database": "value",
                "--escape-character": "value",
                "--field-delimiter": "value",
                "--gcs-uri": "value",
                "--if-exist-target-objects": "bool",
                "--quote-character": "value",
                "--region": "value",
                "--schema-only": "bool",
                "--select-query": "value",
                "--sql": "bool",
                "--tables": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "promote": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "value"
              }
            },
            "restore": {
              "commands": {},
              "flags": {
                "--allocated-ip-range-name": "value",
                "--async": "bool",
                "--backup": "value",
                "--enable-private-service-connect": "bool",
                "--kms-key": "dynamic",
                "--kms-keyring": "dynamic",
                "--kms-location": "dynamic",
                "--kms-project": "dynamic",
                "--network": "value",
                "--point-in-time": "value",
                "--region": "value",
                "--source-cluster": "value",
                "--tags": "value"
              }
            },
            "switchover": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--automated-backup-days-of-week": "value",
                "--automated-backup-encryption-key": "dynamic",
                "--automated-backup-encryption-key-keyring": "dynamic",
                "--automated-backup-encryption-key-location": "dynamic",
                "--automated-backup-encryption-key-project": "dynamic",
                "--automated-backup-retention-count": "value",
                "--automated-backup-retention-period": "value",
                "--automated-backup-start-times": "value",
                "--automated-backup-window": "value",
                "--clear-automated-backup": "bool",
                "--clear-continuous-backup-encryption-key": "bool",
                "--continuous-backup-encryption-key": "dynamic",
                "--continuous-backup-encryption-key-keyring": "dynamic",
                "--continuous-backup-encryption-key-location": "dynamic",
                "--continuous-backup-encryption-key-project": "dynamic",
                "--continuous-backup-recovery-window-days": "value",
                "--disable-automated-backup": "bool",
                "--enable-continuous-backup": "bool",
                "--maintenance-window-any": "bool",
                "--maintenance-window-day": [
                  "MONDAY",
                  "TUESDAY",
                  "WEDNESDAY",
                  "THURSDAY",
                  "FRIDAY",
                  "SATURDAY",
                  "SUNDAY"
                ],
                "--maintenance-window-hour": "value",
                "--region": "value",
                "--subscription-type": [
                  "STANDARD",
                  "TRIAL"
                ]
              }
            }
          },
          "flags": {}
        },
        "instances": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--allowed-psc-projects": "value",
                "--assign-inbound-public-ip": "value",
                "--async": "bool",
                "--authorized-external-networks": "value",
                "--availability-type": [
                  "REGIONAL",
                  "ZONAL"
                ],
                "--cluster": "value",
                "--cpu-count": [
                  2,
                  4,
                  8,
                  16,
                  32,
                  64,
                  96,
                  128
                ],
                "--database-flags": "value",
                "--insights-config-query-plans-per-minute": "value",
                "--insights-config-query-string-length": "value",
                "--insights-config-record-application-tags": "bool",
                "--insights-config-record-client-address": "bool",
                "--instance-type": [
                  "PRIMARY",
                  "READ_POOL"
                ],
                "--outbound-public-ip": "bool",
                "--read-pool-node-count": "value",
                "--region": "value",
                "--require-connectors": "bool",
                "--ssl-mode": [
                  "ALLOW_UNENCRYPTED_AND_ENCRYPTED",
                  "ENCRYPTED_ONLY"
                ]
              }
            },
            "create-secondary": {
              "commands": {},
              "flags": {
                "--allowed-psc-projects": "value",
                "--assign-inbound-public-ip": "value",
                "--async": "bool",
                "--authorized-external-networks": "value",
                "--availability-type": [
                  "REGIONAL",
                  "ZONAL"
                ],
                "--cluster": "value",
                "--outbound-public-ip": "bool",
                "--region": "value",
                "--require-connectors": "bool",
                "--ssl-mode": [
                  "ALLOW_UNENCRYPTED_AND_ENCRYPTED",
                  "ENCRYPTED_ONLY"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--cluster": "value",
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--region": "value",
                "--view": [
                  "basic",
                  "full"
                ]
              }
            },
            "failover": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--cluster": "value",
                "--region": "value"
              }
            },
            "inject-fault": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--cluster": "value",
                "--fault-type": [
                  "stop-vm"
                ],
                "--region": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "restart": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--cluster": "value",
                "--node-ids": "value",
                "--region": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--allowed-psc-projects": "value",
                "--assign-inbound-public-ip": "value",
                "--async": "bool",
                "--authorized-external-networks": "value",
                "--availability-type": [
                  "REGIONAL",
                  "ZONAL"
                ],
                "--cluster": "value",
                "--cpu-count": [
                  2,
                  4,
                  8,
                  16,
                  32,
                  64,
                  96,
                  128
                ],
                "--database-flags": "value",
                "--insights-config-query-plans-per-minute": "value",
                "--insights-config-query-string-length": "value",
                "--insights-config-record-application-tags": "bool",
                "--insights-config-record-client-address": "bool",
                "--outbound-public-ip": "bool",
                "--read-pool-node-count": "value",
                "--region": "value",
                "--require-connectors": "bool",
                "--ssl-mode": [
                  "ALLOW_UNENCRYPTED_AND_ENCRYPTED",
                  "ENCRYPTED_ONLY"
                ]
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "users": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--db-roles": "value",
                "--keep-extra-roles": "value",
                "--password": "value",
                "--region": "value",
                "--superuser": "value",
                "--type": [
                  "BUILT_IN",
                  "IAM_BASED"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--region": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "set-password": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--password": "value",
                "--region": "value"
              }
            },
            "set-roles": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--db-roles": "value",
                "--keep-extra-roles": "value",
                "--region": "value"
              }
            },
            "set-superuser": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--region": "value",
                "--superuser": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "alpha": {
      "commands": {
        "access-approval": {
          "commands": {
            "requests": {
              "commands": {
                "approve": {
                  "commands": {},
                  "flags": {}
                },
                "dismiss": {
                  "commands": {},
                  "flags": {}
                },
                "get": {
                  "commands": {},
                  "flags": {}
                },
                "invalidate": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--state": "value"
                  }
                }
              },
              "flags": {}
            },
            "settings": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "get": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--active_key_version": "value",
                    "--enrolled_services": "value",
                    "--folder": "value",
                    "--notification_emails": "value",
                    "--notification_pubsub_topic": "value",
                    "--organization": "value",
                    "--prefer_no_broad_approval_requests": "value",
                    "--preferred_request_expiration_days": "value",
                    "--request_scope_max_width_preference": [
                      "FOLDER",
                      "ORGANIZATION",
                      "PROJECT"
                    ],
                    "--require_customer_visible_justification": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "access-context-manager": {
          "commands": {
            "authorized-orgs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--asset_type": [
                      "asset-type-credential-strength",
                      "asset-type-device",
                      "asset-type-unspecified"
                    ],
                    "--async": "bool",
                    "--authorization_direction": [
                      "authorization-direction-from",
                      "authorization-direction-to",
                      "authorization-direction-unspecified"
                    ],
                    "--authorization_type": [
                      "authorization-type-trust",
                      "authorization-type-unspecified"
                    ],
                    "--orgs": "value",
                    "--policy": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--policy": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--policy": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--policy": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-orgs": "value",
                    "--clear-orgs": "bool",
                    "--policy": "value",
                    "--remove-orgs": "value",
                    "--set-orgs": "value"
                  }
                }
              },
              "flags": {}
            },
            "cloud-bindings": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--binding-file": "value",
                    "--dry-run-level": "value",
                    "--group-key": "value",
                    "--level": "value",
                    "--organization": "value",
                    "--restricted-client-application-client-ids": "value",
                    "--restricted-client-application-names": "value",
                    "--session-length": "value",
                    "--session-reauth-method": [
                      "login",
                      "password",
                      "security-key"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--binding": "value",
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--binding": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--append": "bool",
                    "--binding": "value",
                    "--binding-file": "value",
                    "--dry-run-level": "value",
                    "--level": "value",
                    "--organization": "value",
                    "--restricted-client-application-client-ids": "value",
                    "--restricted-client-application-names": "value",
                    "--session-length": "value",
                    "--session-reauth-method": [
                      "login",
                      "password",
                      "security-key"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "levels": {
              "commands": {
                "conditions": {
                  "commands": {
                    "list": {
                      "commands": {},
                      "flags": {
                        "--level": "value",
                        "--policy": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--policy": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--basic-level-spec": "value",
                    "--combine-function": [
                      "and",
                      "or"
                    ],
                    "--custom-level-spec": "value",
                    "--description": "value",
                    "--policy": "value",
                    "--title": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--policy": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--policy": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--policy": "value",
                    "--sort-by": "value"
                  }
                },
                "replace-all": {
                  "commands": {},
                  "flags": {
                    "--etag": "value",
                    "--source-file": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--basic-level-spec": "value",
                    "--combine-function": [
                      "and",
                      "or"
                    ],
                    "--custom-level-spec": "value",
                    "--description": "value",
                    "--policy": "value",
                    "--title": "value"
                  }
                }
              },
              "flags": {}
            },
            "perimeters": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--policy": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--access-levels": "value",
                    "--async": "bool",
                    "--description": "value",
                    "--egress-policies": "value",
                    "--enable-vpc-accessible-services": "bool",
                    "--ingress-policies": "value",
                    "--perimeter-type": [
                      "bridge",
                      "regular"
                    ],
                    "--policy": "value",
                    "--resources": "value",
                    "--restricted-services": "value",
                    "--title": "value",
                    "--vpc-allowed-services": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--policy": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--policy": "value"
                  }
                },
                "dry-run": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--access-levels": "value",
                        "--async": "bool",
                        "--egress-policies": "value",
                        "--enable-vpc-accessible-services": "bool",
                        "--ingress-policies": "value",
                        "--perimeter-access-levels": "value",
                        "--perimeter-description": "value",
                        "--perimeter-egress-policies": "value",
                        "--perimeter-enable-vpc-accessible-services": "bool",
                        "--perimeter-ingress-policies": "value",
                        "--perimeter-resources": "value",
                        "--perimeter-restricted-services": "value",
                        "--perimeter-title": "value",
                        "--perimeter-type": "value",
                        "--perimeter-vpc-allowed-services": "value",
                        "--policy": "value",
                        "--resources": "value",
                        "--restricted-services": "value",
                        "--vpc-allowed-services": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--policy": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--policy": "value"
                      }
                    },
                    "drop": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--policy": "value"
                      }
                    },
                    "enforce": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--policy": "value"
                      }
                    },
                    "enforce-all": {
                      "commands": {},
                      "flags": {
                        "--etag": "value",
                        "--policy": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--policy": "value",
                        "--sort-by": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--add-access-levels": "value",
                        "--add-resources": "value",
                        "--add-restricted-services": "value",
                        "--add-vpc-allowed-services": "value",
                        "--async": "bool",
                        "--clear-access-levels": "bool",
                        "--clear-egress-policies": "bool",
                        "--clear-ingress-policies": "bool",
                        "--clear-resources": "bool",
                        "--clear-restricted-services": "bool",
                        "--clear-vpc-allowed-services": "bool",
                        "--enable-vpc-accessible-services": "bool",
                        "--etag": "value",
                        "--policy": "value",
                        "--remove-access-levels": "value",
                        "--remove-resources": "value",
                        "--remove-restricted-services": "value",
                        "--remove-vpc-allowed-services": "value",
                        "--set-egress-policies": "value",
                        "--set-ingress-policies": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--policy": "value",
                    "--sort-by": "value"
                  }
                },
                "replace-all": {
                  "commands": {},
                  "flags": {
                    "--etag": "value",
                    "--source-file": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-access-levels": "value",
                    "--add-resources": "value",
                    "--add-restricted-services": "value",
                    "--add-vpc-allowed-services": "value",
                    "--clear-access-levels": "bool",
                    "--clear-egress-policies": "bool",
                    "--clear-ingress-policies": "bool",
                    "--clear-resources": "bool",
                    "--clear-restricted-services": "bool",
                    "--clear-vpc-allowed-services": "bool",
                    "--description": "value",
                    "--enable-vpc-accessible-services": "bool",
                    "--etag": "value",
                    "--policy": "value",
                    "--remove-access-levels": "value",
                    "--remove-resources": "value",
                    "--remove-restricted-services": "value",
                    "--remove-vpc-allowed-services": "value",
                    "--set-access-levels": "value",
                    "--set-egress-policies": "value",
                    "--set-ingress-policies": "value",
                    "--set-resources": "value",
                    "--set-restricted-services": "value",
                    "--title": "value",
                    "--type": [
                      "bridge",
                      "regular"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "policies": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--organization": "value",
                    "--scopes": "value",
                    "--title": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--title": "value"
                  }
                }
              },
              "flags": {}
            },
            "supported-services": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "active-directory": {
          "commands": {
            "domains": {
              "commands": {
                "backups": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--domain": "value",
                        "--labels": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--domain": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--domain": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--domain": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--domain": "value",
                        "--remove-labels": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--admin-name": "value",
                    "--async": "bool",
                    "--authorized-networks": "value",
                    "--enable-audit-logs": "bool",
                    "--labels": "value",
                    "--region": "value",
                    "--reserved-ip-range": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "describe-ldaps-settings": {
                  "commands": {},
                  "flags": {}
                },
                "extend-schema": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--ldif-file": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "migration": {
                  "commands": {
                    "check-permissions": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--async": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--disable-sid-filtering-domains": "value",
                        "--onprem-domains": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "reset-admin-password": {
                  "commands": {},
                  "flags": {}
                },
                "restore": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--backup": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "sql-integrations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--domain": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--domain": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "trusts": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--direction": [
                          "bidirectional",
                          "inbound",
                          "outbound",
                          "trust-direction-unspecified"
                        ],
                        "--handshake-secret": "value",
                        "--selective-authentication": "bool",
                        "--target-dns-ip-addresses": "value",
                        "--target-domain-name": "value",
                        "--type": [
                          "external",
                          "forest",
                          "trust-type-unspecified"
                        ]
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--target-domain-name": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--target-dns-ip-addresses": "value",
                        "--target-domain-name": "value"
                      }
                    },
                    "validate-state": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--target-domain-name": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-authorized-networks": "value",
                    "--add-region": "value",
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--enable-audit-logs": "bool",
                    "--remove-authorized-networks": "value",
                    "--remove-labels": "value",
                    "--remove-region": "value",
                    "--update-labels": "value"
                  }
                },
                "update-ldaps-settings": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--certificate-password": "value",
                    "--certificate-pfx-file": "value",
                    "--clear-certificates": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "peerings": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--authorized-network": "value",
                    "--domain": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "ai": {
          "commands": {
            "custom-jobs": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--args": "value",
                    "--command": "value",
                    "--config": "value",
                    "--display-name": "value",
                    "--enable-dashboard-access": "bool",
                    "--enable-web-access": "bool",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--network": "value",
                    "--persistent-resource-id": "value",
                    "--python-package-uris": "value",
                    "--region": "value",
                    "--service-account": "value",
                    "--worker-pool-spec": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "local-run": {
                  "commands": {},
                  "flags": {
                    "--executor-image-uri": "value",
                    "--extra-dirs": "value",
                    "--extra-packages": "value",
                    "--gpu": "bool",
                    "--local-package-path": "value",
                    "--output-image-uri": "value",
                    "--python-module": "value",
                    "--requirements": "value",
                    "--script": "value",
                    "--service-account-key-file": "value"
                  }
                },
                "stream-logs": {
                  "commands": {},
                  "flags": {
                    "--allow-multiline-logs": "bool",
                    "--polling-interval": "value",
                    "--region": "dynamic",
                    "--task-name": "value"
                  }
                }
              },
              "flags": {}
            },
            "endpoints": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--encryption-kms-key-name": "value",
                    "--endpoint-id": "value",
                    "--gdce-zone": "value",
                    "--labels": "value",
                    "--network": "value",
                    "--region": "value",
                    "--request-response-logging-rate": "value",
                    "--request-response-logging-table": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "deploy-model": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--autoscaling-metric-specs": "value",
                    "--deployed-model-id": "value",
                    "--display-name": "value",
                    "--enable-access-logging": "bool",
                    "--enable-container-logging": "bool",
                    "--machine-type": "value",
                    "--max-replica-count": "value",
                    "--min-replica-count": "value",
                    "--model": "value",
                    "--region": "dynamic",
                    "--reservation-affinity": "value",
                    "--service-account": "value",
                    "--shared-resources": "dynamic",
                    "--shared-resources-region": "dynamic",
                    "--spot": "bool",
                    "--tpu-topology": "value",
                    "--traffic-split": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "direct-predict": {
                  "commands": {},
                  "flags": {
                    "--json-request": "value",
                    "--region": "dynamic"
                  }
                },
                "direct-raw-predict": {
                  "commands": {},
                  "flags": {
                    "--json-request": "value",
                    "--region": "dynamic"
                  }
                },
                "explain": {
                  "commands": {},
                  "flags": {
                    "--deployed-model-id": "value",
                    "--json-request": "value",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "predict": {
                  "commands": {},
                  "flags": {
                    "--json-request": "value",
                    "--region": "dynamic"
                  }
                },
                "raw-predict": {
                  "commands": {},
                  "flags": {
                    "--http-headers": "value",
                    "--region": "dynamic",
                    "--request": "value"
                  }
                },
                "stream-direct-predict": {
                  "commands": {},
                  "flags": {
                    "--json-request": "value",
                    "--region": "dynamic"
                  }
                },
                "stream-direct-raw-predict": {
                  "commands": {},
                  "flags": {
                    "--json-request": "value",
                    "--region": "dynamic"
                  }
                },
                "stream-raw-predict": {
                  "commands": {},
                  "flags": {
                    "--http-headers": "value",
                    "--region": "dynamic",
                    "--request": "value"
                  }
                },
                "undeploy-model": {
                  "commands": {},
                  "flags": {
                    "--deployed-model-id": "value",
                    "--region": "dynamic",
                    "--traffic-split": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--clear-traffic-split": "bool",
                    "--description": "value",
                    "--disable-request-response-logging": "bool",
                    "--display-name": "value",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--request-response-logging-rate": "value",
                    "--request-response-logging-table": "value",
                    "--traffic-split": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "hp-tuning-jobs": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--algorithm": [
                      "algorithm-unspecified",
                      "grid-search",
                      "random-search"
                    ],
                    "--config": "value",
                    "--display-name": "value",
                    "--enable-dashboard-access": "bool",
                    "--enable-web-access": "bool",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--max-trial-count": "value",
                    "--network": "value",
                    "--parallel-trial-count": "value",
                    "--region": "value",
                    "--service-account": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "stream-logs": {
                  "commands": {},
                  "flags": {
                    "--allow-multiline-logs": "bool",
                    "--polling-interval": "value",
                    "--region": "dynamic",
                    "--task-name": "value"
                  }
                }
              },
              "flags": {}
            },
            "index-endpoints": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--enable-private-service-connect": "bool",
                    "--encryption-kms-key-name": "value",
                    "--labels": "value",
                    "--network": "value",
                    "--project-allowlist": "value",
                    "--public-endpoint-enabled": "bool",
                    "--region": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "deploy-index": {
                  "commands": {},
                  "flags": {
                    "--allowed-issuers": "value",
                    "--audiences": "value",
                    "--deployed-index-id": "value",
                    "--deployment-group": "value",
                    "--display-name": "value",
                    "--enable-access-logging": "bool",
                    "--index": "value",
                    "--machine-type": "value",
                    "--max-replica-count": "value",
                    "--min-replica-count": "value",
                    "--psc-automation-configs": "value",
                    "--region": "dynamic",
                    "--reserved-ip-ranges": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "mutate-deployed-index": {
                  "commands": {},
                  "flags": {
                    "--allowed-issuers": "value",
                    "--audiences": "value",
                    "--deployed-index-id": "value",
                    "--deployment-group": "value",
                    "--enable-access-logging": "bool",
                    "--machine-type": "value",
                    "--max-replica-count": "value",
                    "--min-replica-count": "value",
                    "--region": "dynamic",
                    "--reserved-ip-ranges": "value"
                  }
                },
                "undeploy-index": {
                  "commands": {},
                  "flags": {
                    "--deployed-index-id": "value",
                    "--region": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "indexes": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--encryption-kms-key-name": "value",
                    "--index-update-method": [
                      "batch-update",
                      "stream-update"
                    ],
                    "--labels": "value",
                    "--metadata-file": "value",
                    "--metadata-schema-uri": "value",
                    "--region": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-datapoints": {
                  "commands": {},
                  "flags": {
                    "--datapoint-ids": "value",
                    "--datapoints-from-file": "value",
                    "--region": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--metadata-file": "value",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                },
                "upsert-datapoints": {
                  "commands": {},
                  "flags": {
                    "--datapoints-from-file": "value",
                    "--region": "dynamic",
                    "--update-mask": "value"
                  }
                }
              },
              "flags": {}
            },
            "model-monitoring-jobs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--analysis-instance-schema": "value",
                    "--anomaly-cloud-logging": "bool",
                    "--bigquery-uri": "value",
                    "--data-format": "value",
                    "--dataset": "value",
                    "--display-name": "value",
                    "--emails": "value",
                    "--endpoint": "value",
                    "--feature-attribution-thresholds": "value",
                    "--feature-thresholds": "value",
                    "--gcs-uris": "value",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--log-ttl": "value",
                    "--monitoring-config-from-file": "value",
                    "--monitoring-frequency": "value",
                    "--notification-channels": "value",
                    "--predict-instance-schema": "value",
                    "--prediction-sampling-rate": "value",
                    "--region": "value",
                    "--sample-predict-request": "value",
                    "--target-field": "value",
                    "--training-sampling-rate": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "pause": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "resume": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--analysis-instance-schema": "value",
                    "--anomaly-cloud-logging": "bool",
                    "--clear-labels": "bool",
                    "--display-name": "value",
                    "--emails": "value",
                    "--feature-attribution-thresholds": "value",
                    "--feature-thresholds": "value",
                    "--log-ttl": "value",
                    "--monitoring-config-from-file": "value",
                    "--monitoring-frequency": "value",
                    "--notification-channels": "value",
                    "--prediction-sampling-rate": "value",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "models": {
              "commands": {
                "copy": {
                  "commands": {},
                  "flags": {
                    "--destination-model-id": "value",
                    "--destination-parent-model": "value",
                    "--kms-key-name": "value",
                    "--region": "value",
                    "--source-model": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "delete-version": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-version": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "upload": {
                  "commands": {},
                  "flags": {
                    "--artifact-uri": "value",
                    "--container-args": "value",
                    "--container-command": "value",
                    "--container-deployment-timeout-seconds": "value",
                    "--container-env-vars": "value",
                    "--container-grpc-ports": "value",
                    "--container-health-probe-exec": "value",
                    "--container-health-probe-period-seconds": "value",
                    "--container-health-probe-timeout-seconds": "value",
                    "--container-health-route": "value",
                    "--container-image-uri": "value",
                    "--container-ports": "value",
                    "--container-predict-route": "value",
                    "--container-shared-memory-size-mb": "value",
                    "--container-startup-probe-exec": "value",
                    "--container-startup-probe-period-seconds": "value",
                    "--container-startup-probe-timeout-seconds": "value",
                    "--description": "value",
                    "--display-name": "value",
                    "--explanation-metadata-file": "value",
                    "--explanation-method": "value",
                    "--explanation-modality": "value",
                    "--explanation-nearest-neighbor-search-config-file": "value",
                    "--explanation-neighbor-count": "value",
                    "--explanation-path-count": "value",
                    "--explanation-query": "value",
                    "--explanation-step-count": "value",
                    "--labels": "value",
                    "--model-id": "value",
                    "--parent-model": "value",
                    "--region": "value",
                    "--smooth-grad-noise-sigma": "value",
                    "--smooth-grad-noise-sigma-by-feature": "value",
                    "--smooth-grad-noisy-sample-count": "value",
                    "--uris": "value",
                    "--version-aliases": "value",
                    "--version-description": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--index": "value",
                    "--index-endpoint": "value",
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "persistent-resources": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--config": "value",
                    "--display-name": "value",
                    "--enable-custom-service-account": "bool",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--network": "value",
                    "--persistent-resource-id": "value",
                    "--region": "value",
                    "--resource-pool-spec": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "reboot": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "tensorboard-experiments": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--labels": "value",
                    "--region": "dynamic",
                    "--tensorboard-experiment-id": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--tensorboard-id": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--tensorboard-id": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--tensorboard-id": "dynamic",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "tensorboard-runs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--labels": "value",
                    "--region": "dynamic",
                    "--tensorboard-id": "dynamic",
                    "--tensorboard-run-id": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--tensorboard-experiment-id": "dynamic",
                    "--tensorboard-id": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--tensorboard-experiment-id": "dynamic",
                    "--tensorboard-id": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--tensorboard-experiment-id": "dynamic",
                    "--tensorboard-id": "dynamic",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--tensorboard-experiment-id": "dynamic",
                    "--tensorboard-id": "dynamic",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "tensorboard-time-series": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--plugin-data": "value",
                    "--plugin-name": "value",
                    "--region": "dynamic",
                    "--tensorboard-experiment-id": "dynamic",
                    "--tensorboard-id": "dynamic",
                    "--type": [
                      "blob-sequence",
                      "scalar",
                      "tensor"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--tensorboard-experiment-id": "dynamic",
                    "--tensorboard-id": "dynamic",
                    "--tensorboard-run-id": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--tensorboard-experiment-id": "dynamic",
                    "--tensorboard-id": "dynamic",
                    "--tensorboard-run-id": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--tensorboard-experiment-id": "dynamic",
                    "--tensorboard-id": "dynamic",
                    "--tensorboard-run-id": "dynamic",
                    "--uri": "bool"
                  }
                },
                "read": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--max-data-points": "value",
                    "--region": "dynamic",
                    "--tensorboard-experiment-id": "dynamic",
                    "--tensorboard-id": "dynamic",
                    "--tensorboard-run-id": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--plugin-data": "value",
                    "--plugin-name": "value",
                    "--region": "dynamic",
                    "--tensorboard-experiment-id": "dynamic",
                    "--tensorboard-id": "dynamic",
                    "--tensorboard-run-id": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "tensorboards": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--region": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "ai-platform": {
          "commands": {
            "explain": {
              "commands": {},
              "flags": {
                "--json-instances": "value",
                "--json-request": "value",
                "--model": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--text-instances": "value"
              }
            },
            "jobs": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--summarize": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "stream-logs": {
                  "commands": {},
                  "flags": {
                    "--allow-multiline-logs": "bool",
                    "--polling-interval": "value",
                    "--task-name": "value"
                  }
                },
                "submit": {
                  "commands": {
                    "prediction": {
                      "commands": {},
                      "flags": {
                        "--accelerator-count": "value",
                        "--accelerator-type": [
                          "nvidia-tesla-k80",
                          "nvidia-tesla-p100"
                        ],
                        "--batch-size": "value",
                        "--data-format": [
                          "text",
                          "tf-record",
                          "tf-record-gzip"
                        ],
                        "--input-paths": "value",
                        "--labels": "value",
                        "--max-worker-count": "value",
                        "--model": "value",
                        "--model-dir": "value",
                        "--output-path": "value",
                        "--region": "value",
                        "--runtime-version": "value",
                        "--signature-name": "value"
                      }
                    },
                    "training": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--config": "value",
                        "--enable-web-access": "bool",
                        "--job-dir": "value",
                        "--kms-key": "dynamic",
                        "--kms-keyring": "dynamic",
                        "--kms-location": "dynamic",
                        "--kms-project": "dynamic",
                        "--labels": "value",
                        "--master-accelerator": "value",
                        "--master-image-uri": "value",
                        "--master-machine-type": "value",
                        "--module-name": "value",
                        "--network": "value",
                        "--package-path": "value",
                        "--packages": "value",
                        "--parameter-server-accelerator": "value",
                        "--parameter-server-count": "value",
                        "--parameter-server-image-uri": "value",
                        "--parameter-server-machine-type": "value",
                        "--python-version": "value",
                        "--region": "dynamic",
                        "--runtime-version": "value",
                        "--scale-tier": [
                          "basic",
                          "basic-gpu",
                          "basic-tpu",
                          "custom",
                          "premium-1",
                          "standard-1"
                        ],
                        "--service-account": "value",
                        "--staging-bucket": "value",
                        "--stream-logs": "bool",
                        "--tpu-tf-version": "value",
                        "--use-chief-in-tf-config": "value",
                        "--worker-accelerator": "value",
                        "--worker-count": "value",
                        "--worker-image-uri": "value",
                        "--worker-machine-type": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "local": {
              "commands": {
                "predict": {
                  "commands": {},
                  "flags": {
                    "--framework": [
                      "scikit-learn",
                      "tensorflow",
                      "xgboost"
                    ],
                    "--json-instances": "value",
                    "--json-request": "value",
                    "--model-dir": "value",
                    "--signature-name": "value",
                    "--text-instances": "value"
                  }
                },
                "train": {
                  "commands": {},
                  "flags": {
                    "--distributed": "bool",
                    "--evaluator-count": "value",
                    "--job-dir": "value",
                    "--module-name": "value",
                    "--package-path": "value",
                    "--parameter-server-count": "value",
                    "--start-port": "value",
                    "--worker-count": "value"
                  }
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "models": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--enable-console-logging": "bool",
                    "--enable-logging": "bool",
                    "--labels": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--regions": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--role": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "predict": {
              "commands": {},
              "flags": {
                "--json-instances": "value",
                "--json-request": "value",
                "--model": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--signature-name": "value",
                "--text-instances": "value"
              }
            },
            "versions": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--args": "value",
                    "--async": "bool",
                    "--command": "value",
                    "--config": "value",
                    "--description": "value",
                    "--env-vars": "value",
                    "--explanation-method": [
                      "integrated-gradients",
                      "sampled-shapley",
                      "xrai"
                    ],
                    "--framework": [
                      "scikit-learn",
                      "tensorflow",
                      "xgboost"
                    ],
                    "--health-route": "value",
                    "--image": "value",
                    "--labels": "value",
                    "--machine-type": "value",
                    "--max-nodes": "value",
                    "--metric-targets": "value",
                    "--min-nodes": "value",
                    "--model": "value",
                    "--num-integral-steps": "value",
                    "--num-paths": "value",
                    "--origin": "value",
                    "--package-uris": "value",
                    "--ports": "value",
                    "--predict-route": "value",
                    "--prediction-class": "value",
                    "--python-version": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--runtime-version": "value",
                    "--service-account": "value",
                    "--staging-bucket": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--model": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--model": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--model": "value",
                    "--page-size": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "set-default": {
                  "commands": {},
                  "flags": {
                    "--model": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--bigquery-table-name": "value",
                    "--clear-labels": "bool",
                    "--config": "value",
                    "--description": "value",
                    "--model": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--remove-labels": "value",
                    "--sampling-percentage": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "alloydb": {
          "commands": {
            "backups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster": "value",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--region": "value",
                    "--tags": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "clusters": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--allocated-ip-range-name": "value",
                    "--async": "bool",
                    "--automated-backup-days-of-week": "value",
                    "--automated-backup-encryption-key": "dynamic",
                    "--automated-backup-encryption-key-keyring": "dynamic",
                    "--automated-backup-encryption-key-location": "dynamic",
                    "--automated-backup-encryption-key-project": "dynamic",
                    "--automated-backup-retention-count": "value",
                    "--automated-backup-retention-period": "value",
                    "--automated-backup-start-times": "value",
                    "--automated-backup-window": "value",
                    "--continuous-backup-encryption-key": "dynamic",
                    "--continuous-backup-encryption-key-keyring": "dynamic",
                    "--continuous-backup-encryption-key-location": "dynamic",
                    "--continuous-backup-encryption-key-project": "dynamic",
                    "--continuous-backup-recovery-window-days": "value",
                    "--database-version": [
                      "POSTGRES_14",
                      "POSTGRES_15",
                      "POSTGRES_16"
                    ],
                    "--disable-automated-backup": "bool",
                    "--enable-continuous-backup": "bool",
                    "--enable-private-service-connect": "bool",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--maintenance-window-day": [
                      "MONDAY",
                      "TUESDAY",
                      "WEDNESDAY",
                      "THURSDAY",
                      "FRIDAY",
                      "SATURDAY",
                      "SUNDAY"
                    ],
                    "--maintenance-window-hour": "value",
                    "--network": "value",
                    "--password": "value",
                    "--region": "value",
                    "--subscription-type": [
                      "STANDARD",
                      "TRIAL"
                    ],
                    "--tags": "value"
                  }
                },
                "create-secondary": {
                  "commands": {},
                  "flags": {
                    "--allocated-ip-range-name": "value",
                    "--async": "bool",
                    "--automated-backup-days-of-week": "value",
                    "--automated-backup-encryption-key": "dynamic",
                    "--automated-backup-encryption-key-keyring": "dynamic",
                    "--automated-backup-encryption-key-location": "dynamic",
                    "--automated-backup-encryption-key-project": "dynamic",
                    "--automated-backup-retention-count": "value",
                    "--automated-backup-retention-period": "value",
                    "--automated-backup-start-times": "value",
                    "--automated-backup-window": "value",
                    "--continuous-backup-encryption-key": "dynamic",
                    "--continuous-backup-encryption-key-keyring": "dynamic",
                    "--continuous-backup-encryption-key-location": "dynamic",
                    "--continuous-backup-encryption-key-project": "dynamic",
                    "--continuous-backup-recovery-window-days": "value",
                    "--enable-automated-backup": "bool",
                    "--enable-continuous-backup": "bool",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--primary-cluster": "value",
                    "--region": "value",
                    "--tags": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--force": "bool",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clean-target-objects": "bool",
                    "--csv": "bool",
                    "--database": "value",
                    "--escape-character": "value",
                    "--field-delimiter": "value",
                    "--gcs-uri": "value",
                    "--if-exist-target-objects": "bool",
                    "--quote-character": "value",
                    "--region": "value",
                    "--schema-only": "bool",
                    "--select-query": "value",
                    "--sql": "bool",
                    "--tables": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "promote": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "restore": {
                  "commands": {},
                  "flags": {
                    "--allocated-ip-range-name": "value",
                    "--async": "bool",
                    "--backup": "value",
                    "--enable-private-service-connect": "bool",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--network": "value",
                    "--point-in-time": "value",
                    "--region": "value",
                    "--source-cluster": "value",
                    "--tags": "value"
                  }
                },
                "switchover": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--automated-backup-days-of-week": "value",
                    "--automated-backup-encryption-key": "dynamic",
                    "--automated-backup-encryption-key-keyring": "dynamic",
                    "--automated-backup-encryption-key-location": "dynamic",
                    "--automated-backup-encryption-key-project": "dynamic",
                    "--automated-backup-retention-count": "value",
                    "--automated-backup-retention-period": "value",
                    "--automated-backup-start-times": "value",
                    "--automated-backup-window": "value",
                    "--clear-automated-backup": "bool",
                    "--clear-continuous-backup-encryption-key": "bool",
                    "--continuous-backup-encryption-key": "dynamic",
                    "--continuous-backup-encryption-key-keyring": "dynamic",
                    "--continuous-backup-encryption-key-location": "dynamic",
                    "--continuous-backup-encryption-key-project": "dynamic",
                    "--continuous-backup-recovery-window-days": "value",
                    "--disable-automated-backup": "bool",
                    "--enable-continuous-backup": "bool",
                    "--maintenance-window-any": "bool",
                    "--maintenance-window-day": [
                      "MONDAY",
                      "TUESDAY",
                      "WEDNESDAY",
                      "THURSDAY",
                      "FRIDAY",
                      "SATURDAY",
                      "SUNDAY"
                    ],
                    "--maintenance-window-hour": "value",
                    "--region": "value",
                    "--subscription-type": [
                      "STANDARD",
                      "TRIAL"
                    ]
                  }
                },
                "upgrade": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                }
              },
              "flags": {}
            },
            "instances": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--allowed-psc-projects": "value",
                    "--assign-inbound-public-ip": "value",
                    "--async": "bool",
                    "--authorized-external-networks": "value",
                    "--availability-type": [
                      "REGIONAL",
                      "ZONAL"
                    ],
                    "--cluster": "value",
                    "--connection-pooling-ignore-startup-parameters": "value",
                    "--connection-pooling-max-client-connections": "value",
                    "--connection-pooling-max-pool-size": "value",
                    "--connection-pooling-min-pool-size": "value",
                    "--connection-pooling-pool-mode": [
                      "SESSION",
                      "TRANSACTION"
                    ],
                    "--connection-pooling-query-wait-timeout": "value",
                    "--connection-pooling-server-idle-timeout": "value",
                    "--connection-pooling-stats-users": "value",
                    "--cpu-count": [
                      2,
                      4,
                      8,
                      16,
                      32,
                      64,
                      96,
                      128
                    ],
                    "--database-flags": "value",
                    "--enable-connection-pooling": "bool",
                    "--insights-config-query-plans-per-minute": "value",
                    "--insights-config-query-string-length": "value",
                    "--insights-config-record-application-tags": "bool",
                    "--insights-config-record-client-address": "bool",
                    "--instance-type": [
                      "PRIMARY",
                      "READ_POOL"
                    ],
                    "--observability-config-enabled": "bool",
                    "--observability-config-max-query-string-length": "value",
                    "--observability-config-preserve-comments": "bool",
                    "--observability-config-query-plans-per-minute": "value",
                    "--observability-config-record-application-tags": "bool",
                    "--observability-config-track-active-queries": "bool",
                    "--observability-config-track-wait-events": "bool",
                    "--outbound-public-ip": "bool",
                    "--psc-network-attachment-url": "value",
                    "--read-pool-node-count": "value",
                    "--region": "value",
                    "--require-connectors": "bool",
                    "--ssl-mode": [
                      "ALLOW_UNENCRYPTED_AND_ENCRYPTED",
                      "ENCRYPTED_ONLY"
                    ]
                  }
                },
                "create-secondary": {
                  "commands": {},
                  "flags": {
                    "--allowed-psc-projects": "value",
                    "--assign-inbound-public-ip": "value",
                    "--async": "bool",
                    "--authorized-external-networks": "value",
                    "--availability-type": [
                      "REGIONAL",
                      "ZONAL"
                    ],
                    "--cluster": "value",
                    "--outbound-public-ip": "bool",
                    "--region": "value",
                    "--require-connectors": "bool",
                    "--ssl-mode": [
                      "ALLOW_UNENCRYPTED_AND_ENCRYPTED",
                      "ENCRYPTED_ONLY"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster": "value",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--region": "value",
                    "--view": [
                      "basic",
                      "full"
                    ]
                  }
                },
                "failover": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster": "value",
                    "--region": "value"
                  }
                },
                "inject-fault": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster": "value",
                    "--fault-type": [
                      "stop-vm"
                    ],
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "restart": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster": "value",
                    "--node-ids": "value",
                    "--region": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--allowed-psc-projects": "value",
                    "--assign-inbound-public-ip": "value",
                    "--async": "bool",
                    "--authorized-external-networks": "value",
                    "--availability-type": [
                      "REGIONAL",
                      "ZONAL"
                    ],
                    "--clear-psc-network-attachment-url": "bool",
                    "--cluster": "value",
                    "--connection-pooling-ignore-startup-parameters": "value",
                    "--connection-pooling-max-client-connections": "value",
                    "--connection-pooling-max-pool-size": "value",
                    "--connection-pooling-min-pool-size": "value",
                    "--connection-pooling-pool-mode": [
                      "SESSION",
                      "TRANSACTION"
                    ],
                    "--connection-pooling-query-wait-timeout": "value",
                    "--connection-pooling-server-idle-timeout": "value",
                    "--connection-pooling-stats-users": "value",
                    "--cpu-count": [
                      2,
                      4,
                      8,
                      16,
                      32,
                      64,
                      96,
                      128
                    ],
                    "--database-flags": "value",
                    "--enable-connection-pooling": "bool",
                    "--insights-config-query-plans-per-minute": "value",
                    "--insights-config-query-string-length": "value",
                    "--insights-config-record-application-tags": "bool",
                    "--insights-config-record-client-address": "bool",
                    "--observability-config-enabled": "bool",
                    "--observability-config-max-query-string-length": "value",
                    "--observability-config-preserve-comments": "bool",
                    "--observability-config-query-plans-per-minute": "value",
                    "--observability-config-record-application-tags": "bool",
                    "--observability-config-track-active-queries": "bool",
                    "--observability-config-track-wait-events": "bool",
                    "--outbound-public-ip": "bool",
                    "--psc-network-attachment-url": "value",
                    "--read-pool-node-count": "value",
                    "--region": "value",
                    "--require-connectors": "bool",
                    "--ssl-mode": [
                      "ALLOW_UNENCRYPTED_AND_ENCRYPTED",
                      "ENCRYPTED_ONLY"
                    ],
                    "--update-mode": [
                      "FORCE_APPLY"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "users": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--db-roles": "value",
                    "--keep-extra-roles": "value",
                    "--password": "value",
                    "--region": "value",
                    "--superuser": "value",
                    "--type": [
                      "BUILT_IN",
                      "IAM_BASED"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "set-password": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--password": "value",
                    "--region": "value"
                  }
                },
                "set-roles": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--db-roles": "value",
                    "--keep-extra-roles": "value",
                    "--region": "value"
                  }
                },
                "set-superuser": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--region": "value",
                    "--superuser": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "anthos": {
          "commands": {
            "apply": {
              "commands": {},
              "flags": {}
            },
            "auth": {
              "commands": {
                "login": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--dry-run": "bool",
                    "--kubeconfig": "value",
                    "--login-config": "value",
                    "--login-config-cert": "value",
                    "--no-browser": "bool",
                    "--remote-bootstrap": "value",
                    "--server": "value",
                    "--set-preferred-auth": "bool",
                    "--user": "value"
                  }
                }
              },
              "flags": {}
            },
            "config": {
              "commands": {
                "controller": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--cluster-ipv4-cidr-block": "value",
                        "--cluster-named-range": "value",
                        "--experimental-features": "value",
                        "--full-management": "bool",
                        "--location": "dynamic",
                        "--man-block": "value",
                        "--man-blocks": "value",
                        "--master-ipv4-cidr-block": "value",
                        "--network": "value",
                        "--services-ipv4-cidr-block": "value",
                        "--services-named-range": "value",
                        "--subnet": "value",
                        "--use-private-endpoint": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    },
                    "get-config-connector-identity": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "get-credentials": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--full-name": "bool",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--experimental-features": "value",
                        "--location": "dynamic",
                        "--man-block": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "sync": {
                  "commands": {
                    "repo": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--cluster": "value",
                            "--managed-resources": "value",
                            "--source": "value",
                            "--sync-name": "value",
                            "--sync-namespace": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--membership": "value",
                            "--namespace": "value",
                            "--selector": "value",
                            "--status": "value",
                            "--targets": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "resources": {
                      "commands": {
                        "list": {
                          "commands": {},
                          "flags": {
                            "--cluster": "value",
                            "--membership": "value",
                            "--sync-name": "value",
                            "--sync-namespace": "value"
                          }
                        }
                      },
                      "flags": {}
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "create-login-config": {
              "commands": {},
              "flags": {
                "--kubeconfig": "value",
                "--merge-from": "value",
                "--output": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--output-directory": "value"
              }
            }
          },
          "flags": {}
        },
        "api-gateway": {
          "commands": {
            "api-configs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--api": "value",
                    "--async": "bool",
                    "--backend-auth-service-account": "value",
                    "--display-name": "value",
                    "--grpc-files": "value",
                    "--labels": "value",
                    "--openapi-spec": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--api": "value",
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--api": "value",
                    "--view": [
                      "BASIC",
                      "FULL"
                    ]
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--api": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--api": "value",
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--display-name": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "apis": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--display-name": "value",
                    "--labels": "value",
                    "--managed-service": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--display-name": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "gateways": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--api": "value",
                    "--api-config": "value",
                    "--async": "bool",
                    "--display-name": "value",
                    "--labels": "value",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--api": "value",
                    "--api-config": "value",
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--display-name": "value",
                    "--location": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "apigee": {
          "commands": {
            "apis": {
              "commands": {
                "deploy": {
                  "commands": {},
                  "flags": {
                    "--api": "value",
                    "--environment": "value",
                    "--organization": "value",
                    "--override": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--organization": "value",
                    "--revision": "value",
                    "--verbose": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "undeploy": {
                  "commands": {},
                  "flags": {
                    "--api": "value",
                    "--environment": "value",
                    "--organization": "value"
                  }
                }
              },
              "flags": {}
            },
            "applications": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--developer": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "archives": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--environment": "value",
                    "--organization": "value"
                  }
                },
                "deploy": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--bundle-file": "value",
                    "--environment": "value",
                    "--labels": "value",
                    "--organization": "value",
                    "--source": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--environment": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--environment": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--environment": "value",
                    "--organization": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "deployments": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--api": "value",
                    "--environment": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--api": "value",
                    "--environment": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--revision": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "developers": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "environments": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "organizations": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "provision": {
                  "commands": {},
                  "flags": {
                    "--analytics-region": "value",
                    "--async": "bool",
                    "--authorized-network": "value",
                    "--runtime-location": "value"
                  }
                }
              },
              "flags": {}
            },
            "products": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--all-environments": "bool",
                    "--all-proxies": "bool",
                    "--apis": "value",
                    "--attributes": "value",
                    "--description": "value",
                    "--display-name": "value",
                    "--environments": "value",
                    "--internal-access": "bool",
                    "--manual-approval": "bool",
                    "--oauth-scopes": "value",
                    "--organization": "value",
                    "--private-access": "bool",
                    "--public-access": "bool",
                    "--quota": "value",
                    "--quota-interval": "value",
                    "--quota-unit": [
                      "day",
                      "hour",
                      "minute",
                      "month"
                    ],
                    "--resources": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-api": "value",
                    "--add-attribute": "value",
                    "--add-environment": "value",
                    "--add-oauth-scope": "value",
                    "--add-resource": "value",
                    "--all-apis": "bool",
                    "--all-environments": "bool",
                    "--all-resources": "bool",
                    "--automatic-approval": "bool",
                    "--clear-attributes": "bool",
                    "--clear-description": "bool",
                    "--clear-oauth-scopes": "bool",
                    "--clear-quota": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--internal-access": "bool",
                    "--manual-approval": "bool",
                    "--organization": "value",
                    "--private-access": "bool",
                    "--public-access": "bool",
                    "--quota": "value",
                    "--quota-interval": "value",
                    "--quota-unit": [
                      "day",
                      "hour",
                      "minute",
                      "month"
                    ],
                    "--remove-api": "value",
                    "--remove-attribute": "value",
                    "--remove-environment": "value",
                    "--remove-oauth-scope": "value",
                    "--remove-resource": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "app": {
          "commands": {
            "domain-mappings": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--certificate-id": "value",
                    "--certificate-management": [
                      "automatic",
                      "manual"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--certificate-id": "value",
                    "--certificate-management": [
                      "automatic",
                      "manual"
                    ],
                    "--no-certificate-id": "bool"
                  }
                }
              },
              "flags": {}
            },
            "ssl-certificates": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--certificate": "value",
                    "--display-name": "value",
                    "--private-key": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--certificate": "value",
                    "--display-name": "value",
                    "--private-key": "value"
                  }
                }
              },
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--service-account": "value",
                "--split-health-checks": "bool"
              }
            }
          },
          "flags": {}
        },
        "apphub": {
          "commands": {
            "applications": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--business-owners": "value",
                    "--criticality-type": [
                      "HIGH",
                      "LOW",
                      "MEDIUM",
                      "MISSION_CRITICAL",
                      "TYPE_UNSPECIFIED"
                    ],
                    "--description": "value",
                    "--developer-owners": "value",
                    "--display-name": "value",
                    "--environment-type": [
                      "DEVELOPMENT",
                      "PRODUCTION",
                      "STAGING",
                      "TEST",
                      "TYPE_UNSPECIFIED"
                    ],
                    "--location": "value",
                    "--operator-owners": "value",
                    "--scope-type": [
                      "GLOBAL",
                      "REGIONAL"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "services": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--application": "value",
                        "--async": "bool",
                        "--business-owners": "value",
                        "--criticality-type": [
                          "HIGH",
                          "LOW",
                          "MEDIUM",
                          "MISSION_CRITICAL",
                          "TYPE_UNSPECIFIED"
                        ],
                        "--description": "value",
                        "--developer-owners": "value",
                        "--discovered-service": "value",
                        "--display-name": "value",
                        "--environment-type": [
                          "DEVELOPMENT",
                          "PRODUCTION",
                          "STAGING",
                          "TEST",
                          "TYPE_UNSPECIFIED"
                        ],
                        "--location": "value",
                        "--operator-owners": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--application": "value",
                        "--async": "bool",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--application": "value",
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--application": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--application": "value",
                        "--async": "bool",
                        "--business-owners": "value",
                        "--criticality-type": [
                          "HIGH",
                          "LOW",
                          "MEDIUM",
                          "MISSION_CRITICAL",
                          "TYPE_UNSPECIFIED"
                        ],
                        "--description": "value",
                        "--developer-owners": "value",
                        "--display-name": "value",
                        "--environment-type": [
                          "DEVELOPMENT",
                          "PRODUCTION",
                          "STAGING",
                          "TEST",
                          "TYPE_UNSPECIFIED"
                        ],
                        "--location": "value",
                        "--operator-owners": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--business-owners": "value",
                    "--criticality-type": [
                      "HIGH",
                      "LOW",
                      "MEDIUM",
                      "MISSION_CRITICAL",
                      "TYPE_UNSPECIFIED"
                    ],
                    "--description": "value",
                    "--developer-owners": "value",
                    "--display-name": "value",
                    "--environment-type": [
                      "DEVELOPMENT",
                      "PRODUCTION",
                      "STAGING",
                      "TEST",
                      "TYPE_UNSPECIFIED"
                    ],
                    "--location": "value",
                    "--operator-owners": "value"
                  }
                },
                "workloads": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--application": "value",
                        "--async": "bool",
                        "--business-owners": "value",
                        "--criticality-type": [
                          "HIGH",
                          "LOW",
                          "MEDIUM",
                          "MISSION_CRITICAL",
                          "TYPE_UNSPECIFIED"
                        ],
                        "--description": "value",
                        "--developer-owners": "value",
                        "--discovered-workload": "value",
                        "--display-name": "value",
                        "--environment-type": [
                          "DEVELOPMENT",
                          "PRODUCTION",
                          "STAGING",
                          "TEST",
                          "TYPE_UNSPECIFIED"
                        ],
                        "--location": "value",
                        "--operator-owners": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--application": "value",
                        "--async": "bool",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--application": "value",
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--application": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--application": "value",
                        "--async": "bool",
                        "--business-owners": "value",
                        "--criticality-type": [
                          "HIGH",
                          "LOW",
                          "MEDIUM",
                          "MISSION_CRITICAL",
                          "TYPE_UNSPECIFIED"
                        ],
                        "--description": "value",
                        "--developer-owners": "value",
                        "--display-name": "value",
                        "--environment-type": [
                          "DEVELOPMENT",
                          "PRODUCTION",
                          "STAGING",
                          "TEST",
                          "TYPE_UNSPECIFIED"
                        ],
                        "--location": "value",
                        "--operator-owners": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "discovered-services": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "find-unregistered": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "lookup": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--uri": "value"
                  }
                }
              },
              "flags": {}
            },
            "discovered-workloads": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "find-unregistered": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "lookup": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--uri": "value"
                  }
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "service-projects": {
              "commands": {
                "add": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "detach": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "lookup": {
                  "commands": {},
                  "flags": {}
                },
                "remove": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "artifacts": {
          "commands": {
            "apt": {
              "commands": {
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--gcs-source": "value",
                    "--location": "value"
                  }
                },
                "upload": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                }
              },
              "flags": {}
            },
            "docker": {
              "commands": {
                "images": {
                  "commands": {
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--delete-tags": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--metadata-filter": "value",
                        "--show-all-metadata": "bool",
                        "--show-build-details": "bool",
                        "--show-deployment": "bool",
                        "--show-image-basis": "bool",
                        "--show-package-vulnerability": "bool",
                        "--show-provenance": "bool",
                        "--show-sbom-references": "bool"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--include-tags": "bool",
                        "--limit": "value",
                        "--occurrence-filter": "value",
                        "--page-size": "value",
                        "--show-occurrences": "bool",
                        "--show-occurrences-from": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "tags": {
                  "commands": {
                    "add": {
                      "commands": {},
                      "flags": {}
                    },
                    "delete": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "files": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--package": "value",
                    "--page-size": "value",
                    "--repository": "value",
                    "--sort-by": "value",
                    "--tag": "value"
                  }
                }
              },
              "flags": {}
            },
            "generic": {
              "commands": {
                "download": {
                  "commands": {},
                  "flags": {
                    "--chunk-size": "value",
                    "--destination": "value",
                    "--location": "value",
                    "--name": "value",
                    "--package": "value",
                    "--repository": "value"
                  }
                },
                "upload": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--destination-path": "value",
                    "--location": "value",
                    "--package": "value",
                    "--repository": "value",
                    "--skip-existing": "bool",
                    "--source": "value",
                    "--source-directory": "value"
                  }
                }
              },
              "flags": {}
            },
            "go": {
              "commands": {
                "upload": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--module-path": "value",
                    "--repository": "value",
                    "--source": "value"
                  }
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "packages": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--repository": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--repository": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "print-settings": {
              "commands": {
                "apt": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--repository": "value"
                  }
                },
                "gradle": {
                  "commands": {},
                  "flags": {
                    "--json-key": "value",
                    "--location": "value",
                    "--repository": "value"
                  }
                },
                "mvn": {
                  "commands": {},
                  "flags": {
                    "--json-key": "value",
                    "--location": "value",
                    "--repository": "value"
                  }
                },
                "npm": {
                  "commands": {},
                  "flags": {
                    "--json-key": "value",
                    "--location": "value",
                    "--repository": "value",
                    "--scope": "value"
                  }
                },
                "python": {
                  "commands": {},
                  "flags": {
                    "--json-key": "value",
                    "--location": "value",
                    "--repository": "value"
                  }
                },
                "yum": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--repository": "value"
                  }
                }
              },
              "flags": {}
            },
            "repositories": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--location": "value",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--allow-snapshot-overwrites": "bool",
                    "--async": "bool",
                    "--description": "value",
                    "--kms-key": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--repository-format": "value",
                    "--version-policy": [
                      "none",
                      "release",
                      "snapshot"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "settings": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "disable-upgrade-redirection": {
                  "commands": {},
                  "flags": {}
                },
                "enable-upgrade-redirection": {
                  "commands": {},
                  "flags": {
                    "--dry-run": "bool"
                  }
                }
              },
              "flags": {}
            },
            "tags": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--package": "value",
                    "--repository": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--package": "value",
                    "--repository": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--package": "value",
                    "--page-size": "value",
                    "--repository": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--package": "value",
                    "--repository": "value"
                  }
                }
              },
              "flags": {}
            },
            "versions": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--delete-tags": "bool",
                    "--location": "value",
                    "--package": "value",
                    "--repository": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--package": "value",
                    "--page-size": "value",
                    "--repository": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "vpcsc-config": {
              "commands": {
                "allow": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "deny": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "yum": {
              "commands": {
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--gcs-source": "value",
                    "--location": "value"
                  }
                },
                "upload": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "asset": {
          "commands": {
            "analyze-iam-policy": {
              "commands": {},
              "flags": {
                "--access-time": "value",
                "--analyze-service-account-impersonation": "bool",
                "--execution-timeout": "value",
                "--expand-groups": "bool",
                "--expand-resources": "bool",
                "--expand-roles": "bool",
                "--folder": "value",
                "--full-resource-name": "value",
                "--identity": "value",
                "--include-deny-policy-analysis": "bool",
                "--organization": "value",
                "--output-group-edges": "bool",
                "--output-resource-edges": "bool",
                "--permissions": "value",
                "--roles": "value",
                "--saved-analysis-query": "value",
                "--show-response": "bool"
              }
            },
            "analyze-iam-policy-longrunning": {
              "commands": {},
              "flags": {
                "--access-time": "value",
                "--analyze-service-account-impersonation": "bool",
                "--bigquery-dataset": "value",
                "--bigquery-partition-key": [
                  "PARTITION_KEY_UNSPECIFIED",
                  "REQUEST_TIME"
                ],
                "--bigquery-table-prefix": "value",
                "--bigquery-write-disposition": "value",
                "--expand-groups": "bool",
                "--expand-resources": "bool",
                "--expand-roles": "bool",
                "--folder": "value",
                "--full-resource-name": "value",
                "--gcs-output-path": "value",
                "--identity": "value",
                "--include-deny-policy-analysis": "bool",
                "--organization": "value",
                "--output-group-edges": "bool",
                "--output-resource-edges": "bool",
                "--permissions": "value",
                "--roles": "value"
              }
            },
            "analyze-org-policies": {
              "commands": {},
              "flags": {
                "--constraint": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--scope": "value",
                "--sort-by": "value"
              }
            },
            "analyze-org-policy-governed-containers": {
              "commands": {},
              "flags": {
                "--constraint": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--scope": "value",
                "--sort-by": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--asset-types": "value",
                "--bigquery-dataset": "dynamic",
                "--bigquery-table": "dynamic",
                "--content-type": [
                  "access-policy",
                  "iam-policy",
                  "org-policy",
                  "os-inventory",
                  "relationship",
                  "resource"
                ],
                "--folder": "value",
                "--organization": "value",
                "--output-bigquery-force": "bool",
                "--output-path": "value",
                "--output-path-prefix": "value",
                "--partition-key": [
                  "read-time",
                  "request-time"
                ],
                "--per-asset-type": "bool",
                "--relationship-types": "value",
                "--snapshot-time": "value"
              }
            },
            "feeds": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--asset-names": "value",
                    "--asset-types": "value",
                    "--condition-description": "value",
                    "--condition-expression": "value",
                    "--condition-title": "value",
                    "--content-type": [
                      "access-policy",
                      "iam-policy",
                      "org-policy",
                      "os-inventory",
                      "relationship",
                      "resource"
                    ],
                    "--folder": "value",
                    "--organization": "value",
                    "--pubsub-topic": "value",
                    "--relationship-types": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-asset-names": "value",
                    "--add-asset-types": "value",
                    "--add-relationship-types": "value",
                    "--clear-asset-names": "bool",
                    "--clear-asset-types": "bool",
                    "--clear-condition-description": "bool",
                    "--clear-condition-expression": "bool",
                    "--clear-condition-title": "bool",
                    "--clear-content-type": "bool",
                    "--clear-relationship-types": "bool",
                    "--condition-description": "value",
                    "--condition-expression": "value",
                    "--condition-title": "value",
                    "--content-type": [
                      "access-policy",
                      "iam-policy",
                      "org-policy",
                      "os-inventory",
                      "relationship",
                      "resource"
                    ],
                    "--folder": "value",
                    "--organization": "value",
                    "--pubsub-topic": "value",
                    "--remove-asset-names": "value",
                    "--remove-asset-types": "value",
                    "--remove-relationship-types": "value"
                  }
                }
              },
              "flags": {}
            },
            "get-history": {
              "commands": {},
              "flags": {
                "--asset-names": "value",
                "--content-type": [
                  "access-policy",
                  "iam-policy",
                  "org-policy",
                  "os-inventory",
                  "relationship",
                  "resource"
                ],
                "--end-time": "value",
                "--organization": "value",
                "--relationship-types": "value",
                "--start-time": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--asset-types": "value",
                "--content-type": [
                  "access-policy",
                  "iam-policy",
                  "org-policy",
                  "os-inventory",
                  "relationship",
                  "resource"
                ],
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--organization": "value",
                "--page-size": "value",
                "--relationship-types": "value",
                "--snapshot-time": "value",
                "--sort-by": "value"
              }
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "query": {
              "commands": {},
              "flags": {
                "--bigquery-dataset": "dynamic",
                "--bigquery-table": "dynamic",
                "--end-time": "value",
                "--folder": "value",
                "--job-reference": "value",
                "--organization": "value",
                "--page-size": "value",
                "--page-token": "value",
                "--snapshot-time": "value",
                "--start-time": "value",
                "--statement": "value",
                "--timeout": "value",
                "--write-disposition": [
                  "write-append",
                  "write-empty",
                  "write-truncate"
                ]
              }
            },
            "saved-queries": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--folder": "value",
                    "--labels": "value",
                    "--organization": "value",
                    "--query-file-path": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--folder": "value",
                    "--organization": "value",
                    "--query-file-path": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "assured": {
          "commands": {
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "workloads": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--compliance-regime": [
                      "assured-workloads-for-partners",
                      "au-regions-and-us-support",
                      "ca-protected-b",
                      "ca-regions-and-support",
                      "canada-controlled-goods",
                      "cjis",
                      "eu-regions-and-support",
                      "fedramp-high",
                      "fedramp-moderate",
                      "healthcare-and-life-sciences-controls",
                      "healthcare-and-life-sciences-controls-us-support",
                      "hipaa",
                      "hitrust",
                      "il2",
                      "il4",
                      "il5",
                      "irs-1075",
                      "isr-regions",
                      "isr-regions-and-support",
                      "itar",
                      "jp-regions-and-support",
                      "ksa-regions-and-support-with-sovereignty-controls",
                      "regional-controls",
                      "us-regional-access"
                    ],
                    "--display-name": "value",
                    "--enable-sovereign-controls": "value",
                    "--external-identifier": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--next-rotation-time": "value",
                    "--organization": "value",
                    "--partner": [
                      "local-controls-by-s3ns",
                      "sovereign-controls-by-cntxt",
                      "sovereign-controls-by-cntxt-no-ekm",
                      "sovereign-controls-by-psn",
                      "sovereign-controls-by-sia-minsait",
                      "sovereign-controls-by-t-systems"
                    ],
                    "--partner-permissions": "value",
                    "--partner-services-billing-account": "value",
                    "--provisioned-resources-parent": "value",
                    "--resource-settings": "value",
                    "--rotation-period": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--etag": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "enable-resource-monitoring": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--display-name": "value",
                    "--etag": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--violation-notifications-enabled": "value"
                  }
                },
                "violations": {
                  "commands": {
                    "acknowledge": {
                      "commands": {},
                      "flags": {
                        "--acknowledge-type": "value",
                        "--comment": "value",
                        "--location": "value",
                        "--organization": "value",
                        "--workload": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--organization": "value",
                        "--workload": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--organization": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--workload": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "audit-manager": {
          "commands": {
            "audit-reports": {
              "commands": {
                "generate": {
                  "commands": {},
                  "flags": {
                    "--compliance-framework": "value",
                    "--folder": "value",
                    "--gcs-uri": "value",
                    "--location": "value",
                    "--report-format": [
                      "odf"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "audit-scopes": {
              "commands": {
                "generate": {
                  "commands": {},
                  "flags": {
                    "--compliance-framework": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--output-directory": "value",
                    "--output-file-name": "value",
                    "--report-format": [
                      "odf"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "enrollments": {
              "commands": {
                "add": {
                  "commands": {},
                  "flags": {
                    "--eligible-gcs-buckets": "value",
                    "--folder": "value",
                    "--organization": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "auth": {
          "commands": {
            "activate-service-account": {
              "commands": {},
              "flags": {
                "--key-file": "value",
                "--password-file": "value",
                "--prompt-for-password": "bool"
              }
            },
            "application-default": {
              "commands": {
                "login": {
                  "commands": {},
                  "flags": {
                    "--browser": "bool",
                    "--client-id-file": "value",
                    "--disable-quota-project": "bool",
                    "--launch-browser": "bool",
                    "--login-config": "value",
                    "--scopes": "value"
                  }
                },
                "print-access-token": {
                  "commands": {},
                  "flags": {
                    "--lifetime": "value",
                    "--scopes": "value"
                  }
                },
                "revoke": {
                  "commands": {},
                  "flags": {}
                },
                "set-quota-project": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "configure-docker": {
              "commands": {},
              "flags": {}
            },
            "enterprise-certificate-config": {
              "commands": {
                "create": {
                  "commands": {
                    "linux": {
                      "commands": {},
                      "flags": {
                        "--ecp": "value",
                        "--ecp-client": "value",
                        "--label": "value",
                        "--module": "value",
                        "--output-file": "value",
                        "--slot": "value",
                        "--tls-offload": "value",
                        "--user-pin": "value"
                      }
                    },
                    "macos": {
                      "commands": {},
                      "flags": {
                        "--ecp": "value",
                        "--ecp-client": "value",
                        "--issuer": "value",
                        "--output-file": "value",
                        "--tls-offload": "value"
                      }
                    },
                    "windows": {
                      "commands": {},
                      "flags": {
                        "--ecp": "value",
                        "--ecp-client": "value",
                        "--issuer": "value",
                        "--output-file": "value",
                        "--provider": "value",
                        "--store": "value",
                        "--tls-offload": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--filter-account": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "login": {
              "commands": {},
              "flags": {
                "--activate": "bool",
                "--brief": "bool",
                "--browser": "bool",
                "--cred-file": "value",
                "--enable-gdrive-access": "bool",
                "--force": "bool",
                "--launch-browser": "bool",
                "--login-config": "value",
                "--update-adc": "bool"
              }
            },
            "print-access-token": {
              "commands": {},
              "flags": {
                "--lifetime": "value"
              }
            },
            "print-identity-token": {
              "commands": {},
              "flags": {
                "--audiences": "value",
                "--include-email": "bool",
                "--include-license": "bool",
                "--token-format": [
                  "full",
                  "standard"
                ]
              }
            },
            "revoke": {
              "commands": {},
              "flags": {
                "--all": "bool"
              }
            }
          },
          "flags": {}
        },
        "backup-dr": {
          "commands": {
            "backup-plan-associations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--backup-plan": "dynamic",
                    "--location": "dynamic",
                    "--resource": "value",
                    "--resource-type": "value",
                    "--workload-project": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic",
                    "--workload-project": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "trigger-backup": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--backup-rule-id": "value",
                    "--location": "dynamic",
                    "--workload-project": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "backup-plans": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--backup-rule": "value",
                    "--backup-vault": "dynamic",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "dynamic",
                    "--resource-type": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "backup-vaults": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--access-restriction": [
                      "unrestricted",
                      "within-org",
                      "within-org-but-unrestricted-for-ba",
                      "within-project"
                    ],
                    "--backup-min-enforced-retention": "value",
                    "--description": "value",
                    "--effective-time": "value",
                    "--labels": "value",
                    "--location": "dynamic",
                    "--no-async": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--allow-missing": "bool",
                    "--ignore-backup-plan-references": "bool",
                    "--ignore-inactive-datasources": "bool",
                    "--location": "dynamic",
                    "--no-async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--backup-min-enforced-retention": "value",
                    "--description": "value",
                    "--effective-time": "value",
                    "--force-update": "bool",
                    "--location": "dynamic",
                    "--no-async": "bool",
                    "--unlock-backup-min-enforced-retention": "bool"
                  }
                }
              },
              "flags": {}
            },
            "backups": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--backup-vault": "dynamic",
                    "--data-source": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--backup-vault": "dynamic",
                    "--data-source": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--backup-vault": "value",
                    "--data-source": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "restore": {
                  "commands": {
                    "compute": {
                      "commands": {},
                      "flags": {
                        "--accelerator": "value",
                        "--async": "bool",
                        "--backup-vault": "dynamic",
                        "--can-ip-forward": "bool",
                        "--confidential-compute": "bool",
                        "--create-disk": "value",
                        "--data-source": "dynamic",
                        "--deletion-protection": "bool",
                        "--description": "value",
                        "--enable-display-device": "bool",
                        "--enable-uefi-networking": "bool",
                        "--hostname": "value",
                        "--instance-kms-key": "value",
                        "--instance-termination-action": [
                          "DELETE",
                          "STOP"
                        ],
                        "--key-revocation-action-type": "value",
                        "--labels": "value",
                        "--local-ssd-recovery-timeout": "value",
                        "--location": "dynamic",
                        "--machine-type": "value",
                        "--maintenance-policy": [
                          "MIGRATE",
                          "TERMINATE"
                        ],
                        "--metadata": "value",
                        "--min-cpu-platform": "value",
                        "--min-node-cpu": "value",
                        "--name": "value",
                        "--network-interface": "value",
                        "--network-performance-configs": "value",
                        "--no-scopes": "bool",
                        "--preemptible": "bool",
                        "--private-ipv6-google-access-type": "value",
                        "--provisioning-model": [
                          "SPOT",
                          "STANDARD"
                        ],
                        "--reservation": "value",
                        "--reservation-affinity": [
                          "any",
                          "none",
                          "specific"
                        ],
                        "--resource-manager-tags": "value",
                        "--resource-policies": "value",
                        "--restart-on-failure": "bool",
                        "--scopes": "value",
                        "--service-account": "value",
                        "--tags": "value",
                        "--target-project": "value",
                        "--target-zone": "value",
                        "--threads-per-core": "value",
                        "--visible-core-count": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "data-sources": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--backup-vault": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--backup-vault": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "management-servers": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic",
                    "--network": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "batch": {
          "commands": {
            "jobs": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "submit": {
                  "commands": {},
                  "flags": {
                    "--config": "value",
                    "--container-commands-file": "value",
                    "--container-entrypoint": "value",
                    "--container-image-uri": "value",
                    "--job-prefix": "value",
                    "--location": "value",
                    "--machine-type": "value",
                    "--network": "value",
                    "--no-external-ip-address": "bool",
                    "--priority": "value",
                    "--provisioning-model": [
                      "SPOT",
                      "STANDARD"
                    ],
                    "--script-file-path": "value",
                    "--script-text": "value",
                    "--subnetwork": "value"
                  }
                }
              },
              "flags": {}
            },
            "resource-allowances": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--config": "value",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--usage-limit": "value"
                  }
                }
              },
              "flags": {}
            },
            "tasks": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--job": "value",
                    "--location": "value",
                    "--task_group": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--job": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "beyondcorp": {
          "commands": {
            "app": {
              "commands": {
                "connections": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--application-endpoint": "value",
                        "--application-endpoint-host": "value",
                        "--application-endpoint-port": "value",
                        "--async": "bool",
                        "--connectors": "value",
                        "--display-name": "value",
                        "--labels": "value",
                        "--location": "dynamic",
                        "--type": [
                          "tcp"
                        ]
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--application-endpoint": "value",
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--connectors": "value",
                        "--display-name": "value",
                        "--location": "dynamic",
                        "--remove-labels": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "connectors": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--display-name": "value",
                        "--labels": "value",
                        "--location": "dynamic",
                        "--member": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--details": "bool",
                        "--location": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--display-name": "value",
                        "--location": "dynamic",
                        "--remove-labels": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "bigtable": {
          "commands": {
            "app-profiles": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--instance": "value",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--data-boost": "bool",
                    "--data-boost-compute-billing-owner": [
                      "HOST_PAYS"
                    ],
                    "--description": "value",
                    "--force": "bool",
                    "--instance": "dynamic",
                    "--priority": [
                      "PRIORITY_HIGH",
                      "PRIORITY_LOW",
                      "PRIORITY_MEDIUM"
                    ],
                    "--restrict-to": "value",
                    "--route-any": "bool",
                    "--route-to": "dynamic",
                    "--row-affinity": "bool",
                    "--standard": "bool",
                    "--transactional-writes": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--force": "bool",
                    "--instance": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--data-boost": "bool",
                    "--data-boost-compute-billing-owner": [
                      "HOST_PAYS"
                    ],
                    "--description": "value",
                    "--force": "bool",
                    "--instance": "dynamic",
                    "--priority": [
                      "PRIORITY_HIGH",
                      "PRIORITY_LOW",
                      "PRIORITY_MEDIUM"
                    ],
                    "--restrict-to": "value",
                    "--route-any": "bool",
                    "--route-to": "dynamic",
                    "--row-affinity": "bool",
                    "--standard": "bool",
                    "--transactional-writes": "bool"
                  }
                }
              },
              "flags": {}
            },
            "authorized-views": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic",
                    "--table": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--definition-file": "value",
                    "--instance": "dynamic",
                    "--pre-encoded": "bool",
                    "--table": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic",
                    "--table": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic",
                    "--table": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--table": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--table": "dynamic",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic",
                    "--table": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic",
                    "--table": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--definition-file": "value",
                    "--ignore-warnings": "bool",
                    "--instance": "dynamic",
                    "--interactive": "bool",
                    "--pre-encoded": "bool",
                    "--table": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "backups": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--cluster": "dynamic",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "copy": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--destination-backup": "dynamic",
                    "--destination-cluster": "dynamic",
                    "--destination-instance": "dynamic",
                    "--destination-project": "dynamic",
                    "--expiration-date": "value",
                    "--retention-period": "value",
                    "--source-backup": "dynamic",
                    "--source-cluster": "dynamic",
                    "--source-instance": "dynamic",
                    "--source-project": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--backup-type": [
                      "backup-type-unspecified",
                      "hot",
                      "standard"
                    ],
                    "--cluster": "dynamic",
                    "--expiration-date": "value",
                    "--hot-to-standard-time": "value",
                    "--instance": "dynamic",
                    "--retention-period": "value",
                    "--table": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--cluster": "dynamic",
                    "--instance": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--cluster": "dynamic",
                    "--instance": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--cluster": "dynamic",
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--cluster": "dynamic",
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--cluster": "dynamic",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--cluster": "dynamic",
                    "--instance": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--cluster": "dynamic",
                    "--expiration-date": "value",
                    "--hot-to-standard-time": "value",
                    "--instance": "dynamic",
                    "--retention-period": "value"
                  }
                }
              },
              "flags": {}
            },
            "clusters": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--autoscaling-cpu-target": "value",
                    "--autoscaling-max-nodes": "value",
                    "--autoscaling-min-nodes": "value",
                    "--autoscaling-storage-target": "value",
                    "--instance": "dynamic",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--node-scaling-factor": [
                      "node-scaling-factor-1x",
                      "node-scaling-factor-2x"
                    ],
                    "--num-nodes": "value",
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instances": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--autoscaling-cpu-target": "value",
                    "--autoscaling-max-nodes": "value",
                    "--autoscaling-min-nodes": "value",
                    "--autoscaling-storage-target": "value",
                    "--disable-autoscaling": "bool",
                    "--instance": "dynamic",
                    "--num-nodes": "value"
                  }
                }
              },
              "flags": {}
            },
            "hot-tablets": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--end-time": "value",
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--start-time": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "instances": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster": "dynamic",
                    "--cluster-config": "value",
                    "--cluster-num-nodes": "value",
                    "--cluster-storage-type": [
                      "hdd",
                      "ssd"
                    ],
                    "--cluster-zone": "value",
                    "--display-name": "value",
                    "--instance-type": [
                      "DEVELOPMENT",
                      "PRODUCTION"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "tables": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--instance": "dynamic",
                        "--member": "value",
                        "--role": "dynamic"
                      }
                    },
                    "config": {
                      "commands": {
                        "export": {
                          "commands": {},
                          "flags": {
                            "--all": "bool",
                            "--instance": "dynamic",
                            "--path": "value",
                            "--resource-format": [
                              "krm",
                              "terraform"
                            ]
                          }
                        }
                      },
                      "flags": {}
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--automated-backup-retention-period": "value",
                        "--change-stream-retention-period": "value",
                        "--column-families": "value",
                        "--deletion-protection": "bool",
                        "--enable-automated-backup": "bool",
                        "--instance": "dynamic",
                        "--splits": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--instance": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--instance": "dynamic",
                        "--view": [
                          "encryption",
                          "full",
                          "name",
                          "replication",
                          "schema",
                          "stats"
                        ]
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--instance": "dynamic",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--instances": "dynamic",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--instance": "dynamic",
                        "--member": "value",
                        "--role": "dynamic"
                      }
                    },
                    "restore": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--destination": "dynamic",
                        "--destination-instance": "dynamic",
                        "--source": "dynamic",
                        "--source-cluster": "dynamic",
                        "--source-instance": "dynamic"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--instance": "dynamic"
                      }
                    },
                    "undelete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--instance": "dynamic"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--automated-backup-retention-period": "value",
                        "--change-stream-retention-period": "value",
                        "--clear-change-stream-retention-period": "bool",
                        "--deletion-protection": "bool",
                        "--disable-automated-backup": "bool",
                        "--enable-automated-backup": "bool",
                        "--instance": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--display-name": "value"
                  }
                },
                "upgrade": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "tables": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--instance": "dynamic",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--automated-backup-retention-period": "value",
                    "--change-stream-retention-period": "value",
                    "--column-families": "value",
                    "--deletion-protection": "bool",
                    "--enable-automated-backup": "bool",
                    "--instance": "dynamic",
                    "--splits": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic",
                    "--view": [
                      "encryption",
                      "full",
                      "name",
                      "replication",
                      "schema",
                      "stats"
                    ]
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instances": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "restore": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--destination": "dynamic",
                    "--destination-instance": "dynamic",
                    "--source": "dynamic",
                    "--source-cluster": "dynamic",
                    "--source-instance": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "undelete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--instance": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--automated-backup-retention-period": "value",
                    "--change-stream-retention-period": "value",
                    "--clear-change-stream-retention-period": "bool",
                    "--deletion-protection": "bool",
                    "--disable-automated-backup": "bool",
                    "--enable-automated-backup": "bool",
                    "--instance": "dynamic"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "billing": {
          "commands": {
            "accounts": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "projects": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "link": {
                      "commands": {},
                      "flags": {
                        "--account-id": "dynamic",
                        "--billing-account": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--billing-account": "dynamic",
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "unlink": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "budgets": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--all-updates-rule-monitoring-notification-channels": "value",
                    "--all-updates-rule-pubsub-topic": "value",
                    "--billing-account": "value",
                    "--budget-amount": "value",
                    "--calendar-period": [
                      "calendar-period-unspecified",
                      "month",
                      "quarter",
                      "year"
                    ],
                    "--credit-types-treatment": [
                      "credit-types-treatment-unspecified",
                      "exclude-all-credits",
                      "include-all-credits",
                      "include-specified-credits"
                    ],
                    "--disable-default-iam-recipients": "bool",
                    "--display-name": "value",
                    "--end-date": "value",
                    "--filter-credit-types": "value",
                    "--filter-labels": "value",
                    "--filter-projects": "value",
                    "--filter-resource-ancestors": "value",
                    "--filter-services": "value",
                    "--filter-subaccounts": "value",
                    "--last-period-amount": "bool",
                    "--ownership-scope": [
                      "all-users",
                      "billing-account",
                      "ownership-scope-unspecified"
                    ],
                    "--start-date": "value",
                    "--threshold-rule": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-threshold-rule": "value",
                    "--all-updates-rule-monitoring-notification-channels": "value",
                    "--all-updates-rule-pubsub-topic": "value",
                    "--billing-account": "value",
                    "--budget-amount": "value",
                    "--calendar-period": [
                      "calendar-period-unspecified",
                      "month",
                      "quarter",
                      "year"
                    ],
                    "--clear-threshold-rules": "bool",
                    "--credit-types-treatment": [
                      "credit-types-treatment-unspecified",
                      "exclude-all-credits",
                      "include-all-credits",
                      "include-specified-credits"
                    ],
                    "--disable-default-iam-recipients": "bool",
                    "--display-name": "value",
                    "--end-date": "value",
                    "--filter-credit-types": "value",
                    "--filter-labels": "value",
                    "--filter-projects": "value",
                    "--filter-resource-ancestors": "value",
                    "--filter-services": "value",
                    "--filter-subaccounts": "value",
                    "--last-period-amount": "bool",
                    "--ownership-scope": [
                      "all-users",
                      "billing-account",
                      "ownership-scope-unspecified"
                    ],
                    "--start-date": "value",
                    "--threshold-rules-from-file": "value"
                  }
                }
              },
              "flags": {}
            },
            "projects": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "link": {
                  "commands": {},
                  "flags": {
                    "--account-id": "dynamic",
                    "--billing-account": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "dynamic",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "unlink": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "blockchain-node-engine": {
          "commands": {
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "nodes": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--blockchain-type": [
                      "ethereum"
                    ],
                    "--consensus-client": [
                      "lighthouse"
                    ],
                    "--execution-client": [
                      "geth"
                    ],
                    "--location": "dynamic",
                    "--network": [
                      "goerli",
                      "holesky",
                      "mainnet",
                      "sepolia"
                    ],
                    "--node-type": [
                      "full"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "blockchain-validator": {
          "commands": {
            "blockchain-validator-configs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--blockchain-node-id": "value",
                    "--blockchain-type": [
                      "ethereum"
                    ],
                    "--ethereum-protocol-details-gas-limit": "value",
                    "--ethereum-protocol-details-graffiti": "value",
                    "--ethereum-protocol-details-suggested-fee-recipient": "value",
                    "--ethereum-protocol-details-use-block-builder-proposals": "bool",
                    "--existing-seed-phrase-reference-derivation-index": "value",
                    "--existing-seed-phrase-reference-secret": "value",
                    "--key-source": [
                      "existing-seed-phrase-reference",
                      "remote-web3-signer",
                      "seed-phrase-reference"
                    ],
                    "--labels": "value",
                    "--location": "value",
                    "--remote-web3-signer-timeout-duration": "value",
                    "--remote-web3-signer-voting-public-key": "value",
                    "--remote-web3-signer-web3signer-uri": "value",
                    "--request-id": "value",
                    "--seed-phrase-reference-export": "bool",
                    "--seed-phrase-reference-secret": "value",
                    "--validation-work-enabled": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic",
                    "--request-id": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--blockchain-node-id": "value",
                    "--clear-labels": "bool",
                    "--ethereum-protocol-details-graffiti": "value",
                    "--labels": "value",
                    "--location": "dynamic",
                    "--remote-web3-signer-timeout-duration": "value",
                    "--remote-web3-signer-web3signer-uri": "value",
                    "--remove-labels": "value",
                    "--request-id": "value",
                    "--update-labels": "value",
                    "--validation-work-enabled": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "bms": {
          "commands": {
            "instances": {
              "commands": {
                "auth-info": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "disable-hyperthreading": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "disable-serial-console": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "enable-hyperthreading": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "enable-serial-console": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--region": "dynamic"
                  }
                },
                "reimage": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--kms-crypto-key-version": "value",
                    "--os-image": "value",
                    "--region": "dynamic",
                    "--ssh-keys": "dynamic"
                  }
                },
                "rename": {
                  "commands": {},
                  "flags": {
                    "--new-name": "value",
                    "--region": "dynamic"
                  }
                },
                "reset": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "start": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "stop": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--clear-ssh-keys": "bool",
                    "--enable-hyperthreading": "bool",
                    "--kms-crypto-key-version": "value",
                    "--os-image": "value",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--ssh-keys": "dynamic",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "networks": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--region": "dynamic"
                  }
                },
                "list-ip-reservations": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--region": "dynamic"
                  }
                },
                "rename": {
                  "commands": {},
                  "flags": {
                    "--new-name": "value",
                    "--region": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-ip-range-reservation": "value",
                    "--async": "bool",
                    "--clear-ip-range-reservations": "bool",
                    "--clear-labels": "bool",
                    "--region": "dynamic",
                    "--remove-ip-range-reservation": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "nfs-shares": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--allowed-client": "value",
                    "--async": "bool",
                    "--labels": "value",
                    "--region": "dynamic",
                    "--size-gib": "value",
                    "--storage-type": [
                      "HDD",
                      "SSD"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--region": "dynamic"
                  }
                },
                "rename": {
                  "commands": {},
                  "flags": {
                    "--new-name": "value",
                    "--region": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-allowed-client": "value",
                    "--async": "bool",
                    "--clear-allowed-clients": "bool",
                    "--clear-labels": "bool",
                    "--region": "dynamic",
                    "--remove-allowed-client": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "os-images": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value"
                  }
                }
              },
              "flags": {}
            },
            "serial-console-ssh-keys": {
              "commands": {
                "add": {
                  "commands": {},
                  "flags": {
                    "--key": "value",
                    "--key-file": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value"
                  }
                },
                "remove": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "ssh-keys": {
              "commands": {
                "add": {
                  "commands": {},
                  "flags": {
                    "--key": "value",
                    "--key-file": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value"
                  }
                },
                "remove": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "volumes": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--region": "dynamic"
                  }
                },
                "luns": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--volume": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--region": "dynamic",
                        "--volume": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "rename": {
                  "commands": {},
                  "flags": {
                    "--new-name": "value",
                    "--region": "dynamic"
                  }
                },
                "restore": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic",
                    "--snapshot": "value"
                  }
                },
                "snapshot": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--region": "dynamic",
                    "--snapshot-name": "value"
                  }
                },
                "snapshots": {
                  "commands": {
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--volume": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--volume": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--region": "dynamic",
                        "--volume": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "bq": {
          "commands": {
            "datasets": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--overwrite": "bool",
                    "--permissions-file": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--remove-tables": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--permissions-file": "value"
                  }
                }
              },
              "flags": {}
            },
            "jobs": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {}
                },
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--show-all-users": "bool",
                    "--show-config": "bool",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "tables": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--dataset": "dynamic",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "copy": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--destination": "dynamic",
                    "--destination-dataset": "dynamic",
                    "--job-id": "value",
                    "--overwrite": "bool",
                    "--source": "dynamic",
                    "--source-dataset": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--dataset": "dynamic",
                    "--description": "value",
                    "--expiration": "value",
                    "--overwrite": "bool",
                    "--schema": "value",
                    "--schema-file": "value",
                    "--use-legacy-sql": "bool",
                    "--view": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--dataset": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--dataset": "dynamic"
                  }
                },
                "insert": {
                  "commands": {},
                  "flags": {
                    "--data": "value",
                    "--dataset": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--dataset": "dynamic",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "show-rows": {
                  "commands": {},
                  "flags": {
                    "--dataset": "dynamic",
                    "--limit": "value",
                    "--start": "value",
                    "--table": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-columns": "value",
                    "--add-columns-file": "value",
                    "--dataset": "dynamic",
                    "--description": "value",
                    "--expiration": "value",
                    "--relax-columns": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "builds": {
          "commands": {
            "approve": {
              "commands": {},
              "flags": {
                "--comment": "value",
                "--location": "value",
                "--url": "value"
              }
            },
            "cancel": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "connections": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {
                    "bitbucket-cloud": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--authorizer-token-secret-version": "value",
                        "--read-authorizer-token-secret-version": "value",
                        "--region": "dynamic",
                        "--webhook-secret-secret-version": "value",
                        "--workspace": "value"
                      }
                    },
                    "bitbucket-data-center": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--authorizer-token-secret-version": "value",
                        "--host-uri": "value",
                        "--read-authorizer-token-secret-version": "value",
                        "--region": "dynamic",
                        "--service-directory-service": "value",
                        "--ssl-ca-file": "value",
                        "--webhook-secret-secret-version": "value"
                      }
                    },
                    "github": {
                      "commands": {},
                      "flags": {
                        "--app-installation-id": "value",
                        "--async": "bool",
                        "--authorizer-token-secret-version": "value",
                        "--region": "dynamic"
                      }
                    },
                    "github-enterprise": {
                      "commands": {},
                      "flags": {
                        "--app-id": "value",
                        "--app-installation-id": "value",
                        "--app-slug": "value",
                        "--async": "bool",
                        "--host-uri": "value",
                        "--private-key-secret-version": "value",
                        "--region": "dynamic",
                        "--service-directory-service": "value",
                        "--ssl-ca-file": "value",
                        "--webhook-secret-secret-version": "value"
                      }
                    },
                    "gitlab": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--authorizer-token-secret-version": "value",
                        "--host-uri": "value",
                        "--read-authorizer-token-secret-version": "value",
                        "--region": "dynamic",
                        "--service-directory-service": "value",
                        "--ssl-ca-file": "value",
                        "--webhook-secret-secret-version": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "update": {
                  "commands": {
                    "bitbucket-cloud": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--authorizer-token-secret-version": "value",
                        "--read-authorizer-token-secret-version": "value",
                        "--region": "dynamic",
                        "--webhook-secret-secret-version": "value",
                        "--workspace": "value"
                      }
                    },
                    "bitbucket-data-center": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--authorizer-token-secret-version": "value",
                        "--host-uri": "value",
                        "--read-authorizer-token-secret-version": "value",
                        "--region": "dynamic",
                        "--service-directory-service": "value",
                        "--ssl-ca-file": "value"
                      }
                    },
                    "github": {
                      "commands": {},
                      "flags": {
                        "--app-installation-id": "value",
                        "--async": "bool",
                        "--authorizer-token-secret-version": "value",
                        "--region": "dynamic"
                      }
                    },
                    "github-enterprise": {
                      "commands": {},
                      "flags": {
                        "--app-id": "value",
                        "--app-installation-id": "value",
                        "--app-slug": "value",
                        "--async": "bool",
                        "--host-uri": "value",
                        "--private-key-secret-version": "value",
                        "--region": "dynamic",
                        "--service-directory-service": "value",
                        "--ssl-ca-file": "value",
                        "--webhook-secret-secret-version": "value"
                      }
                    },
                    "gitlab": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--authorizer-token-secret-version": "value",
                        "--host-uri": "value",
                        "--read-authorizer-token-secret-version": "value",
                        "--region": "dynamic",
                        "--service-directory-service": "value",
                        "--ssl-ca-file": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "enterprise-config": {
              "commands": {
                "bitbucketserver": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--admin-access-token-secret-version": "value",
                        "--api-key": "value",
                        "--host-uri": "value",
                        "--name": "value",
                        "--peered-network": "value",
                        "--peered-network-ip-range": "value",
                        "--read-access-token-secret-version": "value",
                        "--region": "value",
                        "--ssl-ca-file": "value",
                        "--user-name": "value",
                        "--webhook-secret-secret-version": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--region": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--admin-access-token-secret-version": "value",
                        "--api-key": "value",
                        "--host-uri": "value",
                        "--read-access-token-secret-version": "value",
                        "--region": "value",
                        "--ssl-ca-file": "value",
                        "--user-name": "value",
                        "--webhook-secret-secret-version": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "github": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--app-id": "value",
                        "--gcs-bucket": "value",
                        "--gcs-object": "value",
                        "--generation": "value",
                        "--host-uri": "value",
                        "--name": "value",
                        "--oauth-client-id-name": "value",
                        "--oauth-client-id-version-name": "value",
                        "--oauth-secret-name": "value",
                        "--oauth-secret-version-name": "value",
                        "--peered-network": "value",
                        "--private-key-name": "value",
                        "--private-key-version-name": "value",
                        "--region": "value",
                        "--webhook-key": "value",
                        "--webhook-secret-name": "value",
                        "--webhook-secret-version-name": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--region": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--app-id": "value",
                        "--gcs-bucket": "value",
                        "--gcs-object": "value",
                        "--generation": "value",
                        "--host-uri": "value",
                        "--oauth-client-id-name": "value",
                        "--oauth-client-id-version-name": "value",
                        "--oauth-secret-name": "value",
                        "--oauth-secret-version-name": "value",
                        "--private-key-name": "value",
                        "--private-key-version-name": "value",
                        "--region": "value",
                        "--webhook-key": "value",
                        "--webhook-secret-name": "value",
                        "--webhook-secret-version-name": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "gitlab": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--api-access-token-secret-version": "value",
                        "--api-key-secret-version": "value",
                        "--host-uri": "value",
                        "--name": "value",
                        "--read-access-token-secret-version": "value",
                        "--region": "value",
                        "--service-directory-service": "value",
                        "--ssl-ca-file": "value",
                        "--user-name": "value",
                        "--webhook-secret-secret-version": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--region": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--api-access-token-secret-version": "value",
                        "--api-key-secret-version": "value",
                        "--host-uri": "value",
                        "--read-access-token-secret-version": "value",
                        "--region": "value",
                        "--service-directory-service": "value",
                        "--ssl-ca-file": "value",
                        "--user-name": "value",
                        "--webhook-secret-secret-version": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "get-default-service-account": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--ongoing": "bool",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "log": {
              "commands": {},
              "flags": {
                "--region": "value",
                "--stream": "bool"
              }
            },
            "reject": {
              "commands": {},
              "flags": {
                "--comment": "value",
                "--url": "value"
              }
            },
            "repositories": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--connection": "dynamic",
                    "--region": "dynamic",
                    "--remote-uri": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--connection": "dynamic",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--connection": "dynamic",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--connection": "dynamic",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "submit": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--config": "value",
                "--default-buckets-behavior": [
                  "default-logs-bucket-behavior-unspecified",
                  "legacy-bucket",
                  "regional-user-owned-bucket"
                ],
                "--dir": "value",
                "--disk-size": "value",
                "--gcs-log-dir": "value",
                "--gcs-source-staging-dir": "value",
                "--git-source-dir": "value",
                "--git-source-revision": "value",
                "--ignore-file": "value",
                "--machine-type": [
                  "e2-highcpu-32",
                  "e2-highcpu-8",
                  "e2-medium",
                  "n1-highcpu-32",
                  "n1-highcpu-8"
                ],
                "--no-cache": "bool",
                "--no-source": "bool",
                "--pack": "value",
                "--polling-interval": "value",
                "--region": "value",
                "--revision": "value",
                "--service-account": "value",
                "--substitutions": "value",
                "--suppress-logs": "bool",
                "--tag": "value",
                "--timeout": "value",
                "--worker-pool": "value"
              }
            },
            "triggers": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {
                    "bitbucket-cloud": {
                      "commands": {},
                      "flags": {
                        "--branch-pattern": "value",
                        "--build-config": "value",
                        "--comment-control": [
                          "COMMENTS_DISABLED",
                          "COMMENTS_ENABLED",
                          "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                        ],
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--ignored-files": "value",
                        "--included-files": "value",
                        "--inline-config": "value",
                        "--name": "value",
                        "--pull-request-pattern": "value",
                        "--region": "value",
                        "--repository": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--substitutions": "value",
                        "--tag-pattern": "value",
                        "--trigger-config": "value"
                      }
                    },
                    "bitbucket-data-center": {
                      "commands": {},
                      "flags": {
                        "--branch-pattern": "value",
                        "--build-config": "value",
                        "--comment-control": [
                          "COMMENTS_DISABLED",
                          "COMMENTS_ENABLED",
                          "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                        ],
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--ignored-files": "value",
                        "--included-files": "value",
                        "--inline-config": "value",
                        "--name": "value",
                        "--pull-request-pattern": "value",
                        "--region": "value",
                        "--repository": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--substitutions": "value",
                        "--tag-pattern": "value",
                        "--trigger-config": "value"
                      }
                    },
                    "bitbucketserver": {
                      "commands": {},
                      "flags": {
                        "--bitbucket-server-config-resource": "value",
                        "--branch-pattern": "value",
                        "--build-config": "value",
                        "--comment-control": [
                          "COMMENTS_DISABLED",
                          "COMMENTS_ENABLED",
                          "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                        ],
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--ignored-files": "value",
                        "--included-files": "value",
                        "--inline-config": "value",
                        "--name": "value",
                        "--project-key": "value",
                        "--pull-request-pattern": "value",
                        "--region": "value",
                        "--repo-slug": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--substitutions": "value",
                        "--tag-pattern": "value",
                        "--trigger-config": "value"
                      }
                    },
                    "cloud-source-repositories": {
                      "commands": {},
                      "flags": {
                        "--branch-pattern": "value",
                        "--build-config": "value",
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--ignored-files": "value",
                        "--included-files": "value",
                        "--inline-config": "value",
                        "--name": "value",
                        "--region": "value",
                        "--repo": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--substitutions": "value",
                        "--tag-pattern": "value",
                        "--trigger-config": "value"
                      }
                    },
                    "github": {
                      "commands": {},
                      "flags": {
                        "--branch-pattern": "value",
                        "--build-config": "value",
                        "--comment-control": [
                          "COMMENTS_DISABLED",
                          "COMMENTS_ENABLED",
                          "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                        ],
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--enterprise-config": "value",
                        "--ignored-files": "value",
                        "--include-logs-with-status": "bool",
                        "--included-files": "value",
                        "--inline-config": "value",
                        "--name": "value",
                        "--pull-request-pattern": "value",
                        "--region": "value",
                        "--repo-name": "value",
                        "--repo-owner": "value",
                        "--repository": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--substitutions": "value",
                        "--tag-pattern": "value",
                        "--trigger-config": "value"
                      }
                    },
                    "gitlab": {
                      "commands": {},
                      "flags": {
                        "--branch-pattern": "value",
                        "--build-config": "value",
                        "--comment-control": [
                          "COMMENTS_DISABLED",
                          "COMMENTS_ENABLED",
                          "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                        ],
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--ignored-files": "value",
                        "--included-files": "value",
                        "--inline-config": "value",
                        "--name": "value",
                        "--pull-request-pattern": "value",
                        "--region": "value",
                        "--repository": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--substitutions": "value",
                        "--tag-pattern": "value",
                        "--trigger-config": "value"
                      }
                    },
                    "manual": {
                      "commands": {},
                      "flags": {
                        "--branch": "value",
                        "--build-config": "value",
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--github-enterprise-config": "value",
                        "--inline-config": "value",
                        "--name": "value",
                        "--region": "value",
                        "--repo": "value",
                        "--repo-type": "value",
                        "--repository": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--substitutions": "value",
                        "--tag": "value",
                        "--trigger-config": "value"
                      }
                    },
                    "pubsub": {
                      "commands": {},
                      "flags": {
                        "--branch": "value",
                        "--build-config": "value",
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--github-enterprise-config": "value",
                        "--inline-config": "value",
                        "--name": "value",
                        "--region": "value",
                        "--repo": "value",
                        "--repo-type": "value",
                        "--repository": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--subscription-filter": "value",
                        "--substitutions": "value",
                        "--tag": "value",
                        "--topic": "value",
                        "--trigger-config": "value"
                      }
                    },
                    "webhook": {
                      "commands": {},
                      "flags": {
                        "--branch": "value",
                        "--build-config": "value",
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--github-enterprise-config": "value",
                        "--inline-config": "value",
                        "--name": "value",
                        "--region": "value",
                        "--repo": "value",
                        "--repo-type": "value",
                        "--repository": "value",
                        "--require-approval": "bool",
                        "--secret": "value",
                        "--service-account": "value",
                        "--subscription-filter": "value",
                        "--substitutions": "value",
                        "--tag": "value",
                        "--trigger-config": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--region": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--region": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "run": {
                  "commands": {},
                  "flags": {
                    "--branch": "value",
                    "--region": "value",
                    "--sha": "value",
                    "--substitutions": "value",
                    "--tag": "value"
                  }
                },
                "update": {
                  "commands": {
                    "bitbucket-cloud": {
                      "commands": {},
                      "flags": {
                        "--branch-pattern": "value",
                        "--build-config": "value",
                        "--clear-substitutions": "bool",
                        "--comment-control": [
                          "COMMENTS_DISABLED",
                          "COMMENTS_ENABLED",
                          "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                        ],
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--ignored-files": "value",
                        "--included-files": "value",
                        "--inline-config": "value",
                        "--pull-request-pattern": "value",
                        "--region": "value",
                        "--remove-substitutions": "value",
                        "--repository": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--tag-pattern": "value",
                        "--trigger-config": "value",
                        "--update-substitutions": "value"
                      }
                    },
                    "bitbucket-data-center": {
                      "commands": {},
                      "flags": {
                        "--branch-pattern": "value",
                        "--build-config": "value",
                        "--clear-substitutions": "bool",
                        "--comment-control": [
                          "COMMENTS_DISABLED",
                          "COMMENTS_ENABLED",
                          "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                        ],
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--ignored-files": "value",
                        "--included-files": "value",
                        "--inline-config": "value",
                        "--pull-request-pattern": "value",
                        "--region": "value",
                        "--remove-substitutions": "value",
                        "--repository": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--tag-pattern": "value",
                        "--trigger-config": "value",
                        "--update-substitutions": "value"
                      }
                    },
                    "bitbucketserver": {
                      "commands": {},
                      "flags": {
                        "--bitbucket-server-config-resource": "value",
                        "--branch-pattern": "value",
                        "--build-config": "value",
                        "--clear-substitutions": "bool",
                        "--comment-control": [
                          "COMMENTS_DISABLED",
                          "COMMENTS_ENABLED",
                          "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                        ],
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--ignored-files": "value",
                        "--included-files": "value",
                        "--inline-config": "value",
                        "--project-key": "value",
                        "--pull-request-pattern": "value",
                        "--region": "value",
                        "--remove-substitutions": "value",
                        "--repo-slug": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--tag-pattern": "value",
                        "--trigger-config": "value",
                        "--update-substitutions": "value"
                      }
                    },
                    "cloud-source-repositories": {
                      "commands": {},
                      "flags": {
                        "--branch-pattern": "value",
                        "--build-config": "value",
                        "--clear-substitutions": "bool",
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--ignored-files": "value",
                        "--included-files": "value",
                        "--inline-config": "value",
                        "--region": "value",
                        "--remove-substitutions": "value",
                        "--repo": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--tag-pattern": "value",
                        "--trigger-config": "value",
                        "--update-substitutions": "value"
                      }
                    },
                    "github": {
                      "commands": {},
                      "flags": {
                        "--branch-pattern": "value",
                        "--build-config": "value",
                        "--clear-substitutions": "bool",
                        "--comment-control": [
                          "COMMENTS_DISABLED",
                          "COMMENTS_ENABLED",
                          "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                        ],
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--enterprise-config": "value",
                        "--ignored-files": "value",
                        "--include-logs-with-status": "bool",
                        "--included-files": "value",
                        "--inline-config": "value",
                        "--pull-request-pattern": "value",
                        "--region": "value",
                        "--remove-substitutions": "value",
                        "--repo-name": "value",
                        "--repo-owner": "value",
                        "--repository": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--tag-pattern": "value",
                        "--trigger-config": "value",
                        "--update-substitutions": "value"
                      }
                    },
                    "gitlab": {
                      "commands": {},
                      "flags": {
                        "--branch-pattern": "value",
                        "--build-config": "value",
                        "--clear-substitutions": "bool",
                        "--comment-control": [
                          "COMMENTS_DISABLED",
                          "COMMENTS_ENABLED",
                          "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                        ],
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--ignored-files": "value",
                        "--included-files": "value",
                        "--inline-config": "value",
                        "--pull-request-pattern": "value",
                        "--region": "value",
                        "--remove-substitutions": "value",
                        "--repository": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--tag-pattern": "value",
                        "--trigger-config": "value",
                        "--update-substitutions": "value"
                      }
                    },
                    "manual": {
                      "commands": {},
                      "flags": {
                        "--clear-substitutions": "bool",
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--git-file-source-branch": "value",
                        "--git-file-source-github-enterprise-config": "value",
                        "--git-file-source-path": "value",
                        "--git-file-source-repo-type": "value",
                        "--git-file-source-tag": "value",
                        "--git-file-source-uri": "value",
                        "--inline-config": "value",
                        "--region": "value",
                        "--remove-substitutions": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--source-to-build-branch": "value",
                        "--source-to-build-github-enterprise-config": "value",
                        "--source-to-build-repo-type": "value",
                        "--source-to-build-tag": "value",
                        "--source-to-build-uri": "value",
                        "--trigger-config": "value",
                        "--update-substitutions": "value"
                      }
                    },
                    "pubsub": {
                      "commands": {},
                      "flags": {
                        "--clear-subscription-filter": "bool",
                        "--clear-substitutions": "bool",
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--git-file-source-branch": "value",
                        "--git-file-source-github-enterprise-config": "value",
                        "--git-file-source-path": "value",
                        "--git-file-source-repo-type": "value",
                        "--git-file-source-tag": "value",
                        "--git-file-source-uri": "value",
                        "--inline-config": "value",
                        "--region": "value",
                        "--remove-substitutions": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--source-to-build-branch": "value",
                        "--source-to-build-github-enterprise-config": "value",
                        "--source-to-build-repo-type": "value",
                        "--source-to-build-tag": "value",
                        "--source-to-build-uri": "value",
                        "--subscription-filter": "value",
                        "--topic": "value",
                        "--trigger-config": "value",
                        "--update-substitutions": "value"
                      }
                    },
                    "webhook": {
                      "commands": {},
                      "flags": {
                        "--clear-substitutions": "bool",
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--git-file-source-branch": "value",
                        "--git-file-source-github-enterprise-config": "value",
                        "--git-file-source-path": "value",
                        "--git-file-source-repo-type": "value",
                        "--git-file-source-tag": "value",
                        "--git-file-source-uri": "value",
                        "--inline-config": "value",
                        "--region": "value",
                        "--remove-substitutions": "value",
                        "--require-approval": "bool",
                        "--secret": "value",
                        "--service-account": "value",
                        "--source-to-build-branch": "value",
                        "--source-to-build-github-enterprise-config": "value",
                        "--source-to-build-repo-type": "value",
                        "--source-to-build-tag": "value",
                        "--source-to-build-uri": "value",
                        "--subscription-filter": "value",
                        "--trigger-config": "value",
                        "--update-substitutions": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "worker-pools": {
              "commands": {
                "apply": {
                  "commands": {},
                  "flags": {
                    "--file": "value",
                    "--generation": "value",
                    "--region": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--config-from-file": "value",
                    "--disable-public-ip-address": "bool",
                    "--generation": "value",
                    "--network-attachment": "value",
                    "--no-public-egress": "bool",
                    "--peered-network": "value",
                    "--peered-network-ip-range": "value",
                    "--region": "value",
                    "--route-all-traffic": "bool",
                    "--worker-disk-size": "value",
                    "--worker-machine-type": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--generation": "value",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--generation": "value",
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--generation": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--config-from-file": "value",
                    "--generation": "value",
                    "--public-egress": "bool",
                    "--region": "value",
                    "--worker-disk-size": "value",
                    "--worker-machine-type": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "certificate-manager": {
          "commands": {
            "certificates": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--certificate-file": "value",
                    "--description": "value",
                    "--dns-authorizations": "value",
                    "--domains": "value",
                    "--issuance-config": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--private-key-file": "value",
                    "--scope": [
                      "all-regions",
                      "default",
                      "edge-cache"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--certificate-file": "value",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "dynamic",
                    "--private-key-file": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "dns-authorizations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--domain": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--type": [
                      "fixed-record",
                      "per-project-record",
                      "type-unspecified"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "issuance-configs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--ca-pool": "value",
                    "--description": "value",
                    "--key-algorithm": [
                      "ecdsa-p256",
                      "rsa-2048"
                    ],
                    "--labels": "value",
                    "--lifetime": "value",
                    "--location": "value",
                    "--rotation-window-percentage": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "maps": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "entries": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--certificates": "dynamic",
                        "--description": "value",
                        "--hostname": "value",
                        "--labels": "value",
                        "--location": "dynamic",
                        "--map": "dynamic",
                        "--set-primary": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "dynamic",
                        "--map": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic",
                        "--map": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--map": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--certificates": "dynamic",
                        "--clear-labels": "bool",
                        "--description": "value",
                        "--location": "dynamic",
                        "--map": "dynamic",
                        "--remove-labels": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "dynamic",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "trust-configs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--allowlisted-certificates": "value",
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--trust-store": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--etag": "value",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value",
                    "--update-mask": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-allowlisted-certificates": "value",
                    "--async": "bool",
                    "--clear-allowlisted-certificates": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--remove-allowlisted-certificates": "value",
                    "--remove-labels": "value",
                    "--trust-store": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "cloud-shell": {
          "commands": {
            "get-mount-command": {
              "commands": {},
              "flags": {
                "--force-key-file-overwrite": "bool",
                "--ssh-key-file": "bool"
              }
            },
            "scp": {
              "commands": {},
              "flags": {
                "--dry-run": "bool",
                "--force-key-file-overwrite": "bool",
                "--recurse": "bool",
                "--scp-flag": "value",
                "--ssh-key-file": "bool"
              }
            },
            "ssh": {
              "commands": {},
              "flags": {
                "--authorize-session": "bool",
                "--command": "value",
                "--dry-run": "bool",
                "--force-key-file-overwrite": "bool",
                "--ssh-flag": "value",
                "--ssh-key-file": "bool"
              }
            }
          },
          "flags": {}
        },
        "code": {
          "commands": {
            "clean-up": {
              "commands": {},
              "flags": {
                "--minikube-profile": "value"
              }
            },
            "dev": {
              "commands": {},
              "flags": {
                "--allow-secret-manager": "bool",
                "--application-default-credential": "bool",
                "--builder": "value",
                "--cloudsql-instances": "value",
                "--cpu": "value",
                "--dockerfile": "value",
                "--env-vars": "value",
                "--env-vars-file": "value",
                "--image": "value",
                "--kube-context": "value",
                "--local-port": "value",
                "--memory": "value",
                "--minikube-profile": "value",
                "--minikube-vm-driver": "value",
                "--namespace": "value",
                "--secrets": "value",
                "--service-account": "value",
                "--service-name": "value",
                "--source": "value",
                "--stop-cluster": "bool"
              }
            }
          },
          "flags": {}
        },
        "composer": {
          "commands": {
            "environments": {
              "commands": {
                "check-upgrade": {
                  "commands": {},
                  "flags": {
                    "--airflow-version": "value",
                    "--async": "bool",
                    "--image-version": "value",
                    "--location": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--airflow-configs": "value",
                    "--airflow-version": "value",
                    "--async": "bool",
                    "--cloud-sql-ipv4-cidr": "value",
                    "--cloud-sql-machine-type": "value",
                    "--cloud-sql-preferred-zone": "value",
                    "--cluster-ipv4-cidr": "value",
                    "--cluster-secondary-range-name": "value",
                    "--composer-internal-ipv4-cidr-block": "value",
                    "--composer-network-ipv4-cidr": "value",
                    "--connection-subnetwork": "value",
                    "--connection-type": [
                      "connection-type-unspecified",
                      "private-service-connect",
                      "vpc-peering"
                    ],
                    "--dag-processor-count": "value",
                    "--dag-processor-cpu": "value",
                    "--dag-processor-memory": "value",
                    "--dag-processor-storage": "value",
                    "--disable-cloud-data-lineage-integration": "bool",
                    "--disable-logs-in-cloud-logging-only": "bool",
                    "--disable-private-builds-only": "bool",
                    "--disk-size": "value",
                    "--enable-cloud-data-lineage-integration": "bool",
                    "--enable-high-resilience": "bool",
                    "--enable-ip-alias": "bool",
                    "--enable-ip-masq-agent": "bool",
                    "--enable-logs-in-cloud-logging-only": "bool",
                    "--enable-master-authorized-networks": "bool",
                    "--enable-private-builds-only": "bool",
                    "--enable-private-endpoint": "bool",
                    "--enable-private-environment": "bool",
                    "--enable-privately-used-public-ips": "bool",
                    "--enable-scheduled-snapshot-creation": "bool",
                    "--enable-triggerer": "bool",
                    "--env-variables": "value",
                    "--environment-size": [
                      "large",
                      "medium",
                      "small",
                      "unspecified"
                    ],
                    "--image-version": "value",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--location": "value",
                    "--machine-type": "value",
                    "--maintenance-window-end": "value",
                    "--maintenance-window-recurrence": "value",
                    "--maintenance-window-start": "value",
                    "--master-authorized-networks": "value",
                    "--master-ipv4-cidr": "value",
                    "--max-pods-per-node": "value",
                    "--max-workers": "value",
                    "--min-workers": "value",
                    "--network": "value",
                    "--network-attachment": "value",
                    "--node-count": "value",
                    "--oauth-scopes": "value",
                    "--python-version": [
                      "2",
                      "3"
                    ],
                    "--scheduler-count": "value",
                    "--scheduler-cpu": "value",
                    "--scheduler-memory": "value",
                    "--scheduler-storage": "value",
                    "--service-account": "value",
                    "--services-ipv4-cidr": "value",
                    "--services-secondary-range-name": "value",
                    "--snapshot-creation-schedule": "value",
                    "--snapshot-location": "value",
                    "--snapshot-schedule-timezone": "value",
                    "--storage-bucket": "value",
                    "--subnetwork": "value",
                    "--support-web-server-plugins": "bool",
                    "--tags": "value",
                    "--triggerer-count": "value",
                    "--triggerer-cpu": "value",
                    "--triggerer-memory": "value",
                    "--web-server-allow-all": "bool",
                    "--web-server-allow-ip": "value",
                    "--web-server-cpu": "value",
                    "--web-server-deny-all": "bool",
                    "--web-server-ipv4-cidr": "value",
                    "--web-server-machine-type": "value",
                    "--web-server-memory": "value",
                    "--web-server-storage": "value",
                    "--worker-cpu": "value",
                    "--worker-memory": "value",
                    "--worker-storage": "value",
                    "--zone": "value"
                  }
                },
                "database-failover": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "fetch-database-properties": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--locations": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-packages": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--tree": "bool"
                  }
                },
                "list-upgrades": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list-workloads": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "restart-web-server": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "run": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "snapshots": {
                  "commands": {
                    "load": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--skip-airflow-overrides-setting": "bool",
                        "--skip-environment-variables-setting": "bool",
                        "--skip-gcs-data-copying": "bool",
                        "--skip-pypi-packages-installation": "bool",
                        "--snapshot-path": "value"
                      }
                    },
                    "save": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--snapshot-location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "storage": {
                  "commands": {
                    "dags": {
                      "commands": {
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--environment": "value",
                            "--location": "value"
                          }
                        },
                        "export": {
                          "commands": {},
                          "flags": {
                            "--destination": "value",
                            "--environment": "value",
                            "--location": "value",
                            "--source": "value"
                          }
                        },
                        "import": {
                          "commands": {},
                          "flags": {
                            "--destination": "value",
                            "--environment": "value",
                            "--location": "value",
                            "--source": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--environment": "value",
                            "--location": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "data": {
                      "commands": {
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--environment": "value",
                            "--location": "value"
                          }
                        },
                        "export": {
                          "commands": {},
                          "flags": {
                            "--destination": "value",
                            "--environment": "value",
                            "--location": "value",
                            "--source": "value"
                          }
                        },
                        "import": {
                          "commands": {},
                          "flags": {
                            "--destination": "value",
                            "--environment": "value",
                            "--location": "value",
                            "--source": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--environment": "value",
                            "--location": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "plugins": {
                      "commands": {
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--environment": "value",
                            "--location": "value"
                          }
                        },
                        "export": {
                          "commands": {},
                          "flags": {
                            "--destination": "value",
                            "--environment": "value",
                            "--location": "value",
                            "--source": "value"
                          }
                        },
                        "import": {
                          "commands": {},
                          "flags": {
                            "--destination": "value",
                            "--environment": "value",
                            "--location": "value",
                            "--source": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--environment": "value",
                            "--location": "value"
                          }
                        }
                      },
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--airflow-version": "value",
                    "--async": "bool",
                    "--clear-airflow-configs": "bool",
                    "--clear-env-variables": "bool",
                    "--clear-labels": "bool",
                    "--clear-maintenance-window": "bool",
                    "--clear-pypi-packages": "bool",
                    "--cloud-sql-machine-type": "value",
                    "--dag-processor-count": "value",
                    "--dag-processor-cpu": "value",
                    "--dag-processor-memory": "value",
                    "--dag-processor-storage": "value",
                    "--disable-cloud-data-lineage-integration": "bool",
                    "--disable-high-resilience": "bool",
                    "--disable-logs-in-cloud-logging-only": "bool",
                    "--disable-master-authorized-networks": "bool",
                    "--disable-private-builds-only": "bool",
                    "--disable-private-environment": "bool",
                    "--disable-scheduled-snapshot-creation": "bool",
                    "--disable-triggerer": "bool",
                    "--disable-vpc-connectivity": "bool",
                    "--enable-cloud-data-lineage-integration": "bool",
                    "--enable-high-resilience": "bool",
                    "--enable-logs-in-cloud-logging-only": "bool",
                    "--enable-master-authorized-networks": "bool",
                    "--enable-private-builds-only": "bool",
                    "--enable-private-environment": "bool",
                    "--enable-scheduled-snapshot-creation": "bool",
                    "--enable-triggerer": "bool",
                    "--environment-size": [
                      "large",
                      "medium",
                      "small",
                      "unspecified"
                    ],
                    "--image-version": "value",
                    "--location": "value",
                    "--maintenance-window-end": "value",
                    "--maintenance-window-recurrence": "value",
                    "--maintenance-window-start": "value",
                    "--master-authorized-networks": "value",
                    "--max-workers": "value",
                    "--min-workers": "value",
                    "--network": "value",
                    "--network-attachment": "value",
                    "--node-count": "value",
                    "--remove-airflow-configs": "value",
                    "--remove-env-variables": "value",
                    "--remove-labels": "value",
                    "--remove-pypi-packages": "value",
                    "--scheduler-count": "value",
                    "--scheduler-cpu": "value",
                    "--scheduler-memory": "value",
                    "--scheduler-storage": "value",
                    "--snapshot-creation-schedule": "value",
                    "--snapshot-location": "value",
                    "--snapshot-schedule-timezone": "value",
                    "--subnetwork": "value",
                    "--support-web-server-plugins": "bool",
                    "--triggerer-count": "value",
                    "--triggerer-cpu": "value",
                    "--triggerer-memory": "value",
                    "--update-airflow-configs": "value",
                    "--update-env-variables": "value",
                    "--update-labels": "value",
                    "--update-pypi-package": "value",
                    "--update-pypi-packages-from-file": "value",
                    "--update-web-server-allow-ip": "value",
                    "--web-server-allow-all": "bool",
                    "--web-server-cpu": "value",
                    "--web-server-deny-all": "bool",
                    "--web-server-machine-type": "value",
                    "--web-server-memory": "value",
                    "--web-server-storage": "value",
                    "--worker-cpu": "value",
                    "--worker-memory": "value",
                    "--worker-storage": "value"
                  }
                },
                "user-workloads-config-maps": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--config-map-file-path": "value",
                        "--environment": "value",
                        "--location": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--environment": "value",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--environment": "value",
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--environment": "value",
                        "--location": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--config-map-file-path": "value",
                        "--environment": "value",
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "user-workloads-secrets": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--environment": "value",
                        "--location": "value",
                        "--secret-file-path": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--environment": "value",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--environment": "value",
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--environment": "value",
                        "--location": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--environment": "value",
                        "--location": "value",
                        "--secret-file-path": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--locations": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "compute": {
          "commands": {
            "accelerator-types": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "addresses": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--region": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--addresses": "value",
                    "--description": "value",
                    "--endpoint-type": [
                      "NETLB",
                      "VM"
                    ],
                    "--global": "bool",
                    "--ip-version": [
                      "IPV4",
                      "IPV6"
                    ],
                    "--network": "value",
                    "--network-tier": "value",
                    "--prefix-length": "value",
                    "--purpose": [
                      "GCE_ENDPOINT",
                      "IPSEC_INTERCONNECT",
                      "PRIVATE_SERVICE_CONNECT",
                      "SHARED_LOADBALANCER_VIP",
                      "VPC_PEERING"
                    ],
                    "--region": "dynamic",
                    "--subnet": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "move": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--global": "bool",
                    "--new-name": "value",
                    "--region": "dynamic",
                    "--target-project": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--global": "bool",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "backend-buckets": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "add-signed-url-key": {
                  "commands": {},
                  "flags": {
                    "--key-file": "value",
                    "--key-name": "value"
                  }
                },
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--bypass-cache-on-request-headers": "value",
                    "--cache-key-include-http-header": "value",
                    "--cache-key-query-string-whitelist": "value",
                    "--cache-mode": [
                      "CACHE_ALL_STATIC",
                      "FORCE_CACHE_ALL",
                      "USE_ORIGIN_HEADERS"
                    ],
                    "--client-ttl": "value",
                    "--compression-mode": [
                      "AUTOMATIC",
                      "DISABLED"
                    ],
                    "--custom-response-header": "value",
                    "--default-ttl": "value",
                    "--description": "value",
                    "--enable-cdn": "bool",
                    "--gcs-bucket-name": "dynamic",
                    "--load-balancing-scheme": [
                      "INTERNAL_MANAGED"
                    ],
                    "--max-ttl": "value",
                    "--negative-caching": "bool",
                    "--negative-caching-policy": "value",
                    "--request-coalescing": "bool",
                    "--serve-while-stale": "value",
                    "--signed-url-cache-max-age": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "delete-signed-url-key": {
                  "commands": {},
                  "flags": {
                    "--key-name": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--bypass-cache-on-request-headers": "value",
                    "--cache-key-include-http-header": "value",
                    "--cache-key-query-string-whitelist": "value",
                    "--cache-mode": [
                      "CACHE_ALL_STATIC",
                      "FORCE_CACHE_ALL",
                      "USE_ORIGIN_HEADERS"
                    ],
                    "--client-ttl": "value",
                    "--compression-mode": [
                      "AUTOMATIC",
                      "DISABLED"
                    ],
                    "--custom-response-header": "value",
                    "--default-ttl": "value",
                    "--description": "value",
                    "--edge-security-policy": "dynamic",
                    "--enable-cdn": "bool",
                    "--gcs-bucket-name": "dynamic",
                    "--max-ttl": "value",
                    "--negative-caching": "bool",
                    "--negative-caching-policy": "value",
                    "--no-bypass-cache-on-request-headers": "bool",
                    "--no-client-ttl": "bool",
                    "--no-custom-response-headers": "bool",
                    "--no-default-ttl": "bool",
                    "--no-max-ttl": "bool",
                    "--no-negative-caching-policies": "bool",
                    "--no-serve-while-stale": "bool",
                    "--request-coalescing": "bool",
                    "--serve-while-stale": "value",
                    "--signed-url-cache-max-age": "value"
                  }
                }
              },
              "flags": {}
            },
            "backend-services": {
              "commands": {
                "add-backend": {
                  "commands": {},
                  "flags": {
                    "--balancing-mode": [
                      "CONNECTION",
                      "CUSTOM_METRICS",
                      "RATE",
                      "UTILIZATION"
                    ],
                    "--capacity-scaler": "value",
                    "--custom-metrics": "value",
                    "--custom-metrics-file": "value",
                    "--description": "value",
                    "--failover": "bool",
                    "--global": "bool",
                    "--global-network-endpoint-group": "bool",
                    "--instance-group": "dynamic",
                    "--instance-group-region": "dynamic",
                    "--instance-group-zone": "dynamic",
                    "--max-connections": "value",
                    "--max-connections-per-endpoint": "value",
                    "--max-connections-per-instance": "value",
                    "--max-rate": "value",
                    "--max-rate-per-endpoint": "value",
                    "--max-rate-per-instance": "value",
                    "--max-utilization": "value",
                    "--network-endpoint-group": "value",
                    "--network-endpoint-group-region": "dynamic",
                    "--network-endpoint-group-zone": "dynamic",
                    "--preference": [
                      "DEFAULT",
                      "PREFERRED"
                    ],
                    "--region": "dynamic"
                  }
                },
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "value"
                  }
                },
                "add-service-bindings": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--service-bindings": "dynamic"
                  }
                },
                "add-signed-url-key": {
                  "commands": {},
                  "flags": {
                    "--key-file": "value",
                    "--key-name": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--affinity-cookie-name": "value",
                    "--affinity-cookie-path": "value",
                    "--affinity-cookie-ttl": "value",
                    "--bypass-cache-on-request-headers": "value",
                    "--cache-key-include-host": "bool",
                    "--cache-key-include-http-header": "value",
                    "--cache-key-include-named-cookie": "value",
                    "--cache-key-include-protocol": "bool",
                    "--cache-key-include-query-string": "bool",
                    "--cache-key-query-string-blacklist": "value",
                    "--cache-key-query-string-whitelist": "value",
                    "--cache-mode": [
                      "CACHE_ALL_STATIC",
                      "FORCE_CACHE_ALL",
                      "USE_ORIGIN_HEADERS"
                    ],
                    "--client-ttl": "value",
                    "--compression-mode": [
                      "AUTOMATIC",
                      "DISABLED"
                    ],
                    "--connection-drain-on-failover": "bool",
                    "--connection-draining-timeout": "value",
                    "--connection-persistence-on-unhealthy-backends": [
                      "ALWAYS_PERSIST",
                      "DEFAULT_FOR_PROTOCOL",
                      "NEVER_PERSIST"
                    ],
                    "--custom-metrics": "value",
                    "--custom-metrics-file": "value",
                    "--custom-request-header": "value",
                    "--custom-response-header": "value",
                    "--default-ttl": "value",
                    "--description": "value",
                    "--drop-traffic-if-unhealthy": "bool",
                    "--enable-cdn": "bool",
                    "--enable-logging": "bool",
                    "--enable-strong-affinity": "bool",
                    "--failover-ratio": "value",
                    "--global": "bool",
                    "--global-health-checks": "bool",
                    "--health-checks": "dynamic",
                    "--health-checks-region": "dynamic",
                    "--http-health-checks": "dynamic",
                    "--https-health-checks": "dynamic",
                    "--iap": "value",
                    "--idle-timeout-sec": "value",
                    "--ip-address-selection-policy": [
                      "IPV4_ONLY",
                      "IPV6_ONLY",
                      "PREFER_IPV6"
                    ],
                    "--load-balancing-scheme": [
                      "EXTERNAL",
                      "EXTERNAL_MANAGED",
                      "INTERNAL",
                      "INTERNAL_MANAGED",
                      "INTERNAL_SELF_MANAGED"
                    ],
                    "--locality-lb-policy": [
                      "INVALID_LB_POLICY",
                      "LEAST_REQUEST",
                      "MAGLEV",
                      "ORIGINAL_DESTINATION",
                      "RANDOM",
                      "RING_HASH",
                      "ROUND_ROBIN",
                      "WEIGHTED_MAGLEV",
                      "WEIGHTED_ROUND_ROBIN"
                    ],
                    "--logging-optional": [
                      "CUSTOM",
                      "EXCLUDE_ALL_OPTIONAL",
                      "INCLUDE_ALL_OPTIONAL"
                    ],
                    "--logging-optional-fields": "value",
                    "--logging-sample-rate": "value",
                    "--max-ttl": "value",
                    "--negative-caching": "bool",
                    "--negative-caching-policy": "value",
                    "--network": "value",
                    "--port-name": "value",
                    "--protocol": "value",
                    "--region": "dynamic",
                    "--request-coalescing": "bool",
                    "--serve-while-stale": "value",
                    "--service-bindings": "dynamic",
                    "--service-lb-policy": "value",
                    "--session-affinity": [
                      "CLIENT_IP",
                      "CLIENT_IP_NO_DESTINATION",
                      "CLIENT_IP_PORT_PROTO",
                      "CLIENT_IP_PROTO",
                      "GENERATED_COOKIE",
                      "HEADER_FIELD",
                      "HTTP_COOKIE",
                      "NONE",
                      "STRONG_COOKIE_AFFINITY"
                    ],
                    "--signed-url-cache-max-age": "value",
                    "--subsetting-policy": [
                      "CONSISTENT_HASH_SUBSETTING",
                      "NONE"
                    ],
                    "--subsetting-subset-size": "value",
                    "--timeout": "value",
                    "--tracking-mode": [
                      "PER_CONNECTION",
                      "PER_SESSION"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "delete-signed-url-key": {
                  "commands": {},
                  "flags": {
                    "--key-name": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "edit": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "get-effective-security-policies": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "get-health": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-usable": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-backend": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--global-network-endpoint-group": "bool",
                    "--instance-group": "dynamic",
                    "--instance-group-region": "dynamic",
                    "--instance-group-zone": "dynamic",
                    "--network-endpoint-group": "value",
                    "--network-endpoint-group-region": "dynamic",
                    "--network-endpoint-group-zone": "dynamic",
                    "--region": "dynamic"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "value"
                  }
                },
                "remove-service-bindings": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--service-bindings": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "set-security-policy": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--security-policy": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--affinity-cookie-name": "value",
                    "--affinity-cookie-path": "value",
                    "--affinity-cookie-ttl": "value",
                    "--bypass-cache-on-request-headers": "value",
                    "--cache-key-include-host": "bool",
                    "--cache-key-include-http-header": "value",
                    "--cache-key-include-named-cookie": "value",
                    "--cache-key-include-protocol": "bool",
                    "--cache-key-include-query-string": "bool",
                    "--cache-key-query-string-blacklist": "value",
                    "--cache-key-query-string-whitelist": "value",
                    "--cache-mode": [
                      "CACHE_ALL_STATIC",
                      "FORCE_CACHE_ALL",
                      "USE_ORIGIN_HEADERS"
                    ],
                    "--clear-custom-metrics": "bool",
                    "--clear-external-managed-migration-state": "bool",
                    "--client-ttl": "value",
                    "--compression-mode": [
                      "AUTOMATIC",
                      "DISABLED"
                    ],
                    "--connection-drain-on-failover": "bool",
                    "--connection-draining-timeout": "value",
                    "--connection-persistence-on-unhealthy-backends": [
                      "ALWAYS_PERSIST",
                      "DEFAULT_FOR_PROTOCOL",
                      "NEVER_PERSIST"
                    ],
                    "--custom-metrics": "value",
                    "--custom-metrics-file": "value",
                    "--custom-request-header": "value",
                    "--custom-response-header": "value",
                    "--default-ttl": "value",
                    "--description": "value",
                    "--drop-traffic-if-unhealthy": "bool",
                    "--edge-security-policy": "dynamic",
                    "--enable-cdn": "bool",
                    "--enable-logging": "bool",
                    "--enable-strong-affinity": "bool",
                    "--external-managed-migration-state": [
                      "PREPARE",
                      "TEST_ALL_TRAFFIC",
                      "TEST_BY_PERCENTAGE"
                    ],
                    "--external-managed-migration-testing-percentage": "value",
                    "--failover-ratio": "value",
                    "--global": "bool",
                    "--global-health-checks": "bool",
                    "--health-checks": "dynamic",
                    "--health-checks-region": "dynamic",
                    "--http-health-checks": "dynamic",
                    "--https-health-checks": "dynamic",
                    "--iap": "value",
                    "--idle-timeout-sec": "value",
                    "--ip-address-selection-policy": [
                      "IPV4_ONLY",
                      "IPV6_ONLY",
                      "PREFER_IPV6"
                    ],
                    "--load-balancing-scheme": [
                      "EXTERNAL",
                      "EXTERNAL_MANAGED"
                    ],
                    "--locality-lb-policy": [
                      "INVALID_LB_POLICY",
                      "LEAST_REQUEST",
                      "MAGLEV",
                      "ORIGINAL_DESTINATION",
                      "RANDOM",
                      "RING_HASH",
                      "ROUND_ROBIN",
                      "WEIGHTED_MAGLEV",
                      "WEIGHTED_ROUND_ROBIN"
                    ],
                    "--logging-optional": [
                      "CUSTOM",
                      "EXCLUDE_ALL_OPTIONAL",
                      "INCLUDE_ALL_OPTIONAL"
                    ],
                    "--logging-optional-fields": "value",
                    "--logging-sample-rate": "value",
                    "--max-ttl": "value",
                    "--negative-caching": "bool",
                    "--negative-caching-policy": "value",
                    "--no-bypass-cache-on-request-headers": "bool",
                    "--no-client-ttl": "bool",
                    "--no-custom-request-headers": "bool",
                    "--no-custom-response-headers": "bool",
                    "--no-default-ttl": "bool",
                    "--no-health-checks": "bool",
                    "--no-max-ttl": "bool",
                    "--no-negative-caching-policies": "bool",
                    "--no-serve-while-stale": "bool",
                    "--no-service-bindings": "bool",
                    "--no-service-lb-policy": "bool",
                    "--port-name": "value",
                    "--protocol": "value",
                    "--region": "dynamic",
                    "--request-coalescing": "bool",
                    "--security-policy": "dynamic",
                    "--serve-while-stale": "value",
                    "--service-bindings": "dynamic",
                    "--service-lb-policy": "value",
                    "--session-affinity": [
                      "CLIENT_IP",
                      "CLIENT_IP_NO_DESTINATION",
                      "CLIENT_IP_PORT_PROTO",
                      "CLIENT_IP_PROTO",
                      "GENERATED_COOKIE",
                      "HEADER_FIELD",
                      "HTTP_COOKIE",
                      "NONE",
                      "STRONG_COOKIE_AFFINITY"
                    ],
                    "--signed-url-cache-max-age": "value",
                    "--subsetting-policy": [
                      "CONSISTENT_HASH_SUBSETTING",
                      "NONE"
                    ],
                    "--subsetting-subset-size": "value",
                    "--timeout": "value",
                    "--tracking-mode": [
                      "PER_CONNECTION",
                      "PER_SESSION"
                    ]
                  }
                },
                "update-backend": {
                  "commands": {},
                  "flags": {
                    "--balancing-mode": [
                      "CONNECTION",
                      "CUSTOM_METRICS",
                      "RATE",
                      "UTILIZATION"
                    ],
                    "--capacity-scaler": "value",
                    "--clear-custom-metrics": "bool",
                    "--custom-metrics": "value",
                    "--custom-metrics-file": "value",
                    "--description": "value",
                    "--failover": "bool",
                    "--global": "bool",
                    "--instance-group": "dynamic",
                    "--instance-group-region": "dynamic",
                    "--instance-group-zone": "dynamic",
                    "--max-connections": "value",
                    "--max-connections-per-endpoint": "value",
                    "--max-connections-per-instance": "value",
                    "--max-rate": "value",
                    "--max-rate-per-endpoint": "value",
                    "--max-rate-per-instance": "value",
                    "--max-utilization": "value",
                    "--network-endpoint-group": "value",
                    "--network-endpoint-group-zone": "dynamic",
                    "--preference": [
                      "DEFAULT",
                      "PREFERRED"
                    ],
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "commitments": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--auto-renew": "bool",
                    "--custom-end-time": "value",
                    "--existing-reservation": "value",
                    "--local-ssd": "value",
                    "--machine-type": "value",
                    "--maintenance-interval": [
                      "PERIODIC",
                      "RECURRENT"
                    ],
                    "--merge-source-commitments": "value",
                    "--min-cpu-platform": "value",
                    "--plan": [
                      "12-month",
                      "36-month"
                    ],
                    "--region": "dynamic",
                    "--require-specific-reservation": "bool",
                    "--reservation": "dynamic",
                    "--reservation-sharing-policy": [
                      "ALLOW_ALL",
                      "DISALLOW_ALL"
                    ],
                    "--reservation-zone": "dynamic",
                    "--reservations-from-file": "value",
                    "--resource-policies": "value",
                    "--resources": "value",
                    "--resources-accelerator": "value",
                    "--share-setting": [
                      "local",
                      "projects"
                    ],
                    "--share-with": "value",
                    "--split-source-commitment": "value",
                    "--type": [
                      "accelerator-optimized",
                      "accelerator-optimized-a3",
                      "accelerator-optimized-a3-mega",
                      "accelerator-optimized-a3-ultra",
                      "compute-optimized",
                      "compute-optimized-c2d",
                      "compute-optimized-c3",
                      "compute-optimized-c3d",
                      "compute-optimized-h3",
                      "general-purpose",
                      "general-purpose-c4",
                      "general-purpose-c4a",
                      "general-purpose-e2",
                      "general-purpose-n2",
                      "general-purpose-n2d",
                      "general-purpose-n4",
                      "general-purpose-t2d",
                      "graphics-optimized",
                      "memory-optimized",
                      "memory-optimized-m3",
                      "memory-optimized-m4",
                      "memory-optimized-x4",
                      "memory-optimized-x4-16tb",
                      "memory-optimized-x4-24tb",
                      "memory-optimized-x4-32tb",
                      "storage-optimized-z3"
                    ],
                    "--vm-count": "value"
                  }
                },
                "create-license": {
                  "commands": {},
                  "flags": {
                    "--amount": "value",
                    "--cores-per-license": "value",
                    "--license": "value",
                    "--plan": [
                      "12-month",
                      "36-month"
                    ],
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--auto-renew": "bool",
                    "--custom-end-time": "value",
                    "--plan": [
                      "36-month"
                    ],
                    "--region": "dynamic"
                  }
                },
                "update-reservations": {
                  "commands": {},
                  "flags": {
                    "--dest-accelerator": "value",
                    "--dest-local-ssd": "value",
                    "--dest-reservation": "value",
                    "--dest-share-setting": [
                      "local",
                      "projects"
                    ],
                    "--dest-share-with": "value",
                    "--region": "dynamic",
                    "--reservations-from-file": "value",
                    "--source-accelerator": "value",
                    "--source-local-ssd": "value",
                    "--source-reservation": "value",
                    "--source-share-setting": [
                      "local",
                      "projects"
                    ],
                    "--source-share-with": "value"
                  }
                }
              },
              "flags": {}
            },
            "config-ssh": {
              "commands": {},
              "flags": {
                "--dry-run": "bool",
                "--force-key-file-overwrite": "bool",
                "--remove": "bool",
                "--ssh-config-file": "value",
                "--ssh-key-file": "value"
              }
            },
            "connect-to-serial-port": {
              "commands": {},
              "flags": {
                "--dry-run": "bool",
                "--extra-args": "value",
                "--force-key-file-overwrite": "bool",
                "--location": "value",
                "--port": "value",
                "--ssh-key-expiration": "value",
                "--ssh-key-expire-after": "value",
                "--ssh-key-file": "value",
                "--zone": "dynamic"
              }
            },
            "copy-files": {
              "commands": {},
              "flags": {
                "--dry-run": "bool",
                "--force-key-file-overwrite": "bool",
                "--plain": "bool",
                "--ssh-key-expiration": "value",
                "--ssh-key-expire-after": "value",
                "--ssh-key-file": "value",
                "--strict-host-key-checking": [
                  "ask",
                  "no",
                  "yes"
                ],
                "--zone": "value"
              }
            },
            "diagnose": {
              "commands": {
                "export-logs": {
                  "commands": {},
                  "flags": {
                    "--collect-process-traces": "bool",
                    "--zone": "dynamic"
                  }
                },
                "routes": {
                  "commands": {},
                  "flags": {
                    "--container": "value",
                    "--dry-run": "bool",
                    "--external-route-ip": "value",
                    "--force-key-file-overwrite": "bool",
                    "--plain": "bool",
                    "--regexp": "value",
                    "--reverse-traceroute": "bool",
                    "--ssh-flag": "value",
                    "--ssh-key-expiration": "value",
                    "--ssh-key-expire-after": "value",
                    "--ssh-key-file": "value",
                    "--strict-host-key-checking": [
                      "ask",
                      "no",
                      "yes"
                    ],
                    "--user": "value",
                    "--zones": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "disk-settings": {
              "commands": {},
              "flags": {}
            },
            "disk-types": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zones": "value"
                  }
                }
              },
              "flags": {}
            },
            "disks": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic",
                    "--zone": "value"
                  }
                },
                "add-labels": {
                  "commands": {},
                  "flags": {
                    "--labels": "value",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "add-resource-policies": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--resource-policies": "value",
                    "--zone": "dynamic"
                  }
                },
                "bulk": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--source-consistency-group-policy": "value",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ],
                        "--zone": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "convert": {
                  "commands": {},
                  "flags": {
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--region": "dynamic",
                    "--target-disk-type": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--access-mode": [
                      "READ_ONLY_MANY",
                      "READ_WRITE_MANY",
                      "READ_WRITE_SINGLE"
                    ],
                    "--architecture": [
                      "ARM64",
                      "X86_64"
                    ],
                    "--confidential-compute": "bool",
                    "--csek-key-file": "value",
                    "--description": "value",
                    "--erase-windows-vss-signature": "bool",
                    "--global-source-snapshot": "bool",
                    "--guest-os-features": "value",
                    "--image": "value",
                    "--image-family": "value",
                    "--image-family-scope": [
                      "global",
                      "zonal"
                    ],
                    "--image-project": "value",
                    "--interface": "value",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--licenses": "value",
                    "--multi-writer": "bool",
                    "--physical-block-size": [
                      "16384",
                      "4096"
                    ],
                    "--primary-disk": "dynamic",
                    "--primary-disk-project": "value",
                    "--primary-disk-region": "dynamic",
                    "--primary-disk-zone": "dynamic",
                    "--provisioned-iops": "value",
                    "--provisioned-throughput": "value",
                    "--region": "dynamic",
                    "--replica-zones": "value",
                    "--require-csek-key-create": "bool",
                    "--resource-policies": "value",
                    "--size": "value",
                    "--source-disk": "dynamic",
                    "--source-disk-region": "dynamic",
                    "--source-disk-zone": "dynamic",
                    "--source-instant-snapshot": "dynamic",
                    "--source-snapshot": "dynamic",
                    "--source-snapshot-region": "dynamic",
                    "--storage-pool": "value",
                    "--type": "dynamic",
                    "--user-licenses": "value",
                    "--zone": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zones": "value"
                  }
                },
                "move": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--destination-zone": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic",
                    "--zone": "value"
                  }
                },
                "remove-labels": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--labels": "value",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "remove-resource-policies": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--resource-policies": "value",
                    "--zone": "dynamic"
                  }
                },
                "resize": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--size": "value",
                    "--zone": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "snapshot": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--chain-name": "value",
                    "--csek-key-file": "value",
                    "--description": "value",
                    "--guest-flush": "bool",
                    "--labels": "value",
                    "--region": "dynamic",
                    "--snapshot-names": "value",
                    "--storage-location": "value",
                    "--zone": "dynamic"
                  }
                },
                "start-async-replication": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--secondary-disk": "dynamic",
                    "--secondary-disk-project": "value",
                    "--secondary-disk-region": "dynamic",
                    "--secondary-disk-zone": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "stop-async-replication": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "stop-group-async-replication": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--access-mode": [
                      "READ_ONLY_MANY",
                      "READ_WRITE_MANY",
                      "READ_WRITE_SINGLE"
                    ],
                    "--append-licenses": "value",
                    "--clear-architecture": "bool",
                    "--clear-labels": "bool",
                    "--clear-user-licenses": "bool",
                    "--provisioned-iops": "value",
                    "--provisioned-throughput": "value",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--remove-licenses": "value",
                    "--replace-license": "value",
                    "--size": "value",
                    "--update-architecture": [
                      "ARM64",
                      "X86_64"
                    ],
                    "--update-labels": "value",
                    "--update-user-licenses": "value",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "external-vpn-gateways": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--interfaces": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "firewall-policies": {
              "commands": {
                "associations": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--firewall-policy": "value",
                        "--folder": "value",
                        "--name": "value",
                        "--organization": "value",
                        "--replace-association-on-target": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--firewall-policy": "value",
                        "--organization": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--folder": "value",
                        "--limit": "value",
                        "--organization": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "clone-rules": {
                  "commands": {},
                  "flags": {
                    "--organization": "value",
                    "--source-firewall-policy": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--folder": "value",
                    "--organization": "value",
                    "--short-name": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "export-rules": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--organization": "value"
                  }
                },
                "import-rules": {
                  "commands": {},
                  "flags": {
                    "--organization": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-rules": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "mirroring-rules": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "do_not_mirror",
                          "goto_next",
                          "mirror"
                        ],
                        "--description": "value",
                        "--dest-ip-ranges": "value",
                        "--direction": [
                          "EGRESS",
                          "INGRESS"
                        ],
                        "--disabled": "bool",
                        "--firewall-policy": "value",
                        "--layer4-configs": "value",
                        "--organization": "value",
                        "--security-profile-group": "value",
                        "--src-ip-ranges": "value",
                        "--target-resources": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--firewall-policy": "value",
                        "--organization": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--firewall-policy": "value",
                        "--organization": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "do_not_mirror",
                          "goto_next",
                          "mirror"
                        ],
                        "--description": "value",
                        "--dest-ip-ranges": "value",
                        "--direction": [
                          "EGRESS",
                          "INGRESS"
                        ],
                        "--disabled": "bool",
                        "--firewall-policy": "value",
                        "--layer4-configs": "value",
                        "--new-priority": "value",
                        "--organization": "value",
                        "--security-profile-group": "value",
                        "--src-ip-ranges": "value",
                        "--target-resources": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "move": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "rules": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "allow",
                          "apply_security_profile_group",
                          "deny",
                          "goto_next"
                        ],
                        "--description": "value",
                        "--dest-address-groups": "value",
                        "--dest-fqdns": "value",
                        "--dest-ip-ranges": "value",
                        "--dest-network-scope": "value",
                        "--dest-region-codes": "value",
                        "--dest-threat-intelligence": "value",
                        "--direction": [
                          "EGRESS",
                          "INGRESS"
                        ],
                        "--disabled": "bool",
                        "--enable-logging": "bool",
                        "--firewall-policy": "value",
                        "--layer4-configs": "value",
                        "--organization": "value",
                        "--security-profile-group": "value",
                        "--src-address-groups": "value",
                        "--src-fqdns": "value",
                        "--src-ip-ranges": "value",
                        "--src-network-scope": "value",
                        "--src-networks": "value",
                        "--src-region-codes": "value",
                        "--src-secure-tags": "value",
                        "--src-threat-intelligence": "value",
                        "--target-resources": "value",
                        "--target-secure-tags": "value",
                        "--target-service-accounts": "value",
                        "--tls-inspect": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--firewall-policy": "value",
                        "--organization": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--firewall-policy": "value",
                        "--organization": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "allow",
                          "apply_security_profile_group",
                          "deny",
                          "goto_next"
                        ],
                        "--description": "value",
                        "--dest-address-groups": "value",
                        "--dest-fqdns": "value",
                        "--dest-ip-ranges": "value",
                        "--dest-network-scope": "value",
                        "--dest-region-codes": "value",
                        "--dest-threat-intelligence": "value",
                        "--direction": [
                          "EGRESS",
                          "INGRESS"
                        ],
                        "--disabled": "bool",
                        "--enable-logging": "bool",
                        "--firewall-policy": "value",
                        "--layer4-configs": "value",
                        "--new-priority": "value",
                        "--organization": "value",
                        "--security-profile-group": "value",
                        "--src-address-groups": "value",
                        "--src-fqdns": "value",
                        "--src-ip-ranges": "value",
                        "--src-network-scope": "value",
                        "--src-networks": "value",
                        "--src-region-codes": "value",
                        "--src-secure-tags": "value",
                        "--src-threat-intelligence": "value",
                        "--target-resources": "value",
                        "--target-secure-tags": "value",
                        "--target-service-accounts": "value",
                        "--tls-inspect": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--organization": "value"
                  }
                }
              },
              "flags": {}
            },
            "firewall-rules": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--action": [
                      "ALLOW",
                      "DENY"
                    ],
                    "--allow": "value",
                    "--description": "value",
                    "--destination-ranges": "value",
                    "--direction": [
                      "EGRESS",
                      "IN",
                      "INGRESS",
                      "OUT"
                    ],
                    "--disabled": "bool",
                    "--enable-logging": "bool",
                    "--logging-metadata": [
                      "exclude-all",
                      "include-all"
                    ],
                    "--network": "value",
                    "--priority": "value",
                    "--rules": "value",
                    "--source-ranges": "value",
                    "--source-service-accounts": "value",
                    "--source-tags": "value",
                    "--target-service-accounts": "value",
                    "--target-tags": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "migrate": {
                  "commands": {},
                  "flags": {
                    "--bind-tags-to-instances": "bool",
                    "--exclusion-patterns-file": "value",
                    "--export-exclusion-patterns": "bool",
                    "--export-tag-mapping": "bool",
                    "--export-terraform-script": "bool",
                    "--force": "bool",
                    "--skip-migrate-target-service-accounts-to-tags": "bool",
                    "--source-network": "dynamic",
                    "--tag-mapping-file": "value",
                    "--target-firewall-policy": "value",
                    "--terraform-script-output-file": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--allow": "value",
                    "--description": "value",
                    "--destination-ranges": "value",
                    "--disabled": "bool",
                    "--enable-logging": "bool",
                    "--logging-metadata": [
                      "exclude-all",
                      "include-all"
                    ],
                    "--priority": "value",
                    "--rules": "value",
                    "--source-ranges": "value",
                    "--source-service-accounts": "value",
                    "--source-tags": "value",
                    "--target-service-accounts": "value",
                    "--target-tags": "value"
                  }
                }
              },
              "flags": {}
            },
            "forwarding-rules": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--global": "bool",
                        "--path": "value",
                        "--region": "dynamic",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--address": "dynamic",
                    "--address-region": "dynamic",
                    "--allow-global-access": "bool",
                    "--allow-psc-global-access": "bool",
                    "--backend-service": "value",
                    "--backend-service-region": "dynamic",
                    "--description": "value",
                    "--disable-automate-dns-zone": "bool",
                    "--global": "bool",
                    "--global-address": "bool",
                    "--global-backend-service": "bool",
                    "--global-target-http-proxy": "bool",
                    "--global-target-https-proxy": "bool",
                    "--global-target-tcp-proxy": "bool",
                    "--ip-collection": "value",
                    "--ip-collection-region": "dynamic",
                    "--ip-protocol": [
                      "AH",
                      "ALL",
                      "ESP",
                      "ICMP",
                      "L3_DEFAULT",
                      "SCTP",
                      "TCP",
                      "UDP"
                    ],
                    "--ip-version": [
                      "IPV4",
                      "IPV6"
                    ],
                    "--is-mirroring-collector": "bool",
                    "--load-balancing-scheme": [
                      "EXTERNAL",
                      "EXTERNAL_MANAGED",
                      "INTERNAL",
                      "INTERNAL_MANAGED",
                      "INTERNAL_SELF_MANAGED"
                    ],
                    "--network": "value",
                    "--network-tier": "value",
                    "--port-range": "value",
                    "--ports": "value",
                    "--region": "dynamic",
                    "--service-directory-registration": "value",
                    "--service-label": "value",
                    "--source-ip-ranges": "value",
                    "--subnet": "value",
                    "--subnet-region": "dynamic",
                    "--target-google-apis-bundle": "value",
                    "--target-grpc-proxy": "value",
                    "--target-http-proxy": "value",
                    "--target-http-proxy-region": "dynamic",
                    "--target-https-proxy": "value",
                    "--target-https-proxy-region": "dynamic",
                    "--target-instance": "value",
                    "--target-instance-zone": "dynamic",
                    "--target-pool": "value",
                    "--target-pool-region": "dynamic",
                    "--target-service-attachment": "value",
                    "--target-service-attachment-region": "dynamic",
                    "--target-ssl-proxy": "value",
                    "--target-tcp-proxy": "value",
                    "--target-tcp-proxy-region": "dynamic",
                    "--target-vpn-gateway": "value",
                    "--target-vpn-gateway-region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "set-target": {
                  "commands": {},
                  "flags": {
                    "--backend-service": "value",
                    "--backend-service-region": "dynamic",
                    "--global": "bool",
                    "--global-backend-service": "bool",
                    "--global-target-http-proxy": "bool",
                    "--global-target-https-proxy": "bool",
                    "--global-target-tcp-proxy": "bool",
                    "--load-balancing-scheme": [
                      "EXTERNAL",
                      "EXTERNAL_MANAGED",
                      "INTERNAL",
                      "INTERNAL_MANAGED",
                      "INTERNAL_SELF_MANAGED"
                    ],
                    "--network": "value",
                    "--region": "dynamic",
                    "--subnet": "value",
                    "--subnet-region": "value",
                    "--target-grpc-proxy": "value",
                    "--target-http-proxy": "value",
                    "--target-http-proxy-region": "dynamic",
                    "--target-https-proxy": "value",
                    "--target-https-proxy-region": "dynamic",
                    "--target-instance": "value",
                    "--target-instance-zone": "dynamic",
                    "--target-pool": "value",
                    "--target-pool-region": "dynamic",
                    "--target-ssl-proxy": "value",
                    "--target-tcp-proxy": "value",
                    "--target-tcp-proxy-region": "dynamic",
                    "--target-vpn-gateway": "value",
                    "--target-vpn-gateway-region": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--allow-global-access": "bool",
                    "--allow-psc-global-access": "bool",
                    "--clear-external-managed-backend-bucket-migration-state": "bool",
                    "--clear-labels": "bool",
                    "--external-managed-backend-bucket-migration-state": [
                      "PREPARE",
                      "TEST_ALL_TRAFFIC",
                      "TEST_BY_PERCENTAGE"
                    ],
                    "--external-managed-backend-bucket-migration-testing-percentage": "value",
                    "--global": "bool",
                    "--load-balancing-scheme": [
                      "EXTERNAL",
                      "EXTERNAL_MANAGED"
                    ],
                    "--network-tier": "value",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--source-ip-ranges": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "future-reservations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--zone": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--auto-created-reservations-delete-time": "value",
                    "--auto-created-reservations-duration": "value",
                    "--auto-delete-auto-created-reservations": "bool",
                    "--commitment-name": "value",
                    "--commitment-plan": [
                      "THIRTY_SIX_MONTH",
                      "TWELVE_MONTH"
                    ],
                    "--deployment-type": [
                      "DENSE",
                      "FLEXIBLE"
                    ],
                    "--description": "value",
                    "--duration": "value",
                    "--end-time": "value",
                    "--local-ssd": "value",
                    "--machine-type": "value",
                    "--maintenance-freeze-duration": "value",
                    "--maintenance-interval": [
                      "PERIODIC",
                      "RECURRENT"
                    ],
                    "--min-cpu-platform": "value",
                    "--name-prefix": "value",
                    "--planning-status": [
                      "DRAFT",
                      "SUBMITTED"
                    ],
                    "--previous-commitment-terms": [
                      "EXTEND"
                    ],
                    "--require-specific-reservation": "bool",
                    "--reservation-mode": [
                      "CALENDAR",
                      "DEFAULT"
                    ],
                    "--reservation-name": "value",
                    "--scheduling-type": [
                      "GROUPED",
                      "INDEPENDENT"
                    ],
                    "--share-setting": [
                      "local",
                      "projects"
                    ],
                    "--share-with": "value",
                    "--source-instance-template": "value",
                    "--start-time": "value",
                    "--total-count": "value",
                    "--zone": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--auto-created-reservations-delete-time": "value",
                    "--auto-created-reservations-duration": "value",
                    "--auto-delete-auto-created-reservations": "bool",
                    "--clear-accelerator": "bool",
                    "--clear-local-ssd": "bool",
                    "--clear-name-prefix": "bool",
                    "--clear-share-settings": "bool",
                    "--commitment-name": "value",
                    "--commitment-plan": [
                      "THIRTY_SIX_MONTH",
                      "TWELVE_MONTH"
                    ],
                    "--deployment-type": [
                      "DENSE",
                      "FLEXIBLE"
                    ],
                    "--description": "value",
                    "--duration": "value",
                    "--end-time": "value",
                    "--local-ssd": "value",
                    "--machine-type": "value",
                    "--maintenance-interval": [
                      "PERIODIC",
                      "RECURRENT"
                    ],
                    "--min-cpu-platform": "value",
                    "--name-prefix": "value",
                    "--planning-status": [
                      "DRAFT",
                      "SUBMITTED"
                    ],
                    "--previous-commitment-terms": [
                      "EXTEND"
                    ],
                    "--require-specific-reservation": "bool",
                    "--reservation-name": "value",
                    "--scheduling-type": [
                      "GROUPED",
                      "INDEPENDENT"
                    ],
                    "--share-setting": [
                      "local",
                      "projects"
                    ],
                    "--share-with": "value",
                    "--start-time": "value",
                    "--total-count": "value",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "health-checks": {
              "commands": {
                "create": {
                  "commands": {
                    "grpc": {
                      "commands": {},
                      "flags": {
                        "--check-interval": "value",
                        "--description": "value",
                        "--enable-logging": "bool",
                        "--global": "bool",
                        "--grpc-service-name": "value",
                        "--healthy-threshold": "value",
                        "--port": "value",
                        "--region": "dynamic",
                        "--timeout": "value",
                        "--unhealthy-threshold": "value",
                        "--use-serving-port": "bool"
                      }
                    },
                    "http": {
                      "commands": {},
                      "flags": {
                        "--check-interval": "value",
                        "--description": "value",
                        "--enable-logging": "bool",
                        "--global": "bool",
                        "--healthy-threshold": "value",
                        "--host": "value",
                        "--port": "value",
                        "--port-name": "value",
                        "--proxy-header": [
                          "NONE",
                          "PROXY_V1"
                        ],
                        "--region": "dynamic",
                        "--request-path": "value",
                        "--response": "value",
                        "--source-regions": "value",
                        "--timeout": "value",
                        "--unhealthy-threshold": "value",
                        "--use-serving-port": "bool",
                        "--weight-report-mode": [
                          "DISABLE",
                          "DRY_RUN",
                          "ENABLE"
                        ]
                      }
                    },
                    "http2": {
                      "commands": {},
                      "flags": {
                        "--check-interval": "value",
                        "--description": "value",
                        "--enable-logging": "bool",
                        "--global": "bool",
                        "--healthy-threshold": "value",
                        "--host": "value",
                        "--port": "value",
                        "--port-name": "value",
                        "--proxy-header": [
                          "NONE",
                          "PROXY_V1"
                        ],
                        "--region": "dynamic",
                        "--request-path": "value",
                        "--response": "value",
                        "--timeout": "value",
                        "--unhealthy-threshold": "value",
                        "--use-serving-port": "bool",
                        "--weight-report-mode": [
                          "DISABLE",
                          "DRY_RUN",
                          "ENABLE"
                        ]
                      }
                    },
                    "https": {
                      "commands": {},
                      "flags": {
                        "--check-interval": "value",
                        "--description": "value",
                        "--enable-logging": "bool",
                        "--global": "bool",
                        "--healthy-threshold": "value",
                        "--host": "value",
                        "--port": "value",
                        "--port-name": "value",
                        "--proxy-header": [
                          "NONE",
                          "PROXY_V1"
                        ],
                        "--region": "dynamic",
                        "--request-path": "value",
                        "--response": "value",
                        "--source-regions": "value",
                        "--timeout": "value",
                        "--unhealthy-threshold": "value",
                        "--use-serving-port": "bool",
                        "--weight-report-mode": [
                          "DISABLE",
                          "DRY_RUN",
                          "ENABLE"
                        ]
                      }
                    },
                    "ssl": {
                      "commands": {},
                      "flags": {
                        "--check-interval": "value",
                        "--description": "value",
                        "--enable-logging": "bool",
                        "--global": "bool",
                        "--healthy-threshold": "value",
                        "--port": "value",
                        "--port-name": "value",
                        "--proxy-header": [
                          "NONE",
                          "PROXY_V1"
                        ],
                        "--region": "dynamic",
                        "--request": "value",
                        "--response": "value",
                        "--timeout": "value",
                        "--unhealthy-threshold": "value",
                        "--use-serving-port": "bool"
                      }
                    },
                    "tcp": {
                      "commands": {},
                      "flags": {
                        "--check-interval": "value",
                        "--description": "value",
                        "--enable-logging": "bool",
                        "--global": "bool",
                        "--healthy-threshold": "value",
                        "--port": "value",
                        "--port-name": "value",
                        "--proxy-header": [
                          "NONE",
                          "PROXY_V1"
                        ],
                        "--region": "dynamic",
                        "--request": "value",
                        "--response": "value",
                        "--source-regions": "value",
                        "--timeout": "value",
                        "--unhealthy-threshold": "value",
                        "--use-serving-port": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--protocol": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {
                    "grpc": {
                      "commands": {},
                      "flags": {
                        "--check-interval": "value",
                        "--description": "value",
                        "--enable-logging": "bool",
                        "--global": "bool",
                        "--grpc-service-name": "value",
                        "--healthy-threshold": "value",
                        "--port": "value",
                        "--region": "dynamic",
                        "--timeout": "value",
                        "--unhealthy-threshold": "value",
                        "--use-serving-port": "bool"
                      }
                    },
                    "http": {
                      "commands": {},
                      "flags": {
                        "--check-interval": "value",
                        "--description": "value",
                        "--enable-logging": "bool",
                        "--global": "bool",
                        "--healthy-threshold": "value",
                        "--host": "value",
                        "--port": "value",
                        "--port-name": "value",
                        "--proxy-header": [
                          "NONE",
                          "PROXY_V1"
                        ],
                        "--region": "dynamic",
                        "--request-path": "value",
                        "--response": "value",
                        "--source-regions": "value",
                        "--timeout": "value",
                        "--unhealthy-threshold": "value",
                        "--use-serving-port": "bool",
                        "--weight-report-mode": [
                          "DISABLE",
                          "DRY_RUN",
                          "ENABLE"
                        ]
                      }
                    },
                    "http2": {
                      "commands": {},
                      "flags": {
                        "--check-interval": "value",
                        "--description": "value",
                        "--enable-logging": "bool",
                        "--global": "bool",
                        "--healthy-threshold": "value",
                        "--host": "value",
                        "--port": "value",
                        "--port-name": "value",
                        "--proxy-header": [
                          "NONE",
                          "PROXY_V1"
                        ],
                        "--region": "dynamic",
                        "--request-path": "value",
                        "--response": "value",
                        "--timeout": "value",
                        "--unhealthy-threshold": "value",
                        "--use-serving-port": "bool",
                        "--weight-report-mode": [
                          "DISABLE",
                          "DRY_RUN",
                          "ENABLE"
                        ]
                      }
                    },
                    "https": {
                      "commands": {},
                      "flags": {
                        "--check-interval": "value",
                        "--description": "value",
                        "--enable-logging": "bool",
                        "--global": "bool",
                        "--healthy-threshold": "value",
                        "--host": "value",
                        "--port": "value",
                        "--port-name": "value",
                        "--proxy-header": [
                          "NONE",
                          "PROXY_V1"
                        ],
                        "--region": "dynamic",
                        "--request-path": "value",
                        "--response": "value",
                        "--source-regions": "value",
                        "--timeout": "value",
                        "--unhealthy-threshold": "value",
                        "--use-serving-port": "bool",
                        "--weight-report-mode": [
                          "DISABLE",
                          "DRY_RUN",
                          "ENABLE"
                        ]
                      }
                    },
                    "ssl": {
                      "commands": {},
                      "flags": {
                        "--check-interval": "value",
                        "--description": "value",
                        "--enable-logging": "bool",
                        "--global": "bool",
                        "--healthy-threshold": "value",
                        "--port": "value",
                        "--port-name": "value",
                        "--proxy-header": [
                          "NONE",
                          "PROXY_V1"
                        ],
                        "--region": "dynamic",
                        "--request": "value",
                        "--response": "value",
                        "--timeout": "value",
                        "--unhealthy-threshold": "value",
                        "--use-serving-port": "bool"
                      }
                    },
                    "tcp": {
                      "commands": {},
                      "flags": {
                        "--check-interval": "value",
                        "--description": "value",
                        "--enable-logging": "bool",
                        "--global": "bool",
                        "--healthy-threshold": "value",
                        "--port": "value",
                        "--port-name": "value",
                        "--proxy-header": [
                          "NONE",
                          "PROXY_V1"
                        ],
                        "--region": "dynamic",
                        "--request": "value",
                        "--response": "value",
                        "--source-regions": "value",
                        "--timeout": "value",
                        "--unhealthy-threshold": "value",
                        "--use-serving-port": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "http-health-checks": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--check-interval": "value",
                    "--description": "value",
                    "--healthy-threshold": "value",
                    "--host": "value",
                    "--port": "value",
                    "--request-path": "value",
                    "--timeout": "value",
                    "--unhealthy-threshold": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--check-interval": "value",
                    "--description": "value",
                    "--healthy-threshold": "value",
                    "--host": "value",
                    "--port": "value",
                    "--request-path": "value",
                    "--timeout": "value",
                    "--unhealthy-threshold": "value"
                  }
                }
              },
              "flags": {}
            },
            "https-health-checks": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--check-interval": "value",
                    "--description": "value",
                    "--healthy-threshold": "value",
                    "--host": "value",
                    "--port": "value",
                    "--request-path": "value",
                    "--timeout": "value",
                    "--unhealthy-threshold": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--check-interval": "value",
                    "--description": "value",
                    "--healthy-threshold": "value",
                    "--host": "value",
                    "--port": "value",
                    "--request-path": "value",
                    "--timeout": "value",
                    "--unhealthy-threshold": "value"
                  }
                }
              },
              "flags": {}
            },
            "images": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "add-labels": {
                  "commands": {},
                  "flags": {
                    "--labels": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--architecture": [
                      "ARM64",
                      "X86_64"
                    ],
                    "--csek-key-file": "value",
                    "--description": "value",
                    "--family": "value",
                    "--forbidden-database-file": "value",
                    "--force": "bool",
                    "--force-create": "bool",
                    "--guest-os-features": "value",
                    "--key-exchange-key-file": "value",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--licenses": "value",
                    "--platform-key-file": "value",
                    "--require-csek-key-create": "bool",
                    "--rollout-override": "value",
                    "--signature-database-file": "value",
                    "--source-disk": "dynamic",
                    "--source-disk-project": "value",
                    "--source-disk-zone": "dynamic",
                    "--source-image": "value",
                    "--source-image-family": "value",
                    "--source-image-project": "value",
                    "--source-snapshot": "dynamic",
                    "--source-uri": "value",
                    "--storage-location": "value",
                    "--user-licenses": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "deprecate": {
                  "commands": {},
                  "flags": {
                    "--delete-in": "value",
                    "--delete-on": "value",
                    "--deprecate-in": "value",
                    "--deprecate-on": "value",
                    "--obsolete-in": "value",
                    "--obsolete-on": "value",
                    "--replacement": "dynamic",
                    "--state": [
                      "ACTIVE",
                      "DELETED",
                      "DEPRECATED",
                      "OBSOLETE"
                    ]
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "describe-from-family": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cloudbuild-service-account": "value",
                    "--compute-service-account": "value",
                    "--destination-uri": "value",
                    "--export-format": "value",
                    "--image": "value",
                    "--image-family": "value",
                    "--image-project": "value",
                    "--log-location": "value",
                    "--network": "value",
                    "--subnet": "value",
                    "--timeout": "value",
                    "--zone": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--aws-access-key-id": "value",
                    "--aws-ami-export-location": "value",
                    "--aws-ami-id": "value",
                    "--aws-region": "value",
                    "--aws-secret-access-key": "value",
                    "--aws-session-token": "value",
                    "--aws-source-ami-file-path": "value",
                    "--byol": "bool",
                    "--cloudbuild-service-account": "value",
                    "--compute-service-account": "value",
                    "--data-disk": "bool",
                    "--description": "value",
                    "--family": "value",
                    "--guest-environment": "bool",
                    "--guest-os-features": "value",
                    "--log-location": "value",
                    "--network": "value",
                    "--no-address": "bool",
                    "--os": [
                      "centos-7",
                      "centos-stream-8",
                      "centos-stream-9",
                      "debian-10",
                      "debian-11",
                      "debian-8",
                      "debian-9",
                      "opensuse-15",
                      "rhel-6",
                      "rhel-6-byol",
                      "rhel-7",
                      "rhel-7-byol",
                      "rhel-8",
                      "rhel-8-byol",
                      "rhel-9",
                      "rhel-9-byol",
                      "rocky-8",
                      "rocky-9",
                      "sles-12",
                      "sles-12-byol",
                      "sles-15",
                      "sles-15-byol",
                      "sles-sap-12",
                      "sles-sap-12-byol",
                      "sles-sap-15",
                      "sles-sap-15-byol",
                      "ubuntu-1404",
                      "ubuntu-1604",
                      "ubuntu-1804",
                      "ubuntu-2004",
                      "ubuntu-2204",
                      "windows-10-x64-byol",
                      "windows-10-x86-byol",
                      "windows-11-x64-byol",
                      "windows-2008r2",
                      "windows-2008r2-byol",
                      "windows-2012",
                      "windows-2012-byol",
                      "windows-2012r2",
                      "windows-2012r2-byol",
                      "windows-2016",
                      "windows-2016-byol",
                      "windows-2019",
                      "windows-2019-byol",
                      "windows-2022",
                      "windows-2022-byol",
                      "windows-7-x64-byol",
                      "windows-7-x86-byol",
                      "windows-8-x64-byol",
                      "windows-8-x86-byol"
                    ],
                    "--source-file": "value",
                    "--source-image": "dynamic",
                    "--storage-location": "value",
                    "--subnet": "value",
                    "--timeout": "value",
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--image-zone": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--preview-images": "bool",
                    "--regexp": "value",
                    "--show-deprecated": "bool",
                    "--sort-by": "value",
                    "--standard-images": "bool",
                    "--uri": "bool"
                  }
                },
                "packages": {
                  "commands": {
                    "diff": {
                      "commands": {},
                      "flags": {
                        "--base-image": "dynamic",
                        "--base-project": "dynamic",
                        "--diff-image": "dynamic",
                        "--diff-project": "dynamic",
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--show-added-packages": "bool",
                        "--show-removed-packages": "bool",
                        "--show-updated-packages": "bool",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--image": "dynamic",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "remove-labels": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--labels": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--architecture": [
                      "ARM64",
                      "X86_64"
                    ],
                    "--clear-labels": "bool",
                    "--clear-user-licenses": "bool",
                    "--description": "value",
                    "--family": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value",
                    "--update-user-licenses": "value"
                  }
                },
                "vulnerabilities": {
                  "commands": {
                    "describe-note": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--image": "dynamic",
                        "--limit": "value",
                        "--page-size": "value",
                        "--regexp": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "instance-groups": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "get-named-ports": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zones": "value"
                  }
                },
                "list-instances": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                },
                "managed": {
                  "commands": {
                    "abandon-instances": {
                      "commands": {},
                      "flags": {
                        "--instances": "value",
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "all-instances-config": {
                      "commands": {
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--labels": "value",
                            "--metadata": "value",
                            "--region": "dynamic",
                            "--zone": "dynamic"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--labels": "value",
                            "--metadata": "value",
                            "--region": "dynamic",
                            "--zone": "dynamic"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--action-on-vm-failed-health-check": [
                          "default-action",
                          "do-nothing",
                          "repair"
                        ],
                        "--base-instance-name": "value",
                        "--default-action-on-vm-failure": [
                          "do-nothing",
                          "repair"
                        ],
                        "--description": "value",
                        "--force-update-on-repair": "bool",
                        "--health-check": "dynamic",
                        "--http-health-check": "value",
                        "--https-health-check": "value",
                        "--initial-delay": "value",
                        "--instance-redistribution-type": [
                          "none",
                          "proactive"
                        ],
                        "--instance-selection": "value",
                        "--instance-selection-machine-types": "value",
                        "--list-managed-instances-results": [
                          "pageless",
                          "paginated"
                        ],
                        "--region": "dynamic",
                        "--resource-manager-tags": "value",
                        "--size": "value",
                        "--standby-policy-initial-delay": "value",
                        "--standby-policy-mode": [
                          "manual",
                          "scale-out-pool"
                        ],
                        "--stateful-disk": "value",
                        "--stateful-external-ip": "value",
                        "--stateful-internal-ip": "value",
                        "--stopped-size": "value",
                        "--suspended-size": "value",
                        "--target-distribution-shape": [
                          "any",
                          "any-single-zone",
                          "balanced",
                          "even"
                        ],
                        "--target-pool": "value",
                        "--target-size-policy-mode": [
                          "bulk",
                          "individual"
                        ],
                        "--template": "value",
                        "--update-policy-max-surge": "value",
                        "--update-policy-max-unavailable": "value",
                        "--update-policy-min-ready": "value",
                        "--update-policy-minimal-action": [
                          "none",
                          "refresh",
                          "replace",
                          "restart"
                        ],
                        "--update-policy-most-disruptive-action": [
                          "none",
                          "refresh",
                          "replace",
                          "restart"
                        ],
                        "--update-policy-replacement-method": [
                          "recreate",
                          "substitute"
                        ],
                        "--update-policy-type": [
                          "opportunistic",
                          "proactive"
                        ],
                        "--zone": "dynamic",
                        "--zones": "dynamic"
                      }
                    },
                    "create-instance": {
                      "commands": {},
                      "flags": {
                        "--instance": "value",
                        "--region": "dynamic",
                        "--stateful-disk": "value",
                        "--stateful-external-ip": "value",
                        "--stateful-internal-ip": "value",
                        "--stateful-metadata": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "delete-instances": {
                      "commands": {},
                      "flags": {
                        "--instances": "value",
                        "--region": "dynamic",
                        "--skip-instances-on-validation-error": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "describe-instance": {
                      "commands": {},
                      "flags": {
                        "--instance": "value",
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "export-autoscaling": {
                      "commands": {},
                      "flags": {
                        "--autoscaling-file": "value",
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "get-named-ports": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "dynamic",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "instance-configs": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--instance": "value",
                            "--instance-update-minimal-action": [
                              "none",
                              "refresh",
                              "replace",
                              "restart"
                            ],
                            "--region": "dynamic",
                            "--stateful-disk": "value",
                            "--stateful-external-ip": "value",
                            "--stateful-internal-ip": "value",
                            "--stateful-metadata": "value",
                            "--update-instance": "bool",
                            "--zone": "dynamic"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--instance-update-minimal-action": [
                              "none",
                              "refresh",
                              "replace",
                              "restart"
                            ],
                            "--instances": "value",
                            "--region": "dynamic",
                            "--update-instance": "bool",
                            "--zone": "dynamic"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--region": "dynamic",
                            "--sort-by": "value",
                            "--zone": "dynamic"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--instance": "value",
                            "--instance-update-minimal-action": [
                              "none",
                              "refresh",
                              "replace",
                              "restart"
                            ],
                            "--region": "dynamic",
                            "--remove-stateful-disks": "value",
                            "--remove-stateful-external-ips": "value",
                            "--remove-stateful-internal-ips": "value",
                            "--remove-stateful-metadata": "value",
                            "--stateful-disk": "value",
                            "--stateful-external-ip": "value",
                            "--stateful-internal-ip": "value",
                            "--stateful-metadata": "value",
                            "--update-instance": "bool",
                            "--zone": "dynamic"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--regexp": "value",
                        "--regions": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zones": "value"
                      }
                    },
                    "list-errors": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "dynamic",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "list-instances": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "dynamic",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "recreate-instances": {
                      "commands": {},
                      "flags": {
                        "--instances": "value",
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "resize": {
                      "commands": {},
                      "flags": {
                        "--creation-retries": "bool",
                        "--region": "dynamic",
                        "--size": "value",
                        "--stopped-size": "value",
                        "--suspended-size": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "resize-requests": {
                      "commands": {
                        "cancel": {
                          "commands": {},
                          "flags": {
                            "--region": "dynamic",
                            "--resize-request": "value",
                            "--resize-requests": "value",
                            "--zone": "dynamic"
                          }
                        },
                        "create": {
                          "commands": {},
                          "flags": {
                            "--region": "dynamic",
                            "--requested-run-duration": "value",
                            "--resize-by": "value",
                            "--resize-request": "value",
                            "--zone": "dynamic"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--region": "dynamic",
                            "--resize-requests": "value",
                            "--zone": "dynamic"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--region": "dynamic",
                            "--resize-request": "value",
                            "--zone": "dynamic"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--region": "dynamic",
                            "--sort-by": "value",
                            "--uri": "bool",
                            "--zone": "dynamic"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "resume-instances": {
                      "commands": {},
                      "flags": {
                        "--instances": "value",
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "rolling-action": {
                      "commands": {
                        "replace": {
                          "commands": {},
                          "flags": {
                            "--max-surge": "value",
                            "--max-unavailable": "value",
                            "--min-ready": "value",
                            "--region": "dynamic",
                            "--replacement-method": [
                              "recreate",
                              "substitute"
                            ],
                            "--zone": "dynamic"
                          }
                        },
                        "restart": {
                          "commands": {},
                          "flags": {
                            "--max-unavailable": "value",
                            "--min-ready": "value",
                            "--region": "dynamic",
                            "--zone": "dynamic"
                          }
                        },
                        "start-update": {
                          "commands": {},
                          "flags": {
                            "--canary-version": "value",
                            "--force": "bool",
                            "--max-surge": "value",
                            "--max-unavailable": "value",
                            "--min-ready": "value",
                            "--minimal-action": [
                              "refresh",
                              "replace",
                              "restart"
                            ],
                            "--most-disruptive-allowed-action": [
                              "refresh",
                              "replace",
                              "restart"
                            ],
                            "--region": "dynamic",
                            "--replacement-method": [
                              "recreate",
                              "substitute"
                            ],
                            "--type": [
                              "opportunistic",
                              "proactive"
                            ],
                            "--zone": "dynamic"
                          }
                        },
                        "stop-proactive-update": {
                          "commands": {},
                          "flags": {
                            "--region": "dynamic",
                            "--zone": "dynamic"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "set-autohealing": {
                      "commands": {},
                      "flags": {
                        "--health-check": "dynamic",
                        "--http-health-check": "value",
                        "--https-health-check": "value",
                        "--initial-delay": "value",
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "set-autoscaling": {
                      "commands": {},
                      "flags": {
                        "--autoscaling-file": "value",
                        "--cool-down-period": "value",
                        "--cpu-utilization-predictive-method": [
                          "none",
                          "optimize-availability",
                          "standard"
                        ],
                        "--custom-metric-utilization": "value",
                        "--description": "value",
                        "--max-num-replicas": "value",
                        "--min-num-replicas": "value",
                        "--mode": [
                          "off",
                          "on",
                          "only-scale-out",
                          "only-up"
                        ],
                        "--region": "dynamic",
                        "--remove-stackdriver-metric": "value",
                        "--scale-based-on-cpu": "bool",
                        "--scale-based-on-load-balancing": "bool",
                        "--scale-in-control": "value",
                        "--schedule-cron": "value",
                        "--schedule-description": "value",
                        "--schedule-duration-sec": "value",
                        "--schedule-min-required-replicas": "value",
                        "--schedule-time-zone": "value",
                        "--set-schedule": "value",
                        "--stackdriver-metric-filter": "value",
                        "--stackdriver-metric-single-instance-assignment": "value",
                        "--stackdriver-metric-utilization-target": "value",
                        "--stackdriver-metric-utilization-target-type": [
                          "delta-per-minute",
                          "delta-per-second",
                          "gauge"
                        ],
                        "--target-cpu-utilization": "value",
                        "--target-load-balancing-utilization": "value",
                        "--update-stackdriver-metric": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "set-instance-template": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--template": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "set-named-ports": {
                      "commands": {},
                      "flags": {
                        "--named-ports": "value",
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "set-standby-policy": {
                      "commands": {},
                      "flags": {
                        "--initial-delay": "value",
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "set-target-pools": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--target-pools": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "start-instances": {
                      "commands": {},
                      "flags": {
                        "--instances": "value",
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "stop-autoscaling": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "stop-instances": {
                      "commands": {},
                      "flags": {
                        "--force": "bool",
                        "--instances": "value",
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "suspend-instances": {
                      "commands": {},
                      "flags": {
                        "--force": "bool",
                        "--instances": "value",
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--action-on-vm-failed-health-check": [
                          "default-action",
                          "do-nothing",
                          "repair"
                        ],
                        "--clear-autohealing": "bool",
                        "--default-action-on-vm-failure": [
                          "do-nothing",
                          "repair"
                        ],
                        "--description": "value",
                        "--force-update-on-repair": "bool",
                        "--health-check": "dynamic",
                        "--http-health-check": "value",
                        "--https-health-check": "value",
                        "--initial-delay": "value",
                        "--instance-redistribution-type": [
                          "none",
                          "proactive"
                        ],
                        "--instance-selection": "value",
                        "--instance-selection-machine-types": "value",
                        "--list-managed-instances-results": [
                          "pageless",
                          "paginated"
                        ],
                        "--region": "dynamic",
                        "--remove-instance-selections": "value",
                        "--remove-instance-selections-all": "bool",
                        "--remove-stateful-disks": "value",
                        "--remove-stateful-external-ips": "value",
                        "--remove-stateful-internal-ips": "value",
                        "--size": "value",
                        "--standby-policy-initial-delay": "value",
                        "--standby-policy-mode": [
                          "manual",
                          "scale-out-pool"
                        ],
                        "--stateful-disk": "value",
                        "--stateful-external-ip": "value",
                        "--stateful-internal-ip": "value",
                        "--stopped-size": "value",
                        "--suspended-size": "value",
                        "--target-distribution-shape": [
                          "any",
                          "any-single-zone",
                          "balanced",
                          "even"
                        ],
                        "--update-policy-max-surge": "value",
                        "--update-policy-max-unavailable": "value",
                        "--update-policy-min-ready": "value",
                        "--update-policy-minimal-action": [
                          "none",
                          "refresh",
                          "replace",
                          "restart"
                        ],
                        "--update-policy-most-disruptive-action": [
                          "none",
                          "refresh",
                          "replace",
                          "restart"
                        ],
                        "--update-policy-replacement-method": [
                          "recreate",
                          "substitute"
                        ],
                        "--update-policy-type": [
                          "opportunistic",
                          "proactive"
                        ],
                        "--zone": "dynamic"
                      }
                    },
                    "update-autoscaling": {
                      "commands": {},
                      "flags": {
                        "--clear-scale-down-control": "bool",
                        "--clear-scale-in-control": "bool",
                        "--cpu-utilization-predictive-method": [
                          "none",
                          "optimize-availability",
                          "standard"
                        ],
                        "--disable-schedule": "value",
                        "--enable-schedule": "value",
                        "--max-num-replicas": "value",
                        "--min-num-replicas": "value",
                        "--mode": [
                          "off",
                          "on",
                          "only-scale-out",
                          "only-up"
                        ],
                        "--region": "dynamic",
                        "--remove-schedule": "value",
                        "--scale-in-control": "value",
                        "--schedule-cron": "value",
                        "--schedule-description": "value",
                        "--schedule-duration-sec": "value",
                        "--schedule-min-required-replicas": "value",
                        "--schedule-time-zone": "value",
                        "--set-schedule": "value",
                        "--update-schedule": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "update-instances": {
                      "commands": {},
                      "flags": {
                        "--all-instances": "bool",
                        "--instances": "value",
                        "--minimal-action": [
                          "none",
                          "refresh",
                          "replace",
                          "restart"
                        ],
                        "--most-disruptive-allowed-action": [
                          "none",
                          "refresh",
                          "replace",
                          "restart"
                        ],
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "wait-until": {
                      "commands": {},
                      "flags": {
                        "--all-instances-config-effective": "bool",
                        "--region": "dynamic",
                        "--stable": "bool",
                        "--timeout": "value",
                        "--version-target-reached": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "wait-until-stable": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--timeout": "value",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "set-named-ports": {
                  "commands": {},
                  "flags": {
                    "--named-ports": "value",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "unmanaged": {
                  "commands": {
                    "add-instances": {
                      "commands": {},
                      "flags": {
                        "--instances": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--description": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--zone": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--zone": "dynamic"
                      }
                    },
                    "get-named-ports": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "dynamic",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--regexp": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zones": "dynamic"
                      }
                    },
                    "list-instances": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--regexp": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "remove-instances": {
                      "commands": {},
                      "flags": {
                        "--instances": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "set-named-ports": {
                      "commands": {},
                      "flags": {
                        "--named-ports": "value",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "instance-templates": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--address": "value",
                    "--boot-disk-auto-delete": "bool",
                    "--boot-disk-device-name": "value",
                    "--boot-disk-interface": "value",
                    "--boot-disk-kms-key": "dynamic",
                    "--boot-disk-kms-keyring": "dynamic",
                    "--boot-disk-kms-location": "dynamic",
                    "--boot-disk-kms-project": "dynamic",
                    "--boot-disk-provisioned-iops": "value",
                    "--boot-disk-provisioned-throughput": "value",
                    "--boot-disk-size": "value",
                    "--boot-disk-type": "value",
                    "--can-ip-forward": "bool",
                    "--confidential-compute": "bool",
                    "--confidential-compute-type": [
                      "SEV",
                      "SEV_SNP",
                      "TDX"
                    ],
                    "--configure-disk": "value",
                    "--create-disk": "value",
                    "--custom-cpu": "value",
                    "--custom-extensions": "bool",
                    "--custom-memory": "value",
                    "--custom-vm-type": "value",
                    "--description": "value",
                    "--discard-local-ssds-at-termination-timestamp": "value",
                    "--disk": "value",
                    "--enable-nested-virtualization": "bool",
                    "--enable-uefi-networking": "bool",
                    "--enable-watchdog-timer": "bool",
                    "--external-ipv6-address": "value",
                    "--external-ipv6-prefix-length": "value",
                    "--graceful-shutdown": "bool",
                    "--graceful-shutdown-max-duration": "value",
                    "--host-error-timeout-seconds": "value",
                    "--image": "value",
                    "--image-family": "value",
                    "--image-project": "value",
                    "--instance-template-region": "value",
                    "--instance-termination-action": [
                      "DELETE",
                      "STOP"
                    ],
                    "--internal-ipv6-address": "value",
                    "--internal-ipv6-prefix-length": "value",
                    "--ipv6-address": "value",
                    "--ipv6-network-tier": [
                      "PREMIUM"
                    ],
                    "--ipv6-prefix-length": "value",
                    "--key-revocation-action-type": [
                      "none",
                      "stop"
                    ],
                    "--labels": "value",
                    "--local-nvdimm": "value",
                    "--local-ssd": "value",
                    "--local-ssd-recovery-timeout": "value",
                    "--machine-type": "dynamic",
                    "--maintenance-interval": [
                      "PERIODIC"
                    ],
                    "--maintenance-policy": [
                      "MIGRATE",
                      "TERMINATE"
                    ],
                    "--max-run-duration": "value",
                    "--mesh": "value",
                    "--metadata": "value",
                    "--metadata-from-file": "value",
                    "--min-cpu-platform": "value",
                    "--min-node-cpu": "value",
                    "--network": "value",
                    "--network-interface": "value",
                    "--network-performance-configs": "value",
                    "--network-tier": "value",
                    "--no-address": "bool",
                    "--no-scopes": "bool",
                    "--no-service-account": "bool",
                    "--node": "value",
                    "--node-affinity-file": "value",
                    "--node-group": "value",
                    "--numa-node-count": "value",
                    "--on-host-maintenance": [
                      "MIGRATE",
                      "TERMINATE"
                    ],
                    "--partner-metadata": "value",
                    "--partner-metadata-from-file": "value",
                    "--performance-monitoring-unit": [
                      "architectural",
                      "enhanced",
                      "standard"
                    ],
                    "--post-key-revocation-action-type": [
                      "noop",
                      "shutdown"
                    ],
                    "--preemptible": "bool",
                    "--private-ipv6-google-access-type": [
                      "enable-bidirectional-access",
                      "enable-outbound-vm-access",
                      "inherit-subnetwork"
                    ],
                    "--private-network-ip": "value",
                    "--provisioning-model": [
                      "RESERVATION_BOUND",
                      "SPOT",
                      "STANDARD"
                    ],
                    "--region": "dynamic",
                    "--reservation": "value",
                    "--reservation-affinity": [
                      "any",
                      "none",
                      "specific",
                      "specific-then-any-reservation",
                      "specific-then-no-reservation"
                    ],
                    "--resource-manager-tags": "value",
                    "--resource-policies": "value",
                    "--restart-on-failure": "bool",
                    "--scopes": "value",
                    "--service-account": "value",
                    "--service-proxy": "value",
                    "--service-proxy-labels": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-secure-boot": "bool",
                    "--shielded-vtpm": "bool",
                    "--source-instance": "dynamic",
                    "--source-instance-zone": "dynamic",
                    "--stack-type": [
                      "IPV4_IPV6",
                      "IPV4_ONLY",
                      "IPV6_ONLY"
                    ],
                    "--subnet": "value",
                    "--subnet-region": "value",
                    "--tags": "value",
                    "--termination-time": "value",
                    "--threads-per-core": "value",
                    "--turbo-mode": "value",
                    "--visible-core-count": "value"
                  }
                },
                "create-with-container": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--address": "value",
                    "--boot-disk-auto-delete": "bool",
                    "--boot-disk-device-name": "value",
                    "--boot-disk-interface": "value",
                    "--boot-disk-provisioned-iops": "value",
                    "--boot-disk-provisioned-throughput": "value",
                    "--boot-disk-size": "value",
                    "--boot-disk-type": "value",
                    "--can-ip-forward": "bool",
                    "--confidential-compute": "bool",
                    "--container-arg": "value",
                    "--container-command": "value",
                    "--container-env": "value",
                    "--container-env-file": "value",
                    "--container-image": "value",
                    "--container-mount-disk": "value",
                    "--container-mount-host-path": "value",
                    "--container-mount-tmpfs": "value",
                    "--container-privileged": "bool",
                    "--container-restart-policy": [
                      "always",
                      "never",
                      "on-failure"
                    ],
                    "--container-stdin": "bool",
                    "--container-tty": "bool",
                    "--create-disk": "value",
                    "--custom-cpu": "value",
                    "--custom-extensions": "bool",
                    "--custom-memory": "value",
                    "--custom-vm-type": "value",
                    "--description": "value",
                    "--disk": "value",
                    "--external-ipv6-address": "value",
                    "--external-ipv6-prefix-length": "value",
                    "--image": "value",
                    "--image-family": "value",
                    "--image-project": "value",
                    "--internal-ipv6-address": "value",
                    "--internal-ipv6-prefix-length": "value",
                    "--ipv6-address": "value",
                    "--ipv6-network-tier": [
                      "PREMIUM"
                    ],
                    "--ipv6-prefix-length": "value",
                    "--labels": "value",
                    "--local-nvdimm": "value",
                    "--local-ssd": "value",
                    "--machine-type": "dynamic",
                    "--maintenance-policy": [
                      "MIGRATE",
                      "TERMINATE"
                    ],
                    "--metadata": "value",
                    "--metadata-from-file": "value",
                    "--min-cpu-platform": "value",
                    "--network": "value",
                    "--network-interface": "value",
                    "--network-tier": "value",
                    "--no-address": "bool",
                    "--no-scopes": "bool",
                    "--no-service-account": "bool",
                    "--on-host-maintenance": [
                      "MIGRATE",
                      "TERMINATE"
                    ],
                    "--preemptible": "bool",
                    "--private-ipv6-google-access-type": [
                      "enable-bidirectional-access",
                      "enable-outbound-vm-access",
                      "inherit-subnetwork"
                    ],
                    "--private-network-ip": "value",
                    "--region": "dynamic",
                    "--reservation": "value",
                    "--reservation-affinity": [
                      "any",
                      "none",
                      "specific",
                      "specific-then-any-reservation",
                      "specific-then-no-reservation"
                    ],
                    "--resource-policies": "value",
                    "--restart-on-failure": "bool",
                    "--scopes": "value",
                    "--service-account": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-secure-boot": "bool",
                    "--shielded-vtpm": "bool",
                    "--stack-type": [
                      "IPV4_IPV6",
                      "IPV4_ONLY",
                      "IPV6_ONLY"
                    ],
                    "--subnet": "value",
                    "--subnet-region": "value",
                    "--tags": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--view": [
                      "BASIC",
                      "FULL"
                    ]
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--view": [
                      "BASIC",
                      "FULL"
                    ]
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "instances": {
              "commands": {
                "add-access-config": {
                  "commands": {},
                  "flags": {
                    "--access-config-name": "value",
                    "--address": "value",
                    "--network-interface": "value",
                    "--network-tier": "value",
                    "--no-public-dns": "bool",
                    "--no-public-ptr": "bool",
                    "--no-public-ptr-domain": "bool",
                    "--public-dns": "bool",
                    "--public-ptr": "bool",
                    "--public-ptr-domain": "value",
                    "--zone": "dynamic"
                  }
                },
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic",
                    "--zone": "value"
                  }
                },
                "add-labels": {
                  "commands": {},
                  "flags": {
                    "--labels": "value",
                    "--zone": "dynamic"
                  }
                },
                "add-metadata": {
                  "commands": {},
                  "flags": {
                    "--metadata": "value",
                    "--metadata-from-file": "value",
                    "--zone": "dynamic"
                  }
                },
                "add-partner-metadata": {
                  "commands": {},
                  "flags": {
                    "--partner-metadata": "value",
                    "--partner-metadata-from-file": "value",
                    "--zone": "dynamic"
                  }
                },
                "add-resource-policies": {
                  "commands": {},
                  "flags": {
                    "--resource-policies": "value",
                    "--zone": "dynamic"
                  }
                },
                "add-tags": {
                  "commands": {},
                  "flags": {
                    "--tags": "value",
                    "--zone": "dynamic"
                  }
                },
                "attach-disk": {
                  "commands": {},
                  "flags": {
                    "--boot": "bool",
                    "--csek-key-file": "value",
                    "--device-name": "value",
                    "--disk": "value",
                    "--disk-scope": [
                      "regional",
                      "zonal"
                    ],
                    "--force-attach": "bool",
                    "--interface": [
                      "NVME",
                      "SCSI"
                    ],
                    "--mode": [
                      "ro",
                      "rw"
                    ],
                    "--zone": "dynamic"
                  }
                },
                "bulk": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--accelerator": "value",
                        "--async": "bool",
                        "--boot-disk-auto-delete": "bool",
                        "--boot-disk-device-name": "value",
                        "--boot-disk-interface": "value",
                        "--boot-disk-kms-key": "dynamic",
                        "--boot-disk-kms-keyring": "dynamic",
                        "--boot-disk-kms-location": "dynamic",
                        "--boot-disk-kms-project": "dynamic",
                        "--boot-disk-provisioned-iops": "value",
                        "--boot-disk-provisioned-throughput": "value",
                        "--boot-disk-size": "value",
                        "--boot-disk-type": "value",
                        "--can-ip-forward": "bool",
                        "--confidential-compute": "bool",
                        "--confidential-compute-type": [
                          "SEV",
                          "SEV_SNP",
                          "TDX"
                        ],
                        "--count": "value",
                        "--create-disk": "value",
                        "--custom-cpu": "value",
                        "--custom-extensions": "bool",
                        "--custom-memory": "value",
                        "--custom-vm-type": "value",
                        "--description": "value",
                        "--discard-local-ssds-at-termination-timestamp": "value",
                        "--disk": "value",
                        "--enable-display-device": "bool",
                        "--enable-nested-virtualization": "bool",
                        "--enable-uefi-networking": "bool",
                        "--enable-watchdog-timer": "bool",
                        "--erase-windows-vss-signature": "bool",
                        "--graceful-shutdown": "bool",
                        "--graceful-shutdown-max-duration": "value",
                        "--host-error-timeout-seconds": "value",
                        "--image": "value",
                        "--image-family": "value",
                        "--image-project": "value",
                        "--instance-termination-action": [
                          "DELETE",
                          "STOP"
                        ],
                        "--labels": "value",
                        "--local-ssd": "value",
                        "--local-ssd-recovery-timeout": "value",
                        "--location-policy": "value",
                        "--machine-type": "dynamic",
                        "--maintenance-interval": [
                          "PERIODIC",
                          "RECURRENT"
                        ],
                        "--maintenance-policy": [
                          "MIGRATE",
                          "TERMINATE"
                        ],
                        "--max-count-per-zone": "value",
                        "--max-run-duration": "value",
                        "--metadata": "value",
                        "--metadata-from-file": "value",
                        "--min-count": "value",
                        "--min-cpu-platform": "value",
                        "--min-node-cpu": "value",
                        "--name-pattern": "value",
                        "--network": "value",
                        "--network-interface": "value",
                        "--network-performance-configs": "value",
                        "--network-tier": "value",
                        "--no-address": "bool",
                        "--no-public-dns": "bool",
                        "--no-scopes": "bool",
                        "--no-service-account": "bool",
                        "--numa-node-count": "value",
                        "--on-host-maintenance": [
                          "MIGRATE",
                          "TERMINATE"
                        ],
                        "--per-instance-hostnames": "value",
                        "--performance-monitoring-unit": [
                          "architectural",
                          "enhanced",
                          "standard"
                        ],
                        "--post-key-revocation-action-type": [
                          "noop",
                          "shutdown"
                        ],
                        "--predefined-names": "value",
                        "--preemptible": "bool",
                        "--provisioning-model": [
                          "RESERVATION_BOUND",
                          "SPOT",
                          "STANDARD"
                        ],
                        "--public-dns": "bool",
                        "--region": "value",
                        "--reservation": "value",
                        "--reservation-affinity": [
                          "any",
                          "none",
                          "specific",
                          "specific-then-any-reservation",
                          "specific-then-no-reservation"
                        ],
                        "--resource-manager-tags": "value",
                        "--resource-policies": "value",
                        "--restart-on-failure": "bool",
                        "--scopes": "value",
                        "--secure-tags": "value",
                        "--service-account": "value",
                        "--shielded-integrity-monitoring": "bool",
                        "--shielded-secure-boot": "bool",
                        "--shielded-vtpm": "bool",
                        "--source-instance-template": "dynamic",
                        "--source-snapshot": "value",
                        "--stack-type": [
                          "IPV4_IPV6",
                          "IPV4_ONLY",
                          "IPV6_ONLY"
                        ],
                        "--subnet": "value",
                        "--tags": "value",
                        "--target-distribution-shape": [
                          "ANY",
                          "ANY_SINGLE_ZONE",
                          "BALANCED"
                        ],
                        "--termination-time": "value",
                        "--threads-per-core": "value",
                        "--turbo-mode": "value",
                        "--visible-core-count": "value",
                        "--zone": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ],
                        "--zone": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--address": "value",
                    "--async": "bool",
                    "--availability-domain": "value",
                    "--boot-disk-auto-delete": "bool",
                    "--boot-disk-device-name": "value",
                    "--boot-disk-interface": "value",
                    "--boot-disk-kms-key": "dynamic",
                    "--boot-disk-kms-keyring": "dynamic",
                    "--boot-disk-kms-location": "dynamic",
                    "--boot-disk-kms-project": "dynamic",
                    "--boot-disk-provisioned-iops": "value",
                    "--boot-disk-provisioned-throughput": "value",
                    "--boot-disk-size": "value",
                    "--boot-disk-type": "value",
                    "--can-ip-forward": "bool",
                    "--confidential-compute": "bool",
                    "--confidential-compute-type": [
                      "SEV",
                      "SEV_SNP",
                      "TDX"
                    ],
                    "--create-disk": "value",
                    "--csek-key-file": "value",
                    "--custom-cpu": "value",
                    "--custom-extensions": "bool",
                    "--custom-memory": "value",
                    "--custom-vm-type": "value",
                    "--deletion-protection": "bool",
                    "--description": "value",
                    "--discard-local-ssds-at-termination-timestamp": "value",
                    "--disk": "value",
                    "--enable-display-device": "bool",
                    "--enable-nested-virtualization": "bool",
                    "--enable-uefi-networking": "bool",
                    "--enable-watchdog-timer": "bool",
                    "--erase-windows-vss-signature": "bool",
                    "--external-ipv6-address": "value",
                    "--external-ipv6-prefix-length": "value",
                    "--graceful-shutdown": "bool",
                    "--graceful-shutdown-max-duration": "value",
                    "--host-error-timeout-seconds": "value",
                    "--hostname": "value",
                    "--image": "value",
                    "--image-family": "value",
                    "--image-family-scope": [
                      "global",
                      "zonal"
                    ],
                    "--image-project": "value",
                    "--instance-kms-key": "dynamic",
                    "--instance-kms-keyring": "dynamic",
                    "--instance-kms-location": "dynamic",
                    "--instance-kms-project": "dynamic",
                    "--instance-termination-action": [
                      "DELETE",
                      "STOP"
                    ],
                    "--internal-ipv6-address": "value",
                    "--internal-ipv6-prefix-length": "value",
                    "--ipv6-address": "value",
                    "--ipv6-network-tier": [
                      "PREMIUM"
                    ],
                    "--ipv6-prefix-length": "value",
                    "--ipv6-public-ptr-domain": "value",
                    "--key-revocation-action-type": [
                      "none",
                      "stop"
                    ],
                    "--labels": "value",
                    "--local-nvdimm": "value",
                    "--local-ssd": "value",
                    "--local-ssd-recovery-timeout": "value",
                    "--machine-type": "dynamic",
                    "--maintenance-freeze-duration": "value",
                    "--maintenance-interval": [
                      "PERIODIC",
                      "RECURRENT"
                    ],
                    "--maintenance-policy": [
                      "MIGRATE",
                      "TERMINATE"
                    ],
                    "--max-run-duration": "value",
                    "--metadata": "value",
                    "--metadata-from-file": "value",
                    "--min-cpu-platform": "value",
                    "--min-node-cpu": "value",
                    "--network": "value",
                    "--network-interface": "value",
                    "--network-interface-from-file": "value",
                    "--network-interface-from-json-string": "value",
                    "--network-performance-configs": "value",
                    "--network-tier": "value",
                    "--no-address": "bool",
                    "--no-public-dns": "bool",
                    "--no-public-ptr": "bool",
                    "--no-public-ptr-domain": "bool",
                    "--no-scopes": "bool",
                    "--no-service-account": "bool",
                    "--node": "value",
                    "--node-affinity-file": "value",
                    "--node-group": "value",
                    "--node-project": "value",
                    "--numa-node-count": "value",
                    "--on-host-maintenance": [
                      "MIGRATE",
                      "TERMINATE"
                    ],
                    "--partner-metadata": "value",
                    "--partner-metadata-from-file": "value",
                    "--performance-monitoring-unit": [
                      "architectural",
                      "enhanced",
                      "standard"
                    ],
                    "--post-key-revocation-action-type": [
                      "noop",
                      "shutdown"
                    ],
                    "--preemptible": "bool",
                    "--private-ipv6-google-access-type": [
                      "enable-bidirectional-access",
                      "enable-outbound-vm-access",
                      "inherit-subnetwork"
                    ],
                    "--private-network-ip": "value",
                    "--provisioning-model": [
                      "RESERVATION_BOUND",
                      "SPOT",
                      "STANDARD"
                    ],
                    "--public-dns": "bool",
                    "--public-ptr": "bool",
                    "--public-ptr-domain": "value",
                    "--require-csek-key-create": "bool",
                    "--reservation": "value",
                    "--reservation-affinity": [
                      "any",
                      "none",
                      "specific",
                      "specific-then-any-reservation",
                      "specific-then-no-reservation"
                    ],
                    "--resource-manager-tags": "value",
                    "--resource-policies": "value",
                    "--restart-on-failure": "bool",
                    "--scopes": "value",
                    "--secure-tags": "value",
                    "--service-account": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-secure-boot": "bool",
                    "--shielded-vtpm": "bool",
                    "--source-instance-template": "dynamic",
                    "--source-instant-snapshot": "value",
                    "--source-machine-image": "dynamic",
                    "--source-machine-image-csek-key-file": "value",
                    "--source-snapshot": "value",
                    "--stack-type": [
                      "IPV4_IPV6",
                      "IPV4_ONLY",
                      "IPV6_ONLY"
                    ],
                    "--subnet": "value",
                    "--tags": "value",
                    "--termination-time": "value",
                    "--threads-per-core": "value",
                    "--turbo-mode": "value",
                    "--visible-core-count": "value",
                    "--zone": "dynamic"
                  }
                },
                "create-with-container": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--address": "value",
                    "--boot-disk-auto-delete": "bool",
                    "--boot-disk-device-name": "value",
                    "--boot-disk-interface": "value",
                    "--boot-disk-provisioned-iops": "value",
                    "--boot-disk-provisioned-throughput": "value",
                    "--boot-disk-size": "value",
                    "--boot-disk-type": "value",
                    "--can-ip-forward": "bool",
                    "--confidential-compute": "bool",
                    "--confidential-compute-type": [
                      "SEV",
                      "SEV_SNP",
                      "TDX"
                    ],
                    "--container-arg": "value",
                    "--container-command": "value",
                    "--container-env": "value",
                    "--container-env-file": "value",
                    "--container-image": "value",
                    "--container-mount-disk": "value",
                    "--container-mount-host-path": "value",
                    "--container-mount-tmpfs": "value",
                    "--container-privileged": "bool",
                    "--container-restart-policy": [
                      "always",
                      "never",
                      "on-failure"
                    ],
                    "--container-stdin": "bool",
                    "--container-tty": "bool",
                    "--create-disk": "value",
                    "--custom-cpu": "value",
                    "--custom-extensions": "bool",
                    "--custom-memory": "value",
                    "--custom-vm-type": "value",
                    "--description": "value",
                    "--discard-local-ssds-at-termination-timestamp": "value",
                    "--disk": "value",
                    "--enable-nested-virtualization": "bool",
                    "--external-ipv6-address": "value",
                    "--external-ipv6-prefix-length": "value",
                    "--graceful-shutdown": "bool",
                    "--graceful-shutdown-max-duration": "value",
                    "--host-error-timeout-seconds": "value",
                    "--image": "value",
                    "--image-family": "value",
                    "--image-project": "value",
                    "--instance-termination-action": [
                      "DELETE",
                      "STOP"
                    ],
                    "--internal-ipv6-address": "value",
                    "--internal-ipv6-prefix-length": "value",
                    "--ipv6-address": "value",
                    "--ipv6-network-tier": [
                      "PREMIUM"
                    ],
                    "--ipv6-prefix-length": "value",
                    "--labels": "value",
                    "--local-nvdimm": "value",
                    "--local-ssd": "value",
                    "--local-ssd-recovery-timeout": "value",
                    "--machine-type": "dynamic",
                    "--maintenance-policy": [
                      "MIGRATE",
                      "TERMINATE"
                    ],
                    "--max-run-duration": "value",
                    "--metadata": "value",
                    "--metadata-from-file": "value",
                    "--min-cpu-platform": "value",
                    "--network": "value",
                    "--network-interface": "value",
                    "--network-performance-configs": "value",
                    "--network-tier": "value",
                    "--no-address": "bool",
                    "--no-public-dns": "bool",
                    "--no-public-ptr": "bool",
                    "--no-public-ptr-domain": "bool",
                    "--no-scopes": "bool",
                    "--no-service-account": "bool",
                    "--numa-node-count": "value",
                    "--on-host-maintenance": [
                      "MIGRATE",
                      "TERMINATE"
                    ],
                    "--preemptible": "bool",
                    "--private-ipv6-google-access-type": [
                      "enable-bidirectional-access",
                      "enable-outbound-vm-access",
                      "inherit-subnetwork"
                    ],
                    "--private-network-ip": "value",
                    "--provisioning-model": [
                      "RESERVATION_BOUND",
                      "SPOT",
                      "STANDARD"
                    ],
                    "--public-dns": "bool",
                    "--public-ptr": "bool",
                    "--public-ptr-domain": "value",
                    "--reservation": "value",
                    "--reservation-affinity": [
                      "any",
                      "none",
                      "specific",
                      "specific-then-any-reservation",
                      "specific-then-no-reservation"
                    ],
                    "--resource-policies": "value",
                    "--restart-on-failure": "bool",
                    "--scopes": "value",
                    "--service-account": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-secure-boot": "bool",
                    "--shielded-vtpm": "bool",
                    "--source-instance-template": "dynamic",
                    "--stack-type": [
                      "IPV4_IPV6",
                      "IPV4_ONLY",
                      "IPV6_ONLY"
                    ],
                    "--subnet": "value",
                    "--tags": "value",
                    "--termination-time": "value",
                    "--threads-per-core": "value",
                    "--visible-core-count": "value",
                    "--zone": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--delete-disks": [
                      "all",
                      "boot",
                      "data"
                    ],
                    "--keep-disks": [
                      "all",
                      "boot",
                      "data"
                    ],
                    "--no-graceful-shutdown": "bool",
                    "--zone": "dynamic"
                  }
                },
                "delete-access-config": {
                  "commands": {},
                  "flags": {
                    "--access-config-name": "value",
                    "--network-interface": "value",
                    "--zone": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--guest-attributes": "value",
                    "--view": [
                      "BASIC",
                      "FULL"
                    ],
                    "--zone": "dynamic"
                  }
                },
                "detach-disk": {
                  "commands": {},
                  "flags": {
                    "--device-name": "value",
                    "--disk": "value",
                    "--disk-scope": [
                      "regional",
                      "zonal"
                    ],
                    "--zone": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--zone": "value"
                  }
                },
                "get-guest-attributes": {
                  "commands": {},
                  "flags": {
                    "--query-path": "value",
                    "--zone": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--zone": "value"
                  }
                },
                "get-serial-port-output": {
                  "commands": {},
                  "flags": {
                    "--port": "value",
                    "--start": "value",
                    "--zone": "dynamic"
                  }
                },
                "get-shielded-identity": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--byol": "bool",
                    "--can-ip-forward": "bool",
                    "--cloudbuild-service-account": "value",
                    "--compute-service-account": "value",
                    "--custom-cpu": "value",
                    "--custom-extensions": "bool",
                    "--custom-memory": "value",
                    "--custom-vm-type": "value",
                    "--deletion-protection": "bool",
                    "--description": "value",
                    "--guest-environment": "bool",
                    "--guest-os-features": "value",
                    "--hostname": "value",
                    "--labels": "value",
                    "--log-location": "value",
                    "--machine-type": "dynamic",
                    "--network": "value",
                    "--network-tier": "value",
                    "--no-address": "bool",
                    "--no-scopes": "bool",
                    "--no-service-account": "bool",
                    "--node": "value",
                    "--node-affinity-file": "value",
                    "--node-group": "value",
                    "--os": [
                      "centos-7",
                      "centos-stream-8",
                      "centos-stream-9",
                      "debian-10",
                      "debian-11",
                      "debian-8",
                      "debian-9",
                      "opensuse-15",
                      "rhel-6",
                      "rhel-6-byol",
                      "rhel-7",
                      "rhel-7-byol",
                      "rhel-8",
                      "rhel-8-byol",
                      "rhel-9",
                      "rhel-9-byol",
                      "rocky-8",
                      "rocky-9",
                      "sles-12",
                      "sles-12-byol",
                      "sles-15",
                      "sles-15-byol",
                      "sles-sap-12",
                      "sles-sap-12-byol",
                      "sles-sap-15",
                      "sles-sap-15-byol",
                      "ubuntu-1404",
                      "ubuntu-1604",
                      "ubuntu-1804",
                      "ubuntu-2004",
                      "ubuntu-2204",
                      "windows-10-x64-byol",
                      "windows-10-x86-byol",
                      "windows-11-x64-byol",
                      "windows-2008r2",
                      "windows-2008r2-byol",
                      "windows-2012",
                      "windows-2012-byol",
                      "windows-2012r2",
                      "windows-2012r2-byol",
                      "windows-2016",
                      "windows-2016-byol",
                      "windows-2019",
                      "windows-2019-byol",
                      "windows-2022",
                      "windows-2022-byol",
                      "windows-7-x64-byol",
                      "windows-7-x86-byol",
                      "windows-8-x64-byol",
                      "windows-8-x86-byol"
                    ],
                    "--private-network-ip": "value",
                    "--restart-on-failure": "bool",
                    "--scopes": "value",
                    "--service-account": "value",
                    "--source-uri": "value",
                    "--subnet": "value",
                    "--tags": "value",
                    "--timeout": "value",
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--view": [
                      "BASIC",
                      "FULL"
                    ],
                    "--zones": "dynamic"
                  }
                },
                "move": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--destination-zone": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "network-interfaces": {
                  "commands": {
                    "add": {
                      "commands": {},
                      "flags": {
                        "--address": "value",
                        "--aliases": "value",
                        "--external-ipv6-address": "value",
                        "--external-ipv6-prefix-length": "value",
                        "--igmp-query": [
                          "IGMP_QUERY_DISABLED",
                          "IGMP_QUERY_V2"
                        ],
                        "--internal-ipv6-address": "value",
                        "--internal-ipv6-prefix-length": "value",
                        "--ipv6-address": "value",
                        "--ipv6-network-tier": [
                          "PREMIUM"
                        ],
                        "--ipv6-prefix-length": "value",
                        "--network": "value",
                        "--network-attachment": "value",
                        "--network-tier": [
                          "FIXED_STANDARD",
                          "PREMIUM",
                          "STANDARD"
                        ],
                        "--no-address": "bool",
                        "--parent-nic-name": "value",
                        "--private-network-ip": "value",
                        "--stack-type": [
                          "IPV4_IPV6",
                          "IPV4_ONLY"
                        ],
                        "--subnetwork": "value",
                        "--vlan": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--network-interface": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "get-effective-firewalls": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--network-interface": "value",
                        "--page-size": "value",
                        "--regexp": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--aliases": "value",
                        "--external-ipv6-address": "value",
                        "--external-ipv6-prefix-length": "value",
                        "--igmp-query": [
                          "IGMP_QUERY_DISABLED",
                          "IGMP_QUERY_V2"
                        ],
                        "--internal-ipv6-address": "value",
                        "--internal-ipv6-prefix-length": "value",
                        "--ipv6-address": "value",
                        "--ipv6-network-tier": [
                          "PREMIUM"
                        ],
                        "--ipv6-prefix-length": "value",
                        "--network": "value",
                        "--network-interface": "value",
                        "--private-network-ip": "value",
                        "--security-policy": "dynamic",
                        "--security-policy-region": "dynamic",
                        "--stack-type": [
                          "IPV4_IPV6",
                          "IPV4_ONLY"
                        ],
                        "--subnetwork": "value",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "ops-agents": {
                  "commands": {
                    "policies": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--agent-rules": "value",
                            "--description": "value",
                            "--group-labels": "value",
                            "--instances": "value",
                            "--os-types": "value",
                            "--zones": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {}
                        },
                        "describe": {
                          "commands": {},
                          "flags": {}
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--agent-rules": "value",
                            "--clear-group-labels": "bool",
                            "--clear-instances": "bool",
                            "--clear-zones": "bool",
                            "--description": "value",
                            "--etag": "value",
                            "--group-labels": "value",
                            "--instances": "value",
                            "--os-types": "value",
                            "--zones": "value"
                          }
                        }
                      },
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "os-inventory": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--zone": "dynamic"
                      }
                    },
                    "list-instances": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--inventory-filter": "value",
                        "--kernel-version": "value",
                        "--limit": "value",
                        "--os-shortname": "value",
                        "--os-version": "value",
                        "--package-name": "value",
                        "--package-version": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "patch-partner-metadata": {
                  "commands": {},
                  "flags": {
                    "--partner-metadata": "value",
                    "--partner-metadata-from-file": "value",
                    "--zone": "dynamic"
                  }
                },
                "perform-maintenance": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic",
                    "--zone": "value"
                  }
                },
                "remove-labels": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--labels": "value",
                    "--zone": "dynamic"
                  }
                },
                "remove-metadata": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--keys": "value",
                    "--zone": "dynamic"
                  }
                },
                "remove-partner-metadata": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--keys": "value",
                    "--zone": "dynamic"
                  }
                },
                "remove-resource-policies": {
                  "commands": {},
                  "flags": {
                    "--resource-policies": "value",
                    "--zone": "dynamic"
                  }
                },
                "remove-tags": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--tags": "value",
                    "--zone": "dynamic"
                  }
                },
                "reset": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "resume": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--zone": "dynamic"
                  }
                },
                "send-diagnostic-interrupt": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "set-disk-auto-delete": {
                  "commands": {},
                  "flags": {
                    "--auto-delete": "bool",
                    "--device-name": "value",
                    "--disk": "value",
                    "--zone": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "set-machine-type": {
                  "commands": {},
                  "flags": {
                    "--custom-cpu": "value",
                    "--custom-extensions": "bool",
                    "--custom-memory": "value",
                    "--custom-vm-type": "value",
                    "--machine-type": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "set-min-cpu-platform": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--min-cpu-platform": "value",
                    "--zone": "dynamic"
                  }
                },
                "set-name": {
                  "commands": {},
                  "flags": {
                    "--new-name": "value",
                    "--zone": "dynamic"
                  }
                },
                "set-scheduling": {
                  "commands": {},
                  "flags": {
                    "--clear-discard-local-ssds-at-termination-timestamp": "bool",
                    "--clear-instance-termination-action": "bool",
                    "--clear-max-run-duration": "bool",
                    "--clear-min-node-cpu": "bool",
                    "--clear-node-affinities": "bool",
                    "--clear-termination-time": "bool",
                    "--discard-local-ssds-at-termination-timestamp": "value",
                    "--graceful-shutdown": "bool",
                    "--graceful-shutdown-max-duration": "value",
                    "--host-error-timeout-seconds": "value",
                    "--instance-termination-action": [
                      "DELETE",
                      "STOP"
                    ],
                    "--local-ssd-recovery-timeout": "value",
                    "--maintenance-policy": [
                      "MIGRATE",
                      "TERMINATE"
                    ],
                    "--max-run-duration": "value",
                    "--min-node-cpu": "value",
                    "--node": "value",
                    "--node-affinity-file": "value",
                    "--node-group": "value",
                    "--on-host-maintenance": [
                      "MIGRATE",
                      "TERMINATE"
                    ],
                    "--preemptible": "bool",
                    "--provisioning-model": [
                      "RESERVATION_BOUND",
                      "SPOT",
                      "STANDARD"
                    ],
                    "--restart-on-failure": "bool",
                    "--termination-time": "value",
                    "--zone": "dynamic"
                  }
                },
                "set-scopes": {
                  "commands": {},
                  "flags": {
                    "--no-scopes": "bool",
                    "--no-service-account": "bool",
                    "--scopes": "value",
                    "--service-account": "value",
                    "--zone": "dynamic"
                  }
                },
                "simulate-maintenance-event": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--with-extended-notifications": "value",
                    "--zone": "dynamic"
                  }
                },
                "start": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--csek-key-file": "value",
                    "--zone": "dynamic"
                  }
                },
                "stop": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--discard-local-ssd": "value",
                    "--no-graceful-shutdown": "bool",
                    "--zone": "dynamic"
                  }
                },
                "suspend": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--discard-local-ssd": "value",
                    "--zone": "dynamic"
                  }
                },
                "tail-serial-port-output": {
                  "commands": {},
                  "flags": {
                    "--port": "value",
                    "--zone": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--clear-node-affinities": "bool",
                    "--deletion-protection": "bool",
                    "--enable-display-device": "bool",
                    "--graceful-shutdown": "bool",
                    "--graceful-shutdown-max-duration": "value",
                    "--min-cpu-platform": "value",
                    "--node": "value",
                    "--node-affinity-file": "value",
                    "--node-group": "value",
                    "--partner-metadata": "value",
                    "--partner-metadata-from-file": "value",
                    "--remove-labels": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-learn-integrity-policy": "bool",
                    "--shielded-secure-boot": "bool",
                    "--shielded-vtpm": "bool",
                    "--update-labels": "value",
                    "--zone": "dynamic"
                  }
                },
                "update-access-config": {
                  "commands": {},
                  "flags": {
                    "--ipv6-public-ptr-domain": "value",
                    "--network-interface": "value",
                    "--network-tier": "value",
                    "--no-ipv6-public-ptr": "bool",
                    "--no-public-dns": "bool",
                    "--no-public-ptr": "bool",
                    "--no-public-ptr-domain": "bool",
                    "--public-dns": "bool",
                    "--public-ptr": "bool",
                    "--public-ptr-domain": "value",
                    "--zone": "dynamic"
                  }
                },
                "update-container": {
                  "commands": {},
                  "flags": {
                    "--clear-container-args": "bool",
                    "--clear-container-command": "bool",
                    "--container-arg": "value",
                    "--container-command": "value",
                    "--container-env": "value",
                    "--container-env-file": "value",
                    "--container-image": "value",
                    "--container-mount-disk": "value",
                    "--container-mount-host-path": "value",
                    "--container-mount-tmpfs": "value",
                    "--container-privileged": "bool",
                    "--container-restart-policy": [
                      "always",
                      "never",
                      "on-failure"
                    ],
                    "--container-stdin": "bool",
                    "--container-tty": "bool",
                    "--remove-container-env": "value",
                    "--remove-container-mounts": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-learn-integrity-policy": "bool",
                    "--shielded-secure-boot": "bool",
                    "--shielded-vtpm": "bool",
                    "--zone": "dynamic"
                  }
                },
                "update-from-file": {
                  "commands": {},
                  "flags": {
                    "--clear-secure-tag": "bool",
                    "--minimal-action": "value",
                    "--most-disruptive-allowed-action": "value",
                    "--source": "value",
                    "--zone": "dynamic"
                  }
                },
                "vulnerabilities": {
                  "commands": {
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--instance": "dynamic",
                        "--instance-zone": "dynamic",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "instant-snapshots": {
              "commands": {
                "add-labels": {
                  "commands": {},
                  "flags": {
                    "--labels": "value",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--labels": "value",
                    "--region": "dynamic",
                    "--source-disk": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zones": "value"
                  }
                }
              },
              "flags": {}
            },
            "interconnects": {
              "commands": {
                "attachments": {
                  "commands": {
                    "dedicated": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--bandwidth": [
                              "100g",
                              "100m",
                              "10g",
                              "1g",
                              "200m",
                              "20g",
                              "2g",
                              "300m",
                              "400m",
                              "500m",
                              "50g",
                              "50m",
                              "5g"
                            ],
                            "--candidate-ipv6-subnets": "value",
                            "--candidate-subnets": "value",
                            "--cloud-router-ipv6-interface-id": "value",
                            "--customer-router-ipv6-interface-id": "value",
                            "--description": "value",
                            "--dry-run": "bool",
                            "--enable-admin": "bool",
                            "--enable-multicast": "bool",
                            "--encryption": [
                              "IPSEC",
                              "NONE"
                            ],
                            "--interconnect": "dynamic",
                            "--ipsec-internal-addresses": "value",
                            "--mtu": "value",
                            "--region": "dynamic",
                            "--router": "dynamic",
                            "--stack-type": [
                              "IPV4_IPV6",
                              "IPV4_ONLY"
                            ],
                            "--subnet-length": [
                              29,
                              30
                            ],
                            "--vlan": "value"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--bandwidth": [
                              "100g",
                              "100m",
                              "10g",
                              "1g",
                              "200m",
                              "20g",
                              "2g",
                              "300m",
                              "400m",
                              "500m",
                              "50g",
                              "50m",
                              "5g"
                            ],
                            "--candidate-ipv6-subnets": "value",
                            "--clear-labels": "bool",
                            "--cloud-router-ipv6-interface-id": "value",
                            "--customer-router-ipv6-interface-id": "value",
                            "--description": "value",
                            "--enable-admin": "bool",
                            "--enable-multicast": "bool",
                            "--mtu": "value",
                            "--region": "dynamic",
                            "--remove-labels": "value",
                            "--stack-type": [
                              "IPV4_IPV6",
                              "IPV4_ONLY"
                            ],
                            "--update-labels": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic"
                      }
                    },
                    "groups": {
                      "commands": {
                        "add-members": {
                          "commands": {},
                          "flags": {
                            "--attachments": "value"
                          }
                        },
                        "create": {
                          "commands": {},
                          "flags": {
                            "--attachments": "value",
                            "--description": "value",
                            "--intended-availability-sla": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {}
                        },
                        "describe": {
                          "commands": {},
                          "flags": {}
                        },
                        "get-operational-status": {
                          "commands": {},
                          "flags": {}
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        },
                        "remove-members": {
                          "commands": {},
                          "flags": {
                            "--attachments": "value"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--attachments": "value",
                            "--description": "value",
                            "--intended-availability-sla": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "partner": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--description": "value",
                            "--dry-run": "bool",
                            "--edge-availability-domain": [
                              "any",
                              "availability-domain-1",
                              "availability-domain-2"
                            ],
                            "--enable-admin": "bool",
                            "--encryption": [
                              "IPSEC",
                              "NONE"
                            ],
                            "--ipsec-internal-addresses": "value",
                            "--mtu": "value",
                            "--region": "dynamic",
                            "--router": "dynamic",
                            "--stack-type": [
                              "IPV4_IPV6",
                              "IPV4_ONLY"
                            ]
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--clear-labels": "bool",
                            "--description": "value",
                            "--enable-admin": "bool",
                            "--mtu": "value",
                            "--region": "dynamic",
                            "--remove-labels": "value",
                            "--stack-type": [
                              "IPV4_IPV6",
                              "IPV4_ONLY"
                            ],
                            "--update-labels": "value"
                          }
                        }
                      },
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--admin-enabled": "bool",
                    "--customer-name": "value",
                    "--description": "value",
                    "--interconnect-type": [
                      "DEDICATED",
                      "IT_PRIVATE",
                      "PARTNER"
                    ],
                    "--link-type": [
                      "LINK_TYPE_ETHERNET_100G_LR",
                      "LINK_TYPE_ETHERNET_10G_LR"
                    ],
                    "--location": "dynamic",
                    "--noc-contact-email": "value",
                    "--remote-location": "dynamic",
                    "--requested-features": "value",
                    "--requested-link-count": "value"
                  }
                },
                "cross-site-networks": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--description": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {}
                    },
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--description": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-diagnostics": {
                  "commands": {},
                  "flags": {}
                },
                "groups": {
                  "commands": {
                    "add-members": {
                      "commands": {},
                      "flags": {
                        "--interconnects": "value"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--description": "value",
                        "--intended-topology-capability": "value",
                        "--interconnects": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {}
                    },
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "get-operational-status": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "remove-members": {
                      "commands": {},
                      "flags": {
                        "--interconnects": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--description": "value",
                        "--intended-topology-capability": "value",
                        "--interconnects": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "locations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "macsec": {
                  "commands": {
                    "add-key": {
                      "commands": {},
                      "flags": {
                        "--key-name": "value",
                        "--start-time": "value"
                      }
                    },
                    "get-config": {
                      "commands": {},
                      "flags": {}
                    },
                    "remove-key": {
                      "commands": {},
                      "flags": {
                        "--key-name": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--enabled": "bool",
                        "--fail-open": "bool"
                      }
                    },
                    "update-key": {
                      "commands": {},
                      "flags": {
                        "--key-name": "value",
                        "--start-time": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "remote-locations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--admin-enabled": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--noc-contact-email": "value",
                    "--remove-labels": "value",
                    "--requested-link-count": "value",
                    "--update-labels": "value"
                  }
                },
                "wire-groups": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--admin-enabled": "value",
                        "--bandwidth-allocation": [
                          "ALLOCATE_PER_WIRE",
                          "SHARED_WITH_WIRE_GROUP"
                        ],
                        "--bandwidth-metered": "value",
                        "--bandwidth-unmetered": "value",
                        "--cross-site-network": "dynamic",
                        "--description": "value",
                        "--fault-response": [
                          "DISABLE_PORT",
                          "NONE"
                        ],
                        "--network-service-class": [
                          "BRONZE",
                          "GOLD"
                        ],
                        "--type": [
                          "BOX_AND_CROSS",
                          "REDUNDANT",
                          "WIRE"
                        ],
                        "--validate-only": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--cross-site-network": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--cross-site-network": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--cross-site-network": "dynamic",
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--admin-enabled": "value",
                        "--bandwidth-allocation": [
                          "ALLOCATE_PER_WIRE",
                          "SHARED_WITH_WIRE_GROUP"
                        ],
                        "--bandwidth-metered": "value",
                        "--bandwidth-unmetered": "value",
                        "--cross-site-network": "dynamic",
                        "--description": "value",
                        "--fault-response": [
                          "DISABLE_PORT",
                          "NONE"
                        ],
                        "--network-service-class": [
                          "BRONZE",
                          "GOLD"
                        ],
                        "--type": [
                          "BOX_AND_CROSS",
                          "REDUNDANT",
                          "WIRE"
                        ],
                        "--validate-only": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "machine-images": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--csek-key-file": "value",
                    "--description": "value",
                    "--guest-flush": "bool",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--require-csek-key-create": "bool",
                    "--source-disk-csek-key": "value",
                    "--source-instance": "dynamic",
                    "--source-instance-zone": "dynamic",
                    "--storage-location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--byol": "bool",
                    "--can-ip-forward": "bool",
                    "--cloudbuild-service-account": "value",
                    "--compute-service-account": "value",
                    "--custom-cpu": "value",
                    "--custom-extensions": "bool",
                    "--custom-memory": "value",
                    "--custom-vm-type": "value",
                    "--description": "value",
                    "--guest-environment": "bool",
                    "--guest-flush": "bool",
                    "--guest-os-features": "value",
                    "--labels": "value",
                    "--log-location": "value",
                    "--machine-type": "dynamic",
                    "--network": "value",
                    "--network-tier": "value",
                    "--no-address": "bool",
                    "--no-scopes": "bool",
                    "--no-service-account": "bool",
                    "--os": [
                      "centos-7",
                      "centos-stream-8",
                      "centos-stream-9",
                      "debian-10",
                      "debian-11",
                      "debian-8",
                      "debian-9",
                      "opensuse-15",
                      "rhel-6",
                      "rhel-6-byol",
                      "rhel-7",
                      "rhel-7-byol",
                      "rhel-8",
                      "rhel-8-byol",
                      "rhel-9",
                      "rhel-9-byol",
                      "rocky-8",
                      "rocky-9",
                      "sles-12",
                      "sles-12-byol",
                      "sles-15",
                      "sles-15-byol",
                      "sles-sap-12",
                      "sles-sap-12-byol",
                      "sles-sap-15",
                      "sles-sap-15-byol",
                      "ubuntu-1404",
                      "ubuntu-1604",
                      "ubuntu-1804",
                      "ubuntu-2004",
                      "ubuntu-2204",
                      "windows-10-x64-byol",
                      "windows-10-x86-byol",
                      "windows-11-x64-byol",
                      "windows-2008r2",
                      "windows-2008r2-byol",
                      "windows-2012",
                      "windows-2012-byol",
                      "windows-2012r2",
                      "windows-2012r2-byol",
                      "windows-2016",
                      "windows-2016-byol",
                      "windows-2019",
                      "windows-2019-byol",
                      "windows-2022",
                      "windows-2022-byol",
                      "windows-7-x64-byol",
                      "windows-7-x86-byol",
                      "windows-8-x64-byol",
                      "windows-8-x86-byol"
                    ],
                    "--restart-on-failure": "bool",
                    "--scopes": "value",
                    "--service-account": "value",
                    "--source-uri": "value",
                    "--storage-location": "value",
                    "--subnet": "value",
                    "--tags": "value",
                    "--timeout": "value",
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "machine-types": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zones": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "network-attachments": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--connection-preference": [
                      "ACCEPT_AUTOMATIC",
                      "ACCEPT_MANUAL"
                    ],
                    "--description": "value",
                    "--producer-accept-list": "value",
                    "--producer-reject-list": "value",
                    "--region": "dynamic",
                    "--subnets": "dynamic",
                    "--subnets-region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--producer-accept-list": "value",
                    "--producer-reject-list": "value",
                    "--region": "dynamic",
                    "--subnets": "dynamic",
                    "--subnets-region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "network-edge-security-services": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--region": "dynamic",
                    "--security-policy": "dynamic",
                    "--security-policy-region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--region": "dynamic",
                    "--security-policy": "dynamic",
                    "--security-policy-region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "network-endpoint-groups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--app-engine-app": "bool",
                    "--app-engine-service": "value",
                    "--app-engine-url-mask": "value",
                    "--app-engine-version": "value",
                    "--cloud-function-name": "value",
                    "--cloud-function-url-mask": "value",
                    "--cloud-run-service": "value",
                    "--cloud-run-tag": "value",
                    "--cloud-run-url-mask": "value",
                    "--default-port": "value",
                    "--global": "bool",
                    "--network": "value",
                    "--network-endpoint-type": [
                      "gce-vm-ip",
                      "gce-vm-ip-port",
                      "gce-vm-ip-portmap",
                      "internet-fqdn-port",
                      "internet-ip-port",
                      "non-gcp-private-ip-port",
                      "private-service-connect",
                      "serverless"
                    ],
                    "--producer-port": "value",
                    "--psc-target-service": "value",
                    "--region": "dynamic",
                    "--serverless-deployment-platform": "value",
                    "--serverless-deployment-resource": "value",
                    "--serverless-deployment-url-mask": "value",
                    "--serverless-deployment-version": "value",
                    "--subnet": "value",
                    "--zone": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zones": "value"
                  }
                },
                "list-network-endpoints": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--zone": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-endpoint": "value",
                    "--global": "bool",
                    "--region": "dynamic",
                    "--remove-endpoint": "value",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "network-firewall-policies": {
              "commands": {
                "associations": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--firewall-policy": "value",
                        "--firewall-policy-region": "dynamic",
                        "--global-firewall-policy": "bool",
                        "--name": "value",
                        "--network": "value",
                        "--replace-association-on-target": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--firewall-policy": "value",
                        "--firewall-policy-region": "dynamic",
                        "--global-firewall-policy": "bool",
                        "--name": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "clone-rules": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--source-firewall-policy": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "export-rules": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "get-effective-firewalls": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--network": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "import-rules": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "mirroring-rules": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "do_not_mirror",
                          "goto_next",
                          "mirror"
                        ],
                        "--description": "value",
                        "--dest-ip-ranges": "value",
                        "--direction": [
                          "EGRESS",
                          "INGRESS"
                        ],
                        "--disabled": "bool",
                        "--firewall-policy": "value",
                        "--global-firewall-policy": "bool",
                        "--layer4-configs": "value",
                        "--security-profile-group": "value",
                        "--src-ip-ranges": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--firewall-policy": "value",
                        "--global-firewall-policy": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--firewall-policy": "value",
                        "--global-firewall-policy": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "do_not_mirror",
                          "goto_next",
                          "mirror"
                        ],
                        "--description": "value",
                        "--dest-ip-ranges": "value",
                        "--direction": [
                          "EGRESS",
                          "INGRESS"
                        ],
                        "--disabled": "bool",
                        "--firewall-policy": "value",
                        "--global-firewall-policy": "bool",
                        "--layer4-configs": "value",
                        "--new-priority": "value",
                        "--security-profile-group": "value",
                        "--src-ip-ranges": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "rules": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "allow",
                          "apply_security_profile_group",
                          "deny",
                          "goto_next"
                        ],
                        "--description": "value",
                        "--dest-address-groups": "value",
                        "--dest-fqdns": "value",
                        "--dest-ip-ranges": "value",
                        "--dest-network-scope": "value",
                        "--dest-region-codes": "value",
                        "--dest-threat-intelligence": "value",
                        "--direction": [
                          "EGRESS",
                          "INGRESS"
                        ],
                        "--disabled": "bool",
                        "--enable-logging": "bool",
                        "--firewall-policy": "value",
                        "--firewall-policy-region": "dynamic",
                        "--global-firewall-policy": "bool",
                        "--layer4-configs": "value",
                        "--security-profile-group": "value",
                        "--src-address-groups": "value",
                        "--src-fqdns": "value",
                        "--src-ip-ranges": "value",
                        "--src-network-scope": "value",
                        "--src-networks": "value",
                        "--src-region-codes": "value",
                        "--src-secure-tags": "value",
                        "--src-threat-intelligence": "value",
                        "--target-secure-tags": "value",
                        "--target-service-accounts": "value",
                        "--tls-inspect": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--firewall-policy": "value",
                        "--firewall-policy-region": "dynamic",
                        "--global-firewall-policy": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--firewall-policy": "value",
                        "--firewall-policy-region": "dynamic",
                        "--global-firewall-policy": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "allow",
                          "apply_security_profile_group",
                          "deny",
                          "goto_next"
                        ],
                        "--description": "value",
                        "--dest-address-groups": "value",
                        "--dest-fqdns": "value",
                        "--dest-ip-ranges": "value",
                        "--dest-network-scope": "value",
                        "--dest-region-codes": "value",
                        "--dest-threat-intelligence": "value",
                        "--direction": [
                          "EGRESS",
                          "INGRESS"
                        ],
                        "--disabled": "bool",
                        "--enable-logging": "bool",
                        "--firewall-policy": "value",
                        "--firewall-policy-region": "dynamic",
                        "--global-firewall-policy": "bool",
                        "--layer4-configs": "value",
                        "--new-priority": "value",
                        "--security-profile-group": "value",
                        "--src-address-groups": "value",
                        "--src-fqdns": "value",
                        "--src-ip-ranges": "value",
                        "--src-network-scope": "value",
                        "--src-networks": "value",
                        "--src-region-codes": "value",
                        "--src-secure-tags": "value",
                        "--src-threat-intelligence": "value",
                        "--target-secure-tags": "value",
                        "--target-service-accounts": "value",
                        "--tls-inspect": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "network-profiles": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "networks": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--bgp-best-path-selection-mode": [
                      "LEGACY",
                      "STANDARD"
                    ],
                    "--bgp-bps-always-compare-med": "bool",
                    "--bgp-bps-inter-region-cost": [
                      "ADD_COST_TO_MED",
                      "DEFAULT"
                    ],
                    "--bgp-routing-mode": [
                      "global",
                      "regional"
                    ],
                    "--description": "value",
                    "--enable-ula-internal-ipv6": "bool",
                    "--internal-ipv6-range": "value",
                    "--mtu": "value",
                    "--network-firewall-policy-enforcement-order": [
                      "AFTER_CLASSIC_FIREWALL",
                      "BEFORE_CLASSIC_FIREWALL"
                    ],
                    "--network-profile": "dynamic",
                    "--range": "value",
                    "--subnet-mode": [
                      "auto",
                      "custom",
                      "legacy"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-effective-firewalls": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-ip-addresses": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--types": "value"
                  }
                },
                "list-ip-owners": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--ip-cidr-range": "value",
                    "--limit": "value",
                    "--owner-projects": "value",
                    "--owner-types": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--subnet-name": "value",
                    "--subnet-region": "value",
                    "--uri": "bool"
                  }
                },
                "peerings": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--auto-create-routes": "bool",
                        "--export-custom-routes": "bool",
                        "--export-subnet-routes-with-public-ip": "bool",
                        "--import-custom-routes": "bool",
                        "--import-subnet-routes-with-public-ip": "bool",
                        "--network": "value",
                        "--peer-network": "value",
                        "--peer-project": "value",
                        "--stack-type": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--network": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--network": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "list-routes": {
                      "commands": {},
                      "flags": {
                        "--direction": [
                          "INCOMING",
                          "OUTGOING"
                        ],
                        "--filter": "value",
                        "--limit": "value",
                        "--network": "value",
                        "--page-size": "value",
                        "--region": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--export-custom-routes": "bool",
                        "--export-subnet-routes-with-public-ip": "bool",
                        "--import-custom-routes": "bool",
                        "--import-subnet-routes-with-public-ip": "bool",
                        "--network": "value",
                        "--stack-type": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "subnets": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--member": "value",
                        "--region": "value",
                        "--role": "dynamic"
                      }
                    },
                    "config": {
                      "commands": {
                        "export": {
                          "commands": {},
                          "flags": {
                            "--all": "bool",
                            "--path": "value",
                            "--region": "value",
                            "--resource-format": [
                              "krm",
                              "terraform"
                            ]
                          }
                        }
                      },
                      "flags": {}
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--aggregation-interval": [
                          "interval-1-min",
                          "interval-10-min",
                          "interval-15-min",
                          "interval-30-sec",
                          "interval-5-min",
                          "interval-5-sec"
                        ],
                        "--description": "value",
                        "--enable-flow-logs": "bool",
                        "--enable-l2": "bool",
                        "--enable-private-ip-google-access": "bool",
                        "--external-ipv6-prefix": "value",
                        "--flow-sampling": "value",
                        "--ip-collection": "value",
                        "--ipv6-access-type": [
                          "EXTERNAL",
                          "INTERNAL"
                        ],
                        "--logging-aggregation-interval": [
                          "interval-1-min",
                          "interval-10-min",
                          "interval-15-min",
                          "interval-30-sec",
                          "interval-5-min",
                          "interval-5-sec"
                        ],
                        "--logging-filter-expr": "value",
                        "--logging-flow-sampling": "value",
                        "--logging-metadata": [
                          "custom",
                          "exclude-all",
                          "include-all"
                        ],
                        "--logging-metadata-fields": "value",
                        "--metadata": [
                          "exclude-all-metadata",
                          "include-all-metadata"
                        ],
                        "--network": "dynamic",
                        "--private-ipv6-google-access-type": [
                          "disable",
                          "enable-bidirectional-access",
                          "enable-outbound-vm-access"
                        ],
                        "--purpose": [
                          "AGGREGATE",
                          "CUSTOM_HARDWARE_LINK",
                          "GLOBAL_MANAGED_PROXY",
                          "INTERNAL_HTTPS_LOAD_BALANCER",
                          "PEER_MIGRATION",
                          "PRIVATE",
                          "PRIVATE_NAT",
                          "PRIVATE_SERVICE_CONNECT",
                          "REGIONAL_MANAGED_PROXY"
                        ],
                        "--range": "value",
                        "--region": "dynamic",
                        "--reserved-internal-range": "value",
                        "--role": [
                          "ACTIVE",
                          "BACKUP"
                        ],
                        "--secondary-range": "value",
                        "--secondary-range-with-reserved-internal-range": "value",
                        "--stack-type": [
                          "IPV4_IPV6",
                          "IPV4_ONLY",
                          "IPV6_ONLY"
                        ],
                        "--vlan": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic"
                      }
                    },
                    "expand-ip-range": {
                      "commands": {},
                      "flags": {
                        "--prefix-length": "value",
                        "--region": "dynamic"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--network": "value",
                        "--page-size": "value",
                        "--regexp": "value",
                        "--regions": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "list-usable": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--service-project": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--member": "value",
                        "--region": "value",
                        "--role": "dynamic"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--region": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--add-secondary-ranges": "value",
                        "--add-secondary-ranges-with-reserved-internal-range": "value",
                        "--aggregation-interval": [
                          "interval-1-min",
                          "interval-10-min",
                          "interval-15-min",
                          "interval-30-sec",
                          "interval-5-min",
                          "interval-5-sec"
                        ],
                        "--allow-cidr-routes-overlap": "bool",
                        "--drain-timeout": "value",
                        "--enable-flow-logs": "bool",
                        "--enable-private-ip-google-access": "bool",
                        "--external-ipv6-prefix": "value",
                        "--flow-sampling": "value",
                        "--ip-collection": "value",
                        "--ipv6-access-type": [
                          "EXTERNAL",
                          "INTERNAL"
                        ],
                        "--logging-aggregation-interval": [
                          "interval-1-min",
                          "interval-10-min",
                          "interval-15-min",
                          "interval-30-sec",
                          "interval-5-min",
                          "interval-5-sec"
                        ],
                        "--logging-filter-expr": "value",
                        "--logging-flow-sampling": "value",
                        "--logging-metadata": [
                          "custom",
                          "exclude-all",
                          "include-all"
                        ],
                        "--logging-metadata-fields": "value",
                        "--metadata": [
                          "exclude-all-metadata",
                          "include-all-metadata"
                        ],
                        "--private-ipv6-google-access-type": [
                          "disable",
                          "enable-bidirectional-access",
                          "enable-outbound-vm-access"
                        ],
                        "--purpose": [
                          "PRIVATE",
                          "REGIONAL_MANAGED_PROXY"
                        ],
                        "--region": "dynamic",
                        "--remove-secondary-ranges": "value",
                        "--role": [
                          "ACTIVE"
                        ],
                        "--stack-type": [
                          "IPV4_IPV6",
                          "IPV4_ONLY"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--bgp-best-path-selection-mode": [
                      "LEGACY",
                      "STANDARD"
                    ],
                    "--bgp-bps-always-compare-med": "bool",
                    "--bgp-bps-inter-region-cost": [
                      "ADD_COST_TO_MED",
                      "DEFAULT"
                    ],
                    "--bgp-routing-mode": [
                      "global",
                      "regional"
                    ],
                    "--enable-ula-internal-ipv6": "bool",
                    "--internal-ipv6-range": "value",
                    "--mtu": "value",
                    "--network-firewall-policy-enforcement-order": [
                      "AFTER_CLASSIC_FIREWALL",
                      "BEFORE_CLASSIC_FIREWALL"
                    ],
                    "--switch-to-custom-subnet-mode": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zones": "value"
                  }
                }
              },
              "flags": {}
            },
            "org-security-policies": {
              "commands": {
                "associations": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--excluded-folders": "value",
                        "--excluded-projects": "value",
                        "--folder": "value",
                        "--name": "value",
                        "--organization": "value",
                        "--project-number": "value",
                        "--replace-association-on-target": "bool",
                        "--security-policy": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--organization": "value",
                        "--security-policy": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--folder": "value",
                        "--limit": "value",
                        "--organization": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "copy-rules": {
                  "commands": {},
                  "flags": {
                    "--organization": "value",
                    "--source-security-policy": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--file-format": [
                      "json",
                      "yaml"
                    ],
                    "--file-name": "value",
                    "--folder": "value",
                    "--organization": "value",
                    "--short-name": "value",
                    "--type": [
                      "CLOUD_ARMOR",
                      "FIREWALL"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-rules": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "move": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "rules": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "allow",
                          "deny",
                          "deny-403",
                          "deny-404",
                          "deny-502",
                          "redirect"
                        ],
                        "--cloud-armor": "bool",
                        "--description": "value",
                        "--dest-ip-ranges": "value",
                        "--dest-ports": "value",
                        "--direction": [
                          "EGRESS",
                          "INGRESS"
                        ],
                        "--enable-logging": "bool",
                        "--expression": "value",
                        "--layer4-configs": "value",
                        "--organization": "value",
                        "--preview": "bool",
                        "--security-policy": "value",
                        "--src-ip-ranges": "value",
                        "--target-resources": "value",
                        "--target-service-accounts": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--organization": "value",
                        "--security-policy": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--organization": "value",
                        "--security-policy": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "allow",
                          "deny",
                          "deny-403",
                          "deny-404",
                          "deny-502",
                          "redirect"
                        ],
                        "--cloud-armor": "bool",
                        "--description": "value",
                        "--dest-ip-ranges": "value",
                        "--dest-ports": "value",
                        "--direction": [
                          "EGRESS",
                          "INGRESS"
                        ],
                        "--enable-logging": "bool",
                        "--expression": "value",
                        "--layer4-configs": "value",
                        "--new-priority": "value",
                        "--organization": "value",
                        "--preview": "bool",
                        "--security-policy": "value",
                        "--src-ip-ranges": "value",
                        "--target-resources": "value",
                        "--target-service-accounts": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--json-custom-content-types": "value",
                    "--json-parsing": [
                      "DISABLED",
                      "STANDARD",
                      "STANDARD_WITH_GRAPHQL"
                    ],
                    "--log-level": [
                      "NORMAL",
                      "VERBOSE"
                    ],
                    "--organization": "value",
                    "--user-ip-request-headers": "value"
                  }
                }
              },
              "flags": {}
            },
            "os-config": {
              "commands": {
                "instance-os-policies-compliances": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "inventories": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--view": [
                          "basic",
                          "full"
                        ]
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--view": [
                          "basic",
                          "full"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "os-policy-assignment-reports": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--instance": "value",
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--assignment-id": "value",
                        "--filter": "value",
                        "--instance": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "os-policy-assignments": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--file": "value",
                        "--location": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "list-revisions": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "operations": {
                      "commands": {
                        "cancel": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--os-policy-assignment": "value"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--os-policy-assignment": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--allow-missing": "bool",
                        "--async": "bool",
                        "--file": "value",
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "os-upgrade": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--auto-rollback": "bool",
                    "--create-machine-backup": "bool",
                    "--log-location": "value",
                    "--source-os": [
                      "windows-2008r2"
                    ],
                    "--target-os": [
                      "windows-2012r2"
                    ],
                    "--timeout": "value",
                    "--zone": "dynamic"
                  }
                },
                "policy-orchestrators": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "delete",
                          "upsert"
                        ],
                        "--async": "bool",
                        "--folder": "value",
                        "--include-folders": "value",
                        "--include-locations": "value",
                        "--include-projects": "value",
                        "--organization": "value",
                        "--policy-file": "value",
                        "--policy-id": "value",
                        "--policy-type": [
                          "os_policy_assignment_v1"
                        ],
                        "--state": [
                          "active",
                          "stopped"
                        ]
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--folder": "value",
                        "--organization": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--folder": "value",
                        "--organization": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--folder": "value",
                        "--limit": "value",
                        "--organization": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "delete",
                          "upsert"
                        ],
                        "--async": "bool",
                        "--clear-folders": "bool",
                        "--clear-locations": "bool",
                        "--clear-projects": "bool",
                        "--folder": "value",
                        "--include-folders": "value",
                        "--include-locations": "value",
                        "--include-projects": "value",
                        "--organization": "value",
                        "--policy-file": "value",
                        "--policy-id": "value",
                        "--state": [
                          "active",
                          "stopped"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "troubleshoot": {
                  "commands": {},
                  "flags": {
                    "--enable-log-analysis": "bool",
                    "--zone": "dynamic"
                  }
                },
                "vulnerability-reports": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "os-login": {
              "commands": {
                "describe-profile": {
                  "commands": {},
                  "flags": {}
                },
                "remove-profile": {
                  "commands": {},
                  "flags": {
                    "--operating-system": [
                      "linux",
                      "windows"
                    ]
                  }
                },
                "ssh-keys": {
                  "commands": {
                    "add": {
                      "commands": {},
                      "flags": {
                        "--key": "value",
                        "--key-file": "value",
                        "--ttl": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--key": "value",
                        "--key-file": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "remove": {
                      "commands": {},
                      "flags": {
                        "--key": "value",
                        "--key-file": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--key": "value",
                        "--key-file": "value",
                        "--ttl": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "packet-mirrorings": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--collector-ilb": "value",
                    "--description": "value",
                    "--enable": "bool",
                    "--filter-cidr-ranges": "value",
                    "--filter-direction": [
                      "both",
                      "egress",
                      "ingress"
                    ],
                    "--filter-protocols": "value",
                    "--mirrored-instances": "value",
                    "--mirrored-subnets": "value",
                    "--mirrored-tags": "value",
                    "--network": "value",
                    "--region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-filter-cidr-ranges": "value",
                    "--add-filter-protocols": "value",
                    "--add-mirrored-instances": "value",
                    "--add-mirrored-subnets": "value",
                    "--add-mirrored-tags": "value",
                    "--async": "bool",
                    "--clear-filter-cidr-ranges": "bool",
                    "--clear-filter-protocols": "bool",
                    "--clear-mirrored-instances": "bool",
                    "--clear-mirrored-subnets": "bool",
                    "--clear-mirrored-tags": "bool",
                    "--collector-ilb": "value",
                    "--description": "value",
                    "--enable": "bool",
                    "--filter-direction": [
                      "both",
                      "egress",
                      "ingress"
                    ],
                    "--region": "dynamic",
                    "--remove-filter-cidr-ranges": "value",
                    "--remove-filter-protocols": "value",
                    "--remove-mirrored-instances": "value",
                    "--remove-mirrored-subnets": "value",
                    "--remove-mirrored-tags": "value",
                    "--set-filter-cidr-ranges": "value",
                    "--set-filter-protocols": "value",
                    "--set-mirrored-instances": "value",
                    "--set-mirrored-subnets": "value",
                    "--set-mirrored-tags": "value"
                  }
                }
              },
              "flags": {}
            },
            "project-info": {
              "commands": {
                "add-metadata": {
                  "commands": {},
                  "flags": {
                    "--metadata": "value",
                    "--metadata-from-file": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "remove-metadata": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--keys": "value"
                  }
                },
                "set-default-service-account": {
                  "commands": {},
                  "flags": {
                    "--no-service-account": "bool",
                    "--service-account": "value"
                  }
                },
                "set-usage-bucket": {
                  "commands": {},
                  "flags": {
                    "--bucket": "value",
                    "--no-bucket": "bool",
                    "--prefix": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--cloud-armor-tier": [
                      "CA_ENTERPRISE_ANNUAL",
                      "CA_ENTERPRISE_PAYGO",
                      "CA_STANDARD"
                    ],
                    "--default-network-tier": [
                      "PREMIUM",
                      "STANDARD"
                    ],
                    "--managed-protection-tier": [
                      "CAMP_PLUS_ANNUAL",
                      "CAMP_PLUS_PAYGO",
                      "CA_STANDARD"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "project-zonal-metadata": {
              "commands": {
                "add": {
                  "commands": {},
                  "flags": {
                    "--metadata": "value",
                    "--zone": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "remove": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--keys": "value",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "public-advertised-prefixes": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--dns-verification-ip": "value",
                    "--pdp-scope": [
                      "GLOBAL",
                      "REGIONAL"
                    ],
                    "--range": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--announce-prefix": "bool",
                    "--status": [
                      "ptr-configured"
                    ],
                    "--withdraw-prefix": "bool"
                  }
                }
              },
              "flags": {}
            },
            "public-delegated-prefixes": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--allocatable-prefix-length": "value",
                    "--description": "value",
                    "--enable-live-migration": "bool",
                    "--global": "bool",
                    "--mode": [
                      "delegation",
                      "external-ipv6-forwarding-rule-creation",
                      "external-ipv6-subnetwork-creation"
                    ],
                    "--public-advertised-prefix": "value",
                    "--public-delegated-prefix": "value",
                    "--range": "value",
                    "--region": "dynamic"
                  }
                },
                "delegated-sub-prefixes": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--allocatable-prefix-length": "value",
                        "--create-addresses": "bool",
                        "--delegatee-project": "value",
                        "--description": "value",
                        "--global-public-delegated-prefix": "bool",
                        "--mode": [
                          "delegation",
                          "external-ipv6-forwarding-rule-creation",
                          "external-ipv6-subnetwork-creation"
                        ],
                        "--public-delegated-prefix": "value",
                        "--public-delegated-prefix-region": "dynamic",
                        "--range": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--global-public-delegated-prefix": "bool",
                        "--public-delegated-prefix": "value",
                        "--public-delegated-prefix-region": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--announce-prefix": "bool",
                    "--region": "dynamic",
                    "--withdraw-prefix": "bool"
                  }
                }
              },
              "flags": {}
            },
            "queued-resources": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--async": "bool",
                    "--boot-disk-auto-delete": "bool",
                    "--boot-disk-device-name": "value",
                    "--boot-disk-interface": "value",
                    "--boot-disk-kms-key": "dynamic",
                    "--boot-disk-kms-keyring": "dynamic",
                    "--boot-disk-kms-location": "dynamic",
                    "--boot-disk-kms-project": "dynamic",
                    "--boot-disk-provisioned-iops": "value",
                    "--boot-disk-provisioned-throughput": "value",
                    "--boot-disk-size": "value",
                    "--boot-disk-type": "value",
                    "--can-ip-forward": "bool",
                    "--confidential-compute": "bool",
                    "--confidential-compute-type": [
                      "SEV",
                      "SEV_SNP",
                      "TDX"
                    ],
                    "--count": "value",
                    "--create-disk": "value",
                    "--custom-cpu": "value",
                    "--custom-extensions": "bool",
                    "--custom-memory": "value",
                    "--custom-vm-type": "value",
                    "--description": "value",
                    "--discard-local-ssds-at-termination-timestamp": "value",
                    "--disk": "value",
                    "--enable-display-device": "bool",
                    "--enable-nested-virtualization": "bool",
                    "--enable-uefi-networking": "bool",
                    "--enable-watchdog-timer": "bool",
                    "--erase-windows-vss-signature": "bool",
                    "--graceful-shutdown": "bool",
                    "--graceful-shutdown-max-duration": "value",
                    "--host-error-timeout-seconds": "value",
                    "--image": "value",
                    "--image-family": "value",
                    "--image-project": "value",
                    "--instance-termination-action": [
                      "DELETE",
                      "STOP"
                    ],
                    "--labels": "value",
                    "--local-ssd": "value",
                    "--local-ssd-recovery-timeout": "value",
                    "--location-policy": "value",
                    "--machine-type": "dynamic",
                    "--maintenance-interval": [
                      "PERIODIC",
                      "RECURRENT"
                    ],
                    "--maintenance-policy": [
                      "MIGRATE",
                      "TERMINATE"
                    ],
                    "--max-run-duration": "value",
                    "--metadata": "value",
                    "--metadata-from-file": "value",
                    "--min-count": "value",
                    "--min-cpu-platform": "value",
                    "--min-node-cpu": "value",
                    "--name-pattern": "value",
                    "--network": "value",
                    "--network-interface": "value",
                    "--network-performance-configs": "value",
                    "--network-tier": "value",
                    "--no-address": "bool",
                    "--no-public-dns": "bool",
                    "--no-scopes": "bool",
                    "--no-service-account": "bool",
                    "--numa-node-count": "value",
                    "--on-host-maintenance": [
                      "MIGRATE",
                      "TERMINATE"
                    ],
                    "--per-instance-hostnames": "value",
                    "--performance-monitoring-unit": [
                      "architectural",
                      "enhanced",
                      "standard"
                    ],
                    "--post-key-revocation-action-type": [
                      "noop",
                      "shutdown"
                    ],
                    "--predefined-names": "value",
                    "--preemptible": "bool",
                    "--provisioning-model": [
                      "SPOT",
                      "STANDARD"
                    ],
                    "--public-dns": "bool",
                    "--reservation": "value",
                    "--reservation-affinity": [
                      "any",
                      "none",
                      "specific",
                      "specific-then-any-reservation",
                      "specific-then-no-reservation"
                    ],
                    "--resource-manager-tags": "value",
                    "--resource-policies": "value",
                    "--restart-on-failure": "bool",
                    "--scopes": "value",
                    "--secure-tags": "value",
                    "--service-account": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-secure-boot": "bool",
                    "--shielded-vtpm": "bool",
                    "--source-instance-template": "dynamic",
                    "--source-snapshot": "value",
                    "--stack-type": [
                      "IPV4_IPV6",
                      "IPV4_ONLY",
                      "IPV6_ONLY"
                    ],
                    "--subnet": "value",
                    "--tags": "value",
                    "--target-distribution-shape": [
                      "ANY",
                      "ANY_SINGLE_ZONE",
                      "BALANCED"
                    ],
                    "--termination-time": "value",
                    "--threads-per-core": "value",
                    "--turbo-mode": "value",
                    "--valid-until-duration": "value",
                    "--valid-until-time": "value",
                    "--visible-core-count": "value",
                    "--zone": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zones": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "regions": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "reservations": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic",
                    "--zone": "value"
                  }
                },
                "blocks": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--block-name": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "perform-maintenance": {
                      "commands": {},
                      "flags": {
                        "--block-name": "value",
                        "--scope": [
                          "all",
                          "running",
                          "unused"
                        ],
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--delete-after-duration": "value",
                    "--delete-at-time": "value",
                    "--description": "value",
                    "--local-ssd": "value",
                    "--machine-type": "value",
                    "--maintenance-freeze-duration": "value",
                    "--maintenance-interval": [
                      "PERIODIC",
                      "RECURRENT"
                    ],
                    "--min-cpu-platform": "value",
                    "--require-specific-reservation": "bool",
                    "--reservation-sharing-policy": [
                      "ALLOW_ALL",
                      "DISALLOW_ALL"
                    ],
                    "--resource-policies": "value",
                    "--share-setting": [
                      "folders",
                      "local",
                      "projects"
                    ],
                    "--share-with": "value",
                    "--source-instance-template": "value",
                    "--vm-count": "value",
                    "--zone": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "perform-maintenance": {
                  "commands": {},
                  "flags": {
                    "--scope": [
                      "all",
                      "running",
                      "unused"
                    ],
                    "--zone": "dynamic"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic",
                    "--zone": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-share-with": "value",
                    "--delete-after-duration": "value",
                    "--delete-at-time": "value",
                    "--disable-auto-delete": "bool",
                    "--remove-share-with": "value",
                    "--reservation-sharing-policy": [
                      "ALLOW_ALL",
                      "DISALLOW_ALL"
                    ],
                    "--share-with": "value",
                    "--vm-count": "value",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "reset-windows-password": {
              "commands": {},
              "flags": {
                "--user": "value",
                "--zone": "dynamic"
              }
            },
            "resource-policies": {
              "commands": {
                "create": {
                  "commands": {
                    "disk-consistency-group": {
                      "commands": {},
                      "flags": {
                        "--description": "value",
                        "--region": "dynamic"
                      }
                    },
                    "group-placement": {
                      "commands": {},
                      "flags": {
                        "--availability-domain-count": "value",
                        "--collocation": [
                          "clustered",
                          "collocated",
                          "unspecified-collocation"
                        ],
                        "--description": "value",
                        "--max-distance": "value",
                        "--region": "dynamic",
                        "--scope": [
                          "host",
                          "unspecified-scope"
                        ],
                        "--tpu-topology": "value",
                        "--vm-count": "value"
                      }
                    },
                    "instance-schedule": {
                      "commands": {},
                      "flags": {
                        "--description": "value",
                        "--end-date": "value",
                        "--initiation-date": "value",
                        "--region": "dynamic",
                        "--timezone": "value",
                        "--vm-start-schedule": "value",
                        "--vm-stop-schedule": "value"
                      }
                    },
                    "snapshot-schedule": {
                      "commands": {},
                      "flags": {
                        "--daily-schedule": "bool",
                        "--description": "value",
                        "--guest-flush": "bool",
                        "--hourly-schedule": "value",
                        "--max-retention-days": "value",
                        "--on-source-disk-delete": [
                          "apply-retention-policy",
                          "keep-auto-snapshots"
                        ],
                        "--region": "dynamic",
                        "--snapshot-labels": "value",
                        "--start-time": "value",
                        "--storage-location": "value",
                        "--weekly-schedule": [
                          "friday",
                          "monday",
                          "saturday",
                          "sunday",
                          "thursday",
                          "tuesday",
                          "wednesday"
                        ],
                        "--weekly-schedule-from-file": "value"
                      }
                    },
                    "vm-maintenance": {
                      "commands": {
                        "concurrency-limit": {
                          "commands": {},
                          "flags": {
                            "--description": "value",
                            "--max-percent": "value",
                            "--region": "dynamic"
                          }
                        },
                        "maintenance-window": {
                          "commands": {},
                          "flags": {
                            "--daily-window": "bool",
                            "--description": "value",
                            "--region": "dynamic",
                            "--start-time": "value"
                          }
                        }
                      },
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "create-snapshot-schedule": {
                  "commands": {},
                  "flags": {
                    "--daily-schedule": "bool",
                    "--description": "value",
                    "--guest-flush": "bool",
                    "--hourly-schedule": "value",
                    "--max-retention-days": "value",
                    "--on-source-disk-delete": [
                      "apply-retention-policy",
                      "keep-auto-snapshots"
                    ],
                    "--region": "dynamic",
                    "--snapshot-labels": "value",
                    "--start-time": "value",
                    "--storage-location": "value",
                    "--weekly-schedule": [
                      "friday",
                      "monday",
                      "saturday",
                      "sunday",
                      "thursday",
                      "tuesday",
                      "wednesday"
                    ],
                    "--weekly-schedule-from-file": "value"
                  }
                },
                "create-vm-maintenance": {
                  "commands": {},
                  "flags": {
                    "--daily-window": "bool",
                    "--description": "value",
                    "--region": "dynamic",
                    "--start-time": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "update": {
                  "commands": {
                    "instance-schedule": {
                      "commands": {},
                      "flags": {
                        "--description": "value",
                        "--end-date": "value",
                        "--initiation-date": "value",
                        "--region": "dynamic",
                        "--timezone": "value",
                        "--vm-start-schedule": "value",
                        "--vm-stop-schedule": "value"
                      }
                    },
                    "snapshot-schedule": {
                      "commands": {},
                      "flags": {
                        "--daily-schedule": "bool",
                        "--description": "value",
                        "--hourly-schedule": "value",
                        "--max-retention-days": "value",
                        "--on-source-disk-delete": [
                          "apply-retention-policy",
                          "keep-auto-snapshots"
                        ],
                        "--region": "dynamic",
                        "--snapshot-labels": "value",
                        "--start-time": "value",
                        "--weekly-schedule": [
                          "friday",
                          "monday",
                          "saturday",
                          "sunday",
                          "thursday",
                          "tuesday",
                          "wednesday"
                        ],
                        "--weekly-schedule-from-file": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "routers": {
              "commands": {
                "add-bgp-peer": {
                  "commands": {},
                  "flags": {
                    "--advertised-route-priority": "value",
                    "--advertisement-mode": [
                      "CUSTOM",
                      "DEFAULT"
                    ],
                    "--async": "bool",
                    "--bfd-min-receive-interval": "value",
                    "--bfd-min-transmit-interval": "value",
                    "--bfd-multiplier": "value",
                    "--bfd-session-initialization-mode": [
                      "ACTIVE",
                      "DISABLED",
                      "PASSIVE"
                    ],
                    "--custom-learned-route-priority": "value",
                    "--enable-ipv4": "bool",
                    "--enable-ipv6": "bool",
                    "--enabled": "bool",
                    "--export-policies": "value",
                    "--import-policies": "value",
                    "--instance": "dynamic",
                    "--instance-zone": "dynamic",
                    "--interface": "value",
                    "--ipv4-nexthop-address": "value",
                    "--ipv6-nexthop-address": "value",
                    "--md5-authentication-key": "value",
                    "--peer-asn": "value",
                    "--peer-ip-address": "value",
                    "--peer-ipv4-nexthop-address": "value",
                    "--peer-ipv6-nexthop-address": "value",
                    "--peer-name": "value",
                    "--region": "dynamic",
                    "--set-advertisement-groups": "value",
                    "--set-advertisement-ranges": "value",
                    "--set-custom-learned-route-ranges": "value"
                  }
                },
                "add-interface": {
                  "commands": {},
                  "flags": {
                    "--interconnect-attachment": "dynamic",
                    "--interconnect-attachment-region": "dynamic",
                    "--interface-name": "value",
                    "--ip-address": "value",
                    "--ip-version": [
                      "IPV4",
                      "IPV6"
                    ],
                    "--mask-length": "value",
                    "--redundant-interface": "value",
                    "--region": "dynamic",
                    "--subnetwork": "dynamic",
                    "--subnetwork-region": "dynamic",
                    "--vpn-tunnel": "dynamic",
                    "--vpn-tunnel-region": "dynamic"
                  }
                },
                "add-route-policy": {
                  "commands": {},
                  "flags": {
                    "--policy-name": "value",
                    "--policy-type": [
                      "EXPORT",
                      "IMPORT"
                    ],
                    "--region": "dynamic"
                  }
                },
                "add-route-policy-term": {
                  "commands": {},
                  "flags": {
                    "--actions": "value",
                    "--match": "value",
                    "--policy-name": "value",
                    "--priority": "value",
                    "--region": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--advertisement-mode": [
                      "CUSTOM",
                      "DEFAULT"
                    ],
                    "--asn": "value",
                    "--async": "bool",
                    "--bgp-identifier-range": "value",
                    "--description": "value",
                    "--encrypted-interconnect-router": "bool",
                    "--keepalive-interval": "value",
                    "--network": "dynamic",
                    "--region": "dynamic",
                    "--set-advertisement-groups": "value",
                    "--set-advertisement-ranges": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "download-route-policy": {
                  "commands": {},
                  "flags": {
                    "--file-format": [
                      "json",
                      "yaml"
                    ],
                    "--file-name": "value",
                    "--policy-name": "value",
                    "--region": "dynamic"
                  }
                },
                "get-nat-ip-info": {
                  "commands": {},
                  "flags": {
                    "--nat-name": "value",
                    "--region": "dynamic"
                  }
                },
                "get-nat-mapping-info": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--nat-name": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value"
                  }
                },
                "get-route-policy": {
                  "commands": {},
                  "flags": {
                    "--policy-name": "value",
                    "--region": "dynamic"
                  }
                },
                "get-status": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-bgp-routes": {
                  "commands": {},
                  "flags": {
                    "--address-family": [
                      "IPV4",
                      "IPV6"
                    ],
                    "--destination-range": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--peer": "value",
                    "--policy-applied": "bool",
                    "--region": "dynamic",
                    "--route-direction": [
                      "INBOUND",
                      "OUTBOUND"
                    ],
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-route-policies": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "nats": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--auto-allocate-nat-external-ips": "bool",
                        "--auto-network-tier": [
                          "PREMIUM",
                          "STANDARD"
                        ],
                        "--enable-dynamic-port-allocation": "bool",
                        "--enable-endpoint-independent-mapping": "bool",
                        "--enable-logging": "bool",
                        "--endpoint-types": "value",
                        "--icmp-idle-timeout": "value",
                        "--log-filter": [
                          "ALL",
                          "ERRORS_ONLY",
                          "TRANSLATIONS_ONLY"
                        ],
                        "--max-ports-per-vm": "value",
                        "--min-ports-per-vm": "value",
                        "--nat-all-subnet-ip-ranges": "bool",
                        "--nat-custom-subnet-ip-ranges": "value",
                        "--nat-external-ip-pool": "value",
                        "--nat-primary-subnet-ip-ranges": "bool",
                        "--nat64-all-v6-subnet-ip-ranges": "bool",
                        "--nat64-custom-v6-subnet-ip-ranges": "value",
                        "--region": "dynamic",
                        "--router": "dynamic",
                        "--rules": "value",
                        "--tcp-established-idle-timeout": "value",
                        "--tcp-time-wait-timeout": "value",
                        "--tcp-transitory-idle-timeout": "value",
                        "--type": [
                          "PRIVATE",
                          "PUBLIC"
                        ],
                        "--udp-idle-timeout": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--router": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--router": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--router": "dynamic"
                      }
                    },
                    "rules": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--async": "bool",
                            "--match": "value",
                            "--nat": "value",
                            "--region": "dynamic",
                            "--router": "dynamic",
                            "--source-nat-active-ips": "value",
                            "--source-nat-active-ranges": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--nat": "value",
                            "--region": "dynamic",
                            "--router": "dynamic"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--nat": "value",
                            "--region": "dynamic",
                            "--router": "dynamic"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--nat": "value",
                            "--region": "dynamic",
                            "--router": "dynamic"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--async": "bool",
                            "--clear-source-nat-drain-ips": "bool",
                            "--clear-source-nat-drain-ranges": "bool",
                            "--match": "value",
                            "--nat": "value",
                            "--region": "dynamic",
                            "--router": "dynamic",
                            "--source-nat-active-ips": "value",
                            "--source-nat-active-ranges": "value",
                            "--source-nat-drain-ips": "value",
                            "--source-nat-drain-ranges": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--auto-allocate-nat-external-ips": "bool",
                        "--auto-network-tier": [
                          "PREMIUM",
                          "STANDARD"
                        ],
                        "--clear-icmp-idle-timeout": "bool",
                        "--clear-max-ports-per-vm": "bool",
                        "--clear-min-ports-per-vm": "bool",
                        "--clear-nat-external-drain-ip-pool": "bool",
                        "--clear-nat-subnet-ip-ranges": "bool",
                        "--clear-nat64-subnet-ip-ranges": "bool",
                        "--clear-tcp-established-idle-timeout": "bool",
                        "--clear-tcp-time-wait-timeout": "bool",
                        "--clear-tcp-transitory-idle-timeout": "bool",
                        "--clear-udp-idle-timeout": "bool",
                        "--enable-dynamic-port-allocation": "bool",
                        "--enable-endpoint-independent-mapping": "bool",
                        "--enable-logging": "bool",
                        "--icmp-idle-timeout": "value",
                        "--log-filter": [
                          "ALL",
                          "ERRORS_ONLY",
                          "TRANSLATIONS_ONLY"
                        ],
                        "--max-ports-per-vm": "value",
                        "--min-ports-per-vm": "value",
                        "--nat-all-subnet-ip-ranges": "bool",
                        "--nat-custom-subnet-ip-ranges": "value",
                        "--nat-external-drain-ip-pool": "value",
                        "--nat-external-ip-pool": "value",
                        "--nat-primary-subnet-ip-ranges": "bool",
                        "--nat64-all-v6-subnet-ip-ranges": "bool",
                        "--nat64-custom-v6-subnet-ip-ranges": "value",
                        "--region": "dynamic",
                        "--router": "dynamic",
                        "--rules": "value",
                        "--tcp-established-idle-timeout": "value",
                        "--tcp-time-wait-timeout": "value",
                        "--tcp-transitory-idle-timeout": "value",
                        "--udp-idle-timeout": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "remove-bgp-peer": {
                  "commands": {},
                  "flags": {
                    "--peer-name": "value",
                    "--peer-names": "value",
                    "--region": "dynamic"
                  }
                },
                "remove-interface": {
                  "commands": {},
                  "flags": {
                    "--interface-name": "value",
                    "--interface-names": "value",
                    "--region": "dynamic"
                  }
                },
                "remove-route-policy": {
                  "commands": {},
                  "flags": {
                    "--policy-name": "value",
                    "--region": "dynamic"
                  }
                },
                "remove-route-policy-term": {
                  "commands": {},
                  "flags": {
                    "--policy-name": "value",
                    "--priority": "value",
                    "--region": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-advertisement-groups": "value",
                    "--add-advertisement-ranges": "value",
                    "--advertisement-mode": [
                      "CUSTOM",
                      "DEFAULT"
                    ],
                    "--asn": "value",
                    "--async": "bool",
                    "--bgp-identifier-range": "value",
                    "--keepalive-interval": "value",
                    "--region": "dynamic",
                    "--remove-advertisement-groups": "value",
                    "--remove-advertisement-ranges": "value",
                    "--set-advertisement-groups": "value",
                    "--set-advertisement-ranges": "value"
                  }
                },
                "update-bgp-peer": {
                  "commands": {},
                  "flags": {
                    "--add-advertisement-groups": "value",
                    "--add-advertisement-ranges": "value",
                    "--add-custom-learned-route-ranges": "value",
                    "--advertised-route-priority": "value",
                    "--advertisement-mode": [
                      "CUSTOM",
                      "DEFAULT"
                    ],
                    "--async": "bool",
                    "--bfd-min-receive-interval": "value",
                    "--bfd-min-transmit-interval": "value",
                    "--bfd-multiplier": "value",
                    "--bfd-session-initialization-mode": [
                      "ACTIVE",
                      "DISABLED",
                      "PASSIVE"
                    ],
                    "--clear-md5-authentication-key": "bool",
                    "--custom-learned-route-priority": "value",
                    "--enable-ipv4": "bool",
                    "--enable-ipv6": "bool",
                    "--enabled": "bool",
                    "--export-policies": "value",
                    "--import-policies": "value",
                    "--interface": "value",
                    "--ip-address": "value",
                    "--ipv4-nexthop-address": "value",
                    "--ipv6-nexthop-address": "value",
                    "--md5-authentication-key": "value",
                    "--peer-asn": "value",
                    "--peer-ip-address": "value",
                    "--peer-ipv4-nexthop-address": "value",
                    "--peer-ipv6-nexthop-address": "value",
                    "--peer-name": "value",
                    "--region": "dynamic",
                    "--remove-advertisement-groups": "value",
                    "--remove-advertisement-ranges": "value",
                    "--remove-custom-learned-route-ranges": "value",
                    "--set-advertisement-groups": "value",
                    "--set-advertisement-ranges": "value",
                    "--set-custom-learned-route-ranges": "value"
                  }
                },
                "update-interface": {
                  "commands": {},
                  "flags": {
                    "--interconnect-attachment": "dynamic",
                    "--interconnect-attachment-region": "dynamic",
                    "--interface-name": "value",
                    "--ip-address": "value",
                    "--ip-version": [
                      "IPV4",
                      "IPV6"
                    ],
                    "--mask-length": "value",
                    "--region": "dynamic",
                    "--vpn-tunnel": "dynamic",
                    "--vpn-tunnel-region": "dynamic"
                  }
                },
                "update-route-policy-term": {
                  "commands": {},
                  "flags": {
                    "--actions": "value",
                    "--match": "value",
                    "--policy-name": "value",
                    "--priority": "value",
                    "--region": "dynamic"
                  }
                },
                "upload-route-policy": {
                  "commands": {},
                  "flags": {
                    "--file-format": [
                      "json",
                      "yaml"
                    ],
                    "--file-name": "value",
                    "--policy-name": "value",
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "routes": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--destination-range": "value",
                    "--network": "value",
                    "--next-hop-address": "value",
                    "--next-hop-gateway": "dynamic",
                    "--next-hop-ilb": "value",
                    "--next-hop-ilb-region": "value",
                    "--next-hop-instance": "value",
                    "--next-hop-instance-zone": "value",
                    "--next-hop-vpn-tunnel": "value",
                    "--next-hop-vpn-tunnel-region": "value",
                    "--priority": "value",
                    "--tags": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "scp": {
              "commands": {},
              "flags": {
                "--compress": "bool",
                "--dest-group": "value",
                "--dry-run": "bool",
                "--force-key-file-overwrite": "bool",
                "--internal-ip": "bool",
                "--network": "value",
                "--plain": "bool",
                "--port": "value",
                "--recurse": "bool",
                "--region": "value",
                "--scp-flag": "value",
                "--ssh-key-expiration": "value",
                "--ssh-key-expire-after": "value",
                "--ssh-key-file": "value",
                "--strict-host-key-checking": [
                  "ask",
                  "no",
                  "yes"
                ],
                "--tunnel-through-iap": "bool",
                "--zone": "value"
              }
            },
            "security-policies": {
              "commands": {
                "add-layer7-ddos-defense-threshold-config": {
                  "commands": {},
                  "flags": {
                    "--auto-deploy-confidence-threshold": "value",
                    "--auto-deploy-expiration-sec": "value",
                    "--auto-deploy-impacted-baseline-threshold": "value",
                    "--auto-deploy-load-threshold": "value",
                    "--detection-absolute-qps": "value",
                    "--detection-load-threshold": "value",
                    "--detection-relative-to-baseline-qps": "value",
                    "--threshold-config-name": "value",
                    "--traffic-granularity-configs": "value"
                  }
                },
                "add-user-defined-field": {
                  "commands": {},
                  "flags": {
                    "--base": [
                      "ipv4",
                      "ipv6",
                      "tcp",
                      "udp"
                    ],
                    "--mask": "value",
                    "--offset": "value",
                    "--region": "dynamic",
                    "--size": "value",
                    "--user-defined-field-name": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--file-format": [
                      "json",
                      "yaml"
                    ],
                    "--file-name": "value",
                    "--global": "bool",
                    "--region": "dynamic",
                    "--type": [
                      "CLOUD_ARMOR",
                      "CLOUD_ARMOR_EDGE",
                      "CLOUD_ARMOR_INTERNAL_SERVICE",
                      "CLOUD_ARMOR_NETWORK"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--file-format": [
                      "json",
                      "yaml"
                    ],
                    "--file-name": "value",
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--file-format": [
                      "json",
                      "yaml"
                    ],
                    "--file-name": "value",
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-preconfigured-expression-sets": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-layer7-ddos-defense-threshold-config": {
                  "commands": {},
                  "flags": {
                    "--threshold-config-name": "value"
                  }
                },
                "remove-user-defined-field": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--user-defined-field-name": "value"
                  }
                },
                "rules": {
                  "commands": {
                    "add-preconfig-waf-exclusion": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--request-cookie-to-exclude": "value",
                        "--request-header-to-exclude": "value",
                        "--request-query-param-to-exclude": "value",
                        "--request-uri-to-exclude": "value",
                        "--security-policy": "dynamic",
                        "--target-rule-ids": "value",
                        "--target-rule-set": "value"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "allow",
                          "deny",
                          "deny-403",
                          "deny-404",
                          "deny-502",
                          "fairshare",
                          "rate-based-ban",
                          "redirect",
                          "redirect-to-recaptcha",
                          "throttle"
                        ],
                        "--ban-duration-sec": "value",
                        "--ban-threshold-count": "value",
                        "--ban-threshold-interval-sec": "value",
                        "--conform-action": [
                          "allow"
                        ],
                        "--description": "value",
                        "--enforce-on-key": [
                          "all",
                          "http-cookie",
                          "http-header",
                          "http-path",
                          "ip",
                          "region-code",
                          "sni",
                          "tls-ja3-fingerprint",
                          "tls-ja4-fingerprint",
                          "user-ip",
                          "xff-ip"
                        ],
                        "--enforce-on-key-configs": "value",
                        "--enforce-on-key-name": "value",
                        "--exceed-action": [
                          "deny",
                          "deny-403",
                          "deny-404",
                          "deny-429",
                          "deny-502",
                          "redirect"
                        ],
                        "--exceed-action-rpc-status-code": "value",
                        "--exceed-action-rpc-status-message": "value",
                        "--exceed-redirect-target": "value",
                        "--exceed-redirect-type": [
                          "external-302",
                          "google-recaptcha"
                        ],
                        "--expression": "value",
                        "--network-dest-ip-ranges": "value",
                        "--network-dest-ports": "value",
                        "--network-ip-protocols": "value",
                        "--network-src-asns": "value",
                        "--network-src-ip-ranges": "value",
                        "--network-src-ports": "value",
                        "--network-src-region-codes": "value",
                        "--network-user-defined-fields": "value",
                        "--preview": "bool",
                        "--rate-limit-threshold-count": "value",
                        "--rate-limit-threshold-interval-sec": "value",
                        "--recaptcha-action-site-keys": "value",
                        "--recaptcha-session-site-keys": "value",
                        "--redirect-target": "value",
                        "--redirect-type": [
                          "external-302",
                          "google-recaptcha"
                        ],
                        "--region": "dynamic",
                        "--request-headers-to-add": "value",
                        "--security-policy": "dynamic",
                        "--src-ip-ranges": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--security-policy": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--security-policy": "dynamic"
                      }
                    },
                    "remove-preconfig-waf-exclusion": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--request-cookie-to-exclude": "value",
                        "--request-header-to-exclude": "value",
                        "--request-query-param-to-exclude": "value",
                        "--request-uri-to-exclude": "value",
                        "--security-policy": "dynamic",
                        "--target-rule-ids": "value",
                        "--target-rule-set": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "allow",
                          "deny",
                          "deny-403",
                          "deny-404",
                          "deny-502",
                          "fairshare",
                          "rate-based-ban",
                          "redirect",
                          "redirect-to-recaptcha",
                          "throttle"
                        ],
                        "--ban-duration-sec": "value",
                        "--ban-threshold-count": "value",
                        "--ban-threshold-interval-sec": "value",
                        "--conform-action": [
                          "allow"
                        ],
                        "--description": "value",
                        "--enforce-on-key": [
                          "all",
                          "http-cookie",
                          "http-header",
                          "http-path",
                          "ip",
                          "region-code",
                          "sni",
                          "tls-ja3-fingerprint",
                          "tls-ja4-fingerprint",
                          "user-ip",
                          "xff-ip"
                        ],
                        "--enforce-on-key-configs": "value",
                        "--enforce-on-key-name": "value",
                        "--exceed-action": [
                          "deny",
                          "deny-403",
                          "deny-404",
                          "deny-429",
                          "deny-502",
                          "redirect"
                        ],
                        "--exceed-action-rpc-status-code": "value",
                        "--exceed-action-rpc-status-message": "value",
                        "--exceed-redirect-target": "value",
                        "--exceed-redirect-type": [
                          "external-302",
                          "google-recaptcha"
                        ],
                        "--expression": "value",
                        "--network-dest-ip-ranges": "value",
                        "--network-dest-ports": "value",
                        "--network-ip-protocols": "value",
                        "--network-src-asns": "value",
                        "--network-src-ip-ranges": "value",
                        "--network-src-ports": "value",
                        "--network-src-region-codes": "value",
                        "--network-user-defined-fields": "value",
                        "--preview": "bool",
                        "--rate-limit-threshold-count": "value",
                        "--rate-limit-threshold-interval-sec": "value",
                        "--recaptcha-action-site-keys": "value",
                        "--recaptcha-session-site-keys": "value",
                        "--redirect-target": "value",
                        "--redirect-type": [
                          "external-302",
                          "google-recaptcha"
                        ],
                        "--region": "dynamic",
                        "--request-headers-to-add": "value",
                        "--security-policy": "dynamic",
                        "--src-ip-ranges": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--ddos-protection": [
                      "ADVANCED",
                      "ADVANCED_PREVIEW",
                      "STANDARD"
                    ],
                    "--description": "value",
                    "--enable-layer7-ddos-defense": "bool",
                    "--enable-ml": "bool",
                    "--global": "bool",
                    "--json-custom-content-types": "value",
                    "--json-parsing": [
                      "DISABLED",
                      "STANDARD",
                      "STANDARD_WITH_GRAPHQL"
                    ],
                    "--layer7-ddos-defense-auto-deploy-confidence-threshold": "value",
                    "--layer7-ddos-defense-auto-deploy-expiration-sec": "value",
                    "--layer7-ddos-defense-auto-deploy-impacted-baseline-threshold": "value",
                    "--layer7-ddos-defense-auto-deploy-load-threshold": "value",
                    "--layer7-ddos-defense-rule-visibility": [
                      "PREMIUM",
                      "STANDARD"
                    ],
                    "--log-level": [
                      "NORMAL",
                      "VERBOSE"
                    ],
                    "--network-ddos-protection": [
                      "ADVANCED",
                      "ADVANCED_PREVIEW",
                      "STANDARD"
                    ],
                    "--recaptcha-redirect-site-key": "value",
                    "--region": "dynamic",
                    "--request-body-inspection-size": [
                      "128KB",
                      "8KB"
                    ],
                    "--user-ip-request-headers": "value"
                  }
                }
              },
              "flags": {}
            },
            "service-attachments": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--connection-preference": [
                      "ACCEPT_AUTOMATIC",
                      "ACCEPT_MANUAL"
                    ],
                    "--consumer-accept-list": "value",
                    "--consumer-reject-list": "value",
                    "--description": "value",
                    "--domain-names": "value",
                    "--enable-proxy-protocol": "bool",
                    "--nat-subnets": "dynamic",
                    "--nat-subnets-region": "dynamic",
                    "--producer-forwarding-rule": "dynamic",
                    "--producer-forwarding-rule-region": "dynamic",
                    "--propagated-connection-limit": "value",
                    "--reconcile-connections": "bool",
                    "--region": "dynamic",
                    "--target-service": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--connection-preference": [
                      "ACCEPT_AUTOMATIC",
                      "ACCEPT_MANUAL"
                    ],
                    "--consumer-accept-list": "value",
                    "--consumer-reject-list": "value",
                    "--description": "value",
                    "--enable-proxy-protocol": "bool",
                    "--nat-subnets": "dynamic",
                    "--nat-subnets-region": "dynamic",
                    "--propagated-connection-limit": "value",
                    "--reconcile-connections": "bool",
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "shared-vpc": {
              "commands": {
                "associated-projects": {
                  "commands": {
                    "add": {
                      "commands": {},
                      "flags": {
                        "--host-project": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "remove": {
                      "commands": {},
                      "flags": {
                        "--host-project": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "disable": {
                  "commands": {},
                  "flags": {}
                },
                "enable": {
                  "commands": {},
                  "flags": {}
                },
                "get-host-project": {
                  "commands": {},
                  "flags": {}
                },
                "list-associated-resources": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "organizations": {
                  "commands": {
                    "list-host-projects": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "sign-url": {
              "commands": {},
              "flags": {
                "--expires-in": "value",
                "--key-file": "value",
                "--key-name": "value",
                "--validate": "bool"
              }
            },
            "snapshot-settings": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-access-locations": "value",
                    "--async": "bool",
                    "--region": "dynamic",
                    "--remove-access-locations": "value",
                    "--storage-location-names": "value",
                    "--storage-location-policy": "value"
                  }
                }
              },
              "flags": {}
            },
            "snapshots": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "add-labels": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--labels": "value",
                    "--region": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--chain-name": "value",
                    "--csek-key-file": "value",
                    "--description": "value",
                    "--global": "bool",
                    "--guest-flush": "bool",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--max-retention-days": "value",
                    "--region": "dynamic",
                    "--snapshot-type": [
                      "ARCHIVE",
                      "STANDARD"
                    ],
                    "--source-disk": "dynamic",
                    "--source-disk-for-recovery-checkpoint": "dynamic",
                    "--source-disk-for-recovery-checkpoint-region": "dynamic",
                    "--source-disk-key-file": "value",
                    "--source-disk-region": "dynamic",
                    "--source-disk-zone": "dynamic",
                    "--source-instant-snapshot": "dynamic",
                    "--source-instant-snapshot-key-file": "value",
                    "--source-instant-snapshot-region": "dynamic",
                    "--source-instant-snapshot-zone": "dynamic",
                    "--storage-location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "remove-labels": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--global": "bool",
                    "--labels": "value",
                    "--region": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--global": "bool",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "sole-tenancy": {
              "commands": {
                "node-groups": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--member": "value",
                        "--role": "dynamic",
                        "--zone": "value"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--autoscaler-mode": [
                          "off",
                          "on",
                          "only-scale-out"
                        ],
                        "--description": "value",
                        "--maintenance-interval": [
                          "as-needed",
                          "recurrent"
                        ],
                        "--maintenance-policy": [
                          "default",
                          "migrate-within-node-group",
                          "restart-in-place"
                        ],
                        "--maintenance-window-start-time": "value",
                        "--max-nodes": "value",
                        "--min-nodes": "value",
                        "--node-template": "value",
                        "--share-setting": [
                          "local",
                          "organization",
                          "projects"
                        ],
                        "--share-with": "value",
                        "--target-size": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--zone": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--zone": "dynamic"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--zone": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--share-settings": "bool",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "list-nodes": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "perform-maintenance": {
                      "commands": {},
                      "flags": {
                        "--nodes": "value",
                        "--start-time": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--member": "value",
                        "--role": "dynamic",
                        "--zone": "value"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--zone": "value"
                      }
                    },
                    "simulate-maintenance-event": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--nodes": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--add-nodes": "value",
                        "--autoscaler-mode": [
                          "off",
                          "on",
                          "only-scale-out"
                        ],
                        "--delete-nodes": "value",
                        "--max-nodes": "value",
                        "--min-nodes": "value",
                        "--node-template": "value",
                        "--share-setting": [
                          "local",
                          "organization",
                          "projects"
                        ],
                        "--share-with": "value",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "node-templates": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--member": "value",
                        "--region": "value",
                        "--role": "dynamic"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--accelerator": "value",
                        "--cpu-overcommit-type": [
                          "enabled",
                          "none"
                        ],
                        "--description": "value",
                        "--disk": "value",
                        "--node-affinity-labels": "value",
                        "--node-requirements": "value",
                        "--node-type": "value",
                        "--region": "dynamic",
                        "--server-binding": [
                          "restart-node-on-any-server",
                          "restart-node-on-minimal-servers"
                        ]
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--member": "value",
                        "--region": "value",
                        "--role": "dynamic"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--region": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "node-types": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--zone": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "ssh": {
              "commands": {},
              "flags": {
                "--command": "value",
                "--container": "value",
                "--dest-group": "value",
                "--dry-run": "bool",
                "--force-key-file-overwrite": "bool",
                "--internal-ip": "bool",
                "--network": "value",
                "--plain": "bool",
                "--region": "value",
                "--ssh-flag": "value",
                "--ssh-key-expiration": "value",
                "--ssh-key-expire-after": "value",
                "--ssh-key-file": "value",
                "--strict-host-key-checking": [
                  "ask",
                  "no",
                  "yes"
                ],
                "--troubleshoot": "bool",
                "--tunnel-through-iap": "bool",
                "--zone": "dynamic"
              }
            },
            "ssl-certificates": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--certificate": "value",
                    "--description": "value",
                    "--domains": "value",
                    "--global": "bool",
                    "--private-key": "value",
                    "--region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "ssl-policies": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--custom-features": "value",
                    "--description": "value",
                    "--global": "bool",
                    "--min-tls-version": [
                      "1.0",
                      "1.1",
                      "1.2"
                    ],
                    "--profile": [
                      "COMPATIBLE",
                      "CUSTOM",
                      "MODERN",
                      "RESTRICTED"
                    ],
                    "--region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-available-features": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--custom-features": "value",
                    "--global": "bool",
                    "--min-tls-version": [
                      "1.0",
                      "1.1",
                      "1.2"
                    ],
                    "--profile": [
                      "COMPATIBLE",
                      "CUSTOM",
                      "MODERN",
                      "RESTRICTED"
                    ],
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "start-iap-tunnel": {
              "commands": {},
              "flags": {
                "--dest-group": "value",
                "--iap-tunnel-disable-connection-check": "bool",
                "--local-host-port": "value",
                "--network": "value",
                "--region": "value",
                "--zone": "dynamic"
              }
            },
            "storage-pool-types": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "storage-pools": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--capacity-provisioning-type": [
                      "advanced",
                      "standard"
                    ],
                    "--description": "value",
                    "--performance-provisioning-type": [
                      "advanced",
                      "standard"
                    ],
                    "--provisioned-capacity": "value",
                    "--provisioned-iops": "value",
                    "--provisioned-throughput": "value",
                    "--storage-pool-type": "value",
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list-disks": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--provisioned-capacity": "value",
                    "--provisioned-iops": "value",
                    "--provisioned-throughput": "value",
                    "--zone": "value"
                  }
                }
              },
              "flags": {}
            },
            "target-grpc-proxies": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--global-url-map": "bool",
                    "--url-map": "dynamic",
                    "--url-map-region": "dynamic",
                    "--validate-for-proxyless": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "target-http-proxies": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--global": "bool",
                    "--global-url-map": "bool",
                    "--http-keep-alive-timeout-sec": "value",
                    "--proxy-bind": "bool",
                    "--region": "dynamic",
                    "--url-map": "dynamic",
                    "--url-map-region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-http-keep-alive-timeout-sec": "bool",
                    "--global": "bool",
                    "--global-url-map": "bool",
                    "--http-keep-alive-timeout-sec": "value",
                    "--region": "dynamic",
                    "--url-map": "dynamic",
                    "--url-map-region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "target-https-proxies": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--certificate-manager-certificates": "dynamic",
                    "--certificate-map": "dynamic",
                    "--description": "value",
                    "--global": "bool",
                    "--global-ssl-certificates": "bool",
                    "--global-ssl-policy": "bool",
                    "--global-url-map": "bool",
                    "--http-keep-alive-timeout-sec": "value",
                    "--proxy-bind": "bool",
                    "--quic-override": [
                      "DISABLE",
                      "ENABLE",
                      "NONE"
                    ],
                    "--region": "dynamic",
                    "--server-tls-policy": "dynamic",
                    "--ssl-certificates": "dynamic",
                    "--ssl-certificates-region": "dynamic",
                    "--ssl-policy": "dynamic",
                    "--ssl-policy-region": "dynamic",
                    "--tls-early-data": [
                      "DISABLED",
                      "PERMISSIVE",
                      "STRICT"
                    ],
                    "--url-map": "dynamic",
                    "--url-map-region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--certificate-manager-certificates": "dynamic",
                    "--certificate-map": "dynamic",
                    "--clear-certificate-map": "bool",
                    "--clear-http-keep-alive-timeout-sec": "bool",
                    "--clear-server-tls-policy": "bool",
                    "--clear-ssl-certificates": "bool",
                    "--clear-ssl-policy": "bool",
                    "--global": "bool",
                    "--global-ssl-certificates": "bool",
                    "--global-ssl-policy": "bool",
                    "--global-url-map": "bool",
                    "--http-keep-alive-timeout-sec": "value",
                    "--quic-override": [
                      "DISABLE",
                      "ENABLE",
                      "NONE"
                    ],
                    "--region": "dynamic",
                    "--server-tls-policy": "dynamic",
                    "--ssl-certificates": "dynamic",
                    "--ssl-certificates-region": "dynamic",
                    "--ssl-policy": "dynamic",
                    "--ssl-policy-region": "dynamic",
                    "--tls-early-data": [
                      "DISABLED",
                      "PERMISSIVE",
                      "STRICT"
                    ],
                    "--url-map": "dynamic",
                    "--url-map-region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "target-instances": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ],
                        "--zone": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--instance": "dynamic",
                    "--instance-zone": "dynamic",
                    "--network": "value",
                    "--zone": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zones": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--security-policy": "dynamic",
                    "--security-policy-region": "dynamic",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "target-pools": {
              "commands": {
                "add-health-checks": {
                  "commands": {},
                  "flags": {
                    "--http-health-check": "dynamic",
                    "--region": "dynamic"
                  }
                },
                "add-instances": {
                  "commands": {},
                  "flags": {
                    "--instances": "dynamic",
                    "--instances-zone": "dynamic",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--region": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--backup-pool": "value",
                    "--description": "value",
                    "--failover-ratio": "value",
                    "--health-check": "value",
                    "--http-health-check": "dynamic",
                    "--region": "dynamic",
                    "--session-affinity": [
                      "CLIENT_IP",
                      "CLIENT_IP_PROTO",
                      "NONE"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "get-health": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-health-checks": {
                  "commands": {},
                  "flags": {
                    "--http-health-check": "dynamic",
                    "--region": "dynamic"
                  }
                },
                "remove-instances": {
                  "commands": {},
                  "flags": {
                    "--instances": "dynamic",
                    "--instances-zone": "dynamic",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "set-backup": {
                  "commands": {},
                  "flags": {
                    "--backup-pool": "dynamic",
                    "--failover-ratio": "value",
                    "--no-backup-pool": "bool",
                    "--region": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--security-policy": "dynamic",
                    "--security-policy-region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "target-ssl-proxies": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--backend-service": "dynamic",
                    "--certificate-map": "dynamic",
                    "--description": "value",
                    "--global-ssl-policy": "bool",
                    "--proxy-header": [
                      "NONE",
                      "PROXY_V1"
                    ],
                    "--ssl-certificates": "dynamic",
                    "--ssl-policy": "dynamic",
                    "--ssl-policy-region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--backend-service": "dynamic",
                    "--certificate-map": "dynamic",
                    "--clear-certificate-map": "bool",
                    "--clear-ssl-certificates": "bool",
                    "--clear-ssl-policy": "bool",
                    "--global-ssl-policy": "bool",
                    "--proxy-header": [
                      "NONE",
                      "PROXY_V1"
                    ],
                    "--ssl-certificates": "dynamic",
                    "--ssl-policy": "dynamic",
                    "--ssl-policy-region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "target-tcp-proxies": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--backend-service": "dynamic",
                    "--backend-service-region": "dynamic",
                    "--description": "value",
                    "--global": "bool",
                    "--global-backend-service": "bool",
                    "--proxy-bind": "bool",
                    "--proxy-header": [
                      "NONE",
                      "PROXY_V1"
                    ],
                    "--region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--backend-service": "dynamic",
                    "--proxy-header": [
                      "NONE",
                      "PROXY_V1"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "target-vpn-gateways": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--region": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--network": "dynamic",
                    "--region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "tpus": {
              "commands": {
                "accelerator-types": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--zone": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator-type": "value",
                    "--async": "bool",
                    "--description": "value",
                    "--model-base-path": "value",
                    "--model-config-file": "value",
                    "--model-name": "value",
                    "--network": "value",
                    "--platform-config-file": "value",
                    "--preemptible": "bool",
                    "--range": "value",
                    "--reserved": "bool",
                    "--use-service-networking": "bool",
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "execution-groups": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--accelerator-type": "value",
                        "--disk-size": "value",
                        "--dry-run": "bool",
                        "--forward-ports": "bool",
                        "--gce-image": "value",
                        "--machine-type": "value",
                        "--name": "value",
                        "--network": "value",
                        "--preemptible": "bool",
                        "--preemptible-vm": "bool",
                        "--tf-version": "value",
                        "--tpu-only": "bool",
                        "--use-dl-images": "bool",
                        "--use-with-notebook": "bool",
                        "--vm-only": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--tpu-only": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--zone": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "resume": {
                      "commands": {},
                      "flags": {
                        "--accelerator-type": "value",
                        "--network": "value",
                        "--preemptible": "bool",
                        "--tf-version": "value",
                        "--vm-only": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "suspend": {
                      "commands": {},
                      "flags": {
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                },
                "locations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "queued-resources": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--accelerator-type": "value",
                        "--async": "bool",
                        "--autocheckpoint-enabled": "bool",
                        "--best-effort": "bool",
                        "--boot-disk": "value",
                        "--data-disk": "value",
                        "--description": "value",
                        "--guaranteed": "bool",
                        "--internal-ips": "bool",
                        "--labels": "value",
                        "--metadata": "value",
                        "--metadata-from-file": "value",
                        "--network": "value",
                        "--network-config": "value",
                        "--node-count": "value",
                        "--node-id": "value",
                        "--node-prefix": "value",
                        "--range": "value",
                        "--reservation": "value",
                        "--reservation-host-folder": "value",
                        "--reservation-host-organization": "value",
                        "--reservation-host-project": "value",
                        "--reserved": "bool",
                        "--runtime-version": "value",
                        "--scopes": "value",
                        "--service-account": "value",
                        "--shielded-secure-boot": "bool",
                        "--spot": "bool",
                        "--subnetwork": "value",
                        "--tags": "value",
                        "--topology": "value",
                        "--type": [
                          "v2",
                          "v3",
                          "v4",
                          "v5litepod",
                          "v5p",
                          "v6e"
                        ],
                        "--valid-after-duration": "value",
                        "--valid-after-time": "value",
                        "--valid-until-duration": "value",
                        "--valid-until-time": "value",
                        "--workload-type": "value",
                        "--zone": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--force": "bool",
                        "--zone": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--zone": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "perform-maintenance": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--node-names": "value",
                        "--zone": "value"
                      }
                    },
                    "reset": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--zone": "value"
                      }
                    },
                    "scp": {
                      "commands": {},
                      "flags": {
                        "--batch-size": "value",
                        "--compress": "bool",
                        "--dry-run": "bool",
                        "--force-key-file-overwrite": "bool",
                        "--internal-ip": "bool",
                        "--node": "value",
                        "--plain": "bool",
                        "--recurse": "bool",
                        "--scp-flag": "value",
                        "--ssh-key-expiration": "value",
                        "--ssh-key-expire-after": "value",
                        "--ssh-key-file": "value",
                        "--strict-host-key-checking": [
                          "ask",
                          "no",
                          "yes"
                        ],
                        "--tunnel-through-iap": "bool",
                        "--worker": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "ssh": {
                      "commands": {},
                      "flags": {
                        "--batch-size": "value",
                        "--command": "value",
                        "--dry-run": "bool",
                        "--force-key-file-overwrite": "bool",
                        "--internal-ip": "bool",
                        "--node": "value",
                        "--output-directory": "value",
                        "--plain": "bool",
                        "--ssh-flag": "value",
                        "--ssh-key-expiration": "value",
                        "--ssh-key-expire-after": "value",
                        "--ssh-key-file": "value",
                        "--strict-host-key-checking": [
                          "ask",
                          "no",
                          "yes"
                        ],
                        "--tunnel-through-iap": "bool",
                        "--worker": "value",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "reimage": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--zone": "value"
                  }
                },
                "reservations": {
                  "commands": {
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "start": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--zone": "value"
                  }
                },
                "stop": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--zone": "value"
                  }
                },
                "topologies": {
                  "commands": {
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "tpu-vm": {
                  "commands": {
                    "accelerator-types": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--zone": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--sort-by": "value",
                            "--zone": "dynamic"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "attach-disk": {
                      "commands": {},
                      "flags": {
                        "--disk": "value",
                        "--mode": [
                          "read-only",
                          "read-write"
                        ],
                        "--zone": "value"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--accelerator-type": "value",
                        "--async": "bool",
                        "--autocheckpoint-enabled": "bool",
                        "--boot-disk": "value",
                        "--data-disk": "value",
                        "--description": "value",
                        "--internal-ips": "bool",
                        "--labels": "value",
                        "--metadata": "value",
                        "--metadata-from-file": "value",
                        "--network": "value",
                        "--preemptible": "bool",
                        "--queue-count": "value",
                        "--range": "value",
                        "--reserved": "bool",
                        "--scopes": "value",
                        "--service-account": "value",
                        "--shielded-secure-boot": "bool",
                        "--spot": "bool",
                        "--subnetwork": "value",
                        "--tags": "value",
                        "--topology": "value",
                        "--type": [
                          "v2",
                          "v3",
                          "v4",
                          "v5litepod",
                          "v5p",
                          "v6e"
                        ],
                        "--zone": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--zone": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--zone": "value"
                      }
                    },
                    "detach-disk": {
                      "commands": {},
                      "flags": {
                        "--disk": "value",
                        "--zone": "value"
                      }
                    },
                    "get-guest-attributes": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--query-path": "value",
                        "--sort-by": "value",
                        "--zone": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "perform-maintenance": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--zone": "value"
                      }
                    },
                    "scp": {
                      "commands": {},
                      "flags": {
                        "--batch-size": "value",
                        "--compress": "bool",
                        "--dry-run": "bool",
                        "--force-key-file-overwrite": "bool",
                        "--internal-ip": "bool",
                        "--plain": "bool",
                        "--recurse": "bool",
                        "--scp-flag": "value",
                        "--ssh-key-expiration": "value",
                        "--ssh-key-expire-after": "value",
                        "--ssh-key-file": "value",
                        "--strict-host-key-checking": [
                          "ask",
                          "no",
                          "yes"
                        ],
                        "--tunnel-through-iap": "bool",
                        "--worker": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "service-identity": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--zone": "dynamic"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "simulate-maintenance-event": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--workers": "value",
                        "--zone": "value"
                      }
                    },
                    "ssh": {
                      "commands": {},
                      "flags": {
                        "--batch-size": "value",
                        "--command": "value",
                        "--dry-run": "bool",
                        "--force-key-file-overwrite": "bool",
                        "--internal-ip": "bool",
                        "--output-directory": "value",
                        "--plain": "bool",
                        "--ssh-flag": "value",
                        "--ssh-key-expiration": "value",
                        "--ssh-key-expire-after": "value",
                        "--ssh-key-file": "value",
                        "--strict-host-key-checking": [
                          "ask",
                          "no",
                          "yes"
                        ],
                        "--tunnel-through-iap": "bool",
                        "--worker": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "start": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--zone": "value"
                      }
                    },
                    "stop": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--zone": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--add-tags": "value",
                        "--async": "bool",
                        "--attach-disk": "value",
                        "--clear-labels": "bool",
                        "--clear-metadata": "bool",
                        "--clear-tags": "bool",
                        "--description": "value",
                        "--detach-disk": "value",
                        "--internal-ips": "bool",
                        "--metadata-from-file": "value",
                        "--remove-labels": "value",
                        "--remove-metadata": "value",
                        "--remove-tags": "value",
                        "--update-labels": "value",
                        "--update-metadata": "value",
                        "--zone": "value"
                      }
                    },
                    "versions": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--zone": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--sort-by": "value",
                            "--zone": "dynamic"
                          }
                        }
                      },
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "versions": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--zone": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "url-maps": {
              "commands": {
                "add-host-rule": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--global": "bool",
                    "--hosts": "value",
                    "--path-matcher-name": "value",
                    "--region": "dynamic"
                  }
                },
                "add-path-matcher": {
                  "commands": {},
                  "flags": {
                    "--backend-bucket-path-rules": "value",
                    "--backend-service-path-rules": "value",
                    "--default-backend-bucket": "value",
                    "--default-service": "value",
                    "--delete-orphaned-path-matcher": "bool",
                    "--description": "value",
                    "--existing-host": "value",
                    "--global": "bool",
                    "--new-hosts": "value",
                    "--path-matcher-name": "value",
                    "--path-rules": "value",
                    "--region": "dynamic"
                  }
                },
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--global": "bool",
                        "--path": "value",
                        "--region": "dynamic",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--default-backend-bucket": "value",
                    "--default-service": "value",
                    "--description": "value",
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "edit": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--source": "value"
                  }
                },
                "invalidate-cdn-cache": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--global": "bool",
                    "--host": "value",
                    "--path": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-cdn-cache-invalidations": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--limit": "value"
                  }
                },
                "remove-host-rule": {
                  "commands": {},
                  "flags": {
                    "--delete-orphaned-path-matcher": "bool",
                    "--global": "bool",
                    "--host": "value",
                    "--region": "dynamic"
                  }
                },
                "remove-path-matcher": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--path-matcher-name": "value",
                    "--region": "dynamic"
                  }
                },
                "set-default-service": {
                  "commands": {},
                  "flags": {
                    "--default-backend-bucket": "value",
                    "--default-service": "value",
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "validate": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--load-balancing-scheme": [
                      "EXTERNAL",
                      "EXTERNAL_MANAGED"
                    ],
                    "--region": "value",
                    "--source": "value"
                  }
                }
              },
              "flags": {}
            },
            "vpn-gateways": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--region": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--gateway-ip-version": [
                      "IPV4",
                      "IPV6"
                    ],
                    "--interconnect-attachments": "value",
                    "--network": "dynamic",
                    "--region": "dynamic",
                    "--stack-type": [
                      "IPV4_IPV6",
                      "IPV4_ONLY",
                      "IPV6_ONLY"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "get-status": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "vpn-tunnels": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--region": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--ike-version": [
                      1,
                      2
                    ],
                    "--interface": [
                      0,
                      1
                    ],
                    "--local-traffic-selector": "value",
                    "--peer-address": "value",
                    "--peer-external-gateway": "dynamic",
                    "--peer-external-gateway-interface": [
                      0,
                      1,
                      2,
                      3
                    ],
                    "--peer-gcp-gateway": "dynamic",
                    "--peer-gcp-gateway-region": "dynamic",
                    "--region": "dynamic",
                    "--remote-traffic-selector": "value",
                    "--router": "dynamic",
                    "--router-region": "dynamic",
                    "--shared-secret": "value",
                    "--target-vpn-gateway": "dynamic",
                    "--target-vpn-gateway-region": "dynamic",
                    "--vpn-gateway": "dynamic",
                    "--vpn-gateway-region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "zones": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "config": {
          "commands": {
            "configurations": {
              "commands": {
                "activate": {
                  "commands": {},
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--activate": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--all": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--sort-by": "value"
                  }
                },
                "rename": {
                  "commands": {},
                  "flags": {
                    "--new-name": "value"
                  }
                }
              },
              "flags": {}
            },
            "get": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--filter": "value",
                "--limit": "value",
                "--sort-by": "value"
              }
            },
            "set": {
              "commands": {},
              "flags": {
                "--installation": "bool"
              }
            },
            "unset": {
              "commands": {},
              "flags": {
                "--installation": "bool"
              }
            }
          },
          "flags": {}
        },
        "container": {
          "commands": {
            "attached": {
              "commands": {
                "clusters": {
                  "commands": {
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--allow-missing": "bool",
                        "--async": "bool",
                        "--ignore-errors": "bool",
                        "--location": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "generate-install-manifest": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--output-file": "value",
                        "--platform-version": "value",
                        "--proxy-secret-name": "value",
                        "--proxy-secret-namespace": "value"
                      }
                    },
                    "get-credentials": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "import": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--context": "value",
                        "--distribution": "value",
                        "--fleet-membership": "value",
                        "--fleet-membership-location": "value",
                        "--kubeconfig": "value",
                        "--location": "value",
                        "--platform-version": "value",
                        "--proxy-secret-name": "value",
                        "--proxy-secret-namespace": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "register": {
                      "commands": {},
                      "flags": {
                        "--admin-groups": "value",
                        "--admin-users": "value",
                        "--annotations": "value",
                        "--binauthz-evaluation-mode": [
                          "DISABLED",
                          "PROJECT_SINGLETON_POLICY_ENFORCE"
                        ],
                        "--context": "value",
                        "--description": "value",
                        "--disable-cloud-monitoring": "bool",
                        "--distribution": "value",
                        "--enable-cloud-monitoring": "bool",
                        "--enable-managed-prometheus": "bool",
                        "--fleet-project": "value",
                        "--has-private-issuer": "bool",
                        "--issuer-url": "value",
                        "--kubeconfig": "value",
                        "--location": "value",
                        "--logging": "value",
                        "--platform-version": "value",
                        "--proxy-secret-name": "value",
                        "--proxy-secret-namespace": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--admin-groups": "value",
                        "--admin-users": "value",
                        "--annotations": "value",
                        "--async": "bool",
                        "--binauthz-evaluation-mode": [
                          "DISABLED",
                          "PROJECT_SINGLETON_POLICY_ENFORCE"
                        ],
                        "--clear-admin-groups": "bool",
                        "--clear-admin-users": "bool",
                        "--clear-description": "bool",
                        "--description": "value",
                        "--disable-cloud-monitoring": "bool",
                        "--disable-managed-prometheus": "bool",
                        "--enable-cloud-monitoring": "bool",
                        "--enable-managed-prometheus": "bool",
                        "--location": "value",
                        "--logging": "value",
                        "--platform-version": "value",
                        "--proxy-secret-name": "value",
                        "--proxy-secret-namespace": "value",
                        "--validate-only": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "get-server-config": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "wait": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "aws": {
              "commands": {
                "clusters": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--admin-groups": "value",
                        "--admin-users": "value",
                        "--annotations": "value",
                        "--async": "bool",
                        "--aws-region": "value",
                        "--binauthz-evaluation-mode": [
                          "DISABLED",
                          "PROJECT_SINGLETON_POLICY_ENFORCE"
                        ],
                        "--cluster-version": "value",
                        "--config-encryption-kms-key-arn": "value",
                        "--database-encryption-kms-key-arn": "value",
                        "--description": "value",
                        "--disable-per-node-pool-sg-rules": "bool",
                        "--enable-managed-prometheus": "bool",
                        "--fleet-project": "value",
                        "--iam-instance-profile": "value",
                        "--instance-placement": [
                          "dedicated",
                          "default",
                          "host"
                        ],
                        "--instance-type": "value",
                        "--location": "value",
                        "--logging": "value",
                        "--main-volume-iops": "value",
                        "--main-volume-kms-key-arn": "value",
                        "--main-volume-size": "value",
                        "--main-volume-throughput": "value",
                        "--main-volume-type": [
                          "gp2",
                          "gp3"
                        ],
                        "--pod-address-cidr-blocks": "value",
                        "--proxy-secret-arn": "value",
                        "--proxy-secret-version-id": "value",
                        "--role-arn": "value",
                        "--role-session-name": "value",
                        "--root-volume-iops": "value",
                        "--root-volume-kms-key-arn": "value",
                        "--root-volume-size": "value",
                        "--root-volume-throughput": "value",
                        "--root-volume-type": [
                          "gp2",
                          "gp3"
                        ],
                        "--security-group-ids": "value",
                        "--service-address-cidr-blocks": "value",
                        "--ssh-ec2-key-pair": "value",
                        "--subnet-ids": "value",
                        "--tags": "value",
                        "--validate-only": "bool",
                        "--vpc-id": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--allow-missing": "bool",
                        "--async": "bool",
                        "--ignore-errors": "bool",
                        "--location": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "get-credentials": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--private-endpoint": "bool"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--admin-groups": "value",
                        "--admin-users": "value",
                        "--annotations": "value",
                        "--async": "bool",
                        "--binauthz-evaluation-mode": [
                          "DISABLED",
                          "PROJECT_SINGLETON_POLICY_ENFORCE"
                        ],
                        "--clear-annotations": "bool",
                        "--clear-description": "bool",
                        "--clear-proxy-config": "bool",
                        "--clear-security-group-ids": "bool",
                        "--clear-ssh-ec2-key-pair": "bool",
                        "--clear-tags": "bool",
                        "--cluster-version": "value",
                        "--config-encryption-kms-key-arn": "value",
                        "--description": "value",
                        "--disable-managed-prometheus": "bool",
                        "--disable-per-node-pool-sg-rules": "bool",
                        "--enable-managed-prometheus": "bool",
                        "--enable-per-node-pool-sg-rules": "bool",
                        "--iam-instance-profile": "value",
                        "--instance-type": "value",
                        "--location": "value",
                        "--logging": "value",
                        "--proxy-secret-arn": "value",
                        "--proxy-secret-version-id": "value",
                        "--role-arn": "value",
                        "--role-session-name": "value",
                        "--root-volume-iops": "value",
                        "--root-volume-kms-key-arn": "value",
                        "--root-volume-size": "value",
                        "--root-volume-throughput": "value",
                        "--root-volume-type": [
                          "gp2",
                          "gp3"
                        ],
                        "--security-group-ids": "value",
                        "--ssh-ec2-key-pair": "value",
                        "--tags": "value",
                        "--validate-only": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "get-server-config": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "node-pools": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--annotations": "value",
                        "--async": "bool",
                        "--autoscaling-metrics": "value",
                        "--autoscaling-metrics-granularity": "value",
                        "--cluster": "value",
                        "--config-encryption-kms-key-arn": "value",
                        "--enable-autorepair": "bool",
                        "--iam-instance-profile": "value",
                        "--image-type": "value",
                        "--instance-placement": [
                          "dedicated",
                          "default",
                          "host"
                        ],
                        "--instance-type": "value",
                        "--kubelet-config-cpu-cfs-quota": "value",
                        "--kubelet-config-cpu-cfs-quota-period": "value",
                        "--kubelet-config-cpu-manager-policy": [
                          "none",
                          "static"
                        ],
                        "--kubelet-config-pod-pids-limit": "value",
                        "--location": "value",
                        "--max-nodes": "value",
                        "--max-pods-per-node": "value",
                        "--max-surge-update": "value",
                        "--max-unavailable-update": "value",
                        "--min-nodes": "value",
                        "--node-labels": "value",
                        "--node-taints": "value",
                        "--node-version": "value",
                        "--proxy-secret-arn": "value",
                        "--proxy-secret-version-id": "value",
                        "--root-volume-iops": "value",
                        "--root-volume-kms-key-arn": "value",
                        "--root-volume-size": "value",
                        "--root-volume-throughput": "value",
                        "--root-volume-type": [
                          "gp2",
                          "gp3"
                        ],
                        "--security-group-ids": "value",
                        "--spot-instance-types": "value",
                        "--ssh-ec2-key-pair": "value",
                        "--subnet-id": "value",
                        "--tags": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--allow-missing": "bool",
                        "--async": "bool",
                        "--cluster": "value",
                        "--ignore-errors": "bool",
                        "--location": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--cluster": "value",
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--cluster": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "rollback": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--cluster": "value",
                        "--location": "value",
                        "--respect-pdb": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--annotations": "value",
                        "--async": "bool",
                        "--autoscaling-metrics": "value",
                        "--autoscaling-metrics-granularity": "value",
                        "--clear-annotations": "bool",
                        "--clear-autoscaling-metrics": "bool",
                        "--clear-node-labels": "bool",
                        "--clear-proxy-config": "bool",
                        "--clear-security-group-ids": "bool",
                        "--clear-ssh-ec2-key-pair": "bool",
                        "--clear-tags": "bool",
                        "--cluster": "value",
                        "--config-encryption-kms-key-arn": "value",
                        "--enable-autorepair": "bool",
                        "--iam-instance-profile": "value",
                        "--instance-type": "value",
                        "--location": "value",
                        "--max-nodes": "value",
                        "--max-surge-update": "value",
                        "--max-unavailable-update": "value",
                        "--min-nodes": "value",
                        "--node-labels": "value",
                        "--node-version": "value",
                        "--proxy-secret-arn": "value",
                        "--proxy-secret-version-id": "value",
                        "--root-volume-iops": "value",
                        "--root-volume-kms-key-arn": "value",
                        "--root-volume-size": "value",
                        "--root-volume-throughput": "value",
                        "--root-volume-type": [
                          "gp2",
                          "gp3"
                        ],
                        "--security-group-ids": "value",
                        "--ssh-ec2-key-pair": "value",
                        "--tags": "value",
                        "--validate-only": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "operations": {
                  "commands": {
                    "cancel": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "wait": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "azure": {
              "commands": {
                "clients": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--application-id": "value",
                        "--async": "bool",
                        "--location": "value",
                        "--tenant-id": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--allow-missing": "bool",
                        "--async": "bool",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "get-public-cert": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--output-file": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "clusters": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--admin-groups": "value",
                        "--admin-users": "value",
                        "--annotations": "value",
                        "--async": "bool",
                        "--azure-application-id": "value",
                        "--azure-region": "value",
                        "--azure-tenant-id": "value",
                        "--client": "value",
                        "--cluster-version": "value",
                        "--config-encryption-key-id": "value",
                        "--config-encryption-public-key": "value",
                        "--database-encryption-key-id": "value",
                        "--description": "value",
                        "--enable-managed-prometheus": "bool",
                        "--endpoint-subnet-id": "value",
                        "--fleet-project": "value",
                        "--location": "value",
                        "--logging": "value",
                        "--main-volume-size": "value",
                        "--pod-address-cidr-blocks": "value",
                        "--proxy-resource-group-id": "value",
                        "--proxy-secret-id": "value",
                        "--replica-placements": "value",
                        "--resource-group-id": "value",
                        "--root-volume-size": "value",
                        "--service-address-cidr-blocks": "value",
                        "--service-load-balancer-subnet-id": "value",
                        "--ssh-public-key": "value",
                        "--subnet-id": "value",
                        "--tags": "value",
                        "--validate-only": "bool",
                        "--vm-size": "value",
                        "--vnet-id": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--allow-missing": "bool",
                        "--async": "bool",
                        "--ignore-errors": "bool",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "get-credentials": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--private-endpoint": "bool"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--admin-groups": "value",
                        "--admin-users": "value",
                        "--annotations": "value",
                        "--async": "bool",
                        "--azure-application-id": "value",
                        "--azure-tenant-id": "value",
                        "--clear-annotations": "bool",
                        "--clear-client": "bool",
                        "--clear-description": "bool",
                        "--client": "value",
                        "--cluster-version": "value",
                        "--description": "value",
                        "--disable-managed-prometheus": "bool",
                        "--enable-managed-prometheus": "bool",
                        "--location": "value",
                        "--logging": "value",
                        "--ssh-public-key": "value",
                        "--validate-only": "bool",
                        "--vm-size": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "get-server-config": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "node-pools": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--annotations": "value",
                        "--async": "bool",
                        "--azure-availability-zone": "value",
                        "--cluster": "value",
                        "--config-encryption-key-id": "value",
                        "--config-encryption-public-key": "value",
                        "--enable-autorepair": "bool",
                        "--image-type": "value",
                        "--location": "value",
                        "--max-nodes": "value",
                        "--max-pods-per-node": "value",
                        "--min-nodes": "value",
                        "--node-labels": "value",
                        "--node-taints": "value",
                        "--node-version": "value",
                        "--proxy-resource-group-id": "value",
                        "--proxy-secret-id": "value",
                        "--root-volume-size": "value",
                        "--ssh-public-key": "value",
                        "--subnet-id": "value",
                        "--tags": "value",
                        "--validate-only": "bool",
                        "--vm-size": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--allow-missing": "bool",
                        "--async": "bool",
                        "--cluster": "value",
                        "--ignore-errors": "bool",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--cluster": "value",
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--cluster": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--annotations": "value",
                        "--async": "bool",
                        "--clear-annotations": "bool",
                        "--cluster": "value",
                        "--enable-autorepair": "bool",
                        "--location": "value",
                        "--max-nodes": "value",
                        "--min-nodes": "value",
                        "--node-version": "value",
                        "--ssh-public-key": "value",
                        "--validate-only": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "operations": {
                  "commands": {
                    "cancel": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "wait": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "backup-restore": {
              "commands": {
                "backup-plans": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--all-namespaces": "bool",
                        "--async": "bool",
                        "--backup-delete-lock-days": "value",
                        "--backup-retain-days": "value",
                        "--cluster": "value",
                        "--cron-schedule": "value",
                        "--deactivated": "bool",
                        "--description": "value",
                        "--encryption-key": "value",
                        "--exclusion-windows-file": "value",
                        "--include-secrets": "bool",
                        "--include-volume-data": "bool",
                        "--labels": "value",
                        "--location": "value",
                        "--locked": "bool",
                        "--paused": "bool",
                        "--permissive-mode": "bool",
                        "--selected-applications": "value",
                        "--selected-namespaces": "value",
                        "--target-rpo-minutes": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--etag": "value",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--all-namespaces": "bool",
                        "--async": "bool",
                        "--backup-delete-lock-days": "value",
                        "--backup-retain-days": "value",
                        "--clear-labels": "bool",
                        "--cron-schedule": "value",
                        "--deactivated": "bool",
                        "--description": "value",
                        "--encryption-key": "value",
                        "--etag": "value",
                        "--exclusion-windows-file": "value",
                        "--include-secrets": "bool",
                        "--include-volume-data": "bool",
                        "--location": "value",
                        "--locked": "bool",
                        "--paused": "bool",
                        "--permissive-mode": "bool",
                        "--remove-labels": "value",
                        "--selected-applications": "value",
                        "--selected-namespaces": "value",
                        "--target-rpo-minutes": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "backups": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--backup-plan": "value",
                        "--delete-lock-days": "value",
                        "--description": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--retain-days": "value",
                        "--wait-for-completion": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--backup-plan": "value",
                        "--etag": "value",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--backup-plan": "value",
                        "--location": "value"
                      }
                    },
                    "get-backup-index-download-url": {
                      "commands": {},
                      "flags": {
                        "--backup-plan": "value",
                        "--location": "value"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--backup-plan": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--backup-plan": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--backup-plan": "value",
                        "--location": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--backup-plan": "value",
                        "--clear-labels": "bool",
                        "--delete-lock-days": "value",
                        "--description": "value",
                        "--etag": "value",
                        "--location": "value",
                        "--remove-labels": "value",
                        "--retain-days": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "locations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "operations": {
                  "commands": {
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "restore-plans": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--all-namespaces": "bool",
                        "--async": "bool",
                        "--backup-plan": "value",
                        "--cluster": "value",
                        "--cluster-resource-conflict-policy": [
                          "use-backup-version",
                          "use-existing-version"
                        ],
                        "--cluster-resource-scope-all-group-kinds": "bool",
                        "--cluster-resource-scope-excluded-group-kinds": "value",
                        "--cluster-resource-scope-no-group-kinds": "bool",
                        "--cluster-resource-scope-selected-group-kinds": "value",
                        "--description": "value",
                        "--excluded-namespaces": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--namespaced-resource-restore-mode": [
                          "delete-and-restore",
                          "fail-on-conflict",
                          "merge-replace-on-conflict",
                          "merge-replace-volume-on-conflict",
                          "merge-skip-on-conflict"
                        ],
                        "--no-namespaces": "bool",
                        "--restore-order-file": "value",
                        "--selected-applications": "value",
                        "--selected-namespaces": "value",
                        "--substitution-rules-file": "value",
                        "--transformation-rules-file": "value",
                        "--volume-data-restore-policy": [
                          "no-volume-data-restoration",
                          "restore-volume-data-from-backup",
                          "reuse-volume-handle-from-backup"
                        ],
                        "--volume-data-restore-policy-bindings": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--etag": "value",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--all-namespaces": "bool",
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--cluster-resource-conflict-policy": [
                          "use-backup-version",
                          "use-existing-version"
                        ],
                        "--cluster-resource-scope-all-group-kinds": "bool",
                        "--cluster-resource-scope-excluded-group-kinds": "value",
                        "--cluster-resource-scope-no-group-kinds": "bool",
                        "--cluster-resource-scope-selected-group-kinds": "value",
                        "--description": "value",
                        "--etag": "value",
                        "--excluded-namespaces": "value",
                        "--location": "value",
                        "--namespaced-resource-restore-mode": [
                          "delete-and-restore",
                          "fail-on-conflict",
                          "merge-replace-on-conflict",
                          "merge-replace-volume-on-conflict",
                          "merge-skip-on-conflict"
                        ],
                        "--no-namespaces": "bool",
                        "--remove-labels": "value",
                        "--restore-order-file": "value",
                        "--selected-applications": "value",
                        "--selected-namespaces": "value",
                        "--substitution-rules-file": "value",
                        "--transformation-rules-file": "value",
                        "--update-labels": "value",
                        "--volume-data-restore-policy": [
                          "no-volume-data-restoration",
                          "restore-volume-data-from-backup",
                          "reuse-volume-handle-from-backup"
                        ],
                        "--volume-data-restore-policy-bindings": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "restores": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--backup": "value",
                        "--description": "value",
                        "--filter-file": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--restore-plan": "value",
                        "--volume-data-restore-policy-overrides-file": "value",
                        "--wait-for-completion": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--etag": "value",
                        "--location": "value",
                        "--restore-plan": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--restore-plan": "value"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--restore-plan": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--restore-plan": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--restore-plan": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--description": "value",
                        "--etag": "value",
                        "--location": "value",
                        "--remove-labels": "value",
                        "--restore-plan": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "volume-backups": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--backup": "value",
                        "--backup-plan": "value",
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--backup": "value",
                        "--backup-plan": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "volume-restores": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--restore": "value",
                        "--restore-plan": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--restore": "value",
                        "--restore-plan": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "bare-metal": {
              "commands": {
                "admin-clusters": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--admin-users": "value",
                        "--annotations": "value",
                        "--api-server-args": "value",
                        "--async": "bool",
                        "--binauthz-evaluation-mode": [
                          "DISABLED",
                          "PROJECT_SINGLETON_POLICY_ENFORCE"
                        ],
                        "--control-plane-load-balancer-port": "value",
                        "--control-plane-node-configs": "value",
                        "--control-plane-node-labels": "value",
                        "--control-plane-node-taints": "value",
                        "--control-plane-vip": "value",
                        "--description": "value",
                        "--enable-application-logs": "bool",
                        "--enable-manual-lb": "bool",
                        "--island-mode-pod-address-cidr-blocks": "value",
                        "--island-mode-service-address-cidr-blocks": "value",
                        "--location": "value",
                        "--login-user": "value",
                        "--lvp-node-mounts-config-path": "value",
                        "--lvp-node-mounts-config-storage-class": "value",
                        "--lvp-share-path": "value",
                        "--lvp-share-storage-class": "value",
                        "--maintenance-address-cidr-blocks": "value",
                        "--max-pods-per-node": "value",
                        "--no-proxy": "value",
                        "--shared-path-pv-count": "value",
                        "--uri": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "enroll": {
                      "commands": {},
                      "flags": {
                        "--admin-cluster-membership": "value",
                        "--admin-cluster-membership-location": "value",
                        "--async": "bool",
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "query-version-config": {
                      "commands": {},
                      "flags": {
                        "--admin-cluster": "value",
                        "--location": "value"
                      }
                    },
                    "unenroll": {
                      "commands": {},
                      "flags": {
                        "--allow-missing": "bool",
                        "--async": "bool",
                        "--ignore-errors": "bool",
                        "--location": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--api-server-args": "value",
                        "--async": "bool",
                        "--binauthz-evaluation-mode": [
                          "DISABLED",
                          "PROJECT_SINGLETON_POLICY_ENFORCE"
                        ],
                        "--control-plane-node-configs": "value",
                        "--control-plane-node-labels": "value",
                        "--control-plane-node-taints": "value",
                        "--description": "value",
                        "--enable-application-logs": "bool",
                        "--island-mode-service-address-cidr-blocks": "value",
                        "--location": "value",
                        "--login-user": "value",
                        "--maintenance-address-cidr-blocks": "value",
                        "--max-pods-per-node": "value",
                        "--no-proxy": "value",
                        "--uri": "value",
                        "--validate-only": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "clusters": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--admin-cluster-membership": "value",
                        "--admin-cluster-membership-location": "value",
                        "--admin-cluster-membership-project": "value",
                        "--admin-users": "value",
                        "--annotations": "value",
                        "--api-server-args": "value",
                        "--async": "bool",
                        "--bgp-address-pools": "value",
                        "--bgp-asn": "value",
                        "--bgp-load-balancer-node-configs": "value",
                        "--bgp-load-balancer-node-labels": "value",
                        "--bgp-load-balancer-node-taints": "value",
                        "--bgp-load-balancer-registry-burst": "value",
                        "--bgp-load-balancer-registry-pull-qps": "value",
                        "--bgp-peer-configs": "value",
                        "--binauthz-evaluation-mode": [
                          "DISABLED",
                          "PROJECT_SINGLETON_POLICY_ENFORCE"
                        ],
                        "--container-runtime": "value",
                        "--control-plane-load-balancer-port": "value",
                        "--control-plane-node-configs": "value",
                        "--control-plane-node-labels": "value",
                        "--control-plane-node-taints": "value",
                        "--control-plane-registry-burst": "value",
                        "--control-plane-registry-pull-qps": "value",
                        "--control-plane-vip": "value",
                        "--description": "value",
                        "--disable-bgp-load-balancer-serialize-image-pulls": "bool",
                        "--disable-control-plane-serialize-image-pulls": "bool",
                        "--disable-metal-lb-load-balancer-serialize-image-pulls": "bool",
                        "--enable-advanced-networking": "bool",
                        "--enable-application-logs": "bool",
                        "--enable-manual-lb": "bool",
                        "--enable-multi-nic-config": "bool",
                        "--enable-sr-iov-config": "bool",
                        "--ingress-vip": "value",
                        "--island-mode-pod-address-cidr-blocks": "value",
                        "--island-mode-service-address-cidr-blocks": "value",
                        "--location": "value",
                        "--login-user": "value",
                        "--lvp-node-mounts-config-path": "value",
                        "--lvp-node-mounts-config-storage-class": "value",
                        "--lvp-share-path": "value",
                        "--lvp-share-storage-class": "value",
                        "--maintenance-address-cidr-blocks": "value",
                        "--max-pods-per-node": "value",
                        "--metal-lb-address-pools": "value",
                        "--metal-lb-load-balancer-node-configs": "value",
                        "--metal-lb-load-balancer-node-labels": "value",
                        "--metal-lb-load-balancer-node-taints": "value",
                        "--metal-lb-load-balancer-registry-burst": "value",
                        "--metal-lb-load-balancer-registry-pull-qps": "value",
                        "--no-proxy": "value",
                        "--shared-path-pv-count": "value",
                        "--upgrade-control-plane": "value",
                        "--uri": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--allow-missing": "bool",
                        "--async": "bool",
                        "--force": "bool",
                        "--ignore-errors": "bool",
                        "--location": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "enroll": {
                      "commands": {},
                      "flags": {
                        "--admin-cluster-membership": "value",
                        "--admin-cluster-membership-location": "value",
                        "--admin-cluster-membership-project": "value",
                        "--async": "bool",
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "query-version-config": {
                      "commands": {},
                      "flags": {
                        "--admin-cluster-membership": "value",
                        "--admin-cluster-membership-location": "value",
                        "--admin-cluster-membership-project": "value",
                        "--cluster": "value",
                        "--location": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--add-annotations": "value",
                        "--admin-users": "value",
                        "--allow-missing": "bool",
                        "--api-server-args": "value",
                        "--async": "bool",
                        "--bgp-address-pools": "value",
                        "--bgp-asn": "value",
                        "--bgp-load-balancer-node-configs": "value",
                        "--bgp-load-balancer-node-labels": "value",
                        "--bgp-load-balancer-node-taints": "value",
                        "--bgp-load-balancer-registry-burst": "value",
                        "--bgp-load-balancer-registry-pull-qps": "value",
                        "--bgp-peer-configs": "value",
                        "--binauthz-evaluation-mode": [
                          "DISABLED",
                          "PROJECT_SINGLETON_POLICY_ENFORCE"
                        ],
                        "--control-plane-node-configs": "value",
                        "--control-plane-node-labels": "value",
                        "--control-plane-node-taints": "value",
                        "--control-plane-registry-burst": "value",
                        "--control-plane-registry-pull-qps": "value",
                        "--description": "value",
                        "--disable-bgp-load-balancer-serialize-image-pulls": "bool",
                        "--disable-control-plane-serialize-image-pulls": "bool",
                        "--disable-metal-lb-load-balancer-serialize-image-pulls": "bool",
                        "--disable-sr-iov-config": "bool",
                        "--enable-application-logs": "bool",
                        "--enable-bgp-load-balancer-serialize-image-pulls": "bool",
                        "--enable-control-plane-serialize-image-pulls": "bool",
                        "--enable-metal-lb-load-balancer-serialize-image-pulls": "bool",
                        "--enable-sr-iov-config": "bool",
                        "--island-mode-service-address-cidr-blocks": "value",
                        "--location": "value",
                        "--login-user": "value",
                        "--maintenance-address-cidr-blocks": "value",
                        "--metal-lb-address-pools": "value",
                        "--metal-lb-load-balancer-node-configs": "value",
                        "--metal-lb-load-balancer-node-labels": "value",
                        "--metal-lb-load-balancer-node-taints": "value",
                        "--metal-lb-load-balancer-registry-burst": "value",
                        "--metal-lb-load-balancer-registry-pull-qps": "value",
                        "--remove-annotations": "value",
                        "--upgrade-control-plane": "value",
                        "--validate-only": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "node-pools": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--annotations": "value",
                        "--async": "bool",
                        "--cluster": "value",
                        "--disable-serialize-image-pulls": "bool",
                        "--display-name": "value",
                        "--location": "value",
                        "--node-configs": "value",
                        "--node-labels": "value",
                        "--node-taints": "value",
                        "--registry-burst": "value",
                        "--registry-pull-qps": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--allow-missing": "bool",
                        "--async": "bool",
                        "--cluster": "value",
                        "--ignore-errors": "bool",
                        "--location": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--cluster": "value",
                        "--location": "value"
                      }
                    },
                    "enroll": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--cluster": "value",
                        "--location": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--cluster": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--allow-missing": "bool",
                        "--async": "bool",
                        "--cluster": "value",
                        "--disable-serialize-image-pulls": "bool",
                        "--display-name": "value",
                        "--enable-serialize-image-pulls": "bool",
                        "--location": "value",
                        "--node-configs": "value",
                        "--node-labels": "value",
                        "--node-taints": "value",
                        "--registry-burst": "value",
                        "--registry-pull-qps": "value",
                        "--validate-only": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "wait": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--timeout": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "standalone-clusters": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "enroll": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--membership": "value",
                        "--membership-location": "value",
                        "--membership-project": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "query-version-config": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--standalone-cluster": "value"
                      }
                    },
                    "unenroll": {
                      "commands": {},
                      "flags": {
                        "--allow-missing": "bool",
                        "--async": "bool",
                        "--ignore-errors": "bool",
                        "--location": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--add-annotations": "value",
                        "--admin-users": "value",
                        "--allow-missing": "bool",
                        "--api-server-args": "value",
                        "--async": "bool",
                        "--bgp-lb-address-pools": "value",
                        "--bgp-lb-asn": "value",
                        "--bgp-lb-load-balancer-node-configs": "value",
                        "--bgp-lb-load-balancer-node-labels": "value",
                        "--bgp-lb-load-balancer-node-taints": "value",
                        "--bgp-lb-peer-configs": "value",
                        "--binauthz-evaluation-mode": [
                          "DISABLED",
                          "PROJECT_SINGLETON_POLICY_ENFORCE"
                        ],
                        "--control-plane-node-configs": "value",
                        "--control-plane-node-labels": "value",
                        "--control-plane-node-taints": "value",
                        "--description": "value",
                        "--disable-sr-iov-config": "bool",
                        "--enable-application-logs": "bool",
                        "--enable-sr-iov-config": "bool",
                        "--island-mode-service-address-cidr-blocks": "value",
                        "--location": "value",
                        "--login-user": "value",
                        "--maintenance-address-cidr-blocks": "value",
                        "--metal-lb-address-pools": "value",
                        "--metal-lb-load-balancer-node-configs": "value",
                        "--metal-lb-load-balancer-node-labels": "value",
                        "--metal-lb-load-balancer-node-taints": "value",
                        "--remove-annotations": "value",
                        "--validate-only": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "binauthz": {
              "commands": {
                "attestations": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--artifact-url": "value",
                        "--attestor": "value",
                        "--attestor-project": "value",
                        "--note": "value",
                        "--note-project": "value",
                        "--payload-file": "value",
                        "--public-key-id": "value",
                        "--signature-file": "value",
                        "--validate": "bool"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--artifact-url": "value",
                        "--attestor": "value",
                        "--attestor-project": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "sign-and-create": {
                      "commands": {},
                      "flags": {
                        "--artifact-url": "value",
                        "--attestor": "value",
                        "--attestor-project": "value",
                        "--dsse-type": "value",
                        "--keyversion": "value",
                        "--keyversion-key": "value",
                        "--keyversion-keyring": "value",
                        "--keyversion-location": "value",
                        "--keyversion-project": "value",
                        "--note": "value",
                        "--note-project": "value",
                        "--pae-encode-payload": "bool",
                        "--public-key-id-override": "value",
                        "--validate": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "attestors": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--member": "value",
                        "--role": "dynamic"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--attestation-authority-note": "value",
                        "--attestation-authority-note-project": "value",
                        "--description": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {}
                    },
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "public-keys": {
                      "commands": {
                        "add": {
                          "commands": {},
                          "flags": {
                            "--attestor": "value",
                            "--comment": "value",
                            "--keyversion": "value",
                            "--keyversion-key": "value",
                            "--keyversion-keyring": "value",
                            "--keyversion-location": "value",
                            "--keyversion-project": "value",
                            "--pgp-public-key-file": "value",
                            "--pkix-public-key-algorithm": [
                              "ec-sign-p256-sha256",
                              "ec-sign-p384-sha384",
                              "ec-sign-p521-sha512",
                              "ecdsa-p256-sha256",
                              "ecdsa-p384-sha384",
                              "ecdsa-p521-sha512",
                              "rsa-pss-2048-sha256",
                              "rsa-pss-3072-sha256",
                              "rsa-pss-4096-sha256",
                              "rsa-pss-4096-sha512",
                              "rsa-sign-pkcs1-2048-sha256",
                              "rsa-sign-pkcs1-3072-sha256",
                              "rsa-sign-pkcs1-4096-sha256",
                              "rsa-sign-pkcs1-4096-sha512",
                              "rsa-sign-pss-2048-sha256",
                              "rsa-sign-pss-3072-sha256",
                              "rsa-sign-pss-4096-sha256",
                              "rsa-sign-pss-4096-sha512"
                            ],
                            "--pkix-public-key-file": "value",
                            "--public-key-id-override": "value"
                          }
                        },
                        "remove": {
                          "commands": {},
                          "flags": {
                            "--attestor": "value"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--attestor": "value",
                            "--comment": "value",
                            "--pgp-public-key-file": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--member": "value",
                        "--role": "dynamic"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {}
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--description": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "continuous-validation": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {}
                    },
                    "enable": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "create-signature-payload": {
                  "commands": {},
                  "flags": {
                    "--artifact-url": "value"
                  }
                },
                "policy": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--member": "value",
                        "--role": "dynamic"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--platform": "value",
                        "--policy-file": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--platform": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--platform": "value"
                      }
                    },
                    "evaluate": {
                      "commands": {},
                      "flags": {
                        "--image": "value",
                        "--platform": "value",
                        "--resource": "value"
                      }
                    },
                    "export": {
                      "commands": {},
                      "flags": {}
                    },
                    "export-system-policy": {
                      "commands": {},
                      "flags": {
                        "--location": [
                          "africa-south1",
                          "asia-east1",
                          "asia-east2",
                          "asia-northeast1",
                          "asia-northeast2",
                          "asia-northeast3",
                          "asia-south1",
                          "asia-south2",
                          "asia-southeast1",
                          "asia-southeast2",
                          "australia-southeast1",
                          "australia-southeast2",
                          "europe-central2",
                          "europe-north1",
                          "europe-southwest1",
                          "europe-west1",
                          "europe-west10",
                          "europe-west12",
                          "europe-west2",
                          "europe-west3",
                          "europe-west4",
                          "europe-west6",
                          "europe-west8",
                          "europe-west9",
                          "global",
                          "me-central1",
                          "me-central2",
                          "me-west1",
                          "northamerica-northeast1",
                          "northamerica-northeast2",
                          "southamerica-east1",
                          "southamerica-west1",
                          "us-central1",
                          "us-central2",
                          "us-east1",
                          "us-east4",
                          "us-east5",
                          "us-east7",
                          "us-south1",
                          "us-west1",
                          "us-west2",
                          "us-west3",
                          "us-west4",
                          "us-west8"
                        ]
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "import": {
                      "commands": {},
                      "flags": {
                        "--strict-validation": "bool"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--member": "value",
                        "--role": "dynamic"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {}
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--platform": "value",
                        "--policy-file": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "clusters": {
              "commands": {
                "check-autopilot-compatibility": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "value"
                  }
                },
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--location": "value",
                        "--path": "value",
                        "--region": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ],
                        "--zone": "value"
                      }
                    }
                  },
                  "flags": {
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--additional-zones": "value",
                    "--additive-vpc-scope-dns-domain": "value",
                    "--addons": "value",
                    "--aggregation-ca": "value",
                    "--allow-route-overlap": "bool",
                    "--async": "bool",
                    "--auto-monitoring-scope": [
                      "ALL",
                      "NONE"
                    ],
                    "--autoprovisioning-config-file": "value",
                    "--autoprovisioning-enable-insecure-kubelet-readonly-port": "bool",
                    "--autoprovisioning-image-type": "value",
                    "--autoprovisioning-locations": "value",
                    "--autoprovisioning-max-surge-upgrade": "value",
                    "--autoprovisioning-max-unavailable-upgrade": "value",
                    "--autoprovisioning-min-cpu-platform": "value",
                    "--autoprovisioning-network-tags": "value",
                    "--autoprovisioning-node-pool-soak-duration": "value",
                    "--autoprovisioning-resource-manager-tags": "value",
                    "--autoprovisioning-scopes": "value",
                    "--autoprovisioning-service-account": "value",
                    "--autoprovisioning-standard-rollout-policy": "value",
                    "--autoscaling-profile": "value",
                    "--binauthz-evaluation-mode": [
                      "disabled",
                      "policy-bindings",
                      "policy-bindings-and-project-singleton-policy-enforce",
                      "project-singleton-policy-enforce"
                    ],
                    "--binauthz-policy-bindings": "value",
                    "--boot-disk-kms-key": "value",
                    "--cloud-run-config": "value",
                    "--cluster-ca": "value",
                    "--cluster-dns": [
                      "clouddns",
                      "default",
                      "kubedns"
                    ],
                    "--cluster-dns-domain": "value",
                    "--cluster-dns-scope": [
                      "cluster",
                      "vpc"
                    ],
                    "--cluster-ipv4-cidr": "value",
                    "--cluster-secondary-range-name": "value",
                    "--cluster-version": "value",
                    "--containerd-config-from-file": "value",
                    "--control-plane-disk-encryption-key": "value",
                    "--create-subnetwork": "value",
                    "--database-encryption-key": "value",
                    "--dataplane-v2-observability-mode": [
                      "DISABLED",
                      "EXTERNAL_LB",
                      "INTERNAL_VPC_LB"
                    ],
                    "--default-max-pods-per-node": "value",
                    "--disable-additive-vpc-scope": "bool",
                    "--disable-dataplane-v2-flow-observability": "bool",
                    "--disable-dataplane-v2-metrics": "bool",
                    "--disable-default-snat": "bool",
                    "--disable-l4-lb-firewall-reconciliation": "bool",
                    "--disable-pod-cidr-overprovision": "bool",
                    "--disk-size": "value",
                    "--disk-type": [
                      "hyperdisk-balanced",
                      "hyperdisk-extreme",
                      "hyperdisk-throughput",
                      "pd-balanced",
                      "pd-ssd",
                      "pd-standard"
                    ],
                    "--enable-authorized-networks-on-private-endpoint": "bool",
                    "--enable-autoprovisioning": "bool",
                    "--enable-autoprovisioning-autorepair": "bool",
                    "--enable-autoprovisioning-autoupgrade": "bool",
                    "--enable-autoprovisioning-blue-green-upgrade": "bool",
                    "--enable-autoprovisioning-surge-upgrade": "bool",
                    "--enable-autorepair": "bool",
                    "--enable-autoscaling": "bool",
                    "--enable-autoupgrade": "bool",
                    "--enable-basic-auth": "bool",
                    "--enable-binauthz": "bool",
                    "--enable-cilium-clusterwide-network-policy": "bool",
                    "--enable-cloud-logging": "bool",
                    "--enable-cloud-monitoring": "bool",
                    "--enable-cloud-run-alpha": "bool",
                    "--enable-confidential-nodes": "bool",
                    "--enable-confidential-storage": "bool",
                    "--enable-cost-allocation": "bool",
                    "--enable-dataplane-v2": "bool",
                    "--enable-dataplane-v2-flow-observability": "bool",
                    "--enable-dataplane-v2-metrics": "bool",
                    "--enable-dns-access": "bool",
                    "--enable-fleet": "bool",
                    "--enable-fqdn-network-policy": "bool",
                    "--enable-gke-oidc": "bool",
                    "--enable-google-cloud-access": "bool",
                    "--enable-gvnic": "bool",
                    "--enable-identity-service": "bool",
                    "--enable-image-streaming": "bool",
                    "--enable-insecure-binding-system-authenticated": "bool",
                    "--enable-insecure-binding-system-unauthenticated": "bool",
                    "--enable-insecure-kubelet-readonly-port": "bool",
                    "--enable-intra-node-visibility": "bool",
                    "--enable-ip-access": "bool",
                    "--enable-ip-alias": "bool",
                    "--enable-kubernetes-alpha": "bool",
                    "--enable-kubernetes-unstable-apis": "value",
                    "--enable-l4-ilb-subsetting": "bool",
                    "--enable-legacy-authorization": "bool",
                    "--enable-logging-monitoring-system-only": "bool",
                    "--enable-managed-prometheus": "bool",
                    "--enable-master-authorized-networks": "bool",
                    "--enable-master-global-access": "bool",
                    "--enable-multi-networking": "bool",
                    "--enable-nested-virtualization": "bool",
                    "--enable-network-egress-metering": "bool",
                    "--enable-network-policy": "bool",
                    "--enable-pod-security-policy": "bool",
                    "--enable-private-endpoint": "bool",
                    "--enable-private-nodes": "bool",
                    "--enable-ray-cluster-logging": "bool",
                    "--enable-ray-cluster-monitoring": "bool",
                    "--enable-resource-consumption-metering": "bool",
                    "--enable-secret-manager": "bool",
                    "--enable-service-externalips": "bool",
                    "--enable-shielded-nodes": "bool",
                    "--enable-stackdriver-kubernetes": "bool",
                    "--enable-tpu": "bool",
                    "--enable-tpu-service-networking": "bool",
                    "--enable-vertical-pod-autoscaling": "bool",
                    "--ephemeral-storage": "value",
                    "--ephemeral-storage-local-ssd": "value",
                    "--etcd-api-ca": "value",
                    "--etcd-peer-ca": "value",
                    "--fleet-project": "value",
                    "--gateway-api": [
                      "disabled",
                      "standard"
                    ],
                    "--gkeops-etcd-backup-encryption-key": "value",
                    "--hpa-profile": [
                      "none",
                      "performance"
                    ],
                    "--identity-provider": "value",
                    "--image-type": "value",
                    "--in-transit-encryption": [
                      "inter-node-transparent",
                      "none"
                    ],
                    "--ipv6-access-type": [
                      "external",
                      "internal"
                    ],
                    "--issue-client-certificate": "bool",
                    "--istio-config": "value",
                    "--labels": "value",
                    "--linux-sysctls": "value",
                    "--local-nvme-ssd-block": "value",
                    "--local-ssd-count": "value",
                    "--local-ssd-encryption-mode": [
                      "EPHEMERAL_KEY_ENCRYPTION",
                      "STANDARD_ENCRYPTION"
                    ],
                    "--local-ssd-volumes": "value",
                    "--location": "value",
                    "--location-policy": [
                      "ANY",
                      "BALANCED"
                    ],
                    "--logging": "value",
                    "--logging-variant": [
                      "DEFAULT",
                      "MAX_THROUGHPUT"
                    ],
                    "--machine-type": "value",
                    "--maintenance-window": "value",
                    "--maintenance-window-end": "value",
                    "--maintenance-window-recurrence": "value",
                    "--maintenance-window-start": "value",
                    "--master-authorized-networks": "value",
                    "--master-ipv4-cidr": "value",
                    "--max-accelerator": "value",
                    "--max-cpu": "value",
                    "--max-memory": "value",
                    "--max-nodes": "value",
                    "--max-nodes-per-pool": "value",
                    "--max-pods-per-node": "value",
                    "--max-surge-upgrade": "value",
                    "--max-unavailable-upgrade": "value",
                    "--metadata": "value",
                    "--metadata-from-file": "value",
                    "--min-accelerator": "value",
                    "--min-cpu": "value",
                    "--min-cpu-platform": "value",
                    "--min-memory": "value",
                    "--min-nodes": "value",
                    "--monitoring": "value",
                    "--network": "value",
                    "--network-performance-configs": "value",
                    "--node-labels": "value",
                    "--node-locations": "value",
                    "--node-pool-name": "value",
                    "--node-taints": "value",
                    "--node-version": "value",
                    "--notification-config": "value",
                    "--num-nodes": "value",
                    "--password": "value",
                    "--placement-policy": "value",
                    "--placement-type": [
                      "COMPACT",
                      "UNSPECIFIED"
                    ],
                    "--preemptible": "bool",
                    "--private-cluster": "bool",
                    "--private-endpoint-subnetwork": "value",
                    "--private-ipv6-google-access-type": [
                      "bidirectional",
                      "disabled",
                      "outbound-only"
                    ],
                    "--region": "value",
                    "--release-channel": "value",
                    "--reservation": "value",
                    "--reservation-affinity": [
                      "any",
                      "none",
                      "specific"
                    ],
                    "--resource-manager-tags": "value",
                    "--resource-usage-bigquery-dataset": "value",
                    "--scopes": "value",
                    "--security-group": "value",
                    "--security-posture": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ],
                    "--security-profile": "value",
                    "--security-profile-runtime-rules": "bool",
                    "--service-account": "value",
                    "--service-account-signing-keys": "value",
                    "--service-account-verification-keys": "value",
                    "--services-ipv4-cidr": "value",
                    "--services-secondary-range-name": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-secure-boot": "bool",
                    "--spot": "bool",
                    "--stack-type": [
                      "ipv4",
                      "ipv4-ipv6"
                    ],
                    "--storage-pools": "value",
                    "--subnetwork": "value",
                    "--system-config-from-file": "value",
                    "--tags": "value",
                    "--threads-per-core": "value",
                    "--tier": [
                      "enterprise",
                      "standard"
                    ],
                    "--total-max-nodes": "value",
                    "--total-min-nodes": "value",
                    "--tpu-ipv4-cidr": "value",
                    "--username": "value",
                    "--workload-metadata": [
                      "EXPOSED",
                      "GCE_METADATA",
                      "GKE_METADATA",
                      "GKE_METADATA_SERVER",
                      "SECURE"
                    ],
                    "--workload-pool": "value",
                    "--workload-vulnerability-scanning": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ],
                    "--zone": "value"
                  }
                },
                "create-auto": {
                  "commands": {},
                  "flags": {
                    "--additive-vpc-scope-dns-domain": "value",
                    "--aggregation-ca": "value",
                    "--async": "bool",
                    "--auto-monitoring-scope": [
                      "ALL",
                      "NONE"
                    ],
                    "--autoprovisioning-enable-insecure-kubelet-readonly-port": "bool",
                    "--autoprovisioning-network-tags": "value",
                    "--autoprovisioning-resource-manager-tags": "value",
                    "--binauthz-evaluation-mode": [
                      "disabled",
                      "policy-bindings",
                      "policy-bindings-and-project-singleton-policy-enforce",
                      "project-singleton-policy-enforce"
                    ],
                    "--binauthz-policy-bindings": "value",
                    "--boot-disk-kms-key": "value",
                    "--cluster-ca": "value",
                    "--cluster-ipv4-cidr": "value",
                    "--cluster-secondary-range-name": "value",
                    "--cluster-version": "value",
                    "--containerd-config-from-file": "value",
                    "--control-plane-disk-encryption-key": "value",
                    "--create-subnetwork": "value",
                    "--database-encryption-key": "value",
                    "--dataplane-v2-observability-mode": [
                      "DISABLED",
                      "EXTERNAL_LB",
                      "INTERNAL_VPC_LB"
                    ],
                    "--disable-additive-vpc-scope": "bool",
                    "--disable-dataplane-v2-flow-observability": "bool",
                    "--disable-l4-lb-firewall-reconciliation": "bool",
                    "--enable-authorized-networks-on-private-endpoint": "bool",
                    "--enable-backup-restore": "bool",
                    "--enable-cilium-clusterwide-network-policy": "bool",
                    "--enable-dataplane-v2-flow-observability": "bool",
                    "--enable-dns-access": "bool",
                    "--enable-fleet": "bool",
                    "--enable-google-cloud-access": "bool",
                    "--enable-insecure-binding-system-authenticated": "bool",
                    "--enable-insecure-binding-system-unauthenticated": "bool",
                    "--enable-ip-access": "bool",
                    "--enable-kubernetes-unstable-apis": "value",
                    "--enable-master-authorized-networks": "bool",
                    "--enable-master-global-access": "bool",
                    "--enable-multi-networking": "bool",
                    "--enable-private-endpoint": "bool",
                    "--enable-private-nodes": "bool",
                    "--enable-ray-cluster-logging": "bool",
                    "--enable-ray-cluster-monitoring": "bool",
                    "--enable-ray-operator": "bool",
                    "--enable-secret-manager": "bool",
                    "--etcd-api-ca": "value",
                    "--etcd-peer-ca": "value",
                    "--fleet-project": "value",
                    "--gkeops-etcd-backup-encryption-key": "value",
                    "--hpa-profile": [
                      "none",
                      "performance"
                    ],
                    "--labels": "value",
                    "--location": "value",
                    "--logging": "value",
                    "--master-authorized-networks": "value",
                    "--master-ipv4-cidr": "value",
                    "--monitoring": "value",
                    "--network": "value",
                    "--private-endpoint-subnetwork": "value",
                    "--region": "value",
                    "--release-channel": "value",
                    "--scopes": "value",
                    "--security-group": "value",
                    "--security-posture": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ],
                    "--service-account": "value",
                    "--service-account-signing-keys": "value",
                    "--service-account-verification-keys": "value",
                    "--services-ipv4-cidr": "value",
                    "--services-secondary-range-name": "value",
                    "--subnetwork": "value",
                    "--tier": [
                      "enterprise",
                      "standard"
                    ],
                    "--workload-policies": "value",
                    "--workload-vulnerability-scanning": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ],
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "get-credentials": {
                  "commands": {},
                  "flags": {
                    "--dns-endpoint": "bool",
                    "--internal-ip": "bool",
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "get-upgrade-info": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "value"
                  }
                },
                "resize": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--node-pool": "value",
                    "--num-nodes": "value",
                    "--region": "value",
                    "--size": "value",
                    "--zone": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-maintenance-exclusion-end": "value",
                    "--add-maintenance-exclusion-name": "value",
                    "--add-maintenance-exclusion-scope": "value",
                    "--add-maintenance-exclusion-start": "value",
                    "--additional-pod-ipv4-ranges": "value",
                    "--additional-zones": "value",
                    "--additive-vpc-scope-dns-domain": "value",
                    "--async": "bool",
                    "--auto-monitoring-scope": [
                      "ALL",
                      "NONE"
                    ],
                    "--autoprovisioning-cgroup-mode": [
                      "default",
                      "v1",
                      "v2"
                    ],
                    "--autoprovisioning-config-file": "value",
                    "--autoprovisioning-enable-insecure-kubelet-readonly-port": "bool",
                    "--autoprovisioning-image-type": "value",
                    "--autoprovisioning-locations": "value",
                    "--autoprovisioning-max-surge-upgrade": "value",
                    "--autoprovisioning-max-unavailable-upgrade": "value",
                    "--autoprovisioning-min-cpu-platform": "value",
                    "--autoprovisioning-network-tags": "value",
                    "--autoprovisioning-node-pool-soak-duration": "value",
                    "--autoprovisioning-resource-manager-tags": "value",
                    "--autoprovisioning-scopes": "value",
                    "--autoprovisioning-service-account": "value",
                    "--autoprovisioning-standard-rollout-policy": "value",
                    "--autoscaling-profile": "value",
                    "--binauthz-evaluation-mode": [
                      "disabled",
                      "policy-bindings",
                      "policy-bindings-and-project-singleton-policy-enforce",
                      "project-singleton-policy-enforce"
                    ],
                    "--binauthz-policy-bindings": "value",
                    "--clear-fleet-project": "bool",
                    "--clear-maintenance-window": "bool",
                    "--clear-resource-usage-bigquery-dataset": "bool",
                    "--cloud-run-config": "value",
                    "--cluster-dns": [
                      "clouddns",
                      "default",
                      "kubedns"
                    ],
                    "--cluster-dns-domain": "value",
                    "--cluster-dns-scope": [
                      "cluster",
                      "vpc"
                    ],
                    "--complete-credential-rotation": "bool",
                    "--complete-ip-rotation": "bool",
                    "--containerd-config-from-file": "value",
                    "--database-encryption-key": "value",
                    "--dataplane-v2-observability-mode": [
                      "DISABLED",
                      "EXTERNAL_LB",
                      "INTERNAL_VPC_LB"
                    ],
                    "--disable-additive-vpc-scope": "bool",
                    "--disable-database-encryption": "bool",
                    "--disable-dataplane-v2-flow-observability": "bool",
                    "--disable-dataplane-v2-metrics": "bool",
                    "--disable-default-snat": "bool",
                    "--disable-l4-lb-firewall-reconciliation": "bool",
                    "--disable-managed-prometheus": "bool",
                    "--disable-workload-identity": "bool",
                    "--enable-authorized-networks-on-private-endpoint": "bool",
                    "--enable-autoprovisioning": "bool",
                    "--enable-autoprovisioning-autorepair": "bool",
                    "--enable-autoprovisioning-autoupgrade": "bool",
                    "--enable-autoprovisioning-blue-green-upgrade": "bool",
                    "--enable-autoprovisioning-surge-upgrade": "bool",
                    "--enable-autoscaling": "bool",
                    "--enable-basic-auth": "bool",
                    "--enable-binauthz": "bool",
                    "--enable-cilium-clusterwide-network-policy": "bool",
                    "--enable-cost-allocation": "bool",
                    "--enable-dataplane-v2-flow-observability": "bool",
                    "--enable-dataplane-v2-metrics": "bool",
                    "--enable-dns-access": "bool",
                    "--enable-fleet": "bool",
                    "--enable-fqdn-network-policy": "bool",
                    "--enable-gke-oidc": "bool",
                    "--enable-google-cloud-access": "bool",
                    "--enable-identity-service": "bool",
                    "--enable-image-streaming": "bool",
                    "--enable-insecure-binding-system-authenticated": "bool",
                    "--enable-insecure-binding-system-unauthenticated": "bool",
                    "--enable-insecure-kubelet-readonly-port": "bool",
                    "--enable-intra-node-visibility": "bool",
                    "--enable-ip-access": "bool",
                    "--enable-kubernetes-unstable-apis": "value",
                    "--enable-l4-ilb-subsetting": "bool",
                    "--enable-l4-lb-firewall-reconciliation": "bool",
                    "--enable-legacy-authorization": "bool",
                    "--enable-logging-monitoring-system-only": "bool",
                    "--enable-managed-prometheus": "bool",
                    "--enable-master-authorized-networks": "bool",
                    "--enable-master-global-access": "bool",
                    "--enable-multi-networking": "bool",
                    "--enable-network-egress-metering": "bool",
                    "--enable-network-policy": "bool",
                    "--enable-pod-security-policy": "bool",
                    "--enable-private-endpoint": "bool",
                    "--enable-private-nodes": "bool",
                    "--enable-ray-cluster-logging": "bool",
                    "--enable-ray-cluster-monitoring": "bool",
                    "--enable-resource-consumption-metering": "bool",
                    "--enable-secret-manager": "bool",
                    "--enable-service-externalips": "bool",
                    "--enable-shielded-nodes": "bool",
                    "--enable-stackdriver-kubernetes": "bool",
                    "--enable-tpu": "bool",
                    "--enable-tpu-service-networking": "bool",
                    "--enable-vertical-pod-autoscaling": "bool",
                    "--fleet-project": "value",
                    "--gateway-api": [
                      "disabled",
                      "standard"
                    ],
                    "--generate-password": "bool",
                    "--hpa-profile": [
                      "none",
                      "performance"
                    ],
                    "--identity-provider": "value",
                    "--in-transit-encryption": [
                      "inter-node-transparent",
                      "none"
                    ],
                    "--istio-config": "value",
                    "--location": "value",
                    "--location-policy": [
                      "ANY",
                      "BALANCED"
                    ],
                    "--logging": "value",
                    "--logging-service": "value",
                    "--logging-variant": [
                      "DEFAULT",
                      "MAX_THROUGHPUT"
                    ],
                    "--maintenance-window": "value",
                    "--maintenance-window-end": "value",
                    "--maintenance-window-recurrence": "value",
                    "--maintenance-window-start": "value",
                    "--master-authorized-networks": "value",
                    "--max-accelerator": "value",
                    "--max-cpu": "value",
                    "--max-memory": "value",
                    "--max-nodes": "value",
                    "--min-accelerator": "value",
                    "--min-cpu": "value",
                    "--min-memory": "value",
                    "--min-nodes": "value",
                    "--monitoring": "value",
                    "--monitoring-service": "value",
                    "--network-performance-configs": "value",
                    "--node-locations": "value",
                    "--node-pool": "value",
                    "--notification-config": "value",
                    "--password": "value",
                    "--private-ipv6-google-access-type": [
                      "bidirectional",
                      "disabled",
                      "outbound-only"
                    ],
                    "--region": "value",
                    "--release-channel": "value",
                    "--remove-additional-pod-ipv4-ranges": "value",
                    "--remove-labels": "value",
                    "--remove-maintenance-exclusion": "value",
                    "--remove-workload-policies": "value",
                    "--resource-usage-bigquery-dataset": "value",
                    "--security-group": "value",
                    "--security-posture": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ],
                    "--security-profile": "value",
                    "--set-password": "bool",
                    "--stack-type": [
                      "ipv4",
                      "ipv4-ipv6"
                    ],
                    "--start-credential-rotation": "bool",
                    "--start-ip-rotation": "bool",
                    "--tier": [
                      "enterprise",
                      "standard"
                    ],
                    "--total-max-nodes": "value",
                    "--total-min-nodes": "value",
                    "--tpu-ipv4-cidr": "value",
                    "--update-addons": "value",
                    "--update-labels": "value",
                    "--username": "value",
                    "--workload-policies": "value",
                    "--workload-pool": "value",
                    "--workload-vulnerability-scanning": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ],
                    "--zone": "value"
                  }
                },
                "upgrade": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster-version": "value",
                    "--image-type": "value",
                    "--location": "value",
                    "--master": "bool",
                    "--node-pool": "value",
                    "--region": "value",
                    "--security-profile": "value",
                    "--security-profile-runtime-rules": "bool",
                    "--zone": "value"
                  }
                }
              },
              "flags": {
                "--location": "value",
                "--region": "value",
                "--zone": "value"
              }
            },
            "fleet": {
              "commands": {
                "cloudrun": {
                  "commands": {
                    "apply": {
                      "commands": {},
                      "flags": {
                        "--config": "value",
                        "--context": "value",
                        "--gke-cluster": "value",
                        "--gke-uri": "value",
                        "--kubeconfig": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "clusterupgrade": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--add-upgrade-soaking-override": "value",
                        "--default-upgrade-soaking": "value",
                        "--upgrade-selector": "value",
                        "--upstream-fleet": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--show-linked-cluster-upgrade": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--add-upgrade-soaking-override": "value",
                        "--default-upgrade-soaking": "value",
                        "--remove-upgrade-soaking-overrides": "bool",
                        "--reset-upstream-fleet": "bool",
                        "--upgrade-selector": "value",
                        "--upstream-fleet": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "config-management": {
                  "commands": {
                    "apply": {
                      "commands": {},
                      "flags": {
                        "--config": "value",
                        "--location": "value",
                        "--membership": "value",
                        "--origin": [
                          "FLEET"
                        ]
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--membership": "value"
                      }
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--fleet-default-member-config": "bool",
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--fleet-default-member-config": "value"
                      }
                    },
                    "fetch-for-apply": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--membership": "value"
                      }
                    },
                    "status": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "unmanage": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--membership": "value"
                      }
                    },
                    "upgrade": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--membership": "value"
                      }
                    },
                    "version": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--binauthz-evaluation-mode": [
                      "disabled",
                      "policy-bindings"
                    ],
                    "--binauthz-policy-bindings": "value",
                    "--display-name": "value",
                    "--labels": "value",
                    "--security-posture": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ],
                    "--workload-vulnerability-scanning": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ]
                  }
                },
                "dataplane-v2-encryption": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "features": {
                  "commands": {
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "fleetobservability": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {}
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--logging-config": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "identity-service": {
                  "commands": {
                    "apply": {
                      "commands": {},
                      "flags": {
                        "--config": "value",
                        "--fleet-default-member-config": "value",
                        "--location": "value",
                        "--membership": "value",
                        "--origin": [
                          "fleet"
                        ]
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--fleet-default-member-config": "bool",
                        "--location": "value",
                        "--membership": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--fleet-default-member-config": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "ingress": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--config-membership": "value",
                        "--location": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--config-membership": "value",
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "memberships": {
                  "commands": {
                    "bindings": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--labels": "value",
                            "--location": "value",
                            "--membership": "value",
                            "--scope": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--membership": "value"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--membership": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--location": "value",
                            "--membership": "value",
                            "--page-size": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--clear-labels": "bool",
                            "--location": "value",
                            "--membership": "value",
                            "--remove-labels": "value",
                            "--scope": "value",
                            "--update-labels": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "generate-gateway-rbac": {
                      "commands": {},
                      "flags": {
                        "--anthos-support": "bool",
                        "--apply": "bool",
                        "--context": "value",
                        "--groups": "value",
                        "--kubeconfig": "value",
                        "--membership": "value",
                        "--rbac-output-file": "value",
                        "--revoke": "bool",
                        "--role": "value",
                        "--users": "value"
                      }
                    },
                    "get-credentials": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "register": {
                      "commands": {},
                      "flags": {
                        "--context": "value",
                        "--enable-workload-identity": "bool",
                        "--gke-cluster": "value",
                        "--gke-uri": "value",
                        "--has-private-issuer": "bool",
                        "--install-connect-agent": "bool",
                        "--internal-ip": "bool",
                        "--kubeconfig": "value",
                        "--location": "value",
                        "--manifest-output-file": "value",
                        "--proxy": "value",
                        "--public-issuer-url": "value",
                        "--service-account-key-file": "value"
                      }
                    },
                    "support-access": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value"
                          }
                        },
                        "disable": {
                          "commands": {},
                          "flags": {
                            "--location": "value"
                          }
                        },
                        "enable": {
                          "commands": {},
                          "flags": {
                            "--location": "value"
                          }
                        },
                        "get-yaml": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--rbac-output-file": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "unregister": {
                      "commands": {},
                      "flags": {
                        "--context": "value",
                        "--gke-cluster": "value",
                        "--gke-uri": "value",
                        "--kubeconfig": "value",
                        "--location": "value",
                        "--uninstall-connect-agent": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--location": "value",
                        "--remove-labels": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "mesh": {
                  "commands": {
                    "debug": {
                      "commands": {
                        "bug-report": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--membership": "value"
                          }
                        },
                        "proxy-config": {
                          "commands": {},
                          "flags": {
                            "--fqdn": "value",
                            "--location": "value",
                            "--membership": "value",
                            "--output": [
                              "json",
                              "yaml"
                            ],
                            "--type": [
                              "bootstrap",
                              "cluster",
                              "clusters",
                              "endpoint",
                              "endpoints",
                              "listener",
                              "listeners",
                              "log",
                              "route",
                              "routes",
                              "secret",
                              "secrets"
                            ]
                          }
                        },
                        "proxy-status": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--membership": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--fleet-default-member-config": "bool",
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--fleet-default-member-config": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--config-api": [
                          "gateway",
                          "istio"
                        ],
                        "--control-plane": [
                          "automatic",
                          "manual",
                          "unspecified"
                        ],
                        "--fleet-default-member-config": "value",
                        "--location": "value",
                        "--management": [
                          "automatic",
                          "manual"
                        ],
                        "--membership": "value",
                        "--memberships": "value",
                        "--origin": [
                          "fleet"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "multi-cluster-services": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "namespaceactuation": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--actuation-mode": [
                          "add-and-remove-fleet-labels",
                          "create-and-delete-if-created",
                          "unspecified"
                        ]
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--actuation-mode": [
                          "add-and-remove-fleet-labels",
                          "create-and-delete-if-created",
                          "unspecified"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "wait": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "packages": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--source": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--force": "bool",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--show-cluster-status": "bool"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "resource-bundles": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--description": "value",
                            "--location": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--force": "bool",
                            "--location": "value"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--location": "value",
                            "--page-size": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        },
                        "releases": {
                          "commands": {
                            "create": {
                              "commands": {},
                              "flags": {
                                "--lifecycle": "value",
                                "--location": "value",
                                "--resource-bundle": "value",
                                "--source": "value",
                                "--use-nested-variants": "bool",
                                "--variants-pattern": "value"
                              }
                            },
                            "delete": {
                              "commands": {},
                              "flags": {
                                "--force": "bool",
                                "--location": "value",
                                "--resource-bundle": "value"
                              }
                            },
                            "describe": {
                              "commands": {},
                              "flags": {
                                "--location": "value",
                                "--resource-bundle": "value"
                              }
                            },
                            "list": {
                              "commands": {},
                              "flags": {
                                "--filter": "value",
                                "--limit": "value",
                                "--location": "value",
                                "--page-size": "value",
                                "--resource-bundle": "value",
                                "--sort-by": "value",
                                "--uri": "bool"
                              }
                            },
                            "update": {
                              "commands": {},
                              "flags": {
                                "--lifecycle": "value",
                                "--location": "value",
                                "--resource-bundle": "value",
                                "--source": "value",
                                "--update-mask": "value",
                                "--variants-pattern": "value"
                              }
                            }
                          },
                          "flags": {}
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--description": "value",
                            "--location": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "rollouts": {
                      "commands": {
                        "abort": {
                          "commands": {},
                          "flags": {
                            "--fleet-package": "value",
                            "--location": "value",
                            "--reason": "value"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--fleet-package": "value",
                            "--less": "bool",
                            "--location": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--fleet-package": "value",
                            "--less": "bool",
                            "--limit": "value",
                            "--location": "value",
                            "--page-size": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        },
                        "resume": {
                          "commands": {},
                          "flags": {
                            "--fleet-package": "value",
                            "--location": "value",
                            "--reason": "value"
                          }
                        },
                        "suspend": {
                          "commands": {},
                          "flags": {
                            "--fleet-package": "value",
                            "--location": "value",
                            "--reason": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--source": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "policycontroller": {
                  "commands": {
                    "content": {
                      "commands": {
                        "bundles": {
                          "commands": {
                            "remove": {
                              "commands": {},
                              "flags": {
                                "--all-memberships": "bool",
                                "--location": "value",
                                "--memberships": "value"
                              }
                            },
                            "set": {
                              "commands": {},
                              "flags": {
                                "--all-memberships": "bool",
                                "--exempted-namespaces": "value",
                                "--location": "value",
                                "--memberships": "value",
                                "--no-exempted-namespaces": "bool"
                              }
                            }
                          },
                          "flags": {}
                        },
                        "templates": {
                          "commands": {
                            "disable": {
                              "commands": {},
                              "flags": {
                                "--all-memberships": "bool",
                                "--location": "value",
                                "--memberships": "value"
                              }
                            },
                            "enable": {
                              "commands": {},
                              "flags": {
                                "--all-memberships": "bool",
                                "--location": "value",
                                "--memberships": "value"
                              }
                            }
                          },
                          "flags": {}
                        }
                      },
                      "flags": {}
                    },
                    "deployment": {
                      "commands": {
                        "remove": {
                          "commands": {},
                          "flags": {
                            "--all-memberships": "bool",
                            "--effect": [
                              "NoExecute",
                              "NoSchedule",
                              "PreferNoSchedule"
                            ],
                            "--location": "value",
                            "--memberships": "value"
                          }
                        },
                        "set": {
                          "commands": {},
                          "flags": {
                            "--all-memberships": "bool",
                            "--effect": [
                              "NoExecute",
                              "NoSchedule",
                              "PreferNoSchedule"
                            ],
                            "--location": "value",
                            "--memberships": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--location": "value",
                        "--memberships": "value"
                      }
                    },
                    "detach": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--location": "value",
                        "--memberships": "value"
                      }
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--fleet-default-member-config": "bool",
                        "--location": "value",
                        "--memberships": "value"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--audit-interval": "value",
                        "--clear-exemptable-namespaces": "bool",
                        "--constraint-violation-limit": "value",
                        "--exemptable-namespaces": "value",
                        "--fleet-default-member-config": "value",
                        "--location": "value",
                        "--log-denies": "bool",
                        "--memberships": "value",
                        "--monitoring": "value",
                        "--mutation": "bool",
                        "--no-content": "bool",
                        "--no-default-bundles": "bool",
                        "--no-fleet-default-member-config": "bool",
                        "--no-log-denies": "bool",
                        "--no-monitoring": "bool",
                        "--no-mutation": "bool",
                        "--no-referential-rules": "bool",
                        "--referential-rules": "bool"
                      }
                    },
                    "suspend": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--location": "value",
                        "--memberships": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--audit-interval": "value",
                        "--clear-exemptable-namespaces": "bool",
                        "--constraint-violation-limit": "value",
                        "--exemptable-namespaces": "value",
                        "--location": "value",
                        "--log-denies": "bool",
                        "--memberships": "value",
                        "--monitoring": "value",
                        "--mutation": "bool",
                        "--no-log-denies": "bool",
                        "--no-monitoring": "bool",
                        "--no-mutation": "bool",
                        "--no-referential-rules": "bool",
                        "--origin": [
                          "FLEET"
                        ],
                        "--referential-rules": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "scopes": {
                  "commands": {
                    "add-app-operator-binding": {
                      "commands": {},
                      "flags": {
                        "--group": "value",
                        "--labels": "value",
                        "--role": [
                          "admin",
                          "edit",
                          "view"
                        ],
                        "--user": "value"
                      }
                    },
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--member": "value",
                        "--role": "dynamic"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--add-upgrade-soaking-override": "value",
                        "--async": "bool",
                        "--default-upgrade-soaking": "value",
                        "--labels": "value",
                        "--namespace-labels": "value",
                        "--upgrade-selector": "value",
                        "--upstream-scope": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--show-cluster-upgrade": "bool",
                        "--show-linked-cluster-upgrade": "bool"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "list-app-operator-bindings": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "list-memberships": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "namespaces": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--labels": "value",
                            "--namespace-labels": "value",
                            "--scope": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--scope": "value"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--scope": "value"
                          }
                        },
                        "get-credentials": {
                          "commands": {},
                          "flags": {
                            "--membership": "value",
                            "--membership-location": "value",
                            "--set-namespace-in-config": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--scope": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--clear-labels": "bool",
                            "--clear-namespace-labels": "bool",
                            "--remove-labels": "value",
                            "--remove-namespace-labels": "value",
                            "--scope": "value",
                            "--update-labels": "value",
                            "--update-namespace-labels": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "rbacrolebindings": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--group": "value",
                            "--labels": "value",
                            "--location": "value",
                            "--role": [
                              "admin",
                              "edit",
                              "view"
                            ],
                            "--scope": "value",
                            "--user": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--scope": "value"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--scope": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--scope": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--clear-labels": "bool",
                            "--group": "value",
                            "--location": "value",
                            "--remove-labels": "value",
                            "--role": [
                              "admin",
                              "edit",
                              "view"
                            ],
                            "--scope": "value",
                            "--update-labels": "value",
                            "--user": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "remove-app-operator-binding": {
                      "commands": {},
                      "flags": {
                        "--group": "value",
                        "--user": "value"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--member": "value",
                        "--role": "dynamic"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--add-upgrade-soaking-override": "value",
                        "--clear-labels": "bool",
                        "--clear-namespace-labels": "bool",
                        "--default-upgrade-soaking": "value",
                        "--location": "value",
                        "--remove-labels": "value",
                        "--remove-namespace-labels": "value",
                        "--remove-upgrade-soaking-overrides": "bool",
                        "--reset-upstream-scope": "bool",
                        "--update-labels": "value",
                        "--update-namespace-labels": "value",
                        "--upgrade-selector": "value",
                        "--upstream-scope": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "service-directory": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--binauthz-evaluation-mode": [
                      "disabled",
                      "policy-bindings"
                    ],
                    "--binauthz-policy-bindings": "value",
                    "--clear-labels": "bool",
                    "--display-name": "value",
                    "--remove-labels": "value",
                    "--security-posture": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ],
                    "--update-labels": "value",
                    "--workload-vulnerability-scanning": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "get-server-config": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--region": "value",
                "--sort-by": "value",
                "--zone": "value"
              }
            },
            "hub": {
              "commands": {
                "cloudrun": {
                  "commands": {
                    "apply": {
                      "commands": {},
                      "flags": {
                        "--config": "value",
                        "--context": "value",
                        "--gke-cluster": "value",
                        "--gke-uri": "value",
                        "--kubeconfig": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "clusterupgrade": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--add-upgrade-soaking-override": "value",
                        "--default-upgrade-soaking": "value",
                        "--upgrade-selector": "value",
                        "--upstream-fleet": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--show-linked-cluster-upgrade": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--add-upgrade-soaking-override": "value",
                        "--default-upgrade-soaking": "value",
                        "--remove-upgrade-soaking-overrides": "bool",
                        "--reset-upstream-fleet": "bool",
                        "--upgrade-selector": "value",
                        "--upstream-fleet": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "config-management": {
                  "commands": {
                    "apply": {
                      "commands": {},
                      "flags": {
                        "--config": "value",
                        "--location": "value",
                        "--membership": "value",
                        "--origin": [
                          "FLEET"
                        ]
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--membership": "value"
                      }
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--fleet-default-member-config": "bool",
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--fleet-default-member-config": "value"
                      }
                    },
                    "fetch-for-apply": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--membership": "value"
                      }
                    },
                    "status": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "unmanage": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--membership": "value"
                      }
                    },
                    "upgrade": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--membership": "value"
                      }
                    },
                    "version": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--binauthz-evaluation-mode": [
                      "disabled",
                      "policy-bindings"
                    ],
                    "--binauthz-policy-bindings": "value",
                    "--display-name": "value",
                    "--labels": "value",
                    "--security-posture": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ],
                    "--workload-vulnerability-scanning": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ]
                  }
                },
                "dataplane-v2-encryption": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "features": {
                  "commands": {
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "fleetobservability": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {}
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--logging-config": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "identity-service": {
                  "commands": {
                    "apply": {
                      "commands": {},
                      "flags": {
                        "--config": "value",
                        "--fleet-default-member-config": "value",
                        "--location": "value",
                        "--membership": "value",
                        "--origin": [
                          "fleet"
                        ]
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--fleet-default-member-config": "bool",
                        "--location": "value",
                        "--membership": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--fleet-default-member-config": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "ingress": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--config-membership": "value",
                        "--location": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--config-membership": "value",
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "memberships": {
                  "commands": {
                    "bindings": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--labels": "value",
                            "--location": "value",
                            "--membership": "value",
                            "--scope": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--membership": "value"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--membership": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--location": "value",
                            "--membership": "value",
                            "--page-size": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--clear-labels": "bool",
                            "--location": "value",
                            "--membership": "value",
                            "--remove-labels": "value",
                            "--scope": "value",
                            "--update-labels": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "generate-gateway-rbac": {
                      "commands": {},
                      "flags": {
                        "--anthos-support": "bool",
                        "--apply": "bool",
                        "--context": "value",
                        "--groups": "value",
                        "--kubeconfig": "value",
                        "--membership": "value",
                        "--rbac-output-file": "value",
                        "--revoke": "bool",
                        "--role": "value",
                        "--users": "value"
                      }
                    },
                    "get-credentials": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "register": {
                      "commands": {},
                      "flags": {
                        "--context": "value",
                        "--enable-workload-identity": "bool",
                        "--gke-cluster": "value",
                        "--gke-uri": "value",
                        "--has-private-issuer": "bool",
                        "--install-connect-agent": "bool",
                        "--internal-ip": "bool",
                        "--kubeconfig": "value",
                        "--location": "value",
                        "--manifest-output-file": "value",
                        "--proxy": "value",
                        "--public-issuer-url": "value",
                        "--service-account-key-file": "value"
                      }
                    },
                    "support-access": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value"
                          }
                        },
                        "disable": {
                          "commands": {},
                          "flags": {
                            "--location": "value"
                          }
                        },
                        "enable": {
                          "commands": {},
                          "flags": {
                            "--location": "value"
                          }
                        },
                        "get-yaml": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--rbac-output-file": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "unregister": {
                      "commands": {},
                      "flags": {
                        "--context": "value",
                        "--gke-cluster": "value",
                        "--gke-uri": "value",
                        "--kubeconfig": "value",
                        "--location": "value",
                        "--uninstall-connect-agent": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--location": "value",
                        "--remove-labels": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "mesh": {
                  "commands": {
                    "debug": {
                      "commands": {
                        "bug-report": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--membership": "value"
                          }
                        },
                        "proxy-config": {
                          "commands": {},
                          "flags": {
                            "--fqdn": "value",
                            "--location": "value",
                            "--membership": "value",
                            "--output": [
                              "json",
                              "yaml"
                            ],
                            "--type": [
                              "bootstrap",
                              "cluster",
                              "clusters",
                              "endpoint",
                              "endpoints",
                              "listener",
                              "listeners",
                              "log",
                              "route",
                              "routes",
                              "secret",
                              "secrets"
                            ]
                          }
                        },
                        "proxy-status": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--membership": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--fleet-default-member-config": "bool",
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--fleet-default-member-config": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--config-api": [
                          "gateway",
                          "istio"
                        ],
                        "--control-plane": [
                          "automatic",
                          "manual",
                          "unspecified"
                        ],
                        "--fleet-default-member-config": "value",
                        "--location": "value",
                        "--management": [
                          "automatic",
                          "manual"
                        ],
                        "--membership": "value",
                        "--memberships": "value",
                        "--origin": [
                          "fleet"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "multi-cluster-services": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "namespaceactuation": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--actuation-mode": [
                          "add-and-remove-fleet-labels",
                          "create-and-delete-if-created",
                          "unspecified"
                        ]
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--actuation-mode": [
                          "add-and-remove-fleet-labels",
                          "create-and-delete-if-created",
                          "unspecified"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "wait": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "packages": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--source": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--force": "bool",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--show-cluster-status": "bool"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "resource-bundles": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--description": "value",
                            "--location": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--force": "bool",
                            "--location": "value"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--location": "value",
                            "--page-size": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        },
                        "releases": {
                          "commands": {
                            "create": {
                              "commands": {},
                              "flags": {
                                "--lifecycle": "value",
                                "--location": "value",
                                "--resource-bundle": "value",
                                "--source": "value",
                                "--use-nested-variants": "bool",
                                "--variants-pattern": "value"
                              }
                            },
                            "delete": {
                              "commands": {},
                              "flags": {
                                "--force": "bool",
                                "--location": "value",
                                "--resource-bundle": "value"
                              }
                            },
                            "describe": {
                              "commands": {},
                              "flags": {
                                "--location": "value",
                                "--resource-bundle": "value"
                              }
                            },
                            "list": {
                              "commands": {},
                              "flags": {
                                "--filter": "value",
                                "--limit": "value",
                                "--location": "value",
                                "--page-size": "value",
                                "--resource-bundle": "value",
                                "--sort-by": "value",
                                "--uri": "bool"
                              }
                            },
                            "update": {
                              "commands": {},
                              "flags": {
                                "--lifecycle": "value",
                                "--location": "value",
                                "--resource-bundle": "value",
                                "--source": "value",
                                "--update-mask": "value",
                                "--variants-pattern": "value"
                              }
                            }
                          },
                          "flags": {}
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--description": "value",
                            "--location": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "rollouts": {
                      "commands": {
                        "abort": {
                          "commands": {},
                          "flags": {
                            "--fleet-package": "value",
                            "--location": "value",
                            "--reason": "value"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--fleet-package": "value",
                            "--less": "bool",
                            "--location": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--fleet-package": "value",
                            "--less": "bool",
                            "--limit": "value",
                            "--location": "value",
                            "--page-size": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        },
                        "resume": {
                          "commands": {},
                          "flags": {
                            "--fleet-package": "value",
                            "--location": "value",
                            "--reason": "value"
                          }
                        },
                        "suspend": {
                          "commands": {},
                          "flags": {
                            "--fleet-package": "value",
                            "--location": "value",
                            "--reason": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--source": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "policycontroller": {
                  "commands": {
                    "content": {
                      "commands": {
                        "bundles": {
                          "commands": {
                            "remove": {
                              "commands": {},
                              "flags": {
                                "--all-memberships": "bool",
                                "--location": "value",
                                "--memberships": "value"
                              }
                            },
                            "set": {
                              "commands": {},
                              "flags": {
                                "--all-memberships": "bool",
                                "--exempted-namespaces": "value",
                                "--location": "value",
                                "--memberships": "value",
                                "--no-exempted-namespaces": "bool"
                              }
                            }
                          },
                          "flags": {}
                        },
                        "templates": {
                          "commands": {
                            "disable": {
                              "commands": {},
                              "flags": {
                                "--all-memberships": "bool",
                                "--location": "value",
                                "--memberships": "value"
                              }
                            },
                            "enable": {
                              "commands": {},
                              "flags": {
                                "--all-memberships": "bool",
                                "--location": "value",
                                "--memberships": "value"
                              }
                            }
                          },
                          "flags": {}
                        }
                      },
                      "flags": {}
                    },
                    "deployment": {
                      "commands": {
                        "remove": {
                          "commands": {},
                          "flags": {
                            "--all-memberships": "bool",
                            "--effect": [
                              "NoExecute",
                              "NoSchedule",
                              "PreferNoSchedule"
                            ],
                            "--location": "value",
                            "--memberships": "value"
                          }
                        },
                        "set": {
                          "commands": {},
                          "flags": {
                            "--all-memberships": "bool",
                            "--effect": [
                              "NoExecute",
                              "NoSchedule",
                              "PreferNoSchedule"
                            ],
                            "--location": "value",
                            "--memberships": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--location": "value",
                        "--memberships": "value"
                      }
                    },
                    "detach": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--location": "value",
                        "--memberships": "value"
                      }
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--fleet-default-member-config": "bool",
                        "--location": "value",
                        "--memberships": "value"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--audit-interval": "value",
                        "--clear-exemptable-namespaces": "bool",
                        "--constraint-violation-limit": "value",
                        "--exemptable-namespaces": "value",
                        "--fleet-default-member-config": "value",
                        "--location": "value",
                        "--log-denies": "bool",
                        "--memberships": "value",
                        "--monitoring": "value",
                        "--mutation": "bool",
                        "--no-content": "bool",
                        "--no-default-bundles": "bool",
                        "--no-fleet-default-member-config": "bool",
                        "--no-log-denies": "bool",
                        "--no-monitoring": "bool",
                        "--no-mutation": "bool",
                        "--no-referential-rules": "bool",
                        "--referential-rules": "bool"
                      }
                    },
                    "suspend": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--location": "value",
                        "--memberships": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--audit-interval": "value",
                        "--clear-exemptable-namespaces": "bool",
                        "--constraint-violation-limit": "value",
                        "--exemptable-namespaces": "value",
                        "--location": "value",
                        "--log-denies": "bool",
                        "--memberships": "value",
                        "--monitoring": "value",
                        "--mutation": "bool",
                        "--no-log-denies": "bool",
                        "--no-monitoring": "bool",
                        "--no-mutation": "bool",
                        "--no-referential-rules": "bool",
                        "--origin": [
                          "FLEET"
                        ],
                        "--referential-rules": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "scopes": {
                  "commands": {
                    "add-app-operator-binding": {
                      "commands": {},
                      "flags": {
                        "--group": "value",
                        "--labels": "value",
                        "--role": [
                          "admin",
                          "edit",
                          "view"
                        ],
                        "--user": "value"
                      }
                    },
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--member": "value",
                        "--role": "dynamic"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--add-upgrade-soaking-override": "value",
                        "--async": "bool",
                        "--default-upgrade-soaking": "value",
                        "--labels": "value",
                        "--namespace-labels": "value",
                        "--upgrade-selector": "value",
                        "--upstream-scope": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--show-cluster-upgrade": "bool",
                        "--show-linked-cluster-upgrade": "bool"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "list-app-operator-bindings": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "list-memberships": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "namespaces": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--labels": "value",
                            "--namespace-labels": "value",
                            "--scope": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--scope": "value"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--scope": "value"
                          }
                        },
                        "get-credentials": {
                          "commands": {},
                          "flags": {
                            "--membership": "value",
                            "--membership-location": "value",
                            "--set-namespace-in-config": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--scope": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--clear-labels": "bool",
                            "--clear-namespace-labels": "bool",
                            "--remove-labels": "value",
                            "--remove-namespace-labels": "value",
                            "--scope": "value",
                            "--update-labels": "value",
                            "--update-namespace-labels": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "rbacrolebindings": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--group": "value",
                            "--labels": "value",
                            "--location": "value",
                            "--role": [
                              "admin",
                              "edit",
                              "view"
                            ],
                            "--scope": "value",
                            "--user": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--scope": "value"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--scope": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--scope": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--clear-labels": "bool",
                            "--group": "value",
                            "--location": "value",
                            "--remove-labels": "value",
                            "--role": [
                              "admin",
                              "edit",
                              "view"
                            ],
                            "--scope": "value",
                            "--update-labels": "value",
                            "--user": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "remove-app-operator-binding": {
                      "commands": {},
                      "flags": {
                        "--group": "value",
                        "--user": "value"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--member": "value",
                        "--role": "dynamic"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--add-upgrade-soaking-override": "value",
                        "--clear-labels": "bool",
                        "--clear-namespace-labels": "bool",
                        "--default-upgrade-soaking": "value",
                        "--location": "value",
                        "--remove-labels": "value",
                        "--remove-namespace-labels": "value",
                        "--remove-upgrade-soaking-overrides": "bool",
                        "--reset-upstream-scope": "bool",
                        "--update-labels": "value",
                        "--update-namespace-labels": "value",
                        "--upgrade-selector": "value",
                        "--upstream-scope": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "service-directory": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--binauthz-evaluation-mode": [
                      "disabled",
                      "policy-bindings"
                    ],
                    "--binauthz-policy-bindings": "value",
                    "--clear-labels": "bool",
                    "--display-name": "value",
                    "--remove-labels": "value",
                    "--security-posture": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ],
                    "--update-labels": "value",
                    "--workload-vulnerability-scanning": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "images": {
              "commands": {
                "add-tag": {
                  "commands": {},
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--force-delete-tags": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--metadata-filter": "value",
                    "--show-all-metadata": "bool",
                    "--show-build-details": "bool",
                    "--show-deployment": "bool",
                    "--show-image-basis": "bool",
                    "--show-package-vulnerability": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--repository": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-tags": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--occurrence-filter": "value",
                    "--page-size": "value",
                    "--show-occurrences": "bool",
                    "--show-occurrences-from": "value",
                    "--sort-by": "value"
                  }
                },
                "untag": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "node-pools": {
              "commands": {
                "complete-upgrade": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--cluster": "value",
                        "--location": "value",
                        "--path": "value",
                        "--region": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ],
                        "--zone": "value"
                      }
                    }
                  },
                  "flags": {
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--additional-node-network": "value",
                    "--additional-pod-network": "value",
                    "--async": "bool",
                    "--boot-disk-kms-key": "value",
                    "--cluster": "value",
                    "--containerd-config-from-file": "value",
                    "--create-pod-ipv4-range": "value",
                    "--disable-pod-cidr-overprovision": "bool",
                    "--disk-size": "value",
                    "--disk-type": [
                      "hyperdisk-balanced",
                      "hyperdisk-extreme",
                      "hyperdisk-throughput",
                      "pd-balanced",
                      "pd-ssd",
                      "pd-standard"
                    ],
                    "--enable-autoprovisioning": "bool",
                    "--enable-autorepair": "bool",
                    "--enable-autoscaling": "bool",
                    "--enable-autoupgrade": "bool",
                    "--enable-best-effort-provision": "bool",
                    "--enable-blue-green-upgrade": "bool",
                    "--enable-confidential-nodes": "bool",
                    "--enable-confidential-storage": "bool",
                    "--enable-gvnic": "bool",
                    "--enable-image-streaming": "bool",
                    "--enable-insecure-kubelet-readonly-port": "bool",
                    "--enable-nested-virtualization": "bool",
                    "--enable-private-nodes": "bool",
                    "--enable-queued-provisioning": "bool",
                    "--enable-surge-upgrade": "bool",
                    "--ephemeral-storage": "value",
                    "--ephemeral-storage-local-ssd": "value",
                    "--image-type": "value",
                    "--labels": "value",
                    "--linux-sysctls": "value",
                    "--local-nvme-ssd-block": "value",
                    "--local-ssd-count": "value",
                    "--local-ssd-encryption-mode": [
                      "EPHEMERAL_KEY_ENCRYPTION",
                      "STANDARD_ENCRYPTION"
                    ],
                    "--local-ssd-volumes": "value",
                    "--location": "value",
                    "--location-policy": [
                      "ANY",
                      "BALANCED"
                    ],
                    "--logging-variant": [
                      "DEFAULT",
                      "MAX_THROUGHPUT"
                    ],
                    "--machine-type": "value",
                    "--max-nodes": "value",
                    "--max-pods-per-node": "value",
                    "--max-run-duration": "value",
                    "--max-surge-upgrade": "value",
                    "--max-unavailable-upgrade": "value",
                    "--metadata": "value",
                    "--metadata-from-file": "value",
                    "--min-cpu-platform": "value",
                    "--min-nodes": "value",
                    "--min-provision-nodes": "value",
                    "--network-performance-configs": "value",
                    "--node-group": "value",
                    "--node-labels": "value",
                    "--node-locations": "value",
                    "--node-pool-soak-duration": "value",
                    "--node-taints": "value",
                    "--node-version": "value",
                    "--num-nodes": "value",
                    "--placement-policy": "value",
                    "--placement-type": [
                      "COMPACT",
                      "UNSPECIFIED"
                    ],
                    "--pod-ipv4-range": "value",
                    "--preemptible": "bool",
                    "--region": "value",
                    "--reservation": "value",
                    "--reservation-affinity": [
                      "any",
                      "none",
                      "specific"
                    ],
                    "--resource-manager-tags": "value",
                    "--sandbox": "value",
                    "--scopes": "value",
                    "--secondary-boot-disk": "value",
                    "--service-account": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-secure-boot": "bool",
                    "--sole-tenant-node-affinity-file": "value",
                    "--spot": "bool",
                    "--standard-rollout-policy": "value",
                    "--storage-pools": "value",
                    "--system-config-from-file": "value",
                    "--tags": "value",
                    "--threads-per-core": "value",
                    "--total-max-nodes": "value",
                    "--total-min-nodes": "value",
                    "--tpu-topology": "value",
                    "--windows-os-version": [
                      "ltsc2019",
                      "ltsc2022"
                    ],
                    "--workload-metadata": [
                      "EXPOSED",
                      "GCE_METADATA",
                      "GKE_METADATA",
                      "GKE_METADATA_SERVER",
                      "SECURE"
                    ],
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster": "value",
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "get-upgrade-info": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "value"
                  }
                },
                "rollback": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster": "value",
                    "--location": "value",
                    "--region": "value",
                    "--respect-pdb": "value",
                    "--zone": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--async": "bool",
                    "--cluster": "value",
                    "--containerd-config-from-file": "value",
                    "--disk-size": "value",
                    "--disk-type": [
                      "hyperdisk-balanced",
                      "hyperdisk-extreme",
                      "hyperdisk-throughput",
                      "pd-balanced",
                      "pd-ssd",
                      "pd-standard"
                    ],
                    "--enable-autoprovisioning": "bool",
                    "--enable-autorepair": "bool",
                    "--enable-autoscaling": "bool",
                    "--enable-autoupgrade": "bool",
                    "--enable-blue-green-upgrade": "bool",
                    "--enable-confidential-nodes": "bool",
                    "--enable-gvnic": "bool",
                    "--enable-image-streaming": "bool",
                    "--enable-insecure-kubelet-readonly-port": "bool",
                    "--enable-private-nodes": "bool",
                    "--enable-queued-provisioning": "bool",
                    "--enable-surge-upgrade": "bool",
                    "--labels": "value",
                    "--location": "value",
                    "--location-policy": [
                      "ANY",
                      "BALANCED"
                    ],
                    "--logging-variant": [
                      "DEFAULT",
                      "MAX_THROUGHPUT"
                    ],
                    "--machine-type": "value",
                    "--max-nodes": "value",
                    "--max-run-duration": "value",
                    "--max-surge-upgrade": "value",
                    "--max-unavailable-upgrade": "value",
                    "--min-nodes": "value",
                    "--network-performance-configs": "value",
                    "--node-labels": "value",
                    "--node-locations": "value",
                    "--node-pool-soak-duration": "value",
                    "--node-taints": "value",
                    "--region": "value",
                    "--resource-manager-tags": "value",
                    "--standard-rollout-policy": "value",
                    "--storage-pools": "value",
                    "--system-config-from-file": "value",
                    "--tags": "value",
                    "--total-max-nodes": "value",
                    "--total-min-nodes": "value",
                    "--windows-os-version": [
                      "ltsc2019",
                      "ltsc2022"
                    ],
                    "--workload-metadata": [
                      "EXPOSED",
                      "GCE_METADATA",
                      "GKE_METADATA",
                      "GKE_METADATA_SERVER",
                      "SECURE"
                    ],
                    "--zone": "value"
                  }
                }
              },
              "flags": {
                "--location": "value",
                "--region": "value",
                "--zone": "value"
              }
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--zone": "value"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                }
              },
              "flags": {
                "--location": "value",
                "--region": "value",
                "--zone": "value"
              }
            },
            "subnets": {
              "commands": {
                "list-usable": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--network-project": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "vmware": {
              "commands": {
                "admin-clusters": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "enroll": {
                      "commands": {},
                      "flags": {
                        "--admin-cluster-membership": "value",
                        "--admin-cluster-membership-location": "value",
                        "--async": "bool",
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "unenroll": {
                      "commands": {},
                      "flags": {
                        "--allow-missing": "bool",
                        "--async": "bool",
                        "--location": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--required-platform-version": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "clusters": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--admin-cluster-membership": "value",
                        "--admin-cluster-membership-location": "value",
                        "--admin-cluster-membership-project": "value",
                        "--admin-users": "value",
                        "--annotations": "value",
                        "--async": "bool",
                        "--control-plane-ip-block": "value",
                        "--control-plane-node-port": "value",
                        "--control-plane-vip": "value",
                        "--cpus": "value",
                        "--description": "value",
                        "--disable-aag-config": "bool",
                        "--disable-control-plane-v2": "bool",
                        "--disable-vsphere-csi": "bool",
                        "--dns-search-domains": "value",
                        "--dns-servers": "value",
                        "--enable-advanced-networking": "bool",
                        "--enable-auto-repair": "bool",
                        "--enable-auto-resize": "bool",
                        "--enable-control-plane-v2": "bool",
                        "--enable-dataplane-v2": "bool",
                        "--enable-dhcp": "bool",
                        "--enable-vm-tracking": "bool",
                        "--f5-config-address": "value",
                        "--f5-config-partition": "value",
                        "--f5-config-snat-pool": "value",
                        "--ingress-http-node-port": "value",
                        "--ingress-https-node-port": "value",
                        "--ingress-vip": "value",
                        "--konnectivity-server-node-port": "value",
                        "--location": "value",
                        "--memory": "value",
                        "--metal-lb-config-address-pools": "value",
                        "--ntp-servers": "value",
                        "--pod-address-cidr-blocks": "value",
                        "--replicas": "value",
                        "--service-address-cidr-blocks": "value",
                        "--static-ip-config-ip-blocks": "value",
                        "--upgrade-policy": "value",
                        "--validate-only": "bool",
                        "--vcenter-ca-cert-data": "value",
                        "--vcenter-cluster": "value",
                        "--vcenter-datacenter": "value",
                        "--vcenter-datastore": "value",
                        "--vcenter-folder": "value",
                        "--vcenter-resource-pool": "value",
                        "--vcenter-storage-policy-name": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--allow-missing": "bool",
                        "--async": "bool",
                        "--force": "bool",
                        "--ignore-errors": "bool",
                        "--location": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "enroll": {
                      "commands": {},
                      "flags": {
                        "--admin-cluster-membership": "value",
                        "--admin-cluster-membership-location": "value",
                        "--admin-cluster-membership-project": "value",
                        "--async": "bool",
                        "--local-name": "value",
                        "--location": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "query-version-config": {
                      "commands": {},
                      "flags": {
                        "--admin-cluster-membership": "value",
                        "--admin-cluster-membership-location": "value",
                        "--admin-cluster-membership-project": "value",
                        "--cluster": "value",
                        "--location": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--add-annotations": "value",
                        "--admin-users": "value",
                        "--async": "bool",
                        "--cpus": "value",
                        "--description": "value",
                        "--disable-aag-config": "bool",
                        "--disable-auto-repair": "bool",
                        "--disable-auto-resize": "bool",
                        "--disable-vsphere-csi": "bool",
                        "--enable-aag-config": "bool",
                        "--enable-auto-repair": "bool",
                        "--enable-auto-resize": "bool",
                        "--enable-vsphere-csi": "bool",
                        "--location": "value",
                        "--memory": "value",
                        "--metal-lb-config-address-pools": "value",
                        "--remove-annotations": "value",
                        "--static-ip-config-ip-blocks": "value",
                        "--upgrade-policy": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "upgrade": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "node-pools": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--annotations": "value",
                        "--async": "bool",
                        "--boot-disk-size": "value",
                        "--cluster": "value",
                        "--cpus": "value",
                        "--display-name": "value",
                        "--enable-load-balancer": "bool",
                        "--image": "value",
                        "--image-type": "value",
                        "--location": "value",
                        "--max-replicas": "value",
                        "--memory": "value",
                        "--min-replicas": "value",
                        "--node-labels": "value",
                        "--node-taints": "value",
                        "--replicas": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--allow-missing": "bool",
                        "--async": "bool",
                        "--cluster": "value",
                        "--ignore-errors": "bool",
                        "--location": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--cluster": "value",
                        "--location": "value"
                      }
                    },
                    "enroll": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--cluster": "value",
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--cluster": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--boot-disk-size": "value",
                        "--cluster": "value",
                        "--cpus": "value",
                        "--disable-load-balancer": "bool",
                        "--display-name": "value",
                        "--enable-load-balancer": "bool",
                        "--image": "value",
                        "--image-type": "value",
                        "--location": "value",
                        "--max-replicas": "value",
                        "--memory": "value",
                        "--min-replicas": "value",
                        "--node-labels": "value",
                        "--node-taints": "value",
                        "--replicas": "value",
                        "--validate-only": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "wait": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "data-catalog": {
          "commands": {
            "crawler-runs": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--crawler": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "start": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "crawlers": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--buckets": "value",
                    "--bundle-specs": "value",
                    "--crawl-scope": [
                      "bucket",
                      "organization",
                      "project"
                    ],
                    "--description": "value",
                    "--display-name": "value",
                    "--run-option": [
                      "manual",
                      "scheduled"
                    ],
                    "--run-schedule": [
                      "daily",
                      "weekly"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-buckets": "value",
                    "--add-bundle-specs": "value",
                    "--clear-buckets": "bool",
                    "--clear-bundle-specs": "bool",
                    "--crawl-scope": [
                      "bucket",
                      "organization",
                      "project"
                    ],
                    "--description": "value",
                    "--display-name": "value",
                    "--remove-buckets": "value",
                    "--remove-bundle-specs": "value",
                    "--run-option": [
                      "manual",
                      "scheduled"
                    ],
                    "--run-schedule": [
                      "daily",
                      "weekly"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "entries": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--entry-group": "value",
                    "--gcs-file-patterns": "value",
                    "--location": "value",
                    "--schema": "value",
                    "--schema-from-file": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--entry-group": "value",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--entry-group": "value",
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--entry-group": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "lookup": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-file-patterns": "value",
                    "--clear-file-patterns": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--entry-group": "value",
                    "--location": "value",
                    "--lookup-entry": "value",
                    "--remove-file-patterns": "value",
                    "--schema": "value",
                    "--schema-from-file": "value"
                  }
                }
              },
              "flags": {}
            },
            "entry-groups": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "search": {
              "commands": {},
              "flags": {
                "--include-gcp-public-datasets": "bool",
                "--include-organization-ids": "value",
                "--include-project-ids": "value",
                "--limit": "value",
                "--order-by": "value",
                "--page-size": "value",
                "--restricted-locations": "value"
              }
            },
            "tag-templates": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--display-name": "value",
                    "--field": "value",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--force": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "fields": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--display-name": "value",
                        "--location": "value",
                        "--tag-template": "value",
                        "--type": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--force": "bool",
                        "--location": "value",
                        "--tag-template": "value"
                      }
                    },
                    "enum-values": {
                      "commands": {
                        "rename": {
                          "commands": {},
                          "flags": {
                            "--field": "value",
                            "--location": "value",
                            "--new-id": "value",
                            "--tag-template": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "rename": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--new-id": "value",
                        "--tag-template": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--display-name": "value",
                        "--enum-values": "value",
                        "--location": "value",
                        "--required": "bool",
                        "--tag-template": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--display-name": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "tags": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--entry": "value",
                    "--entry-group": "value",
                    "--location": "value",
                    "--scope": "value",
                    "--tag-file": "value",
                    "--tag-template": "value",
                    "--tag-template-location": "value",
                    "--tag-template-project": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--entry": "value",
                    "--entry-group": "value",
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--entry": "value",
                    "--entry-group": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--entry": "value",
                    "--entry-group": "value",
                    "--location": "value",
                    "--tag-file": "value",
                    "--tag-template": "value",
                    "--tag-template-location": "value",
                    "--tag-template-project": "value"
                  }
                }
              },
              "flags": {}
            },
            "taxonomies": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "policy-tags": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--member": "value",
                        "--role": "dynamic",
                        "--taxonomy": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--taxonomy": "value"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--taxonomy": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--taxonomy": "value",
                        "--uri": "bool"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--member": "value",
                        "--role": "dynamic",
                        "--taxonomy": "value"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--taxonomy": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "database-migration": {
          "commands": {
            "connection-profiles": {
              "commands": {
                "create": {
                  "commands": {
                    "cloudsql": {
                      "commands": {},
                      "flags": {
                        "--activation-policy": [
                          "ALWAYS",
                          "NEVER"
                        ],
                        "--authorized-networks": "value",
                        "--auto-storage-increase": "bool",
                        "--availability-type": [
                          "REGIONAL",
                          "ZONAL"
                        ],
                        "--data-disk-size": "value",
                        "--data-disk-type": [
                          "PD_HDD",
                          "PD_SSD"
                        ],
                        "--database-flags": "value",
                        "--database-version": [
                          "MYSQL_5_6",
                          "MYSQL_5_7",
                          "MYSQL_8_0",
                          "POSTGRES_10",
                          "POSTGRES_11",
                          "POSTGRES_12",
                          "POSTGRES_13",
                          "POSTGRES_14",
                          "POSTGRES_15",
                          "POSTGRES_9_6"
                        ],
                        "--display-name": "value",
                        "--enable-ip-v4": "bool",
                        "--labels": "value",
                        "--no-async": "bool",
                        "--private-network": "value",
                        "--provider": [
                          "CLOUDSQL",
                          "RDS"
                        ],
                        "--region": "dynamic",
                        "--require-ssl": "bool",
                        "--root-password": "value",
                        "--secondary-zone": "value",
                        "--source-id": "dynamic",
                        "--storage-auto-resize-limit": "value",
                        "--tier": "value",
                        "--user-labels": "value",
                        "--zone": "value"
                      }
                    },
                    "mysql": {
                      "commands": {},
                      "flags": {
                        "--ca-certificate": "value",
                        "--certificate": "value",
                        "--display-name": "value",
                        "--host": "value",
                        "--instance": "value",
                        "--labels": "value",
                        "--no-async": "bool",
                        "--password": "value",
                        "--port": "value",
                        "--private-key": "value",
                        "--prompt-for-password": "bool",
                        "--provider": [
                          "CLOUDSQL",
                          "RDS"
                        ],
                        "--region": "dynamic",
                        "--username": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--force": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--ca-certificate": "value",
                    "--certificate": "value",
                    "--clear-labels": "bool",
                    "--display-name": "value",
                    "--host": "value",
                    "--instance": "value",
                    "--password": "value",
                    "--port": "value",
                    "--private-key": "value",
                    "--prompt-for-password": "bool",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--update-labels": "value",
                    "--username": "value"
                  }
                }
              },
              "flags": {}
            },
            "migration-jobs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--destination": "dynamic",
                    "--display-name": "value",
                    "--dump-path": "value",
                    "--labels": "value",
                    "--no-async": "bool",
                    "--peer-vpc": "value",
                    "--region": "dynamic",
                    "--source": "dynamic",
                    "--static-ip": "bool",
                    "--type": [
                      "CONTINUOUS",
                      "ONE_TIME"
                    ],
                    "--vm": "value",
                    "--vm-ip": "value",
                    "--vm-port": "value",
                    "--vpc": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--force": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "generate-ssh-script": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--vm": "value",
                    "--vm-machine-type": "value",
                    "--vm-port": "value",
                    "--vm-zone": "value",
                    "--vm-zone-create": "value",
                    "--vpc": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "promote": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "restart": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "resume": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "start": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "stop": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--destination": "dynamic",
                    "--display-name": "value",
                    "--dump-path": "value",
                    "--no-async": "bool",
                    "--peer-vpc": "value",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--source": "dynamic",
                    "--static-ip": "bool",
                    "--type": [
                      "CONTINUOUS",
                      "ONE_TIME"
                    ],
                    "--update-labels": "value",
                    "--vm": "value",
                    "--vm-ip": "value",
                    "--vm-port": "value",
                    "--vpc": "value"
                  }
                },
                "verify": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "dataflow": {
          "commands": {
            "jobs": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "export-steps": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "resume-unsupported-sdk": {
                  "commands": {},
                  "flags": {
                    "--region": "value",
                    "--token": "value"
                  }
                }
              },
              "flags": {}
            },
            "logs": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--after": "value",
                    "--before": "value",
                    "--filter": "value",
                    "--importance": [
                      "debug",
                      "detailed",
                      "error",
                      "warning"
                    ],
                    "--limit": "value",
                    "--region": "value"
                  }
                }
              },
              "flags": {}
            },
            "metrics": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--changed-after": "value",
                    "--filter": "value",
                    "--hide-committed": "bool",
                    "--limit": "value",
                    "--region": "value",
                    "--source": [
                      "all",
                      "service",
                      "user"
                    ],
                    "--tentative": "bool",
                    "--transform": "value"
                  }
                }
              },
              "flags": {}
            },
            "snapshots": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--job-id": "value",
                    "--region": "value",
                    "--snapshot-sources": "value",
                    "--snapshot-ttl": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--job-id": "value",
                    "--region": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "dataplex": {
          "commands": {
            "aspect-types": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--metadata-template-file-name": "value",
                    "--validate-only": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--etag": "value",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--etag": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--metadata-template-file-name": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            },
            "assets": {
              "commands": {
                "actions": {
                  "commands": {
                    "list": {
                      "commands": {},
                      "flags": {
                        "--asset": "dynamic",
                        "--filter": "value",
                        "--lake": "dynamic",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--lake": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "value",
                    "--zone": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--csv-delimiter": "value",
                    "--csv-disable-type-inference": "bool",
                    "--csv-encoding": "value",
                    "--csv-header-rows": "value",
                    "--description": "value",
                    "--discovery-enabled": "bool",
                    "--discovery-exclude-patterns": "value",
                    "--discovery-include-patterns": "value",
                    "--discovery-schedule": "value",
                    "--display-name": "value",
                    "--json-disable-type-inference": "bool",
                    "--json-encoding": "value",
                    "--labels": "value",
                    "--lake": "value",
                    "--location": "value",
                    "--resource-name": "value",
                    "--resource-read-access-mode": [
                      "DIRECT",
                      "MANAGED"
                    ],
                    "--resource-type": [
                      "BIGQUERY_DATASET",
                      "STORAGE_BUCKET"
                    ],
                    "--validate-only": "bool",
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--lake": "dynamic",
                    "--location": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--lake": "dynamic",
                    "--location": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--lake": "dynamic",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--lake": "dynamic",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--lake": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "value",
                    "--zone": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--lake": "value",
                    "--location": "value",
                    "--zone": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--csv-delimiter": "value",
                    "--csv-disable-type-inference": "bool",
                    "--csv-encoding": "value",
                    "--csv-header-rows": "value",
                    "--description": "value",
                    "--discovery-enabled": "bool",
                    "--discovery-exclude-patterns": "value",
                    "--discovery-include-patterns": "value",
                    "--discovery-schedule": "value",
                    "--display-name": "value",
                    "--json-disable-type-inference": "bool",
                    "--json-encoding": "value",
                    "--labels": "value",
                    "--lake": "value",
                    "--location": "value",
                    "--resource-read-access-mode": [
                      "DIRECT",
                      "MANAGED"
                    ],
                    "--validate-only": "bool",
                    "--zone": "value"
                  }
                }
              },
              "flags": {}
            },
            "content": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--lake": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--data-text": "value",
                    "--description": "value",
                    "--kernel-type": [
                      "PYTHON3"
                    ],
                    "--labels": "value",
                    "--lake": "value",
                    "--location": "value",
                    "--path": "value",
                    "--query-engine": [
                      "SPARK"
                    ],
                    "--validate-only": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--lake": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--lake": "dynamic",
                    "--location": "dynamic",
                    "--view": [
                      "basic",
                      "full"
                    ]
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--lake": "dynamic",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--lake": "dynamic",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--lake": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--lake": "value",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--data-text": "value",
                    "--description": "value",
                    "--kernel-type": [
                      "PYTHON3"
                    ],
                    "--labels": "value",
                    "--lake": "value",
                    "--location": "value",
                    "--path": "value",
                    "--query-engine": [
                      "SPARK"
                    ],
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            },
            "data-attribute-bindings": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--path-file-format": [
                      "json",
                      "yaml"
                    ],
                    "--path-file-name": "value",
                    "--paths": "value",
                    "--resource": "value",
                    "--resource-attributes": "value",
                    "--validate-only": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--etag": "value",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--etag": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--path-file-format": [
                      "json",
                      "yaml"
                    ],
                    "--path-file-name": "value",
                    "--paths": "value",
                    "--resource-attributes": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            },
            "data-taxonomies": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "attributes": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--data_taxonomy": "value",
                        "--location": "value",
                        "--member": "value",
                        "--role": "value"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--data-readers": "value",
                        "--data_taxonomy": "value",
                        "--description": "value",
                        "--display-name": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--parent": "value",
                        "--resource-owners": "value",
                        "--resource-readers": "value",
                        "--resource-writers": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--data_taxonomy": "dynamic",
                        "--etag": "value",
                        "--location": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--data_taxonomy": "dynamic",
                        "--location": "dynamic"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--data_taxonomy": "dynamic",
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--data_taxonomy": "dynamic",
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--data_taxonomy": "value",
                        "--location": "value",
                        "--member": "value",
                        "--role": "value"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--data_taxonomy": "value",
                        "--location": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--data-readers": "value",
                        "--data_taxonomy": "value",
                        "--description": "value",
                        "--display-name": "value",
                        "--etag": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--parent": "value",
                        "--resource-owners": "value",
                        "--resource-readers": "value",
                        "--resource-writers": "value",
                        "--validate-only": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--validate-only": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--etag": "value",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--etag": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            },
            "datascans": {
              "commands": {
                "create": {
                  "commands": {
                    "data-discovery": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bigquery-publishing-connection": "value",
                        "--bigquery-publishing-table-type": [
                          "BIGLAKE",
                          "EXTERNAL"
                        ],
                        "--data-source-resource": "value",
                        "--description": "value",
                        "--display-name": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--on-demand": "value",
                        "--schedule": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "data-profile": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--data-profile-spec-file": "value",
                        "--data-source-entity": "value",
                        "--data-source-resource": "value",
                        "--description": "value",
                        "--display-name": "value",
                        "--exclude-field-names": "value",
                        "--export-results-table": "value",
                        "--include-field-names": "value",
                        "--incremental-field": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--on-demand": "value",
                        "--row-filter": "value",
                        "--sampling-percent": "value",
                        "--schedule": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "data-quality": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--data-quality-spec-file": "value",
                        "--data-source-entity": "value",
                        "--data-source-resource": "value",
                        "--description": "value",
                        "--display-name": "value",
                        "--incremental-field": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--on-demand": "value",
                        "--schedule": "value",
                        "--validate-only": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic",
                    "--view": [
                      "basic",
                      "full"
                    ]
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "jobs": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--datascan": "dynamic",
                        "--location": "dynamic",
                        "--view": [
                          "basic",
                          "full"
                        ]
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--datascan": "dynamic",
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "run": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {
                    "data-discovery": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bigquery-publishing-connection": "value",
                        "--bigquery-publishing-table-type": "value",
                        "--description": "value",
                        "--display-name": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--on-demand": "value",
                        "--schedule": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "data-profile": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--data-profile-spec-file": "value",
                        "--description": "value",
                        "--display-name": "value",
                        "--exclude-field-names": "value",
                        "--include-field-names": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--on-demand": "value",
                        "--row-filter": "value",
                        "--sampling-percent": "value",
                        "--schedule": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "data-quality": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--data-quality-spec-file": "value",
                        "--description": "value",
                        "--display-name": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--on-demand": "value",
                        "--schedule": "value",
                        "--validate-only": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "entries": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--aspects": "value",
                    "--entry-group": "dynamic",
                    "--entry-source-ancestors": "value",
                    "--entry-source-create-time": "value",
                    "--entry-source-description": "value",
                    "--entry-source-display-name": "value",
                    "--entry-source-labels": "value",
                    "--entry-source-platform": "value",
                    "--entry-source-resource": "value",
                    "--entry-source-system": "value",
                    "--entry-source-update-time": "value",
                    "--entry-type": "value",
                    "--entry-type-location": "value",
                    "--entry-type-project": "value",
                    "--fully-qualified-name": "value",
                    "--location": "dynamic",
                    "--parent-entry": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--entry-group": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--aspect-types": "value",
                    "--entry-group": "dynamic",
                    "--location": "dynamic",
                    "--paths": "value",
                    "--view": [
                      "all",
                      "basic",
                      "custom",
                      "full"
                    ]
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--entry-group": "dynamic",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "lookup": {
                  "commands": {},
                  "flags": {
                    "--aspect-types": "value",
                    "--entry-group": "dynamic",
                    "--location": "dynamic",
                    "--paths": "value",
                    "--view": [
                      "all",
                      "basic",
                      "custom",
                      "full"
                    ]
                  }
                },
                "remove-aspects": {
                  "commands": {},
                  "flags": {
                    "--entry-group": "dynamic",
                    "--keys": "value",
                    "--location": "dynamic"
                  }
                },
                "search": {
                  "commands": {},
                  "flags": {
                    "--limit": "value",
                    "--order-by": "value",
                    "--page-size": "value",
                    "--scope": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-entry-source-create-time": "bool",
                    "--clear-entry-source-description": "bool",
                    "--clear-entry-source-display-name": "bool",
                    "--clear-entry-source-labels": "bool",
                    "--clear-entry-source-platform": "bool",
                    "--clear-entry-source-resource": "bool",
                    "--clear-entry-source-system": "bool",
                    "--clear-fully-qualified-name": "bool",
                    "--entry-group": "dynamic",
                    "--entry-source-create-time": "value",
                    "--entry-source-description": "value",
                    "--entry-source-display-name": "value",
                    "--entry-source-labels": "value",
                    "--entry-source-platform": "value",
                    "--entry-source-resource": "value",
                    "--entry-source-system": "value",
                    "--entry-source-update-time": "value",
                    "--fully-qualified-name": "value",
                    "--location": "dynamic",
                    "--remove-aspects": "value",
                    "--update-aspects": "value"
                  }
                },
                "update-aspects": {
                  "commands": {},
                  "flags": {
                    "--aspects": "value",
                    "--entry-group": "dynamic",
                    "--location": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "entry-groups": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--validate-only": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--etag": "value",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--etag": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            },
            "entry-types": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--platform": "value",
                    "--required-aspects": "value",
                    "--system": "value",
                    "--type-aliases": "value",
                    "--validate-only": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--etag": "value",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--etag": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--platform": "value",
                    "--required-aspects": "value",
                    "--system": "value",
                    "--type-aliases": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            },
            "environments": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--lake": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--compute-disk-size-gb": "value",
                    "--compute-max-node-count": "value",
                    "--compute-node-count": "value",
                    "--description": "value",
                    "--display-name": "value",
                    "--labels": "value",
                    "--lake": "value",
                    "--location": "value",
                    "--os-image-java-libraries": "value",
                    "--os-image-properties": "value",
                    "--os-image-python-packages": "value",
                    "--os-image-version": "value",
                    "--session-enable-fast-startup": "bool",
                    "--session-max-idle-duration": "value",
                    "--validate-only": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--lake": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--lake": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--lake": "dynamic",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--lake": "dynamic",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--lake": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "sessions": {
                  "commands": {
                    "list": {
                      "commands": {},
                      "flags": {
                        "--environment": "dynamic",
                        "--filter": "value",
                        "--lake": "dynamic",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--lake": "value",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--compute-disk-size-gb": "value",
                    "--compute-max-node-count": "value",
                    "--compute-node-count": "value",
                    "--description": "value",
                    "--display-name": "value",
                    "--labels": "value",
                    "--lake": "value",
                    "--location": "value",
                    "--os-image-java-libraries": "value",
                    "--os-image-properties": "value",
                    "--os-image-python-packages": "value",
                    "--os-image-version": "value",
                    "--session-enable-fast-startup": "bool",
                    "--session-max-idle-duration": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            },
            "lakes": {
              "commands": {
                "actions": {
                  "commands": {
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--lake": "dynamic",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "authorize": {
                  "commands": {},
                  "flags": {
                    "--bigquery-dataset-resource": "value",
                    "--project-resource": "value",
                    "--secondary-project": "value",
                    "--storage-bucket-resource": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--metastore-service": "value",
                    "--validate-only": "bool"
                  }
                },
                "deauthorize": {
                  "commands": {},
                  "flags": {
                    "--bigquery-dataset-resource": "value",
                    "--project-resource": "value",
                    "--secondary-project": "value",
                    "--storage-bucket-resource": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--metastore-service": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            },
            "tasks": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--lake": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--batch-executors-count": "value",
                    "--batch-max-executors-count": "value",
                    "--container-image": "value",
                    "--container-image-java-jars": "value",
                    "--container-image-properties": "value",
                    "--container-image-python-packages": "value",
                    "--description": "value",
                    "--display-name": "value",
                    "--execution-args": "value",
                    "--execution-project": "value",
                    "--execution-service-account": "value",
                    "--kms-key": "value",
                    "--labels": "value",
                    "--lake": "dynamic",
                    "--location": "dynamic",
                    "--max-job-execution-lifetime": "value",
                    "--notebook": "value",
                    "--notebook-archive-uris": "value",
                    "--notebook-batch-executors-count": "value",
                    "--notebook-batch-max-executors-count": "value",
                    "--notebook-container-image": "value",
                    "--notebook-container-image-java-jars": "value",
                    "--notebook-container-image-properties": "value",
                    "--notebook-file-uris": "value",
                    "--notebook-vpc-network-name": "value",
                    "--notebook-vpc-network-tags": "value",
                    "--notebook-vpc-sub-network-name": "value",
                    "--spark-archive-uris": "value",
                    "--spark-file-uris": "value",
                    "--spark-main-class": "value",
                    "--spark-main-jar-file-uri": "value",
                    "--spark-python-script-file": "value",
                    "--spark-sql-script": "value",
                    "--spark-sql-script-file": "value",
                    "--trigger-disabled": "bool",
                    "--trigger-max-retires": "value",
                    "--trigger-schedule": "value",
                    "--trigger-start-time": "value",
                    "--trigger-type": [
                      "on-demand",
                      "recurring"
                    ],
                    "--vpc-network-name": "value",
                    "--vpc-network-tags": "value",
                    "--vpc-sub-network-name": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--lake": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--lake": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--lake": "dynamic",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "jobs": {
                  "commands": {
                    "cancel": {
                      "commands": {},
                      "flags": {
                        "--lake": "dynamic",
                        "--location": "dynamic",
                        "--task": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--lake": "dynamic",
                        "--location": "dynamic",
                        "--task": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--lake": "dynamic",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--task": "dynamic",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--lake": "dynamic",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--lake": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "run": {
                  "commands": {},
                  "flags": {
                    "--labels": "value",
                    "--lake": "value",
                    "--location": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--lake": "value",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--batch-executors-count": "value",
                    "--batch-max-executors-count": "value",
                    "--clear-labels": "bool",
                    "--container-image": "value",
                    "--container-image-java-jars": "value",
                    "--container-image-properties": "value",
                    "--container-image-python-packages": "value",
                    "--description": "value",
                    "--display-name": "value",
                    "--execution-args": "value",
                    "--execution-project": "value",
                    "--execution-service-account": "value",
                    "--kms-key": "value",
                    "--lake": "dynamic",
                    "--location": "dynamic",
                    "--max-job-execution-lifetime": "value",
                    "--notebook": "value",
                    "--notebook-archive-uris": "value",
                    "--notebook-batch-executors-count": "value",
                    "--notebook-batch-max-executors-count": "value",
                    "--notebook-container-image": "value",
                    "--notebook-container-image-java-jars": "value",
                    "--notebook-container-image-properties": "value",
                    "--notebook-file-uris": "value",
                    "--notebook-vpc-network-name": "value",
                    "--notebook-vpc-network-tags": "value",
                    "--notebook-vpc-sub-network-name": "value",
                    "--remove-labels": "value",
                    "--spark-archive-uris": "value",
                    "--spark-file-uris": "value",
                    "--spark-main-class": "value",
                    "--spark-main-jar-file-uri": "value",
                    "--spark-python-script-file": "value",
                    "--spark-sql-script": "value",
                    "--spark-sql-script-file": "value",
                    "--trigger-disabled": "bool",
                    "--trigger-max-retires": "value",
                    "--trigger-schedule": "value",
                    "--trigger-start-time": "value",
                    "--update-labels": "value",
                    "--vpc-network-name": "value",
                    "--vpc-network-tags": "value",
                    "--vpc-sub-network-name": "value"
                  }
                }
              },
              "flags": {}
            },
            "zones": {
              "commands": {
                "actions": {
                  "commands": {
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--lake": "dynamic",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--lake": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--csv-delimiter": "value",
                    "--csv-disable-type-inference": "bool",
                    "--csv-encoding": "value",
                    "--csv-header-rows": "value",
                    "--description": "value",
                    "--discovery-enabled": "bool",
                    "--discovery-exclude-patterns": "value",
                    "--discovery-include-patterns": "value",
                    "--discovery-schedule": "value",
                    "--display-name": "value",
                    "--json-disable-type-inference": "bool",
                    "--json-encoding": "value",
                    "--labels": "value",
                    "--lake": "value",
                    "--location": "value",
                    "--resource-location-type": [
                      "MULTI_REGION",
                      "SINGLE_REGION"
                    ],
                    "--type": [
                      "CURATED",
                      "RAW"
                    ],
                    "--validate-only": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--lake": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--lake": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--lake": "dynamic",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--lake": "dynamic",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--lake": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--lake": "value",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--csv-delimiter": "value",
                    "--csv-disable-type-inference": "bool",
                    "--csv-encoding": "value",
                    "--csv-header-rows": "value",
                    "--description": "value",
                    "--discovery-enabled": "bool",
                    "--discovery-exclude-patterns": "value",
                    "--discovery-include-patterns": "value",
                    "--discovery-schedule": "value",
                    "--display-name": "value",
                    "--json-disable-type-inference": "bool",
                    "--json-encoding": "value",
                    "--labels": "value",
                    "--lake": "value",
                    "--location": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "dataproc": {
          "commands": {
            "autoscaling-policies": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--region": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--region": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                }
              },
              "flags": {}
            },
            "clusters": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--autoscaling-policy": "value",
                    "--bucket": "value",
                    "--dataproc-metastore": "value",
                    "--driver-pool-accelerator": "value",
                    "--driver-pool-boot-disk-size": "value",
                    "--driver-pool-boot-disk-type": "value",
                    "--driver-pool-id": "value",
                    "--driver-pool-local-ssd-interface": "value",
                    "--driver-pool-machine-type": "value",
                    "--driver-pool-min-cpu-platform": "value",
                    "--driver-pool-size": "value",
                    "--enable-component-gateway": "bool",
                    "--enable-kerberos": "bool",
                    "--expiration-time": "value",
                    "--gce-pd-kms-key": "dynamic",
                    "--gce-pd-kms-key-keyring": "dynamic",
                    "--gce-pd-kms-key-location": "dynamic",
                    "--gce-pd-kms-key-project": "dynamic",
                    "--image": "value",
                    "--image-version": "value",
                    "--initialization-action-timeout": "value",
                    "--initialization-actions": "value",
                    "--kerberos-config-file": "value",
                    "--kerberos-kms-key": "dynamic",
                    "--kerberos-kms-key-keyring": "dynamic",
                    "--kerberos-kms-key-location": "dynamic",
                    "--kerberos-kms-key-project": "dynamic",
                    "--kerberos-root-principal-password-uri": "value",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--master-accelerator": "value",
                    "--master-boot-disk-provisioned-iops": "value",
                    "--master-boot-disk-provisioned-throughput": "value",
                    "--master-boot-disk-size": "value",
                    "--master-boot-disk-type": "value",
                    "--master-local-ssd-interface": "value",
                    "--master-machine-type": "value",
                    "--master-min-cpu-platform": "value",
                    "--max-age": "value",
                    "--max-idle": "value",
                    "--metadata": "value",
                    "--min-num-workers": "value",
                    "--min-secondary-worker-fraction": "value",
                    "--network": "value",
                    "--no-address": "bool",
                    "--node-group": "value",
                    "--num-driver-pool-local-ssds": "value",
                    "--num-master-local-ssds": "value",
                    "--num-masters": "value",
                    "--num-secondary-worker-local-ssds": "value",
                    "--num-secondary-workers": "value",
                    "--num-worker-local-ssds": "value",
                    "--num-workers": "value",
                    "--optional-components": "value",
                    "--private-ipv6-google-access-type": [
                      "bidirectional",
                      "inherit-subnetwork",
                      "outbound"
                    ],
                    "--properties": "value",
                    "--public-ip-address": "bool",
                    "--region": "value",
                    "--reservation": "value",
                    "--reservation-affinity": [
                      "any",
                      "none",
                      "specific"
                    ],
                    "--scopes": "value",
                    "--secondary-worker-accelerator": "value",
                    "--secondary-worker-boot-disk-size": "value",
                    "--secondary-worker-boot-disk-type": "value",
                    "--secondary-worker-local-ssd-interface": "value",
                    "--secondary-worker-machine-types": "value",
                    "--secondary-worker-standard-capacity-base": "value",
                    "--secondary-worker-standard-capacity-percent-above-base": "value",
                    "--secondary-worker-type": [
                      "non-preemptible",
                      "preemptible",
                      "spot"
                    ],
                    "--service-account": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-secure-boot": "bool",
                    "--shielded-vtpm": "bool",
                    "--single-node": "bool",
                    "--subnet": "value",
                    "--tags": "value",
                    "--temp-bucket": "value",
                    "--worker-accelerator": "value",
                    "--worker-boot-disk-provisioned-iops": "value",
                    "--worker-boot-disk-provisioned-throughput": "value",
                    "--worker-boot-disk-size": "value",
                    "--worker-boot-disk-type": "value",
                    "--worker-local-ssd-interface": "value",
                    "--worker-machine-type": "value",
                    "--worker-machine-types": "value",
                    "--worker-min-cpu-platform": "value",
                    "--zone": "value"
                  }
                },
                "create-from-file": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--file": "value",
                    "--region": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "diagnose": {
                  "commands": {},
                  "flags": {
                    "--end-time": "value",
                    "--job-ids": "value",
                    "--region": "value",
                    "--start-time": "value",
                    "--tarball-access": [
                      "GOOGLE_CLOUD_SUPPORT",
                      "GOOGLE_DATAPROC_DIAGNOSE"
                    ],
                    "--yarn-application-ids": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--region": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "gke": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--gke-cluster": "value",
                        "--gke-cluster-location": "value",
                        "--history-server-cluster": "value",
                        "--history-server-cluster-region": "value",
                        "--metastore-service": "value",
                        "--metastore-service-location": "value",
                        "--namespace": "value",
                        "--pools": "value",
                        "--properties": "value",
                        "--region": "value",
                        "--setup-workload-identity": "bool",
                        "--spark-engine-version": "value",
                        "--staging-bucket": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "start": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "stop": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--autoscaling-policy": "value",
                    "--clear-labels": "bool",
                    "--disable-autoscaling": "bool",
                    "--expiration-time": "value",
                    "--graceful-decommission-timeout": "value",
                    "--max-age": "value",
                    "--max-idle": "value",
                    "--min-secondary-worker-fraction": "value",
                    "--no-max-age": "bool",
                    "--no-max-idle": "bool",
                    "--num-secondary-workers": "value",
                    "--num-workers": "value",
                    "--region": "value",
                    "--remove-labels": "value",
                    "--secondary-worker-standard-capacity-base": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "jobs": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "kill": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--state-filter": [
                      "active",
                      "inactive"
                    ]
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "submit": {
                  "commands": {
                    "flink": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bucket": "value",
                        "--class": "value",
                        "--cluster": "value",
                        "--cluster-labels": "value",
                        "--driver-log-levels": "value",
                        "--driver-required-memory-mb": "value",
                        "--driver-required-vcores": "value",
                        "--jar": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--max-failures-per-hour": "value",
                        "--max-failures-total": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value",
                        "--savepoint": "value"
                      }
                    },
                    "hadoop": {
                      "commands": {},
                      "flags": {
                        "--archives": "value",
                        "--async": "bool",
                        "--bucket": "value",
                        "--class": "value",
                        "--cluster": "value",
                        "--cluster-labels": "value",
                        "--driver-log-levels": "value",
                        "--driver-required-memory-mb": "value",
                        "--driver-required-vcores": "value",
                        "--files": "value",
                        "--jar": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--max-failures-per-hour": "value",
                        "--max-failures-total": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value"
                      }
                    },
                    "hive": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bucket": "value",
                        "--cluster": "value",
                        "--cluster-labels": "value",
                        "--continue-on-failure": "bool",
                        "--driver-required-memory-mb": "value",
                        "--driver-required-vcores": "value",
                        "--execute": "value",
                        "--file": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--max-failures-per-hour": "value",
                        "--max-failures-total": "value",
                        "--params": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value"
                      }
                    },
                    "pig": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bucket": "value",
                        "--cluster": "value",
                        "--cluster-labels": "value",
                        "--continue-on-failure": "bool",
                        "--driver-log-levels": "value",
                        "--driver-required-memory-mb": "value",
                        "--driver-required-vcores": "value",
                        "--execute": "value",
                        "--file": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--max-failures-per-hour": "value",
                        "--max-failures-total": "value",
                        "--params": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value"
                      }
                    },
                    "presto": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bucket": "value",
                        "--client-tags": "value",
                        "--cluster": "value",
                        "--cluster-labels": "value",
                        "--continue-on-failure": "bool",
                        "--driver-log-levels": "value",
                        "--driver-required-memory-mb": "value",
                        "--driver-required-vcores": "value",
                        "--execute": "value",
                        "--file": "value",
                        "--labels": "value",
                        "--max-failures-per-hour": "value",
                        "--max-failures-total": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--query-output-format": "value",
                        "--region": "value"
                      }
                    },
                    "pyspark": {
                      "commands": {},
                      "flags": {
                        "--archives": "value",
                        "--async": "bool",
                        "--bucket": "value",
                        "--cluster": "value",
                        "--cluster-labels": "value",
                        "--driver-log-levels": "value",
                        "--driver-required-memory-mb": "value",
                        "--driver-required-vcores": "value",
                        "--files": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--max-failures-per-hour": "value",
                        "--max-failures-total": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--py-files": "value",
                        "--region": "value"
                      }
                    },
                    "spark": {
                      "commands": {},
                      "flags": {
                        "--archives": "value",
                        "--async": "bool",
                        "--bucket": "value",
                        "--class": "value",
                        "--cluster": "value",
                        "--cluster-labels": "value",
                        "--driver-log-levels": "value",
                        "--driver-required-memory-mb": "value",
                        "--driver-required-vcores": "value",
                        "--files": "value",
                        "--jar": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--max-failures-per-hour": "value",
                        "--max-failures-total": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value"
                      }
                    },
                    "spark-r": {
                      "commands": {},
                      "flags": {
                        "--archives": "value",
                        "--async": "bool",
                        "--bucket": "value",
                        "--cluster": "value",
                        "--cluster-labels": "value",
                        "--driver-log-levels": "value",
                        "--driver-required-memory-mb": "value",
                        "--driver-required-vcores": "value",
                        "--files": "value",
                        "--labels": "value",
                        "--max-failures-per-hour": "value",
                        "--max-failures-total": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value"
                      }
                    },
                    "spark-sql": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bucket": "value",
                        "--cluster": "value",
                        "--cluster-labels": "value",
                        "--driver-log-levels": "value",
                        "--driver-required-memory-mb": "value",
                        "--driver-required-vcores": "value",
                        "--execute": "value",
                        "--file": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--max-failures-per-hour": "value",
                        "--max-failures-total": "value",
                        "--params": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value"
                      }
                    },
                    "trino": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bucket": "value",
                        "--client-tags": "value",
                        "--cluster": "value",
                        "--cluster-labels": "value",
                        "--continue-on-failure": "bool",
                        "--driver-log-levels": "value",
                        "--driver-required-memory-mb": "value",
                        "--driver-required-vcores": "value",
                        "--execute": "value",
                        "--file": "value",
                        "--labels": "value",
                        "--max-failures-per-hour": "value",
                        "--max-failures-total": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--query-output-format": "value",
                        "--region": "value"
                      }
                    }
                  },
                  "flags": {
                    "--async": "bool",
                    "--bucket": "value",
                    "--region": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--region": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                }
              },
              "flags": {}
            },
            "node-groups": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--region": "value"
                  }
                },
                "resize": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--graceful-decommission-timeout": "value",
                    "--region": "value",
                    "--size": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--state-filter": [
                      "active",
                      "inactive"
                    ]
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                }
              },
              "flags": {}
            },
            "workflow-templates": {
              "commands": {
                "add-job": {
                  "commands": {
                    "hadoop": {
                      "commands": {},
                      "flags": {
                        "--archives": "value",
                        "--class": "value",
                        "--driver-log-levels": "value",
                        "--files": "value",
                        "--jar": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value",
                        "--start-after": "value",
                        "--step-id": "value",
                        "--workflow-template": "value"
                      }
                    },
                    "hive": {
                      "commands": {},
                      "flags": {
                        "--continue-on-failure": "bool",
                        "--execute": "value",
                        "--file": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--params": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value",
                        "--start-after": "value",
                        "--step-id": "value",
                        "--workflow-template": "value"
                      }
                    },
                    "pig": {
                      "commands": {},
                      "flags": {
                        "--continue-on-failure": "bool",
                        "--driver-log-levels": "value",
                        "--execute": "value",
                        "--file": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--params": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value",
                        "--start-after": "value",
                        "--step-id": "value",
                        "--workflow-template": "value"
                      }
                    },
                    "presto": {
                      "commands": {},
                      "flags": {
                        "--client-tags": "value",
                        "--continue-on-failure": "bool",
                        "--driver-log-levels": "value",
                        "--execute": "value",
                        "--file": "value",
                        "--labels": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--query-output-format": "value",
                        "--region": "value",
                        "--start-after": "value",
                        "--step-id": "value",
                        "--workflow-template": "value"
                      }
                    },
                    "pyspark": {
                      "commands": {},
                      "flags": {
                        "--archives": "value",
                        "--driver-log-levels": "value",
                        "--files": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--py-files": "value",
                        "--region": "value",
                        "--start-after": "value",
                        "--step-id": "value",
                        "--workflow-template": "value"
                      }
                    },
                    "spark": {
                      "commands": {},
                      "flags": {
                        "--archives": "value",
                        "--class": "value",
                        "--driver-log-levels": "value",
                        "--files": "value",
                        "--jar": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value",
                        "--start-after": "value",
                        "--step-id": "value",
                        "--workflow-template": "value"
                      }
                    },
                    "spark-r": {
                      "commands": {},
                      "flags": {
                        "--archives": "value",
                        "--driver-log-levels": "value",
                        "--files": "value",
                        "--labels": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value",
                        "--start-after": "value",
                        "--step-id": "value",
                        "--workflow-template": "value"
                      }
                    },
                    "spark-sql": {
                      "commands": {},
                      "flags": {
                        "--driver-log-levels": "value",
                        "--execute": "value",
                        "--file": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--params": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value",
                        "--start-after": "value",
                        "--step-id": "value",
                        "--workflow-template": "value"
                      }
                    },
                    "trino": {
                      "commands": {},
                      "flags": {
                        "--client-tags": "value",
                        "--continue-on-failure": "bool",
                        "--driver-log-levels": "value",
                        "--execute": "value",
                        "--file": "value",
                        "--labels": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--query-output-format": "value",
                        "--region": "value",
                        "--start-after": "value",
                        "--step-id": "value",
                        "--workflow-template": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--dag-timeout": "value",
                    "--kms-key": "value",
                    "--labels": "value",
                    "--region": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--region": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--region": "value",
                    "--source": "value"
                  }
                },
                "instantiate": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--parameters": "value",
                    "--region": "value"
                  }
                },
                "instantiate-from-file": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--file": "value",
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-dag-timeout": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "remove-job": {
                  "commands": {},
                  "flags": {
                    "--region": "value",
                    "--step-id": "value"
                  }
                },
                "run": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "set-cluster-selector": {
                  "commands": {},
                  "flags": {
                    "--cluster-labels": "value",
                    "--region": "value"
                  }
                },
                "set-dag-timeout": {
                  "commands": {},
                  "flags": {
                    "--dag-timeout": "value",
                    "--region": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "set-managed-cluster": {
                  "commands": {},
                  "flags": {
                    "--autoscaling-policy": "value",
                    "--bucket": "value",
                    "--cluster-name": "value",
                    "--dataproc-metastore": "value",
                    "--enable-component-gateway": "bool",
                    "--enable-kerberos": "bool",
                    "--image": "value",
                    "--image-version": "value",
                    "--initialization-action-timeout": "value",
                    "--initialization-actions": "value",
                    "--kerberos-config-file": "value",
                    "--kerberos-kms-key": "dynamic",
                    "--kerberos-kms-key-keyring": "dynamic",
                    "--kerberos-kms-key-location": "dynamic",
                    "--kerberos-kms-key-project": "dynamic",
                    "--kerberos-root-principal-password-uri": "value",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--master-accelerator": "value",
                    "--master-boot-disk-provisioned-iops": "value",
                    "--master-boot-disk-provisioned-throughput": "value",
                    "--master-boot-disk-size": "value",
                    "--master-boot-disk-type": "value",
                    "--master-local-ssd-interface": "value",
                    "--master-machine-type": "value",
                    "--master-min-cpu-platform": "value",
                    "--metadata": "value",
                    "--min-num-workers": "value",
                    "--min-secondary-worker-fraction": "value",
                    "--network": "value",
                    "--no-address": "bool",
                    "--node-group": "value",
                    "--num-master-local-ssds": "value",
                    "--num-masters": "value",
                    "--num-secondary-worker-local-ssds": "value",
                    "--num-secondary-workers": "value",
                    "--num-worker-local-ssds": "value",
                    "--num-workers": "value",
                    "--optional-components": "value",
                    "--private-ipv6-google-access-type": [
                      "bidirectional",
                      "inherit-subnetwork",
                      "outbound"
                    ],
                    "--properties": "value",
                    "--public-ip-address": "bool",
                    "--region": "value",
                    "--reservation": "value",
                    "--reservation-affinity": [
                      "any",
                      "none",
                      "specific"
                    ],
                    "--scopes": "value",
                    "--secondary-worker-accelerator": "value",
                    "--secondary-worker-boot-disk-size": "value",
                    "--secondary-worker-boot-disk-type": "value",
                    "--secondary-worker-local-ssd-interface": "value",
                    "--secondary-worker-machine-types": "value",
                    "--secondary-worker-standard-capacity-base": "value",
                    "--secondary-worker-standard-capacity-percent-above-base": "value",
                    "--secondary-worker-type": [
                      "non-preemptible",
                      "preemptible",
                      "spot"
                    ],
                    "--service-account": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-secure-boot": "bool",
                    "--shielded-vtpm": "bool",
                    "--single-node": "bool",
                    "--subnet": "value",
                    "--tags": "value",
                    "--temp-bucket": "value",
                    "--worker-accelerator": "value",
                    "--worker-boot-disk-provisioned-iops": "value",
                    "--worker-boot-disk-provisioned-throughput": "value",
                    "--worker-boot-disk-size": "value",
                    "--worker-boot-disk-type": "value",
                    "--worker-local-ssd-interface": "value",
                    "--worker-machine-type": "value",
                    "--worker-machine-types": "value",
                    "--worker-min-cpu-platform": "value",
                    "--zone": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "datastore": {
          "commands": {
            "export": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--kinds": "value",
                "--namespaces": "value",
                "--operation-labels": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--kinds": "value",
                "--namespaces": "value",
                "--operation-labels": "value"
              }
            },
            "indexes": {
              "commands": {
                "cleanup": {
                  "commands": {},
                  "flags": {
                    "--database": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--database": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "deploy": {
          "commands": {
            "apply": {
              "commands": {},
              "flags": {
                "--file": "value",
                "--region": "value"
              }
            },
            "automation-runs": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "automations": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--region": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--destination": "value",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "custom-target-types": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--region": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "delete": {
              "commands": {},
              "flags": {
                "--file": "value",
                "--force": "bool",
                "--region": "value"
              }
            },
            "delivery-pipelines": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--force": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--region": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "deploy-policies": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "get-config": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "job-runs": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--region": "dynamic",
                    "--release": "dynamic",
                    "--rollout": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--release": "dynamic",
                    "--rollout": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "terminate": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--region": "dynamic",
                    "--release": "dynamic",
                    "--rollout": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "releases": {
              "commands": {
                "abandon": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--region": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--annotations": "value",
                    "--build-artifacts": "value",
                    "--delivery-pipeline": "dynamic",
                    "--deploy-parameters": "value",
                    "--description": "value",
                    "--disable-initial-rollout": "bool",
                    "--enable-initial-rollout": "bool",
                    "--from-k8s-manifest": "value",
                    "--from-run-manifest": "value",
                    "--gcs-source-staging-dir": "value",
                    "--ignore-file": "value",
                    "--images": "value",
                    "--initial-rollout-annotations": "value",
                    "--initial-rollout-labels": "value",
                    "--initial-rollout-phase-id": "value",
                    "--labels": "value",
                    "--region": "dynamic",
                    "--skaffold-file": "value",
                    "--skaffold-version": "value",
                    "--source": "value",
                    "--to-target": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "promote": {
                  "commands": {},
                  "flags": {
                    "--annotations": "value",
                    "--delivery-pipeline": "dynamic",
                    "--labels": "value",
                    "--region": "dynamic",
                    "--release": "dynamic",
                    "--rollout-id": "value",
                    "--starting-phase-id": "value",
                    "--to-target": "value"
                  }
                }
              },
              "flags": {}
            },
            "rollouts": {
              "commands": {
                "advance": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--phase-id": "value",
                    "--region": "dynamic",
                    "--release": "dynamic"
                  }
                },
                "approve": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--region": "dynamic",
                    "--release": "dynamic"
                  }
                },
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--region": "dynamic",
                    "--release": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--region": "dynamic",
                    "--release": "dynamic"
                  }
                },
                "ignore-job": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--job-id": "value",
                    "--phase-id": "value",
                    "--region": "dynamic",
                    "--release": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--release": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "reject": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--region": "dynamic",
                    "--release": "dynamic"
                  }
                },
                "retry-job": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--job-id": "value",
                    "--phase-id": "value",
                    "--region": "dynamic",
                    "--release": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "targets": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "value",
                    "--list-all-pipelines": "bool",
                    "--region": "dynamic",
                    "--skip-pipeline-lookup": "bool"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--region": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "redeploy": {
                  "commands": {},
                  "flags": {
                    "--annotations": "value",
                    "--delivery-pipeline": "value",
                    "--description": "value",
                    "--labels": "value",
                    "--region": "dynamic",
                    "--rollout-id": "value",
                    "--starting-phase-id": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "dynamic"
                  }
                },
                "rollback": {
                  "commands": {},
                  "flags": {
                    "--annotations": "value",
                    "--delivery-pipeline": "value",
                    "--description": "value",
                    "--labels": "value",
                    "--region": "dynamic",
                    "--release": "value",
                    "--rollback-of-rollout": "value",
                    "--rollout-id": "value",
                    "--starting-phase-id": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "deployment-manager": {
          "commands": {
            "deployments": {
              "commands": {
                "cancel-preview": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--fingerprint": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--automatic-rollback-on-error": "bool",
                    "--composite-type": "value",
                    "--config": "value",
                    "--create-policy": [
                      "acquire",
                      "create",
                      "create-or-acquire"
                    ],
                    "--credential": "value",
                    "--description": "value",
                    "--labels": "value",
                    "--preview": "bool",
                    "--properties": "value",
                    "--template": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--delete-policy": [
                      "abandon",
                      "delete"
                    ]
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--simple-list": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "stop": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--fingerprint": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--composite-type": "value",
                    "--config": "value",
                    "--create-policy": [
                      "acquire",
                      "create",
                      "create-or-acquire"
                    ],
                    "--credential": "value",
                    "--delete-policy": [
                      "abandon",
                      "delete"
                    ],
                    "--description": "value",
                    "--fingerprint": "value",
                    "--manifest-id": "value",
                    "--preview": "bool",
                    "--properties": "value",
                    "--remove-labels": "value",
                    "--template": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "manifests": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--deployment": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--deployment": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--simple-list": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--simple-list": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "resources": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--deployment": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--deployment": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--simple-list": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {
                "--deployment": "value"
              }
            },
            "type-providers": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--api-options-file": "value",
                    "--async": "bool",
                    "--custom-certificate-authority-roots": "value",
                    "--description": "value",
                    "--descriptor-url": "value",
                    "--labels": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--api-options-file": "value",
                    "--async": "bool",
                    "--custom-certificate-authority-roots": "value",
                    "--description": "value",
                    "--descriptor-url": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "types": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--status": [
                      "DEPRECATED",
                      "EXPERIMENTAL",
                      "SUPPORTED"
                    ],
                    "--template": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--provider": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--provider": "value",
                    "--provider-project": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--remove-labels": "value",
                    "--status": [
                      "DEPRECATED",
                      "EXPERIMENTAL",
                      "SUPPORTED"
                    ],
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "developer-connect": {
          "commands": {
            "connections": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--annotations": "value",
                    "--async": "bool",
                    "--crypto-key-config-reference": "value",
                    "--disabled": "bool",
                    "--etag": "value",
                    "--github-config-app": [
                      "developer-connect",
                      "firebase"
                    ],
                    "--github-config-app-installation-id": "value",
                    "--github-config-authorizer-credential-oauth-token-secret-version": "value",
                    "--github-enterprise-config-app-id": "value",
                    "--github-enterprise-config-app-installation-id": "value",
                    "--github-enterprise-config-host-uri": "value",
                    "--github-enterprise-config-private-key-secret-version": "value",
                    "--github-enterprise-config-service-directory": "value",
                    "--github-enterprise-config-ssl-ca-certificate": "value",
                    "--github-enterprise-config-webhook-secret-version": "value",
                    "--gitlab-config-authorizer-credential-user-token-secret-version": "value",
                    "--gitlab-config-read-authorizer-credential-user-token-secret-version": "value",
                    "--gitlab-config-webhook-secret-version": "value",
                    "--gitlab-enterprise-config-authorizer-credential-user-token-secret-version": "value",
                    "--gitlab-enterprise-config-host-uri": "value",
                    "--gitlab-enterprise-config-read-authorizer-credential-user-token-secret-version": "value",
                    "--gitlab-enterprise-config-service-directory": "value",
                    "--gitlab-enterprise-config-ssl-ca-certificate": "value",
                    "--gitlab-enterprise-config-webhook-secret-version": "value",
                    "--key-ring": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--namespace": "value",
                    "--request-id": "value",
                    "--secret": "value",
                    "--validate-only": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--etag": "value",
                    "--location": "dynamic",
                    "--request-id": "value",
                    "--validate-only": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "git-repository-links": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--annotations": "value",
                        "--async": "bool",
                        "--clone-uri": "value",
                        "--connection": "dynamic",
                        "--etag": "value",
                        "--labels": "value",
                        "--location": "dynamic",
                        "--request-id": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--connection": "dynamic",
                        "--etag": "value",
                        "--location": "dynamic",
                        "--request-id": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--connection": "dynamic",
                        "--location": "dynamic"
                      }
                    },
                    "fetch-read-token": {
                      "commands": {},
                      "flags": {
                        "--connection": "dynamic",
                        "--location": "dynamic"
                      }
                    },
                    "fetch-read-write-token": {
                      "commands": {},
                      "flags": {
                        "--connection": "dynamic",
                        "--location": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--connection": "dynamic",
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--allow-missing": "bool",
                    "--annotations": "value",
                    "--async": "bool",
                    "--clear-annotations": "bool",
                    "--clear-github-enterprise-config-private-key-secret-version": "bool",
                    "--clear-github-enterprise-config-webhook-secret-version": "bool",
                    "--clear-labels": "bool",
                    "--crypto-key-config-reference": "value",
                    "--disabled": "bool",
                    "--etag": "value",
                    "--github-config-app-installation-id": "value",
                    "--github-config-authorizer-credential-oauth-token-secret-version": "value",
                    "--github-enterprise-config-app-id": "value",
                    "--github-enterprise-config-app-installation-id": "value",
                    "--github-enterprise-config-host-uri": "value",
                    "--github-enterprise-config-private-key-secret-version": "value",
                    "--github-enterprise-config-service-directory": "value",
                    "--github-enterprise-config-ssl-ca-certificate": "value",
                    "--github-enterprise-config-webhook-secret-version": "value",
                    "--gitlab-config-authorizer-credential-user-token-secret-version": "value",
                    "--gitlab-config-read-authorizer-credential-user-token-secret-version": "value",
                    "--gitlab-enterprise-config-authorizer-credential-user-token-secret-version": "value",
                    "--gitlab-enterprise-config-host-uri": "value",
                    "--gitlab-enterprise-config-read-authorizer-credential-user-token-secret-version": "value",
                    "--gitlab-enterprise-config-service-directory": "value",
                    "--gitlab-enterprise-config-ssl-ca-certificate": "value",
                    "--key-ring": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--namespace": "value",
                    "--remove-annotations": "value",
                    "--remove-labels": "value",
                    "--request-id": "value",
                    "--secret": "value",
                    "--update-annotations": "value",
                    "--update-labels": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "dialogflow": {
          "commands": {
            "agent": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--destination": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--replace-all": "bool",
                    "--source": "value"
                  }
                },
                "query": {
                  "commands": {},
                  "flags": {
                    "--audio-encoding": [
                      "audio-encoding-alaw",
                      "audio-encoding-amr",
                      "audio-encoding-amr-wb",
                      "audio-encoding-flac",
                      "audio-encoding-linear-16",
                      "audio-encoding-mulaw",
                      "audio-encoding-ogg-opus",
                      "audio-encoding-speex-with-header-byte",
                      "audio-encoding-unspecified"
                    ],
                    "--language": "value",
                    "--query-audio-file": "value",
                    "--query-text": "value",
                    "--sample-rate": "value",
                    "--session": "value"
                  }
                },
                "train": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                }
              },
              "flags": {}
            },
            "entity-types": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--auto-expand": "bool",
                    "--display-name": "value",
                    "--entities": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-entities": "value",
                    "--auto-expand": "bool",
                    "--clear-entities": "bool",
                    "--display-name": "value",
                    "--remove-entities": "value"
                  }
                }
              },
              "flags": {}
            },
            "intents": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--display-name": "value",
                    "--is-fallback": "bool",
                    "--ml-enabled": "bool",
                    "--other-properties": "value",
                    "--priority": "value",
                    "--responses": "value",
                    "--training-phrases": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--is-fallback": "bool",
                    "--ml-enabled": "bool",
                    "--other-properties": "value",
                    "--priority": "value",
                    "--responses": "value",
                    "--training-phrases": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "dlp": {
          "commands": {
            "datasources": {
              "commands": {
                "bigquery": {
                  "commands": {
                    "analyze": {
                      "commands": {},
                      "flags": {
                        "--categorical-stat-field": "value",
                        "--job-id": "value",
                        "--numerical-stat-field": "value",
                        "--output-table": "value",
                        "--output-topics": "value",
                        "--quasi-ids": "value",
                        "--sensitive-attribute": "value"
                      }
                    },
                    "inspect": {
                      "commands": {},
                      "flags": {
                        "--exclude-info-types": "bool",
                        "--identifying-fields": "value",
                        "--include-quote": "bool",
                        "--info-types": "value",
                        "--job-id": "value",
                        "--max-findings": "value",
                        "--max-findings-per-item": "value",
                        "--max-time": "value",
                        "--min-likelihood": [
                          "likely",
                          "possible",
                          "unlikely",
                          "very-likely",
                          "very-unlikely"
                        ],
                        "--min-time": "value",
                        "--output-table": "value",
                        "--output-topics": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "datastore": {
                  "commands": {
                    "inspect": {
                      "commands": {},
                      "flags": {
                        "--exclude-info-types": "bool",
                        "--include-quote": "bool",
                        "--info-types": "value",
                        "--job-id": "value",
                        "--max-findings": "value",
                        "--max-findings-per-item": "value",
                        "--max-time": "value",
                        "--min-likelihood": [
                          "likely",
                          "possible",
                          "unlikely",
                          "very-likely",
                          "very-unlikely"
                        ],
                        "--min-time": "value",
                        "--output-table": "value",
                        "--output-topics": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "gcs": {
                  "commands": {
                    "inspect": {
                      "commands": {},
                      "flags": {
                        "--exclude-info-types": "bool",
                        "--file-size-limit": "value",
                        "--include-quote": "bool",
                        "--info-types": "value",
                        "--job-id": "value",
                        "--max-findings": "value",
                        "--max-findings-per-item": "value",
                        "--max-time": "value",
                        "--min-likelihood": [
                          "likely",
                          "possible",
                          "unlikely",
                          "very-likely",
                          "very-unlikely"
                        ],
                        "--min-time": "value",
                        "--output-table": "value",
                        "--output-topics": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "images": {
              "commands": {
                "inspect": {
                  "commands": {},
                  "flags": {
                    "--exclude-info-types": "bool",
                    "--include-quote": "bool",
                    "--info-types": "value",
                    "--max-findings": "value",
                    "--min-likelihood": [
                      "likely",
                      "possible",
                      "unlikely",
                      "very-likely",
                      "very-unlikely"
                    ]
                  }
                },
                "redact": {
                  "commands": {},
                  "flags": {
                    "--include-quote": "bool",
                    "--info-types": "value",
                    "--min-likelihood": [
                      "likely",
                      "possible",
                      "unlikely",
                      "very-likely",
                      "very-unlikely"
                    ],
                    "--output-file": "value",
                    "--redact-all-text": "bool",
                    "--redact-color": "value"
                  }
                }
              },
              "flags": {}
            },
            "job-triggers": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--datastore-kind": "value",
                    "--description": "value",
                    "--display-name": "value",
                    "--exclude-info-types": "bool",
                    "--include-quote": "bool",
                    "--info-types": "value",
                    "--input-table": "value",
                    "--max-findings": "value",
                    "--max-findings-per-item": "value",
                    "--min-likelihood": [
                      "likely",
                      "possible",
                      "unlikely",
                      "very-likely",
                      "very-unlikely"
                    ],
                    "--output-table": "value",
                    "--output-topics": "value",
                    "--path": "value",
                    "--trigger-schedule": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "jobs": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--job-type": [
                      "inspect",
                      "risk-analysis"
                    ],
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "text": {
              "commands": {
                "inspect": {
                  "commands": {},
                  "flags": {
                    "--content": "value",
                    "--content-file": "value",
                    "--exclude-info-types": "bool",
                    "--include-quote": "bool",
                    "--info-types": "value",
                    "--max-findings": "value",
                    "--min-likelihood": [
                      "likely",
                      "possible",
                      "unlikely",
                      "very-likely",
                      "very-unlikely"
                    ]
                  }
                },
                "redact": {
                  "commands": {},
                  "flags": {
                    "--content": "value",
                    "--content-file": "value",
                    "--info-types": "value",
                    "--min-likelihood": [
                      "likely",
                      "possible",
                      "unlikely",
                      "very-likely",
                      "very-unlikely"
                    ],
                    "--output-file": "value",
                    "--remove-findings": "bool",
                    "--replace-with-info-type": "bool",
                    "--replacement-text": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "dns": {
          "commands": {
            "active-peering-zones": {
              "commands": {},
              "flags": {}
            },
            "dns-keys": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--sort-by": "value",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "managed-zones": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--denial-of-existence": [
                      "nsec",
                      "nsec3"
                    ],
                    "--description": "value",
                    "--dns-name": "value",
                    "--dnssec-state": [
                      "off",
                      "on",
                      "transfer"
                    ],
                    "--forwarding-targets": "value",
                    "--gkeclusters": "value",
                    "--ksk-algorithm": [
                      "ecdsap256sha256",
                      "ecdsap384sha384",
                      "rsasha1",
                      "rsasha256",
                      "rsasha512"
                    ],
                    "--ksk-key-length": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--log-dns-queries": "bool",
                    "--managed-reverse-lookup": "bool",
                    "--networks": "value",
                    "--private-forwarding-targets": "value",
                    "--service-directory-namespace": "value",
                    "--target-network": "value",
                    "--target-project": "value",
                    "--visibility": [
                      "private",
                      "public"
                    ],
                    "--zsk-algorithm": [
                      "ecdsap256sha256",
                      "ecdsap384sha384",
                      "rsasha1",
                      "rsasha256",
                      "rsasha512"
                    ],
                    "--zsk-key-length": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--policy-file": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--denial-of-existence": [
                      "nsec",
                      "nsec3"
                    ],
                    "--description": "value",
                    "--dnssec-state": [
                      "off",
                      "on",
                      "transfer"
                    ],
                    "--forwarding-targets": "value",
                    "--gkeclusters": "value",
                    "--ksk-algorithm": [
                      "ecdsap256sha256",
                      "ecdsap384sha384",
                      "rsasha1",
                      "rsasha256",
                      "rsasha512"
                    ],
                    "--ksk-key-length": "value",
                    "--location": "value",
                    "--log-dns-queries": "bool",
                    "--managed-reverse-lookup": "bool",
                    "--networks": "value",
                    "--private-forwarding-targets": "value",
                    "--remove-labels": "value",
                    "--target-network": "value",
                    "--target-project": "value",
                    "--update-labels": "value",
                    "--zsk-algorithm": [
                      "ecdsap256sha256",
                      "ecdsap384sha384",
                      "rsasha1",
                      "rsasha256",
                      "rsasha512"
                    ],
                    "--zsk-key-length": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--sort-by": "value",
                    "--zones": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "policies": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--alternative-name-servers": "value",
                    "--description": "value",
                    "--enable-dns64-all-queries": "bool",
                    "--enable-inbound-forwarding": "bool",
                    "--enable-logging": "bool",
                    "--networks": "value",
                    "--private-alternative-name-servers": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--alternative-name-servers": "value",
                    "--description": "value",
                    "--enable-dns64-all-queries": "bool",
                    "--enable-inbound-forwarding": "bool",
                    "--enable-logging": "bool",
                    "--networks": "value",
                    "--private-alternative-name-servers": "value"
                  }
                }
              },
              "flags": {}
            },
            "project-info": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "record-sets": {
              "commands": {
                "changes": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--zone": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--sort-order": [
                          "ascending",
                          "descending"
                        ],
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--backup-data-trickle-ratio": "value",
                    "--enable-geo-fencing": "bool",
                    "--enable-health-checking": "bool",
                    "--health-check": "value",
                    "--location": "value",
                    "--routing-policy-backup-data": "value",
                    "--routing-policy-backup-data-type": [
                      "GEO"
                    ],
                    "--routing-policy-primary-data": "value",
                    "--routing_policy_data": "value",
                    "--routing_policy_type": [
                      "FAILOVER",
                      "GEO",
                      "WRR"
                    ],
                    "--rrdatas": "value",
                    "--ttl": "value",
                    "--type": "value",
                    "--zone": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--type": "value",
                    "--zone": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--type": "value",
                    "--zone": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--zone": "dynamic",
                    "--zone-file-format": "bool"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--delete-all-existing": "bool",
                    "--location": "value",
                    "--replace-origin-ns": "bool",
                    "--zone": "dynamic",
                    "--zone-file-format": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--name": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--type": "value",
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                },
                "transaction": {
                  "commands": {
                    "abort": {
                      "commands": {},
                      "flags": {
                        "--transaction-file": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "add": {
                      "commands": {},
                      "flags": {
                        "--name": "value",
                        "--transaction-file": "value",
                        "--ttl": "value",
                        "--type": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--transaction-file": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "execute": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--transaction-file": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "remove": {
                      "commands": {},
                      "flags": {
                        "--name": "value",
                        "--transaction-file": "value",
                        "--ttl": "value",
                        "--type": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "start": {
                      "commands": {},
                      "flags": {
                        "--transaction-file": "value",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {
                    "--transaction-file": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--backup-data-trickle-ratio": "value",
                    "--enable-geo-fencing": "bool",
                    "--enable-health-checking": "bool",
                    "--health-check": "value",
                    "--location": "value",
                    "--routing-policy-backup-data": "value",
                    "--routing-policy-backup-data-type": [
                      "GEO"
                    ],
                    "--routing-policy-primary-data": "value",
                    "--routing_policy_data": "value",
                    "--routing_policy_type": [
                      "FAILOVER",
                      "GEO",
                      "WRR"
                    ],
                    "--rrdatas": "value",
                    "--ttl": "value",
                    "--type": "value",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "response-policies": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--gkeclusters": "value",
                    "--location": "value",
                    "--networks": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "rules": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--behavior": [
                          "behaviorUnspecified",
                          "bypassResponsePolicy"
                        ],
                        "--dns-name": "value",
                        "--local-data": "value",
                        "--location": "value",
                        "--response-policy": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--response-policy": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--response-policy": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--behavior": [
                          "behaviorUnspecified",
                          "bypassResponsePolicy"
                        ],
                        "--dns-name": "value",
                        "--local-data": "value",
                        "--location": "value",
                        "--response-policy": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--gkeclusters": "value",
                    "--location": "value",
                    "--networks": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "domains": {
          "commands": {
            "registrations": {
              "commands": {
                "authorization-code": {
                  "commands": {
                    "get": {
                      "commands": {},
                      "flags": {}
                    },
                    "reset": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "configure": {
                  "commands": {
                    "contacts": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--contact-data-from-file": "value",
                        "--contact-privacy": [
                          "private-contact-data",
                          "public-contact-data",
                          "redacted-contact-data"
                        ],
                        "--notices": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "dns": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--cloud-dns-zone": "value",
                        "--disable-dnssec": "bool",
                        "--dns-settings-from-file": "value",
                        "--name-servers": "value",
                        "--unsafe-dns-update": "bool",
                        "--use-google-domains-dns": "bool",
                        "--validate-only": "bool"
                      }
                    },
                    "management": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--preferred-renewal-method": [
                          "automatic-renewal",
                          "renewal-disabled"
                        ],
                        "--transfer-lock-state": [
                          "locked",
                          "unlocked"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-register-parameters": {
                  "commands": {},
                  "flags": {}
                },
                "google-domains-dns": {
                  "commands": {
                    "export-dns-record-sets": {
                      "commands": {},
                      "flags": {
                        "--records-file": "value",
                        "--zone-file-format": "bool"
                      }
                    },
                    "get-forwarding-config": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "initiate-push-transfer": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--tag": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "wait": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "register": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cloud-dns-zone": "value",
                    "--contact-data-from-file": "value",
                    "--contact-privacy": [
                      "private-contact-data",
                      "public-contact-data",
                      "redacted-contact-data"
                    ],
                    "--disable-dnssec": "bool",
                    "--labels": "value",
                    "--name-servers": "value",
                    "--notices": "value",
                    "--use-google-domains-dns": "bool",
                    "--validate-only": "bool",
                    "--yearly-price": "value"
                  }
                },
                "renew-domain": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--validate-only": "bool",
                    "--yearly-price": "value"
                  }
                },
                "search-domains": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "edge-cache": {
          "commands": {
            "keysets": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--public-key": "value",
                    "--validation-shared-key": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--public-key": "value",
                    "--validation-shared-key": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "origins": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--failover-origin": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--max-attempts": "value",
                    "--origin-address": "value",
                    "--port": "value",
                    "--protocol": [
                      "http",
                      "http2",
                      "https"
                    ],
                    "--response-timeout": "value",
                    "--retry-conditions": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--failover-origin": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--max-attempts": "value",
                    "--origin-address": "value",
                    "--port": "value",
                    "--protocol": [
                      "http",
                      "http2",
                      "https"
                    ],
                    "--response-timeout": "value",
                    "--retry-conditions": "value"
                  }
                }
              },
              "flags": {}
            },
            "services": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "invalidate-cache": {
                  "commands": {},
                  "flags": {
                    "--host": "value",
                    "--location": "value",
                    "--path": "value",
                    "--tags": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--edge-security-policy": "value",
                    "--edge-ssl-certificate": "value",
                    "--enable-logging": "bool",
                    "--labels": "value",
                    "--location": "value",
                    "--logging-sample-rate": "value",
                    "--require-tls": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "edge-cloud": {
          "commands": {
            "container": {
              "commands": {
                "clusters": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--admin-users": "value",
                        "--async": "bool",
                        "--cluster-ipv4-cidr": "value",
                        "--cluster-ipv6-cidr": "value",
                        "--control-plane-kms-key": "value",
                        "--control-plane-machine-filter": "value",
                        "--control-plane-node-count": "value",
                        "--control-plane-node-location": "value",
                        "--control-plane-node-storage-schema": "value",
                        "--control-plane-shared-deployment-policy": "value",
                        "--default-max-pods-per-node": "value",
                        "--external-lb-address-pools": "value",
                        "--external-lb-ipv4-address-pools": "value",
                        "--external-lb-ipv6-address-pools": "value",
                        "--fleet-project": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--lro-timeout": "value",
                        "--maintenance-window-end": "value",
                        "--maintenance-window-recurrence": "value",
                        "--maintenance-window-start": "value",
                        "--offline-reboot-ttl": "value",
                        "--release-channel": "value",
                        "--services-ipv4-cidr": "value",
                        "--services-ipv6-cidr": "value",
                        "--system-addons-config": "value",
                        "--zone-storage-kms-key": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    },
                    "get-credentials": {
                      "commands": {},
                      "flags": {
                        "--auth-provider-cmd-path": "value",
                        "--location": "value",
                        "--offline-credential": "bool"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "node-pools": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--async": "bool",
                            "--cluster": "value",
                            "--labels": "value",
                            "--local-disk-kms-key": "value",
                            "--location": "value",
                            "--lro-timeout": "value",
                            "--machine-filter": "value",
                            "--node-count": "value",
                            "--node-labels": "value",
                            "--node-location": "value",
                            "--node-storage-schema": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--async": "bool",
                            "--cluster": "dynamic",
                            "--location": "dynamic"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--cluster": "dynamic",
                            "--location": "dynamic"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--cluster": "dynamic",
                            "--filter": "value",
                            "--limit": "value",
                            "--location": "dynamic",
                            "--page-size": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--async": "bool",
                            "--clear-labels": "bool",
                            "--cluster": "value",
                            "--local-disk-kms-key": "value",
                            "--location": "value",
                            "--lro-timeout": "value",
                            "--machine-filter": "value",
                            "--node-count": "value",
                            "--node-labels": "value",
                            "--remove-labels": "value",
                            "--update-labels": "value",
                            "--use-google-managed-key": "bool"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--add-maintenance-exclusion-end": "value",
                        "--add-maintenance-exclusion-name": "value",
                        "--add-maintenance-exclusion-start": "value",
                        "--async": "bool",
                        "--clear-maintenance-window": "bool",
                        "--clear-max-unavailable-worker-nodes": "bool",
                        "--control-plane-kms-key": "value",
                        "--location": "dynamic",
                        "--maintenance-window-end": "value",
                        "--maintenance-window-recurrence": "value",
                        "--maintenance-window-start": "value",
                        "--max-unavailable-worker-nodes": "value",
                        "--offline-reboot-ttl": "value",
                        "--release-channel": [
                          "none",
                          "regular",
                          "release-channel-unspecified"
                        ],
                        "--remove-maintenance-exclusion-window": "value",
                        "--use-google-managed-key": "bool",
                        "--use-google-managed-zone-key": "bool",
                        "--zone-storage-kms-key": "value"
                      }
                    },
                    "upgrade": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--schedule": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "get-server-config": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "machines": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    },
                    "wait": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "regions": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "vpn-connections": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--cluster": "dynamic",
                        "--high-availability": "bool",
                        "--labels": "value",
                        "--location": "value",
                        "--nat-gateway-ip": "value",
                        "--router": "value",
                        "--vpc-network": "value",
                        "--vpc-project": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "zones": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "networking": {
              "commands": {
                "interconnects": {
                  "commands": {
                    "attachments": {
                      "commands": {
                        "dedicated": {
                          "commands": {
                            "create": {
                              "commands": {},
                              "flags": {
                                "--async": "bool",
                                "--description": "value",
                                "--interconnect": "value",
                                "--labels": "value",
                                "--location": "dynamic",
                                "--mtu": "value",
                                "--network": "value",
                                "--vlan-id": "value",
                                "--zone": "dynamic"
                              }
                            }
                          },
                          "flags": {}
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--async": "bool",
                            "--location": "dynamic",
                            "--zone": "dynamic"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "dynamic",
                            "--zone": "dynamic"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--location": "dynamic",
                            "--page-size": "value",
                            "--sort-by": "value",
                            "--uri": "bool",
                            "--zone": "dynamic"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "get-diagnostics": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "networks": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value",
                        "--labels": "value",
                        "--location": "dynamic",
                        "--mtu": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "get-status": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    },
                    "wait": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "routers": {
                  "commands": {
                    "add-bgp-peer": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--interface": "value",
                        "--location": "dynamic",
                        "--peer-asn": "value",
                        "--peer-ipv4-range": "value",
                        "--peer-ipv6-range": "value",
                        "--peer-name": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "add-interface": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--interconnect-attachment": "value",
                        "--interface-name": "value",
                        "--ip-address": "value",
                        "--ip-mask-length": "value",
                        "--location": "dynamic",
                        "--loopback-ip-addresses": "value",
                        "--subnetwork": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--asn": "value",
                        "--async": "bool",
                        "--description": "value",
                        "--labels": "value",
                        "--location": "dynamic",
                        "--network": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "get-status": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "remove-bgp-peer": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "dynamic",
                        "--peer-name": "value",
                        "--peer-names": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "remove-interface": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--interface-name": "value",
                        "--interface-names": "value",
                        "--location": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--add-advertisement-ranges": "value",
                        "--async": "bool",
                        "--location": "dynamic",
                        "--remove-advertisement-ranges": "value",
                        "--set-advertisement-ranges": "value",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "subnets": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bonding-type": [
                          "bonded",
                          "bonding-type-unspecified",
                          "non-bonded"
                        ],
                        "--description": "value",
                        "--ipv4-range": "value",
                        "--ipv6-range": "value",
                        "--labels": "value",
                        "--location": "dynamic",
                        "--network": "value",
                        "--vlan-id": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "zones": {
                  "commands": {
                    "init": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "emulators": {
          "commands": {
            "bigtable": {
              "commands": {
                "env-init": {
                  "commands": {},
                  "flags": {}
                },
                "start": {
                  "commands": {},
                  "flags": {
                    "--host-port": "value"
                  }
                }
              },
              "flags": {}
            },
            "datastore": {
              "commands": {
                "env-init": {
                  "commands": {},
                  "flags": {
                    "--data-dir": "value"
                  }
                },
                "env-unset": {
                  "commands": {},
                  "flags": {
                    "--data-dir": "value"
                  }
                },
                "start": {
                  "commands": {},
                  "flags": {
                    "--consistency": "value",
                    "--data-dir": "value",
                    "--host-port": "value",
                    "--store-on-disk": "bool",
                    "--use-firestore-in-datastore-mode": "bool"
                  }
                }
              },
              "flags": {
                "--data-dir": "value"
              }
            },
            "firestore": {
              "commands": {
                "start": {
                  "commands": {},
                  "flags": {
                    "--database-mode": "value",
                    "--export-on-exit": "value",
                    "--host-port": "value",
                    "--import-data": "value",
                    "--rules": "value"
                  }
                }
              },
              "flags": {}
            },
            "pubsub": {
              "commands": {
                "env-init": {
                  "commands": {},
                  "flags": {
                    "--data-dir": "value"
                  }
                },
                "start": {
                  "commands": {},
                  "flags": {
                    "--data-dir": "value",
                    "--host-port": "value"
                  }
                }
              },
              "flags": {
                "--data-dir": "value"
              }
            },
            "spanner": {
              "commands": {
                "env-init": {
                  "commands": {},
                  "flags": {}
                },
                "start": {
                  "commands": {},
                  "flags": {
                    "--enable-fault-injection": "value",
                    "--host-port": "value",
                    "--rest-port": "value",
                    "--use-docker": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "endpoints": {
          "commands": {
            "configs": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--service": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--service": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--service": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "quota": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--consumer": "value",
                    "--dimensions": "value",
                    "--force": "bool",
                    "--metric": "value",
                    "--service": "value",
                    "--unit": "value",
                    "--value": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--consumer": "value",
                    "--force": "bool",
                    "--metric": "value",
                    "--override-id": "value",
                    "--service": "value",
                    "--unit": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--consumer": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--service": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--consumer": "value",
                    "--dimensions": "value",
                    "--force": "bool",
                    "--metric": "value",
                    "--service": "value",
                    "--unit": "value",
                    "--value": "value"
                  }
                }
              },
              "flags": {}
            },
            "services": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "check-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "deploy": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--force": "bool",
                    "--validate-only": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "undelete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "essential-contacts": {
          "commands": {
            "compute": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--notification-categories": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--email": "value",
                "--folder": "value",
                "--language": "value",
                "--notification-categories": "value",
                "--organization": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--language": "value",
                "--notification-categories": "value",
                "--organization": "value"
              }
            }
          },
          "flags": {}
        },
        "filestore": {
          "commands": {
            "backups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--file-share": "value",
                    "--instance": "value",
                    "--instance-zone": "value",
                    "--labels": "value",
                    "--region": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--region": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "instances": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--file-share": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--network": "value",
                    "--region": "value",
                    "--tier": [
                      "basic-hdd",
                      "basic-ssd",
                      "enterprise",
                      "high-scale-ssd",
                      "premium",
                      "regional",
                      "standard",
                      "zonal"
                    ],
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "value"
                  }
                },
                "restore": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--file-share": "value",
                    "--source-backup": "value",
                    "--source-backup-region": "value",
                    "--source-snapshot": "value",
                    "--source-snapshot-region": "value",
                    "--zone": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--clear-nfs-export-options": "bool",
                    "--description": "value",
                    "--file-share": "value",
                    "--location": "value",
                    "--region": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value",
                    "--zone": "value"
                  }
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "value"
                  }
                }
              },
              "flags": {}
            },
            "regions": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "snapshots": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--file-share": "value",
                    "--instance": "value",
                    "--instance-zone": "value",
                    "--labels": "value",
                    "--region": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--region": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value",
                    "--zone": "value"
                  }
                }
              },
              "flags": {}
            },
            "zones": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "firebase": {
          "commands": {
            "test": {
              "commands": {
                "android": {
                  "commands": {
                    "list-device-capacities": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "locales": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {}
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--sort-by": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "models": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {}
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--sort-by": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "run": {
                      "commands": {},
                      "flags": {
                        "--additional-apks": "value",
                        "--app": "value",
                        "--app-package": "value",
                        "--async": "bool",
                        "--auto-google-login": "bool",
                        "--client-details": "value",
                        "--device": "value",
                        "--device-ids": "value",
                        "--directories-to-pull": "value",
                        "--environment-variables": "value",
                        "--filter": "value",
                        "--grant-permissions": [
                          "all",
                          "none"
                        ],
                        "--limit": "value",
                        "--locales": "value",
                        "--network-profile": "value",
                        "--num-flaky-test-attempts": "value",
                        "--num-uniform-shards": "value",
                        "--obb-files": "value",
                        "--orientations": "dynamic",
                        "--os-version-ids": "value",
                        "--other-files": "value",
                        "--page-size": "value",
                        "--performance-metrics": "bool",
                        "--record-video": "bool",
                        "--resign": "bool",
                        "--results-bucket": "value",
                        "--results-dir": "value",
                        "--results-history-name": "value",
                        "--robo-directives": "value",
                        "--robo-script": "value",
                        "--scenario-labels": "value",
                        "--scenario-numbers": "value",
                        "--sort-by": "value",
                        "--test": "value",
                        "--test-package": "value",
                        "--test-runner-class": "value",
                        "--test-targets": "value",
                        "--test-targets-for-shard": "value",
                        "--timeout": "value",
                        "--type": [
                          "game-loop",
                          "instrumentation",
                          "robo"
                        ],
                        "--use-orchestrator": "bool"
                      }
                    },
                    "versions": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {}
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--sort-by": "value"
                          }
                        }
                      },
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "ios": {
                  "commands": {
                    "list-device-capacities": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "locales": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {}
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--sort-by": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "models": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {}
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--sort-by": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "run": {
                      "commands": {},
                      "flags": {
                        "--additional-ipas": "value",
                        "--app": "value",
                        "--async": "bool",
                        "--client-details": "value",
                        "--device": "value",
                        "--directories-to-pull": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--num-flaky-test-attempts": "value",
                        "--other-files": "value",
                        "--page-size": "value",
                        "--record-video": "bool",
                        "--results-bucket": "value",
                        "--results-dir": "value",
                        "--results-history-name": "value",
                        "--robo-script": "value",
                        "--scenario-numbers": "value",
                        "--sort-by": "value",
                        "--test": "value",
                        "--test-special-entitlements": "bool",
                        "--timeout": "value",
                        "--type": [
                          "game-loop",
                          "robo",
                          "xctest"
                        ],
                        "--xcode-version": "value",
                        "--xctestrun-file": "value"
                      }
                    },
                    "versions": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {}
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--sort-by": "value"
                          }
                        }
                      },
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "ip-blocks": {
                  "commands": {
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "network-profiles": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "firestore": {
          "commands": {
            "backups": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--backup": "value",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--backup": "value",
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "schedules": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--database": "value",
                        "--day-of-week": [
                          "FRI",
                          "MON",
                          "SAT",
                          "SUN",
                          "THU",
                          "TUE",
                          "WED"
                        ],
                        "--recurrence": "value",
                        "--retention": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--backup-schedule": "value",
                        "--database": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--backup-schedule": "value",
                        "--database": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--database": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--backup-schedule": "value",
                        "--database": "value",
                        "--retention": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "bulk-delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--collection-ids": "value",
                "--database": "value",
                "--namespace-ids": "value"
              }
            },
            "databases": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--database": "value",
                    "--delete-protection": "bool",
                    "--enable-pitr": "bool",
                    "--kms-key-name": "value",
                    "--location": "value",
                    "--type": [
                      "datastore-mode",
                      "firestore-native"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--database": "value",
                    "--etag": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--database": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--show-deleted": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "restore": {
                  "commands": {},
                  "flags": {
                    "--destination-database": "value",
                    "--encryption-type": [
                      "customer-managed-encryption",
                      "google-default-encryption",
                      "use-source-encryption"
                    ],
                    "--kms-key-name": "value",
                    "--source-backup": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--database": "value",
                    "--delete-protection": "bool",
                    "--enable-pitr": "bool",
                    "--type": [
                      "datastore-mode",
                      "firestore-native"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "export": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--collection-ids": "value",
                "--database": "value",
                "--namespace-ids": "value",
                "--snapshot-time": "value"
              }
            },
            "fields": {
              "commands": {
                "ttls": {
                  "commands": {
                    "list": {
                      "commands": {},
                      "flags": {
                        "--collection-group": "value",
                        "--database": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--collection-group": "value",
                        "--database": "value",
                        "--disable-ttl": "bool",
                        "--enable-ttl": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--collection-ids": "value",
                "--database": "value",
                "--namespace-ids": "value"
              }
            },
            "indexes": {
              "commands": {
                "composite": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--api-scope": [
                          "any-api",
                          "datastore-mode-api"
                        ],
                        "--async": "bool",
                        "--collection-group": "value",
                        "--database": "value",
                        "--field-config": "value",
                        "--query-scope": [
                          "collection",
                          "collection-group",
                          "collection-recursive"
                        ]
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--database": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--database": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--database": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "fields": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--collection-group": "value",
                        "--database": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--collection-group": "value",
                        "--database": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-exemption": "bool",
                        "--collection-group": "value",
                        "--database": "value",
                        "--disable-indexes": "bool",
                        "--index": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--database": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--database": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--database": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--database": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "functions": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--region": "dynamic",
                "--role": "value"
              }
            },
            "add-invoker-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--region": "dynamic"
              }
            },
            "call": {
              "commands": {},
              "flags": {
                "--cloud-event": "value",
                "--data": "value",
                "--region": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "deploy": {
              "commands": {},
              "flags": {
                "--allow-unauthenticated": "bool",
                "--binary-authorization": "value",
                "--build-env-vars-file": "value",
                "--build-service-account": "value",
                "--build-worker-pool": "value",
                "--buildpack-stack": "value",
                "--clear-binary-authorization": "bool",
                "--clear-build-env-vars": "bool",
                "--clear-build-service-account": "bool",
                "--clear-build-worker-pool": "bool",
                "--clear-docker-repository": "bool",
                "--clear-env-vars": "bool",
                "--clear-kms-key": "bool",
                "--clear-labels": "bool",
                "--clear-max-instances": "bool",
                "--clear-min-instances": "bool",
                "--clear-secrets": "bool",
                "--clear-vpc-connector": "bool",
                "--concurrency": "value",
                "--cpu": "value",
                "--docker-registry": [
                  "artifact-registry",
                  "container-registry"
                ],
                "--docker-repository": "value",
                "--egress-settings": [
                  "all",
                  "private-ranges-only"
                ],
                "--entry-point": "value",
                "--env-vars-file": "value",
                "--gen2": "bool",
                "--ignore-file": "value",
                "--ingress-settings": [
                  "all",
                  "internal-and-gclb",
                  "internal-only"
                ],
                "--kms-key": "value",
                "--max-instances": "value",
                "--memory": "value",
                "--min-instances": "value",
                "--region": "dynamic",
                "--remove-build-env-vars": "value",
                "--remove-env-vars": "value",
                "--remove-labels": "value",
                "--remove-secrets": "value",
                "--retry": "bool",
                "--run-service-account": "value",
                "--runtime": "value",
                "--runtime-update-policy": [
                  "automatic",
                  "on-deploy"
                ],
                "--security-level": [
                  "secure-always",
                  "secure-optional"
                ],
                "--serve-all-traffic-latest-revision": "bool",
                "--service-account": "value",
                "--set-build-env-vars": "value",
                "--set-env-vars": "value",
                "--set-secrets": "value",
                "--source": "dynamic",
                "--stage-bucket": "value",
                "--timeout": "value",
                "--trigger-bucket": "value",
                "--trigger-event": "value",
                "--trigger-event-filters": "value",
                "--trigger-event-filters-path-pattern": "value",
                "--trigger-http": "bool",
                "--trigger-location": "dynamic",
                "--trigger-resource": "value",
                "--trigger-service-account": "value",
                "--trigger-topic": "value",
                "--update-build-env-vars": "value",
                "--update-env-vars": "value",
                "--update-labels": "value",
                "--update-secrets": "value",
                "--vpc-connector": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic",
                "--v2": "bool"
              }
            },
            "event-types": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--gen2": "bool"
                  }
                }
              },
              "flags": {}
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--v2": "bool"
              }
            },
            "local": {
              "commands": {
                "call": {
                  "commands": {},
                  "flags": {
                    "--cloud-event": "value",
                    "--data": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "deploy": {
                  "commands": {},
                  "flags": {
                    "--build-env-vars-file": "value",
                    "--builder": "value",
                    "--clear-build-env-vars": "bool",
                    "--clear-env-vars": "bool",
                    "--entry-point": "value",
                    "--env-vars-file": "value",
                    "--ignore-file": "value",
                    "--port": "value",
                    "--remove-build-env-vars": "value",
                    "--remove-env-vars": "value",
                    "--runtime": "value",
                    "--set-build-env-vars": "value",
                    "--set-env-vars": "value",
                    "--source": "dynamic",
                    "--update-build-env-vars": "value",
                    "--update-env-vars": "value"
                  }
                }
              },
              "flags": {}
            },
            "logs": {
              "commands": {
                "read": {
                  "commands": {},
                  "flags": {
                    "--end-time": "value",
                    "--execution-id": "value",
                    "--filter": "value",
                    "--gen2": "bool",
                    "--limit": "value",
                    "--min-log-level": [
                      "debug",
                      "error",
                      "info"
                    ],
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--start-time": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "regions": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--gen2": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--region": "dynamic",
                "--role": "value"
              }
            },
            "remove-invoker-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--region": "dynamic"
              }
            },
            "runtimes": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "genomics": {
          "commands": {
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "pipelines": {
              "commands": {
                "run": {
                  "commands": {},
                  "flags": {
                    "--boot-disk-size": "value",
                    "--command-line": "value",
                    "--cpus": "value",
                    "--disk-size": "value",
                    "--docker-image": "value",
                    "--env-vars": "value",
                    "--inputs": "value",
                    "--inputs-from-file": "value",
                    "--labels": "value",
                    "--logging": "value",
                    "--memory": "value",
                    "--network": "value",
                    "--outputs": "value",
                    "--pipeline-file": "value",
                    "--preemptible": "bool",
                    "--regions": "value",
                    "--service-account-email": "value",
                    "--service-account-scopes": "value",
                    "--subnetwork": "value",
                    "--zones": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "healthcare": {
          "commands": {
            "annotation-stores": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "evaluate": {
                  "commands": {
                    "bq": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bq-table": "value",
                        "--dataset": "value",
                        "--golden-store": "value",
                        "--location": "value",
                        "--write-disposition": [
                          "write-append",
                          "write-empty",
                          "write-truncate"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "export": {
                  "commands": {
                    "bq": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bq-table": "value",
                        "--dataset": "value",
                        "--location": "value",
                        "--write-disposition": [
                          "write-append",
                          "write-empty",
                          "write-truncate"
                        ]
                      }
                    },
                    "gcs": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--dataset": "value",
                        "--gcs-uri": "value",
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "import": {
                  "commands": {
                    "gcs": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--dataset": "value",
                        "--gcs-uri": "value",
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "consent-stores": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "check-data-access": {
                  "commands": {},
                  "flags": {
                    "--data-id": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--request-attributes": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--labels": "value",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "evaluate-user-consents": {
                  "commands": {},
                  "flags": {
                    "--consent-list": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--page-token": "value",
                    "--request-attributes": "value",
                    "--resource-attributes": "value",
                    "--response-view": [
                      "basic",
                      "full",
                      "response-view-unspecified"
                    ],
                    "--user-id": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "query-accessible-data": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--dataset": "value",
                    "--gcs-uri": "value",
                    "--location": "value",
                    "--request-attributes": "value",
                    "--resource-attributes": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--dataset": "value",
                    "--location": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "datasets": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--encryption-key": "value",
                    "--location": "value",
                    "--time-zone": "value"
                  }
                },
                "deidentify": {
                  "commands": {},
                  "flags": {
                    "--annotation-store": "value",
                    "--async": "bool",
                    "--default-fhir-config": "bool",
                    "--destination-dataset": "value",
                    "--dicom-filter-tags": "value",
                    "--location": "value",
                    "--text-redaction-mode": [
                      "all"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--time-zone": "value"
                  }
                }
              },
              "flags": {}
            },
            "dicom-stores": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value",
                    "--pubsub-topic": "value",
                    "--send-for-bulk-import": "bool",
                    "--stream-configs": "value"
                  }
                },
                "deidentify": {
                  "commands": {},
                  "flags": {
                    "--annotation-store": "value",
                    "--async": "bool",
                    "--dataset": "value",
                    "--destination-store": "value",
                    "--dicom-filter-tags": "value",
                    "--location": "value",
                    "--text-redaction-mode": [
                      "all"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {
                    "bq": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bq-table": "value",
                        "--dataset": "value",
                        "--filter-config-gcs-uri": "value",
                        "--location": "value",
                        "--overwrite-table": "bool",
                        "--write-disposition": [
                          "write-append",
                          "write-empty",
                          "write-truncate"
                        ]
                      }
                    },
                    "gcs": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--dataset": "value",
                        "--filter-config-gcs-uri": "value",
                        "--gcs-uri-prefix": "value",
                        "--location": "value",
                        "--mime-type": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "import": {
                  "commands": {
                    "gcs": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--dataset": "value",
                        "--gcs-uri": "value",
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "metrics": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value",
                    "--pubsub-topic": "value",
                    "--send-for-bulk-import": "bool",
                    "--stream-configs": "value"
                  }
                }
              },
              "flags": {}
            },
            "fhir-stores": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--disable-referential-integrity": "bool",
                    "--disable-resource-versioning": "bool",
                    "--enable-history-modifications": "bool",
                    "--enable-update-create": "bool",
                    "--location": "value",
                    "--pubsub-topic": "value"
                  }
                },
                "deidentify": {
                  "commands": {},
                  "flags": {
                    "--annotation-store": "value",
                    "--async": "bool",
                    "--dataset": "value",
                    "--destination-store": "value",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {
                    "bq": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bq-dataset": "value",
                        "--dataset": "value",
                        "--location": "value",
                        "--recursive-depth": "value",
                        "--resource-type": "value",
                        "--schema-type": [
                          "analytics",
                          "analytics_v2",
                          "lossless"
                        ],
                        "--since": "value",
                        "--write-disposition": [
                          "write-append",
                          "write-empty",
                          "write-truncate"
                        ]
                      }
                    },
                    "gcs": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--dataset": "value",
                        "--gcs-uri": "value",
                        "--location": "value",
                        "--resource-type": "value",
                        "--since": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "import": {
                  "commands": {
                    "gcs": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--content-structure": [
                          "bundle",
                          "bundle-pretty",
                          "resource",
                          "resource-pretty"
                        ],
                        "--dataset": "value",
                        "--error-gcs-uri": "value",
                        "--gcs-uri": "value",
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "metrics": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--enable-history-modifications": "bool",
                    "--enable-update-create": "bool",
                    "--location": "value",
                    "--pubsub-topic": "value"
                  }
                }
              },
              "flags": {}
            },
            "hl7v2-stores": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value",
                    "--parser-version": [
                      "v1",
                      "v2",
                      "v3"
                    ],
                    "--pubsub-topic": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {
                    "gcs": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--dataset": "value",
                        "--end-time": "value",
                        "--gcs-uri": "value",
                        "--location": "value",
                        "--message-view": [
                          "basic",
                          "full",
                          "parsed-only",
                          "raw-only",
                          "schematized-only"
                        ],
                        "--start-time": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "import": {
                  "commands": {
                    "gcs": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--dataset": "value",
                        "--gcs-uri": "value",
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "metrics": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value",
                    "--pubsub-topic": "value"
                  }
                }
              },
              "flags": {}
            },
            "nlp": {
              "commands": {
                "analyze-entities": {
                  "commands": {},
                  "flags": {
                    "--document-content": "value",
                    "--nlp-service": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "help": {
          "commands": {},
          "flags": {
            "--filter": "value",
            "--limit": "value",
            "--page-size": "value",
            "--sort-by": "value"
          }
        },
        "iam": {
          "commands": {
            "list-grantable-roles": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--page-size": "value"
              }
            },
            "list-testable-permissions": {
              "commands": {},
              "flags": {
                "--filter": "value"
              }
            },
            "oauth-clients": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--allowed-grant-types": "value",
                    "--allowed-redirect-uris": "value",
                    "--allowed-scopes": "value",
                    "--client-type": [
                      "confidential-client",
                      "public-client"
                    ],
                    "--description": "value",
                    "--disabled": "bool",
                    "--display-name": "value",
                    "--location": "value"
                  }
                },
                "credentials": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--disabled": "bool",
                        "--display-name": "value",
                        "--location": "value",
                        "--oauth-client": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--oauth-client": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--oauth-client": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--oauth-client": "dynamic",
                        "--sort-by": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--disabled": "bool",
                        "--display-name": "value",
                        "--location": "value",
                        "--oauth-client": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--show-deleted": "bool",
                    "--sort-by": "value"
                  }
                },
                "undelete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--allowed-grant-types": "value",
                    "--allowed-redirect-uris": "value",
                    "--allowed-scopes": "value",
                    "--description": "value",
                    "--disabled": "bool",
                    "--display-name": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "policies": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--attachment-point": "value",
                    "--kind": "value",
                    "--policy-file": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--attachment-point": "value",
                    "--etag": "value",
                    "--kind": "value"
                  }
                },
                "get": {
                  "commands": {},
                  "flags": {
                    "--attachment-point": "value",
                    "--kind": "value"
                  }
                },
                "lint-condition": {
                  "commands": {},
                  "flags": {
                    "--condition-from-file": "value",
                    "--description": "value",
                    "--expression": "value",
                    "--resource-name": "value",
                    "--title": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--attachment-point": "value",
                    "--filter": "value",
                    "--kind": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--page_token": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--attachment-point": "value",
                    "--etag": "value",
                    "--kind": "value",
                    "--policy-file": "value"
                  }
                }
              },
              "flags": {}
            },
            "roles": {
              "commands": {
                "copy": {
                  "commands": {},
                  "flags": {
                    "--dest-organization": "value",
                    "--dest-project": "value",
                    "--destination": "value",
                    "--source": "value",
                    "--source-organization": "value",
                    "--source-project": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--file": "value",
                    "--organization": "value",
                    "--permissions": "value",
                    "--stage": "value",
                    "--title": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--show-deleted": "bool",
                    "--sort-by": "value"
                  }
                },
                "undelete": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-permissions": "value",
                    "--description": "value",
                    "--file": "value",
                    "--organization": "value",
                    "--permissions": "value",
                    "--remove-permissions": "value",
                    "--stage": "value",
                    "--title": "value"
                  }
                }
              },
              "flags": {}
            },
            "service-accounts": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--recommend": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "disable": {
                  "commands": {},
                  "flags": {}
                },
                "enable": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "keys": {
                  "commands": {
                    "config": {
                      "commands": {
                        "export": {
                          "commands": {},
                          "flags": {
                            "--all": "bool",
                            "--iam-account": "dynamic",
                            "--path": "value",
                            "--resource-format": [
                              "krm",
                              "terraform"
                            ]
                          }
                        }
                      },
                      "flags": {}
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--iam-account": "value",
                        "--key-file-type": [
                          "json",
                          "p12"
                        ]
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--iam-account": "value"
                      }
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--iam-account": "dynamic"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--iam-account": "dynamic"
                      }
                    },
                    "get-public-key": {
                      "commands": {},
                      "flags": {
                        "--iam-account": "value",
                        "--output-file": "value",
                        "--type": [
                          "pem",
                          "raw"
                        ]
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--created-before": "value",
                        "--filter": "value",
                        "--iam-account": "value",
                        "--limit": "value",
                        "--managed-by": [
                          "any",
                          "system",
                          "user"
                        ],
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "upload": {
                      "commands": {},
                      "flags": {
                        "--iam-account": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "sign-blob": {
                  "commands": {},
                  "flags": {
                    "--iam-account": "value"
                  }
                },
                "sign-jwt": {
                  "commands": {},
                  "flags": {
                    "--iam-account": "value"
                  }
                },
                "undelete": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value"
                  }
                }
              },
              "flags": {}
            },
            "workforce-pools": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--allowed-services": "value",
                    "--async": "bool",
                    "--description": "value",
                    "--disable-programmatic-signin": "bool",
                    "--disabled": "bool",
                    "--display-name": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--session-duration": "value"
                  }
                },
                "create-cred-config": {
                  "commands": {},
                  "flags": {
                    "--credential-source-field-name": "value",
                    "--credential-source-file": "value",
                    "--credential-source-headers": "value",
                    "--credential-source-type": "value",
                    "--credential-source-url": "value",
                    "--executable-command": "value",
                    "--executable-interactive-timeout-millis": "value",
                    "--executable-output-file": "value",
                    "--executable-timeout-millis": "value",
                    "--output-file": "value",
                    "--service-account": "value",
                    "--service-account-token-lifetime-seconds": "value",
                    "--subject-token-type": "value",
                    "--workforce-pool-user-project": "value"
                  }
                },
                "create-login-config": {
                  "commands": {},
                  "flags": {
                    "--activate": "bool",
                    "--output-file": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--show-deleted": "bool",
                    "--sort-by": "value"
                  }
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--workforce-pool": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "providers": {
                  "commands": {
                    "create-oidc": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--attribute-condition": "value",
                        "--attribute-mapping": "value",
                        "--client-id": "value",
                        "--client-secret-value": "value",
                        "--description": "value",
                        "--disabled": "bool",
                        "--display-name": "value",
                        "--extra-attributes-client-id": "value",
                        "--extra-attributes-client-secret-value": "value",
                        "--extra-attributes-filter": "value",
                        "--extra-attributes-issuer-uri": "value",
                        "--extra-attributes-type": "value",
                        "--issuer-uri": "value",
                        "--jwk-json-path": "value",
                        "--location": "value",
                        "--web-sso-additional-scopes": "value",
                        "--web-sso-assertion-claims-behavior": [
                          "assertion-claims-behavior-unspecified",
                          "merge-user-info-over-id-token-claims",
                          "only-id-token-claims"
                        ],
                        "--web-sso-response-type": [
                          "code",
                          "id-token",
                          "response-type-unspecified"
                        ],
                        "--workforce-pool": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--workforce-pool": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--workforce-pool": "dynamic"
                      }
                    },
                    "keys": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--async": "bool",
                            "--location": "value",
                            "--provider": "dynamic",
                            "--spec": [
                              "key-spec-unspecified",
                              "rsa-2048",
                              "rsa-3072",
                              "rsa-4096"
                            ],
                            "--use": [
                              "encryption",
                              "key-use-unspecified"
                            ],
                            "--workforce-pool": "dynamic"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--async": "bool",
                            "--location": "value",
                            "--provider": "dynamic",
                            "--workforce-pool": "dynamic"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--provider": "dynamic",
                            "--workforce-pool": "dynamic"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--location": "value",
                            "--page-size": "value",
                            "--provider": "dynamic",
                            "--show-deleted": "bool",
                            "--sort-by": "value",
                            "--workforce-pool": "dynamic"
                          }
                        },
                        "operations": {
                          "commands": {
                            "describe": {
                              "commands": {},
                              "flags": {
                                "--key": "dynamic",
                                "--location": "value",
                                "--provider": "dynamic",
                                "--workforce-pool": "dynamic"
                              }
                            }
                          },
                          "flags": {}
                        },
                        "undelete": {
                          "commands": {},
                          "flags": {
                            "--async": "bool",
                            "--location": "value",
                            "--provider": "dynamic",
                            "--workforce-pool": "dynamic"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--show-deleted": "bool",
                        "--sort-by": "value",
                        "--workforce-pool": "dynamic"
                      }
                    },
                    "operations": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--provider": "dynamic",
                            "--workforce-pool": "dynamic"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "undelete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--workforce-pool": "dynamic"
                      }
                    },
                    "update-oidc": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--attribute-condition": "value",
                        "--attribute-mapping": "value",
                        "--clear-client-secret": "bool",
                        "--clear-extra-attributes-config": "bool",
                        "--client-id": "value",
                        "--client-secret-value": "value",
                        "--description": "value",
                        "--disabled": "bool",
                        "--display-name": "value",
                        "--extra-attributes-client-id": "value",
                        "--extra-attributes-client-secret-value": "value",
                        "--extra-attributes-filter": "value",
                        "--extra-attributes-issuer-uri": "value",
                        "--extra-attributes-type": "value",
                        "--issuer-uri": "value",
                        "--jwk-json-path": "value",
                        "--location": "value",
                        "--web-sso-additional-scopes": "value",
                        "--web-sso-assertion-claims-behavior": [
                          "assertion-claims-behavior-unspecified",
                          "merge-user-info-over-id-token-claims",
                          "only-id-token-claims"
                        ],
                        "--web-sso-response-type": [
                          "code",
                          "id-token",
                          "response-type-unspecified"
                        ],
                        "--workforce-pool": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "undelete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--disable-programmatic-signin": "bool",
                    "--disabled": "bool",
                    "--display-name": "value",
                    "--location": "value",
                    "--session-duration": "value"
                  }
                }
              },
              "flags": {}
            },
            "workload-identity-pools": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--disabled": "bool",
                    "--display-name": "value",
                    "--location": "value"
                  }
                },
                "create-cred-config": {
                  "commands": {},
                  "flags": {
                    "--app-id-uri": "value",
                    "--aws": "bool",
                    "--azure": "bool",
                    "--credential-cert-configuration-output-file": "value",
                    "--credential-cert-path": "value",
                    "--credential-cert-private-key-path": "value",
                    "--credential-source-field-name": "value",
                    "--credential-source-file": "value",
                    "--credential-source-headers": "value",
                    "--credential-source-type": "value",
                    "--credential-source-url": "value",
                    "--enable-imdsv2": "bool",
                    "--executable-command": "value",
                    "--executable-output-file": "value",
                    "--executable-timeout-millis": "value",
                    "--output-file": "value",
                    "--service-account": "value",
                    "--service-account-token-lifetime-seconds": "value",
                    "--subject-token-type": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--show-deleted": "bool",
                    "--sort-by": "value"
                  }
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--workload-identity-pool": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "providers": {
                  "commands": {
                    "create-aws": {
                      "commands": {},
                      "flags": {
                        "--account-id": "value",
                        "--attribute-condition": "value",
                        "--attribute-mapping": "value",
                        "--description": "value",
                        "--disabled": "bool",
                        "--display-name": "value",
                        "--location": "value",
                        "--workload-identity-pool": "dynamic"
                      }
                    },
                    "create-oidc": {
                      "commands": {},
                      "flags": {
                        "--allowed-audiences": "value",
                        "--attribute-condition": "value",
                        "--attribute-mapping": "value",
                        "--description": "value",
                        "--disabled": "bool",
                        "--display-name": "value",
                        "--issuer-uri": "value",
                        "--jwk-json-path": "value",
                        "--location": "value",
                        "--workload-identity-pool": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--workload-identity-pool": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--workload-identity-pool": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--show-deleted": "bool",
                        "--sort-by": "value",
                        "--workload-identity-pool": "dynamic"
                      }
                    },
                    "operations": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--provider": "dynamic",
                            "--workload-identity-pool": "dynamic"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "undelete": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--workload-identity-pool": "dynamic"
                      }
                    },
                    "update-aws": {
                      "commands": {},
                      "flags": {
                        "--account-id": "value",
                        "--attribute-condition": "value",
                        "--attribute-mapping": "value",
                        "--description": "value",
                        "--disabled": "bool",
                        "--display-name": "value",
                        "--location": "value",
                        "--workload-identity-pool": "dynamic"
                      }
                    },
                    "update-oidc": {
                      "commands": {},
                      "flags": {
                        "--allowed-audiences": "value",
                        "--attribute-condition": "value",
                        "--attribute-mapping": "value",
                        "--description": "value",
                        "--disabled": "bool",
                        "--display-name": "value",
                        "--issuer-uri": "value",
                        "--jwk-json-path": "value",
                        "--location": "value",
                        "--workload-identity-pool": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "undelete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--disabled": "bool",
                    "--display-name": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "iap": {
          "commands": {
            "oauth-brands": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--application_title": "value",
                    "--support_email": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "oauth-clients": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--display_name": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--brand": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--brand": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "reset-secret": {
                  "commands": {},
                  "flags": {
                    "--brand": "value"
                  }
                }
              },
              "flags": {}
            },
            "settings": {
              "commands": {
                "get": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value",
                    "--region": "value",
                    "--resource-type": [
                      "app-engine",
                      "backend-services",
                      "cloud-run",
                      "compute",
                      "folder",
                      "forwarding-rule",
                      "iap_web",
                      "organization"
                    ],
                    "--service": "value"
                  }
                },
                "set": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value",
                    "--region": "value",
                    "--resource-type": [
                      "app-engine",
                      "backend-services",
                      "cloud-run",
                      "compute",
                      "folder",
                      "forwarding-rule",
                      "iap_web",
                      "organization"
                    ],
                    "--service": "value"
                  }
                }
              },
              "flags": {}
            },
            "tcp": {
              "commands": {
                "dest-groups": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--dest-group": "value",
                        "--member": "value",
                        "--region": "value",
                        "--role": "value"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--fqdn-list": "value",
                        "--ip-range-list": "value",
                        "--region": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--region": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "value"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--dest-group": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "value",
                        "--sort-by": "value"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--dest-group": "value",
                        "--member": "value",
                        "--region": "value",
                        "--role": "value"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--dest-group": "value",
                        "--region": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--fqdn-list": "value",
                        "--ip-range-list": "value",
                        "--region": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "web": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--region": "value",
                    "--resource-type": [
                      "app-engine",
                      "backend-services",
                      "cloud-run",
                      "forwarding-rule"
                    ],
                    "--role": "value",
                    "--service": "value"
                  }
                },
                "disable": {
                  "commands": {},
                  "flags": {
                    "--region": "value",
                    "--resource-type": [
                      "app-engine",
                      "backend-services"
                    ],
                    "--service": "value"
                  }
                },
                "enable": {
                  "commands": {},
                  "flags": {
                    "--oauth2-client-id": "value",
                    "--oauth2-client-secret": "value",
                    "--region": "value",
                    "--resource-type": [
                      "app-engine",
                      "backend-services"
                    ],
                    "--service": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--resource-type": [
                      "app-engine",
                      "backend-services",
                      "cloud-run",
                      "forwarding-rule"
                    ],
                    "--service": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--region": "value",
                    "--resource-type": [
                      "app-engine",
                      "backend-services",
                      "cloud-run",
                      "forwarding-rule"
                    ],
                    "--role": "value",
                    "--service": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "value",
                    "--resource-type": [
                      "app-engine",
                      "backend-services",
                      "cloud-run",
                      "forwarding-rule"
                    ],
                    "--service": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "identity": {
          "commands": {
            "groups": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--dynamic-user-query": "value",
                    "--group-type": [
                      "discussion",
                      "dynamic",
                      "security"
                    ],
                    "--labels": "value",
                    "--organization": "value",
                    "--with-initial-owner": [
                      "empty",
                      "with-initial-owner"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "memberships": {
                  "commands": {
                    "add": {
                      "commands": {},
                      "flags": {
                        "--expiration": "value",
                        "--group-email": "value",
                        "--member-email": "value",
                        "--organization": "value",
                        "--roles": "value"
                      }
                    },
                    "check-transitive-membership": {
                      "commands": {},
                      "flags": {
                        "--group-email": "value",
                        "--member-email": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--group-email": "value",
                        "--member-email": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--group-email": "value",
                        "--member-email": "value"
                      }
                    },
                    "get-membership-graph": {
                      "commands": {},
                      "flags": {
                        "--group-email": "value",
                        "--labels": "value",
                        "--member-email": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--group-email": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--page-token": "value",
                        "--sort-by": "value",
                        "--view": [
                          "basic",
                          "full"
                        ]
                      }
                    },
                    "modify-membership-roles": {
                      "commands": {},
                      "flags": {
                        "--add-roles": "value",
                        "--group-email": "value",
                        "--member-email": "value",
                        "--remove-roles": "value",
                        "--update-roles-params": "value"
                      }
                    },
                    "search-transitive-groups": {
                      "commands": {},
                      "flags": {
                        "--labels": "value",
                        "--member-email": "value",
                        "--page-size": "value",
                        "--page-token": "value"
                      }
                    },
                    "search-transitive-memberships": {
                      "commands": {},
                      "flags": {
                        "--group-email": "value",
                        "--page-size": "value",
                        "--page-token": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "preview": {
                  "commands": {},
                  "flags": {
                    "--custom-field-mask": "value",
                    "--customer": "value",
                    "--max-results": "value",
                    "--page-token": "value",
                    "--projection": [
                      "basic",
                      "custom",
                      "full"
                    ],
                    "--query": "value",
                    "--view-type": [
                      "admin-view",
                      "domain-public"
                    ]
                  }
                },
                "search": {
                  "commands": {},
                  "flags": {
                    "--labels": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--page-token": "value",
                    "--view": [
                      "basic",
                      "full"
                    ]
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-description": "bool",
                    "--clear-display-name": "bool",
                    "--clear-posix-groups": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--dynamic-user-query": "value",
                    "--remove-posix-groups": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "ids": {
          "commands": {
            "endpoints": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--enable-traffic-logs": "bool",
                    "--labels": "value",
                    "--max-wait": "value",
                    "--network": "value",
                    "--severity": [
                      "CRITICAL",
                      "HIGH",
                      "INFORMATIONAL",
                      "LOW",
                      "MEDIUM"
                    ],
                    "--threat-exceptions": "value",
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--max-wait": "value",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--max-wait": "value",
                    "--threat-exceptions": "value",
                    "--zone": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "value"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--max-wait": "value",
                    "--zone": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "immersive-stream": {
          "commands": {
            "xr": {
              "commands": {
                "contents": {
                  "commands": {
                    "build": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "dynamic"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bucket": "value",
                        "--location": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bucket": "value",
                        "--location": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "instances": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--add-region": "value",
                        "--async": "bool",
                        "--content": "value",
                        "--fallback-url": "value",
                        "--gpu-class": "value",
                        "--location": "value",
                        "--mode": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--add-region": "value",
                        "--async": "bool",
                        "--fallback-url": "value",
                        "--location": "value",
                        "--remove-region": "value",
                        "--update-region": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "wait": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "init": {
          "commands": {},
          "flags": {
            "--console-only": "bool",
            "--no-browser": "bool",
            "--no-launch-browser": "bool",
            "--skip-diagnostics": "bool"
          }
        },
        "interactive": {
          "commands": {},
          "flags": {
            "--context": "value"
          }
        },
        "kms": {
          "commands": {
            "asymmetric-decrypt": {
              "commands": {},
              "flags": {
                "--ciphertext-file": "value",
                "--key": "dynamic",
                "--keyring": "dynamic",
                "--location": "dynamic",
                "--plaintext-file": "value",
                "--skip-integrity-verification": "bool"
              }
            },
            "asymmetric-sign": {
              "commands": {},
              "flags": {
                "--digest-algorithm": [
                  "sha256",
                  "sha384",
                  "sha512"
                ],
                "--input-file": "value",
                "--key": "dynamic",
                "--keyring": "dynamic",
                "--location": "dynamic",
                "--signature-file": "value",
                "--skip-integrity-verification": "bool"
              }
            },
            "autokey-config": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--folder": "value"
                  }
                },
                "show-effective-config": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "decrypt": {
              "commands": {},
              "flags": {
                "--additional-authenticated-data-file": "value",
                "--ciphertext-file": "value",
                "--key": "dynamic",
                "--keyring": "dynamic",
                "--location": "dynamic",
                "--plaintext-file": "value",
                "--skip-integrity-verification": "bool"
              }
            },
            "ekm-config": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--location": "dynamic",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--location": "dynamic",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--default-ekm-connection": "value",
                    "--location": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "ekm-connections": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--crypto-space-path": "value",
                    "--endpoint-filter": "value",
                    "--hostname": "value",
                    "--key-management-mode": [
                      "cloud-kms",
                      "manual"
                    ],
                    "--location": "dynamic",
                    "--server-certificates-files": "value",
                    "--service-directory-service": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--crypto-space-path": "value",
                    "--endpoint-filter": "value",
                    "--hostname": "value",
                    "--key-management-mode": [
                      "cloud-kms",
                      "manual"
                    ],
                    "--location": "dynamic",
                    "--server-certificates-files": "value",
                    "--service-directory-service": "value"
                  }
                }
              },
              "flags": {}
            },
            "encrypt": {
              "commands": {},
              "flags": {
                "--additional-authenticated-data-file": "value",
                "--ciphertext-file": "value",
                "--key": "dynamic",
                "--keyring": "dynamic",
                "--location": "dynamic",
                "--plaintext-file": "value",
                "--skip-integrity-verification": "bool"
              }
            },
            "import-jobs": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--keyring": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--import-method": [
                      "rsa-oaep-3072-sha1-aes-256",
                      "rsa-oaep-3072-sha256",
                      "rsa-oaep-3072-sha256-aes-256",
                      "rsa-oaep-4096-sha1-aes-256",
                      "rsa-oaep-4096-sha256",
                      "rsa-oaep-4096-sha256-aes-256"
                    ],
                    "--keyring": "dynamic",
                    "--location": "dynamic",
                    "--protection-level": [
                      "hsm",
                      "software"
                    ]
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--attestation-file": "value",
                    "--keyring": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--keyring": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--keyring": "dynamic",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--keyring": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--keyring": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "inventory": {
              "commands": {
                "get-protected-resources-summary": {
                  "commands": {},
                  "flags": {
                    "--keyname": "dynamic",
                    "--keyring": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "list-keys": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "search-protected-resources": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--keyname": "dynamic",
                    "--keyring": "dynamic",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--resource-types": "value",
                    "--scope": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "key-handles": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--generate-key-handle-id": "bool",
                    "--key-handle-id": "value",
                    "--location": "dynamic",
                    "--resource-type": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--resource-type": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "keyrings": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--location": "value",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "keys": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--keyring": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--keyring": "value",
                        "--location": "value",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--allowed-access-reasons": "value",
                    "--crypto-key-backend": "value",
                    "--default-algorithm": [
                      "aes-128-cbc",
                      "aes-128-ctr",
                      "aes-128-gcm",
                      "aes-256-cbc",
                      "aes-256-ctr",
                      "aes-256-gcm",
                      "ec-sign-ed25519",
                      "ec-sign-p256-sha256",
                      "ec-sign-p384-sha384",
                      "ec-sign-secp256k1-sha256",
                      "external-symmetric-encryption",
                      "google-symmetric-encryption",
                      "hmac-sha1",
                      "hmac-sha224",
                      "hmac-sha256",
                      "hmac-sha384",
                      "hmac-sha512",
                      "rsa-decrypt-oaep-2048-sha1",
                      "rsa-decrypt-oaep-2048-sha256",
                      "rsa-decrypt-oaep-3072-sha1",
                      "rsa-decrypt-oaep-3072-sha256",
                      "rsa-decrypt-oaep-4096-sha1",
                      "rsa-decrypt-oaep-4096-sha256",
                      "rsa-decrypt-oaep-4096-sha512",
                      "rsa-sign-pkcs1-2048-sha256",
                      "rsa-sign-pkcs1-3072-sha256",
                      "rsa-sign-pkcs1-4096-sha256",
                      "rsa-sign-pkcs1-4096-sha512",
                      "rsa-sign-pss-2048-sha256",
                      "rsa-sign-pss-3072-sha256",
                      "rsa-sign-pss-4096-sha256",
                      "rsa-sign-pss-4096-sha512",
                      "rsa-sign-raw-pkcs1-2048",
                      "rsa-sign-raw-pkcs1-3072",
                      "rsa-sign-raw-pkcs1-4096"
                    ],
                    "--destroy-scheduled-duration": "value",
                    "--import-only": "bool",
                    "--keyring": "dynamic",
                    "--labels": "value",
                    "--location": "dynamic",
                    "--next-rotation-time": "value",
                    "--protection-level": [
                      "external",
                      "external-vpc",
                      "hsm",
                      "software"
                    ],
                    "--purpose": [
                      "asymmetric-encryption",
                      "asymmetric-signing",
                      "encryption",
                      "mac",
                      "raw-encryption"
                    ],
                    "--rotation-period": "value",
                    "--skip-initial-version-creation": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--keyring": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--keyring": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--keyring": "dynamic",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--keyring": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "remove-rotation-schedule": {
                  "commands": {},
                  "flags": {
                    "--keyring": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--keyring": "value",
                    "--location": "value"
                  }
                },
                "set-primary-version": {
                  "commands": {},
                  "flags": {
                    "--keyring": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "set-rotation-schedule": {
                  "commands": {},
                  "flags": {
                    "--keyring": "dynamic",
                    "--location": "dynamic",
                    "--next-rotation-time": "value",
                    "--rotation-period": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--allowed-access-reasons": "value",
                    "--clear-labels": "bool",
                    "--default-algorithm": [
                      "aes-128-cbc",
                      "aes-128-ctr",
                      "aes-128-gcm",
                      "aes-256-cbc",
                      "aes-256-ctr",
                      "aes-256-gcm",
                      "ec-sign-ed25519",
                      "ec-sign-p256-sha256",
                      "ec-sign-p384-sha384",
                      "ec-sign-secp256k1-sha256",
                      "external-symmetric-encryption",
                      "google-symmetric-encryption",
                      "hmac-sha1",
                      "hmac-sha224",
                      "hmac-sha256",
                      "hmac-sha384",
                      "hmac-sha512",
                      "rsa-decrypt-oaep-2048-sha1",
                      "rsa-decrypt-oaep-2048-sha256",
                      "rsa-decrypt-oaep-3072-sha1",
                      "rsa-decrypt-oaep-3072-sha256",
                      "rsa-decrypt-oaep-4096-sha1",
                      "rsa-decrypt-oaep-4096-sha256",
                      "rsa-decrypt-oaep-4096-sha512",
                      "rsa-sign-pkcs1-2048-sha256",
                      "rsa-sign-pkcs1-3072-sha256",
                      "rsa-sign-pkcs1-4096-sha256",
                      "rsa-sign-pkcs1-4096-sha512",
                      "rsa-sign-pss-2048-sha256",
                      "rsa-sign-pss-3072-sha256",
                      "rsa-sign-pss-4096-sha256",
                      "rsa-sign-pss-4096-sha512",
                      "rsa-sign-raw-pkcs1-2048",
                      "rsa-sign-raw-pkcs1-3072",
                      "rsa-sign-raw-pkcs1-4096"
                    ],
                    "--keyring": "dynamic",
                    "--location": "dynamic",
                    "--next-rotation-time": "value",
                    "--primary-version": "dynamic",
                    "--remove-key-access-justifications-policy": "bool",
                    "--remove-labels": "value",
                    "--remove-rotation-schedule": "bool",
                    "--rotation-period": "value",
                    "--update-labels": "value"
                  }
                },
                "versions": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--ekm-connection-key-path": "value",
                        "--external-key-uri": "value",
                        "--key": "dynamic",
                        "--keyring": "dynamic",
                        "--location": "dynamic",
                        "--primary": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--attestation-file": "value",
                        "--key": "dynamic",
                        "--keyring": "dynamic",
                        "--location": "dynamic"
                      }
                    },
                    "destroy": {
                      "commands": {},
                      "flags": {
                        "--key": "dynamic",
                        "--keyring": "dynamic",
                        "--location": "dynamic"
                      }
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--key": "dynamic",
                        "--keyring": "dynamic",
                        "--location": "dynamic"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--key": "dynamic",
                        "--keyring": "dynamic",
                        "--location": "dynamic"
                      }
                    },
                    "get-certificate-chain": {
                      "commands": {},
                      "flags": {
                        "--certificate-chain-type": [
                          "all",
                          "cavium",
                          "google-card",
                          "google-partition"
                        ],
                        "--key": "dynamic",
                        "--keyring": "dynamic",
                        "--location": "dynamic",
                        "--output-file": "value"
                      }
                    },
                    "get-public-key": {
                      "commands": {},
                      "flags": {
                        "--key": "dynamic",
                        "--keyring": "dynamic",
                        "--location": "dynamic",
                        "--output-file": "value"
                      }
                    },
                    "import": {
                      "commands": {},
                      "flags": {
                        "--algorithm": [
                          "aes-128-cbc",
                          "aes-128-ctr",
                          "aes-128-gcm",
                          "aes-256-cbc",
                          "aes-256-ctr",
                          "aes-256-gcm",
                          "ec-sign-ed25519",
                          "ec-sign-p256-sha256",
                          "ec-sign-p384-sha384",
                          "ec-sign-secp256k1-sha256",
                          "google-symmetric-encryption",
                          "hmac-sha1",
                          "hmac-sha224",
                          "hmac-sha256",
                          "hmac-sha384",
                          "hmac-sha512",
                          "rsa-decrypt-oaep-2048-sha1",
                          "rsa-decrypt-oaep-2048-sha256",
                          "rsa-decrypt-oaep-3072-sha1",
                          "rsa-decrypt-oaep-3072-sha256",
                          "rsa-decrypt-oaep-4096-sha1",
                          "rsa-decrypt-oaep-4096-sha256",
                          "rsa-decrypt-oaep-4096-sha512",
                          "rsa-sign-pkcs1-2048-sha256",
                          "rsa-sign-pkcs1-3072-sha256",
                          "rsa-sign-pkcs1-4096-sha256",
                          "rsa-sign-pkcs1-4096-sha512",
                          "rsa-sign-pss-2048-sha256",
                          "rsa-sign-pss-3072-sha256",
                          "rsa-sign-pss-4096-sha256",
                          "rsa-sign-pss-4096-sha512",
                          "rsa-sign-raw-pkcs1-2048",
                          "rsa-sign-raw-pkcs1-3072",
                          "rsa-sign-raw-pkcs1-4096"
                        ],
                        "--import-job": "dynamic",
                        "--key": "dynamic",
                        "--keyring": "dynamic",
                        "--location": "dynamic",
                        "--public-key-file": "value",
                        "--target-key-file": "value",
                        "--wrapped-key-file": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--key": "dynamic",
                        "--keyring": "dynamic",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "restore": {
                      "commands": {},
                      "flags": {
                        "--key": "dynamic",
                        "--keyring": "dynamic",
                        "--location": "dynamic"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--ekm-connection-key-path": "value",
                        "--external-key-uri": "value",
                        "--key": "dynamic",
                        "--keyring": "dynamic",
                        "--location": "dynamic",
                        "--state": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "mac-sign": {
              "commands": {},
              "flags": {
                "--input-file": "value",
                "--key": "dynamic",
                "--keyring": "dynamic",
                "--location": "dynamic",
                "--signature-file": "value",
                "--skip-integrity-verification": "bool"
              }
            },
            "mac-verify": {
              "commands": {},
              "flags": {
                "--input-file": "value",
                "--key": "dynamic",
                "--keyring": "dynamic",
                "--location": "dynamic",
                "--signature-file": "value",
                "--skip-integrity-verification": "bool"
              }
            },
            "raw-decrypt": {
              "commands": {},
              "flags": {
                "--additional-authenticated-data-file": "value",
                "--ciphertext-file": "value",
                "--initialization-vector-file": "value",
                "--key": "dynamic",
                "--keyring": "dynamic",
                "--location": "dynamic",
                "--plaintext-file": "value",
                "--skip-integrity-verification": "bool"
              }
            },
            "raw-encrypt": {
              "commands": {},
              "flags": {
                "--additional-authenticated-data-file": "value",
                "--ciphertext-file": "value",
                "--initialization-vector-file": "value",
                "--key": "dynamic",
                "--keyring": "dynamic",
                "--location": "dynamic",
                "--plaintext-file": "value",
                "--skip-integrity-verification": "bool"
              }
            }
          },
          "flags": {}
        },
        "lifesciences": {
          "commands": {
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "pipelines": {
              "commands": {
                "run": {
                  "commands": {},
                  "flags": {
                    "--boot-disk-size": "value",
                    "--command-line": "value",
                    "--disk-size": "value",
                    "--docker-image": "value",
                    "--env-vars": "value",
                    "--inputs": "value",
                    "--inputs-from-file": "value",
                    "--labels": "value",
                    "--location": "dynamic",
                    "--logging": "value",
                    "--machine-type": "value",
                    "--network": "value",
                    "--outputs": "value",
                    "--pipeline-file": "value",
                    "--preemptible": "bool",
                    "--regions": "value",
                    "--service-account-email": "value",
                    "--service-account-scopes": "value",
                    "--subnetwork": "value",
                    "--zones": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "logging": {
          "commands": {
            "buckets": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cmek-kms-key-name": "value",
                    "--description": "value",
                    "--enable-analytics": "bool",
                    "--index": "value",
                    "--location": "value",
                    "--restricted-fields": "value",
                    "--retention-days": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "undelete": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-index": "value",
                    "--async": "bool",
                    "--billing-account": "value",
                    "--clear-indexes": "bool",
                    "--cmek-kms-key-name": "value",
                    "--description": "value",
                    "--enable-analytics": "bool",
                    "--folder": "value",
                    "--location": "value",
                    "--locked": "bool",
                    "--organization": "dynamic",
                    "--remove-indexes": "value",
                    "--restricted-fields": "value",
                    "--retention-days": "value",
                    "--update-index": "value"
                  }
                }
              },
              "flags": {}
            },
            "copy": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--folder": "value",
                "--location": "value",
                "--log-filter": "value",
                "--organization": "dynamic"
              }
            },
            "links": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--billing-account": "value",
                    "--bucket": "value",
                    "--description": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--billing-account": "value",
                    "--bucket": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--bucket": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--bucket": "value",
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--folder": "value",
                    "--organization": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--organization": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "logs": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--bucket": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--sort-by": "value",
                    "--view": "value"
                  }
                }
              },
              "flags": {}
            },
            "metrics": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--bucket-name": "value",
                    "--config-from-file": "value",
                    "--description": "value",
                    "--log-filter": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--bucket-name": "value",
                    "--config-from-file": "value",
                    "--description": "value",
                    "--log-filter": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--operation-filter": "value",
                    "--organization": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "read": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--bucket": "value",
                "--folder": "value",
                "--freshness": "value",
                "--limit": "value",
                "--location": "value",
                "--order": [
                  "asc",
                  "desc"
                ],
                "--organization": "dynamic",
                "--resource-names": "value",
                "--view": "value"
              }
            },
            "resource-descriptors": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "settings": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--folder": "value",
                    "--organization": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-kms-key": "bool",
                    "--disable-default-sink": "bool",
                    "--folder": "value",
                    "--kms-key-name": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--organization": "dynamic",
                    "--storage-location": "value"
                  }
                }
              },
              "flags": {}
            },
            "sinks": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--custom-writer-identity": "value",
                    "--description": "value",
                    "--disabled": "bool",
                    "--exclusion": "value",
                    "--folder": "value",
                    "--include-children": "bool",
                    "--intercept-children": "bool",
                    "--log-filter": "value",
                    "--organization": "dynamic",
                    "--use-partitioned-tables": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--folder": "value",
                    "--organization": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--folder": "value",
                    "--organization": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--organization": "dynamic",
                    "--sink-filter": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-exclusion": "value",
                    "--billing-account": "value",
                    "--clear-exclusions": "bool",
                    "--custom-writer-identity": "value",
                    "--description": "value",
                    "--disabled": "bool",
                    "--folder": "value",
                    "--include-children": "bool",
                    "--intercept-children": "bool",
                    "--log-filter": "value",
                    "--organization": "dynamic",
                    "--remove-exclusions": "value",
                    "--update-exclusion": "value",
                    "--use-partitioned-tables": "bool"
                  }
                }
              },
              "flags": {}
            },
            "tail": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--bucket": "value",
                "--buffer-window": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "dynamic",
                "--view": "value"
              }
            },
            "views": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--bucket": "value",
                    "--description": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--log-filter": "value",
                    "--organization": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--bucket": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--bucket": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--bucket": "value",
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--bucket": "value",
                    "--description": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--log-filter": "value",
                    "--organization": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "write": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--folder": "value",
                "--organization": "dynamic",
                "--payload-type": [
                  "json",
                  "text"
                ],
                "--severity": [
                  "ALERT",
                  "CRITICAL",
                  "DEBUG",
                  "DEFAULT",
                  "EMERGENCY",
                  "ERROR",
                  "INFO",
                  "NOTICE",
                  "WARNING"
                ]
              }
            }
          },
          "flags": {}
        },
        "looker": {
          "commands": {
            "instances": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--consumer-network": "value",
                    "--deny-maintenance-period-end-date": "value",
                    "--deny-maintenance-period-start-date": "value",
                    "--deny-maintenance-period-time": "value",
                    "--edition": [
                      "core-embed-annual",
                      "core-enterprise-annual",
                      "core-standard",
                      "core-standard-annual",
                      "core-trial",
                      "nonprod-core-embed-annual",
                      "nonprod-core-enterprise-annual",
                      "nonprod-core-standard-annual"
                    ],
                    "--fips-enabled": "bool",
                    "--gemini-enabled": "bool",
                    "--gemini-preview-tester-enabled": "bool",
                    "--gemini-prompt-log-enabled": "bool",
                    "--kms-key": "value",
                    "--maintenance-window-day": [
                      "friday",
                      "monday",
                      "saturday",
                      "sunday",
                      "thursday",
                      "tuesday",
                      "wednesday"
                    ],
                    "--maintenance-window-time": "value",
                    "--oauth-client-id": "value",
                    "--oauth-client-secret": "value",
                    "--private-ip-enabled": "bool",
                    "--psc-allowed-vpcs": "value",
                    "--psc-enabled": "bool",
                    "--public-ip-enabled": "bool",
                    "--region": "dynamic",
                    "--reserved-range": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--force": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--kms-key": "value",
                    "--region": "value",
                    "--target-gcs-uri": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--region": "value",
                    "--source-gcs-uri": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "restart": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-developer-users": "value",
                    "--add-standard-users": "value",
                    "--add-viewer-users": "value",
                    "--allowed-email-domains": "value",
                    "--async": "bool",
                    "--clear-psc-allowed-vpcs": "bool",
                    "--clear-psc-service-attachments": "bool",
                    "--custom-domain": "value",
                    "--deny-maintenance-period-end-date": "value",
                    "--deny-maintenance-period-start-date": "value",
                    "--deny-maintenance-period-time": "value",
                    "--gemini-enabled": "bool",
                    "--gemini-preview-tester-enabled": "bool",
                    "--gemini-prompt-log-enabled": "bool",
                    "--linked-lsp-project-number": "value",
                    "--maintenance-window-day": [
                      "friday",
                      "monday",
                      "saturday",
                      "sunday",
                      "thursday",
                      "tuesday",
                      "wednesday"
                    ],
                    "--maintenance-window-time": "value",
                    "--oauth-client-id": "value",
                    "--oauth-client-secret": "value",
                    "--psc-allowed-vpcs": "value",
                    "--psc-service-attachment": "value",
                    "--public-ip-enabled": "bool",
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "regions": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "managed-flink": {
          "commands": {
            "deployments": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--display-name": "value",
                    "--location": "value",
                    "--max-slots": "value",
                    "--network-config-subnetwork": "value",
                    "--network-config-vpc": "value",
                    "--workload-identity": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--max-slots": "value"
                  }
                }
              },
              "flags": {}
            },
            "jobs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--archives": "value",
                    "--async": "bool",
                    "--autotuning-mode": [
                      "elastic",
                      "fixed"
                    ],
                    "--class": "value",
                    "--deployment": "dynamic",
                    "--dry-run": "bool",
                    "--enable-output": "bool",
                    "--jars": "value",
                    "--job-type": [
                      "auto",
                      "jar",
                      "python",
                      "sql"
                    ],
                    "--location": "value",
                    "--max-parallelism": "value",
                    "--min-parallelism": "value",
                    "--name": "value",
                    "--network-config-subnetwork": "value",
                    "--network-config-vpc": "value",
                    "--parallelism": "value",
                    "--python-venv": "value",
                    "--staging-location": "value",
                    "--workload-identity": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--autotuning-mode": [
                      "elastic",
                      "fixed"
                    ],
                    "--deployment": "dynamic",
                    "--enable-output": "bool",
                    "--location": "value",
                    "--max-parallelism": "value",
                    "--min-parallelism": "value",
                    "--parallelism": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "managed-kafka": {
          "commands": {
            "clusters": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--auto-rebalance": "bool",
                    "--cpu": "value",
                    "--encryption-key": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--memory": "value",
                    "--subnets": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--auto-rebalance": "bool",
                    "--cpu": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--memory": "value",
                    "--subnets": "value"
                  }
                }
              },
              "flags": {}
            },
            "consumer-groups": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--location": "value",
                    "--topics-file": "value"
                  }
                }
              },
              "flags": {}
            },
            "topics": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--configs": "value",
                    "--location": "value",
                    "--partitions": "value",
                    "--replication-factor": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-configs": "bool",
                    "--cluster": "value",
                    "--configs": "value",
                    "--location": "value",
                    "--partitions": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "media": {
          "commands": {},
          "flags": {}
        },
        "memcache": {
          "commands": {
            "instances": {
              "commands": {
                "apply-parameters": {
                  "commands": {},
                  "flags": {
                    "--apply-all": "bool",
                    "--async": "bool",
                    "--node-ids": "value",
                    "--region": "dynamic"
                  }
                },
                "apply-software-update": {
                  "commands": {},
                  "flags": {
                    "--apply-all": "bool",
                    "--async": "bool",
                    "--node-ids": "value",
                    "--region": "dynamic"
                  }
                },
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--region": "dynamic",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--authorized-network": "value",
                    "--display-name": "value",
                    "--labels": "value",
                    "--maintenance-window-day": [
                      "friday",
                      "monday",
                      "saturday",
                      "sunday",
                      "thursday",
                      "tuesday",
                      "wednesday"
                    ],
                    "--maintenance-window-duration": "value",
                    "--maintenance-window-start-time": "value",
                    "--memcached-version": [
                      "1.5",
                      "1.6.15"
                    ],
                    "--node-count": "value",
                    "--node-cpu": "value",
                    "--node-memory": "value",
                    "--parameters": "value",
                    "--region": "dynamic",
                    "--reserved-ip-range-id": "value",
                    "--zones": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "reschedule-maintenance": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic",
                    "--reschedule-type": [
                      "immediate",
                      "next-available-window",
                      "specific-time"
                    ],
                    "--schedule-time": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--display-name": "value",
                    "--labels": "value",
                    "--maintenance-window-any": "bool",
                    "--maintenance-window-day": [
                      "friday",
                      "monday",
                      "saturday",
                      "sunday",
                      "thursday",
                      "tuesday",
                      "wednesday"
                    ],
                    "--maintenance-window-duration": "value",
                    "--maintenance-window-start-time": "value",
                    "--node-count": "value",
                    "--parameters": "value",
                    "--region": "dynamic"
                  }
                },
                "upgrade": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--memcached-version": [
                      "1.6.15"
                    ],
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "regions": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "memorystore": {
          "commands": {
            "instances": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--aof-config-append-fsync": [
                      "always",
                      "every-sec",
                      "never"
                    ],
                    "--async": "bool",
                    "--authorization-mode": [
                      "auth-disabled",
                      "iam-auth"
                    ],
                    "--deletion-protection-enabled": "bool",
                    "--engine-configs": "value",
                    "--engine-version": "value",
                    "--labels": "value",
                    "--location": "dynamic",
                    "--mode": [
                      "cluster",
                      "cluster-disabled"
                    ],
                    "--node-type": [
                      "highmem-medium",
                      "highmem-xlarge",
                      "shared-core-nano",
                      "standard-small"
                    ],
                    "--persistence-config-mode": [
                      "aof",
                      "disabled",
                      "rdb"
                    ],
                    "--psc-auto-connections": "value",
                    "--rdb-config-snapshot-period": [
                      "one-hour",
                      "six-hours",
                      "twelve-hours",
                      "twenty-four-hours"
                    ],
                    "--rdb-config-snapshot-start-time": "value",
                    "--replica-count": "value",
                    "--request-id": "value",
                    "--shard-count": "value",
                    "--transit-encryption-mode": [
                      "server-authentication",
                      "transit-encryption-disabled"
                    ],
                    "--zone-distribution-config": "value",
                    "--zone-distribution-config-mode": [
                      "multi-zone",
                      "single-zone"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic",
                    "--request-id": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "get-certificate-authority": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--aof-config-append-fsync": [
                      "always",
                      "every-sec",
                      "never"
                    ],
                    "--async": "bool",
                    "--clear-engine-configs": "bool",
                    "--clear-labels": "bool",
                    "--deletion-protection-enabled": "bool",
                    "--engine-configs": "value",
                    "--labels": "value",
                    "--location": "dynamic",
                    "--persistence-config-mode": [
                      "aof",
                      "disabled",
                      "rdb"
                    ],
                    "--rdb-config-snapshot-period": [
                      "one-hour",
                      "six-hours",
                      "twelve-hours",
                      "twenty-four-hours"
                    ],
                    "--rdb-config-snapshot-start-time": "value",
                    "--remove-engine-configs": "value",
                    "--remove-labels": "value",
                    "--replica-count": "value",
                    "--request-id": "value",
                    "--shard-count": "value",
                    "--update-engine-configs": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "metastore": {
          "commands": {
            "federations": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--backends": "value",
                    "--hive-metastore-version": [
                      "2.3.6",
                      "3.1.2"
                    ],
                    "--labels": "value",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-backends": "bool",
                    "--clear-labels": "bool",
                    "--location": "value",
                    "--remove-backends": "value",
                    "--remove-labels": "value",
                    "--update-backends": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "services": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "alter-metadata-resource-location": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--location_uri": "value",
                    "--resource_name": "value"
                  }
                },
                "alter-table-properties": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--properties": "value",
                    "--table-name": "value",
                    "--update-mask": "value"
                  }
                },
                "backups": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--member": "value",
                        "--role": "dynamic",
                        "--service": "value"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value",
                        "--location": "value",
                        "--service": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--service": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--service": "value"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--service": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--service": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--member": "value",
                        "--role": "dynamic",
                        "--service": "value"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--service": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--autoscaling-enabled": "bool",
                    "--auxiliary-versions": "value",
                    "--auxiliary-versions-from-file": "value",
                    "--consumer-subnetworks": "value",
                    "--data-catalog-sync": "bool",
                    "--database-type": [
                      "mysql",
                      "spanner"
                    ],
                    "--deletion-protection": "bool",
                    "--enable-scheduled-backup": "bool",
                    "--encryption-kms-key": "value",
                    "--endpoint-protocol": [
                      "grpc",
                      "thrift"
                    ],
                    "--hive-metastore-configs": "value",
                    "--hive-metastore-configs-from-file": "value",
                    "--hive-metastore-version": "value",
                    "--instance-size": [
                      "extra-large",
                      "extra-small",
                      "large",
                      "medium",
                      "small"
                    ],
                    "--kerberos-principal": "value",
                    "--keytab": "value",
                    "--krb5-config": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--maintenance-window-day": [
                      "fri",
                      "mon",
                      "sat",
                      "sun",
                      "thu",
                      "tue",
                      "wed"
                    ],
                    "--maintenance-window-hour": "value",
                    "--max-scaling-factor": "value",
                    "--min-scaling-factor": "value",
                    "--network": "value",
                    "--network-config-from-file": "value",
                    "--port": "value",
                    "--read-only-regions": "value",
                    "--read-write-regions": "value",
                    "--release-channel": [
                      "canary",
                      "stable"
                    ],
                    "--scaling-factor": "value",
                    "--scheduled-backup-configs-from-file": "value",
                    "--scheduled-backup-cron": "value",
                    "--scheduled-backup-location": "value",
                    "--tier": [
                      "developer",
                      "enterprise"
                    ]
                  }
                },
                "databases": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--member": "value",
                        "--role": "dynamic",
                        "--service": "value"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--service": "value",
                        "--sort-by": "value"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--member": "value",
                        "--role": "dynamic",
                        "--service": "value"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--service": "value"
                      }
                    },
                    "tables": {
                      "commands": {
                        "add-iam-policy-binding": {
                          "commands": {},
                          "flags": {
                            "--database": "value",
                            "--location": "value",
                            "--member": "value",
                            "--role": "dynamic",
                            "--service": "value"
                          }
                        },
                        "get-iam-policy": {
                          "commands": {},
                          "flags": {
                            "--database": "value",
                            "--filter": "value",
                            "--limit": "value",
                            "--location": "value",
                            "--page-size": "value",
                            "--service": "value",
                            "--sort-by": "value"
                          }
                        },
                        "remove-iam-policy-binding": {
                          "commands": {},
                          "flags": {
                            "--database": "value",
                            "--location": "value",
                            "--member": "value",
                            "--role": "dynamic",
                            "--service": "value"
                          }
                        },
                        "set-iam-policy": {
                          "commands": {},
                          "flags": {
                            "--database": "value",
                            "--location": "value",
                            "--service": "value"
                          }
                        }
                      },
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {
                    "gcs": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--destination-folder": "value",
                        "--dump-type": [
                          "avro",
                          "mysql"
                        ],
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "import": {
                  "commands": {
                    "gcs": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--database-dump": "value",
                        "--description": "value",
                        "--dump-type": [
                          "avro",
                          "mysql"
                        ],
                        "--import-id": "value",
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "imports": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--database-dump": "value",
                        "--database-dump-type": [
                          "mysql"
                        ],
                        "--database-type": [
                          "mysql"
                        ],
                        "--description": "value",
                        "--location": "value",
                        "--service": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--service": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--service": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value",
                        "--location": "value",
                        "--service": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "migrations": {
                  "commands": {
                    "cancel": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value"
                      }
                    },
                    "complete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--service": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--service": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--service": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "start": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bucket": "value",
                        "--cdc-password": "value",
                        "--cdc-username": "value",
                        "--connection-password": "value",
                        "--connection-username": "value",
                        "--hive-database-name": "value",
                        "--instance-connection-name": "value",
                        "--ip-address": "value",
                        "--location": "value",
                        "--nat-subnet": "value",
                        "--port": "value",
                        "--proxy-subnet": "value",
                        "--reverse-proxy-subnet": "value",
                        "--root-path": "value",
                        "--subnet-ip-range": "value",
                        "--vpc-network": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "move-table-to-database": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--destination_db_name": "value",
                    "--location": "value",
                    "--source_db_name": "value",
                    "--table_name": "value"
                  }
                },
                "query-metadata": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--query": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "restore": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--backup": "value",
                    "--backup-location": "value",
                    "--location": "value",
                    "--restore-type": [
                      "full",
                      "metadata-only"
                    ]
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-auxiliary-versions": "value",
                    "--async": "bool",
                    "--autoscaling-enabled": "bool",
                    "--clear-auxiliary-versions": "bool",
                    "--clear-hive-metastore-configs": "bool",
                    "--clear-labels": "bool",
                    "--data-catalog-sync": "bool",
                    "--deletion-protection": "bool",
                    "--enable-scheduled-backup": "bool",
                    "--endpoint-protocol": [
                      "grpc",
                      "thrift"
                    ],
                    "--instance-size": [
                      "extra-large",
                      "extra-small",
                      "large",
                      "medium",
                      "small"
                    ],
                    "--kerberos-principal": "value",
                    "--keytab": "value",
                    "--krb5-config": "value",
                    "--location": "value",
                    "--maintenance-window-day": [
                      "fri",
                      "mon",
                      "sat",
                      "sun",
                      "thu",
                      "tue",
                      "wed"
                    ],
                    "--maintenance-window-hour": "value",
                    "--max-scaling-factor": "value",
                    "--min-scaling-factor": "value",
                    "--port": "value",
                    "--remove-hive-metastore-configs": "value",
                    "--remove-labels": "value",
                    "--scaling-factor": "value",
                    "--scheduled-backup-configs-from-file": "value",
                    "--scheduled-backup-cron": "value",
                    "--scheduled-backup-location": "value",
                    "--tier": [
                      "developer",
                      "enterprise"
                    ],
                    "--update-auxiliary-versions-from-file": "value",
                    "--update-hive-metastore-configs": "value",
                    "--update-hive-metastore-configs-from-file": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "migration": {
          "commands": {
            "vms": {
              "commands": {
                "image-imports": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--additional-licenses": "value",
                        "--description": "value",
                        "--family-name": "value",
                        "--generalize": "bool",
                        "--image-name": "value",
                        "--kms-key": "value",
                        "--labels": "value",
                        "--license-type": [
                          "compute-engine-license-type-byol",
                          "compute-engine-license-type-default",
                          "compute-engine-license-type-payg"
                        ],
                        "--location": "dynamic",
                        "--single-region-storage": "bool",
                        "--skip-os-adaptation": "bool",
                        "--source-file": "value",
                        "--target-project": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "machine-image-imports": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--additional-licenses": "value",
                        "--description": "value",
                        "--enable-integrity-monitoring": "bool",
                        "--enable-vtpm": "bool",
                        "--generalize": "bool",
                        "--kms-key": "value",
                        "--labels": "value",
                        "--license-type": [
                          "compute-engine-license-type-byol",
                          "compute-engine-license-type-default",
                          "compute-engine-license-type-payg"
                        ],
                        "--location": "dynamic",
                        "--machine-image-name": "value",
                        "--machine-type": "value",
                        "--network-interface": "value",
                        "--scopes": "value",
                        "--secure-boot": [
                          "false",
                          "secure-boot-unspecified",
                          "true"
                        ],
                        "--service-account": "value",
                        "--single-region-storage": "bool",
                        "--skip-os-adaptation": "bool",
                        "--source-file": "value",
                        "--tags": "value",
                        "--target-project": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "target-projects": {
                  "commands": {
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "ml": {
          "commands": {
            "language": {
              "commands": {
                "analyze-entities": {
                  "commands": {},
                  "flags": {
                    "--content": "value",
                    "--content-file": "value",
                    "--content-type": [
                      "html",
                      "plain-text"
                    ],
                    "--encoding-type": [
                      "none",
                      "utf16",
                      "utf32",
                      "utf8"
                    ],
                    "--language": "value"
                  }
                },
                "analyze-entity-sentiment": {
                  "commands": {},
                  "flags": {
                    "--content": "value",
                    "--content-file": "value",
                    "--content-type": [
                      "html",
                      "plain-text"
                    ],
                    "--encoding-type": [
                      "none",
                      "utf16",
                      "utf32",
                      "utf8"
                    ],
                    "--language": "value"
                  }
                },
                "analyze-sentiment": {
                  "commands": {},
                  "flags": {
                    "--content": "value",
                    "--content-file": "value",
                    "--content-type": [
                      "html",
                      "plain-text"
                    ],
                    "--encoding-type": [
                      "none",
                      "utf16",
                      "utf32",
                      "utf8"
                    ],
                    "--language": "value"
                  }
                },
                "analyze-syntax": {
                  "commands": {},
                  "flags": {
                    "--content": "value",
                    "--content-file": "value",
                    "--content-type": [
                      "html",
                      "plain-text"
                    ],
                    "--encoding-type": [
                      "none",
                      "utf16",
                      "utf32",
                      "utf8"
                    ],
                    "--language": "value"
                  }
                },
                "classify-text": {
                  "commands": {},
                  "flags": {
                    "--content": "value",
                    "--content-file": "value",
                    "--content-type": [
                      "html",
                      "plain-text"
                    ],
                    "--language": "value"
                  }
                }
              },
              "flags": {}
            },
            "speech": {
              "commands": {
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "wait": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "recognize": {
                  "commands": {},
                  "flags": {
                    "--additional-language-codes": "value",
                    "--audio-channel-count": "value",
                    "--audio-topic": "value",
                    "--enable-automatic-punctuation": "bool",
                    "--enable-speaker-diarization": "bool",
                    "--encoding": [
                      "alaw",
                      "amr",
                      "amr-wb",
                      "encoding-unspecified",
                      "flac",
                      "linear16",
                      "mp3",
                      "mulaw",
                      "ogg-opus",
                      "speex-with-header-byte",
                      "webm-opus"
                    ],
                    "--filter-profanity": "bool",
                    "--hints": "value",
                    "--include-word-confidence": "bool",
                    "--include-word-time-offsets": "bool",
                    "--interaction-type": [
                      "dictation",
                      "discussion",
                      "phone-call",
                      "presentation",
                      "professionally-produced",
                      "voice-command",
                      "voice-search",
                      "voicemail"
                    ],
                    "--language-code": "value",
                    "--max-alternatives": "value",
                    "--max-diarization-speaker-count": "value",
                    "--microphone-distance": [
                      "farfield",
                      "midfield",
                      "nearfield"
                    ],
                    "--min-diarization-speaker-count": "value",
                    "--model": [
                      "command_and_search",
                      "default",
                      "latest_long",
                      "latest_short",
                      "medical_conversation",
                      "medical_dictation",
                      "phone_call",
                      "phone_call_enhanced",
                      "telephony",
                      "telephony_short",
                      "video_enhanced"
                    ],
                    "--naics-code": "value",
                    "--original-media-type": [
                      "audio",
                      "video"
                    ],
                    "--original-mime-type": "value",
                    "--recording-device-name": "value",
                    "--recording-device-type": [
                      "indoor",
                      "outdoor",
                      "pc",
                      "phone-line",
                      "smartphone",
                      "vehicle"
                    ],
                    "--sample-rate": "value",
                    "--separate-channel-recognition": "bool"
                  }
                },
                "recognize-long-running": {
                  "commands": {},
                  "flags": {
                    "--additional-language-codes": "value",
                    "--async": "bool",
                    "--audio-channel-count": "value",
                    "--audio-topic": "value",
                    "--enable-automatic-punctuation": "bool",
                    "--enable-speaker-diarization": "bool",
                    "--encoding": [
                      "alaw",
                      "amr",
                      "amr-wb",
                      "encoding-unspecified",
                      "flac",
                      "linear16",
                      "mp3",
                      "mulaw",
                      "ogg-opus",
                      "speex-with-header-byte",
                      "webm-opus"
                    ],
                    "--filter-profanity": "bool",
                    "--hints": "value",
                    "--include-word-confidence": "bool",
                    "--include-word-time-offsets": "bool",
                    "--interaction-type": [
                      "dictation",
                      "discussion",
                      "phone-call",
                      "presentation",
                      "professionally-produced",
                      "voice-command",
                      "voice-search",
                      "voicemail"
                    ],
                    "--language-code": "value",
                    "--max-alternatives": "value",
                    "--max-diarization-speaker-count": "value",
                    "--microphone-distance": [
                      "farfield",
                      "midfield",
                      "nearfield"
                    ],
                    "--min-diarization-speaker-count": "value",
                    "--model": [
                      "command_and_search",
                      "default",
                      "latest_long",
                      "latest_short",
                      "medical_conversation",
                      "medical_dictation",
                      "phone_call",
                      "phone_call_enhanced",
                      "telephony",
                      "telephony_short",
                      "video_enhanced"
                    ],
                    "--naics-code": "value",
                    "--original-media-type": [
                      "audio",
                      "video"
                    ],
                    "--original-mime-type": "value",
                    "--output-uri": "value",
                    "--recording-device-name": "value",
                    "--recording-device-type": [
                      "indoor",
                      "outdoor",
                      "pc",
                      "phone-line",
                      "smartphone",
                      "vehicle"
                    ],
                    "--sample-rate": "value",
                    "--separate-channel-recognition": "bool"
                  }
                },
                "recognizers": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--audio-channel-count": "value",
                        "--display-name": "value",
                        "--enable-automatic-punctuation": "bool",
                        "--enable-spoken-emojis": "bool",
                        "--enable-spoken-punctuation": "bool",
                        "--enable-word-confidence": "bool",
                        "--enable-word-time-offsets": "bool",
                        "--encoding": "value",
                        "--language-codes": "value",
                        "--location": "value",
                        "--max-alternatives": "value",
                        "--max-speaker-count": "value",
                        "--min-speaker-count": "value",
                        "--model": "value",
                        "--profanity-filter": "bool",
                        "--sample-rate": "value",
                        "--separate-channel-recognition": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "run-batch": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--audio": "value",
                        "--audio-channel-count": "value",
                        "--enable-automatic-punctuation": "bool",
                        "--enable-spoken-emojis": "bool",
                        "--enable-spoken-punctuation": "bool",
                        "--enable-word-confidence": "bool",
                        "--enable-word-time-offsets": "bool",
                        "--encoding": "value",
                        "--hint-boost": "value",
                        "--hint-phrase-sets": "value",
                        "--hint-phrases": "value",
                        "--language-codes": "value",
                        "--location": "value",
                        "--max-alternatives": "value",
                        "--max-speaker-count": "value",
                        "--min-speaker-count": "value",
                        "--model": "value",
                        "--profanity-filter": "bool",
                        "--sample-rate": "value",
                        "--separate-channel-recognition": "bool"
                      }
                    },
                    "run-short": {
                      "commands": {},
                      "flags": {
                        "--audio": "value",
                        "--audio-channel-count": "value",
                        "--enable-automatic-punctuation": "bool",
                        "--enable-spoken-emojis": "bool",
                        "--enable-spoken-punctuation": "bool",
                        "--enable-word-confidence": "bool",
                        "--enable-word-time-offsets": "bool",
                        "--encoding": "value",
                        "--hint-boost": "value",
                        "--hint-phrase-sets": "value",
                        "--hint-phrases": "value",
                        "--language-codes": "value",
                        "--location": "value",
                        "--max-alternatives": "value",
                        "--max-speaker-count": "value",
                        "--min-speaker-count": "value",
                        "--model": "value",
                        "--profanity-filter": "bool",
                        "--sample-rate": "value",
                        "--separate-channel-recognition": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--audio-channel-count": "value",
                        "--display-name": "value",
                        "--enable-automatic-punctuation": "bool",
                        "--enable-spoken-emojis": "bool",
                        "--enable-spoken-punctuation": "bool",
                        "--enable-word-confidence": "bool",
                        "--enable-word-time-offsets": "bool",
                        "--encoding": "value",
                        "--language-codes": "value",
                        "--location": "value",
                        "--max-alternatives": "value",
                        "--max-speaker-count": "value",
                        "--min-speaker-count": "value",
                        "--model": "value",
                        "--profanity-filter": "bool",
                        "--sample-rate": "value",
                        "--separate-channel-recognition": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "translate": {
              "commands": {
                "batch-translate-text": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--glossaries": "value",
                    "--models": "value",
                    "--source": "value",
                    "--source-language": "value",
                    "--target-language-codes": "value",
                    "--zone": "value"
                  }
                },
                "detect-language": {
                  "commands": {},
                  "flags": {
                    "--content": "value",
                    "--content-file": "value",
                    "--mime-type": "value",
                    "--model": "value",
                    "--zone": "value"
                  }
                },
                "get-supported-languages": {
                  "commands": {},
                  "flags": {
                    "--display-language-code": "value",
                    "--model": "value",
                    "--zone": "value"
                  }
                },
                "translate-text": {
                  "commands": {},
                  "flags": {
                    "--content": "value",
                    "--content-file": "value",
                    "--glossary-config": "value",
                    "--mime-type": "value",
                    "--model": "value",
                    "--source-language": "value",
                    "--target-language": "value",
                    "--zone": "value"
                  }
                }
              },
              "flags": {}
            },
            "video": {
              "commands": {
                "detect-explicit-content": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--output-uri": "value",
                    "--region": [
                      "asia-east1",
                      "europe-west1",
                      "us-east1",
                      "us-west1"
                    ],
                    "--segments": "value"
                  }
                },
                "detect-labels": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--detection-mode": [
                      "frame",
                      "shot",
                      "shot-and-frame"
                    ],
                    "--output-uri": "value",
                    "--region": [
                      "asia-east1",
                      "europe-west1",
                      "us-east1",
                      "us-west1"
                    ],
                    "--segments": "value"
                  }
                },
                "detect-object": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--output-uri": "value",
                    "--region": [
                      "asia-east1",
                      "europe-west1",
                      "us-east1",
                      "us-west1"
                    ],
                    "--segments": "value"
                  }
                },
                "detect-shot-changes": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--output-uri": "value",
                    "--region": [
                      "asia-east1",
                      "europe-west1",
                      "us-east1",
                      "us-west1"
                    ],
                    "--segments": "value"
                  }
                },
                "detect-text": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--language-hints": "value",
                    "--output-uri": "value",
                    "--region": [
                      "asia-east1",
                      "europe-west1",
                      "us-east1",
                      "us-west1"
                    ],
                    "--segments": "value"
                  }
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "wait": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "transcribe-speech": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--audio-tracks": "value",
                    "--diarization-speaker-count": "value",
                    "--enable-automatic-punctuation": "bool",
                    "--enable-speaker-diarization": "bool",
                    "--enable-word-confidence": "bool",
                    "--filter-profanity": "bool",
                    "--hints": "value",
                    "--language-code": "value",
                    "--max-alternatives": "value",
                    "--output-uri": "value",
                    "--region": [
                      "asia-east1",
                      "europe-west1",
                      "us-east1",
                      "us-west1"
                    ],
                    "--segments": "value"
                  }
                }
              },
              "flags": {}
            },
            "vision": {
              "commands": {
                "detect-document": {
                  "commands": {},
                  "flags": {
                    "--language-hints": "value",
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                },
                "detect-faces": {
                  "commands": {},
                  "flags": {
                    "--max-results": "value",
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                },
                "detect-image-properties": {
                  "commands": {},
                  "flags": {
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                },
                "detect-labels": {
                  "commands": {},
                  "flags": {
                    "--max-results": "value",
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                },
                "detect-landmarks": {
                  "commands": {},
                  "flags": {
                    "--max-results": "value",
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                },
                "detect-logos": {
                  "commands": {},
                  "flags": {
                    "--max-results": "value",
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                },
                "detect-objects": {
                  "commands": {},
                  "flags": {
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                },
                "detect-product": {
                  "commands": {},
                  "flags": {
                    "--bounding-polygon": "value",
                    "--category": "value",
                    "--filter": "value",
                    "--max-results": "value",
                    "--product-set": "value",
                    "--product-set-location": "value"
                  }
                },
                "detect-safe-search": {
                  "commands": {},
                  "flags": {
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                },
                "detect-text": {
                  "commands": {},
                  "flags": {
                    "--language-hints": "value",
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                },
                "detect-text-pdf": {
                  "commands": {},
                  "flags": {
                    "--batch-size": "value",
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                },
                "detect-text-tiff": {
                  "commands": {},
                  "flags": {
                    "--batch-size": "value",
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                },
                "detect-web": {
                  "commands": {},
                  "flags": {
                    "--include-geo-results": "bool",
                    "--max-results": "value",
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "product-search": {
                  "commands": {
                    "images": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--bounding-polygon": "value",
                            "--location": "value",
                            "--product": "value",
                            "--storage-location": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--product": "value"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--product": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--location": "value",
                            "--page-size": "value",
                            "--product": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "product-sets": {
                      "commands": {
                        "add-product": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--product": "value"
                          }
                        },
                        "create": {
                          "commands": {},
                          "flags": {
                            "--display-name": "value",
                            "--location": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--location": "value"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value"
                          }
                        },
                        "import": {
                          "commands": {},
                          "flags": {
                            "--async": "bool",
                            "--location": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--location": "value",
                            "--page-size": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        },
                        "list-products": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--location": "value",
                            "--page-size": "value",
                            "--product-set": "value",
                            "--sort-by": "value"
                          }
                        },
                        "remove-product": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--product": "value"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--display-name": "value",
                            "--location": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "products": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--category": [
                              "apparel",
                              "homegoods",
                              "toys"
                            ],
                            "--description": "value",
                            "--display-name": "value",
                            "--location": "value",
                            "--product-labels": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--location": "value"
                          }
                        },
                        "delete-all": {
                          "commands": {},
                          "flags": {
                            "--force": "bool",
                            "--orphan-products": "bool",
                            "--product-set": "value"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--location": "value",
                            "--page-size": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--add-product-labels": "value",
                            "--clear-product-labels": "bool",
                            "--description": "value",
                            "--display-name": "value",
                            "--location": "value",
                            "--remove-product-labels": "value"
                          }
                        }
                      },
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "suggest-crop": {
                  "commands": {},
                  "flags": {
                    "--aspect-ratios": "value",
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "ml-engine": {
          "commands": {
            "explain": {
              "commands": {},
              "flags": {
                "--json-instances": "value",
                "--json-request": "value",
                "--model": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--text-instances": "value"
              }
            },
            "jobs": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--summarize": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "stream-logs": {
                  "commands": {},
                  "flags": {
                    "--allow-multiline-logs": "bool",
                    "--polling-interval": "value",
                    "--task-name": "value"
                  }
                },
                "submit": {
                  "commands": {
                    "prediction": {
                      "commands": {},
                      "flags": {
                        "--accelerator-count": "value",
                        "--accelerator-type": [
                          "nvidia-tesla-k80",
                          "nvidia-tesla-p100"
                        ],
                        "--batch-size": "value",
                        "--data-format": [
                          "text",
                          "tf-record",
                          "tf-record-gzip"
                        ],
                        "--input-paths": "value",
                        "--labels": "value",
                        "--max-worker-count": "value",
                        "--model": "value",
                        "--model-dir": "value",
                        "--output-path": "value",
                        "--region": "value",
                        "--runtime-version": "value",
                        "--signature-name": "value"
                      }
                    },
                    "training": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--config": "value",
                        "--enable-web-access": "bool",
                        "--job-dir": "value",
                        "--kms-key": "dynamic",
                        "--kms-keyring": "dynamic",
                        "--kms-location": "dynamic",
                        "--kms-project": "dynamic",
                        "--labels": "value",
                        "--master-accelerator": "value",
                        "--master-image-uri": "value",
                        "--master-machine-type": "value",
                        "--module-name": "value",
                        "--network": "value",
                        "--package-path": "value",
                        "--packages": "value",
                        "--parameter-server-accelerator": "value",
                        "--parameter-server-count": "value",
                        "--parameter-server-image-uri": "value",
                        "--parameter-server-machine-type": "value",
                        "--python-version": "value",
                        "--region": "dynamic",
                        "--runtime-version": "value",
                        "--scale-tier": [
                          "basic",
                          "basic-gpu",
                          "basic-tpu",
                          "custom",
                          "premium-1",
                          "standard-1"
                        ],
                        "--service-account": "value",
                        "--staging-bucket": "value",
                        "--stream-logs": "bool",
                        "--tpu-tf-version": "value",
                        "--use-chief-in-tf-config": "value",
                        "--worker-accelerator": "value",
                        "--worker-count": "value",
                        "--worker-image-uri": "value",
                        "--worker-machine-type": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "local": {
              "commands": {
                "predict": {
                  "commands": {},
                  "flags": {
                    "--framework": [
                      "scikit-learn",
                      "tensorflow",
                      "xgboost"
                    ],
                    "--json-instances": "value",
                    "--json-request": "value",
                    "--model-dir": "value",
                    "--signature-name": "value",
                    "--text-instances": "value"
                  }
                },
                "train": {
                  "commands": {},
                  "flags": {
                    "--distributed": "bool",
                    "--evaluator-count": "value",
                    "--job-dir": "value",
                    "--module-name": "value",
                    "--package-path": "value",
                    "--parameter-server-count": "value",
                    "--start-port": "value",
                    "--worker-count": "value"
                  }
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "models": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--enable-console-logging": "bool",
                    "--enable-logging": "bool",
                    "--labels": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--regions": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--role": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "predict": {
              "commands": {},
              "flags": {
                "--json-instances": "value",
                "--json-request": "value",
                "--model": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--signature-name": "value",
                "--text-instances": "value"
              }
            },
            "versions": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--args": "value",
                    "--async": "bool",
                    "--command": "value",
                    "--config": "value",
                    "--description": "value",
                    "--env-vars": "value",
                    "--explanation-method": [
                      "integrated-gradients",
                      "sampled-shapley",
                      "xrai"
                    ],
                    "--framework": [
                      "scikit-learn",
                      "tensorflow",
                      "xgboost"
                    ],
                    "--health-route": "value",
                    "--image": "value",
                    "--labels": "value",
                    "--machine-type": "value",
                    "--max-nodes": "value",
                    "--metric-targets": "value",
                    "--min-nodes": "value",
                    "--model": "value",
                    "--num-integral-steps": "value",
                    "--num-paths": "value",
                    "--origin": "value",
                    "--package-uris": "value",
                    "--ports": "value",
                    "--predict-route": "value",
                    "--prediction-class": "value",
                    "--python-version": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--runtime-version": "value",
                    "--service-account": "value",
                    "--staging-bucket": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--model": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--model": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--model": "value",
                    "--page-size": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "set-default": {
                  "commands": {},
                  "flags": {
                    "--model": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--bigquery-table-name": "value",
                    "--clear-labels": "bool",
                    "--config": "value",
                    "--description": "value",
                    "--model": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--remove-labels": "value",
                    "--sampling-percentage": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "monitoring": {
          "commands": {
            "channel-descriptors": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "channels": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--channel-content": "value",
                    "--channel-content-from-file": "value",
                    "--channel-labels": "value",
                    "--description": "value",
                    "--display-name": "value",
                    "--enabled": "bool",
                    "--type": "value",
                    "--user-labels": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--force": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--type": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--channel-content": "value",
                    "--channel-content-from-file": "value",
                    "--clear-channel-labels": "bool",
                    "--clear-user-labels": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--enabled": "bool",
                    "--fields": "value",
                    "--remove-channel-labels": "value",
                    "--remove-user-labels": "value",
                    "--type": "value",
                    "--update-channel-labels": "value",
                    "--update-user-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "dashboards": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--config": "value",
                    "--config-from-file": "value",
                    "--validate-only": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--config": "value",
                    "--config-from-file": "value"
                  }
                }
              },
              "flags": {}
            },
            "metrics-scopes": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "policies": {
              "commands": {
                "conditions": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--aggregation": "value",
                        "--condition": "value",
                        "--condition-display-name": "value",
                        "--condition-filter": "value",
                        "--condition-from-file": "value",
                        "--duration": "value",
                        "--if": "value",
                        "--trigger-count": "value",
                        "--trigger-percent": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--policy": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--policy": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--display-name": "value",
                        "--if": "value",
                        "--policy": "value",
                        "--trigger-count": "value",
                        "--trigger-percent": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--aggregation": "value",
                    "--combiner": [
                      "AND",
                      "AND_WITH_MATCHING_RESOURCE",
                      "COMBINE_UNSPECIFIED",
                      "OR"
                    ],
                    "--condition-display-name": "value",
                    "--condition-filter": "value",
                    "--display-name": "value",
                    "--documentation": "value",
                    "--documentation-format": "value",
                    "--documentation-from-file": "value",
                    "--duration": "value",
                    "--enabled": "bool",
                    "--if": "value",
                    "--notification-channels": "value",
                    "--policy": "value",
                    "--policy-from-file": "value",
                    "--trigger-count": "value",
                    "--trigger-percent": "value",
                    "--user-labels": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "migrate": {
                  "commands": {},
                  "flags": {
                    "--channels-from-prometheus-alertmanager-yaml": "value",
                    "--policies-from-prometheus-alert-rules-yaml": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-notification-channels": "value",
                    "--clear-notification-channels": "bool",
                    "--clear-user-labels": "bool",
                    "--combiner": [
                      "AND",
                      "AND_WITH_MATCHING_RESOURCE",
                      "COMBINE_UNSPECIFIED",
                      "OR"
                    ],
                    "--display-name": "value",
                    "--documentation": "value",
                    "--documentation-format": "value",
                    "--documentation-from-file": "value",
                    "--enabled": "bool",
                    "--fields": "value",
                    "--policy": "value",
                    "--policy-from-file": "value",
                    "--remove-notification-channels": "value",
                    "--remove-user-labels": "value",
                    "--set-notification-channels": "value",
                    "--update-user-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "snoozes": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--criteria-policies": "value",
                    "--display-name": "value",
                    "--end-time": "value",
                    "--snooze-from-file": "value",
                    "--start-time": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--display-name": "value",
                    "--end-time": "value",
                    "--fields": "value",
                    "--snooze-from-file": "value",
                    "--start-time": "value"
                  }
                }
              },
              "flags": {}
            },
            "uptime": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--body": "value",
                    "--content-type": [
                      "unspecified",
                      "url-encoded",
                      "user-provided"
                    ],
                    "--custom-content-type": "value",
                    "--group-id": "value",
                    "--group-type": [
                      "aws-elb-load-balancer",
                      "gce-instance"
                    ],
                    "--headers": "value",
                    "--json-path": "value",
                    "--json-path-matcher-type": [
                      "exact-match",
                      "regex-match"
                    ],
                    "--mask-headers": "value",
                    "--matcher-content": "value",
                    "--matcher-type": [
                      "contains-string",
                      "matches-json-path",
                      "matches-regex",
                      "not-contains-string",
                      "not-matches-json-path",
                      "not-matches-regex"
                    ],
                    "--password": "value",
                    "--path": "value",
                    "--period": [
                      "1",
                      "10",
                      "15",
                      "5"
                    ],
                    "--pings-count": "value",
                    "--port": "value",
                    "--protocol": [
                      "http",
                      "https",
                      "tcp"
                    ],
                    "--regions": "value",
                    "--request-method": [
                      "get",
                      "post"
                    ],
                    "--resource-labels": "value",
                    "--resource-type": [
                      "aws-ec2-instance",
                      "aws-elb-load-balancer",
                      "cloud-run-revision",
                      "gae-app",
                      "gce-instance",
                      "servicedirectory-service",
                      "uptime-url"
                    ],
                    "--service-agent-auth": [
                      "oidc-token"
                    ],
                    "--status-classes": "value",
                    "--status-codes": "value",
                    "--synthetic-target": "value",
                    "--timeout": "value",
                    "--user-labels": "value",
                    "--username": "value",
                    "--validate-ssl": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list-configs": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-ips": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-regions": "value",
                    "--add-status-classes": "value",
                    "--add-status-codes": "value",
                    "--body": "value",
                    "--clear-headers": "value",
                    "--clear-regions": "value",
                    "--clear-status-classes": "value",
                    "--clear-status-codes": "value",
                    "--clear-user-labels": "bool",
                    "--content-type": [
                      "unspecified",
                      "url-encoded",
                      "user-provided"
                    ],
                    "--custom-content-type": "value",
                    "--display-name": "value",
                    "--json-path": "value",
                    "--json-path-matcher-type": [
                      "exact-match",
                      "regex-match"
                    ],
                    "--mask-headers": "value",
                    "--matcher-content": "value",
                    "--matcher-type": [
                      "contains-string",
                      "matches-json-path",
                      "matches-regex",
                      "not-contains-string",
                      "not-matches-json-path",
                      "not-matches-regex"
                    ],
                    "--password": "value",
                    "--path": "value",
                    "--period": [
                      "1",
                      "10",
                      "15",
                      "5"
                    ],
                    "--pings-count": "value",
                    "--port": "value",
                    "--remove-headers": "value",
                    "--remove-regions": "value",
                    "--remove-status-classes": "value",
                    "--remove-status-codes": "value",
                    "--remove-user-labels": "value",
                    "--request-method": [
                      "get",
                      "post"
                    ],
                    "--service-agent-auth": [
                      "oidc-token"
                    ],
                    "--set-regions": "value",
                    "--set-status-classes": "value",
                    "--set-status-codes": "value",
                    "--timeout": "value",
                    "--update-headers": "value",
                    "--update-user-labels": "value",
                    "--username": "value",
                    "--validate-ssl": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "mps": {
          "commands": {},
          "flags": {}
        },
        "netapp": {
          "commands": {
            "active-directories": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--administrators": "value",
                    "--async": "bool",
                    "--backup-operators": "value",
                    "--description": "value",
                    "--dns": "value",
                    "--domain": "value",
                    "--enable-aes": "value",
                    "--enable-ldap-signing": "value",
                    "--encrypt-dc-connections": "value",
                    "--kdc-hostname": "value",
                    "--kdc-ip": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--net-bios-prefix": "value",
                    "--nfs-users-with-ldap": "value",
                    "--organizational-unit": "value",
                    "--password": "value",
                    "--security-operators": "value",
                    "--site": "value",
                    "--username": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--administrators": "value",
                    "--async": "bool",
                    "--backup-operators": "value",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--dns": "value",
                    "--domain": "value",
                    "--enable-aes": "value",
                    "--enable-ldap-signing": "value",
                    "--encrypt-dc-connections": "value",
                    "--kdc-hostname": "value",
                    "--kdc-ip": "value",
                    "--location": "value",
                    "--net-bios-prefix": "value",
                    "--nfs-users-with-ldap": "value",
                    "--organizational-unit": "value",
                    "--password": "value",
                    "--remove-labels": "value",
                    "--security-operators": "value",
                    "--site": "value",
                    "--update-labels": "value",
                    "--username": "value"
                  }
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "storage-pools": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--active-directory": "value",
                    "--allow-auto-tiering": "value",
                    "--async": "bool",
                    "--capacity": "value",
                    "--description": "value",
                    "--enable-ldap": "value",
                    "--kms-config": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--network": "value",
                    "--replica-zone": "value",
                    "--service-level": [
                      "extreme",
                      "flex",
                      "premium",
                      "standard"
                    ],
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "switch": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--active-directory": "value",
                    "--allow-auto-tiering": "value",
                    "--async": "bool",
                    "--capacity": "value",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--remove-labels": "value",
                    "--replica-zone": "value",
                    "--update-labels": "value",
                    "--zone": "value"
                  }
                }
              },
              "flags": {}
            },
            "volumes": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--capacity": "value",
                    "--description": "value",
                    "--enable-kerberos": "value",
                    "--export-policy": "value",
                    "--hybrid-replication-parameters": "value",
                    "--labels": "value",
                    "--large-capacity": "value",
                    "--location": "value",
                    "--multiple-endpoints": "value",
                    "--protocols": "value",
                    "--restricted-actions": "value",
                    "--security-style": [
                      "ntfs",
                      "unix"
                    ],
                    "--share-name": "value",
                    "--smb-settings": "value",
                    "--snap-reserve": "value",
                    "--snapshot-daily": "value",
                    "--snapshot-directory": "value",
                    "--snapshot-hourly": "value",
                    "--snapshot-monthly": "value",
                    "--snapshot-weekly": "value",
                    "--source-snapshot": "value",
                    "--storage-pool": "value",
                    "--tiering-policy": "value",
                    "--unix-permissions": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--force": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "revert": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--snapshot": "value"
                  }
                },
                "snapshots": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--volume": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--volume": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--volume": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--volume": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--description": "value",
                        "--location": "value",
                        "--remove-labels": "value",
                        "--update-labels": "value",
                        "--volume": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--capacity": "value",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--enable-kerberos": "value",
                    "--export-policy": "value",
                    "--location": "value",
                    "--protocols": "value",
                    "--remove-labels": "value",
                    "--restricted-actions": "value",
                    "--security-style": [
                      "ntfs",
                      "unix"
                    ],
                    "--share-name": "value",
                    "--smb-settings": "value",
                    "--snap-reserve": "value",
                    "--snapshot-daily": "value",
                    "--snapshot-directory": "value",
                    "--snapshot-hourly": "value",
                    "--snapshot-monthly": "value",
                    "--snapshot-weekly": "value",
                    "--source-snapshot": "value",
                    "--storage-pool": "value",
                    "--tiering-policy": "value",
                    "--unix-permissions": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "network-connectivity": {
          "commands": {
            "hubs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "internal-ranges": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--immutable": "bool",
                    "--ip-cidr-range": "value",
                    "--labels": "value",
                    "--migration-source": "value",
                    "--migration-target": "value",
                    "--network": "value",
                    "--overlaps": "value",
                    "--peering": [
                      "for-peer",
                      "for-self",
                      "not-shared"
                    ],
                    "--prefix-length": "value",
                    "--region": "value",
                    "--target-cidr-range": "value",
                    "--usage": [
                      "external-to-vpc",
                      "for-migration",
                      "for-vpc"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--clear-overlaps": "bool",
                    "--description": "value",
                    "--ip-cidr-range": "value",
                    "--labels": "value",
                    "--overlaps": "value",
                    "--prefix-length": "value",
                    "--region": "value"
                  }
                }
              },
              "flags": {}
            },
            "policy-based-routes": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--destination-range": "value",
                    "--interconnect-attachment-region": "value",
                    "--ip-protocol": "value",
                    "--labels": "value",
                    "--network": "value",
                    "--next-hop-ilb-ip": "value",
                    "--next-hop-other-routes": [
                      "default-routing",
                      "other-routes-unspecified"
                    ],
                    "--priority": "value",
                    "--protocol-version": [
                      "ipv4",
                      "ipv6",
                      "protocol-version-unspecified"
                    ],
                    "--source-range": "value",
                    "--tags": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "spokes": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--hub": "value",
                    "--interconnect-attachment": "value",
                    "--labels": "value",
                    "--region": "value",
                    "--router-appliance": "value",
                    "--vpn-tunnel": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--region": "value",
                    "--router-appliance": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "network-management": {
          "commands": {},
          "flags": {}
        },
        "network-security": {
          "commands": {
            "address-groups": {
              "commands": {
                "add-items": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--items": "value",
                    "--location": "value"
                  }
                },
                "clone-items": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--capacity": "value",
                    "--description": "value",
                    "--items": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--purpose": "value",
                    "--type": [
                      "ipv4",
                      "ipv6"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-references": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-items": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--items": "value",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--items": "value",
                    "--location": "value",
                    "--purpose": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "authorization-policies": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "client-tls-policies": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "firewall-endpoint-associations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--endpoint": "value",
                    "--endpoint-zone": "value",
                    "--labels": "value",
                    "--max-wait": "value",
                    "--network": "value",
                    "--organization": "value",
                    "--tls-inspection-policy": "value",
                    "--tls-inspection-policy-project": "value",
                    "--tls-inspection-policy-region": "value",
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--max-wait": "value",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--disabled": "bool",
                    "--max-wait": "value",
                    "--no-tls-inspection-policy": "bool",
                    "--remove-labels": "value",
                    "--tls-inspection-policy": "value",
                    "--tls-inspection-policy-project": "value",
                    "--tls-inspection-policy-region": "value",
                    "--update-labels": "value",
                    "--zone": "value"
                  }
                }
              },
              "flags": {}
            },
            "firewall-endpoints": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--max-wait": "value",
                    "--organization": "value",
                    "--target-firewall-attachment": "value",
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--max-wait": "value",
                    "--organization": "value",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--organization": "value",
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--max-wait": "value",
                    "--organization": "value",
                    "--remove-labels": "value",
                    "--update-billing-project": "value",
                    "--update-labels": "value",
                    "--zone": "value"
                  }
                }
              },
              "flags": {}
            },
            "gateway-security-policies": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "rules": {
                  "commands": {
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--gateway-security-policy": "value",
                        "--location": "value"
                      }
                    },
                    "export": {
                      "commands": {},
                      "flags": {
                        "--destination": "value",
                        "--gateway-security-policy": "value",
                        "--location": "value"
                      }
                    },
                    "import": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--gateway-security-policy": "value",
                        "--location": "value",
                        "--source": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--gateway-security-policy": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "intercept-deployment-groups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--max-wait": "value",
                    "--network": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--max-wait": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--max-wait": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "intercept-deployments": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--forwarding-rule": "value",
                    "--forwarding-rule-location": "value",
                    "--intercept-deployment-group": "value",
                    "--intercept-deployment-group-location": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--max-wait": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--max-wait": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--max-wait": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "intercept-endpoint-group-associations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--intercept-endpoint-group": "value",
                    "--intercept-endpoint-group-location": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--max-wait": "value",
                    "--network": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--max-wait": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--location": "value",
                    "--max-wait": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "intercept-endpoint-groups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--intercept-deployment-group": "value",
                    "--intercept-deployment-group-location": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--max-wait": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--max-wait": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--max-wait": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "mirroring-deployment-groups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--max-wait": "value",
                    "--network": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--max-wait": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--max-wait": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "mirroring-deployments": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--forwarding-rule": "value",
                    "--forwarding-rule-location": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--max-wait": "value",
                    "--mirroring-deployment-group": "value",
                    "--mirroring-deployment-group-location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--max-wait": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--max-wait": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "mirroring-endpoint-group-associations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--labels": "value",
                    "--location": "value",
                    "--max-wait": "value",
                    "--mirroring-endpoint-group": "value",
                    "--mirroring-endpoint-group-location": "value",
                    "--network": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--max-wait": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--location": "value",
                    "--max-wait": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "mirroring-endpoint-groups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--max-wait": "value",
                    "--mirroring-deployment-group": "value",
                    "--mirroring-deployment-group-location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--max-wait": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--max-wait": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "org-address-groups": {
              "commands": {
                "add-items": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--items": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "clone-items": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--organization": "value",
                    "--source": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--capacity": "value",
                    "--description": "value",
                    "--items": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--type": [
                      "ipv4",
                      "ipv6"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-references": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-items": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--items": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--items": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "security-profile-groups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--custom-intercept-profile": "value",
                    "--custom-intercept-profile-location": "value",
                    "--custom-intercept-profile-organization": "value",
                    "--custom-mirroring-profile": "value",
                    "--custom-mirroring-profile-location": "value",
                    "--custom-mirroring-profile-organization": "value",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--threat-prevention-profile": "value",
                    "--threat-prevention-profile-location": "value",
                    "--threat-prevention-profile-organization": "value",
                    "--url-filtering-profile": "value",
                    "--url-filtering-profile-location": "value",
                    "--url-filtering-profile-organization": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--clear-threat-prevention-profile": "bool",
                    "--clear-url-filtering-profile": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--remove-labels": "value",
                    "--threat-prevention-profile": "value",
                    "--threat-prevention-profile-location": "value",
                    "--threat-prevention-profile-organization": "value",
                    "--update-labels": "value",
                    "--url-filtering-profile": "value",
                    "--url-filtering-profile-location": "value",
                    "--url-filtering-profile-organization": "value"
                  }
                }
              },
              "flags": {}
            },
            "security-profiles": {
              "commands": {
                "custom-intercept": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value",
                        "--intercept-endpoint-group": "value",
                        "--intercept-endpoint-group-location": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--organization": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--organization": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--organization": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--organization": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--description": "value",
                        "--location": "value",
                        "--organization": "value",
                        "--remove-labels": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "custom-mirroring": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--mirroring-endpoint-group": "value",
                        "--mirroring-endpoint-group-location": "value",
                        "--organization": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--organization": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--organization": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--organization": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--description": "value",
                        "--location": "value",
                        "--organization": "value",
                        "--remove-labels": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--organization": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "threat-prevention": {
                  "commands": {
                    "add-override": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "ALERT",
                          "ALLOW",
                          "DEFAULT_ACTION",
                          "DENY"
                        ],
                        "--antivirus": "value",
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--location": "value",
                        "--organization": "value",
                        "--remove-labels": "value",
                        "--severities": "value",
                        "--threat-ids": "value",
                        "--update-labels": "value"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--organization": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--organization": "value"
                      }
                    },
                    "delete-override": {
                      "commands": {},
                      "flags": {
                        "--antivirus": "value",
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--location": "value",
                        "--organization": "value",
                        "--remove-labels": "value",
                        "--severities": "value",
                        "--threat-ids": "value",
                        "--update-labels": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--organization": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "list-overrides": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--organization": "value"
                      }
                    },
                    "update-override": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "ALERT",
                          "ALLOW",
                          "DEFAULT_ACTION",
                          "DENY"
                        ],
                        "--antivirus": "value",
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--location": "value",
                        "--organization": "value",
                        "--remove-labels": "value",
                        "--severities": "value",
                        "--threat-ids": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "server-tls-policies": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "tls-inspection-policies": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "url-lists": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "network-services": {
          "commands": {
            "endpoint-policies": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "gateways": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "grpc-routes": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "http-filters": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "http-routes": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "meshes": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "multicast-consumer-associations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--multicast-domain-activation": "value",
                    "--network": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "multicast-domain-activations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--aggr-egress-pps": "value",
                    "--aggr-ingress-pps": "value",
                    "--async": "bool",
                    "--avg-packet-size": "value",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--max-per-group-ingress-pps": "value",
                    "--max-per-group-subscribers": "value",
                    "--multicast-domain": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "multicast-domain-groups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "multicast-domains": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--admin-network": "value",
                    "--async": "bool",
                    "--connection-type": [
                      "connection-type-unspecified",
                      "ncc",
                      "same-vpc"
                    ],
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--multicast-domain-group": "value",
                    "--ncc-hub": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "multicast-group-consumer-activations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--multicast-consumer-association": "value",
                    "--multicast-group": "value",
                    "--multicast-group-range-activation": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "multicast-group-definitions": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--consumer-accept-list": "value",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--multicast-domain": "value",
                    "--reserved-internal-range": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "multicast-group-producer-activations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--multicast-group": "value",
                    "--multicast-group-range-activation": "value",
                    "--multicast-producer-association": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "multicast-group-range-activations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--multicast-domain-activation": "value",
                    "--multicast-group-range": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "multicast-group-ranges": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--consumer-accept-list": "value",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--multicast-domain": "value",
                    "--reserved-internal-range": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "multicast-groups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--multicast-domain-activation": "value",
                    "--multicast-group-definition": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "multicast-producer-associations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--multicast-domain-activation": "value",
                    "--network": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "observability-policies": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "route-views": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--gateway": "value",
                    "--location": "value",
                    "--mesh": "value",
                    "--route-view": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--gateway": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--mesh": "value",
                    "--page-size": "value"
                  }
                }
              },
              "flags": {}
            },
            "service-bindings": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--service-directory-namespace": "value",
                    "--service-directory-region": "value",
                    "--service-directory-service": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "service-lb-policies": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--auto-capacity-drain": "bool",
                    "--description": "value",
                    "--failover-health-threshold": "value",
                    "--load-balancing-algorithm": [
                      "spray-to-region",
                      "spray-to-world",
                      "waterfall-by-region",
                      "waterfall-by-zone"
                    ],
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--auto-capacity-drain": "bool",
                    "--description": "value",
                    "--failover-health-threshold": "value",
                    "--load-balancing-algorithm": [
                      "spray-to-region",
                      "spray-to-world",
                      "waterfall-by-region",
                      "waterfall-by-zone"
                    ],
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "tcp-routes": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "tls-routes": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "notebooks": {
          "commands": {
            "environments": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--container-repository": "value",
                    "--container-tag": "value",
                    "--description": "value",
                    "--display-name": "value",
                    "--location": "dynamic",
                    "--post-startup-script": "value",
                    "--vm-image-family": "value",
                    "--vm-image-name": "value",
                    "--vm-image-project": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "instances": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator-core-count": "value",
                    "--accelerator-type": [
                      "NVIDIA_H100_80GB",
                      "NVIDIA_H100_MEGA_80GB",
                      "NVIDIA_L4",
                      "NVIDIA_TESLA_A100",
                      "NVIDIA_TESLA_K80",
                      "NVIDIA_TESLA_P100",
                      "NVIDIA_TESLA_P100_VWS",
                      "NVIDIA_TESLA_P4",
                      "NVIDIA_TESLA_P4_VWS",
                      "NVIDIA_TESLA_T4",
                      "NVIDIA_TESLA_T4_VWS",
                      "NVIDIA_TESLA_V100",
                      "TPU_V2",
                      "TPU_V3"
                    ],
                    "--async": "bool",
                    "--boot-disk-size": "value",
                    "--boot-disk-type": [
                      "PD_BALANCED",
                      "PD_EXTREME",
                      "PD_SSD",
                      "PD_STANDARD"
                    ],
                    "--container-repository": "value",
                    "--container-tag": "value",
                    "--custom-gpu-driver-path": "value",
                    "--data-disk-size": "value",
                    "--data-disk-type": [
                      "PD_BALANCED",
                      "PD_EXTREME",
                      "PD_SSD",
                      "PD_STANDARD"
                    ],
                    "--disk-encryption": [
                      "CMEK",
                      "GMEK"
                    ],
                    "--environment": "dynamic",
                    "--environment-location": "dynamic",
                    "--install-gpu-driver": "bool",
                    "--instance-owners": "value",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--location": "dynamic",
                    "--machine-type": "value",
                    "--metadata": "value",
                    "--network": "dynamic",
                    "--no-proxy-access": "bool",
                    "--no-public-ip": "bool",
                    "--no-remove-data-disk": "bool",
                    "--post-startup-script": "value",
                    "--reservation": "value",
                    "--reservation-affinity": [
                      "ANY_RESERVATION",
                      "NO_RESERVATION",
                      "SPECIFIC_RESERVATION",
                      "TYPE_UNSPECIFIED"
                    ],
                    "--service-account": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-secure-boot": "bool",
                    "--shielded-vtpm": "bool",
                    "--subnet": "dynamic",
                    "--subnet-region": "dynamic",
                    "--tags": "value",
                    "--vm-image-family": "value",
                    "--vm-image-name": "value",
                    "--vm-image-project": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "diagnose": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--enable-copy-home-files": "bool",
                    "--enable-packet-capture": "bool",
                    "--enable-repair": "bool",
                    "--gcs-bucket": "value",
                    "--location": "dynamic",
                    "--relative-path": "value",
                    "--timeout-minutes": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "is-upgradeable": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "register": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "reset": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "start": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "stop": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--accelerator-core-count": "value",
                    "--accelerator-type": [
                      "NVIDIA_H100_80GB",
                      "NVIDIA_H100_MEGA_80GB",
                      "NVIDIA_L4",
                      "NVIDIA_TESLA_A100",
                      "NVIDIA_TESLA_K80",
                      "NVIDIA_TESLA_P100",
                      "NVIDIA_TESLA_P100_VWS",
                      "NVIDIA_TESLA_P4",
                      "NVIDIA_TESLA_P4_VWS",
                      "NVIDIA_TESLA_T4",
                      "NVIDIA_TESLA_T4_VWS",
                      "NVIDIA_TESLA_V100",
                      "TPU_V2",
                      "TPU_V3"
                    ],
                    "--async": "bool",
                    "--labels": "value",
                    "--location": "dynamic",
                    "--machine-type": "value"
                  }
                },
                "upgrade": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "organizations": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {}
            }
          },
          "flags": {}
        },
        "pam": {
          "commands": {
            "check-onboarding-status": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "entitlements": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--entitlement-file": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "search": {
                  "commands": {},
                  "flags": {
                    "--caller-access-type": [
                      "grant-approver",
                      "grant-requester"
                    ],
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--entitlement-file": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                }
              },
              "flags": {}
            },
            "grants": {
              "commands": {
                "approve": {
                  "commands": {},
                  "flags": {
                    "--entitlement": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--reason": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--additional-email-recipients": "value",
                    "--entitlement": "value",
                    "--folder": "value",
                    "--justification": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--requested-duration": "value"
                  }
                },
                "deny": {
                  "commands": {},
                  "flags": {
                    "--entitlement": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--reason": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--entitlement": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--entitlement": "value",
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "revoke": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--entitlement": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--reason": "value"
                  }
                },
                "search": {
                  "commands": {},
                  "flags": {
                    "--caller-relationship": [
                      "can-approve",
                      "had-approved",
                      "had-created"
                    ],
                    "--entitlement": "value",
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "policy-troubleshoot": {
          "commands": {
            "iam": {
              "commands": {},
              "flags": {
                "--destination-ip": "value",
                "--destination-port": "value",
                "--permission": "value",
                "--principal-email": "value",
                "--request-time": "value",
                "--resource-name": "value",
                "--resource-service": "value",
                "--resource-type": "value"
              }
            }
          },
          "flags": {}
        },
        "projects": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--enable-cloud-apis": "bool",
                "--folder": "value",
                "--labels": "value",
                "--name": "value",
                "--organization": "value",
                "--set-as-default": "bool",
                "--tags": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--recommend": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "get-ancestors": {
              "commands": {},
              "flags": {}
            },
            "get-ancestors-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--include-deny": "bool",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "move": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "value"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--recommend": "value",
                "--role": "dynamic"
              }
            },
            "search": {
              "commands": {},
              "flags": {
                "--limit": "value",
                "--page-size": "value",
                "--query": "value",
                "--sort-by": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {}
            },
            "undelete": {
              "commands": {},
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-labels": "bool",
                "--name": "value",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "publicca": {
          "commands": {
            "external-account-keys": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--key-output-file": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "pubsub": {
          "commands": {
            "lite-operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--done": "bool",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--subscription": "value"
                  }
                }
              },
              "flags": {}
            },
            "lite-reservations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--throughput-capacity": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list-topics": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--throughput-capacity": "value"
                  }
                }
              },
              "flags": {}
            },
            "lite-subscriptions": {
              "commands": {
                "ack-up-to": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--offset": "value",
                    "--partition": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--delivery-requirement": [
                      "deliver-after-stored",
                      "deliver-immediately"
                    ],
                    "--event-time": "value",
                    "--export-dead-letter-topic": "value",
                    "--export-desired-state": [
                      "active",
                      "paused"
                    ],
                    "--export-pubsub-topic": "value",
                    "--location": "value",
                    "--publish-time": "value",
                    "--starting-offset": [
                      "beginning",
                      "end"
                    ],
                    "--topic": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "seek": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--event-time": "value",
                    "--location": "value",
                    "--publish-time": "value",
                    "--starting-offset": [
                      "beginning",
                      "end"
                    ]
                  }
                },
                "subscribe": {
                  "commands": {},
                  "flags": {
                    "--auto-ack": "bool",
                    "--location": "value",
                    "--num-messages": "value",
                    "--partitions": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--delivery-requirement": [
                      "deliver-after-stored",
                      "deliver-immediately"
                    ],
                    "--export-dead-letter-topic": "value",
                    "--export-desired-state": [
                      "active",
                      "paused"
                    ],
                    "--export-pubsub-topic": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "lite-topics": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--message-retention-period": "value",
                    "--partitions": "value",
                    "--per-partition-bytes": "value",
                    "--per-partition-publish-mib": "value",
                    "--per-partition-subscribe-mib": "value",
                    "--throughput-reservation": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list-subscriptions": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "publish": {
                  "commands": {},
                  "flags": {
                    "--attributes": "value",
                    "--event-time": "value",
                    "--location": "value",
                    "--message": "value",
                    "--ordering-key": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--message-retention-period": "value",
                    "--partitions": "value",
                    "--per-partition-bytes": "value",
                    "--per-partition-publish-mib": "value",
                    "--per-partition-subscribe-mib": "value",
                    "--throughput-reservation": "value"
                  }
                }
              },
              "flags": {}
            },
            "schemas": {
              "commands": {
                "commit": {
                  "commands": {},
                  "flags": {
                    "--definition": "value",
                    "--definition-file": "value",
                    "--type": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--definition": "value",
                    "--definition-file": "value",
                    "--type": [
                      "avro",
                      "protocol-buffer"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "delete-revision": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--view": [
                      "basic",
                      "full"
                    ]
                  }
                },
                "list-revisions": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--view": [
                      "basic",
                      "full"
                    ]
                  }
                },
                "rollback": {
                  "commands": {},
                  "flags": {
                    "--revision-id": "value"
                  }
                },
                "validate-message": {
                  "commands": {},
                  "flags": {
                    "--definition": "value",
                    "--definition-file": "value",
                    "--message": "value",
                    "--message-encoding": [
                      "binary",
                      "json"
                    ],
                    "--schema-name": "value",
                    "--type": [
                      "avro",
                      "protocol-buffer"
                    ]
                  }
                },
                "validate-schema": {
                  "commands": {},
                  "flags": {
                    "--definition": "value",
                    "--definition-file": "value",
                    "--type": [
                      "avro",
                      "protocol-buffer"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "snapshots": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--labels": "value",
                    "--subscription": "value",
                    "--subscription-project": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "subscriptions": {
              "commands": {
                "ack": {
                  "commands": {},
                  "flags": {
                    "--ack-ids": "value"
                  }
                },
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--ack-deadline": "value",
                    "--bigquery-service-account-email": "value",
                    "--bigquery-table": "value",
                    "--cloud-storage-bucket": "value",
                    "--cloud-storage-file-datetime-format": "value",
                    "--cloud-storage-file-prefix": "value",
                    "--cloud-storage-file-suffix": "value",
                    "--cloud-storage-max-bytes": "value",
                    "--cloud-storage-max-duration": "value",
                    "--cloud-storage-max-messages": "value",
                    "--cloud-storage-output-format": "value",
                    "--cloud-storage-service-account-email": "value",
                    "--cloud-storage-use-topic-schema": "bool",
                    "--cloud-storage-write-metadata": "bool",
                    "--dead-letter-topic": "value",
                    "--dead-letter-topic-project": "value",
                    "--drop-unknown-fields": "bool",
                    "--enable-exactly-once-delivery": "bool",
                    "--enable-message-ordering": "bool",
                    "--expiration-period": "value",
                    "--labels": "value",
                    "--max-delivery-attempts": "value",
                    "--max-retry-delay": "value",
                    "--message-filter": "value",
                    "--message-retention-duration": "value",
                    "--min-retry-delay": "value",
                    "--push-auth-service-account": "value",
                    "--push-auth-token-audience": "value",
                    "--push-endpoint": "value",
                    "--push-no-wrapper": "bool",
                    "--push-no-wrapper-write-metadata": "bool",
                    "--retain-acked-messages": "bool",
                    "--topic": "value",
                    "--topic-project": "value",
                    "--use-table-schema": "bool",
                    "--use-topic-schema": "bool",
                    "--write-metadata": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "modify-ack-deadline": {
                  "commands": {},
                  "flags": {
                    "--ack-deadline": "value",
                    "--ack-ids": "value"
                  }
                },
                "modify-message-ack-deadline": {
                  "commands": {},
                  "flags": {
                    "--ack-deadline": "value",
                    "--ack-ids": "value"
                  }
                },
                "modify-push-config": {
                  "commands": {},
                  "flags": {
                    "--push-auth-service-account": "value",
                    "--push-auth-token-audience": "value",
                    "--push-endpoint": "value",
                    "--push-no-wrapper": "bool",
                    "--push-no-wrapper-write-metadata": "bool"
                  }
                },
                "pull": {
                  "commands": {},
                  "flags": {
                    "--auto-ack": "bool",
                    "--filter": "value",
                    "--limit": "value",
                    "--max-messages": "value",
                    "--page-size": "value",
                    "--return-immediately": "bool",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--wait": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "seek": {
                  "commands": {},
                  "flags": {
                    "--snapshot": "value",
                    "--snapshot-project": "value",
                    "--time": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--ack-deadline": "value",
                    "--bigquery-service-account-email": "value",
                    "--bigquery-table": "value",
                    "--clear-bigquery-config": "bool",
                    "--clear-cloud-storage-config": "bool",
                    "--clear-dead-letter-policy": "bool",
                    "--clear-labels": "bool",
                    "--clear-push-no-wrapper-config": "bool",
                    "--clear-retry-policy": "bool",
                    "--cloud-storage-bucket": "value",
                    "--cloud-storage-file-datetime-format": "value",
                    "--cloud-storage-file-prefix": "value",
                    "--cloud-storage-file-suffix": "value",
                    "--cloud-storage-max-bytes": "value",
                    "--cloud-storage-max-duration": "value",
                    "--cloud-storage-max-messages": "value",
                    "--cloud-storage-output-format": "value",
                    "--cloud-storage-service-account-email": "value",
                    "--cloud-storage-use-topic-schema": "bool",
                    "--cloud-storage-write-metadata": "bool",
                    "--dead-letter-topic": "value",
                    "--dead-letter-topic-project": "value",
                    "--drop-unknown-fields": "bool",
                    "--enable-exactly-once-delivery": "bool",
                    "--expiration-period": "value",
                    "--max-delivery-attempts": "value",
                    "--max-retry-delay": "value",
                    "--message-retention-duration": "value",
                    "--min-retry-delay": "value",
                    "--push-auth-service-account": "value",
                    "--push-auth-token-audience": "value",
                    "--push-endpoint": "value",
                    "--push-no-wrapper": "bool",
                    "--push-no-wrapper-write-metadata": "bool",
                    "--remove-labels": "value",
                    "--retain-acked-messages": "bool",
                    "--update-labels": "value",
                    "--use-table-schema": "bool",
                    "--use-topic-schema": "bool",
                    "--write-metadata": "bool"
                  }
                }
              },
              "flags": {}
            },
            "topics": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--cloud-storage-ingestion-bucket": "value",
                    "--cloud-storage-ingestion-input-format": "value",
                    "--cloud-storage-ingestion-match-glob": "value",
                    "--cloud-storage-ingestion-minimum-object-create-time": "value",
                    "--cloud-storage-ingestion-text-delimiter": "value",
                    "--first-revision-id": "value",
                    "--ingestion-log-severity": "value",
                    "--kinesis-ingestion-consumer-arn": "value",
                    "--kinesis-ingestion-role-arn": "value",
                    "--kinesis-ingestion-service-account": "value",
                    "--kinesis-ingestion-stream-arn": "value",
                    "--labels": "value",
                    "--last-revision-id": "value",
                    "--message-encoding": "value",
                    "--message-retention-duration": "value",
                    "--message-storage-policy-allowed-regions": "value",
                    "--message-storage-policy-enforce-in-transit": "bool",
                    "--schema": "value",
                    "--schema-project": "value",
                    "--topic-encryption-key": "dynamic",
                    "--topic-encryption-key-keyring": "dynamic",
                    "--topic-encryption-key-location": "dynamic",
                    "--topic-encryption-key-project": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "detach-subscription": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-snapshots": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-subscriptions": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "publish": {
                  "commands": {},
                  "flags": {
                    "--attribute": "value",
                    "--message": "value",
                    "--ordering-key": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-ingestion-data-source-settings": "bool",
                    "--clear-labels": "bool",
                    "--clear-message-retention-duration": "bool",
                    "--clear-schema-settings": "bool",
                    "--cloud-storage-ingestion-bucket": "value",
                    "--cloud-storage-ingestion-input-format": "value",
                    "--cloud-storage-ingestion-match-glob": "value",
                    "--cloud-storage-ingestion-minimum-object-create-time": "value",
                    "--cloud-storage-ingestion-text-delimiter": "value",
                    "--first-revision-id": "value",
                    "--ingestion-log-severity": "value",
                    "--kinesis-ingestion-consumer-arn": "value",
                    "--kinesis-ingestion-role-arn": "value",
                    "--kinesis-ingestion-service-account": "value",
                    "--kinesis-ingestion-stream-arn": "value",
                    "--last-revision-id": "value",
                    "--message-encoding": "value",
                    "--message-retention-duration": "value",
                    "--message-storage-policy-allowed-regions": "value",
                    "--message-storage-policy-enforce-in-transit": "bool",
                    "--recompute-message-storage-policy": "bool",
                    "--remove-labels": "value",
                    "--schema": "value",
                    "--schema-project": "value",
                    "--topic-encryption-key": "dynamic",
                    "--topic-encryption-key-keyring": "dynamic",
                    "--topic-encryption-key-location": "dynamic",
                    "--topic-encryption-key-project": "dynamic",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "quotas": {
          "commands": {
            "info": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "dynamic",
                    "--service": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--organization": "dynamic",
                    "--page-size": "value",
                    "--service": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "preferences": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--allow-high-percentage-quota-decrease": "bool",
                    "--allow-quota-decrease-below-usage": "bool",
                    "--dimensions": "value",
                    "--email": "value",
                    "--folder": "value",
                    "--justification": "value",
                    "--organization": "dynamic",
                    "--preference-id": "value",
                    "--preferred-value": "value",
                    "--quota-id": "value",
                    "--service": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--organization": "dynamic",
                    "--page-size": "value",
                    "--reconciling-only": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--allow-high-percentage-quota-decrease": "bool",
                    "--allow-missing": "bool",
                    "--allow-quota-decrease-below-usage": "bool",
                    "--dimensions": "value",
                    "--email": "value",
                    "--folder": "value",
                    "--justification": "value",
                    "--organization": "dynamic",
                    "--preferred-value": "value",
                    "--quota-id": "value",
                    "--service": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "recaptcha": {
          "commands": {
            "firewall-policies": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--actions": "value",
                    "--condition": "value",
                    "--description": "value",
                    "--path": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "reorder": {
                  "commands": {},
                  "flags": {
                    "--names": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--actions": "value",
                    "--condition": "value",
                    "--description": "value",
                    "--path": "value"
                  }
                }
              },
              "flags": {}
            },
            "keys": {
              "commands": {
                "add-ip-override": {
                  "commands": {},
                  "flags": {
                    "--ip": "value",
                    "--override": [
                      "allow",
                      "override-type-unspecified"
                    ]
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--allow-all-bundle-ids": "bool",
                    "--allow-all-domains": "bool",
                    "--allow-all-package-names": "bool",
                    "--allow-amp-traffic": "bool",
                    "--android": "bool",
                    "--bundle-ids": "value",
                    "--display-name": "value",
                    "--domains": "value",
                    "--express": "bool",
                    "--integration-type": [
                      "checkbox",
                      "invisible",
                      "score",
                      "score-and-challenge"
                    ],
                    "--ios": "bool",
                    "--key-id": "value",
                    "--labels": "value",
                    "--package-names": "value",
                    "--private-key-file": "value",
                    "--security-preference": [
                      "balance",
                      "challenge-security-preference-unspecified",
                      "security",
                      "usability"
                    ],
                    "--support-non-google-app-store-distribution": "bool",
                    "--team-id": "value",
                    "--testing-challenge": [
                      "challenge",
                      "nocaptcha"
                    ],
                    "--testing-score": "value",
                    "--waf-feature": [
                      "action-token",
                      "challenge-page",
                      "express",
                      "session-token"
                    ],
                    "--waf-service": [
                      "akamai",
                      "ca",
                      "cloudflare",
                      "fastly"
                    ],
                    "--web": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-ip-overrides": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "migrate": {
                  "commands": {},
                  "flags": {
                    "--skip-billing-check": "bool"
                  }
                },
                "remove-ip-override": {
                  "commands": {},
                  "flags": {
                    "--ip": "value",
                    "--override": [
                      "allow",
                      "override-type-unspecified"
                    ]
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--allow-all-bundle-ids": "bool",
                    "--allow-all-domains": "bool",
                    "--allow-all-package-names": "bool",
                    "--allow-amp-traffic": "bool",
                    "--android": "bool",
                    "--bundle-ids": "value",
                    "--display-name": "value",
                    "--domains": "value",
                    "--express": "bool",
                    "--ios": "bool",
                    "--key-id": "value",
                    "--labels": "value",
                    "--package-names": "value",
                    "--private-key-file": "value",
                    "--security-preference": [
                      "balance",
                      "challenge-security-preference-unspecified",
                      "security",
                      "usability"
                    ],
                    "--team-id": "value",
                    "--web": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "recommender": {
          "commands": {
            "insights": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--folder": "value",
                    "--insight-type": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--filter": "value",
                    "--folder": "value",
                    "--insight-type": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--recursive": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "mark-accepted": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--etag": "value",
                    "--folder": "value",
                    "--insight-type": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--state-metadata": "value"
                  }
                },
                "mark-active": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--etag": "value",
                    "--folder": "value",
                    "--insight-type": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "mark-dismissed": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--etag": "value",
                    "--folder": "value",
                    "--insight-type": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--recommendation-change-type": [
                      "dismiss",
                      "leave_unchanged"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "recommendations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--recommender": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--recommender": "value",
                    "--recursive": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "mark-active": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--etag": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--recommender": "value"
                  }
                },
                "mark-claimed": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--etag": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--recommender": "value",
                    "--state-metadata": "value"
                  }
                },
                "mark-dismissed": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--etag": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--recommender": "value"
                  }
                },
                "mark-failed": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--etag": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--recommender": "value",
                    "--state-metadata": "value"
                  }
                },
                "mark-succeeded": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--etag": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--recommender": "value",
                    "--state-metadata": "value"
                  }
                }
              },
              "flags": {}
            },
            "recommender-configs": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--recommender": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "redis": {
          "commands": {
            "clusters": {
              "commands": {
                "add-cluster-endpoints": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster-endpoint": "value",
                    "--region": "dynamic"
                  }
                },
                "backup-collections": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "dynamic",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "backups": {
                  "commands": {
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--backup-collection": "dynamic",
                        "--region": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--backup-collection": "dynamic",
                        "--region": "dynamic"
                      }
                    },
                    "export": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--backup-collection": "dynamic",
                        "--gcs-bucket": "value",
                        "--region": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--backup-collection": "dynamic",
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "dynamic",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--aof-append-fsync": [
                      "always",
                      "everysec",
                      "no"
                    ],
                    "--async": "bool",
                    "--auth-mode": [
                      "disabled",
                      "iam-auth"
                    ],
                    "--automated-backup-mode": [
                      "disabled",
                      "enabled"
                    ],
                    "--automated-backup-start-time": "value",
                    "--automated-backup-ttl": "value",
                    "--cross-cluster-replication-role": [
                      "secondary"
                    ],
                    "--deletion-protection": "bool",
                    "--import-gcs-object-uris": "value",
                    "--import-managed-backup": "value",
                    "--kms-key": "value",
                    "--maintenance-window-day": [
                      "friday",
                      "monday",
                      "saturday",
                      "sunday",
                      "thursday",
                      "tuesday",
                      "wednesday"
                    ],
                    "--maintenance-window-hour": "value",
                    "--network": "value",
                    "--node-type": [
                      "redis-highmem-medium",
                      "redis-highmem-xlarge",
                      "redis-shared-core-nano",
                      "redis-standard-small"
                    ],
                    "--persistence-mode": [
                      "aof",
                      "disabled",
                      "rdb"
                    ],
                    "--primary-cluster": "value",
                    "--rdb-snapshot-period": [
                      "12h",
                      "1h",
                      "24h",
                      "6h"
                    ],
                    "--rdb-snapshot-start-time": "value",
                    "--redis-config": "value",
                    "--region": "dynamic",
                    "--replica-count": "value",
                    "--shard-count": "value",
                    "--transit-encryption-mode": [
                      "disabled",
                      "server-authentication"
                    ],
                    "--zone": "value",
                    "--zone-distribution-mode": [
                      "multi-zone",
                      "single-zone"
                    ]
                  }
                },
                "create-backup": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--backup-id": "value",
                    "--region": "dynamic",
                    "--ttl": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "detach": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "detach-secondaries": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clusters-to-detach": "value",
                    "--region": "dynamic"
                  }
                },
                "get-cluster-certificate-authority": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-cluster-endpoints": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster-endpoint": "value",
                    "--region": "dynamic"
                  }
                },
                "reschedule-maintenance": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic",
                    "--reschedule-type": [
                      "immediate",
                      "specific-time"
                    ],
                    "--schedule-time": "value"
                  }
                },
                "switchover": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--aof-append-fsync": [
                      "always",
                      "everysec",
                      "no"
                    ],
                    "--async": "bool",
                    "--automated-backup-mode": [
                      "disabled",
                      "enabled"
                    ],
                    "--automated-backup-start-time": "value",
                    "--automated-backup-ttl": "value",
                    "--deletion-protection": "bool",
                    "--maintenance-window-any": "bool",
                    "--maintenance-window-day": [
                      "friday",
                      "monday",
                      "saturday",
                      "sunday",
                      "thursday",
                      "tuesday",
                      "wednesday"
                    ],
                    "--maintenance-window-hour": "value",
                    "--persistence-mode": [
                      "aof",
                      "disabled",
                      "rdb"
                    ],
                    "--rdb-snapshot-period": [
                      "12h",
                      "1h",
                      "24h",
                      "6h"
                    ],
                    "--rdb-snapshot-start-time": "value",
                    "--region": "dynamic",
                    "--remove-redis-config": "value",
                    "--replica-count": "value",
                    "--shard-count": "value",
                    "--update-redis-config": "value"
                  }
                }
              },
              "flags": {}
            },
            "instances": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--region": "dynamic",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--alternative-zone": "value",
                    "--async": "bool",
                    "--connect-mode": [
                      "connect-mode-unspecified",
                      "direct-peering",
                      "private-service-access"
                    ],
                    "--customer-managed-key": "value",
                    "--display-name": "value",
                    "--enable-auth": "bool",
                    "--labels": "value",
                    "--maintenance-window-day": [
                      "day-of-week-unspecified",
                      "friday",
                      "monday",
                      "saturday",
                      "sunday",
                      "thursday",
                      "tuesday",
                      "wednesday"
                    ],
                    "--maintenance-window-hour": "value",
                    "--network": "value",
                    "--persistence-mode": [
                      "disabled",
                      "rdb"
                    ],
                    "--rdb-snapshot-period": [
                      "12h",
                      "1h",
                      "24h",
                      "6h"
                    ],
                    "--rdb-snapshot-start-time": "value",
                    "--read-replicas-mode": [
                      "read-replicas-disabled",
                      "read-replicas-enabled"
                    ],
                    "--redis-config": "value",
                    "--redis-version": [
                      "redis_3_2",
                      "redis_4_0",
                      "redis_5_0",
                      "redis_6_x",
                      "redis_7_0",
                      "redis_7_2"
                    ],
                    "--region": "dynamic",
                    "--replica-count": "value",
                    "--reserved-ip-range": "value",
                    "--size": "value",
                    "--tier": [
                      "basic",
                      "standard"
                    ],
                    "--transit-encryption-mode": [
                      "disabled",
                      "server-authentication"
                    ],
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "failover": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--data-protection-mode": [
                      "force-data-loss",
                      "limited-data-loss"
                    ],
                    "--region": "dynamic"
                  }
                },
                "get-auth-string": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "reschedule-maintenance": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic",
                    "--reschedule-type": [
                      "immediate",
                      "next-available-window",
                      "specific-time"
                    ],
                    "--schedule-time": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--display-name": "value",
                    "--enable-auth": "bool",
                    "--maintenance-version": "value",
                    "--maintenance-window-any": "bool",
                    "--maintenance-window-day": [
                      "day-of-week-unspecified",
                      "friday",
                      "monday",
                      "saturday",
                      "sunday",
                      "thursday",
                      "tuesday",
                      "wednesday"
                    ],
                    "--maintenance-window-hour": "value",
                    "--persistence-mode": [
                      "disabled",
                      "rdb"
                    ],
                    "--rdb-snapshot-period": [
                      "12h",
                      "1h",
                      "24h",
                      "6h"
                    ],
                    "--rdb-snapshot-start-time": "value",
                    "--read-replicas-mode": [
                      "read-replicas-disabled",
                      "read-replicas-enabled"
                    ],
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--remove-redis-config": "value",
                    "--replica-count": "value",
                    "--secondary-ip-range": "value",
                    "--size": "value",
                    "--update-labels": "value",
                    "--update-redis-config": "value"
                  }
                },
                "upgrade": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--redis-version": [
                      "redis_4_0",
                      "redis_5_0",
                      "redis_6_x",
                      "redis_7_0",
                      "redis_7_2"
                    ],
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "regions": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "zones": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "resource-config": {
          "commands": {
            "apply": {
              "commands": {},
              "flags": {}
            },
            "bulk-export": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--on-error": [
                  "continue",
                  "halt",
                  "ignore"
                ],
                "--organization": "value",
                "--path": "value",
                "--resource-format": [
                  "krm",
                  "terraform"
                ],
                "--resource-types": "value",
                "--resource-types-file": "value",
                "--storage-path": "value"
              }
            },
            "list-resource-types": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "value"
              }
            },
            "terraform": {
              "commands": {
                "generate-import": {
                  "commands": {},
                  "flags": {
                    "--output-dir": "value",
                    "--output-module-file": "value",
                    "--output-script-file": "value"
                  }
                },
                "init-provider": {
                  "commands": {},
                  "flags": {
                    "--region": "value",
                    "--tf-billing-project": "value",
                    "--tf-user-project-override": "bool",
                    "--use-gcloud-billing-project": "bool",
                    "--zone": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "resource-manager": {
          "commands": {
            "folders": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--display-name": "value",
                    "--folder": "value",
                    "--organization": "value",
                    "--tags": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-ancestors-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--include-deny": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--show-deleted": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "move": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "search": {
                  "commands": {},
                  "flags": {
                    "--limit": "value",
                    "--page-size": "value",
                    "--query": "value",
                    "--sort-by": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "undelete": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--display-name": "value"
                  }
                }
              },
              "flags": {}
            },
            "liens": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--origin": "value",
                    "--reason": "value",
                    "--restrictions": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "org-policies": {
              "commands": {
                "allow": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "dynamic"
                  }
                },
                "deny": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--effective": "bool",
                    "--folder": "value",
                    "--organization": "dynamic"
                  }
                },
                "disable-enforce": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "dynamic"
                  }
                },
                "enable-enforce": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--organization": "dynamic",
                    "--page-size": "value",
                    "--show-unset": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "set-policy": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "tags": {
              "commands": {
                "bindings": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--parent": "value",
                        "--tag-value": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--parent": "value",
                        "--tag-value": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--effective": "bool",
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--parent": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "holds": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--help-link": "value",
                        "--holder": "value",
                        "--location": "value",
                        "--origin": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--holder": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--origin": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "keys": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--member": "value",
                        "--role": "value"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value",
                        "--parent": "value",
                        "--purpose": [
                          "DATA_GOVERNANCE",
                          "GCE_FIREWALL"
                        ],
                        "--purpose-data": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--parent": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--member": "value",
                        "--role": "value"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {}
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "values": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--member": "value",
                        "--role": "value"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value",
                        "--parent": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--parent": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--member": "value",
                        "--role": "value"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {}
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "run": {
          "commands": {
            "deploy": {
              "commands": {},
              "flags": {
                "--add-cloudsql-instances": "value",
                "--add-custom-audiences": "value",
                "--add-volume": "value",
                "--add-volume-mount": "value",
                "--allow-unauthenticated": "bool",
                "--allow-unencrypted-build": "bool",
                "--args": "value",
                "--async": "bool",
                "--automatic-updates": "bool",
                "--base-image": "value",
                "--binary-authorization": "value",
                "--breakglass": "value",
                "--build-env-vars-file": "value",
                "--build-service-account": "value",
                "--build-worker-pool": "value",
                "--clear-base-image": "bool",
                "--clear-binary-authorization": "bool",
                "--clear-build-env-vars": "bool",
                "--clear-build-service-account": "bool",
                "--clear-build-worker-pool": "bool",
                "--clear-cloudsql-instances": "bool",
                "--clear-config-maps": "bool",
                "--clear-custom-audiences": "bool",
                "--clear-encryption-key-shutdown-hours": "bool",
                "--clear-env-vars": "bool",
                "--clear-key": "bool",
                "--clear-labels": "bool",
                "--clear-network": "bool",
                "--clear-network-tags": "bool",
                "--clear-post-key-revocation-action-type": "bool",
                "--clear-secrets": "bool",
                "--clear-volume-mounts": "bool",
                "--clear-volumes": "bool",
                "--clear-vpc-connector": "bool",
                "--command": "value",
                "--concurrency": "value",
                "--container": "value",
                "--cpu": "value",
                "--cpu-boost": "bool",
                "--cpu-throttling": "bool",
                "--default-url": "bool",
                "--delegate-builds": "bool",
                "--depends-on": "value",
                "--deploy-health-check": "bool",
                "--description": "value",
                "--encryption-key-shutdown-hours": "value",
                "--env-vars-file": "value",
                "--execution-environment": [
                  "gen1",
                  "gen2"
                ],
                "--function": "value",
                "--gpu": "value",
                "--image": "value",
                "--ingress": [
                  "all",
                  "internal",
                  "internal-and-cloud-load-balancing"
                ],
                "--invoker-iam-check": "bool",
                "--key": "value",
                "--labels": "value",
                "--liveness-probe": "value",
                "--max": "value",
                "--max-instances": "value",
                "--max-surge": "value",
                "--max-unavailable": "value",
                "--memory": "value",
                "--mesh": "value",
                "--min": "value",
                "--min-instances": "value",
                "--namespace": "value",
                "--network": "value",
                "--network-tags": "value",
                "--no-traffic": "bool",
                "--port": "value",
                "--post-key-revocation-action-type": [
                  "prevent-new",
                  "shut-down"
                ],
                "--region": "value",
                "--remove-build-env-vars": "value",
                "--remove-cloudsql-instances": "value",
                "--remove-config-maps": "value",
                "--remove-containers": "value",
                "--remove-custom-audiences": "value",
                "--remove-env-vars": "value",
                "--remove-labels": "value",
                "--remove-secrets": "value",
                "--remove-volume": "value",
                "--remove-volume-mount": "value",
                "--revision-suffix": "value",
                "--scaling": "value",
                "--service-account": "value",
                "--session-affinity": "bool",
                "--set-build-env-vars": "value",
                "--set-cloudsql-instances": "value",
                "--set-config-maps": "value",
                "--set-custom-audiences": "value",
                "--set-env-vars": "value",
                "--set-secrets": "value",
                "--source": "value",
                "--startup-probe": "value",
                "--subnet": "value",
                "--tag": "value",
                "--timeout": "value",
                "--update-build-env-vars": "value",
                "--update-config-maps": "value",
                "--update-env-vars": "value",
                "--update-labels": "value",
                "--update-secrets": "value",
                "--use-http2": "bool",
                "--vpc-connector": "value",
                "--vpc-egress": [
                  "all",
                  "all-traffic",
                  "private-ranges-only"
                ]
              }
            },
            "domain-mappings": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--domain": "value",
                    "--force-override": "bool",
                    "--namespace": "value",
                    "--region": "value",
                    "--service": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--domain": "value",
                    "--namespace": "value",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--domain": "value",
                    "--namespace": "value",
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--namespace": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {
                "--region": "value"
              }
            },
            "jobs": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--region": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--add-volume": "value",
                    "--add-volume-mount": "value",
                    "--args": "value",
                    "--async": "bool",
                    "--binary-authorization": "value",
                    "--breakglass": "value",
                    "--clear-env-vars": "bool",
                    "--clear-secrets": "bool",
                    "--clear-volume-mounts": "bool",
                    "--clear-volumes": "bool",
                    "--command": "value",
                    "--container": "value",
                    "--cpu": "value",
                    "--depends-on": "value",
                    "--env-vars-file": "value",
                    "--execute-now": "bool",
                    "--image": "value",
                    "--key": "value",
                    "--labels": "value",
                    "--max-retries": "value",
                    "--memory": "value",
                    "--network": "value",
                    "--network-tags": "value",
                    "--parallelism": "value",
                    "--region": "value",
                    "--remove-env-vars": "value",
                    "--remove-secrets": "value",
                    "--remove-volume": "value",
                    "--remove-volume-mount": "value",
                    "--service-account": "value",
                    "--set-cloudsql-instances": "value",
                    "--set-env-vars": "value",
                    "--set-secrets": "value",
                    "--subnet": "value",
                    "--task-timeout": "value",
                    "--tasks": "value",
                    "--update-env-vars": "value",
                    "--update-secrets": "value",
                    "--vpc-connector": "value",
                    "--vpc-egress": [
                      "all",
                      "all-traffic",
                      "private-ranges-only"
                    ],
                    "--wait": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "deploy": {
                  "commands": {},
                  "flags": {
                    "--add-volume": "value",
                    "--add-volume-mount": "value",
                    "--args": "value",
                    "--async": "bool",
                    "--binary-authorization": "value",
                    "--breakglass": "value",
                    "--clear-env-vars": "bool",
                    "--clear-network": "bool",
                    "--clear-network-tags": "bool",
                    "--clear-secrets": "bool",
                    "--clear-volume-mounts": "bool",
                    "--clear-volumes": "bool",
                    "--command": "value",
                    "--container": "value",
                    "--cpu": "value",
                    "--depends-on": "value",
                    "--env-vars-file": "value",
                    "--execute-now": "bool",
                    "--image": "value",
                    "--key": "value",
                    "--labels": "value",
                    "--max-retries": "value",
                    "--memory": "value",
                    "--network": "value",
                    "--network-tags": "value",
                    "--parallelism": "value",
                    "--region": "value",
                    "--remove-containers": "value",
                    "--remove-env-vars": "value",
                    "--remove-secrets": "value",
                    "--remove-volume": "value",
                    "--remove-volume-mount": "value",
                    "--service-account": "value",
                    "--set-cloudsql-instances": "value",
                    "--set-env-vars": "value",
                    "--set-secrets": "value",
                    "--source": "value",
                    "--subnet": "value",
                    "--task-timeout": "value",
                    "--tasks": "value",
                    "--update-env-vars": "value",
                    "--update-secrets": "value",
                    "--vpc-connector": "value",
                    "--vpc-egress": [
                      "all",
                      "all-traffic",
                      "private-ranges-only"
                    ],
                    "--wait": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "execute": {
                  "commands": {},
                  "flags": {
                    "--args": "value",
                    "--async": "bool",
                    "--container": "value",
                    "--region": "value",
                    "--task-timeout": "value",
                    "--tasks": "value",
                    "--update-env-vars": "value",
                    "--wait": "bool"
                  }
                },
                "executions": {
                  "commands": {
                    "cancel": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--region": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--region": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--job": "value",
                        "--limit": "value",
                        "--namespace": "value",
                        "--page-size": "value",
                        "--region": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "logs": {
                      "commands": {
                        "read": {
                          "commands": {},
                          "flags": {
                            "--freshness": "value",
                            "--limit": "value",
                            "--log-filter": "value",
                            "--order": [
                              "asc",
                              "desc"
                            ],
                            "--region": "value"
                          }
                        },
                        "tail": {
                          "commands": {},
                          "flags": {
                            "--log-filter": "value",
                            "--region": "value"
                          }
                        }
                      },
                      "flags": {
                        "--region": "value"
                      }
                    },
                    "tasks": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--region": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--abandoned": "bool",
                            "--cancelled": "bool",
                            "--completed": "bool",
                            "--execution": "value",
                            "--failed": "bool",
                            "--filter": "value",
                            "--limit": "value",
                            "--no-completed": "bool",
                            "--no-started": "bool",
                            "--page-size": "value",
                            "--pending": "bool",
                            "--region": "value",
                            "--running": "bool",
                            "--sort-by": "value",
                            "--started": "bool",
                            "--succeeded": "bool",
                            "--uri": "bool"
                          }
                        }
                      },
                      "flags": {
                        "--region": "value"
                      }
                    }
                  },
                  "flags": {
                    "--region": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--namespace": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "logs": {
                  "commands": {
                    "read": {
                      "commands": {},
                      "flags": {
                        "--freshness": "value",
                        "--limit": "value",
                        "--log-filter": "value",
                        "--order": [
                          "asc",
                          "desc"
                        ],
                        "--region": "value"
                      }
                    },
                    "tail": {
                      "commands": {},
                      "flags": {
                        "--log-filter": "value",
                        "--region": "value"
                      }
                    }
                  },
                  "flags": {
                    "--region": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--region": "value",
                    "--role": "dynamic"
                  }
                },
                "replace": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-cloudsql-instances": "value",
                    "--add-volume": "value",
                    "--add-volume-mount": "value",
                    "--args": "value",
                    "--async": "bool",
                    "--binary-authorization": "value",
                    "--breakglass": "value",
                    "--clear-binary-authorization": "bool",
                    "--clear-cloudsql-instances": "bool",
                    "--clear-env-vars": "bool",
                    "--clear-labels": "bool",
                    "--clear-network": "bool",
                    "--clear-network-tags": "bool",
                    "--clear-secrets": "bool",
                    "--clear-volume-mounts": "bool",
                    "--clear-volumes": "bool",
                    "--clear-vpc-connector": "bool",
                    "--command": "value",
                    "--container": "value",
                    "--cpu": "value",
                    "--depends-on": "value",
                    "--env-vars-file": "value",
                    "--execute-now": "bool",
                    "--image": "value",
                    "--key": "value",
                    "--labels": "value",
                    "--max-retries": "value",
                    "--memory": "value",
                    "--network": "value",
                    "--network-tags": "value",
                    "--parallelism": "value",
                    "--region": "value",
                    "--remove-cloudsql-instances": "value",
                    "--remove-containers": "value",
                    "--remove-env-vars": "value",
                    "--remove-labels": "value",
                    "--remove-secrets": "value",
                    "--remove-volume": "value",
                    "--remove-volume-mount": "value",
                    "--service-account": "value",
                    "--set-cloudsql-instances": "value",
                    "--set-env-vars": "value",
                    "--set-secrets": "value",
                    "--subnet": "value",
                    "--task-timeout": "value",
                    "--tasks": "value",
                    "--update-env-vars": "value",
                    "--update-labels": "value",
                    "--update-secrets": "value",
                    "--vpc-connector": "value",
                    "--vpc-egress": [
                      "all",
                      "all-traffic",
                      "private-ranges-only"
                    ],
                    "--wait": "bool"
                  }
                }
              },
              "flags": {
                "--region": "value"
              }
            },
            "multi-region-services": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--namespace": "value",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--namespace": "value",
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "replace": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--dry-run": "bool",
                    "--region": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-cloudsql-instances": "value",
                    "--add-custom-audiences": "value",
                    "--add-volume": "value",
                    "--add-volume-mount": "value",
                    "--args": "value",
                    "--async": "bool",
                    "--binary-authorization": "value",
                    "--breakglass": "value",
                    "--clear-binary-authorization": "bool",
                    "--clear-cloudsql-instances": "bool",
                    "--clear-config-maps": "bool",
                    "--clear-custom-audiences": "bool",
                    "--clear-encryption-key-shutdown-hours": "bool",
                    "--clear-env-vars": "bool",
                    "--clear-key": "bool",
                    "--clear-labels": "bool",
                    "--clear-network": "bool",
                    "--clear-network-tags": "bool",
                    "--clear-post-key-revocation-action-type": "bool",
                    "--clear-secrets": "bool",
                    "--clear-volume-mounts": "bool",
                    "--clear-volumes": "bool",
                    "--clear-vpc-connector": "bool",
                    "--command": "value",
                    "--concurrency": "value",
                    "--container": "value",
                    "--cpu": "value",
                    "--cpu-boost": "bool",
                    "--cpu-throttling": "bool",
                    "--default-url": "bool",
                    "--depends-on": "value",
                    "--deploy-health-check": "bool",
                    "--description": "value",
                    "--encryption-key-shutdown-hours": "value",
                    "--env-vars-file": "value",
                    "--execution-environment": [
                      "gen1",
                      "gen2"
                    ],
                    "--image": "value",
                    "--ingress": [
                      "all",
                      "internal",
                      "internal-and-cloud-load-balancing"
                    ],
                    "--invoker-iam-check": "bool",
                    "--key": "value",
                    "--labels": "value",
                    "--max": "value",
                    "--max-instances": "value",
                    "--max-surge": "value",
                    "--max-unavailable": "value",
                    "--memory": "value",
                    "--mesh": "value",
                    "--min": "value",
                    "--min-instances": "value",
                    "--namespace": "value",
                    "--network": "value",
                    "--network-tags": "value",
                    "--no-traffic": "bool",
                    "--port": "value",
                    "--post-key-revocation-action-type": [
                      "prevent-new",
                      "shut-down"
                    ],
                    "--region": "value",
                    "--remove-cloudsql-instances": "value",
                    "--remove-config-maps": "value",
                    "--remove-containers": "value",
                    "--remove-custom-audiences": "value",
                    "--remove-env-vars": "value",
                    "--remove-labels": "value",
                    "--remove-secrets": "value",
                    "--remove-volume": "value",
                    "--remove-volume-mount": "value",
                    "--revision-suffix": "value",
                    "--scaling": "value",
                    "--service-account": "value",
                    "--session-affinity": "bool",
                    "--set-cloudsql-instances": "value",
                    "--set-config-maps": "value",
                    "--set-custom-audiences": "value",
                    "--set-env-vars": "value",
                    "--set-secrets": "value",
                    "--subnet": "value",
                    "--tag": "value",
                    "--timeout": "value",
                    "--update-config-maps": "value",
                    "--update-env-vars": "value",
                    "--update-labels": "value",
                    "--update-secrets": "value",
                    "--use-http2": "bool",
                    "--vpc-connector": "value",
                    "--vpc-egress": [
                      "all",
                      "all-traffic",
                      "private-ranges-only"
                    ]
                  }
                }
              },
              "flags": {
                "--region": "value"
              }
            },
            "regions": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "revisions": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--namespace": "value",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--namespace": "value",
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--service": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "logs": {
                  "commands": {
                    "read": {
                      "commands": {},
                      "flags": {
                        "--freshness": "value",
                        "--limit": "value",
                        "--log-filter": "value",
                        "--order": [
                          "asc",
                          "desc"
                        ],
                        "--region": "value"
                      }
                    },
                    "tail": {
                      "commands": {},
                      "flags": {
                        "--log-filter": "value",
                        "--region": "value"
                      }
                    }
                  },
                  "flags": {
                    "--region": "value"
                  }
                }
              },
              "flags": {
                "--region": "value"
              }
            },
            "services": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--region": "value",
                    "--role": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--namespace": "value",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--namespace": "value",
                    "--region": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "logs": {
                  "commands": {
                    "read": {
                      "commands": {},
                      "flags": {
                        "--freshness": "value",
                        "--limit": "value",
                        "--log-filter": "value",
                        "--order": [
                          "asc",
                          "desc"
                        ],
                        "--region": "value"
                      }
                    },
                    "tail": {
                      "commands": {},
                      "flags": {
                        "--log-filter": "value",
                        "--region": "value"
                      }
                    }
                  },
                  "flags": {
                    "--region": "value"
                  }
                },
                "proxy": {
                  "commands": {},
                  "flags": {
                    "--namespace": "value",
                    "--port": "value",
                    "--region": "value",
                    "--tag": "value",
                    "--token": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--region": "value",
                    "--role": "dynamic"
                  }
                },
                "replace": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--dry-run": "bool",
                    "--region": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-cloudsql-instances": "value",
                    "--add-custom-audiences": "value",
                    "--add-volume": "value",
                    "--add-volume-mount": "value",
                    "--args": "value",
                    "--async": "bool",
                    "--binary-authorization": "value",
                    "--breakglass": "value",
                    "--clear-binary-authorization": "bool",
                    "--clear-cloudsql-instances": "bool",
                    "--clear-config-maps": "bool",
                    "--clear-custom-audiences": "bool",
                    "--clear-encryption-key-shutdown-hours": "bool",
                    "--clear-env-vars": "bool",
                    "--clear-key": "bool",
                    "--clear-labels": "bool",
                    "--clear-network": "bool",
                    "--clear-network-tags": "bool",
                    "--clear-post-key-revocation-action-type": "bool",
                    "--clear-secrets": "bool",
                    "--clear-volume-mounts": "bool",
                    "--clear-volumes": "bool",
                    "--clear-vpc-connector": "bool",
                    "--command": "value",
                    "--concurrency": "value",
                    "--container": "value",
                    "--cpu": "value",
                    "--cpu-boost": "bool",
                    "--cpu-throttling": "bool",
                    "--default-url": "bool",
                    "--depends-on": "value",
                    "--deploy-health-check": "bool",
                    "--description": "value",
                    "--encryption-key-shutdown-hours": "value",
                    "--env-vars-file": "value",
                    "--execution-environment": [
                      "gen1",
                      "gen2"
                    ],
                    "--gpu": "value",
                    "--image": "value",
                    "--ingress": [
                      "all",
                      "internal",
                      "internal-and-cloud-load-balancing"
                    ],
                    "--invoker-iam-check": "bool",
                    "--key": "value",
                    "--labels": "value",
                    "--liveness-probe": "value",
                    "--max": "value",
                    "--max-instances": "value",
                    "--max-surge": "value",
                    "--max-unavailable": "value",
                    "--memory": "value",
                    "--mesh": "value",
                    "--min": "value",
                    "--min-instances": "value",
                    "--namespace": "value",
                    "--network": "value",
                    "--network-tags": "value",
                    "--no-traffic": "bool",
                    "--port": "value",
                    "--post-key-revocation-action-type": [
                      "prevent-new",
                      "shut-down"
                    ],
                    "--region": "value",
                    "--remove-cloudsql-instances": "value",
                    "--remove-config-maps": "value",
                    "--remove-containers": "value",
                    "--remove-custom-audiences": "value",
                    "--remove-env-vars": "value",
                    "--remove-labels": "value",
                    "--remove-secrets": "value",
                    "--remove-volume": "value",
                    "--remove-volume-mount": "value",
                    "--revision-suffix": "value",
                    "--scaling": "value",
                    "--service-account": "value",
                    "--session-affinity": "bool",
                    "--set-cloudsql-instances": "value",
                    "--set-config-maps": "value",
                    "--set-custom-audiences": "value",
                    "--set-env-vars": "value",
                    "--set-secrets": "value",
                    "--startup-probe": "value",
                    "--subnet": "value",
                    "--tag": "value",
                    "--timeout": "value",
                    "--update-config-maps": "value",
                    "--update-env-vars": "value",
                    "--update-labels": "value",
                    "--update-secrets": "value",
                    "--use-http2": "bool",
                    "--vpc-connector": "value",
                    "--vpc-egress": [
                      "all",
                      "all-traffic",
                      "private-ranges-only"
                    ]
                  }
                },
                "update-traffic": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--breakglass": "value",
                    "--clear-tags": "bool",
                    "--namespace": "value",
                    "--region": "value",
                    "--remove-tags": "value",
                    "--set-tags": "value",
                    "--to-latest": "bool",
                    "--to-revisions": "value",
                    "--to-tags": "value",
                    "--update-tags": "value"
                  }
                }
              },
              "flags": {
                "--region": "value"
              }
            },
            "workers": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "deploy": {
                  "commands": {},
                  "flags": {
                    "--add-cloudsql-instances": "value",
                    "--add-volume": "value",
                    "--add-volume-mount": "value",
                    "--args": "value",
                    "--async": "bool",
                    "--binary-authorization": "value",
                    "--breakglass": "value",
                    "--clear-binary-authorization": "bool",
                    "--clear-cloudsql-instances": "bool",
                    "--clear-encryption-key-shutdown-hours": "bool",
                    "--clear-env-vars": "bool",
                    "--clear-key": "bool",
                    "--clear-labels": "bool",
                    "--clear-network": "bool",
                    "--clear-network-tags": "bool",
                    "--clear-post-key-revocation-action-type": "bool",
                    "--clear-secrets": "bool",
                    "--clear-volume-mounts": "bool",
                    "--clear-volumes": "bool",
                    "--command": "value",
                    "--cpu": "value",
                    "--description": "value",
                    "--encryption-key-shutdown-hours": "value",
                    "--env-vars-file": "value",
                    "--image": "value",
                    "--key": "value",
                    "--labels": "value",
                    "--max-instances": "value",
                    "--max-surge": "value",
                    "--max-unavailable": "value",
                    "--memory": "value",
                    "--mesh": "value",
                    "--min-instances": "value",
                    "--network": "value",
                    "--network-tags": "value",
                    "--no-promote": "bool",
                    "--post-key-revocation-action-type": [
                      "prevent-new",
                      "shut-down"
                    ],
                    "--region": "value",
                    "--remove-cloudsql-instances": "value",
                    "--remove-env-vars": "value",
                    "--remove-labels": "value",
                    "--remove-secrets": "value",
                    "--remove-volume": "value",
                    "--remove-volume-mount": "value",
                    "--revision-suffix": "value",
                    "--scaling": "value",
                    "--service-account": "value",
                    "--set-cloudsql-instances": "value",
                    "--set-env-vars": "value",
                    "--set-secrets": "value",
                    "--source": "value",
                    "--subnet": "value",
                    "--update-env-vars": "value",
                    "--update-labels": "value",
                    "--update-secrets": "value",
                    "--vpc-egress": [
                      "all",
                      "all-traffic",
                      "private-ranges-only"
                    ]
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--namespace": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "revisions": {
                  "commands": {
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--namespace": "value",
                        "--region": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--namespace": "value",
                        "--region": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--namespace": "value",
                        "--page-size": "value",
                        "--region": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {
                    "--region": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-cloudsql-instances": "value",
                    "--add-custom-audiences": "value",
                    "--add-volume": "value",
                    "--add-volume-mount": "value",
                    "--args": "value",
                    "--async": "bool",
                    "--binary-authorization": "value",
                    "--breakglass": "value",
                    "--clear-binary-authorization": "bool",
                    "--clear-cloudsql-instances": "bool",
                    "--clear-custom-audiences": "bool",
                    "--clear-encryption-key-shutdown-hours": "bool",
                    "--clear-env-vars": "bool",
                    "--clear-key": "bool",
                    "--clear-labels": "bool",
                    "--clear-network": "bool",
                    "--clear-network-tags": "bool",
                    "--clear-post-key-revocation-action-type": "bool",
                    "--clear-secrets": "bool",
                    "--clear-volume-mounts": "bool",
                    "--clear-volumes": "bool",
                    "--command": "value",
                    "--cpu": "value",
                    "--description": "value",
                    "--encryption-key-shutdown-hours": "value",
                    "--env-vars-file": "value",
                    "--image": "value",
                    "--key": "value",
                    "--labels": "value",
                    "--max-instances": "value",
                    "--max-surge": "value",
                    "--max-unavailable": "value",
                    "--memory": "value",
                    "--mesh": "value",
                    "--min-instances": "value",
                    "--network": "value",
                    "--network-tags": "value",
                    "--no-promote": "bool",
                    "--post-key-revocation-action-type": [
                      "prevent-new",
                      "shut-down"
                    ],
                    "--region": "value",
                    "--remove-cloudsql-instances": "value",
                    "--remove-custom-audiences": "value",
                    "--remove-env-vars": "value",
                    "--remove-labels": "value",
                    "--remove-secrets": "value",
                    "--remove-volume": "value",
                    "--remove-volume-mount": "value",
                    "--revision-suffix": "value",
                    "--scaling": "value",
                    "--service-account": "value",
                    "--session-affinity": "bool",
                    "--set-cloudsql-instances": "value",
                    "--set-custom-audiences": "value",
                    "--set-env-vars": "value",
                    "--set-secrets": "value",
                    "--subnet": "value",
                    "--update-env-vars": "value",
                    "--update-labels": "value",
                    "--update-secrets": "value",
                    "--vpc-egress": [
                      "all",
                      "all-traffic",
                      "private-ranges-only"
                    ]
                  }
                },
                "update-instance-split": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--breakglass": "value",
                    "--region": "value",
                    "--to-latest": "bool",
                    "--to-revisions": "value"
                  }
                }
              },
              "flags": {
                "--region": "value"
              }
            }
          },
          "flags": {}
        },
        "scc": {
          "commands": {
            "assets": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--asset": "value",
                    "--resource-name": "value"
                  }
                },
                "get-parent": {
                  "commands": {},
                  "flags": {
                    "--asset": "value",
                    "--resource-name": "value"
                  }
                },
                "get-project": {
                  "commands": {},
                  "flags": {
                    "--asset": "value",
                    "--resource-name": "value"
                  }
                },
                "group": {
                  "commands": {},
                  "flags": {
                    "--compare-duration": "value",
                    "--filter": "value",
                    "--group-by": "value",
                    "--page-size": "value",
                    "--page-token": "value",
                    "--read-time": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--compare-duration": "value",
                    "--field-mask": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--order-by": "value",
                    "--page-size": "value",
                    "--page-token": "value",
                    "--read-time": "value",
                    "--sort-by": "value"
                  }
                },
                "list-marks": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--page-token": "value",
                    "--read-time": "value",
                    "--sort-by": "value"
                  }
                },
                "run-discovery": {
                  "commands": {},
                  "flags": {}
                },
                "update-marks": {
                  "commands": {},
                  "flags": {
                    "--organization": "value",
                    "--security-marks": "value",
                    "--start-time": "value",
                    "--update-mask": "value"
                  }
                }
              },
              "flags": {}
            },
            "custom-modules": {
              "commands": {
                "etd": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--custom-config-from-file": "value",
                        "--display-name": "value",
                        "--enablement-state": [
                          "disabled",
                          "enabled",
                          "enablement-state-unspecified",
                          "inherited"
                        ],
                        "--folder": "value",
                        "--module-type": "value",
                        "--organization": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--folder": "value",
                        "--organization": "value"
                      }
                    },
                    "get": {
                      "commands": {},
                      "flags": {
                        "--folder": "value",
                        "--organization": "value"
                      }
                    },
                    "get-effective": {
                      "commands": {},
                      "flags": {
                        "--folder": "value",
                        "--organization": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--folder": "value",
                        "--limit": "value",
                        "--organization": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list-descendant": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--folder": "value",
                        "--limit": "value",
                        "--organization": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list-effective": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--folder": "value",
                        "--limit": "value",
                        "--organization": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--custom-config-from-file": "value",
                        "--enablement-state": [
                          "disabled",
                          "enabled",
                          "enablement-state-unspecified",
                          "inherited"
                        ],
                        "--folder": "value",
                        "--organization": "value",
                        "--update-mask": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "sha": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--custom-config-from-file": "value",
                        "--display-name": "value",
                        "--enablement-state": [
                          "disabled",
                          "enabled",
                          "enablement-state-unspecified",
                          "inherited"
                        ],
                        "--folder": "value",
                        "--organization": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--folder": "value",
                        "--organization": "value"
                      }
                    },
                    "get": {
                      "commands": {},
                      "flags": {
                        "--folder": "value",
                        "--organization": "value"
                      }
                    },
                    "get-effective": {
                      "commands": {},
                      "flags": {
                        "--folder": "value",
                        "--organization": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--folder": "value",
                        "--limit": "value",
                        "--organization": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list-descendant": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--folder": "value",
                        "--limit": "value",
                        "--organization": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list-effective": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--folder": "value",
                        "--limit": "value",
                        "--organization": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "simulate": {
                      "commands": {},
                      "flags": {
                        "--custom-config-from-file": "value",
                        "--folder": "value",
                        "--organization": "value",
                        "--resource-from-file": "value"
                      }
                    },
                    "test": {
                      "commands": {},
                      "flags": {
                        "--custom-config-from-file": "value",
                        "--display-name": "value",
                        "--folder": "value",
                        "--organization": "value",
                        "--test-data-from-file": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--custom-config-from-file": "value",
                        "--enablement-state": [
                          "disabled",
                          "enabled",
                          "enablement-state-unspecified",
                          "inherited"
                        ],
                        "--folder": "value",
                        "--organization": "value",
                        "--update-mask": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "findings": {
              "commands": {
                "bulk-mute": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--mute-state": [
                      "muted",
                      "undefined"
                    ],
                    "--organization": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--category": "value",
                    "--event-time": "value",
                    "--external-uri": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--resource-name": "value",
                    "--source": "value",
                    "--source-properties": "value",
                    "--state": [
                      "active",
                      "inactive",
                      "state-unspecified"
                    ]
                  }
                },
                "group": {
                  "commands": {},
                  "flags": {
                    "--compare-duration": "value",
                    "--filter": "value",
                    "--group-by": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--page-token": "value",
                    "--read-time": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--compare-duration": "value",
                    "--field-mask": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--order-by": "value",
                    "--page-size": "value",
                    "--page-token": "value",
                    "--read-time": "value",
                    "--sort-by": "value",
                    "--source": "value"
                  }
                },
                "list-marks": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--page-token": "value",
                    "--read-time": "value",
                    "--sort-by": "value",
                    "--source": "value"
                  }
                },
                "set-mute": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--location": "value",
                    "--mute": [
                      "muted",
                      "undefined",
                      "unmuted"
                    ],
                    "--organization": "value",
                    "--source": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--event-time": "value",
                    "--external-uri": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--source": "value",
                    "--source-properties": "value",
                    "--state": [
                      "active",
                      "inactive",
                      "state-unspecified"
                    ],
                    "--update-mask": "value"
                  }
                },
                "update-marks": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--organization": "value",
                    "--security-marks": "value",
                    "--source": "value",
                    "--start-time": "value",
                    "--update-mask": "value"
                  }
                }
              },
              "flags": {}
            },
            "iac-validation-reports": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--tf-plan-file": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "manage": {
              "commands": {
                "custom-modules": {
                  "commands": {
                    "etd": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--custom-config-file": "value",
                            "--display-name": "value",
                            "--enablement-state": "value",
                            "--folder": "value",
                            "--module-type": "value",
                            "--organization": "dynamic",
                            "--parent": "value",
                            "--validate-only": "bool"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--folder": "value",
                            "--organization": "dynamic",
                            "--parent": "value",
                            "--validate-only": "bool"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--folder": "value",
                            "--organization": "dynamic",
                            "--parent": "value"
                          }
                        },
                        "describe-effective": {
                          "commands": {},
                          "flags": {
                            "--folder": "value",
                            "--organization": "dynamic",
                            "--parent": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--folder": "value",
                            "--limit": "value",
                            "--organization": "dynamic",
                            "--page-size": "value",
                            "--parent": "value",
                            "--sort-by": "value"
                          }
                        },
                        "list-descendant": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--folder": "value",
                            "--limit": "value",
                            "--organization": "dynamic",
                            "--page-size": "value",
                            "--parent": "value",
                            "--sort-by": "value"
                          }
                        },
                        "list-effective": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--folder": "value",
                            "--limit": "value",
                            "--organization": "dynamic",
                            "--page-size": "value",
                            "--parent": "value",
                            "--sort-by": "value"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--custom-config-file": "value",
                            "--enablement-state": "value",
                            "--folder": "value",
                            "--organization": "dynamic",
                            "--parent": "value",
                            "--validate-only": "bool"
                          }
                        },
                        "validate": {
                          "commands": {},
                          "flags": {
                            "--custom-config-file": "value",
                            "--folder": "value",
                            "--module-type": "value",
                            "--organization": "dynamic",
                            "--parent": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "sha": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--custom-config-from-file": "value",
                            "--display-name": "value",
                            "--enablement-state": "value",
                            "--folder": "value",
                            "--organization": "dynamic",
                            "--parent": "value",
                            "--validate-only": "bool"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--folder": "value",
                            "--organization": "dynamic",
                            "--parent": "value",
                            "--validate-only": "bool"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--folder": "value",
                            "--organization": "dynamic",
                            "--parent": "value"
                          }
                        },
                        "describe-effective": {
                          "commands": {},
                          "flags": {
                            "--folder": "value",
                            "--organization": "dynamic",
                            "--parent": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--folder": "value",
                            "--limit": "value",
                            "--organization": "dynamic",
                            "--page-size": "value",
                            "--parent": "value",
                            "--sort-by": "value"
                          }
                        },
                        "list-descendant": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--folder": "value",
                            "--limit": "value",
                            "--organization": "dynamic",
                            "--page-size": "value",
                            "--parent": "value",
                            "--sort-by": "value"
                          }
                        },
                        "list-effective": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--folder": "value",
                            "--limit": "value",
                            "--organization": "dynamic",
                            "--page-size": "value",
                            "--parent": "value",
                            "--sort-by": "value"
                          }
                        },
                        "simulate": {
                          "commands": {},
                          "flags": {
                            "--custom-config-from-file": "value",
                            "--folder": "value",
                            "--organization": "dynamic",
                            "--parent": "value",
                            "--resource-from-file": "value"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--custom-config-file": "value",
                            "--enablement-state": "value",
                            "--folder": "value",
                            "--organization": "dynamic",
                            "--parent": "value",
                            "--validate-only": "bool"
                          }
                        }
                      },
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "services": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--filter-modules": "value",
                        "--folder": "value",
                        "--organization": "dynamic",
                        "--parent": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--folder": "value",
                        "--limit": "value",
                        "--organization": "dynamic",
                        "--page-size": "value",
                        "--parent": "value",
                        "--sort-by": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--enablement-state": "value",
                        "--folder": "value",
                        "--module-config-file": "value",
                        "--organization": "dynamic",
                        "--parent": "value",
                        "--validate-only": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "muteconfigs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--expiry-time": "value",
                    "--filter": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--type": [
                      "dynamic",
                      "static"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "get": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--expiry-time": "value",
                    "--filter": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--update-mask": "value"
                  }
                }
              },
              "flags": {}
            },
            "notifications": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--filter": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--pubsub-topic": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--filter": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--pubsub-topic": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                }
              },
              "flags": {}
            },
            "posture-deployments": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--posture-name": "value",
                    "--posture-revision-id": "value",
                    "--target-resource": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--etag": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--etag": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--posture-id": "value",
                    "--posture-revision-id": "value",
                    "--update-mask": "value"
                  }
                }
              },
              "flags": {}
            },
            "posture-operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "posture-templates": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--organization": "value",
                    "--revision-id": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "postures": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--organization": "value",
                    "--posture-from-file": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--etag": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--organization": "value",
                    "--revision-id": "value"
                  }
                },
                "extract": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--organization": "value",
                    "--workload": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list-revisions": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--organization": "value",
                    "--posture-from-file": "value",
                    "--revision-id": "value",
                    "--update-mask": "value"
                  }
                }
              },
              "flags": {}
            },
            "settings": {
              "commands": {
                "describe-explicit": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "services": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--folder": "value",
                        "--organization": "value",
                        "--service": [
                          "container-threat-detection",
                          "event-threat-detection",
                          "security-health-analytics",
                          "virtual-machine-threat-detection",
                          "web-security-scanner"
                        ]
                      }
                    },
                    "describe-explicit": {
                      "commands": {},
                      "flags": {
                        "--folder": "value",
                        "--organization": "value",
                        "--service": [
                          "container-threat-detection",
                          "event-threat-detection",
                          "security-health-analytics",
                          "virtual-machine-threat-detection",
                          "web-security-scanner"
                        ]
                      }
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--folder": "value",
                        "--organization": "value",
                        "--service": [
                          "container-threat-detection",
                          "event-threat-detection",
                          "security-health-analytics",
                          "virtual-machine-threat-detection",
                          "web-security-scanner"
                        ]
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--folder": "value",
                        "--organization": "value",
                        "--service": [
                          "container-threat-detection",
                          "event-threat-detection",
                          "security-health-analytics",
                          "virtual-machine-threat-detection",
                          "web-security-scanner"
                        ]
                      }
                    },
                    "inherit": {
                      "commands": {},
                      "flags": {
                        "--folder": "value",
                        "--service": [
                          "container-threat-detection",
                          "event-threat-detection",
                          "security-health-analytics",
                          "virtual-machine-threat-detection",
                          "web-security-scanner"
                        ]
                      }
                    },
                    "modules": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--folder": "value",
                            "--module": "value",
                            "--organization": "value",
                            "--service": [
                              "container-threat-detection",
                              "event-threat-detection",
                              "security-health-analytics",
                              "virtual-machine-threat-detection",
                              "web-security-scanner"
                            ]
                          }
                        },
                        "describe-explicit": {
                          "commands": {},
                          "flags": {
                            "--folder": "value",
                            "--module": "value",
                            "--organization": "value",
                            "--service": [
                              "container-threat-detection",
                              "event-threat-detection",
                              "security-health-analytics",
                              "virtual-machine-threat-detection",
                              "web-security-scanner"
                            ]
                          }
                        },
                        "disable": {
                          "commands": {},
                          "flags": {
                            "--folder": "value",
                            "--module": "value",
                            "--organization": "value",
                            "--service": [
                              "container-threat-detection",
                              "event-threat-detection",
                              "security-health-analytics",
                              "virtual-machine-threat-detection",
                              "web-security-scanner"
                            ]
                          }
                        },
                        "enable": {
                          "commands": {},
                          "flags": {
                            "--folder": "value",
                            "--module": "value",
                            "--organization": "value",
                            "--service": [
                              "container-threat-detection",
                              "event-threat-detection",
                              "security-health-analytics",
                              "virtual-machine-threat-detection",
                              "web-security-scanner"
                            ]
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--clear-config": "bool",
                            "--config": "value",
                            "--enablement-state": [
                              "disabled",
                              "enabled"
                            ],
                            "--folder": "value",
                            "--module": "value",
                            "--organization": "value",
                            "--service": [
                              "container-threat-detection",
                              "event-threat-detection",
                              "security-health-analytics",
                              "virtual-machine-threat-detection",
                              "web-security-scanner"
                            ]
                          }
                        }
                      },
                      "flags": {}
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "sources": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--source": "value",
                    "--source-display-name": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "scheduler": {
          "commands": {
            "jobs": {
              "commands": {
                "create": {
                  "commands": {
                    "app-engine": {
                      "commands": {},
                      "flags": {
                        "--attempt-deadline": "value",
                        "--description": "value",
                        "--headers": "value",
                        "--http-method": [
                          "delete",
                          "get",
                          "head",
                          "post",
                          "put"
                        ],
                        "--location": "value",
                        "--max-backoff": "value",
                        "--max-doublings": "value",
                        "--max-retry-attempts": "value",
                        "--max-retry-duration": "value",
                        "--message-body": "value",
                        "--message-body-from-file": "value",
                        "--min-backoff": "value",
                        "--relative-url": "value",
                        "--schedule": "value",
                        "--service": "value",
                        "--time-zone": "value"
                      }
                    },
                    "http": {
                      "commands": {},
                      "flags": {
                        "--attempt-deadline": "value",
                        "--description": "value",
                        "--headers": "value",
                        "--http-method": [
                          "delete",
                          "get",
                          "head",
                          "post",
                          "put"
                        ],
                        "--location": "value",
                        "--max-backoff": "value",
                        "--max-doublings": "value",
                        "--max-retry-attempts": "value",
                        "--max-retry-duration": "value",
                        "--message-body": "value",
                        "--message-body-from-file": "value",
                        "--min-backoff": "value",
                        "--oauth-service-account-email": "value",
                        "--oauth-token-scope": "value",
                        "--oidc-service-account-email": "value",
                        "--oidc-token-audience": "value",
                        "--schedule": "value",
                        "--time-zone": "value",
                        "--uri": "value"
                      }
                    },
                    "pubsub": {
                      "commands": {},
                      "flags": {
                        "--attributes": "value",
                        "--description": "value",
                        "--location": "value",
                        "--max-backoff": "value",
                        "--max-doublings": "value",
                        "--max-retry-attempts": "value",
                        "--max-retry-duration": "value",
                        "--message-body": "value",
                        "--message-body-from-file": "value",
                        "--min-backoff": "value",
                        "--schedule": "value",
                        "--time-zone": "value",
                        "--topic": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "pause": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "resume": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "run": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {
                    "app-engine": {
                      "commands": {},
                      "flags": {
                        "--attempt-deadline": "value",
                        "--clear-headers": "bool",
                        "--clear-max-backoff": "bool",
                        "--clear-max-doublings": "bool",
                        "--clear-max-retry-attempts": "bool",
                        "--clear-max-retry-duration": "bool",
                        "--clear-message-body": "bool",
                        "--clear-min-backoff": "bool",
                        "--clear-relative-url": "bool",
                        "--clear-service": "bool",
                        "--clear-time-zone": "bool",
                        "--description": "value",
                        "--http-method": [
                          "delete",
                          "get",
                          "head",
                          "post",
                          "put"
                        ],
                        "--location": "value",
                        "--max-backoff": "value",
                        "--max-doublings": "value",
                        "--max-retry-attempts": "value",
                        "--max-retry-duration": "value",
                        "--message-body": "value",
                        "--message-body-from-file": "value",
                        "--min-backoff": "value",
                        "--relative-url": "value",
                        "--remove-headers": "value",
                        "--schedule": "value",
                        "--service": "value",
                        "--time-zone": "value",
                        "--update-headers": "value"
                      }
                    },
                    "http": {
                      "commands": {},
                      "flags": {
                        "--attempt-deadline": "value",
                        "--clear-auth-token": "bool",
                        "--clear-headers": "bool",
                        "--clear-max-backoff": "bool",
                        "--clear-max-doublings": "bool",
                        "--clear-max-retry-attempts": "bool",
                        "--clear-max-retry-duration": "bool",
                        "--clear-message-body": "bool",
                        "--clear-min-backoff": "bool",
                        "--clear-time-zone": "bool",
                        "--description": "value",
                        "--http-method": [
                          "delete",
                          "get",
                          "head",
                          "post",
                          "put"
                        ],
                        "--location": "value",
                        "--max-backoff": "value",
                        "--max-doublings": "value",
                        "--max-retry-attempts": "value",
                        "--max-retry-duration": "value",
                        "--message-body": "value",
                        "--message-body-from-file": "value",
                        "--min-backoff": "value",
                        "--oauth-service-account-email": "value",
                        "--oauth-token-scope": "value",
                        "--oidc-service-account-email": "value",
                        "--oidc-token-audience": "value",
                        "--remove-headers": "value",
                        "--schedule": "value",
                        "--time-zone": "value",
                        "--update-headers": "value",
                        "--uri": "value"
                      }
                    },
                    "pubsub": {
                      "commands": {},
                      "flags": {
                        "--clear-attributes": "bool",
                        "--clear-max-backoff": "bool",
                        "--clear-max-doublings": "bool",
                        "--clear-max-retry-attempts": "bool",
                        "--clear-max-retry-duration": "bool",
                        "--clear-min-backoff": "bool",
                        "--clear-time-zone": "bool",
                        "--description": "value",
                        "--location": "value",
                        "--max-backoff": "value",
                        "--max-doublings": "value",
                        "--max-retry-attempts": "value",
                        "--max-retry-duration": "value",
                        "--message-body": "value",
                        "--message-body-from-file": "value",
                        "--min-backoff": "value",
                        "--remove-attributes": "value",
                        "--schedule": "value",
                        "--time-zone": "value",
                        "--topic": "value",
                        "--update-attributes": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "secrets": {
          "commands": {
            "config": {
              "commands": {
                "export": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--path": "value",
                    "--resource-format": [
                      "krm",
                      "terraform"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "versions": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ],
                        "--secret": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "service-directory": {
          "commands": {
            "endpoints": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--address": "value",
                    "--location": "value",
                    "--metadata": "value",
                    "--namespace": "value",
                    "--network": "value",
                    "--port": "value",
                    "--service": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--namespace": "value",
                    "--service": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--namespace": "value",
                    "--service": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--location": "value",
                    "--namespace": "value",
                    "--page-size": "value",
                    "--service": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--address": "value",
                    "--location": "value",
                    "--metadata": "value",
                    "--namespace": "value",
                    "--port": "value",
                    "--service": "value"
                  }
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "namespaces": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--labels": "value",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--labels": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "services": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--namespace": "value",
                    "--role": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--metadata": "value",
                    "--namespace": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--namespace": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--namespace": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--namespace": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--location": "value",
                    "--namespace": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--namespace": "value",
                    "--role": "value"
                  }
                },
                "resolve": {
                  "commands": {},
                  "flags": {
                    "--endpoint-filter": "value",
                    "--location": "value",
                    "--max-endpoints": "value",
                    "--namespace": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--namespace": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--metadata": "value",
                    "--namespace": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "service-extensions": {
          "commands": {
            "lb-route-extensions": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "lb-traffic-extensions": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "wasm-actions": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--supported-events": "value",
                    "--wasm-plugin": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "wasm-plugin-versions": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--image": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--plugin-config": "value",
                    "--plugin-config-file": "value",
                    "--plugin-config-uri": "value",
                    "--wasm-plugin": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--wasm-plugin": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--wasm-plugin": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--wasm-plugin": "value"
                  }
                }
              },
              "flags": {}
            },
            "wasm-plugins": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--image": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--log-config": "value",
                    "--main-version": "value",
                    "--plugin-config": "value",
                    "--plugin-config-file": "value",
                    "--plugin-config-uri": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--image": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--log-config": "value",
                    "--main-version": "value",
                    "--plugin-config": "value",
                    "--plugin-config-file": "value",
                    "--plugin-config-uri": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "services": {
          "commands": {
            "api-keys": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--allowed-application": "value",
                    "--allowed-bundle-ids": "value",
                    "--allowed-ips": "value",
                    "--allowed-referrers": "value",
                    "--annotations": "value",
                    "--api-target": "value",
                    "--async": "bool",
                    "--display-name": "value",
                    "--key-id": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-key-string": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--show-deleted": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "lookup": {
                  "commands": {},
                  "flags": {}
                },
                "undelete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--key-string": "value",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--allowed-application": "value",
                    "--allowed-bundle-ids": "value",
                    "--allowed-ips": "value",
                    "--allowed-referrers": "value",
                    "--annotations": "value",
                    "--api-target": "value",
                    "--async": "bool",
                    "--clear-annotations": "bool",
                    "--clear-restrictions": "bool",
                    "--display-name": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "identity": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value",
                    "--service": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--full": "value"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "peered-dns-domains": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--dns-suffix": "value",
                    "--network": "value",
                    "--service": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--network": "value",
                    "--service": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--network": "value",
                    "--service": "value"
                  }
                }
              },
              "flags": {}
            },
            "quota": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--consumer": "value",
                    "--dimensions": "value",
                    "--force": "bool",
                    "--metric": "value",
                    "--service": "value",
                    "--unit": "value",
                    "--value": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--consumer": "value",
                    "--force": "bool",
                    "--metric": "value",
                    "--override-id": "value",
                    "--service": "value",
                    "--unit": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--consumer": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--service": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--consumer": "value",
                    "--dimensions": "value",
                    "--force": "bool",
                    "--metric": "value",
                    "--service": "value",
                    "--unit": "value",
                    "--value": "value"
                  }
                }
              },
              "flags": {}
            },
            "vpc-peerings": {
              "commands": {
                "connect": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--network": "value",
                    "--ranges": "value",
                    "--service": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--network": "value",
                    "--service": "value"
                  }
                },
                "disable-vpc-service-controls": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--network": "value",
                    "--service": "value"
                  }
                },
                "enable-vpc-service-controls": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--network": "value",
                    "--service": "value"
                  }
                },
                "get-vpc-service-controls": {
                  "commands": {},
                  "flags": {
                    "--network": "value",
                    "--service": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--network": "value",
                    "--service": "value"
                  }
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--name": "value"
                      }
                    },
                    "wait": {
                      "commands": {},
                      "flags": {
                        "--name": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--force": "bool",
                    "--network": "value",
                    "--ranges": "value",
                    "--service": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "source": {
          "commands": {
            "project-configs": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-topic": "value",
                    "--disable-pushblock": "bool",
                    "--enable-pushblock": "bool",
                    "--message-format": [
                      "json",
                      "protobuf"
                    ],
                    "--remove-topic": "value",
                    "--service-account": "value",
                    "--topic-project": "value",
                    "--update-topic": "value"
                  }
                }
              },
              "flags": {}
            },
            "repos": {
              "commands": {
                "clone": {
                  "commands": {},
                  "flags": {
                    "--dry-run": "bool",
                    "--use-full-gcloud-path": "bool"
                  }
                },
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--force": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-topic": "value",
                    "--message-format": [
                      "json",
                      "protobuf"
                    ],
                    "--remove-topic": "value",
                    "--service-account": "value",
                    "--topic-project": "value",
                    "--update-topic": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "source-manager": {
          "commands": {
            "instances": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--ca-pool": "value",
                    "--enable-workforce-identity-federation": "bool",
                    "--is-private": "bool",
                    "--kms-key": "value",
                    "--max-wait": "value",
                    "--region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--max-wait": "value",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "repos": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--default-branch": "value",
                    "--description": "value",
                    "--gitignores": "value",
                    "--instance": "value",
                    "--license": "value",
                    "--readme": "value",
                    "--region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--allow-missing": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--instance": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "spanner": {
          "commands": {
            "backup-schedules": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--database": "dynamic",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--backup-type": "value",
                    "--cron": "value",
                    "--database": "value",
                    "--encryption-type": [
                      "customer-managed-encryption",
                      "google-default-encryption",
                      "use-database-encryption"
                    ],
                    "--instance": "value",
                    "--kms-key": "value",
                    "--kms-keyring": "value",
                    "--kms-keys": "value",
                    "--kms-location": "value",
                    "--kms-project": "value",
                    "--retention-duration": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--database": "value",
                    "--instance": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--database": "value",
                    "--instance": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--database": "dynamic",
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--database": "value",
                    "--filter": "value",
                    "--instance": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--database": "dynamic",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--database": "dynamic",
                    "--instance": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--cron": "value",
                    "--database": "value",
                    "--encryption-type": [
                      "customer-managed-encryption",
                      "google-default-encryption",
                      "use-database-encryption"
                    ],
                    "--instance": "value",
                    "--kms-key": "value",
                    "--kms-keyring": "value",
                    "--kms-keys": "value",
                    "--kms-location": "value",
                    "--kms-project": "value",
                    "--retention-duration": "value"
                  }
                }
              },
              "flags": {}
            },
            "backups": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "copy": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--destination-backup": "value",
                    "--destination-instance": "value",
                    "--encryption-type": [
                      "customer-managed-encryption",
                      "google-default-encryption",
                      "use-config-default-or-backup-encryption"
                    ],
                    "--expiration-date": "value",
                    "--kms-key": "value",
                    "--kms-keyring": "value",
                    "--kms-keys": "value",
                    "--kms-location": "value",
                    "--kms-project": "value",
                    "--retention-period": "value",
                    "--source-backup": "value",
                    "--source-instance": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--database": "value",
                    "--encryption-type": [
                      "customer-managed-encryption",
                      "google-default-encryption",
                      "use-database-encryption"
                    ],
                    "--expiration-date": "value",
                    "--instance": "value",
                    "--kms-key": "value",
                    "--kms-keyring": "value",
                    "--kms-keys": "value",
                    "--kms-location": "value",
                    "--kms-project": "value",
                    "--retention-period": "value",
                    "--version-time": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--database": "value",
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "update-metadata": {
                  "commands": {},
                  "flags": {
                    "--expiration-date": "value",
                    "--instance": "dynamic",
                    "--retention-period": "value"
                  }
                }
              },
              "flags": {}
            },
            "databases": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "change-quorum": {
                  "commands": {},
                  "flags": {
                    "--dual-region": "bool",
                    "--etag": "value",
                    "--instance": "value",
                    "--serving-location": "value",
                    "--single-region": "bool"
                  }
                },
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--instance": "dynamic",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--database-dialect": [
                      "GOOGLE_STANDARD_SQL",
                      "POSTGRESQL"
                    ],
                    "--ddl": "value",
                    "--ddl-file": "dynamic",
                    "--instance": "value",
                    "--kms-key": "value",
                    "--kms-keyring": "value",
                    "--kms-keys": "value",
                    "--kms-location": "value",
                    "--kms-project": "value",
                    "--proto-descriptors-file": "dynamic"
                  }
                },
                "ddl": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--include-proto-descriptors": "bool",
                        "--instance": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--ddl": "value",
                        "--ddl-file": "dynamic",
                        "--instance": "value",
                        "--proto-descriptors-file": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--instance": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--instance": "value"
                  }
                },
                "execute-sql": {
                  "commands": {},
                  "flags": {
                    "--database-role": "value",
                    "--enable-partitioned-dml": "bool",
                    "--instance": "value",
                    "--priority": [
                      "high",
                      "low",
                      "medium",
                      "unspecified"
                    ],
                    "--query-mode": [
                      "NORMAL",
                      "PLAN",
                      "PROFILE"
                    ],
                    "--read-timestamp": "value",
                    "--sql": "value",
                    "--strong": "bool",
                    "--timeout": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "restore": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--destination-database": "value",
                    "--destination-instance": "value",
                    "--encryption-type": [
                      "customer-managed-encryption",
                      "google-default-encryption",
                      "use-config-default-or-backup-encryption"
                    ],
                    "--kms-key": "value",
                    "--kms-keyring": "value",
                    "--kms-keys": "value",
                    "--kms-location": "value",
                    "--kms-project": "value",
                    "--source-backup": "value",
                    "--source-instance": "value"
                  }
                },
                "roles": {
                  "commands": {
                    "list": {
                      "commands": {},
                      "flags": {
                        "--database": "value",
                        "--filter": "value",
                        "--instance": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "sessions": {
                  "commands": {
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--database": "value",
                        "--instance": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--database": "value",
                        "--filter": "value",
                        "--instance": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--server-filter": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--instance": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--enable-drop-protection": "bool",
                    "--instance": "value"
                  }
                }
              },
              "flags": {}
            },
            "instance-configs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--add-replicas": "value",
                    "--async": "bool",
                    "--base-config": "value",
                    "--clone-config": "dynamic",
                    "--display-name": "value",
                    "--etag": "value",
                    "--labels": "value",
                    "--replicas": "value",
                    "--skip-replicas": "value",
                    "--validate-only": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--etag": "value",
                    "--validate-only": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--display-name": "value",
                    "--etag": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            },
            "instance-partitions": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--config": "dynamic",
                    "--description": "value",
                    "--instance": "value",
                    "--nodes": "value",
                    "--processing-units": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--instance": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--instance": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--instance": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--instance": "value",
                    "--nodes": "value",
                    "--processing-units": "value"
                  }
                }
              },
              "flags": {}
            },
            "instances": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--asymmetric-autoscaling-option": "value",
                    "--async": "bool",
                    "--autoscaling-high-priority-cpu-target": "value",
                    "--autoscaling-max-nodes": "value",
                    "--autoscaling-max-processing-units": "value",
                    "--autoscaling-min-nodes": "value",
                    "--autoscaling-min-processing-units": "value",
                    "--autoscaling-storage-target": "value",
                    "--config": "dynamic",
                    "--default-backup-schedule-type": [
                      "AUTOMATIC",
                      "DEFAULT_BACKUP_SCHEDULE_TYPE_UNSPECIFIED",
                      "NONE"
                    ],
                    "--description": "value",
                    "--edition": [
                      "EDITION_UNSPECIFIED",
                      "ENTERPRISE",
                      "ENTERPRISE_PLUS",
                      "STANDARD"
                    ],
                    "--expire-behavior": [
                      "free-to-provisioned",
                      "remove-after-grace-period"
                    ],
                    "--instance-type": [
                      "free-instance",
                      "provisioned"
                    ],
                    "--nodes": "value",
                    "--processing-units": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "get-locations": {
                  "commands": {},
                  "flags": {
                    "--verbose": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "move": {
                  "commands": {},
                  "flags": {
                    "--target-config": "dynamic",
                    "--target-database-move-configs": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--asymmetric-autoscaling-option": "value",
                    "--async": "bool",
                    "--autoscaling-high-priority-cpu-target": "value",
                    "--autoscaling-max-nodes": "value",
                    "--autoscaling-max-processing-units": "value",
                    "--autoscaling-min-nodes": "value",
                    "--autoscaling-min-processing-units": "value",
                    "--autoscaling-storage-target": "value",
                    "--clear-asymmetric-autoscaling-option": "value",
                    "--default-backup-schedule-type": [
                      "AUTOMATIC",
                      "DEFAULT_BACKUP_SCHEDULE_TYPE_UNSPECIFIED",
                      "NONE"
                    ],
                    "--description": "value",
                    "--edition": "value",
                    "--expire-behavior": [
                      "free-to-provisioned",
                      "remove-after-grace-period"
                    ],
                    "--instance-type": [
                      "free-instance",
                      "provisioned"
                    ],
                    "--nodes": "value",
                    "--processing-units": "value"
                  }
                }
              },
              "flags": {}
            },
            "migrate": {
              "commands": {
                "cleanup": {
                  "commands": {},
                  "flags": {
                    "--data-shard-ids": "value",
                    "--dataflow": "bool",
                    "--datastream": "bool",
                    "--job-id": "value",
                    "--log-level": "value",
                    "--monitoring": "bool",
                    "--pub-sub": "bool",
                    "--target-profile": "value"
                  }
                },
                "data": {
                  "commands": {},
                  "flags": {
                    "--dataflow-template": "value",
                    "--dry-run": "bool",
                    "--log-level": "value",
                    "--prefix": "value",
                    "--session": "value",
                    "--skip-foreign-keys": "bool",
                    "--source": "value",
                    "--source-profile": "value",
                    "--target": "value",
                    "--target-profile": "value",
                    "--write-limit": "value"
                  }
                },
                "schema": {
                  "commands": {},
                  "flags": {
                    "--dry-run": "bool",
                    "--log-level": "value",
                    "--prefix": "value",
                    "--source": "value",
                    "--source-profile": "value",
                    "--target": "value",
                    "--target-profile": "value"
                  }
                },
                "schema-and-data": {
                  "commands": {},
                  "flags": {
                    "--dataflow-template": "value",
                    "--dry-run": "bool",
                    "--log-level": "value",
                    "--prefix": "value",
                    "--skip-foreign-keys": "bool",
                    "--source": "value",
                    "--source-profile": "value",
                    "--target": "value",
                    "--target-profile": "value",
                    "--write-limit": "value"
                  }
                },
                "web": {
                  "commands": {},
                  "flags": {
                    "--dataflow-template": "value",
                    "--log-level": "value",
                    "--open": "bool",
                    "--port": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--backup": "dynamic",
                    "--database": "dynamic",
                    "--instance": "dynamic",
                    "--instance-config": "dynamic",
                    "--instance-partition": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--backup": "dynamic",
                    "--database": "dynamic",
                    "--instance": "dynamic",
                    "--instance-config": "dynamic",
                    "--instance-partition": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--backup": "dynamic",
                    "--database": "dynamic",
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--instance-config": "dynamic",
                    "--instance-partition": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--type": [
                      "BACKUP",
                      "DATABASE",
                      "DATABASE_CHANGE_QUORUM",
                      "DATABASE_CREATE",
                      "DATABASE_RESTORE",
                      "DATABASE_UPDATE_DDL",
                      "INSTANCE",
                      "INSTANCE_CONFIG_CREATE",
                      "INSTANCE_CONFIG_UPDATE",
                      "INSTANCE_PARTITION"
                    ],
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "rows": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--database": "value",
                    "--instance": "value",
                    "--keys": "value",
                    "--table": "value"
                  }
                },
                "insert": {
                  "commands": {},
                  "flags": {
                    "--data": "value",
                    "--database": "value",
                    "--instance": "value",
                    "--table": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--data": "value",
                    "--database": "value",
                    "--instance": "value",
                    "--table": "value"
                  }
                }
              },
              "flags": {}
            },
            "samples": {
              "commands": {
                "backend": {
                  "commands": {},
                  "flags": {
                    "--database-id": "value",
                    "--duration": "value",
                    "--instance-id": "value",
                    "--port": "value"
                  }
                },
                "init": {
                  "commands": {},
                  "flags": {
                    "--database-id": "value",
                    "--instance-id": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "run": {
                  "commands": {},
                  "flags": {
                    "--cleanup": "bool",
                    "--database-id": "value",
                    "--duration": "value",
                    "--instance-id": "value",
                    "--skip-init": "bool"
                  }
                },
                "workload": {
                  "commands": {},
                  "flags": {
                    "--duration": "value",
                    "--port": "value",
                    "--target-qps": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "sql": {
          "commands": {
            "backups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--instance": "dynamic",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--instance": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "restore": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--backup-instance": "dynamic",
                    "--backup-project": "value",
                    "--restore-instance": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "connect": {
              "commands": {},
              "flags": {
                "--database": "value",
                "--port": "value",
                "--user": "value"
              }
            },
            "databases": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--instance": "value",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--charset": "value",
                    "--collation": "value",
                    "--instance": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "patch": {
                  "commands": {},
                  "flags": {
                    "--charset": "value",
                    "--collation": "value",
                    "--diff": "bool",
                    "--instance": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "export": {
              "commands": {
                "bak": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--bak-type": [
                      "DIFF",
                      "FULL",
                      "TLOG"
                    ],
                    "--database": "value",
                    "--differential-base": "bool",
                    "--export-log-end-time": "value",
                    "--export-log-start-time": "value",
                    "--stripe_count": "value",
                    "--striped": "bool"
                  }
                },
                "csv": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--database": "value",
                    "--escape": "value",
                    "--fields-terminated-by": "value",
                    "--lines-terminated-by": "value",
                    "--offload": "bool",
                    "--query": "value",
                    "--quote": "value"
                  }
                },
                "sql": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clean": "bool",
                    "--database": "value",
                    "--if-exists": "bool",
                    "--offload": "bool",
                    "--parallel": "bool",
                    "--table": "value",
                    "--threads": "value"
                  }
                }
              },
              "flags": {}
            },
            "flags": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--database-version": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "generate-login-token": {
              "commands": {},
              "flags": {
                "--application-default-credential": "bool",
                "--instance": "dynamic"
              }
            },
            "import": {
              "commands": {
                "bak": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--bak-type": [
                      "DIFF",
                      "FULL",
                      "TLOG"
                    ],
                    "--cert-path": "value",
                    "--database": "value",
                    "--no-recovery": "bool",
                    "--prompt-for-pvk-password": "bool",
                    "--pvk-password": "value",
                    "--pvk-path": "value",
                    "--recovery-only": "bool",
                    "--stop-at": "value",
                    "--stop-at-mark": "value",
                    "--striped": "bool"
                  }
                },
                "csv": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--columns": "value",
                    "--database": "value",
                    "--escape": "value",
                    "--fields-terminated-by": "value",
                    "--lines-terminated-by": "value",
                    "--quote": "value",
                    "--table": "value",
                    "--user": "value"
                  }
                },
                "sql": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clean": "bool",
                    "--database": "value",
                    "--if-exists": "bool",
                    "--parallel": "bool",
                    "--threads": "value",
                    "--user": "value"
                  }
                }
              },
              "flags": {}
            },
            "instances": {
              "commands": {
                "clone": {
                  "commands": {},
                  "flags": {
                    "--allocated-ip-range-name": "value",
                    "--async": "bool",
                    "--bin-log-file-name": "value",
                    "--bin-log-position": "value",
                    "--point-in-time": "value",
                    "--preferred-secondary-zone": "value",
                    "--preferred-zone": "value",
                    "--restore-database-name": "value"
                  }
                },
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--activation-policy": [
                      "always",
                      "never"
                    ],
                    "--active-directory-domain": "value",
                    "--allocated-ip-range-name": "value",
                    "--allowed-psc-projects": "value",
                    "--assign-ip": "bool",
                    "--async": "bool",
                    "--audit-bucket-path": "value",
                    "--audit-retention-interval": "value",
                    "--audit-upload-interval": "value",
                    "--authorized-networks": "value",
                    "--availability-type": [
                      "regional",
                      "zonal"
                    ],
                    "--backup": "bool",
                    "--backup-location": "value",
                    "--backup-start-time": "value",
                    "--cascadable-replica": "bool",
                    "--client-certificate-path": "value",
                    "--client-key-path": "value",
                    "--collation": "value",
                    "--connector-enforcement": [
                      "CONNECTOR_ENFORCEMENT_UNSPECIFIED",
                      "NOT_REQUIRED",
                      "REQUIRED"
                    ],
                    "--cpu": "value",
                    "--database-flags": "value",
                    "--database-version": "value",
                    "--deletion-protection": "bool",
                    "--deny-maintenance-period-end-date": "value",
                    "--deny-maintenance-period-start-date": "value",
                    "--deny-maintenance-period-time": "value",
                    "--disk-encryption-key": "dynamic",
                    "--disk-encryption-key-keyring": "dynamic",
                    "--disk-encryption-key-location": "dynamic",
                    "--disk-encryption-key-project": "dynamic",
                    "--edition": [
                      "enterprise",
                      "enterprise-plus"
                    ],
                    "--enable-bin-log": "bool",
                    "--enable-data-cache": "bool",
                    "--enable-dataplex-integration": "bool",
                    "--enable-google-ml-integration": "bool",
                    "--enable-google-private-path": "bool",
                    "--enable-password-policy": "bool",
                    "--enable-point-in-time-recovery": "bool",
                    "--enable-private-service-connect": "bool",
                    "--failover-replica-name": "value",
                    "--gce-zone": "value",
                    "--insights-config-query-insights-enabled": "bool",
                    "--insights-config-query-plans-per-minute": "value",
                    "--insights-config-query-string-length": "value",
                    "--insights-config-record-application-tags": "bool",
                    "--insights-config-record-client-address": "bool",
                    "--labels": "value",
                    "--maintenance-release-channel": [
                      "preview",
                      "production",
                      "week5"
                    ],
                    "--maintenance-window-day": [
                      "FRI",
                      "MON",
                      "SAT",
                      "SUN",
                      "THU",
                      "TUE",
                      "WED"
                    ],
                    "--maintenance-window-hour": "value",
                    "--master-ca-certificate-path": "value",
                    "--master-dump-file-path": "value",
                    "--master-instance-name": "value",
                    "--master-password": "value",
                    "--master-username": "value",
                    "--memory": "value",
                    "--network": "value",
                    "--password-policy-complexity": [
                      "COMPLEXITY_DEFAULT",
                      "COMPLEXITY_UNSPECIFIED"
                    ],
                    "--password-policy-disallow-username-substring": "bool",
                    "--password-policy-min-length": "value",
                    "--password-policy-password-change-interval": "value",
                    "--password-policy-reuse-interval": "value",
                    "--prompt-for-master-password": "bool",
                    "--psc-auto-connections": "value",
                    "--recreate-replicas-on-primary-crash": "bool",
                    "--region": "value",
                    "--replica-type": [
                      "FAILOVER",
                      "READ"
                    ],
                    "--replication": [
                      "asynchronous",
                      "synchronous"
                    ],
                    "--replication-lag-max-seconds-for-recreate": "value",
                    "--require-ssl": "bool",
                    "--retained-backups-count": "value",
                    "--retained-transaction-log-days": "value",
                    "--root-password": "value",
                    "--secondary-zone": "value",
                    "--server-ca-mode": [
                      "CUSTOMER_MANAGED_CAS_CA",
                      "GOOGLE_MANAGED_CAS_CA",
                      "GOOGLE_MANAGED_INTERNAL_CA"
                    ],
                    "--server-ca-pool": "value",
                    "--source-ip-address": "value",
                    "--source-port": "value",
                    "--ssl-mode": [
                      "ALLOW_UNENCRYPTED_AND_ENCRYPTED",
                      "ENCRYPTED_ONLY",
                      "TRUSTED_CLIENT_CERTIFICATE_REQUIRED"
                    ],
                    "--storage-auto-increase": "bool",
                    "--storage-auto-increase-limit": "value",
                    "--storage-size": "value",
                    "--storage-type": [
                      "HDD",
                      "SSD"
                    ],
                    "--threads-per-core": "value",
                    "--tier": "value",
                    "--time-zone": "value",
                    "--timeout": "value",
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--database": "value",
                    "--table": "value"
                  }
                },
                "failover": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "get-latest-recovery-time": {
                  "commands": {},
                  "flags": {}
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--database": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--show-edition": "bool",
                    "--show-sql-network-architecture": "bool",
                    "--show-transactional-log-storage-state": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "patch": {
                  "commands": {},
                  "flags": {
                    "--activation-policy": [
                      "always",
                      "never"
                    ],
                    "--active-directory-domain": "value",
                    "--allocated-ip-range-name": "value",
                    "--allowed-psc-projects": "value",
                    "--assign-ip": "bool",
                    "--async": "bool",
                    "--audit-bucket-path": "value",
                    "--audit-retention-interval": "value",
                    "--audit-upload-interval": "value",
                    "--authorized-gae-apps": "value",
                    "--authorized-networks": "value",
                    "--availability-type": [
                      "regional",
                      "zonal"
                    ],
                    "--backup-location": "value",
                    "--backup-start-time": "value",
                    "--clear-allowed-psc-projects": "bool",
                    "--clear-authorized-networks": "bool",
                    "--clear-database-flags": "bool",
                    "--clear-failover-dr-replica-name": "bool",
                    "--clear-gae-apps": "bool",
                    "--clear-labels": "bool",
                    "--clear-password-policy": "bool",
                    "--clear-psc-auto-connections": "bool",
                    "--connector-enforcement": [
                      "CONNECTOR_ENFORCEMENT_UNSPECIFIED",
                      "NOT_REQUIRED",
                      "REQUIRED"
                    ],
                    "--cpu": "value",
                    "--database-flags": "value",
                    "--database-version": "value",
                    "--deletion-protection": "bool",
                    "--deny-maintenance-period-end-date": "value",
                    "--deny-maintenance-period-start-date": "value",
                    "--deny-maintenance-period-time": "value",
                    "--diff": "bool",
                    "--edition": [
                      "enterprise",
                      "enterprise-plus"
                    ],
                    "--enable-bin-log": "bool",
                    "--enable-data-cache": "bool",
                    "--enable-database-replication": "bool",
                    "--enable-dataplex-integration": "bool",
                    "--enable-google-ml-integration": "bool",
                    "--enable-google-private-path": "bool",
                    "--enable-password-policy": "bool",
                    "--enable-point-in-time-recovery": "bool",
                    "--enable-private-service-connect": "bool",
                    "--failover-dr-replica-name": "value",
                    "--follow-gae-app": "value",
                    "--gce-zone": "value",
                    "--insights-config-query-insights-enabled": "bool",
                    "--insights-config-query-plans-per-minute": "value",
                    "--insights-config-query-string-length": "value",
                    "--insights-config-record-application-tags": "bool",
                    "--insights-config-record-client-address": "bool",
                    "--maintenance-release-channel": [
                      "preview",
                      "production",
                      "week5"
                    ],
                    "--maintenance-version": "value",
                    "--maintenance-window-any": "bool",
                    "--maintenance-window-day": [
                      "FRI",
                      "MON",
                      "SAT",
                      "SUN",
                      "THU",
                      "TUE",
                      "WED"
                    ],
                    "--maintenance-window-hour": "value",
                    "--memory": "value",
                    "--network": "value",
                    "--no-backup": "bool",
                    "--password-policy-complexity": [
                      "COMPLEXITY_DEFAULT",
                      "COMPLEXITY_UNSPECIFIED"
                    ],
                    "--password-policy-disallow-username-substring": "bool",
                    "--password-policy-min-length": "value",
                    "--password-policy-password-change-interval": "value",
                    "--password-policy-reuse-interval": "value",
                    "--pricing-plan": [
                      "PACKAGE",
                      "PER_USE"
                    ],
                    "--psc-auto-connections": "value",
                    "--recreate-replicas-on-primary-crash": "bool",
                    "--remove-deny-maintenance-period": "bool",
                    "--remove-labels": "value",
                    "--replication": [
                      "asynchronous",
                      "synchronous"
                    ],
                    "--replication-lag-max-seconds-for-recreate": "value",
                    "--require-ssl": "bool",
                    "--retained-backups-count": "value",
                    "--retained-transaction-log-days": "value",
                    "--secondary-zone": "value",
                    "--simulate-maintenance-event": "bool",
                    "--ssl-mode": [
                      "ALLOW_UNENCRYPTED_AND_ENCRYPTED",
                      "ENCRYPTED_ONLY",
                      "TRUSTED_CLIENT_CERTIFICATE_REQUIRED"
                    ],
                    "--storage-auto-increase": "bool",
                    "--storage-auto-increase-limit": "value",
                    "--storage-size": "value",
                    "--switch-transaction-logs-to-cloud-storage": "bool",
                    "--threads-per-core": "value",
                    "--tier": "value",
                    "--time-zone": "value",
                    "--update-labels": "value",
                    "--upgrade-sql-network-architecture": "bool",
                    "--zone": "value"
                  }
                },
                "promote-replica": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--failover": "bool"
                  }
                },
                "reencrypt": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "reset-ssl-config": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "restart": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "restore-backup": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--backup-id": "value",
                    "--backup-instance": "dynamic"
                  }
                },
                "switchover": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--db-timeout": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--timeout": "value"
                  }
                }
              },
              "flags": {}
            },
            "reschedule-maintenance": {
              "commands": {},
              "flags": {
                "--reschedule-type": [
                  "IMMEDIATE",
                  "NEXT_AVAILABLE_WINDOW",
                  "SPECIFIC_TIME"
                ],
                "--schedule-time": "value"
              }
            },
            "ssl": {
              "commands": {
                "client-certs": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--instance": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--instance": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--instance": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--instance": "dynamic",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "server-ca-certs": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--instance": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--instance": "dynamic",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "rollback": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--instance": "dynamic"
                      }
                    },
                    "rotate": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--instance": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "server-certs": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--instance": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--instance": "dynamic",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "rollback": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--instance": "dynamic"
                      }
                    },
                    "rotate": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--instance": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "ssl-certs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--instance": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "tiers": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--show-edition": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "users": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--host": "value",
                    "--instance": "dynamic",
                    "--password": "value",
                    "--password-policy-allowed-failed-attempts": "value",
                    "--password-policy-enable-failed-attempts-check": "bool",
                    "--password-policy-enable-password-verification": "bool",
                    "--password-policy-password-expiration-duration": "value",
                    "--type": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--host": "value",
                    "--instance": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--host": "value",
                    "--instance": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "set-password": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--discard-dual-password": "bool",
                    "--host": "value",
                    "--instance": "dynamic",
                    "--password": "value",
                    "--prompt-for-password": "bool",
                    "--retain-password": "bool"
                  }
                },
                "set-password-policy": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-password-policy": "bool",
                    "--host": "value",
                    "--instance": "dynamic",
                    "--password-policy-allowed-failed-attempts": "value",
                    "--password-policy-enable-failed-attempts-check": "bool",
                    "--password-policy-enable-password-verification": "bool",
                    "--password-policy-password-expiration-duration": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "storage": {
          "commands": {
            "batch-operations": {
              "commands": {
                "jobs": {
                  "commands": {
                    "cancel": {
                      "commands": {},
                      "flags": {}
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--bucket": "value",
                        "--delete-object": "bool",
                        "--description": "value",
                        "--enable-permanent-object-deletion": "bool",
                        "--included-object-prefixes": "value",
                        "--manifest-location": "value",
                        "--put-kms-key": "value",
                        "--put-metadata": "value",
                        "--put-object-event-based-hold": "bool",
                        "--put-object-temporary-hold": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {}
                    },
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "buckets": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "anywhere-caches": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--admission-policy": [
                          "ADMIT_ON_FIRST_MISS",
                          "ADMIT_ON_SECOND_MISS"
                        ],
                        "--ttl": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--raw": "bool"
                      }
                    },
                    "disable": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--raw": "bool",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "pause": {
                      "commands": {},
                      "flags": {}
                    },
                    "resume": {
                      "commands": {},
                      "flags": {}
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--admission-policy": [
                          "ADMIT_ON_FIRST_MISS",
                          "ADMIT_ON_SECOND_MISS"
                        ],
                        "--ttl": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--additional-headers": "value",
                    "--autoclass-terminal-storage-class": "value",
                    "--default-encryption-key": "value",
                    "--default-storage-class": "value",
                    "--enable-autoclass": "bool",
                    "--enable-hierarchical-namespace": "bool",
                    "--enable-per-object-retention": "bool",
                    "--ip-filter-file": "value",
                    "--location": "value",
                    "--pap": "bool",
                    "--placement": "value",
                    "--public-access-prevention": "bool",
                    "--recovery-point-objective": [
                      "ASYNC_TURBO",
                      "DEFAULT"
                    ],
                    "--retention-period": "value",
                    "--rpo": [
                      "ASYNC_TURBO",
                      "DEFAULT"
                    ],
                    "--soft-delete-duration": "value",
                    "--uniform-bucket-level-access": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--additional-headers": "value",
                    "--continue-on-error": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--additional-headers": "value",
                    "--raw": "bool",
                    "--soft-deleted": "bool"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--additional-headers": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--raw": "bool",
                    "--soft-deleted": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "notifications": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--custom-attributes": "value",
                        "--event-types": "value",
                        "--object-prefix": "value",
                        "--payload-format": [
                          "json",
                          "none"
                        ],
                        "--skip-topic-setup": "bool",
                        "--topic": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {}
                    },
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "relocate": {
                  "commands": {},
                  "flags": {
                    "--dry-run": "bool",
                    "--finalize": "bool",
                    "--location": "value",
                    "--operation": "value",
                    "--placement": "value",
                    "--ttl": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--continue-on-error": "bool",
                    "--etag": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--acl-file": "value",
                    "--add-acl-grant": "value",
                    "--add-default-object-acl-grant": "value",
                    "--additional-headers": "value",
                    "--autoclass-terminal-storage-class": "value",
                    "--canned-acl": "value",
                    "--clear-cors": "bool",
                    "--clear-default-encryption-key": "bool",
                    "--clear-ip-filter": "bool",
                    "--clear-labels": "bool",
                    "--clear-lifecycle": "bool",
                    "--clear-log-bucket": "bool",
                    "--clear-log-object-prefix": "bool",
                    "--clear-pap": "bool",
                    "--clear-public-access-prevention": "bool",
                    "--clear-retention-period": "bool",
                    "--clear-soft-delete": "bool",
                    "--clear-web-error-page": "bool",
                    "--clear-web-main-page-suffix": "bool",
                    "--continue-on-error": "bool",
                    "--cors-file": "value",
                    "--default-encryption-key": "value",
                    "--default-event-based-hold": "bool",
                    "--default-object-acl-file": "value",
                    "--default-storage-class": "value",
                    "--enable-autoclass": "bool",
                    "--ip-filter-file": "value",
                    "--labels-file": "value",
                    "--lifecycle-file": "value",
                    "--lock-retention-period": "bool",
                    "--log-bucket": "value",
                    "--log-object-prefix": "value",
                    "--pap": "bool",
                    "--predefined-acl": "value",
                    "--predefined-default-object-acl": "value",
                    "--public-access-prevention": "bool",
                    "--read-paths-from-stdin": "bool",
                    "--recovery-point-objective": [
                      "ASYNC_TURBO",
                      "DEFAULT"
                    ],
                    "--remove-acl-grant": "value",
                    "--remove-default-object-acl-grant": "value",
                    "--remove-labels": "value",
                    "--requester-pays": "bool",
                    "--retention-period": "value",
                    "--rpo": [
                      "ASYNC_TURBO",
                      "DEFAULT"
                    ],
                    "--soft-delete-duration": "value",
                    "--uniform-bucket-level-access": "bool",
                    "--update-labels": "value",
                    "--versioning": "bool",
                    "--web-error-page": "value",
                    "--web-main-page-suffix": "value"
                  }
                }
              },
              "flags": {}
            },
            "cat": {
              "commands": {},
              "flags": {
                "--additional-headers": "value",
                "--decryption-keys": "value",
                "--display-url": "bool",
                "--range": "value"
              }
            },
            "cp": {
              "commands": {},
              "flags": {
                "--additional-headers": "value",
                "--all-versions": "bool",
                "--cache-control": "value",
                "--canned-acl": "value",
                "--clear-custom-metadata": "bool",
                "--content-disposition": "value",
                "--content-encoding": "value",
                "--content-language": "value",
                "--content-md5": "value",
                "--content-type": "value",
                "--continue-on-error": "bool",
                "--custom-metadata": "value",
                "--custom-time": "value",
                "--daisy-chain": "bool",
                "--decryption-keys": "value",
                "--do-not-decompress": "bool",
                "--encryption-key": "value",
                "--gzip-in-flight": "value",
                "--gzip-in-flight-all": "bool",
                "--gzip-local": "value",
                "--gzip-local-all": "bool",
                "--if-generation-match": "value",
                "--if-metageneration-match": "value",
                "--ignore-symlinks": "bool",
                "--include-managed-folders": "bool",
                "--manifest-path": "value",
                "--no-clobber": "bool",
                "--predefined-acl": "value",
                "--preserve-acl": "bool",
                "--preserve-posix": "bool",
                "--preserve-symlinks": "bool",
                "--print-created-message": "bool",
                "--read-paths-from-stdin": "bool",
                "--recursive": "bool",
                "--remove-custom-metadata": "value",
                "--retain-until": "value",
                "--retention-mode": [
                  "Locked",
                  "Unlocked"
                ],
                "--skip-unsupported": "bool",
                "--storage-class": "value",
                "--update-custom-metadata": "value"
              }
            },
            "diagnose": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--download-type": [
                  "FILE",
                  "SLICED",
                  "STREAMING"
                ],
                "--export": "bool",
                "--logs-path": "value",
                "--object-count": "value",
                "--object-size": "value",
                "--object-sizes": "value",
                "--process-count": "value",
                "--test-type": "value",
                "--thread-count": "value",
                "--upload-type": [
                  "FILE",
                  "PARALLEL_COMPOSITE",
                  "STREAMING"
                ]
              }
            },
            "du": {
              "commands": {},
              "flags": {
                "--additional-headers": "value",
                "--all-versions": "bool",
                "--exclude-name-pattern": "value",
                "--exclude-name-pattern-file": "value",
                "--readable-sizes": "bool",
                "--summarize": "bool",
                "--total": "bool",
                "--zero-terminator": "bool"
              }
            },
            "folders": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--additional-headers": "value",
                    "--recursive": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--additional-headers": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--additional-headers": "value",
                    "--raw": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--additional-headers": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--raw": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "hash": {
              "commands": {},
              "flags": {
                "--additional-headers": "value",
                "--decryption-keys": "value",
                "--hex": "bool",
                "--skip-crc32c": "bool",
                "--skip-md5": "bool"
              }
            },
            "hmac": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--filter": "value",
                    "--limit": "value",
                    "--long": "bool",
                    "--page-size": "value",
                    "--service-account": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--activate": "bool",
                    "--deactivate": "bool",
                    "--etag": "value"
                  }
                }
              },
              "flags": {}
            },
            "insights": {
              "commands": {
                "dataset-configs": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--auto-add-new-buckets": "bool",
                        "--description": "value",
                        "--exclude-bucket-names": "value",
                        "--exclude-bucket-prefix-regexes": "value",
                        "--exclude-source-locations": "value",
                        "--identity": [
                          "IDENTITY_TYPE_PER_CONFIG",
                          "IDENTITY_TYPE_PER_PROJECT"
                        ],
                        "--include-bucket-names": "value",
                        "--include-bucket-prefix-regexes": "value",
                        "--include-source-locations": "value",
                        "--location": "value",
                        "--organization": "value",
                        "--retention-period-days": "value",
                        "--source-projects": "value",
                        "--source-projects-file": "value"
                      }
                    },
                    "create-link": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--auto-delete-link": "bool",
                        "--force": "bool",
                        "--location": "value"
                      }
                    },
                    "delete-link": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--description": "value",
                        "--location": "value",
                        "--retention-period-days": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "inventory-reports": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--csv-delimiter": "value",
                        "--csv-header": "bool",
                        "--csv-separator": [
                          "\\n",
                          "\\r\\n"
                        ],
                        "--destination": "value",
                        "--display-name": "value",
                        "--metadata-fields": "value",
                        "--parquet": "bool",
                        "--schedule-repeats": [
                          "daily",
                          "weekly"
                        ],
                        "--schedule-repeats-until": "value",
                        "--schedule-starts": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--force": "bool",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "details": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--report-config": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--location": "value",
                            "--page-size": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--source": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--add-metadata-fields": "value",
                        "--csv-delimiter": "value",
                        "--csv-header": "bool",
                        "--csv-separator": [
                          "\\n",
                          "\\r\\n"
                        ],
                        "--destination": "value",
                        "--display-name": "value",
                        "--location": "value",
                        "--metadata-fields": "value",
                        "--parquet": "bool",
                        "--remove-metadata-fields": "value",
                        "--schedule-repeats": [
                          "daily",
                          "weekly"
                        ],
                        "--schedule-repeats-until": "value",
                        "--schedule-starts": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "operations": {
                  "commands": {
                    "cancel": {
                      "commands": {},
                      "flags": {}
                    },
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "ls": {
              "commands": {},
              "flags": {
                "--additional-headers": "value",
                "--all-versions": "bool",
                "--buckets": "bool",
                "--decryption-keys": "value",
                "--etag": "bool",
                "--exhaustive": "bool",
                "--fetch-encrypted-object-hashes": "bool",
                "--full": "bool",
                "--json": "bool",
                "--long": "bool",
                "--next-page-token": "value",
                "--read-paths-from-stdin": "bool",
                "--readable-sizes": "bool",
                "--recursive": "bool",
                "--soft-deleted": "bool"
              }
            },
            "managed-folders": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--additional-headers": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--additional-headers": "value",
                    "--continue-on-error": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--additional-headers": "value",
                    "--raw": "bool"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--additional-headers": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--raw": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--continue-on-error": "bool",
                    "--etag": "value"
                  }
                }
              },
              "flags": {}
            },
            "management-hub": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--organization": "value",
                    "--sub-folder": "value"
                  }
                },
                "disable": {
                  "commands": {},
                  "flags": {
                    "--organization": "value",
                    "--sub-folder": "value"
                  }
                },
                "enable": {
                  "commands": {},
                  "flags": {
                    "--exclude-bucket-id-regexes": "value",
                    "--exclude-bucket-ids": "value",
                    "--exclude-locations": "value",
                    "--include-bucket-id-regexes": "value",
                    "--include-bucket-ids": "value",
                    "--include-locations": "value",
                    "--organization": "value",
                    "--sub-folder": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--exclude-bucket-id-regexes": "value",
                    "--exclude-bucket-ids": "value",
                    "--exclude-locations": "value",
                    "--include-bucket-id-regexes": "value",
                    "--include-bucket-ids": "value",
                    "--include-locations": "value",
                    "--inherit-from-parent": "bool",
                    "--organization": "value",
                    "--sub-folder": "value"
                  }
                }
              },
              "flags": {}
            },
            "mv": {
              "commands": {},
              "flags": {
                "--additional-headers": "value",
                "--all-versions": "bool",
                "--cache-control": "value",
                "--canned-acl": "value",
                "--clear-custom-metadata": "bool",
                "--content-disposition": "value",
                "--content-encoding": "value",
                "--content-language": "value",
                "--content-md5": "value",
                "--content-type": "value",
                "--continue-on-error": "bool",
                "--custom-metadata": "value",
                "--custom-time": "value",
                "--daisy-chain": "bool",
                "--decryption-keys": "value",
                "--do-not-decompress": "bool",
                "--encryption-key": "value",
                "--gzip-in-flight": "value",
                "--gzip-in-flight-all": "bool",
                "--gzip-local": "value",
                "--gzip-local-all": "bool",
                "--if-generation-match": "value",
                "--if-metageneration-match": "value",
                "--ignore-symlinks": "bool",
                "--include-managed-folders": "bool",
                "--manifest-path": "value",
                "--no-clobber": "bool",
                "--predefined-acl": "value",
                "--preserve-acl": "bool",
                "--preserve-posix": "bool",
                "--preserve-symlinks": "bool",
                "--print-created-message": "bool",
                "--read-paths-from-stdin": "bool",
                "--remove-custom-metadata": "value",
                "--retain-until": "value",
                "--retention-mode": [
                  "Locked",
                  "Unlocked"
                ],
                "--skip-unsupported": "bool",
                "--storage-class": "value",
                "--update-custom-metadata": "value"
              }
            },
            "objects": {
              "commands": {
                "compose": {
                  "commands": {},
                  "flags": {
                    "--additional-headers": "value",
                    "--if-generation-match": "value",
                    "--if-metageneration-match": "value",
                    "--retain-until": "value",
                    "--retention-mode": [
                      "Locked",
                      "Unlocked"
                    ]
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--additional-headers": "value",
                    "--decryption-keys": "value",
                    "--fetch-encrypted-object-hashes": "bool",
                    "--raw": "bool",
                    "--soft-deleted": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--additional-headers": "value",
                    "--decryption-keys": "value",
                    "--exhaustive": "bool",
                    "--fetch-encrypted-object-hashes": "bool",
                    "--filter": "value",
                    "--limit": "value",
                    "--next-page-token": "value",
                    "--page-size": "value",
                    "--raw": "bool",
                    "--soft-deleted": "bool",
                    "--sort-by": "value",
                    "--stat": "bool",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--acl-file": "value",
                    "--add-acl-grant": "value",
                    "--additional-headers": "value",
                    "--all-versions": "bool",
                    "--cache-control": "value",
                    "--canned-acl": "value",
                    "--clear-cache-control": "bool",
                    "--clear-content-disposition": "bool",
                    "--clear-content-encoding": "bool",
                    "--clear-content-language": "bool",
                    "--clear-content-type": "bool",
                    "--clear-custom-metadata": "bool",
                    "--clear-custom-time": "bool",
                    "--clear-encryption-key": "bool",
                    "--clear-retention": "bool",
                    "--content-disposition": "value",
                    "--content-encoding": "value",
                    "--content-language": "value",
                    "--content-type": "value",
                    "--continue-on-error": "bool",
                    "--custom-metadata": "value",
                    "--custom-time": "value",
                    "--decryption-keys": "value",
                    "--encryption-key": "value",
                    "--event-based-hold": "bool",
                    "--if-generation-match": "value",
                    "--if-metageneration-match": "value",
                    "--override-unlocked-retention": "bool",
                    "--predefined-acl": "value",
                    "--preserve-acl": "bool",
                    "--read-paths-from-stdin": "bool",
                    "--recursive": "bool",
                    "--remove-acl-grant": "value",
                    "--remove-custom-metadata": "value",
                    "--retain-until": "value",
                    "--retention-mode": [
                      "Locked",
                      "Unlocked"
                    ],
                    "--storage-class": "value",
                    "--temporary-hold": "bool",
                    "--update-custom-metadata": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--server-filter": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "restore": {
              "commands": {},
              "flags": {
                "--all-versions": "bool",
                "--allow-overwrite": "bool",
                "--async": "bool",
                "--deleted-after-time": "value",
                "--deleted-before-time": "value",
                "--if-generation-match": "value",
                "--if-metageneration-match": "value",
                "--preserve-acl": "bool",
                "--read-paths-from-stdin": "bool"
              }
            },
            "rm": {
              "commands": {},
              "flags": {
                "--additional-headers": "value",
                "--all-versions": "bool",
                "--continue-on-error": "bool",
                "--exclude-managed-folders": "bool",
                "--if-generation-match": "value",
                "--if-metageneration-match": "value",
                "--read-paths-from-stdin": "bool",
                "--recursive": "bool"
              }
            },
            "rsync": {
              "commands": {},
              "flags": {
                "--additional-headers": "value",
                "--cache-control": "value",
                "--canned-acl": "value",
                "--checksums-only": "bool",
                "--clear-custom-metadata": "bool",
                "--content-disposition": "value",
                "--content-encoding": "value",
                "--content-language": "value",
                "--content-md5": "value",
                "--content-type": "value",
                "--continue-on-error": "bool",
                "--custom-metadata": "value",
                "--custom-time": "value",
                "--decryption-keys": "value",
                "--delete-unmatched-destination-objects": "bool",
                "--dry-run": "bool",
                "--encryption-key": "value",
                "--exclude": "value",
                "--gzip-in-flight": "value",
                "--gzip-in-flight-all": "bool",
                "--if-generation-match": "value",
                "--if-metageneration-match": "value",
                "--ignore-symlinks": "bool",
                "--include-managed-folders": "bool",
                "--no-clobber": "bool",
                "--predefined-acl": "value",
                "--preserve-posix": "bool",
                "--recursive": "bool",
                "--remove-custom-metadata": "value",
                "--skip-if-dest-has-newer-mtime": "bool",
                "--skip-unsupported": "bool",
                "--update-custom-metadata": "value"
              }
            },
            "service-agent": {
              "commands": {},
              "flags": {
                "--authorize-cmek": "value"
              }
            },
            "sign-url": {
              "commands": {},
              "flags": {
                "--duration": "value",
                "--headers": "value",
                "--http-verb": "value",
                "--private-key-file": "value",
                "--private-key-password": "value",
                "--query-params": "value",
                "--region": "value"
              }
            }
          },
          "flags": {}
        },
        "survey": {
          "commands": {},
          "flags": {}
        },
        "tasks": {
          "commands": {
            "acknowledge": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--queue": "value",
                "--schedule-time": "value"
              }
            },
            "buffer": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--queue": "value",
                "--task-id": "value"
              }
            },
            "cancel-lease": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--queue": "value",
                "--schedule-time": "value"
              }
            },
            "cmek-config": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-kms-key": "bool",
                    "--kms-key-name": "value",
                    "--kms-keyring": "value",
                    "--kms-project": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "create-app-engine-task": {
              "commands": {},
              "flags": {
                "--header": "value",
                "--location": "value",
                "--method": "value",
                "--payload-content": "value",
                "--payload-file": "value",
                "--queue": "value",
                "--routing": "value",
                "--schedule-time": "value",
                "--url": "value"
              }
            },
            "create-http-task": {
              "commands": {},
              "flags": {
                "--body-content": "value",
                "--body-file": "value",
                "--header": "value",
                "--location": "value",
                "--method": "value",
                "--oauth-service-account-email": "value",
                "--oauth-token-scope": "value",
                "--oidc-service-account-email": "value",
                "--oidc-token-audience": "value",
                "--queue": "value",
                "--schedule-time": "value",
                "--url": "value"
              }
            },
            "create-pull-task": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--payload-content": "value",
                "--payload-file": "value",
                "--queue": "value",
                "--schedule-time": "value",
                "--tag": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--queue": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--queue": "value",
                "--response-view": [
                  "basic",
                  "full",
                  "view-unspecified"
                ]
              }
            },
            "lease": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--lease-duration": "value",
                "--limit": "value",
                "--location": "value",
                "--oldest-tag": "bool",
                "--queue": "value",
                "--sort-by": "value",
                "--tag": "value",
                "--uri": "bool"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--queue": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "queues": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--http-header-override": "value",
                    "--http-method-override": "value",
                    "--http-oauth-service-account-email-override": "value",
                    "--http-oauth-token-scope-override": "value",
                    "--http-oidc-service-account-email-override": "value",
                    "--http-oidc-token-audience-override": "value",
                    "--http-uri-override": "value",
                    "--location": "value",
                    "--max-attempts": "value",
                    "--max-backoff": "value",
                    "--max-concurrent-tasks": "value",
                    "--max-doublings": "value",
                    "--max-retry-duration": "value",
                    "--max-tasks-dispatched-per-second": "value",
                    "--min-backoff": "value",
                    "--routing-override": "value"
                  }
                },
                "create-app-engine-queue": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--max-attempts": "value",
                    "--max-backoff": "value",
                    "--max-concurrent-tasks": "value",
                    "--max-doublings": "value",
                    "--max-retry-duration": "value",
                    "--max-tasks-dispatched-per-second": "value",
                    "--min-backoff": "value",
                    "--routing-override": "value"
                  }
                },
                "create-pull-queue": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--max-attempts": "value",
                    "--max-retry-duration": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "pause": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "purge": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "resume": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-http-header-override": "bool",
                    "--clear-http-method-override": "bool",
                    "--clear-http-oauth-service-account-email-override": "bool",
                    "--clear-http-oauth-token-scope-override": "bool",
                    "--clear-http-oidc-service-account-email-override": "bool",
                    "--clear-http-oidc-token-audience-override": "bool",
                    "--clear-http-uri-override": "bool",
                    "--clear-max-attempts": "bool",
                    "--clear-max-backoff": "bool",
                    "--clear-max-concurrent-tasks": "bool",
                    "--clear-max-doublings": "bool",
                    "--clear-max-retry-duration": "bool",
                    "--clear-max-tasks-dispatched-per-second": "bool",
                    "--clear-min-backoff": "bool",
                    "--clear-routing-override": "bool",
                    "--http-header-override": "value",
                    "--http-method-override": "value",
                    "--http-oauth-service-account-email-override": "value",
                    "--http-oauth-token-scope-override": "value",
                    "--http-oidc-service-account-email-override": "value",
                    "--http-oidc-token-audience-override": "value",
                    "--http-uri-override": "value",
                    "--location": "value",
                    "--max-attempts": "value",
                    "--max-backoff": "value",
                    "--max-concurrent-tasks": "value",
                    "--max-doublings": "value",
                    "--max-retry-duration": "value",
                    "--max-tasks-dispatched-per-second": "value",
                    "--min-backoff": "value",
                    "--routing-override": "value"
                  }
                },
                "update-app-engine-queue": {
                  "commands": {},
                  "flags": {
                    "--clear-max-attempts": "bool",
                    "--clear-max-backoff": "bool",
                    "--clear-max-concurrent-tasks": "bool",
                    "--clear-max-doublings": "bool",
                    "--clear-max-retry-duration": "bool",
                    "--clear-max-tasks-dispatched-per-second": "bool",
                    "--clear-min-backoff": "bool",
                    "--clear-routing-override": "bool",
                    "--location": "value",
                    "--max-attempts": "value",
                    "--max-backoff": "value",
                    "--max-concurrent-tasks": "value",
                    "--max-doublings": "value",
                    "--max-retry-duration": "value",
                    "--max-tasks-dispatched-per-second": "value",
                    "--min-backoff": "value",
                    "--routing-override": "value"
                  }
                },
                "update-pull-queue": {
                  "commands": {},
                  "flags": {
                    "--clear-max-attempts": "bool",
                    "--clear-max-retry-duration": "bool",
                    "--location": "value",
                    "--max-attempts": "value",
                    "--max-retry-duration": "value"
                  }
                }
              },
              "flags": {}
            },
            "renew-lease": {
              "commands": {},
              "flags": {
                "--lease-duration": "value",
                "--location": "value",
                "--queue": "value",
                "--schedule-time": "value"
              }
            },
            "run": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--queue": "value"
              }
            }
          },
          "flags": {}
        },
        "telco-automation": {
          "commands": {
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "orchestration-cluster": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cidr-blocks": "value",
                    "--cluster-cidr-block": "value",
                    "--cluster-named-range": "value",
                    "--full-management-config": "bool",
                    "--location": "value",
                    "--master-ipv4-cidr-block": "value",
                    "--network": "value",
                    "--services-cidr-block": "value",
                    "--services-named-range": "value",
                    "--subnet": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "terraform": {
          "commands": {
            "vet": {
              "commands": {},
              "flags": {
                "--policy-library": "value",
                "--region": "value",
                "--zone": "value"
              }
            }
          },
          "flags": {}
        },
        "topic": {
          "commands": {
            "accessibility": {
              "commands": {},
              "flags": {}
            },
            "arg-files": {
              "commands": {},
              "flags": {}
            },
            "cli-trees": {
              "commands": {},
              "flags": {}
            },
            "client-certificate": {
              "commands": {},
              "flags": {}
            },
            "command-conventions": {
              "commands": {},
              "flags": {}
            },
            "configurations": {
              "commands": {},
              "flags": {}
            },
            "datetimes": {
              "commands": {},
              "flags": {}
            },
            "endpoint-override": {
              "commands": {},
              "flags": {}
            },
            "escaping": {
              "commands": {},
              "flags": {}
            },
            "filters": {
              "commands": {},
              "flags": {}
            },
            "flags-file": {
              "commands": {},
              "flags": {}
            },
            "formats": {
              "commands": {},
              "flags": {}
            },
            "gcloudignore": {
              "commands": {},
              "flags": {}
            },
            "offline-help": {
              "commands": {},
              "flags": {}
            },
            "projections": {
              "commands": {},
              "flags": {}
            },
            "resource-keys": {
              "commands": {},
              "flags": {}
            },
            "startup": {
              "commands": {},
              "flags": {}
            },
            "uninstall": {
              "commands": {},
              "flags": {}
            }
          },
          "flags": {}
        },
        "trace": {
          "commands": {
            "sinks": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "transfer": {
          "commands": {
            "agent-pools": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--bandwidth-limit": "value",
                    "--display-name": "value",
                    "--no-async": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--limit": "value",
                    "--names": "value",
                    "--page-size": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--bandwidth-limit": "value",
                    "--clear-bandwidth-limit": "bool",
                    "--clear-display-name": "bool",
                    "--display-name": "value"
                  }
                }
              },
              "flags": {}
            },
            "agents": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--container-manager": [
                      "docker",
                      "podman"
                    ],
                    "--ids": "value",
                    "--uninstall": "bool"
                  }
                },
                "install": {
                  "commands": {},
                  "flags": {
                    "--container-manager": [
                      "docker",
                      "podman"
                    ],
                    "--count": "value",
                    "--creds-file": "value",
                    "--enable-multipart": "bool",
                    "--hdfs-data-transfer-protection": [
                      "authentication",
                      "integrity",
                      "privacy"
                    ],
                    "--hdfs-namenode-uri": "value",
                    "--hdfs-username": "value",
                    "--id-prefix": "value",
                    "--kerberos-config-file": "value",
                    "--kerberos-keytab-file": "value",
                    "--kerberos-service-principal": "value",
                    "--kerberos-user-principal": "value",
                    "--logs-directory": "value",
                    "--max-concurrent-small-file-uploads": "value",
                    "--memlock-limit": "value",
                    "--mount-directories": "value",
                    "--network": "value",
                    "--pool": "value",
                    "--proxy": "value",
                    "--s3-compatible-mode": "bool"
                  }
                }
              },
              "flags": {}
            },
            "appliances": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-southeast1",
                      "europe-west1",
                      "us-central1"
                    ]
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-southeast1",
                      "europe-west1",
                      "us-central1"
                    ]
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--appliances": "dynamic",
                    "--filter": "value",
                    "--limit": "value",
                    "--orders": "dynamic",
                    "--page-size": "value",
                    "--region": [
                      "asia-southeast1",
                      "europe-west1",
                      "us-central1"
                    ],
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "orders": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--address": "value",
                        "--clone": "dynamic",
                        "--clone-region": "dynamic",
                        "--cmek": "value",
                        "--country": [
                          "AT",
                          "BE",
                          "BG",
                          "CA",
                          "CH",
                          "CY",
                          "CZ",
                          "DE",
                          "DK",
                          "EE",
                          "ES",
                          "FI",
                          "FR",
                          "GB",
                          "GR",
                          "HR",
                          "HU",
                          "IE",
                          "IT",
                          "LT",
                          "LU",
                          "LV",
                          "MT",
                          "NL",
                          "NO",
                          "PL",
                          "PT",
                          "RO",
                          "SE",
                          "SG",
                          "SI",
                          "SK",
                          "US"
                        ],
                        "--delivery-notes": "value",
                        "--display-name": "value",
                        "--internet-enabled": "bool",
                        "--model": [
                          "EA_GPU_T4",
                          "EA_STORAGE_7",
                          "TA300_RACKABLE",
                          "TA300_STANDALONE",
                          "TA40_RACKABLE",
                          "TA40_STANDALONE",
                          "TA7"
                        ],
                        "--offline-export": "value",
                        "--offline-import": "value",
                        "--online-import": "value",
                        "--order-contact": "value",
                        "--shipping-contact": "value",
                        "--submit": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--keep-appliances": "bool",
                        "--region": [
                          "asia-southeast1",
                          "europe-west1",
                          "us-central1"
                        ]
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": [
                          "asia-southeast1",
                          "europe-west1",
                          "us-central1"
                        ]
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--appliances": "dynamic",
                        "--filter": "value",
                        "--limit": "value",
                        "--orders": "dynamic",
                        "--page-size": "value",
                        "--region": [
                          "asia-southeast1",
                          "europe-west1",
                          "us-central1"
                        ],
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--address": "value",
                        "--cmek": "value",
                        "--delivery-notes": "value",
                        "--display-name": "value",
                        "--model": [
                          "EA_GPU_T4",
                          "EA_STORAGE_7",
                          "TA300_RACKABLE",
                          "TA300_STANDALONE",
                          "TA40_RACKABLE",
                          "TA40_STANDALONE",
                          "TA7"
                        ],
                        "--offline-export": "value",
                        "--offline-import": "value",
                        "--online-import": "value",
                        "--order-contact": "value",
                        "--region": [
                          "asia-southeast1",
                          "europe-west1",
                          "us-central1"
                        ],
                        "--shipping-contact": "value",
                        "--submit": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "authorize": {
              "commands": {},
              "flags": {
                "--add-missing": "bool",
                "--creds-file": "value"
              }
            },
            "jobs": {
              "commands": {
                "config": {
                  "commands": {
                    "export": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--path": "value",
                        "--resource-format": [
                          "krm",
                          "terraform"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--custom-storage-class": "value",
                    "--delete-from": [
                      "destination-if-unique",
                      "source-after-transfer"
                    ],
                    "--description": "value",
                    "--destination-agent-pool": "value",
                    "--do-not-run": "bool",
                    "--enable-posix-transfer-logs": "bool",
                    "--event-stream-expires": "value",
                    "--event-stream-name": "value",
                    "--event-stream-starts": "value",
                    "--exclude-prefixes": "value",
                    "--include-modified-after-absolute": "value",
                    "--include-modified-after-relative": "value",
                    "--include-modified-before-absolute": "value",
                    "--include-modified-before-relative": "value",
                    "--include-prefixes": "value",
                    "--intermediate-storage-path": "value",
                    "--log-action-states": "value",
                    "--log-actions": "value",
                    "--manifest-file": "value",
                    "--name": "value",
                    "--no-async": "bool",
                    "--notification-event-types": "value",
                    "--notification-payload-format": [
                      "json",
                      "none"
                    ],
                    "--notification-pubsub-topic": "value",
                    "--overwrite-when": [
                      "always",
                      "different",
                      "never"
                    ],
                    "--preserve-metadata": "value",
                    "--replication": "bool",
                    "--s3-cloudfront-domain": "value",
                    "--schedule-repeats-every": "value",
                    "--schedule-repeats-until": "value",
                    "--schedule-starts": "value",
                    "--source-agent-pool": "value",
                    "--source-auth-method": [
                      "AWS_SIGNATURE_V2",
                      "AWS_SIGNATURE_V4"
                    ],
                    "--source-creds-file": "value",
                    "--source-endpoint": "value",
                    "--source-list-api": [
                      "LIST_OBJECTS",
                      "LIST_OBJECTS_V2"
                    ],
                    "--source-network-protocol": [
                      "HTTP",
                      "HTTPS"
                    ],
                    "--source-request-model": [
                      "PATH_STYLE",
                      "VIRTUAL_HOSTED_STYLE"
                    ],
                    "--source-signing-region": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--expand-table": "bool",
                    "--job-names": "value",
                    "--job-statuses": "value",
                    "--job-type": [
                      "replication",
                      "transfer"
                    ],
                    "--limit": "value",
                    "--page-size": "value"
                  }
                },
                "monitor": {
                  "commands": {},
                  "flags": {}
                },
                "run": {
                  "commands": {},
                  "flags": {
                    "--no-async": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-custom-storage-class": "bool",
                    "--clear-delete-from": "bool",
                    "--clear-description": "bool",
                    "--clear-destination-agent-pool": "bool",
                    "--clear-event-stream": "bool",
                    "--clear-exclude-prefixes": "bool",
                    "--clear-include-modified-after-absolute": "bool",
                    "--clear-include-modified-after-relative": "bool",
                    "--clear-include-modified-before-absolute": "bool",
                    "--clear-include-modified-before-relative": "bool",
                    "--clear-include-prefixes": "bool",
                    "--clear-intermediate-storage-path": "bool",
                    "--clear-log-config": "bool",
                    "--clear-manifest-file": "bool",
                    "--clear-notification-config": "bool",
                    "--clear-notification-event-types": "bool",
                    "--clear-preserve-metadata": "bool",
                    "--clear-s3-cloudfront-domain": "bool",
                    "--clear-schedule": "bool",
                    "--clear-source-agent-pool": "bool",
                    "--clear-source-auth-method": "bool",
                    "--clear-source-creds-file": "bool",
                    "--clear-source-endpoint": "bool",
                    "--clear-source-list-api": "bool",
                    "--clear-source-network-protocol": "bool",
                    "--clear-source-request-model": "bool",
                    "--clear-source-signing-region": "bool",
                    "--custom-storage-class": "value",
                    "--delete-from": [
                      "destination-if-unique",
                      "source-after-transfer"
                    ],
                    "--description": "value",
                    "--destination": "value",
                    "--destination-agent-pool": "value",
                    "--enable-posix-transfer-logs": "bool",
                    "--event-stream-expires": "value",
                    "--event-stream-name": "value",
                    "--event-stream-starts": "value",
                    "--exclude-prefixes": "value",
                    "--include-modified-after-absolute": "value",
                    "--include-modified-after-relative": "value",
                    "--include-modified-before-absolute": "value",
                    "--include-modified-before-relative": "value",
                    "--include-prefixes": "value",
                    "--intermediate-storage-path": "value",
                    "--log-action-states": "value",
                    "--log-actions": "value",
                    "--manifest-file": "value",
                    "--notification-event-types": "value",
                    "--notification-payload-format": [
                      "json",
                      "none"
                    ],
                    "--notification-pubsub-topic": "value",
                    "--overwrite-when": [
                      "always",
                      "different",
                      "never"
                    ],
                    "--preserve-metadata": "value",
                    "--s3-cloudfront-domain": "value",
                    "--schedule-repeats-every": "value",
                    "--schedule-repeats-until": "value",
                    "--schedule-starts": "value",
                    "--source": "value",
                    "--source-agent-pool": "value",
                    "--source-auth-method": [
                      "AWS_SIGNATURE_V2",
                      "AWS_SIGNATURE_V4"
                    ],
                    "--source-creds-file": "value",
                    "--source-endpoint": "value",
                    "--source-list-api": [
                      "LIST_OBJECTS",
                      "LIST_OBJECTS_V2"
                    ],
                    "--source-network-protocol": [
                      "HTTP",
                      "HTTPS"
                    ],
                    "--source-request-model": [
                      "PATH_STYLE",
                      "VIRTUAL_HOSTED_STYLE"
                    ],
                    "--source-signing-region": "value",
                    "--status": [
                      "deleted",
                      "disabled",
                      "enabled"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--expand-table": "bool",
                    "--job-names": "value",
                    "--limit": "value",
                    "--operation-names": "value",
                    "--operation-statuses": "value",
                    "--page-size": "value"
                  }
                },
                "monitor": {
                  "commands": {},
                  "flags": {}
                },
                "pause": {
                  "commands": {},
                  "flags": {}
                },
                "resume": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "web-security-scanner": {
          "commands": {
            "scan-configs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--auth-password": "value",
                    "--auth-type": [
                      "custom",
                      "google",
                      "none"
                    ],
                    "--auth-url": "value",
                    "--auth-user": "value",
                    "--blacklist-patterns": "value",
                    "--display-name": "value",
                    "--export-to-security-center": "bool",
                    "--max-qps": "value",
                    "--risk-level": [
                      "low",
                      "normal"
                    ],
                    "--schedule-interval-days": "value",
                    "--schedule-next-start": "value",
                    "--starting-urls": "value",
                    "--target-platforms": "value",
                    "--user-agent": [
                      "chrome-android",
                      "chrome-linux",
                      "safari-iphone",
                      "user-agent-unspecified"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--auth-password": "value",
                    "--auth-type": [
                      "custom",
                      "google",
                      "none"
                    ],
                    "--auth-url": "value",
                    "--auth-user": "value",
                    "--blacklist-patterns": "value",
                    "--display-name": "value",
                    "--export-to-security-center": "bool",
                    "--max-qps": "value",
                    "--risk-level": [
                      "low",
                      "normal"
                    ],
                    "--schedule-interval-days": "value",
                    "--schedule-next-start": "value",
                    "--starting-urls": "value",
                    "--target-platforms": "value",
                    "--user-agent": [
                      "chrome-android",
                      "chrome-linux",
                      "safari-iphone",
                      "user-agent-unspecified"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "scan-runs": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--scan-config": "value"
                  }
                },
                "findings": {
                  "commands": {
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--scan-config": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--scan-config": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-crawled-urls": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--scan-config": "value",
                    "--scan-run": "value",
                    "--sort-by": "value"
                  }
                },
                "start": {
                  "commands": {},
                  "flags": {}
                },
                "stop": {
                  "commands": {},
                  "flags": {
                    "--scan-config": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "workstations": {
          "commands": {
            "clusters": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--domain": "value",
                    "--enable-private-endpoint": "bool",
                    "--labels": "value",
                    "--network": "value",
                    "--region": "value",
                    "--subnetwork": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "configs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator-count": "value",
                    "--accelerator-type": "value",
                    "--allow-unauthenticated-cors-preflight-requests": "bool",
                    "--allowed-ports": "value",
                    "--async": "bool",
                    "--boost-config": "value",
                    "--boot-disk-size": "value",
                    "--cluster": "dynamic",
                    "--container-args": "value",
                    "--container-command": "value",
                    "--container-custom-image": "value",
                    "--container-env": "value",
                    "--container-predefined-image": [
                      "base-image",
                      "clion",
                      "codeoss",
                      "codeoss-cuda",
                      "goland",
                      "intellij",
                      "phpstorm",
                      "pycharm",
                      "rider",
                      "rubymine",
                      "webstorm"
                    ],
                    "--container-run-as-user": "value",
                    "--container-working-dir": "value",
                    "--disable-localhost-replacement": "bool",
                    "--disable-public-ip-addresses": "bool",
                    "--disable-ssh-to-vm": "bool",
                    "--disable-tcp-connections": "bool",
                    "--enable-audit-agent": "bool",
                    "--enable-confidential-compute": "bool",
                    "--enable-nested-virtualization": "bool",
                    "--enable-ssh-to-vm": "bool",
                    "--ephemeral-directory": "value",
                    "--grant-workstation-admin-role-on-create": "bool",
                    "--idle-timeout": "value",
                    "--kms-key": "value",
                    "--kms-key-service-account": "value",
                    "--labels": "value",
                    "--machine-type": "value",
                    "--max-usable-workstations-count": "value",
                    "--network-tags": "value",
                    "--pd-disk-size": [
                      10,
                      50,
                      100,
                      200,
                      500,
                      1000
                    ],
                    "--pd-disk-type": [
                      "pd-balanced",
                      "pd-ssd",
                      "pd-standard"
                    ],
                    "--pd-reclaim-policy": [
                      "delete",
                      "retain"
                    ],
                    "--pd-source-snapshot": "value",
                    "--pool-size": "value",
                    "--region": "value",
                    "--replica-zones": "value",
                    "--running-timeout": "value",
                    "--service-account": "value",
                    "--service-account-scopes": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-secure-boot": "bool",
                    "--shielded-vtpm": "bool",
                    "--vm-tags": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster": "value",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--region": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--region": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--accelerator-count": "value",
                    "--accelerator-type": "value",
                    "--allow-unauthenticated-cors-preflight-requests": "bool",
                    "--allowed-ports": "value",
                    "--async": "bool",
                    "--boost-config": "value",
                    "--boot-disk-size": "value",
                    "--cluster": "dynamic",
                    "--container-args": "value",
                    "--container-command": "value",
                    "--container-custom-image": "value",
                    "--container-env": "value",
                    "--container-predefined-image": [
                      "base-image",
                      "clion",
                      "codeoss",
                      "codeoss-cuda",
                      "goland",
                      "intellij",
                      "phpstorm",
                      "pycharm",
                      "rider",
                      "rubymine",
                      "webstorm"
                    ],
                    "--container-run-as-user": "value",
                    "--container-working-dir": "value",
                    "--disable-localhost-replacement": "bool",
                    "--disable-public-ip-addresses": "bool",
                    "--disable-ssh-to-vm": "bool",
                    "--disable-tcp-connections": "bool",
                    "--disallow-unauthenticated-cors-preflight-requests": "bool",
                    "--enable-audit-agent": "bool",
                    "--enable-confidential-compute": "bool",
                    "--enable-localhost-replacement": "bool",
                    "--enable-nested-virtualization": "bool",
                    "--enable-ssh-to-vm": "bool",
                    "--enable-tcp-connections": "bool",
                    "--grant-workstation-admin-role-on-create": "bool",
                    "--idle-timeout": "value",
                    "--labels": "value",
                    "--machine-type": "value",
                    "--max-usable-workstations-count": "value",
                    "--network-tags": "value",
                    "--pd-source-snapshot": "value",
                    "--pool-size": "value",
                    "--region": "value",
                    "--running-timeout": "value",
                    "--service-account": "value",
                    "--service-account-scopes": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-secure-boot": "bool",
                    "--shielded-vtpm": "bool",
                    "--vm-tags": "value"
                  }
                }
              },
              "flags": {}
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--cluster": "value",
                "--config": "value",
                "--env": "value",
                "--labels": "value",
                "--region": "value",
                "--source-workstation": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--cluster": "value",
                "--config": "value",
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--config": "value",
                "--region": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--config": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--config": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value"
              }
            },
            "list-usable": {
              "commands": {},
              "flags": {
                "--cluster": "dynamic",
                "--config": "dynamic",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--config": "value",
                "--region": "value"
              }
            },
            "ssh": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--command": "value",
                "--config": "value",
                "--local-host-port": "value",
                "--port": "value",
                "--region": "value",
                "--user": "value"
              }
            },
            "start": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--boost": "value",
                "--cluster": "value",
                "--config": "value",
                "--region": "value"
              }
            },
            "start-tcp-tunnel": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--config": "value",
                "--local-host-port": "value",
                "--region": "value"
              }
            },
            "stop": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--cluster": "value",
                "--config": "value",
                "--region": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "anthos": {
      "commands": {
        "auth": {
          "commands": {
            "login": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--dry-run": "bool",
                "--kubeconfig": "value",
                "--login-config": "value",
                "--login-config-cert": "value",
                "--no-browser": "bool",
                "--remote-bootstrap": "value",
                "--server": "value",
                "--set-preferred-auth": "bool",
                "--user": "value"
              }
            }
          },
          "flags": {}
        },
        "config": {
          "commands": {
            "controller": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster-ipv4-cidr-block": "value",
                    "--cluster-named-range": "value",
                    "--full-management": "bool",
                    "--location": "dynamic",
                    "--man-block": "value",
                    "--man-blocks": "value",
                    "--master-ipv4-cidr-block": "value",
                    "--network": "value",
                    "--services-ipv4-cidr-block": "value",
                    "--services-named-range": "value",
                    "--subnet": "value",
                    "--use-private-endpoint": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "get-config-connector-identity": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-credentials": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--full-name": "bool",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "create-login-config": {
          "commands": {},
          "flags": {
            "--kubeconfig": "value",
            "--merge-from": "value",
            "--output": "value"
          }
        }
      },
      "flags": {}
    },
    "api-gateway": {
      "commands": {
        "api-configs": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--api": "value",
                "--async": "bool",
                "--backend-auth-service-account": "value",
                "--display-name": "value",
                "--grpc-files": "value",
                "--labels": "value",
                "--openapi-spec": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--api": "value",
                "--async": "bool"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--api": "value",
                "--view": [
                  "BASIC",
                  "FULL"
                ]
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--api": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--api": "value",
                "--async": "bool",
                "--clear-labels": "bool",
                "--display-name": "value",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "apis": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--display-name": "value",
                "--labels": "value",
                "--managed-service": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-labels": "bool",
                "--display-name": "value",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "gateways": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--api": "value",
                "--api-config": "value",
                "--async": "bool",
                "--display-name": "value",
                "--labels": "value",
                "--location": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--api": "value",
                "--api-config": "value",
                "--async": "bool",
                "--clear-labels": "bool",
                "--display-name": "value",
                "--location": "value",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value"
              }
            },
            "wait": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "apigee": {
      "commands": {
        "apis": {
          "commands": {
            "deploy": {
              "commands": {},
              "flags": {
                "--api": "value",
                "--environment": "value",
                "--organization": "value",
                "--override": "bool"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--organization": "value",
                "--verbose": "bool"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "undeploy": {
              "commands": {},
              "flags": {
                "--api": "value",
                "--environment": "value",
                "--organization": "value"
              }
            }
          },
          "flags": {}
        },
        "applications": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--developer": "value",
                "--filter": "value",
                "--limit": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "deployments": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--api": "value",
                "--environment": "value",
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--api": "value",
                "--environment": "value",
                "--filter": "value",
                "--limit": "value",
                "--organization": "value",
                "--page-size": "value",
                "--revision": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "developers": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "environments": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "organizations": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "products": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--all-environments": "bool",
                "--all-proxies": "bool",
                "--apis": "value",
                "--attributes": "value",
                "--description": "value",
                "--display-name": "value",
                "--environments": "value",
                "--internal-access": "bool",
                "--manual-approval": "bool",
                "--oauth-scopes": "value",
                "--organization": "value",
                "--private-access": "bool",
                "--public-access": "bool",
                "--quota": "value",
                "--quota-interval": "value",
                "--quota-unit": [
                  "day",
                  "hour",
                  "minute",
                  "month"
                ],
                "--resources": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--organization": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-api": "value",
                "--add-attribute": "value",
                "--add-environment": "value",
                "--add-oauth-scope": "value",
                "--add-resource": "value",
                "--all-apis": "bool",
                "--all-environments": "bool",
                "--all-resources": "bool",
                "--automatic-approval": "bool",
                "--clear-attributes": "bool",
                "--clear-description": "bool",
                "--clear-oauth-scopes": "bool",
                "--clear-quota": "bool",
                "--description": "value",
                "--display-name": "value",
                "--internal-access": "bool",
                "--manual-approval": "bool",
                "--organization": "value",
                "--private-access": "bool",
                "--public-access": "bool",
                "--quota": "value",
                "--quota-interval": "value",
                "--quota-unit": [
                  "day",
                  "hour",
                  "minute",
                  "month"
                ],
                "--remove-api": "value",
                "--remove-attribute": "value",
                "--remove-environment": "value",
                "--remove-oauth-scope": "value",
                "--remove-resource": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "app": {
      "commands": {
        "browse": {
          "commands": {},
          "flags": {
            "--launch-browser": "bool",
            "--service": "value"
          }
        },
        "create": {
          "commands": {},
          "flags": {
            "--region": "value",
            "--service-account": "value"
          }
        },
        "deploy": {
          "commands": {},
          "flags": {
            "--appyaml": "value",
            "--bucket": "value",
            "--cache": "bool",
            "--ignore-file": "value",
            "--image-url": "value",
            "--promote": "bool",
            "--service-account": "value",
            "--stop-previous-version": "bool"
          }
        },
        "describe": {
          "commands": {},
          "flags": {}
        },
        "domain-mappings": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--certificate-id": "value",
                "--certificate-management": [
                  "automatic",
                  "manual"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--certificate-id": "value",
                "--certificate-management": [
                  "automatic",
                  "manual"
                ],
                "--no-certificate-id": "bool"
              }
            }
          },
          "flags": {}
        },
        "firewall-rules": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--action": [
                  "ALLOW",
                  "DENY"
                ],
                "--description": "value",
                "--source-range": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "test-ip": {
              "commands": {},
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--action": [
                  "ALLOW",
                  "DENY"
                ],
                "--description": "value",
                "--source-range": "value"
              }
            }
          },
          "flags": {}
        },
        "instances": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--service": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--service": "value"
              }
            },
            "disable-debug": {
              "commands": {},
              "flags": {
                "--service": "value"
              }
            },
            "enable-debug": {
              "commands": {},
              "flags": {
                "--service": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--service": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "scp": {
              "commands": {},
              "flags": {
                "--compress": "bool",
                "--recurse": "bool",
                "--service": "value",
                "--tunnel-through-iap": "bool"
              }
            },
            "ssh": {
              "commands": {},
              "flags": {
                "--container": "value",
                "--service": "value",
                "--tunnel-through-iap": "bool"
              }
            }
          },
          "flags": {}
        },
        "logs": {
          "commands": {
            "read": {
              "commands": {},
              "flags": {
                "--level": [
                  "any",
                  "critical",
                  "debug",
                  "error",
                  "info",
                  "warning"
                ],
                "--limit": "value",
                "--logs": "value",
                "--service": "value"
              }
            },
            "tail": {
              "commands": {},
              "flags": {
                "--level": [
                  "any",
                  "critical",
                  "debug",
                  "error",
                  "info",
                  "warning"
                ],
                "--logs": "value",
                "--service": "value"
              }
            }
          },
          "flags": {}
        },
        "open-console": {
          "commands": {},
          "flags": {
            "--logs": "bool",
            "--service": "value"
          }
        },
        "operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--pending": "bool",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "wait": {
              "commands": {},
              "flags": {}
            }
          },
          "flags": {}
        },
        "regions": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "runtimes": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--environment": [
                  "standard"
                ],
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "services": {
          "commands": {
            "browse": {
              "commands": {},
              "flags": {
                "--launch-browser": "bool"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "set-traffic": {
              "commands": {},
              "flags": {
                "--migrate": "bool",
                "--split-by": [
                  "cookie",
                  "ip",
                  "random"
                ],
                "--splits": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--ingress": [
                  "all",
                  "internal-and-cloud-load-balancing",
                  "internal-only"
                ]
              }
            }
          },
          "flags": {}
        },
        "ssl-certificates": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--certificate": "value",
                "--display-name": "value",
                "--private-key": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--certificate": "value",
                "--display-name": "value",
                "--private-key": "value"
              }
            }
          },
          "flags": {}
        },
        "update": {
          "commands": {},
          "flags": {
            "--service-account": "value",
            "--split-health-checks": "bool"
          }
        },
        "versions": {
          "commands": {
            "browse": {
              "commands": {},
              "flags": {
                "--launch-browser": "bool",
                "--service": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--service": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--service": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--hide-no-traffic": "bool",
                "--limit": "value",
                "--page-size": "value",
                "--service": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "migrate": {
              "commands": {},
              "flags": {
                "--service": "value"
              }
            },
            "start": {
              "commands": {},
              "flags": {
                "--service": "value"
              }
            },
            "stop": {
              "commands": {},
              "flags": {
                "--service": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "apphub": {
      "commands": {
        "applications": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--business-owners": "value",
                "--criticality-type": [
                  "HIGH",
                  "LOW",
                  "MEDIUM",
                  "MISSION_CRITICAL",
                  "TYPE_UNSPECIFIED"
                ],
                "--description": "value",
                "--developer-owners": "value",
                "--display-name": "value",
                "--environment-type": [
                  "DEVELOPMENT",
                  "PRODUCTION",
                  "STAGING",
                  "TEST",
                  "TYPE_UNSPECIFIED"
                ],
                "--location": "value",
                "--operator-owners": "value",
                "--scope-type": [
                  "GLOBAL",
                  "REGIONAL"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "value"
              }
            },
            "services": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--application": "value",
                    "--async": "bool",
                    "--business-owners": "value",
                    "--criticality-type": [
                      "HIGH",
                      "LOW",
                      "MEDIUM",
                      "MISSION_CRITICAL",
                      "TYPE_UNSPECIFIED"
                    ],
                    "--description": "value",
                    "--developer-owners": "value",
                    "--discovered-service": "value",
                    "--display-name": "value",
                    "--environment-type": [
                      "DEVELOPMENT",
                      "PRODUCTION",
                      "STAGING",
                      "TEST",
                      "TYPE_UNSPECIFIED"
                    ],
                    "--location": "value",
                    "--operator-owners": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--application": "value",
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--application": "value",
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--application": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--application": "value",
                    "--async": "bool",
                    "--business-owners": "value",
                    "--criticality-type": [
                      "HIGH",
                      "LOW",
                      "MEDIUM",
                      "MISSION_CRITICAL",
                      "TYPE_UNSPECIFIED"
                    ],
                    "--description": "value",
                    "--developer-owners": "value",
                    "--display-name": "value",
                    "--environment-type": [
                      "DEVELOPMENT",
                      "PRODUCTION",
                      "STAGING",
                      "TEST",
                      "TYPE_UNSPECIFIED"
                    ],
                    "--location": "value",
                    "--operator-owners": "value"
                  }
                }
              },
              "flags": {}
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--business-owners": "value",
                "--criticality-type": [
                  "HIGH",
                  "LOW",
                  "MEDIUM",
                  "MISSION_CRITICAL",
                  "TYPE_UNSPECIFIED"
                ],
                "--description": "value",
                "--developer-owners": "value",
                "--display-name": "value",
                "--environment-type": [
                  "DEVELOPMENT",
                  "PRODUCTION",
                  "STAGING",
                  "TEST",
                  "TYPE_UNSPECIFIED"
                ],
                "--location": "value",
                "--operator-owners": "value"
              }
            },
            "workloads": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--application": "value",
                    "--async": "bool",
                    "--business-owners": "value",
                    "--criticality-type": [
                      "HIGH",
                      "LOW",
                      "MEDIUM",
                      "MISSION_CRITICAL",
                      "TYPE_UNSPECIFIED"
                    ],
                    "--description": "value",
                    "--developer-owners": "value",
                    "--discovered-workload": "value",
                    "--display-name": "value",
                    "--environment-type": [
                      "DEVELOPMENT",
                      "PRODUCTION",
                      "STAGING",
                      "TEST",
                      "TYPE_UNSPECIFIED"
                    ],
                    "--location": "value",
                    "--operator-owners": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--application": "value",
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--application": "value",
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--application": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--application": "value",
                    "--async": "bool",
                    "--business-owners": "value",
                    "--criticality-type": [
                      "HIGH",
                      "LOW",
                      "MEDIUM",
                      "MISSION_CRITICAL",
                      "TYPE_UNSPECIFIED"
                    ],
                    "--description": "value",
                    "--developer-owners": "value",
                    "--display-name": "value",
                    "--environment-type": [
                      "DEVELOPMENT",
                      "PRODUCTION",
                      "STAGING",
                      "TEST",
                      "TYPE_UNSPECIFIED"
                    ],
                    "--location": "value",
                    "--operator-owners": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "discovered-services": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "lookup": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--uri": "value"
              }
            }
          },
          "flags": {}
        },
        "discovered-workloads": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "lookup": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--uri": "value"
              }
            }
          },
          "flags": {}
        },
        "locations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "service-projects": {
          "commands": {
            "add": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "detach": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "lookup": {
              "commands": {},
              "flags": {}
            },
            "remove": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "artifacts": {
      "commands": {
        "apt": {
          "commands": {
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--gcs-source": "value",
                "--location": "value"
              }
            },
            "upload": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--source": "value"
              }
            }
          },
          "flags": {}
        },
        "attachments": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--attachment-namespace": "value",
                "--attachment-type": "value",
                "--files": "value",
                "--location": "value",
                "--repository": "value",
                "--target": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--repository": "value"
              }
            },
            "download": {
              "commands": {},
              "flags": {
                "--chunk-size": "value",
                "--destination": "value",
                "--location": "value",
                "--oci-version-name": "value",
                "--repository": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--repository": "value",
                "--sort-by": "value",
                "--target": "value"
              }
            }
          },
          "flags": {}
        },
        "docker": {
          "commands": {
            "images": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--delete-tags": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--metadata-filter": "value",
                    "--show-all-metadata": "bool",
                    "--show-build-details": "bool",
                    "--show-deployment": "bool",
                    "--show-image-basis": "bool",
                    "--show-package-vulnerability": "bool",
                    "--show-provenance": "bool",
                    "--show-sbom-references": "bool"
                  }
                },
                "get-operation": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--include-tags": "bool",
                    "--limit": "value",
                    "--occurrence-filter": "value",
                    "--page-size": "value",
                    "--show-occurrences": "bool",
                    "--show-occurrences-from": "value",
                    "--sort-by": "value"
                  }
                },
                "list-vulnerabilities": {
                  "commands": {},
                  "flags": {
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value"
                  }
                },
                "scan": {
                  "commands": {},
                  "flags": {
                    "--additional-package-types": "value",
                    "--async": "bool",
                    "--location": [
                      "asia",
                      "europe",
                      "us"
                    ],
                    "--remote": "bool",
                    "--skip-package-types": "value"
                  }
                }
              },
              "flags": {}
            },
            "tags": {
              "commands": {
                "add": {
                  "commands": {},
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "upgrade": {
              "commands": {
                "migrate": {
                  "commands": {},
                  "flags": {
                    "--canary-reads": "value",
                    "--copy-only": "bool",
                    "--from-gcr": "value",
                    "--last-uploaded-versions": "value",
                    "--max-threads": "value",
                    "--pkg-dev-location": "value",
                    "--projects": "value",
                    "--recent-images": "value",
                    "--skip-iam-update": "bool",
                    "--to-pkg-dev": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "files": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--repository": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--repository": "value"
              }
            },
            "download": {
              "commands": {},
              "flags": {
                "--allow-overwrite": "bool",
                "--destination": "value",
                "--local-filename": "value",
                "--location": "value",
                "--repository": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--package": "value",
                "--page-size": "value",
                "--repository": "value",
                "--sort-by": "value",
                "--tag": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--annotations": "value",
                "--location": "value",
                "--repository": "value"
              }
            }
          },
          "flags": {}
        },
        "generic": {
          "commands": {
            "download": {
              "commands": {},
              "flags": {
                "--chunk-size": "value",
                "--destination": "value",
                "--location": "value",
                "--name": "value",
                "--package": "value",
                "--repository": "value"
              }
            },
            "upload": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--destination-path": "value",
                "--location": "value",
                "--package": "value",
                "--repository": "value",
                "--skip-existing": "bool",
                "--source": "value",
                "--source-directory": "value"
              }
            }
          },
          "flags": {}
        },
        "go": {
          "commands": {
            "upload": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--module-path": "value",
                "--repository": "value",
                "--source": "value"
              }
            }
          },
          "flags": {}
        },
        "locations": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            }
          },
          "flags": {}
        },
        "packages": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--repository": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--repository": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--repository": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--annotations": "value",
                "--location": "value",
                "--repository": "value"
              }
            }
          },
          "flags": {}
        },
        "print-settings": {
          "commands": {
            "gradle": {
              "commands": {},
              "flags": {
                "--json-key": "value",
                "--location": "value",
                "--repository": "value"
              }
            },
            "mvn": {
              "commands": {},
              "flags": {
                "--json-key": "value",
                "--location": "value",
                "--repository": "value"
              }
            },
            "npm": {
              "commands": {},
              "flags": {
                "--json-key": "value",
                "--location": "value",
                "--repository": "value",
                "--scope": "value"
              }
            },
            "python": {
              "commands": {},
              "flags": {
                "--json-key": "value",
                "--location": "value",
                "--repository": "value"
              }
            }
          },
          "flags": {}
        },
        "repositories": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--allow-snapshot-overwrites": "bool",
                "--allow-vulnerability-scanning": "bool",
                "--async": "bool",
                "--description": "value",
                "--disable-remote-validation": "bool",
                "--disable-vulnerability-scanning": "bool",
                "--immutable-tags": "bool",
                "--kms-key": "value",
                "--labels": "value",
                "--location": "value",
                "--mode": [
                  "none",
                  "remote-repository",
                  "standard-repository",
                  "virtual-repository"
                ],
                "--remote-apt-repo": "value",
                "--remote-apt-repo-path": "value",
                "--remote-docker-repo": "value",
                "--remote-mvn-repo": "value",
                "--remote-npm-repo": "value",
                "--remote-password-secret-version": "value",
                "--remote-python-repo": "value",
                "--remote-repo-config-desc": "value",
                "--remote-username": "value",
                "--remote-yum-repo": "value",
                "--remote-yum-repo-path": "value",
                "--repository-format": "value",
                "--upstream-policy-file": "value",
                "--version-policy": [
                  "none",
                  "release",
                  "snapshot"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "delete-cleanup-policies": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--policynames": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list-cleanup-policies": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-cleanup-policies": {
              "commands": {},
              "flags": {
                "--dry-run": "bool",
                "--location": "value",
                "--policy": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--allow-vulnerability-scanning": "bool",
                "--clear-labels": "bool",
                "--description": "value",
                "--disable-remote-validation": "bool",
                "--disable-vulnerability-scanning": "bool",
                "--immutable-tags": "bool",
                "--location": "value",
                "--remote-password-secret-version": "value",
                "--remote-username": "value",
                "--remove-labels": "value",
                "--update-labels": "value",
                "--upstream-policy-file": "value"
              }
            }
          },
          "flags": {}
        },
        "rules": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--action": [
                  "allow",
                  "deny"
                ],
                "--condition": "value",
                "--location": "value",
                "--operation": [
                  "download"
                ],
                "--package": "value",
                "--repository": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--repository": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--repository": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--repository": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--action": [
                  "allow",
                  "deny"
                ],
                "--condition": "value",
                "--location": "value",
                "--operation": [
                  "download"
                ],
                "--package": "value",
                "--repository": "value"
              }
            }
          },
          "flags": {}
        },
        "sbom": {
          "commands": {
            "export": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--uri": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--dependency": "value",
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--resource": "value",
                "--resource-prefix": "value",
                "--sort-by": "value"
              }
            },
            "load": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--kms-key-version": "value",
                "--location": "value",
                "--source": "value",
                "--uri": "value"
              }
            }
          },
          "flags": {}
        },
        "settings": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "disable-upgrade-redirection": {
              "commands": {},
              "flags": {}
            },
            "enable-upgrade-redirection": {
              "commands": {},
              "flags": {
                "--dry-run": "bool"
              }
            }
          },
          "flags": {}
        },
        "tags": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--package": "value",
                "--repository": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--package": "value",
                "--repository": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--package": "value",
                "--page-size": "value",
                "--repository": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--package": "value",
                "--repository": "value"
              }
            }
          },
          "flags": {}
        },
        "versions": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--delete-tags": "bool",
                "--location": "value",
                "--package": "value",
                "--repository": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--package": "value",
                "--repository": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--package": "value",
                "--page-size": "value",
                "--repository": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--annotations": "value",
                "--location": "value",
                "--package": "value",
                "--repository": "value"
              }
            }
          },
          "flags": {}
        },
        "vpcsc-config": {
          "commands": {
            "allow": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "deny": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            }
          },
          "flags": {}
        },
        "vulnerabilities": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--occurrence-filter": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "load-vex": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--source": "value",
                "--uri": "value"
              }
            }
          },
          "flags": {}
        },
        "yum": {
          "commands": {
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--gcs-source": "value",
                "--location": "value"
              }
            },
            "upload": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--source": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "asset": {
      "commands": {
        "analyze-iam-policy": {
          "commands": {},
          "flags": {
            "--access-time": "value",
            "--analyze-service-account-impersonation": "bool",
            "--execution-timeout": "value",
            "--expand-groups": "bool",
            "--expand-resources": "bool",
            "--expand-roles": "bool",
            "--folder": "value",
            "--full-resource-name": "value",
            "--identity": "value",
            "--organization": "value",
            "--output-group-edges": "bool",
            "--output-resource-edges": "bool",
            "--permissions": "value",
            "--roles": "value",
            "--saved-analysis-query": "value",
            "--show-response": "bool"
          }
        },
        "analyze-iam-policy-longrunning": {
          "commands": {},
          "flags": {
            "--access-time": "value",
            "--analyze-service-account-impersonation": "bool",
            "--bigquery-dataset": "value",
            "--bigquery-partition-key": [
              "PARTITION_KEY_UNSPECIFIED",
              "REQUEST_TIME"
            ],
            "--bigquery-table-prefix": "value",
            "--bigquery-write-disposition": "value",
            "--expand-groups": "bool",
            "--expand-resources": "bool",
            "--expand-roles": "bool",
            "--folder": "value",
            "--full-resource-name": "value",
            "--gcs-output-path": "value",
            "--identity": "value",
            "--organization": "value",
            "--output-group-edges": "bool",
            "--output-resource-edges": "bool",
            "--permissions": "value",
            "--roles": "value"
          }
        },
        "analyze-move": {
          "commands": {},
          "flags": {
            "--blockers-only": "value",
            "--destination-folder": "value",
            "--destination-organization": "value"
          }
        },
        "analyze-org-policies": {
          "commands": {},
          "flags": {
            "--constraint": "value",
            "--filter": "value",
            "--limit": "value",
            "--page-size": "value",
            "--scope": "value",
            "--sort-by": "value"
          }
        },
        "analyze-org-policy-governed-assets": {
          "commands": {},
          "flags": {
            "--constraint": "value",
            "--filter": "value",
            "--limit": "value",
            "--page-size": "value",
            "--scope": "value",
            "--sort-by": "value"
          }
        },
        "analyze-org-policy-governed-containers": {
          "commands": {},
          "flags": {
            "--constraint": "value",
            "--filter": "value",
            "--limit": "value",
            "--page-size": "value",
            "--scope": "value",
            "--sort-by": "value"
          }
        },
        "export": {
          "commands": {},
          "flags": {
            "--asset-types": "value",
            "--bigquery-dataset": "dynamic",
            "--bigquery-table": "dynamic",
            "--content-type": [
              "access-policy",
              "iam-policy",
              "org-policy",
              "os-inventory",
              "relationship",
              "resource"
            ],
            "--folder": "value",
            "--organization": "value",
            "--output-bigquery-force": "bool",
            "--output-path": "value",
            "--output-path-prefix": "value",
            "--partition-key": [
              "read-time",
              "request-time"
            ],
            "--per-asset-type": "bool",
            "--relationship-types": "value",
            "--snapshot-time": "value"
          }
        },
        "feeds": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--asset-names": "value",
                "--asset-types": "value",
                "--condition-description": "value",
                "--condition-expression": "value",
                "--condition-title": "value",
                "--content-type": [
                  "access-policy",
                  "iam-policy",
                  "org-policy",
                  "os-inventory",
                  "relationship",
                  "resource"
                ],
                "--folder": "value",
                "--organization": "value",
                "--pubsub-topic": "value",
                "--relationship-types": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-asset-names": "value",
                "--add-asset-types": "value",
                "--add-relationship-types": "value",
                "--clear-asset-names": "bool",
                "--clear-asset-types": "bool",
                "--clear-condition-description": "bool",
                "--clear-condition-expression": "bool",
                "--clear-condition-title": "bool",
                "--clear-content-type": "bool",
                "--clear-relationship-types": "bool",
                "--condition-description": "value",
                "--condition-expression": "value",
                "--condition-title": "value",
                "--content-type": [
                  "access-policy",
                  "iam-policy",
                  "org-policy",
                  "os-inventory",
                  "relationship",
                  "resource"
                ],
                "--folder": "value",
                "--organization": "value",
                "--pubsub-topic": "value",
                "--remove-asset-names": "value",
                "--remove-asset-types": "value",
                "--remove-relationship-types": "value"
              }
            }
          },
          "flags": {}
        },
        "get-effective-iam-policy": {
          "commands": {},
          "flags": {
            "--names": "value",
            "--scope": "value"
          }
        },
        "get-history": {
          "commands": {},
          "flags": {
            "--asset-names": "value",
            "--content-type": [
              "access-policy",
              "iam-policy",
              "org-policy",
              "os-inventory",
              "relationship",
              "resource"
            ],
            "--end-time": "value",
            "--organization": "value",
            "--relationship-types": "value",
            "--start-time": "value"
          }
        },
        "list": {
          "commands": {},
          "flags": {
            "--asset-types": "value",
            "--content-type": [
              "access-policy",
              "iam-policy",
              "org-policy",
              "os-inventory",
              "relationship",
              "resource"
            ],
            "--filter": "value",
            "--folder": "value",
            "--limit": "value",
            "--organization": "value",
            "--page-size": "value",
            "--relationship-types": "value",
            "--snapshot-time": "value",
            "--sort-by": "value"
          }
        },
        "operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            }
          },
          "flags": {}
        },
        "query": {
          "commands": {},
          "flags": {
            "--bigquery-dataset": "dynamic",
            "--bigquery-table": "dynamic",
            "--end-time": "value",
            "--folder": "value",
            "--job-reference": "value",
            "--organization": "value",
            "--page-size": "value",
            "--page-token": "value",
            "--snapshot-time": "value",
            "--start-time": "value",
            "--statement": "value",
            "--timeout": "value",
            "--write-disposition": [
              "write-append",
              "write-empty",
              "write-truncate"
            ]
          }
        },
        "saved-queries": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--folder": "value",
                "--labels": "value",
                "--organization": "value",
                "--query-file-path": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-labels": "bool",
                "--description": "value",
                "--folder": "value",
                "--organization": "value",
                "--query-file-path": "value",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "search-all-iam-policies": {
          "commands": {},
          "flags": {
            "--asset-types": "value",
            "--filter": "value",
            "--limit": "value",
            "--order-by": "value",
            "--page-size": "value",
            "--query": "value",
            "--scope": "value",
            "--sort-by": "value"
          }
        },
        "search-all-resources": {
          "commands": {},
          "flags": {
            "--asset-types": "value",
            "--filter": "value",
            "--limit": "value",
            "--order-by": "value",
            "--page-size": "value",
            "--query": "value",
            "--read-mask": "value",
            "--scope": "value",
            "--sort-by": "value"
          }
        }
      },
      "flags": {}
    },
    "assured": {
      "commands": {
        "operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "workloads": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--compliance-regime": [
                  "assured-workloads-for-partners",
                  "au-regions-and-us-support",
                  "ca-protected-b",
                  "ca-regions-and-support",
                  "canada-controlled-goods",
                  "cjis",
                  "eu-regions-and-support",
                  "fedramp-high",
                  "fedramp-moderate",
                  "healthcare-and-life-sciences-controls",
                  "healthcare-and-life-sciences-controls-us-support",
                  "hipaa",
                  "hitrust",
                  "il2",
                  "il4",
                  "il5",
                  "irs-1075",
                  "isr-regions",
                  "isr-regions-and-support",
                  "itar",
                  "jp-regions-and-support",
                  "ksa-regions-and-support-with-sovereignty-controls",
                  "regional-controls",
                  "us-regional-access"
                ],
                "--display-name": "value",
                "--enable-sovereign-controls": "value",
                "--external-identifier": "value",
                "--labels": "value",
                "--location": "value",
                "--next-rotation-time": "value",
                "--organization": "value",
                "--partner": [
                  "local-controls-by-s3ns",
                  "sovereign-controls-by-cntxt",
                  "sovereign-controls-by-cntxt-no-ekm",
                  "sovereign-controls-by-psn",
                  "sovereign-controls-by-sia-minsait",
                  "sovereign-controls-by-t-systems"
                ],
                "--partner-permissions": "value",
                "--partner-services-billing-account": "value",
                "--provisioned-resources-parent": "value",
                "--resource-settings": "value",
                "--rotation-period": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--etag": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--organization": "value"
              }
            },
            "enable-resource-monitoring": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--display-name": "value",
                "--etag": "value",
                "--labels": "value",
                "--location": "value",
                "--organization": "value",
                "--violation-notifications-enabled": "value"
              }
            },
            "violations": {
              "commands": {
                "acknowledge": {
                  "commands": {},
                  "flags": {
                    "--acknowledge-type": "value",
                    "--comment": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--workload": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--organization": "value",
                    "--workload": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--workload": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "audit-manager": {
      "commands": {
        "audit-reports": {
          "commands": {
            "generate": {
              "commands": {},
              "flags": {
                "--compliance-framework": "value",
                "--folder": "value",
                "--gcs-uri": "value",
                "--location": "value",
                "--report-format": [
                  "odf"
                ]
              }
            }
          },
          "flags": {}
        },
        "audit-scopes": {
          "commands": {
            "generate": {
              "commands": {},
              "flags": {
                "--compliance-framework": "value",
                "--folder": "value",
                "--location": "value",
                "--output-directory": "value",
                "--output-file-name": "value",
                "--report-format": [
                  "odf"
                ]
              }
            }
          },
          "flags": {}
        },
        "enrollments": {
          "commands": {
            "add": {
              "commands": {},
              "flags": {
                "--eligible-gcs-buckets": "value",
                "--folder": "value",
                "--organization": "value"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--location": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "auth": {
      "commands": {
        "activate-service-account": {
          "commands": {},
          "flags": {
            "--key-file": "value",
            "--password-file": "value",
            "--prompt-for-password": "bool"
          }
        },
        "application-default": {
          "commands": {
            "login": {
              "commands": {},
              "flags": {
                "--browser": "bool",
                "--client-id-file": "value",
                "--disable-quota-project": "bool",
                "--launch-browser": "bool",
                "--login-config": "value",
                "--scopes": "value"
              }
            },
            "print-access-token": {
              "commands": {},
              "flags": {
                "--lifetime": "value",
                "--scopes": "value"
              }
            },
            "revoke": {
              "commands": {},
              "flags": {}
            },
            "set-quota-project": {
              "commands": {},
              "flags": {}
            }
          },
          "flags": {}
        },
        "configure-docker": {
          "commands": {},
          "flags": {}
        },
        "enterprise-certificate-config": {
          "commands": {
            "create": {
              "commands": {
                "linux": {
                  "commands": {},
                  "flags": {
                    "--ecp": "value",
                    "--ecp-client": "value",
                    "--label": "value",
                    "--module": "value",
                    "--output-file": "value",
                    "--slot": "value",
                    "--tls-offload": "value",
                    "--user-pin": "value"
                  }
                },
                "macos": {
                  "commands": {},
                  "flags": {
                    "--ecp": "value",
                    "--ecp-client": "value",
                    "--issuer": "value",
                    "--output-file": "value",
                    "--tls-offload": "value"
                  }
                },
                "windows": {
                  "commands": {},
                  "flags": {
                    "--ecp": "value",
                    "--ecp-client": "value",
                    "--issuer": "value",
                    "--output-file": "value",
                    "--provider": "value",
                    "--store": "value",
                    "--tls-offload": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "list": {
          "commands": {},
          "flags": {
            "--filter": "value",
            "--filter-account": "value",
            "--limit": "value",
            "--page-size": "value",
            "--sort-by": "value"
          }
        },
        "login": {
          "commands": {},
          "flags": {
            "--activate": "bool",
            "--brief": "bool",
            "--browser": "bool",
            "--cred-file": "value",
            "--enable-gdrive-access": "bool",
            "--force": "bool",
            "--launch-browser": "bool",
            "--login-config": "value",
            "--update-adc": "bool"
          }
        },
        "print-access-token": {
          "commands": {},
          "flags": {
            "--lifetime": "value"
          }
        },
        "print-identity-token": {
          "commands": {},
          "flags": {
            "--audiences": "value",
            "--include-email": "bool",
            "--include-license": "bool",
            "--token-format": [
              "full",
              "standard"
            ]
          }
        },
        "revoke": {
          "commands": {},
          "flags": {
            "--all": "bool"
          }
        }
      },
      "flags": {}
    },
    "backup-dr": {
      "commands": {
        "backup-plan-associations": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--backup-plan": "dynamic",
                "--location": "dynamic",
                "--resource": "value",
                "--resource-type": "value",
                "--workload-project": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic",
                "--workload-project": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "trigger-backup": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--backup-rule-id": "value",
                "--location": "dynamic",
                "--workload-project": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "backup-plans": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--backup-rule": "value",
                "--backup-vault": "dynamic",
                "--description": "value",
                "--labels": "value",
                "--location": "dynamic",
                "--resource-type": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "backup-vaults": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--access-restriction": [
                  "unrestricted",
                  "within-org",
                  "within-org-but-unrestricted-for-ba",
                  "within-project"
                ],
                "--backup-min-enforced-retention": "value",
                "--description": "value",
                "--effective-time": "value",
                "--labels": "value",
                "--location": "dynamic",
                "--no-async": "bool"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--allow-missing": "bool",
                "--ignore-backup-plan-references": "bool",
                "--ignore-inactive-datasources": "bool",
                "--location": "dynamic",
                "--no-async": "bool"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--backup-min-enforced-retention": "value",
                "--description": "value",
                "--effective-time": "value",
                "--force-update": "bool",
                "--location": "dynamic",
                "--no-async": "bool",
                "--unlock-backup-min-enforced-retention": "bool"
              }
            }
          },
          "flags": {}
        },
        "backups": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--backup-vault": "dynamic",
                "--data-source": "dynamic",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--backup-vault": "dynamic",
                "--data-source": "dynamic",
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--backup-vault": "value",
                "--data-source": "value",
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "restore": {
              "commands": {
                "compute": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--async": "bool",
                    "--backup-vault": "dynamic",
                    "--can-ip-forward": "bool",
                    "--confidential-compute": "bool",
                    "--create-disk": "value",
                    "--data-source": "dynamic",
                    "--deletion-protection": "bool",
                    "--description": "value",
                    "--enable-display-device": "bool",
                    "--enable-uefi-networking": "bool",
                    "--hostname": "value",
                    "--instance-kms-key": "value",
                    "--instance-termination-action": [
                      "DELETE",
                      "STOP"
                    ],
                    "--key-revocation-action-type": "value",
                    "--labels": "value",
                    "--local-ssd-recovery-timeout": "value",
                    "--location": "dynamic",
                    "--machine-type": "value",
                    "--maintenance-policy": [
                      "MIGRATE",
                      "TERMINATE"
                    ],
                    "--metadata": "value",
                    "--min-cpu-platform": "value",
                    "--min-node-cpu": "value",
                    "--name": "value",
                    "--network-interface": "value",
                    "--network-performance-configs": "value",
                    "--no-scopes": "bool",
                    "--preemptible": "bool",
                    "--private-ipv6-google-access-type": "value",
                    "--provisioning-model": [
                      "SPOT",
                      "STANDARD"
                    ],
                    "--reservation": "value",
                    "--reservation-affinity": [
                      "any",
                      "none",
                      "specific"
                    ],
                    "--resource-manager-tags": "value",
                    "--resource-policies": "value",
                    "--restart-on-failure": "bool",
                    "--scopes": "value",
                    "--service-account": "value",
                    "--tags": "value",
                    "--target-project": "value",
                    "--target-zone": "value",
                    "--threads-per-core": "value",
                    "--visible-core-count": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "data-sources": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--backup-vault": "dynamic",
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--backup-vault": "value",
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "locations": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "management-servers": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic",
                "--network": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "batch": {
      "commands": {
        "jobs": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "submit": {
              "commands": {},
              "flags": {
                "--config": "value",
                "--container-commands-file": "value",
                "--container-entrypoint": "value",
                "--container-image-uri": "value",
                "--job-prefix": "value",
                "--location": "value",
                "--machine-type": "value",
                "--network": "value",
                "--no-external-ip-address": "bool",
                "--priority": "value",
                "--provisioning-model": [
                  "SPOT",
                  "STANDARD"
                ],
                "--script-file-path": "value",
                "--script-text": "value",
                "--subnetwork": "value"
              }
            }
          },
          "flags": {}
        },
        "tasks": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--job": "value",
                "--location": "value",
                "--task_group": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--job": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "beta": {
      "commands": {
        "access-approval": {
          "commands": {
            "requests": {
              "commands": {
                "approve": {
                  "commands": {},
                  "flags": {}
                },
                "dismiss": {
                  "commands": {},
                  "flags": {}
                },
                "get": {
                  "commands": {},
                  "flags": {}
                },
                "invalidate": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--state": "value"
                  }
                }
              },
              "flags": {}
            },
            "settings": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "get": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--active_key_version": "value",
                    "--enrolled_services": "value",
                    "--folder": "value",
                    "--notification_emails": "value",
                    "--notification_pubsub_topic": "value",
                    "--organization": "value",
                    "--prefer_no_broad_approval_requests": "value",
                    "--preferred_request_expiration_days": "value",
                    "--request_scope_max_width_preference": [
                      "FOLDER",
                      "ORGANIZATION",
                      "PROJECT"
                    ],
                    "--require_customer_visible_justification": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "access-context-manager": {
          "commands": {
            "levels": {
              "commands": {
                "conditions": {
                  "commands": {
                    "list": {
                      "commands": {},
                      "flags": {
                        "--level": "value",
                        "--policy": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--basic-level-spec": "value",
                    "--combine-function": [
                      "and",
                      "or"
                    ],
                    "--custom-level-spec": "value",
                    "--description": "value",
                    "--policy": "value",
                    "--title": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--policy": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--policy": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--policy": "value",
                    "--sort-by": "value"
                  }
                },
                "replace-all": {
                  "commands": {},
                  "flags": {
                    "--etag": "value",
                    "--source-file": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--basic-level-spec": "value",
                    "--combine-function": [
                      "and",
                      "or"
                    ],
                    "--custom-level-spec": "value",
                    "--description": "value",
                    "--policy": "value",
                    "--title": "value"
                  }
                }
              },
              "flags": {}
            },
            "perimeters": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--access-levels": "value",
                    "--async": "bool",
                    "--description": "value",
                    "--egress-policies": "value",
                    "--enable-vpc-accessible-services": "bool",
                    "--ingress-policies": "value",
                    "--perimeter-type": [
                      "bridge",
                      "regular"
                    ],
                    "--policy": "value",
                    "--resources": "value",
                    "--restricted-services": "value",
                    "--title": "value",
                    "--vpc-allowed-services": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--policy": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--policy": "value"
                  }
                },
                "dry-run": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--access-levels": "value",
                        "--async": "bool",
                        "--egress-policies": "value",
                        "--enable-vpc-accessible-services": "bool",
                        "--ingress-policies": "value",
                        "--perimeter-access-levels": "value",
                        "--perimeter-description": "value",
                        "--perimeter-egress-policies": "value",
                        "--perimeter-enable-vpc-accessible-services": "bool",
                        "--perimeter-ingress-policies": "value",
                        "--perimeter-resources": "value",
                        "--perimeter-restricted-services": "value",
                        "--perimeter-title": "value",
                        "--perimeter-type": "value",
                        "--perimeter-vpc-allowed-services": "value",
                        "--policy": "value",
                        "--resources": "value",
                        "--restricted-services": "value",
                        "--vpc-allowed-services": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--policy": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--policy": "value"
                      }
                    },
                    "drop": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--policy": "value"
                      }
                    },
                    "enforce": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--policy": "value"
                      }
                    },
                    "enforce-all": {
                      "commands": {},
                      "flags": {
                        "--etag": "value",
                        "--policy": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--policy": "value",
                        "--sort-by": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--add-access-levels": "value",
                        "--add-resources": "value",
                        "--add-restricted-services": "value",
                        "--add-vpc-allowed-services": "value",
                        "--async": "bool",
                        "--clear-access-levels": "bool",
                        "--clear-egress-policies": "bool",
                        "--clear-ingress-policies": "bool",
                        "--clear-resources": "bool",
                        "--clear-restricted-services": "bool",
                        "--clear-vpc-allowed-services": "bool",
                        "--enable-vpc-accessible-services": "bool",
                        "--etag": "value",
                        "--policy": "value",
                        "--remove-access-levels": "value",
                        "--remove-resources": "value",
                        "--remove-restricted-services": "value",
                        "--remove-vpc-allowed-services": "value",
                        "--set-egress-policies": "value",
                        "--set-ingress-policies": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--policy": "value",
                    "--sort-by": "value"
                  }
                },
                "replace-all": {
                  "commands": {},
                  "flags": {
                    "--etag": "value",
                    "--source-file": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-access-levels": "value",
                    "--add-resources": "value",
                    "--add-restricted-services": "value",
                    "--add-vpc-allowed-services": "value",
                    "--clear-access-levels": "bool",
                    "--clear-egress-policies": "bool",
                    "--clear-ingress-policies": "bool",
                    "--clear-resources": "bool",
                    "--clear-restricted-services": "bool",
                    "--clear-vpc-allowed-services": "bool",
                    "--description": "value",
                    "--enable-vpc-accessible-services": "bool",
                    "--etag": "value",
                    "--policy": "value",
                    "--remove-access-levels": "value",
                    "--remove-resources": "value",
                    "--remove-restricted-services": "value",
                    "--remove-vpc-allowed-services": "value",
                    "--set-access-levels": "value",
                    "--set-egress-policies": "value",
                    "--set-ingress-policies": "value",
                    "--set-resources": "value",
                    "--set-restricted-services": "value",
                    "--title": "value",
                    "--type": [
                      "bridge",
                      "regular"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "policies": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--organization": "value",
                    "--scopes": "value",
                    "--title": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--title": "value"
                  }
                }
              },
              "flags": {}
            },
            "supported-services": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "active-directory": {
          "commands": {
            "domains": {
              "commands": {
                "backups": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--domain": "value",
                        "--labels": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--domain": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--domain": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--domain": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--domain": "value",
                        "--remove-labels": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--admin-name": "value",
                    "--async": "bool",
                    "--authorized-networks": "value",
                    "--enable-audit-logs": "bool",
                    "--labels": "value",
                    "--region": "value",
                    "--reserved-ip-range": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "describe-ldaps-settings": {
                  "commands": {},
                  "flags": {}
                },
                "extend-schema": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--ldif-file": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "migration": {
                  "commands": {
                    "check-permissions": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--async": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--disable-sid-filtering-domains": "value",
                        "--onprem-domains": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "reset-admin-password": {
                  "commands": {},
                  "flags": {}
                },
                "restore": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--backup": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "sql-integrations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--domain": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--domain": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "trusts": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--direction": [
                          "bidirectional",
                          "inbound",
                          "outbound",
                          "trust-direction-unspecified"
                        ],
                        "--handshake-secret": "value",
                        "--selective-authentication": "bool",
                        "--target-dns-ip-addresses": "value",
                        "--target-domain-name": "value",
                        "--type": [
                          "external",
                          "forest",
                          "trust-type-unspecified"
                        ]
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--target-domain-name": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--target-dns-ip-addresses": "value",
                        "--target-domain-name": "value"
                      }
                    },
                    "validate-state": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--target-domain-name": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-authorized-networks": "value",
                    "--add-region": "value",
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--enable-audit-logs": "bool",
                    "--remove-authorized-networks": "value",
                    "--remove-labels": "value",
                    "--remove-region": "value",
                    "--update-labels": "value"
                  }
                },
                "update-ldaps-settings": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--certificate-password": "value",
                    "--certificate-pfx-file": "value",
                    "--clear-certificates": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "peerings": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--authorized-network": "value",
                    "--domain": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "ai": {
          "commands": {
            "custom-jobs": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--args": "value",
                    "--command": "value",
                    "--config": "value",
                    "--display-name": "value",
                    "--enable-dashboard-access": "bool",
                    "--enable-web-access": "bool",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--network": "value",
                    "--persistent-resource-id": "value",
                    "--python-package-uris": "value",
                    "--region": "value",
                    "--service-account": "value",
                    "--worker-pool-spec": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "local-run": {
                  "commands": {},
                  "flags": {
                    "--executor-image-uri": "value",
                    "--extra-dirs": "value",
                    "--extra-packages": "value",
                    "--gpu": "bool",
                    "--local-package-path": "value",
                    "--output-image-uri": "value",
                    "--python-module": "value",
                    "--requirements": "value",
                    "--script": "value",
                    "--service-account-key-file": "value"
                  }
                },
                "stream-logs": {
                  "commands": {},
                  "flags": {
                    "--allow-multiline-logs": "bool",
                    "--polling-interval": "value",
                    "--region": "dynamic",
                    "--task-name": "value"
                  }
                }
              },
              "flags": {}
            },
            "endpoints": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--encryption-kms-key-name": "value",
                    "--endpoint-id": "value",
                    "--gdce-zone": "value",
                    "--labels": "value",
                    "--network": "value",
                    "--region": "value",
                    "--request-response-logging-rate": "value",
                    "--request-response-logging-table": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "deploy-model": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--autoscaling-metric-specs": "value",
                    "--deployed-model-id": "value",
                    "--display-name": "value",
                    "--enable-access-logging": "bool",
                    "--enable-container-logging": "bool",
                    "--machine-type": "value",
                    "--max-replica-count": "value",
                    "--min-replica-count": "value",
                    "--model": "value",
                    "--region": "dynamic",
                    "--reservation-affinity": "value",
                    "--service-account": "value",
                    "--shared-resources": "dynamic",
                    "--shared-resources-region": "dynamic",
                    "--spot": "bool",
                    "--tpu-topology": "value",
                    "--traffic-split": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "direct-predict": {
                  "commands": {},
                  "flags": {
                    "--json-request": "value",
                    "--region": "dynamic"
                  }
                },
                "direct-raw-predict": {
                  "commands": {},
                  "flags": {
                    "--json-request": "value",
                    "--region": "dynamic"
                  }
                },
                "explain": {
                  "commands": {},
                  "flags": {
                    "--deployed-model-id": "value",
                    "--json-request": "value",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "predict": {
                  "commands": {},
                  "flags": {
                    "--json-request": "value",
                    "--region": "dynamic"
                  }
                },
                "raw-predict": {
                  "commands": {},
                  "flags": {
                    "--http-headers": "value",
                    "--region": "dynamic",
                    "--request": "value"
                  }
                },
                "stream-direct-predict": {
                  "commands": {},
                  "flags": {
                    "--json-request": "value",
                    "--region": "dynamic"
                  }
                },
                "stream-direct-raw-predict": {
                  "commands": {},
                  "flags": {
                    "--json-request": "value",
                    "--region": "dynamic"
                  }
                },
                "stream-raw-predict": {
                  "commands": {},
                  "flags": {
                    "--http-headers": "value",
                    "--region": "dynamic",
                    "--request": "value"
                  }
                },
                "undeploy-model": {
                  "commands": {},
                  "flags": {
                    "--deployed-model-id": "value",
                    "--region": "dynamic",
                    "--traffic-split": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--clear-traffic-split": "bool",
                    "--description": "value",
                    "--disable-request-response-logging": "bool",
                    "--display-name": "value",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--request-response-logging-rate": "value",
                    "--request-response-logging-table": "value",
                    "--traffic-split": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "hp-tuning-jobs": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--algorithm": [
                      "algorithm-unspecified",
                      "grid-search",
                      "random-search"
                    ],
                    "--config": "value",
                    "--display-name": "value",
                    "--enable-dashboard-access": "bool",
                    "--enable-web-access": "bool",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--max-trial-count": "value",
                    "--network": "value",
                    "--parallel-trial-count": "value",
                    "--region": "value",
                    "--service-account": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "stream-logs": {
                  "commands": {},
                  "flags": {
                    "--allow-multiline-logs": "bool",
                    "--polling-interval": "value",
                    "--region": "dynamic",
                    "--task-name": "value"
                  }
                }
              },
              "flags": {}
            },
            "index-endpoints": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--enable-private-service-connect": "bool",
                    "--encryption-kms-key-name": "value",
                    "--labels": "value",
                    "--network": "value",
                    "--project-allowlist": "value",
                    "--public-endpoint-enabled": "bool",
                    "--region": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "deploy-index": {
                  "commands": {},
                  "flags": {
                    "--allowed-issuers": "value",
                    "--audiences": "value",
                    "--deployed-index-id": "value",
                    "--deployment-group": "value",
                    "--display-name": "value",
                    "--enable-access-logging": "bool",
                    "--index": "value",
                    "--machine-type": "value",
                    "--max-replica-count": "value",
                    "--min-replica-count": "value",
                    "--psc-automation-configs": "value",
                    "--region": "dynamic",
                    "--reserved-ip-ranges": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "mutate-deployed-index": {
                  "commands": {},
                  "flags": {
                    "--allowed-issuers": "value",
                    "--audiences": "value",
                    "--deployed-index-id": "value",
                    "--deployment-group": "value",
                    "--enable-access-logging": "bool",
                    "--machine-type": "value",
                    "--max-replica-count": "value",
                    "--min-replica-count": "value",
                    "--region": "dynamic",
                    "--reserved-ip-ranges": "value"
                  }
                },
                "undeploy-index": {
                  "commands": {},
                  "flags": {
                    "--deployed-index-id": "value",
                    "--region": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "indexes": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--encryption-kms-key-name": "value",
                    "--index-update-method": [
                      "batch-update",
                      "stream-update"
                    ],
                    "--labels": "value",
                    "--metadata-file": "value",
                    "--metadata-schema-uri": "value",
                    "--region": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-datapoints": {
                  "commands": {},
                  "flags": {
                    "--datapoint-ids": "value",
                    "--datapoints-from-file": "value",
                    "--region": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--metadata-file": "value",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                },
                "upsert-datapoints": {
                  "commands": {},
                  "flags": {
                    "--datapoints-from-file": "value",
                    "--region": "dynamic",
                    "--update-mask": "value"
                  }
                }
              },
              "flags": {}
            },
            "model-monitoring-jobs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--analysis-instance-schema": "value",
                    "--anomaly-cloud-logging": "bool",
                    "--bigquery-uri": "value",
                    "--data-format": "value",
                    "--dataset": "value",
                    "--display-name": "value",
                    "--emails": "value",
                    "--endpoint": "value",
                    "--feature-attribution-thresholds": "value",
                    "--feature-thresholds": "value",
                    "--gcs-uris": "value",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--log-ttl": "value",
                    "--monitoring-config-from-file": "value",
                    "--monitoring-frequency": "value",
                    "--notification-channels": "value",
                    "--predict-instance-schema": "value",
                    "--prediction-sampling-rate": "value",
                    "--region": "value",
                    "--sample-predict-request": "value",
                    "--target-field": "value",
                    "--training-sampling-rate": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "pause": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "resume": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--analysis-instance-schema": "value",
                    "--anomaly-cloud-logging": "bool",
                    "--clear-labels": "bool",
                    "--display-name": "value",
                    "--emails": "value",
                    "--feature-attribution-thresholds": "value",
                    "--feature-thresholds": "value",
                    "--log-ttl": "value",
                    "--monitoring-config-from-file": "value",
                    "--monitoring-frequency": "value",
                    "--notification-channels": "value",
                    "--prediction-sampling-rate": "value",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "models": {
              "commands": {
                "copy": {
                  "commands": {},
                  "flags": {
                    "--destination-model-id": "value",
                    "--destination-parent-model": "value",
                    "--kms-key-name": "value",
                    "--region": "value",
                    "--source-model": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "delete-version": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-version": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "upload": {
                  "commands": {},
                  "flags": {
                    "--artifact-uri": "value",
                    "--container-args": "value",
                    "--container-command": "value",
                    "--container-deployment-timeout-seconds": "value",
                    "--container-env-vars": "value",
                    "--container-grpc-ports": "value",
                    "--container-health-probe-exec": "value",
                    "--container-health-probe-period-seconds": "value",
                    "--container-health-probe-timeout-seconds": "value",
                    "--container-health-route": "value",
                    "--container-image-uri": "value",
                    "--container-ports": "value",
                    "--container-predict-route": "value",
                    "--container-shared-memory-size-mb": "value",
                    "--container-startup-probe-exec": "value",
                    "--container-startup-probe-period-seconds": "value",
                    "--container-startup-probe-timeout-seconds": "value",
                    "--description": "value",
                    "--display-name": "value",
                    "--explanation-metadata-file": "value",
                    "--explanation-method": "value",
                    "--explanation-modality": "value",
                    "--explanation-nearest-neighbor-search-config-file": "value",
                    "--explanation-neighbor-count": "value",
                    "--explanation-path-count": "value",
                    "--explanation-query": "value",
                    "--explanation-step-count": "value",
                    "--labels": "value",
                    "--model-id": "value",
                    "--parent-model": "value",
                    "--region": "value",
                    "--smooth-grad-noise-sigma": "value",
                    "--smooth-grad-noise-sigma-by-feature": "value",
                    "--smooth-grad-noisy-sample-count": "value",
                    "--uris": "value",
                    "--version-aliases": "value",
                    "--version-description": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--index": "value",
                    "--index-endpoint": "value",
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "persistent-resources": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--config": "value",
                    "--display-name": "value",
                    "--enable-custom-service-account": "bool",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--network": "value",
                    "--persistent-resource-id": "value",
                    "--region": "value",
                    "--resource-pool-spec": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "reboot": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "tensorboard-experiments": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--labels": "value",
                    "--region": "dynamic",
                    "--tensorboard-experiment-id": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--tensorboard-id": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--tensorboard-id": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--tensorboard-id": "dynamic",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "tensorboard-runs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--labels": "value",
                    "--region": "dynamic",
                    "--tensorboard-id": "dynamic",
                    "--tensorboard-run-id": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--tensorboard-experiment-id": "dynamic",
                    "--tensorboard-id": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--tensorboard-experiment-id": "dynamic",
                    "--tensorboard-id": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--tensorboard-experiment-id": "dynamic",
                    "--tensorboard-id": "dynamic",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--tensorboard-experiment-id": "dynamic",
                    "--tensorboard-id": "dynamic",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "tensorboard-time-series": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--plugin-data": "value",
                    "--plugin-name": "value",
                    "--region": "dynamic",
                    "--tensorboard-experiment-id": "dynamic",
                    "--tensorboard-id": "dynamic",
                    "--type": [
                      "blob-sequence",
                      "scalar",
                      "tensor"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--tensorboard-experiment-id": "dynamic",
                    "--tensorboard-id": "dynamic",
                    "--tensorboard-run-id": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--tensorboard-experiment-id": "dynamic",
                    "--tensorboard-id": "dynamic",
                    "--tensorboard-run-id": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--tensorboard-experiment-id": "dynamic",
                    "--tensorboard-id": "dynamic",
                    "--tensorboard-run-id": "dynamic",
                    "--uri": "bool"
                  }
                },
                "read": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--max-data-points": "value",
                    "--region": "dynamic",
                    "--tensorboard-experiment-id": "dynamic",
                    "--tensorboard-id": "dynamic",
                    "--tensorboard-run-id": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--plugin-data": "value",
                    "--plugin-name": "value",
                    "--region": "dynamic",
                    "--tensorboard-experiment-id": "dynamic",
                    "--tensorboard-id": "dynamic",
                    "--tensorboard-run-id": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "tensorboards": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--region": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "ai-platform": {
          "commands": {
            "explain": {
              "commands": {},
              "flags": {
                "--json-instances": "value",
                "--json-request": "value",
                "--model": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--text-instances": "value"
              }
            },
            "jobs": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--summarize": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "stream-logs": {
                  "commands": {},
                  "flags": {
                    "--allow-multiline-logs": "bool",
                    "--polling-interval": "value",
                    "--task-name": "value"
                  }
                },
                "submit": {
                  "commands": {
                    "prediction": {
                      "commands": {},
                      "flags": {
                        "--batch-size": "value",
                        "--data-format": [
                          "text",
                          "tf-record",
                          "tf-record-gzip"
                        ],
                        "--input-paths": "value",
                        "--labels": "value",
                        "--max-worker-count": "value",
                        "--model": "value",
                        "--model-dir": "value",
                        "--output-path": "value",
                        "--region": "value",
                        "--runtime-version": "value",
                        "--signature-name": "value"
                      }
                    },
                    "training": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--config": "value",
                        "--enable-web-access": "bool",
                        "--job-dir": "value",
                        "--kms-key": "dynamic",
                        "--kms-keyring": "dynamic",
                        "--kms-location": "dynamic",
                        "--kms-project": "dynamic",
                        "--labels": "value",
                        "--master-accelerator": "value",
                        "--master-image-uri": "value",
                        "--master-machine-type": "value",
                        "--module-name": "value",
                        "--network": "value",
                        "--package-path": "value",
                        "--packages": "value",
                        "--parameter-server-accelerator": "value",
                        "--parameter-server-count": "value",
                        "--parameter-server-image-uri": "value",
                        "--parameter-server-machine-type": "value",
                        "--python-version": "value",
                        "--region": "dynamic",
                        "--runtime-version": "value",
                        "--scale-tier": [
                          "basic",
                          "basic-gpu",
                          "basic-tpu",
                          "custom",
                          "premium-1",
                          "standard-1"
                        ],
                        "--service-account": "value",
                        "--staging-bucket": "value",
                        "--stream-logs": "bool",
                        "--tpu-tf-version": "value",
                        "--use-chief-in-tf-config": "value",
                        "--worker-accelerator": "value",
                        "--worker-count": "value",
                        "--worker-image-uri": "value",
                        "--worker-machine-type": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "local": {
              "commands": {
                "predict": {
                  "commands": {},
                  "flags": {
                    "--framework": [
                      "scikit-learn",
                      "tensorflow",
                      "xgboost"
                    ],
                    "--json-instances": "value",
                    "--json-request": "value",
                    "--model-dir": "value",
                    "--signature-name": "value",
                    "--text-instances": "value"
                  }
                },
                "train": {
                  "commands": {},
                  "flags": {
                    "--distributed": "bool",
                    "--evaluator-count": "value",
                    "--job-dir": "value",
                    "--module-name": "value",
                    "--package-path": "value",
                    "--parameter-server-count": "value",
                    "--start-port": "value",
                    "--worker-count": "value"
                  }
                }
              },
              "flags": {}
            },
            "models": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--enable-console-logging": "bool",
                    "--enable-logging": "bool",
                    "--labels": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--regions": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--role": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "predict": {
              "commands": {},
              "flags": {
                "--json-instances": "value",
                "--json-request": "value",
                "--model": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--signature-name": "value",
                "--text-instances": "value"
              }
            },
            "versions": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--args": "value",
                    "--async": "bool",
                    "--command": "value",
                    "--config": "value",
                    "--description": "value",
                    "--env-vars": "value",
                    "--explanation-method": [
                      "integrated-gradients",
                      "sampled-shapley",
                      "xrai"
                    ],
                    "--framework": [
                      "scikit-learn",
                      "tensorflow",
                      "xgboost"
                    ],
                    "--health-route": "value",
                    "--image": "value",
                    "--labels": "value",
                    "--machine-type": "value",
                    "--max-nodes": "value",
                    "--metric-targets": "value",
                    "--min-nodes": "value",
                    "--model": "value",
                    "--num-integral-steps": "value",
                    "--num-paths": "value",
                    "--origin": "value",
                    "--package-uris": "value",
                    "--ports": "value",
                    "--predict-route": "value",
                    "--prediction-class": "value",
                    "--python-version": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--runtime-version": "value",
                    "--service-account": "value",
                    "--staging-bucket": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--model": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--model": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--model": "value",
                    "--page-size": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "set-default": {
                  "commands": {},
                  "flags": {
                    "--model": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--bigquery-table-name": "value",
                    "--clear-labels": "bool",
                    "--config": "value",
                    "--description": "value",
                    "--model": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--remove-labels": "value",
                    "--sampling-percentage": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "alloydb": {
          "commands": {
            "backups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster": "value",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--region": "value",
                    "--tags": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "clusters": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--allocated-ip-range-name": "value",
                    "--async": "bool",
                    "--automated-backup-days-of-week": "value",
                    "--automated-backup-encryption-key": "dynamic",
                    "--automated-backup-encryption-key-keyring": "dynamic",
                    "--automated-backup-encryption-key-location": "dynamic",
                    "--automated-backup-encryption-key-project": "dynamic",
                    "--automated-backup-retention-count": "value",
                    "--automated-backup-retention-period": "value",
                    "--automated-backup-start-times": "value",
                    "--automated-backup-window": "value",
                    "--continuous-backup-encryption-key": "dynamic",
                    "--continuous-backup-encryption-key-keyring": "dynamic",
                    "--continuous-backup-encryption-key-location": "dynamic",
                    "--continuous-backup-encryption-key-project": "dynamic",
                    "--continuous-backup-recovery-window-days": "value",
                    "--database-version": [
                      "POSTGRES_14",
                      "POSTGRES_15",
                      "POSTGRES_16"
                    ],
                    "--disable-automated-backup": "bool",
                    "--enable-continuous-backup": "bool",
                    "--enable-private-service-connect": "bool",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--maintenance-window-day": [
                      "MONDAY",
                      "TUESDAY",
                      "WEDNESDAY",
                      "THURSDAY",
                      "FRIDAY",
                      "SATURDAY",
                      "SUNDAY"
                    ],
                    "--maintenance-window-hour": "value",
                    "--network": "value",
                    "--password": "value",
                    "--region": "value",
                    "--subscription-type": [
                      "STANDARD",
                      "TRIAL"
                    ],
                    "--tags": "value"
                  }
                },
                "create-secondary": {
                  "commands": {},
                  "flags": {
                    "--allocated-ip-range-name": "value",
                    "--async": "bool",
                    "--automated-backup-days-of-week": "value",
                    "--automated-backup-encryption-key": "dynamic",
                    "--automated-backup-encryption-key-keyring": "dynamic",
                    "--automated-backup-encryption-key-location": "dynamic",
                    "--automated-backup-encryption-key-project": "dynamic",
                    "--automated-backup-retention-count": "value",
                    "--automated-backup-retention-period": "value",
                    "--automated-backup-start-times": "value",
                    "--automated-backup-window": "value",
                    "--continuous-backup-encryption-key": "dynamic",
                    "--continuous-backup-encryption-key-keyring": "dynamic",
                    "--continuous-backup-encryption-key-location": "dynamic",
                    "--continuous-backup-encryption-key-project": "dynamic",
                    "--continuous-backup-recovery-window-days": "value",
                    "--enable-automated-backup": "bool",
                    "--enable-continuous-backup": "bool",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--primary-cluster": "value",
                    "--region": "value",
                    "--tags": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--force": "bool",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clean-target-objects": "bool",
                    "--csv": "bool",
                    "--database": "value",
                    "--escape-character": "value",
                    "--field-delimiter": "value",
                    "--gcs-uri": "value",
                    "--if-exist-target-objects": "bool",
                    "--quote-character": "value",
                    "--region": "value",
                    "--schema-only": "bool",
                    "--select-query": "value",
                    "--sql": "bool",
                    "--tables": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "promote": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "restore": {
                  "commands": {},
                  "flags": {
                    "--allocated-ip-range-name": "value",
                    "--async": "bool",
                    "--backup": "value",
                    "--enable-private-service-connect": "bool",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--network": "value",
                    "--point-in-time": "value",
                    "--region": "value",
                    "--source-cluster": "value",
                    "--tags": "value"
                  }
                },
                "switchover": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--automated-backup-days-of-week": "value",
                    "--automated-backup-encryption-key": "dynamic",
                    "--automated-backup-encryption-key-keyring": "dynamic",
                    "--automated-backup-encryption-key-location": "dynamic",
                    "--automated-backup-encryption-key-project": "dynamic",
                    "--automated-backup-retention-count": "value",
                    "--automated-backup-retention-period": "value",
                    "--automated-backup-start-times": "value",
                    "--automated-backup-window": "value",
                    "--clear-automated-backup": "bool",
                    "--clear-continuous-backup-encryption-key": "bool",
                    "--continuous-backup-encryption-key": "dynamic",
                    "--continuous-backup-encryption-key-keyring": "dynamic",
                    "--continuous-backup-encryption-key-location": "dynamic",
                    "--continuous-backup-encryption-key-project": "dynamic",
                    "--continuous-backup-recovery-window-days": "value",
                    "--disable-automated-backup": "bool",
                    "--enable-continuous-backup": "bool",
                    "--maintenance-window-any": "bool",
                    "--maintenance-window-day": [
                      "MONDAY",
                      "TUESDAY",
                      "WEDNESDAY",
                      "THURSDAY",
                      "FRIDAY",
                      "SATURDAY",
                      "SUNDAY"
                    ],
                    "--maintenance-window-hour": "value",
                    "--region": "value",
                    "--subscription-type": [
                      "STANDARD",
                      "TRIAL"
                    ]
                  }
                },
                "upgrade": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                }
              },
              "flags": {}
            },
            "instances": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--allowed-psc-projects": "value",
                    "--assign-inbound-public-ip": "value",
                    "--async": "bool",
                    "--authorized-external-networks": "value",
                    "--availability-type": [
                      "REGIONAL",
                      "ZONAL"
                    ],
                    "--cluster": "value",
                    "--cpu-count": [
                      2,
                      4,
                      8,
                      16,
                      32,
                      64,
                      96,
                      128
                    ],
                    "--database-flags": "value",
                    "--insights-config-query-plans-per-minute": "value",
                    "--insights-config-query-string-length": "value",
                    "--insights-config-record-application-tags": "bool",
                    "--insights-config-record-client-address": "bool",
                    "--instance-type": [
                      "PRIMARY",
                      "READ_POOL"
                    ],
                    "--observability-config-enabled": "bool",
                    "--observability-config-max-query-string-length": "value",
                    "--observability-config-preserve-comments": "bool",
                    "--observability-config-query-plans-per-minute": "value",
                    "--observability-config-record-application-tags": "bool",
                    "--observability-config-track-active-queries": "bool",
                    "--observability-config-track-wait-events": "bool",
                    "--outbound-public-ip": "bool",
                    "--read-pool-node-count": "value",
                    "--region": "value",
                    "--require-connectors": "bool",
                    "--ssl-mode": [
                      "ALLOW_UNENCRYPTED_AND_ENCRYPTED",
                      "ENCRYPTED_ONLY"
                    ]
                  }
                },
                "create-secondary": {
                  "commands": {},
                  "flags": {
                    "--allowed-psc-projects": "value",
                    "--assign-inbound-public-ip": "value",
                    "--async": "bool",
                    "--authorized-external-networks": "value",
                    "--availability-type": [
                      "REGIONAL",
                      "ZONAL"
                    ],
                    "--cluster": "value",
                    "--outbound-public-ip": "bool",
                    "--region": "value",
                    "--require-connectors": "bool",
                    "--ssl-mode": [
                      "ALLOW_UNENCRYPTED_AND_ENCRYPTED",
                      "ENCRYPTED_ONLY"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster": "value",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--region": "value",
                    "--view": [
                      "basic",
                      "full"
                    ]
                  }
                },
                "failover": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster": "value",
                    "--region": "value"
                  }
                },
                "inject-fault": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster": "value",
                    "--fault-type": [
                      "stop-vm"
                    ],
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "restart": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster": "value",
                    "--node-ids": "value",
                    "--region": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--allowed-psc-projects": "value",
                    "--assign-inbound-public-ip": "value",
                    "--async": "bool",
                    "--authorized-external-networks": "value",
                    "--availability-type": [
                      "REGIONAL",
                      "ZONAL"
                    ],
                    "--cluster": "value",
                    "--cpu-count": [
                      2,
                      4,
                      8,
                      16,
                      32,
                      64,
                      96,
                      128
                    ],
                    "--database-flags": "value",
                    "--insights-config-query-plans-per-minute": "value",
                    "--insights-config-query-string-length": "value",
                    "--insights-config-record-application-tags": "bool",
                    "--insights-config-record-client-address": "bool",
                    "--observability-config-enabled": "bool",
                    "--observability-config-max-query-string-length": "value",
                    "--observability-config-preserve-comments": "bool",
                    "--observability-config-query-plans-per-minute": "value",
                    "--observability-config-record-application-tags": "bool",
                    "--observability-config-track-active-queries": "bool",
                    "--observability-config-track-wait-events": "bool",
                    "--outbound-public-ip": "bool",
                    "--read-pool-node-count": "value",
                    "--region": "value",
                    "--require-connectors": "bool",
                    "--ssl-mode": [
                      "ALLOW_UNENCRYPTED_AND_ENCRYPTED",
                      "ENCRYPTED_ONLY"
                    ],
                    "--update-mode": [
                      "FORCE_APPLY"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "users": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--db-roles": "value",
                    "--keep-extra-roles": "value",
                    "--password": "value",
                    "--region": "value",
                    "--superuser": "value",
                    "--type": [
                      "BUILT_IN",
                      "IAM_BASED"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "set-password": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--password": "value",
                    "--region": "value"
                  }
                },
                "set-roles": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--db-roles": "value",
                    "--keep-extra-roles": "value",
                    "--region": "value"
                  }
                },
                "set-superuser": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--region": "value",
                    "--superuser": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "anthos": {
          "commands": {
            "apply": {
              "commands": {},
              "flags": {}
            },
            "auth": {
              "commands": {
                "login": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--dry-run": "bool",
                    "--kubeconfig": "value",
                    "--login-config": "value",
                    "--login-config-cert": "value",
                    "--no-browser": "bool",
                    "--remote-bootstrap": "value",
                    "--server": "value",
                    "--set-preferred-auth": "bool",
                    "--user": "value"
                  }
                }
              },
              "flags": {}
            },
            "create-login-config": {
              "commands": {},
              "flags": {
                "--kubeconfig": "value",
                "--merge-from": "value",
                "--output": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--output-directory": "value"
              }
            }
          },
          "flags": {}
        },
        "api-gateway": {
          "commands": {
            "api-configs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--api": "value",
                    "--async": "bool",
                    "--backend-auth-service-account": "value",
                    "--display-name": "value",
                    "--grpc-files": "value",
                    "--labels": "value",
                    "--openapi-spec": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--api": "value",
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--api": "value",
                    "--view": [
                      "BASIC",
                      "FULL"
                    ]
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--api": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--api": "value",
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--display-name": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "apis": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--display-name": "value",
                    "--labels": "value",
                    "--managed-service": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--display-name": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "gateways": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--api": "value",
                    "--api-config": "value",
                    "--async": "bool",
                    "--display-name": "value",
                    "--labels": "value",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--api": "value",
                    "--api-config": "value",
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--display-name": "value",
                    "--location": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "apigee": {
          "commands": {
            "apis": {
              "commands": {
                "deploy": {
                  "commands": {},
                  "flags": {
                    "--api": "value",
                    "--environment": "value",
                    "--organization": "value",
                    "--override": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--organization": "value",
                    "--verbose": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "undeploy": {
                  "commands": {},
                  "flags": {
                    "--api": "value",
                    "--environment": "value",
                    "--organization": "value"
                  }
                }
              },
              "flags": {}
            },
            "applications": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--developer": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "archives": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--environment": "value",
                    "--organization": "value"
                  }
                },
                "deploy": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--bundle-file": "value",
                    "--environment": "value",
                    "--labels": "value",
                    "--organization": "value",
                    "--source": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--environment": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--environment": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--environment": "value",
                    "--organization": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "deployments": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--api": "value",
                    "--environment": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--api": "value",
                    "--environment": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--revision": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "developers": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "environments": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "organizations": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "products": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--all-environments": "bool",
                    "--all-proxies": "bool",
                    "--apis": "value",
                    "--attributes": "value",
                    "--description": "value",
                    "--display-name": "value",
                    "--environments": "value",
                    "--internal-access": "bool",
                    "--manual-approval": "bool",
                    "--oauth-scopes": "value",
                    "--organization": "value",
                    "--private-access": "bool",
                    "--public-access": "bool",
                    "--quota": "value",
                    "--quota-interval": "value",
                    "--quota-unit": [
                      "day",
                      "hour",
                      "minute",
                      "month"
                    ],
                    "--resources": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-api": "value",
                    "--add-attribute": "value",
                    "--add-environment": "value",
                    "--add-oauth-scope": "value",
                    "--add-resource": "value",
                    "--all-apis": "bool",
                    "--all-environments": "bool",
                    "--all-resources": "bool",
                    "--automatic-approval": "bool",
                    "--clear-attributes": "bool",
                    "--clear-description": "bool",
                    "--clear-oauth-scopes": "bool",
                    "--clear-quota": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--internal-access": "bool",
                    "--manual-approval": "bool",
                    "--organization": "value",
                    "--private-access": "bool",
                    "--public-access": "bool",
                    "--quota": "value",
                    "--quota-interval": "value",
                    "--quota-unit": [
                      "day",
                      "hour",
                      "minute",
                      "month"
                    ],
                    "--remove-api": "value",
                    "--remove-attribute": "value",
                    "--remove-environment": "value",
                    "--remove-oauth-scope": "value",
                    "--remove-resource": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "app": {
          "commands": {
            "browse": {
              "commands": {},
              "flags": {
                "--launch-browser": "bool",
                "--service": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--region": "value",
                "--service-account": "value"
              }
            },
            "deploy": {
              "commands": {},
              "flags": {
                "--appyaml": "value",
                "--bucket": "value",
                "--cache": "bool",
                "--ignore-file": "value",
                "--image-url": "value",
                "--promote": "bool",
                "--service-account": "value",
                "--stop-previous-version": "bool"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "domain-mappings": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--certificate-id": "value",
                    "--certificate-management": [
                      "automatic",
                      "manual"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--certificate-id": "value",
                    "--certificate-management": [
                      "automatic",
                      "manual"
                    ],
                    "--no-certificate-id": "bool"
                  }
                }
              },
              "flags": {}
            },
            "firewall-rules": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--action": [
                      "ALLOW",
                      "DENY"
                    ],
                    "--description": "value",
                    "--source-range": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "test-ip": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--action": [
                      "ALLOW",
                      "DENY"
                    ],
                    "--description": "value",
                    "--source-range": "value"
                  }
                }
              },
              "flags": {}
            },
            "gen-config": {
              "commands": {},
              "flags": {
                "--config": "value",
                "--custom": "bool",
                "--runtime": "value"
              }
            },
            "instances": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--service": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--service": "value"
                  }
                },
                "disable-debug": {
                  "commands": {},
                  "flags": {
                    "--service": "value"
                  }
                },
                "enable-debug": {
                  "commands": {},
                  "flags": {
                    "--service": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--service": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "scp": {
                  "commands": {},
                  "flags": {
                    "--compress": "bool",
                    "--recurse": "bool",
                    "--service": "value",
                    "--tunnel-through-iap": "bool"
                  }
                },
                "ssh": {
                  "commands": {},
                  "flags": {
                    "--container": "value",
                    "--service": "value",
                    "--tunnel-through-iap": "bool"
                  }
                }
              },
              "flags": {}
            },
            "logs": {
              "commands": {
                "read": {
                  "commands": {},
                  "flags": {
                    "--level": [
                      "any",
                      "critical",
                      "debug",
                      "error",
                      "info",
                      "warning"
                    ],
                    "--limit": "value",
                    "--logs": "value",
                    "--service": "value"
                  }
                },
                "tail": {
                  "commands": {},
                  "flags": {
                    "--level": [
                      "any",
                      "critical",
                      "debug",
                      "error",
                      "info",
                      "warning"
                    ],
                    "--logs": "value",
                    "--service": "value"
                  }
                }
              },
              "flags": {}
            },
            "migrate-config": {
              "commands": {
                "cron-xml-to-yaml": {
                  "commands": {},
                  "flags": {}
                },
                "datastore-indexes-xml-to-yaml": {
                  "commands": {},
                  "flags": {
                    "--generated-indexes-file": "value"
                  }
                },
                "dispatch-xml-to-yaml": {
                  "commands": {},
                  "flags": {}
                },
                "queue-xml-to-yaml": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "open-console": {
              "commands": {},
              "flags": {
                "--logs": "bool",
                "--service": "value"
              }
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--pending": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "regions": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "repair": {
              "commands": {},
              "flags": {}
            },
            "runtimes": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--environment": [
                      "standard"
                    ],
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "services": {
              "commands": {
                "browse": {
                  "commands": {},
                  "flags": {
                    "--launch-browser": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "set-traffic": {
                  "commands": {},
                  "flags": {
                    "--migrate": "bool",
                    "--split-by": [
                      "cookie",
                      "ip",
                      "random"
                    ],
                    "--splits": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--ingress": [
                      "all",
                      "internal-and-cloud-load-balancing",
                      "internal-only"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "ssl-certificates": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--certificate": "value",
                    "--display-name": "value",
                    "--private-key": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--certificate": "value",
                    "--display-name": "value",
                    "--private-key": "value"
                  }
                }
              },
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--service-account": "value",
                "--split-health-checks": "bool"
              }
            },
            "versions": {
              "commands": {
                "browse": {
                  "commands": {},
                  "flags": {
                    "--launch-browser": "bool",
                    "--service": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--service": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--service": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--hide-no-traffic": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--service": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "migrate": {
                  "commands": {},
                  "flags": {
                    "--service": "value"
                  }
                },
                "start": {
                  "commands": {},
                  "flags": {
                    "--service": "value"
                  }
                },
                "stop": {
                  "commands": {},
                  "flags": {
                    "--service": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "artifacts": {
          "commands": {
            "apt": {
              "commands": {
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--gcs-source": "value",
                    "--location": "value"
                  }
                },
                "upload": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                }
              },
              "flags": {}
            },
            "docker": {
              "commands": {
                "images": {
                  "commands": {
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--delete-tags": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--metadata-filter": "value",
                        "--show-all-metadata": "bool",
                        "--show-build-details": "bool",
                        "--show-deployment": "bool",
                        "--show-image-basis": "bool",
                        "--show-package-vulnerability": "bool",
                        "--show-provenance": "bool",
                        "--show-sbom-references": "bool"
                      }
                    },
                    "get-operation": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--include-tags": "bool",
                        "--limit": "value",
                        "--occurrence-filter": "value",
                        "--page-size": "value",
                        "--show-occurrences": "bool",
                        "--show-occurrences-from": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list-vulnerabilities": {
                      "commands": {},
                      "flags": {
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value"
                      }
                    },
                    "scan": {
                      "commands": {},
                      "flags": {
                        "--additional-package-types": "value",
                        "--async": "bool",
                        "--location": [
                          "asia",
                          "europe",
                          "us"
                        ],
                        "--remote": "bool",
                        "--skip-package-types": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "tags": {
                  "commands": {
                    "add": {
                      "commands": {},
                      "flags": {}
                    },
                    "delete": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "upgrade": {
                  "commands": {
                    "print-iam-policy": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "files": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--package": "value",
                    "--page-size": "value",
                    "--repository": "value",
                    "--sort-by": "value",
                    "--tag": "value"
                  }
                }
              },
              "flags": {}
            },
            "generic": {
              "commands": {
                "download": {
                  "commands": {},
                  "flags": {
                    "--chunk-size": "value",
                    "--destination": "value",
                    "--location": "value",
                    "--name": "value",
                    "--package": "value",
                    "--repository": "value"
                  }
                },
                "upload": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--destination-path": "value",
                    "--location": "value",
                    "--package": "value",
                    "--repository": "value",
                    "--skip-existing": "bool",
                    "--source": "value",
                    "--source-directory": "value"
                  }
                }
              },
              "flags": {}
            },
            "go": {
              "commands": {
                "upload": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--module-path": "value",
                    "--repository": "value",
                    "--source": "value"
                  }
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "packages": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--repository": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--repository": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "print-settings": {
              "commands": {
                "apt": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--repository": "value"
                  }
                },
                "gradle": {
                  "commands": {},
                  "flags": {
                    "--json-key": "value",
                    "--location": "value",
                    "--repository": "value"
                  }
                },
                "mvn": {
                  "commands": {},
                  "flags": {
                    "--json-key": "value",
                    "--location": "value",
                    "--repository": "value"
                  }
                },
                "npm": {
                  "commands": {},
                  "flags": {
                    "--json-key": "value",
                    "--location": "value",
                    "--repository": "value",
                    "--scope": "value"
                  }
                },
                "python": {
                  "commands": {},
                  "flags": {
                    "--json-key": "value",
                    "--location": "value",
                    "--repository": "value"
                  }
                },
                "yum": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--repository": "value"
                  }
                }
              },
              "flags": {}
            },
            "repositories": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--allow-snapshot-overwrites": "bool",
                    "--async": "bool",
                    "--description": "value",
                    "--kms-key": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--repository-format": "value",
                    "--version-policy": [
                      "none",
                      "release",
                      "snapshot"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "settings": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "disable-upgrade-redirection": {
                  "commands": {},
                  "flags": {}
                },
                "enable-upgrade-redirection": {
                  "commands": {},
                  "flags": {
                    "--dry-run": "bool"
                  }
                }
              },
              "flags": {}
            },
            "tags": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--package": "value",
                    "--repository": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--package": "value",
                    "--repository": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--package": "value",
                    "--page-size": "value",
                    "--repository": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--package": "value",
                    "--repository": "value"
                  }
                }
              },
              "flags": {}
            },
            "versions": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--delete-tags": "bool",
                    "--location": "value",
                    "--package": "value",
                    "--repository": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--package": "value",
                    "--page-size": "value",
                    "--repository": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "vpcsc-config": {
              "commands": {
                "allow": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "deny": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "yum": {
              "commands": {
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--gcs-source": "value",
                    "--location": "value"
                  }
                },
                "upload": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "asset": {
          "commands": {
            "analyze-iam-policy": {
              "commands": {},
              "flags": {
                "--access-time": "value",
                "--analyze-service-account-impersonation": "bool",
                "--execution-timeout": "value",
                "--expand-groups": "bool",
                "--expand-resources": "bool",
                "--expand-roles": "bool",
                "--folder": "value",
                "--full-resource-name": "value",
                "--identity": "value",
                "--organization": "value",
                "--output-group-edges": "bool",
                "--output-resource-edges": "bool",
                "--permissions": "value",
                "--roles": "value",
                "--saved-analysis-query": "value",
                "--show-response": "bool"
              }
            },
            "analyze-iam-policy-longrunning": {
              "commands": {},
              "flags": {
                "--access-time": "value",
                "--analyze-service-account-impersonation": "bool",
                "--bigquery-dataset": "value",
                "--bigquery-partition-key": [
                  "PARTITION_KEY_UNSPECIFIED",
                  "REQUEST_TIME"
                ],
                "--bigquery-table-prefix": "value",
                "--bigquery-write-disposition": "value",
                "--expand-groups": "bool",
                "--expand-resources": "bool",
                "--expand-roles": "bool",
                "--folder": "value",
                "--full-resource-name": "value",
                "--gcs-output-path": "value",
                "--identity": "value",
                "--organization": "value",
                "--output-group-edges": "bool",
                "--output-resource-edges": "bool",
                "--permissions": "value",
                "--roles": "value"
              }
            },
            "analyze-org-policies": {
              "commands": {},
              "flags": {
                "--constraint": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--scope": "value",
                "--sort-by": "value"
              }
            },
            "analyze-org-policy-governed-assets": {
              "commands": {},
              "flags": {
                "--constraint": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--scope": "value",
                "--sort-by": "value"
              }
            },
            "analyze-org-policy-governed-containers": {
              "commands": {},
              "flags": {
                "--constraint": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--scope": "value",
                "--sort-by": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--asset-types": "value",
                "--bigquery-dataset": "dynamic",
                "--bigquery-table": "dynamic",
                "--content-type": [
                  "access-policy",
                  "iam-policy",
                  "org-policy",
                  "os-inventory",
                  "relationship",
                  "resource"
                ],
                "--folder": "value",
                "--organization": "value",
                "--output-bigquery-force": "bool",
                "--output-path": "value",
                "--output-path-prefix": "value",
                "--partition-key": [
                  "read-time",
                  "request-time"
                ],
                "--per-asset-type": "bool",
                "--relationship-types": "value",
                "--snapshot-time": "value"
              }
            },
            "feeds": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--asset-names": "value",
                    "--asset-types": "value",
                    "--condition-description": "value",
                    "--condition-expression": "value",
                    "--condition-title": "value",
                    "--content-type": [
                      "access-policy",
                      "iam-policy",
                      "org-policy",
                      "os-inventory",
                      "relationship",
                      "resource"
                    ],
                    "--folder": "value",
                    "--organization": "value",
                    "--pubsub-topic": "value",
                    "--relationship-types": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-asset-names": "value",
                    "--add-asset-types": "value",
                    "--add-relationship-types": "value",
                    "--clear-asset-names": "bool",
                    "--clear-asset-types": "bool",
                    "--clear-condition-description": "bool",
                    "--clear-condition-expression": "bool",
                    "--clear-condition-title": "bool",
                    "--clear-content-type": "bool",
                    "--clear-relationship-types": "bool",
                    "--condition-description": "value",
                    "--condition-expression": "value",
                    "--condition-title": "value",
                    "--content-type": [
                      "access-policy",
                      "iam-policy",
                      "org-policy",
                      "os-inventory",
                      "relationship",
                      "resource"
                    ],
                    "--folder": "value",
                    "--organization": "value",
                    "--pubsub-topic": "value",
                    "--remove-asset-names": "value",
                    "--remove-asset-types": "value",
                    "--remove-relationship-types": "value"
                  }
                }
              },
              "flags": {}
            },
            "get-history": {
              "commands": {},
              "flags": {
                "--asset-names": "value",
                "--content-type": [
                  "access-policy",
                  "iam-policy",
                  "org-policy",
                  "os-inventory",
                  "relationship",
                  "resource"
                ],
                "--end-time": "value",
                "--organization": "value",
                "--relationship-types": "value",
                "--start-time": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--asset-types": "value",
                "--content-type": [
                  "access-policy",
                  "iam-policy",
                  "org-policy",
                  "os-inventory",
                  "relationship",
                  "resource"
                ],
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--organization": "value",
                "--page-size": "value",
                "--relationship-types": "value",
                "--snapshot-time": "value",
                "--sort-by": "value"
              }
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "query": {
              "commands": {},
              "flags": {
                "--bigquery-dataset": "dynamic",
                "--bigquery-table": "dynamic",
                "--end-time": "value",
                "--folder": "value",
                "--job-reference": "value",
                "--organization": "value",
                "--page-size": "value",
                "--page-token": "value",
                "--snapshot-time": "value",
                "--start-time": "value",
                "--statement": "value",
                "--timeout": "value",
                "--write-disposition": [
                  "write-append",
                  "write-empty",
                  "write-truncate"
                ]
              }
            },
            "saved-queries": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--folder": "value",
                    "--labels": "value",
                    "--organization": "value",
                    "--query-file-path": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--folder": "value",
                    "--organization": "value",
                    "--query-file-path": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "search-all-iam-policies": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--query": "value",
                "--scope": "value",
                "--sort-by": "value"
              }
            },
            "search-all-resources": {
              "commands": {},
              "flags": {
                "--asset-types": "value",
                "--filter": "value",
                "--limit": "value",
                "--order-by": "value",
                "--page-size": "value",
                "--query": "value",
                "--scope": "value",
                "--sort-by": "value"
              }
            }
          },
          "flags": {}
        },
        "assured": {
          "commands": {
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "workloads": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--compliance-regime": [
                      "assured-workloads-for-partners",
                      "au-regions-and-us-support",
                      "ca-protected-b",
                      "ca-regions-and-support",
                      "canada-controlled-goods",
                      "cjis",
                      "eu-regions-and-support",
                      "fedramp-high",
                      "fedramp-moderate",
                      "healthcare-and-life-sciences-controls",
                      "healthcare-and-life-sciences-controls-us-support",
                      "hipaa",
                      "hitrust",
                      "il2",
                      "il4",
                      "il5",
                      "irs-1075",
                      "isr-regions",
                      "isr-regions-and-support",
                      "itar",
                      "jp-regions-and-support",
                      "ksa-regions-and-support-with-sovereignty-controls",
                      "regional-controls",
                      "us-regional-access"
                    ],
                    "--display-name": "value",
                    "--enable-sovereign-controls": "value",
                    "--external-identifier": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--next-rotation-time": "value",
                    "--organization": "value",
                    "--partner": [
                      "local-controls-by-s3ns",
                      "sovereign-controls-by-cntxt",
                      "sovereign-controls-by-cntxt-no-ekm",
                      "sovereign-controls-by-psn",
                      "sovereign-controls-by-sia-minsait",
                      "sovereign-controls-by-t-systems"
                    ],
                    "--partner-permissions": "value",
                    "--partner-services-billing-account": "value",
                    "--provisioned-resources-parent": "value",
                    "--resource-settings": "value",
                    "--rotation-period": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--etag": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "enable-resource-monitoring": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--display-name": "value",
                    "--etag": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--violation-notifications-enabled": "value"
                  }
                },
                "violations": {
                  "commands": {
                    "acknowledge": {
                      "commands": {},
                      "flags": {
                        "--acknowledge-type": "value",
                        "--comment": "value",
                        "--location": "value",
                        "--organization": "value",
                        "--workload": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--organization": "value",
                        "--workload": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--organization": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--workload": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "auth": {
          "commands": {
            "activate-service-account": {
              "commands": {},
              "flags": {
                "--key-file": "value",
                "--password-file": "value",
                "--prompt-for-password": "bool"
              }
            },
            "application-default": {
              "commands": {
                "login": {
                  "commands": {},
                  "flags": {
                    "--browser": "bool",
                    "--client-id-file": "value",
                    "--disable-quota-project": "bool",
                    "--launch-browser": "bool",
                    "--login-config": "value",
                    "--scopes": "value"
                  }
                },
                "print-access-token": {
                  "commands": {},
                  "flags": {
                    "--lifetime": "value",
                    "--scopes": "value"
                  }
                },
                "revoke": {
                  "commands": {},
                  "flags": {}
                },
                "set-quota-project": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "configure-docker": {
              "commands": {},
              "flags": {}
            },
            "enterprise-certificate-config": {
              "commands": {
                "create": {
                  "commands": {
                    "linux": {
                      "commands": {},
                      "flags": {
                        "--ecp": "value",
                        "--ecp-client": "value",
                        "--label": "value",
                        "--module": "value",
                        "--output-file": "value",
                        "--slot": "value",
                        "--tls-offload": "value",
                        "--user-pin": "value"
                      }
                    },
                    "macos": {
                      "commands": {},
                      "flags": {
                        "--ecp": "value",
                        "--ecp-client": "value",
                        "--issuer": "value",
                        "--output-file": "value",
                        "--tls-offload": "value"
                      }
                    },
                    "windows": {
                      "commands": {},
                      "flags": {
                        "--ecp": "value",
                        "--ecp-client": "value",
                        "--issuer": "value",
                        "--output-file": "value",
                        "--provider": "value",
                        "--store": "value",
                        "--tls-offload": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--filter-account": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "login": {
              "commands": {},
              "flags": {
                "--activate": "bool",
                "--brief": "bool",
                "--browser": "bool",
                "--cred-file": "value",
                "--enable-gdrive-access": "bool",
                "--force": "bool",
                "--launch-browser": "bool",
                "--login-config": "value",
                "--update-adc": "bool"
              }
            },
            "print-access-token": {
              "commands": {},
              "flags": {
                "--lifetime": "value"
              }
            },
            "print-identity-token": {
              "commands": {},
              "flags": {
                "--audiences": "value",
                "--include-email": "bool",
                "--include-license": "bool",
                "--token-format": [
                  "full",
                  "standard"
                ]
              }
            },
            "revoke": {
              "commands": {},
              "flags": {
                "--all": "bool"
              }
            }
          },
          "flags": {}
        },
        "backup-dr": {
          "commands": {
            "locations": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "management-servers": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic",
                    "--network": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "batch": {
          "commands": {
            "jobs": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "submit": {
                  "commands": {},
                  "flags": {
                    "--config": "value",
                    "--container-commands-file": "value",
                    "--container-entrypoint": "value",
                    "--container-image-uri": "value",
                    "--job-prefix": "value",
                    "--location": "value",
                    "--machine-type": "value",
                    "--network": "value",
                    "--no-external-ip-address": "bool",
                    "--priority": "value",
                    "--provisioning-model": [
                      "SPOT",
                      "STANDARD"
                    ],
                    "--script-file-path": "value",
                    "--script-text": "value",
                    "--subnetwork": "value"
                  }
                }
              },
              "flags": {}
            },
            "tasks": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--job": "value",
                    "--location": "value",
                    "--task_group": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--job": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "beyondcorp": {
          "commands": {
            "app": {
              "commands": {
                "connections": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--application-endpoint": "value",
                        "--application-endpoint-host": "value",
                        "--application-endpoint-port": "value",
                        "--async": "bool",
                        "--connectors": "value",
                        "--display-name": "value",
                        "--labels": "value",
                        "--location": "dynamic",
                        "--type": [
                          "tcp"
                        ]
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--application-endpoint": "value",
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--connectors": "value",
                        "--display-name": "value",
                        "--location": "dynamic",
                        "--remove-labels": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "connectors": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--display-name": "value",
                        "--labels": "value",
                        "--location": "dynamic",
                        "--member": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--details": "bool",
                        "--location": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--display-name": "value",
                        "--location": "dynamic",
                        "--remove-labels": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "gateways": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--display-name": "value",
                        "--host-type": [
                          "regional-mig"
                        ],
                        "--labels": "value",
                        "--location": "dynamic",
                        "--type": [
                          "tcp"
                        ]
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "client-connector": {
              "commands": {
                "gateways": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--client-connector-service": "value",
                        "--location": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "services": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--config-from-file": "value",
                        "--display-name": "value",
                        "--egress-peered-vpc": "value",
                        "--ingress-config": "value",
                        "--location": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--config-from-file": "value",
                        "--display-name": "value",
                        "--ingress-config": "value",
                        "--location": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "bigtable": {
          "commands": {
            "app-profiles": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--data-boost": "bool",
                    "--data-boost-compute-billing-owner": [
                      "HOST_PAYS"
                    ],
                    "--description": "value",
                    "--force": "bool",
                    "--instance": "dynamic",
                    "--priority": [
                      "PRIORITY_HIGH",
                      "PRIORITY_LOW",
                      "PRIORITY_MEDIUM"
                    ],
                    "--restrict-to": "value",
                    "--route-any": "bool",
                    "--route-to": "dynamic",
                    "--row-affinity": "bool",
                    "--standard": "bool",
                    "--transactional-writes": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--force": "bool",
                    "--instance": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--data-boost": "bool",
                    "--data-boost-compute-billing-owner": [
                      "HOST_PAYS"
                    ],
                    "--description": "value",
                    "--force": "bool",
                    "--instance": "dynamic",
                    "--priority": [
                      "PRIORITY_HIGH",
                      "PRIORITY_LOW",
                      "PRIORITY_MEDIUM"
                    ],
                    "--restrict-to": "value",
                    "--route-any": "bool",
                    "--route-to": "dynamic",
                    "--row-affinity": "bool",
                    "--standard": "bool",
                    "--transactional-writes": "bool"
                  }
                }
              },
              "flags": {}
            },
            "authorized-views": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic",
                    "--table": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--definition-file": "value",
                    "--instance": "dynamic",
                    "--pre-encoded": "bool",
                    "--table": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic",
                    "--table": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic",
                    "--table": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--table": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--table": "dynamic",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic",
                    "--table": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic",
                    "--table": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--definition-file": "value",
                    "--ignore-warnings": "bool",
                    "--instance": "dynamic",
                    "--interactive": "bool",
                    "--pre-encoded": "bool",
                    "--table": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "backups": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--cluster": "dynamic",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "copy": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--destination-backup": "dynamic",
                    "--destination-cluster": "dynamic",
                    "--destination-instance": "dynamic",
                    "--destination-project": "dynamic",
                    "--expiration-date": "value",
                    "--retention-period": "value",
                    "--source-backup": "dynamic",
                    "--source-cluster": "dynamic",
                    "--source-instance": "dynamic",
                    "--source-project": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--backup-type": [
                      "backup-type-unspecified",
                      "hot",
                      "standard"
                    ],
                    "--cluster": "dynamic",
                    "--expiration-date": "value",
                    "--hot-to-standard-time": "value",
                    "--instance": "dynamic",
                    "--retention-period": "value",
                    "--table": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--cluster": "dynamic",
                    "--instance": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--cluster": "dynamic",
                    "--instance": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--cluster": "dynamic",
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--cluster": "dynamic",
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--cluster": "dynamic",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--cluster": "dynamic",
                    "--instance": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--cluster": "dynamic",
                    "--expiration-date": "value",
                    "--hot-to-standard-time": "value",
                    "--instance": "dynamic",
                    "--retention-period": "value"
                  }
                }
              },
              "flags": {}
            },
            "clusters": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--autoscaling-cpu-target": "value",
                    "--autoscaling-max-nodes": "value",
                    "--autoscaling-min-nodes": "value",
                    "--autoscaling-storage-target": "value",
                    "--instance": "dynamic",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--node-scaling-factor": [
                      "node-scaling-factor-1x",
                      "node-scaling-factor-2x"
                    ],
                    "--num-nodes": "value",
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instances": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--autoscaling-cpu-target": "value",
                    "--autoscaling-max-nodes": "value",
                    "--autoscaling-min-nodes": "value",
                    "--autoscaling-storage-target": "value",
                    "--disable-autoscaling": "bool",
                    "--instance": "dynamic",
                    "--num-nodes": "value"
                  }
                }
              },
              "flags": {}
            },
            "hot-tablets": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--end-time": "value",
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--start-time": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "instances": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster": "dynamic",
                    "--cluster-config": "value",
                    "--cluster-num-nodes": "value",
                    "--cluster-storage-type": [
                      "hdd",
                      "ssd"
                    ],
                    "--cluster-zone": "value",
                    "--display-name": "value",
                    "--instance-type": [
                      "DEVELOPMENT",
                      "PRODUCTION"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "tables": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--instance": "dynamic",
                        "--member": "value",
                        "--role": "dynamic"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--automated-backup-retention-period": "value",
                        "--change-stream-retention-period": "value",
                        "--column-families": "value",
                        "--deletion-protection": "bool",
                        "--enable-automated-backup": "bool",
                        "--instance": "dynamic",
                        "--splits": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--instance": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--instance": "dynamic",
                        "--view": [
                          "encryption",
                          "full",
                          "name",
                          "replication",
                          "schema",
                          "stats"
                        ]
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--instance": "dynamic",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--instances": "dynamic",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--instance": "dynamic",
                        "--member": "value",
                        "--role": "dynamic"
                      }
                    },
                    "restore": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--destination": "dynamic",
                        "--destination-instance": "dynamic",
                        "--source": "dynamic",
                        "--source-cluster": "dynamic",
                        "--source-instance": "dynamic"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--instance": "dynamic"
                      }
                    },
                    "undelete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--instance": "dynamic"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--automated-backup-retention-period": "value",
                        "--change-stream-retention-period": "value",
                        "--clear-change-stream-retention-period": "bool",
                        "--deletion-protection": "bool",
                        "--disable-automated-backup": "bool",
                        "--enable-automated-backup": "bool",
                        "--instance": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--display-name": "value"
                  }
                },
                "upgrade": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "tables": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--automated-backup-retention-period": "value",
                    "--change-stream-retention-period": "value",
                    "--column-families": "value",
                    "--deletion-protection": "bool",
                    "--enable-automated-backup": "bool",
                    "--instance": "dynamic",
                    "--splits": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic",
                    "--view": [
                      "encryption",
                      "full",
                      "name",
                      "replication",
                      "schema",
                      "stats"
                    ]
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instances": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "restore": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--destination": "dynamic",
                    "--destination-instance": "dynamic",
                    "--source": "dynamic",
                    "--source-cluster": "dynamic",
                    "--source-instance": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "undelete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--instance": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--automated-backup-retention-period": "value",
                    "--change-stream-retention-period": "value",
                    "--clear-change-stream-retention-period": "bool",
                    "--deletion-protection": "bool",
                    "--disable-automated-backup": "bool",
                    "--enable-automated-backup": "bool",
                    "--instance": "dynamic"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "billing": {
          "commands": {
            "accounts": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "budgets": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--all-updates-rule-monitoring-notification-channels": "value",
                    "--all-updates-rule-pubsub-topic": "value",
                    "--billing-account": "value",
                    "--budget-amount": "value",
                    "--calendar-period": [
                      "calendar-period-unspecified",
                      "month",
                      "quarter",
                      "year"
                    ],
                    "--credit-types-treatment": [
                      "credit-types-treatment-unspecified",
                      "exclude-all-credits",
                      "include-all-credits",
                      "include-specified-credits"
                    ],
                    "--disable-default-iam-recipients": "bool",
                    "--display-name": "value",
                    "--end-date": "value",
                    "--filter-credit-types": "value",
                    "--filter-labels": "value",
                    "--filter-projects": "value",
                    "--filter-resource-ancestors": "value",
                    "--filter-services": "value",
                    "--filter-subaccounts": "value",
                    "--last-period-amount": "bool",
                    "--ownership-scope": [
                      "all-users",
                      "billing-account",
                      "ownership-scope-unspecified"
                    ],
                    "--start-date": "value",
                    "--threshold-rule": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-threshold-rule": "value",
                    "--all-updates-rule-monitoring-notification-channels": "value",
                    "--all-updates-rule-pubsub-topic": "value",
                    "--billing-account": "value",
                    "--budget-amount": "value",
                    "--calendar-period": [
                      "calendar-period-unspecified",
                      "month",
                      "quarter",
                      "year"
                    ],
                    "--clear-threshold-rules": "bool",
                    "--credit-types-treatment": [
                      "credit-types-treatment-unspecified",
                      "exclude-all-credits",
                      "include-all-credits",
                      "include-specified-credits"
                    ],
                    "--disable-default-iam-recipients": "bool",
                    "--display-name": "value",
                    "--end-date": "value",
                    "--filter-credit-types": "value",
                    "--filter-labels": "value",
                    "--filter-projects": "value",
                    "--filter-resource-ancestors": "value",
                    "--filter-services": "value",
                    "--filter-subaccounts": "value",
                    "--last-period-amount": "bool",
                    "--ownership-scope": [
                      "all-users",
                      "billing-account",
                      "ownership-scope-unspecified"
                    ],
                    "--start-date": "value",
                    "--threshold-rules-from-file": "value"
                  }
                }
              },
              "flags": {}
            },
            "projects": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "link": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "dynamic",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "unlink": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "builds": {
          "commands": {
            "approve": {
              "commands": {},
              "flags": {
                "--comment": "value",
                "--url": "value"
              }
            },
            "cancel": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "connections": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {
                    "bitbucket-cloud": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--authorizer-token-secret-version": "value",
                        "--read-authorizer-token-secret-version": "value",
                        "--region": "dynamic",
                        "--webhook-secret-secret-version": "value",
                        "--workspace": "value"
                      }
                    },
                    "bitbucket-data-center": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--authorizer-token-secret-version": "value",
                        "--host-uri": "value",
                        "--read-authorizer-token-secret-version": "value",
                        "--region": "dynamic",
                        "--service-directory-service": "value",
                        "--ssl-ca-file": "value",
                        "--webhook-secret-secret-version": "value"
                      }
                    },
                    "github": {
                      "commands": {},
                      "flags": {
                        "--app-installation-id": "value",
                        "--async": "bool",
                        "--authorizer-token-secret-version": "value",
                        "--region": "dynamic"
                      }
                    },
                    "github-enterprise": {
                      "commands": {},
                      "flags": {
                        "--app-id": "value",
                        "--app-installation-id": "value",
                        "--app-slug": "value",
                        "--async": "bool",
                        "--host-uri": "value",
                        "--private-key-secret-version": "value",
                        "--region": "dynamic",
                        "--service-directory-service": "value",
                        "--ssl-ca-file": "value",
                        "--webhook-secret-secret-version": "value"
                      }
                    },
                    "gitlab": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--authorizer-token-secret-version": "value",
                        "--host-uri": "value",
                        "--read-authorizer-token-secret-version": "value",
                        "--region": "dynamic",
                        "--service-directory-service": "value",
                        "--ssl-ca-file": "value",
                        "--webhook-secret-secret-version": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "update": {
                  "commands": {
                    "bitbucket-cloud": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--authorizer-token-secret-version": "value",
                        "--read-authorizer-token-secret-version": "value",
                        "--region": "dynamic",
                        "--webhook-secret-secret-version": "value",
                        "--workspace": "value"
                      }
                    },
                    "bitbucket-data-center": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--authorizer-token-secret-version": "value",
                        "--host-uri": "value",
                        "--read-authorizer-token-secret-version": "value",
                        "--region": "dynamic",
                        "--service-directory-service": "value",
                        "--ssl-ca-file": "value"
                      }
                    },
                    "github": {
                      "commands": {},
                      "flags": {
                        "--app-installation-id": "value",
                        "--async": "bool",
                        "--authorizer-token-secret-version": "value",
                        "--region": "dynamic"
                      }
                    },
                    "github-enterprise": {
                      "commands": {},
                      "flags": {
                        "--app-id": "value",
                        "--app-installation-id": "value",
                        "--app-slug": "value",
                        "--async": "bool",
                        "--host-uri": "value",
                        "--private-key-secret-version": "value",
                        "--region": "dynamic",
                        "--service-directory-service": "value",
                        "--ssl-ca-file": "value",
                        "--webhook-secret-secret-version": "value"
                      }
                    },
                    "gitlab": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--authorizer-token-secret-version": "value",
                        "--host-uri": "value",
                        "--read-authorizer-token-secret-version": "value",
                        "--region": "dynamic",
                        "--service-directory-service": "value",
                        "--ssl-ca-file": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "get-default-service-account": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--ongoing": "bool",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "log": {
              "commands": {},
              "flags": {
                "--region": "value",
                "--stream": "bool"
              }
            },
            "reject": {
              "commands": {},
              "flags": {
                "--comment": "value",
                "--url": "value"
              }
            },
            "repositories": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--connection": "dynamic",
                    "--region": "dynamic",
                    "--remote-uri": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--connection": "dynamic",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--connection": "dynamic",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--connection": "dynamic",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "submit": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--config": "value",
                "--default-buckets-behavior": [
                  "default-logs-bucket-behavior-unspecified",
                  "legacy-bucket",
                  "regional-user-owned-bucket"
                ],
                "--dir": "value",
                "--disk-size": "value",
                "--gcs-log-dir": "value",
                "--gcs-source-staging-dir": "value",
                "--git-source-dir": "value",
                "--git-source-revision": "value",
                "--ignore-file": "value",
                "--machine-type": [
                  "e2-highcpu-32",
                  "e2-highcpu-8",
                  "e2-medium",
                  "n1-highcpu-32",
                  "n1-highcpu-8"
                ],
                "--no-cache": "bool",
                "--no-source": "bool",
                "--pack": "value",
                "--polling-interval": "value",
                "--region": "value",
                "--revision": "value",
                "--service-account": "value",
                "--substitutions": "value",
                "--suppress-logs": "bool",
                "--tag": "value",
                "--timeout": "value",
                "--worker-pool": "value"
              }
            },
            "triggers": {
              "commands": {
                "create": {
                  "commands": {
                    "bitbucket-cloud": {
                      "commands": {},
                      "flags": {
                        "--branch-pattern": "value",
                        "--build-config": "value",
                        "--comment-control": [
                          "COMMENTS_DISABLED",
                          "COMMENTS_ENABLED",
                          "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                        ],
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--ignored-files": "value",
                        "--included-files": "value",
                        "--inline-config": "value",
                        "--name": "value",
                        "--pull-request-pattern": "value",
                        "--region": "value",
                        "--repository": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--substitutions": "value",
                        "--tag-pattern": "value",
                        "--trigger-config": "value"
                      }
                    },
                    "bitbucket-data-center": {
                      "commands": {},
                      "flags": {
                        "--branch-pattern": "value",
                        "--build-config": "value",
                        "--comment-control": [
                          "COMMENTS_DISABLED",
                          "COMMENTS_ENABLED",
                          "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                        ],
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--ignored-files": "value",
                        "--included-files": "value",
                        "--inline-config": "value",
                        "--name": "value",
                        "--pull-request-pattern": "value",
                        "--region": "value",
                        "--repository": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--substitutions": "value",
                        "--tag-pattern": "value",
                        "--trigger-config": "value"
                      }
                    },
                    "bitbucketserver": {
                      "commands": {},
                      "flags": {
                        "--bitbucket-server-config-resource": "value",
                        "--branch-pattern": "value",
                        "--build-config": "value",
                        "--comment-control": [
                          "COMMENTS_DISABLED",
                          "COMMENTS_ENABLED",
                          "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                        ],
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--ignored-files": "value",
                        "--included-files": "value",
                        "--inline-config": "value",
                        "--name": "value",
                        "--project-key": "value",
                        "--pull-request-pattern": "value",
                        "--region": "value",
                        "--repo-slug": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--substitutions": "value",
                        "--tag-pattern": "value",
                        "--trigger-config": "value"
                      }
                    },
                    "cloud-source-repositories": {
                      "commands": {},
                      "flags": {
                        "--branch-pattern": "value",
                        "--build-config": "value",
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--ignored-files": "value",
                        "--included-files": "value",
                        "--inline-config": "value",
                        "--name": "value",
                        "--region": "value",
                        "--repo": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--substitutions": "value",
                        "--tag-pattern": "value",
                        "--trigger-config": "value"
                      }
                    },
                    "github": {
                      "commands": {},
                      "flags": {
                        "--branch-pattern": "value",
                        "--build-config": "value",
                        "--comment-control": [
                          "COMMENTS_DISABLED",
                          "COMMENTS_ENABLED",
                          "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                        ],
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--enterprise-config": "value",
                        "--ignored-files": "value",
                        "--include-logs-with-status": "bool",
                        "--included-files": "value",
                        "--inline-config": "value",
                        "--name": "value",
                        "--pull-request-pattern": "value",
                        "--region": "value",
                        "--repo-name": "value",
                        "--repo-owner": "value",
                        "--repository": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--substitutions": "value",
                        "--tag-pattern": "value",
                        "--trigger-config": "value"
                      }
                    },
                    "gitlab": {
                      "commands": {},
                      "flags": {
                        "--branch-pattern": "value",
                        "--build-config": "value",
                        "--comment-control": [
                          "COMMENTS_DISABLED",
                          "COMMENTS_ENABLED",
                          "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                        ],
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--ignored-files": "value",
                        "--included-files": "value",
                        "--inline-config": "value",
                        "--name": "value",
                        "--pull-request-pattern": "value",
                        "--region": "value",
                        "--repository": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--substitutions": "value",
                        "--tag-pattern": "value",
                        "--trigger-config": "value"
                      }
                    },
                    "manual": {
                      "commands": {},
                      "flags": {
                        "--branch": "value",
                        "--build-config": "value",
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--github-enterprise-config": "value",
                        "--inline-config": "value",
                        "--name": "value",
                        "--region": "value",
                        "--repo": "value",
                        "--repo-type": "value",
                        "--repository": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--substitutions": "value",
                        "--tag": "value",
                        "--trigger-config": "value"
                      }
                    },
                    "pubsub": {
                      "commands": {},
                      "flags": {
                        "--branch": "value",
                        "--build-config": "value",
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--github-enterprise-config": "value",
                        "--inline-config": "value",
                        "--name": "value",
                        "--region": "value",
                        "--repo": "value",
                        "--repo-type": "value",
                        "--repository": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--subscription-filter": "value",
                        "--substitutions": "value",
                        "--tag": "value",
                        "--topic": "value",
                        "--trigger-config": "value"
                      }
                    },
                    "webhook": {
                      "commands": {},
                      "flags": {
                        "--branch": "value",
                        "--build-config": "value",
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--github-enterprise-config": "value",
                        "--inline-config": "value",
                        "--name": "value",
                        "--region": "value",
                        "--repo": "value",
                        "--repo-type": "value",
                        "--repository": "value",
                        "--require-approval": "bool",
                        "--secret": "value",
                        "--service-account": "value",
                        "--subscription-filter": "value",
                        "--substitutions": "value",
                        "--tag": "value",
                        "--trigger-config": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--region": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--region": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "run": {
                  "commands": {},
                  "flags": {
                    "--branch": "value",
                    "--region": "value",
                    "--sha": "value",
                    "--substitutions": "value",
                    "--tag": "value"
                  }
                },
                "update": {
                  "commands": {
                    "bitbucket-cloud": {
                      "commands": {},
                      "flags": {
                        "--branch-pattern": "value",
                        "--build-config": "value",
                        "--clear-substitutions": "bool",
                        "--comment-control": [
                          "COMMENTS_DISABLED",
                          "COMMENTS_ENABLED",
                          "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                        ],
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--ignored-files": "value",
                        "--included-files": "value",
                        "--inline-config": "value",
                        "--pull-request-pattern": "value",
                        "--region": "value",
                        "--remove-substitutions": "value",
                        "--repository": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--tag-pattern": "value",
                        "--trigger-config": "value",
                        "--update-substitutions": "value"
                      }
                    },
                    "bitbucket-data-center": {
                      "commands": {},
                      "flags": {
                        "--branch-pattern": "value",
                        "--build-config": "value",
                        "--clear-substitutions": "bool",
                        "--comment-control": [
                          "COMMENTS_DISABLED",
                          "COMMENTS_ENABLED",
                          "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                        ],
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--ignored-files": "value",
                        "--included-files": "value",
                        "--inline-config": "value",
                        "--pull-request-pattern": "value",
                        "--region": "value",
                        "--remove-substitutions": "value",
                        "--repository": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--tag-pattern": "value",
                        "--trigger-config": "value",
                        "--update-substitutions": "value"
                      }
                    },
                    "bitbucketserver": {
                      "commands": {},
                      "flags": {
                        "--bitbucket-server-config-resource": "value",
                        "--branch-pattern": "value",
                        "--build-config": "value",
                        "--clear-substitutions": "bool",
                        "--comment-control": [
                          "COMMENTS_DISABLED",
                          "COMMENTS_ENABLED",
                          "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                        ],
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--ignored-files": "value",
                        "--included-files": "value",
                        "--inline-config": "value",
                        "--project-key": "value",
                        "--pull-request-pattern": "value",
                        "--region": "value",
                        "--remove-substitutions": "value",
                        "--repo-slug": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--tag-pattern": "value",
                        "--trigger-config": "value",
                        "--update-substitutions": "value"
                      }
                    },
                    "cloud-source-repositories": {
                      "commands": {},
                      "flags": {
                        "--branch-pattern": "value",
                        "--build-config": "value",
                        "--clear-substitutions": "bool",
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--ignored-files": "value",
                        "--included-files": "value",
                        "--inline-config": "value",
                        "--region": "value",
                        "--remove-substitutions": "value",
                        "--repo": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--tag-pattern": "value",
                        "--trigger-config": "value",
                        "--update-substitutions": "value"
                      }
                    },
                    "github": {
                      "commands": {},
                      "flags": {
                        "--branch-pattern": "value",
                        "--build-config": "value",
                        "--clear-substitutions": "bool",
                        "--comment-control": [
                          "COMMENTS_DISABLED",
                          "COMMENTS_ENABLED",
                          "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                        ],
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--enterprise-config": "value",
                        "--ignored-files": "value",
                        "--include-logs-with-status": "bool",
                        "--included-files": "value",
                        "--inline-config": "value",
                        "--pull-request-pattern": "value",
                        "--region": "value",
                        "--remove-substitutions": "value",
                        "--repo-name": "value",
                        "--repo-owner": "value",
                        "--repository": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--tag-pattern": "value",
                        "--trigger-config": "value",
                        "--update-substitutions": "value"
                      }
                    },
                    "gitlab": {
                      "commands": {},
                      "flags": {
                        "--branch-pattern": "value",
                        "--build-config": "value",
                        "--clear-substitutions": "bool",
                        "--comment-control": [
                          "COMMENTS_DISABLED",
                          "COMMENTS_ENABLED",
                          "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                        ],
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--ignored-files": "value",
                        "--included-files": "value",
                        "--inline-config": "value",
                        "--pull-request-pattern": "value",
                        "--region": "value",
                        "--remove-substitutions": "value",
                        "--repository": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--tag-pattern": "value",
                        "--trigger-config": "value",
                        "--update-substitutions": "value"
                      }
                    },
                    "manual": {
                      "commands": {},
                      "flags": {
                        "--clear-substitutions": "bool",
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--git-file-source-branch": "value",
                        "--git-file-source-github-enterprise-config": "value",
                        "--git-file-source-path": "value",
                        "--git-file-source-repo-type": "value",
                        "--git-file-source-tag": "value",
                        "--git-file-source-uri": "value",
                        "--inline-config": "value",
                        "--region": "value",
                        "--remove-substitutions": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--source-to-build-branch": "value",
                        "--source-to-build-github-enterprise-config": "value",
                        "--source-to-build-repo-type": "value",
                        "--source-to-build-tag": "value",
                        "--source-to-build-uri": "value",
                        "--trigger-config": "value",
                        "--update-substitutions": "value"
                      }
                    },
                    "pubsub": {
                      "commands": {},
                      "flags": {
                        "--clear-subscription-filter": "bool",
                        "--clear-substitutions": "bool",
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--git-file-source-branch": "value",
                        "--git-file-source-github-enterprise-config": "value",
                        "--git-file-source-path": "value",
                        "--git-file-source-repo-type": "value",
                        "--git-file-source-tag": "value",
                        "--git-file-source-uri": "value",
                        "--inline-config": "value",
                        "--region": "value",
                        "--remove-substitutions": "value",
                        "--require-approval": "bool",
                        "--service-account": "value",
                        "--source-to-build-branch": "value",
                        "--source-to-build-github-enterprise-config": "value",
                        "--source-to-build-repo-type": "value",
                        "--source-to-build-tag": "value",
                        "--source-to-build-uri": "value",
                        "--subscription-filter": "value",
                        "--topic": "value",
                        "--trigger-config": "value",
                        "--update-substitutions": "value"
                      }
                    },
                    "webhook": {
                      "commands": {},
                      "flags": {
                        "--clear-substitutions": "bool",
                        "--description": "value",
                        "--dockerfile": "value",
                        "--dockerfile-dir": "value",
                        "--dockerfile-image": "value",
                        "--git-file-source-branch": "value",
                        "--git-file-source-github-enterprise-config": "value",
                        "--git-file-source-path": "value",
                        "--git-file-source-repo-type": "value",
                        "--git-file-source-tag": "value",
                        "--git-file-source-uri": "value",
                        "--inline-config": "value",
                        "--region": "value",
                        "--remove-substitutions": "value",
                        "--require-approval": "bool",
                        "--secret": "value",
                        "--service-account": "value",
                        "--source-to-build-branch": "value",
                        "--source-to-build-github-enterprise-config": "value",
                        "--source-to-build-repo-type": "value",
                        "--source-to-build-tag": "value",
                        "--source-to-build-uri": "value",
                        "--subscription-filter": "value",
                        "--trigger-config": "value",
                        "--update-substitutions": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "worker-pools": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--config-from-file": "value",
                    "--disable-public-ip-address": "bool",
                    "--generation": "value",
                    "--network-attachment": "value",
                    "--no-public-egress": "bool",
                    "--peered-network": "value",
                    "--peered-network-ip-range": "value",
                    "--region": "value",
                    "--route-all-traffic": "bool",
                    "--worker-disk-size": "value",
                    "--worker-machine-type": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--generation": "value",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--generation": "value",
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--generation": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--config-from-file": "value",
                    "--generation": "value",
                    "--public-egress": "bool",
                    "--region": "value",
                    "--worker-disk-size": "value",
                    "--worker-machine-type": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "certificate-manager": {
          "commands": {
            "certificates": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--certificate-file": "value",
                    "--description": "value",
                    "--dns-authorizations": "value",
                    "--domains": "value",
                    "--issuance-config": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--private-key-file": "value",
                    "--scope": [
                      "all-regions",
                      "default",
                      "edge-cache"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--certificate-file": "value",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "dynamic",
                    "--private-key-file": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "dns-authorizations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--domain": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--type": [
                      "fixed-record",
                      "per-project-record",
                      "type-unspecified"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "issuance-configs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--ca-pool": "value",
                    "--description": "value",
                    "--key-algorithm": [
                      "ecdsa-p256",
                      "rsa-2048"
                    ],
                    "--labels": "value",
                    "--lifetime": "value",
                    "--location": "value",
                    "--rotation-window-percentage": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "maps": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "entries": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--certificates": "dynamic",
                        "--description": "value",
                        "--hostname": "value",
                        "--labels": "value",
                        "--location": "dynamic",
                        "--map": "dynamic",
                        "--set-primary": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "dynamic",
                        "--map": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic",
                        "--map": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--map": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--certificates": "dynamic",
                        "--clear-labels": "bool",
                        "--description": "value",
                        "--location": "dynamic",
                        "--map": "dynamic",
                        "--remove-labels": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "dynamic",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "trust-configs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--allowlisted-certificates": "value",
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--trust-store": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--etag": "value",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value",
                    "--update-mask": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-allowlisted-certificates": "value",
                    "--async": "bool",
                    "--clear-allowlisted-certificates": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--remove-allowlisted-certificates": "value",
                    "--remove-labels": "value",
                    "--trust-store": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "cloud-shell": {
          "commands": {
            "get-mount-command": {
              "commands": {},
              "flags": {
                "--force-key-file-overwrite": "bool",
                "--ssh-key-file": "bool"
              }
            },
            "scp": {
              "commands": {},
              "flags": {
                "--dry-run": "bool",
                "--force-key-file-overwrite": "bool",
                "--recurse": "bool",
                "--scp-flag": "value",
                "--ssh-key-file": "bool"
              }
            },
            "ssh": {
              "commands": {},
              "flags": {
                "--authorize-session": "bool",
                "--command": "value",
                "--dry-run": "bool",
                "--force-key-file-overwrite": "bool",
                "--ssh-flag": "value",
                "--ssh-key-file": "bool"
              }
            }
          },
          "flags": {}
        },
        "code": {
          "commands": {
            "clean-up": {
              "commands": {},
              "flags": {
                "--minikube-profile": "value"
              }
            },
            "dev": {
              "commands": {},
              "flags": {
                "--allow-secret-manager": "bool",
                "--application-default-credential": "bool",
                "--builder": "value",
                "--dockerfile": "value",
                "--kube-context": "value",
                "--local-port": "value",
                "--minikube-profile": "value",
                "--secrets": "value",
                "--service-account": "value",
                "--source": "value",
                "--stop-cluster": "bool"
              }
            }
          },
          "flags": {}
        },
        "colab": {
          "commands": {
            "executions": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--commit-sha": "value",
                    "--dataform-repository-name": "value",
                    "--direct-content": "value",
                    "--display-name": "value",
                    "--execution-timeout": "value",
                    "--gcs-notebook-uri": "value",
                    "--gcs-output-uri": "value",
                    "--generation": "value",
                    "--notebook-runtime-template": "value",
                    "--region": "value",
                    "--service-account": "value",
                    "--user-email": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "runtime-templates": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--region": "value",
                    "--role": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator-count": "value",
                    "--accelerator-type": [
                      "NVIDIA_A100_80GB",
                      "NVIDIA_L4",
                      "NVIDIA_TESLA_A100",
                      "NVIDIA_TESLA_T4",
                      "NVIDIA_TESLA_V100"
                    ],
                    "--async": "bool",
                    "--description": "value",
                    "--disk-size-gb": "value",
                    "--disk-type": [
                      "PD_BALANCED",
                      "PD_EXTREME",
                      "PD_SSD",
                      "PD_STANDARD"
                    ],
                    "--display-name": "value",
                    "--enable-euc": "bool",
                    "--enable-internet-access": "bool",
                    "--enable-secure-boot": "bool",
                    "--idle-shutdown-timeout": "value",
                    "--kms-key": "value",
                    "--kms-keyring": "value",
                    "--kms-location": "value",
                    "--kms-project": "value",
                    "--labels": "value",
                    "--machine-type": "value",
                    "--network": "dynamic",
                    "--network-tags": "value",
                    "--region": "value",
                    "--runtime-template-id": "value",
                    "--subnetwork": "dynamic",
                    "--subnetwork-region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--region": "value",
                    "--role": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                }
              },
              "flags": {}
            },
            "runtimes": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--labels": "value",
                    "--region": "value",
                    "--runtime-id": "value",
                    "--runtime-template": "value",
                    "--runtime-user": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "start": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "stop": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "upgrade": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                }
              },
              "flags": {}
            },
            "schedules": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--commit-sha": "value",
                    "--cron-schedule": "value",
                    "--dataform-repository-name": "value",
                    "--display-name": "value",
                    "--enable-queueing": "bool",
                    "--end-time": "value",
                    "--execution-display-name": "value",
                    "--execution-timeout": "value",
                    "--gcs-notebook-uri": "value",
                    "--gcs-output-uri": "value",
                    "--generation": "value",
                    "--max-concurrent-runs": "value",
                    "--max-runs": "value",
                    "--notebook-runtime-template": "value",
                    "--region": "value",
                    "--service-account": "value",
                    "--start-time": "value",
                    "--user-email": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "pause": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "resume": {
                  "commands": {},
                  "flags": {
                    "--enable-catch-up": "bool",
                    "--region": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--cron-schedule": "value",
                    "--display-name": "value",
                    "--enable-queueing": "bool",
                    "--end-time": "value",
                    "--max-concurrent-runs": "value",
                    "--max-runs": "value",
                    "--region": "value",
                    "--start-time": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "composer": {
          "commands": {
            "environments": {
              "commands": {
                "check-upgrade": {
                  "commands": {},
                  "flags": {
                    "--airflow-version": "value",
                    "--async": "bool",
                    "--image-version": "value",
                    "--location": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--airflow-configs": "value",
                    "--airflow-version": "value",
                    "--async": "bool",
                    "--cloud-sql-ipv4-cidr": "value",
                    "--cloud-sql-machine-type": "value",
                    "--cloud-sql-preferred-zone": "value",
                    "--cluster-ipv4-cidr": "value",
                    "--cluster-secondary-range-name": "value",
                    "--composer-internal-ipv4-cidr-block": "value",
                    "--composer-network-ipv4-cidr": "value",
                    "--connection-subnetwork": "value",
                    "--connection-type": [
                      "connection-type-unspecified",
                      "private-service-connect",
                      "vpc-peering"
                    ],
                    "--dag-processor-count": "value",
                    "--dag-processor-cpu": "value",
                    "--dag-processor-memory": "value",
                    "--dag-processor-storage": "value",
                    "--disable-cloud-data-lineage-integration": "bool",
                    "--disable-logs-in-cloud-logging-only": "bool",
                    "--disable-private-builds-only": "bool",
                    "--disk-size": "value",
                    "--enable-cloud-data-lineage-integration": "bool",
                    "--enable-high-resilience": "bool",
                    "--enable-ip-alias": "bool",
                    "--enable-ip-masq-agent": "bool",
                    "--enable-logs-in-cloud-logging-only": "bool",
                    "--enable-master-authorized-networks": "bool",
                    "--enable-private-builds-only": "bool",
                    "--enable-private-endpoint": "bool",
                    "--enable-private-environment": "bool",
                    "--enable-privately-used-public-ips": "bool",
                    "--enable-scheduled-snapshot-creation": "bool",
                    "--enable-triggerer": "bool",
                    "--env-variables": "value",
                    "--environment-size": [
                      "large",
                      "medium",
                      "small",
                      "unspecified"
                    ],
                    "--image-version": "value",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--location": "value",
                    "--machine-type": "value",
                    "--maintenance-window-end": "value",
                    "--maintenance-window-recurrence": "value",
                    "--maintenance-window-start": "value",
                    "--master-authorized-networks": "value",
                    "--master-ipv4-cidr": "value",
                    "--max-pods-per-node": "value",
                    "--max-workers": "value",
                    "--min-workers": "value",
                    "--network": "value",
                    "--network-attachment": "value",
                    "--node-count": "value",
                    "--oauth-scopes": "value",
                    "--python-version": [
                      "2",
                      "3"
                    ],
                    "--scheduler-count": "value",
                    "--scheduler-cpu": "value",
                    "--scheduler-memory": "value",
                    "--scheduler-storage": "value",
                    "--service-account": "value",
                    "--services-ipv4-cidr": "value",
                    "--services-secondary-range-name": "value",
                    "--snapshot-creation-schedule": "value",
                    "--snapshot-location": "value",
                    "--snapshot-schedule-timezone": "value",
                    "--storage-bucket": "value",
                    "--subnetwork": "value",
                    "--support-web-server-plugins": "bool",
                    "--tags": "value",
                    "--triggerer-count": "value",
                    "--triggerer-cpu": "value",
                    "--triggerer-memory": "value",
                    "--web-server-allow-all": "bool",
                    "--web-server-allow-ip": "value",
                    "--web-server-cpu": "value",
                    "--web-server-deny-all": "bool",
                    "--web-server-ipv4-cidr": "value",
                    "--web-server-machine-type": "value",
                    "--web-server-memory": "value",
                    "--web-server-storage": "value",
                    "--worker-cpu": "value",
                    "--worker-memory": "value",
                    "--worker-storage": "value",
                    "--zone": "value"
                  }
                },
                "database-failover": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "fetch-database-properties": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--locations": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-packages": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--tree": "bool"
                  }
                },
                "list-upgrades": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list-workloads": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "restart-web-server": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "run": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "snapshots": {
                  "commands": {
                    "load": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--skip-airflow-overrides-setting": "bool",
                        "--skip-environment-variables-setting": "bool",
                        "--skip-gcs-data-copying": "bool",
                        "--skip-pypi-packages-installation": "bool",
                        "--snapshot-path": "value"
                      }
                    },
                    "save": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--snapshot-location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "storage": {
                  "commands": {
                    "dags": {
                      "commands": {
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--environment": "value",
                            "--location": "value"
                          }
                        },
                        "export": {
                          "commands": {},
                          "flags": {
                            "--destination": "value",
                            "--environment": "value",
                            "--location": "value",
                            "--source": "value"
                          }
                        },
                        "import": {
                          "commands": {},
                          "flags": {
                            "--destination": "value",
                            "--environment": "value",
                            "--location": "value",
                            "--source": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--environment": "value",
                            "--location": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "data": {
                      "commands": {
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--environment": "value",
                            "--location": "value"
                          }
                        },
                        "export": {
                          "commands": {},
                          "flags": {
                            "--destination": "value",
                            "--environment": "value",
                            "--location": "value",
                            "--source": "value"
                          }
                        },
                        "import": {
                          "commands": {},
                          "flags": {
                            "--destination": "value",
                            "--environment": "value",
                            "--location": "value",
                            "--source": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--environment": "value",
                            "--location": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "plugins": {
                      "commands": {
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--environment": "value",
                            "--location": "value"
                          }
                        },
                        "export": {
                          "commands": {},
                          "flags": {
                            "--destination": "value",
                            "--environment": "value",
                            "--location": "value",
                            "--source": "value"
                          }
                        },
                        "import": {
                          "commands": {},
                          "flags": {
                            "--destination": "value",
                            "--environment": "value",
                            "--location": "value",
                            "--source": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--environment": "value",
                            "--location": "value"
                          }
                        }
                      },
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--airflow-version": "value",
                    "--async": "bool",
                    "--clear-airflow-configs": "bool",
                    "--clear-env-variables": "bool",
                    "--clear-labels": "bool",
                    "--clear-maintenance-window": "bool",
                    "--clear-pypi-packages": "bool",
                    "--cloud-sql-machine-type": "value",
                    "--dag-processor-count": "value",
                    "--dag-processor-cpu": "value",
                    "--dag-processor-memory": "value",
                    "--dag-processor-storage": "value",
                    "--disable-cloud-data-lineage-integration": "bool",
                    "--disable-high-resilience": "bool",
                    "--disable-logs-in-cloud-logging-only": "bool",
                    "--disable-master-authorized-networks": "bool",
                    "--disable-private-builds-only": "bool",
                    "--disable-private-environment": "bool",
                    "--disable-scheduled-snapshot-creation": "bool",
                    "--disable-triggerer": "bool",
                    "--disable-vpc-connectivity": "bool",
                    "--enable-cloud-data-lineage-integration": "bool",
                    "--enable-high-resilience": "bool",
                    "--enable-logs-in-cloud-logging-only": "bool",
                    "--enable-master-authorized-networks": "bool",
                    "--enable-private-builds-only": "bool",
                    "--enable-private-environment": "bool",
                    "--enable-scheduled-snapshot-creation": "bool",
                    "--enable-triggerer": "bool",
                    "--environment-size": [
                      "large",
                      "medium",
                      "small",
                      "unspecified"
                    ],
                    "--image-version": "value",
                    "--location": "value",
                    "--maintenance-window-end": "value",
                    "--maintenance-window-recurrence": "value",
                    "--maintenance-window-start": "value",
                    "--master-authorized-networks": "value",
                    "--max-workers": "value",
                    "--min-workers": "value",
                    "--network": "value",
                    "--network-attachment": "value",
                    "--node-count": "value",
                    "--remove-airflow-configs": "value",
                    "--remove-env-variables": "value",
                    "--remove-labels": "value",
                    "--remove-pypi-packages": "value",
                    "--scheduler-count": "value",
                    "--scheduler-cpu": "value",
                    "--scheduler-memory": "value",
                    "--scheduler-storage": "value",
                    "--snapshot-creation-schedule": "value",
                    "--snapshot-location": "value",
                    "--snapshot-schedule-timezone": "value",
                    "--subnetwork": "value",
                    "--support-web-server-plugins": "bool",
                    "--triggerer-count": "value",
                    "--triggerer-cpu": "value",
                    "--triggerer-memory": "value",
                    "--update-airflow-configs": "value",
                    "--update-env-variables": "value",
                    "--update-labels": "value",
                    "--update-pypi-package": "value",
                    "--update-pypi-packages-from-file": "value",
                    "--update-web-server-allow-ip": "value",
                    "--web-server-allow-all": "bool",
                    "--web-server-cpu": "value",
                    "--web-server-deny-all": "bool",
                    "--web-server-machine-type": "value",
                    "--web-server-memory": "value",
                    "--web-server-storage": "value",
                    "--worker-cpu": "value",
                    "--worker-memory": "value",
                    "--worker-storage": "value"
                  }
                },
                "user-workloads-config-maps": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--config-map-file-path": "value",
                        "--environment": "value",
                        "--location": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--environment": "value",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--environment": "value",
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--environment": "value",
                        "--location": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--config-map-file-path": "value",
                        "--environment": "value",
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "user-workloads-secrets": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--environment": "value",
                        "--location": "value",
                        "--secret-file-path": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--environment": "value",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--environment": "value",
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--environment": "value",
                        "--location": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--environment": "value",
                        "--location": "value",
                        "--secret-file-path": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--locations": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "compute": {
          "commands": {
            "accelerator-types": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "addresses": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--addresses": "value",
                    "--description": "value",
                    "--endpoint-type": [
                      "NETLB",
                      "VM"
                    ],
                    "--global": "bool",
                    "--ip-version": [
                      "IPV4",
                      "IPV6"
                    ],
                    "--network": "value",
                    "--network-tier": "value",
                    "--prefix-length": "value",
                    "--purpose": [
                      "GCE_ENDPOINT",
                      "IPSEC_INTERCONNECT",
                      "PRIVATE_SERVICE_CONNECT",
                      "SHARED_LOADBALANCER_VIP",
                      "VPC_PEERING"
                    ],
                    "--region": "dynamic",
                    "--subnet": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "move": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--global": "bool",
                    "--new-name": "value",
                    "--region": "dynamic",
                    "--target-project": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--global": "bool",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "backend-buckets": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "add-signed-url-key": {
                  "commands": {},
                  "flags": {
                    "--key-file": "value",
                    "--key-name": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--bypass-cache-on-request-headers": "value",
                    "--cache-key-include-http-header": "value",
                    "--cache-key-query-string-whitelist": "value",
                    "--cache-mode": [
                      "CACHE_ALL_STATIC",
                      "FORCE_CACHE_ALL",
                      "USE_ORIGIN_HEADERS"
                    ],
                    "--client-ttl": "value",
                    "--compression-mode": [
                      "AUTOMATIC",
                      "DISABLED"
                    ],
                    "--custom-response-header": "value",
                    "--default-ttl": "value",
                    "--description": "value",
                    "--enable-cdn": "bool",
                    "--gcs-bucket-name": "dynamic",
                    "--load-balancing-scheme": [
                      "INTERNAL_MANAGED"
                    ],
                    "--max-ttl": "value",
                    "--negative-caching": "bool",
                    "--negative-caching-policy": "value",
                    "--request-coalescing": "bool",
                    "--serve-while-stale": "value",
                    "--signed-url-cache-max-age": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "delete-signed-url-key": {
                  "commands": {},
                  "flags": {
                    "--key-name": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--bypass-cache-on-request-headers": "value",
                    "--cache-key-include-http-header": "value",
                    "--cache-key-query-string-whitelist": "value",
                    "--cache-mode": [
                      "CACHE_ALL_STATIC",
                      "FORCE_CACHE_ALL",
                      "USE_ORIGIN_HEADERS"
                    ],
                    "--client-ttl": "value",
                    "--compression-mode": [
                      "AUTOMATIC",
                      "DISABLED"
                    ],
                    "--custom-response-header": "value",
                    "--default-ttl": "value",
                    "--description": "value",
                    "--edge-security-policy": "dynamic",
                    "--enable-cdn": "bool",
                    "--gcs-bucket-name": "dynamic",
                    "--max-ttl": "value",
                    "--negative-caching": "bool",
                    "--negative-caching-policy": "value",
                    "--no-bypass-cache-on-request-headers": "bool",
                    "--no-client-ttl": "bool",
                    "--no-custom-response-headers": "bool",
                    "--no-default-ttl": "bool",
                    "--no-max-ttl": "bool",
                    "--no-negative-caching-policies": "bool",
                    "--no-serve-while-stale": "bool",
                    "--request-coalescing": "bool",
                    "--serve-while-stale": "value",
                    "--signed-url-cache-max-age": "value"
                  }
                }
              },
              "flags": {}
            },
            "backend-services": {
              "commands": {
                "add-backend": {
                  "commands": {},
                  "flags": {
                    "--balancing-mode": [
                      "CONNECTION",
                      "CUSTOM_METRICS",
                      "RATE",
                      "UTILIZATION"
                    ],
                    "--capacity-scaler": "value",
                    "--custom-metrics": "value",
                    "--custom-metrics-file": "value",
                    "--description": "value",
                    "--failover": "bool",
                    "--global": "bool",
                    "--global-network-endpoint-group": "bool",
                    "--instance-group": "dynamic",
                    "--instance-group-region": "dynamic",
                    "--instance-group-zone": "dynamic",
                    "--max-connections": "value",
                    "--max-connections-per-endpoint": "value",
                    "--max-connections-per-instance": "value",
                    "--max-rate": "value",
                    "--max-rate-per-endpoint": "value",
                    "--max-rate-per-instance": "value",
                    "--max-utilization": "value",
                    "--network-endpoint-group": "value",
                    "--network-endpoint-group-region": "dynamic",
                    "--network-endpoint-group-zone": "dynamic",
                    "--preference": [
                      "DEFAULT",
                      "PREFERRED"
                    ],
                    "--region": "dynamic"
                  }
                },
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "value"
                  }
                },
                "add-service-bindings": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--service-bindings": "dynamic"
                  }
                },
                "add-signed-url-key": {
                  "commands": {},
                  "flags": {
                    "--key-file": "value",
                    "--key-name": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--affinity-cookie-name": "value",
                    "--affinity-cookie-path": "value",
                    "--affinity-cookie-ttl": "value",
                    "--bypass-cache-on-request-headers": "value",
                    "--cache-key-include-host": "bool",
                    "--cache-key-include-http-header": "value",
                    "--cache-key-include-named-cookie": "value",
                    "--cache-key-include-protocol": "bool",
                    "--cache-key-include-query-string": "bool",
                    "--cache-key-query-string-blacklist": "value",
                    "--cache-key-query-string-whitelist": "value",
                    "--cache-mode": [
                      "CACHE_ALL_STATIC",
                      "FORCE_CACHE_ALL",
                      "USE_ORIGIN_HEADERS"
                    ],
                    "--client-ttl": "value",
                    "--compression-mode": [
                      "AUTOMATIC",
                      "DISABLED"
                    ],
                    "--connection-drain-on-failover": "bool",
                    "--connection-draining-timeout": "value",
                    "--connection-persistence-on-unhealthy-backends": [
                      "ALWAYS_PERSIST",
                      "DEFAULT_FOR_PROTOCOL",
                      "NEVER_PERSIST"
                    ],
                    "--custom-metrics": "value",
                    "--custom-metrics-file": "value",
                    "--custom-request-header": "value",
                    "--custom-response-header": "value",
                    "--default-ttl": "value",
                    "--description": "value",
                    "--drop-traffic-if-unhealthy": "bool",
                    "--enable-cdn": "bool",
                    "--enable-logging": "bool",
                    "--enable-strong-affinity": "bool",
                    "--failover-ratio": "value",
                    "--global": "bool",
                    "--global-health-checks": "bool",
                    "--health-checks": "dynamic",
                    "--health-checks-region": "dynamic",
                    "--http-health-checks": "dynamic",
                    "--https-health-checks": "dynamic",
                    "--iap": "value",
                    "--idle-timeout-sec": "value",
                    "--ip-address-selection-policy": [
                      "IPV4_ONLY",
                      "IPV6_ONLY",
                      "PREFER_IPV6"
                    ],
                    "--load-balancing-scheme": [
                      "EXTERNAL",
                      "EXTERNAL_MANAGED",
                      "INTERNAL",
                      "INTERNAL_MANAGED",
                      "INTERNAL_SELF_MANAGED"
                    ],
                    "--locality-lb-policy": [
                      "INVALID_LB_POLICY",
                      "LEAST_REQUEST",
                      "MAGLEV",
                      "ORIGINAL_DESTINATION",
                      "RANDOM",
                      "RING_HASH",
                      "ROUND_ROBIN",
                      "WEIGHTED_MAGLEV",
                      "WEIGHTED_ROUND_ROBIN"
                    ],
                    "--logging-optional": [
                      "CUSTOM",
                      "EXCLUDE_ALL_OPTIONAL",
                      "INCLUDE_ALL_OPTIONAL"
                    ],
                    "--logging-optional-fields": "value",
                    "--logging-sample-rate": "value",
                    "--max-ttl": "value",
                    "--negative-caching": "bool",
                    "--negative-caching-policy": "value",
                    "--network": "value",
                    "--port-name": "value",
                    "--protocol": "value",
                    "--region": "dynamic",
                    "--request-coalescing": "bool",
                    "--serve-while-stale": "value",
                    "--service-bindings": "dynamic",
                    "--service-lb-policy": "value",
                    "--session-affinity": [
                      "CLIENT_IP",
                      "CLIENT_IP_NO_DESTINATION",
                      "CLIENT_IP_PORT_PROTO",
                      "CLIENT_IP_PROTO",
                      "GENERATED_COOKIE",
                      "HEADER_FIELD",
                      "HTTP_COOKIE",
                      "NONE",
                      "STRONG_COOKIE_AFFINITY"
                    ],
                    "--signed-url-cache-max-age": "value",
                    "--subsetting-policy": [
                      "CONSISTENT_HASH_SUBSETTING",
                      "NONE"
                    ],
                    "--subsetting-subset-size": "value",
                    "--timeout": "value",
                    "--tracking-mode": [
                      "PER_CONNECTION",
                      "PER_SESSION"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "delete-signed-url-key": {
                  "commands": {},
                  "flags": {
                    "--key-name": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "edit": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "get-effective-security-policies": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "get-health": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-usable": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-backend": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--global-network-endpoint-group": "bool",
                    "--instance-group": "dynamic",
                    "--instance-group-region": "dynamic",
                    "--instance-group-zone": "dynamic",
                    "--network-endpoint-group": "value",
                    "--network-endpoint-group-region": "dynamic",
                    "--network-endpoint-group-zone": "dynamic",
                    "--region": "dynamic"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "value"
                  }
                },
                "remove-service-bindings": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--service-bindings": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--affinity-cookie-name": "value",
                    "--affinity-cookie-path": "value",
                    "--affinity-cookie-ttl": "value",
                    "--bypass-cache-on-request-headers": "value",
                    "--cache-key-include-host": "bool",
                    "--cache-key-include-http-header": "value",
                    "--cache-key-include-named-cookie": "value",
                    "--cache-key-include-protocol": "bool",
                    "--cache-key-include-query-string": "bool",
                    "--cache-key-query-string-blacklist": "value",
                    "--cache-key-query-string-whitelist": "value",
                    "--cache-mode": [
                      "CACHE_ALL_STATIC",
                      "FORCE_CACHE_ALL",
                      "USE_ORIGIN_HEADERS"
                    ],
                    "--clear-custom-metrics": "bool",
                    "--clear-external-managed-migration-state": "bool",
                    "--client-ttl": "value",
                    "--compression-mode": [
                      "AUTOMATIC",
                      "DISABLED"
                    ],
                    "--connection-drain-on-failover": "bool",
                    "--connection-draining-timeout": "value",
                    "--connection-persistence-on-unhealthy-backends": [
                      "ALWAYS_PERSIST",
                      "DEFAULT_FOR_PROTOCOL",
                      "NEVER_PERSIST"
                    ],
                    "--custom-metrics": "value",
                    "--custom-metrics-file": "value",
                    "--custom-request-header": "value",
                    "--custom-response-header": "value",
                    "--default-ttl": "value",
                    "--description": "value",
                    "--drop-traffic-if-unhealthy": "bool",
                    "--edge-security-policy": "dynamic",
                    "--enable-cdn": "bool",
                    "--enable-logging": "bool",
                    "--enable-strong-affinity": "bool",
                    "--external-managed-migration-state": [
                      "PREPARE",
                      "TEST_ALL_TRAFFIC",
                      "TEST_BY_PERCENTAGE"
                    ],
                    "--external-managed-migration-testing-percentage": "value",
                    "--failover-ratio": "value",
                    "--global": "bool",
                    "--global-health-checks": "bool",
                    "--health-checks": "dynamic",
                    "--health-checks-region": "dynamic",
                    "--http-health-checks": "dynamic",
                    "--https-health-checks": "dynamic",
                    "--iap": "value",
                    "--idle-timeout-sec": "value",
                    "--ip-address-selection-policy": [
                      "IPV4_ONLY",
                      "IPV6_ONLY",
                      "PREFER_IPV6"
                    ],
                    "--load-balancing-scheme": [
                      "EXTERNAL",
                      "EXTERNAL_MANAGED"
                    ],
                    "--locality-lb-policy": [
                      "INVALID_LB_POLICY",
                      "LEAST_REQUEST",
                      "MAGLEV",
                      "ORIGINAL_DESTINATION",
                      "RANDOM",
                      "RING_HASH",
                      "ROUND_ROBIN",
                      "WEIGHTED_MAGLEV",
                      "WEIGHTED_ROUND_ROBIN"
                    ],
                    "--logging-optional": [
                      "CUSTOM",
                      "EXCLUDE_ALL_OPTIONAL",
                      "INCLUDE_ALL_OPTIONAL"
                    ],
                    "--logging-optional-fields": "value",
                    "--logging-sample-rate": "value",
                    "--max-ttl": "value",
                    "--negative-caching": "bool",
                    "--negative-caching-policy": "value",
                    "--no-bypass-cache-on-request-headers": "bool",
                    "--no-client-ttl": "bool",
                    "--no-custom-request-headers": "bool",
                    "--no-custom-response-headers": "bool",
                    "--no-default-ttl": "bool",
                    "--no-health-checks": "bool",
                    "--no-max-ttl": "bool",
                    "--no-negative-caching-policies": "bool",
                    "--no-serve-while-stale": "bool",
                    "--no-service-bindings": "bool",
                    "--no-service-lb-policy": "bool",
                    "--port-name": "value",
                    "--protocol": "value",
                    "--region": "dynamic",
                    "--request-coalescing": "bool",
                    "--security-policy": "dynamic",
                    "--serve-while-stale": "value",
                    "--service-bindings": "dynamic",
                    "--service-lb-policy": "value",
                    "--session-affinity": [
                      "CLIENT_IP",
                      "CLIENT_IP_NO_DESTINATION",
                      "CLIENT_IP_PORT_PROTO",
                      "CLIENT_IP_PROTO",
                      "GENERATED_COOKIE",
                      "HEADER_FIELD",
                      "HTTP_COOKIE",
                      "NONE",
                      "STRONG_COOKIE_AFFINITY"
                    ],
                    "--signed-url-cache-max-age": "value",
                    "--subsetting-policy": [
                      "CONSISTENT_HASH_SUBSETTING",
                      "NONE"
                    ],
                    "--subsetting-subset-size": "value",
                    "--timeout": "value",
                    "--tracking-mode": [
                      "PER_CONNECTION",
                      "PER_SESSION"
                    ]
                  }
                },
                "update-backend": {
                  "commands": {},
                  "flags": {
                    "--balancing-mode": [
                      "CONNECTION",
                      "CUSTOM_METRICS",
                      "RATE",
                      "UTILIZATION"
                    ],
                    "--capacity-scaler": "value",
                    "--clear-custom-metrics": "bool",
                    "--custom-metrics": "value",
                    "--custom-metrics-file": "value",
                    "--description": "value",
                    "--failover": "bool",
                    "--global": "bool",
                    "--instance-group": "dynamic",
                    "--instance-group-region": "dynamic",
                    "--instance-group-zone": "dynamic",
                    "--max-connections": "value",
                    "--max-connections-per-endpoint": "value",
                    "--max-connections-per-instance": "value",
                    "--max-rate": "value",
                    "--max-rate-per-endpoint": "value",
                    "--max-rate-per-instance": "value",
                    "--max-utilization": "value",
                    "--network-endpoint-group": "value",
                    "--network-endpoint-group-zone": "dynamic",
                    "--preference": [
                      "DEFAULT",
                      "PREFERRED"
                    ],
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "commitments": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--auto-renew": "bool",
                    "--custom-end-time": "value",
                    "--existing-reservation": "value",
                    "--local-ssd": "value",
                    "--machine-type": "value",
                    "--maintenance-interval": [
                      "PERIODIC",
                      "RECURRENT"
                    ],
                    "--merge-source-commitments": "value",
                    "--min-cpu-platform": "value",
                    "--plan": [
                      "12-month",
                      "36-month"
                    ],
                    "--region": "dynamic",
                    "--require-specific-reservation": "bool",
                    "--reservation": "dynamic",
                    "--reservation-sharing-policy": [
                      "ALLOW_ALL",
                      "DISALLOW_ALL"
                    ],
                    "--reservation-zone": "dynamic",
                    "--reservations-from-file": "value",
                    "--resource-policies": "value",
                    "--resources": "value",
                    "--resources-accelerator": "value",
                    "--share-setting": [
                      "local",
                      "projects"
                    ],
                    "--share-with": "value",
                    "--split-source-commitment": "value",
                    "--type": [
                      "accelerator-optimized",
                      "accelerator-optimized-a3",
                      "accelerator-optimized-a3-mega",
                      "accelerator-optimized-a3-ultra",
                      "compute-optimized",
                      "compute-optimized-c2d",
                      "compute-optimized-c3",
                      "compute-optimized-c3d",
                      "compute-optimized-h3",
                      "general-purpose",
                      "general-purpose-c4",
                      "general-purpose-c4a",
                      "general-purpose-e2",
                      "general-purpose-n2",
                      "general-purpose-n2d",
                      "general-purpose-n4",
                      "general-purpose-t2d",
                      "graphics-optimized",
                      "memory-optimized",
                      "memory-optimized-m3",
                      "memory-optimized-x4-16tb",
                      "memory-optimized-x4-24tb",
                      "memory-optimized-x4-32tb",
                      "storage-optimized-z3"
                    ],
                    "--vm-count": "value"
                  }
                },
                "create-license": {
                  "commands": {},
                  "flags": {
                    "--amount": "value",
                    "--cores-per-license": "value",
                    "--license": "value",
                    "--plan": [
                      "12-month",
                      "36-month"
                    ],
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--auto-renew": "bool",
                    "--custom-end-time": "value",
                    "--plan": [
                      "36-month"
                    ],
                    "--region": "dynamic"
                  }
                },
                "update-reservations": {
                  "commands": {},
                  "flags": {
                    "--dest-accelerator": "value",
                    "--dest-local-ssd": "value",
                    "--dest-reservation": "value",
                    "--dest-share-setting": [
                      "local",
                      "projects"
                    ],
                    "--dest-share-with": "value",
                    "--region": "dynamic",
                    "--reservations-from-file": "value",
                    "--source-accelerator": "value",
                    "--source-local-ssd": "value",
                    "--source-reservation": "value",
                    "--source-share-setting": [
                      "local",
                      "projects"
                    ],
                    "--source-share-with": "value"
                  }
                }
              },
              "flags": {}
            },
            "config-ssh": {
              "commands": {},
              "flags": {
                "--dry-run": "bool",
                "--force-key-file-overwrite": "bool",
                "--remove": "bool",
                "--ssh-config-file": "value",
                "--ssh-key-file": "value"
              }
            },
            "connect-to-serial-port": {
              "commands": {},
              "flags": {
                "--dry-run": "bool",
                "--extra-args": "value",
                "--force-key-file-overwrite": "bool",
                "--location": "value",
                "--port": "value",
                "--ssh-key-expiration": "value",
                "--ssh-key-expire-after": "value",
                "--ssh-key-file": "value",
                "--zone": "dynamic"
              }
            },
            "copy-files": {
              "commands": {},
              "flags": {
                "--dry-run": "bool",
                "--force-key-file-overwrite": "bool",
                "--plain": "bool",
                "--ssh-key-expiration": "value",
                "--ssh-key-expire-after": "value",
                "--ssh-key-file": "value",
                "--strict-host-key-checking": [
                  "ask",
                  "no",
                  "yes"
                ],
                "--zone": "value"
              }
            },
            "diagnose": {
              "commands": {
                "export-logs": {
                  "commands": {},
                  "flags": {
                    "--collect-process-traces": "bool",
                    "--zone": "dynamic"
                  }
                },
                "routes": {
                  "commands": {},
                  "flags": {
                    "--container": "value",
                    "--dry-run": "bool",
                    "--external-route-ip": "value",
                    "--force-key-file-overwrite": "bool",
                    "--plain": "bool",
                    "--regexp": "value",
                    "--reverse-traceroute": "bool",
                    "--ssh-flag": "value",
                    "--ssh-key-expiration": "value",
                    "--ssh-key-expire-after": "value",
                    "--ssh-key-file": "value",
                    "--strict-host-key-checking": [
                      "ask",
                      "no",
                      "yes"
                    ],
                    "--user": "value",
                    "--zones": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "disk-types": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zones": "value"
                  }
                }
              },
              "flags": {}
            },
            "disks": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic",
                    "--zone": "value"
                  }
                },
                "add-labels": {
                  "commands": {},
                  "flags": {
                    "--labels": "value",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "add-resource-policies": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--resource-policies": "value",
                    "--zone": "dynamic"
                  }
                },
                "bulk": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--source-consistency-group-policy": "value",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "convert": {
                  "commands": {},
                  "flags": {
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--region": "dynamic",
                    "--target-disk-type": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--access-mode": [
                      "READ_ONLY_MANY",
                      "READ_WRITE_MANY",
                      "READ_WRITE_SINGLE"
                    ],
                    "--architecture": [
                      "ARM64",
                      "X86_64"
                    ],
                    "--confidential-compute": "bool",
                    "--csek-key-file": "value",
                    "--description": "value",
                    "--erase-windows-vss-signature": "bool",
                    "--guest-os-features": "value",
                    "--image": "value",
                    "--image-family": "value",
                    "--image-family-scope": [
                      "global",
                      "zonal"
                    ],
                    "--image-project": "value",
                    "--interface": "value",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--licenses": "value",
                    "--multi-writer": "bool",
                    "--physical-block-size": [
                      "16384",
                      "4096"
                    ],
                    "--primary-disk": "dynamic",
                    "--primary-disk-project": "value",
                    "--primary-disk-region": "dynamic",
                    "--primary-disk-zone": "dynamic",
                    "--provisioned-iops": "value",
                    "--provisioned-throughput": "value",
                    "--region": "dynamic",
                    "--replica-zones": "value",
                    "--require-csek-key-create": "bool",
                    "--resource-policies": "value",
                    "--size": "value",
                    "--source-disk": "dynamic",
                    "--source-disk-region": "dynamic",
                    "--source-disk-zone": "dynamic",
                    "--source-instant-snapshot": "dynamic",
                    "--source-snapshot": "dynamic",
                    "--storage-pool": "value",
                    "--type": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zones": "value"
                  }
                },
                "move": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--destination-zone": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic",
                    "--zone": "value"
                  }
                },
                "remove-labels": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--labels": "value",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "remove-resource-policies": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--resource-policies": "value",
                    "--zone": "dynamic"
                  }
                },
                "resize": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--size": "value",
                    "--zone": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "snapshot": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--chain-name": "value",
                    "--csek-key-file": "value",
                    "--description": "value",
                    "--guest-flush": "bool",
                    "--labels": "value",
                    "--region": "dynamic",
                    "--snapshot-names": "value",
                    "--storage-location": "value",
                    "--zone": "dynamic"
                  }
                },
                "start-async-replication": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--secondary-disk": "dynamic",
                    "--secondary-disk-project": "value",
                    "--secondary-disk-region": "dynamic",
                    "--secondary-disk-zone": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "stop-async-replication": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "stop-group-async-replication": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--access-mode": [
                      "READ_ONLY_MANY",
                      "READ_WRITE_MANY",
                      "READ_WRITE_SINGLE"
                    ],
                    "--clear-architecture": "bool",
                    "--clear-labels": "bool",
                    "--clear-user-licenses": "bool",
                    "--provisioned-iops": "value",
                    "--provisioned-throughput": "value",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--size": "value",
                    "--update-architecture": [
                      "ARM64",
                      "X86_64"
                    ],
                    "--update-labels": "value",
                    "--update-user-licenses": "value",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "external-vpn-gateways": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--interfaces": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "firewall-policies": {
              "commands": {
                "associations": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--firewall-policy": "value",
                        "--folder": "value",
                        "--name": "value",
                        "--organization": "value",
                        "--replace-association-on-target": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--firewall-policy": "value",
                        "--organization": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--folder": "value",
                        "--limit": "value",
                        "--organization": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "clone-rules": {
                  "commands": {},
                  "flags": {
                    "--organization": "value",
                    "--source-firewall-policy": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--folder": "value",
                    "--organization": "value",
                    "--short-name": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "export-rules": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--organization": "value"
                  }
                },
                "import-rules": {
                  "commands": {},
                  "flags": {
                    "--organization": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-rules": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "mirroring-rules": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "do_not_mirror",
                          "goto_next",
                          "mirror"
                        ],
                        "--description": "value",
                        "--dest-ip-ranges": "value",
                        "--direction": [
                          "EGRESS",
                          "INGRESS"
                        ],
                        "--disabled": "bool",
                        "--firewall-policy": "value",
                        "--layer4-configs": "value",
                        "--organization": "value",
                        "--security-profile-group": "value",
                        "--src-ip-ranges": "value",
                        "--target-resources": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--firewall-policy": "value",
                        "--organization": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--firewall-policy": "value",
                        "--organization": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "do_not_mirror",
                          "goto_next",
                          "mirror"
                        ],
                        "--description": "value",
                        "--dest-ip-ranges": "value",
                        "--direction": [
                          "EGRESS",
                          "INGRESS"
                        ],
                        "--disabled": "bool",
                        "--firewall-policy": "value",
                        "--layer4-configs": "value",
                        "--new-priority": "value",
                        "--organization": "value",
                        "--security-profile-group": "value",
                        "--src-ip-ranges": "value",
                        "--target-resources": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "move": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "rules": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "allow",
                          "apply_security_profile_group",
                          "deny",
                          "goto_next"
                        ],
                        "--description": "value",
                        "--dest-address-groups": "value",
                        "--dest-fqdns": "value",
                        "--dest-ip-ranges": "value",
                        "--dest-network-scope": "value",
                        "--dest-region-codes": "value",
                        "--dest-threat-intelligence": "value",
                        "--direction": [
                          "EGRESS",
                          "INGRESS"
                        ],
                        "--disabled": "bool",
                        "--enable-logging": "bool",
                        "--firewall-policy": "value",
                        "--layer4-configs": "value",
                        "--organization": "value",
                        "--security-profile-group": "value",
                        "--src-address-groups": "value",
                        "--src-fqdns": "value",
                        "--src-ip-ranges": "value",
                        "--src-network-scope": "value",
                        "--src-networks": "value",
                        "--src-region-codes": "value",
                        "--src-secure-tags": "value",
                        "--src-threat-intelligence": "value",
                        "--target-resources": "value",
                        "--target-secure-tags": "value",
                        "--target-service-accounts": "value",
                        "--tls-inspect": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--firewall-policy": "value",
                        "--organization": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--firewall-policy": "value",
                        "--organization": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "allow",
                          "apply_security_profile_group",
                          "deny",
                          "goto_next"
                        ],
                        "--description": "value",
                        "--dest-address-groups": "value",
                        "--dest-fqdns": "value",
                        "--dest-ip-ranges": "value",
                        "--dest-network-scope": "value",
                        "--dest-region-codes": "value",
                        "--dest-threat-intelligence": "value",
                        "--direction": [
                          "EGRESS",
                          "INGRESS"
                        ],
                        "--disabled": "bool",
                        "--enable-logging": "bool",
                        "--firewall-policy": "value",
                        "--layer4-configs": "value",
                        "--new-priority": "value",
                        "--organization": "value",
                        "--security-profile-group": "value",
                        "--src-address-groups": "value",
                        "--src-fqdns": "value",
                        "--src-ip-ranges": "value",
                        "--src-network-scope": "value",
                        "--src-networks": "value",
                        "--src-region-codes": "value",
                        "--src-secure-tags": "value",
                        "--src-threat-intelligence": "value",
                        "--target-resources": "value",
                        "--target-secure-tags": "value",
                        "--target-service-accounts": "value",
                        "--tls-inspect": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--organization": "value"
                  }
                }
              },
              "flags": {}
            },
            "firewall-rules": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--action": [
                      "ALLOW",
                      "DENY"
                    ],
                    "--allow": "value",
                    "--description": "value",
                    "--destination-ranges": "value",
                    "--direction": [
                      "EGRESS",
                      "IN",
                      "INGRESS",
                      "OUT"
                    ],
                    "--disabled": "bool",
                    "--enable-logging": "bool",
                    "--logging-metadata": [
                      "exclude-all",
                      "include-all"
                    ],
                    "--network": "value",
                    "--priority": "value",
                    "--rules": "value",
                    "--source-ranges": "value",
                    "--source-service-accounts": "value",
                    "--source-tags": "value",
                    "--target-service-accounts": "value",
                    "--target-tags": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "migrate": {
                  "commands": {},
                  "flags": {
                    "--bind-tags-to-instances": "bool",
                    "--exclusion-patterns-file": "value",
                    "--export-exclusion-patterns": "bool",
                    "--export-tag-mapping": "bool",
                    "--export-terraform-script": "bool",
                    "--force": "bool",
                    "--skip-migrate-target-service-accounts-to-tags": "bool",
                    "--source-network": "dynamic",
                    "--tag-mapping-file": "value",
                    "--target-firewall-policy": "value",
                    "--terraform-script-output-file": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--allow": "value",
                    "--description": "value",
                    "--destination-ranges": "value",
                    "--disabled": "bool",
                    "--enable-logging": "bool",
                    "--logging-metadata": [
                      "exclude-all",
                      "include-all"
                    ],
                    "--priority": "value",
                    "--rules": "value",
                    "--source-ranges": "value",
                    "--source-service-accounts": "value",
                    "--source-tags": "value",
                    "--target-service-accounts": "value",
                    "--target-tags": "value"
                  }
                }
              },
              "flags": {}
            },
            "forwarding-rules": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--address": "dynamic",
                    "--address-region": "dynamic",
                    "--allow-global-access": "bool",
                    "--allow-psc-global-access": "bool",
                    "--backend-service": "value",
                    "--backend-service-region": "dynamic",
                    "--description": "value",
                    "--disable-automate-dns-zone": "bool",
                    "--global": "bool",
                    "--global-address": "bool",
                    "--global-backend-service": "bool",
                    "--global-target-http-proxy": "bool",
                    "--global-target-https-proxy": "bool",
                    "--global-target-tcp-proxy": "bool",
                    "--ip-collection": "value",
                    "--ip-collection-region": "dynamic",
                    "--ip-protocol": [
                      "AH",
                      "ESP",
                      "ICMP",
                      "L3_DEFAULT",
                      "SCTP",
                      "TCP",
                      "UDP"
                    ],
                    "--ip-version": [
                      "IPV4",
                      "IPV6"
                    ],
                    "--is-mirroring-collector": "bool",
                    "--load-balancing-scheme": [
                      "EXTERNAL",
                      "EXTERNAL_MANAGED",
                      "INTERNAL",
                      "INTERNAL_MANAGED",
                      "INTERNAL_SELF_MANAGED"
                    ],
                    "--network": "value",
                    "--network-tier": "value",
                    "--port-range": "value",
                    "--ports": "value",
                    "--region": "dynamic",
                    "--service-directory-registration": "value",
                    "--service-label": "value",
                    "--source-ip-ranges": "value",
                    "--subnet": "value",
                    "--subnet-region": "dynamic",
                    "--target-google-apis-bundle": "value",
                    "--target-grpc-proxy": "value",
                    "--target-http-proxy": "value",
                    "--target-http-proxy-region": "dynamic",
                    "--target-https-proxy": "value",
                    "--target-https-proxy-region": "dynamic",
                    "--target-instance": "value",
                    "--target-instance-zone": "dynamic",
                    "--target-pool": "value",
                    "--target-pool-region": "dynamic",
                    "--target-service-attachment": "value",
                    "--target-service-attachment-region": "dynamic",
                    "--target-ssl-proxy": "value",
                    "--target-tcp-proxy": "value",
                    "--target-tcp-proxy-region": "dynamic",
                    "--target-vpn-gateway": "value",
                    "--target-vpn-gateway-region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "set-target": {
                  "commands": {},
                  "flags": {
                    "--backend-service": "value",
                    "--backend-service-region": "dynamic",
                    "--global": "bool",
                    "--global-backend-service": "bool",
                    "--global-target-http-proxy": "bool",
                    "--global-target-https-proxy": "bool",
                    "--global-target-tcp-proxy": "bool",
                    "--load-balancing-scheme": [
                      "EXTERNAL",
                      "EXTERNAL_MANAGED",
                      "INTERNAL",
                      "INTERNAL_MANAGED",
                      "INTERNAL_SELF_MANAGED"
                    ],
                    "--network": "value",
                    "--region": "dynamic",
                    "--subnet": "value",
                    "--subnet-region": "value",
                    "--target-grpc-proxy": "value",
                    "--target-http-proxy": "value",
                    "--target-http-proxy-region": "dynamic",
                    "--target-https-proxy": "value",
                    "--target-https-proxy-region": "dynamic",
                    "--target-instance": "value",
                    "--target-instance-zone": "dynamic",
                    "--target-pool": "value",
                    "--target-pool-region": "dynamic",
                    "--target-ssl-proxy": "value",
                    "--target-tcp-proxy": "value",
                    "--target-tcp-proxy-region": "dynamic",
                    "--target-vpn-gateway": "value",
                    "--target-vpn-gateway-region": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--allow-global-access": "bool",
                    "--allow-psc-global-access": "bool",
                    "--clear-external-managed-backend-bucket-migration-state": "bool",
                    "--clear-labels": "bool",
                    "--external-managed-backend-bucket-migration-state": [
                      "PREPARE",
                      "TEST_ALL_TRAFFIC",
                      "TEST_BY_PERCENTAGE"
                    ],
                    "--external-managed-backend-bucket-migration-testing-percentage": "value",
                    "--global": "bool",
                    "--load-balancing-scheme": [
                      "EXTERNAL",
                      "EXTERNAL_MANAGED"
                    ],
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--source-ip-ranges": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "future-reservations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--zone": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--auto-created-reservations-delete-time": "value",
                    "--auto-created-reservations-duration": "value",
                    "--auto-delete-auto-created-reservations": "bool",
                    "--deployment-type": [
                      "DENSE",
                      "FLEXIBLE"
                    ],
                    "--description": "value",
                    "--duration": "value",
                    "--end-time": "value",
                    "--local-ssd": "value",
                    "--machine-type": "value",
                    "--min-cpu-platform": "value",
                    "--name-prefix": "value",
                    "--planning-status": [
                      "DRAFT",
                      "SUBMITTED"
                    ],
                    "--require-specific-reservation": "bool",
                    "--reservation-name": "value",
                    "--scheduling-type": [
                      "GROUPED",
                      "INDEPENDENT"
                    ],
                    "--share-setting": [
                      "local",
                      "projects"
                    ],
                    "--share-with": "value",
                    "--source-instance-template": "value",
                    "--start-time": "value",
                    "--total-count": "value",
                    "--zone": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--auto-created-reservations-delete-time": "value",
                    "--auto-created-reservations-duration": "value",
                    "--auto-delete-auto-created-reservations": "bool",
                    "--clear-accelerator": "bool",
                    "--clear-local-ssd": "bool",
                    "--clear-name-prefix": "bool",
                    "--clear-share-settings": "bool",
                    "--deployment-type": [
                      "DENSE",
                      "FLEXIBLE"
                    ],
                    "--description": "value",
                    "--duration": "value",
                    "--end-time": "value",
                    "--local-ssd": "value",
                    "--machine-type": "value",
                    "--min-cpu-platform": "value",
                    "--name-prefix": "value",
                    "--planning-status": [
                      "DRAFT",
                      "SUBMITTED"
                    ],
                    "--require-specific-reservation": "bool",
                    "--reservation-name": "value",
                    "--scheduling-type": [
                      "GROUPED",
                      "INDEPENDENT"
                    ],
                    "--share-setting": [
                      "local",
                      "projects"
                    ],
                    "--share-with": "value",
                    "--start-time": "value",
                    "--total-count": "value",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "health-checks": {
              "commands": {
                "create": {
                  "commands": {
                    "grpc": {
                      "commands": {},
                      "flags": {
                        "--check-interval": "value",
                        "--description": "value",
                        "--enable-logging": "bool",
                        "--global": "bool",
                        "--grpc-service-name": "value",
                        "--healthy-threshold": "value",
                        "--port": "value",
                        "--region": "dynamic",
                        "--timeout": "value",
                        "--unhealthy-threshold": "value",
                        "--use-serving-port": "bool"
                      }
                    },
                    "http": {
                      "commands": {},
                      "flags": {
                        "--check-interval": "value",
                        "--description": "value",
                        "--enable-logging": "bool",
                        "--global": "bool",
                        "--healthy-threshold": "value",
                        "--host": "value",
                        "--port": "value",
                        "--port-name": "value",
                        "--proxy-header": [
                          "NONE",
                          "PROXY_V1"
                        ],
                        "--region": "dynamic",
                        "--request-path": "value",
                        "--response": "value",
                        "--source-regions": "value",
                        "--timeout": "value",
                        "--unhealthy-threshold": "value",
                        "--use-serving-port": "bool"
                      }
                    },
                    "http2": {
                      "commands": {},
                      "flags": {
                        "--check-interval": "value",
                        "--description": "value",
                        "--enable-logging": "bool",
                        "--global": "bool",
                        "--healthy-threshold": "value",
                        "--host": "value",
                        "--port": "value",
                        "--port-name": "value",
                        "--proxy-header": [
                          "NONE",
                          "PROXY_V1"
                        ],
                        "--region": "dynamic",
                        "--request-path": "value",
                        "--response": "value",
                        "--timeout": "value",
                        "--unhealthy-threshold": "value",
                        "--use-serving-port": "bool"
                      }
                    },
                    "https": {
                      "commands": {},
                      "flags": {
                        "--check-interval": "value",
                        "--description": "value",
                        "--enable-logging": "bool",
                        "--global": "bool",
                        "--healthy-threshold": "value",
                        "--host": "value",
                        "--port": "value",
                        "--port-name": "value",
                        "--proxy-header": [
                          "NONE",
                          "PROXY_V1"
                        ],
                        "--region": "dynamic",
                        "--request-path": "value",
                        "--response": "value",
                        "--source-regions": "value",
                        "--timeout": "value",
                        "--unhealthy-threshold": "value",
                        "--use-serving-port": "bool"
                      }
                    },
                    "ssl": {
                      "commands": {},
                      "flags": {
                        "--check-interval": "value",
                        "--description": "value",
                        "--enable-logging": "bool",
                        "--global": "bool",
                        "--healthy-threshold": "value",
                        "--port": "value",
                        "--port-name": "value",
                        "--proxy-header": [
                          "NONE",
                          "PROXY_V1"
                        ],
                        "--region": "dynamic",
                        "--request": "value",
                        "--response": "value",
                        "--timeout": "value",
                        "--unhealthy-threshold": "value",
                        "--use-serving-port": "bool"
                      }
                    },
                    "tcp": {
                      "commands": {},
                      "flags": {
                        "--check-interval": "value",
                        "--description": "value",
                        "--enable-logging": "bool",
                        "--global": "bool",
                        "--healthy-threshold": "value",
                        "--port": "value",
                        "--port-name": "value",
                        "--proxy-header": [
                          "NONE",
                          "PROXY_V1"
                        ],
                        "--region": "dynamic",
                        "--request": "value",
                        "--response": "value",
                        "--source-regions": "value",
                        "--timeout": "value",
                        "--unhealthy-threshold": "value",
                        "--use-serving-port": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--protocol": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {
                    "grpc": {
                      "commands": {},
                      "flags": {
                        "--check-interval": "value",
                        "--description": "value",
                        "--enable-logging": "bool",
                        "--global": "bool",
                        "--grpc-service-name": "value",
                        "--healthy-threshold": "value",
                        "--port": "value",
                        "--region": "dynamic",
                        "--timeout": "value",
                        "--unhealthy-threshold": "value",
                        "--use-serving-port": "bool"
                      }
                    },
                    "http": {
                      "commands": {},
                      "flags": {
                        "--check-interval": "value",
                        "--description": "value",
                        "--enable-logging": "bool",
                        "--global": "bool",
                        "--healthy-threshold": "value",
                        "--host": "value",
                        "--port": "value",
                        "--port-name": "value",
                        "--proxy-header": [
                          "NONE",
                          "PROXY_V1"
                        ],
                        "--region": "dynamic",
                        "--request-path": "value",
                        "--response": "value",
                        "--source-regions": "value",
                        "--timeout": "value",
                        "--unhealthy-threshold": "value",
                        "--use-serving-port": "bool"
                      }
                    },
                    "http2": {
                      "commands": {},
                      "flags": {
                        "--check-interval": "value",
                        "--description": "value",
                        "--enable-logging": "bool",
                        "--global": "bool",
                        "--healthy-threshold": "value",
                        "--host": "value",
                        "--port": "value",
                        "--port-name": "value",
                        "--proxy-header": [
                          "NONE",
                          "PROXY_V1"
                        ],
                        "--region": "dynamic",
                        "--request-path": "value",
                        "--response": "value",
                        "--timeout": "value",
                        "--unhealthy-threshold": "value",
                        "--use-serving-port": "bool"
                      }
                    },
                    "https": {
                      "commands": {},
                      "flags": {
                        "--check-interval": "value",
                        "--description": "value",
                        "--enable-logging": "bool",
                        "--global": "bool",
                        "--healthy-threshold": "value",
                        "--host": "value",
                        "--port": "value",
                        "--port-name": "value",
                        "--proxy-header": [
                          "NONE",
                          "PROXY_V1"
                        ],
                        "--region": "dynamic",
                        "--request-path": "value",
                        "--response": "value",
                        "--source-regions": "value",
                        "--timeout": "value",
                        "--unhealthy-threshold": "value",
                        "--use-serving-port": "bool"
                      }
                    },
                    "ssl": {
                      "commands": {},
                      "flags": {
                        "--check-interval": "value",
                        "--description": "value",
                        "--enable-logging": "bool",
                        "--global": "bool",
                        "--healthy-threshold": "value",
                        "--port": "value",
                        "--port-name": "value",
                        "--proxy-header": [
                          "NONE",
                          "PROXY_V1"
                        ],
                        "--region": "dynamic",
                        "--request": "value",
                        "--response": "value",
                        "--timeout": "value",
                        "--unhealthy-threshold": "value",
                        "--use-serving-port": "bool"
                      }
                    },
                    "tcp": {
                      "commands": {},
                      "flags": {
                        "--check-interval": "value",
                        "--description": "value",
                        "--enable-logging": "bool",
                        "--global": "bool",
                        "--healthy-threshold": "value",
                        "--port": "value",
                        "--port-name": "value",
                        "--proxy-header": [
                          "NONE",
                          "PROXY_V1"
                        ],
                        "--region": "dynamic",
                        "--request": "value",
                        "--response": "value",
                        "--source-regions": "value",
                        "--timeout": "value",
                        "--unhealthy-threshold": "value",
                        "--use-serving-port": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "http-health-checks": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--check-interval": "value",
                    "--description": "value",
                    "--healthy-threshold": "value",
                    "--host": "value",
                    "--port": "value",
                    "--request-path": "value",
                    "--timeout": "value",
                    "--unhealthy-threshold": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--check-interval": "value",
                    "--description": "value",
                    "--healthy-threshold": "value",
                    "--host": "value",
                    "--port": "value",
                    "--request-path": "value",
                    "--timeout": "value",
                    "--unhealthy-threshold": "value"
                  }
                }
              },
              "flags": {}
            },
            "https-health-checks": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--check-interval": "value",
                    "--description": "value",
                    "--healthy-threshold": "value",
                    "--host": "value",
                    "--port": "value",
                    "--request-path": "value",
                    "--timeout": "value",
                    "--unhealthy-threshold": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--check-interval": "value",
                    "--description": "value",
                    "--healthy-threshold": "value",
                    "--host": "value",
                    "--port": "value",
                    "--request-path": "value",
                    "--timeout": "value",
                    "--unhealthy-threshold": "value"
                  }
                }
              },
              "flags": {}
            },
            "images": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "add-labels": {
                  "commands": {},
                  "flags": {
                    "--labels": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--architecture": [
                      "ARM64",
                      "X86_64"
                    ],
                    "--csek-key-file": "value",
                    "--description": "value",
                    "--family": "value",
                    "--forbidden-database-file": "value",
                    "--force": "bool",
                    "--force-create": "bool",
                    "--guest-os-features": "value",
                    "--key-exchange-key-file": "value",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--licenses": "value",
                    "--platform-key-file": "value",
                    "--require-csek-key-create": "bool",
                    "--signature-database-file": "value",
                    "--source-disk": "dynamic",
                    "--source-disk-project": "value",
                    "--source-disk-zone": "dynamic",
                    "--source-image": "value",
                    "--source-image-family": "value",
                    "--source-image-project": "value",
                    "--source-snapshot": "dynamic",
                    "--source-uri": "value",
                    "--storage-location": "value",
                    "--user-licenses": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "deprecate": {
                  "commands": {},
                  "flags": {
                    "--delete-in": "value",
                    "--delete-on": "value",
                    "--deprecate-in": "value",
                    "--deprecate-on": "value",
                    "--obsolete-in": "value",
                    "--obsolete-on": "value",
                    "--replacement": "dynamic",
                    "--state": [
                      "ACTIVE",
                      "DELETED",
                      "DEPRECATED",
                      "OBSOLETE"
                    ]
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "describe-from-family": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cloudbuild-service-account": "value",
                    "--compute-service-account": "value",
                    "--destination-uri": "value",
                    "--export-format": "value",
                    "--image": "value",
                    "--image-family": "value",
                    "--image-project": "value",
                    "--log-location": "value",
                    "--network": "value",
                    "--subnet": "value",
                    "--timeout": "value",
                    "--zone": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--aws-access-key-id": "value",
                    "--aws-ami-export-location": "value",
                    "--aws-ami-id": "value",
                    "--aws-region": "value",
                    "--aws-secret-access-key": "value",
                    "--aws-session-token": "value",
                    "--aws-source-ami-file-path": "value",
                    "--byol": "bool",
                    "--cloudbuild-service-account": "value",
                    "--compute-service-account": "value",
                    "--data-disk": "bool",
                    "--description": "value",
                    "--family": "value",
                    "--guest-environment": "bool",
                    "--guest-os-features": "value",
                    "--log-location": "value",
                    "--network": "value",
                    "--no-address": "bool",
                    "--os": [
                      "centos-7",
                      "centos-stream-8",
                      "centos-stream-9",
                      "debian-10",
                      "debian-11",
                      "debian-8",
                      "debian-9",
                      "opensuse-15",
                      "rhel-6",
                      "rhel-6-byol",
                      "rhel-7",
                      "rhel-7-byol",
                      "rhel-8",
                      "rhel-8-byol",
                      "rhel-9",
                      "rhel-9-byol",
                      "rocky-8",
                      "rocky-9",
                      "sles-12",
                      "sles-12-byol",
                      "sles-15",
                      "sles-15-byol",
                      "sles-sap-12",
                      "sles-sap-12-byol",
                      "sles-sap-15",
                      "sles-sap-15-byol",
                      "ubuntu-1404",
                      "ubuntu-1604",
                      "ubuntu-1804",
                      "ubuntu-2004",
                      "ubuntu-2204",
                      "windows-10-x64-byol",
                      "windows-10-x86-byol",
                      "windows-11-x64-byol",
                      "windows-2008r2",
                      "windows-2008r2-byol",
                      "windows-2012",
                      "windows-2012-byol",
                      "windows-2012r2",
                      "windows-2012r2-byol",
                      "windows-2016",
                      "windows-2016-byol",
                      "windows-2019",
                      "windows-2019-byol",
                      "windows-2022",
                      "windows-2022-byol",
                      "windows-7-x64-byol",
                      "windows-7-x86-byol",
                      "windows-8-x64-byol",
                      "windows-8-x86-byol"
                    ],
                    "--source-file": "value",
                    "--source-image": "dynamic",
                    "--storage-location": "value",
                    "--subnet": "value",
                    "--timeout": "value",
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--image-zone": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--preview-images": "bool",
                    "--regexp": "value",
                    "--show-deprecated": "bool",
                    "--sort-by": "value",
                    "--standard-images": "bool",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "remove-labels": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--labels": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--architecture": [
                      "ARM64",
                      "X86_64"
                    ],
                    "--clear-labels": "bool",
                    "--clear-user-licenses": "bool",
                    "--description": "value",
                    "--family": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value",
                    "--update-user-licenses": "value"
                  }
                }
              },
              "flags": {}
            },
            "instance-groups": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "get-named-ports": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zones": "value"
                  }
                },
                "list-instances": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                },
                "managed": {
                  "commands": {
                    "abandon-instances": {
                      "commands": {},
                      "flags": {
                        "--instances": "value",
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "all-instances-config": {
                      "commands": {
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--labels": "value",
                            "--metadata": "value",
                            "--region": "dynamic",
                            "--zone": "dynamic"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--labels": "value",
                            "--metadata": "value",
                            "--region": "dynamic",
                            "--zone": "dynamic"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--base-instance-name": "value",
                        "--default-action-on-vm-failure": [
                          "do-nothing",
                          "repair"
                        ],
                        "--description": "value",
                        "--force-update-on-repair": "bool",
                        "--health-check": "dynamic",
                        "--http-health-check": "value",
                        "--https-health-check": "value",
                        "--initial-delay": "value",
                        "--instance-redistribution-type": [
                          "none",
                          "proactive"
                        ],
                        "--instance-selection": "value",
                        "--instance-selection-machine-types": "value",
                        "--list-managed-instances-results": [
                          "pageless",
                          "paginated"
                        ],
                        "--region": "dynamic",
                        "--resource-manager-tags": "value",
                        "--size": "value",
                        "--standby-policy-initial-delay": "value",
                        "--standby-policy-mode": [
                          "manual",
                          "scale-out-pool"
                        ],
                        "--stateful-disk": "value",
                        "--stateful-external-ip": "value",
                        "--stateful-internal-ip": "value",
                        "--stopped-size": "value",
                        "--suspended-size": "value",
                        "--target-distribution-shape": [
                          "any",
                          "any-single-zone",
                          "balanced",
                          "even"
                        ],
                        "--target-pool": "value",
                        "--template": "value",
                        "--update-policy-max-surge": "value",
                        "--update-policy-max-unavailable": "value",
                        "--update-policy-min-ready": "value",
                        "--update-policy-minimal-action": [
                          "none",
                          "refresh",
                          "replace",
                          "restart"
                        ],
                        "--update-policy-most-disruptive-action": [
                          "none",
                          "refresh",
                          "replace",
                          "restart"
                        ],
                        "--update-policy-replacement-method": [
                          "recreate",
                          "substitute"
                        ],
                        "--update-policy-type": [
                          "opportunistic",
                          "proactive"
                        ],
                        "--zone": "dynamic",
                        "--zones": "dynamic"
                      }
                    },
                    "create-instance": {
                      "commands": {},
                      "flags": {
                        "--instance": "value",
                        "--region": "dynamic",
                        "--stateful-disk": "value",
                        "--stateful-external-ip": "value",
                        "--stateful-internal-ip": "value",
                        "--stateful-metadata": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "delete-instances": {
                      "commands": {},
                      "flags": {
                        "--instances": "value",
                        "--region": "dynamic",
                        "--skip-instances-on-validation-error": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "describe-instance": {
                      "commands": {},
                      "flags": {
                        "--instance": "value",
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "export-autoscaling": {
                      "commands": {},
                      "flags": {
                        "--autoscaling-file": "value",
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "get-named-ports": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "dynamic",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "instance-configs": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--instance": "value",
                            "--instance-update-minimal-action": [
                              "none",
                              "refresh",
                              "replace",
                              "restart"
                            ],
                            "--region": "dynamic",
                            "--stateful-disk": "value",
                            "--stateful-external-ip": "value",
                            "--stateful-internal-ip": "value",
                            "--stateful-metadata": "value",
                            "--update-instance": "bool",
                            "--zone": "dynamic"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--instance-update-minimal-action": [
                              "none",
                              "refresh",
                              "replace",
                              "restart"
                            ],
                            "--instances": "value",
                            "--region": "dynamic",
                            "--update-instance": "bool",
                            "--zone": "dynamic"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--region": "dynamic",
                            "--sort-by": "value",
                            "--zone": "dynamic"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--instance": "value",
                            "--instance-update-minimal-action": [
                              "none",
                              "refresh",
                              "replace",
                              "restart"
                            ],
                            "--region": "dynamic",
                            "--remove-stateful-disks": "value",
                            "--remove-stateful-external-ips": "value",
                            "--remove-stateful-internal-ips": "value",
                            "--remove-stateful-metadata": "value",
                            "--stateful-disk": "value",
                            "--stateful-external-ip": "value",
                            "--stateful-internal-ip": "value",
                            "--stateful-metadata": "value",
                            "--update-instance": "bool",
                            "--zone": "dynamic"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--regexp": "value",
                        "--regions": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zones": "value"
                      }
                    },
                    "list-errors": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "dynamic",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "list-instances": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "dynamic",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "recreate-instances": {
                      "commands": {},
                      "flags": {
                        "--instances": "value",
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "resize": {
                      "commands": {},
                      "flags": {
                        "--creation-retries": "bool",
                        "--region": "dynamic",
                        "--size": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "resize-requests": {
                      "commands": {
                        "cancel": {
                          "commands": {},
                          "flags": {
                            "--region": "dynamic",
                            "--resize-requests": "value",
                            "--zone": "dynamic"
                          }
                        },
                        "create": {
                          "commands": {},
                          "flags": {
                            "--region": "dynamic",
                            "--requested-run-duration": "value",
                            "--resize-by": "value",
                            "--resize-request": "value",
                            "--zone": "dynamic"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--region": "dynamic",
                            "--resize-requests": "value",
                            "--zone": "dynamic"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--region": "dynamic",
                            "--resize-request": "value",
                            "--zone": "dynamic"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--region": "dynamic",
                            "--sort-by": "value",
                            "--uri": "bool",
                            "--zone": "dynamic"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "resume-instances": {
                      "commands": {},
                      "flags": {
                        "--instances": "value",
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "rolling-action": {
                      "commands": {
                        "replace": {
                          "commands": {},
                          "flags": {
                            "--max-surge": "value",
                            "--max-unavailable": "value",
                            "--min-ready": "value",
                            "--region": "dynamic",
                            "--replacement-method": [
                              "recreate",
                              "substitute"
                            ],
                            "--zone": "dynamic"
                          }
                        },
                        "restart": {
                          "commands": {},
                          "flags": {
                            "--max-unavailable": "value",
                            "--min-ready": "value",
                            "--region": "dynamic",
                            "--zone": "dynamic"
                          }
                        },
                        "start-update": {
                          "commands": {},
                          "flags": {
                            "--canary-version": "value",
                            "--force": "bool",
                            "--max-surge": "value",
                            "--max-unavailable": "value",
                            "--min-ready": "value",
                            "--minimal-action": [
                              "refresh",
                              "replace",
                              "restart"
                            ],
                            "--most-disruptive-allowed-action": [
                              "refresh",
                              "replace",
                              "restart"
                            ],
                            "--region": "dynamic",
                            "--replacement-method": [
                              "recreate",
                              "substitute"
                            ],
                            "--type": [
                              "opportunistic",
                              "proactive"
                            ],
                            "--zone": "dynamic"
                          }
                        },
                        "stop-proactive-update": {
                          "commands": {},
                          "flags": {
                            "--region": "dynamic",
                            "--zone": "dynamic"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "set-autohealing": {
                      "commands": {},
                      "flags": {
                        "--health-check": "dynamic",
                        "--http-health-check": "value",
                        "--https-health-check": "value",
                        "--initial-delay": "value",
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "set-autoscaling": {
                      "commands": {},
                      "flags": {
                        "--autoscaling-file": "value",
                        "--cool-down-period": "value",
                        "--cpu-utilization-predictive-method": [
                          "none",
                          "optimize-availability"
                        ],
                        "--custom-metric-utilization": "value",
                        "--description": "value",
                        "--max-num-replicas": "value",
                        "--min-num-replicas": "value",
                        "--mode": [
                          "off",
                          "on",
                          "only-scale-out",
                          "only-up"
                        ],
                        "--region": "dynamic",
                        "--remove-stackdriver-metric": "value",
                        "--scale-based-on-cpu": "bool",
                        "--scale-based-on-load-balancing": "bool",
                        "--scale-in-control": "value",
                        "--schedule-cron": "value",
                        "--schedule-description": "value",
                        "--schedule-duration-sec": "value",
                        "--schedule-min-required-replicas": "value",
                        "--schedule-time-zone": "value",
                        "--set-schedule": "value",
                        "--stackdriver-metric-filter": "value",
                        "--stackdriver-metric-single-instance-assignment": "value",
                        "--stackdriver-metric-utilization-target": "value",
                        "--stackdriver-metric-utilization-target-type": [
                          "delta-per-minute",
                          "delta-per-second",
                          "gauge"
                        ],
                        "--target-cpu-utilization": "value",
                        "--target-load-balancing-utilization": "value",
                        "--update-stackdriver-metric": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "set-instance-template": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--template": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "set-named-ports": {
                      "commands": {},
                      "flags": {
                        "--named-ports": "value",
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "set-target-pools": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--target-pools": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "start-instances": {
                      "commands": {},
                      "flags": {
                        "--instances": "value",
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "stop-autoscaling": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "stop-instances": {
                      "commands": {},
                      "flags": {
                        "--force": "bool",
                        "--instances": "value",
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "suspend-instances": {
                      "commands": {},
                      "flags": {
                        "--force": "bool",
                        "--instances": "value",
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--clear-autohealing": "bool",
                        "--default-action-on-vm-failure": [
                          "do-nothing",
                          "repair"
                        ],
                        "--description": "value",
                        "--force-update-on-repair": "bool",
                        "--health-check": "dynamic",
                        "--http-health-check": "value",
                        "--https-health-check": "value",
                        "--initial-delay": "value",
                        "--instance-redistribution-type": [
                          "none",
                          "proactive"
                        ],
                        "--instance-selection": "value",
                        "--instance-selection-machine-types": "value",
                        "--list-managed-instances-results": [
                          "pageless",
                          "paginated"
                        ],
                        "--region": "dynamic",
                        "--remove-instance-selections": "value",
                        "--remove-instance-selections-all": "bool",
                        "--remove-stateful-disks": "value",
                        "--remove-stateful-external-ips": "value",
                        "--remove-stateful-internal-ips": "value",
                        "--size": "value",
                        "--standby-policy-initial-delay": "value",
                        "--standby-policy-mode": [
                          "manual",
                          "scale-out-pool"
                        ],
                        "--stateful-disk": "value",
                        "--stateful-external-ip": "value",
                        "--stateful-internal-ip": "value",
                        "--stopped-size": "value",
                        "--suspended-size": "value",
                        "--target-distribution-shape": [
                          "any",
                          "any-single-zone",
                          "balanced",
                          "even"
                        ],
                        "--update-policy-max-surge": "value",
                        "--update-policy-max-unavailable": "value",
                        "--update-policy-min-ready": "value",
                        "--update-policy-minimal-action": [
                          "none",
                          "refresh",
                          "replace",
                          "restart"
                        ],
                        "--update-policy-most-disruptive-action": [
                          "none",
                          "refresh",
                          "replace",
                          "restart"
                        ],
                        "--update-policy-replacement-method": [
                          "recreate",
                          "substitute"
                        ],
                        "--update-policy-type": [
                          "opportunistic",
                          "proactive"
                        ],
                        "--zone": "dynamic"
                      }
                    },
                    "update-autoscaling": {
                      "commands": {},
                      "flags": {
                        "--clear-scale-down-control": "bool",
                        "--clear-scale-in-control": "bool",
                        "--cpu-utilization-predictive-method": [
                          "none",
                          "optimize-availability"
                        ],
                        "--disable-schedule": "value",
                        "--enable-schedule": "value",
                        "--max-num-replicas": "value",
                        "--min-num-replicas": "value",
                        "--mode": [
                          "off",
                          "on",
                          "only-scale-out",
                          "only-up"
                        ],
                        "--region": "dynamic",
                        "--remove-schedule": "value",
                        "--scale-in-control": "value",
                        "--schedule-cron": "value",
                        "--schedule-description": "value",
                        "--schedule-duration-sec": "value",
                        "--schedule-min-required-replicas": "value",
                        "--schedule-time-zone": "value",
                        "--set-schedule": "value",
                        "--update-schedule": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "update-instances": {
                      "commands": {},
                      "flags": {
                        "--all-instances": "bool",
                        "--instances": "value",
                        "--minimal-action": [
                          "none",
                          "refresh",
                          "replace",
                          "restart"
                        ],
                        "--most-disruptive-allowed-action": [
                          "none",
                          "refresh",
                          "replace",
                          "restart"
                        ],
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "wait-until": {
                      "commands": {},
                      "flags": {
                        "--all-instances-config-effective": "bool",
                        "--region": "dynamic",
                        "--stable": "bool",
                        "--timeout": "value",
                        "--version-target-reached": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "wait-until-stable": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--timeout": "value",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "set-named-ports": {
                  "commands": {},
                  "flags": {
                    "--named-ports": "value",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "unmanaged": {
                  "commands": {
                    "add-instances": {
                      "commands": {},
                      "flags": {
                        "--instances": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--description": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--zone": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--zone": "dynamic"
                      }
                    },
                    "get-named-ports": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "dynamic",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--regexp": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zones": "dynamic"
                      }
                    },
                    "list-instances": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--regexp": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "remove-instances": {
                      "commands": {},
                      "flags": {
                        "--instances": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "set-named-ports": {
                      "commands": {},
                      "flags": {
                        "--named-ports": "value",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "instance-templates": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--address": "value",
                    "--boot-disk-auto-delete": "bool",
                    "--boot-disk-device-name": "value",
                    "--boot-disk-interface": "value",
                    "--boot-disk-kms-key": "dynamic",
                    "--boot-disk-kms-keyring": "dynamic",
                    "--boot-disk-kms-location": "dynamic",
                    "--boot-disk-kms-project": "dynamic",
                    "--boot-disk-provisioned-iops": "value",
                    "--boot-disk-provisioned-throughput": "value",
                    "--boot-disk-size": "value",
                    "--boot-disk-type": "value",
                    "--can-ip-forward": "bool",
                    "--confidential-compute": "bool",
                    "--confidential-compute-type": [
                      "SEV",
                      "SEV_SNP",
                      "TDX"
                    ],
                    "--configure-disk": "value",
                    "--create-disk": "value",
                    "--custom-cpu": "value",
                    "--custom-extensions": "bool",
                    "--custom-memory": "value",
                    "--custom-vm-type": "value",
                    "--description": "value",
                    "--discard-local-ssds-at-termination-timestamp": "value",
                    "--disk": "value",
                    "--enable-nested-virtualization": "bool",
                    "--enable-uefi-networking": "bool",
                    "--external-ipv6-address": "value",
                    "--external-ipv6-prefix-length": "value",
                    "--graceful-shutdown": "bool",
                    "--graceful-shutdown-max-duration": "value",
                    "--host-error-timeout-seconds": "value",
                    "--image": "value",
                    "--image-family": "value",
                    "--image-project": "value",
                    "--instance-template-region": "value",
                    "--instance-termination-action": [
                      "DELETE",
                      "STOP"
                    ],
                    "--internal-ipv6-address": "value",
                    "--internal-ipv6-prefix-length": "value",
                    "--ipv6-network-tier": [
                      "PREMIUM"
                    ],
                    "--key-revocation-action-type": [
                      "none",
                      "stop"
                    ],
                    "--labels": "value",
                    "--local-ssd": "value",
                    "--local-ssd-recovery-timeout": "value",
                    "--machine-type": "dynamic",
                    "--maintenance-interval": [
                      "PERIODIC"
                    ],
                    "--maintenance-policy": [
                      "MIGRATE",
                      "TERMINATE"
                    ],
                    "--max-run-duration": "value",
                    "--mesh": "value",
                    "--metadata": "value",
                    "--metadata-from-file": "value",
                    "--min-cpu-platform": "value",
                    "--min-node-cpu": "value",
                    "--network": "value",
                    "--network-interface": "value",
                    "--network-performance-configs": "value",
                    "--network-tier": "value",
                    "--no-address": "bool",
                    "--no-scopes": "bool",
                    "--no-service-account": "bool",
                    "--node": "value",
                    "--node-affinity-file": "value",
                    "--node-group": "value",
                    "--partner-metadata": "value",
                    "--partner-metadata-from-file": "value",
                    "--performance-monitoring-unit": [
                      "architectural",
                      "enhanced",
                      "standard"
                    ],
                    "--post-key-revocation-action-type": [
                      "noop",
                      "shutdown"
                    ],
                    "--preemptible": "bool",
                    "--private-ipv6-google-access-type": [
                      "enable-bidirectional-access",
                      "enable-outbound-vm-access",
                      "inherit-subnetwork"
                    ],
                    "--private-network-ip": "value",
                    "--provisioning-model": [
                      "RESERVATION_BOUND",
                      "SPOT",
                      "STANDARD"
                    ],
                    "--region": "dynamic",
                    "--reservation": "value",
                    "--reservation-affinity": [
                      "any",
                      "none",
                      "specific",
                      "specific-then-any-reservation",
                      "specific-then-no-reservation"
                    ],
                    "--resource-manager-tags": "value",
                    "--resource-policies": "value",
                    "--restart-on-failure": "bool",
                    "--scopes": "value",
                    "--service-account": "value",
                    "--service-proxy": "value",
                    "--service-proxy-labels": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-secure-boot": "bool",
                    "--shielded-vtpm": "bool",
                    "--source-instance": "dynamic",
                    "--source-instance-zone": "dynamic",
                    "--stack-type": [
                      "IPV4_IPV6",
                      "IPV4_ONLY",
                      "IPV6_ONLY"
                    ],
                    "--subnet": "value",
                    "--tags": "value",
                    "--termination-time": "value",
                    "--threads-per-core": "value",
                    "--turbo-mode": "value",
                    "--visible-core-count": "value"
                  }
                },
                "create-with-container": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--address": "value",
                    "--boot-disk-auto-delete": "bool",
                    "--boot-disk-device-name": "value",
                    "--boot-disk-interface": "value",
                    "--boot-disk-provisioned-iops": "value",
                    "--boot-disk-provisioned-throughput": "value",
                    "--boot-disk-size": "value",
                    "--boot-disk-type": "value",
                    "--can-ip-forward": "bool",
                    "--confidential-compute": "bool",
                    "--container-arg": "value",
                    "--container-command": "value",
                    "--container-env": "value",
                    "--container-env-file": "value",
                    "--container-image": "value",
                    "--container-mount-disk": "value",
                    "--container-mount-host-path": "value",
                    "--container-mount-tmpfs": "value",
                    "--container-privileged": "bool",
                    "--container-restart-policy": [
                      "always",
                      "never",
                      "on-failure"
                    ],
                    "--container-stdin": "bool",
                    "--container-tty": "bool",
                    "--create-disk": "value",
                    "--custom-cpu": "value",
                    "--custom-extensions": "bool",
                    "--custom-memory": "value",
                    "--custom-vm-type": "value",
                    "--description": "value",
                    "--disk": "value",
                    "--external-ipv6-address": "value",
                    "--external-ipv6-prefix-length": "value",
                    "--image": "value",
                    "--image-family": "value",
                    "--image-project": "value",
                    "--internal-ipv6-address": "value",
                    "--internal-ipv6-prefix-length": "value",
                    "--ipv6-network-tier": [
                      "PREMIUM"
                    ],
                    "--labels": "value",
                    "--local-ssd": "value",
                    "--machine-type": "dynamic",
                    "--maintenance-policy": [
                      "MIGRATE",
                      "TERMINATE"
                    ],
                    "--metadata": "value",
                    "--metadata-from-file": "value",
                    "--min-cpu-platform": "value",
                    "--network": "value",
                    "--network-interface": "value",
                    "--network-tier": "value",
                    "--no-address": "bool",
                    "--no-scopes": "bool",
                    "--no-service-account": "bool",
                    "--preemptible": "bool",
                    "--private-ipv6-google-access-type": [
                      "enable-bidirectional-access",
                      "enable-outbound-vm-access",
                      "inherit-subnetwork"
                    ],
                    "--private-network-ip": "value",
                    "--region": "dynamic",
                    "--reservation": "value",
                    "--reservation-affinity": [
                      "any",
                      "none",
                      "specific",
                      "specific-then-any-reservation",
                      "specific-then-no-reservation"
                    ],
                    "--resource-policies": "value",
                    "--restart-on-failure": "bool",
                    "--scopes": "value",
                    "--service-account": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-secure-boot": "bool",
                    "--shielded-vtpm": "bool",
                    "--stack-type": [
                      "IPV4_IPV6",
                      "IPV4_ONLY",
                      "IPV6_ONLY"
                    ],
                    "--subnet": "value",
                    "--tags": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--view": [
                      "BASIC",
                      "FULL"
                    ]
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--view": [
                      "BASIC",
                      "FULL"
                    ]
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "instances": {
              "commands": {
                "add-access-config": {
                  "commands": {},
                  "flags": {
                    "--access-config-name": "value",
                    "--address": "value",
                    "--network-interface": "value",
                    "--network-tier": "value",
                    "--no-public-ptr": "bool",
                    "--no-public-ptr-domain": "bool",
                    "--public-ptr": "bool",
                    "--public-ptr-domain": "value",
                    "--zone": "dynamic"
                  }
                },
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic",
                    "--zone": "value"
                  }
                },
                "add-labels": {
                  "commands": {},
                  "flags": {
                    "--labels": "value",
                    "--zone": "dynamic"
                  }
                },
                "add-metadata": {
                  "commands": {},
                  "flags": {
                    "--metadata": "value",
                    "--metadata-from-file": "value",
                    "--zone": "dynamic"
                  }
                },
                "add-partner-metadata": {
                  "commands": {},
                  "flags": {
                    "--partner-metadata": "value",
                    "--partner-metadata-from-file": "value",
                    "--zone": "dynamic"
                  }
                },
                "add-resource-policies": {
                  "commands": {},
                  "flags": {
                    "--resource-policies": "value",
                    "--zone": "dynamic"
                  }
                },
                "add-tags": {
                  "commands": {},
                  "flags": {
                    "--tags": "value",
                    "--zone": "dynamic"
                  }
                },
                "attach-disk": {
                  "commands": {},
                  "flags": {
                    "--boot": "bool",
                    "--csek-key-file": "value",
                    "--device-name": "value",
                    "--disk": "value",
                    "--disk-scope": [
                      "regional",
                      "zonal"
                    ],
                    "--force-attach": "bool",
                    "--interface": [
                      "NVME",
                      "SCSI"
                    ],
                    "--mode": [
                      "ro",
                      "rw"
                    ],
                    "--zone": "dynamic"
                  }
                },
                "bulk": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--accelerator": "value",
                        "--async": "bool",
                        "--boot-disk-auto-delete": "bool",
                        "--boot-disk-device-name": "value",
                        "--boot-disk-interface": "value",
                        "--boot-disk-kms-key": "dynamic",
                        "--boot-disk-kms-keyring": "dynamic",
                        "--boot-disk-kms-location": "dynamic",
                        "--boot-disk-kms-project": "dynamic",
                        "--boot-disk-provisioned-iops": "value",
                        "--boot-disk-provisioned-throughput": "value",
                        "--boot-disk-size": "value",
                        "--boot-disk-type": "value",
                        "--can-ip-forward": "bool",
                        "--confidential-compute": "bool",
                        "--confidential-compute-type": [
                          "SEV",
                          "SEV_SNP",
                          "TDX"
                        ],
                        "--count": "value",
                        "--create-disk": "value",
                        "--custom-cpu": "value",
                        "--custom-extensions": "bool",
                        "--custom-memory": "value",
                        "--custom-vm-type": "value",
                        "--description": "value",
                        "--discard-local-ssds-at-termination-timestamp": "value",
                        "--disk": "value",
                        "--enable-display-device": "bool",
                        "--enable-nested-virtualization": "bool",
                        "--enable-uefi-networking": "bool",
                        "--erase-windows-vss-signature": "bool",
                        "--graceful-shutdown": "bool",
                        "--graceful-shutdown-max-duration": "value",
                        "--host-error-timeout-seconds": "value",
                        "--image": "value",
                        "--image-family": "value",
                        "--image-project": "value",
                        "--instance-termination-action": [
                          "DELETE",
                          "STOP"
                        ],
                        "--labels": "value",
                        "--local-ssd": "value",
                        "--local-ssd-recovery-timeout": "value",
                        "--location-policy": "value",
                        "--machine-type": "dynamic",
                        "--maintenance-policy": [
                          "MIGRATE",
                          "TERMINATE"
                        ],
                        "--max-count-per-zone": "value",
                        "--max-run-duration": "value",
                        "--metadata": "value",
                        "--metadata-from-file": "value",
                        "--min-count": "value",
                        "--min-cpu-platform": "value",
                        "--min-node-cpu": "value",
                        "--name-pattern": "value",
                        "--network": "value",
                        "--network-interface": "value",
                        "--network-performance-configs": "value",
                        "--network-tier": "value",
                        "--no-address": "bool",
                        "--no-public-dns": "bool",
                        "--no-scopes": "bool",
                        "--no-service-account": "bool",
                        "--on-host-maintenance": [
                          "MIGRATE",
                          "TERMINATE"
                        ],
                        "--per-instance-hostnames": "value",
                        "--performance-monitoring-unit": [
                          "architectural",
                          "enhanced",
                          "standard"
                        ],
                        "--post-key-revocation-action-type": [
                          "noop",
                          "shutdown"
                        ],
                        "--predefined-names": "value",
                        "--preemptible": "bool",
                        "--provisioning-model": [
                          "RESERVATION_BOUND",
                          "SPOT",
                          "STANDARD"
                        ],
                        "--public-dns": "bool",
                        "--region": "value",
                        "--reservation": "value",
                        "--reservation-affinity": [
                          "any",
                          "none",
                          "specific",
                          "specific-then-any-reservation",
                          "specific-then-no-reservation"
                        ],
                        "--resource-manager-tags": "value",
                        "--resource-policies": "value",
                        "--restart-on-failure": "bool",
                        "--scopes": "value",
                        "--service-account": "value",
                        "--shielded-integrity-monitoring": "bool",
                        "--shielded-secure-boot": "bool",
                        "--shielded-vtpm": "bool",
                        "--source-instance-template": "dynamic",
                        "--source-snapshot": "value",
                        "--stack-type": [
                          "IPV4_IPV6",
                          "IPV4_ONLY",
                          "IPV6_ONLY"
                        ],
                        "--subnet": "value",
                        "--tags": "value",
                        "--target-distribution-shape": [
                          "ANY",
                          "ANY_SINGLE_ZONE",
                          "BALANCED"
                        ],
                        "--termination-time": "value",
                        "--threads-per-core": "value",
                        "--turbo-mode": "value",
                        "--visible-core-count": "value",
                        "--zone": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--address": "value",
                    "--async": "bool",
                    "--availability-domain": "value",
                    "--boot-disk-auto-delete": "bool",
                    "--boot-disk-device-name": "value",
                    "--boot-disk-interface": "value",
                    "--boot-disk-kms-key": "dynamic",
                    "--boot-disk-kms-keyring": "dynamic",
                    "--boot-disk-kms-location": "dynamic",
                    "--boot-disk-kms-project": "dynamic",
                    "--boot-disk-provisioned-iops": "value",
                    "--boot-disk-provisioned-throughput": "value",
                    "--boot-disk-size": "value",
                    "--boot-disk-type": "value",
                    "--can-ip-forward": "bool",
                    "--confidential-compute": "bool",
                    "--confidential-compute-type": [
                      "SEV",
                      "SEV_SNP",
                      "TDX"
                    ],
                    "--create-disk": "value",
                    "--csek-key-file": "value",
                    "--custom-cpu": "value",
                    "--custom-extensions": "bool",
                    "--custom-memory": "value",
                    "--custom-vm-type": "value",
                    "--deletion-protection": "bool",
                    "--description": "value",
                    "--discard-local-ssds-at-termination-timestamp": "value",
                    "--disk": "value",
                    "--enable-display-device": "bool",
                    "--enable-nested-virtualization": "bool",
                    "--enable-uefi-networking": "bool",
                    "--erase-windows-vss-signature": "bool",
                    "--external-ipv6-address": "value",
                    "--external-ipv6-prefix-length": "value",
                    "--graceful-shutdown": "bool",
                    "--graceful-shutdown-max-duration": "value",
                    "--host-error-timeout-seconds": "value",
                    "--hostname": "value",
                    "--image": "value",
                    "--image-family": "value",
                    "--image-family-scope": [
                      "global",
                      "zonal"
                    ],
                    "--image-project": "value",
                    "--instance-kms-key": "dynamic",
                    "--instance-kms-keyring": "dynamic",
                    "--instance-kms-location": "dynamic",
                    "--instance-kms-project": "dynamic",
                    "--instance-termination-action": [
                      "DELETE",
                      "STOP"
                    ],
                    "--internal-ipv6-address": "value",
                    "--internal-ipv6-prefix-length": "value",
                    "--ipv6-network-tier": [
                      "PREMIUM"
                    ],
                    "--ipv6-public-ptr-domain": "value",
                    "--key-revocation-action-type": [
                      "none",
                      "stop"
                    ],
                    "--labels": "value",
                    "--local-ssd": "value",
                    "--local-ssd-recovery-timeout": "value",
                    "--machine-type": "dynamic",
                    "--maintenance-policy": [
                      "MIGRATE",
                      "TERMINATE"
                    ],
                    "--max-run-duration": "value",
                    "--metadata": "value",
                    "--metadata-from-file": "value",
                    "--min-cpu-platform": "value",
                    "--min-node-cpu": "value",
                    "--network": "value",
                    "--network-interface": "value",
                    "--network-performance-configs": "value",
                    "--network-tier": "value",
                    "--no-address": "bool",
                    "--no-public-ptr": "bool",
                    "--no-public-ptr-domain": "bool",
                    "--no-scopes": "bool",
                    "--no-service-account": "bool",
                    "--node": "value",
                    "--node-affinity-file": "value",
                    "--node-group": "value",
                    "--node-project": "value",
                    "--partner-metadata": "value",
                    "--partner-metadata-from-file": "value",
                    "--performance-monitoring-unit": [
                      "architectural",
                      "enhanced",
                      "standard"
                    ],
                    "--post-key-revocation-action-type": [
                      "noop",
                      "shutdown"
                    ],
                    "--preemptible": "bool",
                    "--private-ipv6-google-access-type": [
                      "enable-bidirectional-access",
                      "enable-outbound-vm-access",
                      "inherit-subnetwork"
                    ],
                    "--private-network-ip": "value",
                    "--provisioning-model": [
                      "RESERVATION_BOUND",
                      "SPOT",
                      "STANDARD"
                    ],
                    "--public-ptr": "bool",
                    "--public-ptr-domain": "value",
                    "--require-csek-key-create": "bool",
                    "--reservation": "value",
                    "--reservation-affinity": [
                      "any",
                      "none",
                      "specific",
                      "specific-then-any-reservation",
                      "specific-then-no-reservation"
                    ],
                    "--resource-manager-tags": "value",
                    "--resource-policies": "value",
                    "--restart-on-failure": "bool",
                    "--scopes": "value",
                    "--service-account": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-secure-boot": "bool",
                    "--shielded-vtpm": "bool",
                    "--source-instance-template": "dynamic",
                    "--source-machine-image": "dynamic",
                    "--source-machine-image-csek-key-file": "value",
                    "--source-snapshot": "value",
                    "--stack-type": [
                      "IPV4_IPV6",
                      "IPV4_ONLY",
                      "IPV6_ONLY"
                    ],
                    "--subnet": "value",
                    "--tags": "value",
                    "--termination-time": "value",
                    "--threads-per-core": "value",
                    "--turbo-mode": "value",
                    "--visible-core-count": "value",
                    "--zone": "dynamic"
                  }
                },
                "create-with-container": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--address": "value",
                    "--boot-disk-auto-delete": "bool",
                    "--boot-disk-device-name": "value",
                    "--boot-disk-interface": "value",
                    "--boot-disk-provisioned-iops": "value",
                    "--boot-disk-provisioned-throughput": "value",
                    "--boot-disk-size": "value",
                    "--boot-disk-type": "value",
                    "--can-ip-forward": "bool",
                    "--confidential-compute": "bool",
                    "--confidential-compute-type": [
                      "SEV",
                      "SEV_SNP",
                      "TDX"
                    ],
                    "--container-arg": "value",
                    "--container-command": "value",
                    "--container-env": "value",
                    "--container-env-file": "value",
                    "--container-image": "value",
                    "--container-mount-disk": "value",
                    "--container-mount-host-path": "value",
                    "--container-mount-tmpfs": "value",
                    "--container-privileged": "bool",
                    "--container-restart-policy": [
                      "always",
                      "never",
                      "on-failure"
                    ],
                    "--container-stdin": "bool",
                    "--container-tty": "bool",
                    "--create-disk": "value",
                    "--custom-cpu": "value",
                    "--custom-extensions": "bool",
                    "--custom-memory": "value",
                    "--custom-vm-type": "value",
                    "--description": "value",
                    "--discard-local-ssds-at-termination-timestamp": "value",
                    "--disk": "value",
                    "--enable-nested-virtualization": "bool",
                    "--external-ipv6-address": "value",
                    "--external-ipv6-prefix-length": "value",
                    "--graceful-shutdown": "bool",
                    "--graceful-shutdown-max-duration": "value",
                    "--host-error-timeout-seconds": "value",
                    "--image": "value",
                    "--image-family": "value",
                    "--image-project": "value",
                    "--instance-termination-action": [
                      "DELETE",
                      "STOP"
                    ],
                    "--internal-ipv6-address": "value",
                    "--internal-ipv6-prefix-length": "value",
                    "--ipv6-network-tier": [
                      "PREMIUM"
                    ],
                    "--labels": "value",
                    "--local-ssd": "value",
                    "--local-ssd-recovery-timeout": "value",
                    "--machine-type": "dynamic",
                    "--maintenance-policy": [
                      "MIGRATE",
                      "TERMINATE"
                    ],
                    "--max-run-duration": "value",
                    "--metadata": "value",
                    "--metadata-from-file": "value",
                    "--min-cpu-platform": "value",
                    "--network": "value",
                    "--network-interface": "value",
                    "--network-performance-configs": "value",
                    "--network-tier": "value",
                    "--no-address": "bool",
                    "--no-public-ptr": "bool",
                    "--no-public-ptr-domain": "bool",
                    "--no-scopes": "bool",
                    "--no-service-account": "bool",
                    "--preemptible": "bool",
                    "--private-ipv6-google-access-type": [
                      "enable-bidirectional-access",
                      "enable-outbound-vm-access",
                      "inherit-subnetwork"
                    ],
                    "--private-network-ip": "value",
                    "--provisioning-model": [
                      "RESERVATION_BOUND",
                      "SPOT",
                      "STANDARD"
                    ],
                    "--public-ptr": "bool",
                    "--public-ptr-domain": "value",
                    "--reservation": "value",
                    "--reservation-affinity": [
                      "any",
                      "none",
                      "specific",
                      "specific-then-any-reservation",
                      "specific-then-no-reservation"
                    ],
                    "--resource-policies": "value",
                    "--restart-on-failure": "bool",
                    "--scopes": "value",
                    "--service-account": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-secure-boot": "bool",
                    "--shielded-vtpm": "bool",
                    "--source-instance-template": "dynamic",
                    "--stack-type": [
                      "IPV4_IPV6",
                      "IPV4_ONLY",
                      "IPV6_ONLY"
                    ],
                    "--subnet": "value",
                    "--tags": "value",
                    "--termination-time": "value",
                    "--threads-per-core": "value",
                    "--visible-core-count": "value",
                    "--zone": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--delete-disks": [
                      "all",
                      "boot",
                      "data"
                    ],
                    "--keep-disks": [
                      "all",
                      "boot",
                      "data"
                    ],
                    "--no-graceful-shutdown": "bool",
                    "--zone": "dynamic"
                  }
                },
                "delete-access-config": {
                  "commands": {},
                  "flags": {
                    "--access-config-name": "value",
                    "--network-interface": "value",
                    "--zone": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--view": [
                      "BASIC",
                      "FULL"
                    ],
                    "--zone": "dynamic"
                  }
                },
                "detach-disk": {
                  "commands": {},
                  "flags": {
                    "--device-name": "value",
                    "--disk": "value",
                    "--disk-scope": [
                      "regional",
                      "zonal"
                    ],
                    "--zone": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--zone": "value"
                  }
                },
                "get-guest-attributes": {
                  "commands": {},
                  "flags": {
                    "--query-path": "value",
                    "--zone": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--zone": "value"
                  }
                },
                "get-screenshot": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--zone": "dynamic"
                  }
                },
                "get-serial-port-output": {
                  "commands": {},
                  "flags": {
                    "--port": "value",
                    "--start": "value",
                    "--zone": "dynamic"
                  }
                },
                "get-shielded-identity": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--byol": "bool",
                    "--can-ip-forward": "bool",
                    "--cloudbuild-service-account": "value",
                    "--compute-service-account": "value",
                    "--custom-cpu": "value",
                    "--custom-extensions": "bool",
                    "--custom-memory": "value",
                    "--custom-vm-type": "value",
                    "--deletion-protection": "bool",
                    "--description": "value",
                    "--guest-environment": "bool",
                    "--guest-os-features": "value",
                    "--hostname": "value",
                    "--labels": "value",
                    "--log-location": "value",
                    "--machine-type": "dynamic",
                    "--network": "value",
                    "--network-tier": "value",
                    "--no-address": "bool",
                    "--no-scopes": "bool",
                    "--no-service-account": "bool",
                    "--node": "value",
                    "--node-affinity-file": "value",
                    "--node-group": "value",
                    "--os": [
                      "centos-7",
                      "centos-stream-8",
                      "centos-stream-9",
                      "debian-10",
                      "debian-11",
                      "debian-8",
                      "debian-9",
                      "opensuse-15",
                      "rhel-6",
                      "rhel-6-byol",
                      "rhel-7",
                      "rhel-7-byol",
                      "rhel-8",
                      "rhel-8-byol",
                      "rhel-9",
                      "rhel-9-byol",
                      "rocky-8",
                      "rocky-9",
                      "sles-12",
                      "sles-12-byol",
                      "sles-15",
                      "sles-15-byol",
                      "sles-sap-12",
                      "sles-sap-12-byol",
                      "sles-sap-15",
                      "sles-sap-15-byol",
                      "ubuntu-1404",
                      "ubuntu-1604",
                      "ubuntu-1804",
                      "ubuntu-2004",
                      "ubuntu-2204",
                      "windows-10-x64-byol",
                      "windows-10-x86-byol",
                      "windows-11-x64-byol",
                      "windows-2008r2",
                      "windows-2008r2-byol",
                      "windows-2012",
                      "windows-2012-byol",
                      "windows-2012r2",
                      "windows-2012r2-byol",
                      "windows-2016",
                      "windows-2016-byol",
                      "windows-2019",
                      "windows-2019-byol",
                      "windows-2022",
                      "windows-2022-byol",
                      "windows-7-x64-byol",
                      "windows-7-x86-byol",
                      "windows-8-x64-byol",
                      "windows-8-x86-byol"
                    ],
                    "--private-network-ip": "value",
                    "--restart-on-failure": "bool",
                    "--scopes": "value",
                    "--service-account": "value",
                    "--source-uri": "value",
                    "--subnet": "value",
                    "--tags": "value",
                    "--timeout": "value",
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--view": [
                      "BASIC",
                      "FULL"
                    ],
                    "--zones": "dynamic"
                  }
                },
                "move": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--destination-zone": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "network-interfaces": {
                  "commands": {
                    "get-effective-firewalls": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--network-interface": "value",
                        "--page-size": "value",
                        "--regexp": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--aliases": "value",
                        "--external-ipv6-address": "value",
                        "--external-ipv6-prefix-length": "value",
                        "--internal-ipv6-address": "value",
                        "--internal-ipv6-prefix-length": "value",
                        "--ipv6-network-tier": [
                          "PREMIUM"
                        ],
                        "--network": "value",
                        "--network-interface": "value",
                        "--private-network-ip": "value",
                        "--security-policy": "dynamic",
                        "--security-policy-region": "dynamic",
                        "--stack-type": [
                          "IPV4_IPV6",
                          "IPV4_ONLY"
                        ],
                        "--subnetwork": "value",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "ops-agents": {
                  "commands": {
                    "policies": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--agent-rules": "value",
                            "--description": "value",
                            "--group-labels": "value",
                            "--instances": "value",
                            "--os-types": "value",
                            "--zones": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {}
                        },
                        "describe": {
                          "commands": {},
                          "flags": {}
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--agent-rules": "value",
                            "--clear-group-labels": "bool",
                            "--clear-instances": "bool",
                            "--clear-zones": "bool",
                            "--description": "value",
                            "--etag": "value",
                            "--group-labels": "value",
                            "--instances": "value",
                            "--os-types": "value",
                            "--zones": "value"
                          }
                        }
                      },
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "os-inventory": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--zone": "dynamic"
                      }
                    },
                    "list-instances": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--inventory-filter": "value",
                        "--kernel-version": "value",
                        "--limit": "value",
                        "--os-shortname": "value",
                        "--os-version": "value",
                        "--package-name": "value",
                        "--package-version": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "patch-partner-metadata": {
                  "commands": {},
                  "flags": {
                    "--partner-metadata": "value",
                    "--partner-metadata-from-file": "value",
                    "--zone": "dynamic"
                  }
                },
                "perform-maintenance": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic",
                    "--zone": "value"
                  }
                },
                "remove-labels": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--labels": "value",
                    "--zone": "dynamic"
                  }
                },
                "remove-metadata": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--keys": "value",
                    "--zone": "dynamic"
                  }
                },
                "remove-partner-metadata": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--keys": "value",
                    "--zone": "dynamic"
                  }
                },
                "remove-resource-policies": {
                  "commands": {},
                  "flags": {
                    "--resource-policies": "value",
                    "--zone": "dynamic"
                  }
                },
                "remove-tags": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--tags": "value",
                    "--zone": "dynamic"
                  }
                },
                "reset": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "resume": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--zone": "dynamic"
                  }
                },
                "send-diagnostic-interrupt": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "set-disk-auto-delete": {
                  "commands": {},
                  "flags": {
                    "--auto-delete": "bool",
                    "--device-name": "value",
                    "--disk": "value",
                    "--zone": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "set-machine-type": {
                  "commands": {},
                  "flags": {
                    "--custom-cpu": "value",
                    "--custom-extensions": "bool",
                    "--custom-memory": "value",
                    "--custom-vm-type": "value",
                    "--machine-type": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "set-name": {
                  "commands": {},
                  "flags": {
                    "--new-name": "value",
                    "--zone": "dynamic"
                  }
                },
                "set-scheduling": {
                  "commands": {},
                  "flags": {
                    "--clear-discard-local-ssds-at-termination-timestamp": "bool",
                    "--clear-instance-termination-action": "bool",
                    "--clear-max-run-duration": "bool",
                    "--clear-min-node-cpu": "bool",
                    "--clear-node-affinities": "bool",
                    "--clear-termination-time": "bool",
                    "--discard-local-ssds-at-termination-timestamp": "value",
                    "--graceful-shutdown": "bool",
                    "--graceful-shutdown-max-duration": "value",
                    "--host-error-timeout-seconds": "value",
                    "--instance-termination-action": [
                      "DELETE",
                      "STOP"
                    ],
                    "--local-ssd-recovery-timeout": "value",
                    "--maintenance-policy": [
                      "MIGRATE",
                      "TERMINATE"
                    ],
                    "--max-run-duration": "value",
                    "--min-node-cpu": "value",
                    "--node": "value",
                    "--node-affinity-file": "value",
                    "--node-group": "value",
                    "--preemptible": "bool",
                    "--provisioning-model": [
                      "RESERVATION_BOUND",
                      "SPOT",
                      "STANDARD"
                    ],
                    "--restart-on-failure": "bool",
                    "--termination-time": "value",
                    "--zone": "dynamic"
                  }
                },
                "set-scopes": {
                  "commands": {},
                  "flags": {
                    "--no-scopes": "bool",
                    "--no-service-account": "bool",
                    "--scopes": "value",
                    "--service-account": "value",
                    "--zone": "dynamic"
                  }
                },
                "simulate-maintenance-event": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--with-extended-notifications": "value",
                    "--zone": "dynamic"
                  }
                },
                "start": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--csek-key-file": "value",
                    "--zone": "dynamic"
                  }
                },
                "stop": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--discard-local-ssd": "value",
                    "--no-graceful-shutdown": "bool",
                    "--zone": "dynamic"
                  }
                },
                "suspend": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--discard-local-ssd": "value",
                    "--zone": "dynamic"
                  }
                },
                "tail-serial-port-output": {
                  "commands": {},
                  "flags": {
                    "--port": "value",
                    "--zone": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--clear-node-affinities": "bool",
                    "--deletion-protection": "bool",
                    "--enable-display-device": "bool",
                    "--graceful-shutdown": "bool",
                    "--graceful-shutdown-max-duration": "value",
                    "--min-cpu-platform": "value",
                    "--node": "value",
                    "--node-affinity-file": "value",
                    "--node-group": "value",
                    "--partner-metadata": "value",
                    "--partner-metadata-from-file": "value",
                    "--remove-labels": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-learn-integrity-policy": "bool",
                    "--shielded-secure-boot": "bool",
                    "--shielded-vtpm": "bool",
                    "--update-labels": "value",
                    "--zone": "dynamic"
                  }
                },
                "update-access-config": {
                  "commands": {},
                  "flags": {
                    "--ipv6-public-ptr-domain": "value",
                    "--network-interface": "value",
                    "--no-ipv6-public-ptr": "bool",
                    "--no-public-ptr": "bool",
                    "--no-public-ptr-domain": "bool",
                    "--public-ptr": "bool",
                    "--public-ptr-domain": "value",
                    "--zone": "dynamic"
                  }
                },
                "update-container": {
                  "commands": {},
                  "flags": {
                    "--clear-container-args": "bool",
                    "--clear-container-command": "bool",
                    "--container-arg": "value",
                    "--container-command": "value",
                    "--container-env": "value",
                    "--container-env-file": "value",
                    "--container-image": "value",
                    "--container-mount-disk": "value",
                    "--container-mount-host-path": "value",
                    "--container-mount-tmpfs": "value",
                    "--container-privileged": "bool",
                    "--container-restart-policy": [
                      "always",
                      "never",
                      "on-failure"
                    ],
                    "--container-stdin": "bool",
                    "--container-tty": "bool",
                    "--remove-container-env": "value",
                    "--remove-container-mounts": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-learn-integrity-policy": "bool",
                    "--shielded-secure-boot": "bool",
                    "--shielded-vtpm": "bool",
                    "--zone": "dynamic"
                  }
                },
                "update-from-file": {
                  "commands": {},
                  "flags": {
                    "--minimal-action": "value",
                    "--most-disruptive-allowed-action": "value",
                    "--source": "value",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "instant-snapshots": {
              "commands": {
                "add-labels": {
                  "commands": {},
                  "flags": {
                    "--labels": "value",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--labels": "value",
                    "--region": "dynamic",
                    "--source-disk": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zones": "value"
                  }
                }
              },
              "flags": {}
            },
            "interconnects": {
              "commands": {
                "attachments": {
                  "commands": {
                    "dedicated": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--bandwidth": [
                              "100g",
                              "100m",
                              "10g",
                              "1g",
                              "200m",
                              "20g",
                              "2g",
                              "300m",
                              "400m",
                              "500m",
                              "50g",
                              "50m",
                              "5g"
                            ],
                            "--candidate-ipv6-subnets": "value",
                            "--candidate-subnets": "value",
                            "--cloud-router-ipv6-interface-id": "value",
                            "--customer-router-ipv6-interface-id": "value",
                            "--description": "value",
                            "--enable-admin": "bool",
                            "--encryption": [
                              "IPSEC",
                              "NONE"
                            ],
                            "--interconnect": "dynamic",
                            "--ipsec-internal-addresses": "value",
                            "--mtu": "value",
                            "--region": "dynamic",
                            "--router": "dynamic",
                            "--stack-type": [
                              "IPV4_IPV6",
                              "IPV4_ONLY"
                            ],
                            "--subnet-length": [
                              29,
                              30
                            ],
                            "--vlan": "value"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--bandwidth": [
                              "100g",
                              "100m",
                              "10g",
                              "1g",
                              "200m",
                              "20g",
                              "2g",
                              "300m",
                              "400m",
                              "500m",
                              "50g",
                              "50m",
                              "5g"
                            ],
                            "--candidate-ipv6-subnets": "value",
                            "--clear-labels": "bool",
                            "--cloud-router-ipv6-interface-id": "value",
                            "--customer-router-ipv6-interface-id": "value",
                            "--description": "value",
                            "--enable-admin": "bool",
                            "--mtu": "value",
                            "--region": "dynamic",
                            "--remove-labels": "value",
                            "--stack-type": [
                              "IPV4_IPV6",
                              "IPV4_ONLY"
                            ],
                            "--update-labels": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "partner": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--description": "value",
                            "--edge-availability-domain": [
                              "any",
                              "availability-domain-1",
                              "availability-domain-2"
                            ],
                            "--enable-admin": "bool",
                            "--encryption": [
                              "IPSEC",
                              "NONE"
                            ],
                            "--ipsec-internal-addresses": "value",
                            "--mtu": "value",
                            "--region": "dynamic",
                            "--router": "dynamic",
                            "--stack-type": [
                              "IPV4_IPV6",
                              "IPV4_ONLY"
                            ]
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--clear-labels": "bool",
                            "--description": "value",
                            "--enable-admin": "bool",
                            "--mtu": "value",
                            "--region": "dynamic",
                            "--remove-labels": "value",
                            "--stack-type": [
                              "IPV4_IPV6",
                              "IPV4_ONLY"
                            ],
                            "--update-labels": "value"
                          }
                        }
                      },
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--admin-enabled": "bool",
                    "--customer-name": "value",
                    "--description": "value",
                    "--interconnect-type": [
                      "DEDICATED",
                      "IT_PRIVATE",
                      "PARTNER"
                    ],
                    "--link-type": [
                      "LINK_TYPE_ETHERNET_100G_LR",
                      "LINK_TYPE_ETHERNET_10G_LR"
                    ],
                    "--location": "dynamic",
                    "--noc-contact-email": "value",
                    "--remote-location": "dynamic",
                    "--requested-features": "value",
                    "--requested-link-count": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-diagnostics": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "locations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "macsec": {
                  "commands": {
                    "add-key": {
                      "commands": {},
                      "flags": {
                        "--key-name": "value",
                        "--start-time": "value"
                      }
                    },
                    "get-config": {
                      "commands": {},
                      "flags": {}
                    },
                    "remove-key": {
                      "commands": {},
                      "flags": {
                        "--key-name": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--enabled": "bool",
                        "--fail-open": "bool"
                      }
                    },
                    "update-key": {
                      "commands": {},
                      "flags": {
                        "--key-name": "value",
                        "--start-time": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "remote-locations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--admin-enabled": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--noc-contact-email": "value",
                    "--remove-labels": "value",
                    "--requested-link-count": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "machine-images": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--csek-key-file": "value",
                    "--description": "value",
                    "--guest-flush": "bool",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--require-csek-key-create": "bool",
                    "--source-disk-csek-key": "value",
                    "--source-instance": "dynamic",
                    "--source-instance-zone": "dynamic",
                    "--storage-location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--byol": "bool",
                    "--can-ip-forward": "bool",
                    "--cloudbuild-service-account": "value",
                    "--compute-service-account": "value",
                    "--custom-cpu": "value",
                    "--custom-extensions": "bool",
                    "--custom-memory": "value",
                    "--custom-vm-type": "value",
                    "--description": "value",
                    "--guest-environment": "bool",
                    "--guest-flush": "bool",
                    "--guest-os-features": "value",
                    "--labels": "value",
                    "--log-location": "value",
                    "--machine-type": "dynamic",
                    "--network": "value",
                    "--network-tier": "value",
                    "--no-address": "bool",
                    "--no-scopes": "bool",
                    "--no-service-account": "bool",
                    "--os": [
                      "centos-7",
                      "centos-stream-8",
                      "centos-stream-9",
                      "debian-10",
                      "debian-11",
                      "debian-8",
                      "debian-9",
                      "opensuse-15",
                      "rhel-6",
                      "rhel-6-byol",
                      "rhel-7",
                      "rhel-7-byol",
                      "rhel-8",
                      "rhel-8-byol",
                      "rhel-9",
                      "rhel-9-byol",
                      "rocky-8",
                      "rocky-9",
                      "sles-12",
                      "sles-12-byol",
                      "sles-15",
                      "sles-15-byol",
                      "sles-sap-12",
                      "sles-sap-12-byol",
                      "sles-sap-15",
                      "sles-sap-15-byol",
                      "ubuntu-1404",
                      "ubuntu-1604",
                      "ubuntu-1804",
                      "ubuntu-2004",
                      "ubuntu-2204",
                      "windows-10-x64-byol",
                      "windows-10-x86-byol",
                      "windows-11-x64-byol",
                      "windows-2008r2",
                      "windows-2008r2-byol",
                      "windows-2012",
                      "windows-2012-byol",
                      "windows-2012r2",
                      "windows-2012r2-byol",
                      "windows-2016",
                      "windows-2016-byol",
                      "windows-2019",
                      "windows-2019-byol",
                      "windows-2022",
                      "windows-2022-byol",
                      "windows-7-x64-byol",
                      "windows-7-x86-byol",
                      "windows-8-x64-byol",
                      "windows-8-x86-byol"
                    ],
                    "--restart-on-failure": "bool",
                    "--scopes": "value",
                    "--service-account": "value",
                    "--source-uri": "value",
                    "--storage-location": "value",
                    "--subnet": "value",
                    "--tags": "value",
                    "--timeout": "value",
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "machine-types": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zones": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "network-attachments": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--connection-preference": [
                      "ACCEPT_AUTOMATIC",
                      "ACCEPT_MANUAL"
                    ],
                    "--description": "value",
                    "--producer-accept-list": "value",
                    "--producer-reject-list": "value",
                    "--region": "dynamic",
                    "--subnets": "dynamic",
                    "--subnets-region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--producer-accept-list": "value",
                    "--producer-reject-list": "value",
                    "--region": "dynamic",
                    "--subnets": "dynamic",
                    "--subnets-region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "network-edge-security-services": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--region": "dynamic",
                    "--security-policy": "dynamic",
                    "--security-policy-region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--region": "dynamic",
                    "--security-policy": "dynamic",
                    "--security-policy-region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "network-endpoint-groups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--app-engine-app": "bool",
                    "--app-engine-service": "value",
                    "--app-engine-url-mask": "value",
                    "--app-engine-version": "value",
                    "--cloud-function-name": "value",
                    "--cloud-function-url-mask": "value",
                    "--cloud-run-service": "value",
                    "--cloud-run-tag": "value",
                    "--cloud-run-url-mask": "value",
                    "--default-port": "value",
                    "--global": "bool",
                    "--network": "value",
                    "--network-endpoint-type": [
                      "gce-vm-ip",
                      "gce-vm-ip-port",
                      "gce-vm-ip-portmap",
                      "internet-fqdn-port",
                      "internet-ip-port",
                      "non-gcp-private-ip-port",
                      "private-service-connect",
                      "serverless"
                    ],
                    "--producer-port": "value",
                    "--psc-target-service": "value",
                    "--region": "dynamic",
                    "--serverless-deployment-platform": "value",
                    "--serverless-deployment-resource": "value",
                    "--serverless-deployment-url-mask": "value",
                    "--serverless-deployment-version": "value",
                    "--subnet": "value",
                    "--zone": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zones": "value"
                  }
                },
                "list-network-endpoints": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--zone": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-endpoint": "value",
                    "--global": "bool",
                    "--region": "dynamic",
                    "--remove-endpoint": "value",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "network-firewall-policies": {
              "commands": {
                "associations": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--firewall-policy": "value",
                        "--firewall-policy-region": "dynamic",
                        "--global-firewall-policy": "bool",
                        "--name": "value",
                        "--network": "value",
                        "--replace-association-on-target": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--firewall-policy": "value",
                        "--firewall-policy-region": "dynamic",
                        "--global-firewall-policy": "bool",
                        "--name": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "clone-rules": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--source-firewall-policy": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "export-rules": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "get-effective-firewalls": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--network": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "import-rules": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "mirroring-rules": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "do_not_mirror",
                          "goto_next",
                          "mirror"
                        ],
                        "--description": "value",
                        "--dest-ip-ranges": "value",
                        "--direction": [
                          "EGRESS",
                          "INGRESS"
                        ],
                        "--disabled": "bool",
                        "--firewall-policy": "value",
                        "--global-firewall-policy": "bool",
                        "--layer4-configs": "value",
                        "--security-profile-group": "value",
                        "--src-ip-ranges": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--firewall-policy": "value",
                        "--global-firewall-policy": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--firewall-policy": "value",
                        "--global-firewall-policy": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "do_not_mirror",
                          "goto_next",
                          "mirror"
                        ],
                        "--description": "value",
                        "--dest-ip-ranges": "value",
                        "--direction": [
                          "EGRESS",
                          "INGRESS"
                        ],
                        "--disabled": "bool",
                        "--firewall-policy": "value",
                        "--global-firewall-policy": "bool",
                        "--layer4-configs": "value",
                        "--new-priority": "value",
                        "--security-profile-group": "value",
                        "--src-ip-ranges": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "rules": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "allow",
                          "apply_security_profile_group",
                          "deny",
                          "goto_next"
                        ],
                        "--description": "value",
                        "--dest-address-groups": "value",
                        "--dest-fqdns": "value",
                        "--dest-ip-ranges": "value",
                        "--dest-network-scope": "value",
                        "--dest-region-codes": "value",
                        "--dest-threat-intelligence": "value",
                        "--direction": [
                          "EGRESS",
                          "INGRESS"
                        ],
                        "--disabled": "bool",
                        "--enable-logging": "bool",
                        "--firewall-policy": "value",
                        "--firewall-policy-region": "dynamic",
                        "--global-firewall-policy": "bool",
                        "--layer4-configs": "value",
                        "--security-profile-group": "value",
                        "--src-address-groups": "value",
                        "--src-fqdns": "value",
                        "--src-ip-ranges": "value",
                        "--src-network-scope": "value",
                        "--src-networks": "value",
                        "--src-region-codes": "value",
                        "--src-secure-tags": "value",
                        "--src-threat-intelligence": "value",
                        "--target-secure-tags": "value",
                        "--target-service-accounts": "value",
                        "--tls-inspect": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--firewall-policy": "value",
                        "--firewall-policy-region": "dynamic",
                        "--global-firewall-policy": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--firewall-policy": "value",
                        "--firewall-policy-region": "dynamic",
                        "--global-firewall-policy": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "allow",
                          "apply_security_profile_group",
                          "deny",
                          "goto_next"
                        ],
                        "--description": "value",
                        "--dest-address-groups": "value",
                        "--dest-fqdns": "value",
                        "--dest-ip-ranges": "value",
                        "--dest-network-scope": "value",
                        "--dest-region-codes": "value",
                        "--dest-threat-intelligence": "value",
                        "--direction": [
                          "EGRESS",
                          "INGRESS"
                        ],
                        "--disabled": "bool",
                        "--enable-logging": "bool",
                        "--firewall-policy": "value",
                        "--firewall-policy-region": "dynamic",
                        "--global-firewall-policy": "bool",
                        "--layer4-configs": "value",
                        "--new-priority": "value",
                        "--security-profile-group": "value",
                        "--src-address-groups": "value",
                        "--src-fqdns": "value",
                        "--src-ip-ranges": "value",
                        "--src-network-scope": "value",
                        "--src-networks": "value",
                        "--src-region-codes": "value",
                        "--src-secure-tags": "value",
                        "--src-threat-intelligence": "value",
                        "--target-secure-tags": "value",
                        "--target-service-accounts": "value",
                        "--tls-inspect": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "network-profiles": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "networks": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--bgp-best-path-selection-mode": [
                      "LEGACY",
                      "STANDARD"
                    ],
                    "--bgp-bps-always-compare-med": "bool",
                    "--bgp-bps-inter-region-cost": [
                      "ADD_COST_TO_MED",
                      "DEFAULT"
                    ],
                    "--bgp-routing-mode": [
                      "global",
                      "regional"
                    ],
                    "--description": "value",
                    "--enable-ula-internal-ipv6": "bool",
                    "--internal-ipv6-range": "value",
                    "--mtu": "value",
                    "--network-firewall-policy-enforcement-order": [
                      "AFTER_CLASSIC_FIREWALL",
                      "BEFORE_CLASSIC_FIREWALL"
                    ],
                    "--network-profile": "dynamic",
                    "--range": "value",
                    "--subnet-mode": [
                      "auto",
                      "custom",
                      "legacy"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-effective-firewalls": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "peerings": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--auto-create-routes": "bool",
                        "--export-custom-routes": "bool",
                        "--export-subnet-routes-with-public-ip": "bool",
                        "--import-custom-routes": "bool",
                        "--import-subnet-routes-with-public-ip": "bool",
                        "--network": "value",
                        "--peer-network": "value",
                        "--peer-project": "value",
                        "--stack-type": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--network": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--network": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "list-routes": {
                      "commands": {},
                      "flags": {
                        "--direction": [
                          "INCOMING",
                          "OUTGOING"
                        ],
                        "--filter": "value",
                        "--limit": "value",
                        "--network": "value",
                        "--page-size": "value",
                        "--region": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--export-custom-routes": "bool",
                        "--export-subnet-routes-with-public-ip": "bool",
                        "--import-custom-routes": "bool",
                        "--import-subnet-routes-with-public-ip": "bool",
                        "--network": "value",
                        "--stack-type": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "subnets": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--member": "value",
                        "--region": "value",
                        "--role": "dynamic"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--description": "value",
                        "--enable-flow-logs": "bool",
                        "--enable-private-ip-google-access": "bool",
                        "--ipv6-access-type": [
                          "EXTERNAL",
                          "INTERNAL"
                        ],
                        "--logging-aggregation-interval": [
                          "interval-1-min",
                          "interval-10-min",
                          "interval-15-min",
                          "interval-30-sec",
                          "interval-5-min",
                          "interval-5-sec"
                        ],
                        "--logging-filter-expr": "value",
                        "--logging-flow-sampling": "value",
                        "--logging-metadata": [
                          "custom",
                          "exclude-all",
                          "include-all"
                        ],
                        "--logging-metadata-fields": "value",
                        "--network": "dynamic",
                        "--private-ipv6-google-access-type": [
                          "disable",
                          "enable-bidirectional-access",
                          "enable-outbound-vm-access"
                        ],
                        "--purpose": [
                          "GLOBAL_MANAGED_PROXY",
                          "INTERNAL_HTTPS_LOAD_BALANCER",
                          "PEER_MIGRATION",
                          "PRIVATE",
                          "PRIVATE_NAT",
                          "PRIVATE_SERVICE_CONNECT",
                          "REGIONAL_MANAGED_PROXY"
                        ],
                        "--range": "value",
                        "--region": "dynamic",
                        "--reserved-internal-range": "value",
                        "--role": [
                          "ACTIVE",
                          "BACKUP"
                        ],
                        "--secondary-range": "value",
                        "--secondary-range-with-reserved-internal-range": "value",
                        "--stack-type": [
                          "IPV4_IPV6",
                          "IPV4_ONLY",
                          "IPV6_ONLY"
                        ]
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic"
                      }
                    },
                    "expand-ip-range": {
                      "commands": {},
                      "flags": {
                        "--prefix-length": "value",
                        "--region": "dynamic"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--network": "value",
                        "--page-size": "value",
                        "--regexp": "value",
                        "--regions": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "list-usable": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--service-project": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--member": "value",
                        "--region": "value",
                        "--role": "dynamic"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--region": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--add-secondary-ranges": "value",
                        "--add-secondary-ranges-with-reserved-internal-range": "value",
                        "--allow-cidr-routes-overlap": "bool",
                        "--drain-timeout": "value",
                        "--enable-flow-logs": "bool",
                        "--enable-private-ip-google-access": "bool",
                        "--ipv6-access-type": [
                          "EXTERNAL",
                          "INTERNAL"
                        ],
                        "--logging-aggregation-interval": [
                          "interval-1-min",
                          "interval-10-min",
                          "interval-15-min",
                          "interval-30-sec",
                          "interval-5-min",
                          "interval-5-sec"
                        ],
                        "--logging-filter-expr": "value",
                        "--logging-flow-sampling": "value",
                        "--logging-metadata": [
                          "custom",
                          "exclude-all",
                          "include-all"
                        ],
                        "--logging-metadata-fields": "value",
                        "--private-ipv6-google-access-type": [
                          "disable",
                          "enable-bidirectional-access",
                          "enable-outbound-vm-access"
                        ],
                        "--purpose": [
                          "PRIVATE",
                          "REGIONAL_MANAGED_PROXY"
                        ],
                        "--region": "dynamic",
                        "--remove-secondary-ranges": "value",
                        "--role": [
                          "ACTIVE"
                        ],
                        "--stack-type": [
                          "IPV4_IPV6",
                          "IPV4_ONLY"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--bgp-best-path-selection-mode": [
                      "LEGACY",
                      "STANDARD"
                    ],
                    "--bgp-bps-always-compare-med": "bool",
                    "--bgp-bps-inter-region-cost": [
                      "ADD_COST_TO_MED",
                      "DEFAULT"
                    ],
                    "--bgp-routing-mode": [
                      "global",
                      "regional"
                    ],
                    "--enable-ula-internal-ipv6": "bool",
                    "--internal-ipv6-range": "value",
                    "--mtu": "value",
                    "--network-firewall-policy-enforcement-order": [
                      "AFTER_CLASSIC_FIREWALL",
                      "BEFORE_CLASSIC_FIREWALL"
                    ],
                    "--switch-to-custom-subnet-mode": "bool"
                  }
                },
                "vpc-access": {
                  "commands": {
                    "connectors": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--async": "bool",
                            "--machine-type": "value",
                            "--max-instances": "value",
                            "--max-throughput": "value",
                            "--min-instances": "value",
                            "--min-throughput": "value",
                            "--network": "value",
                            "--range": "value",
                            "--region": "dynamic",
                            "--subnet": "value",
                            "--subnet-project": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--async": "bool",
                            "--region": "dynamic"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--region": "dynamic"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--region": "dynamic",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--async": "bool",
                            "--machine-type": "value",
                            "--max-instances": "value",
                            "--min-instances": "value",
                            "--region": "dynamic"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "locations": {
                      "commands": {
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "operations": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--region": "dynamic"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--region": "dynamic",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        }
                      },
                      "flags": {}
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zones": "value"
                  }
                }
              },
              "flags": {}
            },
            "org-security-policies": {
              "commands": {
                "associations": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--excluded-folders": "value",
                        "--excluded-projects": "value",
                        "--folder": "value",
                        "--name": "value",
                        "--organization": "value",
                        "--project-number": "value",
                        "--replace-association-on-target": "bool",
                        "--security-policy": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--organization": "value",
                        "--security-policy": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--folder": "value",
                        "--limit": "value",
                        "--organization": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "copy-rules": {
                  "commands": {},
                  "flags": {
                    "--organization": "value",
                    "--source-security-policy": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--file-format": [
                      "json",
                      "yaml"
                    ],
                    "--file-name": "value",
                    "--folder": "value",
                    "--organization": "value",
                    "--short-name": "value",
                    "--type": [
                      "CLOUD_ARMOR",
                      "FIREWALL"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-rules": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "move": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "rules": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "allow",
                          "deny",
                          "deny-403",
                          "deny-404",
                          "deny-502",
                          "redirect"
                        ],
                        "--cloud-armor": "bool",
                        "--description": "value",
                        "--dest-ip-ranges": "value",
                        "--direction": [
                          "EGRESS",
                          "INGRESS"
                        ],
                        "--enable-logging": "bool",
                        "--expression": "value",
                        "--layer4-configs": "value",
                        "--organization": "value",
                        "--preview": "bool",
                        "--security-policy": "value",
                        "--src-ip-ranges": "value",
                        "--target-resources": "value",
                        "--target-service-accounts": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--organization": "value",
                        "--security-policy": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--organization": "value",
                        "--security-policy": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "allow",
                          "deny",
                          "deny-403",
                          "deny-404",
                          "deny-502",
                          "redirect"
                        ],
                        "--cloud-armor": "bool",
                        "--description": "value",
                        "--dest-ip-ranges": "value",
                        "--direction": [
                          "EGRESS",
                          "INGRESS"
                        ],
                        "--enable-logging": "bool",
                        "--expression": "value",
                        "--layer4-configs": "value",
                        "--new-priority": "value",
                        "--organization": "value",
                        "--preview": "bool",
                        "--security-policy": "value",
                        "--src-ip-ranges": "value",
                        "--target-resources": "value",
                        "--target-service-accounts": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--json-custom-content-types": "value",
                    "--json-parsing": [
                      "DISABLED",
                      "STANDARD",
                      "STANDARD_WITH_GRAPHQL"
                    ],
                    "--log-level": [
                      "NORMAL",
                      "VERBOSE"
                    ],
                    "--organization": "value",
                    "--user-ip-request-headers": "value"
                  }
                }
              },
              "flags": {}
            },
            "os-config": {
              "commands": {
                "guest-policies": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--file": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {}
                    },
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "lookup": {
                      "commands": {},
                      "flags": {
                        "--zone": "dynamic"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--file": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "os-upgrade": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--auto-rollback": "bool",
                    "--create-machine-backup": "bool",
                    "--log-location": "value",
                    "--source-os": [
                      "windows-2008r2"
                    ],
                    "--target-os": [
                      "windows-2012r2"
                    ],
                    "--timeout": "value",
                    "--zone": "dynamic"
                  }
                },
                "patch-deployments": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--file": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {}
                    },
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "pause": {
                      "commands": {},
                      "flags": {}
                    },
                    "resume": {
                      "commands": {},
                      "flags": {}
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--file": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "patch-jobs": {
                  "commands": {
                    "cancel": {
                      "commands": {},
                      "flags": {}
                    },
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "execute": {
                      "commands": {},
                      "flags": {
                        "--apt-dist": "bool",
                        "--apt-excludes": "value",
                        "--apt-exclusive-packages": "value",
                        "--async": "bool",
                        "--description": "value",
                        "--display-name": "value",
                        "--dry-run": "bool",
                        "--duration": "value",
                        "--instance-filter-all": "bool",
                        "--instance-filter-group-labels": "value",
                        "--instance-filter-name-prefixes": "value",
                        "--instance-filter-names": "value",
                        "--instance-filter-zones": "value",
                        "--mig-instances-allowed": "bool",
                        "--post-patch-linux-executable": "value",
                        "--post-patch-linux-success-codes": "value",
                        "--post-patch-windows-executable": "value",
                        "--post-patch-windows-success-codes": "value",
                        "--pre-patch-linux-executable": "value",
                        "--pre-patch-linux-success-codes": "value",
                        "--pre-patch-windows-executable": "value",
                        "--pre-patch-windows-success-codes": "value",
                        "--reboot-config": [
                          "always",
                          "default",
                          "never"
                        ],
                        "--rollout-disruption-budget": "value",
                        "--rollout-disruption-budget-percent": "value",
                        "--rollout-mode": [
                          "concurrent-zones",
                          "zone-by-zone"
                        ],
                        "--windows-classifications": "value",
                        "--windows-excludes": "value",
                        "--windows-exclusive-patches": "value",
                        "--yum-excludes": "value",
                        "--yum-exclusive-packages": "value",
                        "--yum-minimal": "bool",
                        "--yum-security": "bool",
                        "--zypper-categories": "value",
                        "--zypper-excludes": "value",
                        "--zypper-exclusive-patches": "value",
                        "--zypper-severities": "value",
                        "--zypper-with-optional": "bool",
                        "--zypper-with-update": "bool"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "list-instance-details": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "policy-orchestrators": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "delete",
                          "upsert"
                        ],
                        "--async": "bool",
                        "--folder": "value",
                        "--include-folders": "value",
                        "--include-locations": "value",
                        "--include-projects": "value",
                        "--organization": "value",
                        "--policy-file": "value",
                        "--policy-id": "value",
                        "--policy-type": [
                          "os_policy_assignment_v1"
                        ],
                        "--state": [
                          "active",
                          "stopped"
                        ]
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--folder": "value",
                        "--organization": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--folder": "value",
                        "--organization": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--folder": "value",
                        "--limit": "value",
                        "--organization": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "delete",
                          "upsert"
                        ],
                        "--async": "bool",
                        "--clear-folders": "bool",
                        "--clear-locations": "bool",
                        "--clear-projects": "bool",
                        "--folder": "value",
                        "--include-folders": "value",
                        "--include-locations": "value",
                        "--include-projects": "value",
                        "--organization": "value",
                        "--policy-file": "value",
                        "--policy-id": "value",
                        "--state": [
                          "active",
                          "stopped"
                        ]
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "os-login": {
              "commands": {
                "describe-profile": {
                  "commands": {},
                  "flags": {}
                },
                "remove-profile": {
                  "commands": {},
                  "flags": {}
                },
                "ssh-keys": {
                  "commands": {
                    "add": {
                      "commands": {},
                      "flags": {
                        "--key": "value",
                        "--key-file": "value",
                        "--ttl": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--key": "value",
                        "--key-file": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "remove": {
                      "commands": {},
                      "flags": {
                        "--key": "value",
                        "--key-file": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--key": "value",
                        "--key-file": "value",
                        "--ttl": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "packet-mirrorings": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--collector-ilb": "value",
                    "--description": "value",
                    "--enable": "bool",
                    "--filter-cidr-ranges": "value",
                    "--filter-direction": [
                      "both",
                      "egress",
                      "ingress"
                    ],
                    "--filter-protocols": "value",
                    "--mirrored-instances": "value",
                    "--mirrored-subnets": "value",
                    "--mirrored-tags": "value",
                    "--network": "value",
                    "--region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-filter-cidr-ranges": "value",
                    "--add-filter-protocols": "value",
                    "--add-mirrored-instances": "value",
                    "--add-mirrored-subnets": "value",
                    "--add-mirrored-tags": "value",
                    "--async": "bool",
                    "--clear-filter-cidr-ranges": "bool",
                    "--clear-filter-protocols": "bool",
                    "--clear-mirrored-instances": "bool",
                    "--clear-mirrored-subnets": "bool",
                    "--clear-mirrored-tags": "bool",
                    "--collector-ilb": "value",
                    "--description": "value",
                    "--enable": "bool",
                    "--filter-direction": [
                      "both",
                      "egress",
                      "ingress"
                    ],
                    "--region": "dynamic",
                    "--remove-filter-cidr-ranges": "value",
                    "--remove-filter-protocols": "value",
                    "--remove-mirrored-instances": "value",
                    "--remove-mirrored-subnets": "value",
                    "--remove-mirrored-tags": "value",
                    "--set-filter-cidr-ranges": "value",
                    "--set-filter-protocols": "value",
                    "--set-mirrored-instances": "value",
                    "--set-mirrored-subnets": "value",
                    "--set-mirrored-tags": "value"
                  }
                }
              },
              "flags": {}
            },
            "project-info": {
              "commands": {
                "add-metadata": {
                  "commands": {},
                  "flags": {
                    "--metadata": "value",
                    "--metadata-from-file": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "remove-metadata": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--keys": "value"
                  }
                },
                "set-usage-bucket": {
                  "commands": {},
                  "flags": {
                    "--bucket": "value",
                    "--no-bucket": "bool",
                    "--prefix": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--cloud-armor-tier": [
                      "CA_ENTERPRISE_ANNUAL",
                      "CA_ENTERPRISE_PAYGO",
                      "CA_STANDARD"
                    ],
                    "--default-network-tier": [
                      "PREMIUM",
                      "STANDARD"
                    ],
                    "--managed-protection-tier": [
                      "CAMP_PLUS_ANNUAL",
                      "CAMP_PLUS_PAYGO",
                      "CA_STANDARD"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "project-zonal-metadata": {
              "commands": {
                "add": {
                  "commands": {},
                  "flags": {
                    "--metadata": "value",
                    "--zone": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "remove": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--keys": "value",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "public-advertised-prefixes": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--dns-verification-ip": "value",
                    "--pdp-scope": [
                      "GLOBAL",
                      "REGIONAL"
                    ],
                    "--range": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--announce-prefix": "bool",
                    "--status": [
                      "ptr-configured"
                    ],
                    "--withdraw-prefix": "bool"
                  }
                }
              },
              "flags": {}
            },
            "public-delegated-prefixes": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--allocatable-prefix-length": "value",
                    "--description": "value",
                    "--enable-live-migration": "bool",
                    "--global": "bool",
                    "--mode": [
                      "delegation",
                      "external-ipv6-forwarding-rule-creation"
                    ],
                    "--public-advertised-prefix": "value",
                    "--public-delegated-prefix": "value",
                    "--range": "value",
                    "--region": "dynamic"
                  }
                },
                "delegated-sub-prefixes": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--allocatable-prefix-length": "value",
                        "--create-addresses": "bool",
                        "--delegatee-project": "value",
                        "--description": "value",
                        "--global-public-delegated-prefix": "bool",
                        "--mode": [
                          "delegation",
                          "external-ipv6-forwarding-rule-creation"
                        ],
                        "--public-delegated-prefix": "value",
                        "--public-delegated-prefix-region": "dynamic",
                        "--range": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--global-public-delegated-prefix": "bool",
                        "--public-delegated-prefix": "value",
                        "--public-delegated-prefix-region": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--announce-prefix": "bool",
                    "--region": "dynamic",
                    "--withdraw-prefix": "bool"
                  }
                }
              },
              "flags": {}
            },
            "regions": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "reservations": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic",
                    "--zone": "value"
                  }
                },
                "blocks": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--block-name": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--delete-after-duration": "value",
                    "--delete-at-time": "value",
                    "--description": "value",
                    "--local-ssd": "value",
                    "--machine-type": "value",
                    "--min-cpu-platform": "value",
                    "--require-specific-reservation": "bool",
                    "--reservation-sharing-policy": [
                      "ALLOW_ALL",
                      "DISALLOW_ALL"
                    ],
                    "--resource-policies": "value",
                    "--share-setting": [
                      "local",
                      "projects"
                    ],
                    "--share-with": "value",
                    "--source-instance-template": "value",
                    "--vm-count": "value",
                    "--zone": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic",
                    "--zone": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-share-with": "value",
                    "--delete-after-duration": "value",
                    "--delete-at-time": "value",
                    "--disable-auto-delete": "bool",
                    "--remove-share-with": "value",
                    "--reservation-sharing-policy": [
                      "ALLOW_ALL",
                      "DISALLOW_ALL"
                    ],
                    "--share-with": "value",
                    "--vm-count": "value",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "reset-windows-password": {
              "commands": {},
              "flags": {
                "--user": "value",
                "--zone": "dynamic"
              }
            },
            "resource-policies": {
              "commands": {
                "create": {
                  "commands": {
                    "disk-consistency-group": {
                      "commands": {},
                      "flags": {
                        "--description": "value",
                        "--region": "dynamic"
                      }
                    },
                    "group-placement": {
                      "commands": {},
                      "flags": {
                        "--availability-domain-count": "value",
                        "--collocation": [
                          "collocated",
                          "unspecified-collocation"
                        ],
                        "--description": "value",
                        "--max-distance": "value",
                        "--region": "dynamic",
                        "--vm-count": "value"
                      }
                    },
                    "instance-schedule": {
                      "commands": {},
                      "flags": {
                        "--description": "value",
                        "--end-date": "value",
                        "--initiation-date": "value",
                        "--region": "dynamic",
                        "--timezone": "value",
                        "--vm-start-schedule": "value",
                        "--vm-stop-schedule": "value"
                      }
                    },
                    "snapshot-schedule": {
                      "commands": {},
                      "flags": {
                        "--daily-schedule": "bool",
                        "--description": "value",
                        "--guest-flush": "bool",
                        "--hourly-schedule": "value",
                        "--max-retention-days": "value",
                        "--on-source-disk-delete": [
                          "apply-retention-policy",
                          "keep-auto-snapshots"
                        ],
                        "--region": "dynamic",
                        "--snapshot-labels": "value",
                        "--start-time": "value",
                        "--storage-location": "value",
                        "--weekly-schedule": [
                          "friday",
                          "monday",
                          "saturday",
                          "sunday",
                          "thursday",
                          "tuesday",
                          "wednesday"
                        ],
                        "--weekly-schedule-from-file": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "create-snapshot-schedule": {
                  "commands": {},
                  "flags": {
                    "--daily-schedule": "bool",
                    "--description": "value",
                    "--guest-flush": "bool",
                    "--hourly-schedule": "value",
                    "--max-retention-days": "value",
                    "--on-source-disk-delete": [
                      "apply-retention-policy",
                      "keep-auto-snapshots"
                    ],
                    "--region": "dynamic",
                    "--snapshot-labels": "value",
                    "--start-time": "value",
                    "--storage-location": "value",
                    "--weekly-schedule": [
                      "friday",
                      "monday",
                      "saturday",
                      "sunday",
                      "thursday",
                      "tuesday",
                      "wednesday"
                    ],
                    "--weekly-schedule-from-file": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "update": {
                  "commands": {
                    "instance-schedule": {
                      "commands": {},
                      "flags": {
                        "--description": "value",
                        "--end-date": "value",
                        "--initiation-date": "value",
                        "--region": "dynamic",
                        "--timezone": "value",
                        "--vm-start-schedule": "value",
                        "--vm-stop-schedule": "value"
                      }
                    },
                    "snapshot-schedule": {
                      "commands": {},
                      "flags": {
                        "--daily-schedule": "bool",
                        "--description": "value",
                        "--hourly-schedule": "value",
                        "--max-retention-days": "value",
                        "--on-source-disk-delete": [
                          "apply-retention-policy",
                          "keep-auto-snapshots"
                        ],
                        "--region": "dynamic",
                        "--snapshot-labels": "value",
                        "--start-time": "value",
                        "--weekly-schedule": [
                          "friday",
                          "monday",
                          "saturday",
                          "sunday",
                          "thursday",
                          "tuesday",
                          "wednesday"
                        ],
                        "--weekly-schedule-from-file": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "routers": {
              "commands": {
                "add-bgp-peer": {
                  "commands": {},
                  "flags": {
                    "--advertised-route-priority": "value",
                    "--advertisement-mode": [
                      "CUSTOM",
                      "DEFAULT"
                    ],
                    "--async": "bool",
                    "--bfd-min-receive-interval": "value",
                    "--bfd-min-transmit-interval": "value",
                    "--bfd-multiplier": "value",
                    "--bfd-session-initialization-mode": [
                      "ACTIVE",
                      "DISABLED",
                      "PASSIVE"
                    ],
                    "--custom-learned-route-priority": "value",
                    "--enable-ipv4": "bool",
                    "--enable-ipv6": "bool",
                    "--enabled": "bool",
                    "--export-policies": "value",
                    "--import-policies": "value",
                    "--instance": "dynamic",
                    "--instance-zone": "dynamic",
                    "--interface": "value",
                    "--ipv4-nexthop-address": "value",
                    "--ipv6-nexthop-address": "value",
                    "--md5-authentication-key": "value",
                    "--peer-asn": "value",
                    "--peer-ip-address": "value",
                    "--peer-ipv4-nexthop-address": "value",
                    "--peer-ipv6-nexthop-address": "value",
                    "--peer-name": "value",
                    "--region": "dynamic",
                    "--set-advertisement-groups": "value",
                    "--set-advertisement-ranges": "value",
                    "--set-custom-learned-route-ranges": "value"
                  }
                },
                "add-interface": {
                  "commands": {},
                  "flags": {
                    "--interconnect-attachment": "dynamic",
                    "--interconnect-attachment-region": "dynamic",
                    "--interface-name": "value",
                    "--ip-address": "value",
                    "--ip-version": [
                      "IPV4",
                      "IPV6"
                    ],
                    "--mask-length": "value",
                    "--redundant-interface": "value",
                    "--region": "dynamic",
                    "--subnetwork": "dynamic",
                    "--subnetwork-region": "dynamic",
                    "--vpn-tunnel": "dynamic",
                    "--vpn-tunnel-region": "dynamic"
                  }
                },
                "add-route-policy": {
                  "commands": {},
                  "flags": {
                    "--policy-name": "value",
                    "--policy-type": [
                      "EXPORT",
                      "IMPORT"
                    ],
                    "--region": "dynamic"
                  }
                },
                "add-route-policy-term": {
                  "commands": {},
                  "flags": {
                    "--actions": "value",
                    "--match": "value",
                    "--policy-name": "value",
                    "--priority": "value",
                    "--region": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--advertisement-mode": [
                      "CUSTOM",
                      "DEFAULT"
                    ],
                    "--asn": "value",
                    "--async": "bool",
                    "--bgp-identifier-range": "value",
                    "--description": "value",
                    "--encrypted-interconnect-router": "bool",
                    "--keepalive-interval": "value",
                    "--network": "dynamic",
                    "--region": "dynamic",
                    "--set-advertisement-groups": "value",
                    "--set-advertisement-ranges": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "download-route-policy": {
                  "commands": {},
                  "flags": {
                    "--file-format": [
                      "json",
                      "yaml"
                    ],
                    "--file-name": "value",
                    "--policy-name": "value",
                    "--region": "dynamic"
                  }
                },
                "get-nat-ip-info": {
                  "commands": {},
                  "flags": {
                    "--nat-name": "value",
                    "--region": "dynamic"
                  }
                },
                "get-nat-mapping-info": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--nat-name": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value"
                  }
                },
                "get-route-policy": {
                  "commands": {},
                  "flags": {
                    "--policy-name": "value",
                    "--region": "dynamic"
                  }
                },
                "get-status": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-bgp-routes": {
                  "commands": {},
                  "flags": {
                    "--address-family": [
                      "IPV4",
                      "IPV6"
                    ],
                    "--destination-range": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--peer": "value",
                    "--policy-applied": "bool",
                    "--region": "dynamic",
                    "--route-direction": [
                      "INBOUND",
                      "OUTBOUND"
                    ],
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-route-policies": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "nats": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--auto-allocate-nat-external-ips": "bool",
                        "--auto-network-tier": [
                          "PREMIUM",
                          "STANDARD"
                        ],
                        "--enable-dynamic-port-allocation": "bool",
                        "--enable-endpoint-independent-mapping": "bool",
                        "--enable-logging": "bool",
                        "--endpoint-types": "value",
                        "--icmp-idle-timeout": "value",
                        "--log-filter": [
                          "ALL",
                          "ERRORS_ONLY",
                          "TRANSLATIONS_ONLY"
                        ],
                        "--max-ports-per-vm": "value",
                        "--min-ports-per-vm": "value",
                        "--nat-all-subnet-ip-ranges": "bool",
                        "--nat-custom-subnet-ip-ranges": "value",
                        "--nat-external-ip-pool": "value",
                        "--nat-primary-subnet-ip-ranges": "bool",
                        "--nat64-all-v6-subnet-ip-ranges": "bool",
                        "--nat64-custom-v6-subnet-ip-ranges": "value",
                        "--region": "dynamic",
                        "--router": "dynamic",
                        "--rules": "value",
                        "--tcp-established-idle-timeout": "value",
                        "--tcp-time-wait-timeout": "value",
                        "--tcp-transitory-idle-timeout": "value",
                        "--type": [
                          "PRIVATE",
                          "PUBLIC"
                        ],
                        "--udp-idle-timeout": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--router": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--router": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--router": "dynamic"
                      }
                    },
                    "rules": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--async": "bool",
                            "--match": "value",
                            "--nat": "value",
                            "--region": "dynamic",
                            "--router": "dynamic",
                            "--source-nat-active-ips": "value",
                            "--source-nat-active-ranges": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--nat": "value",
                            "--region": "dynamic",
                            "--router": "dynamic"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--nat": "value",
                            "--region": "dynamic",
                            "--router": "dynamic"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--nat": "value",
                            "--region": "dynamic",
                            "--router": "dynamic"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--async": "bool",
                            "--clear-source-nat-drain-ips": "bool",
                            "--clear-source-nat-drain-ranges": "bool",
                            "--match": "value",
                            "--nat": "value",
                            "--region": "dynamic",
                            "--router": "dynamic",
                            "--source-nat-active-ips": "value",
                            "--source-nat-active-ranges": "value",
                            "--source-nat-drain-ips": "value",
                            "--source-nat-drain-ranges": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--auto-allocate-nat-external-ips": "bool",
                        "--auto-network-tier": [
                          "PREMIUM",
                          "STANDARD"
                        ],
                        "--clear-icmp-idle-timeout": "bool",
                        "--clear-max-ports-per-vm": "bool",
                        "--clear-min-ports-per-vm": "bool",
                        "--clear-nat-external-drain-ip-pool": "bool",
                        "--clear-nat-subnet-ip-ranges": "bool",
                        "--clear-nat64-subnet-ip-ranges": "bool",
                        "--clear-tcp-established-idle-timeout": "bool",
                        "--clear-tcp-time-wait-timeout": "bool",
                        "--clear-tcp-transitory-idle-timeout": "bool",
                        "--clear-udp-idle-timeout": "bool",
                        "--enable-dynamic-port-allocation": "bool",
                        "--enable-endpoint-independent-mapping": "bool",
                        "--enable-logging": "bool",
                        "--icmp-idle-timeout": "value",
                        "--log-filter": [
                          "ALL",
                          "ERRORS_ONLY",
                          "TRANSLATIONS_ONLY"
                        ],
                        "--max-ports-per-vm": "value",
                        "--min-ports-per-vm": "value",
                        "--nat-all-subnet-ip-ranges": "bool",
                        "--nat-custom-subnet-ip-ranges": "value",
                        "--nat-external-drain-ip-pool": "value",
                        "--nat-external-ip-pool": "value",
                        "--nat-primary-subnet-ip-ranges": "bool",
                        "--nat64-all-v6-subnet-ip-ranges": "bool",
                        "--nat64-custom-v6-subnet-ip-ranges": "value",
                        "--region": "dynamic",
                        "--router": "dynamic",
                        "--rules": "value",
                        "--tcp-established-idle-timeout": "value",
                        "--tcp-time-wait-timeout": "value",
                        "--tcp-transitory-idle-timeout": "value",
                        "--udp-idle-timeout": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "remove-bgp-peer": {
                  "commands": {},
                  "flags": {
                    "--peer-name": "value",
                    "--peer-names": "value",
                    "--region": "dynamic"
                  }
                },
                "remove-interface": {
                  "commands": {},
                  "flags": {
                    "--interface-name": "value",
                    "--interface-names": "value",
                    "--region": "dynamic"
                  }
                },
                "remove-route-policy": {
                  "commands": {},
                  "flags": {
                    "--policy-name": "value",
                    "--region": "dynamic"
                  }
                },
                "remove-route-policy-term": {
                  "commands": {},
                  "flags": {
                    "--policy-name": "value",
                    "--priority": "value",
                    "--region": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-advertisement-groups": "value",
                    "--add-advertisement-ranges": "value",
                    "--advertisement-mode": [
                      "CUSTOM",
                      "DEFAULT"
                    ],
                    "--asn": "value",
                    "--async": "bool",
                    "--bgp-identifier-range": "value",
                    "--keepalive-interval": "value",
                    "--region": "dynamic",
                    "--remove-advertisement-groups": "value",
                    "--remove-advertisement-ranges": "value",
                    "--set-advertisement-groups": "value",
                    "--set-advertisement-ranges": "value"
                  }
                },
                "update-bgp-peer": {
                  "commands": {},
                  "flags": {
                    "--add-advertisement-groups": "value",
                    "--add-advertisement-ranges": "value",
                    "--add-custom-learned-route-ranges": "value",
                    "--advertised-route-priority": "value",
                    "--advertisement-mode": [
                      "CUSTOM",
                      "DEFAULT"
                    ],
                    "--async": "bool",
                    "--bfd-min-receive-interval": "value",
                    "--bfd-min-transmit-interval": "value",
                    "--bfd-multiplier": "value",
                    "--bfd-session-initialization-mode": [
                      "ACTIVE",
                      "DISABLED",
                      "PASSIVE"
                    ],
                    "--clear-md5-authentication-key": "bool",
                    "--custom-learned-route-priority": "value",
                    "--enable-ipv4": "bool",
                    "--enable-ipv6": "bool",
                    "--enabled": "bool",
                    "--export-policies": "value",
                    "--import-policies": "value",
                    "--interface": "value",
                    "--ip-address": "value",
                    "--ipv4-nexthop-address": "value",
                    "--ipv6-nexthop-address": "value",
                    "--md5-authentication-key": "value",
                    "--peer-asn": "value",
                    "--peer-ip-address": "value",
                    "--peer-ipv4-nexthop-address": "value",
                    "--peer-ipv6-nexthop-address": "value",
                    "--peer-name": "value",
                    "--region": "dynamic",
                    "--remove-advertisement-groups": "value",
                    "--remove-advertisement-ranges": "value",
                    "--remove-custom-learned-route-ranges": "value",
                    "--set-advertisement-groups": "value",
                    "--set-advertisement-ranges": "value",
                    "--set-custom-learned-route-ranges": "value"
                  }
                },
                "update-interface": {
                  "commands": {},
                  "flags": {
                    "--interconnect-attachment": "dynamic",
                    "--interconnect-attachment-region": "dynamic",
                    "--interface-name": "value",
                    "--ip-address": "value",
                    "--ip-version": [
                      "IPV4",
                      "IPV6"
                    ],
                    "--mask-length": "value",
                    "--region": "dynamic",
                    "--vpn-tunnel": "dynamic",
                    "--vpn-tunnel-region": "dynamic"
                  }
                },
                "update-route-policy-term": {
                  "commands": {},
                  "flags": {
                    "--actions": "value",
                    "--match": "value",
                    "--policy-name": "value",
                    "--priority": "value",
                    "--region": "dynamic"
                  }
                },
                "upload-route-policy": {
                  "commands": {},
                  "flags": {
                    "--file-format": [
                      "json",
                      "yaml"
                    ],
                    "--file-name": "value",
                    "--policy-name": "value",
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "routes": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--destination-range": "value",
                    "--network": "value",
                    "--next-hop-address": "value",
                    "--next-hop-gateway": "dynamic",
                    "--next-hop-ilb": "value",
                    "--next-hop-ilb-region": "value",
                    "--next-hop-instance": "value",
                    "--next-hop-instance-zone": "value",
                    "--next-hop-vpn-tunnel": "value",
                    "--next-hop-vpn-tunnel-region": "value",
                    "--priority": "value",
                    "--tags": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "scp": {
              "commands": {},
              "flags": {
                "--compress": "bool",
                "--dest-group": "value",
                "--dry-run": "bool",
                "--force-key-file-overwrite": "bool",
                "--internal-ip": "bool",
                "--network": "value",
                "--plain": "bool",
                "--port": "value",
                "--recurse": "bool",
                "--region": "value",
                "--scp-flag": "value",
                "--ssh-key-expiration": "value",
                "--ssh-key-expire-after": "value",
                "--ssh-key-file": "value",
                "--strict-host-key-checking": [
                  "ask",
                  "no",
                  "yes"
                ],
                "--tunnel-through-iap": "bool",
                "--zone": "value"
              }
            },
            "security-policies": {
              "commands": {
                "add-layer7-ddos-defense-threshold-config": {
                  "commands": {},
                  "flags": {
                    "--auto-deploy-confidence-threshold": "value",
                    "--auto-deploy-expiration-sec": "value",
                    "--auto-deploy-impacted-baseline-threshold": "value",
                    "--auto-deploy-load-threshold": "value",
                    "--detection-absolute-qps": "value",
                    "--detection-load-threshold": "value",
                    "--detection-relative-to-baseline-qps": "value",
                    "--threshold-config-name": "value",
                    "--traffic-granularity-configs": "value"
                  }
                },
                "add-user-defined-field": {
                  "commands": {},
                  "flags": {
                    "--base": [
                      "ipv4",
                      "ipv6",
                      "tcp",
                      "udp"
                    ],
                    "--mask": "value",
                    "--offset": "value",
                    "--region": "dynamic",
                    "--size": "value",
                    "--user-defined-field-name": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--file-format": [
                      "json",
                      "yaml"
                    ],
                    "--file-name": "value",
                    "--global": "bool",
                    "--region": "dynamic",
                    "--type": [
                      "CLOUD_ARMOR",
                      "CLOUD_ARMOR_EDGE",
                      "CLOUD_ARMOR_NETWORK"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--file-format": [
                      "json",
                      "yaml"
                    ],
                    "--file-name": "value",
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--file-format": [
                      "json",
                      "yaml"
                    ],
                    "--file-name": "value",
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-preconfigured-expression-sets": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-layer7-ddos-defense-threshold-config": {
                  "commands": {},
                  "flags": {
                    "--threshold-config-name": "value"
                  }
                },
                "remove-user-defined-field": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--user-defined-field-name": "value"
                  }
                },
                "rules": {
                  "commands": {
                    "add-preconfig-waf-exclusion": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--request-cookie-to-exclude": "value",
                        "--request-header-to-exclude": "value",
                        "--request-query-param-to-exclude": "value",
                        "--request-uri-to-exclude": "value",
                        "--security-policy": "dynamic",
                        "--target-rule-ids": "value",
                        "--target-rule-set": "value"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "allow",
                          "deny",
                          "deny-403",
                          "deny-404",
                          "deny-502",
                          "rate-based-ban",
                          "redirect",
                          "redirect-to-recaptcha",
                          "throttle"
                        ],
                        "--ban-duration-sec": "value",
                        "--ban-threshold-count": "value",
                        "--ban-threshold-interval-sec": "value",
                        "--conform-action": [
                          "allow"
                        ],
                        "--description": "value",
                        "--enforce-on-key": [
                          "all",
                          "http-cookie",
                          "http-header",
                          "http-path",
                          "ip",
                          "region-code",
                          "sni",
                          "tls-ja3-fingerprint",
                          "tls-ja4-fingerprint",
                          "user-ip",
                          "xff-ip"
                        ],
                        "--enforce-on-key-configs": "value",
                        "--enforce-on-key-name": "value",
                        "--exceed-action": [
                          "deny",
                          "deny-403",
                          "deny-404",
                          "deny-429",
                          "deny-502",
                          "redirect"
                        ],
                        "--exceed-redirect-target": "value",
                        "--exceed-redirect-type": [
                          "external-302",
                          "google-recaptcha"
                        ],
                        "--expression": "value",
                        "--network-dest-ip-ranges": "value",
                        "--network-dest-ports": "value",
                        "--network-ip-protocols": "value",
                        "--network-src-asns": "value",
                        "--network-src-ip-ranges": "value",
                        "--network-src-ports": "value",
                        "--network-src-region-codes": "value",
                        "--network-user-defined-fields": "value",
                        "--preview": "bool",
                        "--rate-limit-threshold-count": "value",
                        "--rate-limit-threshold-interval-sec": "value",
                        "--recaptcha-action-site-keys": "value",
                        "--recaptcha-session-site-keys": "value",
                        "--redirect-target": "value",
                        "--redirect-type": [
                          "external-302",
                          "google-recaptcha"
                        ],
                        "--region": "dynamic",
                        "--request-headers-to-add": "value",
                        "--security-policy": "dynamic",
                        "--src-ip-ranges": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--security-policy": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--security-policy": "dynamic"
                      }
                    },
                    "remove-preconfig-waf-exclusion": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--request-cookie-to-exclude": "value",
                        "--request-header-to-exclude": "value",
                        "--request-query-param-to-exclude": "value",
                        "--request-uri-to-exclude": "value",
                        "--security-policy": "dynamic",
                        "--target-rule-ids": "value",
                        "--target-rule-set": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "allow",
                          "deny",
                          "deny-403",
                          "deny-404",
                          "deny-502",
                          "rate-based-ban",
                          "redirect",
                          "redirect-to-recaptcha",
                          "throttle"
                        ],
                        "--ban-duration-sec": "value",
                        "--ban-threshold-count": "value",
                        "--ban-threshold-interval-sec": "value",
                        "--conform-action": [
                          "allow"
                        ],
                        "--description": "value",
                        "--enforce-on-key": [
                          "all",
                          "http-cookie",
                          "http-header",
                          "http-path",
                          "ip",
                          "region-code",
                          "sni",
                          "tls-ja3-fingerprint",
                          "tls-ja4-fingerprint",
                          "user-ip",
                          "xff-ip"
                        ],
                        "--enforce-on-key-configs": "value",
                        "--enforce-on-key-name": "value",
                        "--exceed-action": [
                          "deny",
                          "deny-403",
                          "deny-404",
                          "deny-429",
                          "deny-502",
                          "redirect"
                        ],
                        "--exceed-redirect-target": "value",
                        "--exceed-redirect-type": [
                          "external-302",
                          "google-recaptcha"
                        ],
                        "--expression": "value",
                        "--network-dest-ip-ranges": "value",
                        "--network-dest-ports": "value",
                        "--network-ip-protocols": "value",
                        "--network-src-asns": "value",
                        "--network-src-ip-ranges": "value",
                        "--network-src-ports": "value",
                        "--network-src-region-codes": "value",
                        "--network-user-defined-fields": "value",
                        "--preview": "bool",
                        "--rate-limit-threshold-count": "value",
                        "--rate-limit-threshold-interval-sec": "value",
                        "--recaptcha-action-site-keys": "value",
                        "--recaptcha-session-site-keys": "value",
                        "--redirect-target": "value",
                        "--redirect-type": [
                          "external-302",
                          "google-recaptcha"
                        ],
                        "--region": "dynamic",
                        "--request-headers-to-add": "value",
                        "--security-policy": "dynamic",
                        "--src-ip-ranges": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--enable-layer7-ddos-defense": "bool",
                    "--global": "bool",
                    "--json-custom-content-types": "value",
                    "--json-parsing": [
                      "DISABLED",
                      "STANDARD",
                      "STANDARD_WITH_GRAPHQL"
                    ],
                    "--layer7-ddos-defense-auto-deploy-confidence-threshold": "value",
                    "--layer7-ddos-defense-auto-deploy-expiration-sec": "value",
                    "--layer7-ddos-defense-auto-deploy-impacted-baseline-threshold": "value",
                    "--layer7-ddos-defense-auto-deploy-load-threshold": "value",
                    "--layer7-ddos-defense-rule-visibility": [
                      "PREMIUM",
                      "STANDARD"
                    ],
                    "--log-level": [
                      "NORMAL",
                      "VERBOSE"
                    ],
                    "--network-ddos-protection": [
                      "ADVANCED",
                      "ADVANCED_PREVIEW",
                      "STANDARD"
                    ],
                    "--recaptcha-redirect-site-key": "value",
                    "--region": "dynamic",
                    "--request-body-inspection-size": [
                      "128KB",
                      "8KB"
                    ],
                    "--user-ip-request-headers": "value"
                  }
                }
              },
              "flags": {}
            },
            "service-attachments": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--connection-preference": [
                      "ACCEPT_AUTOMATIC",
                      "ACCEPT_MANUAL"
                    ],
                    "--consumer-accept-list": "value",
                    "--consumer-reject-list": "value",
                    "--description": "value",
                    "--domain-names": "value",
                    "--enable-proxy-protocol": "bool",
                    "--nat-subnets": "dynamic",
                    "--nat-subnets-region": "dynamic",
                    "--producer-forwarding-rule": "dynamic",
                    "--producer-forwarding-rule-region": "dynamic",
                    "--propagated-connection-limit": "value",
                    "--reconcile-connections": "bool",
                    "--region": "dynamic",
                    "--target-service": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--connection-preference": [
                      "ACCEPT_AUTOMATIC",
                      "ACCEPT_MANUAL"
                    ],
                    "--consumer-accept-list": "value",
                    "--consumer-reject-list": "value",
                    "--description": "value",
                    "--enable-proxy-protocol": "bool",
                    "--nat-subnets": "dynamic",
                    "--nat-subnets-region": "dynamic",
                    "--propagated-connection-limit": "value",
                    "--reconcile-connections": "bool",
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "shared-vpc": {
              "commands": {
                "associated-projects": {
                  "commands": {
                    "add": {
                      "commands": {},
                      "flags": {
                        "--host-project": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "remove": {
                      "commands": {},
                      "flags": {
                        "--host-project": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "disable": {
                  "commands": {},
                  "flags": {}
                },
                "enable": {
                  "commands": {},
                  "flags": {}
                },
                "get-host-project": {
                  "commands": {},
                  "flags": {}
                },
                "list-associated-resources": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "organizations": {
                  "commands": {
                    "list-host-projects": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "sign-url": {
              "commands": {},
              "flags": {
                "--expires-in": "value",
                "--key-file": "value",
                "--key-name": "value",
                "--validate": "bool"
              }
            },
            "snapshot-settings": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--storage-location-names": "value",
                    "--storage-location-policy": "value"
                  }
                }
              },
              "flags": {}
            },
            "snapshots": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "add-labels": {
                  "commands": {},
                  "flags": {
                    "--labels": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--chain-name": "value",
                    "--csek-key-file": "value",
                    "--description": "value",
                    "--guest-flush": "bool",
                    "--labels": "value",
                    "--snapshot-type": [
                      "ARCHIVE",
                      "STANDARD"
                    ],
                    "--source-disk": "dynamic",
                    "--source-disk-for-recovery-checkpoint": "dynamic",
                    "--source-disk-for-recovery-checkpoint-region": "dynamic",
                    "--source-disk-key-file": "value",
                    "--source-disk-region": "dynamic",
                    "--source-disk-zone": "dynamic",
                    "--source-instant-snapshot": "dynamic",
                    "--source-instant-snapshot-key-file": "value",
                    "--source-instant-snapshot-region": "dynamic",
                    "--source-instant-snapshot-zone": "dynamic",
                    "--storage-location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "remove-labels": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--labels": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "sole-tenancy": {
              "commands": {
                "node-groups": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--member": "value",
                        "--role": "dynamic",
                        "--zone": "value"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--autoscaler-mode": [
                          "off",
                          "on",
                          "only-scale-out"
                        ],
                        "--description": "value",
                        "--maintenance-interval": [
                          "as-needed",
                          "recurrent"
                        ],
                        "--maintenance-policy": [
                          "default",
                          "migrate-within-node-group",
                          "restart-in-place"
                        ],
                        "--maintenance-window-start-time": "value",
                        "--max-nodes": "value",
                        "--min-nodes": "value",
                        "--node-template": "value",
                        "--share-setting": [
                          "local",
                          "organization",
                          "projects"
                        ],
                        "--share-with": "value",
                        "--target-size": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--zone": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--zone": "dynamic"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--zone": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--share-settings": "bool",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "list-nodes": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "perform-maintenance": {
                      "commands": {},
                      "flags": {
                        "--nodes": "value",
                        "--start-time": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--member": "value",
                        "--role": "dynamic",
                        "--zone": "value"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--zone": "value"
                      }
                    },
                    "simulate-maintenance-event": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--nodes": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--add-nodes": "value",
                        "--autoscaler-mode": [
                          "off",
                          "on",
                          "only-scale-out"
                        ],
                        "--delete-nodes": "value",
                        "--max-nodes": "value",
                        "--min-nodes": "value",
                        "--node-template": "value",
                        "--share-setting": [
                          "local",
                          "organization",
                          "projects"
                        ],
                        "--share-with": "value",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "node-templates": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--member": "value",
                        "--region": "value",
                        "--role": "dynamic"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--accelerator": "value",
                        "--cpu-overcommit-type": [
                          "enabled",
                          "none"
                        ],
                        "--description": "value",
                        "--disk": "value",
                        "--node-affinity-labels": "value",
                        "--node-requirements": "value",
                        "--node-type": "value",
                        "--region": "dynamic",
                        "--server-binding": [
                          "restart-node-on-any-server",
                          "restart-node-on-minimal-servers"
                        ]
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--member": "value",
                        "--region": "value",
                        "--role": "dynamic"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--region": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "node-types": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--zone": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "ssh": {
              "commands": {},
              "flags": {
                "--command": "value",
                "--container": "value",
                "--dest-group": "value",
                "--dry-run": "bool",
                "--force-key-file-overwrite": "bool",
                "--internal-ip": "bool",
                "--network": "value",
                "--plain": "bool",
                "--region": "value",
                "--ssh-flag": "value",
                "--ssh-key-expiration": "value",
                "--ssh-key-expire-after": "value",
                "--ssh-key-file": "value",
                "--strict-host-key-checking": [
                  "ask",
                  "no",
                  "yes"
                ],
                "--troubleshoot": "bool",
                "--tunnel-through-iap": "bool",
                "--zone": "dynamic"
              }
            },
            "ssl-certificates": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--certificate": "value",
                    "--description": "value",
                    "--domains": "value",
                    "--global": "bool",
                    "--private-key": "value",
                    "--region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "ssl-policies": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--custom-features": "value",
                    "--description": "value",
                    "--global": "bool",
                    "--min-tls-version": [
                      "1.0",
                      "1.1",
                      "1.2"
                    ],
                    "--profile": [
                      "COMPATIBLE",
                      "CUSTOM",
                      "MODERN",
                      "RESTRICTED"
                    ],
                    "--region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-available-features": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--custom-features": "value",
                    "--global": "bool",
                    "--min-tls-version": [
                      "1.0",
                      "1.1",
                      "1.2"
                    ],
                    "--profile": [
                      "COMPATIBLE",
                      "CUSTOM",
                      "MODERN",
                      "RESTRICTED"
                    ],
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "start-iap-tunnel": {
              "commands": {},
              "flags": {
                "--dest-group": "value",
                "--iap-tunnel-disable-connection-check": "bool",
                "--local-host-port": "value",
                "--network": "value",
                "--region": "value",
                "--zone": "dynamic"
              }
            },
            "storage-pool-types": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "storage-pools": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--capacity-provisioning-type": [
                      "advanced",
                      "standard"
                    ],
                    "--description": "value",
                    "--performance-provisioning-type": [
                      "advanced",
                      "standard"
                    ],
                    "--provisioned-capacity": "value",
                    "--provisioned-iops": "value",
                    "--provisioned-throughput": "value",
                    "--storage-pool-type": "value",
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list-disks": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--provisioned-capacity": "value",
                    "--provisioned-iops": "value",
                    "--provisioned-throughput": "value",
                    "--zone": "value"
                  }
                }
              },
              "flags": {}
            },
            "target-grpc-proxies": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--global-url-map": "bool",
                    "--url-map": "dynamic",
                    "--url-map-region": "dynamic",
                    "--validate-for-proxyless": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "target-http-proxies": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--global": "bool",
                    "--global-url-map": "bool",
                    "--http-keep-alive-timeout-sec": "value",
                    "--region": "dynamic",
                    "--url-map": "dynamic",
                    "--url-map-region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-http-keep-alive-timeout-sec": "bool",
                    "--global": "bool",
                    "--global-url-map": "bool",
                    "--http-keep-alive-timeout-sec": "value",
                    "--region": "dynamic",
                    "--url-map": "dynamic",
                    "--url-map-region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "target-https-proxies": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--certificate-manager-certificates": "dynamic",
                    "--certificate-map": "dynamic",
                    "--description": "value",
                    "--global": "bool",
                    "--global-ssl-certificates": "bool",
                    "--global-ssl-policy": "bool",
                    "--global-url-map": "bool",
                    "--http-keep-alive-timeout-sec": "value",
                    "--quic-override": [
                      "DISABLE",
                      "ENABLE",
                      "NONE"
                    ],
                    "--region": "dynamic",
                    "--server-tls-policy": "dynamic",
                    "--ssl-certificates": "dynamic",
                    "--ssl-certificates-region": "dynamic",
                    "--ssl-policy": "dynamic",
                    "--ssl-policy-region": "dynamic",
                    "--tls-early-data": [
                      "DISABLED",
                      "PERMISSIVE",
                      "STRICT"
                    ],
                    "--url-map": "dynamic",
                    "--url-map-region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--certificate-manager-certificates": "dynamic",
                    "--certificate-map": "dynamic",
                    "--clear-certificate-map": "bool",
                    "--clear-http-keep-alive-timeout-sec": "bool",
                    "--clear-server-tls-policy": "bool",
                    "--clear-ssl-certificates": "bool",
                    "--clear-ssl-policy": "bool",
                    "--global": "bool",
                    "--global-ssl-certificates": "bool",
                    "--global-ssl-policy": "bool",
                    "--global-url-map": "bool",
                    "--http-keep-alive-timeout-sec": "value",
                    "--quic-override": [
                      "DISABLE",
                      "ENABLE",
                      "NONE"
                    ],
                    "--region": "dynamic",
                    "--server-tls-policy": "dynamic",
                    "--ssl-certificates": "dynamic",
                    "--ssl-certificates-region": "dynamic",
                    "--ssl-policy": "dynamic",
                    "--ssl-policy-region": "dynamic",
                    "--tls-early-data": [
                      "DISABLED",
                      "PERMISSIVE",
                      "STRICT"
                    ],
                    "--url-map": "dynamic",
                    "--url-map-region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "target-instances": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--instance": "dynamic",
                    "--instance-zone": "dynamic",
                    "--network": "value",
                    "--zone": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zones": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--security-policy": "dynamic",
                    "--security-policy-region": "dynamic",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "target-pools": {
              "commands": {
                "add-health-checks": {
                  "commands": {},
                  "flags": {
                    "--http-health-check": "dynamic",
                    "--region": "dynamic"
                  }
                },
                "add-instances": {
                  "commands": {},
                  "flags": {
                    "--instances": "dynamic",
                    "--instances-zone": "dynamic",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--backup-pool": "value",
                    "--description": "value",
                    "--failover-ratio": "value",
                    "--health-check": "value",
                    "--http-health-check": "dynamic",
                    "--region": "dynamic",
                    "--session-affinity": [
                      "CLIENT_IP",
                      "CLIENT_IP_PROTO",
                      "NONE"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "get-health": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-health-checks": {
                  "commands": {},
                  "flags": {
                    "--http-health-check": "dynamic",
                    "--region": "dynamic"
                  }
                },
                "remove-instances": {
                  "commands": {},
                  "flags": {
                    "--instances": "dynamic",
                    "--instances-zone": "dynamic",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "set-backup": {
                  "commands": {},
                  "flags": {
                    "--backup-pool": "dynamic",
                    "--failover-ratio": "value",
                    "--no-backup-pool": "bool",
                    "--region": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--security-policy": "dynamic",
                    "--security-policy-region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "target-ssl-proxies": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--backend-service": "dynamic",
                    "--certificate-map": "dynamic",
                    "--description": "value",
                    "--global-ssl-policy": "bool",
                    "--proxy-header": [
                      "NONE",
                      "PROXY_V1"
                    ],
                    "--ssl-certificates": "dynamic",
                    "--ssl-policy": "dynamic",
                    "--ssl-policy-region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--backend-service": "dynamic",
                    "--certificate-map": "dynamic",
                    "--clear-certificate-map": "bool",
                    "--clear-ssl-certificates": "bool",
                    "--clear-ssl-policy": "bool",
                    "--global-ssl-policy": "bool",
                    "--proxy-header": [
                      "NONE",
                      "PROXY_V1"
                    ],
                    "--ssl-certificates": "dynamic",
                    "--ssl-policy": "dynamic",
                    "--ssl-policy-region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "target-tcp-proxies": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--backend-service": "dynamic",
                    "--backend-service-region": "dynamic",
                    "--description": "value",
                    "--global": "bool",
                    "--global-backend-service": "bool",
                    "--proxy-bind": "bool",
                    "--proxy-header": [
                      "NONE",
                      "PROXY_V1"
                    ],
                    "--region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--backend-service": "dynamic",
                    "--proxy-header": [
                      "NONE",
                      "PROXY_V1"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "target-vpn-gateways": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--network": "dynamic",
                    "--region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "tpus": {
              "commands": {
                "accelerator-types": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--zone": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator-type": "value",
                    "--async": "bool",
                    "--description": "value",
                    "--network": "value",
                    "--preemptible": "bool",
                    "--range": "value",
                    "--reserved": "bool",
                    "--use-service-networking": "bool",
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "execution-groups": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--accelerator-type": "value",
                        "--disk-size": "value",
                        "--dry-run": "bool",
                        "--forward-ports": "bool",
                        "--gce-image": "value",
                        "--machine-type": "value",
                        "--name": "value",
                        "--network": "value",
                        "--preemptible": "bool",
                        "--preemptible-vm": "bool",
                        "--tf-version": "value",
                        "--tpu-only": "bool",
                        "--use-dl-images": "bool",
                        "--use-with-notebook": "bool",
                        "--vm-only": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--tpu-only": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--zone": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "resume": {
                      "commands": {},
                      "flags": {
                        "--accelerator-type": "value",
                        "--network": "value",
                        "--preemptible": "bool",
                        "--tf-version": "value",
                        "--vm-only": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "suspend": {
                      "commands": {},
                      "flags": {
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                },
                "locations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "reimage": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--zone": "value"
                  }
                },
                "start": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--zone": "value"
                  }
                },
                "stop": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--zone": "value"
                  }
                },
                "versions": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--zone": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "url-maps": {
              "commands": {
                "add-host-rule": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--global": "bool",
                    "--hosts": "value",
                    "--path-matcher-name": "value",
                    "--region": "dynamic"
                  }
                },
                "add-path-matcher": {
                  "commands": {},
                  "flags": {
                    "--backend-bucket-path-rules": "value",
                    "--backend-service-path-rules": "value",
                    "--default-backend-bucket": "value",
                    "--default-service": "value",
                    "--delete-orphaned-path-matcher": "bool",
                    "--description": "value",
                    "--existing-host": "value",
                    "--global": "bool",
                    "--new-hosts": "value",
                    "--path-matcher-name": "value",
                    "--path-rules": "value",
                    "--region": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--default-backend-bucket": "value",
                    "--default-service": "value",
                    "--description": "value",
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "edit": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "dynamic",
                    "--source": "value"
                  }
                },
                "invalidate-cdn-cache": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--global": "bool",
                    "--host": "value",
                    "--path": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-cdn-cache-invalidations": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--limit": "value"
                  }
                },
                "remove-host-rule": {
                  "commands": {},
                  "flags": {
                    "--delete-orphaned-path-matcher": "bool",
                    "--global": "bool",
                    "--host": "value",
                    "--region": "dynamic"
                  }
                },
                "remove-path-matcher": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--path-matcher-name": "value",
                    "--region": "dynamic"
                  }
                },
                "set-default-service": {
                  "commands": {},
                  "flags": {
                    "--default-backend-bucket": "value",
                    "--default-service": "value",
                    "--global": "bool",
                    "--region": "dynamic"
                  }
                },
                "validate": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--load-balancing-scheme": [
                      "EXTERNAL",
                      "EXTERNAL_MANAGED"
                    ],
                    "--region": "value",
                    "--source": "value"
                  }
                }
              },
              "flags": {}
            },
            "vpn-gateways": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--gateway-ip-version": [
                      "IPV4",
                      "IPV6"
                    ],
                    "--interconnect-attachments": "value",
                    "--network": "dynamic",
                    "--region": "dynamic",
                    "--stack-type": [
                      "IPV4_IPV6",
                      "IPV4_ONLY",
                      "IPV6_ONLY"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "get-status": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "vpn-tunnels": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--ike-version": [
                      1,
                      2
                    ],
                    "--interface": [
                      0,
                      1
                    ],
                    "--local-traffic-selector": "value",
                    "--peer-address": "value",
                    "--peer-external-gateway": "dynamic",
                    "--peer-external-gateway-interface": [
                      0,
                      1,
                      2,
                      3
                    ],
                    "--peer-gcp-gateway": "dynamic",
                    "--peer-gcp-gateway-region": "dynamic",
                    "--region": "dynamic",
                    "--remote-traffic-selector": "value",
                    "--router": "dynamic",
                    "--router-region": "dynamic",
                    "--shared-secret": "value",
                    "--target-vpn-gateway": "dynamic",
                    "--target-vpn-gateway-region": "dynamic",
                    "--vpn-gateway": "dynamic",
                    "--vpn-gateway-region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "zones": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "config": {
          "commands": {
            "configurations": {
              "commands": {
                "activate": {
                  "commands": {},
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--activate": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--all": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--sort-by": "value"
                  }
                },
                "rename": {
                  "commands": {},
                  "flags": {
                    "--new-name": "value"
                  }
                }
              },
              "flags": {}
            },
            "get": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--filter": "value",
                "--limit": "value",
                "--sort-by": "value"
              }
            },
            "set": {
              "commands": {},
              "flags": {
                "--installation": "bool"
              }
            },
            "unset": {
              "commands": {},
              "flags": {
                "--installation": "bool"
              }
            }
          },
          "flags": {}
        },
        "container": {
          "commands": {
            "backup-restore": {
              "commands": {
                "backup-plans": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--all-namespaces": "bool",
                        "--async": "bool",
                        "--backup-delete-lock-days": "value",
                        "--backup-retain-days": "value",
                        "--cluster": "value",
                        "--cron-schedule": "value",
                        "--deactivated": "bool",
                        "--description": "value",
                        "--encryption-key": "value",
                        "--exclusion-windows-file": "value",
                        "--include-secrets": "bool",
                        "--include-volume-data": "bool",
                        "--labels": "value",
                        "--location": "value",
                        "--locked": "bool",
                        "--paused": "bool",
                        "--permissive-mode": "bool",
                        "--selected-applications": "value",
                        "--selected-namespaces": "value",
                        "--target-rpo-minutes": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--etag": "value",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--all-namespaces": "bool",
                        "--async": "bool",
                        "--backup-delete-lock-days": "value",
                        "--backup-retain-days": "value",
                        "--clear-labels": "bool",
                        "--cron-schedule": "value",
                        "--deactivated": "bool",
                        "--description": "value",
                        "--encryption-key": "value",
                        "--etag": "value",
                        "--exclusion-windows-file": "value",
                        "--include-secrets": "bool",
                        "--include-volume-data": "bool",
                        "--location": "value",
                        "--locked": "bool",
                        "--paused": "bool",
                        "--permissive-mode": "bool",
                        "--remove-labels": "value",
                        "--selected-applications": "value",
                        "--selected-namespaces": "value",
                        "--target-rpo-minutes": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "backups": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--backup-plan": "value",
                        "--delete-lock-days": "value",
                        "--description": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--retain-days": "value",
                        "--wait-for-completion": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--backup-plan": "value",
                        "--etag": "value",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--backup-plan": "value",
                        "--location": "value"
                      }
                    },
                    "get-backup-index-download-url": {
                      "commands": {},
                      "flags": {
                        "--backup-plan": "value",
                        "--location": "value"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--backup-plan": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--backup-plan": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--backup-plan": "value",
                        "--location": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--backup-plan": "value",
                        "--clear-labels": "bool",
                        "--delete-lock-days": "value",
                        "--description": "value",
                        "--etag": "value",
                        "--location": "value",
                        "--remove-labels": "value",
                        "--retain-days": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "locations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "operations": {
                  "commands": {
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "restore-plans": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--all-namespaces": "bool",
                        "--async": "bool",
                        "--backup-plan": "value",
                        "--cluster": "value",
                        "--cluster-resource-conflict-policy": [
                          "use-backup-version",
                          "use-existing-version"
                        ],
                        "--cluster-resource-scope-all-group-kinds": "bool",
                        "--cluster-resource-scope-excluded-group-kinds": "value",
                        "--cluster-resource-scope-no-group-kinds": "bool",
                        "--cluster-resource-scope-selected-group-kinds": "value",
                        "--description": "value",
                        "--excluded-namespaces": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--namespaced-resource-restore-mode": [
                          "delete-and-restore",
                          "fail-on-conflict",
                          "merge-replace-on-conflict",
                          "merge-replace-volume-on-conflict",
                          "merge-skip-on-conflict"
                        ],
                        "--no-namespaces": "bool",
                        "--restore-order-file": "value",
                        "--selected-applications": "value",
                        "--selected-namespaces": "value",
                        "--substitution-rules-file": "value",
                        "--transformation-rules-file": "value",
                        "--volume-data-restore-policy": [
                          "no-volume-data-restoration",
                          "restore-volume-data-from-backup",
                          "reuse-volume-handle-from-backup"
                        ],
                        "--volume-data-restore-policy-bindings": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--etag": "value",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--all-namespaces": "bool",
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--cluster-resource-conflict-policy": [
                          "use-backup-version",
                          "use-existing-version"
                        ],
                        "--cluster-resource-scope-all-group-kinds": "bool",
                        "--cluster-resource-scope-excluded-group-kinds": "value",
                        "--cluster-resource-scope-no-group-kinds": "bool",
                        "--cluster-resource-scope-selected-group-kinds": "value",
                        "--description": "value",
                        "--etag": "value",
                        "--excluded-namespaces": "value",
                        "--location": "value",
                        "--namespaced-resource-restore-mode": [
                          "delete-and-restore",
                          "fail-on-conflict",
                          "merge-replace-on-conflict",
                          "merge-replace-volume-on-conflict",
                          "merge-skip-on-conflict"
                        ],
                        "--no-namespaces": "bool",
                        "--remove-labels": "value",
                        "--restore-order-file": "value",
                        "--selected-applications": "value",
                        "--selected-namespaces": "value",
                        "--substitution-rules-file": "value",
                        "--transformation-rules-file": "value",
                        "--update-labels": "value",
                        "--volume-data-restore-policy": [
                          "no-volume-data-restoration",
                          "restore-volume-data-from-backup",
                          "reuse-volume-handle-from-backup"
                        ],
                        "--volume-data-restore-policy-bindings": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "restores": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--backup": "value",
                        "--description": "value",
                        "--filter-file": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--restore-plan": "value",
                        "--volume-data-restore-policy-overrides-file": "value",
                        "--wait-for-completion": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--etag": "value",
                        "--location": "value",
                        "--restore-plan": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--restore-plan": "value"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--restore-plan": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--restore-plan": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--restore-plan": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--description": "value",
                        "--etag": "value",
                        "--location": "value",
                        "--remove-labels": "value",
                        "--restore-plan": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "volume-backups": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--backup": "value",
                        "--backup-plan": "value",
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--backup": "value",
                        "--backup-plan": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "volume-restores": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--restore": "value",
                        "--restore-plan": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--restore": "value",
                        "--restore-plan": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "bare-metal": {
              "commands": {
                "admin-clusters": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--admin-users": "value",
                        "--annotations": "value",
                        "--api-server-args": "value",
                        "--async": "bool",
                        "--binauthz-evaluation-mode": [
                          "DISABLED",
                          "PROJECT_SINGLETON_POLICY_ENFORCE"
                        ],
                        "--control-plane-load-balancer-port": "value",
                        "--control-plane-node-configs": "value",
                        "--control-plane-node-labels": "value",
                        "--control-plane-node-taints": "value",
                        "--control-plane-vip": "value",
                        "--description": "value",
                        "--enable-application-logs": "bool",
                        "--enable-manual-lb": "bool",
                        "--island-mode-pod-address-cidr-blocks": "value",
                        "--island-mode-service-address-cidr-blocks": "value",
                        "--location": "value",
                        "--login-user": "value",
                        "--lvp-node-mounts-config-path": "value",
                        "--lvp-node-mounts-config-storage-class": "value",
                        "--lvp-share-path": "value",
                        "--lvp-share-storage-class": "value",
                        "--maintenance-address-cidr-blocks": "value",
                        "--max-pods-per-node": "value",
                        "--no-proxy": "value",
                        "--shared-path-pv-count": "value",
                        "--uri": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "enroll": {
                      "commands": {},
                      "flags": {
                        "--admin-cluster-membership": "value",
                        "--admin-cluster-membership-location": "value",
                        "--async": "bool",
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "query-version-config": {
                      "commands": {},
                      "flags": {
                        "--admin-cluster": "value",
                        "--location": "value"
                      }
                    },
                    "unenroll": {
                      "commands": {},
                      "flags": {
                        "--allow-missing": "bool",
                        "--async": "bool",
                        "--ignore-errors": "bool",
                        "--location": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--api-server-args": "value",
                        "--async": "bool",
                        "--binauthz-evaluation-mode": [
                          "DISABLED",
                          "PROJECT_SINGLETON_POLICY_ENFORCE"
                        ],
                        "--control-plane-node-configs": "value",
                        "--control-plane-node-labels": "value",
                        "--control-plane-node-taints": "value",
                        "--description": "value",
                        "--enable-application-logs": "bool",
                        "--island-mode-service-address-cidr-blocks": "value",
                        "--location": "value",
                        "--login-user": "value",
                        "--maintenance-address-cidr-blocks": "value",
                        "--max-pods-per-node": "value",
                        "--no-proxy": "value",
                        "--uri": "value",
                        "--validate-only": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "clusters": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--admin-cluster-membership": "value",
                        "--admin-cluster-membership-location": "value",
                        "--admin-cluster-membership-project": "value",
                        "--admin-users": "value",
                        "--annotations": "value",
                        "--api-server-args": "value",
                        "--async": "bool",
                        "--bgp-address-pools": "value",
                        "--bgp-asn": "value",
                        "--bgp-load-balancer-node-configs": "value",
                        "--bgp-load-balancer-node-labels": "value",
                        "--bgp-load-balancer-node-taints": "value",
                        "--bgp-load-balancer-registry-burst": "value",
                        "--bgp-load-balancer-registry-pull-qps": "value",
                        "--bgp-peer-configs": "value",
                        "--binauthz-evaluation-mode": [
                          "DISABLED",
                          "PROJECT_SINGLETON_POLICY_ENFORCE"
                        ],
                        "--container-runtime": "value",
                        "--control-plane-load-balancer-port": "value",
                        "--control-plane-node-configs": "value",
                        "--control-plane-node-labels": "value",
                        "--control-plane-node-taints": "value",
                        "--control-plane-registry-burst": "value",
                        "--control-plane-registry-pull-qps": "value",
                        "--control-plane-vip": "value",
                        "--description": "value",
                        "--disable-bgp-load-balancer-serialize-image-pulls": "bool",
                        "--disable-control-plane-serialize-image-pulls": "bool",
                        "--disable-metal-lb-load-balancer-serialize-image-pulls": "bool",
                        "--enable-advanced-networking": "bool",
                        "--enable-application-logs": "bool",
                        "--enable-manual-lb": "bool",
                        "--enable-multi-nic-config": "bool",
                        "--enable-sr-iov-config": "bool",
                        "--ingress-vip": "value",
                        "--island-mode-pod-address-cidr-blocks": "value",
                        "--island-mode-service-address-cidr-blocks": "value",
                        "--location": "value",
                        "--login-user": "value",
                        "--lvp-node-mounts-config-path": "value",
                        "--lvp-node-mounts-config-storage-class": "value",
                        "--lvp-share-path": "value",
                        "--lvp-share-storage-class": "value",
                        "--maintenance-address-cidr-blocks": "value",
                        "--max-pods-per-node": "value",
                        "--metal-lb-address-pools": "value",
                        "--metal-lb-load-balancer-node-configs": "value",
                        "--metal-lb-load-balancer-node-labels": "value",
                        "--metal-lb-load-balancer-node-taints": "value",
                        "--metal-lb-load-balancer-registry-burst": "value",
                        "--metal-lb-load-balancer-registry-pull-qps": "value",
                        "--no-proxy": "value",
                        "--shared-path-pv-count": "value",
                        "--uri": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--allow-missing": "bool",
                        "--async": "bool",
                        "--force": "bool",
                        "--ignore-errors": "bool",
                        "--location": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "enroll": {
                      "commands": {},
                      "flags": {
                        "--admin-cluster-membership": "value",
                        "--admin-cluster-membership-location": "value",
                        "--admin-cluster-membership-project": "value",
                        "--async": "bool",
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "query-version-config": {
                      "commands": {},
                      "flags": {
                        "--admin-cluster-membership": "value",
                        "--admin-cluster-membership-location": "value",
                        "--admin-cluster-membership-project": "value",
                        "--cluster": "value",
                        "--location": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--add-annotations": "value",
                        "--admin-users": "value",
                        "--allow-missing": "bool",
                        "--api-server-args": "value",
                        "--async": "bool",
                        "--bgp-address-pools": "value",
                        "--bgp-asn": "value",
                        "--bgp-load-balancer-node-configs": "value",
                        "--bgp-load-balancer-node-labels": "value",
                        "--bgp-load-balancer-node-taints": "value",
                        "--bgp-load-balancer-registry-burst": "value",
                        "--bgp-load-balancer-registry-pull-qps": "value",
                        "--bgp-peer-configs": "value",
                        "--binauthz-evaluation-mode": [
                          "DISABLED",
                          "PROJECT_SINGLETON_POLICY_ENFORCE"
                        ],
                        "--control-plane-node-configs": "value",
                        "--control-plane-node-labels": "value",
                        "--control-plane-node-taints": "value",
                        "--control-plane-registry-burst": "value",
                        "--control-plane-registry-pull-qps": "value",
                        "--description": "value",
                        "--disable-bgp-load-balancer-serialize-image-pulls": "bool",
                        "--disable-control-plane-serialize-image-pulls": "bool",
                        "--disable-metal-lb-load-balancer-serialize-image-pulls": "bool",
                        "--disable-sr-iov-config": "bool",
                        "--enable-application-logs": "bool",
                        "--enable-bgp-load-balancer-serialize-image-pulls": "bool",
                        "--enable-control-plane-serialize-image-pulls": "bool",
                        "--enable-metal-lb-load-balancer-serialize-image-pulls": "bool",
                        "--enable-sr-iov-config": "bool",
                        "--island-mode-service-address-cidr-blocks": "value",
                        "--location": "value",
                        "--login-user": "value",
                        "--maintenance-address-cidr-blocks": "value",
                        "--metal-lb-address-pools": "value",
                        "--metal-lb-load-balancer-node-configs": "value",
                        "--metal-lb-load-balancer-node-labels": "value",
                        "--metal-lb-load-balancer-node-taints": "value",
                        "--metal-lb-load-balancer-registry-burst": "value",
                        "--metal-lb-load-balancer-registry-pull-qps": "value",
                        "--remove-annotations": "value",
                        "--validate-only": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "node-pools": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--annotations": "value",
                        "--async": "bool",
                        "--cluster": "value",
                        "--disable-serialize-image-pulls": "bool",
                        "--display-name": "value",
                        "--location": "value",
                        "--node-configs": "value",
                        "--node-labels": "value",
                        "--node-taints": "value",
                        "--registry-burst": "value",
                        "--registry-pull-qps": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--allow-missing": "bool",
                        "--async": "bool",
                        "--cluster": "value",
                        "--ignore-errors": "bool",
                        "--location": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--cluster": "value",
                        "--location": "value"
                      }
                    },
                    "enroll": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--cluster": "value",
                        "--location": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--cluster": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--allow-missing": "bool",
                        "--async": "bool",
                        "--cluster": "value",
                        "--disable-serialize-image-pulls": "bool",
                        "--display-name": "value",
                        "--enable-serialize-image-pulls": "bool",
                        "--location": "value",
                        "--node-configs": "value",
                        "--node-labels": "value",
                        "--node-taints": "value",
                        "--registry-burst": "value",
                        "--registry-pull-qps": "value",
                        "--validate-only": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "wait": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "binauthz": {
              "commands": {
                "attestations": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--artifact-url": "value",
                        "--attestor": "value",
                        "--attestor-project": "value",
                        "--note": "value",
                        "--note-project": "value",
                        "--payload-file": "value",
                        "--public-key-id": "value",
                        "--signature-file": "value",
                        "--validate": "bool"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--artifact-url": "value",
                        "--attestor": "value",
                        "--attestor-project": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "sign-and-create": {
                      "commands": {},
                      "flags": {
                        "--artifact-url": "value",
                        "--attestor": "value",
                        "--attestor-project": "value",
                        "--dsse-type": "value",
                        "--keyversion": "value",
                        "--keyversion-key": "value",
                        "--keyversion-keyring": "value",
                        "--keyversion-location": "value",
                        "--keyversion-project": "value",
                        "--note": "value",
                        "--note-project": "value",
                        "--pae-encode-payload": "bool",
                        "--public-key-id-override": "value",
                        "--validate": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "attestors": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--member": "value",
                        "--role": "dynamic"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--attestation-authority-note": "value",
                        "--attestation-authority-note-project": "value",
                        "--description": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {}
                    },
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "public-keys": {
                      "commands": {
                        "add": {
                          "commands": {},
                          "flags": {
                            "--attestor": "value",
                            "--comment": "value",
                            "--keyversion": "value",
                            "--keyversion-key": "value",
                            "--keyversion-keyring": "value",
                            "--keyversion-location": "value",
                            "--keyversion-project": "value",
                            "--pgp-public-key-file": "value",
                            "--pkix-public-key-algorithm": [
                              "ec-sign-p256-sha256",
                              "ec-sign-p384-sha384",
                              "ec-sign-p521-sha512",
                              "ecdsa-p256-sha256",
                              "ecdsa-p384-sha384",
                              "ecdsa-p521-sha512",
                              "rsa-pss-2048-sha256",
                              "rsa-pss-3072-sha256",
                              "rsa-pss-4096-sha256",
                              "rsa-pss-4096-sha512",
                              "rsa-sign-pkcs1-2048-sha256",
                              "rsa-sign-pkcs1-3072-sha256",
                              "rsa-sign-pkcs1-4096-sha256",
                              "rsa-sign-pkcs1-4096-sha512",
                              "rsa-sign-pss-2048-sha256",
                              "rsa-sign-pss-3072-sha256",
                              "rsa-sign-pss-4096-sha256",
                              "rsa-sign-pss-4096-sha512"
                            ],
                            "--pkix-public-key-file": "value",
                            "--public-key-id-override": "value"
                          }
                        },
                        "remove": {
                          "commands": {},
                          "flags": {
                            "--attestor": "value"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--attestor": "value",
                            "--comment": "value",
                            "--pgp-public-key-file": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--member": "value",
                        "--role": "dynamic"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {}
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--description": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "create-signature-payload": {
                  "commands": {},
                  "flags": {
                    "--artifact-url": "value"
                  }
                },
                "policy": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--member": "value",
                        "--role": "dynamic"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--platform": "value",
                        "--policy-file": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--platform": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--platform": "value"
                      }
                    },
                    "evaluate": {
                      "commands": {},
                      "flags": {
                        "--image": "value",
                        "--platform": "value",
                        "--resource": "value"
                      }
                    },
                    "export": {
                      "commands": {},
                      "flags": {}
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "import": {
                      "commands": {},
                      "flags": {
                        "--strict-validation": "bool"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--member": "value",
                        "--role": "dynamic"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {}
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--platform": "value",
                        "--policy-file": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "clusters": {
              "commands": {
                "check-autopilot-compatibility": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--additional-zones": "value",
                    "--additive-vpc-scope-dns-domain": "value",
                    "--addons": "value",
                    "--aggregation-ca": "value",
                    "--allow-route-overlap": "bool",
                    "--async": "bool",
                    "--auto-monitoring-scope": [
                      "ALL",
                      "NONE"
                    ],
                    "--autoprovisioning-config-file": "value",
                    "--autoprovisioning-enable-insecure-kubelet-readonly-port": "bool",
                    "--autoprovisioning-image-type": "value",
                    "--autoprovisioning-locations": "value",
                    "--autoprovisioning-max-surge-upgrade": "value",
                    "--autoprovisioning-max-unavailable-upgrade": "value",
                    "--autoprovisioning-min-cpu-platform": "value",
                    "--autoprovisioning-network-tags": "value",
                    "--autoprovisioning-node-pool-soak-duration": "value",
                    "--autoprovisioning-resource-manager-tags": "value",
                    "--autoprovisioning-scopes": "value",
                    "--autoprovisioning-service-account": "value",
                    "--autoprovisioning-standard-rollout-policy": "value",
                    "--autoscaling-profile": "value",
                    "--binauthz-evaluation-mode": [
                      "disabled",
                      "policy-bindings",
                      "policy-bindings-and-project-singleton-policy-enforce",
                      "project-singleton-policy-enforce"
                    ],
                    "--binauthz-policy-bindings": "value",
                    "--boot-disk-kms-key": "value",
                    "--cloud-run-config": "value",
                    "--cluster-ca": "value",
                    "--cluster-dns": [
                      "clouddns",
                      "default",
                      "kubedns"
                    ],
                    "--cluster-dns-domain": "value",
                    "--cluster-dns-scope": [
                      "cluster",
                      "vpc"
                    ],
                    "--cluster-ipv4-cidr": "value",
                    "--cluster-secondary-range-name": "value",
                    "--cluster-version": "value",
                    "--containerd-config-from-file": "value",
                    "--control-plane-disk-encryption-key": "value",
                    "--create-subnetwork": "value",
                    "--database-encryption-key": "value",
                    "--dataplane-v2-observability-mode": [
                      "DISABLED",
                      "EXTERNAL_LB",
                      "INTERNAL_VPC_LB"
                    ],
                    "--default-max-pods-per-node": "value",
                    "--disable-additive-vpc-scope": "bool",
                    "--disable-dataplane-v2-flow-observability": "bool",
                    "--disable-dataplane-v2-metrics": "bool",
                    "--disable-default-snat": "bool",
                    "--disable-l4-lb-firewall-reconciliation": "bool",
                    "--disable-pod-cidr-overprovision": "bool",
                    "--disk-size": "value",
                    "--disk-type": [
                      "hyperdisk-balanced",
                      "hyperdisk-extreme",
                      "hyperdisk-throughput",
                      "pd-balanced",
                      "pd-ssd",
                      "pd-standard"
                    ],
                    "--enable-authorized-networks-on-private-endpoint": "bool",
                    "--enable-autoprovisioning": "bool",
                    "--enable-autoprovisioning-autorepair": "bool",
                    "--enable-autoprovisioning-autoupgrade": "bool",
                    "--enable-autoprovisioning-blue-green-upgrade": "bool",
                    "--enable-autoprovisioning-surge-upgrade": "bool",
                    "--enable-autorepair": "bool",
                    "--enable-autoscaling": "bool",
                    "--enable-autoupgrade": "bool",
                    "--enable-basic-auth": "bool",
                    "--enable-binauthz": "bool",
                    "--enable-cilium-clusterwide-network-policy": "bool",
                    "--enable-cloud-logging": "bool",
                    "--enable-cloud-monitoring": "bool",
                    "--enable-cloud-run-alpha": "bool",
                    "--enable-confidential-nodes": "bool",
                    "--enable-confidential-storage": "bool",
                    "--enable-cost-allocation": "bool",
                    "--enable-dataplane-v2": "bool",
                    "--enable-dataplane-v2-flow-observability": "bool",
                    "--enable-dataplane-v2-metrics": "bool",
                    "--enable-dns-access": "bool",
                    "--enable-fleet": "bool",
                    "--enable-fqdn-network-policy": "bool",
                    "--enable-gke-oidc": "bool",
                    "--enable-google-cloud-access": "bool",
                    "--enable-gvnic": "bool",
                    "--enable-identity-service": "bool",
                    "--enable-image-streaming": "bool",
                    "--enable-insecure-binding-system-authenticated": "bool",
                    "--enable-insecure-binding-system-unauthenticated": "bool",
                    "--enable-insecure-kubelet-readonly-port": "bool",
                    "--enable-intra-node-visibility": "bool",
                    "--enable-ip-access": "bool",
                    "--enable-ip-alias": "bool",
                    "--enable-kubernetes-alpha": "bool",
                    "--enable-kubernetes-unstable-apis": "value",
                    "--enable-l4-ilb-subsetting": "bool",
                    "--enable-legacy-authorization": "bool",
                    "--enable-logging-monitoring-system-only": "bool",
                    "--enable-managed-prometheus": "bool",
                    "--enable-master-authorized-networks": "bool",
                    "--enable-master-global-access": "bool",
                    "--enable-multi-networking": "bool",
                    "--enable-nested-virtualization": "bool",
                    "--enable-network-egress-metering": "bool",
                    "--enable-network-policy": "bool",
                    "--enable-pod-security-policy": "bool",
                    "--enable-private-endpoint": "bool",
                    "--enable-private-nodes": "bool",
                    "--enable-ray-cluster-logging": "bool",
                    "--enable-ray-cluster-monitoring": "bool",
                    "--enable-resource-consumption-metering": "bool",
                    "--enable-secret-manager": "bool",
                    "--enable-service-externalips": "bool",
                    "--enable-shielded-nodes": "bool",
                    "--enable-stackdriver-kubernetes": "bool",
                    "--enable-tpu": "bool",
                    "--enable-tpu-service-networking": "bool",
                    "--enable-vertical-pod-autoscaling": "bool",
                    "--ephemeral-storage": "value",
                    "--ephemeral-storage-local-ssd": "value",
                    "--etcd-api-ca": "value",
                    "--etcd-peer-ca": "value",
                    "--fleet-project": "value",
                    "--gateway-api": [
                      "disabled",
                      "standard"
                    ],
                    "--gkeops-etcd-backup-encryption-key": "value",
                    "--hpa-profile": [
                      "none",
                      "performance"
                    ],
                    "--identity-provider": "value",
                    "--image-type": "value",
                    "--in-transit-encryption": [
                      "inter-node-transparent",
                      "none"
                    ],
                    "--ipv6-access-type": [
                      "external",
                      "internal"
                    ],
                    "--issue-client-certificate": "bool",
                    "--istio-config": "value",
                    "--labels": "value",
                    "--local-nvme-ssd-block": "value",
                    "--local-ssd-count": "value",
                    "--local-ssd-encryption-mode": [
                      "EPHEMERAL_KEY_ENCRYPTION",
                      "STANDARD_ENCRYPTION"
                    ],
                    "--location": "value",
                    "--location-policy": [
                      "ANY",
                      "BALANCED"
                    ],
                    "--logging": "value",
                    "--logging-variant": [
                      "DEFAULT",
                      "MAX_THROUGHPUT"
                    ],
                    "--machine-type": "value",
                    "--maintenance-window": "value",
                    "--maintenance-window-end": "value",
                    "--maintenance-window-recurrence": "value",
                    "--maintenance-window-start": "value",
                    "--master-authorized-networks": "value",
                    "--master-ipv4-cidr": "value",
                    "--max-accelerator": "value",
                    "--max-cpu": "value",
                    "--max-memory": "value",
                    "--max-nodes": "value",
                    "--max-nodes-per-pool": "value",
                    "--max-pods-per-node": "value",
                    "--max-surge-upgrade": "value",
                    "--max-unavailable-upgrade": "value",
                    "--metadata": "value",
                    "--metadata-from-file": "value",
                    "--min-accelerator": "value",
                    "--min-cpu": "value",
                    "--min-cpu-platform": "value",
                    "--min-memory": "value",
                    "--min-nodes": "value",
                    "--monitoring": "value",
                    "--network": "value",
                    "--network-performance-configs": "value",
                    "--node-labels": "value",
                    "--node-locations": "value",
                    "--node-taints": "value",
                    "--node-version": "value",
                    "--notification-config": "value",
                    "--num-nodes": "value",
                    "--password": "value",
                    "--placement-policy": "value",
                    "--placement-type": [
                      "COMPACT",
                      "UNSPECIFIED"
                    ],
                    "--preemptible": "bool",
                    "--private-cluster": "bool",
                    "--private-endpoint-subnetwork": "value",
                    "--private-ipv6-google-access-type": [
                      "bidirectional",
                      "disabled",
                      "outbound-only"
                    ],
                    "--region": "value",
                    "--release-channel": "value",
                    "--reservation": "value",
                    "--reservation-affinity": [
                      "any",
                      "none",
                      "specific"
                    ],
                    "--resource-manager-tags": "value",
                    "--resource-usage-bigquery-dataset": "value",
                    "--scopes": "value",
                    "--security-group": "value",
                    "--security-posture": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ],
                    "--service-account": "value",
                    "--service-account-signing-keys": "value",
                    "--service-account-verification-keys": "value",
                    "--services-ipv4-cidr": "value",
                    "--services-secondary-range-name": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-secure-boot": "bool",
                    "--spot": "bool",
                    "--stack-type": [
                      "ipv4",
                      "ipv4-ipv6"
                    ],
                    "--storage-pools": "value",
                    "--subnetwork": "value",
                    "--system-config-from-file": "value",
                    "--tags": "value",
                    "--threads-per-core": "value",
                    "--tier": [
                      "enterprise",
                      "standard"
                    ],
                    "--total-max-nodes": "value",
                    "--total-min-nodes": "value",
                    "--tpu-ipv4-cidr": "value",
                    "--username": "value",
                    "--workload-metadata": [
                      "EXPOSED",
                      "GCE_METADATA",
                      "GKE_METADATA",
                      "GKE_METADATA_SERVER",
                      "SECURE"
                    ],
                    "--workload-pool": "value",
                    "--workload-vulnerability-scanning": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ],
                    "--zone": "value"
                  }
                },
                "create-auto": {
                  "commands": {},
                  "flags": {
                    "--additive-vpc-scope-dns-domain": "value",
                    "--aggregation-ca": "value",
                    "--async": "bool",
                    "--auto-monitoring-scope": [
                      "ALL",
                      "NONE"
                    ],
                    "--autoprovisioning-enable-insecure-kubelet-readonly-port": "bool",
                    "--autoprovisioning-network-tags": "value",
                    "--autoprovisioning-resource-manager-tags": "value",
                    "--binauthz-evaluation-mode": [
                      "disabled",
                      "policy-bindings",
                      "policy-bindings-and-project-singleton-policy-enforce",
                      "project-singleton-policy-enforce"
                    ],
                    "--binauthz-policy-bindings": "value",
                    "--boot-disk-kms-key": "value",
                    "--cluster-ca": "value",
                    "--cluster-ipv4-cidr": "value",
                    "--cluster-secondary-range-name": "value",
                    "--cluster-version": "value",
                    "--containerd-config-from-file": "value",
                    "--control-plane-disk-encryption-key": "value",
                    "--create-subnetwork": "value",
                    "--database-encryption-key": "value",
                    "--dataplane-v2-observability-mode": [
                      "DISABLED",
                      "EXTERNAL_LB",
                      "INTERNAL_VPC_LB"
                    ],
                    "--disable-additive-vpc-scope": "bool",
                    "--disable-dataplane-v2-flow-observability": "bool",
                    "--disable-l4-lb-firewall-reconciliation": "bool",
                    "--enable-authorized-networks-on-private-endpoint": "bool",
                    "--enable-backup-restore": "bool",
                    "--enable-cilium-clusterwide-network-policy": "bool",
                    "--enable-dataplane-v2-flow-observability": "bool",
                    "--enable-dns-access": "bool",
                    "--enable-fleet": "bool",
                    "--enable-google-cloud-access": "bool",
                    "--enable-insecure-binding-system-authenticated": "bool",
                    "--enable-insecure-binding-system-unauthenticated": "bool",
                    "--enable-ip-access": "bool",
                    "--enable-kubernetes-unstable-apis": "value",
                    "--enable-master-authorized-networks": "bool",
                    "--enable-master-global-access": "bool",
                    "--enable-multi-networking": "bool",
                    "--enable-private-endpoint": "bool",
                    "--enable-private-nodes": "bool",
                    "--enable-ray-cluster-logging": "bool",
                    "--enable-ray-cluster-monitoring": "bool",
                    "--enable-ray-operator": "bool",
                    "--enable-secret-manager": "bool",
                    "--etcd-api-ca": "value",
                    "--etcd-peer-ca": "value",
                    "--fleet-project": "value",
                    "--gkeops-etcd-backup-encryption-key": "value",
                    "--hpa-profile": [
                      "none",
                      "performance"
                    ],
                    "--labels": "value",
                    "--location": "value",
                    "--logging": "value",
                    "--master-authorized-networks": "value",
                    "--master-ipv4-cidr": "value",
                    "--monitoring": "value",
                    "--network": "value",
                    "--private-endpoint-subnetwork": "value",
                    "--region": "value",
                    "--release-channel": "value",
                    "--scopes": "value",
                    "--security-group": "value",
                    "--security-posture": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ],
                    "--service-account": "value",
                    "--service-account-signing-keys": "value",
                    "--service-account-verification-keys": "value",
                    "--services-ipv4-cidr": "value",
                    "--services-secondary-range-name": "value",
                    "--subnetwork": "value",
                    "--tier": [
                      "enterprise",
                      "standard"
                    ],
                    "--workload-policies": "value",
                    "--workload-vulnerability-scanning": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ],
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "get-credentials": {
                  "commands": {},
                  "flags": {
                    "--dns-endpoint": "bool",
                    "--internal-ip": "bool",
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "get-upgrade-info": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "value"
                  }
                },
                "resize": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--node-pool": "value",
                    "--num-nodes": "value",
                    "--region": "value",
                    "--size": "value",
                    "--zone": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-maintenance-exclusion-end": "value",
                    "--add-maintenance-exclusion-name": "value",
                    "--add-maintenance-exclusion-scope": "value",
                    "--add-maintenance-exclusion-start": "value",
                    "--additional-pod-ipv4-ranges": "value",
                    "--additional-zones": "value",
                    "--additive-vpc-scope-dns-domain": "value",
                    "--async": "bool",
                    "--auto-monitoring-scope": [
                      "ALL",
                      "NONE"
                    ],
                    "--autoprovisioning-cgroup-mode": [
                      "default",
                      "v1",
                      "v2"
                    ],
                    "--autoprovisioning-config-file": "value",
                    "--autoprovisioning-enable-insecure-kubelet-readonly-port": "bool",
                    "--autoprovisioning-image-type": "value",
                    "--autoprovisioning-locations": "value",
                    "--autoprovisioning-max-surge-upgrade": "value",
                    "--autoprovisioning-max-unavailable-upgrade": "value",
                    "--autoprovisioning-min-cpu-platform": "value",
                    "--autoprovisioning-network-tags": "value",
                    "--autoprovisioning-node-pool-soak-duration": "value",
                    "--autoprovisioning-resource-manager-tags": "value",
                    "--autoprovisioning-scopes": "value",
                    "--autoprovisioning-service-account": "value",
                    "--autoprovisioning-standard-rollout-policy": "value",
                    "--autoscaling-profile": "value",
                    "--binauthz-evaluation-mode": [
                      "disabled",
                      "policy-bindings",
                      "policy-bindings-and-project-singleton-policy-enforce",
                      "project-singleton-policy-enforce"
                    ],
                    "--binauthz-policy-bindings": "value",
                    "--clear-fleet-project": "bool",
                    "--clear-maintenance-window": "bool",
                    "--clear-resource-usage-bigquery-dataset": "bool",
                    "--cloud-run-config": "value",
                    "--cluster-dns": [
                      "clouddns",
                      "default",
                      "kubedns"
                    ],
                    "--cluster-dns-domain": "value",
                    "--cluster-dns-scope": [
                      "cluster",
                      "vpc"
                    ],
                    "--complete-credential-rotation": "bool",
                    "--complete-ip-rotation": "bool",
                    "--containerd-config-from-file": "value",
                    "--database-encryption-key": "value",
                    "--dataplane-v2-observability-mode": [
                      "DISABLED",
                      "EXTERNAL_LB",
                      "INTERNAL_VPC_LB"
                    ],
                    "--disable-additive-vpc-scope": "bool",
                    "--disable-database-encryption": "bool",
                    "--disable-dataplane-v2-flow-observability": "bool",
                    "--disable-dataplane-v2-metrics": "bool",
                    "--disable-default-snat": "bool",
                    "--disable-l4-lb-firewall-reconciliation": "bool",
                    "--disable-managed-prometheus": "bool",
                    "--disable-workload-identity": "bool",
                    "--enable-authorized-networks-on-private-endpoint": "bool",
                    "--enable-autoprovisioning": "bool",
                    "--enable-autoprovisioning-autorepair": "bool",
                    "--enable-autoprovisioning-autoupgrade": "bool",
                    "--enable-autoprovisioning-blue-green-upgrade": "bool",
                    "--enable-autoprovisioning-surge-upgrade": "bool",
                    "--enable-autoscaling": "bool",
                    "--enable-basic-auth": "bool",
                    "--enable-binauthz": "bool",
                    "--enable-cilium-clusterwide-network-policy": "bool",
                    "--enable-cost-allocation": "bool",
                    "--enable-dataplane-v2-flow-observability": "bool",
                    "--enable-dataplane-v2-metrics": "bool",
                    "--enable-dns-access": "bool",
                    "--enable-fleet": "bool",
                    "--enable-fqdn-network-policy": "bool",
                    "--enable-gke-oidc": "bool",
                    "--enable-google-cloud-access": "bool",
                    "--enable-identity-service": "bool",
                    "--enable-image-streaming": "bool",
                    "--enable-insecure-binding-system-authenticated": "bool",
                    "--enable-insecure-binding-system-unauthenticated": "bool",
                    "--enable-insecure-kubelet-readonly-port": "bool",
                    "--enable-intra-node-visibility": "bool",
                    "--enable-ip-access": "bool",
                    "--enable-kubernetes-unstable-apis": "value",
                    "--enable-l4-ilb-subsetting": "bool",
                    "--enable-l4-lb-firewall-reconciliation": "bool",
                    "--enable-legacy-authorization": "bool",
                    "--enable-logging-monitoring-system-only": "bool",
                    "--enable-managed-prometheus": "bool",
                    "--enable-master-authorized-networks": "bool",
                    "--enable-master-global-access": "bool",
                    "--enable-multi-networking": "bool",
                    "--enable-network-egress-metering": "bool",
                    "--enable-network-policy": "bool",
                    "--enable-pod-security-policy": "bool",
                    "--enable-private-endpoint": "bool",
                    "--enable-private-nodes": "bool",
                    "--enable-ray-cluster-logging": "bool",
                    "--enable-ray-cluster-monitoring": "bool",
                    "--enable-resource-consumption-metering": "bool",
                    "--enable-secret-manager": "bool",
                    "--enable-service-externalips": "bool",
                    "--enable-shielded-nodes": "bool",
                    "--enable-stackdriver-kubernetes": "bool",
                    "--enable-tpu": "bool",
                    "--enable-tpu-service-networking": "bool",
                    "--enable-vertical-pod-autoscaling": "bool",
                    "--fleet-project": "value",
                    "--gateway-api": [
                      "disabled",
                      "standard"
                    ],
                    "--generate-password": "bool",
                    "--hpa-profile": [
                      "none",
                      "performance"
                    ],
                    "--identity-provider": "value",
                    "--in-transit-encryption": [
                      "inter-node-transparent",
                      "none"
                    ],
                    "--istio-config": "value",
                    "--location": "value",
                    "--location-policy": [
                      "ANY",
                      "BALANCED"
                    ],
                    "--logging": "value",
                    "--logging-service": "value",
                    "--logging-variant": [
                      "DEFAULT",
                      "MAX_THROUGHPUT"
                    ],
                    "--maintenance-window": "value",
                    "--maintenance-window-end": "value",
                    "--maintenance-window-recurrence": "value",
                    "--maintenance-window-start": "value",
                    "--master-authorized-networks": "value",
                    "--max-accelerator": "value",
                    "--max-cpu": "value",
                    "--max-memory": "value",
                    "--max-nodes": "value",
                    "--min-accelerator": "value",
                    "--min-cpu": "value",
                    "--min-memory": "value",
                    "--min-nodes": "value",
                    "--monitoring": "value",
                    "--monitoring-service": "value",
                    "--network-performance-configs": "value",
                    "--node-locations": "value",
                    "--node-pool": "value",
                    "--notification-config": "value",
                    "--password": "value",
                    "--private-ipv6-google-access-type": [
                      "bidirectional",
                      "disabled",
                      "outbound-only"
                    ],
                    "--region": "value",
                    "--release-channel": "value",
                    "--remove-additional-pod-ipv4-ranges": "value",
                    "--remove-labels": "value",
                    "--remove-maintenance-exclusion": "value",
                    "--remove-workload-policies": "value",
                    "--resource-usage-bigquery-dataset": "value",
                    "--security-group": "value",
                    "--security-posture": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ],
                    "--set-password": "bool",
                    "--stack-type": [
                      "ipv4",
                      "ipv4-ipv6"
                    ],
                    "--start-credential-rotation": "bool",
                    "--start-ip-rotation": "bool",
                    "--tier": [
                      "enterprise",
                      "standard"
                    ],
                    "--total-max-nodes": "value",
                    "--total-min-nodes": "value",
                    "--tpu-ipv4-cidr": "value",
                    "--update-addons": "value",
                    "--update-labels": "value",
                    "--username": "value",
                    "--workload-policies": "value",
                    "--workload-pool": "value",
                    "--workload-vulnerability-scanning": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ],
                    "--zone": "value"
                  }
                },
                "upgrade": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster-version": "value",
                    "--image-type": "value",
                    "--location": "value",
                    "--master": "bool",
                    "--node-pool": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                }
              },
              "flags": {
                "--location": "value",
                "--region": "value",
                "--zone": "value"
              }
            },
            "fleet": {
              "commands": {
                "cloudrun": {
                  "commands": {
                    "apply": {
                      "commands": {},
                      "flags": {
                        "--config": "value",
                        "--context": "value",
                        "--gke-cluster": "value",
                        "--gke-uri": "value",
                        "--kubeconfig": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "clusterupgrade": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--add-upgrade-soaking-override": "value",
                        "--default-upgrade-soaking": "value",
                        "--upgrade-selector": "value",
                        "--upstream-fleet": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--show-linked-cluster-upgrade": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--add-upgrade-soaking-override": "value",
                        "--default-upgrade-soaking": "value",
                        "--remove-upgrade-soaking-overrides": "bool",
                        "--reset-upstream-fleet": "bool",
                        "--upgrade-selector": "value",
                        "--upstream-fleet": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "config-management": {
                  "commands": {
                    "apply": {
                      "commands": {},
                      "flags": {
                        "--config": "value",
                        "--location": "value",
                        "--membership": "value",
                        "--origin": [
                          "FLEET"
                        ]
                      }
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--fleet-default-member-config": "bool",
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--fleet-default-member-config": "value"
                      }
                    },
                    "status": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "unmanage": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--membership": "value"
                      }
                    },
                    "upgrade": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--membership": "value"
                      }
                    },
                    "version": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--binauthz-evaluation-mode": [
                      "disabled",
                      "policy-bindings"
                    ],
                    "--binauthz-policy-bindings": "value",
                    "--display-name": "value",
                    "--labels": "value",
                    "--security-posture": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ],
                    "--workload-vulnerability-scanning": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ]
                  }
                },
                "dataplane-v2-encryption": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "features": {
                  "commands": {
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "fleetobservability": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {}
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--logging-config": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "identity-service": {
                  "commands": {
                    "apply": {
                      "commands": {},
                      "flags": {
                        "--config": "value",
                        "--fleet-default-member-config": "value",
                        "--location": "value",
                        "--membership": "value",
                        "--origin": [
                          "fleet"
                        ]
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--fleet-default-member-config": "bool",
                        "--location": "value",
                        "--membership": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--fleet-default-member-config": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "ingress": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--config-membership": "value",
                        "--location": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--config-membership": "value",
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "memberships": {
                  "commands": {
                    "bindings": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--labels": "value",
                            "--location": "value",
                            "--membership": "value",
                            "--scope": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--membership": "value"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--membership": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--location": "value",
                            "--membership": "value",
                            "--page-size": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--clear-labels": "bool",
                            "--location": "value",
                            "--membership": "value",
                            "--remove-labels": "value",
                            "--scope": "value",
                            "--update-labels": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "generate-gateway-rbac": {
                      "commands": {},
                      "flags": {
                        "--anthos-support": "bool",
                        "--apply": "bool",
                        "--context": "value",
                        "--groups": "value",
                        "--kubeconfig": "value",
                        "--membership": "value",
                        "--rbac-output-file": "value",
                        "--revoke": "bool",
                        "--role": "value",
                        "--users": "value"
                      }
                    },
                    "get-credentials": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "register": {
                      "commands": {},
                      "flags": {
                        "--context": "value",
                        "--enable-workload-identity": "bool",
                        "--gke-cluster": "value",
                        "--gke-uri": "value",
                        "--has-private-issuer": "bool",
                        "--install-connect-agent": "bool",
                        "--internal-ip": "bool",
                        "--kubeconfig": "value",
                        "--location": "value",
                        "--manifest-output-file": "value",
                        "--proxy": "value",
                        "--public-issuer-url": "value",
                        "--service-account-key-file": "value"
                      }
                    },
                    "support-access": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value"
                          }
                        },
                        "disable": {
                          "commands": {},
                          "flags": {
                            "--location": "value"
                          }
                        },
                        "enable": {
                          "commands": {},
                          "flags": {
                            "--location": "value"
                          }
                        },
                        "get-yaml": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--rbac-output-file": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "unregister": {
                      "commands": {},
                      "flags": {
                        "--context": "value",
                        "--gke-cluster": "value",
                        "--gke-uri": "value",
                        "--kubeconfig": "value",
                        "--location": "value",
                        "--uninstall-connect-agent": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--location": "value",
                        "--remove-labels": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "mesh": {
                  "commands": {
                    "debug": {
                      "commands": {
                        "bug-report": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--membership": "value"
                          }
                        },
                        "proxy-config": {
                          "commands": {},
                          "flags": {
                            "--fqdn": "value",
                            "--location": "value",
                            "--membership": "value",
                            "--output": [
                              "json",
                              "yaml"
                            ],
                            "--type": [
                              "bootstrap",
                              "cluster",
                              "clusters",
                              "endpoint",
                              "endpoints",
                              "listener",
                              "listeners",
                              "log",
                              "route",
                              "routes",
                              "secret",
                              "secrets"
                            ]
                          }
                        },
                        "proxy-status": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--membership": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--fleet-default-member-config": "bool",
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--fleet-default-member-config": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--control-plane": [
                          "automatic",
                          "manual",
                          "unspecified"
                        ],
                        "--fleet-default-member-config": "value",
                        "--location": "value",
                        "--management": [
                          "automatic",
                          "manual"
                        ],
                        "--memberships": "value",
                        "--origin": [
                          "fleet"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "multi-cluster-services": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "wait": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "policycontroller": {
                  "commands": {
                    "content": {
                      "commands": {
                        "bundles": {
                          "commands": {
                            "remove": {
                              "commands": {},
                              "flags": {
                                "--all-memberships": "bool",
                                "--location": "value",
                                "--memberships": "value"
                              }
                            },
                            "set": {
                              "commands": {},
                              "flags": {
                                "--all-memberships": "bool",
                                "--exempted-namespaces": "value",
                                "--location": "value",
                                "--memberships": "value",
                                "--no-exempted-namespaces": "bool"
                              }
                            }
                          },
                          "flags": {}
                        },
                        "templates": {
                          "commands": {
                            "disable": {
                              "commands": {},
                              "flags": {
                                "--all-memberships": "bool",
                                "--location": "value",
                                "--memberships": "value"
                              }
                            },
                            "enable": {
                              "commands": {},
                              "flags": {
                                "--all-memberships": "bool",
                                "--location": "value",
                                "--memberships": "value"
                              }
                            }
                          },
                          "flags": {}
                        }
                      },
                      "flags": {}
                    },
                    "deployment": {
                      "commands": {
                        "remove": {
                          "commands": {},
                          "flags": {
                            "--all-memberships": "bool",
                            "--effect": [
                              "NoExecute",
                              "NoSchedule",
                              "PreferNoSchedule"
                            ],
                            "--location": "value",
                            "--memberships": "value"
                          }
                        },
                        "set": {
                          "commands": {},
                          "flags": {
                            "--all-memberships": "bool",
                            "--effect": [
                              "NoExecute",
                              "NoSchedule",
                              "PreferNoSchedule"
                            ],
                            "--location": "value",
                            "--memberships": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--location": "value",
                        "--memberships": "value"
                      }
                    },
                    "detach": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--location": "value",
                        "--memberships": "value"
                      }
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--fleet-default-member-config": "bool",
                        "--location": "value",
                        "--memberships": "value"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--audit-interval": "value",
                        "--clear-exemptable-namespaces": "bool",
                        "--constraint-violation-limit": "value",
                        "--exemptable-namespaces": "value",
                        "--fleet-default-member-config": "value",
                        "--location": "value",
                        "--log-denies": "bool",
                        "--memberships": "value",
                        "--monitoring": "value",
                        "--mutation": "bool",
                        "--no-content": "bool",
                        "--no-default-bundles": "bool",
                        "--no-fleet-default-member-config": "bool",
                        "--no-log-denies": "bool",
                        "--no-monitoring": "bool",
                        "--no-mutation": "bool",
                        "--no-referential-rules": "bool",
                        "--referential-rules": "bool"
                      }
                    },
                    "suspend": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--location": "value",
                        "--memberships": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--audit-interval": "value",
                        "--clear-exemptable-namespaces": "bool",
                        "--constraint-violation-limit": "value",
                        "--exemptable-namespaces": "value",
                        "--location": "value",
                        "--log-denies": "bool",
                        "--memberships": "value",
                        "--monitoring": "value",
                        "--mutation": "bool",
                        "--no-log-denies": "bool",
                        "--no-monitoring": "bool",
                        "--no-mutation": "bool",
                        "--no-referential-rules": "bool",
                        "--origin": [
                          "FLEET"
                        ],
                        "--referential-rules": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "scopes": {
                  "commands": {
                    "add-app-operator-binding": {
                      "commands": {},
                      "flags": {
                        "--group": "value",
                        "--labels": "value",
                        "--role": [
                          "admin",
                          "edit",
                          "view"
                        ],
                        "--user": "value"
                      }
                    },
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--member": "value",
                        "--role": "dynamic"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--labels": "value",
                        "--namespace-labels": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "list-app-operator-bindings": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "list-memberships": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "namespaces": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--labels": "value",
                            "--namespace-labels": "value",
                            "--scope": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--scope": "value"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--scope": "value"
                          }
                        },
                        "get-credentials": {
                          "commands": {},
                          "flags": {
                            "--membership": "value",
                            "--membership-location": "value",
                            "--set-namespace-in-config": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--scope": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--clear-labels": "bool",
                            "--clear-namespace-labels": "bool",
                            "--remove-labels": "value",
                            "--remove-namespace-labels": "value",
                            "--scope": "value",
                            "--update-labels": "value",
                            "--update-namespace-labels": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "rbacrolebindings": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--group": "value",
                            "--labels": "value",
                            "--location": "value",
                            "--role": [
                              "admin",
                              "edit",
                              "view"
                            ],
                            "--scope": "value",
                            "--user": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--scope": "value"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--scope": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--scope": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--clear-labels": "bool",
                            "--group": "value",
                            "--location": "value",
                            "--remove-labels": "value",
                            "--role": [
                              "admin",
                              "edit",
                              "view"
                            ],
                            "--scope": "value",
                            "--update-labels": "value",
                            "--user": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "remove-app-operator-binding": {
                      "commands": {},
                      "flags": {
                        "--group": "value",
                        "--user": "value"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--member": "value",
                        "--role": "dynamic"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--add-upgrade-soaking-override": "value",
                        "--clear-labels": "bool",
                        "--clear-namespace-labels": "bool",
                        "--default-upgrade-soaking": "value",
                        "--location": "value",
                        "--remove-labels": "value",
                        "--remove-namespace-labels": "value",
                        "--remove-upgrade-soaking-overrides": "bool",
                        "--reset-upstream-scope": "bool",
                        "--update-labels": "value",
                        "--update-namespace-labels": "value",
                        "--upgrade-selector": "value",
                        "--upstream-scope": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--binauthz-evaluation-mode": [
                      "disabled",
                      "policy-bindings"
                    ],
                    "--binauthz-policy-bindings": "value",
                    "--clear-labels": "bool",
                    "--display-name": "value",
                    "--remove-labels": "value",
                    "--security-posture": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ],
                    "--update-labels": "value",
                    "--workload-vulnerability-scanning": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "get-server-config": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--region": "value",
                "--sort-by": "value",
                "--zone": "value"
              }
            },
            "hub": {
              "commands": {
                "cloudrun": {
                  "commands": {
                    "apply": {
                      "commands": {},
                      "flags": {
                        "--config": "value",
                        "--context": "value",
                        "--gke-cluster": "value",
                        "--gke-uri": "value",
                        "--kubeconfig": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "clusterupgrade": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--add-upgrade-soaking-override": "value",
                        "--default-upgrade-soaking": "value",
                        "--upgrade-selector": "value",
                        "--upstream-fleet": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--show-linked-cluster-upgrade": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--add-upgrade-soaking-override": "value",
                        "--default-upgrade-soaking": "value",
                        "--remove-upgrade-soaking-overrides": "bool",
                        "--reset-upstream-fleet": "bool",
                        "--upgrade-selector": "value",
                        "--upstream-fleet": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "config-management": {
                  "commands": {
                    "apply": {
                      "commands": {},
                      "flags": {
                        "--config": "value",
                        "--location": "value",
                        "--membership": "value",
                        "--origin": [
                          "FLEET"
                        ]
                      }
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--fleet-default-member-config": "bool",
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--fleet-default-member-config": "value"
                      }
                    },
                    "status": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "unmanage": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--membership": "value"
                      }
                    },
                    "upgrade": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--membership": "value"
                      }
                    },
                    "version": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--binauthz-evaluation-mode": [
                      "disabled",
                      "policy-bindings"
                    ],
                    "--binauthz-policy-bindings": "value",
                    "--display-name": "value",
                    "--labels": "value",
                    "--security-posture": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ],
                    "--workload-vulnerability-scanning": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ]
                  }
                },
                "dataplane-v2-encryption": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "features": {
                  "commands": {
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "fleetobservability": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {}
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--logging-config": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "identity-service": {
                  "commands": {
                    "apply": {
                      "commands": {},
                      "flags": {
                        "--config": "value",
                        "--fleet-default-member-config": "value",
                        "--location": "value",
                        "--membership": "value",
                        "--origin": [
                          "fleet"
                        ]
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--fleet-default-member-config": "bool",
                        "--location": "value",
                        "--membership": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--fleet-default-member-config": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "ingress": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--config-membership": "value",
                        "--location": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--config-membership": "value",
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "memberships": {
                  "commands": {
                    "bindings": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--labels": "value",
                            "--location": "value",
                            "--membership": "value",
                            "--scope": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--membership": "value"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--membership": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--location": "value",
                            "--membership": "value",
                            "--page-size": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--clear-labels": "bool",
                            "--location": "value",
                            "--membership": "value",
                            "--remove-labels": "value",
                            "--scope": "value",
                            "--update-labels": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "generate-gateway-rbac": {
                      "commands": {},
                      "flags": {
                        "--anthos-support": "bool",
                        "--apply": "bool",
                        "--context": "value",
                        "--groups": "value",
                        "--kubeconfig": "value",
                        "--membership": "value",
                        "--rbac-output-file": "value",
                        "--revoke": "bool",
                        "--role": "value",
                        "--users": "value"
                      }
                    },
                    "get-credentials": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "register": {
                      "commands": {},
                      "flags": {
                        "--context": "value",
                        "--enable-workload-identity": "bool",
                        "--gke-cluster": "value",
                        "--gke-uri": "value",
                        "--has-private-issuer": "bool",
                        "--install-connect-agent": "bool",
                        "--internal-ip": "bool",
                        "--kubeconfig": "value",
                        "--location": "value",
                        "--manifest-output-file": "value",
                        "--proxy": "value",
                        "--public-issuer-url": "value",
                        "--service-account-key-file": "value"
                      }
                    },
                    "support-access": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value"
                          }
                        },
                        "disable": {
                          "commands": {},
                          "flags": {
                            "--location": "value"
                          }
                        },
                        "enable": {
                          "commands": {},
                          "flags": {
                            "--location": "value"
                          }
                        },
                        "get-yaml": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--rbac-output-file": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "unregister": {
                      "commands": {},
                      "flags": {
                        "--context": "value",
                        "--gke-cluster": "value",
                        "--gke-uri": "value",
                        "--kubeconfig": "value",
                        "--location": "value",
                        "--uninstall-connect-agent": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--location": "value",
                        "--remove-labels": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "mesh": {
                  "commands": {
                    "debug": {
                      "commands": {
                        "bug-report": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--membership": "value"
                          }
                        },
                        "proxy-config": {
                          "commands": {},
                          "flags": {
                            "--fqdn": "value",
                            "--location": "value",
                            "--membership": "value",
                            "--output": [
                              "json",
                              "yaml"
                            ],
                            "--type": [
                              "bootstrap",
                              "cluster",
                              "clusters",
                              "endpoint",
                              "endpoints",
                              "listener",
                              "listeners",
                              "log",
                              "route",
                              "routes",
                              "secret",
                              "secrets"
                            ]
                          }
                        },
                        "proxy-status": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--membership": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--fleet-default-member-config": "bool",
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--fleet-default-member-config": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--control-plane": [
                          "automatic",
                          "manual",
                          "unspecified"
                        ],
                        "--fleet-default-member-config": "value",
                        "--location": "value",
                        "--management": [
                          "automatic",
                          "manual"
                        ],
                        "--memberships": "value",
                        "--origin": [
                          "fleet"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "multi-cluster-services": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--force": "bool"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "wait": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "policycontroller": {
                  "commands": {
                    "content": {
                      "commands": {
                        "bundles": {
                          "commands": {
                            "remove": {
                              "commands": {},
                              "flags": {
                                "--all-memberships": "bool",
                                "--location": "value",
                                "--memberships": "value"
                              }
                            },
                            "set": {
                              "commands": {},
                              "flags": {
                                "--all-memberships": "bool",
                                "--exempted-namespaces": "value",
                                "--location": "value",
                                "--memberships": "value",
                                "--no-exempted-namespaces": "bool"
                              }
                            }
                          },
                          "flags": {}
                        },
                        "templates": {
                          "commands": {
                            "disable": {
                              "commands": {},
                              "flags": {
                                "--all-memberships": "bool",
                                "--location": "value",
                                "--memberships": "value"
                              }
                            },
                            "enable": {
                              "commands": {},
                              "flags": {
                                "--all-memberships": "bool",
                                "--location": "value",
                                "--memberships": "value"
                              }
                            }
                          },
                          "flags": {}
                        }
                      },
                      "flags": {}
                    },
                    "deployment": {
                      "commands": {
                        "remove": {
                          "commands": {},
                          "flags": {
                            "--all-memberships": "bool",
                            "--effect": [
                              "NoExecute",
                              "NoSchedule",
                              "PreferNoSchedule"
                            ],
                            "--location": "value",
                            "--memberships": "value"
                          }
                        },
                        "set": {
                          "commands": {},
                          "flags": {
                            "--all-memberships": "bool",
                            "--effect": [
                              "NoExecute",
                              "NoSchedule",
                              "PreferNoSchedule"
                            ],
                            "--location": "value",
                            "--memberships": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--location": "value",
                        "--memberships": "value"
                      }
                    },
                    "detach": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--location": "value",
                        "--memberships": "value"
                      }
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--fleet-default-member-config": "bool",
                        "--location": "value",
                        "--memberships": "value"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--audit-interval": "value",
                        "--clear-exemptable-namespaces": "bool",
                        "--constraint-violation-limit": "value",
                        "--exemptable-namespaces": "value",
                        "--fleet-default-member-config": "value",
                        "--location": "value",
                        "--log-denies": "bool",
                        "--memberships": "value",
                        "--monitoring": "value",
                        "--mutation": "bool",
                        "--no-content": "bool",
                        "--no-default-bundles": "bool",
                        "--no-fleet-default-member-config": "bool",
                        "--no-log-denies": "bool",
                        "--no-monitoring": "bool",
                        "--no-mutation": "bool",
                        "--no-referential-rules": "bool",
                        "--referential-rules": "bool"
                      }
                    },
                    "suspend": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--location": "value",
                        "--memberships": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--audit-interval": "value",
                        "--clear-exemptable-namespaces": "bool",
                        "--constraint-violation-limit": "value",
                        "--exemptable-namespaces": "value",
                        "--location": "value",
                        "--log-denies": "bool",
                        "--memberships": "value",
                        "--monitoring": "value",
                        "--mutation": "bool",
                        "--no-log-denies": "bool",
                        "--no-monitoring": "bool",
                        "--no-mutation": "bool",
                        "--no-referential-rules": "bool",
                        "--origin": [
                          "FLEET"
                        ],
                        "--referential-rules": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "scopes": {
                  "commands": {
                    "add-app-operator-binding": {
                      "commands": {},
                      "flags": {
                        "--group": "value",
                        "--labels": "value",
                        "--role": [
                          "admin",
                          "edit",
                          "view"
                        ],
                        "--user": "value"
                      }
                    },
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--member": "value",
                        "--role": "dynamic"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--labels": "value",
                        "--namespace-labels": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "list-app-operator-bindings": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "list-memberships": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "namespaces": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--labels": "value",
                            "--namespace-labels": "value",
                            "--scope": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--scope": "value"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--scope": "value"
                          }
                        },
                        "get-credentials": {
                          "commands": {},
                          "flags": {
                            "--membership": "value",
                            "--membership-location": "value",
                            "--set-namespace-in-config": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--scope": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--clear-labels": "bool",
                            "--clear-namespace-labels": "bool",
                            "--remove-labels": "value",
                            "--remove-namespace-labels": "value",
                            "--scope": "value",
                            "--update-labels": "value",
                            "--update-namespace-labels": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "rbacrolebindings": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--group": "value",
                            "--labels": "value",
                            "--location": "value",
                            "--role": [
                              "admin",
                              "edit",
                              "view"
                            ],
                            "--scope": "value",
                            "--user": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--scope": "value"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--scope": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--scope": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--clear-labels": "bool",
                            "--group": "value",
                            "--location": "value",
                            "--remove-labels": "value",
                            "--role": [
                              "admin",
                              "edit",
                              "view"
                            ],
                            "--scope": "value",
                            "--update-labels": "value",
                            "--user": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "remove-app-operator-binding": {
                      "commands": {},
                      "flags": {
                        "--group": "value",
                        "--user": "value"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--member": "value",
                        "--role": "dynamic"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--add-upgrade-soaking-override": "value",
                        "--clear-labels": "bool",
                        "--clear-namespace-labels": "bool",
                        "--default-upgrade-soaking": "value",
                        "--location": "value",
                        "--remove-labels": "value",
                        "--remove-namespace-labels": "value",
                        "--remove-upgrade-soaking-overrides": "bool",
                        "--reset-upstream-scope": "bool",
                        "--update-labels": "value",
                        "--update-namespace-labels": "value",
                        "--upgrade-selector": "value",
                        "--upstream-scope": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--binauthz-evaluation-mode": [
                      "disabled",
                      "policy-bindings"
                    ],
                    "--binauthz-policy-bindings": "value",
                    "--clear-labels": "bool",
                    "--display-name": "value",
                    "--remove-labels": "value",
                    "--security-posture": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ],
                    "--update-labels": "value",
                    "--workload-vulnerability-scanning": [
                      "disabled",
                      "enterprise",
                      "standard"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "images": {
              "commands": {
                "add-tag": {
                  "commands": {},
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--force-delete-tags": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--metadata-filter": "value",
                    "--show-all-metadata": "bool",
                    "--show-build-details": "bool",
                    "--show-deployment": "bool",
                    "--show-image-basis": "bool",
                    "--show-package-vulnerability": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--repository": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-tags": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--occurrence-filter": "value",
                    "--page-size": "value",
                    "--show-occurrences": "bool",
                    "--show-occurrences-from": "value",
                    "--sort-by": "value"
                  }
                },
                "untag": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "node-pools": {
              "commands": {
                "complete-upgrade": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--additional-node-network": "value",
                    "--additional-pod-network": "value",
                    "--async": "bool",
                    "--boot-disk-kms-key": "value",
                    "--cluster": "value",
                    "--containerd-config-from-file": "value",
                    "--create-pod-ipv4-range": "value",
                    "--disable-pod-cidr-overprovision": "bool",
                    "--disk-size": "value",
                    "--disk-type": [
                      "hyperdisk-balanced",
                      "hyperdisk-extreme",
                      "hyperdisk-throughput",
                      "pd-balanced",
                      "pd-ssd",
                      "pd-standard"
                    ],
                    "--enable-autoprovisioning": "bool",
                    "--enable-autorepair": "bool",
                    "--enable-autoscaling": "bool",
                    "--enable-autoupgrade": "bool",
                    "--enable-best-effort-provision": "bool",
                    "--enable-blue-green-upgrade": "bool",
                    "--enable-confidential-nodes": "bool",
                    "--enable-confidential-storage": "bool",
                    "--enable-gvnic": "bool",
                    "--enable-image-streaming": "bool",
                    "--enable-insecure-kubelet-readonly-port": "bool",
                    "--enable-nested-virtualization": "bool",
                    "--enable-private-nodes": "bool",
                    "--enable-queued-provisioning": "bool",
                    "--enable-surge-upgrade": "bool",
                    "--ephemeral-storage": "value",
                    "--ephemeral-storage-local-ssd": "value",
                    "--image-type": "value",
                    "--labels": "value",
                    "--local-nvme-ssd-block": "value",
                    "--local-ssd-count": "value",
                    "--local-ssd-encryption-mode": [
                      "EPHEMERAL_KEY_ENCRYPTION",
                      "STANDARD_ENCRYPTION"
                    ],
                    "--location": "value",
                    "--location-policy": [
                      "ANY",
                      "BALANCED"
                    ],
                    "--logging-variant": [
                      "DEFAULT",
                      "MAX_THROUGHPUT"
                    ],
                    "--machine-type": "value",
                    "--max-nodes": "value",
                    "--max-pods-per-node": "value",
                    "--max-run-duration": "value",
                    "--max-surge-upgrade": "value",
                    "--max-unavailable-upgrade": "value",
                    "--metadata": "value",
                    "--metadata-from-file": "value",
                    "--min-cpu-platform": "value",
                    "--min-nodes": "value",
                    "--min-provision-nodes": "value",
                    "--network-performance-configs": "value",
                    "--node-group": "value",
                    "--node-labels": "value",
                    "--node-locations": "value",
                    "--node-pool-soak-duration": "value",
                    "--node-taints": "value",
                    "--node-version": "value",
                    "--num-nodes": "value",
                    "--placement-policy": "value",
                    "--placement-type": [
                      "COMPACT",
                      "UNSPECIFIED"
                    ],
                    "--pod-ipv4-range": "value",
                    "--preemptible": "bool",
                    "--region": "value",
                    "--reservation": "value",
                    "--reservation-affinity": [
                      "any",
                      "none",
                      "specific"
                    ],
                    "--resource-manager-tags": "value",
                    "--sandbox": "value",
                    "--scopes": "value",
                    "--secondary-boot-disk": "value",
                    "--service-account": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-secure-boot": "bool",
                    "--sole-tenant-node-affinity-file": "value",
                    "--spot": "bool",
                    "--standard-rollout-policy": "value",
                    "--storage-pools": "value",
                    "--system-config-from-file": "value",
                    "--tags": "value",
                    "--threads-per-core": "value",
                    "--total-max-nodes": "value",
                    "--total-min-nodes": "value",
                    "--tpu-topology": "value",
                    "--windows-os-version": [
                      "ltsc2019",
                      "ltsc2022"
                    ],
                    "--workload-metadata": [
                      "EXPOSED",
                      "GCE_METADATA",
                      "GKE_METADATA",
                      "GKE_METADATA_SERVER",
                      "SECURE"
                    ],
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster": "value",
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "get-upgrade-info": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "value"
                  }
                },
                "rollback": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster": "value",
                    "--location": "value",
                    "--region": "value",
                    "--respect-pdb": "value",
                    "--zone": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--async": "bool",
                    "--cluster": "value",
                    "--containerd-config-from-file": "value",
                    "--disk-size": "value",
                    "--disk-type": [
                      "hyperdisk-balanced",
                      "hyperdisk-extreme",
                      "hyperdisk-throughput",
                      "pd-balanced",
                      "pd-ssd",
                      "pd-standard"
                    ],
                    "--enable-autoprovisioning": "bool",
                    "--enable-autorepair": "bool",
                    "--enable-autoscaling": "bool",
                    "--enable-autoupgrade": "bool",
                    "--enable-blue-green-upgrade": "bool",
                    "--enable-confidential-nodes": "bool",
                    "--enable-gvnic": "bool",
                    "--enable-image-streaming": "bool",
                    "--enable-insecure-kubelet-readonly-port": "bool",
                    "--enable-private-nodes": "bool",
                    "--enable-queued-provisioning": "bool",
                    "--enable-surge-upgrade": "bool",
                    "--labels": "value",
                    "--location": "value",
                    "--location-policy": [
                      "ANY",
                      "BALANCED"
                    ],
                    "--logging-variant": [
                      "DEFAULT",
                      "MAX_THROUGHPUT"
                    ],
                    "--machine-type": "value",
                    "--max-nodes": "value",
                    "--max-run-duration": "value",
                    "--max-surge-upgrade": "value",
                    "--max-unavailable-upgrade": "value",
                    "--min-nodes": "value",
                    "--network-performance-configs": "value",
                    "--node-labels": "value",
                    "--node-locations": "value",
                    "--node-pool-soak-duration": "value",
                    "--node-taints": "value",
                    "--region": "value",
                    "--resource-manager-tags": "value",
                    "--standard-rollout-policy": "value",
                    "--storage-pools": "value",
                    "--system-config-from-file": "value",
                    "--tags": "value",
                    "--total-max-nodes": "value",
                    "--total-min-nodes": "value",
                    "--windows-os-version": [
                      "ltsc2019",
                      "ltsc2022"
                    ],
                    "--workload-metadata": [
                      "EXPOSED",
                      "GCE_METADATA",
                      "GKE_METADATA",
                      "GKE_METADATA_SERVER",
                      "SECURE"
                    ],
                    "--zone": "value"
                  }
                }
              },
              "flags": {
                "--location": "value",
                "--region": "value",
                "--zone": "value"
              }
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--zone": "value"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                }
              },
              "flags": {
                "--location": "value",
                "--region": "value",
                "--zone": "value"
              }
            },
            "subnets": {
              "commands": {
                "list-usable": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--network-project": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "vmware": {
              "commands": {
                "admin-clusters": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "enroll": {
                      "commands": {},
                      "flags": {
                        "--admin-cluster-membership": "value",
                        "--admin-cluster-membership-location": "value",
                        "--async": "bool",
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "unenroll": {
                      "commands": {},
                      "flags": {
                        "--allow-missing": "bool",
                        "--async": "bool",
                        "--location": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--required-platform-version": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "clusters": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--admin-cluster-membership": "value",
                        "--admin-cluster-membership-location": "value",
                        "--admin-cluster-membership-project": "value",
                        "--admin-users": "value",
                        "--annotations": "value",
                        "--async": "bool",
                        "--control-plane-ip-block": "value",
                        "--control-plane-node-port": "value",
                        "--control-plane-vip": "value",
                        "--cpus": "value",
                        "--description": "value",
                        "--disable-aag-config": "bool",
                        "--disable-control-plane-v2": "bool",
                        "--disable-vsphere-csi": "bool",
                        "--dns-search-domains": "value",
                        "--dns-servers": "value",
                        "--enable-advanced-networking": "bool",
                        "--enable-auto-repair": "bool",
                        "--enable-auto-resize": "bool",
                        "--enable-control-plane-v2": "bool",
                        "--enable-dataplane-v2": "bool",
                        "--enable-dhcp": "bool",
                        "--enable-vm-tracking": "bool",
                        "--f5-config-address": "value",
                        "--f5-config-partition": "value",
                        "--f5-config-snat-pool": "value",
                        "--ingress-http-node-port": "value",
                        "--ingress-https-node-port": "value",
                        "--ingress-vip": "value",
                        "--konnectivity-server-node-port": "value",
                        "--location": "value",
                        "--memory": "value",
                        "--metal-lb-config-address-pools": "value",
                        "--ntp-servers": "value",
                        "--pod-address-cidr-blocks": "value",
                        "--replicas": "value",
                        "--service-address-cidr-blocks": "value",
                        "--static-ip-config-ip-blocks": "value",
                        "--upgrade-policy": "value",
                        "--validate-only": "bool",
                        "--vcenter-ca-cert-data": "value",
                        "--vcenter-cluster": "value",
                        "--vcenter-datacenter": "value",
                        "--vcenter-datastore": "value",
                        "--vcenter-folder": "value",
                        "--vcenter-resource-pool": "value",
                        "--vcenter-storage-policy-name": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--allow-missing": "bool",
                        "--async": "bool",
                        "--force": "bool",
                        "--ignore-errors": "bool",
                        "--location": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "enroll": {
                      "commands": {},
                      "flags": {
                        "--admin-cluster-membership": "value",
                        "--admin-cluster-membership-location": "value",
                        "--admin-cluster-membership-project": "value",
                        "--async": "bool",
                        "--local-name": "value",
                        "--location": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "query-version-config": {
                      "commands": {},
                      "flags": {
                        "--admin-cluster-membership": "value",
                        "--admin-cluster-membership-location": "value",
                        "--admin-cluster-membership-project": "value",
                        "--cluster": "value",
                        "--location": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--add-annotations": "value",
                        "--admin-users": "value",
                        "--async": "bool",
                        "--cpus": "value",
                        "--description": "value",
                        "--disable-aag-config": "bool",
                        "--disable-auto-repair": "bool",
                        "--disable-auto-resize": "bool",
                        "--disable-vsphere-csi": "bool",
                        "--enable-aag-config": "bool",
                        "--enable-auto-repair": "bool",
                        "--enable-auto-resize": "bool",
                        "--enable-vsphere-csi": "bool",
                        "--location": "value",
                        "--memory": "value",
                        "--metal-lb-config-address-pools": "value",
                        "--remove-annotations": "value",
                        "--static-ip-config-ip-blocks": "value",
                        "--upgrade-policy": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "upgrade": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "node-pools": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--annotations": "value",
                        "--async": "bool",
                        "--boot-disk-size": "value",
                        "--cluster": "value",
                        "--cpus": "value",
                        "--display-name": "value",
                        "--enable-load-balancer": "bool",
                        "--image": "value",
                        "--image-type": "value",
                        "--location": "value",
                        "--max-replicas": "value",
                        "--memory": "value",
                        "--min-replicas": "value",
                        "--node-labels": "value",
                        "--node-taints": "value",
                        "--replicas": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--allow-missing": "bool",
                        "--async": "bool",
                        "--cluster": "value",
                        "--ignore-errors": "bool",
                        "--location": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--cluster": "value",
                        "--location": "value"
                      }
                    },
                    "enroll": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--cluster": "value",
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--cluster": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--boot-disk-size": "value",
                        "--cluster": "value",
                        "--cpus": "value",
                        "--disable-load-balancer": "bool",
                        "--display-name": "value",
                        "--enable-load-balancer": "bool",
                        "--image": "value",
                        "--image-type": "value",
                        "--location": "value",
                        "--max-replicas": "value",
                        "--memory": "value",
                        "--min-replicas": "value",
                        "--node-labels": "value",
                        "--node-taints": "value",
                        "--replicas": "value",
                        "--validate-only": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "wait": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "data-catalog": {
          "commands": {
            "entries": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--entry-group": "value",
                    "--gcs-file-patterns": "value",
                    "--location": "value",
                    "--schema": "value",
                    "--schema-from-file": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--entry-group": "value",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--entry-group": "value",
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--entry-group": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "lookup": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-file-patterns": "value",
                    "--clear-file-patterns": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--entry-group": "value",
                    "--location": "value",
                    "--lookup-entry": "value",
                    "--remove-file-patterns": "value",
                    "--schema": "value",
                    "--schema-from-file": "value"
                  }
                }
              },
              "flags": {}
            },
            "entry-groups": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "search": {
              "commands": {},
              "flags": {
                "--include-gcp-public-datasets": "bool",
                "--include-organization-ids": "value",
                "--include-project-ids": "value",
                "--limit": "value",
                "--order-by": "value",
                "--page-size": "value",
                "--restricted-locations": "value"
              }
            },
            "tag-templates": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--display-name": "value",
                    "--field": "value",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--force": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "fields": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--display-name": "value",
                        "--location": "value",
                        "--tag-template": "value",
                        "--type": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--force": "bool",
                        "--location": "value",
                        "--tag-template": "value"
                      }
                    },
                    "enum-values": {
                      "commands": {
                        "rename": {
                          "commands": {},
                          "flags": {
                            "--field": "value",
                            "--location": "value",
                            "--new-id": "value",
                            "--tag-template": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "rename": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--new-id": "value",
                        "--tag-template": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--display-name": "value",
                        "--enum-values": "value",
                        "--location": "value",
                        "--required": "bool",
                        "--tag-template": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--display-name": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "tags": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--entry": "value",
                    "--entry-group": "value",
                    "--location": "value",
                    "--scope": "value",
                    "--tag-file": "value",
                    "--tag-template": "value",
                    "--tag-template-location": "value",
                    "--tag-template-project": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--entry": "value",
                    "--entry-group": "value",
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--entry": "value",
                    "--entry-group": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--entry": "value",
                    "--entry-group": "value",
                    "--location": "value",
                    "--tag-file": "value",
                    "--tag-template": "value",
                    "--tag-template-location": "value",
                    "--tag-template-project": "value"
                  }
                }
              },
              "flags": {}
            },
            "taxonomies": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "policy-tags": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--member": "value",
                        "--role": "dynamic",
                        "--taxonomy": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--taxonomy": "value"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--taxonomy": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--taxonomy": "value",
                        "--uri": "bool"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--member": "value",
                        "--role": "dynamic",
                        "--taxonomy": "value"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--taxonomy": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "data-fusion": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--namespace": "value",
                "--role": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--namespace": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "instances": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--edition": [
                      "basic",
                      "developer",
                      "enterprise"
                    ],
                    "--enable_rbac": "bool",
                    "--enable_stackdriver_logging": "bool",
                    "--enable_stackdriver_monitoring": "bool",
                    "--labels": "value",
                    "--location": "value",
                    "--maintenance-window-end": "value",
                    "--maintenance-window-recurrence": "value",
                    "--maintenance-window-start": "value",
                    "--options": "value",
                    "--patch_revision": "value",
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "restart": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-maintenance-window": "bool",
                    "--enable_rbac": "bool",
                    "--enable_stackdriver_logging": "bool",
                    "--enable_stackdriver_monitoring": "bool",
                    "--labels": "value",
                    "--location": "value",
                    "--maintenance-window-end": "value",
                    "--maintenance-window-recurrence": "value",
                    "--maintenance-window-start": "value",
                    "--options": "value",
                    "--patch_revision": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--namespace": "value",
                "--role": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--namespace": "value"
              }
            }
          },
          "flags": {}
        },
        "dataflow": {
          "commands": {
            "flex-template": {
              "commands": {
                "build": {
                  "commands": {},
                  "flags": {
                    "--additional-experiments": "value",
                    "--additional-user-labels": "value",
                    "--dataflow-kms-key": "value",
                    "--disable-public-ips": "bool",
                    "--enable-streaming-engine": "bool",
                    "--env": "value",
                    "--flex-template-base-image": "value",
                    "--gcs-log-dir": "value",
                    "--go-binary-path": "value",
                    "--image": "value",
                    "--image-gcr-path": "value",
                    "--image-repository-cert-path": "value",
                    "--image-repository-password-secret-id": "value",
                    "--image-repository-username-secret-id": "value",
                    "--jar": "value",
                    "--max-workers": "value",
                    "--metadata-file": "value",
                    "--network": "value",
                    "--num-workers": "value",
                    "--print-only": "bool",
                    "--py-path": "value",
                    "--sdk-language": [
                      "GO",
                      "JAVA",
                      "PYTHON"
                    ],
                    "--service-account-email": "value",
                    "--staging-location": "value",
                    "--subnetwork": "value",
                    "--temp-location": "value",
                    "--worker-machine-type": "value",
                    "--worker-region": "value",
                    "--worker-zone": "value"
                  }
                },
                "run": {
                  "commands": {},
                  "flags": {
                    "--additional-experiments": "value",
                    "--additional-user-labels": "value",
                    "--dataflow-kms-key": "value",
                    "--disable-public-ips": "bool",
                    "--enable-streaming-engine": "bool",
                    "--flexrs-goal": [
                      "COST_OPTIMIZED",
                      "SPEED_OPTIMIZED"
                    ],
                    "--launcher-machine-type": "value",
                    "--max-workers": "value",
                    "--network": "value",
                    "--num-workers": "value",
                    "--parameters": "value",
                    "--region": "value",
                    "--service-account-email": "value",
                    "--staging-location": "value",
                    "--subnetwork": "value",
                    "--temp-location": "value",
                    "--template-file-gcs-location": "value",
                    "--transform-name-mappings": "value",
                    "--update": "bool",
                    "--worker-machine-type": "value",
                    "--worker-region": "value",
                    "--worker-zone": "value"
                  }
                }
              },
              "flags": {}
            },
            "jobs": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--force": "bool",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--full": "bool",
                    "--region": "value"
                  }
                },
                "drain": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "export-steps": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--created-after": "value",
                    "--created-before": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--status": [
                      "active",
                      "all",
                      "terminated"
                    ],
                    "--uri": "bool"
                  }
                },
                "run": {
                  "commands": {},
                  "flags": {
                    "--additional-experiments": "value",
                    "--dataflow-kms-key": "value",
                    "--disable-public-ips": "bool",
                    "--enable-streaming-engine": "bool",
                    "--gcs-location": "value",
                    "--max-workers": "value",
                    "--network": "value",
                    "--num-workers": "value",
                    "--parameters": "value",
                    "--region": "value",
                    "--service-account-email": "value",
                    "--staging-location": "value",
                    "--subnetwork": "value",
                    "--worker-machine-type": "value",
                    "--worker-region": "value",
                    "--worker-zone": "value",
                    "--zone": "value"
                  }
                },
                "show": {
                  "commands": {},
                  "flags": {
                    "--environment": "bool",
                    "--region": "value",
                    "--steps": "bool"
                  }
                },
                "update-options": {
                  "commands": {},
                  "flags": {
                    "--max-num-workers": "value",
                    "--min-num-workers": "value",
                    "--region": "value",
                    "--unset-worker-utilization-hint": "bool",
                    "--worker-utilization-hint": "value"
                  }
                }
              },
              "flags": {}
            },
            "logs": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--after": "value",
                    "--before": "value",
                    "--filter": "value",
                    "--importance": [
                      "debug",
                      "detailed",
                      "error",
                      "warning"
                    ],
                    "--limit": "value",
                    "--region": "value"
                  }
                }
              },
              "flags": {}
            },
            "metrics": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--changed-after": "value",
                    "--filter": "value",
                    "--hide-committed": "bool",
                    "--limit": "value",
                    "--region": "value",
                    "--source": [
                      "all",
                      "service",
                      "user"
                    ],
                    "--tentative": "bool",
                    "--transform": "value"
                  }
                }
              },
              "flags": {}
            },
            "snapshots": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--job-id": "value",
                    "--region": "value",
                    "--snapshot-sources": "value",
                    "--snapshot-ttl": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--job-id": "value",
                    "--region": "value"
                  }
                }
              },
              "flags": {}
            },
            "sql": {
              "commands": {
                "query": {
                  "commands": {},
                  "flags": {
                    "--bigquery-dataset": "value",
                    "--bigquery-project": "value",
                    "--bigquery-table": "value",
                    "--bigquery-write-disposition": [
                      "write-append",
                      "write-empty",
                      "write-truncate"
                    ],
                    "--dataflow-kms-key": "value",
                    "--disable-public-ips": "bool",
                    "--dry-run": "bool",
                    "--job-name": "value",
                    "--max-workers": "value",
                    "--network": "value",
                    "--num-workers": "value",
                    "--parameter": "value",
                    "--parameters-file": "value",
                    "--pubsub-create-disposition": [
                      "create-if-not-found",
                      "fail-if-not-found"
                    ],
                    "--pubsub-project": "value",
                    "--pubsub-topic": "value",
                    "--region": "value",
                    "--service-account-email": "value",
                    "--subnetwork": "value",
                    "--worker-machine-type": "value",
                    "--worker-region": "value",
                    "--worker-zone": "value",
                    "--zone": "value"
                  }
                }
              },
              "flags": {}
            },
            "yaml": {
              "commands": {
                "run": {
                  "commands": {},
                  "flags": {
                    "--jinja-variables": "value",
                    "--pipeline-options": "value",
                    "--region": "value",
                    "--yaml-pipeline": "value",
                    "--yaml-pipeline-file": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "datapipelines": {
          "commands": {
            "pipeline": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--additional-experiments": "value",
                    "--additional-user-labels": "value",
                    "--dataflow-kms-key": "value",
                    "--dataflow-service-account-email": "value",
                    "--disable-public-ips": "bool",
                    "--display-name": "value",
                    "--enable-streaming-engine": "bool",
                    "--flexrs-goal": [
                      "COST_OPTIMIZED",
                      "SPEED_OPTIMIZED"
                    ],
                    "--max-workers": "value",
                    "--network": "value",
                    "--num-workers": "value",
                    "--parameters": "value",
                    "--pipeline-type": [
                      "batch",
                      "streaming"
                    ],
                    "--region": "value",
                    "--schedule": "value",
                    "--scheduler-service-account-email": "value",
                    "--subnetwork": "value",
                    "--temp-location": "value",
                    "--template-file-gcs-location": "value",
                    "--template-type": [
                      "classic",
                      "flex"
                    ],
                    "--time-zone": "value",
                    "--transform-name-mappings": "value",
                    "--update": "bool",
                    "--worker-machine-type": "value",
                    "--worker-region": "value",
                    "--worker-zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "job": {
                  "commands": {
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--pipeline": "dynamic",
                        "--region": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "run": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "stop": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--additional-experiments": "value",
                    "--additional-user-labels": "value",
                    "--dataflow-kms-key": "value",
                    "--dataflow-service-account-email": "value",
                    "--disable-public-ips": "bool",
                    "--display-name": "value",
                    "--enable-streaming-engine": "bool",
                    "--flexrs-goal": [
                      "COST_OPTIMIZED",
                      "SPEED_OPTIMIZED"
                    ],
                    "--max-workers": "value",
                    "--network": "value",
                    "--num-workers": "value",
                    "--parameters": "value",
                    "--region": "value",
                    "--schedule": "value",
                    "--scheduler-service-account-email": "value",
                    "--subnetwork": "value",
                    "--temp-location": "value",
                    "--template-file-gcs-location": "value",
                    "--template-type": [
                      "classic",
                      "flex"
                    ],
                    "--time-zone": "value",
                    "--transform-name-mappings": "value",
                    "--update": "bool",
                    "--worker-machine-type": "value",
                    "--worker-region": "value",
                    "--worker-zone": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "dataproc": {
          "commands": {
            "autoscaling-policies": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--region": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--region": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                }
              },
              "flags": {}
            },
            "batches": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "submit": {
                  "commands": {
                    "pyspark": {
                      "commands": {},
                      "flags": {
                        "--archives": "value",
                        "--async": "bool",
                        "--batch": "value",
                        "--container-image": "value",
                        "--deps-bucket": "value",
                        "--files": "value",
                        "--history-server-cluster": "value",
                        "--jars": "value",
                        "--kms-key": "value",
                        "--labels": "value",
                        "--metastore-service": "value",
                        "--network": "value",
                        "--properties": "value",
                        "--py-files": "value",
                        "--region": "value",
                        "--request-id": "value",
                        "--service-account": "value",
                        "--staging-bucket": "value",
                        "--subnet": "value",
                        "--tags": "value",
                        "--ttl": "value",
                        "--version": "value"
                      }
                    },
                    "spark": {
                      "commands": {},
                      "flags": {
                        "--archives": "value",
                        "--async": "bool",
                        "--batch": "value",
                        "--class": "value",
                        "--container-image": "value",
                        "--deps-bucket": "value",
                        "--files": "value",
                        "--history-server-cluster": "value",
                        "--jar": "value",
                        "--jars": "value",
                        "--kms-key": "value",
                        "--labels": "value",
                        "--metastore-service": "value",
                        "--network": "value",
                        "--properties": "value",
                        "--region": "value",
                        "--request-id": "value",
                        "--service-account": "value",
                        "--staging-bucket": "value",
                        "--subnet": "value",
                        "--tags": "value",
                        "--ttl": "value",
                        "--version": "value"
                      }
                    },
                    "spark-r": {
                      "commands": {},
                      "flags": {
                        "--archives": "value",
                        "--async": "bool",
                        "--batch": "value",
                        "--container-image": "value",
                        "--deps-bucket": "value",
                        "--files": "value",
                        "--history-server-cluster": "value",
                        "--kms-key": "value",
                        "--labels": "value",
                        "--metastore-service": "value",
                        "--network": "value",
                        "--properties": "value",
                        "--region": "value",
                        "--request-id": "value",
                        "--service-account": "value",
                        "--staging-bucket": "value",
                        "--subnet": "value",
                        "--tags": "value",
                        "--ttl": "value",
                        "--version": "value"
                      }
                    },
                    "spark-sql": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--batch": "value",
                        "--container-image": "value",
                        "--deps-bucket": "value",
                        "--history-server-cluster": "value",
                        "--jars": "value",
                        "--kms-key": "value",
                        "--labels": "value",
                        "--metastore-service": "value",
                        "--network": "value",
                        "--properties": "value",
                        "--region": "value",
                        "--request-id": "value",
                        "--service-account": "value",
                        "--staging-bucket": "value",
                        "--subnet": "value",
                        "--tags": "value",
                        "--ttl": "value",
                        "--vars": "value",
                        "--version": "value"
                      }
                    }
                  },
                  "flags": {
                    "--async": "bool",
                    "--batch": "value",
                    "--container-image": "value",
                    "--history-server-cluster": "value",
                    "--kms-key": "value",
                    "--labels": "value",
                    "--metastore-service": "value",
                    "--network": "value",
                    "--properties": "value",
                    "--region": "value",
                    "--request-id": "value",
                    "--service-account": "value",
                    "--staging-bucket": "value",
                    "--subnet": "value",
                    "--tags": "value",
                    "--ttl": "value"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                }
              },
              "flags": {}
            },
            "clusters": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--autoscaling-policy": "value",
                    "--bucket": "value",
                    "--dataproc-metastore": "value",
                    "--driver-pool-accelerator": "value",
                    "--driver-pool-boot-disk-size": "value",
                    "--driver-pool-boot-disk-type": "value",
                    "--driver-pool-id": "value",
                    "--driver-pool-local-ssd-interface": "value",
                    "--driver-pool-machine-type": "value",
                    "--driver-pool-min-cpu-platform": "value",
                    "--driver-pool-size": "value",
                    "--enable-component-gateway": "bool",
                    "--enable-kerberos": "bool",
                    "--expiration-time": "value",
                    "--gce-pd-kms-key": "dynamic",
                    "--gce-pd-kms-key-keyring": "dynamic",
                    "--gce-pd-kms-key-location": "dynamic",
                    "--gce-pd-kms-key-project": "dynamic",
                    "--image": "value",
                    "--image-version": "value",
                    "--initialization-action-timeout": "value",
                    "--initialization-actions": "value",
                    "--kerberos-config-file": "value",
                    "--kerberos-kms-key": "dynamic",
                    "--kerberos-kms-key-keyring": "dynamic",
                    "--kerberos-kms-key-location": "dynamic",
                    "--kerberos-kms-key-project": "dynamic",
                    "--kerberos-root-principal-password-uri": "value",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--master-accelerator": "value",
                    "--master-boot-disk-provisioned-iops": "value",
                    "--master-boot-disk-provisioned-throughput": "value",
                    "--master-boot-disk-size": "value",
                    "--master-boot-disk-type": "value",
                    "--master-local-ssd-interface": "value",
                    "--master-machine-type": "value",
                    "--master-min-cpu-platform": "value",
                    "--max-age": "value",
                    "--max-idle": "value",
                    "--metadata": "value",
                    "--min-num-workers": "value",
                    "--min-secondary-worker-fraction": "value",
                    "--network": "value",
                    "--no-address": "bool",
                    "--node-group": "value",
                    "--num-driver-pool-local-ssds": "value",
                    "--num-master-local-ssds": "value",
                    "--num-masters": "value",
                    "--num-secondary-worker-local-ssds": "value",
                    "--num-secondary-workers": "value",
                    "--num-worker-local-ssds": "value",
                    "--num-workers": "value",
                    "--optional-components": "value",
                    "--private-ipv6-google-access-type": [
                      "bidirectional",
                      "inherit-subnetwork",
                      "outbound"
                    ],
                    "--properties": "value",
                    "--public-ip-address": "bool",
                    "--region": "value",
                    "--reservation": "value",
                    "--reservation-affinity": [
                      "any",
                      "none",
                      "specific"
                    ],
                    "--scopes": "value",
                    "--secondary-worker-accelerator": "value",
                    "--secondary-worker-boot-disk-size": "value",
                    "--secondary-worker-boot-disk-type": "value",
                    "--secondary-worker-local-ssd-interface": "value",
                    "--secondary-worker-machine-types": "value",
                    "--secondary-worker-standard-capacity-base": "value",
                    "--secondary-worker-standard-capacity-percent-above-base": "value",
                    "--secondary-worker-type": [
                      "non-preemptible",
                      "preemptible",
                      "spot"
                    ],
                    "--service-account": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-secure-boot": "bool",
                    "--shielded-vtpm": "bool",
                    "--single-node": "bool",
                    "--subnet": "value",
                    "--tags": "value",
                    "--temp-bucket": "value",
                    "--worker-accelerator": "value",
                    "--worker-boot-disk-provisioned-iops": "value",
                    "--worker-boot-disk-provisioned-throughput": "value",
                    "--worker-boot-disk-size": "value",
                    "--worker-boot-disk-type": "value",
                    "--worker-local-ssd-interface": "value",
                    "--worker-machine-type": "value",
                    "--worker-machine-types": "value",
                    "--worker-min-cpu-platform": "value",
                    "--zone": "value"
                  }
                },
                "create-from-file": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--file": "value",
                    "--region": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "diagnose": {
                  "commands": {},
                  "flags": {
                    "--end-time": "value",
                    "--job-ids": "value",
                    "--region": "value",
                    "--start-time": "value",
                    "--tarball-access": [
                      "GOOGLE_CLOUD_SUPPORT",
                      "GOOGLE_DATAPROC_DIAGNOSE"
                    ],
                    "--yarn-application-ids": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--region": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "gke": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--gke-cluster": "value",
                        "--gke-cluster-location": "value",
                        "--history-server-cluster": "value",
                        "--history-server-cluster-region": "value",
                        "--metastore-service": "value",
                        "--metastore-service-location": "value",
                        "--namespace": "value",
                        "--pools": "value",
                        "--properties": "value",
                        "--region": "value",
                        "--setup-workload-identity": "bool",
                        "--spark-engine-version": "value",
                        "--staging-bucket": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "start": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "stop": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--autoscaling-policy": "value",
                    "--clear-labels": "bool",
                    "--disable-autoscaling": "bool",
                    "--expiration-time": "value",
                    "--graceful-decommission-timeout": "value",
                    "--max-age": "value",
                    "--max-idle": "value",
                    "--min-secondary-worker-fraction": "value",
                    "--no-max-age": "bool",
                    "--no-max-idle": "bool",
                    "--num-secondary-workers": "value",
                    "--num-workers": "value",
                    "--region": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "jobs": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "kill": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--state-filter": [
                      "active",
                      "inactive"
                    ]
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "submit": {
                  "commands": {
                    "flink": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bucket": "value",
                        "--class": "value",
                        "--cluster": "value",
                        "--cluster-labels": "value",
                        "--driver-log-levels": "value",
                        "--driver-required-memory-mb": "value",
                        "--driver-required-vcores": "value",
                        "--jar": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--max-failures-per-hour": "value",
                        "--max-failures-total": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value",
                        "--savepoint": "value"
                      }
                    },
                    "hadoop": {
                      "commands": {},
                      "flags": {
                        "--archives": "value",
                        "--async": "bool",
                        "--bucket": "value",
                        "--class": "value",
                        "--cluster": "value",
                        "--cluster-labels": "value",
                        "--driver-log-levels": "value",
                        "--driver-required-memory-mb": "value",
                        "--driver-required-vcores": "value",
                        "--files": "value",
                        "--jar": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--max-failures-per-hour": "value",
                        "--max-failures-total": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value"
                      }
                    },
                    "hive": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bucket": "value",
                        "--cluster": "value",
                        "--cluster-labels": "value",
                        "--continue-on-failure": "bool",
                        "--driver-required-memory-mb": "value",
                        "--driver-required-vcores": "value",
                        "--execute": "value",
                        "--file": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--max-failures-per-hour": "value",
                        "--max-failures-total": "value",
                        "--params": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value"
                      }
                    },
                    "pig": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bucket": "value",
                        "--cluster": "value",
                        "--cluster-labels": "value",
                        "--continue-on-failure": "bool",
                        "--driver-log-levels": "value",
                        "--driver-required-memory-mb": "value",
                        "--driver-required-vcores": "value",
                        "--execute": "value",
                        "--file": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--max-failures-per-hour": "value",
                        "--max-failures-total": "value",
                        "--params": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value"
                      }
                    },
                    "presto": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bucket": "value",
                        "--client-tags": "value",
                        "--cluster": "value",
                        "--cluster-labels": "value",
                        "--continue-on-failure": "bool",
                        "--driver-log-levels": "value",
                        "--driver-required-memory-mb": "value",
                        "--driver-required-vcores": "value",
                        "--execute": "value",
                        "--file": "value",
                        "--labels": "value",
                        "--max-failures-per-hour": "value",
                        "--max-failures-total": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--query-output-format": "value",
                        "--region": "value"
                      }
                    },
                    "pyspark": {
                      "commands": {},
                      "flags": {
                        "--archives": "value",
                        "--async": "bool",
                        "--bucket": "value",
                        "--cluster": "value",
                        "--cluster-labels": "value",
                        "--driver-log-levels": "value",
                        "--driver-required-memory-mb": "value",
                        "--driver-required-vcores": "value",
                        "--files": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--max-failures-per-hour": "value",
                        "--max-failures-total": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--py-files": "value",
                        "--region": "value"
                      }
                    },
                    "spark": {
                      "commands": {},
                      "flags": {
                        "--archives": "value",
                        "--async": "bool",
                        "--bucket": "value",
                        "--class": "value",
                        "--cluster": "value",
                        "--cluster-labels": "value",
                        "--driver-log-levels": "value",
                        "--driver-required-memory-mb": "value",
                        "--driver-required-vcores": "value",
                        "--files": "value",
                        "--jar": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--max-failures-per-hour": "value",
                        "--max-failures-total": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value"
                      }
                    },
                    "spark-r": {
                      "commands": {},
                      "flags": {
                        "--archives": "value",
                        "--async": "bool",
                        "--bucket": "value",
                        "--cluster": "value",
                        "--cluster-labels": "value",
                        "--driver-log-levels": "value",
                        "--driver-required-memory-mb": "value",
                        "--driver-required-vcores": "value",
                        "--files": "value",
                        "--labels": "value",
                        "--max-failures-per-hour": "value",
                        "--max-failures-total": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value"
                      }
                    },
                    "spark-sql": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bucket": "value",
                        "--cluster": "value",
                        "--cluster-labels": "value",
                        "--driver-log-levels": "value",
                        "--driver-required-memory-mb": "value",
                        "--driver-required-vcores": "value",
                        "--execute": "value",
                        "--file": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--max-failures-per-hour": "value",
                        "--max-failures-total": "value",
                        "--params": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value"
                      }
                    },
                    "trino": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bucket": "value",
                        "--client-tags": "value",
                        "--cluster": "value",
                        "--cluster-labels": "value",
                        "--continue-on-failure": "bool",
                        "--driver-log-levels": "value",
                        "--driver-required-memory-mb": "value",
                        "--driver-required-vcores": "value",
                        "--execute": "value",
                        "--file": "value",
                        "--labels": "value",
                        "--max-failures-per-hour": "value",
                        "--max-failures-total": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--query-output-format": "value",
                        "--region": "value"
                      }
                    }
                  },
                  "flags": {
                    "--async": "bool",
                    "--bucket": "value",
                    "--region": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--region": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                }
              },
              "flags": {}
            },
            "node-groups": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--region": "value"
                  }
                },
                "resize": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--graceful-decommission-timeout": "value",
                    "--region": "value",
                    "--size": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--state-filter": [
                      "active",
                      "inactive"
                    ]
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                }
              },
              "flags": {}
            },
            "session-templates": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "sessions": {
              "commands": {
                "create": {
                  "commands": {
                    "spark": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--container-image": "value",
                        "--history-server-cluster": "value",
                        "--kernel": [
                          "python",
                          "scala"
                        ],
                        "--kms-key": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--max-idle": "value",
                        "--metastore-service": "value",
                        "--network": "value",
                        "--property": "value",
                        "--request-id": "value",
                        "--service-account": "value",
                        "--session_template": "value",
                        "--staging-bucket": "value",
                        "--subnet": "value",
                        "--tags": "value",
                        "--ttl": "value",
                        "--version": "value"
                      }
                    }
                  },
                  "flags": {
                    "--async": "bool",
                    "--container-image": "value",
                    "--history-server-cluster": "value",
                    "--kernel": [
                      "python",
                      "scala"
                    ],
                    "--kms-key": "value",
                    "--labels": "value",
                    "--max-idle": "value",
                    "--metastore-service": "value",
                    "--network": "value",
                    "--property": "value",
                    "--request-id": "value",
                    "--service-account": "value",
                    "--session_template": "value",
                    "--staging-bucket": "value",
                    "--subnet": "value",
                    "--tags": "value",
                    "--ttl": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "terminate": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "workflow-templates": {
              "commands": {
                "add-job": {
                  "commands": {
                    "hadoop": {
                      "commands": {},
                      "flags": {
                        "--archives": "value",
                        "--class": "value",
                        "--driver-log-levels": "value",
                        "--files": "value",
                        "--jar": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value",
                        "--start-after": "value",
                        "--step-id": "value",
                        "--workflow-template": "value"
                      }
                    },
                    "hive": {
                      "commands": {},
                      "flags": {
                        "--continue-on-failure": "bool",
                        "--execute": "value",
                        "--file": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--params": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value",
                        "--start-after": "value",
                        "--step-id": "value",
                        "--workflow-template": "value"
                      }
                    },
                    "pig": {
                      "commands": {},
                      "flags": {
                        "--continue-on-failure": "bool",
                        "--driver-log-levels": "value",
                        "--execute": "value",
                        "--file": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--params": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value",
                        "--start-after": "value",
                        "--step-id": "value",
                        "--workflow-template": "value"
                      }
                    },
                    "presto": {
                      "commands": {},
                      "flags": {
                        "--client-tags": "value",
                        "--continue-on-failure": "bool",
                        "--driver-log-levels": "value",
                        "--execute": "value",
                        "--file": "value",
                        "--labels": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--query-output-format": "value",
                        "--region": "value",
                        "--start-after": "value",
                        "--step-id": "value",
                        "--workflow-template": "value"
                      }
                    },
                    "pyspark": {
                      "commands": {},
                      "flags": {
                        "--archives": "value",
                        "--driver-log-levels": "value",
                        "--files": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--py-files": "value",
                        "--region": "value",
                        "--start-after": "value",
                        "--step-id": "value",
                        "--workflow-template": "value"
                      }
                    },
                    "spark": {
                      "commands": {},
                      "flags": {
                        "--archives": "value",
                        "--class": "value",
                        "--driver-log-levels": "value",
                        "--files": "value",
                        "--jar": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value",
                        "--start-after": "value",
                        "--step-id": "value",
                        "--workflow-template": "value"
                      }
                    },
                    "spark-r": {
                      "commands": {},
                      "flags": {
                        "--archives": "value",
                        "--driver-log-levels": "value",
                        "--files": "value",
                        "--labels": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value",
                        "--start-after": "value",
                        "--step-id": "value",
                        "--workflow-template": "value"
                      }
                    },
                    "spark-sql": {
                      "commands": {},
                      "flags": {
                        "--driver-log-levels": "value",
                        "--execute": "value",
                        "--file": "value",
                        "--jars": "value",
                        "--labels": "value",
                        "--params": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--region": "value",
                        "--start-after": "value",
                        "--step-id": "value",
                        "--workflow-template": "value"
                      }
                    },
                    "trino": {
                      "commands": {},
                      "flags": {
                        "--client-tags": "value",
                        "--continue-on-failure": "bool",
                        "--driver-log-levels": "value",
                        "--execute": "value",
                        "--file": "value",
                        "--labels": "value",
                        "--properties": "value",
                        "--properties-file": "value",
                        "--query-output-format": "value",
                        "--region": "value",
                        "--start-after": "value",
                        "--step-id": "value",
                        "--workflow-template": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--dag-timeout": "value",
                    "--kms-key": "value",
                    "--labels": "value",
                    "--region": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--region": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--region": "value",
                    "--source": "value"
                  }
                },
                "instantiate": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--parameters": "value",
                    "--region": "value"
                  }
                },
                "instantiate-from-file": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--file": "value",
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-dag-timeout": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "remove-job": {
                  "commands": {},
                  "flags": {
                    "--region": "value",
                    "--step-id": "value"
                  }
                },
                "run": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "set-cluster-selector": {
                  "commands": {},
                  "flags": {
                    "--cluster-labels": "value",
                    "--region": "value"
                  }
                },
                "set-dag-timeout": {
                  "commands": {},
                  "flags": {
                    "--dag-timeout": "value",
                    "--region": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "set-managed-cluster": {
                  "commands": {},
                  "flags": {
                    "--autoscaling-policy": "value",
                    "--bucket": "value",
                    "--cluster-name": "value",
                    "--dataproc-metastore": "value",
                    "--enable-component-gateway": "bool",
                    "--enable-kerberos": "bool",
                    "--image": "value",
                    "--image-version": "value",
                    "--initialization-action-timeout": "value",
                    "--initialization-actions": "value",
                    "--kerberos-config-file": "value",
                    "--kerberos-kms-key": "dynamic",
                    "--kerberos-kms-key-keyring": "dynamic",
                    "--kerberos-kms-key-location": "dynamic",
                    "--kerberos-kms-key-project": "dynamic",
                    "--kerberos-root-principal-password-uri": "value",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--master-accelerator": "value",
                    "--master-boot-disk-provisioned-iops": "value",
                    "--master-boot-disk-provisioned-throughput": "value",
                    "--master-boot-disk-size": "value",
                    "--master-boot-disk-type": "value",
                    "--master-local-ssd-interface": "value",
                    "--master-machine-type": "value",
                    "--master-min-cpu-platform": "value",
                    "--metadata": "value",
                    "--min-num-workers": "value",
                    "--min-secondary-worker-fraction": "value",
                    "--network": "value",
                    "--no-address": "bool",
                    "--node-group": "value",
                    "--num-master-local-ssds": "value",
                    "--num-masters": "value",
                    "--num-secondary-worker-local-ssds": "value",
                    "--num-secondary-workers": "value",
                    "--num-worker-local-ssds": "value",
                    "--num-workers": "value",
                    "--optional-components": "value",
                    "--private-ipv6-google-access-type": [
                      "bidirectional",
                      "inherit-subnetwork",
                      "outbound"
                    ],
                    "--properties": "value",
                    "--public-ip-address": "bool",
                    "--region": "value",
                    "--reservation": "value",
                    "--reservation-affinity": [
                      "any",
                      "none",
                      "specific"
                    ],
                    "--scopes": "value",
                    "--secondary-worker-accelerator": "value",
                    "--secondary-worker-boot-disk-size": "value",
                    "--secondary-worker-boot-disk-type": "value",
                    "--secondary-worker-local-ssd-interface": "value",
                    "--secondary-worker-machine-types": "value",
                    "--secondary-worker-standard-capacity-base": "value",
                    "--secondary-worker-standard-capacity-percent-above-base": "value",
                    "--secondary-worker-type": [
                      "non-preemptible",
                      "preemptible",
                      "spot"
                    ],
                    "--service-account": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-secure-boot": "bool",
                    "--shielded-vtpm": "bool",
                    "--single-node": "bool",
                    "--subnet": "value",
                    "--tags": "value",
                    "--temp-bucket": "value",
                    "--worker-accelerator": "value",
                    "--worker-boot-disk-provisioned-iops": "value",
                    "--worker-boot-disk-provisioned-throughput": "value",
                    "--worker-boot-disk-size": "value",
                    "--worker-boot-disk-type": "value",
                    "--worker-local-ssd-interface": "value",
                    "--worker-machine-type": "value",
                    "--worker-machine-types": "value",
                    "--worker-min-cpu-platform": "value",
                    "--zone": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "datastore": {
          "commands": {
            "export": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--kinds": "value",
                "--namespaces": "value",
                "--operation-labels": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--kinds": "value",
                "--namespaces": "value",
                "--operation-labels": "value"
              }
            },
            "indexes": {
              "commands": {
                "cleanup": {
                  "commands": {},
                  "flags": {
                    "--database": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--database": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "datastream": {
          "commands": {
            "connection-profiles": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--bucket-name": "value",
                    "--ca-certificate": "value",
                    "--client-certificate": "value",
                    "--client-key": "value",
                    "--database-service": "value",
                    "--display-name": "value",
                    "--forward-ssh-hostname": "value",
                    "--forward-ssh-password": "value",
                    "--forward-ssh-port": "value",
                    "--forward-ssh-private-key": "value",
                    "--forward-ssh-username": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--mysql-hostname": "value",
                    "--mysql-password": "value",
                    "--mysql-port": "value",
                    "--mysql-prompt-for-password": "bool",
                    "--mysql-username": "value",
                    "--no-connectivity": "bool",
                    "--oracle-hostname": "value",
                    "--oracle-password": "value",
                    "--oracle-port": "value",
                    "--oracle-prompt-for-password": "bool",
                    "--oracle-username": "value",
                    "--postgresql-ca-certificate": "value",
                    "--postgresql-client-certificate": "value",
                    "--postgresql-client-key": "value",
                    "--postgresql-database": "value",
                    "--postgresql-hostname": "value",
                    "--postgresql-password": "value",
                    "--postgresql-port": "value",
                    "--postgresql-prompt-for-password": "bool",
                    "--postgresql-username": "value",
                    "--private-connection-name": "value",
                    "--root-path": "value",
                    "--sqlserver-database": "value",
                    "--sqlserver-hostname": "value",
                    "--sqlserver-password": "value",
                    "--sqlserver-port": "value",
                    "--sqlserver-prompt-for-password": "bool",
                    "--sqlserver-username": "value",
                    "--static-ip-connectivity": "bool",
                    "--type": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "discover": {
                  "commands": {},
                  "flags": {
                    "--connection-profile-name": "value",
                    "--connection-profile-object-file": "value",
                    "--full-hierarchy": "bool",
                    "--hierarchy-depth": "value",
                    "--location": "value",
                    "--mysql-rdbms-file": "value",
                    "--oracle-rdbms-file": "value",
                    "--postgresql-rdbms-file": "value",
                    "--recursive": "bool",
                    "--recursive-depth": "value",
                    "--sqlserver-rdbms-file": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--bucket-name": "value",
                    "--ca-certificate": "value",
                    "--clear-labels": "bool",
                    "--client-certificate": "value",
                    "--client-key": "value",
                    "--database-service": "value",
                    "--display-name": "value",
                    "--forward-ssh-hostname": "value",
                    "--forward-ssh-password": "value",
                    "--forward-ssh-port": "value",
                    "--forward-ssh-private-key": "value",
                    "--forward-ssh-username": "value",
                    "--location": "value",
                    "--mysql-hostname": "value",
                    "--mysql-password": "value",
                    "--mysql-port": "value",
                    "--mysql-prompt-for-password": "bool",
                    "--mysql-username": "value",
                    "--no-connectivity": "bool",
                    "--oracle-hostname": "value",
                    "--oracle-password": "value",
                    "--oracle-port": "value",
                    "--oracle-prompt-for-password": "bool",
                    "--oracle-username": "value",
                    "--postgresql-ca-certificate": "value",
                    "--postgresql-client-certificate": "value",
                    "--postgresql-client-key": "value",
                    "--postgresql-database": "value",
                    "--postgresql-hostname": "value",
                    "--postgresql-password": "value",
                    "--postgresql-port": "value",
                    "--postgresql-prompt-for-password": "bool",
                    "--postgresql-username": "value",
                    "--private-connection-name": "value",
                    "--remove-labels": "value",
                    "--root-path": "value",
                    "--sqlserver-database": "value",
                    "--sqlserver-hostname": "value",
                    "--sqlserver-password": "value",
                    "--sqlserver-port": "value",
                    "--sqlserver-prompt-for-password": "bool",
                    "--sqlserver-username": "value",
                    "--static-ip-connectivity": "bool",
                    "--type": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "fetch-static-ips": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "private-connections": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--display-name": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--subnet": "value",
                    "--vpc-name": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--force": "bool",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "routes": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--destination-address": "value",
                    "--destination-port": "value",
                    "--display-name": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--private-connection": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic",
                    "--private-connection": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic",
                    "--private-connection": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--private-connection": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "streams": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--backfill-all": "bool",
                    "--backfill-none": "bool",
                    "--bigquery-destination-config": "value",
                    "--destination-name": "value",
                    "--display-name": "value",
                    "--force": "bool",
                    "--gcs-destination-config": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--mysql-excluded-objects": "value",
                    "--mysql-source-config": "value",
                    "--oracle-excluded-objects": "value",
                    "--oracle-source-config": "value",
                    "--postgresql-excluded-objects": "value",
                    "--postgresql-source-config": "value",
                    "--source-name": "value",
                    "--sqlserver-excluded-objects": "value",
                    "--sqlserver-source-config": "value",
                    "--validate-only": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--backfill-all": "bool",
                    "--backfill-none": "bool",
                    "--bigquery-destination-config": "value",
                    "--clear-labels": "bool",
                    "--destination-name": "value",
                    "--display-name": "value",
                    "--force": "bool",
                    "--gcs-destination-config": "value",
                    "--location": "value",
                    "--mysql-excluded-objects": "value",
                    "--mysql-source-config": "value",
                    "--oracle-excluded-objects": "value",
                    "--oracle-source-config": "value",
                    "--postgresql-excluded-objects": "value",
                    "--postgresql-source-config": "value",
                    "--remove-labels": "value",
                    "--source-name": "value",
                    "--sqlserver-excluded-objects": "value",
                    "--sqlserver-source-config": "value",
                    "--state": "value",
                    "--update-labels": "value",
                    "--update-mask": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "deploy": {
          "commands": {
            "apply": {
              "commands": {},
              "flags": {
                "--file": "value",
                "--region": "value"
              }
            },
            "automation-runs": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "automations": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--region": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--destination": "value",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "custom-target-types": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--region": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "delete": {
              "commands": {},
              "flags": {
                "--file": "value",
                "--force": "bool",
                "--region": "value"
              }
            },
            "delivery-pipelines": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--force": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--region": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "deploy-policies": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "get-config": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "job-runs": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--region": "dynamic",
                    "--release": "dynamic",
                    "--rollout": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--release": "dynamic",
                    "--rollout": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "terminate": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--region": "dynamic",
                    "--release": "dynamic",
                    "--rollout": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "releases": {
              "commands": {
                "abandon": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--region": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--annotations": "value",
                    "--build-artifacts": "value",
                    "--delivery-pipeline": "dynamic",
                    "--deploy-parameters": "value",
                    "--description": "value",
                    "--disable-initial-rollout": "bool",
                    "--enable-initial-rollout": "bool",
                    "--from-k8s-manifest": "value",
                    "--from-run-manifest": "value",
                    "--gcs-source-staging-dir": "value",
                    "--ignore-file": "value",
                    "--images": "value",
                    "--initial-rollout-annotations": "value",
                    "--initial-rollout-labels": "value",
                    "--initial-rollout-phase-id": "value",
                    "--labels": "value",
                    "--region": "dynamic",
                    "--skaffold-file": "value",
                    "--skaffold-version": "value",
                    "--source": "value",
                    "--to-target": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "promote": {
                  "commands": {},
                  "flags": {
                    "--annotations": "value",
                    "--delivery-pipeline": "dynamic",
                    "--labels": "value",
                    "--region": "dynamic",
                    "--release": "dynamic",
                    "--rollout-id": "value",
                    "--starting-phase-id": "value",
                    "--to-target": "value"
                  }
                }
              },
              "flags": {}
            },
            "rollouts": {
              "commands": {
                "advance": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--phase-id": "value",
                    "--region": "dynamic",
                    "--release": "dynamic"
                  }
                },
                "approve": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--region": "dynamic",
                    "--release": "dynamic"
                  }
                },
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--region": "dynamic",
                    "--release": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--region": "dynamic",
                    "--release": "dynamic"
                  }
                },
                "ignore-job": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--job-id": "value",
                    "--phase-id": "value",
                    "--region": "dynamic",
                    "--release": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--release": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "reject": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--region": "dynamic",
                    "--release": "dynamic"
                  }
                },
                "retry-job": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "dynamic",
                    "--job-id": "value",
                    "--phase-id": "value",
                    "--region": "dynamic",
                    "--release": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "targets": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--delivery-pipeline": "value",
                    "--list-all-pipelines": "bool",
                    "--region": "dynamic",
                    "--skip-pipeline-lookup": "bool"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--region": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "redeploy": {
                  "commands": {},
                  "flags": {
                    "--annotations": "value",
                    "--delivery-pipeline": "value",
                    "--description": "value",
                    "--labels": "value",
                    "--region": "dynamic",
                    "--rollout-id": "value",
                    "--starting-phase-id": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "dynamic"
                  }
                },
                "rollback": {
                  "commands": {},
                  "flags": {
                    "--annotations": "value",
                    "--delivery-pipeline": "value",
                    "--description": "value",
                    "--labels": "value",
                    "--region": "dynamic",
                    "--release": "value",
                    "--rollout-id": "value",
                    "--starting-phase-id": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "deployment-manager": {
          "commands": {
            "deployments": {
              "commands": {
                "cancel-preview": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--fingerprint": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--automatic-rollback-on-error": "bool",
                    "--composite-type": "value",
                    "--config": "value",
                    "--create-policy": [
                      "acquire",
                      "create",
                      "create-or-acquire"
                    ],
                    "--description": "value",
                    "--labels": "value",
                    "--preview": "bool",
                    "--properties": "value",
                    "--template": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--delete-policy": [
                      "abandon",
                      "delete"
                    ]
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--simple-list": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "stop": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--fingerprint": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--composite-type": "value",
                    "--config": "value",
                    "--create-policy": [
                      "acquire",
                      "create",
                      "create-or-acquire"
                    ],
                    "--delete-policy": [
                      "abandon",
                      "delete"
                    ],
                    "--description": "value",
                    "--fingerprint": "value",
                    "--manifest-id": "value",
                    "--preview": "bool",
                    "--properties": "value",
                    "--remove-labels": "value",
                    "--template": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "manifests": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--deployment": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--deployment": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--simple-list": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--simple-list": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "resources": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--deployment": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--deployment": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--simple-list": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {
                "--deployment": "value"
              }
            },
            "type-providers": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--api-options-file": "value",
                    "--async": "bool",
                    "--custom-certificate-authority-roots": "value",
                    "--description": "value",
                    "--descriptor-url": "value",
                    "--labels": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--api-options-file": "value",
                    "--async": "bool",
                    "--custom-certificate-authority-roots": "value",
                    "--description": "value",
                    "--descriptor-url": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "types": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--status": [
                      "DEPRECATED",
                      "EXPERIMENTAL",
                      "SUPPORTED"
                    ],
                    "--template": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--provider": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--provider": "value",
                    "--provider-project": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--remove-labels": "value",
                    "--status": [
                      "DEPRECATED",
                      "EXPERIMENTAL",
                      "SUPPORTED"
                    ],
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "developer-connect": {
          "commands": {
            "connections": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--annotations": "value",
                    "--async": "bool",
                    "--crypto-key-config-reference": "value",
                    "--disabled": "bool",
                    "--etag": "value",
                    "--github-config-app": [
                      "developer-connect",
                      "firebase"
                    ],
                    "--github-config-app-installation-id": "value",
                    "--github-config-authorizer-credential-oauth-token-secret-version": "value",
                    "--github-enterprise-config-app-id": "value",
                    "--github-enterprise-config-app-installation-id": "value",
                    "--github-enterprise-config-host-uri": "value",
                    "--github-enterprise-config-private-key-secret-version": "value",
                    "--github-enterprise-config-service-directory": "value",
                    "--github-enterprise-config-ssl-ca-certificate": "value",
                    "--github-enterprise-config-webhook-secret-version": "value",
                    "--gitlab-config-authorizer-credential-user-token-secret-version": "value",
                    "--gitlab-config-read-authorizer-credential-user-token-secret-version": "value",
                    "--gitlab-config-webhook-secret-version": "value",
                    "--gitlab-enterprise-config-authorizer-credential-user-token-secret-version": "value",
                    "--gitlab-enterprise-config-host-uri": "value",
                    "--gitlab-enterprise-config-read-authorizer-credential-user-token-secret-version": "value",
                    "--gitlab-enterprise-config-service-directory": "value",
                    "--gitlab-enterprise-config-ssl-ca-certificate": "value",
                    "--gitlab-enterprise-config-webhook-secret-version": "value",
                    "--key-ring": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--namespace": "value",
                    "--request-id": "value",
                    "--secret": "value",
                    "--validate-only": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--etag": "value",
                    "--location": "dynamic",
                    "--request-id": "value",
                    "--validate-only": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "git-repository-links": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--annotations": "value",
                        "--async": "bool",
                        "--clone-uri": "value",
                        "--connection": "dynamic",
                        "--etag": "value",
                        "--labels": "value",
                        "--location": "dynamic",
                        "--request-id": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--connection": "dynamic",
                        "--etag": "value",
                        "--location": "dynamic",
                        "--request-id": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--connection": "dynamic",
                        "--location": "dynamic"
                      }
                    },
                    "fetch-read-token": {
                      "commands": {},
                      "flags": {
                        "--connection": "dynamic",
                        "--location": "dynamic"
                      }
                    },
                    "fetch-read-write-token": {
                      "commands": {},
                      "flags": {
                        "--connection": "dynamic",
                        "--location": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--connection": "dynamic",
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--allow-missing": "bool",
                    "--annotations": "value",
                    "--async": "bool",
                    "--clear-annotations": "bool",
                    "--clear-github-enterprise-config-private-key-secret-version": "bool",
                    "--clear-github-enterprise-config-webhook-secret-version": "bool",
                    "--clear-labels": "bool",
                    "--crypto-key-config-reference": "value",
                    "--disabled": "bool",
                    "--etag": "value",
                    "--github-config-app-installation-id": "value",
                    "--github-config-authorizer-credential-oauth-token-secret-version": "value",
                    "--github-enterprise-config-app-id": "value",
                    "--github-enterprise-config-app-installation-id": "value",
                    "--github-enterprise-config-host-uri": "value",
                    "--github-enterprise-config-private-key-secret-version": "value",
                    "--github-enterprise-config-service-directory": "value",
                    "--github-enterprise-config-ssl-ca-certificate": "value",
                    "--github-enterprise-config-webhook-secret-version": "value",
                    "--gitlab-config-authorizer-credential-user-token-secret-version": "value",
                    "--gitlab-config-read-authorizer-credential-user-token-secret-version": "value",
                    "--gitlab-enterprise-config-authorizer-credential-user-token-secret-version": "value",
                    "--gitlab-enterprise-config-host-uri": "value",
                    "--gitlab-enterprise-config-read-authorizer-credential-user-token-secret-version": "value",
                    "--gitlab-enterprise-config-service-directory": "value",
                    "--gitlab-enterprise-config-ssl-ca-certificate": "value",
                    "--key-ring": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--namespace": "value",
                    "--remove-annotations": "value",
                    "--remove-labels": "value",
                    "--request-id": "value",
                    "--secret": "value",
                    "--update-annotations": "value",
                    "--update-labels": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "dns": {
          "commands": {
            "dns-keys": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--sort-by": "value",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "managed-zones": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--denial-of-existence": [
                      "nsec",
                      "nsec3"
                    ],
                    "--description": "value",
                    "--dns-name": "value",
                    "--dnssec-state": [
                      "off",
                      "on",
                      "transfer"
                    ],
                    "--forwarding-targets": "value",
                    "--gkeclusters": "value",
                    "--ksk-algorithm": [
                      "ecdsap256sha256",
                      "ecdsap384sha384",
                      "rsasha1",
                      "rsasha256",
                      "rsasha512"
                    ],
                    "--ksk-key-length": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--log-dns-queries": "bool",
                    "--managed-reverse-lookup": "bool",
                    "--networks": "value",
                    "--private-forwarding-targets": "value",
                    "--service-directory-namespace": "value",
                    "--target-network": "value",
                    "--target-project": "value",
                    "--visibility": [
                      "private",
                      "public"
                    ],
                    "--zsk-algorithm": [
                      "ecdsap256sha256",
                      "ecdsap384sha384",
                      "rsasha1",
                      "rsasha256",
                      "rsasha512"
                    ],
                    "--zsk-key-length": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--policy-file": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--denial-of-existence": [
                      "nsec",
                      "nsec3"
                    ],
                    "--description": "value",
                    "--dnssec-state": [
                      "off",
                      "on",
                      "transfer"
                    ],
                    "--forwarding-targets": "value",
                    "--gkeclusters": "value",
                    "--ksk-algorithm": [
                      "ecdsap256sha256",
                      "ecdsap384sha384",
                      "rsasha1",
                      "rsasha256",
                      "rsasha512"
                    ],
                    "--ksk-key-length": "value",
                    "--location": "value",
                    "--log-dns-queries": "bool",
                    "--managed-reverse-lookup": "bool",
                    "--networks": "value",
                    "--private-forwarding-targets": "value",
                    "--remove-labels": "value",
                    "--target-network": "value",
                    "--target-project": "value",
                    "--update-labels": "value",
                    "--zsk-algorithm": [
                      "ecdsap256sha256",
                      "ecdsap384sha384",
                      "rsasha1",
                      "rsasha256",
                      "rsasha512"
                    ],
                    "--zsk-key-length": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--sort-by": "value",
                    "--zones": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "policies": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--alternative-name-servers": "value",
                    "--description": "value",
                    "--enable-dns64-all-queries": "bool",
                    "--enable-inbound-forwarding": "bool",
                    "--enable-logging": "bool",
                    "--networks": "value",
                    "--private-alternative-name-servers": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--alternative-name-servers": "value",
                    "--description": "value",
                    "--enable-dns64-all-queries": "bool",
                    "--enable-inbound-forwarding": "bool",
                    "--enable-logging": "bool",
                    "--networks": "value",
                    "--private-alternative-name-servers": "value"
                  }
                }
              },
              "flags": {}
            },
            "project-info": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "record-sets": {
              "commands": {
                "changes": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--zone": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--sort-order": [
                          "ascending",
                          "descending"
                        ],
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--backup-data-trickle-ratio": "value",
                    "--enable-geo-fencing": "bool",
                    "--enable-health-checking": "bool",
                    "--health-check": "value",
                    "--location": "value",
                    "--routing-policy-backup-data": "value",
                    "--routing-policy-backup-data-type": [
                      "GEO"
                    ],
                    "--routing-policy-primary-data": "value",
                    "--routing_policy_data": "value",
                    "--routing_policy_type": [
                      "FAILOVER",
                      "GEO",
                      "WRR"
                    ],
                    "--rrdatas": "value",
                    "--ttl": "value",
                    "--type": "value",
                    "--zone": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--type": "value",
                    "--zone": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--type": "value",
                    "--zone": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--zone": "dynamic",
                    "--zone-file-format": "bool"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--delete-all-existing": "bool",
                    "--location": "value",
                    "--replace-origin-ns": "bool",
                    "--zone": "dynamic",
                    "--zone-file-format": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--name": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--type": "value",
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                },
                "transaction": {
                  "commands": {
                    "abort": {
                      "commands": {},
                      "flags": {
                        "--transaction-file": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "add": {
                      "commands": {},
                      "flags": {
                        "--name": "value",
                        "--transaction-file": "value",
                        "--ttl": "value",
                        "--type": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--transaction-file": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "execute": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--transaction-file": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "remove": {
                      "commands": {},
                      "flags": {
                        "--name": "value",
                        "--transaction-file": "value",
                        "--ttl": "value",
                        "--type": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "start": {
                      "commands": {},
                      "flags": {
                        "--transaction-file": "value",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {
                    "--transaction-file": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--backup-data-trickle-ratio": "value",
                    "--enable-geo-fencing": "bool",
                    "--enable-health-checking": "bool",
                    "--health-check": "value",
                    "--location": "value",
                    "--routing-policy-backup-data": "value",
                    "--routing-policy-backup-data-type": [
                      "GEO"
                    ],
                    "--routing-policy-primary-data": "value",
                    "--routing_policy_data": "value",
                    "--routing_policy_type": [
                      "FAILOVER",
                      "GEO",
                      "WRR"
                    ],
                    "--rrdatas": "value",
                    "--ttl": "value",
                    "--type": "value",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "response-policies": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--gkeclusters": "value",
                    "--location": "value",
                    "--networks": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "rules": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--behavior": [
                          "behaviorUnspecified",
                          "bypassResponsePolicy"
                        ],
                        "--dns-name": "value",
                        "--local-data": "value",
                        "--location": "value",
                        "--response-policy": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--response-policy": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--response-policy": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--behavior": [
                          "behaviorUnspecified",
                          "bypassResponsePolicy"
                        ],
                        "--dns-name": "value",
                        "--local-data": "value",
                        "--location": "value",
                        "--response-policy": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--gkeclusters": "value",
                    "--location": "value",
                    "--networks": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "domains": {
          "commands": {
            "list-user-verified": {
              "commands": {},
              "flags": {}
            },
            "registrations": {
              "commands": {
                "authorization-code": {
                  "commands": {
                    "get": {
                      "commands": {},
                      "flags": {}
                    },
                    "reset": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "configure": {
                  "commands": {
                    "contacts": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--contact-data-from-file": "value",
                        "--contact-privacy": [
                          "private-contact-data",
                          "public-contact-data",
                          "redacted-contact-data"
                        ],
                        "--notices": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "dns": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--cloud-dns-zone": "value",
                        "--disable-dnssec": "bool",
                        "--dns-settings-from-file": "value",
                        "--name-servers": "value",
                        "--unsafe-dns-update": "bool",
                        "--use-google-domains-dns": "bool",
                        "--validate-only": "bool"
                      }
                    },
                    "management": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--preferred-renewal-method": [
                          "automatic-renewal",
                          "renewal-disabled"
                        ],
                        "--transfer-lock-state": [
                          "locked",
                          "unlocked"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-register-parameters": {
                  "commands": {},
                  "flags": {}
                },
                "google-domains-dns": {
                  "commands": {
                    "export-dns-record-sets": {
                      "commands": {},
                      "flags": {
                        "--records-file": "value",
                        "--zone-file-format": "bool"
                      }
                    },
                    "get-forwarding-config": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "initiate-push-transfer": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--tag": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "wait": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "register": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cloud-dns-zone": "value",
                    "--contact-data-from-file": "value",
                    "--contact-privacy": [
                      "private-contact-data",
                      "public-contact-data",
                      "redacted-contact-data"
                    ],
                    "--disable-dnssec": "bool",
                    "--labels": "value",
                    "--name-servers": "value",
                    "--notices": "value",
                    "--use-google-domains-dns": "bool",
                    "--validate-only": "bool",
                    "--yearly-price": "value"
                  }
                },
                "renew-domain": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--validate-only": "bool",
                    "--yearly-price": "value"
                  }
                },
                "search-domains": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "verify": {
              "commands": {},
              "flags": {}
            }
          },
          "flags": {}
        },
        "emulators": {
          "commands": {
            "bigtable": {
              "commands": {
                "env-init": {
                  "commands": {},
                  "flags": {}
                },
                "start": {
                  "commands": {},
                  "flags": {
                    "--host-port": "value"
                  }
                }
              },
              "flags": {}
            },
            "datastore": {
              "commands": {
                "env-init": {
                  "commands": {},
                  "flags": {
                    "--data-dir": "value"
                  }
                },
                "env-unset": {
                  "commands": {},
                  "flags": {
                    "--data-dir": "value"
                  }
                },
                "start": {
                  "commands": {},
                  "flags": {
                    "--consistency": "value",
                    "--data-dir": "value",
                    "--host-port": "value",
                    "--store-on-disk": "bool",
                    "--use-firestore-in-datastore-mode": "bool"
                  }
                }
              },
              "flags": {
                "--data-dir": "value"
              }
            },
            "firestore": {
              "commands": {
                "start": {
                  "commands": {},
                  "flags": {
                    "--database-mode": "value",
                    "--export-on-exit": "value",
                    "--host-port": "value",
                    "--import-data": "value",
                    "--rules": "value"
                  }
                }
              },
              "flags": {}
            },
            "pubsub": {
              "commands": {
                "env-init": {
                  "commands": {},
                  "flags": {
                    "--data-dir": "value"
                  }
                },
                "start": {
                  "commands": {},
                  "flags": {
                    "--data-dir": "value",
                    "--host-port": "value"
                  }
                }
              },
              "flags": {
                "--data-dir": "value"
              }
            },
            "spanner": {
              "commands": {
                "env-init": {
                  "commands": {},
                  "flags": {}
                },
                "start": {
                  "commands": {},
                  "flags": {
                    "--enable-fault-injection": "value",
                    "--host-port": "value",
                    "--rest-port": "value",
                    "--use-docker": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "endpoints": {
          "commands": {
            "configs": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--service": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--service": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--service": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "services": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "check-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "deploy": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--force": "bool",
                    "--validate-only": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "undelete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "error-reporting": {
          "commands": {
            "events": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "report": {
                  "commands": {},
                  "flags": {
                    "--message": "value",
                    "--message-file": "value",
                    "--service": "value",
                    "--service-version": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "essential-contacts": {
          "commands": {
            "compute": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--notification-categories": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--email": "value",
                "--folder": "value",
                "--language": "value",
                "--notification-categories": "value",
                "--organization": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--language": "value",
                "--notification-categories": "value",
                "--organization": "value"
              }
            }
          },
          "flags": {}
        },
        "eventarc": {
          "commands": {
            "enrollments": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cel-match": "value",
                    "--destination-pipeline": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--message-bus": "value",
                    "--message-bus-project": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cel-match": "value",
                    "--clear-labels": "bool",
                    "--destination-pipeline": "value",
                    "--location": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "google-api-sources": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--crypto-key": "value",
                    "--destination-message-bus": "value",
                    "--destination-message-bus-project": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--logging-config": [
                      "ALERT",
                      "CRITICAL",
                      "DEBUG",
                      "EMERGENCY",
                      "ERROR",
                      "INFO",
                      "NONE",
                      "NOTICE",
                      "WARNING"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-crypto-key": "bool",
                    "--clear-labels": "bool",
                    "--crypto-key": "value",
                    "--destination-message-bus": "value",
                    "--destination-message-bus-project": "value",
                    "--location": "value",
                    "--logging-config": [
                      "ALERT",
                      "CRITICAL",
                      "DEBUG",
                      "EMERGENCY",
                      "ERROR",
                      "INFO",
                      "NONE",
                      "NOTICE",
                      "WARNING"
                    ],
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "message-buses": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--crypto-key": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--logging-config": [
                      "ALERT",
                      "CRITICAL",
                      "DEBUG",
                      "EMERGENCY",
                      "ERROR",
                      "INFO",
                      "NONE",
                      "NOTICE",
                      "WARNING"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-enrollments": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "publish": {
                  "commands": {},
                  "flags": {
                    "--avro-message": "value",
                    "--event-attributes": "value",
                    "--event-data": "value",
                    "--event-id": "value",
                    "--event-source": "value",
                    "--event-type": "value",
                    "--json-message": "value",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-crypto-key": "bool",
                    "--clear-labels": "bool",
                    "--crypto-key": "value",
                    "--location": "value",
                    "--logging-config": [
                      "ALERT",
                      "CRITICAL",
                      "DEBUG",
                      "EMERGENCY",
                      "ERROR",
                      "INFO",
                      "NONE",
                      "NOTICE",
                      "WARNING"
                    ],
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "pipelines": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--crypto-key": "value",
                    "--destinations": "value",
                    "--input-payload-format-avro-schema-definition": "value",
                    "--input-payload-format-json": "value",
                    "--input-payload-format-protobuf-schema-definition": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--logging-config": [
                      "ALERT",
                      "CRITICAL",
                      "DEBUG",
                      "EMERGENCY",
                      "ERROR",
                      "INFO",
                      "NONE",
                      "NOTICE",
                      "WARNING"
                    ],
                    "--max-retry-attempts": "value",
                    "--max-retry-delay": "value",
                    "--mediations": "value",
                    "--min-retry-delay": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-crypto-key": "bool",
                    "--clear-labels": "bool",
                    "--crypto-key": "value",
                    "--destinations": "value",
                    "--input-payload-format-avro-schema-definition": "value",
                    "--input-payload-format-json": "value",
                    "--input-payload-format-protobuf-schema-definition": "value",
                    "--location": "value",
                    "--logging-config": [
                      "ALERT",
                      "CRITICAL",
                      "DEBUG",
                      "EMERGENCY",
                      "ERROR",
                      "INFO",
                      "NONE",
                      "NOTICE",
                      "WARNING"
                    ],
                    "--max-retry-attempts": "value",
                    "--max-retry-delay": "value",
                    "--mediations": "value",
                    "--min-retry-delay": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "filestore": {
          "commands": {
            "backups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--file-share": "value",
                    "--instance": "value",
                    "--instance-location": "value",
                    "--instance-zone": "value",
                    "--kms-key": "value",
                    "--labels": "value",
                    "--region": "value",
                    "--tags": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--region": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "instances": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--deletion-protection": "bool",
                    "--deletion-protection-reason": "value",
                    "--description": "value",
                    "--file-share": "value",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--location": "value",
                    "--managed-ad": "value",
                    "--network": "value",
                    "--performance": "value",
                    "--protocol": [
                      "nfs-v3",
                      "nfs-v4-1"
                    ],
                    "--region": "value",
                    "--source-instance": "value",
                    "--tags": "value",
                    "--tier": [
                      "basic-hdd",
                      "basic-ssd",
                      "enterprise",
                      "high-scale-ssd",
                      "premium",
                      "regional",
                      "standard",
                      "zonal"
                    ],
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--force": "bool",
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--region": "value",
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "value"
                  }
                },
                "promote-replica": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--zone": "dynamic"
                  }
                },
                "restore": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--file-share": "value",
                    "--location": "value",
                    "--source-backup": "value",
                    "--source-backup-region": "value",
                    "--zone": "dynamic"
                  }
                },
                "revert": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic",
                    "--target-snapshot": "value"
                  }
                },
                "snapshots": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value",
                        "--instance": "value",
                        "--instance-location": "value",
                        "--instance-region": "value",
                        "--labels": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--instance": "value",
                        "--instance-location": "value",
                        "--instance-region": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--instance": "value",
                        "--instance-location": "value",
                        "--instance-region": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--instance": "value",
                        "--instance-location": "value",
                        "--instance-region": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--description": "value",
                        "--instance": "value",
                        "--instance-location": "value",
                        "--instance-region": "value",
                        "--remove-labels": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--clear-nfs-export-options": "bool",
                    "--deletion-protection": "bool",
                    "--deletion-protection-reason": "value",
                    "--description": "value",
                    "--disconnect-managed-ad": "bool",
                    "--file-share": "value",
                    "--location": "value",
                    "--managed-ad": "value",
                    "--performance": "value",
                    "--region": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value",
                    "--zone": "value"
                  }
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "value"
                  }
                }
              },
              "flags": {}
            },
            "regions": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "zones": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "firebase": {
          "commands": {
            "test": {
              "commands": {
                "android": {
                  "commands": {
                    "list-device-capacities": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "locales": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {}
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--sort-by": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "models": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {}
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--sort-by": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "run": {
                      "commands": {},
                      "flags": {
                        "--additional-apks": "value",
                        "--app": "value",
                        "--app-package": "value",
                        "--async": "bool",
                        "--auto-google-login": "bool",
                        "--client-details": "value",
                        "--device": "value",
                        "--device-ids": "value",
                        "--directories-to-pull": "value",
                        "--environment-variables": "value",
                        "--filter": "value",
                        "--grant-permissions": [
                          "all",
                          "none"
                        ],
                        "--limit": "value",
                        "--locales": "value",
                        "--network-profile": "value",
                        "--num-flaky-test-attempts": "value",
                        "--num-uniform-shards": "value",
                        "--obb-files": "value",
                        "--orientations": "dynamic",
                        "--os-version-ids": "value",
                        "--other-files": "value",
                        "--page-size": "value",
                        "--performance-metrics": "bool",
                        "--record-video": "bool",
                        "--resign": "bool",
                        "--results-bucket": "value",
                        "--results-dir": "value",
                        "--results-history-name": "value",
                        "--robo-directives": "value",
                        "--robo-script": "value",
                        "--scenario-labels": "value",
                        "--scenario-numbers": "value",
                        "--sort-by": "value",
                        "--test": "value",
                        "--test-package": "value",
                        "--test-runner-class": "value",
                        "--test-targets": "value",
                        "--test-targets-for-shard": "value",
                        "--timeout": "value",
                        "--type": [
                          "game-loop",
                          "instrumentation",
                          "robo"
                        ],
                        "--use-orchestrator": "bool"
                      }
                    },
                    "versions": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {}
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--sort-by": "value"
                          }
                        }
                      },
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "ios": {
                  "commands": {
                    "list-device-capacities": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "locales": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {}
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--sort-by": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "models": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {}
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--sort-by": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "run": {
                      "commands": {},
                      "flags": {
                        "--additional-ipas": "value",
                        "--app": "value",
                        "--async": "bool",
                        "--client-details": "value",
                        "--device": "value",
                        "--directories-to-pull": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--num-flaky-test-attempts": "value",
                        "--other-files": "value",
                        "--page-size": "value",
                        "--record-video": "bool",
                        "--results-bucket": "value",
                        "--results-dir": "value",
                        "--results-history-name": "value",
                        "--robo-script": "value",
                        "--scenario-numbers": "value",
                        "--sort-by": "value",
                        "--test": "value",
                        "--test-special-entitlements": "bool",
                        "--timeout": "value",
                        "--type": [
                          "game-loop",
                          "robo",
                          "xctest"
                        ],
                        "--xcode-version": "value",
                        "--xctestrun-file": "value"
                      }
                    },
                    "versions": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {}
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--sort-by": "value"
                          }
                        }
                      },
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "ip-blocks": {
                  "commands": {
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "network-profiles": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "firestore": {
          "commands": {
            "backups": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--backup": "value",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--backup": "value",
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "schedules": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--database": "value",
                        "--day-of-week": [
                          "FRI",
                          "MON",
                          "SAT",
                          "SUN",
                          "THU",
                          "TUE",
                          "WED"
                        ],
                        "--recurrence": "value",
                        "--retention": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--backup-schedule": "value",
                        "--database": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--backup-schedule": "value",
                        "--database": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--database": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--backup-schedule": "value",
                        "--database": "value",
                        "--retention": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "bulk-delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--collection-ids": "value",
                "--database": "value",
                "--namespace-ids": "value"
              }
            },
            "databases": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--database": "value",
                    "--delete-protection": "bool",
                    "--enable-pitr": "bool",
                    "--kms-key-name": "value",
                    "--location": "value",
                    "--type": [
                      "datastore-mode",
                      "firestore-native"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--database": "value",
                    "--etag": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--database": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--show-deleted": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "restore": {
                  "commands": {},
                  "flags": {
                    "--destination-database": "value",
                    "--encryption-type": [
                      "customer-managed-encryption",
                      "google-default-encryption",
                      "use-source-encryption"
                    ],
                    "--kms-key-name": "value",
                    "--source-backup": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--database": "value",
                    "--delete-protection": "bool",
                    "--enable-pitr": "bool",
                    "--type": [
                      "datastore-mode",
                      "firestore-native"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "export": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--collection-ids": "value",
                "--database": "value",
                "--namespace-ids": "value",
                "--snapshot-time": "value"
              }
            },
            "fields": {
              "commands": {
                "ttls": {
                  "commands": {
                    "list": {
                      "commands": {},
                      "flags": {
                        "--collection-group": "value",
                        "--database": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--collection-group": "value",
                        "--database": "value",
                        "--disable-ttl": "bool",
                        "--enable-ttl": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--collection-ids": "value",
                "--database": "value",
                "--namespace-ids": "value"
              }
            },
            "indexes": {
              "commands": {
                "composite": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--api-scope": [
                          "any-api",
                          "datastore-mode-api"
                        ],
                        "--async": "bool",
                        "--collection-group": "value",
                        "--database": "value",
                        "--field-config": "value",
                        "--query-scope": [
                          "collection",
                          "collection-group",
                          "collection-recursive"
                        ]
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--database": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--database": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--database": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "fields": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--collection-group": "value",
                        "--database": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--collection-group": "value",
                        "--database": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-exemption": "bool",
                        "--collection-group": "value",
                        "--database": "value",
                        "--disable-indexes": "bool",
                        "--index": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--database": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--database": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--database": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--database": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "functions": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--region": "dynamic",
                "--role": "value"
              }
            },
            "add-invoker-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--region": "dynamic"
              }
            },
            "call": {
              "commands": {},
              "flags": {
                "--cloud-event": "value",
                "--data": "value",
                "--region": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "deploy": {
              "commands": {},
              "flags": {
                "--allow-unauthenticated": "bool",
                "--binary-authorization": "value",
                "--build-env-vars-file": "value",
                "--build-service-account": "value",
                "--build-worker-pool": "value",
                "--clear-binary-authorization": "bool",
                "--clear-build-env-vars": "bool",
                "--clear-build-service-account": "bool",
                "--clear-build-worker-pool": "bool",
                "--clear-docker-repository": "bool",
                "--clear-env-vars": "bool",
                "--clear-kms-key": "bool",
                "--clear-labels": "bool",
                "--clear-max-instances": "bool",
                "--clear-min-instances": "bool",
                "--clear-secrets": "bool",
                "--clear-vpc-connector": "bool",
                "--concurrency": "value",
                "--cpu": "value",
                "--docker-registry": [
                  "artifact-registry",
                  "container-registry"
                ],
                "--docker-repository": "value",
                "--egress-settings": [
                  "all",
                  "private-ranges-only"
                ],
                "--entry-point": "value",
                "--env-vars-file": "value",
                "--gen2": "bool",
                "--ignore-file": "value",
                "--ingress-settings": [
                  "all",
                  "internal-and-gclb",
                  "internal-only"
                ],
                "--kms-key": "value",
                "--max-instances": "value",
                "--memory": "value",
                "--min-instances": "value",
                "--region": "dynamic",
                "--remove-build-env-vars": "value",
                "--remove-env-vars": "value",
                "--remove-labels": "value",
                "--remove-secrets": "value",
                "--retry": "bool",
                "--run-service-account": "value",
                "--runtime": "value",
                "--runtime-update-policy": [
                  "automatic",
                  "on-deploy"
                ],
                "--security-level": [
                  "secure-always",
                  "secure-optional"
                ],
                "--serve-all-traffic-latest-revision": "bool",
                "--service-account": "value",
                "--set-build-env-vars": "value",
                "--set-env-vars": "value",
                "--set-secrets": "value",
                "--source": "dynamic",
                "--stage-bucket": "value",
                "--timeout": "value",
                "--trigger-bucket": "value",
                "--trigger-event": "value",
                "--trigger-event-filters": "value",
                "--trigger-event-filters-path-pattern": "value",
                "--trigger-http": "bool",
                "--trigger-location": "dynamic",
                "--trigger-resource": "value",
                "--trigger-service-account": "value",
                "--trigger-topic": "value",
                "--update-build-env-vars": "value",
                "--update-env-vars": "value",
                "--update-labels": "value",
                "--update-secrets": "value",
                "--vpc-connector": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic",
                "--v2": "bool"
              }
            },
            "event-types": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--gen2": "bool"
                  }
                }
              },
              "flags": {}
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--v2": "bool"
              }
            },
            "logs": {
              "commands": {
                "read": {
                  "commands": {},
                  "flags": {
                    "--end-time": "value",
                    "--execution-id": "value",
                    "--filter": "value",
                    "--gen2": "bool",
                    "--limit": "value",
                    "--min-log-level": [
                      "debug",
                      "error",
                      "info"
                    ],
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--start-time": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "regions": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--gen2": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--region": "dynamic",
                "--role": "value"
              }
            },
            "remove-invoker-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--region": "dynamic"
              }
            },
            "runtimes": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "healthcare": {
          "commands": {
            "annotation-stores": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "evaluate": {
                  "commands": {
                    "bq": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bq-table": "value",
                        "--dataset": "value",
                        "--golden-store": "value",
                        "--location": "value",
                        "--write-disposition": [
                          "write-append",
                          "write-empty",
                          "write-truncate"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "export": {
                  "commands": {
                    "bq": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bq-table": "value",
                        "--dataset": "value",
                        "--location": "value",
                        "--write-disposition": [
                          "write-append",
                          "write-empty",
                          "write-truncate"
                        ]
                      }
                    },
                    "gcs": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--dataset": "value",
                        "--gcs-uri": "value",
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "import": {
                  "commands": {
                    "gcs": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--dataset": "value",
                        "--gcs-uri": "value",
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "consent-stores": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "check-data-access": {
                  "commands": {},
                  "flags": {
                    "--data-id": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--request-attributes": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--labels": "value",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "evaluate-user-consents": {
                  "commands": {},
                  "flags": {
                    "--consent-list": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--page-token": "value",
                    "--request-attributes": "value",
                    "--resource-attributes": "value",
                    "--response-view": [
                      "basic",
                      "full",
                      "response-view-unspecified"
                    ],
                    "--user-id": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "query-accessible-data": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--dataset": "value",
                    "--gcs-uri": "value",
                    "--location": "value",
                    "--request-attributes": "value",
                    "--resource-attributes": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--dataset": "value",
                    "--location": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "datasets": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--encryption-key": "value",
                    "--location": "value",
                    "--time-zone": "value"
                  }
                },
                "deidentify": {
                  "commands": {},
                  "flags": {
                    "--annotation-store": "value",
                    "--async": "bool",
                    "--default-fhir-config": "bool",
                    "--destination-dataset": "value",
                    "--dicom-filter-tags": "value",
                    "--location": "value",
                    "--text-redaction-mode": [
                      "all"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--time-zone": "value"
                  }
                }
              },
              "flags": {}
            },
            "dicom-stores": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value",
                    "--pubsub-topic": "value",
                    "--send-for-bulk-import": "bool",
                    "--stream-configs": "value"
                  }
                },
                "deidentify": {
                  "commands": {},
                  "flags": {
                    "--annotation-store": "value",
                    "--async": "bool",
                    "--dataset": "value",
                    "--destination-store": "value",
                    "--dicom-filter-tags": "value",
                    "--location": "value",
                    "--text-redaction-mode": [
                      "all"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {
                    "bq": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bq-table": "value",
                        "--dataset": "value",
                        "--filter-config-gcs-uri": "value",
                        "--location": "value",
                        "--overwrite-table": "bool",
                        "--write-disposition": [
                          "write-append",
                          "write-empty",
                          "write-truncate"
                        ]
                      }
                    },
                    "gcs": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--dataset": "value",
                        "--filter-config-gcs-uri": "value",
                        "--gcs-uri-prefix": "value",
                        "--location": "value",
                        "--mime-type": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "import": {
                  "commands": {
                    "gcs": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--dataset": "value",
                        "--gcs-uri": "value",
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "metrics": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value",
                    "--pubsub-topic": "value",
                    "--send-for-bulk-import": "bool",
                    "--stream-configs": "value"
                  }
                }
              },
              "flags": {}
            },
            "fhir-stores": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--disable-referential-integrity": "bool",
                    "--disable-resource-versioning": "bool",
                    "--enable-history-modifications": "bool",
                    "--enable-update-create": "bool",
                    "--location": "value",
                    "--pubsub-topic": "value"
                  }
                },
                "deidentify": {
                  "commands": {},
                  "flags": {
                    "--annotation-store": "value",
                    "--async": "bool",
                    "--dataset": "value",
                    "--destination-store": "value",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {
                    "bq": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bq-dataset": "value",
                        "--dataset": "value",
                        "--location": "value",
                        "--recursive-depth": "value",
                        "--resource-type": "value",
                        "--schema-type": [
                          "analytics",
                          "analytics_v2",
                          "lossless"
                        ],
                        "--since": "value",
                        "--write-disposition": [
                          "write-append",
                          "write-empty",
                          "write-truncate"
                        ]
                      }
                    },
                    "gcs": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--dataset": "value",
                        "--gcs-uri": "value",
                        "--location": "value",
                        "--resource-type": "value",
                        "--since": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "import": {
                  "commands": {
                    "gcs": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--content-structure": [
                          "bundle",
                          "bundle-pretty",
                          "resource",
                          "resource-pretty"
                        ],
                        "--dataset": "value",
                        "--gcs-uri": "value",
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "metrics": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--enable-history-modifications": "bool",
                    "--enable-update-create": "bool",
                    "--location": "value",
                    "--pubsub-topic": "value"
                  }
                }
              },
              "flags": {}
            },
            "hl7v2-stores": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value",
                    "--parser-version": [
                      "v1",
                      "v2",
                      "v3"
                    ],
                    "--pubsub-topic": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {
                    "gcs": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--dataset": "value",
                        "--end-time": "value",
                        "--gcs-uri": "value",
                        "--location": "value",
                        "--message-view": [
                          "basic",
                          "full",
                          "parsed-only",
                          "raw-only",
                          "schematized-only"
                        ],
                        "--start-time": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "import": {
                  "commands": {
                    "gcs": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--dataset": "value",
                        "--gcs-uri": "value",
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "metrics": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value",
                    "--pubsub-topic": "value"
                  }
                }
              },
              "flags": {}
            },
            "nlp": {
              "commands": {
                "analyze-entities": {
                  "commands": {},
                  "flags": {
                    "--document-content": "value",
                    "--nlp-service": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--dataset": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "help": {
          "commands": {},
          "flags": {
            "--filter": "value",
            "--limit": "value",
            "--page-size": "value",
            "--sort-by": "value"
          }
        },
        "iam": {
          "commands": {
            "list-grantable-roles": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--page-size": "value"
              }
            },
            "list-testable-permissions": {
              "commands": {},
              "flags": {
                "--filter": "value"
              }
            },
            "policies": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--attachment-point": "value",
                    "--kind": "value",
                    "--policy-file": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--attachment-point": "value",
                    "--etag": "value",
                    "--kind": "value"
                  }
                },
                "get": {
                  "commands": {},
                  "flags": {
                    "--attachment-point": "value",
                    "--kind": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--attachment-point": "value",
                    "--filter": "value",
                    "--kind": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--page_token": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--attachment-point": "value",
                    "--etag": "value",
                    "--kind": "value",
                    "--policy-file": "value"
                  }
                }
              },
              "flags": {}
            },
            "policy-bindings": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--annotations": "value",
                    "--async": "bool",
                    "--condition-description": "value",
                    "--condition-expression": "value",
                    "--condition-location": "value",
                    "--condition-title": "value",
                    "--display-name": "value",
                    "--etag": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--policy": "value",
                    "--policy-kind": [
                      "principal-access-boundary"
                    ],
                    "--target-principal-set": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--etag": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "search-target-policy-bindings": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--target": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--annotations": "value",
                    "--async": "bool",
                    "--clear-annotations": "bool",
                    "--condition-description": "value",
                    "--condition-expression": "value",
                    "--condition-location": "value",
                    "--condition-title": "value",
                    "--display-name": "value",
                    "--etag": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--remove-annotations": "value",
                    "--update-annotations": "value"
                  }
                }
              },
              "flags": {}
            },
            "principal-access-boundary-policies": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--annotations": "value",
                    "--async": "bool",
                    "--details-enforcement-version": "value",
                    "--details-rules": "value",
                    "--display-name": "value",
                    "--etag": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--etag": "value",
                    "--force": "bool",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "search-policy-bindings": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-details-rules": "value",
                    "--annotations": "value",
                    "--async": "bool",
                    "--clear-annotations": "bool",
                    "--clear-details-rules": "bool",
                    "--details-enforcement-version": "value",
                    "--details-rules": "value",
                    "--display-name": "value",
                    "--etag": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--remove-annotations": "value",
                    "--remove-details-rules": "value",
                    "--update-annotations": "value"
                  }
                }
              },
              "flags": {}
            },
            "roles": {
              "commands": {
                "copy": {
                  "commands": {},
                  "flags": {
                    "--dest-organization": "value",
                    "--dest-project": "value",
                    "--destination": "value",
                    "--source": "value",
                    "--source-organization": "value",
                    "--source-project": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--file": "value",
                    "--organization": "value",
                    "--permissions": "value",
                    "--stage": "value",
                    "--title": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--show-deleted": "bool",
                    "--sort-by": "value"
                  }
                },
                "undelete": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-permissions": "value",
                    "--description": "value",
                    "--file": "value",
                    "--organization": "value",
                    "--permissions": "value",
                    "--remove-permissions": "value",
                    "--stage": "value",
                    "--title": "value"
                  }
                }
              },
              "flags": {}
            },
            "service-accounts": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--recommend": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "disable": {
                  "commands": {},
                  "flags": {}
                },
                "enable": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "keys": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--iam-account": "value",
                        "--key-file-type": [
                          "json",
                          "p12"
                        ]
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--iam-account": "value"
                      }
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--iam-account": "dynamic"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--iam-account": "dynamic"
                      }
                    },
                    "get-public-key": {
                      "commands": {},
                      "flags": {
                        "--iam-account": "value",
                        "--output-file": "value",
                        "--type": [
                          "pem",
                          "raw"
                        ]
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--created-before": "value",
                        "--filter": "value",
                        "--iam-account": "value",
                        "--limit": "value",
                        "--managed-by": [
                          "any",
                          "system",
                          "user"
                        ],
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "upload": {
                      "commands": {},
                      "flags": {
                        "--iam-account": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "sign-blob": {
                  "commands": {},
                  "flags": {
                    "--iam-account": "value"
                  }
                },
                "sign-jwt": {
                  "commands": {},
                  "flags": {
                    "--iam-account": "value"
                  }
                },
                "undelete": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value"
                  }
                }
              },
              "flags": {}
            },
            "workforce-pools": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--allowed-services": "value",
                    "--async": "bool",
                    "--description": "value",
                    "--disable-programmatic-signin": "bool",
                    "--disabled": "bool",
                    "--display-name": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--session-duration": "value"
                  }
                },
                "create-cred-config": {
                  "commands": {},
                  "flags": {
                    "--credential-source-field-name": "value",
                    "--credential-source-file": "value",
                    "--credential-source-headers": "value",
                    "--credential-source-type": "value",
                    "--credential-source-url": "value",
                    "--executable-command": "value",
                    "--executable-interactive-timeout-millis": "value",
                    "--executable-output-file": "value",
                    "--executable-timeout-millis": "value",
                    "--output-file": "value",
                    "--service-account": "value",
                    "--service-account-token-lifetime-seconds": "value",
                    "--subject-token-type": "value",
                    "--workforce-pool-user-project": "value"
                  }
                },
                "create-login-config": {
                  "commands": {},
                  "flags": {
                    "--activate": "bool",
                    "--output-file": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--show-deleted": "bool",
                    "--sort-by": "value"
                  }
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--workforce-pool": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "providers": {
                  "commands": {
                    "create-oidc": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--attribute-condition": "value",
                        "--attribute-mapping": "value",
                        "--client-id": "value",
                        "--client-secret-value": "value",
                        "--description": "value",
                        "--disabled": "bool",
                        "--display-name": "value",
                        "--extra-attributes-client-id": "value",
                        "--extra-attributes-client-secret-value": "value",
                        "--extra-attributes-filter": "value",
                        "--extra-attributes-issuer-uri": "value",
                        "--extra-attributes-type": "value",
                        "--issuer-uri": "value",
                        "--jwk-json-path": "value",
                        "--location": "value",
                        "--web-sso-additional-scopes": "value",
                        "--web-sso-assertion-claims-behavior": [
                          "assertion-claims-behavior-unspecified",
                          "merge-user-info-over-id-token-claims",
                          "only-id-token-claims"
                        ],
                        "--web-sso-response-type": [
                          "code",
                          "id-token",
                          "response-type-unspecified"
                        ],
                        "--workforce-pool": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--workforce-pool": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--workforce-pool": "dynamic"
                      }
                    },
                    "keys": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--async": "bool",
                            "--location": "value",
                            "--provider": "dynamic",
                            "--spec": [
                              "key-spec-unspecified",
                              "rsa-2048",
                              "rsa-3072",
                              "rsa-4096"
                            ],
                            "--use": [
                              "encryption",
                              "key-use-unspecified"
                            ],
                            "--workforce-pool": "dynamic"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--async": "bool",
                            "--location": "value",
                            "--provider": "dynamic",
                            "--workforce-pool": "dynamic"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--provider": "dynamic",
                            "--workforce-pool": "dynamic"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--location": "value",
                            "--page-size": "value",
                            "--provider": "dynamic",
                            "--show-deleted": "bool",
                            "--sort-by": "value",
                            "--workforce-pool": "dynamic"
                          }
                        },
                        "operations": {
                          "commands": {
                            "describe": {
                              "commands": {},
                              "flags": {
                                "--key": "dynamic",
                                "--location": "value",
                                "--provider": "dynamic",
                                "--workforce-pool": "dynamic"
                              }
                            }
                          },
                          "flags": {}
                        },
                        "undelete": {
                          "commands": {},
                          "flags": {
                            "--async": "bool",
                            "--location": "value",
                            "--provider": "dynamic",
                            "--workforce-pool": "dynamic"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--show-deleted": "bool",
                        "--sort-by": "value",
                        "--workforce-pool": "dynamic"
                      }
                    },
                    "operations": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--provider": "dynamic",
                            "--workforce-pool": "dynamic"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "undelete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--workforce-pool": "dynamic"
                      }
                    },
                    "update-oidc": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--attribute-condition": "value",
                        "--attribute-mapping": "value",
                        "--clear-client-secret": "bool",
                        "--clear-extra-attributes-config": "bool",
                        "--client-id": "value",
                        "--client-secret-value": "value",
                        "--description": "value",
                        "--disabled": "bool",
                        "--display-name": "value",
                        "--extra-attributes-client-id": "value",
                        "--extra-attributes-client-secret-value": "value",
                        "--extra-attributes-filter": "value",
                        "--extra-attributes-issuer-uri": "value",
                        "--extra-attributes-type": "value",
                        "--issuer-uri": "value",
                        "--jwk-json-path": "value",
                        "--location": "value",
                        "--web-sso-additional-scopes": "value",
                        "--web-sso-assertion-claims-behavior": [
                          "assertion-claims-behavior-unspecified",
                          "merge-user-info-over-id-token-claims",
                          "only-id-token-claims"
                        ],
                        "--web-sso-response-type": [
                          "code",
                          "id-token",
                          "response-type-unspecified"
                        ],
                        "--workforce-pool": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "undelete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--disable-programmatic-signin": "bool",
                    "--disabled": "bool",
                    "--display-name": "value",
                    "--location": "value",
                    "--session-duration": "value"
                  }
                }
              },
              "flags": {}
            },
            "workload-identity-pools": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--disabled": "bool",
                    "--display-name": "value",
                    "--location": "value"
                  }
                },
                "create-cred-config": {
                  "commands": {},
                  "flags": {
                    "--app-id-uri": "value",
                    "--aws": "bool",
                    "--azure": "bool",
                    "--credential-cert-configuration-output-file": "value",
                    "--credential-cert-path": "value",
                    "--credential-cert-private-key-path": "value",
                    "--credential-source-field-name": "value",
                    "--credential-source-file": "value",
                    "--credential-source-headers": "value",
                    "--credential-source-type": "value",
                    "--credential-source-url": "value",
                    "--enable-imdsv2": "bool",
                    "--executable-command": "value",
                    "--executable-output-file": "value",
                    "--executable-timeout-millis": "value",
                    "--output-file": "value",
                    "--service-account": "value",
                    "--service-account-token-lifetime-seconds": "value",
                    "--subject-token-type": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--show-deleted": "bool",
                    "--sort-by": "value"
                  }
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--workload-identity-pool": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "providers": {
                  "commands": {
                    "create-aws": {
                      "commands": {},
                      "flags": {
                        "--account-id": "value",
                        "--attribute-condition": "value",
                        "--attribute-mapping": "value",
                        "--description": "value",
                        "--disabled": "bool",
                        "--display-name": "value",
                        "--location": "value",
                        "--workload-identity-pool": "dynamic"
                      }
                    },
                    "create-oidc": {
                      "commands": {},
                      "flags": {
                        "--allowed-audiences": "value",
                        "--attribute-condition": "value",
                        "--attribute-mapping": "value",
                        "--description": "value",
                        "--disabled": "bool",
                        "--display-name": "value",
                        "--issuer-uri": "value",
                        "--jwk-json-path": "value",
                        "--location": "value",
                        "--workload-identity-pool": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--workload-identity-pool": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--workload-identity-pool": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--show-deleted": "bool",
                        "--sort-by": "value",
                        "--workload-identity-pool": "dynamic"
                      }
                    },
                    "operations": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--provider": "dynamic",
                            "--workload-identity-pool": "dynamic"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "undelete": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--workload-identity-pool": "dynamic"
                      }
                    },
                    "update-aws": {
                      "commands": {},
                      "flags": {
                        "--account-id": "value",
                        "--attribute-condition": "value",
                        "--attribute-mapping": "value",
                        "--description": "value",
                        "--disabled": "bool",
                        "--display-name": "value",
                        "--location": "value",
                        "--workload-identity-pool": "dynamic"
                      }
                    },
                    "update-oidc": {
                      "commands": {},
                      "flags": {
                        "--allowed-audiences": "value",
                        "--attribute-condition": "value",
                        "--attribute-mapping": "value",
                        "--description": "value",
                        "--disabled": "bool",
                        "--display-name": "value",
                        "--issuer-uri": "value",
                        "--jwk-json-path": "value",
                        "--location": "value",
                        "--workload-identity-pool": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "undelete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--disabled": "bool",
                    "--display-name": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "iap": {
          "commands": {
            "oauth-brands": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--application_title": "value",
                    "--support_email": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "oauth-clients": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--display_name": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--brand": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--brand": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "reset-secret": {
                  "commands": {},
                  "flags": {
                    "--brand": "value"
                  }
                }
              },
              "flags": {}
            },
            "settings": {
              "commands": {
                "get": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value",
                    "--region": "value",
                    "--resource-type": [
                      "app-engine",
                      "backend-services",
                      "compute",
                      "folder",
                      "forwarding-rule",
                      "iap_web",
                      "organization"
                    ],
                    "--service": "value"
                  }
                },
                "set": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value",
                    "--region": "value",
                    "--resource-type": [
                      "app-engine",
                      "backend-services",
                      "compute",
                      "folder",
                      "forwarding-rule",
                      "iap_web",
                      "organization"
                    ],
                    "--service": "value"
                  }
                }
              },
              "flags": {}
            },
            "tcp": {
              "commands": {
                "dest-groups": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--dest-group": "value",
                        "--member": "value",
                        "--region": "value",
                        "--role": "value"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--fqdn-list": "value",
                        "--ip-range-list": "value",
                        "--region": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--region": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "value"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--dest-group": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "value",
                        "--sort-by": "value"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--dest-group": "value",
                        "--member": "value",
                        "--region": "value",
                        "--role": "value"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--dest-group": "value",
                        "--region": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--fqdn-list": "value",
                        "--ip-range-list": "value",
                        "--region": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "web": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--region": "value",
                    "--resource-type": [
                      "app-engine",
                      "backend-services",
                      "forwarding-rule"
                    ],
                    "--role": "value",
                    "--service": "value"
                  }
                },
                "disable": {
                  "commands": {},
                  "flags": {
                    "--region": "value",
                    "--resource-type": [
                      "app-engine",
                      "backend-services"
                    ],
                    "--service": "value"
                  }
                },
                "enable": {
                  "commands": {},
                  "flags": {
                    "--oauth2-client-id": "value",
                    "--oauth2-client-secret": "value",
                    "--region": "value",
                    "--resource-type": [
                      "app-engine",
                      "backend-services"
                    ],
                    "--service": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--resource-type": [
                      "app-engine",
                      "backend-services",
                      "forwarding-rule"
                    ],
                    "--service": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--region": "value",
                    "--resource-type": [
                      "app-engine",
                      "backend-services",
                      "forwarding-rule"
                    ],
                    "--role": "value",
                    "--service": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "value",
                    "--resource-type": [
                      "app-engine",
                      "backend-services",
                      "forwarding-rule"
                    ],
                    "--service": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "identity": {
          "commands": {
            "groups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--display-name": "value",
                    "--dynamic-user-query": "value",
                    "--group-type": [
                      "discussion",
                      "dynamic",
                      "security"
                    ],
                    "--labels": "value",
                    "--organization": "value",
                    "--with-initial-owner": [
                      "empty",
                      "with-initial-owner"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "memberships": {
                  "commands": {
                    "add": {
                      "commands": {},
                      "flags": {
                        "--expiration": "value",
                        "--group-email": "value",
                        "--member-email": "value",
                        "--organization": "value",
                        "--roles": "value"
                      }
                    },
                    "check-transitive-membership": {
                      "commands": {},
                      "flags": {
                        "--group-email": "value",
                        "--member-email": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--group-email": "value",
                        "--member-email": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--group-email": "value",
                        "--member-email": "value"
                      }
                    },
                    "get-membership-graph": {
                      "commands": {},
                      "flags": {
                        "--group-email": "value",
                        "--labels": "value",
                        "--member-email": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--group-email": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--page-token": "value",
                        "--sort-by": "value",
                        "--view": [
                          "basic",
                          "full"
                        ]
                      }
                    },
                    "modify-membership-roles": {
                      "commands": {},
                      "flags": {
                        "--add-roles": "value",
                        "--group-email": "value",
                        "--member-email": "value",
                        "--remove-roles": "value",
                        "--update-roles-params": "value"
                      }
                    },
                    "search-transitive-groups": {
                      "commands": {},
                      "flags": {
                        "--labels": "value",
                        "--member-email": "value",
                        "--page-size": "value",
                        "--page-token": "value"
                      }
                    },
                    "search-transitive-memberships": {
                      "commands": {},
                      "flags": {
                        "--group-email": "value",
                        "--page-size": "value",
                        "--page-token": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "preview": {
                  "commands": {},
                  "flags": {
                    "--custom-field-mask": "value",
                    "--customer": "value",
                    "--max-results": "value",
                    "--page-token": "value",
                    "--projection": [
                      "basic",
                      "custom",
                      "full"
                    ],
                    "--query": "value",
                    "--view-type": [
                      "admin-view",
                      "domain-public"
                    ]
                  }
                },
                "search": {
                  "commands": {},
                  "flags": {
                    "--labels": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--page-token": "value",
                    "--view": [
                      "basic",
                      "full"
                    ]
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-description": "bool",
                    "--clear-display-name": "bool",
                    "--clear-posix-groups": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--dynamic-user-query": "value",
                    "--labels": "value",
                    "--remove-posix-groups": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "ids": {
          "commands": {
            "endpoints": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--enable-traffic-logs": "bool",
                    "--labels": "value",
                    "--max-wait": "value",
                    "--network": "value",
                    "--severity": [
                      "CRITICAL",
                      "HIGH",
                      "INFORMATIONAL",
                      "LOW",
                      "MEDIUM"
                    ],
                    "--threat-exceptions": "value",
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--max-wait": "value",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--max-wait": "value",
                    "--threat-exceptions": "value",
                    "--zone": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "init": {
          "commands": {},
          "flags": {
            "--console-only": "bool",
            "--no-browser": "bool",
            "--no-launch-browser": "bool",
            "--skip-diagnostics": "bool"
          }
        },
        "interactive": {
          "commands": {},
          "flags": {
            "--context": "value"
          }
        },
        "kms": {
          "commands": {
            "asymmetric-decrypt": {
              "commands": {},
              "flags": {
                "--ciphertext-file": "value",
                "--key": "dynamic",
                "--keyring": "dynamic",
                "--location": "dynamic",
                "--plaintext-file": "value",
                "--skip-integrity-verification": "bool"
              }
            },
            "asymmetric-sign": {
              "commands": {},
              "flags": {
                "--digest-algorithm": [
                  "sha256",
                  "sha384",
                  "sha512"
                ],
                "--input-file": "value",
                "--key": "dynamic",
                "--keyring": "dynamic",
                "--location": "dynamic",
                "--signature-file": "value",
                "--skip-integrity-verification": "bool"
              }
            },
            "autokey-config": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--folder": "value"
                  }
                },
                "show-effective-config": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "decrypt": {
              "commands": {},
              "flags": {
                "--additional-authenticated-data-file": "value",
                "--ciphertext-file": "value",
                "--key": "dynamic",
                "--keyring": "dynamic",
                "--location": "dynamic",
                "--plaintext-file": "value",
                "--skip-integrity-verification": "bool"
              }
            },
            "ekm-config": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--location": "dynamic",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--location": "dynamic",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--default-ekm-connection": "value",
                    "--location": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "ekm-connections": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--crypto-space-path": "value",
                    "--endpoint-filter": "value",
                    "--hostname": "value",
                    "--key-management-mode": [
                      "cloud-kms",
                      "manual"
                    ],
                    "--location": "dynamic",
                    "--server-certificates-files": "value",
                    "--service-directory-service": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--crypto-space-path": "value",
                    "--endpoint-filter": "value",
                    "--hostname": "value",
                    "--key-management-mode": [
                      "cloud-kms",
                      "manual"
                    ],
                    "--location": "dynamic",
                    "--server-certificates-files": "value",
                    "--service-directory-service": "value"
                  }
                }
              },
              "flags": {}
            },
            "encrypt": {
              "commands": {},
              "flags": {
                "--additional-authenticated-data-file": "value",
                "--ciphertext-file": "value",
                "--key": "dynamic",
                "--keyring": "dynamic",
                "--location": "dynamic",
                "--plaintext-file": "value",
                "--skip-integrity-verification": "bool"
              }
            },
            "import-jobs": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--keyring": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--import-method": [
                      "rsa-oaep-3072-sha1-aes-256",
                      "rsa-oaep-3072-sha256",
                      "rsa-oaep-3072-sha256-aes-256",
                      "rsa-oaep-4096-sha1-aes-256",
                      "rsa-oaep-4096-sha256",
                      "rsa-oaep-4096-sha256-aes-256"
                    ],
                    "--keyring": "dynamic",
                    "--location": "dynamic",
                    "--protection-level": [
                      "hsm",
                      "software"
                    ]
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--attestation-file": "value",
                    "--keyring": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--keyring": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--keyring": "dynamic",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--keyring": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--keyring": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "inventory": {
              "commands": {
                "get-protected-resources-summary": {
                  "commands": {},
                  "flags": {
                    "--keyname": "dynamic",
                    "--keyring": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "list-keys": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "search-protected-resources": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--keyname": "dynamic",
                    "--keyring": "dynamic",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--resource-types": "value",
                    "--scope": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "key-handles": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--generate-key-handle-id": "bool",
                    "--key-handle-id": "value",
                    "--location": "dynamic",
                    "--resource-type": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--resource-type": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "keyrings": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "keys": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--keyring": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--allowed-access-reasons": "value",
                    "--crypto-key-backend": "value",
                    "--default-algorithm": [
                      "aes-128-cbc",
                      "aes-128-ctr",
                      "aes-128-gcm",
                      "aes-256-cbc",
                      "aes-256-ctr",
                      "aes-256-gcm",
                      "ec-sign-ed25519",
                      "ec-sign-p256-sha256",
                      "ec-sign-p384-sha384",
                      "ec-sign-secp256k1-sha256",
                      "external-symmetric-encryption",
                      "google-symmetric-encryption",
                      "hmac-sha1",
                      "hmac-sha224",
                      "hmac-sha256",
                      "hmac-sha384",
                      "hmac-sha512",
                      "rsa-decrypt-oaep-2048-sha1",
                      "rsa-decrypt-oaep-2048-sha256",
                      "rsa-decrypt-oaep-3072-sha1",
                      "rsa-decrypt-oaep-3072-sha256",
                      "rsa-decrypt-oaep-4096-sha1",
                      "rsa-decrypt-oaep-4096-sha256",
                      "rsa-decrypt-oaep-4096-sha512",
                      "rsa-sign-pkcs1-2048-sha256",
                      "rsa-sign-pkcs1-3072-sha256",
                      "rsa-sign-pkcs1-4096-sha256",
                      "rsa-sign-pkcs1-4096-sha512",
                      "rsa-sign-pss-2048-sha256",
                      "rsa-sign-pss-3072-sha256",
                      "rsa-sign-pss-4096-sha256",
                      "rsa-sign-pss-4096-sha512",
                      "rsa-sign-raw-pkcs1-2048",
                      "rsa-sign-raw-pkcs1-3072",
                      "rsa-sign-raw-pkcs1-4096"
                    ],
                    "--destroy-scheduled-duration": "value",
                    "--import-only": "bool",
                    "--keyring": "dynamic",
                    "--labels": "value",
                    "--location": "dynamic",
                    "--next-rotation-time": "value",
                    "--protection-level": [
                      "external",
                      "external-vpc",
                      "hsm",
                      "software"
                    ],
                    "--purpose": [
                      "asymmetric-encryption",
                      "asymmetric-signing",
                      "encryption",
                      "mac",
                      "raw-encryption"
                    ],
                    "--rotation-period": "value",
                    "--skip-initial-version-creation": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--keyring": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--keyring": "dynamic",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--keyring": "dynamic",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--keyring": "value",
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "remove-rotation-schedule": {
                  "commands": {},
                  "flags": {
                    "--keyring": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--keyring": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "set-primary-version": {
                  "commands": {},
                  "flags": {
                    "--keyring": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "set-rotation-schedule": {
                  "commands": {},
                  "flags": {
                    "--keyring": "dynamic",
                    "--location": "dynamic",
                    "--next-rotation-time": "value",
                    "--rotation-period": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--allowed-access-reasons": "value",
                    "--clear-labels": "bool",
                    "--default-algorithm": [
                      "aes-128-cbc",
                      "aes-128-ctr",
                      "aes-128-gcm",
                      "aes-256-cbc",
                      "aes-256-ctr",
                      "aes-256-gcm",
                      "ec-sign-ed25519",
                      "ec-sign-p256-sha256",
                      "ec-sign-p384-sha384",
                      "ec-sign-secp256k1-sha256",
                      "external-symmetric-encryption",
                      "google-symmetric-encryption",
                      "hmac-sha1",
                      "hmac-sha224",
                      "hmac-sha256",
                      "hmac-sha384",
                      "hmac-sha512",
                      "rsa-decrypt-oaep-2048-sha1",
                      "rsa-decrypt-oaep-2048-sha256",
                      "rsa-decrypt-oaep-3072-sha1",
                      "rsa-decrypt-oaep-3072-sha256",
                      "rsa-decrypt-oaep-4096-sha1",
                      "rsa-decrypt-oaep-4096-sha256",
                      "rsa-decrypt-oaep-4096-sha512",
                      "rsa-sign-pkcs1-2048-sha256",
                      "rsa-sign-pkcs1-3072-sha256",
                      "rsa-sign-pkcs1-4096-sha256",
                      "rsa-sign-pkcs1-4096-sha512",
                      "rsa-sign-pss-2048-sha256",
                      "rsa-sign-pss-3072-sha256",
                      "rsa-sign-pss-4096-sha256",
                      "rsa-sign-pss-4096-sha512",
                      "rsa-sign-raw-pkcs1-2048",
                      "rsa-sign-raw-pkcs1-3072",
                      "rsa-sign-raw-pkcs1-4096"
                    ],
                    "--keyring": "dynamic",
                    "--location": "dynamic",
                    "--next-rotation-time": "value",
                    "--primary-version": "dynamic",
                    "--remove-key-access-justifications-policy": "bool",
                    "--remove-labels": "value",
                    "--remove-rotation-schedule": "bool",
                    "--rotation-period": "value",
                    "--update-labels": "value"
                  }
                },
                "versions": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--ekm-connection-key-path": "value",
                        "--external-key-uri": "value",
                        "--key": "dynamic",
                        "--keyring": "dynamic",
                        "--location": "dynamic",
                        "--primary": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--attestation-file": "value",
                        "--key": "dynamic",
                        "--keyring": "dynamic",
                        "--location": "dynamic"
                      }
                    },
                    "destroy": {
                      "commands": {},
                      "flags": {
                        "--key": "dynamic",
                        "--keyring": "dynamic",
                        "--location": "dynamic"
                      }
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--key": "dynamic",
                        "--keyring": "dynamic",
                        "--location": "dynamic"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--key": "dynamic",
                        "--keyring": "dynamic",
                        "--location": "dynamic"
                      }
                    },
                    "get-certificate-chain": {
                      "commands": {},
                      "flags": {
                        "--certificate-chain-type": [
                          "all",
                          "cavium",
                          "google-card",
                          "google-partition"
                        ],
                        "--key": "dynamic",
                        "--keyring": "dynamic",
                        "--location": "dynamic",
                        "--output-file": "value"
                      }
                    },
                    "get-public-key": {
                      "commands": {},
                      "flags": {
                        "--key": "dynamic",
                        "--keyring": "dynamic",
                        "--location": "dynamic",
                        "--output-file": "value"
                      }
                    },
                    "import": {
                      "commands": {},
                      "flags": {
                        "--algorithm": [
                          "aes-128-cbc",
                          "aes-128-ctr",
                          "aes-128-gcm",
                          "aes-256-cbc",
                          "aes-256-ctr",
                          "aes-256-gcm",
                          "ec-sign-ed25519",
                          "ec-sign-p256-sha256",
                          "ec-sign-p384-sha384",
                          "ec-sign-secp256k1-sha256",
                          "google-symmetric-encryption",
                          "hmac-sha1",
                          "hmac-sha224",
                          "hmac-sha256",
                          "hmac-sha384",
                          "hmac-sha512",
                          "rsa-decrypt-oaep-2048-sha1",
                          "rsa-decrypt-oaep-2048-sha256",
                          "rsa-decrypt-oaep-3072-sha1",
                          "rsa-decrypt-oaep-3072-sha256",
                          "rsa-decrypt-oaep-4096-sha1",
                          "rsa-decrypt-oaep-4096-sha256",
                          "rsa-decrypt-oaep-4096-sha512",
                          "rsa-sign-pkcs1-2048-sha256",
                          "rsa-sign-pkcs1-3072-sha256",
                          "rsa-sign-pkcs1-4096-sha256",
                          "rsa-sign-pkcs1-4096-sha512",
                          "rsa-sign-pss-2048-sha256",
                          "rsa-sign-pss-3072-sha256",
                          "rsa-sign-pss-4096-sha256",
                          "rsa-sign-pss-4096-sha512",
                          "rsa-sign-raw-pkcs1-2048",
                          "rsa-sign-raw-pkcs1-3072",
                          "rsa-sign-raw-pkcs1-4096"
                        ],
                        "--import-job": "dynamic",
                        "--key": "dynamic",
                        "--keyring": "dynamic",
                        "--location": "dynamic",
                        "--public-key-file": "value",
                        "--target-key-file": "value",
                        "--wrapped-key-file": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--key": "dynamic",
                        "--keyring": "dynamic",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "restore": {
                      "commands": {},
                      "flags": {
                        "--key": "dynamic",
                        "--keyring": "dynamic",
                        "--location": "dynamic"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--ekm-connection-key-path": "value",
                        "--external-key-uri": "value",
                        "--key": "dynamic",
                        "--keyring": "dynamic",
                        "--location": "dynamic",
                        "--state": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "mac-sign": {
              "commands": {},
              "flags": {
                "--input-file": "value",
                "--key": "dynamic",
                "--keyring": "dynamic",
                "--location": "dynamic",
                "--signature-file": "value",
                "--skip-integrity-verification": "bool"
              }
            },
            "mac-verify": {
              "commands": {},
              "flags": {
                "--input-file": "value",
                "--key": "dynamic",
                "--keyring": "dynamic",
                "--location": "dynamic",
                "--signature-file": "value",
                "--skip-integrity-verification": "bool"
              }
            },
            "raw-decrypt": {
              "commands": {},
              "flags": {
                "--additional-authenticated-data-file": "value",
                "--ciphertext-file": "value",
                "--initialization-vector-file": "value",
                "--key": "dynamic",
                "--keyring": "dynamic",
                "--location": "dynamic",
                "--plaintext-file": "value",
                "--skip-integrity-verification": "bool"
              }
            },
            "raw-encrypt": {
              "commands": {},
              "flags": {
                "--additional-authenticated-data-file": "value",
                "--ciphertext-file": "value",
                "--initialization-vector-file": "value",
                "--key": "dynamic",
                "--keyring": "dynamic",
                "--location": "dynamic",
                "--plaintext-file": "value",
                "--skip-integrity-verification": "bool"
              }
            }
          },
          "flags": {}
        },
        "lifesciences": {
          "commands": {
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "pipelines": {
              "commands": {
                "run": {
                  "commands": {},
                  "flags": {
                    "--boot-disk-size": "value",
                    "--command-line": "value",
                    "--disk-size": "value",
                    "--docker-image": "value",
                    "--env-vars": "value",
                    "--inputs": "value",
                    "--inputs-from-file": "value",
                    "--labels": "value",
                    "--location": "dynamic",
                    "--logging": "value",
                    "--machine-type": "value",
                    "--network": "value",
                    "--outputs": "value",
                    "--pipeline-file": "value",
                    "--preemptible": "bool",
                    "--regions": "value",
                    "--service-account-email": "value",
                    "--service-account-scopes": "value",
                    "--subnetwork": "value",
                    "--zones": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "logging": {
          "commands": {
            "buckets": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cmek-kms-key-name": "value",
                    "--description": "value",
                    "--enable-analytics": "bool",
                    "--index": "value",
                    "--location": "value",
                    "--restricted-fields": "value",
                    "--retention-days": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "undelete": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-index": "value",
                    "--async": "bool",
                    "--billing-account": "value",
                    "--clear-indexes": "bool",
                    "--cmek-kms-key-name": "value",
                    "--description": "value",
                    "--enable-analytics": "bool",
                    "--folder": "value",
                    "--location": "value",
                    "--locked": "bool",
                    "--organization": "dynamic",
                    "--remove-indexes": "value",
                    "--restricted-fields": "value",
                    "--retention-days": "value",
                    "--update-index": "value"
                  }
                }
              },
              "flags": {}
            },
            "copy": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--folder": "value",
                "--location": "value",
                "--log-filter": "value",
                "--organization": "dynamic"
              }
            },
            "links": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--billing-account": "value",
                    "--bucket": "value",
                    "--description": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--billing-account": "value",
                    "--bucket": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--bucket": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--bucket": "value",
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--folder": "value",
                    "--organization": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--organization": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "logs": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--bucket": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--sort-by": "value",
                    "--view": "value"
                  }
                }
              },
              "flags": {}
            },
            "metrics": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--bucket-name": "value",
                    "--config-from-file": "value",
                    "--description": "value",
                    "--log-filter": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--bucket-name": "value",
                    "--config-from-file": "value",
                    "--description": "value",
                    "--log-filter": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--operation-filter": "value",
                    "--organization": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "read": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--bucket": "value",
                "--folder": "value",
                "--freshness": "value",
                "--limit": "value",
                "--location": "value",
                "--order": [
                  "asc",
                  "desc"
                ],
                "--organization": "dynamic",
                "--resource-names": "value",
                "--view": "value"
              }
            },
            "resource-descriptors": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "settings": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--folder": "value",
                    "--organization": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-kms-key": "bool",
                    "--disable-default-sink": "bool",
                    "--folder": "value",
                    "--kms-key-name": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--organization": "dynamic",
                    "--storage-location": "value"
                  }
                }
              },
              "flags": {}
            },
            "sinks": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--custom-writer-identity": "value",
                    "--description": "value",
                    "--disabled": "bool",
                    "--exclusion": "value",
                    "--folder": "value",
                    "--include-children": "bool",
                    "--intercept-children": "bool",
                    "--log-filter": "value",
                    "--organization": "dynamic",
                    "--use-partitioned-tables": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--folder": "value",
                    "--organization": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--folder": "value",
                    "--organization": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--organization": "dynamic",
                    "--sink-filter": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-exclusion": "value",
                    "--billing-account": "value",
                    "--clear-exclusions": "bool",
                    "--custom-writer-identity": "value",
                    "--description": "value",
                    "--disabled": "bool",
                    "--folder": "value",
                    "--include-children": "bool",
                    "--intercept-children": "bool",
                    "--log-filter": "value",
                    "--organization": "dynamic",
                    "--remove-exclusions": "value",
                    "--update-exclusion": "value",
                    "--use-partitioned-tables": "bool"
                  }
                }
              },
              "flags": {}
            },
            "tail": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--bucket": "value",
                "--buffer-window": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "dynamic",
                "--view": "value"
              }
            },
            "views": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--bucket": "value",
                    "--description": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--log-filter": "value",
                    "--organization": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--bucket": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--bucket": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--bucket": "value",
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--bucket": "value",
                    "--description": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--log-filter": "value",
                    "--organization": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "write": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--folder": "value",
                "--organization": "dynamic",
                "--payload-type": [
                  "json",
                  "text"
                ],
                "--severity": [
                  "ALERT",
                  "CRITICAL",
                  "DEBUG",
                  "DEFAULT",
                  "EMERGENCY",
                  "ERROR",
                  "INFO",
                  "NOTICE",
                  "WARNING"
                ]
              }
            }
          },
          "flags": {}
        },
        "managed-kafka": {
          "commands": {
            "clusters": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--auto-rebalance": "bool",
                    "--cpu": "value",
                    "--encryption-key": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--memory": "value",
                    "--subnets": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--auto-rebalance": "bool",
                    "--cpu": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--memory": "value",
                    "--subnets": "value"
                  }
                }
              },
              "flags": {}
            },
            "consumer-groups": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--location": "value",
                    "--topics-file": "value"
                  }
                }
              },
              "flags": {}
            },
            "topics": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--configs": "value",
                    "--location": "value",
                    "--partitions": "value",
                    "--replication-factor": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-configs": "bool",
                    "--cluster": "value",
                    "--configs": "value",
                    "--location": "value",
                    "--partitions": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "memcache": {
          "commands": {
            "instances": {
              "commands": {
                "apply-parameters": {
                  "commands": {},
                  "flags": {
                    "--apply-all": "bool",
                    "--async": "bool",
                    "--node-ids": "value",
                    "--region": "dynamic"
                  }
                },
                "apply-software-update": {
                  "commands": {},
                  "flags": {
                    "--apply-all": "bool",
                    "--async": "bool",
                    "--node-ids": "value",
                    "--region": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--authorized-network": "value",
                    "--display-name": "value",
                    "--labels": "value",
                    "--maintenance-window-day": [
                      "friday",
                      "monday",
                      "saturday",
                      "sunday",
                      "thursday",
                      "tuesday",
                      "wednesday"
                    ],
                    "--maintenance-window-duration": "value",
                    "--maintenance-window-start-time": "value",
                    "--memcached-version": [
                      "1.5",
                      "1.6.15"
                    ],
                    "--node-count": "value",
                    "--node-cpu": "value",
                    "--node-memory": "value",
                    "--parameters": "value",
                    "--region": "dynamic",
                    "--reserved-ip-range-id": "value",
                    "--zones": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "reschedule-maintenance": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic",
                    "--reschedule-type": [
                      "immediate",
                      "next-available-window",
                      "specific-time"
                    ],
                    "--schedule-time": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--display-name": "value",
                    "--labels": "value",
                    "--maintenance-window-any": "bool",
                    "--maintenance-window-day": [
                      "friday",
                      "monday",
                      "saturday",
                      "sunday",
                      "thursday",
                      "tuesday",
                      "wednesday"
                    ],
                    "--maintenance-window-duration": "value",
                    "--maintenance-window-start-time": "value",
                    "--node-count": "value",
                    "--parameters": "value",
                    "--region": "dynamic"
                  }
                },
                "upgrade": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--memcached-version": [
                      "1.6.15"
                    ],
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "regions": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "memorystore": {
          "commands": {
            "instances": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--aof-config-append-fsync": [
                      "always",
                      "every-sec",
                      "never"
                    ],
                    "--async": "bool",
                    "--authorization-mode": [
                      "auth-disabled",
                      "iam-auth"
                    ],
                    "--deletion-protection-enabled": "bool",
                    "--engine-configs": "value",
                    "--engine-version": "value",
                    "--labels": "value",
                    "--location": "dynamic",
                    "--mode": [
                      "cluster",
                      "cluster-disabled"
                    ],
                    "--node-type": [
                      "highmem-medium",
                      "highmem-xlarge",
                      "shared-core-nano",
                      "standard-small"
                    ],
                    "--persistence-config-mode": [
                      "aof",
                      "disabled",
                      "rdb"
                    ],
                    "--psc-auto-connections": "value",
                    "--rdb-config-snapshot-period": [
                      "one-hour",
                      "six-hours",
                      "twelve-hours",
                      "twenty-four-hours"
                    ],
                    "--rdb-config-snapshot-start-time": "value",
                    "--replica-count": "value",
                    "--request-id": "value",
                    "--shard-count": "value",
                    "--transit-encryption-mode": [
                      "server-authentication",
                      "transit-encryption-disabled"
                    ],
                    "--zone-distribution-config": "value",
                    "--zone-distribution-config-mode": [
                      "multi-zone",
                      "single-zone"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic",
                    "--request-id": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "get-certificate-authority": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--aof-config-append-fsync": [
                      "always",
                      "every-sec",
                      "never"
                    ],
                    "--async": "bool",
                    "--clear-engine-configs": "bool",
                    "--clear-labels": "bool",
                    "--deletion-protection-enabled": "bool",
                    "--engine-configs": "value",
                    "--labels": "value",
                    "--location": "dynamic",
                    "--persistence-config-mode": [
                      "aof",
                      "disabled",
                      "rdb"
                    ],
                    "--rdb-config-snapshot-period": [
                      "one-hour",
                      "six-hours",
                      "twelve-hours",
                      "twenty-four-hours"
                    ],
                    "--rdb-config-snapshot-start-time": "value",
                    "--remove-engine-configs": "value",
                    "--remove-labels": "value",
                    "--replica-count": "value",
                    "--request-id": "value",
                    "--shard-count": "value",
                    "--update-engine-configs": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "metastore": {
          "commands": {
            "federations": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--backends": "value",
                    "--hive-metastore-version": [
                      "2.3.6",
                      "3.1.2"
                    ],
                    "--labels": "value",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-backends": "bool",
                    "--clear-labels": "bool",
                    "--location": "value",
                    "--remove-backends": "value",
                    "--remove-labels": "value",
                    "--update-backends": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "services": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "alter-metadata-resource-location": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--location_uri": "value",
                    "--resource_name": "value"
                  }
                },
                "alter-table-properties": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--properties": "value",
                    "--table-name": "value",
                    "--update-mask": "value"
                  }
                },
                "backups": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--member": "value",
                        "--role": "dynamic",
                        "--service": "value"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value",
                        "--location": "value",
                        "--service": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--service": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--service": "value"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--service": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--service": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--member": "value",
                        "--role": "dynamic",
                        "--service": "value"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--service": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--autoscaling-enabled": "bool",
                    "--auxiliary-versions": "value",
                    "--auxiliary-versions-from-file": "value",
                    "--consumer-subnetworks": "value",
                    "--data-catalog-sync": "bool",
                    "--database-type": [
                      "mysql",
                      "spanner"
                    ],
                    "--deletion-protection": "bool",
                    "--enable-scheduled-backup": "bool",
                    "--encryption-kms-key": "value",
                    "--endpoint-protocol": [
                      "grpc",
                      "thrift"
                    ],
                    "--hive-metastore-configs": "value",
                    "--hive-metastore-configs-from-file": "value",
                    "--hive-metastore-version": "value",
                    "--instance-size": [
                      "extra-large",
                      "extra-small",
                      "large",
                      "medium",
                      "small"
                    ],
                    "--kerberos-principal": "value",
                    "--keytab": "value",
                    "--krb5-config": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--maintenance-window-day": [
                      "fri",
                      "mon",
                      "sat",
                      "sun",
                      "thu",
                      "tue",
                      "wed"
                    ],
                    "--maintenance-window-hour": "value",
                    "--max-scaling-factor": "value",
                    "--min-scaling-factor": "value",
                    "--network": "value",
                    "--network-config-from-file": "value",
                    "--port": "value",
                    "--read-only-regions": "value",
                    "--read-write-regions": "value",
                    "--release-channel": [
                      "canary",
                      "stable"
                    ],
                    "--scaling-factor": "value",
                    "--scheduled-backup-configs-from-file": "value",
                    "--scheduled-backup-cron": "value",
                    "--scheduled-backup-location": "value",
                    "--tier": [
                      "developer",
                      "enterprise"
                    ]
                  }
                },
                "databases": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--member": "value",
                        "--role": "dynamic",
                        "--service": "value"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--service": "value",
                        "--sort-by": "value"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--member": "value",
                        "--role": "dynamic",
                        "--service": "value"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--service": "value"
                      }
                    },
                    "tables": {
                      "commands": {
                        "add-iam-policy-binding": {
                          "commands": {},
                          "flags": {
                            "--database": "value",
                            "--location": "value",
                            "--member": "value",
                            "--role": "dynamic",
                            "--service": "value"
                          }
                        },
                        "get-iam-policy": {
                          "commands": {},
                          "flags": {
                            "--database": "value",
                            "--filter": "value",
                            "--limit": "value",
                            "--location": "value",
                            "--page-size": "value",
                            "--service": "value",
                            "--sort-by": "value"
                          }
                        },
                        "remove-iam-policy-binding": {
                          "commands": {},
                          "flags": {
                            "--database": "value",
                            "--location": "value",
                            "--member": "value",
                            "--role": "dynamic",
                            "--service": "value"
                          }
                        },
                        "set-iam-policy": {
                          "commands": {},
                          "flags": {
                            "--database": "value",
                            "--location": "value",
                            "--service": "value"
                          }
                        }
                      },
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {
                    "gcs": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--destination-folder": "value",
                        "--dump-type": [
                          "avro",
                          "mysql"
                        ],
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "import": {
                  "commands": {
                    "gcs": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--database-dump": "value",
                        "--description": "value",
                        "--dump-type": [
                          "avro",
                          "mysql"
                        ],
                        "--import-id": "value",
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "imports": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--database-dump": "value",
                        "--database-dump-type": [
                          "mysql"
                        ],
                        "--database-type": [
                          "mysql"
                        ],
                        "--description": "value",
                        "--location": "value",
                        "--service": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--service": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--service": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value",
                        "--location": "value",
                        "--service": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "migrations": {
                  "commands": {
                    "cancel": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value"
                      }
                    },
                    "complete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--service": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--service": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--service": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "start": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--bucket": "value",
                        "--cdc-password": "value",
                        "--cdc-username": "value",
                        "--connection-password": "value",
                        "--connection-username": "value",
                        "--hive-database-name": "value",
                        "--instance-connection-name": "value",
                        "--ip-address": "value",
                        "--location": "value",
                        "--nat-subnet": "value",
                        "--port": "value",
                        "--proxy-subnet": "value",
                        "--reverse-proxy-subnet": "value",
                        "--root-path": "value",
                        "--subnet-ip-range": "value",
                        "--vpc-network": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "move-table-to-database": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--destination_db_name": "value",
                    "--location": "value",
                    "--source_db_name": "value",
                    "--table_name": "value"
                  }
                },
                "query-metadata": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--query": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "restore": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--backup": "value",
                    "--backup-location": "value",
                    "--location": "value",
                    "--restore-type": [
                      "full",
                      "metadata-only"
                    ]
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-auxiliary-versions": "value",
                    "--async": "bool",
                    "--autoscaling-enabled": "bool",
                    "--clear-auxiliary-versions": "bool",
                    "--clear-hive-metastore-configs": "bool",
                    "--clear-labels": "bool",
                    "--data-catalog-sync": "bool",
                    "--deletion-protection": "bool",
                    "--enable-scheduled-backup": "bool",
                    "--endpoint-protocol": [
                      "grpc",
                      "thrift"
                    ],
                    "--instance-size": [
                      "extra-large",
                      "extra-small",
                      "large",
                      "medium",
                      "small"
                    ],
                    "--kerberos-principal": "value",
                    "--keytab": "value",
                    "--krb5-config": "value",
                    "--location": "value",
                    "--maintenance-window-day": [
                      "fri",
                      "mon",
                      "sat",
                      "sun",
                      "thu",
                      "tue",
                      "wed"
                    ],
                    "--maintenance-window-hour": "value",
                    "--max-scaling-factor": "value",
                    "--min-scaling-factor": "value",
                    "--port": "value",
                    "--remove-hive-metastore-configs": "value",
                    "--remove-labels": "value",
                    "--scaling-factor": "value",
                    "--scheduled-backup-configs-from-file": "value",
                    "--scheduled-backup-cron": "value",
                    "--scheduled-backup-location": "value",
                    "--tier": [
                      "developer",
                      "enterprise"
                    ],
                    "--update-auxiliary-versions-from-file": "value",
                    "--update-hive-metastore-configs": "value",
                    "--update-hive-metastore-configs-from-file": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "ml": {
          "commands": {
            "language": {
              "commands": {
                "analyze-entities": {
                  "commands": {},
                  "flags": {
                    "--content": "value",
                    "--content-file": "value",
                    "--content-type": [
                      "html",
                      "plain-text"
                    ],
                    "--encoding-type": [
                      "none",
                      "utf16",
                      "utf32",
                      "utf8"
                    ],
                    "--language": "value"
                  }
                },
                "analyze-entity-sentiment": {
                  "commands": {},
                  "flags": {
                    "--content": "value",
                    "--content-file": "value",
                    "--content-type": [
                      "html",
                      "plain-text"
                    ],
                    "--encoding-type": [
                      "none",
                      "utf16",
                      "utf32",
                      "utf8"
                    ],
                    "--language": "value"
                  }
                },
                "analyze-sentiment": {
                  "commands": {},
                  "flags": {
                    "--content": "value",
                    "--content-file": "value",
                    "--content-type": [
                      "html",
                      "plain-text"
                    ],
                    "--encoding-type": [
                      "none",
                      "utf16",
                      "utf32",
                      "utf8"
                    ],
                    "--language": "value"
                  }
                },
                "analyze-syntax": {
                  "commands": {},
                  "flags": {
                    "--content": "value",
                    "--content-file": "value",
                    "--content-type": [
                      "html",
                      "plain-text"
                    ],
                    "--encoding-type": [
                      "none",
                      "utf16",
                      "utf32",
                      "utf8"
                    ],
                    "--language": "value"
                  }
                },
                "classify-text": {
                  "commands": {},
                  "flags": {
                    "--content": "value",
                    "--content-file": "value",
                    "--content-type": [
                      "html",
                      "plain-text"
                    ],
                    "--language": "value"
                  }
                }
              },
              "flags": {}
            },
            "speech": {
              "commands": {
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "wait": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "recognize": {
                  "commands": {},
                  "flags": {
                    "--additional-language-codes": "value",
                    "--audio-channel-count": "value",
                    "--enable-automatic-punctuation": "bool",
                    "--enable-speaker-diarization": "bool",
                    "--encoding": [
                      "alaw",
                      "amr",
                      "amr-wb",
                      "encoding-unspecified",
                      "flac",
                      "linear16",
                      "mp3",
                      "mulaw",
                      "ogg-opus",
                      "speex-with-header-byte",
                      "webm-opus"
                    ],
                    "--filter-profanity": "bool",
                    "--hints": "value",
                    "--include-word-confidence": "bool",
                    "--include-word-time-offsets": "bool",
                    "--language-code": "value",
                    "--max-alternatives": "value",
                    "--max-diarization-speaker-count": "value",
                    "--min-diarization-speaker-count": "value",
                    "--model": [
                      "command_and_search",
                      "default",
                      "latest_long",
                      "latest_short",
                      "medical_conversation",
                      "medical_dictation",
                      "phone_call",
                      "phone_call_enhanced",
                      "telephony",
                      "telephony_short",
                      "video_enhanced"
                    ],
                    "--sample-rate": "value",
                    "--separate-channel-recognition": "bool"
                  }
                },
                "recognize-long-running": {
                  "commands": {},
                  "flags": {
                    "--additional-language-codes": "value",
                    "--async": "bool",
                    "--audio-channel-count": "value",
                    "--enable-automatic-punctuation": "bool",
                    "--enable-speaker-diarization": "bool",
                    "--encoding": [
                      "alaw",
                      "amr",
                      "amr-wb",
                      "encoding-unspecified",
                      "flac",
                      "linear16",
                      "mp3",
                      "mulaw",
                      "ogg-opus",
                      "speex-with-header-byte",
                      "webm-opus"
                    ],
                    "--filter-profanity": "bool",
                    "--hints": "value",
                    "--include-word-confidence": "bool",
                    "--include-word-time-offsets": "bool",
                    "--language-code": "value",
                    "--max-alternatives": "value",
                    "--max-diarization-speaker-count": "value",
                    "--min-diarization-speaker-count": "value",
                    "--model": [
                      "command_and_search",
                      "default",
                      "latest_long",
                      "latest_short",
                      "medical_conversation",
                      "medical_dictation",
                      "phone_call",
                      "phone_call_enhanced",
                      "telephony",
                      "telephony_short",
                      "video_enhanced"
                    ],
                    "--output-uri": "value",
                    "--sample-rate": "value",
                    "--separate-channel-recognition": "bool"
                  }
                }
              },
              "flags": {}
            },
            "translate": {
              "commands": {
                "batch-translate-text": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--glossaries": "value",
                    "--models": "value",
                    "--source": "value",
                    "--source-language": "value",
                    "--target-language-codes": "value",
                    "--zone": "value"
                  }
                },
                "detect-language": {
                  "commands": {},
                  "flags": {
                    "--content": "value",
                    "--content-file": "value",
                    "--mime-type": "value",
                    "--model": "value",
                    "--zone": "value"
                  }
                },
                "get-supported-languages": {
                  "commands": {},
                  "flags": {
                    "--display-language-code": "value",
                    "--model": "value",
                    "--zone": "value"
                  }
                },
                "translate-text": {
                  "commands": {},
                  "flags": {
                    "--content": "value",
                    "--content-file": "value",
                    "--glossary-config": "value",
                    "--mime-type": "value",
                    "--model": "value",
                    "--source-language": "value",
                    "--target-language": "value",
                    "--zone": "value"
                  }
                }
              },
              "flags": {}
            },
            "video": {
              "commands": {
                "detect-explicit-content": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--output-uri": "value",
                    "--region": [
                      "asia-east1",
                      "europe-west1",
                      "us-east1",
                      "us-west1"
                    ],
                    "--segments": "value"
                  }
                },
                "detect-labels": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--detection-mode": [
                      "frame",
                      "shot",
                      "shot-and-frame"
                    ],
                    "--output-uri": "value",
                    "--region": [
                      "asia-east1",
                      "europe-west1",
                      "us-east1",
                      "us-west1"
                    ],
                    "--segments": "value"
                  }
                },
                "detect-object": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--output-uri": "value",
                    "--region": [
                      "asia-east1",
                      "europe-west1",
                      "us-east1",
                      "us-west1"
                    ],
                    "--segments": "value"
                  }
                },
                "detect-shot-changes": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--output-uri": "value",
                    "--region": [
                      "asia-east1",
                      "europe-west1",
                      "us-east1",
                      "us-west1"
                    ],
                    "--segments": "value"
                  }
                },
                "detect-text": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--language-hints": "value",
                    "--output-uri": "value",
                    "--region": [
                      "asia-east1",
                      "europe-west1",
                      "us-east1",
                      "us-west1"
                    ],
                    "--segments": "value"
                  }
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "wait": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "transcribe-speech": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--audio-tracks": "value",
                    "--diarization-speaker-count": "value",
                    "--enable-automatic-punctuation": "bool",
                    "--enable-speaker-diarization": "bool",
                    "--enable-word-confidence": "bool",
                    "--filter-profanity": "bool",
                    "--hints": "value",
                    "--language-code": "value",
                    "--max-alternatives": "value",
                    "--output-uri": "value",
                    "--region": [
                      "asia-east1",
                      "europe-west1",
                      "us-east1",
                      "us-west1"
                    ],
                    "--segments": "value"
                  }
                }
              },
              "flags": {}
            },
            "vision": {
              "commands": {
                "detect-document": {
                  "commands": {},
                  "flags": {
                    "--language-hints": "value",
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                },
                "detect-faces": {
                  "commands": {},
                  "flags": {
                    "--max-results": "value",
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                },
                "detect-image-properties": {
                  "commands": {},
                  "flags": {
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                },
                "detect-labels": {
                  "commands": {},
                  "flags": {
                    "--max-results": "value",
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                },
                "detect-landmarks": {
                  "commands": {},
                  "flags": {
                    "--max-results": "value",
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                },
                "detect-logos": {
                  "commands": {},
                  "flags": {
                    "--max-results": "value",
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                },
                "detect-objects": {
                  "commands": {},
                  "flags": {
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                },
                "detect-product": {
                  "commands": {},
                  "flags": {
                    "--bounding-polygon": "value",
                    "--category": "value",
                    "--filter": "value",
                    "--max-results": "value",
                    "--product-set": "value",
                    "--product-set-location": "value"
                  }
                },
                "detect-safe-search": {
                  "commands": {},
                  "flags": {
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                },
                "detect-text": {
                  "commands": {},
                  "flags": {
                    "--language-hints": "value",
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                },
                "detect-text-pdf": {
                  "commands": {},
                  "flags": {
                    "--batch-size": "value",
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                },
                "detect-text-tiff": {
                  "commands": {},
                  "flags": {
                    "--batch-size": "value",
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                },
                "detect-web": {
                  "commands": {},
                  "flags": {
                    "--include-geo-results": "bool",
                    "--max-results": "value",
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "product-search": {
                  "commands": {
                    "images": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--bounding-polygon": "value",
                            "--location": "value",
                            "--product": "value",
                            "--storage-location": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--product": "value"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--product": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--location": "value",
                            "--page-size": "value",
                            "--product": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "product-sets": {
                      "commands": {
                        "add-product": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--product": "value"
                          }
                        },
                        "create": {
                          "commands": {},
                          "flags": {
                            "--display-name": "value",
                            "--location": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--location": "value"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value"
                          }
                        },
                        "import": {
                          "commands": {},
                          "flags": {
                            "--async": "bool",
                            "--location": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--location": "value",
                            "--page-size": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        },
                        "list-products": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--location": "value",
                            "--page-size": "value",
                            "--product-set": "value",
                            "--sort-by": "value"
                          }
                        },
                        "remove-product": {
                          "commands": {},
                          "flags": {
                            "--location": "value",
                            "--product": "value"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--display-name": "value",
                            "--location": "value"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "products": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--category": [
                              "apparel",
                              "homegoods",
                              "toys"
                            ],
                            "--description": "value",
                            "--display-name": "value",
                            "--location": "value",
                            "--product-labels": "value"
                          }
                        },
                        "delete": {
                          "commands": {},
                          "flags": {
                            "--location": "value"
                          }
                        },
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--location": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--filter": "value",
                            "--limit": "value",
                            "--location": "value",
                            "--page-size": "value",
                            "--sort-by": "value",
                            "--uri": "bool"
                          }
                        },
                        "update": {
                          "commands": {},
                          "flags": {
                            "--add-product-labels": "value",
                            "--clear-product-labels": "bool",
                            "--description": "value",
                            "--display-name": "value",
                            "--location": "value",
                            "--remove-product-labels": "value"
                          }
                        }
                      },
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "suggest-crop": {
                  "commands": {},
                  "flags": {
                    "--aspect-ratios": "value",
                    "--model-version": [
                      "builtin/latest",
                      "builtin/stable"
                    ]
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "ml-engine": {
          "commands": {
            "explain": {
              "commands": {},
              "flags": {
                "--json-instances": "value",
                "--json-request": "value",
                "--model": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--text-instances": "value"
              }
            },
            "jobs": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--summarize": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "stream-logs": {
                  "commands": {},
                  "flags": {
                    "--allow-multiline-logs": "bool",
                    "--polling-interval": "value",
                    "--task-name": "value"
                  }
                },
                "submit": {
                  "commands": {
                    "prediction": {
                      "commands": {},
                      "flags": {
                        "--batch-size": "value",
                        "--data-format": [
                          "text",
                          "tf-record",
                          "tf-record-gzip"
                        ],
                        "--input-paths": "value",
                        "--labels": "value",
                        "--max-worker-count": "value",
                        "--model": "value",
                        "--model-dir": "value",
                        "--output-path": "value",
                        "--region": "value",
                        "--runtime-version": "value",
                        "--signature-name": "value"
                      }
                    },
                    "training": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--config": "value",
                        "--enable-web-access": "bool",
                        "--job-dir": "value",
                        "--kms-key": "dynamic",
                        "--kms-keyring": "dynamic",
                        "--kms-location": "dynamic",
                        "--kms-project": "dynamic",
                        "--labels": "value",
                        "--master-accelerator": "value",
                        "--master-image-uri": "value",
                        "--master-machine-type": "value",
                        "--module-name": "value",
                        "--network": "value",
                        "--package-path": "value",
                        "--packages": "value",
                        "--parameter-server-accelerator": "value",
                        "--parameter-server-count": "value",
                        "--parameter-server-image-uri": "value",
                        "--parameter-server-machine-type": "value",
                        "--python-version": "value",
                        "--region": "dynamic",
                        "--runtime-version": "value",
                        "--scale-tier": [
                          "basic",
                          "basic-gpu",
                          "basic-tpu",
                          "custom",
                          "premium-1",
                          "standard-1"
                        ],
                        "--service-account": "value",
                        "--staging-bucket": "value",
                        "--stream-logs": "bool",
                        "--tpu-tf-version": "value",
                        "--use-chief-in-tf-config": "value",
                        "--worker-accelerator": "value",
                        "--worker-count": "value",
                        "--worker-image-uri": "value",
                        "--worker-machine-type": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "local": {
              "commands": {
                "predict": {
                  "commands": {},
                  "flags": {
                    "--framework": [
                      "scikit-learn",
                      "tensorflow",
                      "xgboost"
                    ],
                    "--json-instances": "value",
                    "--json-request": "value",
                    "--model-dir": "value",
                    "--signature-name": "value",
                    "--text-instances": "value"
                  }
                },
                "train": {
                  "commands": {},
                  "flags": {
                    "--distributed": "bool",
                    "--evaluator-count": "value",
                    "--job-dir": "value",
                    "--module-name": "value",
                    "--package-path": "value",
                    "--parameter-server-count": "value",
                    "--start-port": "value",
                    "--worker-count": "value"
                  }
                }
              },
              "flags": {}
            },
            "models": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--enable-console-logging": "bool",
                    "--enable-logging": "bool",
                    "--labels": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--regions": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--role": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "predict": {
              "commands": {},
              "flags": {
                "--json-instances": "value",
                "--json-request": "value",
                "--model": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--signature-name": "value",
                "--text-instances": "value"
              }
            },
            "versions": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--args": "value",
                    "--async": "bool",
                    "--command": "value",
                    "--config": "value",
                    "--description": "value",
                    "--env-vars": "value",
                    "--explanation-method": [
                      "integrated-gradients",
                      "sampled-shapley",
                      "xrai"
                    ],
                    "--framework": [
                      "scikit-learn",
                      "tensorflow",
                      "xgboost"
                    ],
                    "--health-route": "value",
                    "--image": "value",
                    "--labels": "value",
                    "--machine-type": "value",
                    "--max-nodes": "value",
                    "--metric-targets": "value",
                    "--min-nodes": "value",
                    "--model": "value",
                    "--num-integral-steps": "value",
                    "--num-paths": "value",
                    "--origin": "value",
                    "--package-uris": "value",
                    "--ports": "value",
                    "--predict-route": "value",
                    "--prediction-class": "value",
                    "--python-version": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--runtime-version": "value",
                    "--service-account": "value",
                    "--staging-bucket": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--model": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--model": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--model": "value",
                    "--page-size": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "set-default": {
                  "commands": {},
                  "flags": {
                    "--model": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ]
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--bigquery-table-name": "value",
                    "--clear-labels": "bool",
                    "--config": "value",
                    "--description": "value",
                    "--model": "value",
                    "--region": [
                      "asia-east1",
                      "asia-northeast1",
                      "asia-southeast1",
                      "australia-southeast1",
                      "europe-west1",
                      "europe-west2",
                      "europe-west3",
                      "europe-west4",
                      "global",
                      "northamerica-northeast1",
                      "us-central1",
                      "us-east1",
                      "us-east4",
                      "us-west1"
                    ],
                    "--remove-labels": "value",
                    "--sampling-percentage": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "monitoring": {
          "commands": {
            "channel-descriptors": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "channels": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--channel-content": "value",
                    "--channel-content-from-file": "value",
                    "--channel-labels": "value",
                    "--description": "value",
                    "--display-name": "value",
                    "--enabled": "bool",
                    "--type": "value",
                    "--user-labels": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--force": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--type": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--channel-content": "value",
                    "--channel-content-from-file": "value",
                    "--clear-channel-labels": "bool",
                    "--clear-user-labels": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--enabled": "bool",
                    "--fields": "value",
                    "--remove-channel-labels": "value",
                    "--remove-user-labels": "value",
                    "--type": "value",
                    "--update-channel-labels": "value",
                    "--update-user-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "dashboards": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--config": "value",
                    "--config-from-file": "value",
                    "--validate-only": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--config": "value",
                    "--config-from-file": "value"
                  }
                }
              },
              "flags": {}
            },
            "metrics-scopes": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "snoozes": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--criteria-policies": "value",
                    "--display-name": "value",
                    "--end-time": "value",
                    "--snooze-from-file": "value",
                    "--start-time": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--display-name": "value",
                    "--end-time": "value",
                    "--fields": "value",
                    "--snooze-from-file": "value",
                    "--start-time": "value"
                  }
                }
              },
              "flags": {}
            },
            "uptime": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--body": "value",
                    "--content-type": [
                      "unspecified",
                      "url-encoded",
                      "user-provided"
                    ],
                    "--custom-content-type": "value",
                    "--group-id": "value",
                    "--group-type": [
                      "aws-elb-load-balancer",
                      "gce-instance"
                    ],
                    "--headers": "value",
                    "--json-path": "value",
                    "--json-path-matcher-type": [
                      "exact-match",
                      "regex-match"
                    ],
                    "--mask-headers": "value",
                    "--matcher-content": "value",
                    "--matcher-type": [
                      "contains-string",
                      "matches-json-path",
                      "matches-regex",
                      "not-contains-string",
                      "not-matches-json-path",
                      "not-matches-regex"
                    ],
                    "--password": "value",
                    "--path": "value",
                    "--period": [
                      "1",
                      "10",
                      "15",
                      "5"
                    ],
                    "--pings-count": "value",
                    "--port": "value",
                    "--protocol": [
                      "http",
                      "https",
                      "tcp"
                    ],
                    "--regions": "value",
                    "--request-method": [
                      "get",
                      "post"
                    ],
                    "--resource-labels": "value",
                    "--resource-type": [
                      "aws-ec2-instance",
                      "aws-elb-load-balancer",
                      "cloud-run-revision",
                      "gae-app",
                      "gce-instance",
                      "servicedirectory-service",
                      "uptime-url"
                    ],
                    "--service-agent-auth": [
                      "oidc-token"
                    ],
                    "--status-classes": "value",
                    "--status-codes": "value",
                    "--synthetic-target": "value",
                    "--timeout": "value",
                    "--user-labels": "value",
                    "--username": "value",
                    "--validate-ssl": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list-configs": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-ips": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-regions": "value",
                    "--add-status-classes": "value",
                    "--add-status-codes": "value",
                    "--body": "value",
                    "--clear-headers": "value",
                    "--clear-regions": "value",
                    "--clear-status-classes": "value",
                    "--clear-status-codes": "value",
                    "--clear-user-labels": "bool",
                    "--content-type": [
                      "unspecified",
                      "url-encoded",
                      "user-provided"
                    ],
                    "--custom-content-type": "value",
                    "--display-name": "value",
                    "--json-path": "value",
                    "--json-path-matcher-type": [
                      "exact-match",
                      "regex-match"
                    ],
                    "--mask-headers": "value",
                    "--matcher-content": "value",
                    "--matcher-type": [
                      "contains-string",
                      "matches-json-path",
                      "matches-regex",
                      "not-contains-string",
                      "not-matches-json-path",
                      "not-matches-regex"
                    ],
                    "--password": "value",
                    "--path": "value",
                    "--period": [
                      "1",
                      "10",
                      "15",
                      "5"
                    ],
                    "--pings-count": "value",
                    "--port": "value",
                    "--remove-headers": "value",
                    "--remove-regions": "value",
                    "--remove-status-classes": "value",
                    "--remove-status-codes": "value",
                    "--remove-user-labels": "value",
                    "--request-method": [
                      "get",
                      "post"
                    ],
                    "--service-agent-auth": [
                      "oidc-token"
                    ],
                    "--set-regions": "value",
                    "--set-status-classes": "value",
                    "--set-status-codes": "value",
                    "--timeout": "value",
                    "--update-headers": "value",
                    "--update-user-labels": "value",
                    "--username": "value",
                    "--validate-ssl": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "netapp": {
          "commands": {
            "active-directories": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--administrators": "value",
                    "--async": "bool",
                    "--backup-operators": "value",
                    "--description": "value",
                    "--dns": "value",
                    "--domain": "value",
                    "--enable-aes": "value",
                    "--enable-ldap-signing": "value",
                    "--encrypt-dc-connections": "value",
                    "--kdc-hostname": "value",
                    "--kdc-ip": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--net-bios-prefix": "value",
                    "--nfs-users-with-ldap": "value",
                    "--organizational-unit": "value",
                    "--password": "value",
                    "--security-operators": "value",
                    "--site": "value",
                    "--username": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--administrators": "value",
                    "--async": "bool",
                    "--backup-operators": "value",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--dns": "value",
                    "--domain": "value",
                    "--enable-aes": "value",
                    "--enable-ldap-signing": "value",
                    "--encrypt-dc-connections": "value",
                    "--kdc-hostname": "value",
                    "--kdc-ip": "value",
                    "--location": "value",
                    "--net-bios-prefix": "value",
                    "--nfs-users-with-ldap": "value",
                    "--organizational-unit": "value",
                    "--password": "value",
                    "--remove-labels": "value",
                    "--security-operators": "value",
                    "--site": "value",
                    "--update-labels": "value",
                    "--username": "value"
                  }
                }
              },
              "flags": {}
            },
            "backup-policies": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--daily-backup-limit": "value",
                    "--description": "value",
                    "--enabled": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--monthly-backup-limit": "value",
                    "--weekly-backup-limit": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--daily-backup-limit": "value",
                    "--description": "value",
                    "--enabled": "value",
                    "--location": "value",
                    "--monthly-backup-limit": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value",
                    "--weekly-backup-limit": "value"
                  }
                }
              },
              "flags": {}
            },
            "backup-vaults": {
              "commands": {
                "backups": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--backup-vault": "value",
                        "--description": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--source-snapshot": "value",
                        "--source-volume": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--backup-vault": "value",
                        "--location": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--backup-vault": "value",
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--backup-vault": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--backup-vault": "value",
                        "--clear-labels": "bool",
                        "--description": "value",
                        "--location": "value",
                        "--remove-labels": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "kms-configs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--kms-key": "value",
                    "--kms-keyring": "value",
                    "--kms-location": "value",
                    "--kms-project": "value",
                    "--labels": "value",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "encrypt": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--kms-key": "value",
                    "--kms-keyring": "value",
                    "--kms-location": "value",
                    "--kms-project": "value",
                    "--location": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                },
                "verify": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "storage-pools": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--active-directory": "value",
                    "--allow-auto-tiering": "value",
                    "--async": "bool",
                    "--capacity": "value",
                    "--description": "value",
                    "--enable-ldap": "value",
                    "--kms-config": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--network": "value",
                    "--replica-zone": "value",
                    "--service-level": [
                      "extreme",
                      "flex",
                      "premium",
                      "standard"
                    ],
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "switch": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--active-directory": "value",
                    "--allow-auto-tiering": "value",
                    "--async": "bool",
                    "--capacity": "value",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--remove-labels": "value",
                    "--replica-zone": "value",
                    "--update-labels": "value",
                    "--zone": "value"
                  }
                },
                "validate-directory-service": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--directory-service-type": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "volumes": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--backup-config": "value",
                    "--backup_vault": "value",
                    "--capacity": "value",
                    "--description": "value",
                    "--enable-kerberos": "value",
                    "--export-policy": "value",
                    "--hybrid-replication-parameters": "value",
                    "--labels": "value",
                    "--large-capacity": "value",
                    "--location": "value",
                    "--multiple-endpoints": "value",
                    "--protocols": "value",
                    "--restricted-actions": "value",
                    "--security-style": [
                      "ntfs",
                      "unix"
                    ],
                    "--share-name": "value",
                    "--smb-settings": "value",
                    "--snap-reserve": "value",
                    "--snapshot-daily": "value",
                    "--snapshot-directory": "value",
                    "--snapshot-hourly": "value",
                    "--snapshot-monthly": "value",
                    "--snapshot-weekly": "value",
                    "--source-backup": "value",
                    "--source-snapshot": "value",
                    "--storage-pool": "value",
                    "--tiering-policy": "value",
                    "--unix-permissions": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--force": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "replications": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--cluster-location": "value",
                        "--description": "value",
                        "--destination-volume-parameters": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--replication-schedule": "value",
                        "--volume": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--volume": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--volume": "value"
                      }
                    },
                    "establish-peering": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--peer-cluster-name": "value",
                        "--peer-ip-addresses": "value",
                        "--peer-svm-name": "value",
                        "--peer-volume-name": "value",
                        "--volume": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--volume": "value"
                      }
                    },
                    "resume": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--volume": "value"
                      }
                    },
                    "reverse": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--volume": "value"
                      }
                    },
                    "stop": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--force": "bool",
                        "--location": "value",
                        "--volume": "value"
                      }
                    },
                    "sync": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--volume": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--cluster-location": "value",
                        "--description": "value",
                        "--location": "value",
                        "--remove-labels": "value",
                        "--replication-schedule": "value",
                        "--update-labels": "value",
                        "--volume": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "revert": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--snapshot": "value"
                  }
                },
                "snapshots": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--volume": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--volume": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--volume": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--volume": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--description": "value",
                        "--location": "value",
                        "--remove-labels": "value",
                        "--update-labels": "value",
                        "--volume": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--backup-config": "value",
                    "--backup_vault": "value",
                    "--capacity": "value",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--enable-kerberos": "value",
                    "--export-policy": "value",
                    "--location": "value",
                    "--protocols": "value",
                    "--remove-labels": "value",
                    "--restricted-actions": "value",
                    "--security-style": [
                      "ntfs",
                      "unix"
                    ],
                    "--share-name": "value",
                    "--smb-settings": "value",
                    "--snap-reserve": "value",
                    "--snapshot-daily": "value",
                    "--snapshot-directory": "value",
                    "--snapshot-hourly": "value",
                    "--snapshot-monthly": "value",
                    "--snapshot-weekly": "value",
                    "--source-backup": "value",
                    "--source-snapshot": "value",
                    "--storage-pool": "value",
                    "--tiering-policy": "value",
                    "--unix-permissions": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "network-connectivity": {
          "commands": {
            "hubs": {
              "commands": {
                "accept-spoke": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--spoke": "value"
                  }
                },
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--export-psc": "bool",
                    "--labels": "value",
                    "--policy-mode": [
                      "policy-mode-unspecified",
                      "preset"
                    ],
                    "--preset-topology": [
                      "hybrid-inspection",
                      "mesh",
                      "preset-topology-unspecified",
                      "star"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "groups": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--hub": "value",
                        "--member": "value",
                        "--role": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--hub": "value"
                      }
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--hub": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--hub": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--hub": "value",
                        "--member": "value",
                        "--role": "dynamic"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {
                        "--hub": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--add-auto-accept-projects": "value",
                        "--async": "bool",
                        "--clear-auto-accept-projects": "bool",
                        "--clear-labels": "bool",
                        "--description": "value",
                        "--hub": "dynamic",
                        "--remove-auto-accept-projects": "value",
                        "--remove-labels": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list-spokes": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--spoke-locations": "value",
                    "--view": [
                      "basic",
                      "detailed"
                    ]
                  }
                },
                "reject-spoke": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--details": "value",
                    "--spoke": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "route-tables": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--hub": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--hub": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    },
                    "routes": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--hub": "value",
                            "--route_table": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--effective-location": "value",
                            "--filter": "value",
                            "--hub": "value",
                            "--limit": "value",
                            "--page-size": "value",
                            "--route_table": "value",
                            "--sort-by": "value"
                          }
                        }
                      },
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--export-psc": "bool",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "policy-based-routes": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--destination-range": "value",
                    "--interconnect-attachment-region": "value",
                    "--ip-protocol": "value",
                    "--labels": "value",
                    "--network": "value",
                    "--next-hop-ilb-ip": "value",
                    "--next-hop-other-routes": [
                      "default-routing",
                      "other-routes-unspecified"
                    ],
                    "--priority": "value",
                    "--protocol-version": [
                      "ipv4",
                      "ipv6",
                      "protocol-version-unspecified"
                    ],
                    "--source-range": "value",
                    "--tags": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "regional-endpoints": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--address": "value",
                    "--async": "bool",
                    "--description": "value",
                    "--enable-global-access": "bool",
                    "--labels": "value",
                    "--network": "value",
                    "--region": "value",
                    "--subnetwork": "value",
                    "--target-google-api": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "spokes": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--global": "bool",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--global": "bool",
                    "--region": "value"
                  }
                },
                "linked-interconnect-attachments": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value",
                        "--group": "value",
                        "--hub": "value",
                        "--include-import-ranges": "value",
                        "--interconnect-attachments": "value",
                        "--labels": "value",
                        "--region": "value",
                        "--site-to-site-data-transfer": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--description": "value",
                        "--include-import-ranges": "value",
                        "--region": "value",
                        "--remove-labels": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "linked-producer-vpc-network": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value",
                        "--exclude-export-ranges": "value",
                        "--global": "bool",
                        "--hub": "value",
                        "--include-export-ranges": "value",
                        "--labels": "value",
                        "--network": "value",
                        "--peering": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--description": "value",
                        "--global": "bool",
                        "--include-export-ranges": "value",
                        "--remove-labels": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "linked-router-appliances": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value",
                        "--group": "value",
                        "--hub": "value",
                        "--include-import-ranges": "value",
                        "--labels": "value",
                        "--region": "value",
                        "--router-appliance": "value",
                        "--site-to-site-data-transfer": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--description": "value",
                        "--include-import-ranges": "value",
                        "--region": "value",
                        "--remove-labels": "value",
                        "--router-appliance": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "linked-vpc-network": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value",
                        "--exclude-export-ranges": "value",
                        "--global": "bool",
                        "--hub": "value",
                        "--include-export-ranges": "value",
                        "--labels": "value",
                        "--vpc-network": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--description": "value",
                        "--global": "bool",
                        "--include-export-ranges": "value",
                        "--remove-labels": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "linked-vpn-tunnels": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value",
                        "--group": "value",
                        "--hub": "value",
                        "--include-import-ranges": "value",
                        "--labels": "value",
                        "--region": "value",
                        "--site-to-site-data-transfer": "bool",
                        "--vpn-tunnels": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--description": "value",
                        "--include-import-ranges": "value",
                        "--region": "value",
                        "--remove-labels": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--global": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "network-management": {
          "commands": {
            "connectivity-tests": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--bypass-firewall-checks": "bool",
                    "--description": "value",
                    "--destination-cloud-sql-instance": "value",
                    "--destination-forwarding-rule": "value",
                    "--destination-fqdn": "value",
                    "--destination-gke-master-cluster": "value",
                    "--destination-instance": "value",
                    "--destination-ip-address": "value",
                    "--destination-network": "value",
                    "--destination-port": "value",
                    "--destination-project": "value",
                    "--destination-redis-cluster": "value",
                    "--destination-redis-instance": "value",
                    "--labels": "value",
                    "--other-projects": "value",
                    "--protocol": "value",
                    "--round-trip": "bool",
                    "--source-app-engine-version": "value",
                    "--source-cloud-function": "value",
                    "--source-cloud-run-revision": "value",
                    "--source-cloud-sql-instance": "value",
                    "--source-gke-master-cluster": "value",
                    "--source-instance": "value",
                    "--source-ip-address": "value",
                    "--source-network": "value",
                    "--source-network-type": [
                      "gcp-network",
                      "non-gcp-network"
                    ],
                    "--source-project": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "rerun": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--bypass-firewall-checks": "bool",
                    "--clear-destination-cloud-sql-instance": "bool",
                    "--clear-destination-forwarding-rule": "bool",
                    "--clear-destination-gke-master-cluster": "bool",
                    "--clear-destination-instance": "bool",
                    "--clear-destination-ip-address": "bool",
                    "--clear-destination-redis-cluster": "bool",
                    "--clear-destination-redis-instance": "bool",
                    "--clear-source-app-engine-version": "bool",
                    "--clear-source-cloud-function": "bool",
                    "--clear-source-cloud-run-revision": "bool",
                    "--clear-source-cloud-sql-instance": "bool",
                    "--clear-source-gke-master-cluster": "bool",
                    "--clear-source-instance": "bool",
                    "--clear-source-ip-address": "bool",
                    "--description": "value",
                    "--destination-cloud-sql-instance": "value",
                    "--destination-forwarding-rule": "value",
                    "--destination-fqdn": "value",
                    "--destination-gke-master-cluster": "value",
                    "--destination-instance": "value",
                    "--destination-ip-address": "value",
                    "--destination-network": "value",
                    "--destination-port": "value",
                    "--destination-project": "value",
                    "--destination-redis-cluster": "value",
                    "--destination-redis-instance": "value",
                    "--labels": "value",
                    "--other-projects": "value",
                    "--protocol": "value",
                    "--round-trip": "bool",
                    "--source-app-engine-version": "value",
                    "--source-cloud-function": "value",
                    "--source-cloud-run-revision": "value",
                    "--source-cloud-sql-instance": "value",
                    "--source-gke-master-cluster": "value",
                    "--source-instance": "value",
                    "--source-ip-address": "value",
                    "--source-network": "value",
                    "--source-network-type": [
                      "gcp-network",
                      "non-gcp-network"
                    ],
                    "--source-project": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "vpc-flow-logs-configs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--aggregation-interval": [
                      "interval-1-min",
                      "interval-10-min",
                      "interval-15-min",
                      "interval-30-sec",
                      "interval-5-min",
                      "interval-5-sec"
                    ],
                    "--async": "bool",
                    "--description": "value",
                    "--filter-expr": "value",
                    "--flow-sampling": "value",
                    "--interconnect-attachment": "value",
                    "--labels": "value",
                    "--location": "dynamic",
                    "--metadata": [
                      "custom-metadata",
                      "exclude-all-metadata",
                      "include-all-metadata"
                    ],
                    "--metadata-fields": "value",
                    "--state": [
                      "disabled",
                      "enabled"
                    ],
                    "--vpn-tunnel": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-metadata-fields": "value",
                    "--aggregation-interval": [
                      "interval-1-min",
                      "interval-10-min",
                      "interval-15-min",
                      "interval-30-sec",
                      "interval-5-min",
                      "interval-5-sec"
                    ],
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--clear-metadata-fields": "bool",
                    "--description": "value",
                    "--filter-expr": "value",
                    "--flow-sampling": "value",
                    "--interconnect-attachment": "value",
                    "--labels": "value",
                    "--location": "dynamic",
                    "--metadata": [
                      "custom-metadata",
                      "exclude-all-metadata",
                      "include-all-metadata"
                    ],
                    "--metadata-fields": "value",
                    "--remove-labels": "value",
                    "--remove-metadata-fields": "value",
                    "--state": [
                      "disabled",
                      "enabled"
                    ],
                    "--update-labels": "value",
                    "--vpn-tunnel": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "network-security": {
          "commands": {
            "address-groups": {
              "commands": {
                "add-items": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--items": "value",
                    "--location": "value"
                  }
                },
                "clone-items": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--capacity": "value",
                    "--description": "value",
                    "--items": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--purpose": "value",
                    "--type": [
                      "ipv4",
                      "ipv6"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-references": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-items": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--items": "value",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--items": "value",
                    "--location": "value",
                    "--purpose": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "authorization-policies": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "authz-policies": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "client-tls-policies": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "firewall-endpoint-associations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--endpoint": "value",
                    "--endpoint-zone": "value",
                    "--labels": "value",
                    "--max-wait": "value",
                    "--network": "value",
                    "--organization": "value",
                    "--tls-inspection-policy": "value",
                    "--tls-inspection-policy-project": "value",
                    "--tls-inspection-policy-region": "value",
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--max-wait": "value",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--disabled": "bool",
                    "--max-wait": "value",
                    "--no-tls-inspection-policy": "bool",
                    "--remove-labels": "value",
                    "--tls-inspection-policy": "value",
                    "--tls-inspection-policy-project": "value",
                    "--tls-inspection-policy-region": "value",
                    "--update-labels": "value",
                    "--zone": "value"
                  }
                }
              },
              "flags": {}
            },
            "firewall-endpoints": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--max-wait": "value",
                    "--organization": "value",
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--max-wait": "value",
                    "--organization": "value",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--organization": "value",
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--max-wait": "value",
                    "--organization": "value",
                    "--remove-labels": "value",
                    "--update-billing-project": "value",
                    "--update-labels": "value",
                    "--zone": "value"
                  }
                }
              },
              "flags": {}
            },
            "gateway-security-policies": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "rules": {
                  "commands": {
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--gateway-security-policy": "value",
                        "--location": "value"
                      }
                    },
                    "export": {
                      "commands": {},
                      "flags": {
                        "--destination": "value",
                        "--gateway-security-policy": "value",
                        "--location": "value"
                      }
                    },
                    "import": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--gateway-security-policy": "value",
                        "--location": "value",
                        "--source": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--gateway-security-policy": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "intercept-deployment-groups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--max-wait": "value",
                    "--network": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--max-wait": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--max-wait": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "intercept-deployments": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--forwarding-rule": "value",
                    "--forwarding-rule-location": "value",
                    "--intercept-deployment-group": "value",
                    "--intercept-deployment-group-location": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--max-wait": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--max-wait": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--max-wait": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "intercept-endpoint-group-associations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--intercept-endpoint-group": "value",
                    "--intercept-endpoint-group-location": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--max-wait": "value",
                    "--network": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--max-wait": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--location": "value",
                    "--max-wait": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "intercept-endpoint-groups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--intercept-deployment-group": "value",
                    "--intercept-deployment-group-location": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--max-wait": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--max-wait": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--max-wait": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "mirroring-deployment-groups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--labels": "value",
                    "--location": "value",
                    "--max-wait": "value",
                    "--network": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--max-wait": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--location": "value",
                    "--max-wait": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "mirroring-deployments": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--forwarding-rule": "value",
                    "--forwarding-rule-location": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--max-wait": "value",
                    "--mirroring-deployment-group": "value",
                    "--mirroring-deployment-group-location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--max-wait": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--location": "value",
                    "--max-wait": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "mirroring-endpoint-group-associations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--labels": "value",
                    "--location": "value",
                    "--max-wait": "value",
                    "--mirroring-endpoint-group": "value",
                    "--mirroring-endpoint-group-location": "value",
                    "--network": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--max-wait": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--location": "value",
                    "--max-wait": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "mirroring-endpoint-groups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--labels": "value",
                    "--location": "value",
                    "--max-wait": "value",
                    "--mirroring-deployment-group": "value",
                    "--mirroring-deployment-group-location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--max-wait": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--location": "value",
                    "--max-wait": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "org-address-groups": {
              "commands": {
                "add-items": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--items": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "clone-items": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--organization": "value",
                    "--source": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--capacity": "value",
                    "--description": "value",
                    "--items": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--type": [
                      "ipv4",
                      "ipv6"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-references": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-items": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--items": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--items": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "security-profile-groups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--custom-intercept-profile": "value",
                    "--custom-intercept-profile-location": "value",
                    "--custom-intercept-profile-organization": "value",
                    "--custom-mirroring-profile": "value",
                    "--custom-mirroring-profile-location": "value",
                    "--custom-mirroring-profile-organization": "value",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--threat-prevention-profile": "value",
                    "--threat-prevention-profile-location": "value",
                    "--threat-prevention-profile-organization": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--remove-labels": "value",
                    "--threat-prevention-profile": "value",
                    "--threat-prevention-profile-location": "value",
                    "--threat-prevention-profile-organization": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "security-profiles": {
              "commands": {
                "custom-intercept": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value",
                        "--intercept-endpoint-group": "value",
                        "--intercept-endpoint-group-location": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--organization": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--organization": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--organization": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--organization": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--description": "value",
                        "--location": "value",
                        "--organization": "value",
                        "--remove-labels": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "custom-mirroring": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--mirroring-endpoint-group": "value",
                        "--mirroring-endpoint-group-location": "value",
                        "--organization": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--organization": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--organization": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--organization": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--description": "value",
                        "--location": "value",
                        "--organization": "value",
                        "--remove-labels": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "threat-prevention": {
                  "commands": {
                    "add-override": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "ALERT",
                          "ALLOW",
                          "DEFAULT_ACTION",
                          "DENY"
                        ],
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--location": "value",
                        "--organization": "value",
                        "--remove-labels": "value",
                        "--severities": "value",
                        "--threat-ids": "value",
                        "--update-labels": "value"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--organization": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--organization": "value"
                      }
                    },
                    "delete-override": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--location": "value",
                        "--organization": "value",
                        "--remove-labels": "value",
                        "--severities": "value",
                        "--threat-ids": "value",
                        "--update-labels": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--organization": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "list-overrides": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--organization": "value"
                      }
                    },
                    "update-override": {
                      "commands": {},
                      "flags": {
                        "--action": [
                          "ALERT",
                          "ALLOW",
                          "DEFAULT_ACTION",
                          "DENY"
                        ],
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--location": "value",
                        "--organization": "value",
                        "--remove-labels": "value",
                        "--severities": "value",
                        "--threat-ids": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "server-tls-policies": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "tls-inspection-policies": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "url-lists": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "network-services": {
          "commands": {
            "endpoint-policies": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "multicast-consumer-associations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--multicast-domain-activation": "value",
                    "--network": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "multicast-domain-activations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--aggr-egress-pps": "value",
                    "--aggr-ingress-pps": "value",
                    "--async": "bool",
                    "--avg-packet-size": "value",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--max-per-group-ingress-pps": "value",
                    "--max-per-group-subscribers": "value",
                    "--multicast-domain": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "multicast-domain-groups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "multicast-domains": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--admin-network": "value",
                    "--async": "bool",
                    "--connection-type": [
                      "connection-type-unspecified",
                      "ncc",
                      "same-vpc"
                    ],
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--multicast-domain-group": "value",
                    "--ncc-hub": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "multicast-group-consumer-activations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--multicast-consumer-association": "value",
                    "--multicast-group-range-activation": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "multicast-group-producer-activations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--multicast-group-range-activation": "value",
                    "--multicast-producer-association": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "multicast-group-range-activations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--multicast-domain-activation": "value",
                    "--multicast-group-range": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "multicast-group-ranges": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--consumer-accept-list": "value",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--multicast-domain": "value",
                    "--reserved-internal-range": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "multicast-producer-associations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--multicast-domain-activation": "value",
                    "--network": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "service-bindings": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--service-directory-namespace": "value",
                    "--service-directory-region": "value",
                    "--service-directory-service": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "service-lb-policies": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--auto-capacity-drain": "bool",
                    "--description": "value",
                    "--failover-health-threshold": "value",
                    "--load-balancing-algorithm": [
                      "spray-to-region",
                      "spray-to-world",
                      "waterfall-by-region",
                      "waterfall-by-zone"
                    ],
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--auto-capacity-drain": "bool",
                    "--description": "value",
                    "--failover-health-threshold": "value",
                    "--load-balancing-algorithm": [
                      "spray-to-region",
                      "spray-to-world",
                      "waterfall-by-region",
                      "waterfall-by-zone"
                    ],
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "notebooks": {
          "commands": {
            "environments": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--container-repository": "value",
                    "--container-tag": "value",
                    "--description": "value",
                    "--display-name": "value",
                    "--location": "dynamic",
                    "--post-startup-script": "value",
                    "--vm-image-family": "value",
                    "--vm-image-name": "value",
                    "--vm-image-project": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "instances": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator-core-count": "value",
                    "--accelerator-type": [
                      "NVIDIA_H100_80GB",
                      "NVIDIA_H100_MEGA_80GB",
                      "NVIDIA_L4",
                      "NVIDIA_TESLA_A100",
                      "NVIDIA_TESLA_K80",
                      "NVIDIA_TESLA_P100",
                      "NVIDIA_TESLA_P100_VWS",
                      "NVIDIA_TESLA_P4",
                      "NVIDIA_TESLA_P4_VWS",
                      "NVIDIA_TESLA_T4",
                      "NVIDIA_TESLA_T4_VWS",
                      "NVIDIA_TESLA_V100",
                      "TPU_V2",
                      "TPU_V3"
                    ],
                    "--async": "bool",
                    "--boot-disk-size": "value",
                    "--boot-disk-type": [
                      "PD_BALANCED",
                      "PD_EXTREME",
                      "PD_SSD",
                      "PD_STANDARD"
                    ],
                    "--container-repository": "value",
                    "--container-tag": "value",
                    "--custom-gpu-driver-path": "value",
                    "--data-disk-size": "value",
                    "--data-disk-type": [
                      "PD_BALANCED",
                      "PD_EXTREME",
                      "PD_SSD",
                      "PD_STANDARD"
                    ],
                    "--disk-encryption": [
                      "CMEK",
                      "GMEK"
                    ],
                    "--environment": "dynamic",
                    "--environment-location": "dynamic",
                    "--install-gpu-driver": "bool",
                    "--instance-owners": "value",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--location": "dynamic",
                    "--machine-type": "value",
                    "--metadata": "value",
                    "--network": "dynamic",
                    "--no-proxy-access": "bool",
                    "--no-public-ip": "bool",
                    "--no-remove-data-disk": "bool",
                    "--post-startup-script": "value",
                    "--reservation": "value",
                    "--reservation-affinity": [
                      "ANY_RESERVATION",
                      "NO_RESERVATION",
                      "SPECIFIC_RESERVATION",
                      "TYPE_UNSPECIFIED"
                    ],
                    "--service-account": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-secure-boot": "bool",
                    "--shielded-vtpm": "bool",
                    "--subnet": "dynamic",
                    "--subnet-region": "dynamic",
                    "--tags": "value",
                    "--vm-image-family": "value",
                    "--vm-image-name": "value",
                    "--vm-image-project": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "diagnose": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--enable-copy-home-files": "bool",
                    "--enable-packet-capture": "bool",
                    "--enable-repair": "bool",
                    "--gcs-bucket": "value",
                    "--location": "dynamic",
                    "--relative-path": "value",
                    "--timeout-minutes": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "is-upgradeable": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "register": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "reset": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "start": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "stop": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--accelerator-core-count": "value",
                    "--accelerator-type": [
                      "NVIDIA_H100_80GB",
                      "NVIDIA_H100_MEGA_80GB",
                      "NVIDIA_L4",
                      "NVIDIA_TESLA_A100",
                      "NVIDIA_TESLA_K80",
                      "NVIDIA_TESLA_P100",
                      "NVIDIA_TESLA_P100_VWS",
                      "NVIDIA_TESLA_P4",
                      "NVIDIA_TESLA_P4_VWS",
                      "NVIDIA_TESLA_T4",
                      "NVIDIA_TESLA_T4_VWS",
                      "NVIDIA_TESLA_V100",
                      "TPU_V2",
                      "TPU_V3"
                    ],
                    "--async": "bool",
                    "--labels": "value",
                    "--location": "dynamic",
                    "--machine-type": "value"
                  }
                },
                "upgrade": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "organizations": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {}
            }
          },
          "flags": {}
        },
        "pam": {
          "commands": {
            "check-onboarding-status": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "entitlements": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--entitlement-file": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "search": {
                  "commands": {},
                  "flags": {
                    "--caller-access-type": [
                      "grant-approver",
                      "grant-requester"
                    ],
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--entitlement-file": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                }
              },
              "flags": {}
            },
            "grants": {
              "commands": {
                "approve": {
                  "commands": {},
                  "flags": {
                    "--entitlement": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--reason": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--additional-email-recipients": "value",
                    "--entitlement": "value",
                    "--folder": "value",
                    "--justification": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--requested-duration": "value"
                  }
                },
                "deny": {
                  "commands": {},
                  "flags": {
                    "--entitlement": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--reason": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--entitlement": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--entitlement": "value",
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "revoke": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--entitlement": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--reason": "value"
                  }
                },
                "search": {
                  "commands": {},
                  "flags": {
                    "--caller-relationship": [
                      "can-approve",
                      "had-approved",
                      "had-created"
                    ],
                    "--entitlement": "value",
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "policy-troubleshoot": {
          "commands": {
            "iam": {
              "commands": {},
              "flags": {
                "--destination-ip": "value",
                "--destination-port": "value",
                "--permission": "value",
                "--principal-email": "value",
                "--request-time": "value",
                "--resource-name": "value",
                "--resource-service": "value",
                "--resource-type": "value"
              }
            }
          },
          "flags": {}
        },
        "projects": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--enable-cloud-apis": "bool",
                "--folder": "value",
                "--labels": "value",
                "--name": "value",
                "--organization": "value",
                "--set-as-default": "bool",
                "--tags": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--recommend": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "get-ancestors": {
              "commands": {},
              "flags": {}
            },
            "get-ancestors-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--include-deny": "bool",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "move": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "value"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--recommend": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {}
            },
            "undelete": {
              "commands": {},
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--name": "value"
              }
            }
          },
          "flags": {}
        },
        "publicca": {
          "commands": {
            "external-account-keys": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--key-output-file": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "pubsub": {
          "commands": {
            "lite-operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--done": "bool",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--subscription": "value"
                  }
                }
              },
              "flags": {}
            },
            "lite-reservations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--throughput-capacity": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list-topics": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--throughput-capacity": "value"
                  }
                }
              },
              "flags": {}
            },
            "lite-subscriptions": {
              "commands": {
                "ack-up-to": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--offset": "value",
                    "--partition": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--delivery-requirement": [
                      "deliver-after-stored",
                      "deliver-immediately"
                    ],
                    "--event-time": "value",
                    "--export-dead-letter-topic": "value",
                    "--export-desired-state": [
                      "active",
                      "paused"
                    ],
                    "--export-pubsub-topic": "value",
                    "--location": "value",
                    "--publish-time": "value",
                    "--starting-offset": [
                      "beginning",
                      "end"
                    ],
                    "--topic": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "seek": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--event-time": "value",
                    "--location": "value",
                    "--publish-time": "value",
                    "--starting-offset": [
                      "beginning",
                      "end"
                    ]
                  }
                },
                "subscribe": {
                  "commands": {},
                  "flags": {
                    "--auto-ack": "bool",
                    "--location": "value",
                    "--num-messages": "value",
                    "--partitions": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--delivery-requirement": [
                      "deliver-after-stored",
                      "deliver-immediately"
                    ],
                    "--export-dead-letter-topic": "value",
                    "--export-desired-state": [
                      "active",
                      "paused"
                    ],
                    "--export-pubsub-topic": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "lite-topics": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--message-retention-period": "value",
                    "--partitions": "value",
                    "--per-partition-bytes": "value",
                    "--per-partition-publish-mib": "value",
                    "--per-partition-subscribe-mib": "value",
                    "--throughput-reservation": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list-subscriptions": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "publish": {
                  "commands": {},
                  "flags": {
                    "--attributes": "value",
                    "--event-time": "value",
                    "--location": "value",
                    "--message": "value",
                    "--ordering-key": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--message-retention-period": "value",
                    "--partitions": "value",
                    "--per-partition-bytes": "value",
                    "--per-partition-publish-mib": "value",
                    "--per-partition-subscribe-mib": "value",
                    "--throughput-reservation": "value"
                  }
                }
              },
              "flags": {}
            },
            "schemas": {
              "commands": {
                "commit": {
                  "commands": {},
                  "flags": {
                    "--definition": "value",
                    "--definition-file": "value",
                    "--type": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--definition": "value",
                    "--definition-file": "value",
                    "--type": [
                      "avro",
                      "protocol-buffer"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "delete-revision": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--view": [
                      "basic",
                      "full"
                    ]
                  }
                },
                "list-revisions": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--view": [
                      "basic",
                      "full"
                    ]
                  }
                },
                "rollback": {
                  "commands": {},
                  "flags": {
                    "--revision-id": "value"
                  }
                },
                "validate-message": {
                  "commands": {},
                  "flags": {
                    "--definition": "value",
                    "--definition-file": "value",
                    "--message": "value",
                    "--message-encoding": [
                      "binary",
                      "json"
                    ],
                    "--schema-name": "value",
                    "--type": [
                      "avro",
                      "protocol-buffer"
                    ]
                  }
                },
                "validate-schema": {
                  "commands": {},
                  "flags": {
                    "--definition": "value",
                    "--definition-file": "value",
                    "--type": [
                      "avro",
                      "protocol-buffer"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "snapshots": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--labels": "value",
                    "--subscription": "value",
                    "--subscription-project": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "subscriptions": {
              "commands": {
                "ack": {
                  "commands": {},
                  "flags": {
                    "--ack-ids": "value"
                  }
                },
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--ack-deadline": "value",
                    "--bigquery-service-account-email": "value",
                    "--bigquery-table": "value",
                    "--cloud-storage-bucket": "value",
                    "--cloud-storage-file-datetime-format": "value",
                    "--cloud-storage-file-prefix": "value",
                    "--cloud-storage-file-suffix": "value",
                    "--cloud-storage-max-bytes": "value",
                    "--cloud-storage-max-duration": "value",
                    "--cloud-storage-max-messages": "value",
                    "--cloud-storage-output-format": "value",
                    "--cloud-storage-service-account-email": "value",
                    "--cloud-storage-use-topic-schema": "bool",
                    "--cloud-storage-write-metadata": "bool",
                    "--dead-letter-topic": "value",
                    "--dead-letter-topic-project": "value",
                    "--drop-unknown-fields": "bool",
                    "--enable-exactly-once-delivery": "bool",
                    "--enable-message-ordering": "bool",
                    "--expiration-period": "value",
                    "--labels": "value",
                    "--max-delivery-attempts": "value",
                    "--max-retry-delay": "value",
                    "--message-filter": "value",
                    "--message-retention-duration": "value",
                    "--min-retry-delay": "value",
                    "--push-auth-service-account": "value",
                    "--push-auth-token-audience": "value",
                    "--push-endpoint": "value",
                    "--push-no-wrapper": "bool",
                    "--push-no-wrapper-write-metadata": "bool",
                    "--retain-acked-messages": "bool",
                    "--topic": "value",
                    "--topic-project": "value",
                    "--use-table-schema": "bool",
                    "--use-topic-schema": "bool",
                    "--write-metadata": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "modify-ack-deadline": {
                  "commands": {},
                  "flags": {
                    "--ack-deadline": "value",
                    "--ack-ids": "value"
                  }
                },
                "modify-message-ack-deadline": {
                  "commands": {},
                  "flags": {
                    "--ack-deadline": "value",
                    "--ack-ids": "value"
                  }
                },
                "modify-push-config": {
                  "commands": {},
                  "flags": {
                    "--push-auth-service-account": "value",
                    "--push-auth-token-audience": "value",
                    "--push-endpoint": "value",
                    "--push-no-wrapper": "bool",
                    "--push-no-wrapper-write-metadata": "bool"
                  }
                },
                "pull": {
                  "commands": {},
                  "flags": {
                    "--auto-ack": "bool",
                    "--filter": "value",
                    "--limit": "value",
                    "--max-messages": "value",
                    "--page-size": "value",
                    "--return-immediately": "bool",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--wait": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "seek": {
                  "commands": {},
                  "flags": {
                    "--snapshot": "value",
                    "--snapshot-project": "value",
                    "--time": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--ack-deadline": "value",
                    "--bigquery-service-account-email": "value",
                    "--bigquery-table": "value",
                    "--clear-bigquery-config": "bool",
                    "--clear-cloud-storage-config": "bool",
                    "--clear-dead-letter-policy": "bool",
                    "--clear-labels": "bool",
                    "--clear-push-no-wrapper-config": "bool",
                    "--clear-retry-policy": "bool",
                    "--cloud-storage-bucket": "value",
                    "--cloud-storage-file-datetime-format": "value",
                    "--cloud-storage-file-prefix": "value",
                    "--cloud-storage-file-suffix": "value",
                    "--cloud-storage-max-bytes": "value",
                    "--cloud-storage-max-duration": "value",
                    "--cloud-storage-max-messages": "value",
                    "--cloud-storage-output-format": "value",
                    "--cloud-storage-service-account-email": "value",
                    "--cloud-storage-use-topic-schema": "bool",
                    "--cloud-storage-write-metadata": "bool",
                    "--dead-letter-topic": "value",
                    "--dead-letter-topic-project": "value",
                    "--drop-unknown-fields": "bool",
                    "--enable-exactly-once-delivery": "bool",
                    "--expiration-period": "value",
                    "--max-delivery-attempts": "value",
                    "--max-retry-delay": "value",
                    "--message-retention-duration": "value",
                    "--min-retry-delay": "value",
                    "--push-auth-service-account": "value",
                    "--push-auth-token-audience": "value",
                    "--push-endpoint": "value",
                    "--push-no-wrapper": "bool",
                    "--push-no-wrapper-write-metadata": "bool",
                    "--remove-labels": "value",
                    "--retain-acked-messages": "bool",
                    "--update-labels": "value",
                    "--use-table-schema": "bool",
                    "--use-topic-schema": "bool",
                    "--write-metadata": "bool"
                  }
                }
              },
              "flags": {}
            },
            "topics": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--cloud-storage-ingestion-bucket": "value",
                    "--cloud-storage-ingestion-input-format": "value",
                    "--cloud-storage-ingestion-match-glob": "value",
                    "--cloud-storage-ingestion-minimum-object-create-time": "value",
                    "--cloud-storage-ingestion-text-delimiter": "value",
                    "--first-revision-id": "value",
                    "--ingestion-log-severity": "value",
                    "--kinesis-ingestion-consumer-arn": "value",
                    "--kinesis-ingestion-role-arn": "value",
                    "--kinesis-ingestion-service-account": "value",
                    "--kinesis-ingestion-stream-arn": "value",
                    "--labels": "value",
                    "--last-revision-id": "value",
                    "--message-encoding": "value",
                    "--message-retention-duration": "value",
                    "--message-storage-policy-allowed-regions": "value",
                    "--message-storage-policy-enforce-in-transit": "bool",
                    "--schema": "value",
                    "--schema-project": "value",
                    "--topic-encryption-key": "dynamic",
                    "--topic-encryption-key-keyring": "dynamic",
                    "--topic-encryption-key-location": "dynamic",
                    "--topic-encryption-key-project": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "detach-subscription": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-subscriptions": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "publish": {
                  "commands": {},
                  "flags": {
                    "--attribute": "value",
                    "--message": "value",
                    "--ordering-key": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-ingestion-data-source-settings": "bool",
                    "--clear-labels": "bool",
                    "--clear-message-retention-duration": "bool",
                    "--clear-schema-settings": "bool",
                    "--cloud-storage-ingestion-bucket": "value",
                    "--cloud-storage-ingestion-input-format": "value",
                    "--cloud-storage-ingestion-match-glob": "value",
                    "--cloud-storage-ingestion-minimum-object-create-time": "value",
                    "--cloud-storage-ingestion-text-delimiter": "value",
                    "--first-revision-id": "value",
                    "--ingestion-log-severity": "value",
                    "--kinesis-ingestion-consumer-arn": "value",
                    "--kinesis-ingestion-role-arn": "value",
                    "--kinesis-ingestion-service-account": "value",
                    "--kinesis-ingestion-stream-arn": "value",
                    "--last-revision-id": "value",
                    "--message-encoding": "value",
                    "--message-retention-duration": "value",
                    "--message-storage-policy-allowed-regions": "value",
                    "--message-storage-policy-enforce-in-transit": "bool",
                    "--recompute-message-storage-policy": "bool",
                    "--remove-labels": "value",
                    "--schema": "value",
                    "--schema-project": "value",
                    "--topic-encryption-key": "dynamic",
                    "--topic-encryption-key-keyring": "dynamic",
                    "--topic-encryption-key-location": "dynamic",
                    "--topic-encryption-key-project": "dynamic",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "quotas": {
          "commands": {
            "adjuster": {
              "commands": {
                "settings": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--enablement": [
                          "disabled",
                          "enabled"
                        ],
                        "--validate-only": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "info": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "dynamic",
                    "--service": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--organization": "dynamic",
                    "--page-size": "value",
                    "--service": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "preferences": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--allow-high-percentage-quota-decrease": "bool",
                    "--allow-quota-decrease-below-usage": "bool",
                    "--dimensions": "value",
                    "--email": "value",
                    "--folder": "value",
                    "--justification": "value",
                    "--organization": "dynamic",
                    "--preference-id": "value",
                    "--preferred-value": "value",
                    "--quota-id": "value",
                    "--service": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--organization": "dynamic",
                    "--page-size": "value",
                    "--reconciling-only": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--allow-high-percentage-quota-decrease": "bool",
                    "--allow-missing": "bool",
                    "--allow-quota-decrease-below-usage": "bool",
                    "--dimensions": "value",
                    "--email": "value",
                    "--folder": "value",
                    "--justification": "value",
                    "--organization": "dynamic",
                    "--preferred-value": "value",
                    "--quota-id": "value",
                    "--service": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "recommender": {
          "commands": {
            "insight-type-config": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--annotations": "value",
                    "--billing-account": "value",
                    "--config-file": "value",
                    "--display-name": "value",
                    "--etag": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            },
            "insights": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--folder": "value",
                    "--insight-type": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--filter": "value",
                    "--folder": "value",
                    "--insight-type": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "mark-accepted": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--etag": "value",
                    "--folder": "value",
                    "--insight-type": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--state-metadata": "value"
                  }
                }
              },
              "flags": {}
            },
            "recommendations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--recommender": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--recommender": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "mark-claimed": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--etag": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--recommender": "value",
                    "--state-metadata": "value"
                  }
                },
                "mark-dismissed": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--etag": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--recommender": "value"
                  }
                },
                "mark-failed": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--etag": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--recommender": "value",
                    "--state-metadata": "value"
                  }
                },
                "mark-succeeded": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--etag": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--recommender": "value",
                    "--state-metadata": "value"
                  }
                }
              },
              "flags": {}
            },
            "recommender-config": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--billing-account": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--annotations": "value",
                    "--billing-account": "value",
                    "--config-file": "value",
                    "--display-name": "value",
                    "--etag": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "redis": {
          "commands": {
            "clusters": {
              "commands": {
                "add-cluster-endpoints": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster-endpoint": "value",
                    "--region": "dynamic"
                  }
                },
                "backup-collections": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "dynamic",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "backups": {
                  "commands": {
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--backup-collection": "dynamic",
                        "--region": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--backup-collection": "dynamic",
                        "--region": "dynamic"
                      }
                    },
                    "export": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--backup-collection": "dynamic",
                        "--gcs-bucket": "value",
                        "--region": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--backup-collection": "dynamic",
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "dynamic",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--aof-append-fsync": [
                      "always",
                      "everysec",
                      "no"
                    ],
                    "--async": "bool",
                    "--auth-mode": [
                      "disabled",
                      "iam-auth"
                    ],
                    "--automated-backup-mode": [
                      "disabled",
                      "enabled"
                    ],
                    "--automated-backup-start-time": "value",
                    "--automated-backup-ttl": "value",
                    "--cross-cluster-replication-role": [
                      "secondary"
                    ],
                    "--deletion-protection": "bool",
                    "--import-gcs-object-uris": "value",
                    "--import-managed-backup": "value",
                    "--kms-key": "value",
                    "--maintenance-window-day": [
                      "friday",
                      "monday",
                      "saturday",
                      "sunday",
                      "thursday",
                      "tuesday",
                      "wednesday"
                    ],
                    "--maintenance-window-hour": "value",
                    "--network": "value",
                    "--node-type": [
                      "redis-highmem-medium",
                      "redis-highmem-xlarge",
                      "redis-shared-core-nano",
                      "redis-standard-small"
                    ],
                    "--persistence-mode": [
                      "aof",
                      "disabled",
                      "rdb"
                    ],
                    "--primary-cluster": "value",
                    "--rdb-snapshot-period": [
                      "12h",
                      "1h",
                      "24h",
                      "6h"
                    ],
                    "--rdb-snapshot-start-time": "value",
                    "--redis-config": "value",
                    "--region": "dynamic",
                    "--replica-count": "value",
                    "--shard-count": "value",
                    "--transit-encryption-mode": [
                      "disabled",
                      "server-authentication"
                    ],
                    "--zone": "value",
                    "--zone-distribution-mode": [
                      "multi-zone",
                      "single-zone"
                    ]
                  }
                },
                "create-backup": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--backup-id": "value",
                    "--region": "dynamic",
                    "--ttl": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "detach": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "detach-secondaries": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clusters-to-detach": "value",
                    "--region": "dynamic"
                  }
                },
                "get-cluster-certificate-authority": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-cluster-endpoints": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster-endpoint": "value",
                    "--region": "dynamic"
                  }
                },
                "reschedule-maintenance": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic",
                    "--reschedule-type": [
                      "immediate",
                      "specific-time"
                    ],
                    "--schedule-time": "value"
                  }
                },
                "switchover": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--aof-append-fsync": [
                      "always",
                      "everysec",
                      "no"
                    ],
                    "--async": "bool",
                    "--automated-backup-mode": [
                      "disabled",
                      "enabled"
                    ],
                    "--automated-backup-start-time": "value",
                    "--automated-backup-ttl": "value",
                    "--deletion-protection": "bool",
                    "--maintenance-window-any": "bool",
                    "--maintenance-window-day": [
                      "friday",
                      "monday",
                      "saturday",
                      "sunday",
                      "thursday",
                      "tuesday",
                      "wednesday"
                    ],
                    "--maintenance-window-hour": "value",
                    "--persistence-mode": [
                      "aof",
                      "disabled",
                      "rdb"
                    ],
                    "--rdb-snapshot-period": [
                      "12h",
                      "1h",
                      "24h",
                      "6h"
                    ],
                    "--rdb-snapshot-start-time": "value",
                    "--region": "dynamic",
                    "--remove-redis-config": "value",
                    "--replica-count": "value",
                    "--shard-count": "value",
                    "--update-redis-config": "value"
                  }
                }
              },
              "flags": {}
            },
            "instances": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--alternative-zone": "value",
                    "--async": "bool",
                    "--connect-mode": [
                      "connect-mode-unspecified",
                      "direct-peering",
                      "private-service-access"
                    ],
                    "--customer-managed-key": "value",
                    "--display-name": "value",
                    "--enable-auth": "bool",
                    "--labels": "value",
                    "--maintenance-window-day": [
                      "day-of-week-unspecified",
                      "friday",
                      "monday",
                      "saturday",
                      "sunday",
                      "thursday",
                      "tuesday",
                      "wednesday"
                    ],
                    "--maintenance-window-hour": "value",
                    "--network": "value",
                    "--persistence-mode": [
                      "disabled",
                      "rdb"
                    ],
                    "--rdb-snapshot-period": [
                      "12h",
                      "1h",
                      "24h",
                      "6h"
                    ],
                    "--rdb-snapshot-start-time": "value",
                    "--read-replicas-mode": [
                      "read-replicas-disabled",
                      "read-replicas-enabled"
                    ],
                    "--redis-config": "value",
                    "--redis-version": [
                      "redis_3_2",
                      "redis_4_0",
                      "redis_5_0",
                      "redis_6_x",
                      "redis_7_0",
                      "redis_7_2"
                    ],
                    "--region": "dynamic",
                    "--replica-count": "value",
                    "--reserved-ip-range": "value",
                    "--size": "value",
                    "--tier": [
                      "basic",
                      "standard"
                    ],
                    "--transit-encryption-mode": [
                      "disabled",
                      "server-authentication"
                    ],
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "failover": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--data-protection-mode": [
                      "force-data-loss",
                      "limited-data-loss"
                    ],
                    "--region": "dynamic"
                  }
                },
                "get-auth-string": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "reschedule-maintenance": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "dynamic",
                    "--reschedule-type": [
                      "immediate",
                      "next-available-window",
                      "specific-time"
                    ],
                    "--schedule-time": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--display-name": "value",
                    "--enable-auth": "bool",
                    "--maintenance-version": "value",
                    "--maintenance-window-any": "bool",
                    "--maintenance-window-day": [
                      "day-of-week-unspecified",
                      "friday",
                      "monday",
                      "saturday",
                      "sunday",
                      "thursday",
                      "tuesday",
                      "wednesday"
                    ],
                    "--maintenance-window-hour": "value",
                    "--persistence-mode": [
                      "disabled",
                      "rdb"
                    ],
                    "--rdb-snapshot-period": [
                      "12h",
                      "1h",
                      "24h",
                      "6h"
                    ],
                    "--rdb-snapshot-start-time": "value",
                    "--read-replicas-mode": [
                      "read-replicas-disabled",
                      "read-replicas-enabled"
                    ],
                    "--region": "dynamic",
                    "--remove-labels": "value",
                    "--remove-redis-config": "value",
                    "--replica-count": "value",
                    "--secondary-ip-range": "value",
                    "--size": "value",
                    "--update-labels": "value",
                    "--update-redis-config": "value"
                  }
                },
                "upgrade": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--redis-version": [
                      "redis_4_0",
                      "redis_5_0",
                      "redis_6_x",
                      "redis_7_0",
                      "redis_7_2"
                    ],
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "regions": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "zones": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "resource-config": {
          "commands": {
            "bulk-export": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--on-error": [
                  "continue",
                  "halt",
                  "ignore"
                ],
                "--organization": "value",
                "--path": "value",
                "--resource-format": [
                  "krm",
                  "terraform"
                ],
                "--resource-types": "value",
                "--resource-types-file": "value",
                "--storage-path": "value"
              }
            },
            "list-resource-types": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "value"
              }
            },
            "terraform": {
              "commands": {
                "generate-import": {
                  "commands": {},
                  "flags": {
                    "--output-dir": "value",
                    "--output-module-file": "value",
                    "--output-script-file": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "resource-manager": {
          "commands": {
            "folders": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--display-name": "value",
                    "--folder": "value",
                    "--organization": "value",
                    "--tags": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-ancestors-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--include-deny": "bool",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--show-deleted": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "move": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "undelete": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--display-name": "value"
                  }
                }
              },
              "flags": {}
            },
            "org-policies": {
              "commands": {
                "allow": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "dynamic"
                  }
                },
                "deny": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--effective": "bool",
                    "--folder": "value",
                    "--organization": "dynamic"
                  }
                },
                "disable-enforce": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "dynamic"
                  }
                },
                "enable-enforce": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--organization": "dynamic",
                    "--page-size": "value",
                    "--show-unset": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "set-policy": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "tags": {
              "commands": {
                "bindings": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--parent": "value",
                        "--tag-value": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--parent": "value",
                        "--tag-value": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--effective": "bool",
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--parent": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "holds": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--help-link": "value",
                        "--holder": "value",
                        "--location": "value",
                        "--origin": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--holder": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--origin": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "keys": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--member": "value",
                        "--role": "value"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value",
                        "--parent": "value",
                        "--purpose": [
                          "DATA_GOVERNANCE",
                          "GCE_FIREWALL"
                        ],
                        "--purpose-data": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--parent": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--member": "value",
                        "--role": "value"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {}
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "values": {
                  "commands": {
                    "add-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--member": "value",
                        "--role": "value"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value",
                        "--parent": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "get-iam-policy": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--parent": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "remove-iam-policy-binding": {
                      "commands": {},
                      "flags": {
                        "--all": "bool",
                        "--condition": "value",
                        "--condition-from-file": "value",
                        "--member": "value",
                        "--role": "value"
                      }
                    },
                    "set-iam-policy": {
                      "commands": {},
                      "flags": {}
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--description": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "run": {
          "commands": {
            "deploy": {
              "commands": {},
              "flags": {
                "--add-cloudsql-instances": "value",
                "--add-custom-audiences": "value",
                "--add-volume": "value",
                "--add-volume-mount": "value",
                "--allow-unauthenticated": "bool",
                "--allow-unencrypted-build": "bool",
                "--args": "value",
                "--async": "bool",
                "--automatic-updates": "bool",
                "--base-image": "value",
                "--binary-authorization": "value",
                "--breakglass": "value",
                "--build-env-vars-file": "value",
                "--build-service-account": "value",
                "--build-worker-pool": "value",
                "--clear-base-image": "bool",
                "--clear-binary-authorization": "bool",
                "--clear-build-env-vars": "bool",
                "--clear-build-service-account": "bool",
                "--clear-build-worker-pool": "bool",
                "--clear-cloudsql-instances": "bool",
                "--clear-config-maps": "bool",
                "--clear-custom-audiences": "bool",
                "--clear-encryption-key-shutdown-hours": "bool",
                "--clear-env-vars": "bool",
                "--clear-key": "bool",
                "--clear-labels": "bool",
                "--clear-network": "bool",
                "--clear-network-tags": "bool",
                "--clear-post-key-revocation-action-type": "bool",
                "--clear-secrets": "bool",
                "--clear-volume-mounts": "bool",
                "--clear-volumes": "bool",
                "--clear-vpc-connector": "bool",
                "--command": "value",
                "--concurrency": "value",
                "--container": "value",
                "--cpu": "value",
                "--cpu-boost": "bool",
                "--cpu-throttling": "bool",
                "--default-url": "bool",
                "--depends-on": "value",
                "--deploy-health-check": "bool",
                "--description": "value",
                "--encryption-key-shutdown-hours": "value",
                "--env-vars-file": "value",
                "--execution-environment": [
                  "gen1",
                  "gen2"
                ],
                "--function": "value",
                "--gpu": "value",
                "--gpu-type": "value",
                "--image": "value",
                "--ingress": [
                  "all",
                  "internal",
                  "internal-and-cloud-load-balancing"
                ],
                "--invoker-iam-check": "bool",
                "--key": "value",
                "--labels": "value",
                "--liveness-probe": "value",
                "--max-instances": "value",
                "--memory": "value",
                "--mesh": "value",
                "--min": "value",
                "--min-instances": "value",
                "--namespace": "value",
                "--network": "value",
                "--network-tags": "value",
                "--no-traffic": "bool",
                "--port": "value",
                "--post-key-revocation-action-type": [
                  "prevent-new",
                  "shut-down"
                ],
                "--region": "value",
                "--remove-build-env-vars": "value",
                "--remove-cloudsql-instances": "value",
                "--remove-config-maps": "value",
                "--remove-containers": "value",
                "--remove-custom-audiences": "value",
                "--remove-env-vars": "value",
                "--remove-labels": "value",
                "--remove-secrets": "value",
                "--remove-volume": "value",
                "--remove-volume-mount": "value",
                "--revision-suffix": "value",
                "--service-account": "value",
                "--session-affinity": "bool",
                "--set-build-env-vars": "value",
                "--set-cloudsql-instances": "value",
                "--set-config-maps": "value",
                "--set-custom-audiences": "value",
                "--set-env-vars": "value",
                "--set-secrets": "value",
                "--source": "value",
                "--startup-probe": "value",
                "--subnet": "value",
                "--tag": "value",
                "--timeout": "value",
                "--update-build-env-vars": "value",
                "--update-config-maps": "value",
                "--update-env-vars": "value",
                "--update-labels": "value",
                "--update-secrets": "value",
                "--use-http2": "bool",
                "--vpc-connector": "value",
                "--vpc-egress": [
                  "all",
                  "all-traffic",
                  "private-ranges-only"
                ]
              }
            },
            "domain-mappings": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--domain": "value",
                    "--force-override": "bool",
                    "--namespace": "value",
                    "--region": "value",
                    "--service": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--domain": "value",
                    "--namespace": "value",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--domain": "value",
                    "--namespace": "value",
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--namespace": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {
                "--region": "value"
              }
            },
            "jobs": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--region": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--add-volume": "value",
                    "--add-volume-mount": "value",
                    "--args": "value",
                    "--async": "bool",
                    "--binary-authorization": "value",
                    "--breakglass": "value",
                    "--clear-env-vars": "bool",
                    "--clear-secrets": "bool",
                    "--clear-volume-mounts": "bool",
                    "--clear-volumes": "bool",
                    "--command": "value",
                    "--container": "value",
                    "--cpu": "value",
                    "--depends-on": "value",
                    "--env-vars-file": "value",
                    "--execute-now": "bool",
                    "--image": "value",
                    "--key": "value",
                    "--labels": "value",
                    "--max-retries": "value",
                    "--memory": "value",
                    "--network": "value",
                    "--network-tags": "value",
                    "--parallelism": "value",
                    "--region": "value",
                    "--remove-env-vars": "value",
                    "--remove-secrets": "value",
                    "--remove-volume": "value",
                    "--remove-volume-mount": "value",
                    "--service-account": "value",
                    "--set-cloudsql-instances": "value",
                    "--set-env-vars": "value",
                    "--set-secrets": "value",
                    "--subnet": "value",
                    "--task-timeout": "value",
                    "--tasks": "value",
                    "--update-env-vars": "value",
                    "--update-secrets": "value",
                    "--vpc-connector": "value",
                    "--vpc-egress": [
                      "all",
                      "all-traffic",
                      "private-ranges-only"
                    ],
                    "--wait": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "deploy": {
                  "commands": {},
                  "flags": {
                    "--add-volume": "value",
                    "--add-volume-mount": "value",
                    "--args": "value",
                    "--async": "bool",
                    "--binary-authorization": "value",
                    "--breakglass": "value",
                    "--clear-env-vars": "bool",
                    "--clear-network": "bool",
                    "--clear-network-tags": "bool",
                    "--clear-secrets": "bool",
                    "--clear-volume-mounts": "bool",
                    "--clear-volumes": "bool",
                    "--command": "value",
                    "--container": "value",
                    "--cpu": "value",
                    "--depends-on": "value",
                    "--env-vars-file": "value",
                    "--execute-now": "bool",
                    "--image": "value",
                    "--key": "value",
                    "--labels": "value",
                    "--max-retries": "value",
                    "--memory": "value",
                    "--network": "value",
                    "--network-tags": "value",
                    "--parallelism": "value",
                    "--region": "value",
                    "--remove-containers": "value",
                    "--remove-env-vars": "value",
                    "--remove-secrets": "value",
                    "--remove-volume": "value",
                    "--remove-volume-mount": "value",
                    "--service-account": "value",
                    "--set-cloudsql-instances": "value",
                    "--set-env-vars": "value",
                    "--set-secrets": "value",
                    "--source": "value",
                    "--subnet": "value",
                    "--task-timeout": "value",
                    "--tasks": "value",
                    "--update-env-vars": "value",
                    "--update-secrets": "value",
                    "--vpc-connector": "value",
                    "--vpc-egress": [
                      "all",
                      "all-traffic",
                      "private-ranges-only"
                    ],
                    "--wait": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "execute": {
                  "commands": {},
                  "flags": {
                    "--args": "value",
                    "--async": "bool",
                    "--container": "value",
                    "--region": "value",
                    "--task-timeout": "value",
                    "--tasks": "value",
                    "--update-env-vars": "value",
                    "--wait": "bool"
                  }
                },
                "executions": {
                  "commands": {
                    "cancel": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--region": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--region": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--job": "value",
                        "--limit": "value",
                        "--namespace": "value",
                        "--page-size": "value",
                        "--region": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "logs": {
                      "commands": {
                        "read": {
                          "commands": {},
                          "flags": {
                            "--freshness": "value",
                            "--limit": "value",
                            "--log-filter": "value",
                            "--order": [
                              "asc",
                              "desc"
                            ],
                            "--region": "value"
                          }
                        },
                        "tail": {
                          "commands": {},
                          "flags": {
                            "--log-filter": "value",
                            "--region": "value"
                          }
                        }
                      },
                      "flags": {
                        "--region": "value"
                      }
                    },
                    "tasks": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--region": "value"
                          }
                        },
                        "list": {
                          "commands": {},
                          "flags": {
                            "--abandoned": "bool",
                            "--cancelled": "bool",
                            "--completed": "bool",
                            "--execution": "value",
                            "--failed": "bool",
                            "--filter": "value",
                            "--limit": "value",
                            "--no-completed": "bool",
                            "--no-started": "bool",
                            "--page-size": "value",
                            "--pending": "bool",
                            "--region": "value",
                            "--running": "bool",
                            "--sort-by": "value",
                            "--started": "bool",
                            "--succeeded": "bool",
                            "--uri": "bool"
                          }
                        }
                      },
                      "flags": {
                        "--region": "value"
                      }
                    }
                  },
                  "flags": {
                    "--region": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--namespace": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "logs": {
                  "commands": {
                    "read": {
                      "commands": {},
                      "flags": {
                        "--freshness": "value",
                        "--limit": "value",
                        "--log-filter": "value",
                        "--order": [
                          "asc",
                          "desc"
                        ],
                        "--region": "value"
                      }
                    },
                    "tail": {
                      "commands": {},
                      "flags": {
                        "--log-filter": "value",
                        "--region": "value"
                      }
                    }
                  },
                  "flags": {
                    "--region": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--region": "value",
                    "--role": "dynamic"
                  }
                },
                "replace": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-cloudsql-instances": "value",
                    "--add-volume": "value",
                    "--add-volume-mount": "value",
                    "--args": "value",
                    "--async": "bool",
                    "--binary-authorization": "value",
                    "--breakglass": "value",
                    "--clear-binary-authorization": "bool",
                    "--clear-cloudsql-instances": "bool",
                    "--clear-env-vars": "bool",
                    "--clear-labels": "bool",
                    "--clear-network": "bool",
                    "--clear-network-tags": "bool",
                    "--clear-secrets": "bool",
                    "--clear-volume-mounts": "bool",
                    "--clear-volumes": "bool",
                    "--clear-vpc-connector": "bool",
                    "--command": "value",
                    "--container": "value",
                    "--cpu": "value",
                    "--depends-on": "value",
                    "--env-vars-file": "value",
                    "--execute-now": "bool",
                    "--image": "value",
                    "--key": "value",
                    "--labels": "value",
                    "--max-retries": "value",
                    "--memory": "value",
                    "--network": "value",
                    "--network-tags": "value",
                    "--parallelism": "value",
                    "--region": "value",
                    "--remove-cloudsql-instances": "value",
                    "--remove-containers": "value",
                    "--remove-env-vars": "value",
                    "--remove-labels": "value",
                    "--remove-secrets": "value",
                    "--remove-volume": "value",
                    "--remove-volume-mount": "value",
                    "--service-account": "value",
                    "--set-cloudsql-instances": "value",
                    "--set-env-vars": "value",
                    "--set-secrets": "value",
                    "--subnet": "value",
                    "--task-timeout": "value",
                    "--tasks": "value",
                    "--update-env-vars": "value",
                    "--update-labels": "value",
                    "--update-secrets": "value",
                    "--vpc-connector": "value",
                    "--vpc-egress": [
                      "all",
                      "all-traffic",
                      "private-ranges-only"
                    ],
                    "--wait": "bool"
                  }
                }
              },
              "flags": {
                "--region": "value"
              }
            },
            "multi-region-services": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--namespace": "value",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--namespace": "value",
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "replace": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--dry-run": "bool",
                    "--region": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-cloudsql-instances": "value",
                    "--add-custom-audiences": "value",
                    "--add-volume": "value",
                    "--add-volume-mount": "value",
                    "--args": "value",
                    "--async": "bool",
                    "--binary-authorization": "value",
                    "--breakglass": "value",
                    "--clear-binary-authorization": "bool",
                    "--clear-cloudsql-instances": "bool",
                    "--clear-config-maps": "bool",
                    "--clear-custom-audiences": "bool",
                    "--clear-encryption-key-shutdown-hours": "bool",
                    "--clear-env-vars": "bool",
                    "--clear-key": "bool",
                    "--clear-labels": "bool",
                    "--clear-network": "bool",
                    "--clear-network-tags": "bool",
                    "--clear-post-key-revocation-action-type": "bool",
                    "--clear-secrets": "bool",
                    "--clear-volume-mounts": "bool",
                    "--clear-volumes": "bool",
                    "--clear-vpc-connector": "bool",
                    "--command": "value",
                    "--concurrency": "value",
                    "--container": "value",
                    "--cpu": "value",
                    "--cpu-boost": "bool",
                    "--cpu-throttling": "bool",
                    "--default-url": "bool",
                    "--depends-on": "value",
                    "--deploy-health-check": "bool",
                    "--encryption-key-shutdown-hours": "value",
                    "--env-vars-file": "value",
                    "--execution-environment": [
                      "gen1",
                      "gen2"
                    ],
                    "--gpu-type": "value",
                    "--image": "value",
                    "--ingress": [
                      "all",
                      "internal",
                      "internal-and-cloud-load-balancing"
                    ],
                    "--invoker-iam-check": "bool",
                    "--key": "value",
                    "--labels": "value",
                    "--max-instances": "value",
                    "--memory": "value",
                    "--mesh": "value",
                    "--min": "value",
                    "--min-instances": "value",
                    "--namespace": "value",
                    "--network": "value",
                    "--network-tags": "value",
                    "--no-traffic": "bool",
                    "--port": "value",
                    "--post-key-revocation-action-type": [
                      "prevent-new",
                      "shut-down"
                    ],
                    "--region": "value",
                    "--remove-cloudsql-instances": "value",
                    "--remove-config-maps": "value",
                    "--remove-containers": "value",
                    "--remove-custom-audiences": "value",
                    "--remove-env-vars": "value",
                    "--remove-labels": "value",
                    "--remove-secrets": "value",
                    "--remove-volume": "value",
                    "--remove-volume-mount": "value",
                    "--revision-suffix": "value",
                    "--service-account": "value",
                    "--session-affinity": "bool",
                    "--set-cloudsql-instances": "value",
                    "--set-config-maps": "value",
                    "--set-custom-audiences": "value",
                    "--set-env-vars": "value",
                    "--set-secrets": "value",
                    "--subnet": "value",
                    "--tag": "value",
                    "--timeout": "value",
                    "--update-config-maps": "value",
                    "--update-env-vars": "value",
                    "--update-labels": "value",
                    "--update-secrets": "value",
                    "--use-http2": "bool",
                    "--vpc-connector": "value",
                    "--vpc-egress": [
                      "all",
                      "all-traffic",
                      "private-ranges-only"
                    ]
                  }
                }
              },
              "flags": {
                "--region": "value"
              }
            },
            "regions": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "revisions": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--namespace": "value",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--namespace": "value",
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--service": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "logs": {
                  "commands": {
                    "read": {
                      "commands": {},
                      "flags": {
                        "--freshness": "value",
                        "--limit": "value",
                        "--log-filter": "value",
                        "--order": [
                          "asc",
                          "desc"
                        ],
                        "--region": "value"
                      }
                    },
                    "tail": {
                      "commands": {},
                      "flags": {
                        "--log-filter": "value",
                        "--region": "value"
                      }
                    }
                  },
                  "flags": {
                    "--region": "value"
                  }
                }
              },
              "flags": {
                "--region": "value"
              }
            },
            "services": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--region": "value",
                    "--role": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--namespace": "value",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--namespace": "value",
                    "--region": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "logs": {
                  "commands": {
                    "read": {
                      "commands": {},
                      "flags": {
                        "--freshness": "value",
                        "--limit": "value",
                        "--log-filter": "value",
                        "--order": [
                          "asc",
                          "desc"
                        ],
                        "--region": "value"
                      }
                    },
                    "tail": {
                      "commands": {},
                      "flags": {
                        "--log-filter": "value",
                        "--region": "value"
                      }
                    }
                  },
                  "flags": {
                    "--region": "value"
                  }
                },
                "proxy": {
                  "commands": {},
                  "flags": {
                    "--namespace": "value",
                    "--port": "value",
                    "--region": "value",
                    "--tag": "value",
                    "--token": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--region": "value",
                    "--role": "dynamic"
                  }
                },
                "replace": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--dry-run": "bool",
                    "--region": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-cloudsql-instances": "value",
                    "--add-custom-audiences": "value",
                    "--add-volume": "value",
                    "--add-volume-mount": "value",
                    "--args": "value",
                    "--async": "bool",
                    "--binary-authorization": "value",
                    "--breakglass": "value",
                    "--clear-binary-authorization": "bool",
                    "--clear-cloudsql-instances": "bool",
                    "--clear-config-maps": "bool",
                    "--clear-custom-audiences": "bool",
                    "--clear-encryption-key-shutdown-hours": "bool",
                    "--clear-env-vars": "bool",
                    "--clear-key": "bool",
                    "--clear-labels": "bool",
                    "--clear-network": "bool",
                    "--clear-network-tags": "bool",
                    "--clear-post-key-revocation-action-type": "bool",
                    "--clear-secrets": "bool",
                    "--clear-volume-mounts": "bool",
                    "--clear-volumes": "bool",
                    "--clear-vpc-connector": "bool",
                    "--command": "value",
                    "--concurrency": "value",
                    "--container": "value",
                    "--cpu": "value",
                    "--cpu-boost": "bool",
                    "--cpu-throttling": "bool",
                    "--default-url": "bool",
                    "--depends-on": "value",
                    "--deploy-health-check": "bool",
                    "--encryption-key-shutdown-hours": "value",
                    "--env-vars-file": "value",
                    "--execution-environment": [
                      "gen1",
                      "gen2"
                    ],
                    "--gpu": "value",
                    "--gpu-type": "value",
                    "--image": "value",
                    "--ingress": [
                      "all",
                      "internal",
                      "internal-and-cloud-load-balancing"
                    ],
                    "--invoker-iam-check": "bool",
                    "--key": "value",
                    "--labels": "value",
                    "--liveness-probe": "value",
                    "--max-instances": "value",
                    "--memory": "value",
                    "--mesh": "value",
                    "--min": "value",
                    "--min-instances": "value",
                    "--namespace": "value",
                    "--network": "value",
                    "--network-tags": "value",
                    "--no-traffic": "bool",
                    "--port": "value",
                    "--post-key-revocation-action-type": [
                      "prevent-new",
                      "shut-down"
                    ],
                    "--region": "value",
                    "--remove-cloudsql-instances": "value",
                    "--remove-config-maps": "value",
                    "--remove-containers": "value",
                    "--remove-custom-audiences": "value",
                    "--remove-env-vars": "value",
                    "--remove-labels": "value",
                    "--remove-secrets": "value",
                    "--remove-volume": "value",
                    "--remove-volume-mount": "value",
                    "--revision-suffix": "value",
                    "--service-account": "value",
                    "--session-affinity": "bool",
                    "--set-cloudsql-instances": "value",
                    "--set-config-maps": "value",
                    "--set-custom-audiences": "value",
                    "--set-env-vars": "value",
                    "--set-secrets": "value",
                    "--startup-probe": "value",
                    "--subnet": "value",
                    "--tag": "value",
                    "--timeout": "value",
                    "--update-config-maps": "value",
                    "--update-env-vars": "value",
                    "--update-labels": "value",
                    "--update-secrets": "value",
                    "--use-http2": "bool",
                    "--vpc-connector": "value",
                    "--vpc-egress": [
                      "all",
                      "all-traffic",
                      "private-ranges-only"
                    ]
                  }
                },
                "update-traffic": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-tags": "bool",
                    "--namespace": "value",
                    "--region": "value",
                    "--remove-tags": "value",
                    "--set-tags": "value",
                    "--to-latest": "bool",
                    "--to-revisions": "value",
                    "--to-tags": "value",
                    "--update-tags": "value"
                  }
                }
              },
              "flags": {
                "--region": "value"
              }
            }
          },
          "flags": {}
        },
        "runtime-config": {
          "commands": {
            "configs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value"
                  }
                },
                "variables": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--config-name": "value"
                      }
                    },
                    "get-value": {
                      "commands": {},
                      "flags": {
                        "--config-name": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--config-name": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--values": "bool"
                      }
                    },
                    "set": {
                      "commands": {},
                      "flags": {
                        "--config-name": "value",
                        "--fail-if-absent": "bool",
                        "--fail-if-present": "bool",
                        "--is-text": "bool"
                      }
                    },
                    "unset": {
                      "commands": {},
                      "flags": {
                        "--config-name": "value",
                        "--fail-if-absent": "bool",
                        "--recursive": "bool"
                      }
                    },
                    "watch": {
                      "commands": {},
                      "flags": {
                        "--config-name": "value",
                        "--max-wait": "value",
                        "--newer-than": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "waiters": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--config-name": "value",
                        "--failure-cardinality-number": "value",
                        "--failure-cardinality-path": "value",
                        "--success-cardinality-number": "value",
                        "--success-cardinality-path": "value",
                        "--timeout": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--config-name": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--config-name": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--config-name": "value",
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "wait": {
                      "commands": {},
                      "flags": {
                        "--config-name": "value",
                        "--max-wait": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "scc": {
          "commands": {
            "assets": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--asset": "value",
                    "--resource-name": "value"
                  }
                },
                "get-parent": {
                  "commands": {},
                  "flags": {
                    "--asset": "value",
                    "--resource-name": "value"
                  }
                },
                "get-project": {
                  "commands": {},
                  "flags": {
                    "--asset": "value",
                    "--resource-name": "value"
                  }
                },
                "group": {
                  "commands": {},
                  "flags": {
                    "--compare-duration": "value",
                    "--filter": "value",
                    "--group-by": "value",
                    "--page-size": "value",
                    "--page-token": "value",
                    "--read-time": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--compare-duration": "value",
                    "--field-mask": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--order-by": "value",
                    "--page-size": "value",
                    "--page-token": "value",
                    "--read-time": "value",
                    "--sort-by": "value"
                  }
                },
                "list-marks": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--page-token": "value",
                    "--read-time": "value",
                    "--sort-by": "value"
                  }
                },
                "run-discovery": {
                  "commands": {},
                  "flags": {}
                },
                "update-marks": {
                  "commands": {},
                  "flags": {
                    "--organization": "value",
                    "--security-marks": "value",
                    "--start-time": "value",
                    "--update-mask": "value"
                  }
                }
              },
              "flags": {}
            },
            "findings": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--category": "value",
                    "--event-time": "value",
                    "--external-uri": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--resource-name": "value",
                    "--source": "value",
                    "--source-properties": "value",
                    "--state": [
                      "active",
                      "inactive",
                      "state-unspecified"
                    ]
                  }
                },
                "group": {
                  "commands": {},
                  "flags": {
                    "--compare-duration": "value",
                    "--filter": "value",
                    "--group-by": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--page-token": "value",
                    "--read-time": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--compare-duration": "value",
                    "--field-mask": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--order-by": "value",
                    "--page-size": "value",
                    "--page-token": "value",
                    "--read-time": "value",
                    "--sort-by": "value",
                    "--source": "value"
                  }
                },
                "list-marks": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--page-token": "value",
                    "--read-time": "value",
                    "--sort-by": "value",
                    "--source": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--event-time": "value",
                    "--external-uri": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--source": "value",
                    "--source-properties": "value",
                    "--state": [
                      "active",
                      "inactive",
                      "state-unspecified"
                    ],
                    "--update-mask": "value"
                  }
                },
                "update-marks": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--organization": "value",
                    "--security-marks": "value",
                    "--source": "value",
                    "--start-time": "value",
                    "--update-mask": "value"
                  }
                }
              },
              "flags": {}
            },
            "notifications": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--filter": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--pubsub-topic": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--filter": "value",
                    "--folder": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--pubsub-topic": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--organization": "value"
                  }
                }
              },
              "flags": {}
            },
            "sources": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--source": "value",
                    "--source-display-name": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "scheduler": {
          "commands": {
            "jobs": {
              "commands": {
                "create": {
                  "commands": {
                    "app-engine": {
                      "commands": {},
                      "flags": {
                        "--attempt-deadline": "value",
                        "--description": "value",
                        "--headers": "value",
                        "--http-method": [
                          "delete",
                          "get",
                          "head",
                          "post",
                          "put"
                        ],
                        "--location": "value",
                        "--max-backoff": "value",
                        "--max-doublings": "value",
                        "--max-retry-attempts": "value",
                        "--max-retry-duration": "value",
                        "--message-body": "value",
                        "--message-body-from-file": "value",
                        "--min-backoff": "value",
                        "--relative-url": "value",
                        "--schedule": "value",
                        "--service": "value",
                        "--time-zone": "value"
                      }
                    },
                    "http": {
                      "commands": {},
                      "flags": {
                        "--attempt-deadline": "value",
                        "--description": "value",
                        "--headers": "value",
                        "--http-method": [
                          "delete",
                          "get",
                          "head",
                          "post",
                          "put"
                        ],
                        "--location": "value",
                        "--max-backoff": "value",
                        "--max-doublings": "value",
                        "--max-retry-attempts": "value",
                        "--max-retry-duration": "value",
                        "--message-body": "value",
                        "--message-body-from-file": "value",
                        "--min-backoff": "value",
                        "--oauth-service-account-email": "value",
                        "--oauth-token-scope": "value",
                        "--oidc-service-account-email": "value",
                        "--oidc-token-audience": "value",
                        "--schedule": "value",
                        "--time-zone": "value",
                        "--uri": "value"
                      }
                    },
                    "pubsub": {
                      "commands": {},
                      "flags": {
                        "--attributes": "value",
                        "--description": "value",
                        "--location": "value",
                        "--max-backoff": "value",
                        "--max-doublings": "value",
                        "--max-retry-attempts": "value",
                        "--max-retry-duration": "value",
                        "--message-body": "value",
                        "--message-body-from-file": "value",
                        "--min-backoff": "value",
                        "--schedule": "value",
                        "--time-zone": "value",
                        "--topic": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "pause": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "resume": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "run": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {
                    "app-engine": {
                      "commands": {},
                      "flags": {
                        "--attempt-deadline": "value",
                        "--clear-headers": "bool",
                        "--clear-max-backoff": "bool",
                        "--clear-max-doublings": "bool",
                        "--clear-max-retry-attempts": "bool",
                        "--clear-max-retry-duration": "bool",
                        "--clear-message-body": "bool",
                        "--clear-min-backoff": "bool",
                        "--clear-relative-url": "bool",
                        "--clear-service": "bool",
                        "--clear-time-zone": "bool",
                        "--description": "value",
                        "--http-method": [
                          "delete",
                          "get",
                          "head",
                          "post",
                          "put"
                        ],
                        "--location": "value",
                        "--max-backoff": "value",
                        "--max-doublings": "value",
                        "--max-retry-attempts": "value",
                        "--max-retry-duration": "value",
                        "--message-body": "value",
                        "--message-body-from-file": "value",
                        "--min-backoff": "value",
                        "--relative-url": "value",
                        "--remove-headers": "value",
                        "--schedule": "value",
                        "--service": "value",
                        "--time-zone": "value",
                        "--update-headers": "value"
                      }
                    },
                    "http": {
                      "commands": {},
                      "flags": {
                        "--attempt-deadline": "value",
                        "--clear-auth-token": "bool",
                        "--clear-headers": "bool",
                        "--clear-max-backoff": "bool",
                        "--clear-max-doublings": "bool",
                        "--clear-max-retry-attempts": "bool",
                        "--clear-max-retry-duration": "bool",
                        "--clear-message-body": "bool",
                        "--clear-min-backoff": "bool",
                        "--clear-time-zone": "bool",
                        "--description": "value",
                        "--http-method": [
                          "delete",
                          "get",
                          "head",
                          "post",
                          "put"
                        ],
                        "--location": "value",
                        "--max-backoff": "value",
                        "--max-doublings": "value",
                        "--max-retry-attempts": "value",
                        "--max-retry-duration": "value",
                        "--message-body": "value",
                        "--message-body-from-file": "value",
                        "--min-backoff": "value",
                        "--oauth-service-account-email": "value",
                        "--oauth-token-scope": "value",
                        "--oidc-service-account-email": "value",
                        "--oidc-token-audience": "value",
                        "--remove-headers": "value",
                        "--schedule": "value",
                        "--time-zone": "value",
                        "--update-headers": "value",
                        "--uri": "value"
                      }
                    },
                    "pubsub": {
                      "commands": {},
                      "flags": {
                        "--clear-attributes": "bool",
                        "--clear-max-backoff": "bool",
                        "--clear-max-doublings": "bool",
                        "--clear-max-retry-attempts": "bool",
                        "--clear-max-retry-duration": "bool",
                        "--clear-min-backoff": "bool",
                        "--clear-time-zone": "bool",
                        "--description": "value",
                        "--location": "value",
                        "--max-backoff": "value",
                        "--max-doublings": "value",
                        "--max-retry-attempts": "value",
                        "--max-retry-duration": "value",
                        "--message-body": "value",
                        "--message-body-from-file": "value",
                        "--min-backoff": "value",
                        "--remove-attributes": "value",
                        "--schedule": "value",
                        "--time-zone": "value",
                        "--topic": "value",
                        "--update-attributes": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "secrets": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--location": "dynamic",
                "--member": "value",
                "--role": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--data-file": "value",
                "--expire-time": "value",
                "--kms-key-name": "value",
                "--labels": "value",
                "--location": "dynamic",
                "--locations": "value",
                "--next-rotation-time": "value",
                "--regional-kms-key-name": "value",
                "--replication-policy": "value",
                "--replication-policy-file": "value",
                "--rotation-period": "value",
                "--set-annotations": "value",
                "--topics": "value",
                "--ttl": "value",
                "--version-destroy-ttl": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--etag": "value",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--location": "dynamic",
                "--member": "value",
                "--role": "value"
              }
            },
            "replication": {
              "commands": {
                "get": {
                  "commands": {},
                  "flags": {}
                },
                "set": {
                  "commands": {},
                  "flags": {
                    "--replication-policy-file": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--remove-cmek": "bool",
                    "--set-kms-key": "value"
                  }
                }
              },
              "flags": {}
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-topics": "value",
                "--clear-annotations": "bool",
                "--clear-labels": "bool",
                "--clear-topics": "bool",
                "--clear-version-aliases": "bool",
                "--etag": "value",
                "--expire-time": "value",
                "--location": "dynamic",
                "--next-rotation-time": "value",
                "--regional-kms-key-name": "value",
                "--remove-annotations": "value",
                "--remove-expiration": "bool",
                "--remove-labels": "value",
                "--remove-next-rotation-time": "bool",
                "--remove-regional-kms-key-name": "bool",
                "--remove-rotation-period": "bool",
                "--remove-rotation-schedule": "bool",
                "--remove-topics": "value",
                "--remove-version-aliases": "value",
                "--remove-version-destroy-ttl": "bool",
                "--rotation-period": "value",
                "--ttl": "value",
                "--update-annotations": "value",
                "--update-labels": "value",
                "--update-version-aliases": "value",
                "--version-destroy-ttl": "value"
              }
            },
            "versions": {
              "commands": {
                "access": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic",
                    "--out-file": "value",
                    "--secret": "dynamic"
                  }
                },
                "add": {
                  "commands": {},
                  "flags": {
                    "--data-file": "value",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic",
                    "--secret": "dynamic"
                  }
                },
                "destroy": {
                  "commands": {},
                  "flags": {
                    "--etag": "value",
                    "--location": "dynamic",
                    "--secret": "dynamic"
                  }
                },
                "disable": {
                  "commands": {},
                  "flags": {
                    "--etag": "value",
                    "--location": "dynamic",
                    "--secret": "dynamic"
                  }
                },
                "enable": {
                  "commands": {},
                  "flags": {
                    "--etag": "value",
                    "--location": "dynamic",
                    "--secret": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "service-directory": {
          "commands": {
            "endpoints": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--address": "value",
                    "--location": "value",
                    "--metadata": "value",
                    "--namespace": "value",
                    "--network": "value",
                    "--port": "value",
                    "--service": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--namespace": "value",
                    "--service": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--namespace": "value",
                    "--service": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--location": "value",
                    "--namespace": "value",
                    "--page-size": "value",
                    "--service": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--address": "value",
                    "--location": "value",
                    "--metadata": "value",
                    "--namespace": "value",
                    "--port": "value",
                    "--service": "value"
                  }
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "namespaces": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--labels": "value",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--labels": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "services": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--namespace": "value",
                    "--role": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--metadata": "value",
                    "--namespace": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--namespace": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--namespace": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--namespace": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--location": "value",
                    "--namespace": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--namespace": "value",
                    "--role": "value"
                  }
                },
                "resolve": {
                  "commands": {},
                  "flags": {
                    "--endpoint-filter": "value",
                    "--location": "value",
                    "--max-endpoints": "value",
                    "--namespace": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--namespace": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--metadata": "value",
                    "--namespace": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "service-extensions": {
          "commands": {
            "authz-extensions": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "lb-route-extensions": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "lb-traffic-extensions": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "wasm-plugin-versions": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--image": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--plugin-config": "value",
                    "--plugin-config-file": "value",
                    "--plugin-config-uri": "value",
                    "--wasm-plugin": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--wasm-plugin": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--wasm-plugin": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--wasm-plugin": "value"
                  }
                }
              },
              "flags": {}
            },
            "wasm-plugins": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--image": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--log-config": "value",
                    "--main-version": "value",
                    "--plugin-config": "value",
                    "--plugin-config-file": "value",
                    "--plugin-config-uri": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--image": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--log-config": "value",
                    "--main-version": "value",
                    "--plugin-config": "value",
                    "--plugin-config-file": "value",
                    "--plugin-config-uri": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "services": {
          "commands": {
            "api-keys": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--allowed-application": "value",
                    "--allowed-bundle-ids": "value",
                    "--allowed-ips": "value",
                    "--allowed-referrers": "value",
                    "--annotations": "value",
                    "--api-target": "value",
                    "--async": "bool",
                    "--display-name": "value",
                    "--key-id": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-key-string": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--show-deleted": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "lookup": {
                  "commands": {},
                  "flags": {}
                },
                "undelete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--key-string": "value",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--allowed-application": "value",
                    "--allowed-bundle-ids": "value",
                    "--allowed-ips": "value",
                    "--allowed-referrers": "value",
                    "--annotations": "value",
                    "--api-target": "value",
                    "--async": "bool",
                    "--clear-annotations": "bool",
                    "--clear-restrictions": "bool",
                    "--display-name": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "disable": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--force": "bool"
              }
            },
            "enable": {
              "commands": {},
              "flags": {
                "--async": "bool"
              }
            },
            "identity": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value",
                    "--service": "value"
                  }
                }
              },
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--available": "bool",
                "--enabled": "bool",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--full": "value"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "peered-dns-domains": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--dns-suffix": "value",
                    "--network": "value",
                    "--service": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--network": "value",
                    "--service": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--network": "value",
                    "--service": "value"
                  }
                }
              },
              "flags": {}
            },
            "vpc-peerings": {
              "commands": {
                "connect": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--network": "value",
                    "--ranges": "value",
                    "--service": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--network": "value",
                    "--service": "value"
                  }
                },
                "disable-vpc-service-controls": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--network": "value",
                    "--service": "value"
                  }
                },
                "enable-vpc-service-controls": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--network": "value",
                    "--service": "value"
                  }
                },
                "get-vpc-service-controls": {
                  "commands": {},
                  "flags": {
                    "--network": "value",
                    "--service": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--network": "value",
                    "--service": "value"
                  }
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--name": "value"
                      }
                    },
                    "wait": {
                      "commands": {},
                      "flags": {
                        "--name": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--force": "bool",
                    "--network": "value",
                    "--ranges": "value",
                    "--service": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "source": {
          "commands": {
            "project-configs": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-topic": "value",
                    "--disable-pushblock": "bool",
                    "--enable-pushblock": "bool",
                    "--message-format": [
                      "json",
                      "protobuf"
                    ],
                    "--remove-topic": "value",
                    "--service-account": "value",
                    "--topic-project": "value",
                    "--update-topic": "value"
                  }
                }
              },
              "flags": {}
            },
            "repos": {
              "commands": {
                "clone": {
                  "commands": {},
                  "flags": {
                    "--dry-run": "bool",
                    "--use-full-gcloud-path": "bool"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--force": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-topic": "value",
                    "--message-format": [
                      "json",
                      "protobuf"
                    ],
                    "--remove-topic": "value",
                    "--service-account": "value",
                    "--topic-project": "value",
                    "--update-topic": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "source-manager": {
          "commands": {
            "instances": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--ca-pool": "value",
                    "--enable-workforce-identity-federation": "bool",
                    "--is-private": "bool",
                    "--kms-key": "value",
                    "--max-wait": "value",
                    "--region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--max-wait": "value",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "locations": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "repos": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--default-branch": "value",
                    "--description": "value",
                    "--gitignores": "value",
                    "--instance": "value",
                    "--license": "value",
                    "--readme": "value",
                    "--region": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--allow-missing": "bool",
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--instance": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--region": "dynamic",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "spanner": {
          "commands": {
            "backup-schedules": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--database": "dynamic",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--backup-type": "value",
                    "--cron": "value",
                    "--database": "value",
                    "--encryption-type": [
                      "customer-managed-encryption",
                      "google-default-encryption",
                      "use-database-encryption"
                    ],
                    "--instance": "value",
                    "--kms-key": "value",
                    "--kms-keyring": "value",
                    "--kms-keys": "value",
                    "--kms-location": "value",
                    "--kms-project": "value",
                    "--retention-duration": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--database": "value",
                    "--instance": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--database": "value",
                    "--instance": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--database": "dynamic",
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--database": "value",
                    "--filter": "value",
                    "--instance": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--database": "dynamic",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--database": "dynamic",
                    "--instance": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--cron": "value",
                    "--database": "value",
                    "--encryption-type": [
                      "customer-managed-encryption",
                      "google-default-encryption",
                      "use-database-encryption"
                    ],
                    "--instance": "value",
                    "--kms-key": "value",
                    "--kms-keyring": "value",
                    "--kms-keys": "value",
                    "--kms-location": "value",
                    "--kms-project": "value",
                    "--retention-duration": "value"
                  }
                }
              },
              "flags": {}
            },
            "backups": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "copy": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--destination-backup": "value",
                    "--destination-instance": "value",
                    "--encryption-type": [
                      "customer-managed-encryption",
                      "google-default-encryption",
                      "use-config-default-or-backup-encryption"
                    ],
                    "--expiration-date": "value",
                    "--kms-key": "value",
                    "--kms-keyring": "value",
                    "--kms-keys": "value",
                    "--kms-location": "value",
                    "--kms-project": "value",
                    "--retention-period": "value",
                    "--source-backup": "value",
                    "--source-instance": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--database": "value",
                    "--encryption-type": [
                      "customer-managed-encryption",
                      "google-default-encryption",
                      "use-database-encryption"
                    ],
                    "--expiration-date": "value",
                    "--instance": "value",
                    "--kms-key": "value",
                    "--kms-keyring": "value",
                    "--kms-keys": "value",
                    "--kms-location": "value",
                    "--kms-project": "value",
                    "--retention-period": "value",
                    "--version-time": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--database": "value",
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "update-metadata": {
                  "commands": {},
                  "flags": {
                    "--expiration-date": "value",
                    "--instance": "dynamic",
                    "--retention-period": "value"
                  }
                }
              },
              "flags": {}
            },
            "databases": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "change-quorum": {
                  "commands": {},
                  "flags": {
                    "--dual-region": "bool",
                    "--etag": "value",
                    "--instance": "value",
                    "--serving-location": "value",
                    "--single-region": "bool"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--database-dialect": [
                      "GOOGLE_STANDARD_SQL",
                      "POSTGRESQL"
                    ],
                    "--ddl": "value",
                    "--ddl-file": "dynamic",
                    "--instance": "value",
                    "--kms-key": "value",
                    "--kms-keyring": "value",
                    "--kms-keys": "value",
                    "--kms-location": "value",
                    "--kms-project": "value",
                    "--proto-descriptors-file": "dynamic"
                  }
                },
                "ddl": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--include-proto-descriptors": "bool",
                        "--instance": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--ddl": "value",
                        "--ddl-file": "dynamic",
                        "--instance": "value",
                        "--proto-descriptors-file": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--instance": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--instance": "value"
                  }
                },
                "execute-sql": {
                  "commands": {},
                  "flags": {
                    "--database-role": "value",
                    "--enable-partitioned-dml": "bool",
                    "--instance": "value",
                    "--priority": [
                      "high",
                      "low",
                      "medium",
                      "unspecified"
                    ],
                    "--query-mode": [
                      "NORMAL",
                      "PLAN",
                      "PROFILE"
                    ],
                    "--read-timestamp": "value",
                    "--sql": "value",
                    "--strong": "bool",
                    "--timeout": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "restore": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--destination-database": "value",
                    "--destination-instance": "value",
                    "--encryption-type": [
                      "customer-managed-encryption",
                      "google-default-encryption",
                      "use-config-default-or-backup-encryption"
                    ],
                    "--kms-key": "value",
                    "--kms-keyring": "value",
                    "--kms-keys": "value",
                    "--kms-location": "value",
                    "--kms-project": "value",
                    "--source-backup": "value",
                    "--source-instance": "value"
                  }
                },
                "roles": {
                  "commands": {
                    "list": {
                      "commands": {},
                      "flags": {
                        "--database": "value",
                        "--filter": "value",
                        "--instance": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "sessions": {
                  "commands": {
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--database": "value",
                        "--instance": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--database": "value",
                        "--filter": "value",
                        "--instance": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--server-filter": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--instance": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--enable-drop-protection": "bool",
                    "--instance": "value"
                  }
                }
              },
              "flags": {}
            },
            "instance-configs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--add-replicas": "value",
                    "--async": "bool",
                    "--base-config": "value",
                    "--clone-config": "dynamic",
                    "--display-name": "value",
                    "--etag": "value",
                    "--labels": "value",
                    "--replicas": "value",
                    "--skip-replicas": "value",
                    "--validate-only": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--etag": "value",
                    "--validate-only": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--display-name": "value",
                    "--etag": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            },
            "instance-partitions": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--config": "dynamic",
                    "--description": "value",
                    "--instance": "value",
                    "--nodes": "value",
                    "--processing-units": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--instance": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--instance": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--instance": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--instance": "value",
                    "--nodes": "value",
                    "--processing-units": "value"
                  }
                }
              },
              "flags": {}
            },
            "instances": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--asymmetric-autoscaling-option": "value",
                    "--async": "bool",
                    "--autoscaling-high-priority-cpu-target": "value",
                    "--autoscaling-max-nodes": "value",
                    "--autoscaling-max-processing-units": "value",
                    "--autoscaling-min-nodes": "value",
                    "--autoscaling-min-processing-units": "value",
                    "--autoscaling-storage-target": "value",
                    "--config": "dynamic",
                    "--default-backup-schedule-type": [
                      "AUTOMATIC",
                      "DEFAULT_BACKUP_SCHEDULE_TYPE_UNSPECIFIED",
                      "NONE"
                    ],
                    "--description": "value",
                    "--edition": [
                      "EDITION_UNSPECIFIED",
                      "ENTERPRISE",
                      "ENTERPRISE_PLUS",
                      "STANDARD"
                    ],
                    "--expire-behavior": [
                      "free-to-provisioned",
                      "remove-after-grace-period"
                    ],
                    "--instance-type": [
                      "free-instance",
                      "provisioned"
                    ],
                    "--nodes": "value",
                    "--processing-units": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "get-locations": {
                  "commands": {},
                  "flags": {
                    "--verbose": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "move": {
                  "commands": {},
                  "flags": {
                    "--target-config": "dynamic"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--asymmetric-autoscaling-option": "value",
                    "--async": "bool",
                    "--autoscaling-high-priority-cpu-target": "value",
                    "--autoscaling-max-nodes": "value",
                    "--autoscaling-max-processing-units": "value",
                    "--autoscaling-min-nodes": "value",
                    "--autoscaling-min-processing-units": "value",
                    "--autoscaling-storage-target": "value",
                    "--clear-asymmetric-autoscaling-option": "value",
                    "--default-backup-schedule-type": [
                      "AUTOMATIC",
                      "DEFAULT_BACKUP_SCHEDULE_TYPE_UNSPECIFIED",
                      "NONE"
                    ],
                    "--description": "value",
                    "--edition": "value",
                    "--expire-behavior": [
                      "free-to-provisioned",
                      "remove-after-grace-period"
                    ],
                    "--instance-type": [
                      "free-instance",
                      "provisioned"
                    ],
                    "--nodes": "value",
                    "--processing-units": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--backup": "dynamic",
                    "--database": "dynamic",
                    "--instance": "dynamic",
                    "--instance-config": "dynamic",
                    "--instance-partition": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--backup": "dynamic",
                    "--database": "dynamic",
                    "--instance": "dynamic",
                    "--instance-config": "dynamic",
                    "--instance-partition": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--backup": "dynamic",
                    "--database": "dynamic",
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--instance-config": "dynamic",
                    "--instance-partition": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--type": [
                      "BACKUP",
                      "DATABASE",
                      "DATABASE_CHANGE_QUORUM",
                      "DATABASE_CREATE",
                      "DATABASE_RESTORE",
                      "DATABASE_UPDATE_DDL",
                      "INSTANCE",
                      "INSTANCE_CONFIG_CREATE",
                      "INSTANCE_CONFIG_UPDATE",
                      "INSTANCE_PARTITION"
                    ],
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "rows": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--database": "value",
                    "--instance": "value",
                    "--keys": "value",
                    "--table": "value"
                  }
                },
                "insert": {
                  "commands": {},
                  "flags": {
                    "--data": "value",
                    "--database": "value",
                    "--instance": "value",
                    "--table": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--data": "value",
                    "--database": "value",
                    "--instance": "value",
                    "--table": "value"
                  }
                }
              },
              "flags": {}
            },
            "samples": {
              "commands": {
                "backend": {
                  "commands": {},
                  "flags": {
                    "--database-id": "value",
                    "--duration": "value",
                    "--instance-id": "value",
                    "--port": "value"
                  }
                },
                "init": {
                  "commands": {},
                  "flags": {
                    "--database-id": "value",
                    "--instance-id": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "run": {
                  "commands": {},
                  "flags": {
                    "--cleanup": "bool",
                    "--database-id": "value",
                    "--duration": "value",
                    "--instance-id": "value",
                    "--skip-init": "bool"
                  }
                },
                "workload": {
                  "commands": {},
                  "flags": {
                    "--duration": "value",
                    "--port": "value",
                    "--target-qps": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "sql": {
          "commands": {
            "backups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--instance": "dynamic",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--instance": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "restore": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--backup-instance": "dynamic",
                    "--backup-project": "value",
                    "--restore-instance": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "connect": {
              "commands": {},
              "flags": {
                "--database": "value",
                "--port": "value",
                "--user": "value"
              }
            },
            "databases": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--charset": "value",
                    "--collation": "value",
                    "--instance": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "patch": {
                  "commands": {},
                  "flags": {
                    "--charset": "value",
                    "--collation": "value",
                    "--diff": "bool",
                    "--instance": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "export": {
              "commands": {
                "bak": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--bak-type": [
                      "DIFF",
                      "FULL",
                      "TLOG"
                    ],
                    "--database": "value",
                    "--differential-base": "bool",
                    "--export-log-end-time": "value",
                    "--export-log-start-time": "value",
                    "--stripe_count": "value",
                    "--striped": "bool"
                  }
                },
                "csv": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--database": "value",
                    "--escape": "value",
                    "--fields-terminated-by": "value",
                    "--lines-terminated-by": "value",
                    "--offload": "bool",
                    "--query": "value",
                    "--quote": "value"
                  }
                },
                "sql": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clean": "bool",
                    "--database": "value",
                    "--if-exists": "bool",
                    "--offload": "bool",
                    "--parallel": "bool",
                    "--table": "value",
                    "--threads": "value"
                  }
                }
              },
              "flags": {}
            },
            "flags": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--database-version": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "generate-login-token": {
              "commands": {},
              "flags": {
                "--application-default-credential": "bool",
                "--instance": "dynamic"
              }
            },
            "import": {
              "commands": {
                "bak": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--bak-type": [
                      "DIFF",
                      "FULL",
                      "TLOG"
                    ],
                    "--cert-path": "value",
                    "--database": "value",
                    "--no-recovery": "bool",
                    "--prompt-for-pvk-password": "bool",
                    "--pvk-password": "value",
                    "--pvk-path": "value",
                    "--recovery-only": "bool",
                    "--stop-at": "value",
                    "--stop-at-mark": "value",
                    "--striped": "bool"
                  }
                },
                "csv": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--columns": "value",
                    "--database": "value",
                    "--escape": "value",
                    "--fields-terminated-by": "value",
                    "--lines-terminated-by": "value",
                    "--quote": "value",
                    "--table": "value",
                    "--user": "value"
                  }
                },
                "sql": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clean": "bool",
                    "--database": "value",
                    "--if-exists": "bool",
                    "--parallel": "bool",
                    "--threads": "value",
                    "--user": "value"
                  }
                }
              },
              "flags": {}
            },
            "instances": {
              "commands": {
                "clone": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--bin-log-file-name": "value",
                    "--bin-log-position": "value",
                    "--point-in-time": "value",
                    "--preferred-secondary-zone": "value",
                    "--preferred-zone": "value",
                    "--restore-database-name": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--activation-policy": [
                      "always",
                      "never"
                    ],
                    "--active-directory-domain": "value",
                    "--allocated-ip-range-name": "value",
                    "--allowed-psc-projects": "value",
                    "--assign-ip": "bool",
                    "--async": "bool",
                    "--audit-bucket-path": "value",
                    "--audit-retention-interval": "value",
                    "--audit-upload-interval": "value",
                    "--authorized-networks": "value",
                    "--availability-type": [
                      "regional",
                      "zonal"
                    ],
                    "--backup": "bool",
                    "--backup-location": "value",
                    "--backup-start-time": "value",
                    "--cascadable-replica": "bool",
                    "--client-certificate-path": "value",
                    "--client-key-path": "value",
                    "--collation": "value",
                    "--connector-enforcement": [
                      "CONNECTOR_ENFORCEMENT_UNSPECIFIED",
                      "NOT_REQUIRED",
                      "REQUIRED"
                    ],
                    "--cpu": "value",
                    "--database-flags": "value",
                    "--database-version": "value",
                    "--deletion-protection": "bool",
                    "--deny-maintenance-period-end-date": "value",
                    "--deny-maintenance-period-start-date": "value",
                    "--deny-maintenance-period-time": "value",
                    "--disk-encryption-key": "dynamic",
                    "--disk-encryption-key-keyring": "dynamic",
                    "--disk-encryption-key-location": "dynamic",
                    "--disk-encryption-key-project": "dynamic",
                    "--edition": [
                      "enterprise",
                      "enterprise-plus"
                    ],
                    "--enable-bin-log": "bool",
                    "--enable-data-cache": "bool",
                    "--enable-dataplex-integration": "bool",
                    "--enable-google-ml-integration": "bool",
                    "--enable-google-private-path": "bool",
                    "--enable-password-policy": "bool",
                    "--enable-point-in-time-recovery": "bool",
                    "--enable-private-service-connect": "bool",
                    "--failover-replica-name": "value",
                    "--gce-zone": "value",
                    "--insights-config-query-insights-enabled": "bool",
                    "--insights-config-query-plans-per-minute": "value",
                    "--insights-config-query-string-length": "value",
                    "--insights-config-record-application-tags": "bool",
                    "--insights-config-record-client-address": "bool",
                    "--labels": "value",
                    "--maintenance-release-channel": [
                      "preview",
                      "production",
                      "week5"
                    ],
                    "--maintenance-window-day": [
                      "FRI",
                      "MON",
                      "SAT",
                      "SUN",
                      "THU",
                      "TUE",
                      "WED"
                    ],
                    "--maintenance-window-hour": "value",
                    "--master-ca-certificate-path": "value",
                    "--master-dump-file-path": "value",
                    "--master-instance-name": "value",
                    "--master-password": "value",
                    "--master-username": "value",
                    "--memory": "value",
                    "--network": "value",
                    "--password-policy-complexity": [
                      "COMPLEXITY_DEFAULT",
                      "COMPLEXITY_UNSPECIFIED"
                    ],
                    "--password-policy-disallow-username-substring": "bool",
                    "--password-policy-min-length": "value",
                    "--password-policy-password-change-interval": "value",
                    "--password-policy-reuse-interval": "value",
                    "--prompt-for-master-password": "bool",
                    "--psc-auto-connections": "value",
                    "--recreate-replicas-on-primary-crash": "bool",
                    "--region": "value",
                    "--replica-type": [
                      "FAILOVER",
                      "READ"
                    ],
                    "--replication": [
                      "asynchronous",
                      "synchronous"
                    ],
                    "--replication-lag-max-seconds-for-recreate": "value",
                    "--require-ssl": "bool",
                    "--retained-backups-count": "value",
                    "--retained-transaction-log-days": "value",
                    "--root-password": "value",
                    "--secondary-zone": "value",
                    "--server-ca-mode": [
                      "CUSTOMER_MANAGED_CAS_CA",
                      "GOOGLE_MANAGED_CAS_CA",
                      "GOOGLE_MANAGED_INTERNAL_CA"
                    ],
                    "--server-ca-pool": "value",
                    "--source-ip-address": "value",
                    "--source-port": "value",
                    "--ssl-mode": [
                      "ALLOW_UNENCRYPTED_AND_ENCRYPTED",
                      "ENCRYPTED_ONLY",
                      "TRUSTED_CLIENT_CERTIFICATE_REQUIRED"
                    ],
                    "--storage-auto-increase": "bool",
                    "--storage-auto-increase-limit": "value",
                    "--storage-size": "value",
                    "--storage-type": [
                      "HDD",
                      "SSD"
                    ],
                    "--threads-per-core": "value",
                    "--tier": "value",
                    "--time-zone": "value",
                    "--timeout": "value",
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--database": "value",
                    "--table": "value"
                  }
                },
                "failover": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "get-latest-recovery-time": {
                  "commands": {},
                  "flags": {}
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--database": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--show-edition": "bool",
                    "--show-sql-network-architecture": "bool",
                    "--show-transactional-log-storage-state": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "patch": {
                  "commands": {},
                  "flags": {
                    "--activation-policy": [
                      "always",
                      "never"
                    ],
                    "--active-directory-domain": "value",
                    "--allocated-ip-range-name": "value",
                    "--allowed-psc-projects": "value",
                    "--assign-ip": "bool",
                    "--async": "bool",
                    "--audit-bucket-path": "value",
                    "--audit-retention-interval": "value",
                    "--audit-upload-interval": "value",
                    "--authorized-gae-apps": "value",
                    "--authorized-networks": "value",
                    "--availability-type": [
                      "regional",
                      "zonal"
                    ],
                    "--backup-location": "value",
                    "--backup-start-time": "value",
                    "--clear-allowed-psc-projects": "bool",
                    "--clear-authorized-networks": "bool",
                    "--clear-database-flags": "bool",
                    "--clear-failover-dr-replica-name": "bool",
                    "--clear-gae-apps": "bool",
                    "--clear-labels": "bool",
                    "--clear-password-policy": "bool",
                    "--clear-psc-auto-connections": "bool",
                    "--connector-enforcement": [
                      "CONNECTOR_ENFORCEMENT_UNSPECIFIED",
                      "NOT_REQUIRED",
                      "REQUIRED"
                    ],
                    "--cpu": "value",
                    "--database-flags": "value",
                    "--database-version": "value",
                    "--deletion-protection": "bool",
                    "--deny-maintenance-period-end-date": "value",
                    "--deny-maintenance-period-start-date": "value",
                    "--deny-maintenance-period-time": "value",
                    "--diff": "bool",
                    "--edition": [
                      "enterprise",
                      "enterprise-plus"
                    ],
                    "--enable-bin-log": "bool",
                    "--enable-data-cache": "bool",
                    "--enable-database-replication": "bool",
                    "--enable-dataplex-integration": "bool",
                    "--enable-google-ml-integration": "bool",
                    "--enable-google-private-path": "bool",
                    "--enable-password-policy": "bool",
                    "--enable-point-in-time-recovery": "bool",
                    "--enable-private-service-connect": "bool",
                    "--failover-dr-replica-name": "value",
                    "--follow-gae-app": "value",
                    "--gce-zone": "value",
                    "--insights-config-query-insights-enabled": "bool",
                    "--insights-config-query-plans-per-minute": "value",
                    "--insights-config-query-string-length": "value",
                    "--insights-config-record-application-tags": "bool",
                    "--insights-config-record-client-address": "bool",
                    "--maintenance-release-channel": [
                      "preview",
                      "production",
                      "week5"
                    ],
                    "--maintenance-version": "value",
                    "--maintenance-window-any": "bool",
                    "--maintenance-window-day": [
                      "FRI",
                      "MON",
                      "SAT",
                      "SUN",
                      "THU",
                      "TUE",
                      "WED"
                    ],
                    "--maintenance-window-hour": "value",
                    "--memory": "value",
                    "--network": "value",
                    "--no-backup": "bool",
                    "--password-policy-complexity": [
                      "COMPLEXITY_DEFAULT",
                      "COMPLEXITY_UNSPECIFIED"
                    ],
                    "--password-policy-disallow-username-substring": "bool",
                    "--password-policy-min-length": "value",
                    "--password-policy-password-change-interval": "value",
                    "--password-policy-reuse-interval": "value",
                    "--pricing-plan": [
                      "PACKAGE",
                      "PER_USE"
                    ],
                    "--psc-auto-connections": "value",
                    "--recreate-replicas-on-primary-crash": "bool",
                    "--remove-deny-maintenance-period": "bool",
                    "--remove-labels": "value",
                    "--replication": [
                      "asynchronous",
                      "synchronous"
                    ],
                    "--replication-lag-max-seconds-for-recreate": "value",
                    "--require-ssl": "bool",
                    "--retained-backups-count": "value",
                    "--retained-transaction-log-days": "value",
                    "--secondary-zone": "value",
                    "--simulate-maintenance-event": "bool",
                    "--ssl-mode": [
                      "ALLOW_UNENCRYPTED_AND_ENCRYPTED",
                      "ENCRYPTED_ONLY",
                      "TRUSTED_CLIENT_CERTIFICATE_REQUIRED"
                    ],
                    "--storage-auto-increase": "bool",
                    "--storage-auto-increase-limit": "value",
                    "--storage-size": "value",
                    "--switch-transaction-logs-to-cloud-storage": "bool",
                    "--threads-per-core": "value",
                    "--tier": "value",
                    "--time-zone": "value",
                    "--update-labels": "value",
                    "--upgrade-sql-network-architecture": "bool",
                    "--zone": "value"
                  }
                },
                "promote-replica": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--failover": "bool"
                  }
                },
                "reencrypt": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "reset-ssl-config": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "restart": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "restore-backup": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--backup-id": "value",
                    "--backup-instance": "dynamic"
                  }
                },
                "switchover": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--db-timeout": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--timeout": "value"
                  }
                }
              },
              "flags": {}
            },
            "reschedule-maintenance": {
              "commands": {},
              "flags": {
                "--reschedule-type": [
                  "IMMEDIATE",
                  "NEXT_AVAILABLE_WINDOW",
                  "SPECIFIC_TIME"
                ],
                "--schedule-time": "value"
              }
            },
            "ssl": {
              "commands": {
                "client-certs": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--instance": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--instance": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--instance": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--instance": "dynamic",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "server-ca-certs": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--instance": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--instance": "dynamic",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "rollback": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--instance": "dynamic"
                      }
                    },
                    "rotate": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--instance": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "server-certs": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--instance": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--instance": "dynamic",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "rollback": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--instance": "dynamic"
                      }
                    },
                    "rotate": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--instance": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "ssl-certs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--instance": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "tiers": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--show-edition": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "users": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--host": "value",
                    "--instance": "dynamic",
                    "--password": "value",
                    "--password-policy-allowed-failed-attempts": "value",
                    "--password-policy-enable-failed-attempts-check": "bool",
                    "--password-policy-enable-password-verification": "bool",
                    "--password-policy-password-expiration-duration": "value",
                    "--type": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--host": "value",
                    "--instance": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--host": "value",
                    "--instance": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "set-password": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--discard-dual-password": "bool",
                    "--host": "value",
                    "--instance": "dynamic",
                    "--password": "value",
                    "--prompt-for-password": "bool",
                    "--retain-password": "bool"
                  }
                },
                "set-password-policy": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-password-policy": "bool",
                    "--host": "value",
                    "--instance": "dynamic",
                    "--password-policy-allowed-failed-attempts": "value",
                    "--password-policy-enable-failed-attempts-check": "bool",
                    "--password-policy-enable-password-verification": "bool",
                    "--password-policy-password-expiration-duration": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "survey": {
          "commands": {},
          "flags": {}
        },
        "tasks": {
          "commands": {
            "buffer": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--queue": "value",
                "--task-id": "value"
              }
            },
            "cmek-config": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-kms-key": "bool",
                    "--kms-key-name": "value",
                    "--kms-keyring": "value",
                    "--kms-project": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "create-app-engine-task": {
              "commands": {},
              "flags": {
                "--body-content": "value",
                "--body-file": "value",
                "--header": "value",
                "--location": "value",
                "--method": "value",
                "--queue": "value",
                "--relative-uri": "value",
                "--routing": "value",
                "--schedule-time": "value"
              }
            },
            "create-http-task": {
              "commands": {},
              "flags": {
                "--body-content": "value",
                "--body-file": "value",
                "--header": "value",
                "--location": "value",
                "--method": "value",
                "--oauth-service-account-email": "value",
                "--oauth-token-scope": "value",
                "--oidc-service-account-email": "value",
                "--oidc-token-audience": "value",
                "--queue": "value",
                "--schedule-time": "value",
                "--url": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--queue": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--queue": "value",
                "--response-view": [
                  "basic",
                  "full",
                  "view-unspecified"
                ]
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--queue": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "queues": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--http-header-override": "value",
                    "--http-method-override": "value",
                    "--http-oauth-service-account-email-override": "value",
                    "--http-oauth-token-scope-override": "value",
                    "--http-oidc-service-account-email-override": "value",
                    "--http-oidc-token-audience-override": "value",
                    "--http-uri-override": "value",
                    "--location": "value",
                    "--log-sampling-ratio": "value",
                    "--max-attempts": "value",
                    "--max-backoff": "value",
                    "--max-concurrent-dispatches": "value",
                    "--max-dispatches-per-second": "value",
                    "--max-doublings": "value",
                    "--max-retry-duration": "value",
                    "--min-backoff": "value",
                    "--routing-override": "value",
                    "--type": "value"
                  }
                },
                "create-app-engine-queue": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--log-sampling-ratio": "value",
                    "--max-attempts": "value",
                    "--max-backoff": "value",
                    "--max-concurrent-dispatches": "value",
                    "--max-dispatches-per-second": "value",
                    "--max-doublings": "value",
                    "--max-retry-duration": "value",
                    "--min-backoff": "value",
                    "--routing-override": "value"
                  }
                },
                "create-pull-queue": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--max-attempts": "value",
                    "--max-retry-duration": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "pause": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "purge": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "resume": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-http-header-override": "bool",
                    "--clear-http-method-override": "bool",
                    "--clear-http-oauth-service-account-email-override": "bool",
                    "--clear-http-oauth-token-scope-override": "bool",
                    "--clear-http-oidc-service-account-email-override": "bool",
                    "--clear-http-oidc-token-audience-override": "bool",
                    "--clear-http-uri-override": "bool",
                    "--clear-log-sampling-ratio": "bool",
                    "--clear-max-attempts": "bool",
                    "--clear-max-backoff": "bool",
                    "--clear-max-concurrent-dispatches": "bool",
                    "--clear-max-dispatches-per-second": "bool",
                    "--clear-max-doublings": "bool",
                    "--clear-max-retry-duration": "bool",
                    "--clear-min-backoff": "bool",
                    "--clear-routing-override": "bool",
                    "--http-header-override": "value",
                    "--http-method-override": "value",
                    "--http-oauth-service-account-email-override": "value",
                    "--http-oauth-token-scope-override": "value",
                    "--http-oidc-service-account-email-override": "value",
                    "--http-oidc-token-audience-override": "value",
                    "--http-uri-override": "value",
                    "--location": "value",
                    "--log-sampling-ratio": "value",
                    "--max-attempts": "value",
                    "--max-backoff": "value",
                    "--max-concurrent-dispatches": "value",
                    "--max-dispatches-per-second": "value",
                    "--max-doublings": "value",
                    "--max-retry-duration": "value",
                    "--min-backoff": "value",
                    "--routing-override": "value",
                    "--type": "value"
                  }
                },
                "update-app-engine-queue": {
                  "commands": {},
                  "flags": {
                    "--clear-log-sampling-ratio": "bool",
                    "--clear-max-attempts": "bool",
                    "--clear-max-backoff": "bool",
                    "--clear-max-concurrent-dispatches": "bool",
                    "--clear-max-dispatches-per-second": "bool",
                    "--clear-max-doublings": "bool",
                    "--clear-max-retry-duration": "bool",
                    "--clear-min-backoff": "bool",
                    "--clear-routing-override": "bool",
                    "--location": "value",
                    "--log-sampling-ratio": "value",
                    "--max-attempts": "value",
                    "--max-backoff": "value",
                    "--max-concurrent-dispatches": "value",
                    "--max-dispatches-per-second": "value",
                    "--max-doublings": "value",
                    "--max-retry-duration": "value",
                    "--min-backoff": "value",
                    "--routing-override": "value"
                  }
                }
              },
              "flags": {}
            },
            "run": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--queue": "value"
              }
            }
          },
          "flags": {}
        },
        "terraform": {
          "commands": {
            "vet": {
              "commands": {},
              "flags": {
                "--policy-library": "value",
                "--region": "value",
                "--zone": "value"
              }
            }
          },
          "flags": {}
        },
        "topic": {
          "commands": {
            "accessibility": {
              "commands": {},
              "flags": {}
            },
            "arg-files": {
              "commands": {},
              "flags": {}
            },
            "cli-trees": {
              "commands": {},
              "flags": {}
            },
            "client-certificate": {
              "commands": {},
              "flags": {}
            },
            "command-conventions": {
              "commands": {},
              "flags": {}
            },
            "configurations": {
              "commands": {},
              "flags": {}
            },
            "datetimes": {
              "commands": {},
              "flags": {}
            },
            "endpoint-override": {
              "commands": {},
              "flags": {}
            },
            "escaping": {
              "commands": {},
              "flags": {}
            },
            "filters": {
              "commands": {},
              "flags": {}
            },
            "flags-file": {
              "commands": {},
              "flags": {}
            },
            "formats": {
              "commands": {},
              "flags": {}
            },
            "gcloudignore": {
              "commands": {},
              "flags": {}
            },
            "offline-help": {
              "commands": {},
              "flags": {}
            },
            "projections": {
              "commands": {},
              "flags": {}
            },
            "resource-keys": {
              "commands": {},
              "flags": {}
            },
            "startup": {
              "commands": {},
              "flags": {}
            },
            "uninstall": {
              "commands": {},
              "flags": {}
            }
          },
          "flags": {}
        },
        "workbench": {
          "commands": {},
          "flags": {}
        },
        "workflows": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "deploy": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--labels": "value",
                "--location": "value",
                "--service-account": "value",
                "--source": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "execute": {
              "commands": {},
              "flags": {
                "--call-log-level": [
                  "log-all-calls",
                  "log-errors-only",
                  "none"
                ],
                "--data": "value",
                "--location": "value"
              }
            },
            "executions": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--workflow": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--workflow": "value"
                  }
                },
                "describe-last": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--workflow": "value"
                  }
                },
                "wait-last": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "run": {
              "commands": {},
              "flags": {
                "--call-log-level": [
                  "log-all-calls",
                  "log-errors-only",
                  "none"
                ],
                "--data": "value",
                "--location": "value"
              }
            }
          },
          "flags": {}
        },
        "workstations": {
          "commands": {
            "clusters": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--domain": "value",
                    "--enable-private-endpoint": "bool",
                    "--labels": "value",
                    "--network": "value",
                    "--region": "value",
                    "--subnetwork": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "configs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator-count": "value",
                    "--accelerator-type": "value",
                    "--allow-unauthenticated-cors-preflight-requests": "bool",
                    "--allowed-ports": "value",
                    "--async": "bool",
                    "--boost-config": "value",
                    "--boot-disk-size": "value",
                    "--cluster": "dynamic",
                    "--container-args": "value",
                    "--container-command": "value",
                    "--container-custom-image": "value",
                    "--container-env": "value",
                    "--container-predefined-image": [
                      "base-image",
                      "clion",
                      "codeoss",
                      "codeoss-cuda",
                      "goland",
                      "intellij",
                      "phpstorm",
                      "pycharm",
                      "rider",
                      "rubymine",
                      "webstorm"
                    ],
                    "--container-run-as-user": "value",
                    "--container-working-dir": "value",
                    "--disable-localhost-replacement": "bool",
                    "--disable-public-ip-addresses": "bool",
                    "--disable-ssh-to-vm": "bool",
                    "--disable-tcp-connections": "bool",
                    "--enable-audit-agent": "bool",
                    "--enable-confidential-compute": "bool",
                    "--enable-nested-virtualization": "bool",
                    "--enable-ssh-to-vm": "bool",
                    "--ephemeral-directory": "value",
                    "--grant-workstation-admin-role-on-create": "bool",
                    "--idle-timeout": "value",
                    "--kms-key": "value",
                    "--kms-key-service-account": "value",
                    "--labels": "value",
                    "--machine-type": "value",
                    "--max-usable-workstations-count": "value",
                    "--network-tags": "value",
                    "--pd-disk-size": [
                      10,
                      50,
                      100,
                      200,
                      500,
                      1000
                    ],
                    "--pd-disk-type": [
                      "pd-balanced",
                      "pd-ssd",
                      "pd-standard"
                    ],
                    "--pd-reclaim-policy": [
                      "delete",
                      "retain"
                    ],
                    "--pd-source-snapshot": "value",
                    "--pool-size": "value",
                    "--region": "value",
                    "--replica-zones": "value",
                    "--running-timeout": "value",
                    "--service-account": "value",
                    "--service-account-scopes": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-secure-boot": "bool",
                    "--shielded-vtpm": "bool",
                    "--vm-tags": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster": "value",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--region": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--region": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--accelerator-count": "value",
                    "--accelerator-type": "value",
                    "--allow-unauthenticated-cors-preflight-requests": "bool",
                    "--allowed-ports": "value",
                    "--async": "bool",
                    "--boost-config": "value",
                    "--boot-disk-size": "value",
                    "--cluster": "dynamic",
                    "--container-args": "value",
                    "--container-command": "value",
                    "--container-custom-image": "value",
                    "--container-env": "value",
                    "--container-predefined-image": [
                      "base-image",
                      "clion",
                      "codeoss",
                      "codeoss-cuda",
                      "goland",
                      "intellij",
                      "phpstorm",
                      "pycharm",
                      "rider",
                      "rubymine",
                      "webstorm"
                    ],
                    "--container-run-as-user": "value",
                    "--container-working-dir": "value",
                    "--disable-localhost-replacement": "bool",
                    "--disable-public-ip-addresses": "bool",
                    "--disable-ssh-to-vm": "bool",
                    "--disable-tcp-connections": "bool",
                    "--disallow-unauthenticated-cors-preflight-requests": "bool",
                    "--enable-audit-agent": "bool",
                    "--enable-confidential-compute": "bool",
                    "--enable-localhost-replacement": "bool",
                    "--enable-nested-virtualization": "bool",
                    "--enable-ssh-to-vm": "bool",
                    "--enable-tcp-connections": "bool",
                    "--grant-workstation-admin-role-on-create": "bool",
                    "--idle-timeout": "value",
                    "--labels": "value",
                    "--machine-type": "value",
                    "--max-usable-workstations-count": "value",
                    "--network-tags": "value",
                    "--pd-source-snapshot": "value",
                    "--pool-size": "value",
                    "--region": "value",
                    "--running-timeout": "value",
                    "--service-account": "value",
                    "--service-account-scopes": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-secure-boot": "bool",
                    "--shielded-vtpm": "bool",
                    "--vm-tags": "value"
                  }
                }
              },
              "flags": {}
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--cluster": "value",
                "--config": "value",
                "--env": "value",
                "--labels": "value",
                "--region": "value",
                "--source-workstation": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--cluster": "value",
                "--config": "value",
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--config": "value",
                "--region": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--config": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--config": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value"
              }
            },
            "list-usable": {
              "commands": {},
              "flags": {
                "--cluster": "dynamic",
                "--config": "dynamic",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--config": "value",
                "--region": "value"
              }
            },
            "ssh": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--command": "value",
                "--config": "value",
                "--local-host-port": "value",
                "--port": "value",
                "--region": "value",
                "--user": "value"
              }
            },
            "start": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--boost": "value",
                "--cluster": "value",
                "--config": "value",
                "--region": "value"
              }
            },
            "start-tcp-tunnel": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--config": "value",
                "--local-host-port": "value",
                "--region": "value"
              }
            },
            "stop": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--cluster": "value",
                "--config": "value",
                "--region": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "bigtable": {
      "commands": {
        "app-profiles": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--force": "bool",
                "--instance": "dynamic",
                "--priority": [
                  "PRIORITY_HIGH",
                  "PRIORITY_LOW",
                  "PRIORITY_MEDIUM"
                ],
                "--restrict-to": "value",
                "--route-any": "bool",
                "--route-to": "dynamic",
                "--row-affinity": "bool",
                "--transactional-writes": "bool"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--force": "bool",
                "--instance": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--instance": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--instance": "dynamic",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--force": "bool",
                "--instance": "dynamic",
                "--priority": [
                  "PRIORITY_HIGH",
                  "PRIORITY_LOW",
                  "PRIORITY_MEDIUM"
                ],
                "--restrict-to": "value",
                "--route-any": "bool",
                "--route-to": "dynamic",
                "--row-affinity": "bool",
                "--transactional-writes": "bool"
              }
            }
          },
          "flags": {}
        },
        "authorized-views": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--instance": "dynamic",
                "--member": "value",
                "--role": "dynamic",
                "--table": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--definition-file": "value",
                "--instance": "dynamic",
                "--pre-encoded": "bool",
                "--table": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--instance": "dynamic",
                "--table": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--instance": "dynamic",
                "--table": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--instance": "dynamic",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--table": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--instance": "dynamic",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--table": "dynamic",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--instance": "dynamic",
                "--member": "value",
                "--role": "dynamic",
                "--table": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--instance": "dynamic",
                "--table": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--definition-file": "value",
                "--ignore-warnings": "bool",
                "--instance": "dynamic",
                "--interactive": "bool",
                "--pre-encoded": "bool",
                "--table": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "backups": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--cluster": "dynamic",
                "--condition": "value",
                "--condition-from-file": "value",
                "--instance": "dynamic",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "copy": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--destination-backup": "dynamic",
                "--destination-cluster": "dynamic",
                "--destination-instance": "dynamic",
                "--destination-project": "dynamic",
                "--expiration-date": "value",
                "--retention-period": "value",
                "--source-backup": "dynamic",
                "--source-cluster": "dynamic",
                "--source-instance": "dynamic",
                "--source-project": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--backup-type": [
                  "backup-type-unspecified",
                  "hot",
                  "standard"
                ],
                "--cluster": "dynamic",
                "--expiration-date": "value",
                "--hot-to-standard-time": "value",
                "--instance": "dynamic",
                "--retention-period": "value",
                "--table": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--cluster": "dynamic",
                "--instance": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--cluster": "dynamic",
                "--instance": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--cluster": "dynamic",
                "--filter": "value",
                "--instance": "dynamic",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--cluster": "dynamic",
                "--filter": "value",
                "--instance": "dynamic",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--cluster": "dynamic",
                "--condition": "value",
                "--condition-from-file": "value",
                "--instance": "dynamic",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--cluster": "dynamic",
                "--instance": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--cluster": "dynamic",
                "--expiration-date": "value",
                "--hot-to-standard-time": "value",
                "--instance": "dynamic",
                "--retention-period": "value"
              }
            }
          },
          "flags": {}
        },
        "clusters": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--autoscaling-cpu-target": "value",
                "--autoscaling-max-nodes": "value",
                "--autoscaling-min-nodes": "value",
                "--autoscaling-storage-target": "value",
                "--instance": "dynamic",
                "--kms-key": "dynamic",
                "--kms-keyring": "dynamic",
                "--kms-location": "dynamic",
                "--kms-project": "dynamic",
                "--node-scaling-factor": [
                  "node-scaling-factor-1x",
                  "node-scaling-factor-2x"
                ],
                "--num-nodes": "value",
                "--zone": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--instance": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--instance": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--instances": "dynamic",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--autoscaling-cpu-target": "value",
                "--autoscaling-max-nodes": "value",
                "--autoscaling-min-nodes": "value",
                "--autoscaling-storage-target": "value",
                "--disable-autoscaling": "bool",
                "--instance": "dynamic",
                "--num-nodes": "value"
              }
            }
          },
          "flags": {}
        },
        "hot-tablets": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--end-time": "value",
                "--filter": "value",
                "--instance": "dynamic",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--start-time": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "instances": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--cluster": "dynamic",
                "--cluster-config": "value",
                "--cluster-num-nodes": "value",
                "--cluster-storage-type": [
                  "hdd",
                  "ssd"
                ],
                "--cluster-zone": "value",
                "--display-name": "value",
                "--instance-type": [
                  "DEVELOPMENT",
                  "PRODUCTION"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {}
            },
            "tables": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--automated-backup-retention-period": "value",
                    "--change-stream-retention-period": "value",
                    "--column-families": "value",
                    "--deletion-protection": "bool",
                    "--enable-automated-backup": "bool",
                    "--instance": "dynamic",
                    "--splits": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic",
                    "--view": [
                      "encryption",
                      "full",
                      "name",
                      "replication",
                      "schema",
                      "stats"
                    ]
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instances": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--instance": "dynamic",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "restore": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--destination": "dynamic",
                    "--destination-instance": "dynamic",
                    "--source": "dynamic",
                    "--source-cluster": "dynamic",
                    "--source-instance": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "undelete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--instance": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--automated-backup-retention-period": "value",
                    "--change-stream-retention-period": "value",
                    "--clear-change-stream-retention-period": "bool",
                    "--deletion-protection": "bool",
                    "--disable-automated-backup": "bool",
                    "--enable-automated-backup": "bool",
                    "--instance": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--display-name": "value"
              }
            },
            "upgrade": {
              "commands": {},
              "flags": {
                "--async": "bool"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--instance": "dynamic",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "tables": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--instance": "dynamic",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--automated-backup-retention-period": "value",
                "--change-stream-retention-period": "value",
                "--column-families": "value",
                "--deletion-protection": "bool",
                "--enable-automated-backup": "bool",
                "--instance": "dynamic",
                "--splits": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--instance": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--instance": "dynamic",
                "--view": [
                  "encryption",
                  "full",
                  "name",
                  "replication",
                  "schema",
                  "stats"
                ]
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--instance": "dynamic",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--instances": "dynamic",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--instance": "dynamic",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "restore": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--destination": "dynamic",
                "--destination-instance": "dynamic",
                "--source": "dynamic",
                "--source-cluster": "dynamic",
                "--source-instance": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--instance": "dynamic"
              }
            },
            "undelete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--instance": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--automated-backup-retention-period": "value",
                "--change-stream-retention-period": "value",
                "--clear-change-stream-retention-period": "bool",
                "--deletion-protection": "bool",
                "--disable-automated-backup": "bool",
                "--enable-automated-backup": "bool",
                "--instance": "dynamic"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "billing": {
      "commands": {
        "accounts": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {}
            }
          },
          "flags": {}
        },
        "budgets": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--budget-amount": "value",
                "--calendar-period": [
                  "calendar-period-unspecified",
                  "month",
                  "quarter",
                  "year"
                ],
                "--credit-types-treatment": [
                  "credit-types-treatment-unspecified",
                  "exclude-all-credits",
                  "include-all-credits",
                  "include-specified-credits"
                ],
                "--disable-default-iam-recipients": "bool",
                "--display-name": "value",
                "--end-date": "value",
                "--filter-credit-types": "value",
                "--filter-labels": "value",
                "--filter-projects": "value",
                "--filter-resource-ancestors": "value",
                "--filter-services": "value",
                "--filter-subaccounts": "value",
                "--last-period-amount": "bool",
                "--notifications-rule-monitoring-notification-channels": "value",
                "--notifications-rule-pubsub-topic": "value",
                "--ownership-scope": [
                  "all-users",
                  "billing-account",
                  "ownership-scope-unspecified"
                ],
                "--start-date": "value",
                "--threshold-rule": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--billing-account": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--billing-account": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-threshold-rule": "value",
                "--billing-account": "value",
                "--budget-amount": "value",
                "--calendar-period": [
                  "calendar-period-unspecified",
                  "month",
                  "quarter",
                  "year"
                ],
                "--clear-threshold-rules": "bool",
                "--credit-types-treatment": [
                  "credit-types-treatment-unspecified",
                  "exclude-all-credits",
                  "include-all-credits",
                  "include-specified-credits"
                ],
                "--disable-default-iam-recipients": "bool",
                "--display-name": "value",
                "--end-date": "value",
                "--filter-credit-types": "value",
                "--filter-labels": "value",
                "--filter-projects": "value",
                "--filter-resource-ancestors": "value",
                "--filter-services": "value",
                "--filter-subaccounts": "value",
                "--last-period-amount": "bool",
                "--notifications-rule-monitoring-notification-channels": "value",
                "--notifications-rule-pubsub-topic": "value",
                "--ownership-scope": [
                  "all-users",
                  "billing-account",
                  "ownership-scope-unspecified"
                ],
                "--start-date": "value",
                "--threshold-rules-from-file": "value"
              }
            }
          },
          "flags": {}
        },
        "projects": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "link": {
              "commands": {},
              "flags": {
                "--billing-account": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--billing-account": "dynamic",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "unlink": {
              "commands": {},
              "flags": {}
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "bms": {
      "commands": {
        "instances": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "disable-serial-console": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "dynamic"
              }
            },
            "enable-serial-console": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--region": "dynamic"
              }
            },
            "rename": {
              "commands": {},
              "flags": {
                "--new-name": "value",
                "--region": "dynamic"
              }
            },
            "reset": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "dynamic"
              }
            },
            "start": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "dynamic"
              }
            },
            "stop": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-labels": "bool",
                "--enable-hyperthreading": "bool",
                "--os-image": "value",
                "--region": "dynamic",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "networks": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--region": "dynamic"
              }
            },
            "list-ip-reservations": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--region": "dynamic"
              }
            },
            "rename": {
              "commands": {},
              "flags": {
                "--new-name": "value",
                "--region": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-ip-range-reservation": "value",
                "--async": "bool",
                "--clear-ip-range-reservations": "bool",
                "--clear-labels": "bool",
                "--region": "dynamic",
                "--remove-ip-range-reservation": "value",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "nfs-shares": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--allowed-client": "value",
                "--async": "bool",
                "--labels": "value",
                "--region": "dynamic",
                "--size-gib": "value",
                "--storage-type": [
                  "HDD",
                  "SSD"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--region": "dynamic"
              }
            },
            "rename": {
              "commands": {},
              "flags": {
                "--new-name": "value",
                "--region": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-allowed-client": "value",
                "--async": "bool",
                "--clear-allowed-clients": "bool",
                "--clear-labels": "bool",
                "--region": "dynamic",
                "--remove-allowed-client": "value",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "wait": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "os-images": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value"
              }
            }
          },
          "flags": {}
        },
        "ssh-keys": {
          "commands": {
            "add": {
              "commands": {},
              "flags": {
                "--key": "value",
                "--key-file": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value"
              }
            },
            "remove": {
              "commands": {},
              "flags": {}
            }
          },
          "flags": {}
        },
        "volumes": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--region": "dynamic"
              }
            },
            "luns": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--volume": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--region": "dynamic",
                    "--volume": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "rename": {
              "commands": {},
              "flags": {
                "--new-name": "value",
                "--region": "dynamic"
              }
            },
            "restore": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "dynamic",
                "--snapshot": "value"
              }
            },
            "snapshot": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--region": "dynamic",
                "--snapshot-name": "value"
              }
            },
            "snapshots": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--volume": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--volume": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--region": "dynamic",
                    "--volume": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-labels": "bool",
                "--region": "dynamic",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "builds": {
      "commands": {
        "cancel": {
          "commands": {},
          "flags": {
            "--region": "value"
          }
        },
        "connections": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--region": "dynamic",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {
                "bitbucket-cloud": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--authorizer-token-secret-version": "value",
                    "--read-authorizer-token-secret-version": "value",
                    "--region": "dynamic",
                    "--webhook-secret-secret-version": "value",
                    "--workspace": "value"
                  }
                },
                "bitbucket-data-center": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--authorizer-token-secret-version": "value",
                    "--host-uri": "value",
                    "--read-authorizer-token-secret-version": "value",
                    "--region": "dynamic",
                    "--service-directory-service": "value",
                    "--ssl-ca-file": "value",
                    "--webhook-secret-secret-version": "value"
                  }
                },
                "github": {
                  "commands": {},
                  "flags": {
                    "--app-installation-id": "value",
                    "--async": "bool",
                    "--authorizer-token-secret-version": "value",
                    "--region": "dynamic"
                  }
                },
                "github-enterprise": {
                  "commands": {},
                  "flags": {
                    "--app-id": "value",
                    "--app-installation-id": "value",
                    "--app-slug": "value",
                    "--async": "bool",
                    "--host-uri": "value",
                    "--private-key-secret-version": "value",
                    "--region": "dynamic",
                    "--service-directory-service": "value",
                    "--ssl-ca-file": "value",
                    "--webhook-secret-secret-version": "value"
                  }
                },
                "gitlab": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--authorizer-token-secret-version": "value",
                    "--host-uri": "value",
                    "--read-authorizer-token-secret-version": "value",
                    "--region": "dynamic",
                    "--service-directory-service": "value",
                    "--ssl-ca-file": "value",
                    "--webhook-secret-secret-version": "value"
                  }
                }
              },
              "flags": {}
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "update": {
              "commands": {
                "bitbucket-cloud": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--authorizer-token-secret-version": "value",
                    "--read-authorizer-token-secret-version": "value",
                    "--region": "dynamic",
                    "--webhook-secret-secret-version": "value",
                    "--workspace": "value"
                  }
                },
                "bitbucket-data-center": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--authorizer-token-secret-version": "value",
                    "--host-uri": "value",
                    "--read-authorizer-token-secret-version": "value",
                    "--region": "dynamic",
                    "--service-directory-service": "value",
                    "--ssl-ca-file": "value"
                  }
                },
                "github": {
                  "commands": {},
                  "flags": {
                    "--app-installation-id": "value",
                    "--async": "bool",
                    "--authorizer-token-secret-version": "value",
                    "--region": "dynamic"
                  }
                },
                "github-enterprise": {
                  "commands": {},
                  "flags": {
                    "--app-id": "value",
                    "--app-installation-id": "value",
                    "--app-slug": "value",
                    "--async": "bool",
                    "--host-uri": "value",
                    "--private-key-secret-version": "value",
                    "--region": "dynamic",
                    "--service-directory-service": "value",
                    "--ssl-ca-file": "value",
                    "--webhook-secret-secret-version": "value"
                  }
                },
                "gitlab": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--authorizer-token-secret-version": "value",
                    "--host-uri": "value",
                    "--read-authorizer-token-secret-version": "value",
                    "--region": "dynamic",
                    "--service-directory-service": "value",
                    "--ssl-ca-file": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "describe": {
          "commands": {},
          "flags": {
            "--region": "value"
          }
        },
        "get-default-service-account": {
          "commands": {},
          "flags": {
            "--region": "value"
          }
        },
        "list": {
          "commands": {},
          "flags": {
            "--filter": "value",
            "--limit": "value",
            "--ongoing": "bool",
            "--page-size": "value",
            "--region": "value",
            "--sort-by": "value",
            "--uri": "bool"
          }
        },
        "log": {
          "commands": {},
          "flags": {
            "--region": "value",
            "--stream": "bool"
          }
        },
        "repositories": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--connection": "dynamic",
                "--region": "dynamic",
                "--remote-uri": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--connection": "dynamic",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--connection": "dynamic",
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--connection": "dynamic",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "submit": {
          "commands": {},
          "flags": {
            "--async": "bool",
            "--config": "value",
            "--default-buckets-behavior": [
              "default-logs-bucket-behavior-unspecified",
              "legacy-bucket",
              "regional-user-owned-bucket"
            ],
            "--dir": "value",
            "--disk-size": "value",
            "--gcs-log-dir": "value",
            "--gcs-source-staging-dir": "value",
            "--git-source-dir": "value",
            "--git-source-revision": "value",
            "--ignore-file": "value",
            "--machine-type": [
              "e2-highcpu-32",
              "e2-highcpu-8",
              "e2-medium",
              "n1-highcpu-32",
              "n1-highcpu-8"
            ],
            "--no-cache": "bool",
            "--no-source": "bool",
            "--pack": "value",
            "--polling-interval": "value",
            "--region": "value",
            "--revision": "value",
            "--service-account": "value",
            "--substitutions": "value",
            "--suppress-logs": "bool",
            "--tag": "value",
            "--timeout": "value",
            "--worker-pool": "value"
          }
        },
        "triggers": {
          "commands": {
            "create": {
              "commands": {
                "bitbucket-cloud": {
                  "commands": {},
                  "flags": {
                    "--branch-pattern": "value",
                    "--build-config": "value",
                    "--comment-control": [
                      "COMMENTS_DISABLED",
                      "COMMENTS_ENABLED",
                      "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                    ],
                    "--description": "value",
                    "--dockerfile": "value",
                    "--dockerfile-dir": "value",
                    "--dockerfile-image": "value",
                    "--ignored-files": "value",
                    "--included-files": "value",
                    "--inline-config": "value",
                    "--name": "value",
                    "--pull-request-pattern": "value",
                    "--region": "value",
                    "--repository": "value",
                    "--require-approval": "bool",
                    "--service-account": "value",
                    "--substitutions": "value",
                    "--tag-pattern": "value",
                    "--trigger-config": "value"
                  }
                },
                "bitbucket-data-center": {
                  "commands": {},
                  "flags": {
                    "--branch-pattern": "value",
                    "--build-config": "value",
                    "--comment-control": [
                      "COMMENTS_DISABLED",
                      "COMMENTS_ENABLED",
                      "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                    ],
                    "--description": "value",
                    "--dockerfile": "value",
                    "--dockerfile-dir": "value",
                    "--dockerfile-image": "value",
                    "--ignored-files": "value",
                    "--included-files": "value",
                    "--inline-config": "value",
                    "--name": "value",
                    "--pull-request-pattern": "value",
                    "--region": "value",
                    "--repository": "value",
                    "--require-approval": "bool",
                    "--service-account": "value",
                    "--substitutions": "value",
                    "--tag-pattern": "value",
                    "--trigger-config": "value"
                  }
                },
                "bitbucketserver": {
                  "commands": {},
                  "flags": {
                    "--bitbucket-server-config-resource": "value",
                    "--branch-pattern": "value",
                    "--build-config": "value",
                    "--comment-control": [
                      "COMMENTS_DISABLED",
                      "COMMENTS_ENABLED",
                      "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                    ],
                    "--description": "value",
                    "--dockerfile": "value",
                    "--dockerfile-dir": "value",
                    "--dockerfile-image": "value",
                    "--ignored-files": "value",
                    "--included-files": "value",
                    "--inline-config": "value",
                    "--name": "value",
                    "--project-key": "value",
                    "--pull-request-pattern": "value",
                    "--region": "value",
                    "--repo-slug": "value",
                    "--require-approval": "bool",
                    "--service-account": "value",
                    "--substitutions": "value",
                    "--tag-pattern": "value",
                    "--trigger-config": "value"
                  }
                },
                "cloud-source-repositories": {
                  "commands": {},
                  "flags": {
                    "--branch-pattern": "value",
                    "--build-config": "value",
                    "--description": "value",
                    "--dockerfile": "value",
                    "--dockerfile-dir": "value",
                    "--dockerfile-image": "value",
                    "--ignored-files": "value",
                    "--included-files": "value",
                    "--inline-config": "value",
                    "--name": "value",
                    "--region": "value",
                    "--repo": "value",
                    "--require-approval": "bool",
                    "--service-account": "value",
                    "--substitutions": "value",
                    "--tag-pattern": "value",
                    "--trigger-config": "value"
                  }
                },
                "github": {
                  "commands": {},
                  "flags": {
                    "--branch-pattern": "value",
                    "--build-config": "value",
                    "--comment-control": [
                      "COMMENTS_DISABLED",
                      "COMMENTS_ENABLED",
                      "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                    ],
                    "--description": "value",
                    "--dockerfile": "value",
                    "--dockerfile-dir": "value",
                    "--dockerfile-image": "value",
                    "--enterprise-config": "value",
                    "--ignored-files": "value",
                    "--include-logs-with-status": "bool",
                    "--included-files": "value",
                    "--inline-config": "value",
                    "--name": "value",
                    "--pull-request-pattern": "value",
                    "--region": "value",
                    "--repo-name": "value",
                    "--repo-owner": "value",
                    "--repository": "value",
                    "--require-approval": "bool",
                    "--service-account": "value",
                    "--substitutions": "value",
                    "--tag-pattern": "value",
                    "--trigger-config": "value"
                  }
                },
                "gitlab": {
                  "commands": {},
                  "flags": {
                    "--branch-pattern": "value",
                    "--build-config": "value",
                    "--comment-control": [
                      "COMMENTS_DISABLED",
                      "COMMENTS_ENABLED",
                      "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                    ],
                    "--description": "value",
                    "--dockerfile": "value",
                    "--dockerfile-dir": "value",
                    "--dockerfile-image": "value",
                    "--ignored-files": "value",
                    "--included-files": "value",
                    "--inline-config": "value",
                    "--name": "value",
                    "--pull-request-pattern": "value",
                    "--region": "value",
                    "--repository": "value",
                    "--require-approval": "bool",
                    "--service-account": "value",
                    "--substitutions": "value",
                    "--tag-pattern": "value",
                    "--trigger-config": "value"
                  }
                },
                "manual": {
                  "commands": {},
                  "flags": {
                    "--branch": "value",
                    "--build-config": "value",
                    "--description": "value",
                    "--dockerfile": "value",
                    "--dockerfile-dir": "value",
                    "--dockerfile-image": "value",
                    "--github-enterprise-config": "value",
                    "--inline-config": "value",
                    "--name": "value",
                    "--region": "value",
                    "--repo": "value",
                    "--repo-type": "value",
                    "--repository": "value",
                    "--require-approval": "bool",
                    "--service-account": "value",
                    "--substitutions": "value",
                    "--tag": "value",
                    "--trigger-config": "value"
                  }
                },
                "pubsub": {
                  "commands": {},
                  "flags": {
                    "--branch": "value",
                    "--build-config": "value",
                    "--description": "value",
                    "--dockerfile": "value",
                    "--dockerfile-dir": "value",
                    "--dockerfile-image": "value",
                    "--github-enterprise-config": "value",
                    "--inline-config": "value",
                    "--name": "value",
                    "--region": "value",
                    "--repo": "value",
                    "--repo-type": "value",
                    "--repository": "value",
                    "--require-approval": "bool",
                    "--service-account": "value",
                    "--subscription-filter": "value",
                    "--substitutions": "value",
                    "--tag": "value",
                    "--topic": "value",
                    "--trigger-config": "value"
                  }
                },
                "webhook": {
                  "commands": {},
                  "flags": {
                    "--branch": "value",
                    "--build-config": "value",
                    "--description": "value",
                    "--dockerfile": "value",
                    "--dockerfile-dir": "value",
                    "--dockerfile-image": "value",
                    "--github-enterprise-config": "value",
                    "--inline-config": "value",
                    "--name": "value",
                    "--region": "value",
                    "--repo": "value",
                    "--repo-type": "value",
                    "--repository": "value",
                    "--require-approval": "bool",
                    "--secret": "value",
                    "--service-account": "value",
                    "--subscription-filter": "value",
                    "--substitutions": "value",
                    "--tag": "value",
                    "--trigger-config": "value"
                  }
                }
              },
              "flags": {}
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--region": "value",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "run": {
              "commands": {},
              "flags": {
                "--branch": "value",
                "--region": "value",
                "--sha": "value",
                "--substitutions": "value",
                "--tag": "value"
              }
            },
            "update": {
              "commands": {
                "bitbucket-cloud": {
                  "commands": {},
                  "flags": {
                    "--branch-pattern": "value",
                    "--build-config": "value",
                    "--clear-substitutions": "bool",
                    "--comment-control": [
                      "COMMENTS_DISABLED",
                      "COMMENTS_ENABLED",
                      "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                    ],
                    "--description": "value",
                    "--dockerfile": "value",
                    "--dockerfile-dir": "value",
                    "--dockerfile-image": "value",
                    "--ignored-files": "value",
                    "--included-files": "value",
                    "--inline-config": "value",
                    "--pull-request-pattern": "value",
                    "--region": "value",
                    "--remove-substitutions": "value",
                    "--repository": "value",
                    "--require-approval": "bool",
                    "--service-account": "value",
                    "--tag-pattern": "value",
                    "--trigger-config": "value",
                    "--update-substitutions": "value"
                  }
                },
                "bitbucket-data-center": {
                  "commands": {},
                  "flags": {
                    "--branch-pattern": "value",
                    "--build-config": "value",
                    "--clear-substitutions": "bool",
                    "--comment-control": [
                      "COMMENTS_DISABLED",
                      "COMMENTS_ENABLED",
                      "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                    ],
                    "--description": "value",
                    "--dockerfile": "value",
                    "--dockerfile-dir": "value",
                    "--dockerfile-image": "value",
                    "--ignored-files": "value",
                    "--included-files": "value",
                    "--inline-config": "value",
                    "--pull-request-pattern": "value",
                    "--region": "value",
                    "--remove-substitutions": "value",
                    "--repository": "value",
                    "--require-approval": "bool",
                    "--service-account": "value",
                    "--tag-pattern": "value",
                    "--trigger-config": "value",
                    "--update-substitutions": "value"
                  }
                },
                "bitbucketserver": {
                  "commands": {},
                  "flags": {
                    "--bitbucket-server-config-resource": "value",
                    "--branch-pattern": "value",
                    "--build-config": "value",
                    "--clear-substitutions": "bool",
                    "--comment-control": [
                      "COMMENTS_DISABLED",
                      "COMMENTS_ENABLED",
                      "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                    ],
                    "--description": "value",
                    "--dockerfile": "value",
                    "--dockerfile-dir": "value",
                    "--dockerfile-image": "value",
                    "--ignored-files": "value",
                    "--included-files": "value",
                    "--inline-config": "value",
                    "--project-key": "value",
                    "--pull-request-pattern": "value",
                    "--region": "value",
                    "--remove-substitutions": "value",
                    "--repo-slug": "value",
                    "--require-approval": "bool",
                    "--service-account": "value",
                    "--tag-pattern": "value",
                    "--trigger-config": "value",
                    "--update-substitutions": "value"
                  }
                },
                "cloud-source-repositories": {
                  "commands": {},
                  "flags": {
                    "--branch-pattern": "value",
                    "--build-config": "value",
                    "--clear-substitutions": "bool",
                    "--description": "value",
                    "--dockerfile": "value",
                    "--dockerfile-dir": "value",
                    "--dockerfile-image": "value",
                    "--ignored-files": "value",
                    "--included-files": "value",
                    "--inline-config": "value",
                    "--region": "value",
                    "--remove-substitutions": "value",
                    "--repo": "value",
                    "--require-approval": "bool",
                    "--service-account": "value",
                    "--tag-pattern": "value",
                    "--trigger-config": "value",
                    "--update-substitutions": "value"
                  }
                },
                "github": {
                  "commands": {},
                  "flags": {
                    "--branch-pattern": "value",
                    "--build-config": "value",
                    "--clear-substitutions": "bool",
                    "--comment-control": [
                      "COMMENTS_DISABLED",
                      "COMMENTS_ENABLED",
                      "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                    ],
                    "--description": "value",
                    "--dockerfile": "value",
                    "--dockerfile-dir": "value",
                    "--dockerfile-image": "value",
                    "--enterprise-config": "value",
                    "--ignored-files": "value",
                    "--include-logs-with-status": "bool",
                    "--included-files": "value",
                    "--inline-config": "value",
                    "--pull-request-pattern": "value",
                    "--region": "value",
                    "--remove-substitutions": "value",
                    "--repo-name": "value",
                    "--repo-owner": "value",
                    "--repository": "value",
                    "--require-approval": "bool",
                    "--service-account": "value",
                    "--tag-pattern": "value",
                    "--trigger-config": "value",
                    "--update-substitutions": "value"
                  }
                },
                "gitlab": {
                  "commands": {},
                  "flags": {
                    "--branch-pattern": "value",
                    "--build-config": "value",
                    "--clear-substitutions": "bool",
                    "--comment-control": [
                      "COMMENTS_DISABLED",
                      "COMMENTS_ENABLED",
                      "COMMENTS_ENABLED_FOR_EXTERNAL_CONTRIBUTORS_ONLY"
                    ],
                    "--description": "value",
                    "--dockerfile": "value",
                    "--dockerfile-dir": "value",
                    "--dockerfile-image": "value",
                    "--ignored-files": "value",
                    "--included-files": "value",
                    "--inline-config": "value",
                    "--pull-request-pattern": "value",
                    "--region": "value",
                    "--remove-substitutions": "value",
                    "--repository": "value",
                    "--require-approval": "bool",
                    "--service-account": "value",
                    "--tag-pattern": "value",
                    "--trigger-config": "value",
                    "--update-substitutions": "value"
                  }
                },
                "manual": {
                  "commands": {},
                  "flags": {
                    "--clear-substitutions": "bool",
                    "--description": "value",
                    "--dockerfile": "value",
                    "--dockerfile-dir": "value",
                    "--dockerfile-image": "value",
                    "--git-file-source-branch": "value",
                    "--git-file-source-github-enterprise-config": "value",
                    "--git-file-source-path": "value",
                    "--git-file-source-repo-type": "value",
                    "--git-file-source-tag": "value",
                    "--git-file-source-uri": "value",
                    "--inline-config": "value",
                    "--region": "value",
                    "--remove-substitutions": "value",
                    "--require-approval": "bool",
                    "--service-account": "value",
                    "--source-to-build-branch": "value",
                    "--source-to-build-github-enterprise-config": "value",
                    "--source-to-build-repo-type": "value",
                    "--source-to-build-tag": "value",
                    "--source-to-build-uri": "value",
                    "--trigger-config": "value",
                    "--update-substitutions": "value"
                  }
                },
                "pubsub": {
                  "commands": {},
                  "flags": {
                    "--clear-subscription-filter": "bool",
                    "--clear-substitutions": "bool",
                    "--description": "value",
                    "--dockerfile": "value",
                    "--dockerfile-dir": "value",
                    "--dockerfile-image": "value",
                    "--git-file-source-branch": "value",
                    "--git-file-source-github-enterprise-config": "value",
                    "--git-file-source-path": "value",
                    "--git-file-source-repo-type": "value",
                    "--git-file-source-tag": "value",
                    "--git-file-source-uri": "value",
                    "--inline-config": "value",
                    "--region": "value",
                    "--remove-substitutions": "value",
                    "--require-approval": "bool",
                    "--service-account": "value",
                    "--source-to-build-branch": "value",
                    "--source-to-build-github-enterprise-config": "value",
                    "--source-to-build-repo-type": "value",
                    "--source-to-build-tag": "value",
                    "--source-to-build-uri": "value",
                    "--subscription-filter": "value",
                    "--topic": "value",
                    "--trigger-config": "value",
                    "--update-substitutions": "value"
                  }
                },
                "webhook": {
                  "commands": {},
                  "flags": {
                    "--clear-substitutions": "bool",
                    "--description": "value",
                    "--dockerfile": "value",
                    "--dockerfile-dir": "value",
                    "--dockerfile-image": "value",
                    "--git-file-source-branch": "value",
                    "--git-file-source-github-enterprise-config": "value",
                    "--git-file-source-path": "value",
                    "--git-file-source-repo-type": "value",
                    "--git-file-source-tag": "value",
                    "--git-file-source-uri": "value",
                    "--inline-config": "value",
                    "--region": "value",
                    "--remove-substitutions": "value",
                    "--require-approval": "bool",
                    "--secret": "value",
                    "--service-account": "value",
                    "--source-to-build-branch": "value",
                    "--source-to-build-github-enterprise-config": "value",
                    "--source-to-build-repo-type": "value",
                    "--source-to-build-tag": "value",
                    "--source-to-build-uri": "value",
                    "--subscription-filter": "value",
                    "--trigger-config": "value",
                    "--update-substitutions": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "worker-pools": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--config-from-file": "value",
                "--no-public-egress": "bool",
                "--peered-network": "value",
                "--peered-network-ip-range": "value",
                "--region": "value",
                "--worker-disk-size": "value",
                "--worker-machine-type": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--config-from-file": "value",
                "--public-egress": "bool",
                "--region": "value",
                "--worker-disk-size": "value",
                "--worker-machine-type": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "certificate-manager": {
      "commands": {
        "certificates": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--certificate-file": "value",
                "--description": "value",
                "--dns-authorizations": "value",
                "--domains": "value",
                "--issuance-config": "value",
                "--labels": "value",
                "--location": "value",
                "--private-key-file": "value",
                "--scope": [
                  "all-regions",
                  "default",
                  "edge-cache"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--certificate-file": "value",
                "--clear-labels": "bool",
                "--description": "value",
                "--location": "dynamic",
                "--private-key-file": "value",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "dns-authorizations": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--domain": "value",
                "--labels": "value",
                "--location": "value",
                "--type": [
                  "fixed-record",
                  "per-project-record",
                  "type-unspecified"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-labels": "bool",
                "--description": "value",
                "--location": "value",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "issuance-configs": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--ca-pool": "value",
                "--description": "value",
                "--key-algorithm": [
                  "ecdsa-p256",
                  "rsa-2048"
                ],
                "--labels": "value",
                "--lifetime": "value",
                "--location": "value",
                "--rotation-window-percentage": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-labels": "bool",
                "--description": "value",
                "--location": "value",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "maps": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--labels": "value",
                "--location": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "entries": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--certificates": "dynamic",
                    "--description": "value",
                    "--hostname": "value",
                    "--labels": "value",
                    "--location": "dynamic",
                    "--map": "dynamic",
                    "--set-primary": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic",
                    "--map": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic",
                    "--map": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--map": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--certificates": "dynamic",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "dynamic",
                    "--map": "dynamic",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-labels": "bool",
                "--description": "value",
                "--location": "dynamic",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "trust-configs": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--allowlisted-certificates": "value",
                "--async": "bool",
                "--description": "value",
                "--labels": "value",
                "--location": "value",
                "--trust-store": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--etag": "value",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--location": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--source": "value",
                "--update-mask": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-allowlisted-certificates": "value",
                "--async": "bool",
                "--clear-allowlisted-certificates": "bool",
                "--clear-labels": "bool",
                "--description": "value",
                "--location": "value",
                "--remove-allowlisted-certificates": "value",
                "--remove-labels": "value",
                "--trust-store": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "cheat-sheet": {
      "commands": {},
      "flags": {}
    },
    "cloud-shell": {
      "commands": {
        "get-mount-command": {
          "commands": {},
          "flags": {
            "--force-key-file-overwrite": "bool",
            "--ssh-key-file": "bool"
          }
        },
        "scp": {
          "commands": {},
          "flags": {
            "--dry-run": "bool",
            "--force-key-file-overwrite": "bool",
            "--recurse": "bool",
            "--scp-flag": "value",
            "--ssh-key-file": "bool"
          }
        },
        "ssh": {
          "commands": {},
          "flags": {
            "--authorize-session": "bool",
            "--command": "value",
            "--dry-run": "bool",
            "--force-key-file-overwrite": "bool",
            "--ssh-flag": "value",
            "--ssh-key-file": "bool"
          }
        }
      },
      "flags": {}
    },
    "colab": {
      "commands": {
        "executions": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--commit-sha": "value",
                "--dataform-repository-name": "value",
                "--direct-content": "value",
                "--display-name": "value",
                "--execution-timeout": "value",
                "--gcs-notebook-uri": "value",
                "--gcs-output-uri": "value",
                "--generation": "value",
                "--notebook-runtime-template": "value",
                "--region": "value",
                "--service-account": "value",
                "--user-email": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "runtime-templates": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--region": "value",
                "--role": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--accelerator-count": "value",
                "--accelerator-type": [
                  "NVIDIA_A100_80GB",
                  "NVIDIA_L4",
                  "NVIDIA_TESLA_A100",
                  "NVIDIA_TESLA_T4",
                  "NVIDIA_TESLA_V100"
                ],
                "--async": "bool",
                "--description": "value",
                "--disk-size-gb": "value",
                "--disk-type": [
                  "PD_BALANCED",
                  "PD_EXTREME",
                  "PD_SSD",
                  "PD_STANDARD"
                ],
                "--display-name": "value",
                "--enable-euc": "bool",
                "--enable-internet-access": "bool",
                "--enable-secure-boot": "bool",
                "--idle-shutdown-timeout": "value",
                "--kms-key": "value",
                "--kms-keyring": "value",
                "--kms-location": "value",
                "--kms-project": "value",
                "--labels": "value",
                "--machine-type": "value",
                "--network": "dynamic",
                "--network-tags": "value",
                "--region": "value",
                "--runtime-template-id": "value",
                "--subnetwork": "dynamic",
                "--subnetwork-region": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--region": "value",
                "--role": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            }
          },
          "flags": {}
        },
        "runtimes": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--display-name": "value",
                "--labels": "value",
                "--region": "value",
                "--runtime-id": "value",
                "--runtime-template": "value",
                "--runtime-user": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "start": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "value"
              }
            },
            "stop": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "value"
              }
            },
            "upgrade": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "value"
              }
            }
          },
          "flags": {}
        },
        "schedules": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--commit-sha": "value",
                "--cron-schedule": "value",
                "--dataform-repository-name": "value",
                "--display-name": "value",
                "--enable-queueing": "bool",
                "--end-time": "value",
                "--execution-display-name": "value",
                "--execution-timeout": "value",
                "--gcs-notebook-uri": "value",
                "--gcs-output-uri": "value",
                "--generation": "value",
                "--max-concurrent-runs": "value",
                "--max-runs": "value",
                "--notebook-runtime-template": "value",
                "--region": "value",
                "--service-account": "value",
                "--start-time": "value",
                "--user-email": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "pause": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "resume": {
              "commands": {},
              "flags": {
                "--enable-catch-up": "bool",
                "--region": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--cron-schedule": "value",
                "--display-name": "value",
                "--enable-queueing": "bool",
                "--end-time": "value",
                "--max-concurrent-runs": "value",
                "--max-runs": "value",
                "--region": "value",
                "--start-time": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "components": {
      "commands": {
        "install": {
          "commands": {},
          "flags": {}
        },
        "list": {
          "commands": {},
          "flags": {
            "--filter": "value",
            "--limit": "value",
            "--only-local-state": "bool",
            "--show-platform": "bool",
            "--show-versions": "bool",
            "--sort-by": "value"
          }
        },
        "reinstall": {
          "commands": {},
          "flags": {}
        },
        "remove": {
          "commands": {},
          "flags": {}
        },
        "repositories": {
          "commands": {
            "add": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--sort-by": "value"
              }
            },
            "remove": {
              "commands": {},
              "flags": {
                "--all": "bool"
              }
            }
          },
          "flags": {}
        },
        "update": {
          "commands": {},
          "flags": {}
        }
      },
      "flags": {}
    },
    "composer": {
      "commands": {
        "environments": {
          "commands": {
            "check-upgrade": {
              "commands": {},
              "flags": {
                "--airflow-version": "value",
                "--async": "bool",
                "--image-version": "value",
                "--location": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--airflow-configs": "value",
                "--airflow-version": "value",
                "--async": "bool",
                "--cloud-sql-ipv4-cidr": "value",
                "--cloud-sql-machine-type": "value",
                "--cloud-sql-preferred-zone": "value",
                "--cluster-ipv4-cidr": "value",
                "--cluster-secondary-range-name": "value",
                "--composer-internal-ipv4-cidr-block": "value",
                "--composer-network-ipv4-cidr": "value",
                "--connection-subnetwork": "value",
                "--connection-type": [
                  "connection-type-unspecified",
                  "private-service-connect",
                  "vpc-peering"
                ],
                "--dag-processor-count": "value",
                "--dag-processor-cpu": "value",
                "--dag-processor-memory": "value",
                "--dag-processor-storage": "value",
                "--disable-cloud-data-lineage-integration": "bool",
                "--disable-logs-in-cloud-logging-only": "bool",
                "--disable-private-builds-only": "bool",
                "--disk-size": "value",
                "--enable-cloud-data-lineage-integration": "bool",
                "--enable-high-resilience": "bool",
                "--enable-ip-alias": "bool",
                "--enable-ip-masq-agent": "bool",
                "--enable-logs-in-cloud-logging-only": "bool",
                "--enable-master-authorized-networks": "bool",
                "--enable-private-builds-only": "bool",
                "--enable-private-endpoint": "bool",
                "--enable-private-environment": "bool",
                "--enable-privately-used-public-ips": "bool",
                "--enable-scheduled-snapshot-creation": "bool",
                "--enable-triggerer": "bool",
                "--env-variables": "value",
                "--environment-size": [
                  "large",
                  "medium",
                  "small",
                  "unspecified"
                ],
                "--image-version": "value",
                "--kms-key": "dynamic",
                "--kms-keyring": "dynamic",
                "--kms-location": "dynamic",
                "--kms-project": "dynamic",
                "--labels": "value",
                "--location": "value",
                "--machine-type": "value",
                "--maintenance-window-end": "value",
                "--maintenance-window-recurrence": "value",
                "--maintenance-window-start": "value",
                "--master-authorized-networks": "value",
                "--master-ipv4-cidr": "value",
                "--max-workers": "value",
                "--min-workers": "value",
                "--network": "value",
                "--network-attachment": "value",
                "--node-count": "value",
                "--oauth-scopes": "value",
                "--python-version": [
                  "2",
                  "3"
                ],
                "--scheduler-count": "value",
                "--scheduler-cpu": "value",
                "--scheduler-memory": "value",
                "--scheduler-storage": "value",
                "--service-account": "value",
                "--services-ipv4-cidr": "value",
                "--services-secondary-range-name": "value",
                "--snapshot-creation-schedule": "value",
                "--snapshot-location": "value",
                "--snapshot-schedule-timezone": "value",
                "--storage-bucket": "value",
                "--subnetwork": "value",
                "--support-web-server-plugins": "bool",
                "--tags": "value",
                "--triggerer-count": "value",
                "--triggerer-cpu": "value",
                "--triggerer-memory": "value",
                "--web-server-allow-all": "bool",
                "--web-server-allow-ip": "value",
                "--web-server-cpu": "value",
                "--web-server-deny-all": "bool",
                "--web-server-ipv4-cidr": "value",
                "--web-server-machine-type": "value",
                "--web-server-memory": "value",
                "--web-server-storage": "value",
                "--worker-cpu": "value",
                "--worker-memory": "value",
                "--worker-storage": "value",
                "--zone": "value"
              }
            },
            "database-failover": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "fetch-database-properties": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--locations": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "list-packages": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--tree": "bool"
              }
            },
            "list-upgrades": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list-workloads": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "run": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "snapshots": {
              "commands": {
                "load": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--skip-airflow-overrides-setting": "bool",
                    "--skip-environment-variables-setting": "bool",
                    "--skip-gcs-data-copying": "bool",
                    "--skip-pypi-packages-installation": "bool",
                    "--snapshot-path": "value"
                  }
                },
                "save": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--snapshot-location": "value"
                  }
                }
              },
              "flags": {}
            },
            "storage": {
              "commands": {
                "dags": {
                  "commands": {
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--environment": "value",
                        "--location": "value"
                      }
                    },
                    "export": {
                      "commands": {},
                      "flags": {
                        "--destination": "value",
                        "--environment": "value",
                        "--location": "value",
                        "--source": "value"
                      }
                    },
                    "import": {
                      "commands": {},
                      "flags": {
                        "--destination": "value",
                        "--environment": "value",
                        "--location": "value",
                        "--source": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--environment": "value",
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "data": {
                  "commands": {
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--environment": "value",
                        "--location": "value"
                      }
                    },
                    "export": {
                      "commands": {},
                      "flags": {
                        "--destination": "value",
                        "--environment": "value",
                        "--location": "value",
                        "--source": "value"
                      }
                    },
                    "import": {
                      "commands": {},
                      "flags": {
                        "--destination": "value",
                        "--environment": "value",
                        "--location": "value",
                        "--source": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--environment": "value",
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "plugins": {
                  "commands": {
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--environment": "value",
                        "--location": "value"
                      }
                    },
                    "export": {
                      "commands": {},
                      "flags": {
                        "--destination": "value",
                        "--environment": "value",
                        "--location": "value",
                        "--source": "value"
                      }
                    },
                    "import": {
                      "commands": {},
                      "flags": {
                        "--destination": "value",
                        "--environment": "value",
                        "--location": "value",
                        "--source": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--environment": "value",
                        "--location": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-airflow-configs": "bool",
                "--clear-env-variables": "bool",
                "--clear-labels": "bool",
                "--clear-maintenance-window": "bool",
                "--clear-pypi-packages": "bool",
                "--cloud-sql-machine-type": "value",
                "--dag-processor-count": "value",
                "--dag-processor-cpu": "value",
                "--dag-processor-memory": "value",
                "--dag-processor-storage": "value",
                "--disable-cloud-data-lineage-integration": "bool",
                "--disable-high-resilience": "bool",
                "--disable-logs-in-cloud-logging-only": "bool",
                "--disable-master-authorized-networks": "bool",
                "--disable-private-builds-only": "bool",
                "--disable-private-environment": "bool",
                "--disable-scheduled-snapshot-creation": "bool",
                "--disable-triggerer": "bool",
                "--disable-vpc-connectivity": "bool",
                "--enable-cloud-data-lineage-integration": "bool",
                "--enable-high-resilience": "bool",
                "--enable-logs-in-cloud-logging-only": "bool",
                "--enable-master-authorized-networks": "bool",
                "--enable-private-builds-only": "bool",
                "--enable-private-environment": "bool",
                "--enable-scheduled-snapshot-creation": "bool",
                "--enable-triggerer": "bool",
                "--environment-size": [
                  "large",
                  "medium",
                  "small",
                  "unspecified"
                ],
                "--image-version": "value",
                "--location": "value",
                "--maintenance-window-end": "value",
                "--maintenance-window-recurrence": "value",
                "--maintenance-window-start": "value",
                "--master-authorized-networks": "value",
                "--max-workers": "value",
                "--min-workers": "value",
                "--network": "value",
                "--network-attachment": "value",
                "--node-count": "value",
                "--remove-airflow-configs": "value",
                "--remove-env-variables": "value",
                "--remove-labels": "value",
                "--remove-pypi-packages": "value",
                "--scheduler-count": "value",
                "--scheduler-cpu": "value",
                "--scheduler-memory": "value",
                "--scheduler-storage": "value",
                "--snapshot-creation-schedule": "value",
                "--snapshot-location": "value",
                "--snapshot-schedule-timezone": "value",
                "--subnetwork": "value",
                "--support-web-server-plugins": "bool",
                "--triggerer-count": "value",
                "--triggerer-cpu": "value",
                "--triggerer-memory": "value",
                "--update-airflow-configs": "value",
                "--update-env-variables": "value",
                "--update-labels": "value",
                "--update-pypi-package": "value",
                "--update-pypi-packages-from-file": "value",
                "--update-web-server-allow-ip": "value",
                "--web-server-allow-all": "bool",
                "--web-server-cpu": "value",
                "--web-server-deny-all": "bool",
                "--web-server-machine-type": "value",
                "--web-server-memory": "value",
                "--web-server-storage": "value",
                "--worker-cpu": "value",
                "--worker-memory": "value",
                "--worker-storage": "value"
              }
            },
            "user-workloads-config-maps": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--config-map-file-path": "value",
                    "--environment": "value",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--environment": "value",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--environment": "value",
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--environment": "value",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--config-map-file-path": "value",
                    "--environment": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "user-workloads-secrets": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--environment": "value",
                    "--location": "value",
                    "--secret-file-path": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--environment": "value",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--environment": "value",
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--environment": "value",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--environment": "value",
                    "--location": "value",
                    "--secret-file-path": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--locations": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "wait": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "compute": {
      "commands": {
        "accelerator-types": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--zone": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "addresses": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--addresses": "value",
                "--description": "value",
                "--endpoint-type": [
                  "NETLB",
                  "VM"
                ],
                "--global": "bool",
                "--ip-version": [
                  "IPV4",
                  "IPV6"
                ],
                "--network": "value",
                "--network-tier": "value",
                "--prefix-length": "value",
                "--purpose": [
                  "GCE_ENDPOINT",
                  "IPSEC_INTERCONNECT",
                  "PRIVATE_SERVICE_CONNECT",
                  "SHARED_LOADBALANCER_VIP",
                  "VPC_PEERING"
                ],
                "--region": "dynamic",
                "--subnet": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--global": "bool",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "move": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--global": "bool",
                "--new-name": "value",
                "--region": "dynamic",
                "--target-project": "value"
              }
            }
          },
          "flags": {}
        },
        "backend-buckets": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "add-signed-url-key": {
              "commands": {},
              "flags": {
                "--key-file": "value",
                "--key-name": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--bypass-cache-on-request-headers": "value",
                "--cache-key-include-http-header": "value",
                "--cache-key-query-string-whitelist": "value",
                "--cache-mode": [
                  "CACHE_ALL_STATIC",
                  "FORCE_CACHE_ALL",
                  "USE_ORIGIN_HEADERS"
                ],
                "--client-ttl": "value",
                "--compression-mode": [
                  "AUTOMATIC",
                  "DISABLED"
                ],
                "--custom-response-header": "value",
                "--default-ttl": "value",
                "--description": "value",
                "--enable-cdn": "bool",
                "--gcs-bucket-name": "dynamic",
                "--max-ttl": "value",
                "--negative-caching": "bool",
                "--negative-caching-policy": "value",
                "--request-coalescing": "bool",
                "--serve-while-stale": "value",
                "--signed-url-cache-max-age": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "delete-signed-url-key": {
              "commands": {},
              "flags": {
                "--key-name": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--bypass-cache-on-request-headers": "value",
                "--cache-key-include-http-header": "value",
                "--cache-key-query-string-whitelist": "value",
                "--cache-mode": [
                  "CACHE_ALL_STATIC",
                  "FORCE_CACHE_ALL",
                  "USE_ORIGIN_HEADERS"
                ],
                "--client-ttl": "value",
                "--compression-mode": [
                  "AUTOMATIC",
                  "DISABLED"
                ],
                "--custom-response-header": "value",
                "--default-ttl": "value",
                "--description": "value",
                "--edge-security-policy": "dynamic",
                "--enable-cdn": "bool",
                "--gcs-bucket-name": "dynamic",
                "--max-ttl": "value",
                "--negative-caching": "bool",
                "--negative-caching-policy": "value",
                "--no-bypass-cache-on-request-headers": "bool",
                "--no-client-ttl": "bool",
                "--no-custom-response-headers": "bool",
                "--no-default-ttl": "bool",
                "--no-max-ttl": "bool",
                "--no-negative-caching-policies": "bool",
                "--no-serve-while-stale": "bool",
                "--request-coalescing": "bool",
                "--serve-while-stale": "value",
                "--signed-url-cache-max-age": "value"
              }
            }
          },
          "flags": {}
        },
        "backend-services": {
          "commands": {
            "add-backend": {
              "commands": {},
              "flags": {
                "--balancing-mode": [
                  "CONNECTION",
                  "CUSTOM_METRICS",
                  "RATE",
                  "UTILIZATION"
                ],
                "--capacity-scaler": "value",
                "--description": "value",
                "--failover": "bool",
                "--global": "bool",
                "--global-network-endpoint-group": "bool",
                "--instance-group": "dynamic",
                "--instance-group-region": "dynamic",
                "--instance-group-zone": "dynamic",
                "--max-connections": "value",
                "--max-connections-per-endpoint": "value",
                "--max-connections-per-instance": "value",
                "--max-rate": "value",
                "--max-rate-per-endpoint": "value",
                "--max-rate-per-instance": "value",
                "--max-utilization": "value",
                "--network-endpoint-group": "value",
                "--network-endpoint-group-region": "dynamic",
                "--network-endpoint-group-zone": "dynamic",
                "--preference": [
                  "DEFAULT",
                  "PREFERRED"
                ],
                "--region": "dynamic"
              }
            },
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--member": "value",
                "--region": "dynamic",
                "--role": "value"
              }
            },
            "add-service-bindings": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic",
                "--service-bindings": "dynamic"
              }
            },
            "add-signed-url-key": {
              "commands": {},
              "flags": {
                "--key-file": "value",
                "--key-name": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--affinity-cookie-name": "value",
                "--affinity-cookie-path": "value",
                "--affinity-cookie-ttl": "value",
                "--bypass-cache-on-request-headers": "value",
                "--cache-key-include-host": "bool",
                "--cache-key-include-http-header": "value",
                "--cache-key-include-named-cookie": "value",
                "--cache-key-include-protocol": "bool",
                "--cache-key-include-query-string": "bool",
                "--cache-key-query-string-blacklist": "value",
                "--cache-key-query-string-whitelist": "value",
                "--cache-mode": [
                  "CACHE_ALL_STATIC",
                  "FORCE_CACHE_ALL",
                  "USE_ORIGIN_HEADERS"
                ],
                "--client-ttl": "value",
                "--compression-mode": [
                  "AUTOMATIC",
                  "DISABLED"
                ],
                "--connection-drain-on-failover": "bool",
                "--connection-draining-timeout": "value",
                "--connection-persistence-on-unhealthy-backends": [
                  "ALWAYS_PERSIST",
                  "DEFAULT_FOR_PROTOCOL",
                  "NEVER_PERSIST"
                ],
                "--custom-request-header": "value",
                "--custom-response-header": "value",
                "--default-ttl": "value",
                "--description": "value",
                "--drop-traffic-if-unhealthy": "bool",
                "--enable-cdn": "bool",
                "--enable-logging": "bool",
                "--enable-strong-affinity": "bool",
                "--failover-ratio": "value",
                "--global": "bool",
                "--global-health-checks": "bool",
                "--health-checks": "dynamic",
                "--health-checks-region": "dynamic",
                "--http-health-checks": "dynamic",
                "--https-health-checks": "dynamic",
                "--iap": "value",
                "--idle-timeout-sec": "value",
                "--ip-address-selection-policy": [
                  "IPV4_ONLY",
                  "IPV6_ONLY",
                  "PREFER_IPV6"
                ],
                "--load-balancing-scheme": [
                  "EXTERNAL",
                  "EXTERNAL_MANAGED",
                  "INTERNAL",
                  "INTERNAL_MANAGED",
                  "INTERNAL_SELF_MANAGED"
                ],
                "--locality-lb-policy": [
                  "INVALID_LB_POLICY",
                  "LEAST_REQUEST",
                  "MAGLEV",
                  "ORIGINAL_DESTINATION",
                  "RANDOM",
                  "RING_HASH",
                  "ROUND_ROBIN",
                  "WEIGHTED_MAGLEV",
                  "WEIGHTED_ROUND_ROBIN"
                ],
                "--logging-optional": [
                  "CUSTOM",
                  "EXCLUDE_ALL_OPTIONAL",
                  "INCLUDE_ALL_OPTIONAL"
                ],
                "--logging-optional-fields": "value",
                "--logging-sample-rate": "value",
                "--max-ttl": "value",
                "--negative-caching": "bool",
                "--negative-caching-policy": "value",
                "--network": "value",
                "--port-name": "value",
                "--protocol": "value",
                "--region": "dynamic",
                "--request-coalescing": "bool",
                "--serve-while-stale": "value",
                "--service-bindings": "dynamic",
                "--service-lb-policy": "value",
                "--session-affinity": [
                  "CLIENT_IP",
                  "CLIENT_IP_NO_DESTINATION",
                  "CLIENT_IP_PORT_PROTO",
                  "CLIENT_IP_PROTO",
                  "GENERATED_COOKIE",
                  "HEADER_FIELD",
                  "HTTP_COOKIE",
                  "NONE",
                  "STRONG_COOKIE_AFFINITY"
                ],
                "--signed-url-cache-max-age": "value",
                "--subsetting-policy": [
                  "CONSISTENT_HASH_SUBSETTING",
                  "NONE"
                ],
                "--timeout": "value",
                "--tracking-mode": [
                  "PER_CONNECTION",
                  "PER_SESSION"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "delete-signed-url-key": {
              "commands": {},
              "flags": {
                "--key-name": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "edit": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "get-health": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--global": "bool",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--global": "bool",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--global": "bool",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "list-usable": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--global": "bool",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-backend": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--global-network-endpoint-group": "bool",
                "--instance-group": "dynamic",
                "--instance-group-region": "dynamic",
                "--instance-group-zone": "dynamic",
                "--network-endpoint-group": "value",
                "--network-endpoint-group-region": "dynamic",
                "--network-endpoint-group-zone": "dynamic",
                "--region": "dynamic"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--member": "value",
                "--region": "dynamic",
                "--role": "value"
              }
            },
            "remove-service-bindings": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic",
                "--service-bindings": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--affinity-cookie-name": "value",
                "--affinity-cookie-path": "value",
                "--affinity-cookie-ttl": "value",
                "--bypass-cache-on-request-headers": "value",
                "--cache-key-include-host": "bool",
                "--cache-key-include-http-header": "value",
                "--cache-key-include-named-cookie": "value",
                "--cache-key-include-protocol": "bool",
                "--cache-key-include-query-string": "bool",
                "--cache-key-query-string-blacklist": "value",
                "--cache-key-query-string-whitelist": "value",
                "--cache-mode": [
                  "CACHE_ALL_STATIC",
                  "FORCE_CACHE_ALL",
                  "USE_ORIGIN_HEADERS"
                ],
                "--client-ttl": "value",
                "--compression-mode": [
                  "AUTOMATIC",
                  "DISABLED"
                ],
                "--connection-drain-on-failover": "bool",
                "--connection-draining-timeout": "value",
                "--connection-persistence-on-unhealthy-backends": [
                  "ALWAYS_PERSIST",
                  "DEFAULT_FOR_PROTOCOL",
                  "NEVER_PERSIST"
                ],
                "--custom-request-header": "value",
                "--custom-response-header": "value",
                "--default-ttl": "value",
                "--description": "value",
                "--drop-traffic-if-unhealthy": "bool",
                "--edge-security-policy": "dynamic",
                "--enable-cdn": "bool",
                "--enable-logging": "bool",
                "--enable-strong-affinity": "bool",
                "--failover-ratio": "value",
                "--global": "bool",
                "--global-health-checks": "bool",
                "--health-checks": "dynamic",
                "--health-checks-region": "dynamic",
                "--http-health-checks": "dynamic",
                "--https-health-checks": "dynamic",
                "--iap": "value",
                "--idle-timeout-sec": "value",
                "--ip-address-selection-policy": [
                  "IPV4_ONLY",
                  "IPV6_ONLY",
                  "PREFER_IPV6"
                ],
                "--locality-lb-policy": [
                  "INVALID_LB_POLICY",
                  "LEAST_REQUEST",
                  "MAGLEV",
                  "ORIGINAL_DESTINATION",
                  "RANDOM",
                  "RING_HASH",
                  "ROUND_ROBIN",
                  "WEIGHTED_MAGLEV",
                  "WEIGHTED_ROUND_ROBIN"
                ],
                "--logging-optional": [
                  "CUSTOM",
                  "EXCLUDE_ALL_OPTIONAL",
                  "INCLUDE_ALL_OPTIONAL"
                ],
                "--logging-optional-fields": "value",
                "--logging-sample-rate": "value",
                "--max-ttl": "value",
                "--negative-caching": "bool",
                "--negative-caching-policy": "value",
                "--no-bypass-cache-on-request-headers": "bool",
                "--no-client-ttl": "bool",
                "--no-custom-request-headers": "bool",
                "--no-custom-response-headers": "bool",
                "--no-default-ttl": "bool",
                "--no-health-checks": "bool",
                "--no-max-ttl": "bool",
                "--no-negative-caching-policies": "bool",
                "--no-serve-while-stale": "bool",
                "--no-service-bindings": "bool",
                "--no-service-lb-policy": "bool",
                "--port-name": "value",
                "--protocol": "value",
                "--region": "dynamic",
                "--request-coalescing": "bool",
                "--security-policy": "dynamic",
                "--serve-while-stale": "value",
                "--service-bindings": "dynamic",
                "--service-lb-policy": "value",
                "--session-affinity": [
                  "CLIENT_IP",
                  "CLIENT_IP_NO_DESTINATION",
                  "CLIENT_IP_PORT_PROTO",
                  "CLIENT_IP_PROTO",
                  "GENERATED_COOKIE",
                  "HEADER_FIELD",
                  "HTTP_COOKIE",
                  "NONE",
                  "STRONG_COOKIE_AFFINITY"
                ],
                "--signed-url-cache-max-age": "value",
                "--subsetting-policy": [
                  "CONSISTENT_HASH_SUBSETTING",
                  "NONE"
                ],
                "--timeout": "value",
                "--tracking-mode": [
                  "PER_CONNECTION",
                  "PER_SESSION"
                ]
              }
            },
            "update-backend": {
              "commands": {},
              "flags": {
                "--balancing-mode": [
                  "CONNECTION",
                  "CUSTOM_METRICS",
                  "RATE",
                  "UTILIZATION"
                ],
                "--capacity-scaler": "value",
                "--description": "value",
                "--failover": "bool",
                "--global": "bool",
                "--instance-group": "dynamic",
                "--instance-group-region": "dynamic",
                "--instance-group-zone": "dynamic",
                "--max-connections": "value",
                "--max-connections-per-endpoint": "value",
                "--max-connections-per-instance": "value",
                "--max-rate": "value",
                "--max-rate-per-endpoint": "value",
                "--max-rate-per-instance": "value",
                "--max-utilization": "value",
                "--network-endpoint-group": "value",
                "--network-endpoint-group-zone": "dynamic",
                "--preference": [
                  "DEFAULT",
                  "PREFERRED"
                ],
                "--region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "commitments": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--accelerator": "value",
                "--auto-renew": "bool",
                "--custom-end-time": "value",
                "--existing-reservation": "value",
                "--local-ssd": "value",
                "--machine-type": "value",
                "--merge-source-commitments": "value",
                "--min-cpu-platform": "value",
                "--plan": [
                  "12-month",
                  "36-month"
                ],
                "--region": "dynamic",
                "--require-specific-reservation": "bool",
                "--reservation": "dynamic",
                "--reservation-zone": "dynamic",
                "--reservations-from-file": "value",
                "--resource-policies": "value",
                "--resources": "value",
                "--resources-accelerator": "value",
                "--share-setting": [
                  "local",
                  "projects"
                ],
                "--share-with": "value",
                "--split-source-commitment": "value",
                "--type": [
                  "accelerator-optimized",
                  "accelerator-optimized-a3",
                  "accelerator-optimized-a3-mega",
                  "compute-optimized",
                  "compute-optimized-c2d",
                  "compute-optimized-c3",
                  "compute-optimized-c3d",
                  "compute-optimized-h3",
                  "general-purpose",
                  "general-purpose-c4",
                  "general-purpose-c4a",
                  "general-purpose-e2",
                  "general-purpose-n2",
                  "general-purpose-n2d",
                  "general-purpose-n4",
                  "general-purpose-t2d",
                  "graphics-optimized",
                  "memory-optimized",
                  "memory-optimized-m3",
                  "memory-optimized-x4-16tb",
                  "memory-optimized-x4-24tb",
                  "memory-optimized-x4-32tb",
                  "storage-optimized-z3"
                ],
                "--vm-count": "value"
              }
            },
            "create-license": {
              "commands": {},
              "flags": {
                "--amount": "value",
                "--cores-per-license": "value",
                "--license": "value",
                "--plan": [
                  "12-month",
                  "36-month"
                ],
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--auto-renew": "bool",
                "--custom-end-time": "value",
                "--plan": [
                  "36-month"
                ],
                "--region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "config-ssh": {
          "commands": {},
          "flags": {
            "--dry-run": "bool",
            "--force-key-file-overwrite": "bool",
            "--remove": "bool",
            "--ssh-config-file": "value",
            "--ssh-key-file": "value"
          }
        },
        "connect-to-serial-port": {
          "commands": {},
          "flags": {
            "--dry-run": "bool",
            "--extra-args": "value",
            "--force-key-file-overwrite": "bool",
            "--location": "value",
            "--port": "value",
            "--ssh-key-expiration": "value",
            "--ssh-key-expire-after": "value",
            "--ssh-key-file": "value",
            "--zone": "dynamic"
          }
        },
        "copy-files": {
          "commands": {},
          "flags": {
            "--dry-run": "bool",
            "--force-key-file-overwrite": "bool",
            "--plain": "bool",
            "--ssh-key-expiration": "value",
            "--ssh-key-expire-after": "value",
            "--ssh-key-file": "value",
            "--strict-host-key-checking": [
              "ask",
              "no",
              "yes"
            ],
            "--zone": "value"
          }
        },
        "diagnose": {
          "commands": {
            "export-logs": {
              "commands": {},
              "flags": {
                "--collect-process-traces": "bool",
                "--zone": "dynamic"
              }
            },
            "routes": {
              "commands": {},
              "flags": {
                "--container": "value",
                "--dry-run": "bool",
                "--external-route-ip": "value",
                "--force-key-file-overwrite": "bool",
                "--plain": "bool",
                "--regexp": "value",
                "--reverse-traceroute": "bool",
                "--ssh-flag": "value",
                "--ssh-key-expiration": "value",
                "--ssh-key-expire-after": "value",
                "--ssh-key-file": "value",
                "--strict-host-key-checking": [
                  "ask",
                  "no",
                  "yes"
                ],
                "--user": "value",
                "--zones": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "disk-types": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--zone": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--sort-by": "value",
                "--uri": "bool",
                "--zones": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "disks": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic",
                "--zone": "value"
              }
            },
            "add-labels": {
              "commands": {},
              "flags": {
                "--labels": "value",
                "--region": "dynamic",
                "--zone": "dynamic"
              }
            },
            "add-resource-policies": {
              "commands": {},
              "flags": {
                "--region": "dynamic",
                "--resource-policies": "value",
                "--zone": "dynamic"
              }
            },
            "bulk": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--source-consistency-group-policy": "value",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "convert": {
              "commands": {},
              "flags": {
                "--kms-key": "dynamic",
                "--kms-keyring": "dynamic",
                "--kms-location": "dynamic",
                "--kms-project": "dynamic",
                "--region": "dynamic",
                "--target-disk-type": "dynamic",
                "--zone": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--access-mode": [
                  "READ_ONLY_MANY",
                  "READ_WRITE_MANY",
                  "READ_WRITE_SINGLE"
                ],
                "--architecture": [
                  "ARM64",
                  "X86_64"
                ],
                "--confidential-compute": "bool",
                "--csek-key-file": "value",
                "--description": "value",
                "--guest-os-features": "value",
                "--image": "value",
                "--image-family": "value",
                "--image-family-scope": [
                  "global",
                  "zonal"
                ],
                "--image-project": "value",
                "--kms-key": "dynamic",
                "--kms-keyring": "dynamic",
                "--kms-location": "dynamic",
                "--kms-project": "dynamic",
                "--labels": "value",
                "--licenses": "value",
                "--primary-disk": "dynamic",
                "--primary-disk-project": "value",
                "--primary-disk-region": "dynamic",
                "--primary-disk-zone": "dynamic",
                "--provisioned-iops": "value",
                "--provisioned-throughput": "value",
                "--region": "dynamic",
                "--replica-zones": "value",
                "--require-csek-key-create": "bool",
                "--resource-policies": "value",
                "--size": "value",
                "--source-disk": "dynamic",
                "--source-disk-region": "dynamic",
                "--source-disk-zone": "dynamic",
                "--source-instant-snapshot": "dynamic",
                "--source-snapshot": "dynamic",
                "--storage-pool": "value",
                "--type": "dynamic",
                "--zone": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "dynamic",
                "--zone": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic",
                "--zone": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--zone": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool",
                "--zones": "value"
              }
            },
            "move": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--destination-zone": "dynamic",
                "--zone": "dynamic"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic",
                "--zone": "value"
              }
            },
            "remove-labels": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--labels": "value",
                "--region": "dynamic",
                "--zone": "dynamic"
              }
            },
            "remove-resource-policies": {
              "commands": {},
              "flags": {
                "--region": "dynamic",
                "--resource-policies": "value",
                "--zone": "dynamic"
              }
            },
            "resize": {
              "commands": {},
              "flags": {
                "--region": "dynamic",
                "--size": "value",
                "--zone": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--zone": "value"
              }
            },
            "snapshot": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--chain-name": "value",
                "--csek-key-file": "value",
                "--description": "value",
                "--guest-flush": "bool",
                "--labels": "value",
                "--region": "dynamic",
                "--snapshot-names": "value",
                "--storage-location": "value",
                "--zone": "dynamic"
              }
            },
            "start-async-replication": {
              "commands": {},
              "flags": {
                "--region": "dynamic",
                "--secondary-disk": "dynamic",
                "--secondary-disk-project": "value",
                "--secondary-disk-region": "dynamic",
                "--secondary-disk-zone": "dynamic",
                "--zone": "dynamic"
              }
            },
            "stop-async-replication": {
              "commands": {},
              "flags": {
                "--region": "dynamic",
                "--zone": "dynamic"
              }
            },
            "stop-group-async-replication": {
              "commands": {},
              "flags": {
                "--region": "dynamic",
                "--zone": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--access-mode": [
                  "READ_ONLY_MANY",
                  "READ_WRITE_MANY",
                  "READ_WRITE_SINGLE"
                ],
                "--clear-architecture": "bool",
                "--clear-labels": "bool",
                "--provisioned-iops": "value",
                "--provisioned-throughput": "value",
                "--region": "dynamic",
                "--remove-labels": "value",
                "--size": "value",
                "--update-architecture": [
                  "ARM64",
                  "X86_64"
                ],
                "--update-labels": "value",
                "--zone": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "external-vpn-gateways": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--interfaces": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-labels": "bool",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "firewall-policies": {
          "commands": {
            "associations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--firewall-policy": "value",
                    "--folder": "value",
                    "--name": "value",
                    "--organization": "value",
                    "--replace-association-on-target": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--firewall-policy": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "clone-rules": {
              "commands": {},
              "flags": {
                "--organization": "value",
                "--source-firewall-policy": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--folder": "value",
                "--organization": "value",
                "--short-name": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--organization": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--organization": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "list-rules": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--organization": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "move": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "value"
              }
            },
            "rules": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--action": [
                      "allow",
                      "apply_security_profile_group",
                      "deny",
                      "goto_next"
                    ],
                    "--description": "value",
                    "--dest-address-groups": "value",
                    "--dest-fqdns": "value",
                    "--dest-ip-ranges": "value",
                    "--dest-region-codes": "value",
                    "--dest-threat-intelligence": "value",
                    "--direction": [
                      "EGRESS",
                      "INGRESS"
                    ],
                    "--disabled": "bool",
                    "--enable-logging": "bool",
                    "--firewall-policy": "value",
                    "--layer4-configs": "value",
                    "--organization": "value",
                    "--security-profile-group": "value",
                    "--src-address-groups": "value",
                    "--src-fqdns": "value",
                    "--src-ip-ranges": "value",
                    "--src-region-codes": "value",
                    "--src-secure-tags": "value",
                    "--src-threat-intelligence": "value",
                    "--target-resources": "value",
                    "--target-secure-tags": "value",
                    "--target-service-accounts": "value",
                    "--tls-inspect": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--firewall-policy": "value",
                    "--organization": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--firewall-policy": "value",
                    "--organization": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--action": [
                      "allow",
                      "apply_security_profile_group",
                      "deny",
                      "goto_next"
                    ],
                    "--description": "value",
                    "--dest-address-groups": "value",
                    "--dest-fqdns": "value",
                    "--dest-ip-ranges": "value",
                    "--dest-region-codes": "value",
                    "--dest-threat-intelligence": "value",
                    "--direction": [
                      "EGRESS",
                      "INGRESS"
                    ],
                    "--disabled": "bool",
                    "--enable-logging": "bool",
                    "--firewall-policy": "value",
                    "--layer4-configs": "value",
                    "--new-priority": "value",
                    "--organization": "value",
                    "--security-profile-group": "value",
                    "--src-address-groups": "value",
                    "--src-fqdns": "value",
                    "--src-ip-ranges": "value",
                    "--src-region-codes": "value",
                    "--src-secure-tags": "value",
                    "--src-threat-intelligence": "value",
                    "--target-resources": "value",
                    "--target-secure-tags": "value",
                    "--target-service-accounts": "value",
                    "--tls-inspect": "bool"
                  }
                }
              },
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--organization": "value"
              }
            }
          },
          "flags": {}
        },
        "firewall-rules": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--action": [
                  "ALLOW",
                  "DENY"
                ],
                "--allow": "value",
                "--description": "value",
                "--destination-ranges": "value",
                "--direction": [
                  "EGRESS",
                  "IN",
                  "INGRESS",
                  "OUT"
                ],
                "--disabled": "bool",
                "--enable-logging": "bool",
                "--logging-metadata": [
                  "exclude-all",
                  "include-all"
                ],
                "--network": "value",
                "--priority": "value",
                "--rules": "value",
                "--source-ranges": "value",
                "--source-service-accounts": "value",
                "--source-tags": "value",
                "--target-service-accounts": "value",
                "--target-tags": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--allow": "value",
                "--description": "value",
                "--destination-ranges": "value",
                "--disabled": "bool",
                "--enable-logging": "bool",
                "--logging-metadata": [
                  "exclude-all",
                  "include-all"
                ],
                "--priority": "value",
                "--rules": "value",
                "--source-ranges": "value",
                "--source-service-accounts": "value",
                "--source-tags": "value",
                "--target-service-accounts": "value",
                "--target-tags": "value"
              }
            }
          },
          "flags": {}
        },
        "forwarding-rules": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--address": "dynamic",
                "--address-region": "dynamic",
                "--allow-global-access": "bool",
                "--allow-psc-global-access": "bool",
                "--backend-service": "value",
                "--backend-service-region": "dynamic",
                "--description": "value",
                "--disable-automate-dns-zone": "bool",
                "--global": "bool",
                "--global-address": "bool",
                "--global-backend-service": "bool",
                "--global-target-http-proxy": "bool",
                "--global-target-https-proxy": "bool",
                "--global-target-tcp-proxy": "bool",
                "--ip-collection": "value",
                "--ip-collection-region": "dynamic",
                "--ip-protocol": [
                  "AH",
                  "ESP",
                  "ICMP",
                  "L3_DEFAULT",
                  "SCTP",
                  "TCP",
                  "UDP"
                ],
                "--ip-version": [
                  "IPV4",
                  "IPV6"
                ],
                "--is-mirroring-collector": "bool",
                "--load-balancing-scheme": [
                  "EXTERNAL",
                  "EXTERNAL_MANAGED",
                  "INTERNAL",
                  "INTERNAL_MANAGED",
                  "INTERNAL_SELF_MANAGED"
                ],
                "--network": "value",
                "--network-tier": "value",
                "--port-range": "value",
                "--ports": "value",
                "--region": "dynamic",
                "--service-directory-registration": "value",
                "--service-label": "value",
                "--source-ip-ranges": "value",
                "--subnet": "value",
                "--subnet-region": "dynamic",
                "--target-google-apis-bundle": "value",
                "--target-grpc-proxy": "value",
                "--target-http-proxy": "value",
                "--target-http-proxy-region": "dynamic",
                "--target-https-proxy": "value",
                "--target-https-proxy-region": "dynamic",
                "--target-instance": "value",
                "--target-instance-zone": "dynamic",
                "--target-pool": "value",
                "--target-pool-region": "dynamic",
                "--target-service-attachment": "value",
                "--target-service-attachment-region": "dynamic",
                "--target-ssl-proxy": "value",
                "--target-tcp-proxy": "value",
                "--target-tcp-proxy-region": "dynamic",
                "--target-vpn-gateway": "value",
                "--target-vpn-gateway-region": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--global": "bool",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "set-target": {
              "commands": {},
              "flags": {
                "--backend-service": "value",
                "--backend-service-region": "dynamic",
                "--global": "bool",
                "--global-backend-service": "bool",
                "--global-target-http-proxy": "bool",
                "--global-target-https-proxy": "bool",
                "--global-target-tcp-proxy": "bool",
                "--load-balancing-scheme": [
                  "EXTERNAL",
                  "EXTERNAL_MANAGED",
                  "INTERNAL",
                  "INTERNAL_MANAGED",
                  "INTERNAL_SELF_MANAGED"
                ],
                "--network": "value",
                "--region": "dynamic",
                "--subnet": "value",
                "--subnet-region": "value",
                "--target-grpc-proxy": "value",
                "--target-http-proxy": "value",
                "--target-http-proxy-region": "dynamic",
                "--target-https-proxy": "value",
                "--target-https-proxy-region": "dynamic",
                "--target-instance": "value",
                "--target-instance-zone": "dynamic",
                "--target-pool": "value",
                "--target-pool-region": "dynamic",
                "--target-ssl-proxy": "value",
                "--target-tcp-proxy": "value",
                "--target-tcp-proxy-region": "dynamic",
                "--target-vpn-gateway": "value",
                "--target-vpn-gateway-region": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--allow-global-access": "bool",
                "--allow-psc-global-access": "bool",
                "--clear-labels": "bool",
                "--global": "bool",
                "--region": "dynamic",
                "--remove-labels": "value",
                "--source-ip-ranges": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "health-checks": {
          "commands": {
            "create": {
              "commands": {
                "grpc": {
                  "commands": {},
                  "flags": {
                    "--check-interval": "value",
                    "--description": "value",
                    "--enable-logging": "bool",
                    "--global": "bool",
                    "--grpc-service-name": "value",
                    "--healthy-threshold": "value",
                    "--port": "value",
                    "--region": "dynamic",
                    "--timeout": "value",
                    "--unhealthy-threshold": "value",
                    "--use-serving-port": "bool"
                  }
                },
                "http": {
                  "commands": {},
                  "flags": {
                    "--check-interval": "value",
                    "--description": "value",
                    "--enable-logging": "bool",
                    "--global": "bool",
                    "--healthy-threshold": "value",
                    "--host": "value",
                    "--port": "value",
                    "--port-name": "value",
                    "--proxy-header": [
                      "NONE",
                      "PROXY_V1"
                    ],
                    "--region": "dynamic",
                    "--request-path": "value",
                    "--response": "value",
                    "--source-regions": "value",
                    "--timeout": "value",
                    "--unhealthy-threshold": "value",
                    "--use-serving-port": "bool"
                  }
                },
                "http2": {
                  "commands": {},
                  "flags": {
                    "--check-interval": "value",
                    "--description": "value",
                    "--enable-logging": "bool",
                    "--global": "bool",
                    "--healthy-threshold": "value",
                    "--host": "value",
                    "--port": "value",
                    "--port-name": "value",
                    "--proxy-header": [
                      "NONE",
                      "PROXY_V1"
                    ],
                    "--region": "dynamic",
                    "--request-path": "value",
                    "--response": "value",
                    "--timeout": "value",
                    "--unhealthy-threshold": "value",
                    "--use-serving-port": "bool"
                  }
                },
                "https": {
                  "commands": {},
                  "flags": {
                    "--check-interval": "value",
                    "--description": "value",
                    "--enable-logging": "bool",
                    "--global": "bool",
                    "--healthy-threshold": "value",
                    "--host": "value",
                    "--port": "value",
                    "--port-name": "value",
                    "--proxy-header": [
                      "NONE",
                      "PROXY_V1"
                    ],
                    "--region": "dynamic",
                    "--request-path": "value",
                    "--response": "value",
                    "--source-regions": "value",
                    "--timeout": "value",
                    "--unhealthy-threshold": "value",
                    "--use-serving-port": "bool"
                  }
                },
                "ssl": {
                  "commands": {},
                  "flags": {
                    "--check-interval": "value",
                    "--description": "value",
                    "--enable-logging": "bool",
                    "--global": "bool",
                    "--healthy-threshold": "value",
                    "--port": "value",
                    "--port-name": "value",
                    "--proxy-header": [
                      "NONE",
                      "PROXY_V1"
                    ],
                    "--region": "dynamic",
                    "--request": "value",
                    "--response": "value",
                    "--timeout": "value",
                    "--unhealthy-threshold": "value",
                    "--use-serving-port": "bool"
                  }
                },
                "tcp": {
                  "commands": {},
                  "flags": {
                    "--check-interval": "value",
                    "--description": "value",
                    "--enable-logging": "bool",
                    "--global": "bool",
                    "--healthy-threshold": "value",
                    "--port": "value",
                    "--port-name": "value",
                    "--proxy-header": [
                      "NONE",
                      "PROXY_V1"
                    ],
                    "--region": "dynamic",
                    "--request": "value",
                    "--response": "value",
                    "--source-regions": "value",
                    "--timeout": "value",
                    "--unhealthy-threshold": "value",
                    "--use-serving-port": "bool"
                  }
                }
              },
              "flags": {}
            },
            "delete": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--global": "bool",
                "--limit": "value",
                "--page-size": "value",
                "--protocol": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {
                "grpc": {
                  "commands": {},
                  "flags": {
                    "--check-interval": "value",
                    "--description": "value",
                    "--enable-logging": "bool",
                    "--global": "bool",
                    "--grpc-service-name": "value",
                    "--healthy-threshold": "value",
                    "--port": "value",
                    "--region": "dynamic",
                    "--timeout": "value",
                    "--unhealthy-threshold": "value",
                    "--use-serving-port": "bool"
                  }
                },
                "http": {
                  "commands": {},
                  "flags": {
                    "--check-interval": "value",
                    "--description": "value",
                    "--enable-logging": "bool",
                    "--global": "bool",
                    "--healthy-threshold": "value",
                    "--host": "value",
                    "--port": "value",
                    "--port-name": "value",
                    "--proxy-header": [
                      "NONE",
                      "PROXY_V1"
                    ],
                    "--region": "dynamic",
                    "--request-path": "value",
                    "--response": "value",
                    "--source-regions": "value",
                    "--timeout": "value",
                    "--unhealthy-threshold": "value",
                    "--use-serving-port": "bool"
                  }
                },
                "http2": {
                  "commands": {},
                  "flags": {
                    "--check-interval": "value",
                    "--description": "value",
                    "--enable-logging": "bool",
                    "--global": "bool",
                    "--healthy-threshold": "value",
                    "--host": "value",
                    "--port": "value",
                    "--port-name": "value",
                    "--proxy-header": [
                      "NONE",
                      "PROXY_V1"
                    ],
                    "--region": "dynamic",
                    "--request-path": "value",
                    "--response": "value",
                    "--timeout": "value",
                    "--unhealthy-threshold": "value",
                    "--use-serving-port": "bool"
                  }
                },
                "https": {
                  "commands": {},
                  "flags": {
                    "--check-interval": "value",
                    "--description": "value",
                    "--enable-logging": "bool",
                    "--global": "bool",
                    "--healthy-threshold": "value",
                    "--host": "value",
                    "--port": "value",
                    "--port-name": "value",
                    "--proxy-header": [
                      "NONE",
                      "PROXY_V1"
                    ],
                    "--region": "dynamic",
                    "--request-path": "value",
                    "--response": "value",
                    "--source-regions": "value",
                    "--timeout": "value",
                    "--unhealthy-threshold": "value",
                    "--use-serving-port": "bool"
                  }
                },
                "ssl": {
                  "commands": {},
                  "flags": {
                    "--check-interval": "value",
                    "--description": "value",
                    "--enable-logging": "bool",
                    "--global": "bool",
                    "--healthy-threshold": "value",
                    "--port": "value",
                    "--port-name": "value",
                    "--proxy-header": [
                      "NONE",
                      "PROXY_V1"
                    ],
                    "--region": "dynamic",
                    "--request": "value",
                    "--response": "value",
                    "--timeout": "value",
                    "--unhealthy-threshold": "value",
                    "--use-serving-port": "bool"
                  }
                },
                "tcp": {
                  "commands": {},
                  "flags": {
                    "--check-interval": "value",
                    "--description": "value",
                    "--enable-logging": "bool",
                    "--global": "bool",
                    "--healthy-threshold": "value",
                    "--port": "value",
                    "--port-name": "value",
                    "--proxy-header": [
                      "NONE",
                      "PROXY_V1"
                    ],
                    "--region": "dynamic",
                    "--request": "value",
                    "--response": "value",
                    "--source-regions": "value",
                    "--timeout": "value",
                    "--unhealthy-threshold": "value",
                    "--use-serving-port": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "http-health-checks": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--check-interval": "value",
                "--description": "value",
                "--healthy-threshold": "value",
                "--host": "value",
                "--port": "value",
                "--request-path": "value",
                "--timeout": "value",
                "--unhealthy-threshold": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--check-interval": "value",
                "--description": "value",
                "--healthy-threshold": "value",
                "--host": "value",
                "--port": "value",
                "--request-path": "value",
                "--timeout": "value",
                "--unhealthy-threshold": "value"
              }
            }
          },
          "flags": {}
        },
        "https-health-checks": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--check-interval": "value",
                "--description": "value",
                "--healthy-threshold": "value",
                "--host": "value",
                "--port": "value",
                "--request-path": "value",
                "--timeout": "value",
                "--unhealthy-threshold": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--check-interval": "value",
                "--description": "value",
                "--healthy-threshold": "value",
                "--host": "value",
                "--port": "value",
                "--request-path": "value",
                "--timeout": "value",
                "--unhealthy-threshold": "value"
              }
            }
          },
          "flags": {}
        },
        "images": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "add-labels": {
              "commands": {},
              "flags": {
                "--labels": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--architecture": [
                  "ARM64",
                  "X86_64"
                ],
                "--csek-key-file": "value",
                "--description": "value",
                "--family": "value",
                "--forbidden-database-file": "value",
                "--force": "bool",
                "--guest-os-features": "value",
                "--key-exchange-key-file": "value",
                "--kms-key": "dynamic",
                "--kms-keyring": "dynamic",
                "--kms-location": "dynamic",
                "--kms-project": "dynamic",
                "--labels": "value",
                "--licenses": "value",
                "--platform-key-file": "value",
                "--require-csek-key-create": "bool",
                "--signature-database-file": "value",
                "--source-disk": "dynamic",
                "--source-disk-project": "value",
                "--source-disk-zone": "dynamic",
                "--source-image": "value",
                "--source-image-family": "value",
                "--source-image-project": "value",
                "--source-snapshot": "dynamic",
                "--source-uri": "value",
                "--storage-location": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "deprecate": {
              "commands": {},
              "flags": {
                "--delete-in": "value",
                "--delete-on": "value",
                "--deprecate-in": "value",
                "--deprecate-on": "value",
                "--obsolete-in": "value",
                "--obsolete-on": "value",
                "--replacement": "dynamic",
                "--state": [
                  "ACTIVE",
                  "DELETED",
                  "DEPRECATED",
                  "OBSOLETE"
                ]
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "describe-from-family": {
              "commands": {},
              "flags": {
                "--zone": "dynamic"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--cloudbuild-service-account": "value",
                "--compute-service-account": "value",
                "--destination-uri": "value",
                "--export-format": "value",
                "--image": "value",
                "--image-family": "value",
                "--image-project": "value",
                "--log-location": "value",
                "--network": "value",
                "--subnet": "value",
                "--timeout": "value",
                "--zone": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--aws-access-key-id": "value",
                "--aws-ami-export-location": "value",
                "--aws-ami-id": "value",
                "--aws-region": "value",
                "--aws-secret-access-key": "value",
                "--aws-session-token": "value",
                "--aws-source-ami-file-path": "value",
                "--byol": "bool",
                "--cloudbuild-service-account": "value",
                "--compute-service-account": "value",
                "--data-disk": "bool",
                "--description": "value",
                "--family": "value",
                "--guest-environment": "bool",
                "--guest-os-features": "value",
                "--log-location": "value",
                "--network": "value",
                "--no-address": "bool",
                "--os": [
                  "centos-7",
                  "centos-stream-8",
                  "centos-stream-9",
                  "debian-10",
                  "debian-11",
                  "debian-8",
                  "debian-9",
                  "opensuse-15",
                  "rhel-6",
                  "rhel-6-byol",
                  "rhel-7",
                  "rhel-7-byol",
                  "rhel-8",
                  "rhel-8-byol",
                  "rhel-9",
                  "rhel-9-byol",
                  "rocky-8",
                  "rocky-9",
                  "sles-12",
                  "sles-12-byol",
                  "sles-15",
                  "sles-15-byol",
                  "sles-sap-12",
                  "sles-sap-12-byol",
                  "sles-sap-15",
                  "sles-sap-15-byol",
                  "ubuntu-1404",
                  "ubuntu-1604",
                  "ubuntu-1804",
                  "ubuntu-2004",
                  "ubuntu-2204",
                  "windows-10-x64-byol",
                  "windows-10-x86-byol",
                  "windows-11-x64-byol",
                  "windows-2008r2",
                  "windows-2008r2-byol",
                  "windows-2012",
                  "windows-2012-byol",
                  "windows-2012r2",
                  "windows-2012r2-byol",
                  "windows-2016",
                  "windows-2016-byol",
                  "windows-2019",
                  "windows-2019-byol",
                  "windows-2022",
                  "windows-2022-byol",
                  "windows-7-x64-byol",
                  "windows-7-x86-byol",
                  "windows-8-x64-byol",
                  "windows-8-x86-byol"
                ],
                "--source-file": "value",
                "--source-image": "dynamic",
                "--storage-location": "value",
                "--subnet": "value",
                "--timeout": "value",
                "--zone": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--preview-images": "bool",
                "--regexp": "value",
                "--show-deprecated": "bool",
                "--sort-by": "value",
                "--standard-images": "bool",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "remove-labels": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--labels": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--architecture": [
                  "ARM64",
                  "X86_64"
                ],
                "--clear-labels": "bool",
                "--description": "value",
                "--family": "value",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "instance-groups": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic",
                "--zone": "dynamic"
              }
            },
            "get-named-ports": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uri": "bool",
                "--zone": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--only-managed": "bool",
                "--only-unmanaged": "bool",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool",
                "--zones": "value"
              }
            },
            "list-instances": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uri": "bool",
                "--zone": "dynamic"
              }
            },
            "managed": {
              "commands": {
                "abandon-instances": {
                  "commands": {},
                  "flags": {
                    "--instances": "value",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "all-instances-config": {
                  "commands": {
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--labels": "value",
                        "--metadata": "value",
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--labels": "value",
                        "--metadata": "value",
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--base-instance-name": "value",
                    "--default-action-on-vm-failure": [
                      "do-nothing",
                      "repair"
                    ],
                    "--description": "value",
                    "--force-update-on-repair": "bool",
                    "--health-check": "dynamic",
                    "--http-health-check": "value",
                    "--https-health-check": "value",
                    "--initial-delay": "value",
                    "--instance-redistribution-type": [
                      "none",
                      "proactive"
                    ],
                    "--instance-selection": "value",
                    "--instance-selection-machine-types": "value",
                    "--list-managed-instances-results": [
                      "pageless",
                      "paginated"
                    ],
                    "--region": "dynamic",
                    "--size": "value",
                    "--standby-policy-initial-delay": "value",
                    "--standby-policy-mode": [
                      "manual",
                      "scale-out-pool"
                    ],
                    "--stateful-disk": "value",
                    "--stateful-external-ip": "value",
                    "--stateful-internal-ip": "value",
                    "--stopped-size": "value",
                    "--suspended-size": "value",
                    "--target-distribution-shape": [
                      "any",
                      "any-single-zone",
                      "balanced",
                      "even"
                    ],
                    "--target-pool": "value",
                    "--template": "value",
                    "--update-policy-max-surge": "value",
                    "--update-policy-max-unavailable": "value",
                    "--update-policy-minimal-action": [
                      "none",
                      "refresh",
                      "replace",
                      "restart"
                    ],
                    "--update-policy-most-disruptive-action": [
                      "none",
                      "refresh",
                      "replace",
                      "restart"
                    ],
                    "--update-policy-replacement-method": [
                      "recreate",
                      "substitute"
                    ],
                    "--update-policy-type": [
                      "opportunistic",
                      "proactive"
                    ],
                    "--zone": "dynamic",
                    "--zones": "dynamic"
                  }
                },
                "create-instance": {
                  "commands": {},
                  "flags": {
                    "--instance": "value",
                    "--region": "dynamic",
                    "--stateful-disk": "value",
                    "--stateful-external-ip": "value",
                    "--stateful-internal-ip": "value",
                    "--stateful-metadata": "value",
                    "--zone": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "delete-instances": {
                  "commands": {},
                  "flags": {
                    "--instances": "value",
                    "--region": "dynamic",
                    "--skip-instances-on-validation-error": "bool",
                    "--zone": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "describe-instance": {
                  "commands": {},
                  "flags": {
                    "--instance": "value",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "get-named-ports": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                },
                "instance-configs": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--instance": "value",
                        "--instance-update-minimal-action": [
                          "none",
                          "refresh",
                          "replace",
                          "restart"
                        ],
                        "--region": "dynamic",
                        "--stateful-disk": "value",
                        "--stateful-external-ip": "value",
                        "--stateful-internal-ip": "value",
                        "--stateful-metadata": "value",
                        "--update-instance": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--instance-update-minimal-action": [
                          "none",
                          "refresh",
                          "replace",
                          "restart"
                        ],
                        "--instances": "value",
                        "--region": "dynamic",
                        "--update-instance": "bool",
                        "--zone": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "dynamic",
                        "--sort-by": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--instance": "value",
                        "--instance-update-minimal-action": [
                          "none",
                          "refresh",
                          "replace",
                          "restart"
                        ],
                        "--region": "dynamic",
                        "--remove-stateful-disks": "value",
                        "--remove-stateful-external-ips": "value",
                        "--remove-stateful-internal-ips": "value",
                        "--remove-stateful-metadata": "value",
                        "--stateful-disk": "value",
                        "--stateful-external-ip": "value",
                        "--stateful-internal-ip": "value",
                        "--stateful-metadata": "value",
                        "--update-instance": "bool",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zones": "value"
                  }
                },
                "list-errors": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                },
                "list-instances": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                },
                "recreate-instances": {
                  "commands": {},
                  "flags": {
                    "--instances": "value",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "resize": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--size": "value",
                    "--zone": "dynamic"
                  }
                },
                "resize-requests": {
                  "commands": {
                    "cancel": {
                      "commands": {},
                      "flags": {
                        "--resize-requests": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "create": {
                      "commands": {},
                      "flags": {
                        "--requested-run-duration": "value",
                        "--resize-by": "value",
                        "--resize-request": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--resize-requests": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--resize-request": "value",
                        "--zone": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "resume-instances": {
                  "commands": {},
                  "flags": {
                    "--instances": "value",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "rolling-action": {
                  "commands": {
                    "replace": {
                      "commands": {},
                      "flags": {
                        "--max-surge": "value",
                        "--max-unavailable": "value",
                        "--region": "dynamic",
                        "--replacement-method": [
                          "recreate",
                          "substitute"
                        ],
                        "--zone": "dynamic"
                      }
                    },
                    "restart": {
                      "commands": {},
                      "flags": {
                        "--max-unavailable": "value",
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "start-update": {
                      "commands": {},
                      "flags": {
                        "--canary-version": "value",
                        "--force": "bool",
                        "--max-surge": "value",
                        "--max-unavailable": "value",
                        "--minimal-action": [
                          "refresh",
                          "replace",
                          "restart"
                        ],
                        "--most-disruptive-allowed-action": [
                          "refresh",
                          "replace",
                          "restart"
                        ],
                        "--region": "dynamic",
                        "--replacement-method": [
                          "recreate",
                          "substitute"
                        ],
                        "--type": [
                          "opportunistic",
                          "proactive"
                        ],
                        "--zone": "dynamic"
                      }
                    },
                    "stop-proactive-update": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "set-autoscaling": {
                  "commands": {},
                  "flags": {
                    "--cool-down-period": "value",
                    "--cpu-utilization-predictive-method": [
                      "none",
                      "optimize-availability"
                    ],
                    "--custom-metric-utilization": "value",
                    "--description": "value",
                    "--max-num-replicas": "value",
                    "--min-num-replicas": "value",
                    "--mode": [
                      "off",
                      "on",
                      "only-scale-out",
                      "only-up"
                    ],
                    "--region": "dynamic",
                    "--remove-stackdriver-metric": "value",
                    "--scale-based-on-cpu": "bool",
                    "--scale-based-on-load-balancing": "bool",
                    "--scale-in-control": "value",
                    "--schedule-cron": "value",
                    "--schedule-description": "value",
                    "--schedule-duration-sec": "value",
                    "--schedule-min-required-replicas": "value",
                    "--schedule-time-zone": "value",
                    "--set-schedule": "value",
                    "--stackdriver-metric-filter": "value",
                    "--stackdriver-metric-single-instance-assignment": "value",
                    "--stackdriver-metric-utilization-target": "value",
                    "--stackdriver-metric-utilization-target-type": [
                      "delta-per-minute",
                      "delta-per-second",
                      "gauge"
                    ],
                    "--target-cpu-utilization": "value",
                    "--target-load-balancing-utilization": "value",
                    "--update-stackdriver-metric": "value",
                    "--zone": "dynamic"
                  }
                },
                "set-instance-template": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--template": "value",
                    "--zone": "dynamic"
                  }
                },
                "set-named-ports": {
                  "commands": {},
                  "flags": {
                    "--named-ports": "value",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "set-target-pools": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--target-pools": "value",
                    "--zone": "dynamic"
                  }
                },
                "start-instances": {
                  "commands": {},
                  "flags": {
                    "--instances": "value",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "stop-autoscaling": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "stop-instances": {
                  "commands": {},
                  "flags": {
                    "--force": "bool",
                    "--instances": "value",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "suspend-instances": {
                  "commands": {},
                  "flags": {
                    "--force": "bool",
                    "--instances": "value",
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--clear-autohealing": "bool",
                    "--default-action-on-vm-failure": [
                      "do-nothing",
                      "repair"
                    ],
                    "--description": "value",
                    "--force-update-on-repair": "bool",
                    "--health-check": "dynamic",
                    "--http-health-check": "value",
                    "--https-health-check": "value",
                    "--initial-delay": "value",
                    "--instance-redistribution-type": [
                      "none",
                      "proactive"
                    ],
                    "--instance-selection": "value",
                    "--instance-selection-machine-types": "value",
                    "--list-managed-instances-results": [
                      "pageless",
                      "paginated"
                    ],
                    "--region": "dynamic",
                    "--remove-instance-selections": "value",
                    "--remove-instance-selections-all": "bool",
                    "--remove-stateful-disks": "value",
                    "--remove-stateful-external-ips": "value",
                    "--remove-stateful-internal-ips": "value",
                    "--size": "value",
                    "--standby-policy-initial-delay": "value",
                    "--standby-policy-mode": [
                      "manual",
                      "scale-out-pool"
                    ],
                    "--stateful-disk": "value",
                    "--stateful-external-ip": "value",
                    "--stateful-internal-ip": "value",
                    "--stopped-size": "value",
                    "--suspended-size": "value",
                    "--target-distribution-shape": [
                      "any",
                      "any-single-zone",
                      "balanced",
                      "even"
                    ],
                    "--update-policy-max-surge": "value",
                    "--update-policy-max-unavailable": "value",
                    "--update-policy-minimal-action": [
                      "none",
                      "refresh",
                      "replace",
                      "restart"
                    ],
                    "--update-policy-most-disruptive-action": [
                      "none",
                      "refresh",
                      "replace",
                      "restart"
                    ],
                    "--update-policy-replacement-method": [
                      "recreate",
                      "substitute"
                    ],
                    "--update-policy-type": [
                      "opportunistic",
                      "proactive"
                    ],
                    "--zone": "dynamic"
                  }
                },
                "update-autoscaling": {
                  "commands": {},
                  "flags": {
                    "--clear-scale-in-control": "bool",
                    "--cpu-utilization-predictive-method": [
                      "none",
                      "optimize-availability"
                    ],
                    "--disable-schedule": "value",
                    "--enable-schedule": "value",
                    "--max-num-replicas": "value",
                    "--min-num-replicas": "value",
                    "--mode": [
                      "off",
                      "on",
                      "only-scale-out",
                      "only-up"
                    ],
                    "--region": "dynamic",
                    "--remove-schedule": "value",
                    "--scale-in-control": "value",
                    "--schedule-cron": "value",
                    "--schedule-description": "value",
                    "--schedule-duration-sec": "value",
                    "--schedule-min-required-replicas": "value",
                    "--schedule-time-zone": "value",
                    "--set-schedule": "value",
                    "--update-schedule": "value",
                    "--zone": "dynamic"
                  }
                },
                "update-instances": {
                  "commands": {},
                  "flags": {
                    "--all-instances": "bool",
                    "--instances": "value",
                    "--minimal-action": [
                      "none",
                      "refresh",
                      "replace",
                      "restart"
                    ],
                    "--most-disruptive-allowed-action": [
                      "none",
                      "refresh",
                      "replace",
                      "restart"
                    ],
                    "--region": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "wait-until": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--stable": "bool",
                    "--timeout": "value",
                    "--version-target-reached": "bool",
                    "--zone": "dynamic"
                  }
                },
                "wait-until-stable": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--timeout": "value",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "set-named-ports": {
              "commands": {},
              "flags": {
                "--named-ports": "value",
                "--region": "dynamic",
                "--zone": "dynamic"
              }
            },
            "unmanaged": {
              "commands": {
                "add-instances": {
                  "commands": {},
                  "flags": {
                    "--instances": "value",
                    "--zone": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--zone": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "get-named-ports": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zones": "dynamic"
                  }
                },
                "list-instances": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                },
                "remove-instances": {
                  "commands": {},
                  "flags": {
                    "--instances": "value",
                    "--zone": "dynamic"
                  }
                },
                "set-named-ports": {
                  "commands": {},
                  "flags": {
                    "--named-ports": "value",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "instance-templates": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--accelerator": "value",
                "--address": "value",
                "--boot-disk-auto-delete": "bool",
                "--boot-disk-device-name": "value",
                "--boot-disk-interface": "value",
                "--boot-disk-kms-key": "dynamic",
                "--boot-disk-kms-keyring": "dynamic",
                "--boot-disk-kms-location": "dynamic",
                "--boot-disk-kms-project": "dynamic",
                "--boot-disk-provisioned-iops": "value",
                "--boot-disk-provisioned-throughput": "value",
                "--boot-disk-size": "value",
                "--boot-disk-type": "value",
                "--can-ip-forward": "bool",
                "--confidential-compute": "bool",
                "--confidential-compute-type": [
                  "SEV",
                  "SEV_SNP",
                  "TDX"
                ],
                "--configure-disk": "value",
                "--create-disk": "value",
                "--custom-cpu": "value",
                "--custom-extensions": "bool",
                "--custom-memory": "value",
                "--custom-vm-type": "value",
                "--description": "value",
                "--discard-local-ssds-at-termination-timestamp": "value",
                "--disk": "value",
                "--enable-nested-virtualization": "bool",
                "--enable-uefi-networking": "bool",
                "--external-ipv6-address": "value",
                "--external-ipv6-prefix-length": "value",
                "--image": "value",
                "--image-family": "value",
                "--image-project": "value",
                "--instance-template-region": "value",
                "--instance-termination-action": [
                  "DELETE",
                  "STOP"
                ],
                "--internal-ipv6-address": "value",
                "--internal-ipv6-prefix-length": "value",
                "--ipv6-network-tier": [
                  "PREMIUM"
                ],
                "--key-revocation-action-type": [
                  "none",
                  "stop"
                ],
                "--labels": "value",
                "--local-ssd": "value",
                "--local-ssd-recovery-timeout": "value",
                "--machine-type": "dynamic",
                "--maintenance-policy": [
                  "MIGRATE",
                  "TERMINATE"
                ],
                "--max-run-duration": "value",
                "--metadata": "value",
                "--metadata-from-file": "value",
                "--min-cpu-platform": "value",
                "--min-node-cpu": "value",
                "--network": "value",
                "--network-interface": "value",
                "--network-performance-configs": "value",
                "--network-tier": "value",
                "--no-address": "bool",
                "--no-scopes": "bool",
                "--no-service-account": "bool",
                "--node": "value",
                "--node-affinity-file": "value",
                "--node-group": "value",
                "--performance-monitoring-unit": [
                  "architectural",
                  "enhanced",
                  "standard"
                ],
                "--preemptible": "bool",
                "--private-ipv6-google-access-type": [
                  "enable-bidirectional-access",
                  "enable-outbound-vm-access",
                  "inherit-subnetwork"
                ],
                "--private-network-ip": "value",
                "--provisioning-model": [
                  "SPOT",
                  "STANDARD"
                ],
                "--region": "dynamic",
                "--reservation": "value",
                "--reservation-affinity": [
                  "any",
                  "none",
                  "specific"
                ],
                "--resource-manager-tags": "value",
                "--resource-policies": "value",
                "--restart-on-failure": "bool",
                "--scopes": "value",
                "--service-account": "value",
                "--service-proxy": "value",
                "--service-proxy-labels": "value",
                "--shielded-integrity-monitoring": "bool",
                "--shielded-secure-boot": "bool",
                "--shielded-vtpm": "bool",
                "--source-instance": "dynamic",
                "--source-instance-zone": "dynamic",
                "--stack-type": [
                  "IPV4_IPV6",
                  "IPV4_ONLY",
                  "IPV6_ONLY"
                ],
                "--subnet": "value",
                "--tags": "value",
                "--termination-time": "value",
                "--threads-per-core": "value",
                "--turbo-mode": "value",
                "--visible-core-count": "value"
              }
            },
            "create-with-container": {
              "commands": {},
              "flags": {
                "--address": "value",
                "--boot-disk-auto-delete": "bool",
                "--boot-disk-device-name": "value",
                "--boot-disk-interface": "value",
                "--boot-disk-provisioned-iops": "value",
                "--boot-disk-provisioned-throughput": "value",
                "--boot-disk-size": "value",
                "--boot-disk-type": "value",
                "--can-ip-forward": "bool",
                "--confidential-compute": "bool",
                "--container-arg": "value",
                "--container-command": "value",
                "--container-env": "value",
                "--container-env-file": "value",
                "--container-image": "value",
                "--container-mount-disk": "value",
                "--container-mount-host-path": "value",
                "--container-mount-tmpfs": "value",
                "--container-privileged": "bool",
                "--container-restart-policy": [
                  "always",
                  "never",
                  "on-failure"
                ],
                "--container-stdin": "bool",
                "--container-tty": "bool",
                "--create-disk": "value",
                "--custom-cpu": "value",
                "--custom-extensions": "bool",
                "--custom-memory": "value",
                "--custom-vm-type": "value",
                "--description": "value",
                "--disk": "value",
                "--external-ipv6-address": "value",
                "--external-ipv6-prefix-length": "value",
                "--image": "value",
                "--image-family": "value",
                "--image-project": "value",
                "--internal-ipv6-address": "value",
                "--internal-ipv6-prefix-length": "value",
                "--ipv6-network-tier": [
                  "PREMIUM"
                ],
                "--labels": "value",
                "--machine-type": "dynamic",
                "--maintenance-policy": [
                  "MIGRATE",
                  "TERMINATE"
                ],
                "--metadata": "value",
                "--metadata-from-file": "value",
                "--min-cpu-platform": "value",
                "--network": "value",
                "--network-interface": "value",
                "--network-tier": "value",
                "--no-address": "bool",
                "--no-scopes": "bool",
                "--no-service-account": "bool",
                "--preemptible": "bool",
                "--private-ipv6-google-access-type": [
                  "enable-bidirectional-access",
                  "enable-outbound-vm-access",
                  "inherit-subnetwork"
                ],
                "--private-network-ip": "value",
                "--region": "dynamic",
                "--reservation": "value",
                "--reservation-affinity": [
                  "any",
                  "none",
                  "specific"
                ],
                "--resource-policies": "value",
                "--restart-on-failure": "bool",
                "--scopes": "value",
                "--service-account": "value",
                "--shielded-integrity-monitoring": "bool",
                "--shielded-secure-boot": "bool",
                "--shielded-vtpm": "bool",
                "--stack-type": [
                  "IPV4_IPV6",
                  "IPV4_ONLY",
                  "IPV6_ONLY"
                ],
                "--subnet": "value",
                "--tags": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--global": "bool",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {}
            }
          },
          "flags": {}
        },
        "instances": {
          "commands": {
            "add-access-config": {
              "commands": {},
              "flags": {
                "--access-config-name": "value",
                "--address": "value",
                "--network-interface": "value",
                "--network-tier": "value",
                "--no-public-ptr": "bool",
                "--no-public-ptr-domain": "bool",
                "--public-ptr": "bool",
                "--public-ptr-domain": "value",
                "--zone": "dynamic"
              }
            },
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic",
                "--zone": "value"
              }
            },
            "add-labels": {
              "commands": {},
              "flags": {
                "--labels": "value",
                "--zone": "dynamic"
              }
            },
            "add-metadata": {
              "commands": {},
              "flags": {
                "--metadata": "value",
                "--metadata-from-file": "value",
                "--zone": "dynamic"
              }
            },
            "add-resource-policies": {
              "commands": {},
              "flags": {
                "--resource-policies": "value",
                "--zone": "dynamic"
              }
            },
            "add-tags": {
              "commands": {},
              "flags": {
                "--tags": "value",
                "--zone": "dynamic"
              }
            },
            "attach-disk": {
              "commands": {},
              "flags": {
                "--boot": "bool",
                "--csek-key-file": "value",
                "--device-name": "value",
                "--disk": "value",
                "--disk-scope": [
                  "regional",
                  "zonal"
                ],
                "--force-attach": "bool",
                "--interface": [
                  "NVME",
                  "SCSI"
                ],
                "--mode": [
                  "ro",
                  "rw"
                ],
                "--zone": "dynamic"
              }
            },
            "bulk": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--async": "bool",
                    "--boot-disk-auto-delete": "bool",
                    "--boot-disk-device-name": "value",
                    "--boot-disk-interface": "value",
                    "--boot-disk-kms-key": "dynamic",
                    "--boot-disk-kms-keyring": "dynamic",
                    "--boot-disk-kms-location": "dynamic",
                    "--boot-disk-kms-project": "dynamic",
                    "--boot-disk-provisioned-iops": "value",
                    "--boot-disk-provisioned-throughput": "value",
                    "--boot-disk-size": "value",
                    "--boot-disk-type": "value",
                    "--can-ip-forward": "bool",
                    "--confidential-compute": "bool",
                    "--confidential-compute-type": [
                      "SEV",
                      "SEV_SNP",
                      "TDX"
                    ],
                    "--count": "value",
                    "--create-disk": "value",
                    "--custom-cpu": "value",
                    "--custom-extensions": "bool",
                    "--custom-memory": "value",
                    "--custom-vm-type": "value",
                    "--description": "value",
                    "--discard-local-ssds-at-termination-timestamp": "value",
                    "--disk": "value",
                    "--enable-nested-virtualization": "bool",
                    "--enable-uefi-networking": "bool",
                    "--erase-windows-vss-signature": "bool",
                    "--image": "value",
                    "--image-family": "value",
                    "--image-project": "value",
                    "--instance-termination-action": [
                      "DELETE",
                      "STOP"
                    ],
                    "--labels": "value",
                    "--local-ssd": "value",
                    "--local-ssd-recovery-timeout": "value",
                    "--location-policy": "value",
                    "--machine-type": "dynamic",
                    "--maintenance-policy": [
                      "MIGRATE",
                      "TERMINATE"
                    ],
                    "--max-count-per-zone": "value",
                    "--max-run-duration": "value",
                    "--metadata": "value",
                    "--metadata-from-file": "value",
                    "--min-count": "value",
                    "--min-cpu-platform": "value",
                    "--min-node-cpu": "value",
                    "--name-pattern": "value",
                    "--network": "value",
                    "--network-interface": "value",
                    "--network-performance-configs": "value",
                    "--network-tier": "value",
                    "--no-address": "bool",
                    "--no-public-dns": "bool",
                    "--no-scopes": "bool",
                    "--no-service-account": "bool",
                    "--on-host-maintenance": [
                      "MIGRATE",
                      "TERMINATE"
                    ],
                    "--performance-monitoring-unit": [
                      "architectural",
                      "enhanced",
                      "standard"
                    ],
                    "--post-key-revocation-action-type": [
                      "noop",
                      "shutdown"
                    ],
                    "--predefined-names": "value",
                    "--preemptible": "bool",
                    "--provisioning-model": [
                      "SPOT",
                      "STANDARD"
                    ],
                    "--public-dns": "bool",
                    "--region": "value",
                    "--reservation": "value",
                    "--reservation-affinity": [
                      "any",
                      "none",
                      "specific"
                    ],
                    "--resource-manager-tags": "value",
                    "--resource-policies": "value",
                    "--restart-on-failure": "bool",
                    "--scopes": "value",
                    "--service-account": "value",
                    "--shielded-integrity-monitoring": "bool",
                    "--shielded-secure-boot": "bool",
                    "--shielded-vtpm": "bool",
                    "--source-instance-template": "dynamic",
                    "--source-snapshot": "value",
                    "--stack-type": [
                      "IPV4_IPV6",
                      "IPV4_ONLY",
                      "IPV6_ONLY"
                    ],
                    "--subnet": "value",
                    "--tags": "value",
                    "--target-distribution-shape": [
                      "ANY",
                      "ANY_SINGLE_ZONE",
                      "BALANCED"
                    ],
                    "--termination-time": "value",
                    "--threads-per-core": "value",
                    "--turbo-mode": "value",
                    "--visible-core-count": "value",
                    "--zone": "value"
                  }
                }
              },
              "flags": {}
            },
            "create": {
              "commands": {},
              "flags": {
                "--accelerator": "value",
                "--address": "value",
                "--async": "bool",
                "--availability-domain": "value",
                "--boot-disk-auto-delete": "bool",
                "--boot-disk-device-name": "value",
                "--boot-disk-interface": "value",
                "--boot-disk-kms-key": "dynamic",
                "--boot-disk-kms-keyring": "dynamic",
                "--boot-disk-kms-location": "dynamic",
                "--boot-disk-kms-project": "dynamic",
                "--boot-disk-provisioned-iops": "value",
                "--boot-disk-provisioned-throughput": "value",
                "--boot-disk-size": "value",
                "--boot-disk-type": "value",
                "--can-ip-forward": "bool",
                "--confidential-compute": "bool",
                "--confidential-compute-type": [
                  "SEV",
                  "SEV_SNP",
                  "TDX"
                ],
                "--create-disk": "value",
                "--csek-key-file": "value",
                "--custom-cpu": "value",
                "--custom-extensions": "bool",
                "--custom-memory": "value",
                "--custom-vm-type": "value",
                "--deletion-protection": "bool",
                "--description": "value",
                "--discard-local-ssds-at-termination-timestamp": "value",
                "--disk": "value",
                "--enable-display-device": "bool",
                "--enable-nested-virtualization": "bool",
                "--enable-uefi-networking": "bool",
                "--erase-windows-vss-signature": "bool",
                "--external-ipv6-address": "value",
                "--external-ipv6-prefix-length": "value",
                "--hostname": "value",
                "--image": "value",
                "--image-family": "value",
                "--image-family-scope": [
                  "global",
                  "zonal"
                ],
                "--image-project": "value",
                "--instance-kms-key": "dynamic",
                "--instance-kms-keyring": "dynamic",
                "--instance-kms-location": "dynamic",
                "--instance-kms-project": "dynamic",
                "--instance-termination-action": [
                  "DELETE",
                  "STOP"
                ],
                "--internal-ipv6-address": "value",
                "--internal-ipv6-prefix-length": "value",
                "--ipv6-network-tier": [
                  "PREMIUM"
                ],
                "--ipv6-public-ptr-domain": "value",
                "--key-revocation-action-type": [
                  "none",
                  "stop"
                ],
                "--labels": "value",
                "--local-ssd": "value",
                "--local-ssd-recovery-timeout": "value",
                "--machine-type": "dynamic",
                "--maintenance-policy": [
                  "MIGRATE",
                  "TERMINATE"
                ],
                "--max-run-duration": "value",
                "--metadata": "value",
                "--metadata-from-file": "value",
                "--min-cpu-platform": "value",
                "--min-node-cpu": "value",
                "--network": "value",
                "--network-interface": "value",
                "--network-performance-configs": "value",
                "--network-tier": "value",
                "--no-address": "bool",
                "--no-public-ptr": "bool",
                "--no-public-ptr-domain": "bool",
                "--no-scopes": "bool",
                "--no-service-account": "bool",
                "--node": "value",
                "--node-affinity-file": "value",
                "--node-group": "value",
                "--node-project": "value",
                "--performance-monitoring-unit": [
                  "architectural",
                  "enhanced",
                  "standard"
                ],
                "--preemptible": "bool",
                "--private-ipv6-google-access-type": [
                  "enable-bidirectional-access",
                  "enable-outbound-vm-access",
                  "inherit-subnetwork"
                ],
                "--private-network-ip": "value",
                "--provisioning-model": [
                  "SPOT",
                  "STANDARD"
                ],
                "--public-ptr": "bool",
                "--public-ptr-domain": "value",
                "--require-csek-key-create": "bool",
                "--reservation": "value",
                "--reservation-affinity": [
                  "any",
                  "none",
                  "specific"
                ],
                "--resource-manager-tags": "value",
                "--resource-policies": "value",
                "--restart-on-failure": "bool",
                "--scopes": "value",
                "--service-account": "value",
                "--shielded-integrity-monitoring": "bool",
                "--shielded-secure-boot": "bool",
                "--shielded-vtpm": "bool",
                "--source-instance-template": "dynamic",
                "--source-machine-image": "dynamic",
                "--source-machine-image-csek-key-file": "value",
                "--source-snapshot": "value",
                "--stack-type": [
                  "IPV4_IPV6",
                  "IPV4_ONLY",
                  "IPV6_ONLY"
                ],
                "--subnet": "value",
                "--tags": "value",
                "--termination-time": "value",
                "--threads-per-core": "value",
                "--turbo-mode": "value",
                "--visible-core-count": "value",
                "--zone": "dynamic"
              }
            },
            "create-with-container": {
              "commands": {},
              "flags": {
                "--accelerator": "value",
                "--address": "value",
                "--boot-disk-auto-delete": "bool",
                "--boot-disk-device-name": "value",
                "--boot-disk-interface": "value",
                "--boot-disk-provisioned-iops": "value",
                "--boot-disk-provisioned-throughput": "value",
                "--boot-disk-size": "value",
                "--boot-disk-type": "value",
                "--can-ip-forward": "bool",
                "--confidential-compute": "bool",
                "--confidential-compute-type": [
                  "SEV",
                  "SEV_SNP",
                  "TDX"
                ],
                "--container-arg": "value",
                "--container-command": "value",
                "--container-env": "value",
                "--container-env-file": "value",
                "--container-image": "value",
                "--container-mount-disk": "value",
                "--container-mount-host-path": "value",
                "--container-mount-tmpfs": "value",
                "--container-privileged": "bool",
                "--container-restart-policy": [
                  "always",
                  "never",
                  "on-failure"
                ],
                "--container-stdin": "bool",
                "--container-tty": "bool",
                "--create-disk": "value",
                "--custom-cpu": "value",
                "--custom-extensions": "bool",
                "--custom-memory": "value",
                "--custom-vm-type": "value",
                "--description": "value",
                "--discard-local-ssds-at-termination-timestamp": "value",
                "--disk": "value",
                "--enable-nested-virtualization": "bool",
                "--external-ipv6-address": "value",
                "--external-ipv6-prefix-length": "value",
                "--image": "value",
                "--image-family": "value",
                "--image-project": "value",
                "--instance-termination-action": [
                  "DELETE",
                  "STOP"
                ],
                "--internal-ipv6-address": "value",
                "--internal-ipv6-prefix-length": "value",
                "--ipv6-network-tier": [
                  "PREMIUM"
                ],
                "--labels": "value",
                "--local-ssd-recovery-timeout": "value",
                "--machine-type": "dynamic",
                "--maintenance-policy": [
                  "MIGRATE",
                  "TERMINATE"
                ],
                "--max-run-duration": "value",
                "--metadata": "value",
                "--metadata-from-file": "value",
                "--min-cpu-platform": "value",
                "--network": "value",
                "--network-interface": "value",
                "--network-performance-configs": "value",
                "--network-tier": "value",
                "--no-address": "bool",
                "--no-public-ptr": "bool",
                "--no-public-ptr-domain": "bool",
                "--no-scopes": "bool",
                "--no-service-account": "bool",
                "--preemptible": "bool",
                "--private-ipv6-google-access-type": [
                  "enable-bidirectional-access",
                  "enable-outbound-vm-access",
                  "inherit-subnetwork"
                ],
                "--private-network-ip": "value",
                "--provisioning-model": [
                  "SPOT",
                  "STANDARD"
                ],
                "--public-ptr": "bool",
                "--public-ptr-domain": "value",
                "--reservation": "value",
                "--reservation-affinity": [
                  "any",
                  "none",
                  "specific"
                ],
                "--resource-policies": "value",
                "--restart-on-failure": "bool",
                "--scopes": "value",
                "--service-account": "value",
                "--shielded-integrity-monitoring": "bool",
                "--shielded-secure-boot": "bool",
                "--shielded-vtpm": "bool",
                "--source-instance-template": "dynamic",
                "--stack-type": [
                  "IPV4_IPV6",
                  "IPV4_ONLY",
                  "IPV6_ONLY"
                ],
                "--subnet": "value",
                "--tags": "value",
                "--termination-time": "value",
                "--threads-per-core": "value",
                "--visible-core-count": "value",
                "--zone": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--delete-disks": [
                  "all",
                  "boot",
                  "data"
                ],
                "--keep-disks": [
                  "all",
                  "boot",
                  "data"
                ],
                "--zone": "dynamic"
              }
            },
            "delete-access-config": {
              "commands": {},
              "flags": {
                "--access-config-name": "value",
                "--network-interface": "value",
                "--zone": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--zone": "dynamic"
              }
            },
            "detach-disk": {
              "commands": {},
              "flags": {
                "--device-name": "value",
                "--disk": "value",
                "--disk-scope": [
                  "regional",
                  "zonal"
                ],
                "--zone": "dynamic"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--zone": "value"
              }
            },
            "get-guest-attributes": {
              "commands": {},
              "flags": {
                "--query-path": "value",
                "--zone": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--zone": "value"
              }
            },
            "get-screenshot": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--zone": "dynamic"
              }
            },
            "get-serial-port-output": {
              "commands": {},
              "flags": {
                "--port": "value",
                "--start": "value",
                "--zone": "dynamic"
              }
            },
            "get-shielded-identity": {
              "commands": {},
              "flags": {
                "--zone": "dynamic"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--byol": "bool",
                "--can-ip-forward": "bool",
                "--cloudbuild-service-account": "value",
                "--compute-service-account": "value",
                "--custom-cpu": "value",
                "--custom-extensions": "bool",
                "--custom-memory": "value",
                "--custom-vm-type": "value",
                "--deletion-protection": "bool",
                "--description": "value",
                "--guest-environment": "bool",
                "--guest-os-features": "value",
                "--hostname": "value",
                "--labels": "value",
                "--log-location": "value",
                "--machine-type": "dynamic",
                "--network": "value",
                "--network-tier": "value",
                "--no-address": "bool",
                "--no-scopes": "bool",
                "--no-service-account": "bool",
                "--node": "value",
                "--node-affinity-file": "value",
                "--node-group": "value",
                "--os": [
                  "centos-7",
                  "centos-stream-8",
                  "centos-stream-9",
                  "debian-10",
                  "debian-11",
                  "debian-8",
                  "debian-9",
                  "opensuse-15",
                  "rhel-6",
                  "rhel-6-byol",
                  "rhel-7",
                  "rhel-7-byol",
                  "rhel-8",
                  "rhel-8-byol",
                  "rhel-9",
                  "rhel-9-byol",
                  "rocky-8",
                  "rocky-9",
                  "sles-12",
                  "sles-12-byol",
                  "sles-15",
                  "sles-15-byol",
                  "sles-sap-12",
                  "sles-sap-12-byol",
                  "sles-sap-15",
                  "sles-sap-15-byol",
                  "ubuntu-1404",
                  "ubuntu-1604",
                  "ubuntu-1804",
                  "ubuntu-2004",
                  "ubuntu-2204",
                  "windows-10-x64-byol",
                  "windows-10-x86-byol",
                  "windows-11-x64-byol",
                  "windows-2008r2",
                  "windows-2008r2-byol",
                  "windows-2012",
                  "windows-2012-byol",
                  "windows-2012r2",
                  "windows-2012r2-byol",
                  "windows-2016",
                  "windows-2016-byol",
                  "windows-2019",
                  "windows-2019-byol",
                  "windows-2022",
                  "windows-2022-byol",
                  "windows-7-x64-byol",
                  "windows-7-x86-byol",
                  "windows-8-x64-byol",
                  "windows-8-x86-byol"
                ],
                "--private-network-ip": "value",
                "--restart-on-failure": "bool",
                "--scopes": "value",
                "--service-account": "value",
                "--source-uri": "value",
                "--subnet": "value",
                "--tags": "value",
                "--timeout": "value",
                "--zone": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--sort-by": "value",
                "--uri": "bool",
                "--zones": "dynamic"
              }
            },
            "move": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--destination-zone": "dynamic",
                "--zone": "dynamic"
              }
            },
            "network-interfaces": {
              "commands": {
                "get-effective-firewalls": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--network-interface": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--aliases": "value",
                    "--external-ipv6-address": "value",
                    "--external-ipv6-prefix-length": "value",
                    "--internal-ipv6-address": "value",
                    "--internal-ipv6-prefix-length": "value",
                    "--ipv6-network-tier": [
                      "PREMIUM"
                    ],
                    "--network": "value",
                    "--network-interface": "value",
                    "--private-network-ip": "value",
                    "--security-policy": "dynamic",
                    "--security-policy-region": "dynamic",
                    "--stack-type": [
                      "IPV4_IPV6",
                      "IPV4_ONLY"
                    ],
                    "--subnetwork": "value",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "ops-agents": {
              "commands": {
                "policies": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--file": "value",
                        "--zone": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--zone": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--zone": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--file": "value",
                        "--zone": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "os-inventory": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "list-instances": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--inventory-filter": "value",
                    "--kernel-version": "value",
                    "--limit": "value",
                    "--os-shortname": "value",
                    "--os-version": "value",
                    "--package-name": "value",
                    "--package-version": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "perform-maintenance": {
              "commands": {},
              "flags": {
                "--zone": "dynamic"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic",
                "--zone": "value"
              }
            },
            "remove-labels": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--labels": "value",
                "--zone": "dynamic"
              }
            },
            "remove-metadata": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--keys": "value",
                "--zone": "dynamic"
              }
            },
            "remove-resource-policies": {
              "commands": {},
              "flags": {
                "--resource-policies": "value",
                "--zone": "dynamic"
              }
            },
            "remove-tags": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--tags": "value",
                "--zone": "dynamic"
              }
            },
            "reset": {
              "commands": {},
              "flags": {
                "--zone": "dynamic"
              }
            },
            "resume": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--zone": "dynamic"
              }
            },
            "send-diagnostic-interrupt": {
              "commands": {},
              "flags": {
                "--zone": "dynamic"
              }
            },
            "set-disk-auto-delete": {
              "commands": {},
              "flags": {
                "--auto-delete": "bool",
                "--device-name": "value",
                "--disk": "value",
                "--zone": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--zone": "value"
              }
            },
            "set-machine-type": {
              "commands": {},
              "flags": {
                "--custom-cpu": "value",
                "--custom-extensions": "bool",
                "--custom-memory": "value",
                "--custom-vm-type": "value",
                "--machine-type": "dynamic",
                "--zone": "dynamic"
              }
            },
            "set-name": {
              "commands": {},
              "flags": {
                "--new-name": "value",
                "--zone": "dynamic"
              }
            },
            "set-scheduling": {
              "commands": {},
              "flags": {
                "--clear-discard-local-ssds-at-termination-timestamp": "bool",
                "--clear-instance-termination-action": "bool",
                "--clear-max-run-duration": "bool",
                "--clear-min-node-cpu": "bool",
                "--clear-node-affinities": "bool",
                "--clear-termination-time": "bool",
                "--discard-local-ssds-at-termination-timestamp": "value",
                "--instance-termination-action": [
                  "DELETE",
                  "STOP"
                ],
                "--local-ssd-recovery-timeout": "value",
                "--maintenance-policy": [
                  "MIGRATE",
                  "TERMINATE"
                ],
                "--max-run-duration": "value",
                "--min-node-cpu": "value",
                "--node": "value",
                "--node-affinity-file": "value",
                "--node-group": "value",
                "--preemptible": "bool",
                "--provisioning-model": [
                  "SPOT",
                  "STANDARD"
                ],
                "--restart-on-failure": "bool",
                "--termination-time": "value",
                "--zone": "dynamic"
              }
            },
            "set-service-account": {
              "commands": {},
              "flags": {
                "--no-scopes": "bool",
                "--no-service-account": "bool",
                "--scopes": "value",
                "--service-account": "value",
                "--zone": "dynamic"
              }
            },
            "simulate-maintenance-event": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--with-extended-notifications": "value",
                "--zone": "dynamic"
              }
            },
            "start": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--csek-key-file": "value",
                "--zone": "dynamic"
              }
            },
            "stop": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--discard-local-ssd": "value",
                "--zone": "dynamic"
              }
            },
            "suspend": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--discard-local-ssd": "value",
                "--zone": "dynamic"
              }
            },
            "tail-serial-port-output": {
              "commands": {},
              "flags": {
                "--port": "value",
                "--zone": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-labels": "bool",
                "--clear-node-affinities": "bool",
                "--deletion-protection": "bool",
                "--enable-display-device": "bool",
                "--min-cpu-platform": "value",
                "--node": "value",
                "--node-affinity-file": "value",
                "--node-group": "value",
                "--remove-labels": "value",
                "--shielded-integrity-monitoring": "bool",
                "--shielded-learn-integrity-policy": "bool",
                "--shielded-secure-boot": "bool",
                "--shielded-vtpm": "bool",
                "--update-labels": "value",
                "--zone": "dynamic"
              }
            },
            "update-access-config": {
              "commands": {},
              "flags": {
                "--ipv6-public-ptr-domain": "value",
                "--network-interface": "value",
                "--no-ipv6-public-ptr": "bool",
                "--no-public-ptr": "bool",
                "--no-public-ptr-domain": "bool",
                "--public-ptr": "bool",
                "--public-ptr-domain": "value",
                "--zone": "dynamic"
              }
            },
            "update-container": {
              "commands": {},
              "flags": {
                "--clear-container-args": "bool",
                "--clear-container-command": "bool",
                "--container-arg": "value",
                "--container-command": "value",
                "--container-env": "value",
                "--container-env-file": "value",
                "--container-image": "value",
                "--container-mount-disk": "value",
                "--container-mount-host-path": "value",
                "--container-mount-tmpfs": "value",
                "--container-privileged": "bool",
                "--container-restart-policy": [
                  "always",
                  "never",
                  "on-failure"
                ],
                "--container-stdin": "bool",
                "--container-tty": "bool",
                "--remove-container-env": "value",
                "--remove-container-mounts": "value",
                "--shielded-integrity-monitoring": "bool",
                "--shielded-learn-integrity-policy": "bool",
                "--shielded-secure-boot": "bool",
                "--shielded-vtpm": "bool",
                "--zone": "dynamic"
              }
            },
            "update-from-file": {
              "commands": {},
              "flags": {
                "--minimal-action": "value",
                "--most-disruptive-allowed-action": "value",
                "--source": "value",
                "--zone": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "instant-snapshots": {
          "commands": {
            "add-labels": {
              "commands": {},
              "flags": {
                "--labels": "value",
                "--region": "dynamic",
                "--zone": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--labels": "value",
                "--region": "dynamic",
                "--source-disk": "dynamic",
                "--zone": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "dynamic",
                "--zone": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic",
                "--zone": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool",
                "--zones": "value"
              }
            }
          },
          "flags": {}
        },
        "interconnects": {
          "commands": {
            "attachments": {
              "commands": {
                "dedicated": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--bandwidth": [
                          "100g",
                          "100m",
                          "10g",
                          "1g",
                          "200m",
                          "20g",
                          "2g",
                          "300m",
                          "400m",
                          "500m",
                          "50g",
                          "50m",
                          "5g"
                        ],
                        "--candidate-ipv6-subnets": "value",
                        "--candidate-subnets": "value",
                        "--cloud-router-ipv6-interface-id": "value",
                        "--customer-router-ipv6-interface-id": "value",
                        "--description": "value",
                        "--enable-admin": "bool",
                        "--encryption": [
                          "IPSEC",
                          "NONE"
                        ],
                        "--interconnect": "dynamic",
                        "--ipsec-internal-addresses": "value",
                        "--mtu": "value",
                        "--region": "dynamic",
                        "--router": "dynamic",
                        "--stack-type": [
                          "IPV4_IPV6",
                          "IPV4_ONLY"
                        ],
                        "--subnet-length": [
                          29,
                          30
                        ],
                        "--vlan": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--bandwidth": [
                          "100g",
                          "100m",
                          "10g",
                          "1g",
                          "200m",
                          "20g",
                          "2g",
                          "300m",
                          "400m",
                          "500m",
                          "50g",
                          "50m",
                          "5g"
                        ],
                        "--candidate-ipv6-subnets": "value",
                        "--cloud-router-ipv6-interface-id": "value",
                        "--customer-router-ipv6-interface-id": "value",
                        "--description": "value",
                        "--enable-admin": "bool",
                        "--mtu": "value",
                        "--region": "dynamic",
                        "--stack-type": [
                          "IPV4_IPV6",
                          "IPV4_ONLY"
                        ]
                      }
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "partner": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--description": "value",
                        "--edge-availability-domain": [
                          "any",
                          "availability-domain-1",
                          "availability-domain-2"
                        ],
                        "--enable-admin": "bool",
                        "--encryption": [
                          "IPSEC",
                          "NONE"
                        ],
                        "--ipsec-internal-addresses": "value",
                        "--mtu": "value",
                        "--region": "dynamic",
                        "--router": "dynamic",
                        "--stack-type": [
                          "IPV4_IPV6",
                          "IPV4_ONLY"
                        ]
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--description": "value",
                        "--enable-admin": "bool",
                        "--mtu": "value",
                        "--region": "dynamic",
                        "--stack-type": [
                          "IPV4_IPV6",
                          "IPV4_ONLY"
                        ]
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "create": {
              "commands": {},
              "flags": {
                "--admin-enabled": "bool",
                "--customer-name": "value",
                "--description": "value",
                "--interconnect-type": [
                  "DEDICATED",
                  "PARTNER"
                ],
                "--link-type": [
                  "LINK_TYPE_ETHERNET_100G_LR",
                  "LINK_TYPE_ETHERNET_10G_LR"
                ],
                "--location": "dynamic",
                "--noc-contact-email": "value",
                "--remote-location": "dynamic",
                "--requested-features": "value",
                "--requested-link-count": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "get-diagnostics": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "macsec": {
              "commands": {
                "add-key": {
                  "commands": {},
                  "flags": {
                    "--key-name": "value",
                    "--start-time": "value"
                  }
                },
                "get-config": {
                  "commands": {},
                  "flags": {}
                },
                "remove-key": {
                  "commands": {},
                  "flags": {
                    "--key-name": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--enabled": "bool",
                    "--fail-open": "bool"
                  }
                },
                "update-key": {
                  "commands": {},
                  "flags": {
                    "--key-name": "value",
                    "--start-time": "value"
                  }
                }
              },
              "flags": {}
            },
            "remote-locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--admin-enabled": "bool",
                "--description": "value",
                "--noc-contact-email": "value",
                "--requested-link-count": "value"
              }
            }
          },
          "flags": {}
        },
        "machine-images": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--csek-key-file": "value",
                "--description": "value",
                "--guest-flush": "bool",
                "--kms-key": "dynamic",
                "--kms-keyring": "dynamic",
                "--kms-location": "dynamic",
                "--kms-project": "dynamic",
                "--require-csek-key-create": "bool",
                "--source-disk-csek-key": "value",
                "--source-instance": "dynamic",
                "--source-instance-zone": "dynamic",
                "--storage-location": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--byol": "bool",
                "--can-ip-forward": "bool",
                "--cloudbuild-service-account": "value",
                "--compute-service-account": "value",
                "--custom-cpu": "value",
                "--custom-extensions": "bool",
                "--custom-memory": "value",
                "--custom-vm-type": "value",
                "--description": "value",
                "--guest-environment": "bool",
                "--guest-flush": "bool",
                "--guest-os-features": "value",
                "--labels": "value",
                "--log-location": "value",
                "--machine-type": "dynamic",
                "--network": "value",
                "--network-tier": "value",
                "--no-address": "bool",
                "--no-scopes": "bool",
                "--no-service-account": "bool",
                "--os": [
                  "centos-7",
                  "centos-stream-8",
                  "centos-stream-9",
                  "debian-10",
                  "debian-11",
                  "debian-8",
                  "debian-9",
                  "opensuse-15",
                  "rhel-6",
                  "rhel-6-byol",
                  "rhel-7",
                  "rhel-7-byol",
                  "rhel-8",
                  "rhel-8-byol",
                  "rhel-9",
                  "rhel-9-byol",
                  "rocky-8",
                  "rocky-9",
                  "sles-12",
                  "sles-12-byol",
                  "sles-15",
                  "sles-15-byol",
                  "sles-sap-12",
                  "sles-sap-12-byol",
                  "sles-sap-15",
                  "sles-sap-15-byol",
                  "ubuntu-1404",
                  "ubuntu-1604",
                  "ubuntu-1804",
                  "ubuntu-2004",
                  "ubuntu-2204",
                  "windows-10-x64-byol",
                  "windows-10-x86-byol",
                  "windows-11-x64-byol",
                  "windows-2008r2",
                  "windows-2008r2-byol",
                  "windows-2012",
                  "windows-2012-byol",
                  "windows-2012r2",
                  "windows-2012r2-byol",
                  "windows-2016",
                  "windows-2016-byol",
                  "windows-2019",
                  "windows-2019-byol",
                  "windows-2022",
                  "windows-2022-byol",
                  "windows-7-x64-byol",
                  "windows-7-x86-byol",
                  "windows-8-x64-byol",
                  "windows-8-x86-byol"
                ],
                "--restart-on-failure": "bool",
                "--scopes": "value",
                "--service-account": "value",
                "--source-uri": "value",
                "--storage-location": "value",
                "--subnet": "value",
                "--tags": "value",
                "--timeout": "value",
                "--zone": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {}
            }
          },
          "flags": {}
        },
        "machine-types": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--zone": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--sort-by": "value",
                "--uri": "bool",
                "--zones": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "network-attachments": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--connection-preference": [
                  "ACCEPT_AUTOMATIC",
                  "ACCEPT_MANUAL"
                ],
                "--description": "value",
                "--producer-accept-list": "value",
                "--producer-reject-list": "value",
                "--region": "dynamic",
                "--subnets": "dynamic",
                "--subnets-region": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--producer-accept-list": "value",
                "--producer-reject-list": "value",
                "--region": "dynamic",
                "--subnets": "dynamic",
                "--subnets-region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "network-edge-security-services": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--region": "dynamic",
                "--security-policy": "dynamic",
                "--security-policy-region": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--region": "dynamic",
                "--security-policy": "dynamic",
                "--security-policy-region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "network-endpoint-groups": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--app-engine-app": "bool",
                "--app-engine-service": "value",
                "--app-engine-url-mask": "value",
                "--app-engine-version": "value",
                "--cloud-function-name": "value",
                "--cloud-function-url-mask": "value",
                "--cloud-run-service": "value",
                "--cloud-run-tag": "value",
                "--cloud-run-url-mask": "value",
                "--default-port": "value",
                "--global": "bool",
                "--network": "value",
                "--network-endpoint-type": [
                  "gce-vm-ip",
                  "gce-vm-ip-port",
                  "gce-vm-ip-portmap",
                  "internet-fqdn-port",
                  "internet-ip-port",
                  "non-gcp-private-ip-port",
                  "private-service-connect",
                  "serverless"
                ],
                "--producer-port": "value",
                "--psc-target-service": "value",
                "--region": "dynamic",
                "--subnet": "value",
                "--zone": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic",
                "--zone": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic",
                "--zone": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--global": "bool",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool",
                "--zones": "value"
              }
            },
            "list-network-endpoints": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--global": "bool",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--zone": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-endpoint": "value",
                "--global": "bool",
                "--region": "dynamic",
                "--remove-endpoint": "value",
                "--zone": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "network-firewall-policies": {
          "commands": {
            "associations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--firewall-policy": "value",
                    "--firewall-policy-region": "dynamic",
                    "--global-firewall-policy": "bool",
                    "--name": "value",
                    "--network": "value",
                    "--replace-association-on-target": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--firewall-policy": "value",
                    "--firewall-policy-region": "dynamic",
                    "--global-firewall-policy": "bool",
                    "--name": "value"
                  }
                }
              },
              "flags": {}
            },
            "clone-rules": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic",
                "--source-firewall-policy": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "get-effective-firewalls": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--network": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--global": "bool",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "rules": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--action": [
                      "allow",
                      "apply_security_profile_group",
                      "deny",
                      "goto_next"
                    ],
                    "--description": "value",
                    "--dest-address-groups": "value",
                    "--dest-fqdns": "value",
                    "--dest-ip-ranges": "value",
                    "--dest-region-codes": "value",
                    "--dest-threat-intelligence": "value",
                    "--direction": [
                      "EGRESS",
                      "INGRESS"
                    ],
                    "--disabled": "bool",
                    "--enable-logging": "bool",
                    "--firewall-policy": "value",
                    "--firewall-policy-region": "dynamic",
                    "--global-firewall-policy": "bool",
                    "--layer4-configs": "value",
                    "--security-profile-group": "value",
                    "--src-address-groups": "value",
                    "--src-fqdns": "value",
                    "--src-ip-ranges": "value",
                    "--src-region-codes": "value",
                    "--src-secure-tags": "value",
                    "--src-threat-intelligence": "value",
                    "--target-secure-tags": "value",
                    "--target-service-accounts": "value",
                    "--tls-inspect": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--firewall-policy": "value",
                    "--firewall-policy-region": "dynamic",
                    "--global-firewall-policy": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--firewall-policy": "value",
                    "--firewall-policy-region": "dynamic",
                    "--global-firewall-policy": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--action": [
                      "allow",
                      "apply_security_profile_group",
                      "deny",
                      "goto_next"
                    ],
                    "--description": "value",
                    "--dest-address-groups": "value",
                    "--dest-fqdns": "value",
                    "--dest-ip-ranges": "value",
                    "--dest-region-codes": "value",
                    "--dest-threat-intelligence": "value",
                    "--direction": [
                      "EGRESS",
                      "INGRESS"
                    ],
                    "--disabled": "bool",
                    "--enable-logging": "bool",
                    "--firewall-policy": "value",
                    "--firewall-policy-region": "dynamic",
                    "--global-firewall-policy": "bool",
                    "--layer4-configs": "value",
                    "--new-priority": "value",
                    "--security-profile-group": "value",
                    "--src-address-groups": "value",
                    "--src-fqdns": "value",
                    "--src-ip-ranges": "value",
                    "--src-region-codes": "value",
                    "--src-secure-tags": "value",
                    "--src-threat-intelligence": "value",
                    "--target-secure-tags": "value",
                    "--target-service-accounts": "value",
                    "--tls-inspect": "bool"
                  }
                }
              },
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--global": "bool",
                "--region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "network-profiles": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "networks": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--bgp-best-path-selection-mode": [
                  "LEGACY",
                  "STANDARD"
                ],
                "--bgp-bps-always-compare-med": "bool",
                "--bgp-bps-inter-region-cost": [
                  "ADD_COST_TO_MED",
                  "DEFAULT"
                ],
                "--bgp-routing-mode": [
                  "global",
                  "regional"
                ],
                "--description": "value",
                "--enable-ula-internal-ipv6": "bool",
                "--internal-ipv6-range": "value",
                "--mtu": "value",
                "--network-firewall-policy-enforcement-order": [
                  "AFTER_CLASSIC_FIREWALL",
                  "BEFORE_CLASSIC_FIREWALL"
                ],
                "--network-profile": "dynamic",
                "--range": "value",
                "--subnet-mode": [
                  "auto",
                  "custom",
                  "legacy"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "get-effective-firewalls": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "peerings": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--auto-create-routes": "bool",
                    "--export-custom-routes": "bool",
                    "--export-subnet-routes-with-public-ip": "bool",
                    "--import-custom-routes": "bool",
                    "--import-subnet-routes-with-public-ip": "bool",
                    "--network": "value",
                    "--peer-network": "value",
                    "--peer-project": "value",
                    "--stack-type": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--network": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--network": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-routes": {
                  "commands": {},
                  "flags": {
                    "--direction": [
                      "INCOMING",
                      "OUTGOING"
                    ],
                    "--filter": "value",
                    "--limit": "value",
                    "--network": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--export-custom-routes": "bool",
                    "--export-subnet-routes-with-public-ip": "bool",
                    "--import-custom-routes": "bool",
                    "--import-subnet-routes-with-public-ip": "bool",
                    "--network": "value",
                    "--stack-type": "value"
                  }
                }
              },
              "flags": {}
            },
            "subnets": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--region": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--enable-flow-logs": "bool",
                    "--enable-private-ip-google-access": "bool",
                    "--ipv6-access-type": [
                      "EXTERNAL",
                      "INTERNAL"
                    ],
                    "--logging-aggregation-interval": [
                      "interval-1-min",
                      "interval-10-min",
                      "interval-15-min",
                      "interval-30-sec",
                      "interval-5-min",
                      "interval-5-sec"
                    ],
                    "--logging-filter-expr": "value",
                    "--logging-flow-sampling": "value",
                    "--logging-metadata": [
                      "custom",
                      "exclude-all",
                      "include-all"
                    ],
                    "--logging-metadata-fields": "value",
                    "--network": "dynamic",
                    "--private-ipv6-google-access-type": [
                      "disable",
                      "enable-bidirectional-access",
                      "enable-outbound-vm-access"
                    ],
                    "--purpose": [
                      "GLOBAL_MANAGED_PROXY",
                      "INTERNAL_HTTPS_LOAD_BALANCER",
                      "PEER_MIGRATION",
                      "PRIVATE",
                      "PRIVATE_NAT",
                      "PRIVATE_SERVICE_CONNECT",
                      "REGIONAL_MANAGED_PROXY"
                    ],
                    "--range": "value",
                    "--region": "dynamic",
                    "--reserved-internal-range": "value",
                    "--role": [
                      "ACTIVE",
                      "BACKUP"
                    ],
                    "--secondary-range": "value",
                    "--secondary-range-with-reserved-internal-range": "value",
                    "--stack-type": [
                      "IPV4_IPV6",
                      "IPV4_ONLY",
                      "IPV6_ONLY"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "expand-ip-range": {
                  "commands": {},
                  "flags": {
                    "--prefix-length": "value",
                    "--region": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--network": "value",
                    "--page-size": "value",
                    "--regexp": "value",
                    "--regions": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-usable": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--region": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-secondary-ranges": "value",
                    "--add-secondary-ranges-with-reserved-internal-range": "value",
                    "--drain-timeout": "value",
                    "--enable-flow-logs": "bool",
                    "--enable-private-ip-google-access": "bool",
                    "--ipv6-access-type": [
                      "EXTERNAL",
                      "INTERNAL"
                    ],
                    "--logging-aggregation-interval": [
                      "interval-1-min",
                      "interval-10-min",
                      "interval-15-min",
                      "interval-30-sec",
                      "interval-5-min",
                      "interval-5-sec"
                    ],
                    "--logging-filter-expr": "value",
                    "--logging-flow-sampling": "value",
                    "--logging-metadata": [
                      "custom",
                      "exclude-all",
                      "include-all"
                    ],
                    "--logging-metadata-fields": "value",
                    "--private-ipv6-google-access-type": [
                      "disable",
                      "enable-bidirectional-access",
                      "enable-outbound-vm-access"
                    ],
                    "--purpose": [
                      "PRIVATE",
                      "REGIONAL_MANAGED_PROXY"
                    ],
                    "--region": "dynamic",
                    "--remove-secondary-ranges": "value",
                    "--role": [
                      "ACTIVE"
                    ],
                    "--stack-type": [
                      "IPV4_IPV6",
                      "IPV4_ONLY"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--bgp-best-path-selection-mode": [
                  "LEGACY",
                  "STANDARD"
                ],
                "--bgp-bps-always-compare-med": "bool",
                "--bgp-bps-inter-region-cost": [
                  "ADD_COST_TO_MED",
                  "DEFAULT"
                ],
                "--bgp-routing-mode": [
                  "global",
                  "regional"
                ],
                "--enable-ula-internal-ipv6": "bool",
                "--internal-ipv6-range": "value",
                "--mtu": "value",
                "--network-firewall-policy-enforcement-order": [
                  "AFTER_CLASSIC_FIREWALL",
                  "BEFORE_CLASSIC_FIREWALL"
                ],
                "--switch-to-custom-subnet-mode": "bool"
              }
            },
            "vpc-access": {
              "commands": {
                "connectors": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--machine-type": "value",
                        "--max-instances": "value",
                        "--max-throughput": "value",
                        "--min-instances": "value",
                        "--min-throughput": "value",
                        "--network": "value",
                        "--range": "value",
                        "--region": "dynamic",
                        "--subnet": "value",
                        "--subnet-project": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--region": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "dynamic",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--machine-type": "value",
                        "--max-instances": "value",
                        "--min-instances": "value",
                        "--region": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "locations": {
                  "commands": {
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--region": "dynamic",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic",
                "--zone": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--global": "bool",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool",
                "--zones": "value"
              }
            }
          },
          "flags": {}
        },
        "os-config": {
          "commands": {
            "inventories": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--view": [
                      "basic",
                      "full"
                    ]
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--view": [
                      "basic",
                      "full"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "os-policy-assignment-reports": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--instance": "value",
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--assignment-id": "value",
                    "--filter": "value",
                    "--instance": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "os-policy-assignments": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--file": "value",
                    "--location": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-revisions": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "operations": {
                  "commands": {
                    "cancel": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--os-policy-assignment": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--os-policy-assignment": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--allow-missing": "bool",
                    "--async": "bool",
                    "--file": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "patch-deployments": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--file": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "pause": {
                  "commands": {},
                  "flags": {}
                },
                "resume": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--file": "value"
                  }
                }
              },
              "flags": {}
            },
            "patch-jobs": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "execute": {
                  "commands": {},
                  "flags": {
                    "--apt-dist": "bool",
                    "--apt-excludes": "value",
                    "--apt-exclusive-packages": "value",
                    "--async": "bool",
                    "--description": "value",
                    "--display-name": "value",
                    "--dry-run": "bool",
                    "--duration": "value",
                    "--instance-filter-all": "bool",
                    "--instance-filter-group-labels": "value",
                    "--instance-filter-name-prefixes": "value",
                    "--instance-filter-names": "value",
                    "--instance-filter-zones": "value",
                    "--mig-instances-allowed": "bool",
                    "--post-patch-linux-executable": "value",
                    "--post-patch-linux-success-codes": "value",
                    "--post-patch-windows-executable": "value",
                    "--post-patch-windows-success-codes": "value",
                    "--pre-patch-linux-executable": "value",
                    "--pre-patch-linux-success-codes": "value",
                    "--pre-patch-windows-executable": "value",
                    "--pre-patch-windows-success-codes": "value",
                    "--reboot-config": [
                      "always",
                      "default",
                      "never"
                    ],
                    "--rollout-disruption-budget": "value",
                    "--rollout-disruption-budget-percent": "value",
                    "--rollout-mode": [
                      "concurrent-zones",
                      "zone-by-zone"
                    ],
                    "--windows-classifications": "value",
                    "--windows-excludes": "value",
                    "--windows-exclusive-patches": "value",
                    "--yum-excludes": "value",
                    "--yum-exclusive-packages": "value",
                    "--yum-minimal": "bool",
                    "--yum-security": "bool",
                    "--zypper-categories": "value",
                    "--zypper-excludes": "value",
                    "--zypper-exclusive-patches": "value",
                    "--zypper-severities": "value",
                    "--zypper-with-optional": "bool",
                    "--zypper-with-update": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-instance-details": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "project-feature-settings": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--patch-and-config-feature-set": [
                      "full",
                      "limited",
                      "osconfig-b",
                      "osconfig-c"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "troubleshoot": {
              "commands": {},
              "flags": {
                "--zone": "dynamic"
              }
            },
            "vulnerability-reports": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "os-login": {
          "commands": {
            "describe-profile": {
              "commands": {},
              "flags": {}
            },
            "remove-profile": {
              "commands": {},
              "flags": {}
            },
            "ssh-keys": {
              "commands": {
                "add": {
                  "commands": {},
                  "flags": {
                    "--key": "value",
                    "--key-file": "value",
                    "--ttl": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--key": "value",
                    "--key-file": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "remove": {
                  "commands": {},
                  "flags": {
                    "--key": "value",
                    "--key-file": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--key": "value",
                    "--key-file": "value",
                    "--ttl": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "packet-mirrorings": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--collector-ilb": "value",
                "--description": "value",
                "--enable": "bool",
                "--filter-cidr-ranges": "value",
                "--filter-direction": [
                  "both",
                  "egress",
                  "ingress"
                ],
                "--filter-protocols": "value",
                "--mirrored-instances": "value",
                "--mirrored-subnets": "value",
                "--mirrored-tags": "value",
                "--network": "value",
                "--region": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-filter-cidr-ranges": "value",
                "--add-filter-protocols": "value",
                "--add-mirrored-instances": "value",
                "--add-mirrored-subnets": "value",
                "--add-mirrored-tags": "value",
                "--async": "bool",
                "--clear-filter-cidr-ranges": "bool",
                "--clear-filter-protocols": "bool",
                "--clear-mirrored-instances": "bool",
                "--clear-mirrored-subnets": "bool",
                "--clear-mirrored-tags": "bool",
                "--collector-ilb": "value",
                "--description": "value",
                "--enable": "bool",
                "--filter-direction": [
                  "both",
                  "egress",
                  "ingress"
                ],
                "--region": "dynamic",
                "--remove-filter-cidr-ranges": "value",
                "--remove-filter-protocols": "value",
                "--remove-mirrored-instances": "value",
                "--remove-mirrored-subnets": "value",
                "--remove-mirrored-tags": "value",
                "--set-filter-cidr-ranges": "value",
                "--set-filter-protocols": "value",
                "--set-mirrored-instances": "value",
                "--set-mirrored-subnets": "value",
                "--set-mirrored-tags": "value"
              }
            }
          },
          "flags": {}
        },
        "project-info": {
          "commands": {
            "add-metadata": {
              "commands": {},
              "flags": {
                "--metadata": "value",
                "--metadata-from-file": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "remove-metadata": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--keys": "value"
              }
            },
            "set-usage-bucket": {
              "commands": {},
              "flags": {
                "--bucket": "value",
                "--no-bucket": "bool",
                "--prefix": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--cloud-armor-tier": [
                  "CA_ENTERPRISE_ANNUAL",
                  "CA_ENTERPRISE_PAYGO",
                  "CA_STANDARD"
                ],
                "--default-network-tier": [
                  "PREMIUM",
                  "STANDARD"
                ]
              }
            }
          },
          "flags": {}
        },
        "project-zonal-metadata": {
          "commands": {
            "add": {
              "commands": {},
              "flags": {
                "--metadata": "value",
                "--zone": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--zone": "dynamic"
              }
            },
            "remove": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--keys": "value",
                "--zone": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "public-advertised-prefixes": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--dns-verification-ip": "value",
                "--pdp-scope": [
                  "GLOBAL",
                  "REGIONAL"
                ],
                "--range": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--announce-prefix": "bool",
                "--status": [
                  "ptr-configured"
                ],
                "--withdraw-prefix": "bool"
              }
            }
          },
          "flags": {}
        },
        "public-delegated-prefixes": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--allocatable-prefix-length": "value",
                "--description": "value",
                "--enable-live-migration": "bool",
                "--global": "bool",
                "--mode": [
                  "delegation",
                  "external-ipv6-forwarding-rule-creation"
                ],
                "--public-advertised-prefix": "value",
                "--public-delegated-prefix": "value",
                "--range": "value",
                "--region": "dynamic"
              }
            },
            "delegated-sub-prefixes": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--allocatable-prefix-length": "value",
                    "--create-addresses": "bool",
                    "--delegatee-project": "value",
                    "--description": "value",
                    "--global-public-delegated-prefix": "bool",
                    "--mode": [
                      "delegation",
                      "external-ipv6-forwarding-rule-creation"
                    ],
                    "--public-delegated-prefix": "value",
                    "--public-delegated-prefix-region": "dynamic",
                    "--range": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--global-public-delegated-prefix": "bool",
                    "--public-delegated-prefix": "value",
                    "--public-delegated-prefix-region": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "delete": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--announce-prefix": "bool",
                "--region": "dynamic",
                "--withdraw-prefix": "bool"
              }
            }
          },
          "flags": {}
        },
        "regions": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "reservations": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic",
                "--zone": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--accelerator": "value",
                "--description": "value",
                "--local-ssd": "value",
                "--machine-type": "value",
                "--min-cpu-platform": "value",
                "--require-specific-reservation": "bool",
                "--resource-policies": "value",
                "--share-setting": [
                  "local",
                  "projects"
                ],
                "--share-with": "value",
                "--source-instance-template": "value",
                "--vm-count": "value",
                "--zone": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--zone": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--zone": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--zone": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic",
                "--zone": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--zone": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-share-with": "value",
                "--remove-share-with": "value",
                "--vm-count": "value",
                "--zone": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "reset-windows-password": {
          "commands": {},
          "flags": {
            "--user": "value",
            "--zone": "dynamic"
          }
        },
        "resource-policies": {
          "commands": {
            "create": {
              "commands": {
                "disk-consistency-group": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--region": "dynamic"
                  }
                },
                "group-placement": {
                  "commands": {},
                  "flags": {
                    "--availability-domain-count": "value",
                    "--collocation": [
                      "collocated",
                      "unspecified-collocation"
                    ],
                    "--description": "value",
                    "--region": "dynamic",
                    "--vm-count": "value"
                  }
                },
                "instance-schedule": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--end-date": "value",
                    "--initiation-date": "value",
                    "--region": "dynamic",
                    "--timezone": "value",
                    "--vm-start-schedule": "value",
                    "--vm-stop-schedule": "value"
                  }
                },
                "snapshot-schedule": {
                  "commands": {},
                  "flags": {
                    "--daily-schedule": "bool",
                    "--description": "value",
                    "--guest-flush": "bool",
                    "--hourly-schedule": "value",
                    "--max-retention-days": "value",
                    "--on-source-disk-delete": [
                      "apply-retention-policy",
                      "keep-auto-snapshots"
                    ],
                    "--region": "dynamic",
                    "--snapshot-labels": "value",
                    "--start-time": "value",
                    "--storage-location": "value",
                    "--weekly-schedule": [
                      "friday",
                      "monday",
                      "saturday",
                      "sunday",
                      "thursday",
                      "tuesday",
                      "wednesday"
                    ],
                    "--weekly-schedule-from-file": "value"
                  }
                }
              },
              "flags": {}
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "update": {
              "commands": {
                "instance-schedule": {
                  "commands": {},
                  "flags": {
                    "--description": "value",
                    "--end-date": "value",
                    "--initiation-date": "value",
                    "--region": "dynamic",
                    "--timezone": "value",
                    "--vm-start-schedule": "value",
                    "--vm-stop-schedule": "value"
                  }
                },
                "snapshot-schedule": {
                  "commands": {},
                  "flags": {
                    "--daily-schedule": "bool",
                    "--description": "value",
                    "--hourly-schedule": "value",
                    "--max-retention-days": "value",
                    "--on-source-disk-delete": [
                      "apply-retention-policy",
                      "keep-auto-snapshots"
                    ],
                    "--region": "dynamic",
                    "--snapshot-labels": "value",
                    "--start-time": "value",
                    "--weekly-schedule": [
                      "friday",
                      "monday",
                      "saturday",
                      "sunday",
                      "thursday",
                      "tuesday",
                      "wednesday"
                    ],
                    "--weekly-schedule-from-file": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "routers": {
          "commands": {
            "add-bgp-peer": {
              "commands": {},
              "flags": {
                "--advertised-route-priority": "value",
                "--advertisement-mode": [
                  "CUSTOM",
                  "DEFAULT"
                ],
                "--async": "bool",
                "--bfd-min-receive-interval": "value",
                "--bfd-min-transmit-interval": "value",
                "--bfd-multiplier": "value",
                "--bfd-session-initialization-mode": [
                  "ACTIVE",
                  "DISABLED",
                  "PASSIVE"
                ],
                "--custom-learned-route-priority": "value",
                "--enable-ipv4": "bool",
                "--enable-ipv6": "bool",
                "--enabled": "bool",
                "--instance": "dynamic",
                "--instance-zone": "dynamic",
                "--interface": "value",
                "--ipv4-nexthop-address": "value",
                "--ipv6-nexthop-address": "value",
                "--md5-authentication-key": "value",
                "--peer-asn": "value",
                "--peer-ip-address": "value",
                "--peer-ipv4-nexthop-address": "value",
                "--peer-ipv6-nexthop-address": "value",
                "--peer-name": "value",
                "--region": "dynamic",
                "--set-advertisement-groups": "value",
                "--set-advertisement-ranges": "value",
                "--set-custom-learned-route-ranges": "value"
              }
            },
            "add-interface": {
              "commands": {},
              "flags": {
                "--interconnect-attachment": "dynamic",
                "--interconnect-attachment-region": "dynamic",
                "--interface-name": "value",
                "--ip-address": "value",
                "--ip-version": [
                  "IPV4",
                  "IPV6"
                ],
                "--mask-length": "value",
                "--redundant-interface": "value",
                "--region": "dynamic",
                "--subnetwork": "dynamic",
                "--subnetwork-region": "dynamic",
                "--vpn-tunnel": "dynamic",
                "--vpn-tunnel-region": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--advertisement-mode": [
                  "CUSTOM",
                  "DEFAULT"
                ],
                "--asn": "value",
                "--async": "bool",
                "--bgp-identifier-range": "value",
                "--description": "value",
                "--encrypted-interconnect-router": "bool",
                "--keepalive-interval": "value",
                "--network": "dynamic",
                "--region": "dynamic",
                "--set-advertisement-groups": "value",
                "--set-advertisement-ranges": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "get-nat-ip-info": {
              "commands": {},
              "flags": {
                "--nat-name": "value",
                "--region": "dynamic"
              }
            },
            "get-nat-mapping-info": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--nat-name": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value"
              }
            },
            "get-status": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "nats": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--auto-allocate-nat-external-ips": "bool",
                    "--auto-network-tier": [
                      "PREMIUM",
                      "STANDARD"
                    ],
                    "--enable-dynamic-port-allocation": "bool",
                    "--enable-endpoint-independent-mapping": "bool",
                    "--enable-logging": "bool",
                    "--endpoint-types": "value",
                    "--icmp-idle-timeout": "value",
                    "--log-filter": [
                      "ALL",
                      "ERRORS_ONLY",
                      "TRANSLATIONS_ONLY"
                    ],
                    "--max-ports-per-vm": "value",
                    "--min-ports-per-vm": "value",
                    "--nat-all-subnet-ip-ranges": "bool",
                    "--nat-custom-subnet-ip-ranges": "value",
                    "--nat-external-ip-pool": "value",
                    "--nat-primary-subnet-ip-ranges": "bool",
                    "--region": "dynamic",
                    "--router": "dynamic",
                    "--rules": "value",
                    "--tcp-established-idle-timeout": "value",
                    "--tcp-time-wait-timeout": "value",
                    "--tcp-transitory-idle-timeout": "value",
                    "--type": [
                      "PRIVATE",
                      "PUBLIC"
                    ],
                    "--udp-idle-timeout": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--router": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--router": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--router": "dynamic"
                  }
                },
                "rules": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--match": "value",
                        "--nat": "value",
                        "--region": "dynamic",
                        "--router": "dynamic",
                        "--source-nat-active-ips": "value",
                        "--source-nat-active-ranges": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--nat": "value",
                        "--region": "dynamic",
                        "--router": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--nat": "value",
                        "--region": "dynamic",
                        "--router": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--nat": "value",
                        "--region": "dynamic",
                        "--router": "dynamic"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-source-nat-drain-ips": "bool",
                        "--clear-source-nat-drain-ranges": "bool",
                        "--match": "value",
                        "--nat": "value",
                        "--region": "dynamic",
                        "--router": "dynamic",
                        "--source-nat-active-ips": "value",
                        "--source-nat-active-ranges": "value",
                        "--source-nat-drain-ips": "value",
                        "--source-nat-drain-ranges": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--auto-allocate-nat-external-ips": "bool",
                    "--auto-network-tier": [
                      "PREMIUM",
                      "STANDARD"
                    ],
                    "--clear-icmp-idle-timeout": "bool",
                    "--clear-max-ports-per-vm": "bool",
                    "--clear-min-ports-per-vm": "bool",
                    "--clear-nat-external-drain-ip-pool": "bool",
                    "--clear-tcp-established-idle-timeout": "bool",
                    "--clear-tcp-time-wait-timeout": "bool",
                    "--clear-tcp-transitory-idle-timeout": "bool",
                    "--clear-udp-idle-timeout": "bool",
                    "--enable-dynamic-port-allocation": "bool",
                    "--enable-endpoint-independent-mapping": "bool",
                    "--enable-logging": "bool",
                    "--icmp-idle-timeout": "value",
                    "--log-filter": [
                      "ALL",
                      "ERRORS_ONLY",
                      "TRANSLATIONS_ONLY"
                    ],
                    "--max-ports-per-vm": "value",
                    "--min-ports-per-vm": "value",
                    "--nat-all-subnet-ip-ranges": "bool",
                    "--nat-custom-subnet-ip-ranges": "value",
                    "--nat-external-drain-ip-pool": "value",
                    "--nat-external-ip-pool": "value",
                    "--nat-primary-subnet-ip-ranges": "bool",
                    "--region": "dynamic",
                    "--router": "dynamic",
                    "--rules": "value",
                    "--tcp-established-idle-timeout": "value",
                    "--tcp-time-wait-timeout": "value",
                    "--tcp-transitory-idle-timeout": "value",
                    "--udp-idle-timeout": "value"
                  }
                }
              },
              "flags": {}
            },
            "remove-bgp-peer": {
              "commands": {},
              "flags": {
                "--peer-name": "value",
                "--peer-names": "value",
                "--region": "dynamic"
              }
            },
            "remove-interface": {
              "commands": {},
              "flags": {
                "--interface-name": "value",
                "--interface-names": "value",
                "--region": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-advertisement-groups": "value",
                "--add-advertisement-ranges": "value",
                "--advertisement-mode": [
                  "CUSTOM",
                  "DEFAULT"
                ],
                "--asn": "value",
                "--async": "bool",
                "--bgp-identifier-range": "value",
                "--keepalive-interval": "value",
                "--region": "dynamic",
                "--remove-advertisement-groups": "value",
                "--remove-advertisement-ranges": "value",
                "--set-advertisement-groups": "value",
                "--set-advertisement-ranges": "value"
              }
            },
            "update-bgp-peer": {
              "commands": {},
              "flags": {
                "--add-advertisement-groups": "value",
                "--add-advertisement-ranges": "value",
                "--add-custom-learned-route-ranges": "value",
                "--advertised-route-priority": "value",
                "--advertisement-mode": [
                  "CUSTOM",
                  "DEFAULT"
                ],
                "--async": "bool",
                "--bfd-min-receive-interval": "value",
                "--bfd-min-transmit-interval": "value",
                "--bfd-multiplier": "value",
                "--bfd-session-initialization-mode": [
                  "ACTIVE",
                  "DISABLED",
                  "PASSIVE"
                ],
                "--clear-md5-authentication-key": "bool",
                "--custom-learned-route-priority": "value",
                "--enable-ipv4": "bool",
                "--enable-ipv6": "bool",
                "--enabled": "bool",
                "--interface": "value",
                "--ip-address": "value",
                "--ipv4-nexthop-address": "value",
                "--ipv6-nexthop-address": "value",
                "--md5-authentication-key": "value",
                "--peer-asn": "value",
                "--peer-ip-address": "value",
                "--peer-ipv4-nexthop-address": "value",
                "--peer-ipv6-nexthop-address": "value",
                "--peer-name": "value",
                "--region": "dynamic",
                "--remove-advertisement-groups": "value",
                "--remove-advertisement-ranges": "value",
                "--remove-custom-learned-route-ranges": "value",
                "--set-advertisement-groups": "value",
                "--set-advertisement-ranges": "value",
                "--set-custom-learned-route-ranges": "value"
              }
            },
            "update-interface": {
              "commands": {},
              "flags": {
                "--interconnect-attachment": "dynamic",
                "--interconnect-attachment-region": "dynamic",
                "--interface-name": "value",
                "--ip-address": "value",
                "--ip-version": [
                  "IPV4",
                  "IPV6"
                ],
                "--mask-length": "value",
                "--region": "dynamic",
                "--vpn-tunnel": "dynamic",
                "--vpn-tunnel-region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "routes": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--destination-range": "value",
                "--network": "value",
                "--next-hop-address": "value",
                "--next-hop-gateway": "dynamic",
                "--next-hop-ilb": "value",
                "--next-hop-ilb-region": "value",
                "--next-hop-instance": "value",
                "--next-hop-instance-zone": "value",
                "--next-hop-vpn-tunnel": "value",
                "--next-hop-vpn-tunnel-region": "value",
                "--priority": "value",
                "--tags": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "scp": {
          "commands": {},
          "flags": {
            "--compress": "bool",
            "--dest-group": "value",
            "--dry-run": "bool",
            "--force-key-file-overwrite": "bool",
            "--internal-ip": "bool",
            "--network": "value",
            "--plain": "bool",
            "--port": "value",
            "--recurse": "bool",
            "--region": "value",
            "--scp-flag": "value",
            "--ssh-key-expiration": "value",
            "--ssh-key-expire-after": "value",
            "--ssh-key-file": "value",
            "--strict-host-key-checking": [
              "ask",
              "no",
              "yes"
            ],
            "--tunnel-through-iap": "bool",
            "--zone": "value"
          }
        },
        "security-policies": {
          "commands": {
            "add-layer7-ddos-defense-threshold-config": {
              "commands": {},
              "flags": {
                "--auto-deploy-confidence-threshold": "value",
                "--auto-deploy-expiration-sec": "value",
                "--auto-deploy-impacted-baseline-threshold": "value",
                "--auto-deploy-load-threshold": "value",
                "--detection-absolute-qps": "value",
                "--detection-load-threshold": "value",
                "--detection-relative-to-baseline-qps": "value",
                "--threshold-config-name": "value",
                "--traffic-granularity-configs": "value"
              }
            },
            "add-user-defined-field": {
              "commands": {},
              "flags": {
                "--base": [
                  "ipv4",
                  "ipv6",
                  "tcp",
                  "udp"
                ],
                "--mask": "value",
                "--offset": "value",
                "--region": "dynamic",
                "--size": "value",
                "--user-defined-field-name": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--file-format": [
                  "json",
                  "yaml"
                ],
                "--file-name": "value",
                "--global": "bool",
                "--region": "dynamic",
                "--type": [
                  "CLOUD_ARMOR",
                  "CLOUD_ARMOR_EDGE",
                  "CLOUD_ARMOR_NETWORK"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--file-format": [
                  "json",
                  "yaml"
                ],
                "--file-name": "value",
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--file-format": [
                  "json",
                  "yaml"
                ],
                "--file-name": "value",
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--global": "bool",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "list-preconfigured-expression-sets": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "remove-layer7-ddos-defense-threshold-config": {
              "commands": {},
              "flags": {
                "--threshold-config-name": "value"
              }
            },
            "remove-user-defined-field": {
              "commands": {},
              "flags": {
                "--region": "dynamic",
                "--user-defined-field-name": "value"
              }
            },
            "rules": {
              "commands": {
                "add-preconfig-waf-exclusion": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--request-cookie-to-exclude": "value",
                    "--request-header-to-exclude": "value",
                    "--request-query-param-to-exclude": "value",
                    "--request-uri-to-exclude": "value",
                    "--security-policy": "dynamic",
                    "--target-rule-ids": "value",
                    "--target-rule-set": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--action": [
                      "allow",
                      "deny",
                      "deny-403",
                      "deny-404",
                      "deny-502",
                      "rate-based-ban",
                      "redirect",
                      "redirect-to-recaptcha",
                      "throttle"
                    ],
                    "--ban-duration-sec": "value",
                    "--ban-threshold-count": "value",
                    "--ban-threshold-interval-sec": "value",
                    "--conform-action": [
                      "allow"
                    ],
                    "--description": "value",
                    "--enforce-on-key": [
                      "all",
                      "http-cookie",
                      "http-header",
                      "http-path",
                      "ip",
                      "region-code",
                      "sni",
                      "tls-ja3-fingerprint",
                      "tls-ja4-fingerprint",
                      "user-ip",
                      "xff-ip"
                    ],
                    "--enforce-on-key-configs": "value",
                    "--enforce-on-key-name": "value",
                    "--exceed-action": [
                      "deny",
                      "deny-403",
                      "deny-404",
                      "deny-429",
                      "deny-502",
                      "redirect"
                    ],
                    "--exceed-redirect-target": "value",
                    "--exceed-redirect-type": [
                      "external-302",
                      "google-recaptcha"
                    ],
                    "--expression": "value",
                    "--network-dest-ip-ranges": "value",
                    "--network-dest-ports": "value",
                    "--network-ip-protocols": "value",
                    "--network-src-asns": "value",
                    "--network-src-ip-ranges": "value",
                    "--network-src-ports": "value",
                    "--network-src-region-codes": "value",
                    "--network-user-defined-fields": "value",
                    "--preview": "bool",
                    "--rate-limit-threshold-count": "value",
                    "--rate-limit-threshold-interval-sec": "value",
                    "--recaptcha-action-site-keys": "value",
                    "--recaptcha-session-site-keys": "value",
                    "--redirect-target": "value",
                    "--redirect-type": [
                      "external-302",
                      "google-recaptcha"
                    ],
                    "--region": "dynamic",
                    "--request-headers-to-add": "value",
                    "--security-policy": "dynamic",
                    "--src-ip-ranges": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--security-policy": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--security-policy": "dynamic"
                  }
                },
                "remove-preconfig-waf-exclusion": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic",
                    "--request-cookie-to-exclude": "value",
                    "--request-header-to-exclude": "value",
                    "--request-query-param-to-exclude": "value",
                    "--request-uri-to-exclude": "value",
                    "--security-policy": "dynamic",
                    "--target-rule-ids": "value",
                    "--target-rule-set": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--action": [
                      "allow",
                      "deny",
                      "deny-403",
                      "deny-404",
                      "deny-502",
                      "rate-based-ban",
                      "redirect",
                      "redirect-to-recaptcha",
                      "throttle"
                    ],
                    "--ban-duration-sec": "value",
                    "--ban-threshold-count": "value",
                    "--ban-threshold-interval-sec": "value",
                    "--conform-action": [
                      "allow"
                    ],
                    "--description": "value",
                    "--enforce-on-key": [
                      "all",
                      "http-cookie",
                      "http-header",
                      "http-path",
                      "ip",
                      "region-code",
                      "sni",
                      "tls-ja3-fingerprint",
                      "tls-ja4-fingerprint",
                      "user-ip",
                      "xff-ip"
                    ],
                    "--enforce-on-key-configs": "value",
                    "--enforce-on-key-name": "value",
                    "--exceed-action": [
                      "deny",
                      "deny-403",
                      "deny-404",
                      "deny-429",
                      "deny-502",
                      "redirect"
                    ],
                    "--exceed-redirect-target": "value",
                    "--exceed-redirect-type": [
                      "external-302",
                      "google-recaptcha"
                    ],
                    "--expression": "value",
                    "--network-dest-ip-ranges": "value",
                    "--network-dest-ports": "value",
                    "--network-ip-protocols": "value",
                    "--network-src-asns": "value",
                    "--network-src-ip-ranges": "value",
                    "--network-src-ports": "value",
                    "--network-src-region-codes": "value",
                    "--network-user-defined-fields": "value",
                    "--preview": "bool",
                    "--rate-limit-threshold-count": "value",
                    "--rate-limit-threshold-interval-sec": "value",
                    "--recaptcha-action-site-keys": "value",
                    "--recaptcha-session-site-keys": "value",
                    "--redirect-target": "value",
                    "--redirect-type": [
                      "external-302",
                      "google-recaptcha"
                    ],
                    "--region": "dynamic",
                    "--request-headers-to-add": "value",
                    "--security-policy": "dynamic",
                    "--src-ip-ranges": "value"
                  }
                }
              },
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--enable-layer7-ddos-defense": "bool",
                "--global": "bool",
                "--json-custom-content-types": "value",
                "--json-parsing": [
                  "DISABLED",
                  "STANDARD",
                  "STANDARD_WITH_GRAPHQL"
                ],
                "--layer7-ddos-defense-rule-visibility": [
                  "PREMIUM",
                  "STANDARD"
                ],
                "--log-level": [
                  "NORMAL",
                  "VERBOSE"
                ],
                "--network-ddos-protection": [
                  "ADVANCED",
                  "STANDARD"
                ],
                "--recaptcha-redirect-site-key": "value",
                "--region": "dynamic",
                "--user-ip-request-headers": "value"
              }
            }
          },
          "flags": {}
        },
        "service-attachments": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--connection-preference": [
                  "ACCEPT_AUTOMATIC",
                  "ACCEPT_MANUAL"
                ],
                "--consumer-accept-list": "value",
                "--consumer-reject-list": "value",
                "--description": "value",
                "--domain-names": "value",
                "--enable-proxy-protocol": "bool",
                "--nat-subnets": "dynamic",
                "--nat-subnets-region": "dynamic",
                "--producer-forwarding-rule": "dynamic",
                "--producer-forwarding-rule-region": "dynamic",
                "--propagated-connection-limit": "value",
                "--reconcile-connections": "bool",
                "--region": "dynamic",
                "--target-service": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--connection-preference": [
                  "ACCEPT_AUTOMATIC",
                  "ACCEPT_MANUAL"
                ],
                "--consumer-accept-list": "value",
                "--consumer-reject-list": "value",
                "--description": "value",
                "--enable-proxy-protocol": "bool",
                "--nat-subnets": "dynamic",
                "--nat-subnets-region": "dynamic",
                "--propagated-connection-limit": "value",
                "--reconcile-connections": "bool",
                "--region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "shared-vpc": {
          "commands": {
            "associated-projects": {
              "commands": {
                "add": {
                  "commands": {},
                  "flags": {
                    "--host-project": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove": {
                  "commands": {},
                  "flags": {
                    "--host-project": "value"
                  }
                }
              },
              "flags": {}
            },
            "disable": {
              "commands": {},
              "flags": {}
            },
            "enable": {
              "commands": {},
              "flags": {}
            },
            "get-host-project": {
              "commands": {},
              "flags": {}
            },
            "list-associated-resources": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "organizations": {
              "commands": {
                "list-host-projects": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "sign-url": {
          "commands": {},
          "flags": {
            "--expires-in": "value",
            "--key-file": "value",
            "--key-name": "value",
            "--validate": "bool"
          }
        },
        "snapshot-settings": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--storage-location-names": "value",
                "--storage-location-policy": "value"
              }
            }
          },
          "flags": {}
        },
        "snapshots": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "add-labels": {
              "commands": {},
              "flags": {
                "--labels": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--chain-name": "value",
                "--csek-key-file": "value",
                "--description": "value",
                "--guest-flush": "bool",
                "--labels": "value",
                "--snapshot-type": [
                  "ARCHIVE",
                  "STANDARD"
                ],
                "--source-disk": "dynamic",
                "--source-disk-for-recovery-checkpoint": "dynamic",
                "--source-disk-for-recovery-checkpoint-region": "dynamic",
                "--source-disk-key-file": "value",
                "--source-disk-region": "dynamic",
                "--source-disk-zone": "dynamic",
                "--source-instant-snapshot": "dynamic",
                "--source-instant-snapshot-key-file": "value",
                "--source-instant-snapshot-region": "dynamic",
                "--source-instant-snapshot-zone": "dynamic",
                "--storage-location": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "remove-labels": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--labels": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-labels": "bool",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "sole-tenancy": {
          "commands": {
            "node-groups": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic",
                    "--zone": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--autoscaler-mode": [
                      "off",
                      "on",
                      "only-scale-out"
                    ],
                    "--description": "value",
                    "--maintenance-interval": [
                      "as-needed",
                      "recurrent"
                    ],
                    "--maintenance-policy": [
                      "default",
                      "migrate-within-node-group",
                      "restart-in-place"
                    ],
                    "--maintenance-window-start-time": "value",
                    "--max-nodes": "value",
                    "--min-nodes": "value",
                    "--node-template": "value",
                    "--share-setting": [
                      "local",
                      "organization",
                      "projects"
                    ],
                    "--share-with": "value",
                    "--target-size": "value",
                    "--zone": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--share-settings": "bool",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-nodes": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--zone": "dynamic"
                  }
                },
                "perform-maintenance": {
                  "commands": {},
                  "flags": {
                    "--nodes": "value",
                    "--start-time": "value",
                    "--zone": "dynamic"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic",
                    "--zone": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "simulate-maintenance-event": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--nodes": "value",
                    "--zone": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-nodes": "value",
                    "--autoscaler-mode": [
                      "off",
                      "on",
                      "only-scale-out"
                    ],
                    "--delete-nodes": "value",
                    "--max-nodes": "value",
                    "--min-nodes": "value",
                    "--node-template": "value",
                    "--share-setting": [
                      "local",
                      "organization",
                      "projects"
                    ],
                    "--share-with": "value",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "node-templates": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--region": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator": "value",
                    "--cpu-overcommit-type": [
                      "enabled",
                      "none"
                    ],
                    "--description": "value",
                    "--disk": "value",
                    "--node-affinity-labels": "value",
                    "--node-requirements": "value",
                    "--node-type": "value",
                    "--region": "dynamic",
                    "--server-binding": [
                      "restart-node-on-any-server",
                      "restart-node-on-minimal-servers"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "dynamic"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--region": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                }
              },
              "flags": {}
            },
            "node-types": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "ssh": {
          "commands": {},
          "flags": {
            "--command": "value",
            "--container": "value",
            "--dest-group": "value",
            "--dry-run": "bool",
            "--force-key-file-overwrite": "bool",
            "--internal-ip": "bool",
            "--network": "value",
            "--plain": "bool",
            "--region": "value",
            "--ssh-flag": "value",
            "--ssh-key-expiration": "value",
            "--ssh-key-expire-after": "value",
            "--ssh-key-file": "value",
            "--strict-host-key-checking": [
              "ask",
              "no",
              "yes"
            ],
            "--troubleshoot": "bool",
            "--tunnel-through-iap": "bool",
            "--zone": "dynamic"
          }
        },
        "ssl-certificates": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--certificate": "value",
                "--description": "value",
                "--domains": "value",
                "--global": "bool",
                "--private-key": "value",
                "--region": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--global": "bool",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "ssl-policies": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--custom-features": "value",
                "--description": "value",
                "--global": "bool",
                "--min-tls-version": [
                  "1.0",
                  "1.1",
                  "1.2"
                ],
                "--profile": [
                  "COMPATIBLE",
                  "CUSTOM",
                  "MODERN",
                  "RESTRICTED"
                ],
                "--region": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--global": "bool",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "list-available-features": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--custom-features": "value",
                "--global": "bool",
                "--min-tls-version": [
                  "1.0",
                  "1.1",
                  "1.2"
                ],
                "--profile": [
                  "COMPATIBLE",
                  "CUSTOM",
                  "MODERN",
                  "RESTRICTED"
                ],
                "--region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "start-iap-tunnel": {
          "commands": {},
          "flags": {
            "--dest-group": "value",
            "--iap-tunnel-disable-connection-check": "bool",
            "--local-host-port": "value",
            "--network": "value",
            "--region": "value",
            "--zone": "dynamic"
          }
        },
        "storage-pool-types": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--zone": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            }
          },
          "flags": {}
        },
        "storage-pools": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--capacity-provisioning-type": [
                  "advanced",
                  "standard"
                ],
                "--description": "value",
                "--performance-provisioning-type": [
                  "advanced",
                  "standard"
                ],
                "--provisioned-capacity": "value",
                "--provisioned-iops": "value",
                "--provisioned-throughput": "value",
                "--storage-pool-type": "value",
                "--zone": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--zone": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--zone": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--zone": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list-disks": {
              "commands": {},
              "flags": {
                "--zone": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--zone": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--provisioned-capacity": "value",
                "--provisioned-iops": "value",
                "--provisioned-throughput": "value",
                "--zone": "value"
              }
            }
          },
          "flags": {}
        },
        "target-grpc-proxies": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--global-url-map": "bool",
                "--url-map": "dynamic",
                "--url-map-region": "dynamic",
                "--validate-for-proxyless": "bool"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "target-http-proxies": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--global": "bool",
                "--global-url-map": "bool",
                "--http-keep-alive-timeout-sec": "value",
                "--region": "dynamic",
                "--url-map": "dynamic",
                "--url-map-region": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--global": "bool",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-http-keep-alive-timeout-sec": "bool",
                "--global": "bool",
                "--global-url-map": "bool",
                "--http-keep-alive-timeout-sec": "value",
                "--region": "dynamic",
                "--url-map": "dynamic",
                "--url-map-region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "target-https-proxies": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--certificate-manager-certificates": "dynamic",
                "--certificate-map": "dynamic",
                "--description": "value",
                "--global": "bool",
                "--global-ssl-certificates": "bool",
                "--global-ssl-policy": "bool",
                "--global-url-map": "bool",
                "--http-keep-alive-timeout-sec": "value",
                "--quic-override": [
                  "DISABLE",
                  "ENABLE",
                  "NONE"
                ],
                "--region": "dynamic",
                "--server-tls-policy": "dynamic",
                "--ssl-certificates": "dynamic",
                "--ssl-certificates-region": "dynamic",
                "--ssl-policy": "dynamic",
                "--ssl-policy-region": "dynamic",
                "--tls-early-data": [
                  "DISABLED",
                  "PERMISSIVE",
                  "STRICT"
                ],
                "--url-map": "dynamic",
                "--url-map-region": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--global": "bool",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--certificate-manager-certificates": "dynamic",
                "--certificate-map": "dynamic",
                "--clear-certificate-map": "bool",
                "--clear-http-keep-alive-timeout-sec": "bool",
                "--clear-server-tls-policy": "bool",
                "--clear-ssl-certificates": "bool",
                "--clear-ssl-policy": "bool",
                "--global": "bool",
                "--global-ssl-certificates": "bool",
                "--global-ssl-policy": "bool",
                "--global-url-map": "bool",
                "--http-keep-alive-timeout-sec": "value",
                "--quic-override": [
                  "DISABLE",
                  "ENABLE",
                  "NONE"
                ],
                "--region": "dynamic",
                "--server-tls-policy": "dynamic",
                "--ssl-certificates": "dynamic",
                "--ssl-certificates-region": "dynamic",
                "--ssl-policy": "dynamic",
                "--ssl-policy-region": "dynamic",
                "--tls-early-data": [
                  "DISABLED",
                  "PERMISSIVE",
                  "STRICT"
                ],
                "--url-map": "dynamic",
                "--url-map-region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "target-instances": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--instance": "dynamic",
                "--instance-zone": "dynamic",
                "--network": "value",
                "--zone": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--zone": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--zone": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--sort-by": "value",
                "--uri": "bool",
                "--zones": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--security-policy": "dynamic",
                "--security-policy-region": "dynamic",
                "--zone": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "target-pools": {
          "commands": {
            "add-health-checks": {
              "commands": {},
              "flags": {
                "--http-health-check": "dynamic",
                "--region": "dynamic"
              }
            },
            "add-instances": {
              "commands": {},
              "flags": {
                "--instances": "dynamic",
                "--instances-zone": "dynamic",
                "--region": "dynamic",
                "--zone": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--backup-pool": "value",
                "--description": "value",
                "--failover-ratio": "value",
                "--health-check": "value",
                "--http-health-check": "dynamic",
                "--region": "dynamic",
                "--session-affinity": [
                  "CLIENT_IP",
                  "CLIENT_IP_PROTO",
                  "NONE"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "get-health": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-health-checks": {
              "commands": {},
              "flags": {
                "--http-health-check": "dynamic",
                "--region": "dynamic"
              }
            },
            "remove-instances": {
              "commands": {},
              "flags": {
                "--instances": "dynamic",
                "--instances-zone": "dynamic",
                "--region": "dynamic",
                "--zone": "dynamic"
              }
            },
            "set-backup": {
              "commands": {},
              "flags": {
                "--backup-pool": "dynamic",
                "--failover-ratio": "value",
                "--no-backup-pool": "bool",
                "--region": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--region": "dynamic",
                "--security-policy": "dynamic",
                "--security-policy-region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "target-ssl-proxies": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--backend-service": "dynamic",
                "--certificate-map": "dynamic",
                "--description": "value",
                "--global-ssl-policy": "bool",
                "--proxy-header": [
                  "NONE",
                  "PROXY_V1"
                ],
                "--ssl-certificates": "dynamic",
                "--ssl-policy": "dynamic",
                "--ssl-policy-region": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--backend-service": "dynamic",
                "--certificate-map": "dynamic",
                "--clear-certificate-map": "bool",
                "--clear-ssl-certificates": "bool",
                "--clear-ssl-policy": "bool",
                "--global-ssl-policy": "bool",
                "--proxy-header": [
                  "NONE",
                  "PROXY_V1"
                ],
                "--ssl-certificates": "dynamic",
                "--ssl-policy": "dynamic",
                "--ssl-policy-region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "target-tcp-proxies": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--backend-service": "dynamic",
                "--backend-service-region": "dynamic",
                "--description": "value",
                "--global": "bool",
                "--global-backend-service": "bool",
                "--proxy-bind": "bool",
                "--proxy-header": [
                  "NONE",
                  "PROXY_V1"
                ],
                "--region": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--global": "bool",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--backend-service": "dynamic",
                "--proxy-header": [
                  "NONE",
                  "PROXY_V1"
                ]
              }
            }
          },
          "flags": {}
        },
        "target-vpn-gateways": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--network": "dynamic",
                "--region": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "tpus": {
          "commands": {
            "accelerator-types": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "create": {
              "commands": {},
              "flags": {
                "--accelerator-type": "value",
                "--async": "bool",
                "--description": "value",
                "--network": "value",
                "--preemptible": "bool",
                "--range": "value",
                "--zone": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--zone": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--zone": "value"
              }
            },
            "execution-groups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator-type": "value",
                    "--disk-size": "value",
                    "--dry-run": "bool",
                    "--forward-ports": "bool",
                    "--gce-image": "value",
                    "--machine-type": "value",
                    "--name": "value",
                    "--network": "value",
                    "--preemptible": "bool",
                    "--preemptible-vm": "bool",
                    "--tf-version": "value",
                    "--tpu-only": "bool",
                    "--use-dl-images": "bool",
                    "--use-with-notebook": "bool",
                    "--vm-only": "bool",
                    "--zone": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--tpu-only": "bool",
                    "--zone": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool",
                "--zone": "dynamic"
              }
            },
            "locations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "queued-resources": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator-type": "value",
                    "--async": "bool",
                    "--data-disk": "value",
                    "--description": "value",
                    "--guaranteed": "bool",
                    "--internal-ips": "bool",
                    "--labels": "value",
                    "--metadata": "value",
                    "--metadata-from-file": "value",
                    "--network": "value",
                    "--node-count": "value",
                    "--node-id": "value",
                    "--node-prefix": "value",
                    "--range": "value",
                    "--reservation-host-folder": "value",
                    "--reservation-host-organization": "value",
                    "--reservation-host-project": "value",
                    "--reserved": "bool",
                    "--runtime-version": "value",
                    "--scopes": "value",
                    "--service-account": "value",
                    "--shielded-secure-boot": "bool",
                    "--spot": "bool",
                    "--subnetwork": "value",
                    "--tags": "value",
                    "--topology": "value",
                    "--type": [
                      "v2",
                      "v3",
                      "v4"
                    ],
                    "--valid-after-duration": "value",
                    "--valid-after-time": "value",
                    "--valid-until-duration": "value",
                    "--valid-until-time": "value",
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--force": "bool",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                },
                "reset": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--zone": "value"
                  }
                },
                "scp": {
                  "commands": {},
                  "flags": {
                    "--batch-size": "value",
                    "--compress": "bool",
                    "--dry-run": "bool",
                    "--force-key-file-overwrite": "bool",
                    "--internal-ip": "bool",
                    "--node": "value",
                    "--plain": "bool",
                    "--recurse": "bool",
                    "--scp-flag": "value",
                    "--ssh-key-expiration": "value",
                    "--ssh-key-expire-after": "value",
                    "--ssh-key-file": "value",
                    "--strict-host-key-checking": [
                      "ask",
                      "no",
                      "yes"
                    ],
                    "--tunnel-through-iap": "bool",
                    "--worker": "value",
                    "--zone": "dynamic"
                  }
                },
                "ssh": {
                  "commands": {},
                  "flags": {
                    "--batch-size": "value",
                    "--command": "value",
                    "--dry-run": "bool",
                    "--force-key-file-overwrite": "bool",
                    "--internal-ip": "bool",
                    "--node": "value",
                    "--output-directory": "value",
                    "--plain": "bool",
                    "--ssh-flag": "value",
                    "--ssh-key-expiration": "value",
                    "--ssh-key-expire-after": "value",
                    "--ssh-key-file": "value",
                    "--strict-host-key-checking": [
                      "ask",
                      "no",
                      "yes"
                    ],
                    "--tunnel-through-iap": "bool",
                    "--worker": "value",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "reimage": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--zone": "value"
              }
            },
            "start": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--zone": "value"
              }
            },
            "stop": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--zone": "value"
              }
            },
            "topologies": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "tpu-vm": {
              "commands": {
                "accelerator-types": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--zone": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--accelerator-type": "value",
                    "--async": "bool",
                    "--data-disk": "value",
                    "--description": "value",
                    "--internal-ips": "bool",
                    "--labels": "value",
                    "--metadata": "value",
                    "--metadata-from-file": "value",
                    "--network": "value",
                    "--preemptible": "bool",
                    "--queue-count": "value",
                    "--range": "value",
                    "--reserved": "bool",
                    "--scopes": "value",
                    "--service-account": "value",
                    "--shielded-secure-boot": "bool",
                    "--spot": "bool",
                    "--subnetwork": "value",
                    "--tags": "value",
                    "--topology": "value",
                    "--type": [
                      "v2",
                      "v3",
                      "v4"
                    ],
                    "--zone": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--zone": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "get-guest-attributes": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--query-path": "value",
                    "--sort-by": "value",
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                },
                "scp": {
                  "commands": {},
                  "flags": {
                    "--compress": "bool",
                    "--dry-run": "bool",
                    "--force-key-file-overwrite": "bool",
                    "--internal-ip": "bool",
                    "--plain": "bool",
                    "--recurse": "bool",
                    "--scp-flag": "value",
                    "--ssh-key-expiration": "value",
                    "--ssh-key-expire-after": "value",
                    "--ssh-key-file": "value",
                    "--strict-host-key-checking": [
                      "ask",
                      "no",
                      "yes"
                    ],
                    "--worker": "value",
                    "--zone": "dynamic"
                  }
                },
                "service-identity": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "ssh": {
                  "commands": {},
                  "flags": {
                    "--command": "value",
                    "--dry-run": "bool",
                    "--force-key-file-overwrite": "bool",
                    "--internal-ip": "bool",
                    "--output-directory": "value",
                    "--plain": "bool",
                    "--ssh-flag": "value",
                    "--ssh-key-expiration": "value",
                    "--ssh-key-expire-after": "value",
                    "--ssh-key-file": "value",
                    "--strict-host-key-checking": [
                      "ask",
                      "no",
                      "yes"
                    ],
                    "--worker": "value",
                    "--zone": "dynamic"
                  }
                },
                "start": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--zone": "value"
                  }
                },
                "stop": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--zone": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-tags": "value",
                    "--async": "bool",
                    "--attach-disk": "value",
                    "--clear-labels": "bool",
                    "--clear-metadata": "bool",
                    "--clear-tags": "bool",
                    "--description": "value",
                    "--detach-disk": "value",
                    "--internal-ips": "bool",
                    "--metadata-from-file": "value",
                    "--remove-labels": "value",
                    "--remove-metadata": "value",
                    "--remove-tags": "value",
                    "--update-labels": "value",
                    "--update-metadata": "value",
                    "--zone": "value"
                  }
                },
                "versions": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--zone": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "versions": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "url-maps": {
          "commands": {
            "add-host-rule": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--global": "bool",
                "--hosts": "value",
                "--path-matcher-name": "value",
                "--region": "dynamic"
              }
            },
            "add-path-matcher": {
              "commands": {},
              "flags": {
                "--backend-bucket-path-rules": "value",
                "--backend-service-path-rules": "value",
                "--default-backend-bucket": "value",
                "--default-service": "value",
                "--delete-orphaned-path-matcher": "bool",
                "--description": "value",
                "--existing-host": "value",
                "--global": "bool",
                "--new-hosts": "value",
                "--path-matcher-name": "value",
                "--path-rules": "value",
                "--region": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--default-backend-bucket": "value",
                "--default-service": "value",
                "--description": "value",
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "edit": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "dynamic",
                "--source": "value"
              }
            },
            "invalidate-cdn-cache": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--global": "bool",
                "--host": "value",
                "--path": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--global": "bool",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "list-cdn-cache-invalidations": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--limit": "value"
              }
            },
            "remove-host-rule": {
              "commands": {},
              "flags": {
                "--delete-orphaned-path-matcher": "bool",
                "--global": "bool",
                "--host": "value",
                "--region": "dynamic"
              }
            },
            "remove-path-matcher": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--path-matcher-name": "value",
                "--region": "dynamic"
              }
            },
            "set-default-service": {
              "commands": {},
              "flags": {
                "--default-backend-bucket": "value",
                "--default-service": "value",
                "--global": "bool",
                "--region": "dynamic"
              }
            },
            "validate": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--load-balancing-scheme": [
                  "EXTERNAL",
                  "EXTERNAL_MANAGED"
                ],
                "--region": "value",
                "--source": "value"
              }
            }
          },
          "flags": {}
        },
        "vpn-gateways": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--gateway-ip-version": [
                  "IPV4",
                  "IPV6"
                ],
                "--interconnect-attachments": "value",
                "--network": "dynamic",
                "--region": "dynamic",
                "--stack-type": [
                  "IPV4_IPV6",
                  "IPV4_ONLY",
                  "IPV6_ONLY"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "get-status": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-labels": "bool",
                "--region": "dynamic",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "vpn-tunnels": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--ike-version": [
                  1,
                  2
                ],
                "--interface": [
                  0,
                  1
                ],
                "--local-traffic-selector": "value",
                "--peer-address": "value",
                "--peer-external-gateway": "dynamic",
                "--peer-external-gateway-interface": [
                  0,
                  1,
                  2,
                  3
                ],
                "--peer-gcp-gateway": "dynamic",
                "--peer-gcp-gateway-region": "dynamic",
                "--region": "dynamic",
                "--remote-traffic-selector": "value",
                "--router": "dynamic",
                "--router-region": "dynamic",
                "--shared-secret": "value",
                "--target-vpn-gateway": "dynamic",
                "--target-vpn-gateway-region": "dynamic",
                "--vpn-gateway": "dynamic",
                "--vpn-gateway-region": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--regions": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "zones": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--regexp": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "config": {
      "commands": {
        "configurations": {
          "commands": {
            "activate": {
              "commands": {},
              "flags": {}
            },
            "create": {
              "commands": {},
              "flags": {
                "--activate": "bool"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {
                "--all": "bool"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--sort-by": "value"
              }
            },
            "rename": {
              "commands": {},
              "flags": {
                "--new-name": "value"
              }
            }
          },
          "flags": {}
        },
        "get": {
          "commands": {},
          "flags": {}
        },
        "list": {
          "commands": {},
          "flags": {
            "--all": "bool",
            "--filter": "value",
            "--limit": "value",
            "--sort-by": "value"
          }
        },
        "set": {
          "commands": {},
          "flags": {
            "--installation": "bool"
          }
        },
        "unset": {
          "commands": {},
          "flags": {
            "--installation": "bool"
          }
        }
      },
      "flags": {}
    },
    "container": {
      "commands": {
        "attached": {
          "commands": {
            "clusters": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--allow-missing": "bool",
                    "--async": "bool",
                    "--ignore-errors": "bool",
                    "--location": "value",
                    "--validate-only": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "generate-install-manifest": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--output-file": "value",
                    "--platform-version": "value",
                    "--proxy-secret-name": "value",
                    "--proxy-secret-namespace": "value"
                  }
                },
                "get-credentials": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--context": "value",
                    "--distribution": "value",
                    "--fleet-membership": "value",
                    "--fleet-membership-location": "value",
                    "--kubeconfig": "value",
                    "--location": "value",
                    "--platform-version": "value",
                    "--proxy-secret-name": "value",
                    "--proxy-secret-namespace": "value",
                    "--validate-only": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "register": {
                  "commands": {},
                  "flags": {
                    "--admin-groups": "value",
                    "--admin-users": "value",
                    "--annotations": "value",
                    "--binauthz-evaluation-mode": [
                      "DISABLED",
                      "PROJECT_SINGLETON_POLICY_ENFORCE"
                    ],
                    "--context": "value",
                    "--description": "value",
                    "--disable-cloud-monitoring": "bool",
                    "--distribution": "value",
                    "--enable-cloud-monitoring": "bool",
                    "--enable-managed-prometheus": "bool",
                    "--fleet-project": "value",
                    "--has-private-issuer": "bool",
                    "--issuer-url": "value",
                    "--kubeconfig": "value",
                    "--location": "value",
                    "--logging": "value",
                    "--platform-version": "value",
                    "--proxy-secret-name": "value",
                    "--proxy-secret-namespace": "value",
                    "--validate-only": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--admin-groups": "value",
                    "--admin-users": "value",
                    "--annotations": "value",
                    "--async": "bool",
                    "--binauthz-evaluation-mode": [
                      "DISABLED",
                      "PROJECT_SINGLETON_POLICY_ENFORCE"
                    ],
                    "--clear-admin-groups": "bool",
                    "--clear-admin-users": "bool",
                    "--clear-description": "bool",
                    "--description": "value",
                    "--disable-cloud-monitoring": "bool",
                    "--disable-managed-prometheus": "bool",
                    "--enable-cloud-monitoring": "bool",
                    "--enable-managed-prometheus": "bool",
                    "--location": "value",
                    "--logging": "value",
                    "--platform-version": "value",
                    "--proxy-secret-name": "value",
                    "--proxy-secret-namespace": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            },
            "get-server-config": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "aws": {
          "commands": {
            "clusters": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--admin-groups": "value",
                    "--admin-users": "value",
                    "--annotations": "value",
                    "--async": "bool",
                    "--aws-region": "value",
                    "--binauthz-evaluation-mode": [
                      "DISABLED",
                      "PROJECT_SINGLETON_POLICY_ENFORCE"
                    ],
                    "--cluster-version": "value",
                    "--config-encryption-kms-key-arn": "value",
                    "--database-encryption-kms-key-arn": "value",
                    "--description": "value",
                    "--disable-per-node-pool-sg-rules": "bool",
                    "--enable-managed-prometheus": "bool",
                    "--fleet-project": "value",
                    "--iam-instance-profile": "value",
                    "--instance-type": "value",
                    "--location": "value",
                    "--logging": "value",
                    "--main-volume-iops": "value",
                    "--main-volume-kms-key-arn": "value",
                    "--main-volume-size": "value",
                    "--main-volume-throughput": "value",
                    "--main-volume-type": [
                      "gp2",
                      "gp3"
                    ],
                    "--pod-address-cidr-blocks": "value",
                    "--proxy-secret-arn": "value",
                    "--proxy-secret-version-id": "value",
                    "--role-arn": "value",
                    "--role-session-name": "value",
                    "--root-volume-iops": "value",
                    "--root-volume-kms-key-arn": "value",
                    "--root-volume-size": "value",
                    "--root-volume-throughput": "value",
                    "--root-volume-type": [
                      "gp2",
                      "gp3"
                    ],
                    "--security-group-ids": "value",
                    "--service-address-cidr-blocks": "value",
                    "--ssh-ec2-key-pair": "value",
                    "--subnet-ids": "value",
                    "--tags": "value",
                    "--validate-only": "bool",
                    "--vpc-id": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--allow-missing": "bool",
                    "--async": "bool",
                    "--ignore-errors": "bool",
                    "--location": "value",
                    "--validate-only": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-credentials": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--private-endpoint": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--admin-groups": "value",
                    "--admin-users": "value",
                    "--annotations": "value",
                    "--async": "bool",
                    "--binauthz-evaluation-mode": [
                      "DISABLED",
                      "PROJECT_SINGLETON_POLICY_ENFORCE"
                    ],
                    "--clear-annotations": "bool",
                    "--clear-description": "bool",
                    "--clear-proxy-config": "bool",
                    "--clear-security-group-ids": "bool",
                    "--clear-ssh-ec2-key-pair": "bool",
                    "--clear-tags": "bool",
                    "--cluster-version": "value",
                    "--config-encryption-kms-key-arn": "value",
                    "--description": "value",
                    "--disable-managed-prometheus": "bool",
                    "--disable-per-node-pool-sg-rules": "bool",
                    "--enable-managed-prometheus": "bool",
                    "--enable-per-node-pool-sg-rules": "bool",
                    "--iam-instance-profile": "value",
                    "--instance-type": "value",
                    "--location": "value",
                    "--logging": "value",
                    "--proxy-secret-arn": "value",
                    "--proxy-secret-version-id": "value",
                    "--role-arn": "value",
                    "--role-session-name": "value",
                    "--root-volume-iops": "value",
                    "--root-volume-kms-key-arn": "value",
                    "--root-volume-size": "value",
                    "--root-volume-throughput": "value",
                    "--root-volume-type": [
                      "gp2",
                      "gp3"
                    ],
                    "--security-group-ids": "value",
                    "--ssh-ec2-key-pair": "value",
                    "--tags": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            },
            "get-server-config": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "node-pools": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--annotations": "value",
                    "--async": "bool",
                    "--autoscaling-metrics": "value",
                    "--autoscaling-metrics-granularity": "value",
                    "--cluster": "value",
                    "--config-encryption-kms-key-arn": "value",
                    "--enable-autorepair": "bool",
                    "--iam-instance-profile": "value",
                    "--instance-type": "value",
                    "--kubelet-config-cpu-cfs-quota": "value",
                    "--kubelet-config-cpu-cfs-quota-period": "value",
                    "--kubelet-config-cpu-manager-policy": [
                      "none",
                      "static"
                    ],
                    "--kubelet-config-pod-pids-limit": "value",
                    "--location": "value",
                    "--max-nodes": "value",
                    "--max-pods-per-node": "value",
                    "--max-surge-update": "value",
                    "--max-unavailable-update": "value",
                    "--min-nodes": "value",
                    "--node-labels": "value",
                    "--node-taints": "value",
                    "--node-version": "value",
                    "--proxy-secret-arn": "value",
                    "--proxy-secret-version-id": "value",
                    "--root-volume-iops": "value",
                    "--root-volume-kms-key-arn": "value",
                    "--root-volume-size": "value",
                    "--root-volume-throughput": "value",
                    "--root-volume-type": [
                      "gp2",
                      "gp3"
                    ],
                    "--security-group-ids": "value",
                    "--spot-instance-types": "value",
                    "--ssh-ec2-key-pair": "value",
                    "--subnet-id": "value",
                    "--tags": "value",
                    "--validate-only": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--allow-missing": "bool",
                    "--async": "bool",
                    "--cluster": "value",
                    "--ignore-errors": "bool",
                    "--location": "value",
                    "--validate-only": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "rollback": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster": "value",
                    "--location": "value",
                    "--respect-pdb": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--annotations": "value",
                    "--async": "bool",
                    "--autoscaling-metrics": "value",
                    "--autoscaling-metrics-granularity": "value",
                    "--clear-annotations": "bool",
                    "--clear-autoscaling-metrics": "bool",
                    "--clear-node-labels": "bool",
                    "--clear-proxy-config": "bool",
                    "--clear-security-group-ids": "bool",
                    "--clear-ssh-ec2-key-pair": "bool",
                    "--clear-tags": "bool",
                    "--cluster": "value",
                    "--config-encryption-kms-key-arn": "value",
                    "--enable-autorepair": "bool",
                    "--iam-instance-profile": "value",
                    "--instance-type": "value",
                    "--location": "value",
                    "--max-nodes": "value",
                    "--max-surge-update": "value",
                    "--max-unavailable-update": "value",
                    "--min-nodes": "value",
                    "--node-labels": "value",
                    "--node-version": "value",
                    "--proxy-secret-arn": "value",
                    "--proxy-secret-version-id": "value",
                    "--root-volume-iops": "value",
                    "--root-volume-kms-key-arn": "value",
                    "--root-volume-size": "value",
                    "--root-volume-throughput": "value",
                    "--root-volume-type": [
                      "gp2",
                      "gp3"
                    ],
                    "--security-group-ids": "value",
                    "--ssh-ec2-key-pair": "value",
                    "--tags": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "azure": {
          "commands": {
            "clients": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--application-id": "value",
                    "--async": "bool",
                    "--location": "value",
                    "--tenant-id": "value",
                    "--validate-only": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--allow-missing": "bool",
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-public-cert": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--output-file": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "clusters": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--admin-groups": "value",
                    "--admin-users": "value",
                    "--annotations": "value",
                    "--async": "bool",
                    "--azure-application-id": "value",
                    "--azure-region": "value",
                    "--azure-tenant-id": "value",
                    "--client": "value",
                    "--cluster-version": "value",
                    "--config-encryption-key-id": "value",
                    "--config-encryption-public-key": "value",
                    "--database-encryption-key-id": "value",
                    "--description": "value",
                    "--enable-managed-prometheus": "bool",
                    "--endpoint-subnet-id": "value",
                    "--fleet-project": "value",
                    "--location": "value",
                    "--logging": "value",
                    "--main-volume-size": "value",
                    "--pod-address-cidr-blocks": "value",
                    "--proxy-resource-group-id": "value",
                    "--proxy-secret-id": "value",
                    "--replica-placements": "value",
                    "--resource-group-id": "value",
                    "--root-volume-size": "value",
                    "--service-address-cidr-blocks": "value",
                    "--service-load-balancer-subnet-id": "value",
                    "--ssh-public-key": "value",
                    "--subnet-id": "value",
                    "--tags": "value",
                    "--validate-only": "bool",
                    "--vm-size": "value",
                    "--vnet-id": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--allow-missing": "bool",
                    "--async": "bool",
                    "--ignore-errors": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-credentials": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--private-endpoint": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--admin-groups": "value",
                    "--admin-users": "value",
                    "--annotations": "value",
                    "--async": "bool",
                    "--azure-application-id": "value",
                    "--azure-tenant-id": "value",
                    "--clear-annotations": "bool",
                    "--clear-client": "bool",
                    "--clear-description": "bool",
                    "--client": "value",
                    "--cluster-version": "value",
                    "--description": "value",
                    "--disable-managed-prometheus": "bool",
                    "--enable-managed-prometheus": "bool",
                    "--location": "value",
                    "--logging": "value",
                    "--ssh-public-key": "value",
                    "--validate-only": "bool",
                    "--vm-size": "value"
                  }
                }
              },
              "flags": {}
            },
            "get-server-config": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "node-pools": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--annotations": "value",
                    "--async": "bool",
                    "--azure-availability-zone": "value",
                    "--cluster": "value",
                    "--config-encryption-key-id": "value",
                    "--config-encryption-public-key": "value",
                    "--enable-autorepair": "bool",
                    "--location": "value",
                    "--max-nodes": "value",
                    "--max-pods-per-node": "value",
                    "--min-nodes": "value",
                    "--node-labels": "value",
                    "--node-taints": "value",
                    "--node-version": "value",
                    "--proxy-resource-group-id": "value",
                    "--proxy-secret-id": "value",
                    "--root-volume-size": "value",
                    "--ssh-public-key": "value",
                    "--subnet-id": "value",
                    "--tags": "value",
                    "--validate-only": "bool",
                    "--vm-size": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--allow-missing": "bool",
                    "--async": "bool",
                    "--cluster": "value",
                    "--ignore-errors": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--annotations": "value",
                    "--async": "bool",
                    "--clear-annotations": "bool",
                    "--cluster": "value",
                    "--enable-autorepair": "bool",
                    "--location": "value",
                    "--max-nodes": "value",
                    "--min-nodes": "value",
                    "--node-version": "value",
                    "--ssh-public-key": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "bare-metal": {
          "commands": {
            "admin-clusters": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--admin-users": "value",
                    "--annotations": "value",
                    "--api-server-args": "value",
                    "--async": "bool",
                    "--binauthz-evaluation-mode": [
                      "DISABLED",
                      "PROJECT_SINGLETON_POLICY_ENFORCE"
                    ],
                    "--control-plane-load-balancer-port": "value",
                    "--control-plane-node-configs": "value",
                    "--control-plane-node-labels": "value",
                    "--control-plane-node-taints": "value",
                    "--control-plane-vip": "value",
                    "--description": "value",
                    "--enable-application-logs": "bool",
                    "--enable-manual-lb": "bool",
                    "--island-mode-pod-address-cidr-blocks": "value",
                    "--island-mode-service-address-cidr-blocks": "value",
                    "--location": "value",
                    "--login-user": "value",
                    "--lvp-node-mounts-config-path": "value",
                    "--lvp-node-mounts-config-storage-class": "value",
                    "--lvp-share-path": "value",
                    "--lvp-share-storage-class": "value",
                    "--maintenance-address-cidr-blocks": "value",
                    "--max-pods-per-node": "value",
                    "--no-proxy": "value",
                    "--shared-path-pv-count": "value",
                    "--uri": "value",
                    "--validate-only": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "enroll": {
                  "commands": {},
                  "flags": {
                    "--admin-cluster-membership": "value",
                    "--admin-cluster-membership-location": "value",
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "query-version-config": {
                  "commands": {},
                  "flags": {
                    "--admin-cluster": "value",
                    "--location": "value"
                  }
                },
                "unenroll": {
                  "commands": {},
                  "flags": {
                    "--allow-missing": "bool",
                    "--async": "bool",
                    "--ignore-errors": "bool",
                    "--location": "value",
                    "--validate-only": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--api-server-args": "value",
                    "--async": "bool",
                    "--binauthz-evaluation-mode": [
                      "DISABLED",
                      "PROJECT_SINGLETON_POLICY_ENFORCE"
                    ],
                    "--control-plane-node-configs": "value",
                    "--control-plane-node-labels": "value",
                    "--control-plane-node-taints": "value",
                    "--description": "value",
                    "--enable-application-logs": "bool",
                    "--island-mode-service-address-cidr-blocks": "value",
                    "--location": "value",
                    "--login-user": "value",
                    "--maintenance-address-cidr-blocks": "value",
                    "--max-pods-per-node": "value",
                    "--no-proxy": "value",
                    "--uri": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            },
            "clusters": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--admin-cluster-membership": "value",
                    "--admin-cluster-membership-location": "value",
                    "--admin-cluster-membership-project": "value",
                    "--admin-users": "value",
                    "--annotations": "value",
                    "--api-server-args": "value",
                    "--async": "bool",
                    "--bgp-address-pools": "value",
                    "--bgp-asn": "value",
                    "--bgp-load-balancer-node-configs": "value",
                    "--bgp-load-balancer-node-labels": "value",
                    "--bgp-load-balancer-node-taints": "value",
                    "--bgp-load-balancer-registry-burst": "value",
                    "--bgp-load-balancer-registry-pull-qps": "value",
                    "--bgp-peer-configs": "value",
                    "--binauthz-evaluation-mode": [
                      "DISABLED",
                      "PROJECT_SINGLETON_POLICY_ENFORCE"
                    ],
                    "--container-runtime": "value",
                    "--control-plane-load-balancer-port": "value",
                    "--control-plane-node-configs": "value",
                    "--control-plane-node-labels": "value",
                    "--control-plane-node-taints": "value",
                    "--control-plane-registry-burst": "value",
                    "--control-plane-registry-pull-qps": "value",
                    "--control-plane-vip": "value",
                    "--description": "value",
                    "--disable-bgp-load-balancer-serialize-image-pulls": "bool",
                    "--disable-control-plane-serialize-image-pulls": "bool",
                    "--disable-metal-lb-load-balancer-serialize-image-pulls": "bool",
                    "--enable-advanced-networking": "bool",
                    "--enable-application-logs": "bool",
                    "--enable-manual-lb": "bool",
                    "--enable-multi-nic-config": "bool",
                    "--enable-sr-iov-config": "bool",
                    "--ingress-vip": "value",
                    "--island-mode-pod-address-cidr-blocks": "value",
                    "--island-mode-service-address-cidr-blocks": "value",
                    "--location": "value",
                    "--login-user": "value",
                    "--lvp-node-mounts-config-path": "value",
                    "--lvp-node-mounts-config-storage-class": "value",
                    "--lvp-share-path": "value",
                    "--lvp-share-storage-class": "value",
                    "--maintenance-address-cidr-blocks": "value",
                    "--max-pods-per-node": "value",
                    "--metal-lb-address-pools": "value",
                    "--metal-lb-load-balancer-node-configs": "value",
                    "--metal-lb-load-balancer-node-labels": "value",
                    "--metal-lb-load-balancer-node-taints": "value",
                    "--metal-lb-load-balancer-registry-burst": "value",
                    "--metal-lb-load-balancer-registry-pull-qps": "value",
                    "--no-proxy": "value",
                    "--shared-path-pv-count": "value",
                    "--uri": "value",
                    "--validate-only": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--allow-missing": "bool",
                    "--async": "bool",
                    "--force": "bool",
                    "--ignore-errors": "bool",
                    "--location": "value",
                    "--validate-only": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "enroll": {
                  "commands": {},
                  "flags": {
                    "--admin-cluster-membership": "value",
                    "--admin-cluster-membership-location": "value",
                    "--admin-cluster-membership-project": "value",
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "query-version-config": {
                  "commands": {},
                  "flags": {
                    "--admin-cluster-membership": "value",
                    "--admin-cluster-membership-location": "value",
                    "--admin-cluster-membership-project": "value",
                    "--cluster": "value",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-annotations": "value",
                    "--admin-users": "value",
                    "--allow-missing": "bool",
                    "--api-server-args": "value",
                    "--async": "bool",
                    "--bgp-address-pools": "value",
                    "--bgp-asn": "value",
                    "--bgp-load-balancer-node-configs": "value",
                    "--bgp-load-balancer-node-labels": "value",
                    "--bgp-load-balancer-node-taints": "value",
                    "--bgp-load-balancer-registry-burst": "value",
                    "--bgp-load-balancer-registry-pull-qps": "value",
                    "--bgp-peer-configs": "value",
                    "--binauthz-evaluation-mode": [
                      "DISABLED",
                      "PROJECT_SINGLETON_POLICY_ENFORCE"
                    ],
                    "--control-plane-node-configs": "value",
                    "--control-plane-node-labels": "value",
                    "--control-plane-node-taints": "value",
                    "--control-plane-registry-burst": "value",
                    "--control-plane-registry-pull-qps": "value",
                    "--description": "value",
                    "--disable-bgp-load-balancer-serialize-image-pulls": "bool",
                    "--disable-control-plane-serialize-image-pulls": "bool",
                    "--disable-metal-lb-load-balancer-serialize-image-pulls": "bool",
                    "--disable-sr-iov-config": "bool",
                    "--enable-application-logs": "bool",
                    "--enable-bgp-load-balancer-serialize-image-pulls": "bool",
                    "--enable-control-plane-serialize-image-pulls": "bool",
                    "--enable-metal-lb-load-balancer-serialize-image-pulls": "bool",
                    "--enable-sr-iov-config": "bool",
                    "--island-mode-service-address-cidr-blocks": "value",
                    "--location": "value",
                    "--login-user": "value",
                    "--maintenance-address-cidr-blocks": "value",
                    "--metal-lb-address-pools": "value",
                    "--metal-lb-load-balancer-node-configs": "value",
                    "--metal-lb-load-balancer-node-labels": "value",
                    "--metal-lb-load-balancer-node-taints": "value",
                    "--metal-lb-load-balancer-registry-burst": "value",
                    "--metal-lb-load-balancer-registry-pull-qps": "value",
                    "--remove-annotations": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            },
            "node-pools": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--annotations": "value",
                    "--async": "bool",
                    "--cluster": "value",
                    "--disable-serialize-image-pulls": "bool",
                    "--display-name": "value",
                    "--location": "value",
                    "--node-configs": "value",
                    "--node-labels": "value",
                    "--node-taints": "value",
                    "--registry-burst": "value",
                    "--registry-pull-qps": "value",
                    "--validate-only": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--allow-missing": "bool",
                    "--async": "bool",
                    "--cluster": "value",
                    "--ignore-errors": "bool",
                    "--location": "value",
                    "--validate-only": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--location": "value"
                  }
                },
                "enroll": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster": "value",
                    "--location": "value",
                    "--validate-only": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--allow-missing": "bool",
                    "--async": "bool",
                    "--cluster": "value",
                    "--disable-serialize-image-pulls": "bool",
                    "--display-name": "value",
                    "--enable-serialize-image-pulls": "bool",
                    "--location": "value",
                    "--node-configs": "value",
                    "--node-labels": "value",
                    "--node-taints": "value",
                    "--registry-burst": "value",
                    "--registry-pull-qps": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "binauthz": {
          "commands": {
            "attestations": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--artifact-url": "value",
                    "--attestor": "value",
                    "--attestor-project": "value",
                    "--note": "value",
                    "--note-project": "value",
                    "--payload-file": "value",
                    "--public-key-id": "value",
                    "--signature-file": "value",
                    "--validate": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--artifact-url": "value",
                    "--attestor": "value",
                    "--attestor-project": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "attestors": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--attestation-authority-note": "value",
                    "--attestation-authority-note-project": "value",
                    "--description": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "public-keys": {
                  "commands": {
                    "add": {
                      "commands": {},
                      "flags": {
                        "--attestor": "value",
                        "--comment": "value",
                        "--keyversion": "value",
                        "--keyversion-key": "value",
                        "--keyversion-keyring": "value",
                        "--keyversion-location": "value",
                        "--keyversion-project": "value",
                        "--pgp-public-key-file": "value",
                        "--pkix-public-key-algorithm": [
                          "ec-sign-p256-sha256",
                          "ec-sign-p384-sha384",
                          "ec-sign-p521-sha512",
                          "ecdsa-p256-sha256",
                          "ecdsa-p384-sha384",
                          "ecdsa-p521-sha512",
                          "rsa-pss-2048-sha256",
                          "rsa-pss-3072-sha256",
                          "rsa-pss-4096-sha256",
                          "rsa-pss-4096-sha512",
                          "rsa-sign-pkcs1-2048-sha256",
                          "rsa-sign-pkcs1-3072-sha256",
                          "rsa-sign-pkcs1-4096-sha256",
                          "rsa-sign-pkcs1-4096-sha512",
                          "rsa-sign-pss-2048-sha256",
                          "rsa-sign-pss-3072-sha256",
                          "rsa-sign-pss-4096-sha256",
                          "rsa-sign-pss-4096-sha512"
                        ],
                        "--pkix-public-key-file": "value",
                        "--public-key-id-override": "value"
                      }
                    },
                    "remove": {
                      "commands": {},
                      "flags": {
                        "--attestor": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--attestor": "value",
                        "--comment": "value",
                        "--pgp-public-key-file": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--description": "value"
                  }
                }
              },
              "flags": {}
            },
            "create-signature-payload": {
              "commands": {},
              "flags": {
                "--artifact-url": "value"
              }
            },
            "policy": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--strict-validation": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "clusters": {
          "commands": {
            "check-autopilot-compatibility": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool",
                "--zone": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--accelerator": "value",
                "--additional-zones": "value",
                "--additive-vpc-scope-dns-domain": "value",
                "--addons": "value",
                "--aggregation-ca": "value",
                "--async": "bool",
                "--autoprovisioning-config-file": "value",
                "--autoprovisioning-enable-insecure-kubelet-readonly-port": "bool",
                "--autoprovisioning-image-type": "value",
                "--autoprovisioning-locations": "value",
                "--autoprovisioning-max-surge-upgrade": "value",
                "--autoprovisioning-max-unavailable-upgrade": "value",
                "--autoprovisioning-min-cpu-platform": "value",
                "--autoprovisioning-network-tags": "value",
                "--autoprovisioning-node-pool-soak-duration": "value",
                "--autoprovisioning-resource-manager-tags": "value",
                "--autoprovisioning-scopes": "value",
                "--autoprovisioning-service-account": "value",
                "--autoprovisioning-standard-rollout-policy": "value",
                "--autoscaling-profile": "value",
                "--binauthz-evaluation-mode": [
                  "disabled",
                  "project-singleton-policy-enforce"
                ],
                "--boot-disk-kms-key": "value",
                "--cloud-run-config": "value",
                "--cluster-ca": "value",
                "--cluster-dns": [
                  "clouddns",
                  "default",
                  "kubedns"
                ],
                "--cluster-dns-domain": "value",
                "--cluster-dns-scope": [
                  "cluster",
                  "vpc"
                ],
                "--cluster-ipv4-cidr": "value",
                "--cluster-secondary-range-name": "value",
                "--cluster-version": "value",
                "--containerd-config-from-file": "value",
                "--control-plane-disk-encryption-key": "value",
                "--create-subnetwork": "value",
                "--database-encryption-key": "value",
                "--dataplane-v2-observability-mode": [
                  "DISABLED",
                  "EXTERNAL_LB",
                  "INTERNAL_VPC_LB"
                ],
                "--default-max-pods-per-node": "value",
                "--disable-additive-vpc-scope": "bool",
                "--disable-dataplane-v2-flow-observability": "bool",
                "--disable-dataplane-v2-metrics": "bool",
                "--disable-default-snat": "bool",
                "--disable-l4-lb-firewall-reconciliation": "bool",
                "--disk-size": "value",
                "--disk-type": [
                  "hyperdisk-balanced",
                  "hyperdisk-extreme",
                  "hyperdisk-throughput",
                  "pd-balanced",
                  "pd-ssd",
                  "pd-standard"
                ],
                "--enable-authorized-networks-on-private-endpoint": "bool",
                "--enable-autoprovisioning": "bool",
                "--enable-autoprovisioning-autorepair": "bool",
                "--enable-autoprovisioning-autoupgrade": "bool",
                "--enable-autoprovisioning-blue-green-upgrade": "bool",
                "--enable-autoprovisioning-surge-upgrade": "bool",
                "--enable-autorepair": "bool",
                "--enable-autoscaling": "bool",
                "--enable-autoupgrade": "bool",
                "--enable-basic-auth": "bool",
                "--enable-binauthz": "bool",
                "--enable-cilium-clusterwide-network-policy": "bool",
                "--enable-cloud-logging": "bool",
                "--enable-cloud-monitoring": "bool",
                "--enable-cloud-run-alpha": "bool",
                "--enable-confidential-nodes": "bool",
                "--enable-confidential-storage": "bool",
                "--enable-cost-allocation": "bool",
                "--enable-dataplane-v2": "bool",
                "--enable-dataplane-v2-flow-observability": "bool",
                "--enable-dataplane-v2-metrics": "bool",
                "--enable-dns-access": "bool",
                "--enable-fleet": "bool",
                "--enable-fqdn-network-policy": "bool",
                "--enable-google-cloud-access": "bool",
                "--enable-gvnic": "bool",
                "--enable-identity-service": "bool",
                "--enable-image-streaming": "bool",
                "--enable-insecure-binding-system-authenticated": "bool",
                "--enable-insecure-binding-system-unauthenticated": "bool",
                "--enable-insecure-kubelet-readonly-port": "bool",
                "--enable-intra-node-visibility": "bool",
                "--enable-ip-access": "bool",
                "--enable-ip-alias": "bool",
                "--enable-kubernetes-alpha": "bool",
                "--enable-kubernetes-unstable-apis": "value",
                "--enable-l4-ilb-subsetting": "bool",
                "--enable-legacy-authorization": "bool",
                "--enable-managed-prometheus": "bool",
                "--enable-master-authorized-networks": "bool",
                "--enable-master-global-access": "bool",
                "--enable-multi-networking": "bool",
                "--enable-nested-virtualization": "bool",
                "--enable-network-egress-metering": "bool",
                "--enable-network-policy": "bool",
                "--enable-private-endpoint": "bool",
                "--enable-private-nodes": "bool",
                "--enable-ray-cluster-logging": "bool",
                "--enable-ray-cluster-monitoring": "bool",
                "--enable-resource-consumption-metering": "bool",
                "--enable-secret-manager": "bool",
                "--enable-service-externalips": "bool",
                "--enable-shielded-nodes": "bool",
                "--enable-stackdriver-kubernetes": "bool",
                "--enable-tpu": "bool",
                "--enable-vertical-pod-autoscaling": "bool",
                "--ephemeral-storage-local-ssd": "value",
                "--etcd-api-ca": "value",
                "--etcd-peer-ca": "value",
                "--fleet-project": "value",
                "--gateway-api": [
                  "disabled",
                  "standard"
                ],
                "--gkeops-etcd-backup-encryption-key": "value",
                "--image-type": "value",
                "--in-transit-encryption": [
                  "inter-node-transparent",
                  "none"
                ],
                "--ipv6-access-type": [
                  "external",
                  "internal"
                ],
                "--issue-client-certificate": "bool",
                "--labels": "value",
                "--local-nvme-ssd-block": "value",
                "--local-ssd-count": "value",
                "--location": "value",
                "--location-policy": [
                  "ANY",
                  "BALANCED"
                ],
                "--logging": "value",
                "--logging-variant": [
                  "DEFAULT",
                  "MAX_THROUGHPUT"
                ],
                "--machine-type": "value",
                "--maintenance-window": "value",
                "--maintenance-window-end": "value",
                "--maintenance-window-recurrence": "value",
                "--maintenance-window-start": "value",
                "--master-authorized-networks": "value",
                "--master-ipv4-cidr": "value",
                "--max-accelerator": "value",
                "--max-cpu": "value",
                "--max-memory": "value",
                "--max-nodes": "value",
                "--max-nodes-per-pool": "value",
                "--max-pods-per-node": "value",
                "--max-surge-upgrade": "value",
                "--max-unavailable-upgrade": "value",
                "--metadata": "value",
                "--metadata-from-file": "value",
                "--min-accelerator": "value",
                "--min-cpu": "value",
                "--min-cpu-platform": "value",
                "--min-memory": "value",
                "--min-nodes": "value",
                "--monitoring": "value",
                "--network": "value",
                "--network-performance-configs": "value",
                "--node-labels": "value",
                "--node-locations": "value",
                "--node-taints": "value",
                "--node-version": "value",
                "--notification-config": "value",
                "--num-nodes": "value",
                "--password": "value",
                "--placement-policy": "value",
                "--placement-type": [
                  "COMPACT",
                  "UNSPECIFIED"
                ],
                "--preemptible": "bool",
                "--private-endpoint-subnetwork": "value",
                "--private-ipv6-google-access-type": [
                  "bidirectional",
                  "disabled",
                  "outbound-only"
                ],
                "--region": "value",
                "--release-channel": "value",
                "--reservation": "value",
                "--reservation-affinity": [
                  "any",
                  "none",
                  "specific"
                ],
                "--resource-manager-tags": "value",
                "--resource-usage-bigquery-dataset": "value",
                "--scopes": "value",
                "--security-group": "value",
                "--security-posture": [
                  "disabled",
                  "enterprise",
                  "standard"
                ],
                "--service-account": "value",
                "--service-account-signing-keys": "value",
                "--service-account-verification-keys": "value",
                "--services-ipv4-cidr": "value",
                "--services-secondary-range-name": "value",
                "--shielded-integrity-monitoring": "bool",
                "--shielded-secure-boot": "bool",
                "--spot": "bool",
                "--stack-type": [
                  "ipv4",
                  "ipv4-ipv6"
                ],
                "--storage-pools": "value",
                "--subnetwork": "value",
                "--system-config-from-file": "value",
                "--tags": "value",
                "--threads-per-core": "value",
                "--tier": [
                  "enterprise",
                  "standard"
                ],
                "--total-max-nodes": "value",
                "--total-min-nodes": "value",
                "--tpu-ipv4-cidr": "value",
                "--username": "value",
                "--workload-metadata": [
                  "GCE_METADATA",
                  "GKE_METADATA"
                ],
                "--workload-pool": "value",
                "--workload-vulnerability-scanning": [
                  "disabled",
                  "enterprise",
                  "standard"
                ],
                "--zone": "value"
              }
            },
            "create-auto": {
              "commands": {},
              "flags": {
                "--additive-vpc-scope-dns-domain": "value",
                "--aggregation-ca": "value",
                "--async": "bool",
                "--autoprovisioning-enable-insecure-kubelet-readonly-port": "bool",
                "--autoprovisioning-network-tags": "value",
                "--autoprovisioning-resource-manager-tags": "value",
                "--binauthz-evaluation-mode": [
                  "disabled",
                  "project-singleton-policy-enforce"
                ],
                "--boot-disk-kms-key": "value",
                "--cluster-ca": "value",
                "--cluster-ipv4-cidr": "value",
                "--cluster-secondary-range-name": "value",
                "--cluster-version": "value",
                "--containerd-config-from-file": "value",
                "--control-plane-disk-encryption-key": "value",
                "--create-subnetwork": "value",
                "--database-encryption-key": "value",
                "--dataplane-v2-observability-mode": [
                  "DISABLED",
                  "EXTERNAL_LB",
                  "INTERNAL_VPC_LB"
                ],
                "--disable-additive-vpc-scope": "bool",
                "--disable-dataplane-v2-flow-observability": "bool",
                "--disable-l4-lb-firewall-reconciliation": "bool",
                "--enable-authorized-networks-on-private-endpoint": "bool",
                "--enable-backup-restore": "bool",
                "--enable-cilium-clusterwide-network-policy": "bool",
                "--enable-dataplane-v2-flow-observability": "bool",
                "--enable-dns-access": "bool",
                "--enable-fleet": "bool",
                "--enable-google-cloud-access": "bool",
                "--enable-insecure-binding-system-authenticated": "bool",
                "--enable-insecure-binding-system-unauthenticated": "bool",
                "--enable-ip-access": "bool",
                "--enable-kubernetes-unstable-apis": "value",
                "--enable-master-authorized-networks": "bool",
                "--enable-master-global-access": "bool",
                "--enable-multi-networking": "bool",
                "--enable-private-endpoint": "bool",
                "--enable-private-nodes": "bool",
                "--enable-ray-cluster-logging": "bool",
                "--enable-ray-cluster-monitoring": "bool",
                "--enable-ray-operator": "bool",
                "--enable-secret-manager": "bool",
                "--etcd-api-ca": "value",
                "--etcd-peer-ca": "value",
                "--fleet-project": "value",
                "--gkeops-etcd-backup-encryption-key": "value",
                "--labels": "value",
                "--location": "value",
                "--logging": "value",
                "--master-authorized-networks": "value",
                "--master-ipv4-cidr": "value",
                "--monitoring": "value",
                "--network": "value",
                "--private-endpoint-subnetwork": "value",
                "--region": "value",
                "--release-channel": "value",
                "--scopes": "value",
                "--security-group": "value",
                "--security-posture": [
                  "disabled",
                  "enterprise",
                  "standard"
                ],
                "--service-account": "value",
                "--service-account-signing-keys": "value",
                "--service-account-verification-keys": "value",
                "--services-ipv4-cidr": "value",
                "--services-secondary-range-name": "value",
                "--subnetwork": "value",
                "--tier": [
                  "enterprise",
                  "standard"
                ],
                "--workload-policies": "value",
                "--workload-vulnerability-scanning": [
                  "disabled",
                  "enterprise",
                  "standard"
                ],
                "--zone": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--region": "value",
                "--zone": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--region": "value",
                "--zone": "value"
              }
            },
            "get-credentials": {
              "commands": {},
              "flags": {
                "--dns-endpoint": "bool",
                "--internal-ip": "bool",
                "--location": "value",
                "--region": "value",
                "--zone": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool",
                "--zone": "value"
              }
            },
            "resize": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--node-pool": "value",
                "--num-nodes": "value",
                "--region": "value",
                "--size": "value",
                "--zone": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-maintenance-exclusion-end": "value",
                "--add-maintenance-exclusion-name": "value",
                "--add-maintenance-exclusion-scope": "value",
                "--add-maintenance-exclusion-start": "value",
                "--additional-pod-ipv4-ranges": "value",
                "--additive-vpc-scope-dns-domain": "value",
                "--async": "bool",
                "--autoprovisioning-cgroup-mode": [
                  "default",
                  "v1",
                  "v2"
                ],
                "--autoprovisioning-config-file": "value",
                "--autoprovisioning-enable-insecure-kubelet-readonly-port": "bool",
                "--autoprovisioning-image-type": "value",
                "--autoprovisioning-locations": "value",
                "--autoprovisioning-max-surge-upgrade": "value",
                "--autoprovisioning-max-unavailable-upgrade": "value",
                "--autoprovisioning-min-cpu-platform": "value",
                "--autoprovisioning-network-tags": "value",
                "--autoprovisioning-node-pool-soak-duration": "value",
                "--autoprovisioning-resource-manager-tags": "value",
                "--autoprovisioning-scopes": "value",
                "--autoprovisioning-service-account": "value",
                "--autoprovisioning-standard-rollout-policy": "value",
                "--autoscaling-profile": "value",
                "--binauthz-evaluation-mode": [
                  "disabled",
                  "project-singleton-policy-enforce"
                ],
                "--clear-fleet-project": "bool",
                "--clear-maintenance-window": "bool",
                "--clear-resource-usage-bigquery-dataset": "bool",
                "--cloud-run-config": "value",
                "--cluster-dns": [
                  "clouddns",
                  "default",
                  "kubedns"
                ],
                "--cluster-dns-domain": "value",
                "--cluster-dns-scope": [
                  "cluster",
                  "vpc"
                ],
                "--complete-credential-rotation": "bool",
                "--complete-ip-rotation": "bool",
                "--containerd-config-from-file": "value",
                "--database-encryption-key": "value",
                "--dataplane-v2-observability-mode": [
                  "DISABLED",
                  "EXTERNAL_LB",
                  "INTERNAL_VPC_LB"
                ],
                "--disable-additive-vpc-scope": "bool",
                "--disable-database-encryption": "bool",
                "--disable-dataplane-v2-flow-observability": "bool",
                "--disable-dataplane-v2-metrics": "bool",
                "--disable-default-snat": "bool",
                "--disable-l4-lb-firewall-reconciliation": "bool",
                "--disable-managed-prometheus": "bool",
                "--disable-workload-identity": "bool",
                "--enable-authorized-networks-on-private-endpoint": "bool",
                "--enable-autoprovisioning": "bool",
                "--enable-autoprovisioning-autorepair": "bool",
                "--enable-autoprovisioning-autoupgrade": "bool",
                "--enable-autoprovisioning-blue-green-upgrade": "bool",
                "--enable-autoprovisioning-surge-upgrade": "bool",
                "--enable-autoscaling": "bool",
                "--enable-basic-auth": "bool",
                "--enable-binauthz": "bool",
                "--enable-cilium-clusterwide-network-policy": "bool",
                "--enable-cost-allocation": "bool",
                "--enable-dataplane-v2-flow-observability": "bool",
                "--enable-dataplane-v2-metrics": "bool",
                "--enable-dns-access": "bool",
                "--enable-fleet": "bool",
                "--enable-fqdn-network-policy": "bool",
                "--enable-google-cloud-access": "bool",
                "--enable-identity-service": "bool",
                "--enable-image-streaming": "bool",
                "--enable-insecure-binding-system-authenticated": "bool",
                "--enable-insecure-binding-system-unauthenticated": "bool",
                "--enable-insecure-kubelet-readonly-port": "bool",
                "--enable-intra-node-visibility": "bool",
                "--enable-ip-access": "bool",
                "--enable-kubernetes-unstable-apis": "value",
                "--enable-l4-ilb-subsetting": "bool",
                "--enable-l4-lb-firewall-reconciliation": "bool",
                "--enable-legacy-authorization": "bool",
                "--enable-managed-prometheus": "bool",
                "--enable-master-authorized-networks": "bool",
                "--enable-master-global-access": "bool",
                "--enable-multi-networking": "bool",
                "--enable-network-egress-metering": "bool",
                "--enable-network-policy": "bool",
                "--enable-private-endpoint": "bool",
                "--enable-private-nodes": "bool",
                "--enable-ray-cluster-logging": "bool",
                "--enable-ray-cluster-monitoring": "bool",
                "--enable-resource-consumption-metering": "bool",
                "--enable-secret-manager": "bool",
                "--enable-service-externalips": "bool",
                "--enable-shielded-nodes": "bool",
                "--enable-stackdriver-kubernetes": "bool",
                "--enable-vertical-pod-autoscaling": "bool",
                "--fleet-project": "value",
                "--gateway-api": [
                  "disabled",
                  "standard"
                ],
                "--generate-password": "bool",
                "--in-transit-encryption": [
                  "inter-node-transparent",
                  "none"
                ],
                "--location": "value",
                "--location-policy": [
                  "ANY",
                  "BALANCED"
                ],
                "--logging": "value",
                "--logging-service": "value",
                "--logging-variant": [
                  "DEFAULT",
                  "MAX_THROUGHPUT"
                ],
                "--maintenance-window": "value",
                "--maintenance-window-end": "value",
                "--maintenance-window-recurrence": "value",
                "--maintenance-window-start": "value",
                "--master-authorized-networks": "value",
                "--max-accelerator": "value",
                "--max-cpu": "value",
                "--max-memory": "value",
                "--max-nodes": "value",
                "--min-accelerator": "value",
                "--min-cpu": "value",
                "--min-memory": "value",
                "--min-nodes": "value",
                "--monitoring": "value",
                "--monitoring-service": "value",
                "--network-performance-configs": "value",
                "--node-locations": "value",
                "--node-pool": "value",
                "--notification-config": "value",
                "--password": "value",
                "--private-ipv6-google-access-type": [
                  "bidirectional",
                  "disabled",
                  "outbound-only"
                ],
                "--region": "value",
                "--release-channel": "value",
                "--remove-additional-pod-ipv4-ranges": "value",
                "--remove-labels": "value",
                "--remove-maintenance-exclusion": "value",
                "--remove-workload-policies": "value",
                "--resource-usage-bigquery-dataset": "value",
                "--security-group": "value",
                "--security-posture": [
                  "disabled",
                  "enterprise",
                  "standard"
                ],
                "--set-password": "bool",
                "--stack-type": [
                  "ipv4",
                  "ipv4-ipv6"
                ],
                "--start-credential-rotation": "bool",
                "--start-ip-rotation": "bool",
                "--tier": [
                  "enterprise",
                  "standard"
                ],
                "--total-max-nodes": "value",
                "--total-min-nodes": "value",
                "--update-addons": "value",
                "--update-labels": "value",
                "--username": "value",
                "--workload-policies": "value",
                "--workload-pool": "value",
                "--workload-vulnerability-scanning": [
                  "disabled",
                  "enterprise",
                  "standard"
                ],
                "--zone": "value"
              }
            },
            "upgrade": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--cluster-version": "value",
                "--image-type": "value",
                "--location": "value",
                "--master": "bool",
                "--node-pool": "value",
                "--region": "value",
                "--zone": "value"
              }
            }
          },
          "flags": {
            "--location": "value",
            "--region": "value",
            "--zone": "value"
          }
        },
        "fleet": {
          "commands": {
            "cloudrun": {
              "commands": {
                "apply": {
                  "commands": {},
                  "flags": {
                    "--config": "value",
                    "--context": "value",
                    "--gke-cluster": "value",
                    "--gke-uri": "value",
                    "--kubeconfig": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "disable": {
                  "commands": {},
                  "flags": {
                    "--force": "bool"
                  }
                },
                "enable": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "clusterupgrade": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--add-upgrade-soaking-override": "value",
                    "--default-upgrade-soaking": "value",
                    "--upgrade-selector": "value",
                    "--upstream-fleet": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--show-linked-cluster-upgrade": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-upgrade-soaking-override": "value",
                    "--default-upgrade-soaking": "value",
                    "--remove-upgrade-soaking-overrides": "bool",
                    "--reset-upstream-fleet": "bool",
                    "--upgrade-selector": "value",
                    "--upstream-fleet": "value"
                  }
                }
              },
              "flags": {}
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--binauthz-evaluation-mode": [
                  "disabled",
                  "policy-bindings"
                ],
                "--binauthz-policy-bindings": "value",
                "--display-name": "value",
                "--labels": "value",
                "--security-posture": [
                  "disabled",
                  "enterprise",
                  "standard"
                ],
                "--workload-vulnerability-scanning": [
                  "disabled",
                  "enterprise",
                  "standard"
                ]
              }
            },
            "dataplane-v2-encryption": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "disable": {
                  "commands": {},
                  "flags": {
                    "--force": "bool"
                  }
                },
                "enable": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "features": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "fleetobservability": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "disable": {
                  "commands": {},
                  "flags": {
                    "--force": "bool"
                  }
                },
                "enable": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--logging-config": "value"
                  }
                }
              },
              "flags": {}
            },
            "identity-service": {
              "commands": {
                "apply": {
                  "commands": {},
                  "flags": {
                    "--config": "value",
                    "--fleet-default-member-config": "value",
                    "--location": "value",
                    "--membership": "value",
                    "--origin": [
                      "fleet"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--fleet-default-member-config": "bool",
                    "--location": "value",
                    "--membership": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "disable": {
                  "commands": {},
                  "flags": {
                    "--force": "bool"
                  }
                },
                "enable": {
                  "commands": {},
                  "flags": {
                    "--fleet-default-member-config": "value"
                  }
                }
              },
              "flags": {}
            },
            "ingress": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "disable": {
                  "commands": {},
                  "flags": {
                    "--force": "bool"
                  }
                },
                "enable": {
                  "commands": {},
                  "flags": {
                    "--config-membership": "value",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--config-membership": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "memberships": {
              "commands": {
                "bindings": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--labels": "value",
                        "--location": "value",
                        "--membership": "value",
                        "--scope": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--membership": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--membership": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--membership": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--clear-labels": "bool",
                        "--location": "value",
                        "--membership": "value",
                        "--remove-labels": "value",
                        "--scope": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "generate-gateway-rbac": {
                  "commands": {},
                  "flags": {
                    "--anthos-support": "bool",
                    "--apply": "bool",
                    "--context": "value",
                    "--groups": "value",
                    "--kubeconfig": "value",
                    "--membership": "value",
                    "--rbac-output-file": "value",
                    "--revoke": "bool",
                    "--role": "value",
                    "--users": "value"
                  }
                },
                "get-credentials": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "register": {
                  "commands": {},
                  "flags": {
                    "--context": "value",
                    "--enable-workload-identity": "bool",
                    "--gke-cluster": "value",
                    "--gke-uri": "value",
                    "--has-private-issuer": "bool",
                    "--install-connect-agent": "bool",
                    "--internal-ip": "bool",
                    "--kubeconfig": "value",
                    "--location": "value",
                    "--manifest-output-file": "value",
                    "--proxy": "value",
                    "--public-issuer-url": "value",
                    "--service-account-key-file": "value"
                  }
                },
                "support-access": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "get-yaml": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--rbac-output-file": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "unregister": {
                  "commands": {},
                  "flags": {
                    "--context": "value",
                    "--gke-cluster": "value",
                    "--gke-uri": "value",
                    "--kubeconfig": "value",
                    "--location": "value",
                    "--uninstall-connect-agent": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--location": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "mesh": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "disable": {
                  "commands": {},
                  "flags": {
                    "--fleet-default-member-config": "bool",
                    "--force": "bool"
                  }
                },
                "enable": {
                  "commands": {},
                  "flags": {
                    "--fleet-default-member-config": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--control-plane": [
                      "automatic",
                      "manual",
                      "unspecified"
                    ],
                    "--fleet-default-member-config": "value",
                    "--location": "value",
                    "--management": [
                      "automatic",
                      "manual"
                    ],
                    "--memberships": "value",
                    "--origin": [
                      "fleet"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "multi-cluster-services": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "disable": {
                  "commands": {},
                  "flags": {
                    "--force": "bool"
                  }
                },
                "enable": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "policycontroller": {
              "commands": {
                "content": {
                  "commands": {
                    "bundles": {
                      "commands": {
                        "remove": {
                          "commands": {},
                          "flags": {
                            "--all-memberships": "bool",
                            "--location": "value",
                            "--memberships": "value"
                          }
                        },
                        "set": {
                          "commands": {},
                          "flags": {
                            "--all-memberships": "bool",
                            "--exempted-namespaces": "value",
                            "--location": "value",
                            "--memberships": "value",
                            "--no-exempted-namespaces": "bool"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "templates": {
                      "commands": {
                        "disable": {
                          "commands": {},
                          "flags": {
                            "--all-memberships": "bool",
                            "--location": "value",
                            "--memberships": "value"
                          }
                        },
                        "enable": {
                          "commands": {},
                          "flags": {
                            "--all-memberships": "bool",
                            "--location": "value",
                            "--memberships": "value"
                          }
                        }
                      },
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "deployment": {
                  "commands": {
                    "remove": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--effect": [
                          "NoExecute",
                          "NoSchedule",
                          "PreferNoSchedule"
                        ],
                        "--location": "value",
                        "--memberships": "value"
                      }
                    },
                    "set": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--effect": [
                          "NoExecute",
                          "NoSchedule",
                          "PreferNoSchedule"
                        ],
                        "--location": "value",
                        "--memberships": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--all-memberships": "bool",
                    "--location": "value",
                    "--memberships": "value"
                  }
                },
                "detach": {
                  "commands": {},
                  "flags": {
                    "--all-memberships": "bool",
                    "--location": "value",
                    "--memberships": "value"
                  }
                },
                "disable": {
                  "commands": {},
                  "flags": {
                    "--all-memberships": "bool",
                    "--fleet-default-member-config": "bool",
                    "--location": "value",
                    "--memberships": "value"
                  }
                },
                "enable": {
                  "commands": {},
                  "flags": {
                    "--all-memberships": "bool",
                    "--audit-interval": "value",
                    "--clear-exemptable-namespaces": "bool",
                    "--constraint-violation-limit": "value",
                    "--exemptable-namespaces": "value",
                    "--fleet-default-member-config": "value",
                    "--location": "value",
                    "--log-denies": "bool",
                    "--memberships": "value",
                    "--monitoring": "value",
                    "--mutation": "bool",
                    "--no-content": "bool",
                    "--no-default-bundles": "bool",
                    "--no-fleet-default-member-config": "bool",
                    "--no-log-denies": "bool",
                    "--no-monitoring": "bool",
                    "--no-mutation": "bool",
                    "--no-referential-rules": "bool",
                    "--referential-rules": "bool"
                  }
                },
                "suspend": {
                  "commands": {},
                  "flags": {
                    "--all-memberships": "bool",
                    "--location": "value",
                    "--memberships": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--all-memberships": "bool",
                    "--audit-interval": "value",
                    "--clear-exemptable-namespaces": "bool",
                    "--constraint-violation-limit": "value",
                    "--exemptable-namespaces": "value",
                    "--location": "value",
                    "--log-denies": "bool",
                    "--memberships": "value",
                    "--monitoring": "value",
                    "--mutation": "bool",
                    "--no-log-denies": "bool",
                    "--no-monitoring": "bool",
                    "--no-mutation": "bool",
                    "--no-referential-rules": "bool",
                    "--origin": [
                      "FLEET"
                    ],
                    "--referential-rules": "bool"
                  }
                }
              },
              "flags": {}
            },
            "scopes": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--labels": "value",
                    "--namespace-labels": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-memberships": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "namespaces": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--labels": "value",
                        "--namespace-labels": "value",
                        "--scope": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--scope": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--scope": "value"
                      }
                    },
                    "get-credentials": {
                      "commands": {},
                      "flags": {
                        "--membership": "value",
                        "--membership-location": "value",
                        "--set-namespace-in-config": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--scope": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--clear-labels": "bool",
                        "--clear-namespace-labels": "bool",
                        "--remove-labels": "value",
                        "--remove-namespace-labels": "value",
                        "--scope": "value",
                        "--update-labels": "value",
                        "--update-namespace-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "rbacrolebindings": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--group": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--role": [
                          "admin",
                          "edit",
                          "view"
                        ],
                        "--scope": "value",
                        "--user": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--scope": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--scope": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--scope": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--clear-labels": "bool",
                        "--group": "value",
                        "--location": "value",
                        "--remove-labels": "value",
                        "--role": [
                          "admin",
                          "edit",
                          "view"
                        ],
                        "--scope": "value",
                        "--update-labels": "value",
                        "--user": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-upgrade-soaking-override": "value",
                    "--clear-labels": "bool",
                    "--clear-namespace-labels": "bool",
                    "--default-upgrade-soaking": "value",
                    "--location": "value",
                    "--remove-labels": "value",
                    "--remove-namespace-labels": "value",
                    "--remove-upgrade-soaking-overrides": "bool",
                    "--reset-upstream-scope": "bool",
                    "--update-labels": "value",
                    "--update-namespace-labels": "value",
                    "--upgrade-selector": "value",
                    "--upstream-scope": "value"
                  }
                }
              },
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--binauthz-evaluation-mode": [
                  "disabled",
                  "policy-bindings"
                ],
                "--binauthz-policy-bindings": "value",
                "--clear-labels": "bool",
                "--display-name": "value",
                "--remove-labels": "value",
                "--security-posture": [
                  "disabled",
                  "enterprise",
                  "standard"
                ],
                "--update-labels": "value",
                "--workload-vulnerability-scanning": [
                  "disabled",
                  "enterprise",
                  "standard"
                ]
              }
            }
          },
          "flags": {}
        },
        "get-server-config": {
          "commands": {},
          "flags": {
            "--filter": "value",
            "--limit": "value",
            "--location": "value",
            "--region": "value",
            "--sort-by": "value",
            "--zone": "value"
          }
        },
        "hub": {
          "commands": {
            "cloudrun": {
              "commands": {
                "apply": {
                  "commands": {},
                  "flags": {
                    "--config": "value",
                    "--context": "value",
                    "--gke-cluster": "value",
                    "--gke-uri": "value",
                    "--kubeconfig": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "disable": {
                  "commands": {},
                  "flags": {
                    "--force": "bool"
                  }
                },
                "enable": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "clusterupgrade": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--add-upgrade-soaking-override": "value",
                    "--default-upgrade-soaking": "value",
                    "--upgrade-selector": "value",
                    "--upstream-fleet": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--show-linked-cluster-upgrade": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-upgrade-soaking-override": "value",
                    "--default-upgrade-soaking": "value",
                    "--remove-upgrade-soaking-overrides": "bool",
                    "--reset-upstream-fleet": "bool",
                    "--upgrade-selector": "value",
                    "--upstream-fleet": "value"
                  }
                }
              },
              "flags": {}
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--binauthz-evaluation-mode": [
                  "disabled",
                  "policy-bindings"
                ],
                "--binauthz-policy-bindings": "value",
                "--display-name": "value",
                "--labels": "value",
                "--security-posture": [
                  "disabled",
                  "enterprise",
                  "standard"
                ],
                "--workload-vulnerability-scanning": [
                  "disabled",
                  "enterprise",
                  "standard"
                ]
              }
            },
            "dataplane-v2-encryption": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "disable": {
                  "commands": {},
                  "flags": {
                    "--force": "bool"
                  }
                },
                "enable": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "features": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "fleetobservability": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "disable": {
                  "commands": {},
                  "flags": {
                    "--force": "bool"
                  }
                },
                "enable": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--logging-config": "value"
                  }
                }
              },
              "flags": {}
            },
            "identity-service": {
              "commands": {
                "apply": {
                  "commands": {},
                  "flags": {
                    "--config": "value",
                    "--fleet-default-member-config": "value",
                    "--location": "value",
                    "--membership": "value",
                    "--origin": [
                      "fleet"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--fleet-default-member-config": "bool",
                    "--location": "value",
                    "--membership": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "disable": {
                  "commands": {},
                  "flags": {
                    "--force": "bool"
                  }
                },
                "enable": {
                  "commands": {},
                  "flags": {
                    "--fleet-default-member-config": "value"
                  }
                }
              },
              "flags": {}
            },
            "ingress": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "disable": {
                  "commands": {},
                  "flags": {
                    "--force": "bool"
                  }
                },
                "enable": {
                  "commands": {},
                  "flags": {
                    "--config-membership": "value",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--config-membership": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "memberships": {
              "commands": {
                "bindings": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--labels": "value",
                        "--location": "value",
                        "--membership": "value",
                        "--scope": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--membership": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--membership": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--membership": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--clear-labels": "bool",
                        "--location": "value",
                        "--membership": "value",
                        "--remove-labels": "value",
                        "--scope": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "generate-gateway-rbac": {
                  "commands": {},
                  "flags": {
                    "--anthos-support": "bool",
                    "--apply": "bool",
                    "--context": "value",
                    "--groups": "value",
                    "--kubeconfig": "value",
                    "--membership": "value",
                    "--rbac-output-file": "value",
                    "--revoke": "bool",
                    "--role": "value",
                    "--users": "value"
                  }
                },
                "get-credentials": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "register": {
                  "commands": {},
                  "flags": {
                    "--context": "value",
                    "--enable-workload-identity": "bool",
                    "--gke-cluster": "value",
                    "--gke-uri": "value",
                    "--has-private-issuer": "bool",
                    "--install-connect-agent": "bool",
                    "--internal-ip": "bool",
                    "--kubeconfig": "value",
                    "--location": "value",
                    "--manifest-output-file": "value",
                    "--proxy": "value",
                    "--public-issuer-url": "value",
                    "--service-account-key-file": "value"
                  }
                },
                "support-access": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "disable": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "enable": {
                      "commands": {},
                      "flags": {
                        "--location": "value"
                      }
                    },
                    "get-yaml": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--rbac-output-file": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "unregister": {
                  "commands": {},
                  "flags": {
                    "--context": "value",
                    "--gke-cluster": "value",
                    "--gke-uri": "value",
                    "--kubeconfig": "value",
                    "--location": "value",
                    "--uninstall-connect-agent": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--location": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "mesh": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "disable": {
                  "commands": {},
                  "flags": {
                    "--fleet-default-member-config": "bool",
                    "--force": "bool"
                  }
                },
                "enable": {
                  "commands": {},
                  "flags": {
                    "--fleet-default-member-config": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--control-plane": [
                      "automatic",
                      "manual",
                      "unspecified"
                    ],
                    "--fleet-default-member-config": "value",
                    "--location": "value",
                    "--management": [
                      "automatic",
                      "manual"
                    ],
                    "--memberships": "value",
                    "--origin": [
                      "fleet"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "multi-cluster-services": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "disable": {
                  "commands": {},
                  "flags": {
                    "--force": "bool"
                  }
                },
                "enable": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "policycontroller": {
              "commands": {
                "content": {
                  "commands": {
                    "bundles": {
                      "commands": {
                        "remove": {
                          "commands": {},
                          "flags": {
                            "--all-memberships": "bool",
                            "--location": "value",
                            "--memberships": "value"
                          }
                        },
                        "set": {
                          "commands": {},
                          "flags": {
                            "--all-memberships": "bool",
                            "--exempted-namespaces": "value",
                            "--location": "value",
                            "--memberships": "value",
                            "--no-exempted-namespaces": "bool"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "templates": {
                      "commands": {
                        "disable": {
                          "commands": {},
                          "flags": {
                            "--all-memberships": "bool",
                            "--location": "value",
                            "--memberships": "value"
                          }
                        },
                        "enable": {
                          "commands": {},
                          "flags": {
                            "--all-memberships": "bool",
                            "--location": "value",
                            "--memberships": "value"
                          }
                        }
                      },
                      "flags": {}
                    }
                  },
                  "flags": {}
                },
                "deployment": {
                  "commands": {
                    "remove": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--effect": [
                          "NoExecute",
                          "NoSchedule",
                          "PreferNoSchedule"
                        ],
                        "--location": "value",
                        "--memberships": "value"
                      }
                    },
                    "set": {
                      "commands": {},
                      "flags": {
                        "--all-memberships": "bool",
                        "--effect": [
                          "NoExecute",
                          "NoSchedule",
                          "PreferNoSchedule"
                        ],
                        "--location": "value",
                        "--memberships": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--all-memberships": "bool",
                    "--location": "value",
                    "--memberships": "value"
                  }
                },
                "detach": {
                  "commands": {},
                  "flags": {
                    "--all-memberships": "bool",
                    "--location": "value",
                    "--memberships": "value"
                  }
                },
                "disable": {
                  "commands": {},
                  "flags": {
                    "--all-memberships": "bool",
                    "--fleet-default-member-config": "bool",
                    "--location": "value",
                    "--memberships": "value"
                  }
                },
                "enable": {
                  "commands": {},
                  "flags": {
                    "--all-memberships": "bool",
                    "--audit-interval": "value",
                    "--clear-exemptable-namespaces": "bool",
                    "--constraint-violation-limit": "value",
                    "--exemptable-namespaces": "value",
                    "--fleet-default-member-config": "value",
                    "--location": "value",
                    "--log-denies": "bool",
                    "--memberships": "value",
                    "--monitoring": "value",
                    "--mutation": "bool",
                    "--no-content": "bool",
                    "--no-default-bundles": "bool",
                    "--no-fleet-default-member-config": "bool",
                    "--no-log-denies": "bool",
                    "--no-monitoring": "bool",
                    "--no-mutation": "bool",
                    "--no-referential-rules": "bool",
                    "--referential-rules": "bool"
                  }
                },
                "suspend": {
                  "commands": {},
                  "flags": {
                    "--all-memberships": "bool",
                    "--location": "value",
                    "--memberships": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--all-memberships": "bool",
                    "--audit-interval": "value",
                    "--clear-exemptable-namespaces": "bool",
                    "--constraint-violation-limit": "value",
                    "--exemptable-namespaces": "value",
                    "--location": "value",
                    "--log-denies": "bool",
                    "--memberships": "value",
                    "--monitoring": "value",
                    "--mutation": "bool",
                    "--no-log-denies": "bool",
                    "--no-monitoring": "bool",
                    "--no-mutation": "bool",
                    "--no-referential-rules": "bool",
                    "--origin": [
                      "FLEET"
                    ],
                    "--referential-rules": "bool"
                  }
                }
              },
              "flags": {}
            },
            "scopes": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--labels": "value",
                    "--namespace-labels": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-memberships": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "namespaces": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--labels": "value",
                        "--namespace-labels": "value",
                        "--scope": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--scope": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--scope": "value"
                      }
                    },
                    "get-credentials": {
                      "commands": {},
                      "flags": {
                        "--membership": "value",
                        "--membership-location": "value",
                        "--set-namespace-in-config": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--scope": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--clear-labels": "bool",
                        "--clear-namespace-labels": "bool",
                        "--remove-labels": "value",
                        "--remove-namespace-labels": "value",
                        "--scope": "value",
                        "--update-labels": "value",
                        "--update-namespace-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "rbacrolebindings": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--group": "value",
                        "--labels": "value",
                        "--location": "value",
                        "--role": [
                          "admin",
                          "edit",
                          "view"
                        ],
                        "--scope": "value",
                        "--user": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--scope": "value"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--scope": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--scope": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--clear-labels": "bool",
                        "--group": "value",
                        "--location": "value",
                        "--remove-labels": "value",
                        "--role": [
                          "admin",
                          "edit",
                          "view"
                        ],
                        "--scope": "value",
                        "--update-labels": "value",
                        "--user": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-upgrade-soaking-override": "value",
                    "--clear-labels": "bool",
                    "--clear-namespace-labels": "bool",
                    "--default-upgrade-soaking": "value",
                    "--location": "value",
                    "--remove-labels": "value",
                    "--remove-namespace-labels": "value",
                    "--remove-upgrade-soaking-overrides": "bool",
                    "--reset-upstream-scope": "bool",
                    "--update-labels": "value",
                    "--update-namespace-labels": "value",
                    "--upgrade-selector": "value",
                    "--upstream-scope": "value"
                  }
                }
              },
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--binauthz-evaluation-mode": [
                  "disabled",
                  "policy-bindings"
                ],
                "--binauthz-policy-bindings": "value",
                "--clear-labels": "bool",
                "--display-name": "value",
                "--remove-labels": "value",
                "--security-posture": [
                  "disabled",
                  "enterprise",
                  "standard"
                ],
                "--update-labels": "value",
                "--workload-vulnerability-scanning": [
                  "disabled",
                  "enterprise",
                  "standard"
                ]
              }
            }
          },
          "flags": {}
        },
        "images": {
          "commands": {
            "add-tag": {
              "commands": {},
              "flags": {}
            },
            "delete": {
              "commands": {},
              "flags": {
                "--force-delete-tags": "bool"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--repository": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "list-gcr-usage": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list-tags": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "untag": {
              "commands": {},
              "flags": {}
            }
          },
          "flags": {}
        },
        "node-pools": {
          "commands": {
            "complete-upgrade": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--location": "value",
                "--region": "value",
                "--zone": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--accelerator": "value",
                "--additional-node-network": "value",
                "--additional-pod-network": "value",
                "--async": "bool",
                "--boot-disk-kms-key": "value",
                "--cluster": "value",
                "--containerd-config-from-file": "value",
                "--create-pod-ipv4-range": "value",
                "--disk-size": "value",
                "--disk-type": [
                  "hyperdisk-balanced",
                  "hyperdisk-extreme",
                  "hyperdisk-throughput",
                  "pd-balanced",
                  "pd-ssd",
                  "pd-standard"
                ],
                "--enable-autoprovisioning": "bool",
                "--enable-autorepair": "bool",
                "--enable-autoscaling": "bool",
                "--enable-autoupgrade": "bool",
                "--enable-best-effort-provision": "bool",
                "--enable-blue-green-upgrade": "bool",
                "--enable-confidential-nodes": "bool",
                "--enable-confidential-storage": "bool",
                "--enable-gvnic": "bool",
                "--enable-image-streaming": "bool",
                "--enable-insecure-kubelet-readonly-port": "bool",
                "--enable-nested-virtualization": "bool",
                "--enable-private-nodes": "bool",
                "--enable-queued-provisioning": "bool",
                "--enable-surge-upgrade": "bool",
                "--ephemeral-storage-local-ssd": "value",
                "--image-type": "value",
                "--labels": "value",
                "--local-nvme-ssd-block": "value",
                "--local-ssd-count": "value",
                "--location": "value",
                "--location-policy": [
                  "ANY",
                  "BALANCED"
                ],
                "--logging-variant": [
                  "DEFAULT",
                  "MAX_THROUGHPUT"
                ],
                "--machine-type": "value",
                "--max-nodes": "value",
                "--max-pods-per-node": "value",
                "--max-run-duration": "value",
                "--max-surge-upgrade": "value",
                "--max-unavailable-upgrade": "value",
                "--metadata": "value",
                "--metadata-from-file": "value",
                "--min-cpu-platform": "value",
                "--min-nodes": "value",
                "--min-provision-nodes": "value",
                "--network-performance-configs": "value",
                "--node-group": "value",
                "--node-labels": "value",
                "--node-locations": "value",
                "--node-pool-soak-duration": "value",
                "--node-taints": "value",
                "--node-version": "value",
                "--num-nodes": "value",
                "--placement-policy": "value",
                "--placement-type": [
                  "COMPACT",
                  "UNSPECIFIED"
                ],
                "--pod-ipv4-range": "value",
                "--preemptible": "bool",
                "--region": "value",
                "--reservation": "value",
                "--reservation-affinity": [
                  "any",
                  "none",
                  "specific"
                ],
                "--resource-manager-tags": "value",
                "--sandbox": "value",
                "--scopes": "value",
                "--secondary-boot-disk": "value",
                "--service-account": "value",
                "--shielded-integrity-monitoring": "bool",
                "--shielded-secure-boot": "bool",
                "--sole-tenant-node-affinity-file": "value",
                "--spot": "bool",
                "--standard-rollout-policy": "value",
                "--storage-pools": "value",
                "--system-config-from-file": "value",
                "--tags": "value",
                "--threads-per-core": "value",
                "--total-max-nodes": "value",
                "--total-min-nodes": "value",
                "--tpu-topology": "value",
                "--windows-os-version": [
                  "ltsc2019",
                  "ltsc2022"
                ],
                "--workload-metadata": [
                  "GCE_METADATA",
                  "GKE_METADATA"
                ],
                "--zone": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--cluster": "value",
                "--location": "value",
                "--region": "value",
                "--zone": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--location": "value",
                "--region": "value",
                "--zone": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool",
                "--zone": "value"
              }
            },
            "rollback": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--cluster": "value",
                "--location": "value",
                "--region": "value",
                "--respect-pdb": "value",
                "--zone": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--accelerator": "value",
                "--async": "bool",
                "--cluster": "value",
                "--containerd-config-from-file": "value",
                "--disk-size": "value",
                "--disk-type": [
                  "hyperdisk-balanced",
                  "hyperdisk-extreme",
                  "hyperdisk-throughput",
                  "pd-balanced",
                  "pd-ssd",
                  "pd-standard"
                ],
                "--enable-autoprovisioning": "bool",
                "--enable-autorepair": "bool",
                "--enable-autoscaling": "bool",
                "--enable-autoupgrade": "bool",
                "--enable-blue-green-upgrade": "bool",
                "--enable-confidential-nodes": "bool",
                "--enable-gvnic": "bool",
                "--enable-image-streaming": "bool",
                "--enable-insecure-kubelet-readonly-port": "bool",
                "--enable-private-nodes": "bool",
                "--enable-queued-provisioning": "bool",
                "--enable-surge-upgrade": "bool",
                "--labels": "value",
                "--location": "value",
                "--location-policy": [
                  "ANY",
                  "BALANCED"
                ],
                "--logging-variant": [
                  "DEFAULT",
                  "MAX_THROUGHPUT"
                ],
                "--machine-type": "value",
                "--max-nodes": "value",
                "--max-run-duration": "value",
                "--max-surge-upgrade": "value",
                "--max-unavailable-upgrade": "value",
                "--min-nodes": "value",
                "--network-performance-configs": "value",
                "--node-labels": "value",
                "--node-locations": "value",
                "--node-pool-soak-duration": "value",
                "--node-taints": "value",
                "--region": "value",
                "--resource-manager-tags": "value",
                "--standard-rollout-policy": "value",
                "--storage-pools": "value",
                "--system-config-from-file": "value",
                "--tags": "value",
                "--total-max-nodes": "value",
                "--total-min-nodes": "value",
                "--windows-os-version": [
                  "ltsc2019",
                  "ltsc2022"
                ],
                "--workload-metadata": [
                  "GCE_METADATA",
                  "GKE_METADATA"
                ],
                "--zone": "value"
              }
            }
          },
          "flags": {
            "--location": "value",
            "--region": "value",
            "--zone": "value"
          }
        },
        "operations": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--region": "value",
                "--zone": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--region": "value",
                "--zone": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--zone": "value"
              }
            },
            "wait": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--region": "value",
                "--zone": "value"
              }
            }
          },
          "flags": {
            "--location": "value",
            "--region": "value",
            "--zone": "value"
          }
        },
        "subnets": {
          "commands": {
            "list-usable": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--network-project": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "vmware": {
          "commands": {
            "admin-clusters": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "enroll": {
                  "commands": {},
                  "flags": {
                    "--admin-cluster-membership": "value",
                    "--admin-cluster-membership-location": "value",
                    "--async": "bool",
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "unenroll": {
                  "commands": {},
                  "flags": {
                    "--allow-missing": "bool",
                    "--async": "bool",
                    "--location": "value",
                    "--validate-only": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--required-platform-version": "value"
                  }
                }
              },
              "flags": {}
            },
            "clusters": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--admin-cluster-membership": "value",
                    "--admin-cluster-membership-location": "value",
                    "--admin-cluster-membership-project": "value",
                    "--admin-users": "value",
                    "--annotations": "value",
                    "--async": "bool",
                    "--control-plane-ip-block": "value",
                    "--control-plane-node-port": "value",
                    "--control-plane-vip": "value",
                    "--cpus": "value",
                    "--description": "value",
                    "--disable-aag-config": "bool",
                    "--disable-control-plane-v2": "bool",
                    "--disable-vsphere-csi": "bool",
                    "--dns-search-domains": "value",
                    "--dns-servers": "value",
                    "--enable-advanced-networking": "bool",
                    "--enable-auto-repair": "bool",
                    "--enable-auto-resize": "bool",
                    "--enable-control-plane-v2": "bool",
                    "--enable-dataplane-v2": "bool",
                    "--enable-dhcp": "bool",
                    "--enable-vm-tracking": "bool",
                    "--f5-config-address": "value",
                    "--f5-config-partition": "value",
                    "--f5-config-snat-pool": "value",
                    "--ingress-http-node-port": "value",
                    "--ingress-https-node-port": "value",
                    "--ingress-vip": "value",
                    "--konnectivity-server-node-port": "value",
                    "--location": "value",
                    "--memory": "value",
                    "--metal-lb-config-address-pools": "value",
                    "--ntp-servers": "value",
                    "--pod-address-cidr-blocks": "value",
                    "--replicas": "value",
                    "--service-address-cidr-blocks": "value",
                    "--static-ip-config-ip-blocks": "value",
                    "--upgrade-policy": "value",
                    "--validate-only": "bool",
                    "--vcenter-ca-cert-data": "value",
                    "--vcenter-cluster": "value",
                    "--vcenter-datacenter": "value",
                    "--vcenter-datastore": "value",
                    "--vcenter-folder": "value",
                    "--vcenter-resource-pool": "value",
                    "--vcenter-storage-policy-name": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--allow-missing": "bool",
                    "--async": "bool",
                    "--force": "bool",
                    "--ignore-errors": "bool",
                    "--location": "value",
                    "--validate-only": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "enroll": {
                  "commands": {},
                  "flags": {
                    "--admin-cluster-membership": "value",
                    "--admin-cluster-membership-location": "value",
                    "--admin-cluster-membership-project": "value",
                    "--async": "bool",
                    "--local-name": "value",
                    "--location": "value",
                    "--validate-only": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "query-version-config": {
                  "commands": {},
                  "flags": {
                    "--admin-cluster-membership": "value",
                    "--admin-cluster-membership-location": "value",
                    "--admin-cluster-membership-project": "value",
                    "--cluster": "value",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-annotations": "value",
                    "--admin-users": "value",
                    "--async": "bool",
                    "--cpus": "value",
                    "--description": "value",
                    "--disable-aag-config": "bool",
                    "--disable-auto-repair": "bool",
                    "--disable-auto-resize": "bool",
                    "--disable-vsphere-csi": "bool",
                    "--enable-aag-config": "bool",
                    "--enable-auto-repair": "bool",
                    "--enable-auto-resize": "bool",
                    "--enable-vsphere-csi": "bool",
                    "--location": "value",
                    "--memory": "value",
                    "--metal-lb-config-address-pools": "value",
                    "--remove-annotations": "value",
                    "--static-ip-config-ip-blocks": "value",
                    "--upgrade-policy": "value",
                    "--validate-only": "bool"
                  }
                },
                "upgrade": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "node-pools": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--annotations": "value",
                    "--async": "bool",
                    "--boot-disk-size": "value",
                    "--cluster": "value",
                    "--cpus": "value",
                    "--display-name": "value",
                    "--enable-load-balancer": "bool",
                    "--image": "value",
                    "--image-type": "value",
                    "--location": "value",
                    "--max-replicas": "value",
                    "--memory": "value",
                    "--min-replicas": "value",
                    "--node-labels": "value",
                    "--node-taints": "value",
                    "--replicas": "value",
                    "--validate-only": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--allow-missing": "bool",
                    "--async": "bool",
                    "--cluster": "value",
                    "--ignore-errors": "bool",
                    "--location": "value",
                    "--validate-only": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--location": "value"
                  }
                },
                "enroll": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster": "value",
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--cluster": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--boot-disk-size": "value",
                    "--cluster": "value",
                    "--cpus": "value",
                    "--disable-load-balancer": "bool",
                    "--display-name": "value",
                    "--enable-load-balancer": "bool",
                    "--image": "value",
                    "--image-type": "value",
                    "--location": "value",
                    "--max-replicas": "value",
                    "--memory": "value",
                    "--min-replicas": "value",
                    "--node-labels": "value",
                    "--node-taints": "value",
                    "--replicas": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "data-catalog": {
      "commands": {
        "entries": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--display-name": "value",
                "--entry-group": "value",
                "--fully-qualified-name": "value",
                "--gcs-file-patterns": "value",
                "--linked-resource": "value",
                "--location": "value",
                "--schema": "value",
                "--schema-from-file": "value",
                "--source-system-create-time": "value",
                "--source-system-update-time": "value",
                "--type": [
                  "cluster",
                  "dashboard",
                  "data-source-connection",
                  "data-stream",
                  "database",
                  "database-schema",
                  "entry-type-unspecified",
                  "explore",
                  "feature-group",
                  "feature-online-store",
                  "feature-view",
                  "fileset",
                  "lake",
                  "look",
                  "model",
                  "routine",
                  "service",
                  "table",
                  "zone"
                ],
                "--user-specified-system": "value",
                "--user-specified-type": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--entry-group": "value",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--entry-group": "value",
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--entry-group": "value",
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "lookup": {
              "commands": {},
              "flags": {}
            },
            "star": {
              "commands": {},
              "flags": {
                "--entry-group": "value",
                "--location": "value"
              }
            },
            "unstar": {
              "commands": {},
              "flags": {
                "--entry-group": "value",
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-file-patterns": "value",
                "--clear-file-patterns": "bool",
                "--description": "value",
                "--display-name": "value",
                "--entry-group": "value",
                "--linked-resource": "value",
                "--location": "value",
                "--lookup-entry": "value",
                "--remove-file-patterns": "value",
                "--schema": "value",
                "--schema-from-file": "value",
                "--user-specified-system": "value",
                "--user-specified-type": "value"
              }
            }
          },
          "flags": {}
        },
        "entry-groups": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--display-name": "value",
                "--location": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--display-name": "value",
                "--location": "value"
              }
            }
          },
          "flags": {}
        },
        "search": {
          "commands": {},
          "flags": {
            "--include-gcp-public-datasets": "bool",
            "--include-organization-ids": "value",
            "--include-project-ids": "value",
            "--limit": "value",
            "--order-by": "value",
            "--page-size": "value",
            "--restricted-locations": "value"
          }
        },
        "tag-templates": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--display-name": "value",
                "--field": "value",
                "--location": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--force": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "fields": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--display-name": "value",
                    "--location": "value",
                    "--tag-template": "value",
                    "--type": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--force": "bool",
                    "--location": "value",
                    "--tag-template": "value"
                  }
                },
                "enum-values": {
                  "commands": {
                    "rename": {
                      "commands": {},
                      "flags": {
                        "--field": "value",
                        "--location": "value",
                        "--new-id": "value",
                        "--tag-template": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "rename": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--new-id": "value",
                    "--tag-template": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--display-name": "value",
                    "--enum-values": "value",
                    "--location": "value",
                    "--required": "bool",
                    "--tag-template": "value"
                  }
                }
              },
              "flags": {}
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--display-name": "value",
                "--location": "value"
              }
            }
          },
          "flags": {}
        },
        "tags": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--entry": "value",
                "--entry-group": "value",
                "--location": "value",
                "--scope": "value",
                "--tag-file": "value",
                "--tag-template": "value",
                "--tag-template-location": "value",
                "--tag-template-project": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--entry": "value",
                "--entry-group": "value",
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--entry": "value",
                "--entry-group": "value",
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--entry": "value",
                "--entry-group": "value",
                "--location": "value",
                "--tag-file": "value",
                "--tag-template": "value",
                "--tag-template-location": "value",
                "--tag-template-project": "value"
              }
            }
          },
          "flags": {}
        },
        "taxonomies": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "policy-tags": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic",
                    "--taxonomy": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--taxonomy": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--taxonomy": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--taxonomy": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic",
                    "--taxonomy": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--taxonomy": "value"
                  }
                }
              },
              "flags": {}
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "database-migration": {
      "commands": {
        "connection-profiles": {
          "commands": {
            "create": {
              "commands": {
                "alloydb": {
                  "commands": {},
                  "flags": {
                    "--authorized-network-cidr-ranges": "value",
                    "--cluster-labels": "value",
                    "--cpu-count": [
                      2,
                      4,
                      8,
                      16,
                      32,
                      64
                    ],
                    "--database-flags": "value",
                    "--database-version": [
                      "POSTGRES_14",
                      "POSTGRES_15",
                      "POSTGRES_16"
                    ],
                    "--display-name": "value",
                    "--enable-outbound-public-ip": "bool",
                    "--enable-public-ip": "bool",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--network": "value",
                    "--no-async": "bool",
                    "--password": "value",
                    "--primary-id": "value",
                    "--primary-labels": "value",
                    "--region": "dynamic",
                    "--role": [
                      "DESTINATION",
                      "SOURCE"
                    ]
                  }
                },
                "cloudsql": {
                  "commands": {},
                  "flags": {
                    "--activation-policy": [
                      "ALWAYS",
                      "NEVER"
                    ],
                    "--allocated-ip-range": "value",
                    "--authorized-networks": "value",
                    "--auto-storage-increase": "bool",
                    "--availability-type": [
                      "REGIONAL",
                      "ZONAL"
                    ],
                    "--cmek-key": "dynamic",
                    "--cmek-keyring": "dynamic",
                    "--cmek-project": "dynamic",
                    "--data-disk-size": "value",
                    "--data-disk-type": [
                      "PD_HDD",
                      "PD_SSD"
                    ],
                    "--database-flags": "value",
                    "--database-version": [
                      "MYSQL_5_6",
                      "MYSQL_5_7",
                      "MYSQL_8_0",
                      "MYSQL_8_0_18",
                      "MYSQL_8_0_26",
                      "MYSQL_8_0_27",
                      "MYSQL_8_0_28",
                      "MYSQL_8_0_30",
                      "MYSQL_8_0_31",
                      "MYSQL_8_0_32",
                      "MYSQL_8_0_33",
                      "MYSQL_8_0_34",
                      "MYSQL_8_0_35",
                      "MYSQL_8_0_36",
                      "MYSQL_8_0_37",
                      "MYSQL_8_4",
                      "POSTGRES_10",
                      "POSTGRES_11",
                      "POSTGRES_12",
                      "POSTGRES_13",
                      "POSTGRES_14",
                      "POSTGRES_15",
                      "POSTGRES_16",
                      "POSTGRES_9_6"
                    ],
                    "--database-version-name": "value",
                    "--display-name": "value",
                    "--edition": [
                      "enterprise",
                      "enterprise-plus"
                    ],
                    "--enable-ip-v4": "bool",
                    "--labels": "value",
                    "--no-async": "bool",
                    "--private-network": "value",
                    "--provider": [
                      "CLOUDSQL",
                      "RDS"
                    ],
                    "--region": "dynamic",
                    "--require-ssl": "bool",
                    "--role": [
                      "DESTINATION",
                      "SOURCE"
                    ],
                    "--root-password": "value",
                    "--secondary-zone": "value",
                    "--source-id": "dynamic",
                    "--storage-auto-resize-limit": "value",
                    "--tier": "value",
                    "--user-labels": "value",
                    "--zone": "value"
                  }
                },
                "mysql": {
                  "commands": {},
                  "flags": {
                    "--ca-certificate": "value",
                    "--client-certificate": "value",
                    "--cloudsql-instance": "value",
                    "--display-name": "value",
                    "--host": "value",
                    "--labels": "value",
                    "--no-async": "bool",
                    "--password": "value",
                    "--port": "value",
                    "--private-key": "value",
                    "--prompt-for-password": "bool",
                    "--provider": [
                      "CLOUDSQL",
                      "RDS"
                    ],
                    "--region": "dynamic",
                    "--role": [
                      "DESTINATION",
                      "SOURCE"
                    ],
                    "--ssl-type": [
                      "NONE",
                      "REQUIRED",
                      "SERVER_CLIENT",
                      "SERVER_ONLY"
                    ],
                    "--username": "value"
                  }
                },
                "oracle": {
                  "commands": {},
                  "flags": {
                    "--ca-certificate": "value",
                    "--database-service": "value",
                    "--display-name": "value",
                    "--forward-ssh-hostname": "value",
                    "--forward-ssh-password": "value",
                    "--forward-ssh-port": "value",
                    "--forward-ssh-private-key": "value",
                    "--forward-ssh-username": "value",
                    "--host": "value",
                    "--labels": "value",
                    "--no-async": "bool",
                    "--password": "value",
                    "--port": "value",
                    "--private-connection": "dynamic",
                    "--prompt-for-password": "bool",
                    "--region": "dynamic",
                    "--role": [
                      "DESTINATION",
                      "SOURCE"
                    ],
                    "--static-ip-connectivity": "bool",
                    "--username": "value"
                  }
                },
                "postgresql": {
                  "commands": {},
                  "flags": {
                    "--alloydb-cluster": "value",
                    "--ca-certificate": "value",
                    "--client-certificate": "value",
                    "--cloudsql-instance": "value",
                    "--display-name": "value",
                    "--host": "value",
                    "--labels": "value",
                    "--no-async": "bool",
                    "--password": "value",
                    "--port": "value",
                    "--private-key": "value",
                    "--prompt-for-password": "bool",
                    "--psc-service-attachment": "value",
                    "--region": "dynamic",
                    "--role": [
                      "DESTINATION",
                      "SOURCE"
                    ],
                    "--ssl-type": [
                      "NONE",
                      "REQUIRED",
                      "SERVER_CLIENT",
                      "SERVER_ONLY"
                    ],
                    "--static-ip-connectivity": "bool",
                    "--username": "value"
                  }
                },
                "sqlserver": {
                  "commands": {},
                  "flags": {
                    "--cloudsql-instance": "value",
                    "--cloudsql-project-id": "value",
                    "--display-name": "value",
                    "--gcs-bucket": "value",
                    "--gcs-prefix": "value",
                    "--labels": "value",
                    "--no-async": "bool",
                    "--password": "value",
                    "--prompt-for-password": "bool",
                    "--provider": [
                      "CLOUDSQL",
                      "RDS"
                    ],
                    "--region": "dynamic",
                    "--role": [
                      "DESTINATION",
                      "SOURCE"
                    ],
                    "--username": "value"
                  }
                }
              },
              "flags": {}
            },
            "delete": {
              "commands": {},
              "flags": {
                "--force": "bool",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "test": {
              "commands": {},
              "flags": {
                "--no-async": "bool",
                "--region": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--alloydb-cluster": "value",
                "--ca-certificate": "value",
                "--clear-labels": "bool",
                "--client-certificate": "value",
                "--cloudsql-instance": "value",
                "--cloudsql-project-id": "value",
                "--database-service": "value",
                "--display-name": "value",
                "--gcs-bucket": "value",
                "--gcs-prefix": "value",
                "--host": "value",
                "--password": "value",
                "--port": "value",
                "--private-key": "value",
                "--prompt-for-password": "bool",
                "--region": "dynamic",
                "--remove-labels": "value",
                "--ssl-type": [
                  "NONE",
                  "REQUIRED",
                  "SERVER_CLIENT",
                  "SERVER_ONLY"
                ],
                "--update-labels": "value",
                "--username": "value"
              }
            }
          },
          "flags": {}
        },
        "conversion-workspaces": {
          "commands": {
            "apply": {
              "commands": {},
              "flags": {
                "--destination-connection-profile": "dynamic",
                "--filter": "value",
                "--no-async": "bool",
                "--region": "dynamic"
              }
            },
            "commit": {
              "commands": {},
              "flags": {
                "--commit-name": "value",
                "--no-async": "bool",
                "--region": "dynamic"
              }
            },
            "convert": {
              "commands": {},
              "flags": {
                "--auto-commit": "bool",
                "--filter": "value",
                "--no-async": "bool",
                "--region": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--destination-database-engine": [
                  "POSTGRESQL"
                ],
                "--destination-database-version": "value",
                "--display-name": "value",
                "--global-settings": "value",
                "--no-async": "bool",
                "--region": "dynamic",
                "--source-database-engine": [
                  "ORACLE"
                ],
                "--source-database-version": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--no-async": "bool",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "describe-ddls": {
              "commands": {},
              "flags": {
                "--commit-id": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--tree-type": [
                  "DRAFT",
                  "SOURCE"
                ],
                "--uncommitted": "bool",
                "--uri": "bool"
              }
            },
            "describe-entities": {
              "commands": {},
              "flags": {
                "--commit-id": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--tree-type": [
                  "DRAFT",
                  "SOURCE"
                ],
                "--uncommitted": "bool",
                "--uri": "bool"
              }
            },
            "describe-issues": {
              "commands": {},
              "flags": {
                "--commit-id": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uncommitted": "bool",
                "--uri": "bool"
              }
            },
            "import-rules": {
              "commands": {},
              "flags": {
                "--auto-commit": "bool",
                "--config-files": "value",
                "--file-format": [
                  "ORA2PG"
                ],
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "list-background-jobs": {
              "commands": {},
              "flags": {
                "--max-size": "value",
                "--most-recent-per-job-type": "bool",
                "--region": "dynamic"
              }
            },
            "rollback": {
              "commands": {},
              "flags": {
                "--no-async": "bool",
                "--region": "dynamic"
              }
            },
            "seed": {
              "commands": {},
              "flags": {
                "--auto-commit": "bool",
                "--destination-connection-profile": "dynamic",
                "--no-async": "bool",
                "--region": "dynamic",
                "--source-connection-profile": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--display-name": "value",
                "--no-async": "bool",
                "--region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "migration-jobs": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--cmek-key": "dynamic",
                "--cmek-keyring": "dynamic",
                "--cmek-project": "dynamic",
                "--commit-id": "value",
                "--conversion-workspace": "dynamic",
                "--databases-filter": "value",
                "--destination": "dynamic",
                "--display-name": "value",
                "--dump-parallel-level": [
                  "MAX",
                  "MIN",
                  "OPTIMAL"
                ],
                "--dump-path": "value",
                "--dump-type": [
                  "LOGICAL",
                  "PHYSICAL"
                ],
                "--filter": "value",
                "--labels": "value",
                "--no-async": "bool",
                "--peer-vpc": "value",
                "--region": "dynamic",
                "--source": "dynamic",
                "--sqlserver-databases": "value",
                "--sqlserver-diff-backup": "bool",
                "--sqlserver-encrypted-databases": "value",
                "--sqlserver-promote-when-ready": "bool",
                "--static-ip": "bool",
                "--type": [
                  "CONTINUOUS",
                  "ONE_TIME"
                ],
                "--vm": "value",
                "--vm-ip": "value",
                "--vm-port": "value",
                "--vpc": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--force": "bool",
                "--region": "dynamic"
              }
            },
            "demote-destination": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "fetch-source-objects": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "generate-ssh-script": {
              "commands": {},
              "flags": {
                "--region": "dynamic",
                "--subnet": "value",
                "--vm": "value",
                "--vm-machine-type": "value",
                "--vm-port": "value",
                "--vm-zone": "value",
                "--vm-zone-create": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "promote": {
              "commands": {},
              "flags": {
                "--databases-filter": "value",
                "--region": "dynamic"
              }
            },
            "restart": {
              "commands": {},
              "flags": {
                "--databases-filter": "value",
                "--region": "dynamic",
                "--restart-failed-objects": "bool",
                "--skip-validation": "bool"
              }
            },
            "resume": {
              "commands": {},
              "flags": {
                "--region": "dynamic",
                "--skip-validation": "bool"
              }
            },
            "start": {
              "commands": {},
              "flags": {
                "--region": "dynamic",
                "--skip-validation": "bool"
              }
            },
            "stop": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-labels": "bool",
                "--commit-id": "value",
                "--databases-filter": "value",
                "--destination": "dynamic",
                "--display-name": "value",
                "--dump-parallel-level": [
                  "MAX",
                  "MIN",
                  "OPTIMAL"
                ],
                "--dump-path": "value",
                "--dump-type": [
                  "LOGICAL",
                  "PHYSICAL"
                ],
                "--filter": "value",
                "--no-async": "bool",
                "--peer-vpc": "value",
                "--region": "dynamic",
                "--remove-labels": "value",
                "--source": "dynamic",
                "--sqlserver-databases": "value",
                "--sqlserver-diff-backup": "bool",
                "--sqlserver-encrypted-databases": "value",
                "--sqlserver-promote-when-ready": "bool",
                "--static-ip": "bool",
                "--type": [
                  "CONTINUOUS",
                  "ONE_TIME"
                ],
                "--update-labels": "value",
                "--vm": "value",
                "--vm-ip": "value",
                "--vm-port": "value",
                "--vpc": "value"
              }
            },
            "verify": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "objects": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--migration-job": "dynamic",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "lookup": {
              "commands": {},
              "flags": {
                "--database": "value",
                "--migration-job": "dynamic",
                "--region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "private-connections": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--display-name": "value",
                "--labels": "value",
                "--no-async": "bool",
                "--region": "dynamic",
                "--subnet": "value",
                "--vpc": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--no-async": "bool",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "dataflow": {
      "commands": {
        "flex-template": {
          "commands": {
            "build": {
              "commands": {},
              "flags": {
                "--additional-experiments": "value",
                "--additional-user-labels": "value",
                "--dataflow-kms-key": "value",
                "--disable-public-ips": "bool",
                "--enable-streaming-engine": "bool",
                "--env": "value",
                "--flex-template-base-image": "value",
                "--gcs-log-dir": "value",
                "--go-binary-path": "value",
                "--image": "value",
                "--image-gcr-path": "value",
                "--image-repository-cert-path": "value",
                "--image-repository-password-secret-id": "value",
                "--image-repository-username-secret-id": "value",
                "--jar": "value",
                "--max-workers": "value",
                "--metadata-file": "value",
                "--network": "value",
                "--num-workers": "value",
                "--print-only": "bool",
                "--py-path": "value",
                "--sdk-language": [
                  "GO",
                  "JAVA",
                  "PYTHON"
                ],
                "--service-account-email": "value",
                "--staging-location": "value",
                "--subnetwork": "value",
                "--temp-location": "value",
                "--worker-machine-type": "value",
                "--worker-region": "value",
                "--worker-zone": "value"
              }
            },
            "run": {
              "commands": {},
              "flags": {
                "--additional-experiments": "value",
                "--additional-user-labels": "value",
                "--dataflow-kms-key": "value",
                "--disable-public-ips": "bool",
                "--enable-streaming-engine": "bool",
                "--flexrs-goal": [
                  "COST_OPTIMIZED",
                  "SPEED_OPTIMIZED"
                ],
                "--launcher-machine-type": "value",
                "--max-workers": "value",
                "--network": "value",
                "--num-workers": "value",
                "--parameters": "value",
                "--region": "value",
                "--service-account-email": "value",
                "--staging-location": "value",
                "--subnetwork": "value",
                "--temp-location": "value",
                "--template-file-gcs-location": "value",
                "--transform-name-mappings": "value",
                "--update": "bool",
                "--worker-machine-type": "value",
                "--worker-region": "value",
                "--worker-zone": "value"
              }
            }
          },
          "flags": {}
        },
        "jobs": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {
                "--force": "bool",
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--full": "bool",
                "--region": "value"
              }
            },
            "drain": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--created-after": "value",
                "--created-before": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--status": [
                  "active",
                  "all",
                  "terminated"
                ],
                "--uri": "bool"
              }
            },
            "run": {
              "commands": {},
              "flags": {
                "--additional-experiments": "value",
                "--dataflow-kms-key": "value",
                "--disable-public-ips": "bool",
                "--enable-streaming-engine": "bool",
                "--gcs-location": "value",
                "--max-workers": "value",
                "--network": "value",
                "--num-workers": "value",
                "--parameters": "value",
                "--region": "value",
                "--service-account-email": "value",
                "--staging-location": "value",
                "--subnetwork": "value",
                "--worker-machine-type": "value",
                "--worker-region": "value",
                "--worker-zone": "value",
                "--zone": "value"
              }
            },
            "show": {
              "commands": {},
              "flags": {
                "--environment": "bool",
                "--region": "value",
                "--steps": "bool"
              }
            },
            "update-options": {
              "commands": {},
              "flags": {
                "--max-num-workers": "value",
                "--min-num-workers": "value",
                "--region": "value",
                "--unset-worker-utilization-hint": "bool",
                "--worker-utilization-hint": "value"
              }
            }
          },
          "flags": {}
        },
        "snapshots": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--job-id": "value",
                "--region": "value",
                "--snapshot-sources": "value",
                "--snapshot-ttl": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--job-id": "value",
                "--region": "value"
              }
            }
          },
          "flags": {}
        },
        "sql": {
          "commands": {
            "query": {
              "commands": {},
              "flags": {
                "--bigquery-dataset": "value",
                "--bigquery-project": "value",
                "--bigquery-table": "value",
                "--bigquery-write-disposition": [
                  "write-append",
                  "write-empty",
                  "write-truncate"
                ],
                "--dataflow-kms-key": "value",
                "--disable-public-ips": "bool",
                "--dry-run": "bool",
                "--job-name": "value",
                "--max-workers": "value",
                "--network": "value",
                "--num-workers": "value",
                "--parameter": "value",
                "--parameters-file": "value",
                "--pubsub-create-disposition": [
                  "create-if-not-found",
                  "fail-if-not-found"
                ],
                "--pubsub-project": "value",
                "--pubsub-topic": "value",
                "--region": "value",
                "--service-account-email": "value",
                "--subnetwork": "value",
                "--worker-machine-type": "value",
                "--worker-region": "value",
                "--worker-zone": "value",
                "--zone": "value"
              }
            }
          },
          "flags": {}
        },
        "yaml": {
          "commands": {
            "run": {
              "commands": {},
              "flags": {
                "--jinja-variables": "value",
                "--pipeline-options": "value",
                "--region": "value",
                "--yaml-pipeline": "value",
                "--yaml-pipeline-file": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "dataplex": {
      "commands": {
        "aspect-types": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--display-name": "value",
                "--labels": "value",
                "--location": "value",
                "--metadata-template-file-name": "value",
                "--validate-only": "bool"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--etag": "value",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--display-name": "value",
                "--etag": "value",
                "--labels": "value",
                "--location": "value",
                "--metadata-template-file-name": "value",
                "--validate-only": "bool"
              }
            }
          },
          "flags": {}
        },
        "assets": {
          "commands": {
            "actions": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--asset": "dynamic",
                    "--filter": "value",
                    "--lake": "dynamic",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--lake": "value",
                "--location": "value",
                "--member": "value",
                "--role": "value",
                "--zone": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--csv-delimiter": "value",
                "--csv-disable-type-inference": "bool",
                "--csv-encoding": "value",
                "--csv-header-rows": "value",
                "--description": "value",
                "--discovery-enabled": "bool",
                "--discovery-exclude-patterns": "value",
                "--discovery-include-patterns": "value",
                "--discovery-schedule": "value",
                "--display-name": "value",
                "--json-disable-type-inference": "bool",
                "--json-encoding": "value",
                "--labels": "value",
                "--lake": "value",
                "--location": "value",
                "--resource-name": "value",
                "--resource-read-access-mode": [
                  "DIRECT",
                  "MANAGED"
                ],
                "--resource-type": [
                  "BIGQUERY_DATASET",
                  "STORAGE_BUCKET"
                ],
                "--validate-only": "bool",
                "--zone": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--lake": "dynamic",
                "--location": "dynamic",
                "--zone": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--lake": "dynamic",
                "--location": "dynamic",
                "--zone": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--lake": "dynamic",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--zone": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--lake": "dynamic",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool",
                "--zone": "dynamic"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--lake": "value",
                "--location": "value",
                "--member": "value",
                "--role": "value",
                "--zone": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--lake": "value",
                "--location": "value",
                "--zone": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--csv-delimiter": "value",
                "--csv-disable-type-inference": "bool",
                "--csv-encoding": "value",
                "--csv-header-rows": "value",
                "--description": "value",
                "--discovery-enabled": "bool",
                "--discovery-exclude-patterns": "value",
                "--discovery-include-patterns": "value",
                "--discovery-schedule": "value",
                "--display-name": "value",
                "--json-disable-type-inference": "bool",
                "--json-encoding": "value",
                "--labels": "value",
                "--lake": "value",
                "--location": "value",
                "--resource-read-access-mode": [
                  "DIRECT",
                  "MANAGED"
                ],
                "--validate-only": "bool",
                "--zone": "value"
              }
            }
          },
          "flags": {}
        },
        "content": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--lake": "value",
                "--location": "value",
                "--member": "value",
                "--role": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--data-text": "value",
                "--description": "value",
                "--kernel-type": [
                  "PYTHON3"
                ],
                "--labels": "value",
                "--lake": "value",
                "--location": "value",
                "--path": "value",
                "--query-engine": [
                  "SPARK"
                ],
                "--validate-only": "bool"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--lake": "dynamic",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--lake": "dynamic",
                "--location": "dynamic",
                "--view": [
                  "basic",
                  "full"
                ]
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--lake": "dynamic",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--lake": "dynamic",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--lake": "value",
                "--location": "value",
                "--member": "value",
                "--role": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--lake": "value",
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--data-text": "value",
                "--description": "value",
                "--kernel-type": [
                  "PYTHON3"
                ],
                "--labels": "value",
                "--lake": "value",
                "--location": "value",
                "--path": "value",
                "--query-engine": [
                  "SPARK"
                ],
                "--validate-only": "bool"
              }
            }
          },
          "flags": {}
        },
        "datascans": {
          "commands": {
            "create": {
              "commands": {
                "data-profile": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--data-profile-spec-file": "value",
                    "--data-source-entity": "value",
                    "--data-source-resource": "value",
                    "--description": "value",
                    "--display-name": "value",
                    "--exclude-field-names": "value",
                    "--export-results-table": "value",
                    "--include-field-names": "value",
                    "--incremental-field": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--on-demand": "value",
                    "--row-filter": "value",
                    "--sampling-percent": "value",
                    "--schedule": "value",
                    "--validate-only": "bool"
                  }
                },
                "data-quality": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--data-quality-spec-file": "value",
                    "--data-source-entity": "value",
                    "--data-source-resource": "value",
                    "--description": "value",
                    "--display-name": "value",
                    "--incremental-field": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--on-demand": "value",
                    "--schedule": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic",
                "--view": [
                  "basic",
                  "full"
                ]
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "jobs": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--datascan": "dynamic",
                    "--location": "dynamic",
                    "--view": [
                      "basic",
                      "full"
                    ]
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--datascan": "dynamic",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "run": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "update": {
              "commands": {
                "data-profile": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--data-profile-spec-file": "value",
                    "--description": "value",
                    "--display-name": "value",
                    "--exclude-field-names": "value",
                    "--include-field-names": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--on-demand": "value",
                    "--row-filter": "value",
                    "--sampling-percent": "value",
                    "--schedule": "value",
                    "--validate-only": "bool"
                  }
                },
                "data-quality": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--data-quality-spec-file": "value",
                    "--description": "value",
                    "--display-name": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--on-demand": "value",
                    "--schedule": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "entries": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--aspects": "value",
                "--entry-group": "dynamic",
                "--entry-source-ancestors": "value",
                "--entry-source-create-time": "value",
                "--entry-source-description": "value",
                "--entry-source-display-name": "value",
                "--entry-source-labels": "value",
                "--entry-source-platform": "value",
                "--entry-source-resource": "value",
                "--entry-source-system": "value",
                "--entry-source-update-time": "value",
                "--entry-type": "value",
                "--entry-type-location": "value",
                "--entry-type-project": "value",
                "--fully-qualified-name": "value",
                "--location": "dynamic",
                "--parent-entry": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--entry-group": "dynamic",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--aspect-types": "value",
                "--entry-group": "dynamic",
                "--location": "dynamic",
                "--paths": "value",
                "--view": [
                  "all",
                  "basic",
                  "custom",
                  "full"
                ]
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--entry-group": "dynamic",
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "lookup": {
              "commands": {},
              "flags": {
                "--aspect-types": "value",
                "--entry-group": "dynamic",
                "--location": "dynamic",
                "--paths": "value",
                "--view": [
                  "all",
                  "basic",
                  "custom",
                  "full"
                ]
              }
            },
            "remove-aspects": {
              "commands": {},
              "flags": {
                "--entry-group": "dynamic",
                "--keys": "value",
                "--location": "dynamic"
              }
            },
            "search": {
              "commands": {},
              "flags": {
                "--limit": "value",
                "--order-by": "value",
                "--page-size": "value",
                "--scope": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-entry-source-create-time": "bool",
                "--clear-entry-source-description": "bool",
                "--clear-entry-source-display-name": "bool",
                "--clear-entry-source-labels": "bool",
                "--clear-entry-source-platform": "bool",
                "--clear-entry-source-resource": "bool",
                "--clear-entry-source-system": "bool",
                "--clear-fully-qualified-name": "bool",
                "--entry-group": "dynamic",
                "--entry-source-create-time": "value",
                "--entry-source-description": "value",
                "--entry-source-display-name": "value",
                "--entry-source-labels": "value",
                "--entry-source-platform": "value",
                "--entry-source-resource": "value",
                "--entry-source-system": "value",
                "--entry-source-update-time": "value",
                "--fully-qualified-name": "value",
                "--location": "dynamic",
                "--remove-aspects": "value",
                "--update-aspects": "value"
              }
            },
            "update-aspects": {
              "commands": {},
              "flags": {
                "--aspects": "value",
                "--entry-group": "dynamic",
                "--location": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "entry-groups": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--display-name": "value",
                "--labels": "value",
                "--location": "value",
                "--validate-only": "bool"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--etag": "value",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--display-name": "value",
                "--etag": "value",
                "--labels": "value",
                "--location": "value",
                "--validate-only": "bool"
              }
            }
          },
          "flags": {}
        },
        "entry-types": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--display-name": "value",
                "--labels": "value",
                "--location": "value",
                "--platform": "value",
                "--required-aspects": "value",
                "--system": "value",
                "--type-aliases": "value",
                "--validate-only": "bool"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--etag": "value",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--display-name": "value",
                "--etag": "value",
                "--labels": "value",
                "--location": "value",
                "--platform": "value",
                "--required-aspects": "value",
                "--system": "value",
                "--type-aliases": "value",
                "--validate-only": "bool"
              }
            }
          },
          "flags": {}
        },
        "environments": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--lake": "value",
                "--location": "value",
                "--member": "value",
                "--role": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--compute-disk-size-gb": "value",
                "--compute-max-node-count": "value",
                "--compute-node-count": "value",
                "--description": "value",
                "--display-name": "value",
                "--labels": "value",
                "--lake": "value",
                "--location": "value",
                "--os-image-java-libraries": "value",
                "--os-image-properties": "value",
                "--os-image-python-packages": "value",
                "--os-image-version": "value",
                "--session-enable-fast-startup": "bool",
                "--session-max-idle-duration": "value",
                "--validate-only": "bool"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--lake": "dynamic",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--lake": "dynamic",
                "--location": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--lake": "dynamic",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--lake": "dynamic",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--lake": "value",
                "--location": "value",
                "--member": "value",
                "--role": "value"
              }
            },
            "sessions": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--environment": "dynamic",
                    "--filter": "value",
                    "--lake": "dynamic",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--lake": "value",
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--compute-disk-size-gb": "value",
                "--compute-max-node-count": "value",
                "--compute-node-count": "value",
                "--description": "value",
                "--display-name": "value",
                "--labels": "value",
                "--lake": "value",
                "--location": "value",
                "--os-image-java-libraries": "value",
                "--os-image-properties": "value",
                "--os-image-python-packages": "value",
                "--os-image-version": "value",
                "--session-enable-fast-startup": "bool",
                "--session-max-idle-duration": "value",
                "--validate-only": "bool"
              }
            }
          },
          "flags": {}
        },
        "lakes": {
          "commands": {
            "actions": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--lake": "dynamic",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "value"
              }
            },
            "authorize": {
              "commands": {},
              "flags": {
                "--bigquery-dataset-resource": "value",
                "--project-resource": "value",
                "--secondary-project": "value",
                "--storage-bucket-resource": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--display-name": "value",
                "--labels": "value",
                "--location": "value",
                "--metastore-service": "value",
                "--validate-only": "bool"
              }
            },
            "deauthorize": {
              "commands": {},
              "flags": {
                "--bigquery-dataset-resource": "value",
                "--project-resource": "value",
                "--secondary-project": "value",
                "--storage-bucket-resource": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--display-name": "value",
                "--labels": "value",
                "--location": "value",
                "--metastore-service": "value",
                "--validate-only": "bool"
              }
            }
          },
          "flags": {}
        },
        "tasks": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--lake": "value",
                "--location": "value",
                "--member": "value",
                "--role": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--batch-executors-count": "value",
                "--batch-max-executors-count": "value",
                "--container-image": "value",
                "--container-image-java-jars": "value",
                "--container-image-properties": "value",
                "--container-image-python-packages": "value",
                "--description": "value",
                "--display-name": "value",
                "--execution-args": "value",
                "--execution-project": "value",
                "--execution-service-account": "value",
                "--kms-key": "value",
                "--labels": "value",
                "--lake": "dynamic",
                "--location": "dynamic",
                "--max-job-execution-lifetime": "value",
                "--notebook": "value",
                "--notebook-archive-uris": "value",
                "--notebook-batch-executors-count": "value",
                "--notebook-batch-max-executors-count": "value",
                "--notebook-container-image": "value",
                "--notebook-container-image-java-jars": "value",
                "--notebook-container-image-properties": "value",
                "--notebook-file-uris": "value",
                "--notebook-vpc-network-name": "value",
                "--notebook-vpc-network-tags": "value",
                "--notebook-vpc-sub-network-name": "value",
                "--spark-archive-uris": "value",
                "--spark-file-uris": "value",
                "--spark-main-class": "value",
                "--spark-main-jar-file-uri": "value",
                "--spark-python-script-file": "value",
                "--spark-sql-script": "value",
                "--spark-sql-script-file": "value",
                "--trigger-disabled": "bool",
                "--trigger-max-retires": "value",
                "--trigger-schedule": "value",
                "--trigger-start-time": "value",
                "--trigger-type": [
                  "on-demand",
                  "recurring"
                ],
                "--vpc-network-name": "value",
                "--vpc-network-tags": "value",
                "--vpc-sub-network-name": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--lake": "dynamic",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--lake": "dynamic",
                "--location": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--lake": "dynamic",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "jobs": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--lake": "dynamic",
                    "--location": "dynamic",
                    "--task": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--lake": "dynamic",
                    "--location": "dynamic",
                    "--task": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--lake": "dynamic",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--task": "dynamic",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--lake": "dynamic",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--lake": "value",
                "--location": "value",
                "--member": "value",
                "--role": "value"
              }
            },
            "run": {
              "commands": {},
              "flags": {
                "--labels": "value",
                "--lake": "value",
                "--location": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--lake": "value",
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--batch-executors-count": "value",
                "--batch-max-executors-count": "value",
                "--clear-labels": "bool",
                "--container-image": "value",
                "--container-image-java-jars": "value",
                "--container-image-properties": "value",
                "--container-image-python-packages": "value",
                "--description": "value",
                "--display-name": "value",
                "--execution-args": "value",
                "--execution-project": "value",
                "--execution-service-account": "value",
                "--kms-key": "value",
                "--lake": "dynamic",
                "--location": "dynamic",
                "--max-job-execution-lifetime": "value",
                "--notebook": "value",
                "--notebook-archive-uris": "value",
                "--notebook-batch-executors-count": "value",
                "--notebook-batch-max-executors-count": "value",
                "--notebook-container-image": "value",
                "--notebook-container-image-java-jars": "value",
                "--notebook-container-image-properties": "value",
                "--notebook-file-uris": "value",
                "--notebook-vpc-network-name": "value",
                "--notebook-vpc-network-tags": "value",
                "--notebook-vpc-sub-network-name": "value",
                "--remove-labels": "value",
                "--spark-archive-uris": "value",
                "--spark-file-uris": "value",
                "--spark-main-class": "value",
                "--spark-main-jar-file-uri": "value",
                "--spark-python-script-file": "value",
                "--spark-sql-script": "value",
                "--spark-sql-script-file": "value",
                "--trigger-disabled": "bool",
                "--trigger-max-retires": "value",
                "--trigger-schedule": "value",
                "--trigger-start-time": "value",
                "--update-labels": "value",
                "--vpc-network-name": "value",
                "--vpc-network-tags": "value",
                "--vpc-sub-network-name": "value"
              }
            }
          },
          "flags": {}
        },
        "zones": {
          "commands": {
            "actions": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--lake": "dynamic",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--lake": "value",
                "--location": "value",
                "--member": "value",
                "--role": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--csv-delimiter": "value",
                "--csv-disable-type-inference": "bool",
                "--csv-encoding": "value",
                "--csv-header-rows": "value",
                "--description": "value",
                "--discovery-enabled": "bool",
                "--discovery-exclude-patterns": "value",
                "--discovery-include-patterns": "value",
                "--discovery-schedule": "value",
                "--display-name": "value",
                "--json-disable-type-inference": "bool",
                "--json-encoding": "value",
                "--labels": "value",
                "--lake": "value",
                "--location": "value",
                "--resource-location-type": [
                  "MULTI_REGION",
                  "SINGLE_REGION"
                ],
                "--type": [
                  "CURATED",
                  "RAW"
                ],
                "--validate-only": "bool"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--lake": "dynamic",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--lake": "dynamic",
                "--location": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--lake": "dynamic",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--lake": "dynamic",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--lake": "value",
                "--location": "value",
                "--member": "value",
                "--role": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--lake": "value",
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--csv-delimiter": "value",
                "--csv-disable-type-inference": "bool",
                "--csv-encoding": "value",
                "--csv-header-rows": "value",
                "--description": "value",
                "--discovery-enabled": "bool",
                "--discovery-exclude-patterns": "value",
                "--discovery-include-patterns": "value",
                "--discovery-schedule": "value",
                "--display-name": "value",
                "--json-disable-type-inference": "bool",
                "--json-encoding": "value",
                "--labels": "value",
                "--lake": "value",
                "--location": "value",
                "--validate-only": "bool"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "dataproc": {
      "commands": {
        "autoscaling-policies": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--region": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--region": "value",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            }
          },
          "flags": {}
        },
        "batches": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value"
              }
            },
            "submit": {
              "commands": {
                "pyspark": {
                  "commands": {},
                  "flags": {
                    "--archives": "value",
                    "--async": "bool",
                    "--batch": "value",
                    "--container-image": "value",
                    "--deps-bucket": "value",
                    "--files": "value",
                    "--history-server-cluster": "value",
                    "--jars": "value",
                    "--kms-key": "value",
                    "--labels": "value",
                    "--metastore-service": "value",
                    "--network": "value",
                    "--properties": "value",
                    "--py-files": "value",
                    "--region": "value",
                    "--request-id": "value",
                    "--service-account": "value",
                    "--staging-bucket": "value",
                    "--subnet": "value",
                    "--tags": "value",
                    "--ttl": "value",
                    "--version": "value"
                  }
                },
                "spark": {
                  "commands": {},
                  "flags": {
                    "--archives": "value",
                    "--async": "bool",
                    "--batch": "value",
                    "--class": "value",
                    "--container-image": "value",
                    "--deps-bucket": "value",
                    "--files": "value",
                    "--history-server-cluster": "value",
                    "--jar": "value",
                    "--jars": "value",
                    "--kms-key": "value",
                    "--labels": "value",
                    "--metastore-service": "value",
                    "--network": "value",
                    "--properties": "value",
                    "--region": "value",
                    "--request-id": "value",
                    "--service-account": "value",
                    "--staging-bucket": "value",
                    "--subnet": "value",
                    "--tags": "value",
                    "--ttl": "value",
                    "--version": "value"
                  }
                },
                "spark-r": {
                  "commands": {},
                  "flags": {
                    "--archives": "value",
                    "--async": "bool",
                    "--batch": "value",
                    "--container-image": "value",
                    "--deps-bucket": "value",
                    "--files": "value",
                    "--history-server-cluster": "value",
                    "--kms-key": "value",
                    "--labels": "value",
                    "--metastore-service": "value",
                    "--network": "value",
                    "--properties": "value",
                    "--region": "value",
                    "--request-id": "value",
                    "--service-account": "value",
                    "--staging-bucket": "value",
                    "--subnet": "value",
                    "--tags": "value",
                    "--ttl": "value",
                    "--version": "value"
                  }
                },
                "spark-sql": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--batch": "value",
                    "--container-image": "value",
                    "--deps-bucket": "value",
                    "--history-server-cluster": "value",
                    "--jars": "value",
                    "--kms-key": "value",
                    "--labels": "value",
                    "--metastore-service": "value",
                    "--network": "value",
                    "--properties": "value",
                    "--region": "value",
                    "--request-id": "value",
                    "--service-account": "value",
                    "--staging-bucket": "value",
                    "--subnet": "value",
                    "--tags": "value",
                    "--ttl": "value",
                    "--vars": "value",
                    "--version": "value"
                  }
                }
              },
              "flags": {
                "--async": "bool",
                "--batch": "value",
                "--container-image": "value",
                "--history-server-cluster": "value",
                "--kms-key": "value",
                "--labels": "value",
                "--metastore-service": "value",
                "--network": "value",
                "--properties": "value",
                "--region": "value",
                "--request-id": "value",
                "--service-account": "value",
                "--staging-bucket": "value",
                "--subnet": "value",
                "--tags": "value",
                "--ttl": "value"
              }
            },
            "wait": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            }
          },
          "flags": {}
        },
        "clusters": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--action-on-failed-primary-workers": [
                  "DELETE",
                  "FAILURE_ACTION_UNSPECIFIED",
                  "NO_ACTION"
                ],
                "--async": "bool",
                "--autoscaling-policy": "value",
                "--bucket": "value",
                "--confidential-compute": "bool",
                "--dataproc-metastore": "value",
                "--driver-pool-accelerator": "value",
                "--driver-pool-boot-disk-size": "value",
                "--driver-pool-boot-disk-type": "value",
                "--driver-pool-id": "value",
                "--driver-pool-local-ssd-interface": "value",
                "--driver-pool-machine-type": "value",
                "--driver-pool-min-cpu-platform": "value",
                "--driver-pool-size": "value",
                "--enable-component-gateway": "bool",
                "--enable-kerberos": "bool",
                "--expiration-time": "value",
                "--gce-pd-kms-key": "dynamic",
                "--gce-pd-kms-key-keyring": "dynamic",
                "--gce-pd-kms-key-location": "dynamic",
                "--gce-pd-kms-key-project": "dynamic",
                "--identity-config-file": "value",
                "--image": "value",
                "--image-version": "value",
                "--initialization-action-timeout": "value",
                "--initialization-actions": "value",
                "--kerberos-config-file": "value",
                "--kerberos-kms-key": "dynamic",
                "--kerberos-kms-key-keyring": "dynamic",
                "--kerberos-kms-key-location": "dynamic",
                "--kerberos-kms-key-project": "dynamic",
                "--kerberos-root-principal-password-uri": "value",
                "--kms-key": "dynamic",
                "--kms-keyring": "dynamic",
                "--kms-location": "dynamic",
                "--kms-project": "dynamic",
                "--labels": "value",
                "--master-accelerator": "value",
                "--master-boot-disk-provisioned-iops": "value",
                "--master-boot-disk-provisioned-throughput": "value",
                "--master-boot-disk-size": "value",
                "--master-boot-disk-type": "value",
                "--master-local-ssd-interface": "value",
                "--master-machine-type": "value",
                "--master-min-cpu-platform": "value",
                "--max-age": "value",
                "--max-idle": "value",
                "--metadata": "value",
                "--metric-overrides": "value",
                "--metric-overrides-file": "value",
                "--metric-sources": "value",
                "--min-num-workers": "value",
                "--min-secondary-worker-fraction": "value",
                "--network": "value",
                "--no-address": "bool",
                "--node-group": "value",
                "--num-driver-pool-local-ssds": "value",
                "--num-master-local-ssds": "value",
                "--num-masters": "value",
                "--num-secondary-worker-local-ssds": "value",
                "--num-secondary-workers": "value",
                "--num-worker-local-ssds": "value",
                "--num-workers": "value",
                "--optional-components": "value",
                "--private-ipv6-google-access-type": [
                  "bidirectional",
                  "inherit-subnetwork",
                  "outbound"
                ],
                "--properties": "value",
                "--public-ip-address": "bool",
                "--region": "value",
                "--reservation": "value",
                "--reservation-affinity": [
                  "any",
                  "none",
                  "specific"
                ],
                "--scopes": "value",
                "--secondary-worker-accelerator": "value",
                "--secondary-worker-boot-disk-size": "value",
                "--secondary-worker-boot-disk-type": "value",
                "--secondary-worker-local-ssd-interface": "value",
                "--secondary-worker-machine-types": "value",
                "--secondary-worker-standard-capacity-base": "value",
                "--secondary-worker-standard-capacity-percent-above-base": "value",
                "--secondary-worker-type": [
                  "non-preemptible",
                  "preemptible",
                  "spot"
                ],
                "--secure-multi-tenancy-user-mapping": "value",
                "--service-account": "value",
                "--shielded-integrity-monitoring": "bool",
                "--shielded-secure-boot": "bool",
                "--shielded-vtpm": "bool",
                "--single-node": "bool",
                "--subnet": "value",
                "--tags": "value",
                "--temp-bucket": "value",
                "--worker-accelerator": "value",
                "--worker-boot-disk-provisioned-iops": "value",
                "--worker-boot-disk-provisioned-throughput": "value",
                "--worker-boot-disk-size": "value",
                "--worker-boot-disk-type": "value",
                "--worker-local-ssd-interface": "value",
                "--worker-machine-type": "value",
                "--worker-machine-types": "value",
                "--worker-min-cpu-platform": "value",
                "--zone": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "diagnose": {
              "commands": {},
              "flags": {
                "--end-time": "value",
                "--job-ids": "value",
                "--region": "value",
                "--start-time": "value",
                "--tarball-access": [
                  "GOOGLE_CLOUD_SUPPORT",
                  "GOOGLE_DATAPROC_DIAGNOSE"
                ],
                "--yarn-application-ids": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--region": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value"
              }
            },
            "gke": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--gke-cluster": "value",
                    "--gke-cluster-location": "value",
                    "--history-server-cluster": "value",
                    "--history-server-cluster-region": "value",
                    "--metastore-service": "value",
                    "--metastore-service-location": "value",
                    "--namespace": "value",
                    "--pools": "value",
                    "--properties": "value",
                    "--region": "value",
                    "--setup-workload-identity": "bool",
                    "--spark-engine-version": "value",
                    "--staging-bucket": "value"
                  }
                }
              },
              "flags": {}
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "value",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "start": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "value"
              }
            },
            "stop": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--autoscaling-policy": "value",
                "--clear-labels": "bool",
                "--disable-autoscaling": "bool",
                "--expiration-time": "value",
                "--graceful-decommission-timeout": "value",
                "--max-age": "value",
                "--max-idle": "value",
                "--min-secondary-worker-fraction": "value",
                "--no-max-age": "bool",
                "--no-max-idle": "bool",
                "--num-secondary-workers": "value",
                "--num-workers": "value",
                "--region": "value",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "jobs": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value"
              }
            },
            "kill": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--state-filter": [
                  "active",
                  "inactive"
                ]
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "submit": {
              "commands": {
                "flink": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--bucket": "value",
                    "--class": "value",
                    "--cluster": "value",
                    "--cluster-labels": "value",
                    "--driver-log-levels": "value",
                    "--driver-required-memory-mb": "value",
                    "--driver-required-vcores": "value",
                    "--jar": "value",
                    "--jars": "value",
                    "--labels": "value",
                    "--max-failures-per-hour": "value",
                    "--max-failures-total": "value",
                    "--properties": "value",
                    "--properties-file": "value",
                    "--region": "value",
                    "--savepoint": "value"
                  }
                },
                "hadoop": {
                  "commands": {},
                  "flags": {
                    "--archives": "value",
                    "--async": "bool",
                    "--bucket": "value",
                    "--class": "value",
                    "--cluster": "value",
                    "--cluster-labels": "value",
                    "--driver-log-levels": "value",
                    "--driver-required-memory-mb": "value",
                    "--driver-required-vcores": "value",
                    "--files": "value",
                    "--jar": "value",
                    "--jars": "value",
                    "--labels": "value",
                    "--max-failures-per-hour": "value",
                    "--max-failures-total": "value",
                    "--properties": "value",
                    "--properties-file": "value",
                    "--region": "value"
                  }
                },
                "hive": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--bucket": "value",
                    "--cluster": "value",
                    "--cluster-labels": "value",
                    "--continue-on-failure": "bool",
                    "--driver-required-memory-mb": "value",
                    "--driver-required-vcores": "value",
                    "--execute": "value",
                    "--file": "value",
                    "--jars": "value",
                    "--labels": "value",
                    "--max-failures-per-hour": "value",
                    "--max-failures-total": "value",
                    "--params": "value",
                    "--properties": "value",
                    "--properties-file": "value",
                    "--region": "value"
                  }
                },
                "pig": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--bucket": "value",
                    "--cluster": "value",
                    "--cluster-labels": "value",
                    "--continue-on-failure": "bool",
                    "--driver-log-levels": "value",
                    "--driver-required-memory-mb": "value",
                    "--driver-required-vcores": "value",
                    "--execute": "value",
                    "--file": "value",
                    "--jars": "value",
                    "--labels": "value",
                    "--max-failures-per-hour": "value",
                    "--max-failures-total": "value",
                    "--params": "value",
                    "--properties": "value",
                    "--properties-file": "value",
                    "--region": "value"
                  }
                },
                "presto": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--bucket": "value",
                    "--client-tags": "value",
                    "--cluster": "value",
                    "--cluster-labels": "value",
                    "--continue-on-failure": "bool",
                    "--driver-log-levels": "value",
                    "--driver-required-memory-mb": "value",
                    "--driver-required-vcores": "value",
                    "--execute": "value",
                    "--file": "value",
                    "--labels": "value",
                    "--max-failures-per-hour": "value",
                    "--max-failures-total": "value",
                    "--properties": "value",
                    "--properties-file": "value",
                    "--query-output-format": "value",
                    "--region": "value"
                  }
                },
                "pyspark": {
                  "commands": {},
                  "flags": {
                    "--archives": "value",
                    "--async": "bool",
                    "--bucket": "value",
                    "--cluster": "value",
                    "--cluster-labels": "value",
                    "--driver-log-levels": "value",
                    "--driver-required-memory-mb": "value",
                    "--driver-required-vcores": "value",
                    "--files": "value",
                    "--jars": "value",
                    "--labels": "value",
                    "--max-failures-per-hour": "value",
                    "--max-failures-total": "value",
                    "--properties": "value",
                    "--properties-file": "value",
                    "--py-files": "value",
                    "--region": "value"
                  }
                },
                "spark": {
                  "commands": {},
                  "flags": {
                    "--archives": "value",
                    "--async": "bool",
                    "--bucket": "value",
                    "--class": "value",
                    "--cluster": "value",
                    "--cluster-labels": "value",
                    "--driver-log-levels": "value",
                    "--driver-required-memory-mb": "value",
                    "--driver-required-vcores": "value",
                    "--files": "value",
                    "--jar": "value",
                    "--jars": "value",
                    "--labels": "value",
                    "--max-failures-per-hour": "value",
                    "--max-failures-total": "value",
                    "--properties": "value",
                    "--properties-file": "value",
                    "--region": "value"
                  }
                },
                "spark-r": {
                  "commands": {},
                  "flags": {
                    "--archives": "value",
                    "--async": "bool",
                    "--bucket": "value",
                    "--cluster": "value",
                    "--cluster-labels": "value",
                    "--driver-log-levels": "value",
                    "--driver-required-memory-mb": "value",
                    "--driver-required-vcores": "value",
                    "--files": "value",
                    "--labels": "value",
                    "--max-failures-per-hour": "value",
                    "--max-failures-total": "value",
                    "--properties": "value",
                    "--properties-file": "value",
                    "--region": "value"
                  }
                },
                "spark-sql": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--bucket": "value",
                    "--cluster": "value",
                    "--cluster-labels": "value",
                    "--driver-log-levels": "value",
                    "--driver-required-memory-mb": "value",
                    "--driver-required-vcores": "value",
                    "--execute": "value",
                    "--file": "value",
                    "--jars": "value",
                    "--labels": "value",
                    "--max-failures-per-hour": "value",
                    "--max-failures-total": "value",
                    "--params": "value",
                    "--properties": "value",
                    "--properties-file": "value",
                    "--region": "value"
                  }
                },
                "trino": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--bucket": "value",
                    "--client-tags": "value",
                    "--cluster": "value",
                    "--cluster-labels": "value",
                    "--continue-on-failure": "bool",
                    "--driver-log-levels": "value",
                    "--driver-required-memory-mb": "value",
                    "--driver-required-vcores": "value",
                    "--execute": "value",
                    "--file": "value",
                    "--labels": "value",
                    "--max-failures-per-hour": "value",
                    "--max-failures-total": "value",
                    "--properties": "value",
                    "--properties-file": "value",
                    "--query-output-format": "value",
                    "--region": "value"
                  }
                }
              },
              "flags": {
                "--async": "bool",
                "--bucket": "value",
                "--region": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-labels": "bool",
                "--region": "value",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            },
            "wait": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            }
          },
          "flags": {}
        },
        "node-groups": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--region": "value"
              }
            },
            "resize": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--graceful-decommission-timeout": "value",
                "--region": "value",
                "--size": "value"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--state-filter": [
                  "active",
                  "inactive"
                ]
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            }
          },
          "flags": {}
        },
        "workflow-templates": {
          "commands": {
            "add-job": {
              "commands": {
                "hadoop": {
                  "commands": {},
                  "flags": {
                    "--archives": "value",
                    "--class": "value",
                    "--driver-log-levels": "value",
                    "--files": "value",
                    "--jar": "value",
                    "--jars": "value",
                    "--labels": "value",
                    "--properties": "value",
                    "--properties-file": "value",
                    "--region": "value",
                    "--start-after": "value",
                    "--step-id": "value",
                    "--workflow-template": "value"
                  }
                },
                "hive": {
                  "commands": {},
                  "flags": {
                    "--continue-on-failure": "bool",
                    "--execute": "value",
                    "--file": "value",
                    "--jars": "value",
                    "--labels": "value",
                    "--params": "value",
                    "--properties": "value",
                    "--properties-file": "value",
                    "--region": "value",
                    "--start-after": "value",
                    "--step-id": "value",
                    "--workflow-template": "value"
                  }
                },
                "pig": {
                  "commands": {},
                  "flags": {
                    "--continue-on-failure": "bool",
                    "--driver-log-levels": "value",
                    "--execute": "value",
                    "--file": "value",
                    "--jars": "value",
                    "--labels": "value",
                    "--params": "value",
                    "--properties": "value",
                    "--properties-file": "value",
                    "--region": "value",
                    "--start-after": "value",
                    "--step-id": "value",
                    "--workflow-template": "value"
                  }
                },
                "presto": {
                  "commands": {},
                  "flags": {
                    "--client-tags": "value",
                    "--continue-on-failure": "bool",
                    "--driver-log-levels": "value",
                    "--execute": "value",
                    "--file": "value",
                    "--labels": "value",
                    "--properties": "value",
                    "--properties-file": "value",
                    "--query-output-format": "value",
                    "--region": "value",
                    "--start-after": "value",
                    "--step-id": "value",
                    "--workflow-template": "value"
                  }
                },
                "pyspark": {
                  "commands": {},
                  "flags": {
                    "--archives": "value",
                    "--driver-log-levels": "value",
                    "--files": "value",
                    "--jars": "value",
                    "--labels": "value",
                    "--properties": "value",
                    "--properties-file": "value",
                    "--py-files": "value",
                    "--region": "value",
                    "--start-after": "value",
                    "--step-id": "value",
                    "--workflow-template": "value"
                  }
                },
                "spark": {
                  "commands": {},
                  "flags": {
                    "--archives": "value",
                    "--class": "value",
                    "--driver-log-levels": "value",
                    "--files": "value",
                    "--jar": "value",
                    "--jars": "value",
                    "--labels": "value",
                    "--properties": "value",
                    "--properties-file": "value",
                    "--region": "value",
                    "--start-after": "value",
                    "--step-id": "value",
                    "--workflow-template": "value"
                  }
                },
                "spark-r": {
                  "commands": {},
                  "flags": {
                    "--archives": "value",
                    "--driver-log-levels": "value",
                    "--files": "value",
                    "--labels": "value",
                    "--properties": "value",
                    "--properties-file": "value",
                    "--region": "value",
                    "--start-after": "value",
                    "--step-id": "value",
                    "--workflow-template": "value"
                  }
                },
                "spark-sql": {
                  "commands": {},
                  "flags": {
                    "--driver-log-levels": "value",
                    "--execute": "value",
                    "--file": "value",
                    "--jars": "value",
                    "--labels": "value",
                    "--params": "value",
                    "--properties": "value",
                    "--properties-file": "value",
                    "--region": "value",
                    "--start-after": "value",
                    "--step-id": "value",
                    "--workflow-template": "value"
                  }
                },
                "trino": {
                  "commands": {},
                  "flags": {
                    "--client-tags": "value",
                    "--continue-on-failure": "bool",
                    "--driver-log-levels": "value",
                    "--execute": "value",
                    "--file": "value",
                    "--labels": "value",
                    "--properties": "value",
                    "--properties-file": "value",
                    "--query-output-format": "value",
                    "--region": "value",
                    "--start-after": "value",
                    "--step-id": "value",
                    "--workflow-template": "value"
                  }
                }
              },
              "flags": {}
            },
            "create": {
              "commands": {},
              "flags": {
                "--dag-timeout": "value",
                "--kms-key": "value",
                "--labels": "value",
                "--region": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--region": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--region": "value",
                "--source": "value"
              }
            },
            "instantiate": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--parameters": "value",
                "--region": "value"
              }
            },
            "instantiate-from-file": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--file": "value",
                "--region": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value"
              }
            },
            "remove-dag-timeout": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "remove-job": {
              "commands": {},
              "flags": {
                "--region": "value",
                "--step-id": "value"
              }
            },
            "set-cluster-selector": {
              "commands": {},
              "flags": {
                "--cluster-labels": "value",
                "--region": "value"
              }
            },
            "set-dag-timeout": {
              "commands": {},
              "flags": {
                "--dag-timeout": "value",
                "--region": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "set-managed-cluster": {
              "commands": {},
              "flags": {
                "--autoscaling-policy": "value",
                "--bucket": "value",
                "--cluster-name": "value",
                "--confidential-compute": "bool",
                "--dataproc-metastore": "value",
                "--enable-component-gateway": "bool",
                "--enable-kerberos": "bool",
                "--identity-config-file": "value",
                "--image": "value",
                "--image-version": "value",
                "--initialization-action-timeout": "value",
                "--initialization-actions": "value",
                "--kerberos-config-file": "value",
                "--kerberos-kms-key": "dynamic",
                "--kerberos-kms-key-keyring": "dynamic",
                "--kerberos-kms-key-location": "dynamic",
                "--kerberos-kms-key-project": "dynamic",
                "--kerberos-root-principal-password-uri": "value",
                "--kms-key": "dynamic",
                "--kms-keyring": "dynamic",
                "--kms-location": "dynamic",
                "--kms-project": "dynamic",
                "--labels": "value",
                "--master-accelerator": "value",
                "--master-boot-disk-provisioned-iops": "value",
                "--master-boot-disk-provisioned-throughput": "value",
                "--master-boot-disk-size": "value",
                "--master-boot-disk-type": "value",
                "--master-local-ssd-interface": "value",
                "--master-machine-type": "value",
                "--master-min-cpu-platform": "value",
                "--metadata": "value",
                "--metric-overrides": "value",
                "--metric-overrides-file": "value",
                "--metric-sources": "value",
                "--min-num-workers": "value",
                "--min-secondary-worker-fraction": "value",
                "--network": "value",
                "--no-address": "bool",
                "--node-group": "value",
                "--num-master-local-ssds": "value",
                "--num-masters": "value",
                "--num-secondary-worker-local-ssds": "value",
                "--num-secondary-workers": "value",
                "--num-worker-local-ssds": "value",
                "--num-workers": "value",
                "--optional-components": "value",
                "--private-ipv6-google-access-type": [
                  "bidirectional",
                  "inherit-subnetwork",
                  "outbound"
                ],
                "--properties": "value",
                "--public-ip-address": "bool",
                "--region": "value",
                "--reservation": "value",
                "--reservation-affinity": [
                  "any",
                  "none",
                  "specific"
                ],
                "--scopes": "value",
                "--secondary-worker-accelerator": "value",
                "--secondary-worker-boot-disk-size": "value",
                "--secondary-worker-boot-disk-type": "value",
                "--secondary-worker-local-ssd-interface": "value",
                "--secondary-worker-machine-types": "value",
                "--secondary-worker-standard-capacity-base": "value",
                "--secondary-worker-standard-capacity-percent-above-base": "value",
                "--secondary-worker-type": [
                  "non-preemptible",
                  "preemptible",
                  "spot"
                ],
                "--secure-multi-tenancy-user-mapping": "value",
                "--service-account": "value",
                "--shielded-integrity-monitoring": "bool",
                "--shielded-secure-boot": "bool",
                "--shielded-vtpm": "bool",
                "--single-node": "bool",
                "--subnet": "value",
                "--tags": "value",
                "--temp-bucket": "value",
                "--worker-accelerator": "value",
                "--worker-boot-disk-provisioned-iops": "value",
                "--worker-boot-disk-provisioned-throughput": "value",
                "--worker-boot-disk-size": "value",
                "--worker-boot-disk-type": "value",
                "--worker-local-ssd-interface": "value",
                "--worker-machine-type": "value",
                "--worker-machine-types": "value",
                "--worker-min-cpu-platform": "value",
                "--zone": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "datastore": {
      "commands": {
        "export": {
          "commands": {},
          "flags": {
            "--async": "bool",
            "--kinds": "value",
            "--namespaces": "value",
            "--operation-labels": "value"
          }
        },
        "import": {
          "commands": {},
          "flags": {
            "--async": "bool",
            "--kinds": "value",
            "--namespaces": "value",
            "--operation-labels": "value"
          }
        },
        "indexes": {
          "commands": {
            "cleanup": {
              "commands": {},
              "flags": {
                "--database": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--database": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {}
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "datastream": {
      "commands": {
        "connection-profiles": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--bucket": "value",
                "--ca-certificate": "value",
                "--client-certificate": "value",
                "--client-key": "value",
                "--database-service": "value",
                "--display-name": "value",
                "--force": "bool",
                "--forward-ssh-hostname": "value",
                "--forward-ssh-password": "value",
                "--forward-ssh-port": "value",
                "--forward-ssh-private-key": "value",
                "--forward-ssh-username": "value",
                "--labels": "value",
                "--location": "value",
                "--mysql-hostname": "value",
                "--mysql-password": "value",
                "--mysql-port": "value",
                "--mysql-prompt-for-password": "bool",
                "--mysql-username": "value",
                "--oracle-hostname": "value",
                "--oracle-password": "value",
                "--oracle-port": "value",
                "--oracle-prompt-for-password": "bool",
                "--oracle-username": "value",
                "--postgresql-ca-certificate": "value",
                "--postgresql-client-certificate": "value",
                "--postgresql-client-key": "value",
                "--postgresql-database": "value",
                "--postgresql-hostname": "value",
                "--postgresql-password": "value",
                "--postgresql-port": "value",
                "--postgresql-prompt-for-password": "bool",
                "--postgresql-username": "value",
                "--private-connection": "value",
                "--root-path": "value",
                "--sqlserver-database": "value",
                "--sqlserver-hostname": "value",
                "--sqlserver-password": "value",
                "--sqlserver-port": "value",
                "--sqlserver-prompt-for-password": "bool",
                "--sqlserver-username": "value",
                "--static-ip-connectivity": "bool",
                "--type": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "discover": {
              "commands": {},
              "flags": {
                "--connection-profile-name": "value",
                "--connection-profile-object-file": "value",
                "--full-hierarchy": "bool",
                "--hierarchy-depth": "value",
                "--location": "value",
                "--mysql-rdbms-file": "value",
                "--oracle-rdbms-file": "value",
                "--postgresql-rdbms-file": "value",
                "--recursive": "bool",
                "--recursive-depth": "value",
                "--sqlserver-rdbms-file": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--bucket": "value",
                "--ca-certificate": "value",
                "--clear-labels": "bool",
                "--client-certificate": "value",
                "--client-key": "value",
                "--database-service": "value",
                "--display-name": "value",
                "--force": "bool",
                "--forward-ssh-hostname": "value",
                "--forward-ssh-password": "value",
                "--forward-ssh-port": "value",
                "--forward-ssh-private-key": "value",
                "--forward-ssh-username": "value",
                "--location": "value",
                "--mysql-hostname": "value",
                "--mysql-password": "value",
                "--mysql-port": "value",
                "--mysql-prompt-for-password": "bool",
                "--mysql-username": "value",
                "--oracle-hostname": "value",
                "--oracle-password": "value",
                "--oracle-port": "value",
                "--oracle-prompt-for-password": "bool",
                "--oracle-username": "value",
                "--postgresql-ca-certificate": "value",
                "--postgresql-client-certificate": "value",
                "--postgresql-client-key": "value",
                "--postgresql-database": "value",
                "--postgresql-hostname": "value",
                "--postgresql-password": "value",
                "--postgresql-port": "value",
                "--postgresql-prompt-for-password": "bool",
                "--postgresql-username": "value",
                "--private-connection": "value",
                "--remove-labels": "value",
                "--root-path": "value",
                "--sqlserver-database": "value",
                "--sqlserver-hostname": "value",
                "--sqlserver-password": "value",
                "--sqlserver-port": "value",
                "--sqlserver-prompt-for-password": "bool",
                "--sqlserver-username": "value",
                "--static-ip-connectivity": "bool",
                "--type": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "locations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "fetch-static-ips": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "objects": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic",
                "--stream": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--stream": "value",
                "--uri": "bool"
              }
            },
            "lookup": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--mysql-database": "value",
                "--mysql-table": "value",
                "--oracle-schema": "value",
                "--oracle-table": "value",
                "--postgresql-schema": "value",
                "--postgresql-table": "value",
                "--sqlserver-schema": "value",
                "--sqlserver-table": "value",
                "--stream": "value"
              }
            },
            "start-backfill": {
              "commands": {},
              "flags": {
                "--location": "dynamic",
                "--stream": "dynamic"
              }
            },
            "stop-backfill": {
              "commands": {},
              "flags": {
                "--location": "dynamic",
                "--stream": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "private-connections": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--display-name": "value",
                "--labels": "value",
                "--location": "value",
                "--subnet": "value",
                "--vpc": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--force": "bool",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "routes": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--destination-address": "value",
                "--destination-port": "value",
                "--display-name": "value",
                "--labels": "value",
                "--location": "value",
                "--private-connection": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "dynamic",
                "--private-connection": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic",
                "--private-connection": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--private-connection": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "streams": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--backfill-all": "bool",
                "--backfill-none": "bool",
                "--bigquery-destination-config": "value",
                "--destination": "value",
                "--display-name": "value",
                "--force": "bool",
                "--gcs-destination-config": "value",
                "--labels": "value",
                "--location": "value",
                "--mysql-excluded-objects": "value",
                "--mysql-source-config": "value",
                "--oracle-excluded-objects": "value",
                "--oracle-source-config": "value",
                "--postgresql-excluded-objects": "value",
                "--postgresql-source-config": "value",
                "--source": "value",
                "--sqlserver-excluded-objects": "value",
                "--sqlserver-source-config": "value",
                "--validate-only": "bool"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--backfill-all": "bool",
                "--backfill-none": "bool",
                "--bigquery-destination-config": "value",
                "--clear-labels": "bool",
                "--destination": "value",
                "--display-name": "value",
                "--force": "bool",
                "--gcs-destination-config": "value",
                "--location": "value",
                "--mysql-excluded-objects": "value",
                "--mysql-source-config": "value",
                "--oracle-excluded-objects": "value",
                "--oracle-source-config": "value",
                "--postgresql-excluded-objects": "value",
                "--postgresql-source-config": "value",
                "--remove-labels": "value",
                "--source": "value",
                "--sqlserver-excluded-objects": "value",
                "--sqlserver-source-config": "value",
                "--state": "value",
                "--update-labels": "value",
                "--update-mask": "value",
                "--validate-only": "bool"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "deploy": {
      "commands": {
        "apply": {
          "commands": {},
          "flags": {
            "--file": "value",
            "--region": "value"
          }
        },
        "automation-runs": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {
                "--delivery-pipeline": "dynamic",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--delivery-pipeline": "dynamic",
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--delivery-pipeline": "dynamic",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "automations": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--delivery-pipeline": "dynamic",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--delivery-pipeline": "dynamic",
                "--region": "dynamic"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--delivery-pipeline": "dynamic",
                "--destination": "value",
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--delivery-pipeline": "dynamic",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "custom-target-types": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--region": "dynamic",
                "--role": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--region": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--region": "dynamic",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "delete": {
          "commands": {},
          "flags": {
            "--file": "value",
            "--force": "bool",
            "--region": "value"
          }
        },
        "delivery-pipelines": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--region": "dynamic",
                "--role": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--force": "bool",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--region": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--region": "dynamic",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "deploy-policies": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "get-config": {
          "commands": {},
          "flags": {
            "--region": "value"
          }
        },
        "job-runs": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--delivery-pipeline": "dynamic",
                "--region": "dynamic",
                "--release": "dynamic",
                "--rollout": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--delivery-pipeline": "dynamic",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--release": "dynamic",
                "--rollout": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "terminate": {
              "commands": {},
              "flags": {
                "--delivery-pipeline": "dynamic",
                "--region": "dynamic",
                "--release": "dynamic",
                "--rollout": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "releases": {
          "commands": {
            "abandon": {
              "commands": {},
              "flags": {
                "--delivery-pipeline": "dynamic",
                "--region": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--annotations": "value",
                "--build-artifacts": "value",
                "--delivery-pipeline": "dynamic",
                "--deploy-parameters": "value",
                "--description": "value",
                "--disable-initial-rollout": "bool",
                "--enable-initial-rollout": "bool",
                "--from-k8s-manifest": "value",
                "--from-run-manifest": "value",
                "--gcs-source-staging-dir": "value",
                "--ignore-file": "value",
                "--images": "value",
                "--initial-rollout-annotations": "value",
                "--initial-rollout-labels": "value",
                "--initial-rollout-phase-id": "value",
                "--labels": "value",
                "--region": "dynamic",
                "--skaffold-file": "value",
                "--skaffold-version": "value",
                "--source": "value",
                "--to-target": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--delivery-pipeline": "dynamic",
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--delivery-pipeline": "dynamic",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "promote": {
              "commands": {},
              "flags": {
                "--annotations": "value",
                "--delivery-pipeline": "dynamic",
                "--labels": "value",
                "--region": "dynamic",
                "--release": "dynamic",
                "--rollout-id": "value",
                "--starting-phase-id": "value",
                "--to-target": "value"
              }
            }
          },
          "flags": {}
        },
        "rollouts": {
          "commands": {
            "advance": {
              "commands": {},
              "flags": {
                "--delivery-pipeline": "dynamic",
                "--phase-id": "value",
                "--region": "dynamic",
                "--release": "dynamic"
              }
            },
            "approve": {
              "commands": {},
              "flags": {
                "--delivery-pipeline": "dynamic",
                "--region": "dynamic",
                "--release": "dynamic"
              }
            },
            "cancel": {
              "commands": {},
              "flags": {
                "--delivery-pipeline": "dynamic",
                "--region": "dynamic",
                "--release": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--delivery-pipeline": "dynamic",
                "--region": "dynamic",
                "--release": "dynamic"
              }
            },
            "ignore-job": {
              "commands": {},
              "flags": {
                "--delivery-pipeline": "dynamic",
                "--job-id": "value",
                "--phase-id": "value",
                "--region": "dynamic",
                "--release": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--delivery-pipeline": "dynamic",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--release": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "reject": {
              "commands": {},
              "flags": {
                "--delivery-pipeline": "dynamic",
                "--region": "dynamic",
                "--release": "dynamic"
              }
            },
            "retry-job": {
              "commands": {},
              "flags": {
                "--delivery-pipeline": "dynamic",
                "--job-id": "value",
                "--phase-id": "value",
                "--region": "dynamic",
                "--release": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "targets": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--region": "dynamic",
                "--role": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--delivery-pipeline": "value",
                "--list-all-pipelines": "bool",
                "--region": "dynamic",
                "--skip-pipeline-lookup": "bool"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--region": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "redeploy": {
              "commands": {},
              "flags": {
                "--annotations": "value",
                "--delivery-pipeline": "value",
                "--description": "value",
                "--labels": "value",
                "--region": "dynamic",
                "--rollout-id": "value",
                "--starting-phase-id": "value"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--region": "dynamic",
                "--role": "dynamic"
              }
            },
            "rollback": {
              "commands": {},
              "flags": {
                "--annotations": "value",
                "--delivery-pipeline": "value",
                "--description": "value",
                "--labels": "value",
                "--region": "dynamic",
                "--release": "value",
                "--rollout-id": "value",
                "--starting-phase-id": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "deployment-manager": {
      "commands": {
        "deployments": {
          "commands": {
            "cancel-preview": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--fingerprint": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--automatic-rollback-on-error": "bool",
                "--composite-type": "value",
                "--config": "value",
                "--description": "value",
                "--labels": "value",
                "--preview": "bool",
                "--properties": "value",
                "--template": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--delete-policy": [
                  "abandon",
                  "delete"
                ]
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--simple-list": "bool",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "stop": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--fingerprint": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--composite-type": "value",
                "--config": "value",
                "--create-policy": [
                  "acquire",
                  "create-or-acquire"
                ],
                "--delete-policy": [
                  "abandon",
                  "delete"
                ],
                "--description": "value",
                "--fingerprint": "value",
                "--preview": "bool",
                "--properties": "value",
                "--remove-labels": "value",
                "--template": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "manifests": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--deployment": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--deployment": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--simple-list": "bool",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--simple-list": "bool",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "wait": {
              "commands": {},
              "flags": {}
            }
          },
          "flags": {}
        },
        "resources": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--deployment": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--deployment": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--simple-list": "bool",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {
            "--deployment": "value"
          }
        },
        "types": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "developer-connect": {
      "commands": {
        "connections": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--annotations": "value",
                "--async": "bool",
                "--crypto-key-config-reference": "value",
                "--disabled": "bool",
                "--etag": "value",
                "--github-config-app": [
                  "developer-connect",
                  "firebase"
                ],
                "--github-config-app-installation-id": "value",
                "--github-config-authorizer-credential-oauth-token-secret-version": "value",
                "--github-enterprise-config-app-id": "value",
                "--github-enterprise-config-app-installation-id": "value",
                "--github-enterprise-config-host-uri": "value",
                "--github-enterprise-config-private-key-secret-version": "value",
                "--github-enterprise-config-service-directory": "value",
                "--github-enterprise-config-ssl-ca-certificate": "value",
                "--github-enterprise-config-webhook-secret-version": "value",
                "--gitlab-config-authorizer-credential-user-token-secret-version": "value",
                "--gitlab-config-read-authorizer-credential-user-token-secret-version": "value",
                "--gitlab-config-webhook-secret-version": "value",
                "--gitlab-enterprise-config-authorizer-credential-user-token-secret-version": "value",
                "--gitlab-enterprise-config-host-uri": "value",
                "--gitlab-enterprise-config-read-authorizer-credential-user-token-secret-version": "value",
                "--gitlab-enterprise-config-service-directory": "value",
                "--gitlab-enterprise-config-ssl-ca-certificate": "value",
                "--gitlab-enterprise-config-webhook-secret-version": "value",
                "--key-ring": "value",
                "--labels": "value",
                "--location": "value",
                "--namespace": "value",
                "--request-id": "value",
                "--secret": "value",
                "--validate-only": "bool"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--etag": "value",
                "--location": "dynamic",
                "--request-id": "value",
                "--validate-only": "bool"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "git-repository-links": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--annotations": "value",
                    "--async": "bool",
                    "--clone-uri": "value",
                    "--connection": "dynamic",
                    "--etag": "value",
                    "--labels": "value",
                    "--location": "dynamic",
                    "--request-id": "value",
                    "--validate-only": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--connection": "dynamic",
                    "--etag": "value",
                    "--location": "dynamic",
                    "--request-id": "value",
                    "--validate-only": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--connection": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "fetch-read-token": {
                  "commands": {},
                  "flags": {
                    "--connection": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "fetch-read-write-token": {
                  "commands": {},
                  "flags": {
                    "--connection": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--connection": "dynamic",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--allow-missing": "bool",
                "--annotations": "value",
                "--async": "bool",
                "--clear-annotations": "bool",
                "--clear-github-enterprise-config-private-key-secret-version": "bool",
                "--clear-github-enterprise-config-webhook-secret-version": "bool",
                "--clear-labels": "bool",
                "--crypto-key-config-reference": "value",
                "--disabled": "bool",
                "--etag": "value",
                "--github-config-app-installation-id": "value",
                "--github-config-authorizer-credential-oauth-token-secret-version": "value",
                "--github-enterprise-config-app-id": "value",
                "--github-enterprise-config-app-installation-id": "value",
                "--github-enterprise-config-host-uri": "value",
                "--github-enterprise-config-private-key-secret-version": "value",
                "--github-enterprise-config-service-directory": "value",
                "--github-enterprise-config-ssl-ca-certificate": "value",
                "--github-enterprise-config-webhook-secret-version": "value",
                "--gitlab-config-authorizer-credential-user-token-secret-version": "value",
                "--gitlab-config-read-authorizer-credential-user-token-secret-version": "value",
                "--gitlab-enterprise-config-authorizer-credential-user-token-secret-version": "value",
                "--gitlab-enterprise-config-host-uri": "value",
                "--gitlab-enterprise-config-read-authorizer-credential-user-token-secret-version": "value",
                "--gitlab-enterprise-config-service-directory": "value",
                "--gitlab-enterprise-config-ssl-ca-certificate": "value",
                "--key-ring": "value",
                "--labels": "value",
                "--location": "value",
                "--namespace": "value",
                "--remove-annotations": "value",
                "--remove-labels": "value",
                "--request-id": "value",
                "--secret": "value",
                "--update-annotations": "value",
                "--update-labels": "value",
                "--validate-only": "bool"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "wait": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "dns": {
      "commands": {
        "dns-keys": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--zone": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--sort-by": "value",
                "--zone": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "managed-zones": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--denial-of-existence": [
                  "nsec",
                  "nsec3"
                ],
                "--description": "value",
                "--dns-name": "value",
                "--dnssec-state": [
                  "off",
                  "on",
                  "transfer"
                ],
                "--forwarding-targets": "value",
                "--gkeclusters": "value",
                "--ksk-algorithm": [
                  "ecdsap256sha256",
                  "ecdsap384sha384",
                  "rsasha1",
                  "rsasha256",
                  "rsasha512"
                ],
                "--ksk-key-length": "value",
                "--labels": "value",
                "--location": "value",
                "--log-dns-queries": "bool",
                "--managed-reverse-lookup": "bool",
                "--networks": "value",
                "--private-forwarding-targets": "value",
                "--service-directory-namespace": "value",
                "--target-network": "value",
                "--target-project": "value",
                "--visibility": [
                  "private",
                  "public"
                ],
                "--zsk-algorithm": [
                  "ecdsap256sha256",
                  "ecdsap384sha384",
                  "rsasha1",
                  "rsasha256",
                  "rsasha512"
                ],
                "--zsk-key-length": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--policy-file": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-labels": "bool",
                "--denial-of-existence": [
                  "nsec",
                  "nsec3"
                ],
                "--description": "value",
                "--dnssec-state": [
                  "off",
                  "on",
                  "transfer"
                ],
                "--forwarding-targets": "value",
                "--gkeclusters": "value",
                "--ksk-algorithm": [
                  "ecdsap256sha256",
                  "ecdsap384sha384",
                  "rsasha1",
                  "rsasha256",
                  "rsasha512"
                ],
                "--ksk-key-length": "value",
                "--location": "value",
                "--log-dns-queries": "bool",
                "--managed-reverse-lookup": "bool",
                "--networks": "value",
                "--private-forwarding-targets": "value",
                "--remove-labels": "value",
                "--target-network": "value",
                "--target-project": "value",
                "--update-labels": "value",
                "--zsk-algorithm": [
                  "ecdsap256sha256",
                  "ecdsap384sha384",
                  "rsasha1",
                  "rsasha256",
                  "rsasha512"
                ],
                "--zsk-key-length": "value"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--zone": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--sort-by": "value",
                "--zones": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "policies": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--alternative-name-servers": "value",
                "--description": "value",
                "--enable-inbound-forwarding": "bool",
                "--enable-logging": "bool",
                "--networks": "value",
                "--private-alternative-name-servers": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--alternative-name-servers": "value",
                "--description": "value",
                "--enable-inbound-forwarding": "bool",
                "--enable-logging": "bool",
                "--networks": "value",
                "--private-alternative-name-servers": "value"
              }
            }
          },
          "flags": {}
        },
        "project-info": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            }
          },
          "flags": {}
        },
        "record-sets": {
          "commands": {
            "changes": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--sort-order": [
                      "ascending",
                      "descending"
                    ],
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "create": {
              "commands": {},
              "flags": {
                "--backup-data-trickle-ratio": "value",
                "--enable-geo-fencing": "bool",
                "--enable-health-checking": "bool",
                "--location": "value",
                "--routing-policy-backup-data": "value",
                "--routing-policy-backup-data-type": [
                  "GEO"
                ],
                "--routing-policy-data": "value",
                "--routing-policy-primary-data": "value",
                "--routing-policy-type": [
                  "FAILOVER",
                  "GEO",
                  "WRR"
                ],
                "--rrdatas": "value",
                "--ttl": "value",
                "--type": "value",
                "--zone": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--type": "value",
                "--zone": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--type": "value",
                "--zone": "dynamic"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--zone": "dynamic",
                "--zone-file-format": "bool"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--delete-all-existing": "bool",
                "--location": "value",
                "--replace-origin-ns": "bool",
                "--zone": "dynamic",
                "--zone-file-format": "bool"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--name": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--type": "value",
                "--uri": "bool",
                "--zone": "dynamic"
              }
            },
            "transaction": {
              "commands": {
                "abort": {
                  "commands": {},
                  "flags": {
                    "--transaction-file": "value",
                    "--zone": "dynamic"
                  }
                },
                "add": {
                  "commands": {},
                  "flags": {
                    "--name": "value",
                    "--transaction-file": "value",
                    "--ttl": "value",
                    "--type": "value",
                    "--zone": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--transaction-file": "value",
                    "--zone": "dynamic"
                  }
                },
                "execute": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--transaction-file": "value",
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                },
                "remove": {
                  "commands": {},
                  "flags": {
                    "--name": "value",
                    "--transaction-file": "value",
                    "--ttl": "value",
                    "--type": "value",
                    "--zone": "dynamic"
                  }
                },
                "start": {
                  "commands": {},
                  "flags": {
                    "--transaction-file": "value",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {
                "--transaction-file": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--backup-data-trickle-ratio": "value",
                "--enable-geo-fencing": "bool",
                "--enable-health-checking": "bool",
                "--location": "value",
                "--routing-policy-backup-data": "value",
                "--routing-policy-backup-data-type": [
                  "GEO"
                ],
                "--routing-policy-data": "value",
                "--routing-policy-primary-data": "value",
                "--routing-policy-type": [
                  "FAILOVER",
                  "GEO",
                  "WRR"
                ],
                "--rrdatas": "value",
                "--ttl": "value",
                "--type": "value",
                "--zone": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "response-policies": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--gkeclusters": "value",
                "--location": "value",
                "--networks": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "rules": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--behavior": [
                      "behaviorUnspecified",
                      "bypassResponsePolicy"
                    ],
                    "--dns-name": "value",
                    "--local-data": "value",
                    "--location": "value",
                    "--response-policy": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--response-policy": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--response-policy": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--behavior": [
                      "behaviorUnspecified",
                      "bypassResponsePolicy"
                    ],
                    "--dns-name": "value",
                    "--local-data": "value",
                    "--location": "value",
                    "--response-policy": "value"
                  }
                }
              },
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--gkeclusters": "value",
                "--location": "value",
                "--networks": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "docker": {
      "commands": {},
      "flags": {
        "--authorize-only": "bool",
        "--docker-host": "value",
        "--server": "value"
      }
    },
    "domains": {
      "commands": {
        "list-user-verified": {
          "commands": {},
          "flags": {}
        },
        "registrations": {
          "commands": {
            "authorization-code": {
              "commands": {
                "get": {
                  "commands": {},
                  "flags": {}
                },
                "reset": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "configure": {
              "commands": {
                "contacts": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--contact-data-from-file": "value",
                    "--contact-privacy": [
                      "private-contact-data",
                      "public-contact-data",
                      "redacted-contact-data"
                    ],
                    "--notices": "value",
                    "--validate-only": "bool"
                  }
                },
                "dns": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cloud-dns-zone": "value",
                    "--disable-dnssec": "bool",
                    "--dns-settings-from-file": "value",
                    "--name-servers": "value",
                    "--unsafe-dns-update": "bool",
                    "--use-google-domains-dns": "bool",
                    "--validate-only": "bool"
                  }
                },
                "management": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--preferred-renewal-method": [
                      "automatic-renewal",
                      "renewal-disabled"
                    ],
                    "--transfer-lock-state": [
                      "locked",
                      "unlocked"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "get-register-parameters": {
              "commands": {},
              "flags": {}
            },
            "google-domains-dns": {
              "commands": {
                "export-dns-record-sets": {
                  "commands": {},
                  "flags": {
                    "--records-file": "value",
                    "--zone-file-format": "bool"
                  }
                },
                "get-forwarding-config": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "initiate-push-transfer": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--tag": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "register": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--cloud-dns-zone": "value",
                "--contact-data-from-file": "value",
                "--contact-privacy": [
                  "private-contact-data",
                  "public-contact-data",
                  "redacted-contact-data"
                ],
                "--disable-dnssec": "bool",
                "--labels": "value",
                "--name-servers": "value",
                "--notices": "value",
                "--use-google-domains-dns": "bool",
                "--validate-only": "bool",
                "--yearly-price": "value"
              }
            },
            "renew-domain": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--validate-only": "bool",
                "--yearly-price": "value"
              }
            },
            "search-domains": {
              "commands": {},
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-labels": "bool",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "verify": {
          "commands": {},
          "flags": {}
        }
      },
      "flags": {}
    },
    "edge-cache": {
      "commands": {
        "keysets": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--labels": "value",
                "--location": "value",
                "--public-key": "value",
                "--validation-shared-key": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--location": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--labels": "value",
                "--location": "value",
                "--public-key": "value",
                "--validation-shared-key": "value"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "origins": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--failover-origin": "value",
                "--labels": "value",
                "--location": "value",
                "--max-attempts": "value",
                "--origin-address": "value",
                "--port": "value",
                "--protocol": [
                  "http",
                  "http2",
                  "https"
                ],
                "--response-timeout": "value",
                "--retry-conditions": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--location": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--failover-origin": "value",
                "--labels": "value",
                "--location": "value",
                "--max-attempts": "value",
                "--origin-address": "value",
                "--port": "value",
                "--protocol": [
                  "http",
                  "http2",
                  "https"
                ],
                "--response-timeout": "value",
                "--retry-conditions": "value"
              }
            }
          },
          "flags": {}
        },
        "services": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--location": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--source": "value"
              }
            },
            "invalidate-cache": {
              "commands": {},
              "flags": {
                "--host": "value",
                "--location": "value",
                "--path": "value",
                "--tags": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--edge-security-policy": "value",
                "--edge-ssl-certificate": "value",
                "--enable-logging": "bool",
                "--labels": "value",
                "--location": "value",
                "--logging-sample-rate": "value",
                "--require-tls": "bool"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "edge-cloud": {
      "commands": {
        "container": {
          "commands": {
            "clusters": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--admin-users": "value",
                    "--async": "bool",
                    "--cluster-ipv4-cidr": "value",
                    "--control-plane-kms-key": "value",
                    "--control-plane-machine-filter": "value",
                    "--control-plane-node-count": "value",
                    "--control-plane-node-location": "value",
                    "--control-plane-node-storage-schema": "value",
                    "--control-plane-shared-deployment-policy": "value",
                    "--default-max-pods-per-node": "value",
                    "--external-lb-ipv4-address-pools": "value",
                    "--fleet-project": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--lro-timeout": "value",
                    "--maintenance-window-end": "value",
                    "--maintenance-window-recurrence": "value",
                    "--maintenance-window-start": "value",
                    "--offline-reboot-ttl": "value",
                    "--release-channel": "value",
                    "--services-ipv4-cidr": "value",
                    "--system-addons-config": "value",
                    "--zone-storage-kms-key": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "get-credentials": {
                  "commands": {},
                  "flags": {
                    "--auth-provider-cmd-path": "value",
                    "--location": "value",
                    "--offline-credential": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "node-pools": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--cluster": "value",
                        "--labels": "value",
                        "--local-disk-kms-key": "value",
                        "--location": "value",
                        "--lro-timeout": "value",
                        "--machine-filter": "value",
                        "--node-count": "value",
                        "--node-labels": "value",
                        "--node-location": "value",
                        "--node-storage-schema": "value"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--cluster": "dynamic",
                        "--location": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--cluster": "dynamic",
                        "--location": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--cluster": "dynamic",
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--clear-labels": "bool",
                        "--cluster": "value",
                        "--location": "value",
                        "--lro-timeout": "value",
                        "--machine-filter": "value",
                        "--node-count": "value",
                        "--node-labels": "value",
                        "--remove-labels": "value",
                        "--update-labels": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-maintenance-exclusion-end": "value",
                    "--add-maintenance-exclusion-name": "value",
                    "--add-maintenance-exclusion-start": "value",
                    "--async": "bool",
                    "--clear-maintenance-window": "bool",
                    "--location": "dynamic",
                    "--maintenance-window-end": "value",
                    "--maintenance-window-recurrence": "value",
                    "--maintenance-window-start": "value",
                    "--offline-reboot-ttl": "value",
                    "--release-channel": [
                      "none",
                      "regular",
                      "release-channel-unspecified"
                    ],
                    "--remove-maintenance-exclusion-window": "value",
                    "--use-google-managed-zone-key": "bool",
                    "--zone-storage-kms-key": "value"
                  }
                },
                "upgrade": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--schedule": "value"
                  }
                }
              },
              "flags": {}
            },
            "get-server-config": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "machines": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "regions": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "vpn-connections": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster": "dynamic",
                    "--high-availability": "bool",
                    "--labels": "value",
                    "--location": "value",
                    "--nat-gateway-ip": "value",
                    "--router": "value",
                    "--vpc-network": "value",
                    "--vpc-project": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "zones": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "networking": {
          "commands": {
            "interconnects": {
              "commands": {
                "attachments": {
                  "commands": {
                    "dedicated": {
                      "commands": {
                        "create": {
                          "commands": {},
                          "flags": {
                            "--async": "bool",
                            "--description": "value",
                            "--interconnect": "value",
                            "--labels": "value",
                            "--location": "dynamic",
                            "--mtu": "value",
                            "--network": "value",
                            "--vlan-id": "value",
                            "--zone": "dynamic"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic",
                        "--zone": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool",
                        "--zone": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "get-diagnostics": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "networks": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "dynamic",
                    "--mtu": "value",
                    "--zone": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "get-status": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "routers": {
              "commands": {
                "add-bgp-peer": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--interface": "value",
                    "--location": "dynamic",
                    "--peer-asn": "value",
                    "--peer-ipv4-range": "value",
                    "--peer-name": "value",
                    "--zone": "dynamic"
                  }
                },
                "add-interface": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--interconnect-attachment": "value",
                    "--interface-name": "value",
                    "--ip-address": "value",
                    "--ip-mask-length": "value",
                    "--location": "dynamic",
                    "--loopback-ip-addresses": "value",
                    "--subnetwork": "value",
                    "--zone": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--asn": "value",
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "dynamic",
                    "--network": "value",
                    "--zone": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "get-status": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                },
                "remove-bgp-peer": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic",
                    "--peer-name": "value",
                    "--peer-names": "value",
                    "--zone": "dynamic"
                  }
                },
                "remove-interface": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--interface-name": "value",
                    "--interface-names": "value",
                    "--location": "dynamic",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "subnets": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--ipv4-range": "value",
                    "--ipv6-range": "value",
                    "--labels": "value",
                    "--location": "dynamic",
                    "--network": "value",
                    "--vlan-id": "value",
                    "--zone": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic",
                    "--zone": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--zone": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "zones": {
              "commands": {
                "init": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "emulators": {
      "commands": {
        "firestore": {
          "commands": {
            "start": {
              "commands": {},
              "flags": {
                "--database-mode": "value",
                "--export-on-exit": "value",
                "--host-port": "value",
                "--import-data": "value",
                "--rules": "value"
              }
            }
          },
          "flags": {}
        },
        "spanner": {
          "commands": {
            "env-init": {
              "commands": {},
              "flags": {}
            },
            "start": {
              "commands": {},
              "flags": {
                "--enable-fault-injection": "value",
                "--host-port": "value",
                "--rest-port": "value",
                "--use-docker": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "endpoints": {
      "commands": {
        "configs": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--service": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--service": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--service": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "wait": {
              "commands": {},
              "flags": {}
            }
          },
          "flags": {}
        },
        "services": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "check-iam-policy": {
              "commands": {},
              "flags": {}
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool"
              }
            },
            "deploy": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--force": "bool",
                "--validate-only": "bool"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "undelete": {
              "commands": {},
              "flags": {
                "--async": "bool"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "essential-contacts": {
      "commands": {
        "compute": {
          "commands": {},
          "flags": {
            "--filter": "value",
            "--folder": "value",
            "--limit": "value",
            "--notification-categories": "value",
            "--organization": "value",
            "--page-size": "value",
            "--sort-by": "value"
          }
        },
        "create": {
          "commands": {},
          "flags": {
            "--email": "value",
            "--folder": "value",
            "--language": "value",
            "--notification-categories": "value",
            "--organization": "value"
          }
        },
        "delete": {
          "commands": {},
          "flags": {
            "--folder": "value",
            "--organization": "value"
          }
        },
        "describe": {
          "commands": {},
          "flags": {
            "--folder": "value",
            "--organization": "value"
          }
        },
        "list": {
          "commands": {},
          "flags": {
            "--filter": "value",
            "--folder": "value",
            "--limit": "value",
            "--organization": "value",
            "--page-size": "value",
            "--sort-by": "value"
          }
        },
        "update": {
          "commands": {},
          "flags": {
            "--folder": "value",
            "--language": "value",
            "--notification-categories": "value",
            "--organization": "value"
          }
        }
      },
      "flags": {}
    },
    "eventarc": {
      "commands": {
        "audit-logs-provider": {
          "commands": {
            "method-names": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--service-name": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "service-names": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "channel-connections": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--activation-token": "value",
                "--async": "bool",
                "--channel": "value",
                "--labels": "value",
                "--location": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "channels": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--crypto-key": "value",
                "--labels": "value",
                "--location": "value",
                "--provider": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-crypto-key": "bool",
                "--clear-labels": "bool",
                "--crypto-key": "value",
                "--location": "value",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "google-channels": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-crypto-key": "bool",
                "--crypto-key": "value",
                "--location": "value"
              }
            }
          },
          "flags": {}
        },
        "locations": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "providers": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--name": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "triggers": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--channel": "value",
                "--destination-gke-cluster": "value",
                "--destination-gke-location": "value",
                "--destination-gke-namespace": "value",
                "--destination-gke-path": "value",
                "--destination-gke-service": "value",
                "--destination-http-endpoint-uri": "value",
                "--destination-run-path": "value",
                "--destination-run-region": "value",
                "--destination-run-service": "value",
                "--destination-workflow": "value",
                "--destination-workflow-location": "value",
                "--event-data-content-type": "value",
                "--event-filters": "value",
                "--event-filters-path-pattern": "value",
                "--labels": "value",
                "--location": "value",
                "--network-attachment": "value",
                "--service-account": "value",
                "--transport-topic": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-destination-gke-path": "bool",
                "--clear-destination-run-path": "bool",
                "--clear-labels": "bool",
                "--clear-service-account": "bool",
                "--destination-gke-namespace": "value",
                "--destination-gke-path": "value",
                "--destination-gke-service": "value",
                "--destination-run-path": "value",
                "--destination-run-region": "value",
                "--destination-run-service": "value",
                "--destination-workflow": "value",
                "--destination-workflow-location": "value",
                "--event-data-content-type": "value",
                "--event-filters": "value",
                "--event-filters-path-pattern": "value",
                "--location": "value",
                "--remove-labels": "value",
                "--service-account": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "feedback": {
      "commands": {},
      "flags": {
        "--log-file": "value"
      }
    },
    "filestore": {
      "commands": {
        "backups": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--file-share": "value",
                "--instance": "value",
                "--instance-location": "value",
                "--instance-zone": "value",
                "--kms-key": "value",
                "--labels": "value",
                "--region": "value",
                "--tags": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-labels": "bool",
                "--description": "value",
                "--region": "value",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "instances": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--deletion-protection": "bool",
                "--deletion-protection-reason": "value",
                "--description": "value",
                "--file-share": "value",
                "--kms-key": "dynamic",
                "--kms-keyring": "dynamic",
                "--kms-location": "dynamic",
                "--kms-project": "dynamic",
                "--labels": "value",
                "--location": "value",
                "--network": "value",
                "--performance": "value",
                "--region": "value",
                "--source-instance": "value",
                "--tags": "value",
                "--tier": [
                  "basic-hdd",
                  "basic-ssd",
                  "enterprise",
                  "high-scale-ssd",
                  "premium",
                  "regional",
                  "standard",
                  "zonal"
                ],
                "--zone": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--force": "bool",
                "--location": "value",
                "--region": "value",
                "--zone": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--region": "value",
                "--zone": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool",
                "--zone": "value"
              }
            },
            "promote-replica": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--zone": "dynamic"
              }
            },
            "restore": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--file-share": "value",
                "--source-backup": "value",
                "--source-backup-region": "value",
                "--zone": "dynamic"
              }
            },
            "revert": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic",
                "--target-snapshot": "value"
              }
            },
            "snapshots": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--instance": "value",
                    "--instance-location": "value",
                    "--instance-region": "value",
                    "--labels": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--instance": "value",
                    "--instance-location": "value",
                    "--instance-region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--instance": "value",
                    "--instance-location": "value",
                    "--instance-region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "value",
                    "--instance-location": "value",
                    "--instance-region": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--instance": "value",
                    "--instance-location": "value",
                    "--instance-region": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-labels": "bool",
                "--clear-nfs-export-options": "bool",
                "--deletion-protection": "bool",
                "--deletion-protection-reason": "value",
                "--description": "value",
                "--file-share": "value",
                "--location": "value",
                "--performance": "value",
                "--region": "value",
                "--remove-labels": "value",
                "--update-labels": "value",
                "--zone": "value"
              }
            }
          },
          "flags": {}
        },
        "locations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--zone": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--zone": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool",
                "--zone": "value"
              }
            }
          },
          "flags": {}
        },
        "regions": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            }
          },
          "flags": {}
        },
        "zones": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "firebase": {
      "commands": {
        "test": {
          "commands": {
            "android": {
              "commands": {
                "list-device-capacities": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "locales": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "models": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "run": {
                  "commands": {},
                  "flags": {
                    "--additional-apks": "value",
                    "--app": "value",
                    "--app-package": "value",
                    "--async": "bool",
                    "--auto-google-login": "bool",
                    "--client-details": "value",
                    "--device": "value",
                    "--device-ids": "value",
                    "--directories-to-pull": "value",
                    "--environment-variables": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--locales": "value",
                    "--network-profile": "value",
                    "--num-flaky-test-attempts": "value",
                    "--obb-files": "value",
                    "--orientations": "dynamic",
                    "--os-version-ids": "value",
                    "--other-files": "value",
                    "--page-size": "value",
                    "--performance-metrics": "bool",
                    "--record-video": "bool",
                    "--resign": "bool",
                    "--results-bucket": "value",
                    "--results-dir": "value",
                    "--results-history-name": "value",
                    "--robo-directives": "value",
                    "--robo-script": "value",
                    "--scenario-labels": "value",
                    "--scenario-numbers": "value",
                    "--sort-by": "value",
                    "--test": "value",
                    "--test-package": "value",
                    "--test-runner-class": "value",
                    "--test-targets": "value",
                    "--timeout": "value",
                    "--type": [
                      "game-loop",
                      "instrumentation",
                      "robo"
                    ],
                    "--use-orchestrator": "bool"
                  }
                },
                "versions": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "ios": {
              "commands": {
                "list-device-capacities": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "locales": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "models": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "run": {
                  "commands": {},
                  "flags": {
                    "--app": "value",
                    "--async": "bool",
                    "--client-details": "value",
                    "--device": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--num-flaky-test-attempts": "value",
                    "--page-size": "value",
                    "--record-video": "bool",
                    "--results-bucket": "value",
                    "--results-dir": "value",
                    "--results-history-name": "value",
                    "--sort-by": "value",
                    "--test": "value",
                    "--test-special-entitlements": "bool",
                    "--timeout": "value",
                    "--type": [
                      "game-loop",
                      "robo",
                      "xctest"
                    ],
                    "--xcode-version": "value",
                    "--xctestrun-file": "value"
                  }
                },
                "versions": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {}
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "network-profiles": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "firestore": {
      "commands": {
        "backups": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--backup": "value",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--backup": "value",
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "schedules": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--database": "value",
                    "--day-of-week": [
                      "FRI",
                      "MON",
                      "SAT",
                      "SUN",
                      "THU",
                      "TUE",
                      "WED"
                    ],
                    "--recurrence": "value",
                    "--retention": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--backup-schedule": "value",
                    "--database": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--backup-schedule": "value",
                    "--database": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--database": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--backup-schedule": "value",
                    "--database": "value",
                    "--retention": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "databases": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--database": "value",
                "--delete-protection": "bool",
                "--enable-pitr": "bool",
                "--kms-key-name": "value",
                "--location": "value",
                "--type": [
                  "datastore-mode",
                  "firestore-native"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--database": "value",
                "--etag": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--database": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--show-deleted": "bool",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "restore": {
              "commands": {},
              "flags": {
                "--destination-database": "value",
                "--encryption-type": [
                  "customer-managed-encryption",
                  "google-default-encryption",
                  "use-source-encryption"
                ],
                "--kms-key-name": "value",
                "--source-backup": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--database": "value",
                "--delete-protection": "bool",
                "--enable-pitr": "bool",
                "--type": [
                  "datastore-mode",
                  "firestore-native"
                ]
              }
            }
          },
          "flags": {}
        },
        "export": {
          "commands": {},
          "flags": {
            "--async": "bool",
            "--collection-ids": "value",
            "--database": "value",
            "--namespace-ids": "value",
            "--snapshot-time": "value"
          }
        },
        "fields": {
          "commands": {
            "ttls": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--collection-group": "value",
                    "--database": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--collection-group": "value",
                    "--database": "value",
                    "--disable-ttl": "bool",
                    "--enable-ttl": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "import": {
          "commands": {},
          "flags": {
            "--async": "bool",
            "--collection-ids": "value",
            "--database": "value",
            "--namespace-ids": "value"
          }
        },
        "indexes": {
          "commands": {
            "composite": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--api-scope": [
                      "any-api",
                      "datastore-mode-api"
                    ],
                    "--async": "bool",
                    "--collection-group": "value",
                    "--database": "value",
                    "--field-config": "value",
                    "--query-scope": [
                      "collection",
                      "collection-group",
                      "collection-recursive"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--database": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--database": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--database": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "fields": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--collection-group": "value",
                    "--database": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--collection-group": "value",
                    "--database": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-exemption": "bool",
                    "--collection-group": "value",
                    "--database": "value",
                    "--disable-indexes": "bool",
                    "--index": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "locations": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {
                "--database": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--database": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--database": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--database": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "functions": {
      "commands": {
        "add-iam-policy-binding": {
          "commands": {},
          "flags": {
            "--member": "value",
            "--region": "dynamic",
            "--role": "value"
          }
        },
        "add-invoker-policy-binding": {
          "commands": {},
          "flags": {
            "--member": "value",
            "--region": "dynamic"
          }
        },
        "call": {
          "commands": {},
          "flags": {
            "--cloud-event": "value",
            "--data": "value",
            "--region": "dynamic"
          }
        },
        "delete": {
          "commands": {},
          "flags": {
            "--region": "dynamic"
          }
        },
        "deploy": {
          "commands": {},
          "flags": {
            "--allow-unauthenticated": "bool",
            "--binary-authorization": "value",
            "--build-env-vars-file": "value",
            "--build-service-account": "value",
            "--build-worker-pool": "value",
            "--clear-binary-authorization": "bool",
            "--clear-build-env-vars": "bool",
            "--clear-build-service-account": "bool",
            "--clear-build-worker-pool": "bool",
            "--clear-docker-repository": "bool",
            "--clear-env-vars": "bool",
            "--clear-kms-key": "bool",
            "--clear-labels": "bool",
            "--clear-max-instances": "bool",
            "--clear-min-instances": "bool",
            "--clear-secrets": "bool",
            "--clear-vpc-connector": "bool",
            "--concurrency": "value",
            "--cpu": "value",
            "--docker-registry": [
              "artifact-registry",
              "container-registry"
            ],
            "--docker-repository": "value",
            "--egress-settings": [
              "all",
              "private-ranges-only"
            ],
            "--entry-point": "value",
            "--env-vars-file": "value",
            "--gen2": "bool",
            "--ignore-file": "value",
            "--ingress-settings": [
              "all",
              "internal-and-gclb",
              "internal-only"
            ],
            "--kms-key": "value",
            "--max-instances": "value",
            "--memory": "value",
            "--min-instances": "value",
            "--region": "dynamic",
            "--remove-build-env-vars": "value",
            "--remove-env-vars": "value",
            "--remove-labels": "value",
            "--remove-secrets": "value",
            "--retry": "bool",
            "--run-service-account": "value",
            "--runtime": "value",
            "--runtime-update-policy": [
              "automatic",
              "on-deploy"
            ],
            "--security-level": [
              "secure-always",
              "secure-optional"
            ],
            "--serve-all-traffic-latest-revision": "bool",
            "--service-account": "value",
            "--set-build-env-vars": "value",
            "--set-env-vars": "value",
            "--set-secrets": "value",
            "--source": "dynamic",
            "--stage-bucket": "value",
            "--timeout": "value",
            "--trigger-bucket": "value",
            "--trigger-event": "value",
            "--trigger-event-filters": "value",
            "--trigger-event-filters-path-pattern": "value",
            "--trigger-http": "bool",
            "--trigger-location": "dynamic",
            "--trigger-resource": "value",
            "--trigger-service-account": "value",
            "--trigger-topic": "value",
            "--update-build-env-vars": "value",
            "--update-env-vars": "value",
            "--update-labels": "value",
            "--update-secrets": "value",
            "--vpc-connector": "dynamic"
          }
        },
        "describe": {
          "commands": {},
          "flags": {
            "--region": "dynamic",
            "--v2": "bool"
          }
        },
        "event-types": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--gen2": "bool"
              }
            }
          },
          "flags": {}
        },
        "get-iam-policy": {
          "commands": {},
          "flags": {
            "--filter": "value",
            "--limit": "value",
            "--page-size": "value",
            "--region": "dynamic",
            "--sort-by": "value",
            "--uri": "bool"
          }
        },
        "list": {
          "commands": {},
          "flags": {
            "--filter": "value",
            "--limit": "value",
            "--page-size": "value",
            "--regions": "value",
            "--sort-by": "value",
            "--v2": "bool"
          }
        },
        "logs": {
          "commands": {
            "read": {
              "commands": {},
              "flags": {
                "--end-time": "value",
                "--execution-id": "value",
                "--filter": "value",
                "--gen2": "bool",
                "--limit": "value",
                "--min-log-level": [
                  "debug",
                  "error",
                  "info"
                ],
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--start-time": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "regions": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--gen2": "bool",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "remove-iam-policy-binding": {
          "commands": {},
          "flags": {
            "--member": "value",
            "--region": "dynamic",
            "--role": "value"
          }
        },
        "remove-invoker-policy-binding": {
          "commands": {},
          "flags": {
            "--member": "value",
            "--region": "dynamic"
          }
        },
        "runtimes": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "set-iam-policy": {
          "commands": {},
          "flags": {
            "--region": "dynamic"
          }
        }
      },
      "flags": {}
    },
    "gemini": {
      "commands": {
        "code-repository-indexes": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--kms-key": "value",
                "--labels": "value",
                "--location": "value",
                "--request-id": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--force": "bool",
                "--location": "value",
                "--request-id": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "repository-groups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--code-repository-index": "dynamic",
                    "--labels": "value",
                    "--location": "value",
                    "--repositories": "value",
                    "--request-id": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--code-repository-index": "dynamic",
                    "--location": "value",
                    "--request-id": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--code-repository-index": "dynamic",
                    "--location": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--code-repository-index": "dynamic",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--code-repository-index": "dynamic",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--code-repository-index": "dynamic",
                    "--location": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-repositories": "value",
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--clear-repositories": "bool",
                    "--code-repository-index": "dynamic",
                    "--labels": "value",
                    "--location": "value",
                    "--remove-labels": "value",
                    "--remove-repositories": "value",
                    "--repositories": "value",
                    "--request-id": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-labels": "bool",
                "--labels": "value",
                "--location": "value",
                "--remove-labels": "value",
                "--request-id": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "wait": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "healthcare": {
      "commands": {
        "consent-stores": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--dataset": "value",
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "check-data-access": {
              "commands": {},
              "flags": {
                "--data-id": "value",
                "--dataset": "value",
                "--location": "value",
                "--request-attributes": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--labels": "value",
                "--location": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--location": "value"
              }
            },
            "evaluate-user-consents": {
              "commands": {},
              "flags": {
                "--consent-list": "value",
                "--dataset": "value",
                "--location": "value",
                "--page-size": "value",
                "--page-token": "value",
                "--request-attributes": "value",
                "--resource-attributes": "value",
                "--response-view": [
                  "basic",
                  "full",
                  "response-view-unspecified"
                ],
                "--user-id": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "query-accessible-data": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--dataset": "value",
                "--gcs-uri": "value",
                "--location": "value",
                "--request-attributes": "value",
                "--resource-attributes": "value"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--dataset": "value",
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-labels": "bool",
                "--dataset": "value",
                "--location": "value",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "datasets": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--encryption-key": "value",
                "--location": "value",
                "--time-zone": "value"
              }
            },
            "deidentify": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--default-fhir-config": "bool",
                "--destination-dataset": "value",
                "--dicom-filter-tags": "value",
                "--location": "value",
                "--text-redaction-mode": [
                  "all"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--time-zone": "value"
              }
            }
          },
          "flags": {}
        },
        "dicom-stores": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--dataset": "value",
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--location": "value",
                "--pubsub-topic": "value",
                "--send-for-bulk-import": "bool",
                "--stream-configs": "value"
              }
            },
            "deidentify": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--dataset": "value",
                "--destination-store": "value",
                "--dicom-filter-tags": "value",
                "--location": "value",
                "--text-redaction-mode": [
                  "all"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--location": "value"
              }
            },
            "export": {
              "commands": {
                "bq": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--bq-table": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--overwrite-table": "bool",
                    "--write-disposition": [
                      "write-append",
                      "write-empty",
                      "write-truncate"
                    ]
                  }
                },
                "gcs": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--dataset": "value",
                    "--gcs-uri-prefix": "value",
                    "--location": "value",
                    "--mime-type": "value"
                  }
                }
              },
              "flags": {}
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "import": {
              "commands": {
                "gcs": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--dataset": "value",
                    "--gcs-uri": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "metrics": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--location": "value"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--dataset": "value",
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--location": "value",
                "--pubsub-topic": "value",
                "--send-for-bulk-import": "bool",
                "--stream-configs": "value"
              }
            }
          },
          "flags": {}
        },
        "fhir-stores": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--dataset": "value",
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--disable-referential-integrity": "bool",
                "--disable-resource-versioning": "bool",
                "--enable-update-create": "bool",
                "--location": "value",
                "--pubsub-topic": "value"
              }
            },
            "deidentify": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--dataset": "value",
                "--destination-store": "value",
                "--location": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--location": "value"
              }
            },
            "export": {
              "commands": {
                "bq": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--bq-dataset": "value",
                    "--dataset": "value",
                    "--location": "value",
                    "--recursive-depth": "value",
                    "--resource-type": "value",
                    "--schema-type": [
                      "analytics",
                      "analytics_v2"
                    ],
                    "--since": "value",
                    "--write-disposition": [
                      "write-append",
                      "write-empty",
                      "write-truncate"
                    ]
                  }
                },
                "gcs": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--dataset": "value",
                    "--gcs-uri": "value",
                    "--location": "value",
                    "--resource-type": "value",
                    "--since": "value"
                  }
                }
              },
              "flags": {}
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "import": {
              "commands": {
                "gcs": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--content-structure": [
                      "bundle",
                      "bundle-pretty",
                      "resource",
                      "resource-pretty"
                    ],
                    "--dataset": "value",
                    "--gcs-uri": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "metrics": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--location": "value"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--dataset": "value",
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--enable-update-create": "bool",
                "--location": "value",
                "--pubsub-topic": "value"
              }
            }
          },
          "flags": {}
        },
        "hl7v2-stores": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--dataset": "value",
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--location": "value",
                "--notification-config": "value",
                "--parser-version": [
                  "v1",
                  "v2",
                  "v3"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--location": "value"
              }
            },
            "export": {
              "commands": {
                "gcs": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--dataset": "value",
                    "--end-time": "value",
                    "--gcs-uri": "value",
                    "--location": "value",
                    "--message-view": [
                      "basic",
                      "full",
                      "parsed-only",
                      "raw-only",
                      "schematized-only"
                    ],
                    "--start-time": "value"
                  }
                }
              },
              "flags": {}
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "import": {
              "commands": {
                "gcs": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--dataset": "value",
                    "--gcs-uri": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "metrics": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--location": "value"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--dataset": "value",
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--location": "value",
                "--notification-config": "value"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "help": {
      "commands": {},
      "flags": {
        "--filter": "value",
        "--limit": "value",
        "--page-size": "value",
        "--sort-by": "value"
      }
    },
    "iam": {
      "commands": {
        "list-grantable-roles": {
          "commands": {},
          "flags": {
            "--filter": "value",
            "--page-size": "value"
          }
        },
        "list-testable-permissions": {
          "commands": {},
          "flags": {
            "--filter": "value"
          }
        },
        "oauth-clients": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--allowed-grant-types": "value",
                "--allowed-redirect-uris": "value",
                "--allowed-scopes": "value",
                "--client-type": [
                  "confidential-client",
                  "public-client"
                ],
                "--description": "value",
                "--disabled": "bool",
                "--display-name": "value",
                "--location": "value"
              }
            },
            "credentials": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--disabled": "bool",
                    "--display-name": "value",
                    "--location": "value",
                    "--oauth-client": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--oauth-client": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--oauth-client": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--oauth-client": "dynamic",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--disabled": "bool",
                    "--display-name": "value",
                    "--location": "value",
                    "--oauth-client": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--show-deleted": "bool",
                "--sort-by": "value"
              }
            },
            "undelete": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--allowed-grant-types": "value",
                "--allowed-redirect-uris": "value",
                "--allowed-scopes": "value",
                "--description": "value",
                "--disabled": "bool",
                "--display-name": "value",
                "--location": "value"
              }
            }
          },
          "flags": {}
        },
        "policies": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--attachment-point": "value",
                "--kind": "value",
                "--policy-file": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--attachment-point": "value",
                "--etag": "value",
                "--kind": "value"
              }
            },
            "get": {
              "commands": {},
              "flags": {
                "--attachment-point": "value",
                "--kind": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--attachment-point": "value",
                "--filter": "value",
                "--kind": "value",
                "--limit": "value",
                "--page-size": "value",
                "--page_token": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--attachment-point": "value",
                "--etag": "value",
                "--kind": "value",
                "--policy-file": "value"
              }
            }
          },
          "flags": {}
        },
        "policy-bindings": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--annotations": "value",
                "--async": "bool",
                "--condition-description": "value",
                "--condition-expression": "value",
                "--condition-location": "value",
                "--condition-title": "value",
                "--display-name": "value",
                "--etag": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "value",
                "--policy": "value",
                "--policy-kind": [
                  "principal-access-boundary"
                ],
                "--target-principal-set": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--etag": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--location": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "search-target-policy-bindings": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--location": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--target": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--annotations": "value",
                "--async": "bool",
                "--clear-annotations": "bool",
                "--condition-description": "value",
                "--condition-expression": "value",
                "--condition-location": "value",
                "--condition-title": "value",
                "--display-name": "value",
                "--etag": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "value",
                "--remove-annotations": "value",
                "--update-annotations": "value"
              }
            }
          },
          "flags": {}
        },
        "principal-access-boundary-policies": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--annotations": "value",
                "--async": "bool",
                "--details-enforcement-version": "value",
                "--details-rules": "value",
                "--display-name": "value",
                "--etag": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--etag": "value",
                "--force": "bool",
                "--location": "value",
                "--organization": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "search-policy-bindings": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-details-rules": "value",
                "--annotations": "value",
                "--async": "bool",
                "--clear-annotations": "bool",
                "--clear-details-rules": "bool",
                "--details-enforcement-version": "value",
                "--details-rules": "value",
                "--display-name": "value",
                "--etag": "value",
                "--location": "value",
                "--organization": "value",
                "--remove-annotations": "value",
                "--remove-details-rules": "value",
                "--update-annotations": "value"
              }
            }
          },
          "flags": {}
        },
        "roles": {
          "commands": {
            "copy": {
              "commands": {},
              "flags": {
                "--dest-organization": "value",
                "--dest-project": "value",
                "--destination": "value",
                "--source": "value",
                "--source-organization": "value",
                "--source-project": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--file": "value",
                "--organization": "value",
                "--permissions": "value",
                "--stage": "value",
                "--title": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--organization": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--organization": "value",
                "--show-deleted": "bool",
                "--sort-by": "value"
              }
            },
            "undelete": {
              "commands": {},
              "flags": {
                "--organization": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-permissions": "value",
                "--description": "value",
                "--file": "value",
                "--organization": "value",
                "--permissions": "value",
                "--remove-permissions": "value",
                "--stage": "value",
                "--title": "value"
              }
            }
          },
          "flags": {}
        },
        "service-accounts": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--display-name": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "disable": {
              "commands": {},
              "flags": {}
            },
            "enable": {
              "commands": {},
              "flags": {}
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "keys": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--iam-account": "value",
                    "--key-file-type": [
                      "json",
                      "p12"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--iam-account": "value"
                  }
                },
                "disable": {
                  "commands": {},
                  "flags": {
                    "--iam-account": "dynamic"
                  }
                },
                "enable": {
                  "commands": {},
                  "flags": {
                    "--iam-account": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--created-before": "value",
                    "--filter": "value",
                    "--iam-account": "value",
                    "--limit": "value",
                    "--managed-by": [
                      "any",
                      "system",
                      "user"
                    ],
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "upload": {
                  "commands": {},
                  "flags": {
                    "--iam-account": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {}
            },
            "sign-blob": {
              "commands": {},
              "flags": {
                "--iam-account": "value"
              }
            },
            "sign-jwt": {
              "commands": {},
              "flags": {
                "--iam-account": "value"
              }
            },
            "undelete": {
              "commands": {},
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--display-name": "value"
              }
            }
          },
          "flags": {}
        },
        "simulator": {
          "commands": {
            "replay-recent-access": {
              "commands": {},
              "flags": {}
            }
          },
          "flags": {}
        },
        "workforce-pools": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--allowed-services": "value",
                "--async": "bool",
                "--description": "value",
                "--disable-programmatic-signin": "bool",
                "--disabled": "bool",
                "--display-name": "value",
                "--location": "value",
                "--organization": "value",
                "--session-duration": "value"
              }
            },
            "create-cred-config": {
              "commands": {},
              "flags": {
                "--credential-source-field-name": "value",
                "--credential-source-file": "value",
                "--credential-source-headers": "value",
                "--credential-source-type": "value",
                "--credential-source-url": "value",
                "--executable-command": "value",
                "--executable-interactive-timeout-millis": "value",
                "--executable-output-file": "value",
                "--executable-timeout-millis": "value",
                "--output-file": "value",
                "--service-account": "value",
                "--service-account-token-lifetime-seconds": "value",
                "--subject-token-type": "value",
                "--workforce-pool-user-project": "value"
              }
            },
            "create-login-config": {
              "commands": {},
              "flags": {
                "--activate": "bool",
                "--output-file": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--organization": "value",
                "--page-size": "value",
                "--show-deleted": "bool",
                "--sort-by": "value"
              }
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--workforce-pool": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "providers": {
              "commands": {
                "create-oidc": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--attribute-condition": "value",
                    "--attribute-mapping": "value",
                    "--client-id": "value",
                    "--client-secret-value": "value",
                    "--description": "value",
                    "--disabled": "bool",
                    "--display-name": "value",
                    "--extra-attributes-client-id": "value",
                    "--extra-attributes-client-secret-value": "value",
                    "--extra-attributes-filter": "value",
                    "--extra-attributes-issuer-uri": "value",
                    "--extra-attributes-type": "value",
                    "--issuer-uri": "value",
                    "--jwk-json-path": "value",
                    "--location": "value",
                    "--web-sso-additional-scopes": "value",
                    "--web-sso-assertion-claims-behavior": [
                      "assertion-claims-behavior-unspecified",
                      "merge-user-info-over-id-token-claims",
                      "only-id-token-claims"
                    ],
                    "--web-sso-response-type": [
                      "code",
                      "id-token",
                      "response-type-unspecified"
                    ],
                    "--workforce-pool": "dynamic"
                  }
                },
                "create-saml": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--attribute-condition": "value",
                    "--attribute-mapping": "value",
                    "--description": "value",
                    "--disabled": "bool",
                    "--display-name": "value",
                    "--idp-metadata-path": "value",
                    "--location": "value",
                    "--workforce-pool": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--workforce-pool": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--workforce-pool": "dynamic"
                  }
                },
                "keys": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--provider": "dynamic",
                        "--spec": [
                          "key-spec-unspecified",
                          "rsa-2048",
                          "rsa-3072",
                          "rsa-4096"
                        ],
                        "--use": [
                          "encryption",
                          "key-use-unspecified"
                        ],
                        "--workforce-pool": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--provider": "dynamic",
                        "--workforce-pool": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--provider": "dynamic",
                        "--workforce-pool": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--provider": "dynamic",
                        "--show-deleted": "bool",
                        "--sort-by": "value",
                        "--workforce-pool": "dynamic"
                      }
                    },
                    "operations": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--key": "dynamic",
                            "--location": "value",
                            "--provider": "dynamic",
                            "--workforce-pool": "dynamic"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "undelete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--provider": "dynamic",
                        "--workforce-pool": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--show-deleted": "bool",
                    "--sort-by": "value",
                    "--workforce-pool": "dynamic"
                  }
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--provider": "dynamic",
                        "--workforce-pool": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "undelete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--workforce-pool": "dynamic"
                  }
                },
                "update-oidc": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--attribute-condition": "value",
                    "--attribute-mapping": "value",
                    "--clear-client-secret": "bool",
                    "--clear-extra-attributes-config": "bool",
                    "--client-id": "value",
                    "--client-secret-value": "value",
                    "--description": "value",
                    "--disabled": "bool",
                    "--display-name": "value",
                    "--extra-attributes-client-id": "value",
                    "--extra-attributes-client-secret-value": "value",
                    "--extra-attributes-filter": "value",
                    "--extra-attributes-issuer-uri": "value",
                    "--extra-attributes-type": "value",
                    "--issuer-uri": "value",
                    "--jwk-json-path": "value",
                    "--location": "value",
                    "--web-sso-additional-scopes": "value",
                    "--web-sso-assertion-claims-behavior": [
                      "assertion-claims-behavior-unspecified",
                      "merge-user-info-over-id-token-claims",
                      "only-id-token-claims"
                    ],
                    "--web-sso-response-type": [
                      "code",
                      "id-token",
                      "response-type-unspecified"
                    ],
                    "--workforce-pool": "dynamic"
                  }
                },
                "update-saml": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--attribute-condition": "value",
                    "--attribute-mapping": "value",
                    "--description": "value",
                    "--disabled": "bool",
                    "--display-name": "value",
                    "--idp-metadata-path": "value",
                    "--location": "value",
                    "--workforce-pool": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "subjects": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--workforce-pool": "dynamic"
                  }
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--subject": "value",
                        "--workforce-pool": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "undelete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--workforce-pool": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "undelete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--disable-programmatic-signin": "bool",
                "--disabled": "bool",
                "--display-name": "value",
                "--location": "value",
                "--session-duration": "value"
              }
            }
          },
          "flags": {}
        },
        "workload-identity-pools": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--disabled": "bool",
                "--display-name": "value",
                "--location": "value"
              }
            },
            "create-cred-config": {
              "commands": {},
              "flags": {
                "--app-id-uri": "value",
                "--aws": "bool",
                "--azure": "bool",
                "--credential-cert-configuration-output-file": "value",
                "--credential-cert-path": "value",
                "--credential-cert-private-key-path": "value",
                "--credential-source-field-name": "value",
                "--credential-source-file": "value",
                "--credential-source-headers": "value",
                "--credential-source-type": "value",
                "--credential-source-url": "value",
                "--enable-imdsv2": "bool",
                "--executable-command": "value",
                "--executable-output-file": "value",
                "--executable-timeout-millis": "value",
                "--output-file": "value",
                "--service-account": "value",
                "--service-account-token-lifetime-seconds": "value",
                "--subject-token-type": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--show-deleted": "bool",
                "--sort-by": "value"
              }
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--workload-identity-pool": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "providers": {
              "commands": {
                "create-aws": {
                  "commands": {},
                  "flags": {
                    "--account-id": "value",
                    "--attribute-condition": "value",
                    "--attribute-mapping": "value",
                    "--description": "value",
                    "--disabled": "bool",
                    "--display-name": "value",
                    "--location": "value",
                    "--workload-identity-pool": "dynamic"
                  }
                },
                "create-oidc": {
                  "commands": {},
                  "flags": {
                    "--allowed-audiences": "value",
                    "--attribute-condition": "value",
                    "--attribute-mapping": "value",
                    "--description": "value",
                    "--disabled": "bool",
                    "--display-name": "value",
                    "--issuer-uri": "value",
                    "--jwk-json-path": "value",
                    "--location": "value",
                    "--workload-identity-pool": "dynamic"
                  }
                },
                "create-saml": {
                  "commands": {},
                  "flags": {
                    "--attribute-condition": "value",
                    "--attribute-mapping": "value",
                    "--description": "value",
                    "--disabled": "bool",
                    "--display-name": "value",
                    "--idp-metadata-path": "value",
                    "--location": "value",
                    "--workload-identity-pool": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--workload-identity-pool": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--workload-identity-pool": "dynamic"
                  }
                },
                "keys": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--provider": "dynamic",
                        "--spec": [
                          "key-spec-unspecified",
                          "rsa-2048",
                          "rsa-3072",
                          "rsa-4096"
                        ],
                        "--use": [
                          "encryption",
                          "key-use-unspecified"
                        ],
                        "--workload-identity-pool": "dynamic"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--provider": "dynamic",
                        "--workload-identity-pool": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--provider": "dynamic",
                        "--workload-identity-pool": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--provider": "dynamic",
                        "--show-deleted": "bool",
                        "--sort-by": "value",
                        "--workload-identity-pool": "dynamic"
                      }
                    },
                    "operations": {
                      "commands": {
                        "describe": {
                          "commands": {},
                          "flags": {
                            "--key": "dynamic",
                            "--location": "value",
                            "--provider": "dynamic",
                            "--workload-identity-pool": "dynamic"
                          }
                        }
                      },
                      "flags": {}
                    },
                    "undelete": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "value",
                        "--provider": "dynamic",
                        "--workload-identity-pool": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--show-deleted": "bool",
                    "--sort-by": "value",
                    "--workload-identity-pool": "dynamic"
                  }
                },
                "operations": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--provider": "dynamic",
                        "--workload-identity-pool": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                },
                "undelete": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--workload-identity-pool": "dynamic"
                  }
                },
                "update-aws": {
                  "commands": {},
                  "flags": {
                    "--account-id": "value",
                    "--attribute-condition": "value",
                    "--attribute-mapping": "value",
                    "--description": "value",
                    "--disabled": "bool",
                    "--display-name": "value",
                    "--location": "value",
                    "--workload-identity-pool": "dynamic"
                  }
                },
                "update-oidc": {
                  "commands": {},
                  "flags": {
                    "--allowed-audiences": "value",
                    "--attribute-condition": "value",
                    "--attribute-mapping": "value",
                    "--description": "value",
                    "--disabled": "bool",
                    "--display-name": "value",
                    "--issuer-uri": "value",
                    "--jwk-json-path": "value",
                    "--location": "value",
                    "--workload-identity-pool": "dynamic"
                  }
                },
                "update-saml": {
                  "commands": {},
                  "flags": {
                    "--attribute-condition": "value",
                    "--attribute-mapping": "value",
                    "--description": "value",
                    "--disabled": "bool",
                    "--display-name": "value",
                    "--idp-metadata-path": "value",
                    "--location": "value",
                    "--workload-identity-pool": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "undelete": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--disabled": "bool",
                "--display-name": "value",
                "--location": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "iap": {
      "commands": {
        "oauth-brands": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--application_title": "value",
                "--support_email": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            }
          },
          "flags": {}
        },
        "oauth-clients": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--display_name": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--brand": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--brand": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "reset-secret": {
              "commands": {},
              "flags": {
                "--brand": "value"
              }
            }
          },
          "flags": {}
        },
        "settings": {
          "commands": {
            "get": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "value",
                "--region": "value",
                "--resource-type": [
                  "app-engine",
                  "backend-services",
                  "compute",
                  "folder",
                  "iap_web",
                  "organization"
                ],
                "--service": "value"
              }
            },
            "set": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "value",
                "--region": "value",
                "--resource-type": [
                  "app-engine",
                  "backend-services",
                  "compute",
                  "folder",
                  "iap_web",
                  "organization"
                ],
                "--service": "value"
              }
            }
          },
          "flags": {}
        },
        "tcp": {
          "commands": {
            "dest-groups": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--dest-group": "value",
                    "--member": "value",
                    "--region": "value",
                    "--role": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--fqdn-list": "value",
                    "--ip-range-list": "value",
                    "--region": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--dest-group": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--dest-group": "value",
                    "--member": "value",
                    "--region": "value",
                    "--role": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--dest-group": "value",
                    "--region": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--fqdn-list": "value",
                    "--ip-range-list": "value",
                    "--region": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "web": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--region": "value",
                "--resource-type": [
                  "app-engine",
                  "backend-services"
                ],
                "--role": "value",
                "--service": "value"
              }
            },
            "disable": {
              "commands": {},
              "flags": {
                "--region": "value",
                "--resource-type": [
                  "app-engine",
                  "backend-services"
                ],
                "--service": "value"
              }
            },
            "enable": {
              "commands": {},
              "flags": {
                "--oauth2-client-id": "value",
                "--oauth2-client-secret": "value",
                "--region": "value",
                "--resource-type": [
                  "app-engine",
                  "backend-services"
                ],
                "--service": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--resource-type": [
                  "app-engine",
                  "backend-services"
                ],
                "--service": "value",
                "--sort-by": "value"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--region": "value",
                "--resource-type": [
                  "app-engine",
                  "backend-services"
                ],
                "--role": "value",
                "--service": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--region": "value",
                "--resource-type": [
                  "app-engine",
                  "backend-services"
                ],
                "--service": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "identity": {
      "commands": {
        "groups": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--customer": "value",
                "--description": "value",
                "--display-name": "value",
                "--dynamic-user-query": "value",
                "--group-type": [
                  "discussion",
                  "dynamic",
                  "security"
                ],
                "--labels": "value",
                "--organization": "value",
                "--with-initial-owner": [
                  "empty",
                  "with-initial-owner"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "memberships": {
              "commands": {
                "add": {
                  "commands": {},
                  "flags": {
                    "--expiration": "value",
                    "--group-email": "value",
                    "--member-email": "value",
                    "--roles": "value"
                  }
                },
                "check-transitive-membership": {
                  "commands": {},
                  "flags": {
                    "--group-email": "value",
                    "--member-email": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--group-email": "value",
                    "--member-email": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--group-email": "value",
                    "--member-email": "value"
                  }
                },
                "get-membership-graph": {
                  "commands": {},
                  "flags": {
                    "--group-email": "value",
                    "--labels": "value",
                    "--member-email": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--group-email": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--page-token": "value",
                    "--sort-by": "value",
                    "--view": [
                      "basic",
                      "full"
                    ]
                  }
                },
                "modify-membership-roles": {
                  "commands": {},
                  "flags": {
                    "--add-roles": "value",
                    "--group-email": "value",
                    "--member-email": "value",
                    "--remove-roles": "value",
                    "--update-roles-params": "value"
                  }
                },
                "search-transitive-groups": {
                  "commands": {},
                  "flags": {
                    "--labels": "value",
                    "--member-email": "value",
                    "--page-size": "value",
                    "--page-token": "value"
                  }
                },
                "search-transitive-memberships": {
                  "commands": {},
                  "flags": {
                    "--group-email": "value",
                    "--page-size": "value",
                    "--page-token": "value"
                  }
                }
              },
              "flags": {}
            },
            "search": {
              "commands": {},
              "flags": {
                "--customer": "value",
                "--labels": "value",
                "--organization": "value",
                "--page-size": "value",
                "--page-token": "value",
                "--view": [
                  "basic",
                  "full"
                ]
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-description": "bool",
                "--clear-display-name": "bool",
                "--description": "value",
                "--display-name": "value",
                "--dynamic-user-query": "value",
                "--labels": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "ids": {
      "commands": {
        "endpoints": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--enable-traffic-logs": "bool",
                "--labels": "value",
                "--max-wait": "value",
                "--network": "value",
                "--severity": [
                  "CRITICAL",
                  "HIGH",
                  "INFORMATIONAL",
                  "LOW",
                  "MEDIUM"
                ],
                "--threat-exceptions": "value",
                "--zone": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--max-wait": "value",
                "--zone": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--zone": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--max-wait": "value",
                "--threat-exceptions": "value",
                "--zone": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "immersive-stream": {
      "commands": {
        "xr": {
          "commands": {
            "contents": {
              "commands": {
                "build": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--bucket": "value",
                    "--location": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--bucket": "value",
                    "--location": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "instances": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--add-region": "value",
                    "--async": "bool",
                    "--content": "value",
                    "--fallback-url": "value",
                    "--gpu-class": "value",
                    "--location": "value",
                    "--mode": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-region": "value",
                    "--async": "bool",
                    "--fallback-url": "value",
                    "--location": "value",
                    "--remove-region": "value",
                    "--update-region": "value"
                  }
                }
              },
              "flags": {}
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "info": {
      "commands": {},
      "flags": {
        "--anonymize": "bool",
        "--run-diagnostics": "bool",
        "--show-log": "bool"
      }
    },
    "infra-manager": {
      "commands": {
        "deployments": {
          "commands": {
            "apply": {
              "commands": {},
              "flags": {
                "--annotations": "value",
                "--artifacts-gcs-bucket": "value",
                "--async": "bool",
                "--gcs-source": "value",
                "--git-source-directory": "value",
                "--git-source-ref": "value",
                "--git-source-repo": "value",
                "--ignore-file": "value",
                "--import-existing-resources": "bool",
                "--input-values": "value",
                "--inputs-file": "value",
                "--labels": "value",
                "--local-source": "value",
                "--location": "dynamic",
                "--quota-validation": "value",
                "--service-account": "value",
                "--tf-version-constraint": "value",
                "--worker-pool": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--delete-policy": [
                  "abandon",
                  "delete",
                  "delete-policy-unspecified"
                ],
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "export-lock": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "export-statefile": {
              "commands": {},
              "flags": {
                "--draft": "bool",
                "--file": "value",
                "--location": "dynamic"
              }
            },
            "import-statefile": {
              "commands": {},
              "flags": {
                "--file": "value",
                "--location": "dynamic",
                "--lock-id": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "lock": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "unlock": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic",
                "--lock-id": "value"
              }
            }
          },
          "flags": {}
        },
        "previews": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--annotations": "value",
                "--artifacts-gcs-bucket": "value",
                "--async": "bool",
                "--deployment": "value",
                "--gcs-source": "value",
                "--git-source-directory": "value",
                "--git-source-ref": "value",
                "--git-source-repo": "value",
                "--ignore-file": "value",
                "--input-values": "value",
                "--inputs-file": "value",
                "--labels": "value",
                "--local-source": "value",
                "--location": "dynamic",
                "--preview-mode": "value",
                "--service-account": "value",
                "--worker-pool": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--file": "value",
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "resources": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--deployment": "dynamic",
                "--location": "dynamic",
                "--revision": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--deployment": "dynamic",
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--revision": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "revisions": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--deployment": "dynamic",
                "--location": "dynamic"
              }
            },
            "export-statefile": {
              "commands": {},
              "flags": {
                "--deployment": "dynamic",
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--deployment": "dynamic",
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "terraform-versions": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "init": {
      "commands": {},
      "flags": {
        "--console-only": "bool",
        "--no-browser": "bool",
        "--no-launch-browser": "bool",
        "--skip-diagnostics": "bool"
      }
    },
    "kms": {
      "commands": {
        "asymmetric-decrypt": {
          "commands": {},
          "flags": {
            "--ciphertext-file": "value",
            "--key": "dynamic",
            "--keyring": "dynamic",
            "--location": "dynamic",
            "--plaintext-file": "value",
            "--skip-integrity-verification": "bool"
          }
        },
        "asymmetric-sign": {
          "commands": {},
          "flags": {
            "--digest-algorithm": [
              "sha256",
              "sha384",
              "sha512"
            ],
            "--input-file": "value",
            "--key": "dynamic",
            "--keyring": "dynamic",
            "--location": "dynamic",
            "--signature-file": "value",
            "--skip-integrity-verification": "bool"
          }
        },
        "decrypt": {
          "commands": {},
          "flags": {
            "--additional-authenticated-data-file": "value",
            "--ciphertext-file": "value",
            "--key": "dynamic",
            "--keyring": "dynamic",
            "--location": "dynamic",
            "--plaintext-file": "value",
            "--skip-integrity-verification": "bool"
          }
        },
        "ekm-config": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--location": "dynamic",
                "--member": "value",
                "--role": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--location": "dynamic",
                "--member": "value",
                "--role": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--default-ekm-connection": "value",
                "--location": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "ekm-connections": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--crypto-space-path": "value",
                "--endpoint-filter": "value",
                "--hostname": "value",
                "--key-management-mode": [
                  "cloud-kms",
                  "manual"
                ],
                "--location": "dynamic",
                "--server-certificates-files": "value",
                "--service-directory-service": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--crypto-space-path": "value",
                "--endpoint-filter": "value",
                "--hostname": "value",
                "--key-management-mode": [
                  "cloud-kms",
                  "manual"
                ],
                "--location": "dynamic",
                "--server-certificates-files": "value",
                "--service-directory-service": "value"
              }
            }
          },
          "flags": {}
        },
        "encrypt": {
          "commands": {},
          "flags": {
            "--additional-authenticated-data-file": "value",
            "--ciphertext-file": "value",
            "--key": "dynamic",
            "--keyring": "dynamic",
            "--location": "dynamic",
            "--plaintext-file": "value",
            "--skip-integrity-verification": "bool"
          }
        },
        "import-jobs": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--keyring": "value",
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--import-method": [
                  "rsa-oaep-3072-sha1-aes-256",
                  "rsa-oaep-3072-sha256",
                  "rsa-oaep-3072-sha256-aes-256",
                  "rsa-oaep-4096-sha1-aes-256",
                  "rsa-oaep-4096-sha256",
                  "rsa-oaep-4096-sha256-aes-256"
                ],
                "--keyring": "dynamic",
                "--location": "dynamic",
                "--protection-level": [
                  "hsm",
                  "software"
                ]
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--attestation-file": "value",
                "--keyring": "dynamic",
                "--location": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--keyring": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--keyring": "dynamic",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--keyring": "value",
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--keyring": "value",
                "--location": "value"
              }
            }
          },
          "flags": {}
        },
        "inventory": {
          "commands": {
            "get-protected-resources-summary": {
              "commands": {},
              "flags": {
                "--keyname": "dynamic",
                "--keyring": "dynamic",
                "--location": "dynamic"
              }
            },
            "list-keys": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "search-protected-resources": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--keyname": "dynamic",
                "--keyring": "dynamic",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--resource-types": "value",
                "--scope": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "keyrings": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "keys": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--keyring": "value",
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--allowed-access-reasons": "value",
                "--crypto-key-backend": "value",
                "--default-algorithm": [
                  "aes-128-cbc",
                  "aes-128-ctr",
                  "aes-128-gcm",
                  "aes-256-cbc",
                  "aes-256-ctr",
                  "aes-256-gcm",
                  "ec-sign-ed25519",
                  "ec-sign-p256-sha256",
                  "ec-sign-p384-sha384",
                  "ec-sign-secp256k1-sha256",
                  "external-symmetric-encryption",
                  "google-symmetric-encryption",
                  "hmac-sha1",
                  "hmac-sha224",
                  "hmac-sha256",
                  "hmac-sha384",
                  "hmac-sha512",
                  "rsa-decrypt-oaep-2048-sha1",
                  "rsa-decrypt-oaep-2048-sha256",
                  "rsa-decrypt-oaep-3072-sha1",
                  "rsa-decrypt-oaep-3072-sha256",
                  "rsa-decrypt-oaep-4096-sha1",
                  "rsa-decrypt-oaep-4096-sha256",
                  "rsa-decrypt-oaep-4096-sha512",
                  "rsa-sign-pkcs1-2048-sha256",
                  "rsa-sign-pkcs1-3072-sha256",
                  "rsa-sign-pkcs1-4096-sha256",
                  "rsa-sign-pkcs1-4096-sha512",
                  "rsa-sign-pss-2048-sha256",
                  "rsa-sign-pss-3072-sha256",
                  "rsa-sign-pss-4096-sha256",
                  "rsa-sign-pss-4096-sha512",
                  "rsa-sign-raw-pkcs1-2048",
                  "rsa-sign-raw-pkcs1-3072",
                  "rsa-sign-raw-pkcs1-4096"
                ],
                "--destroy-scheduled-duration": "value",
                "--import-only": "bool",
                "--keyring": "dynamic",
                "--labels": "value",
                "--location": "dynamic",
                "--next-rotation-time": "value",
                "--protection-level": [
                  "external",
                  "external-vpc",
                  "hsm",
                  "software"
                ],
                "--purpose": [
                  "asymmetric-encryption",
                  "asymmetric-signing",
                  "encryption",
                  "mac",
                  "raw-encryption"
                ],
                "--rotation-period": "value",
                "--skip-initial-version-creation": "bool"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--keyring": "dynamic",
                "--location": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--keyring": "dynamic",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--keyring": "dynamic",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--keyring": "value",
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "remove-rotation-schedule": {
              "commands": {},
              "flags": {
                "--keyring": "dynamic",
                "--location": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--keyring": "dynamic",
                "--location": "dynamic"
              }
            },
            "set-primary-version": {
              "commands": {},
              "flags": {
                "--keyring": "dynamic",
                "--location": "dynamic"
              }
            },
            "set-rotation-schedule": {
              "commands": {},
              "flags": {
                "--keyring": "dynamic",
                "--location": "dynamic",
                "--next-rotation-time": "value",
                "--rotation-period": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--allowed-access-reasons": "value",
                "--clear-labels": "bool",
                "--default-algorithm": [
                  "aes-128-cbc",
                  "aes-128-ctr",
                  "aes-128-gcm",
                  "aes-256-cbc",
                  "aes-256-ctr",
                  "aes-256-gcm",
                  "ec-sign-ed25519",
                  "ec-sign-p256-sha256",
                  "ec-sign-p384-sha384",
                  "ec-sign-secp256k1-sha256",
                  "external-symmetric-encryption",
                  "google-symmetric-encryption",
                  "hmac-sha1",
                  "hmac-sha224",
                  "hmac-sha256",
                  "hmac-sha384",
                  "hmac-sha512",
                  "rsa-decrypt-oaep-2048-sha1",
                  "rsa-decrypt-oaep-2048-sha256",
                  "rsa-decrypt-oaep-3072-sha1",
                  "rsa-decrypt-oaep-3072-sha256",
                  "rsa-decrypt-oaep-4096-sha1",
                  "rsa-decrypt-oaep-4096-sha256",
                  "rsa-decrypt-oaep-4096-sha512",
                  "rsa-sign-pkcs1-2048-sha256",
                  "rsa-sign-pkcs1-3072-sha256",
                  "rsa-sign-pkcs1-4096-sha256",
                  "rsa-sign-pkcs1-4096-sha512",
                  "rsa-sign-pss-2048-sha256",
                  "rsa-sign-pss-3072-sha256",
                  "rsa-sign-pss-4096-sha256",
                  "rsa-sign-pss-4096-sha512",
                  "rsa-sign-raw-pkcs1-2048",
                  "rsa-sign-raw-pkcs1-3072",
                  "rsa-sign-raw-pkcs1-4096"
                ],
                "--keyring": "dynamic",
                "--location": "dynamic",
                "--next-rotation-time": "value",
                "--primary-version": "dynamic",
                "--remove-key-access-justifications-policy": "bool",
                "--remove-labels": "value",
                "--remove-rotation-schedule": "bool",
                "--rotation-period": "value",
                "--update-labels": "value"
              }
            },
            "versions": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--ekm-connection-key-path": "value",
                    "--external-key-uri": "value",
                    "--key": "dynamic",
                    "--keyring": "dynamic",
                    "--location": "dynamic",
                    "--primary": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--attestation-file": "value",
                    "--key": "dynamic",
                    "--keyring": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "destroy": {
                  "commands": {},
                  "flags": {
                    "--key": "dynamic",
                    "--keyring": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "disable": {
                  "commands": {},
                  "flags": {
                    "--key": "dynamic",
                    "--keyring": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "enable": {
                  "commands": {},
                  "flags": {
                    "--key": "dynamic",
                    "--keyring": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "get-certificate-chain": {
                  "commands": {},
                  "flags": {
                    "--certificate-chain-type": [
                      "all",
                      "cavium",
                      "google-card",
                      "google-partition"
                    ],
                    "--key": "dynamic",
                    "--keyring": "dynamic",
                    "--location": "dynamic",
                    "--output-file": "value"
                  }
                },
                "get-public-key": {
                  "commands": {},
                  "flags": {
                    "--key": "dynamic",
                    "--keyring": "dynamic",
                    "--location": "dynamic",
                    "--output-file": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--algorithm": [
                      "aes-128-cbc",
                      "aes-128-ctr",
                      "aes-128-gcm",
                      "aes-256-cbc",
                      "aes-256-ctr",
                      "aes-256-gcm",
                      "ec-sign-ed25519",
                      "ec-sign-p256-sha256",
                      "ec-sign-p384-sha384",
                      "ec-sign-secp256k1-sha256",
                      "google-symmetric-encryption",
                      "hmac-sha1",
                      "hmac-sha224",
                      "hmac-sha256",
                      "hmac-sha384",
                      "hmac-sha512",
                      "rsa-decrypt-oaep-2048-sha1",
                      "rsa-decrypt-oaep-2048-sha256",
                      "rsa-decrypt-oaep-3072-sha1",
                      "rsa-decrypt-oaep-3072-sha256",
                      "rsa-decrypt-oaep-4096-sha1",
                      "rsa-decrypt-oaep-4096-sha256",
                      "rsa-decrypt-oaep-4096-sha512",
                      "rsa-sign-pkcs1-2048-sha256",
                      "rsa-sign-pkcs1-3072-sha256",
                      "rsa-sign-pkcs1-4096-sha256",
                      "rsa-sign-pkcs1-4096-sha512",
                      "rsa-sign-pss-2048-sha256",
                      "rsa-sign-pss-3072-sha256",
                      "rsa-sign-pss-4096-sha256",
                      "rsa-sign-pss-4096-sha512",
                      "rsa-sign-raw-pkcs1-2048",
                      "rsa-sign-raw-pkcs1-3072",
                      "rsa-sign-raw-pkcs1-4096"
                    ],
                    "--import-job": "dynamic",
                    "--key": "dynamic",
                    "--keyring": "dynamic",
                    "--location": "dynamic",
                    "--public-key-file": "value",
                    "--target-key-file": "value",
                    "--wrapped-key-file": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--key": "dynamic",
                    "--keyring": "dynamic",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "restore": {
                  "commands": {},
                  "flags": {
                    "--key": "dynamic",
                    "--keyring": "dynamic",
                    "--location": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--ekm-connection-key-path": "value",
                    "--external-key-uri": "value",
                    "--key": "dynamic",
                    "--keyring": "dynamic",
                    "--location": "dynamic",
                    "--state": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "locations": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "mac-sign": {
          "commands": {},
          "flags": {
            "--input-file": "value",
            "--key": "dynamic",
            "--keyring": "dynamic",
            "--location": "dynamic",
            "--signature-file": "value",
            "--skip-integrity-verification": "bool"
          }
        },
        "mac-verify": {
          "commands": {},
          "flags": {
            "--input-file": "value",
            "--key": "dynamic",
            "--keyring": "dynamic",
            "--location": "dynamic",
            "--signature-file": "value",
            "--skip-integrity-verification": "bool"
          }
        },
        "raw-decrypt": {
          "commands": {},
          "flags": {
            "--additional-authenticated-data-file": "value",
            "--ciphertext-file": "value",
            "--initialization-vector-file": "value",
            "--key": "dynamic",
            "--keyring": "dynamic",
            "--location": "dynamic",
            "--plaintext-file": "value",
            "--skip-integrity-verification": "bool"
          }
        },
        "raw-encrypt": {
          "commands": {},
          "flags": {
            "--additional-authenticated-data-file": "value",
            "--ciphertext-file": "value",
            "--initialization-vector-file": "value",
            "--key": "dynamic",
            "--keyring": "dynamic",
            "--location": "dynamic",
            "--plaintext-file": "value",
            "--skip-integrity-verification": "bool"
          }
        }
      },
      "flags": {}
    },
    "logging": {
      "commands": {
        "buckets": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--cmek-kms-key-name": "value",
                "--description": "value",
                "--enable-analytics": "bool",
                "--index": "value",
                "--location": "value",
                "--restricted-fields": "value",
                "--retention-days": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--location": "value",
                "--organization": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "undelete": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-index": "value",
                "--async": "bool",
                "--billing-account": "value",
                "--clear-indexes": "bool",
                "--cmek-kms-key-name": "value",
                "--description": "value",
                "--enable-analytics": "bool",
                "--folder": "value",
                "--location": "value",
                "--locked": "bool",
                "--organization": "dynamic",
                "--remove-indexes": "value",
                "--restricted-fields": "value",
                "--retention-days": "value",
                "--update-index": "value"
              }
            }
          },
          "flags": {}
        },
        "copy": {
          "commands": {},
          "flags": {
            "--billing-account": "value",
            "--folder": "value",
            "--location": "value",
            "--log-filter": "value",
            "--organization": "dynamic"
          }
        },
        "links": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--billing-account": "value",
                "--bucket": "value",
                "--description": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--billing-account": "value",
                "--bucket": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--bucket": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--bucket": "value",
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--location": "value",
                "--organization": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "locations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--folder": "value",
                "--organization": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--organization": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "logs": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--bucket": "value",
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--sort-by": "value",
                "--view": "value"
              }
            }
          },
          "flags": {}
        },
        "metrics": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--bucket-name": "value",
                "--config-from-file": "value",
                "--description": "value",
                "--log-filter": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--bucket-name": "value",
                "--config-from-file": "value",
                "--description": "value",
                "--log-filter": "value"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--folder": "value",
                "--limit": "value",
                "--location": "value",
                "--operation-filter": "value",
                "--organization": "dynamic",
                "--page-size": "value",
                "--sort-by": "value"
              }
            }
          },
          "flags": {}
        },
        "read": {
          "commands": {},
          "flags": {
            "--billing-account": "value",
            "--bucket": "value",
            "--folder": "value",
            "--freshness": "value",
            "--limit": "value",
            "--location": "value",
            "--order": [
              "asc",
              "desc"
            ],
            "--organization": "dynamic",
            "--resource-names": "value",
            "--view": "value"
          }
        },
        "resource-descriptors": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--sort-by": "value"
              }
            }
          },
          "flags": {}
        },
        "scopes": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--folder": "value",
                "--organization": "dynamic",
                "--resource-names": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--organization": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--resource-names": "value"
              }
            }
          },
          "flags": {}
        },
        "settings": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--folder": "value",
                "--organization": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-kms-key": "bool",
                "--disable-default-sink": "bool",
                "--folder": "value",
                "--kms-key-name": "dynamic",
                "--kms-keyring": "dynamic",
                "--kms-location": "dynamic",
                "--kms-project": "dynamic",
                "--organization": "dynamic",
                "--storage-location": "value"
              }
            }
          },
          "flags": {}
        },
        "sinks": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--custom-writer-identity": "value",
                "--description": "value",
                "--disabled": "bool",
                "--exclusion": "value",
                "--folder": "value",
                "--include-children": "bool",
                "--intercept-children": "bool",
                "--log-filter": "value",
                "--organization": "dynamic",
                "--use-partitioned-tables": "bool"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--folder": "value",
                "--organization": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--folder": "value",
                "--organization": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--organization": "dynamic",
                "--sink-filter": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-exclusion": "value",
                "--billing-account": "value",
                "--clear-exclusions": "bool",
                "--custom-writer-identity": "value",
                "--description": "value",
                "--disabled": "bool",
                "--folder": "value",
                "--include-children": "bool",
                "--intercept-children": "bool",
                "--log-filter": "value",
                "--organization": "dynamic",
                "--remove-exclusions": "value",
                "--update-exclusion": "value",
                "--use-partitioned-tables": "bool"
              }
            }
          },
          "flags": {}
        },
        "views": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--bucket": "value",
                "--condition": "value",
                "--condition-from-file": "value",
                "--folder": "value",
                "--location": "value",
                "--member": "value",
                "--organization": "dynamic",
                "--role": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--bucket": "value",
                "--description": "value",
                "--folder": "value",
                "--location": "value",
                "--log-filter": "value",
                "--organization": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--bucket": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--bucket": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--bucket": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--bucket": "value",
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--location": "value",
                "--organization": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--billing-account": "value",
                "--bucket": "value",
                "--condition": "value",
                "--condition-from-file": "value",
                "--folder": "value",
                "--location": "value",
                "--member": "value",
                "--organization": "dynamic",
                "--role": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--bucket": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--bucket": "value",
                "--description": "value",
                "--folder": "value",
                "--location": "value",
                "--log-filter": "value",
                "--organization": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "write": {
          "commands": {},
          "flags": {
            "--billing-account": "value",
            "--folder": "value",
            "--organization": "dynamic",
            "--payload-type": [
              "json",
              "text"
            ],
            "--severity": [
              "ALERT",
              "CRITICAL",
              "DEBUG",
              "DEFAULT",
              "EMERGENCY",
              "ERROR",
              "INFO",
              "NOTICE",
              "WARNING"
            ]
          }
        }
      },
      "flags": {}
    },
    "looker": {
      "commands": {
        "instances": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--consumer-network": "value",
                "--deny-maintenance-period-end-date": "value",
                "--deny-maintenance-period-start-date": "value",
                "--deny-maintenance-period-time": "value",
                "--edition": [
                  "core-embed-annual",
                  "core-enterprise-annual",
                  "core-standard",
                  "core-standard-annual",
                  "core-trial",
                  "nonprod-core-embed-annual",
                  "nonprod-core-enterprise-annual",
                  "nonprod-core-standard-annual"
                ],
                "--fips-enabled": "bool",
                "--kms-key": "value",
                "--maintenance-window-day": [
                  "friday",
                  "monday",
                  "saturday",
                  "sunday",
                  "thursday",
                  "tuesday",
                  "wednesday"
                ],
                "--maintenance-window-time": "value",
                "--oauth-client-id": "value",
                "--oauth-client-secret": "value",
                "--private-ip-enabled": "bool",
                "--psc-allowed-vpcs": "value",
                "--psc-enabled": "bool",
                "--public-ip-enabled": "bool",
                "--region": "dynamic",
                "--reserved-range": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--force": "bool",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--kms-key": "value",
                "--region": "value",
                "--target-gcs-uri": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--region": "value",
                "--source-gcs-uri": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "restart": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-developer-users": "value",
                "--add-standard-users": "value",
                "--add-viewer-users": "value",
                "--allowed-email-domains": "value",
                "--async": "bool",
                "--clear-psc-allowed-vpcs": "bool",
                "--clear-psc-service-attachments": "bool",
                "--custom-domain": "value",
                "--deny-maintenance-period-end-date": "value",
                "--deny-maintenance-period-start-date": "value",
                "--deny-maintenance-period-time": "value",
                "--linked-lsp-project-number": "value",
                "--maintenance-window-day": [
                  "friday",
                  "monday",
                  "saturday",
                  "sunday",
                  "thursday",
                  "tuesday",
                  "wednesday"
                ],
                "--maintenance-window-time": "value",
                "--oauth-client-id": "value",
                "--oauth-client-secret": "value",
                "--psc-allowed-vpcs": "value",
                "--psc-service-attachment": "value",
                "--public-ip-enabled": "bool",
                "--region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "regions": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "managed-kafka": {
      "commands": {
        "clusters": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--auto-rebalance": "bool",
                "--cpu": "value",
                "--encryption-key": "value",
                "--labels": "value",
                "--location": "value",
                "--memory": "value",
                "--subnets": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--auto-rebalance": "bool",
                "--cpu": "value",
                "--labels": "value",
                "--location": "value",
                "--memory": "value",
                "--subnets": "value"
              }
            }
          },
          "flags": {}
        },
        "consumer-groups": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--location": "value",
                "--topics-file": "value"
              }
            }
          },
          "flags": {}
        },
        "topics": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--configs": "value",
                "--location": "value",
                "--partitions": "value",
                "--replication-factor": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-configs": "bool",
                "--cluster": "value",
                "--configs": "value",
                "--location": "value",
                "--partitions": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "memcache": {
      "commands": {
        "instances": {
          "commands": {
            "apply-parameters": {
              "commands": {},
              "flags": {
                "--apply-all": "bool",
                "--async": "bool",
                "--node-ids": "value",
                "--region": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--authorized-network": "value",
                "--display-name": "value",
                "--labels": "value",
                "--maintenance-window-day": [
                  "friday",
                  "monday",
                  "saturday",
                  "sunday",
                  "thursday",
                  "tuesday",
                  "wednesday"
                ],
                "--maintenance-window-duration": "value",
                "--maintenance-window-start-time": "value",
                "--memcached-version": [
                  "1.5",
                  "1.6.15"
                ],
                "--node-count": "value",
                "--node-cpu": "value",
                "--node-memory": "value",
                "--parameters": "value",
                "--region": "dynamic",
                "--reserved-ip-range-id": "value",
                "--zones": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "reschedule-maintenance": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "dynamic",
                "--reschedule-type": [
                  "immediate",
                  "next-available-window",
                  "specific-time"
                ],
                "--schedule-time": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--display-name": "value",
                "--labels": "value",
                "--maintenance-window-any": "bool",
                "--maintenance-window-day": [
                  "friday",
                  "monday",
                  "saturday",
                  "sunday",
                  "thursday",
                  "tuesday",
                  "wednesday"
                ],
                "--maintenance-window-duration": "value",
                "--maintenance-window-start-time": "value",
                "--node-count": "value",
                "--parameters": "value",
                "--region": "dynamic"
              }
            },
            "upgrade": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--memcached-version": [
                  "1.6.15"
                ],
                "--region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "regions": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "memorystore": {
      "commands": {
        "instances": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--aof-config-append-fsync": [
                  "always",
                  "every-sec",
                  "never"
                ],
                "--async": "bool",
                "--authorization-mode": [
                  "auth-disabled",
                  "iam-auth"
                ],
                "--deletion-protection-enabled": "bool",
                "--engine-configs": "value",
                "--engine-version": "value",
                "--labels": "value",
                "--location": "dynamic",
                "--mode": [
                  "cluster",
                  "cluster-disabled"
                ],
                "--node-type": [
                  "highmem-medium",
                  "highmem-xlarge",
                  "shared-core-nano",
                  "standard-small"
                ],
                "--persistence-config-mode": [
                  "aof",
                  "disabled",
                  "rdb"
                ],
                "--psc-auto-connections": "value",
                "--rdb-config-snapshot-period": [
                  "one-hour",
                  "six-hours",
                  "twelve-hours",
                  "twenty-four-hours"
                ],
                "--rdb-config-snapshot-start-time": "value",
                "--replica-count": "value",
                "--request-id": "value",
                "--shard-count": "value",
                "--transit-encryption-mode": [
                  "server-authentication",
                  "transit-encryption-disabled"
                ],
                "--zone-distribution-config": "value",
                "--zone-distribution-config-mode": [
                  "multi-zone",
                  "single-zone"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic",
                "--request-id": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "get-certificate-authority": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--aof-config-append-fsync": [
                  "always",
                  "every-sec",
                  "never"
                ],
                "--async": "bool",
                "--clear-engine-configs": "bool",
                "--clear-labels": "bool",
                "--deletion-protection-enabled": "bool",
                "--engine-configs": "value",
                "--labels": "value",
                "--location": "dynamic",
                "--persistence-config-mode": [
                  "aof",
                  "disabled",
                  "rdb"
                ],
                "--rdb-config-snapshot-period": [
                  "one-hour",
                  "six-hours",
                  "twelve-hours",
                  "twenty-four-hours"
                ],
                "--rdb-config-snapshot-start-time": "value",
                "--remove-engine-configs": "value",
                "--remove-labels": "value",
                "--replica-count": "value",
                "--request-id": "value",
                "--shard-count": "value",
                "--update-engine-configs": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "metastore": {
      "commands": {
        "federations": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--backends": "value",
                "--hive-metastore-version": [
                  "2.3.6",
                  "3.1.2"
                ],
                "--labels": "value",
                "--location": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-backends": "bool",
                "--clear-labels": "bool",
                "--location": "value",
                "--remove-backends": "value",
                "--remove-labels": "value",
                "--update-backends": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "locations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "wait": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            }
          },
          "flags": {}
        },
        "services": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "alter-metadata-resource-location": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--location_uri": "value",
                "--resource_name": "value"
              }
            },
            "alter-table-properties": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--properties": "value",
                "--table-name": "value",
                "--update-mask": "value"
              }
            },
            "backups": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic",
                    "--service": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--service": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--service": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--service": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--service": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--service": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--member": "value",
                    "--role": "dynamic",
                    "--service": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--service": "value"
                  }
                }
              },
              "flags": {}
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--autoscaling-enabled": "bool",
                "--auxiliary-versions": "value",
                "--auxiliary-versions-from-file": "value",
                "--consumer-subnetworks": "value",
                "--data-catalog-sync": "bool",
                "--database-type": [
                  "mysql",
                  "spanner"
                ],
                "--deletion-protection": "bool",
                "--enable-scheduled-backup": "bool",
                "--encryption-kms-key": "value",
                "--endpoint-protocol": [
                  "grpc",
                  "thrift"
                ],
                "--hive-metastore-configs": "value",
                "--hive-metastore-configs-from-file": "value",
                "--hive-metastore-version": "value",
                "--instance-size": [
                  "extra-large",
                  "extra-small",
                  "large",
                  "medium",
                  "small"
                ],
                "--kerberos-principal": "value",
                "--keytab": "value",
                "--krb5-config": "value",
                "--labels": "value",
                "--location": "value",
                "--maintenance-window-day": [
                  "fri",
                  "mon",
                  "sat",
                  "sun",
                  "thu",
                  "tue",
                  "wed"
                ],
                "--maintenance-window-hour": "value",
                "--max-scaling-factor": "value",
                "--min-scaling-factor": "value",
                "--network": "value",
                "--network-config-from-file": "value",
                "--port": "value",
                "--release-channel": [
                  "canary",
                  "stable"
                ],
                "--scaling-factor": "value",
                "--scheduled-backup-configs-from-file": "value",
                "--scheduled-backup-cron": "value",
                "--scheduled-backup-location": "value",
                "--tier": [
                  "developer",
                  "enterprise"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "export": {
              "commands": {
                "gcs": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--destination-folder": "value",
                    "--dump-type": [
                      "avro",
                      "mysql"
                    ],
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "import": {
              "commands": {
                "gcs": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--database-dump": "value",
                    "--description": "value",
                    "--dump-type": [
                      "avro",
                      "mysql"
                    ],
                    "--import-id": "value",
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "move-table-to-database": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--destination_db_name": "value",
                "--location": "value",
                "--source_db_name": "value",
                "--table_name": "value"
              }
            },
            "query-metadata": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--query": "value"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "restore": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--backup": "value",
                "--backup-location": "value",
                "--location": "value",
                "--restore-type": [
                  "full",
                  "metadata-only"
                ]
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-auxiliary-versions": "value",
                "--async": "bool",
                "--autoscaling-enabled": "bool",
                "--clear-auxiliary-versions": "bool",
                "--clear-hive-metastore-configs": "bool",
                "--clear-labels": "bool",
                "--data-catalog-sync": "bool",
                "--deletion-protection": "bool",
                "--enable-scheduled-backup": "bool",
                "--endpoint-protocol": [
                  "grpc",
                  "thrift"
                ],
                "--instance-size": [
                  "extra-large",
                  "extra-small",
                  "large",
                  "medium",
                  "small"
                ],
                "--kerberos-principal": "value",
                "--keytab": "value",
                "--krb5-config": "value",
                "--location": "value",
                "--maintenance-window-day": [
                  "fri",
                  "mon",
                  "sat",
                  "sun",
                  "thu",
                  "tue",
                  "wed"
                ],
                "--maintenance-window-hour": "value",
                "--max-scaling-factor": "value",
                "--min-scaling-factor": "value",
                "--port": "value",
                "--remove-hive-metastore-configs": "value",
                "--remove-labels": "value",
                "--scaling-factor": "value",
                "--scheduled-backup-configs-from-file": "value",
                "--scheduled-backup-cron": "value",
                "--scheduled-backup-location": "value",
                "--tier": [
                  "developer",
                  "enterprise"
                ],
                "--update-auxiliary-versions-from-file": "value",
                "--update-hive-metastore-configs": "value",
                "--update-hive-metastore-configs-from-file": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "migration": {
      "commands": {
        "vms": {
          "commands": {
            "image-imports": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--additional-licenses": "value",
                    "--description": "value",
                    "--family-name": "value",
                    "--generalize": "bool",
                    "--image-name": "value",
                    "--kms-key": "value",
                    "--labels": "value",
                    "--license-type": [
                      "compute-engine-license-type-byol",
                      "compute-engine-license-type-default",
                      "compute-engine-license-type-payg"
                    ],
                    "--location": "dynamic",
                    "--single-region-storage": "bool",
                    "--skip-os-adaptation": "bool",
                    "--source-file": "value",
                    "--target-project": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "machine-image-imports": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--additional-licenses": "value",
                    "--description": "value",
                    "--enable-integrity-monitoring": "bool",
                    "--enable-vtpm": "bool",
                    "--generalize": "bool",
                    "--kms-key": "value",
                    "--labels": "value",
                    "--license-type": [
                      "compute-engine-license-type-byol",
                      "compute-engine-license-type-default",
                      "compute-engine-license-type-payg"
                    ],
                    "--location": "dynamic",
                    "--machine-image-name": "value",
                    "--machine-type": "value",
                    "--network-interface": "value",
                    "--scopes": "value",
                    "--secure-boot": [
                      "false",
                      "secure-boot-unspecified",
                      "true"
                    ],
                    "--service-account": "value",
                    "--single-region-storage": "bool",
                    "--skip-os-adaptation": "bool",
                    "--source-file": "value",
                    "--tags": "value",
                    "--target-project": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "ml": {
      "commands": {
        "language": {
          "commands": {
            "analyze-entities": {
              "commands": {},
              "flags": {
                "--content": "value",
                "--content-file": "value",
                "--content-type": [
                  "html",
                  "plain-text"
                ],
                "--encoding-type": [
                  "none",
                  "utf16",
                  "utf32",
                  "utf8"
                ],
                "--language": "value"
              }
            },
            "analyze-entity-sentiment": {
              "commands": {},
              "flags": {
                "--content": "value",
                "--content-file": "value",
                "--content-type": [
                  "html",
                  "plain-text"
                ],
                "--encoding-type": [
                  "none",
                  "utf16",
                  "utf32",
                  "utf8"
                ],
                "--language": "value"
              }
            },
            "analyze-sentiment": {
              "commands": {},
              "flags": {
                "--content": "value",
                "--content-file": "value",
                "--content-type": [
                  "html",
                  "plain-text"
                ],
                "--encoding-type": [
                  "none",
                  "utf16",
                  "utf32",
                  "utf8"
                ],
                "--language": "value"
              }
            },
            "analyze-syntax": {
              "commands": {},
              "flags": {
                "--content": "value",
                "--content-file": "value",
                "--content-type": [
                  "html",
                  "plain-text"
                ],
                "--encoding-type": [
                  "none",
                  "utf16",
                  "utf32",
                  "utf8"
                ],
                "--language": "value"
              }
            },
            "classify-text": {
              "commands": {},
              "flags": {
                "--content": "value",
                "--content-file": "value",
                "--content-type": [
                  "html",
                  "plain-text"
                ],
                "--language": "value"
              }
            }
          },
          "flags": {}
        },
        "speech": {
          "commands": {
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "wait": {
                  "commands": {},
                  "flags": {}
                }
              },
              "flags": {}
            },
            "recognize": {
              "commands": {},
              "flags": {
                "--audio-channel-count": "value",
                "--enable-automatic-punctuation": "bool",
                "--encoding": [
                  "alaw",
                  "amr",
                  "amr-wb",
                  "encoding-unspecified",
                  "flac",
                  "linear16",
                  "mp3",
                  "mulaw",
                  "ogg-opus",
                  "speex-with-header-byte",
                  "webm-opus"
                ],
                "--filter-profanity": "bool",
                "--hints": "value",
                "--include-word-time-offsets": "bool",
                "--language-code": "value",
                "--max-alternatives": "value",
                "--model": [
                  "command_and_search",
                  "default",
                  "latest_long",
                  "latest_short",
                  "medical_conversation",
                  "medical_dictation",
                  "phone_call",
                  "phone_call_enhanced",
                  "telephony",
                  "telephony_short",
                  "video_enhanced"
                ],
                "--sample-rate": "value",
                "--separate-channel-recognition": "bool"
              }
            },
            "recognize-long-running": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--audio-channel-count": "value",
                "--enable-automatic-punctuation": "bool",
                "--encoding": [
                  "alaw",
                  "amr",
                  "amr-wb",
                  "encoding-unspecified",
                  "flac",
                  "linear16",
                  "mp3",
                  "mulaw",
                  "ogg-opus",
                  "speex-with-header-byte",
                  "webm-opus"
                ],
                "--filter-profanity": "bool",
                "--hints": "value",
                "--include-word-time-offsets": "bool",
                "--language-code": "value",
                "--max-alternatives": "value",
                "--model": [
                  "command_and_search",
                  "default",
                  "latest_long",
                  "latest_short",
                  "medical_conversation",
                  "medical_dictation",
                  "phone_call",
                  "phone_call_enhanced",
                  "telephony",
                  "telephony_short",
                  "video_enhanced"
                ],
                "--output-uri": "value",
                "--sample-rate": "value",
                "--separate-channel-recognition": "bool"
              }
            }
          },
          "flags": {}
        },
        "video": {
          "commands": {
            "detect-explicit-content": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--output-uri": "value",
                "--region": [
                  "asia-east1",
                  "europe-west1",
                  "us-east1",
                  "us-west1"
                ],
                "--segments": "value"
              }
            },
            "detect-labels": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--detection-mode": [
                  "frame",
                  "shot",
                  "shot-and-frame"
                ],
                "--output-uri": "value",
                "--region": [
                  "asia-east1",
                  "europe-west1",
                  "us-east1",
                  "us-west1"
                ],
                "--segments": "value"
              }
            },
            "detect-shot-changes": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--output-uri": "value",
                "--region": [
                  "asia-east1",
                  "europe-west1",
                  "us-east1",
                  "us-west1"
                ],
                "--segments": "value"
              }
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "vision": {
          "commands": {
            "detect-document": {
              "commands": {},
              "flags": {
                "--language-hints": "value"
              }
            },
            "detect-faces": {
              "commands": {},
              "flags": {
                "--max-results": "value"
              }
            },
            "detect-image-properties": {
              "commands": {},
              "flags": {}
            },
            "detect-labels": {
              "commands": {},
              "flags": {
                "--max-results": "value"
              }
            },
            "detect-landmarks": {
              "commands": {},
              "flags": {
                "--max-results": "value"
              }
            },
            "detect-logos": {
              "commands": {},
              "flags": {
                "--max-results": "value"
              }
            },
            "detect-objects": {
              "commands": {},
              "flags": {}
            },
            "detect-safe-search": {
              "commands": {},
              "flags": {}
            },
            "detect-text": {
              "commands": {},
              "flags": {
                "--language-hints": "value"
              }
            },
            "detect-text-pdf": {
              "commands": {},
              "flags": {
                "--batch-size": "value"
              }
            },
            "detect-text-tiff": {
              "commands": {},
              "flags": {
                "--batch-size": "value"
              }
            },
            "detect-web": {
              "commands": {},
              "flags": {
                "--max-results": "value"
              }
            },
            "suggest-crop": {
              "commands": {},
              "flags": {
                "--aspect-ratios": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "ml-engine": {
      "commands": {
        "jobs": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {
                "--summarize": "bool"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "stream-logs": {
              "commands": {},
              "flags": {
                "--allow-multiline-logs": "bool",
                "--polling-interval": "value",
                "--task-name": "value"
              }
            },
            "submit": {
              "commands": {
                "prediction": {
                  "commands": {},
                  "flags": {
                    "--batch-size": "value",
                    "--data-format": [
                      "text",
                      "tf-record",
                      "tf-record-gzip"
                    ],
                    "--input-paths": "value",
                    "--labels": "value",
                    "--max-worker-count": "value",
                    "--model": "value",
                    "--model-dir": "value",
                    "--output-path": "value",
                    "--region": "value",
                    "--runtime-version": "value",
                    "--signature-name": "value"
                  }
                },
                "training": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--config": "value",
                    "--enable-web-access": "bool",
                    "--job-dir": "value",
                    "--kms-key": "dynamic",
                    "--kms-keyring": "dynamic",
                    "--kms-location": "dynamic",
                    "--kms-project": "dynamic",
                    "--labels": "value",
                    "--master-accelerator": "value",
                    "--master-image-uri": "value",
                    "--master-machine-type": "value",
                    "--module-name": "value",
                    "--package-path": "value",
                    "--packages": "value",
                    "--parameter-server-accelerator": "value",
                    "--parameter-server-count": "value",
                    "--parameter-server-image-uri": "value",
                    "--parameter-server-machine-type": "value",
                    "--python-version": "value",
                    "--region": "dynamic",
                    "--runtime-version": "value",
                    "--scale-tier": [
                      "basic",
                      "basic-gpu",
                      "basic-tpu",
                      "custom",
                      "premium-1",
                      "standard-1"
                    ],
                    "--service-account": "value",
                    "--staging-bucket": "value",
                    "--stream-logs": "bool",
                    "--use-chief-in-tf-config": "value",
                    "--worker-accelerator": "value",
                    "--worker-count": "value",
                    "--worker-image-uri": "value",
                    "--worker-machine-type": "value"
                  }
                }
              },
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-labels": "bool",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "local": {
          "commands": {
            "predict": {
              "commands": {},
              "flags": {
                "--framework": [
                  "scikit-learn",
                  "tensorflow",
                  "xgboost"
                ],
                "--json-instances": "value",
                "--json-request": "value",
                "--model-dir": "value",
                "--signature-name": "value",
                "--text-instances": "value"
              }
            },
            "train": {
              "commands": {},
              "flags": {
                "--distributed": "bool",
                "--evaluator-count": "value",
                "--job-dir": "value",
                "--module-name": "value",
                "--package-path": "value",
                "--parameter-server-count": "value",
                "--start-port": "value",
                "--worker-count": "value"
              }
            }
          },
          "flags": {}
        },
        "models": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--enable-logging": "bool",
                "--labels": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--regions": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ]
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ]
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--role": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ]
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-labels": "bool",
                "--description": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ]
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ]
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "wait": {
              "commands": {},
              "flags": {
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ]
              }
            }
          },
          "flags": {}
        },
        "predict": {
          "commands": {},
          "flags": {
            "--json-instances": "value",
            "--json-request": "value",
            "--model": "value",
            "--region": [
              "asia-east1",
              "asia-northeast1",
              "asia-southeast1",
              "australia-southeast1",
              "europe-west1",
              "europe-west2",
              "europe-west3",
              "europe-west4",
              "global",
              "northamerica-northeast1",
              "us-central1",
              "us-east1",
              "us-east4",
              "us-west1"
            ],
            "--signature-name": "value",
            "--text-instances": "value"
          }
        },
        "versions": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--accelerator": "value",
                "--async": "bool",
                "--config": "value",
                "--description": "value",
                "--framework": [
                  "scikit-learn",
                  "tensorflow",
                  "xgboost"
                ],
                "--labels": "value",
                "--machine-type": "value",
                "--max-nodes": "value",
                "--metric-targets": "value",
                "--min-nodes": "value",
                "--model": "value",
                "--origin": "value",
                "--python-version": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--runtime-version": "value",
                "--staging-bucket": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--model": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ]
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--model": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ]
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--model": "value",
                "--page-size": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "set-default": {
              "commands": {},
              "flags": {
                "--model": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ]
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-labels": "bool",
                "--config": "value",
                "--description": "value",
                "--model": "value",
                "--region": [
                  "asia-east1",
                  "asia-northeast1",
                  "asia-southeast1",
                  "australia-southeast1",
                  "europe-west1",
                  "europe-west2",
                  "europe-west3",
                  "europe-west4",
                  "global",
                  "northamerica-northeast1",
                  "us-central1",
                  "us-east1",
                  "us-east4",
                  "us-west1"
                ],
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "monitoring": {
      "commands": {
        "dashboards": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--config": "value",
                "--config-from-file": "value",
                "--validate-only": "bool"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--config": "value",
                "--config-from-file": "value"
              }
            }
          },
          "flags": {}
        },
        "snoozes": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {}
            },
            "create": {
              "commands": {},
              "flags": {
                "--criteria-policies": "value",
                "--display-name": "value",
                "--end-time": "value",
                "--snooze-from-file": "value",
                "--start-time": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--display-name": "value",
                "--end-time": "value",
                "--fields": "value",
                "--snooze-from-file": "value",
                "--start-time": "value"
              }
            }
          },
          "flags": {}
        },
        "uptime": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--body": "value",
                "--content-type": [
                  "unspecified",
                  "url-encoded",
                  "user-provided"
                ],
                "--custom-content-type": "value",
                "--group-id": "value",
                "--group-type": [
                  "aws-elb-load-balancer",
                  "gce-instance"
                ],
                "--headers": "value",
                "--json-path": "value",
                "--json-path-matcher-type": [
                  "exact-match",
                  "regex-match"
                ],
                "--mask-headers": "value",
                "--matcher-content": "value",
                "--matcher-type": [
                  "contains-string",
                  "matches-json-path",
                  "matches-regex",
                  "not-contains-string",
                  "not-matches-json-path",
                  "not-matches-regex"
                ],
                "--password": "value",
                "--path": "value",
                "--period": [
                  "1",
                  "10",
                  "15",
                  "5"
                ],
                "--pings-count": "value",
                "--port": "value",
                "--protocol": [
                  "http",
                  "https",
                  "tcp"
                ],
                "--regions": "value",
                "--request-method": [
                  "get",
                  "post"
                ],
                "--resource-labels": "value",
                "--resource-type": [
                  "aws-ec2-instance",
                  "aws-elb-load-balancer",
                  "cloud-run-revision",
                  "gae-app",
                  "gce-instance",
                  "servicedirectory-service",
                  "uptime-url"
                ],
                "--service-agent-auth": [
                  "oidc-token"
                ],
                "--status-classes": "value",
                "--status-codes": "value",
                "--synthetic-target": "value",
                "--timeout": "value",
                "--user-labels": "value",
                "--username": "value",
                "--validate-ssl": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list-configs": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "list-ips": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-regions": "value",
                "--add-status-classes": "value",
                "--add-status-codes": "value",
                "--body": "value",
                "--clear-headers": "value",
                "--clear-regions": "value",
                "--clear-status-classes": "value",
                "--clear-status-codes": "value",
                "--clear-user-labels": "bool",
                "--content-type": [
                  "unspecified",
                  "url-encoded",
                  "user-provided"
                ],
                "--custom-content-type": "value",
                "--display-name": "value",
                "--json-path": "value",
                "--json-path-matcher-type": [
                  "exact-match",
                  "regex-match"
                ],
                "--mask-headers": "value",
                "--matcher-content": "value",
                "--matcher-type": [
                  "contains-string",
                  "matches-json-path",
                  "matches-regex",
                  "not-contains-string",
                  "not-matches-json-path",
                  "not-matches-regex"
                ],
                "--password": "value",
                "--path": "value",
                "--period": [
                  "1",
                  "10",
                  "15",
                  "5"
                ],
                "--pings-count": "value",
                "--port": "value",
                "--remove-headers": "value",
                "--remove-regions": "value",
                "--remove-status-classes": "value",
                "--remove-status-codes": "value",
                "--remove-user-labels": "value",
                "--request-method": [
                  "get",
                  "post"
                ],
                "--service-agent-auth": [
                  "oidc-token"
                ],
                "--set-regions": "value",
                "--set-status-classes": "value",
                "--set-status-codes": "value",
                "--timeout": "value",
                "--update-headers": "value",
                "--update-user-labels": "value",
                "--username": "value",
                "--validate-ssl": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "netapp": {
      "commands": {
        "active-directories": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--administrators": "value",
                "--async": "bool",
                "--backup-operators": "value",
                "--description": "value",
                "--dns": "value",
                "--domain": "value",
                "--enable-aes": "value",
                "--enable-ldap-signing": "value",
                "--encrypt-dc-connections": "value",
                "--kdc-hostname": "value",
                "--kdc-ip": "value",
                "--labels": "value",
                "--location": "value",
                "--net-bios-prefix": "value",
                "--nfs-users-with-ldap": "value",
                "--organizational-unit": "value",
                "--password": "value",
                "--security-operators": "value",
                "--site": "value",
                "--username": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--administrators": "value",
                "--async": "bool",
                "--backup-operators": "value",
                "--clear-labels": "bool",
                "--description": "value",
                "--dns": "value",
                "--domain": "value",
                "--enable-aes": "value",
                "--enable-ldap-signing": "value",
                "--encrypt-dc-connections": "value",
                "--kdc-hostname": "value",
                "--kdc-ip": "value",
                "--location": "value",
                "--net-bios-prefix": "value",
                "--nfs-users-with-ldap": "value",
                "--organizational-unit": "value",
                "--password": "value",
                "--remove-labels": "value",
                "--security-operators": "value",
                "--site": "value",
                "--update-labels": "value",
                "--username": "value"
              }
            }
          },
          "flags": {}
        },
        "backup-policies": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--daily-backup-limit": "value",
                "--description": "value",
                "--enabled": "value",
                "--labels": "value",
                "--location": "value",
                "--monthly-backup-limit": "value",
                "--weekly-backup-limit": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-labels": "bool",
                "--daily-backup-limit": "value",
                "--description": "value",
                "--enabled": "value",
                "--location": "value",
                "--monthly-backup-limit": "value",
                "--remove-labels": "value",
                "--update-labels": "value",
                "--weekly-backup-limit": "value"
              }
            }
          },
          "flags": {}
        },
        "backup-vaults": {
          "commands": {
            "backups": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--backup-vault": "value",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--source-snapshot": "value",
                    "--source-volume": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--backup-vault": "value",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--backup-vault": "value",
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--backup-vault": "value",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--backup-vault": "value",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--labels": "value",
                "--location": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-labels": "bool",
                "--description": "value",
                "--location": "value",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "kms-configs": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--kms-key": "value",
                "--kms-keyring": "value",
                "--kms-location": "value",
                "--kms-project": "value",
                "--labels": "value",
                "--location": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "encrypt": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-labels": "bool",
                "--description": "value",
                "--kms-key": "value",
                "--kms-keyring": "value",
                "--kms-location": "value",
                "--kms-project": "value",
                "--location": "value",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            },
            "verify": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            }
          },
          "flags": {}
        },
        "locations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "storage-pools": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--active-directory": "value",
                "--allow-auto-tiering": "value",
                "--async": "bool",
                "--capacity": "value",
                "--description": "value",
                "--enable-ldap": "value",
                "--kms-config": "value",
                "--labels": "value",
                "--location": "value",
                "--network": "value",
                "--replica-zone": "value",
                "--service-level": [
                  "extreme",
                  "flex",
                  "premium",
                  "standard"
                ],
                "--zone": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "switch": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--active-directory": "value",
                "--allow-auto-tiering": "value",
                "--async": "bool",
                "--capacity": "value",
                "--clear-labels": "bool",
                "--description": "value",
                "--location": "value",
                "--remove-labels": "value",
                "--replica-zone": "value",
                "--update-labels": "value",
                "--zone": "value"
              }
            },
            "validate-directory-service": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--directory-service-type": "value",
                "--location": "value"
              }
            }
          },
          "flags": {}
        },
        "volumes": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--backup-config": "value",
                "--backup_vault": "value",
                "--capacity": "value",
                "--description": "value",
                "--enable-kerberos": "value",
                "--export-policy": "value",
                "--hybrid-replication-parameters": "value",
                "--labels": "value",
                "--large-capacity": "value",
                "--location": "value",
                "--multiple-endpoints": "value",
                "--protocols": "value",
                "--restricted-actions": "value",
                "--security-style": [
                  "ntfs",
                  "unix"
                ],
                "--share-name": "value",
                "--smb-settings": "value",
                "--snap-reserve": "value",
                "--snapshot-daily": "value",
                "--snapshot-directory": "value",
                "--snapshot-hourly": "value",
                "--snapshot-monthly": "value",
                "--snapshot-weekly": "value",
                "--source-backup": "value",
                "--source-snapshot": "value",
                "--storage-pool": "value",
                "--tiering-policy": "value",
                "--unix-permissions": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--force": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "replications": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--cluster-location": "value",
                    "--description": "value",
                    "--destination-volume-parameters": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--replication-schedule": "value",
                    "--volume": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--volume": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--volume": "value"
                  }
                },
                "establish-peering": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--peer-cluster-name": "value",
                    "--peer-ip-addresses": "value",
                    "--peer-svm-name": "value",
                    "--peer-volume-name": "value",
                    "--volume": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--volume": "value"
                  }
                },
                "resume": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--volume": "value"
                  }
                },
                "reverse": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--volume": "value"
                  }
                },
                "stop": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--force": "bool",
                    "--location": "value",
                    "--volume": "value"
                  }
                },
                "sync": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--volume": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--cluster-location": "value",
                    "--description": "value",
                    "--location": "value",
                    "--remove-labels": "value",
                    "--replication-schedule": "value",
                    "--update-labels": "value",
                    "--volume": "value"
                  }
                }
              },
              "flags": {}
            },
            "revert": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--snapshot": "value"
              }
            },
            "snapshots": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--volume": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--volume": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--volume": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool",
                    "--volume": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value",
                    "--volume": "value"
                  }
                }
              },
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--backup-config": "value",
                "--backup_vault": "value",
                "--capacity": "value",
                "--clear-labels": "bool",
                "--description": "value",
                "--enable-kerberos": "value",
                "--export-policy": "value",
                "--location": "value",
                "--protocols": "value",
                "--remove-labels": "value",
                "--restricted-actions": "value",
                "--security-style": [
                  "ntfs",
                  "unix"
                ],
                "--share-name": "value",
                "--smb-settings": "value",
                "--snap-reserve": "value",
                "--snapshot-daily": "value",
                "--snapshot-directory": "value",
                "--snapshot-hourly": "value",
                "--snapshot-monthly": "value",
                "--snapshot-weekly": "value",
                "--source-backup": "value",
                "--source-snapshot": "value",
                "--storage-pool": "value",
                "--tiering-policy": "value",
                "--unix-permissions": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "network-connectivity": {
      "commands": {
        "hubs": {
          "commands": {
            "accept-spoke": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--spoke": "value"
              }
            },
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--export-psc": "bool",
                "--labels": "value",
                "--policy-mode": [
                  "policy-mode-unspecified",
                  "preset"
                ],
                "--preset-topology": [
                  "hybrid-inspection",
                  "mesh",
                  "preset-topology-unspecified",
                  "star"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "groups": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--hub": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--hub": "value"
                  }
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--hub": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--hub": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--hub": "value",
                    "--member": "value",
                    "--role": "dynamic"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {
                    "--hub": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-auto-accept-projects": "value",
                    "--async": "bool",
                    "--clear-auto-accept-projects": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--hub": "dynamic",
                    "--remove-auto-accept-projects": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list-spokes": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--spoke-locations": "value",
                "--view": [
                  "basic",
                  "detailed"
                ]
              }
            },
            "query-status": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--group-by": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "reject-spoke": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--details": "value",
                "--spoke": "value"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "route-tables": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--hub": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--hub": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "routes": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--hub": "value",
                        "--route_table": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--effective-location": "value",
                        "--filter": "value",
                        "--hub": "value",
                        "--limit": "value",
                        "--page-size": "value",
                        "--route_table": "value",
                        "--sort-by": "value"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-labels": "bool",
                "--description": "value",
                "--export-psc": "bool",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "internal-ranges": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--ip-cidr-range": "value",
                "--labels": "value",
                "--migration-source": "value",
                "--migration-target": "value",
                "--network": "value",
                "--overlaps": "value",
                "--peering": [
                  "for-peer",
                  "for-self",
                  "not-shared"
                ],
                "--prefix-length": "value",
                "--region": "value",
                "--target-cidr-range": "value",
                "--usage": [
                  "external-to-vpc",
                  "for-migration",
                  "for-vpc"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-labels": "bool",
                "--clear-overlaps": "bool",
                "--description": "value",
                "--ip-cidr-range": "value",
                "--labels": "value",
                "--overlaps": "value",
                "--prefix-length": "value",
                "--region": "value"
              }
            }
          },
          "flags": {}
        },
        "locations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value"
              }
            }
          },
          "flags": {}
        },
        "policy-based-routes": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--destination-range": "value",
                "--interconnect-attachment-region": "value",
                "--ip-protocol": "value",
                "--labels": "value",
                "--network": "value",
                "--next-hop-ilb-ip": "value",
                "--next-hop-other-routes": [
                  "default-routing",
                  "other-routes-unspecified"
                ],
                "--priority": "value",
                "--protocol-version": [
                  "ipv4",
                  "protocol-version-unspecified"
                ],
                "--source-range": "value",
                "--tags": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            }
          },
          "flags": {}
        },
        "regional-endpoints": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--address": "value",
                "--async": "bool",
                "--description": "value",
                "--enable-global-access": "bool",
                "--labels": "value",
                "--network": "value",
                "--region": "value",
                "--subnetwork": "value",
                "--target-google-api": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value"
              }
            }
          },
          "flags": {}
        },
        "service-connection-policies": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--allowed-google-producers-resource-hierarchy-level": "value",
                "--async": "bool",
                "--description": "value",
                "--labels": "value",
                "--network": "value",
                "--producer-instance-location": [
                  "custom-resource-hierarchy-levels",
                  "none"
                ],
                "--psc-connection-limit": "value",
                "--region": "value",
                "--service-class": "value",
                "--subnets": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--labels": "value",
                "--psc-connection-limit": "value",
                "--region": "value",
                "--subnets": "value"
              }
            }
          },
          "flags": {}
        },
        "spokes": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--global": "bool",
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--global": "bool",
                "--region": "value"
              }
            },
            "linked-interconnect-attachments": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--group": "value",
                    "--hub": "value",
                    "--include-import-ranges": "value",
                    "--interconnect-attachments": "value",
                    "--labels": "value",
                    "--region": "value",
                    "--site-to-site-data-transfer": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--include-import-ranges": "value",
                    "--region": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "linked-producer-vpc-network": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--exclude-export-ranges": "value",
                    "--global": "bool",
                    "--hub": "value",
                    "--include-export-ranges": "value",
                    "--labels": "value",
                    "--network": "value",
                    "--peering": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--global": "bool",
                    "--include-export-ranges": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "linked-router-appliances": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--group": "value",
                    "--hub": "value",
                    "--include-import-ranges": "value",
                    "--labels": "value",
                    "--region": "value",
                    "--router-appliance": "value",
                    "--site-to-site-data-transfer": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--include-import-ranges": "value",
                    "--region": "value",
                    "--remove-labels": "value",
                    "--router-appliance": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "linked-vpc-network": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--exclude-export-ranges": "value",
                    "--global": "bool",
                    "--hub": "value",
                    "--include-export-ranges": "value",
                    "--labels": "value",
                    "--vpc-network": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--global": "bool",
                    "--include-export-ranges": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "linked-vpn-tunnels": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--group": "value",
                    "--hub": "value",
                    "--include-import-ranges": "value",
                    "--labels": "value",
                    "--region": "value",
                    "--site-to-site-data-transfer": "bool",
                    "--vpn-tunnels": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--description": "value",
                    "--include-import-ranges": "value",
                    "--region": "value",
                    "--remove-labels": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--global": "bool",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "network-management": {
      "commands": {
        "connectivity-tests": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--bypass-firewall-checks": "bool",
                "--description": "value",
                "--destination-cloud-sql-instance": "value",
                "--destination-forwarding-rule": "value",
                "--destination-fqdn": "value",
                "--destination-gke-master-cluster": "value",
                "--destination-instance": "value",
                "--destination-ip-address": "value",
                "--destination-network": "value",
                "--destination-port": "value",
                "--destination-project": "value",
                "--destination-redis-cluster": "value",
                "--destination-redis-instance": "value",
                "--labels": "value",
                "--other-projects": "value",
                "--protocol": "value",
                "--round-trip": "bool",
                "--source-app-engine-version": "value",
                "--source-cloud-function": "value",
                "--source-cloud-run-revision": "value",
                "--source-cloud-sql-instance": "value",
                "--source-gke-master-cluster": "value",
                "--source-instance": "value",
                "--source-ip-address": "value",
                "--source-network": "value",
                "--source-network-type": [
                  "gcp-network",
                  "non-gcp-network"
                ],
                "--source-project": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "rerun": {
              "commands": {},
              "flags": {
                "--async": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--bypass-firewall-checks": "bool",
                "--clear-destination-cloud-sql-instance": "bool",
                "--clear-destination-forwarding-rule": "bool",
                "--clear-destination-gke-master-cluster": "bool",
                "--clear-destination-instance": "bool",
                "--clear-destination-ip-address": "bool",
                "--clear-destination-redis-cluster": "bool",
                "--clear-destination-redis-instance": "bool",
                "--clear-source-app-engine-version": "bool",
                "--clear-source-cloud-function": "bool",
                "--clear-source-cloud-run-revision": "bool",
                "--clear-source-cloud-sql-instance": "bool",
                "--clear-source-gke-master-cluster": "bool",
                "--clear-source-instance": "bool",
                "--clear-source-ip-address": "bool",
                "--description": "value",
                "--destination-cloud-sql-instance": "value",
                "--destination-forwarding-rule": "value",
                "--destination-fqdn": "value",
                "--destination-gke-master-cluster": "value",
                "--destination-instance": "value",
                "--destination-ip-address": "value",
                "--destination-network": "value",
                "--destination-port": "value",
                "--destination-project": "value",
                "--destination-redis-cluster": "value",
                "--destination-redis-instance": "value",
                "--labels": "value",
                "--other-projects": "value",
                "--protocol": "value",
                "--round-trip": "bool",
                "--source-app-engine-version": "value",
                "--source-cloud-function": "value",
                "--source-cloud-run-revision": "value",
                "--source-cloud-sql-instance": "value",
                "--source-gke-master-cluster": "value",
                "--source-instance": "value",
                "--source-ip-address": "value",
                "--source-network": "value",
                "--source-network-type": [
                  "gcp-network",
                  "non-gcp-network"
                ],
                "--source-project": "value"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            }
          },
          "flags": {}
        },
        "vpc-flow-logs-configs": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--aggregation-interval": [
                  "interval-1-min",
                  "interval-10-min",
                  "interval-15-min",
                  "interval-30-sec",
                  "interval-5-min",
                  "interval-5-sec"
                ],
                "--async": "bool",
                "--description": "value",
                "--filter-expr": "value",
                "--flow-sampling": "value",
                "--interconnect-attachment": "value",
                "--labels": "value",
                "--location": "dynamic",
                "--metadata": [
                  "custom-metadata",
                  "exclude-all-metadata",
                  "include-all-metadata"
                ],
                "--metadata-fields": "value",
                "--state": [
                  "disabled",
                  "enabled"
                ],
                "--vpn-tunnel": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-metadata-fields": "value",
                "--aggregation-interval": [
                  "interval-1-min",
                  "interval-10-min",
                  "interval-15-min",
                  "interval-30-sec",
                  "interval-5-min",
                  "interval-5-sec"
                ],
                "--async": "bool",
                "--clear-labels": "bool",
                "--clear-metadata-fields": "bool",
                "--description": "value",
                "--filter-expr": "value",
                "--flow-sampling": "value",
                "--interconnect-attachment": "value",
                "--labels": "value",
                "--location": "dynamic",
                "--metadata": [
                  "custom-metadata",
                  "exclude-all-metadata",
                  "include-all-metadata"
                ],
                "--metadata-fields": "value",
                "--remove-labels": "value",
                "--remove-metadata-fields": "value",
                "--state": [
                  "disabled",
                  "enabled"
                ],
                "--update-labels": "value",
                "--vpn-tunnel": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "network-security": {
      "commands": {
        "address-groups": {
          "commands": {
            "add-items": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--items": "value",
                "--location": "value"
              }
            },
            "clone-items": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--source": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--capacity": "value",
                "--description": "value",
                "--items": "value",
                "--labels": "value",
                "--location": "value",
                "--purpose": "value",
                "--type": [
                  "ipv4",
                  "ipv6"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "list-references": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-items": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--items": "value",
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-labels": "bool",
                "--description": "value",
                "--items": "value",
                "--location": "value",
                "--purpose": "value",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "authorization-policies": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--location": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "client-tls-policies": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--location": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "firewall-endpoint-associations": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--endpoint": "value",
                "--endpoint-zone": "value",
                "--labels": "value",
                "--max-wait": "value",
                "--network": "value",
                "--organization": "value",
                "--tls-inspection-policy": "value",
                "--tls-inspection-policy-project": "value",
                "--tls-inspection-policy-region": "value",
                "--zone": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--max-wait": "value",
                "--zone": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--zone": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool",
                "--zone": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-labels": "bool",
                "--disabled": "bool",
                "--max-wait": "value",
                "--no-tls-inspection-policy": "bool",
                "--remove-labels": "value",
                "--tls-inspection-policy": "value",
                "--tls-inspection-policy-project": "value",
                "--tls-inspection-policy-region": "value",
                "--update-labels": "value",
                "--zone": "value"
              }
            }
          },
          "flags": {}
        },
        "firewall-endpoints": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--labels": "value",
                "--max-wait": "value",
                "--organization": "value",
                "--zone": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--max-wait": "value",
                "--organization": "value",
                "--zone": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--organization": "value",
                "--zone": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool",
                "--zone": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-labels": "bool",
                "--description": "value",
                "--max-wait": "value",
                "--organization": "value",
                "--remove-labels": "value",
                "--update-billing-project": "value",
                "--update-labels": "value",
                "--zone": "value"
              }
            }
          },
          "flags": {}
        },
        "gateway-security-policies": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--location": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "rules": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--gateway-security-policy": "value",
                    "--location": "value"
                  }
                },
                "export": {
                  "commands": {},
                  "flags": {
                    "--destination": "value",
                    "--gateway-security-policy": "value",
                    "--location": "value"
                  }
                },
                "import": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--gateway-security-policy": "value",
                    "--location": "value",
                    "--source": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--gateway-security-policy": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "org-address-groups": {
          "commands": {
            "add-items": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--items": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "clone-items": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--organization": "value",
                "--source": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--capacity": "value",
                "--description": "value",
                "--items": "value",
                "--labels": "value",
                "--location": "value",
                "--organization": "value",
                "--type": [
                  "ipv4",
                  "ipv6"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--organization": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "list-references": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-items": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--items": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-labels": "bool",
                "--description": "value",
                "--items": "value",
                "--location": "value",
                "--organization": "value",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "security-profile-groups": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--labels": "value",
                "--location": "value",
                "--organization": "value",
                "--threat-prevention-profile": "value",
                "--threat-prevention-profile-location": "value",
                "--threat-prevention-profile-organization": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--organization": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-labels": "bool",
                "--description": "value",
                "--location": "value",
                "--organization": "value",
                "--remove-labels": "value",
                "--threat-prevention-profile": "value",
                "--threat-prevention-profile-location": "value",
                "--threat-prevention-profile-organization": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "security-profiles": {
          "commands": {
            "threat-prevention": {
              "commands": {
                "add-override": {
                  "commands": {},
                  "flags": {
                    "--action": [
                      "ALERT",
                      "ALLOW",
                      "DEFAULT_ACTION",
                      "DENY"
                    ],
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--location": "value",
                    "--organization": "value",
                    "--remove-labels": "value",
                    "--severities": "value",
                    "--threat-ids": "value",
                    "--update-labels": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--labels": "value",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "delete-override": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--location": "value",
                    "--organization": "value",
                    "--remove-labels": "value",
                    "--severities": "value",
                    "--threat-ids": "value",
                    "--update-labels": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "list-overrides": {
                  "commands": {},
                  "flags": {
                    "--location": "value",
                    "--organization": "value"
                  }
                },
                "update-override": {
                  "commands": {},
                  "flags": {
                    "--action": [
                      "ALERT",
                      "ALLOW",
                      "DEFAULT_ACTION",
                      "DENY"
                    ],
                    "--async": "bool",
                    "--clear-labels": "bool",
                    "--location": "value",
                    "--organization": "value",
                    "--remove-labels": "value",
                    "--severities": "value",
                    "--threat-ids": "value",
                    "--update-labels": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "server-tls-policies": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--location": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "tls-inspection-policies": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--location": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "url-lists": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--location": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "network-services": {
      "commands": {
        "endpoint-policies": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--location": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "gateways": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--location": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "grpc-routes": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--location": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "http-routes": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--location": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "meshes": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--location": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "route-views": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--gateway": "value",
                "--location": "value",
                "--mesh": "value",
                "--route-view": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--gateway": "value",
                "--limit": "value",
                "--location": "value",
                "--mesh": "value",
                "--page-size": "value"
              }
            }
          },
          "flags": {}
        },
        "service-bindings": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--location": "value",
                "--service-directory-namespace": "value",
                "--service-directory-region": "value",
                "--service-directory-service": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "service-lb-policies": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--auto-capacity-drain": "bool",
                "--description": "value",
                "--failover-health-threshold": "value",
                "--load-balancing-algorithm": [
                  "spray-to-region",
                  "spray-to-world",
                  "waterfall-by-region",
                  "waterfall-by-zone"
                ],
                "--location": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--location": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--auto-capacity-drain": "bool",
                "--description": "value",
                "--failover-health-threshold": "value",
                "--load-balancing-algorithm": [
                  "spray-to-region",
                  "spray-to-world",
                  "waterfall-by-region",
                  "waterfall-by-zone"
                ],
                "--location": "value"
              }
            }
          },
          "flags": {}
        },
        "tcp-routes": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--location": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "tls-routes": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--location": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "notebooks": {
      "commands": {
        "environments": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--container-repository": "value",
                "--container-tag": "value",
                "--description": "value",
                "--display-name": "value",
                "--location": "dynamic",
                "--post-startup-script": "value",
                "--vm-image-family": "value",
                "--vm-image-name": "value",
                "--vm-image-project": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "instances": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "dynamic",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--accelerator-core-count": "value",
                "--accelerator-type": [
                  "NVIDIA_H100_80GB",
                  "NVIDIA_H100_MEGA_80GB",
                  "NVIDIA_L4",
                  "NVIDIA_TESLA_A100",
                  "NVIDIA_TESLA_K80",
                  "NVIDIA_TESLA_P100",
                  "NVIDIA_TESLA_P100_VWS",
                  "NVIDIA_TESLA_P4",
                  "NVIDIA_TESLA_P4_VWS",
                  "NVIDIA_TESLA_T4",
                  "NVIDIA_TESLA_T4_VWS",
                  "NVIDIA_TESLA_V100",
                  "TPU_V2",
                  "TPU_V3"
                ],
                "--async": "bool",
                "--boot-disk-size": "value",
                "--boot-disk-type": [
                  "PD_BALANCED",
                  "PD_EXTREME",
                  "PD_SSD",
                  "PD_STANDARD"
                ],
                "--container-repository": "value",
                "--container-tag": "value",
                "--custom-gpu-driver-path": "value",
                "--data-disk-size": "value",
                "--data-disk-type": [
                  "PD_BALANCED",
                  "PD_EXTREME",
                  "PD_SSD",
                  "PD_STANDARD"
                ],
                "--disk-encryption": [
                  "CMEK",
                  "GMEK"
                ],
                "--environment": "dynamic",
                "--environment-location": "dynamic",
                "--install-gpu-driver": "bool",
                "--instance-owners": "value",
                "--kms-key": "dynamic",
                "--kms-keyring": "dynamic",
                "--kms-location": "dynamic",
                "--kms-project": "dynamic",
                "--labels": "value",
                "--location": "dynamic",
                "--machine-type": "value",
                "--metadata": "value",
                "--network": "dynamic",
                "--no-proxy-access": "bool",
                "--no-public-ip": "bool",
                "--no-remove-data-disk": "bool",
                "--post-startup-script": "value",
                "--reservation": "value",
                "--reservation-affinity": [
                  "ANY_RESERVATION",
                  "NO_RESERVATION",
                  "SPECIFIC_RESERVATION",
                  "TYPE_UNSPECIFIED"
                ],
                "--service-account": "value",
                "--shielded-integrity-monitoring": "bool",
                "--shielded-secure-boot": "bool",
                "--shielded-vtpm": "bool",
                "--subnet": "dynamic",
                "--subnet-region": "dynamic",
                "--tags": "value",
                "--vm-image-family": "value",
                "--vm-image-name": "value",
                "--vm-image-project": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "diagnose": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--enable-copy-home-files": "bool",
                "--enable-packet-capture": "bool",
                "--enable-repair": "bool",
                "--gcs-bucket": "value",
                "--location": "dynamic",
                "--relative-path": "value",
                "--timeout-minutes": "value"
              }
            },
            "get-health": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "is-upgradeable": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "migrate": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic",
                "--post-startup-script-option": [
                  "POST_STARTUP_SCRIPT_OPTION_RERUN",
                  "POST_STARTUP_SCRIPT_OPTION_SKIP",
                  "POST_STARTUP_SCRIPT_OPTION_UNSPECIFIED"
                ]
              }
            },
            "register": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "dynamic",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "reset": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "rollback": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic",
                "--target-snapshot": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "start": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "stop": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--accelerator-core-count": "value",
                "--accelerator-type": [
                  "NVIDIA_H100_80GB",
                  "NVIDIA_H100_MEGA_80GB",
                  "NVIDIA_L4",
                  "NVIDIA_TESLA_A100",
                  "NVIDIA_TESLA_K80",
                  "NVIDIA_TESLA_P100",
                  "NVIDIA_TESLA_P100_VWS",
                  "NVIDIA_TESLA_P4",
                  "NVIDIA_TESLA_P4_VWS",
                  "NVIDIA_TESLA_T4",
                  "NVIDIA_TESLA_T4_VWS",
                  "NVIDIA_TESLA_V100",
                  "TPU_V2",
                  "TPU_V3"
                ],
                "--async": "bool",
                "--labels": "value",
                "--location": "dynamic",
                "--machine-type": "value"
              }
            },
            "upgrade": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "locations": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "runtimes": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--custom-gpu-driver-path": "value",
                "--idle-shutdown-timeout": "value",
                "--install-gpu-driver": "value",
                "--interface": "value",
                "--location": "dynamic",
                "--machine-type": "value",
                "--mode": "value",
                "--post-startup-script": "value",
                "--post-startup-script-behavior": "value",
                "--runtime-access-type": "value",
                "--runtime-owner": "value",
                "--runtime-type": "value",
                "--source": "value",
                "--type": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "diagnose": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--enable-copy-home-files": "bool",
                "--enable-packet-capture": "bool",
                "--enable-repair": "bool",
                "--gcs-bucket": "value",
                "--location": "dynamic",
                "--relative-path": "value",
                "--timeout-minutes": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "migrate": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic",
                "--network": "dynamic",
                "--post-startup-script-option": [
                  "POST_STARTUP_SCRIPT_OPTION_RERUN",
                  "POST_STARTUP_SCRIPT_OPTION_SKIP",
                  "POST_STARTUP_SCRIPT_OPTION_UNSPECIFIED"
                ],
                "--service-account": "value",
                "--subnet": "dynamic",
                "--subnet-region": "dynamic"
              }
            },
            "reset": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "start": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "stop": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "switch": {
              "commands": {},
              "flags": {
                "--accelerator-core-count": "value",
                "--accelerator-type": [
                  "NVIDIA_TESLA_A100",
                  "NVIDIA_TESLA_K80",
                  "NVIDIA_TESLA_P100",
                  "NVIDIA_TESLA_P100_VWS",
                  "NVIDIA_TESLA_P4",
                  "NVIDIA_TESLA_P4_VWS",
                  "NVIDIA_TESLA_T4",
                  "NVIDIA_TESLA_T4_VWS",
                  "NVIDIA_TESLA_V100",
                  "TPU_V2",
                  "TPU_V3"
                ],
                "--async": "bool",
                "--location": "dynamic",
                "--machine-type": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "oracle-database": {
      "commands": {
        "autonomous-database-backups": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "autonomous-database-character-sets": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "autonomous-databases": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--admin-password": "value",
                "--async": "bool",
                "--cidr": "value",
                "--database": "value",
                "--display-name": "value",
                "--labels": "value",
                "--location": "dynamic",
                "--network": "value",
                "--properties-backup-retention-period-days": "value",
                "--properties-character-set": "value",
                "--properties-compute-count": "value",
                "--properties-cpu-core-count": "value",
                "--properties-customer-contacts": "value",
                "--properties-data-storage-size-gb": "value",
                "--properties-data-storage-size-tb": "value",
                "--properties-db-edition": [
                  "enterprise-edition",
                  "standard-edition"
                ],
                "--properties-db-version": "value",
                "--properties-db-workload": [
                  "ajd",
                  "apex",
                  "dw",
                  "oltp"
                ],
                "--properties-is-auto-scaling-enabled": "bool",
                "--properties-is-storage-auto-scaling-enabled": "bool",
                "--properties-license-type": [
                  "bring-your-own-license",
                  "license-included"
                ],
                "--properties-maintenance-schedule-type": [
                  "early",
                  "regular"
                ],
                "--properties-mtls-connection-required": "bool",
                "--properties-n-character-set": "value",
                "--properties-private-endpoint-ip": "value",
                "--properties-private-endpoint-label": "value",
                "--properties-secret-id": "value",
                "--properties-vault-id": "value",
                "--request-id": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic",
                "--request-id": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "generate-wallet": {
              "commands": {},
              "flags": {
                "--is-regional": "bool",
                "--location": "dynamic",
                "--password": "value",
                "--type": [
                  "all",
                  "single"
                ]
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "restore": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic",
                "--restore-time": "value"
              }
            }
          },
          "flags": {}
        },
        "autonomous-db-versions": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "cloud-exadata-infrastructures": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--display-name": "value",
                "--gcp-oracle-zone": "value",
                "--labels": "value",
                "--location": "dynamic",
                "--maintenance-window-custom-action-timeout-mins": "value",
                "--maintenance-window-days-of-week": "value",
                "--maintenance-window-hours-of-day": "value",
                "--maintenance-window-is-custom-action-timeout-enabled": "bool",
                "--maintenance-window-lead-time-week": "value",
                "--maintenance-window-months": "value",
                "--maintenance-window-patching-mode": [
                  "non-rolling",
                  "rolling"
                ],
                "--maintenance-window-preference": [
                  "custom-preference",
                  "no-preference"
                ],
                "--maintenance-window-weeks-of-month": "value",
                "--properties-compute-count": "value",
                "--properties-customer-contacts": "value",
                "--properties-shape": "value",
                "--properties-storage-count": "value",
                "--properties-total-storage-size-gb": "value",
                "--request-id": "value"
              }
            },
            "db-servers": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--cloud-exadata-infrastructure": "dynamic",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--force": "bool",
                "--location": "dynamic",
                "--request-id": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "cloud-vm-clusters": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--backup-subnet-cidr": "value",
                "--cidr": "value",
                "--diagnostics-data-collection-options-events-enabled": "bool",
                "--diagnostics-data-collection-options-health-monitoring-enabled": "bool",
                "--diagnostics-data-collection-options-incident-logs-enabled": "bool",
                "--display-name": "value",
                "--exadata-infrastructure": "dynamic",
                "--labels": "value",
                "--location": "value",
                "--network": "value",
                "--properties-cluster-name": "value",
                "--properties-cpu-core-count": "value",
                "--properties-data-storage-size-tb": "value",
                "--properties-db-node-storage-size-gb": "value",
                "--properties-db-server-ocids": "value",
                "--properties-disk-redundancy": [
                  "high",
                  "normal"
                ],
                "--properties-gi-version": "value",
                "--properties-hostname-prefix": "value",
                "--properties-license-type": [
                  "bring-your-own-license",
                  "license-included"
                ],
                "--properties-local-backup-enabled": "bool",
                "--properties-memory-size-gb": "value",
                "--properties-node-count": "value",
                "--properties-ocpu-count": "value",
                "--properties-sparse-diskgroup-enabled": "bool",
                "--properties-ssh-public-keys": "value",
                "--request-id": "value",
                "--time-zone-id": "value",
                "--time-zone-version": "value"
              }
            },
            "db-nodes": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--cloud-vm-cluster": "dynamic",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--force": "bool",
                "--location": "dynamic",
                "--request-id": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "db-system-shapes": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "entitlements": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "gi-versions": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "wait": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "org-policies": {
      "commands": {
        "delete": {
          "commands": {},
          "flags": {
            "--etag": "value",
            "--folder": "value",
            "--organization": "dynamic"
          }
        },
        "delete-custom-constraint": {
          "commands": {},
          "flags": {
            "--organization": "value"
          }
        },
        "describe": {
          "commands": {},
          "flags": {
            "--effective": "bool",
            "--folder": "value",
            "--organization": "dynamic"
          }
        },
        "describe-custom-constraint": {
          "commands": {},
          "flags": {
            "--organization": "value"
          }
        },
        "list": {
          "commands": {},
          "flags": {
            "--filter": "value",
            "--folder": "value",
            "--limit": "value",
            "--organization": "dynamic",
            "--page-size": "value",
            "--show-unset": "bool",
            "--sort-by": "value",
            "--uri": "bool"
          }
        },
        "list-custom-constraints": {
          "commands": {},
          "flags": {
            "--filter": "value",
            "--limit": "value",
            "--organization": "value",
            "--page-size": "value",
            "--sort-by": "value",
            "--uri": "bool"
          }
        },
        "reset": {
          "commands": {},
          "flags": {
            "--folder": "value",
            "--organization": "dynamic",
            "--update-mask": "value"
          }
        },
        "set-custom-constraint": {
          "commands": {},
          "flags": {}
        },
        "set-policy": {
          "commands": {},
          "flags": {
            "--update-mask": "value"
          }
        }
      },
      "flags": {}
    },
    "organizations": {
      "commands": {
        "add-iam-policy-binding": {
          "commands": {},
          "flags": {
            "--condition": "value",
            "--condition-from-file": "value",
            "--member": "value",
            "--role": "dynamic"
          }
        },
        "describe": {
          "commands": {},
          "flags": {}
        },
        "get-iam-policy": {
          "commands": {},
          "flags": {
            "--filter": "value",
            "--limit": "value",
            "--page-size": "value",
            "--sort-by": "value"
          }
        },
        "list": {
          "commands": {},
          "flags": {
            "--filter": "value",
            "--limit": "value",
            "--page-size": "value",
            "--sort-by": "value",
            "--uri": "bool"
          }
        },
        "remove-iam-policy-binding": {
          "commands": {},
          "flags": {
            "--all": "bool",
            "--condition": "value",
            "--condition-from-file": "value",
            "--member": "value",
            "--role": "dynamic"
          }
        },
        "set-iam-policy": {
          "commands": {},
          "flags": {}
        }
      },
      "flags": {}
    },
    "pam": {
      "commands": {
        "check-onboarding-status": {
          "commands": {},
          "flags": {
            "--folder": "value",
            "--location": "value",
            "--organization": "value"
          }
        },
        "entitlements": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--entitlement-file": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--folder": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--destination": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--location": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "search": {
              "commands": {},
              "flags": {
                "--caller-access-type": [
                  "grant-approver",
                  "grant-requester"
                ],
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--location": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--entitlement-file": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "value"
              }
            }
          },
          "flags": {}
        },
        "grants": {
          "commands": {
            "approve": {
              "commands": {},
              "flags": {
                "--entitlement": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "value",
                "--reason": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--additional-email-recipients": "value",
                "--entitlement": "value",
                "--folder": "value",
                "--justification": "value",
                "--location": "value",
                "--organization": "value",
                "--requested-duration": "value"
              }
            },
            "deny": {
              "commands": {},
              "flags": {
                "--entitlement": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "value",
                "--reason": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--entitlement": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--entitlement": "value",
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--location": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "revoke": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--entitlement": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "value",
                "--reason": "value"
              }
            },
            "search": {
              "commands": {},
              "flags": {
                "--caller-relationship": [
                  "can-approve",
                  "had-approved",
                  "had-created"
                ],
                "--entitlement": "value",
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--location": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--location": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "wait": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--location": "value",
                "--organization": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "policy-intelligence": {
      "commands": {
        "query-activity": {
          "commands": {},
          "flags": {
            "--activity-type": [
              "serviceAccountKeyLastAuthentication",
              "serviceAccountLastAuthentication"
            ],
            "--limit": "value",
            "--page-size": "value",
            "--query-filter": "value"
          }
        },
        "troubleshoot-policy": {
          "commands": {
            "iam": {
              "commands": {},
              "flags": {
                "--destination-ip": "value",
                "--destination-port": "value",
                "--permission": "value",
                "--principal-email": "value",
                "--request-time": "value",
                "--resource-name": "value",
                "--resource-service": "value",
                "--resource-type": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "policy-troubleshoot": {
      "commands": {
        "iam": {
          "commands": {},
          "flags": {
            "--destination-ip": "value",
            "--destination-port": "value",
            "--permission": "value",
            "--principal-email": "value",
            "--request-time": "value",
            "--resource-name": "value",
            "--resource-service": "value",
            "--resource-type": "value"
          }
        }
      },
      "flags": {}
    },
    "preview": {
      "commands": {
        "config": {
          "commands": {
            "configurations": {
              "commands": {
                "activate": {
                  "commands": {},
                  "flags": {}
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--activate": "bool"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--all": "bool"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--sort-by": "value"
                  }
                },
                "rename": {
                  "commands": {},
                  "flags": {
                    "--new-name": "value"
                  }
                }
              },
              "flags": {}
            },
            "get": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--filter": "value",
                "--limit": "value",
                "--sort-by": "value"
              }
            },
            "set": {
              "commands": {},
              "flags": {
                "--installation": "bool"
              }
            },
            "unset": {
              "commands": {},
              "flags": {
                "--installation": "bool"
              }
            }
          },
          "flags": {}
        },
        "help": {
          "commands": {},
          "flags": {
            "--filter": "value",
            "--limit": "value",
            "--page-size": "value",
            "--sort-by": "value"
          }
        },
        "init": {
          "commands": {},
          "flags": {
            "--console-only": "bool",
            "--no-browser": "bool",
            "--no-launch-browser": "bool",
            "--skip-diagnostics": "bool"
          }
        },
        "survey": {
          "commands": {},
          "flags": {}
        }
      },
      "flags": {}
    },
    "privateca": {
      "commands": {
        "certificates": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--ca": "value",
                "--cert-output-file": "value",
                "--csr": "value",
                "--dns-san": "value",
                "--email-san": "value",
                "--extended-key-usages": "value",
                "--generate-key": "bool",
                "--ip-san": "value",
                "--is-ca-cert": "bool",
                "--issuer-location": "dynamic",
                "--issuer-pool": "dynamic",
                "--key-output-file": "value",
                "--key-usages": "value",
                "--kms-key": "value",
                "--kms-key-version": "value",
                "--kms-keyring": "value",
                "--kms-location": "dynamic",
                "--kms-project": "value",
                "--labels": "value",
                "--max-chain-length": "value",
                "--name-constraints-critical": "bool",
                "--name-excluded-dns": "value",
                "--name-excluded-email": "value",
                "--name-excluded-ip": "value",
                "--name-excluded-uri": "value",
                "--name-permitted-dns": "value",
                "--name-permitted-email": "value",
                "--name-permitted-ip": "value",
                "--name-permitted-uri": "value",
                "--subject": "value",
                "--subject-key-id": "value",
                "--template": "value",
                "--template-location": "dynamic",
                "--unconstrained-chain-length": "bool",
                "--uri-san": "value",
                "--use-preset-profile": "value",
                "--validate-only": "bool",
                "--validity": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--issuer-location": "value",
                "--issuer-pool": "value"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--include-chain": "bool",
                "--issuer-location": "dynamic",
                "--issuer-pool": "dynamic",
                "--output-file": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--issuer-pool": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "revoke": {
              "commands": {},
              "flags": {
                "--certificate": "dynamic",
                "--issuer-location": "dynamic",
                "--issuer-pool": "value",
                "--reason": [
                  "affiliation-changed",
                  "attribute-authority-compromise",
                  "certificate-authority-compromise",
                  "certificate-hold",
                  "cessation-of-operation",
                  "key-compromise",
                  "privilege-withdrawn",
                  "superseded",
                  "unspecified"
                ],
                "--serial-number": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-labels": "bool",
                "--issuer-location": "dynamic",
                "--issuer-pool": "dynamic",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "locations": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "pools": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--issuance-policy": "value",
                "--labels": "value",
                "--location": "dynamic",
                "--publish-ca-cert": "bool",
                "--publish-crl": "bool",
                "--publishing-encoding-format": [
                  "der",
                  "pem"
                ],
                "--tier": [
                  "devops",
                  "enterprise"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--ignore-dependent-resources": "bool",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "get-ca-certs": {
              "commands": {},
              "flags": {
                "--location": "dynamic",
                "--output-file": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-labels": "bool",
                "--issuance-policy": "value",
                "--location": "dynamic",
                "--publish-ca-cert": "bool",
                "--publish-crl": "bool",
                "--publishing-encoding-format": [
                  "der",
                  "pem"
                ],
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "roots": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--auto-enable": "bool",
                "--bucket": "value",
                "--dns-san": "value",
                "--email-san": "value",
                "--extended-key-usages": "value",
                "--from-ca": "value",
                "--ip-san": "value",
                "--key-algorithm": [
                  "ec-p256-sha256",
                  "ec-p384-sha384",
                  "rsa-pkcs1-2048-sha256",
                  "rsa-pkcs1-3072-sha256",
                  "rsa-pkcs1-4096-sha256",
                  "rsa-pss-2048-sha256",
                  "rsa-pss-3072-sha256",
                  "rsa-pss-4096-sha256"
                ],
                "--key-usages": "value",
                "--kms-key": "value",
                "--kms-key-version": "value",
                "--kms-keyring": "value",
                "--kms-location": "dynamic",
                "--kms-project": "value",
                "--labels": "value",
                "--location": "dynamic",
                "--max-chain-length": "value",
                "--name-constraints-critical": "bool",
                "--name-excluded-dns": "value",
                "--name-excluded-email": "value",
                "--name-excluded-ip": "value",
                "--name-excluded-uri": "value",
                "--name-permitted-dns": "value",
                "--name-permitted-email": "value",
                "--name-permitted-ip": "value",
                "--name-permitted-uri": "value",
                "--pool": "value",
                "--subject": "value",
                "--subject-key-id": "value",
                "--unconstrained-chain-length": "bool",
                "--uri-san": "value",
                "--use-preset-profile": "value",
                "--validity": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--ignore-active-certificates": "bool",
                "--ignore-dependent-resources": "bool",
                "--location": "dynamic",
                "--pool": "value",
                "--skip-grace-period": "bool"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--pool": "value"
              }
            },
            "disable": {
              "commands": {},
              "flags": {
                "--ignore-dependent-resources": "bool",
                "--location": "dynamic",
                "--pool": "value"
              }
            },
            "enable": {
              "commands": {},
              "flags": {
                "--location": "dynamic",
                "--pool": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--pool": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "undelete": {
              "commands": {},
              "flags": {
                "--location": "dynamic",
                "--pool": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-labels": "bool",
                "--location": "dynamic",
                "--pool": "value",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "subordinates": {
          "commands": {
            "activate": {
              "commands": {},
              "flags": {
                "--auto-enable": "bool",
                "--location": "dynamic",
                "--pem-chain": "value",
                "--pool": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--auto-enable": "bool",
                "--bucket": "value",
                "--create-csr": "bool",
                "--csr-output-file": "value",
                "--dns-san": "value",
                "--email-san": "value",
                "--extended-key-usages": "value",
                "--from-ca": "value",
                "--ip-san": "value",
                "--issuer-ca": "value",
                "--issuer-location": "dynamic",
                "--issuer-pool": "value",
                "--key-algorithm": [
                  "ec-p256-sha256",
                  "ec-p384-sha384",
                  "rsa-pkcs1-2048-sha256",
                  "rsa-pkcs1-3072-sha256",
                  "rsa-pkcs1-4096-sha256",
                  "rsa-pss-2048-sha256",
                  "rsa-pss-3072-sha256",
                  "rsa-pss-4096-sha256"
                ],
                "--key-usages": "value",
                "--kms-key": "value",
                "--kms-key-version": "value",
                "--kms-keyring": "value",
                "--kms-location": "dynamic",
                "--kms-project": "value",
                "--labels": "value",
                "--location": "dynamic",
                "--max-chain-length": "value",
                "--name-constraints-critical": "bool",
                "--name-excluded-dns": "value",
                "--name-excluded-email": "value",
                "--name-excluded-ip": "value",
                "--name-excluded-uri": "value",
                "--name-permitted-dns": "value",
                "--name-permitted-email": "value",
                "--name-permitted-ip": "value",
                "--name-permitted-uri": "value",
                "--pool": "value",
                "--subject": "value",
                "--subject-key-id": "value",
                "--unconstrained-chain-length": "bool",
                "--uri-san": "value",
                "--use-preset-profile": "value",
                "--validity": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--ignore-active-certificates": "bool",
                "--ignore-dependent-resources": "bool",
                "--location": "dynamic",
                "--pool": "value",
                "--skip-grace-period": "bool"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--pool": "value"
              }
            },
            "disable": {
              "commands": {},
              "flags": {
                "--ignore-dependent-resources": "bool",
                "--location": "dynamic",
                "--pool": "value"
              }
            },
            "enable": {
              "commands": {},
              "flags": {
                "--location": "dynamic",
                "--pool": "value"
              }
            },
            "get-csr": {
              "commands": {},
              "flags": {
                "--location": "dynamic",
                "--pool": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--pool": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "undelete": {
              "commands": {},
              "flags": {
                "--location": "dynamic",
                "--pool": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-labels": "bool",
                "--location": "dynamic",
                "--pem-chain": "value",
                "--pool": "value",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        },
        "templates": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--copy-all-requested-extensions": "bool",
                "--copy-extensions-by-oid": "value",
                "--copy-known-extensions": "value",
                "--copy-sans": "bool",
                "--copy-subject": "bool",
                "--description": "value",
                "--identity-cel-expression": "value",
                "--labels": "value",
                "--location": "dynamic",
                "--maximum-lifetime": "value",
                "--predefined-values-file": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "replicate": {
              "commands": {},
              "flags": {
                "--all-locations": "bool",
                "--continue-on-error": "bool",
                "--location": "dynamic",
                "--overwrite": "bool",
                "--target-locations": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-labels": "bool",
                "--copy-all-requested-extensions": "bool",
                "--copy-extensions-by-oid": "value",
                "--copy-known-extensions": "value",
                "--copy-sans": "bool",
                "--copy-subject": "bool",
                "--description": "value",
                "--drop-known-extensions": "bool",
                "--drop-oid-extensions": "bool",
                "--identity-cel-expression": "value",
                "--location": "dynamic",
                "--predefined-values-file": "value",
                "--remove-labels": "value",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "projects": {
      "commands": {
        "add-iam-policy-binding": {
          "commands": {},
          "flags": {
            "--condition": "value",
            "--condition-from-file": "value",
            "--member": "value",
            "--role": "dynamic"
          }
        },
        "create": {
          "commands": {},
          "flags": {
            "--enable-cloud-apis": "bool",
            "--folder": "value",
            "--labels": "value",
            "--name": "value",
            "--organization": "value",
            "--set-as-default": "bool",
            "--tags": "value"
          }
        },
        "delete": {
          "commands": {},
          "flags": {}
        },
        "describe": {
          "commands": {},
          "flags": {}
        },
        "get-ancestors": {
          "commands": {},
          "flags": {}
        },
        "get-ancestors-iam-policy": {
          "commands": {},
          "flags": {
            "--filter": "value",
            "--include-deny": "bool",
            "--limit": "value",
            "--page-size": "value",
            "--sort-by": "value"
          }
        },
        "get-iam-policy": {
          "commands": {},
          "flags": {
            "--filter": "value",
            "--limit": "value",
            "--page-size": "value",
            "--sort-by": "value"
          }
        },
        "list": {
          "commands": {},
          "flags": {
            "--filter": "value",
            "--limit": "value",
            "--page-size": "value",
            "--sort-by": "value",
            "--uri": "bool"
          }
        },
        "remove-iam-policy-binding": {
          "commands": {},
          "flags": {
            "--all": "bool",
            "--condition": "value",
            "--condition-from-file": "value",
            "--member": "value",
            "--role": "dynamic"
          }
        },
        "set-iam-policy": {
          "commands": {},
          "flags": {}
        },
        "undelete": {
          "commands": {},
          "flags": {}
        },
        "update": {
          "commands": {},
          "flags": {
            "--name": "value"
          }
        }
      },
      "flags": {}
    },
    "publicca": {
      "commands": {
        "external-account-keys": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--key-output-file": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "pubsub": {
      "commands": {
        "lite-operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--done": "bool",
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--subscription": "value"
              }
            }
          },
          "flags": {}
        },
        "lite-reservations": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--throughput-capacity": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list-topics": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--throughput-capacity": "value"
              }
            }
          },
          "flags": {}
        },
        "lite-subscriptions": {
          "commands": {
            "ack-up-to": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--offset": "value",
                "--partition": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--delivery-requirement": [
                  "deliver-after-stored",
                  "deliver-immediately"
                ],
                "--event-time": "value",
                "--export-dead-letter-topic": "value",
                "--export-desired-state": [
                  "active",
                  "paused"
                ],
                "--export-pubsub-topic": "value",
                "--location": "value",
                "--publish-time": "value",
                "--starting-offset": [
                  "beginning",
                  "end"
                ],
                "--topic": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "seek": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--event-time": "value",
                "--location": "value",
                "--publish-time": "value",
                "--starting-offset": [
                  "beginning",
                  "end"
                ]
              }
            },
            "subscribe": {
              "commands": {},
              "flags": {
                "--auto-ack": "bool",
                "--location": "value",
                "--num-messages": "value",
                "--partitions": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--delivery-requirement": [
                  "deliver-after-stored",
                  "deliver-immediately"
                ],
                "--export-dead-letter-topic": "value",
                "--export-desired-state": [
                  "active",
                  "paused"
                ],
                "--export-pubsub-topic": "value",
                "--location": "value"
              }
            }
          },
          "flags": {}
        },
        "lite-topics": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--message-retention-period": "value",
                "--partitions": "value",
                "--per-partition-bytes": "value",
                "--per-partition-publish-mib": "value",
                "--per-partition-subscribe-mib": "value",
                "--throughput-reservation": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list-subscriptions": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "publish": {
              "commands": {},
              "flags": {
                "--attributes": "value",
                "--event-time": "value",
                "--location": "value",
                "--message": "value",
                "--ordering-key": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--message-retention-period": "value",
                "--partitions": "value",
                "--per-partition-bytes": "value",
                "--per-partition-publish-mib": "value",
                "--per-partition-subscribe-mib": "value",
                "--throughput-reservation": "value"
              }
            }
          },
          "flags": {}
        },
        "schemas": {
          "commands": {
            "commit": {
              "commands": {},
              "flags": {
                "--definition": "value",
                "--definition-file": "value",
                "--type": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--definition": "value",
                "--definition-file": "value",
                "--type": [
                  "avro",
                  "protocol-buffer"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "delete-revision": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool",
                "--view": [
                  "basic",
                  "full"
                ]
              }
            },
            "list-revisions": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool",
                "--view": [
                  "basic",
                  "full"
                ]
              }
            },
            "rollback": {
              "commands": {},
              "flags": {
                "--revision-id": "value"
              }
            },
            "validate-message": {
              "commands": {},
              "flags": {
                "--definition": "value",
                "--definition-file": "value",
                "--message": "value",
                "--message-encoding": [
                  "binary",
                  "json"
                ],
                "--schema-name": "value",
                "--type": [
                  "avro",
                  "protocol-buffer"
                ]
              }
            },
            "validate-schema": {
              "commands": {},
              "flags": {
                "--definition": "value",
                "--definition-file": "value",
                "--type": [
                  "avro",
                  "protocol-buffer"
                ]
              }
            }
          },
          "flags": {}
        },
        "snapshots": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--labels": "value",
                "--subscription": "value",
                "--subscription-project": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "subscriptions": {
          "commands": {
            "ack": {
              "commands": {},
              "flags": {
                "--ack-ids": "value"
              }
            },
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--ack-deadline": "value",
                "--bigquery-service-account-email": "value",
                "--bigquery-table": "value",
                "--cloud-storage-bucket": "value",
                "--cloud-storage-file-datetime-format": "value",
                "--cloud-storage-file-prefix": "value",
                "--cloud-storage-file-suffix": "value",
                "--cloud-storage-max-bytes": "value",
                "--cloud-storage-max-duration": "value",
                "--cloud-storage-max-messages": "value",
                "--cloud-storage-output-format": "value",
                "--cloud-storage-service-account-email": "value",
                "--cloud-storage-use-topic-schema": "bool",
                "--cloud-storage-write-metadata": "bool",
                "--dead-letter-topic": "value",
                "--dead-letter-topic-project": "value",
                "--drop-unknown-fields": "bool",
                "--enable-exactly-once-delivery": "bool",
                "--enable-message-ordering": "bool",
                "--expiration-period": "value",
                "--labels": "value",
                "--max-delivery-attempts": "value",
                "--max-retry-delay": "value",
                "--message-filter": "value",
                "--message-retention-duration": "value",
                "--min-retry-delay": "value",
                "--push-auth-service-account": "value",
                "--push-auth-token-audience": "value",
                "--push-endpoint": "value",
                "--push-no-wrapper": "bool",
                "--push-no-wrapper-write-metadata": "bool",
                "--retain-acked-messages": "bool",
                "--topic": "value",
                "--topic-project": "value",
                "--use-table-schema": "bool",
                "--use-topic-schema": "bool",
                "--write-metadata": "bool"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "modify-message-ack-deadline": {
              "commands": {},
              "flags": {
                "--ack-deadline": "value",
                "--ack-ids": "value"
              }
            },
            "modify-push-config": {
              "commands": {},
              "flags": {
                "--push-auth-service-account": "value",
                "--push-auth-token-audience": "value",
                "--push-endpoint": "value",
                "--push-no-wrapper": "bool",
                "--push-no-wrapper-write-metadata": "bool"
              }
            },
            "pull": {
              "commands": {},
              "flags": {
                "--auto-ack": "bool",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "seek": {
              "commands": {},
              "flags": {
                "--snapshot": "value",
                "--snapshot-project": "value",
                "--time": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--ack-deadline": "value",
                "--bigquery-service-account-email": "value",
                "--bigquery-table": "value",
                "--clear-bigquery-config": "bool",
                "--clear-cloud-storage-config": "bool",
                "--clear-dead-letter-policy": "bool",
                "--clear-labels": "bool",
                "--clear-push-no-wrapper-config": "bool",
                "--clear-retry-policy": "bool",
                "--cloud-storage-bucket": "value",
                "--cloud-storage-file-datetime-format": "value",
                "--cloud-storage-file-prefix": "value",
                "--cloud-storage-file-suffix": "value",
                "--cloud-storage-max-bytes": "value",
                "--cloud-storage-max-duration": "value",
                "--cloud-storage-max-messages": "value",
                "--cloud-storage-output-format": "value",
                "--cloud-storage-service-account-email": "value",
                "--cloud-storage-use-topic-schema": "bool",
                "--cloud-storage-write-metadata": "bool",
                "--dead-letter-topic": "value",
                "--dead-letter-topic-project": "value",
                "--drop-unknown-fields": "bool",
                "--enable-exactly-once-delivery": "bool",
                "--expiration-period": "value",
                "--max-delivery-attempts": "value",
                "--max-retry-delay": "value",
                "--message-retention-duration": "value",
                "--min-retry-delay": "value",
                "--push-auth-service-account": "value",
                "--push-auth-token-audience": "value",
                "--push-endpoint": "value",
                "--push-no-wrapper": "bool",
                "--push-no-wrapper-write-metadata": "bool",
                "--remove-labels": "value",
                "--retain-acked-messages": "bool",
                "--update-labels": "value",
                "--use-table-schema": "bool",
                "--use-topic-schema": "bool",
                "--write-metadata": "bool"
              }
            }
          },
          "flags": {}
        },
        "topics": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--cloud-storage-ingestion-bucket": "value",
                "--cloud-storage-ingestion-input-format": "value",
                "--cloud-storage-ingestion-match-glob": "value",
                "--cloud-storage-ingestion-minimum-object-create-time": "value",
                "--cloud-storage-ingestion-text-delimiter": "value",
                "--first-revision-id": "value",
                "--ingestion-log-severity": "value",
                "--kinesis-ingestion-consumer-arn": "value",
                "--kinesis-ingestion-role-arn": "value",
                "--kinesis-ingestion-service-account": "value",
                "--kinesis-ingestion-stream-arn": "value",
                "--labels": "value",
                "--last-revision-id": "value",
                "--message-encoding": "value",
                "--message-retention-duration": "value",
                "--message-storage-policy-allowed-regions": "value",
                "--message-storage-policy-enforce-in-transit": "bool",
                "--schema": "value",
                "--schema-project": "value",
                "--topic-encryption-key": "dynamic",
                "--topic-encryption-key-keyring": "dynamic",
                "--topic-encryption-key-location": "dynamic",
                "--topic-encryption-key-project": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "detach-subscription": {
              "commands": {},
              "flags": {}
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "list-subscriptions": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "publish": {
              "commands": {},
              "flags": {
                "--attribute": "value",
                "--message": "value",
                "--ordering-key": "value"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-ingestion-data-source-settings": "bool",
                "--clear-labels": "bool",
                "--clear-message-retention-duration": "bool",
                "--clear-schema-settings": "bool",
                "--cloud-storage-ingestion-bucket": "value",
                "--cloud-storage-ingestion-input-format": "value",
                "--cloud-storage-ingestion-match-glob": "value",
                "--cloud-storage-ingestion-minimum-object-create-time": "value",
                "--cloud-storage-ingestion-text-delimiter": "value",
                "--first-revision-id": "value",
                "--ingestion-log-severity": "value",
                "--kinesis-ingestion-consumer-arn": "value",
                "--kinesis-ingestion-role-arn": "value",
                "--kinesis-ingestion-service-account": "value",
                "--kinesis-ingestion-stream-arn": "value",
                "--last-revision-id": "value",
                "--message-encoding": "value",
                "--message-retention-duration": "value",
                "--message-storage-policy-allowed-regions": "value",
                "--message-storage-policy-enforce-in-transit": "bool",
                "--recompute-message-storage-policy": "bool",
                "--remove-labels": "value",
                "--schema": "value",
                "--schema-project": "value",
                "--topic-encryption-key": "dynamic",
                "--topic-encryption-key-keyring": "dynamic",
                "--topic-encryption-key-location": "dynamic",
                "--topic-encryption-key-project": "dynamic",
                "--update-labels": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "recaptcha": {
      "commands": {
        "firewall-policies": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--actions": "value",
                "--condition": "value",
                "--description": "value",
                "--path": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "reorder": {
              "commands": {},
              "flags": {
                "--names": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--actions": "value",
                "--condition": "value",
                "--description": "value",
                "--path": "value"
              }
            }
          },
          "flags": {}
        },
        "keys": {
          "commands": {
            "add-ip-override": {
              "commands": {},
              "flags": {
                "--ip": "value",
                "--override": [
                  "allow",
                  "override-type-unspecified"
                ]
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--allow-all-bundle-ids": "bool",
                "--allow-all-domains": "bool",
                "--allow-all-package-names": "bool",
                "--allow-amp-traffic": "bool",
                "--android": "bool",
                "--bundle-ids": "value",
                "--display-name": "value",
                "--domains": "value",
                "--express": "bool",
                "--integration-type": [
                  "checkbox",
                  "invisible",
                  "score",
                  "score-and-challenge"
                ],
                "--ios": "bool",
                "--key-id": "value",
                "--labels": "value",
                "--package-names": "value",
                "--private-key-file": "value",
                "--security-preference": [
                  "balance",
                  "challenge-security-preference-unspecified",
                  "security",
                  "usability"
                ],
                "--support-non-google-app-store-distribution": "bool",
                "--team-id": "value",
                "--testing-challenge": [
                  "challenge",
                  "nocaptcha"
                ],
                "--testing-score": "value",
                "--waf-feature": [
                  "action-token",
                  "challenge-page",
                  "express",
                  "session-token"
                ],
                "--waf-service": [
                  "akamai",
                  "ca",
                  "cloudflare",
                  "fastly"
                ],
                "--web": "bool"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "list-ip-overrides": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "migrate": {
              "commands": {},
              "flags": {
                "--skip-billing-check": "bool"
              }
            },
            "remove-ip-override": {
              "commands": {},
              "flags": {
                "--ip": "value",
                "--override": [
                  "allow",
                  "override-type-unspecified"
                ]
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--allow-all-bundle-ids": "bool",
                "--allow-all-domains": "bool",
                "--allow-all-package-names": "bool",
                "--allow-amp-traffic": "bool",
                "--android": "bool",
                "--bundle-ids": "value",
                "--display-name": "value",
                "--domains": "value",
                "--express": "bool",
                "--ios": "bool",
                "--key-id": "value",
                "--labels": "value",
                "--package-names": "value",
                "--private-key-file": "value",
                "--security-preference": [
                  "balance",
                  "challenge-security-preference-unspecified",
                  "security",
                  "usability"
                ],
                "--team-id": "value",
                "--web": "bool"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "recommender": {
      "commands": {
        "insight-type-config": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--annotations": "value",
                "--billing-account": "value",
                "--config-file": "value",
                "--display-name": "value",
                "--etag": "value",
                "--location": "value",
                "--organization": "value",
                "--validate-only": "bool"
              }
            }
          },
          "flags": {}
        },
        "insights": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--folder": "value",
                "--insight-type": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--filter": "value",
                "--folder": "value",
                "--insight-type": "value",
                "--limit": "value",
                "--location": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "mark-accepted": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--etag": "value",
                "--folder": "value",
                "--insight-type": "value",
                "--location": "value",
                "--organization": "value",
                "--state-metadata": "value"
              }
            }
          },
          "flags": {}
        },
        "recommendations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "value",
                "--recommender": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--location": "value",
                "--organization": "value",
                "--page-size": "value",
                "--recommender": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "mark-claimed": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--etag": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "value",
                "--recommender": "value",
                "--state-metadata": "value"
              }
            },
            "mark-dismissed": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--etag": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "value",
                "--recommender": "value"
              }
            },
            "mark-failed": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--etag": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "value",
                "--recommender": "value",
                "--state-metadata": "value"
              }
            },
            "mark-succeeded": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--etag": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "value",
                "--recommender": "value",
                "--state-metadata": "value"
              }
            }
          },
          "flags": {}
        },
        "recommender-config": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--billing-account": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--annotations": "value",
                "--billing-account": "value",
                "--config-file": "value",
                "--display-name": "value",
                "--etag": "value",
                "--location": "value",
                "--organization": "value",
                "--validate-only": "bool"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "redis": {
      "commands": {
        "clusters": {
          "commands": {
            "add-cluster-endpoints": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--cluster-endpoint": "value",
                "--region": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--aof-append-fsync": [
                  "always",
                  "everysec",
                  "no"
                ],
                "--async": "bool",
                "--auth-mode": [
                  "disabled",
                  "iam-auth"
                ],
                "--cross-cluster-replication-role": [
                  "secondary"
                ],
                "--deletion-protection": "bool",
                "--maintenance-window-day": [
                  "friday",
                  "monday",
                  "saturday",
                  "sunday",
                  "thursday",
                  "tuesday",
                  "wednesday"
                ],
                "--maintenance-window-hour": "value",
                "--network": "value",
                "--node-type": [
                  "redis-highmem-medium",
                  "redis-highmem-xlarge",
                  "redis-shared-core-nano",
                  "redis-standard-small"
                ],
                "--persistence-mode": [
                  "aof",
                  "disabled",
                  "rdb"
                ],
                "--primary-cluster": "value",
                "--rdb-snapshot-period": [
                  "12h",
                  "1h",
                  "24h",
                  "6h"
                ],
                "--rdb-snapshot-start-time": "value",
                "--redis-config": "value",
                "--region": "dynamic",
                "--replica-count": "value",
                "--shard-count": "value",
                "--transit-encryption-mode": [
                  "disabled",
                  "server-authentication"
                ],
                "--zone": "value",
                "--zone-distribution-mode": [
                  "multi-zone",
                  "single-zone"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "detach": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "dynamic"
              }
            },
            "detach-secondaries": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clusters-to-detach": "value",
                "--region": "dynamic"
              }
            },
            "get-cluster-certificate-authority": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-cluster-endpoints": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--cluster-endpoint": "value",
                "--region": "dynamic"
              }
            },
            "reschedule-maintenance": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "dynamic",
                "--reschedule-type": [
                  "immediate",
                  "specific-time"
                ],
                "--schedule-time": "value"
              }
            },
            "switchover": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--aof-append-fsync": [
                  "always",
                  "everysec",
                  "no"
                ],
                "--async": "bool",
                "--deletion-protection": "bool",
                "--maintenance-window-any": "bool",
                "--maintenance-window-day": [
                  "friday",
                  "monday",
                  "saturday",
                  "sunday",
                  "thursday",
                  "tuesday",
                  "wednesday"
                ],
                "--maintenance-window-hour": "value",
                "--persistence-mode": [
                  "aof",
                  "disabled",
                  "rdb"
                ],
                "--rdb-snapshot-period": [
                  "12h",
                  "1h",
                  "24h",
                  "6h"
                ],
                "--rdb-snapshot-start-time": "value",
                "--region": "dynamic",
                "--remove-redis-config": "value",
                "--replica-count": "value",
                "--shard-count": "value",
                "--update-redis-config": "value"
              }
            }
          },
          "flags": {}
        },
        "instances": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--alternative-zone": "value",
                "--async": "bool",
                "--connect-mode": [
                  "connect-mode-unspecified",
                  "direct-peering",
                  "private-service-access"
                ],
                "--customer-managed-key": "value",
                "--display-name": "value",
                "--enable-auth": "bool",
                "--labels": "value",
                "--maintenance-window-day": [
                  "day-of-week-unspecified",
                  "friday",
                  "monday",
                  "saturday",
                  "sunday",
                  "thursday",
                  "tuesday",
                  "wednesday"
                ],
                "--maintenance-window-hour": "value",
                "--network": "value",
                "--persistence-mode": [
                  "disabled",
                  "rdb"
                ],
                "--rdb-snapshot-period": [
                  "12h",
                  "1h",
                  "24h",
                  "6h"
                ],
                "--rdb-snapshot-start-time": "value",
                "--read-replicas-mode": [
                  "read-replicas-disabled",
                  "read-replicas-enabled"
                ],
                "--redis-config": "value",
                "--redis-version": [
                  "redis_3_2",
                  "redis_4_0",
                  "redis_5_0",
                  "redis_6_x",
                  "redis_7_0",
                  "redis_7_2"
                ],
                "--region": "dynamic",
                "--replica-count": "value",
                "--reserved-ip-range": "value",
                "--size": "value",
                "--tier": [
                  "basic",
                  "standard"
                ],
                "--transit-encryption-mode": [
                  "disabled",
                  "server-authentication"
                ],
                "--zone": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "export": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "dynamic"
              }
            },
            "failover": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--data-protection-mode": [
                  "force-data-loss",
                  "limited-data-loss"
                ],
                "--region": "dynamic"
              }
            },
            "get-auth-string": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "reschedule-maintenance": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "dynamic",
                "--reschedule-type": [
                  "immediate",
                  "next-available-window",
                  "specific-time"
                ],
                "--schedule-time": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-labels": "bool",
                "--display-name": "value",
                "--enable-auth": "bool",
                "--maintenance-version": "value",
                "--maintenance-window-any": "bool",
                "--maintenance-window-day": [
                  "day-of-week-unspecified",
                  "friday",
                  "monday",
                  "saturday",
                  "sunday",
                  "thursday",
                  "tuesday",
                  "wednesday"
                ],
                "--maintenance-window-hour": "value",
                "--persistence-mode": [
                  "disabled",
                  "rdb"
                ],
                "--rdb-snapshot-period": [
                  "12h",
                  "1h",
                  "24h",
                  "6h"
                ],
                "--rdb-snapshot-start-time": "value",
                "--read-replicas-mode": [
                  "read-replicas-disabled",
                  "read-replicas-enabled"
                ],
                "--region": "dynamic",
                "--remove-labels": "value",
                "--remove-redis-config": "value",
                "--replica-count": "value",
                "--secondary-ip-range": "value",
                "--size": "value",
                "--update-labels": "value",
                "--update-redis-config": "value"
              }
            },
            "upgrade": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--redis-version": [
                  "redis_4_0",
                  "redis_5_0",
                  "redis_6_x",
                  "redis_7_0",
                  "redis_7_2"
                ],
                "--region": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "dynamic",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "regions": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "zones": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "resource-manager": {
      "commands": {
        "folders": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--display-name": "value",
                "--folder": "value",
                "--organization": "value",
                "--tags": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "get-ancestors-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--include-deny": "bool",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "move": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--folder": "value",
                "--organization": "value"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {}
            },
            "undelete": {
              "commands": {},
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--display-name": "value"
              }
            }
          },
          "flags": {}
        },
        "org-policies": {
          "commands": {
            "allow": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "dynamic"
              }
            },
            "deny": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--effective": "bool",
                "--folder": "value",
                "--organization": "dynamic"
              }
            },
            "disable-enforce": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "dynamic"
              }
            },
            "enable-enforce": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--organization": "dynamic",
                "--page-size": "value",
                "--show-unset": "bool",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "set-policy": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--organization": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "tags": {
          "commands": {
            "bindings": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--parent": "value",
                    "--tag-value": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "value",
                    "--parent": "value",
                    "--tag-value": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--effective": "bool",
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--parent": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "holds": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--help-link": "value",
                    "--holder": "value",
                    "--location": "value",
                    "--origin": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--holder": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--origin": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "keys": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--parent": "value",
                    "--purpose": [
                      "DATA_GOVERNANCE",
                      "GCE_FIREWALL"
                    ],
                    "--purpose-data": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--parent": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value"
                  }
                }
              },
              "flags": {}
            },
            "values": {
              "commands": {
                "add-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--parent": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "get-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--parent": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "remove-iam-policy-binding": {
                  "commands": {},
                  "flags": {
                    "--all": "bool",
                    "--condition": "value",
                    "--condition-from-file": "value",
                    "--member": "value",
                    "--role": "value"
                  }
                },
                "set-iam-policy": {
                  "commands": {},
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "run": {
      "commands": {
        "deploy": {
          "commands": {},
          "flags": {
            "--add-cloudsql-instances": "value",
            "--add-custom-audiences": "value",
            "--add-volume": "value",
            "--add-volume-mount": "value",
            "--allow-unauthenticated": "bool",
            "--allow-unencrypted-build": "bool",
            "--args": "value",
            "--async": "bool",
            "--binary-authorization": "value",
            "--breakglass": "value",
            "--clear-binary-authorization": "bool",
            "--clear-cloudsql-instances": "bool",
            "--clear-config-maps": "bool",
            "--clear-custom-audiences": "bool",
            "--clear-encryption-key-shutdown-hours": "bool",
            "--clear-env-vars": "bool",
            "--clear-key": "bool",
            "--clear-labels": "bool",
            "--clear-network": "bool",
            "--clear-network-tags": "bool",
            "--clear-post-key-revocation-action-type": "bool",
            "--clear-secrets": "bool",
            "--clear-volume-mounts": "bool",
            "--clear-volumes": "bool",
            "--clear-vpc-connector": "bool",
            "--command": "value",
            "--concurrency": "value",
            "--container": "value",
            "--cpu": "value",
            "--cpu-boost": "bool",
            "--cpu-throttling": "bool",
            "--depends-on": "value",
            "--description": "value",
            "--encryption-key-shutdown-hours": "value",
            "--env-vars-file": "value",
            "--execution-environment": [
              "gen1",
              "gen2"
            ],
            "--image": "value",
            "--ingress": [
              "all",
              "internal",
              "internal-and-cloud-load-balancing"
            ],
            "--invoker-iam-check": "bool",
            "--key": "value",
            "--labels": "value",
            "--max-instances": "value",
            "--memory": "value",
            "--min": "value",
            "--min-instances": "value",
            "--namespace": "value",
            "--network": "value",
            "--network-tags": "value",
            "--no-traffic": "bool",
            "--port": "value",
            "--post-key-revocation-action-type": [
              "prevent-new",
              "shut-down"
            ],
            "--region": "value",
            "--remove-cloudsql-instances": "value",
            "--remove-config-maps": "value",
            "--remove-containers": "value",
            "--remove-custom-audiences": "value",
            "--remove-env-vars": "value",
            "--remove-labels": "value",
            "--remove-secrets": "value",
            "--remove-volume": "value",
            "--remove-volume-mount": "value",
            "--revision-suffix": "value",
            "--service-account": "value",
            "--session-affinity": "bool",
            "--set-cloudsql-instances": "value",
            "--set-config-maps": "value",
            "--set-custom-audiences": "value",
            "--set-env-vars": "value",
            "--set-secrets": "value",
            "--source": "value",
            "--subnet": "value",
            "--tag": "value",
            "--timeout": "value",
            "--update-config-maps": "value",
            "--update-env-vars": "value",
            "--update-labels": "value",
            "--update-secrets": "value",
            "--use-http2": "bool",
            "--vpc-connector": "value",
            "--vpc-egress": [
              "all",
              "all-traffic",
              "private-ranges-only"
            ]
          }
        },
        "domain-mappings": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--domain": "value",
                "--force-override": "bool",
                "--namespace": "value",
                "--service": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--domain": "value",
                "--namespace": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--domain": "value",
                "--namespace": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--namespace": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "jobs": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--region": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--add-volume": "value",
                "--add-volume-mount": "value",
                "--args": "value",
                "--async": "bool",
                "--binary-authorization": "value",
                "--breakglass": "value",
                "--clear-volume-mounts": "bool",
                "--clear-volumes": "bool",
                "--command": "value",
                "--cpu": "value",
                "--env-vars-file": "value",
                "--execute-now": "bool",
                "--image": "value",
                "--key": "value",
                "--labels": "value",
                "--max-retries": "value",
                "--memory": "value",
                "--network": "value",
                "--network-tags": "value",
                "--parallelism": "value",
                "--region": "value",
                "--remove-volume": "value",
                "--remove-volume-mount": "value",
                "--service-account": "value",
                "--set-cloudsql-instances": "value",
                "--set-env-vars": "value",
                "--set-secrets": "value",
                "--subnet": "value",
                "--task-timeout": "value",
                "--tasks": "value",
                "--vpc-connector": "value",
                "--vpc-egress": [
                  "all",
                  "all-traffic",
                  "private-ranges-only"
                ],
                "--wait": "bool"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "value"
              }
            },
            "deploy": {
              "commands": {},
              "flags": {
                "--add-volume": "value",
                "--add-volume-mount": "value",
                "--args": "value",
                "--async": "bool",
                "--binary-authorization": "value",
                "--breakglass": "value",
                "--clear-env-vars": "bool",
                "--clear-network": "bool",
                "--clear-network-tags": "bool",
                "--clear-volume-mounts": "bool",
                "--clear-volumes": "bool",
                "--command": "value",
                "--cpu": "value",
                "--env-vars-file": "value",
                "--execute-now": "bool",
                "--image": "value",
                "--key": "value",
                "--labels": "value",
                "--max-retries": "value",
                "--memory": "value",
                "--network": "value",
                "--network-tags": "value",
                "--parallelism": "value",
                "--region": "value",
                "--remove-env-vars": "value",
                "--remove-volume": "value",
                "--remove-volume-mount": "value",
                "--service-account": "value",
                "--set-cloudsql-instances": "value",
                "--set-env-vars": "value",
                "--set-secrets": "value",
                "--source": "value",
                "--subnet": "value",
                "--task-timeout": "value",
                "--tasks": "value",
                "--update-env-vars": "value",
                "--vpc-connector": "value",
                "--vpc-egress": [
                  "all",
                  "all-traffic",
                  "private-ranges-only"
                ],
                "--wait": "bool"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "execute": {
              "commands": {},
              "flags": {
                "--args": "value",
                "--async": "bool",
                "--region": "value",
                "--task-timeout": "value",
                "--tasks": "value",
                "--update-env-vars": "value",
                "--wait": "bool"
              }
            },
            "executions": {
              "commands": {
                "cancel": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--region": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--region": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--job": "value",
                    "--limit": "value",
                    "--namespace": "value",
                    "--page-size": "value",
                    "--region": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "tasks": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--region": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--abandoned": "bool",
                        "--cancelled": "bool",
                        "--completed": "bool",
                        "--execution": "value",
                        "--failed": "bool",
                        "--filter": "value",
                        "--limit": "value",
                        "--no-completed": "bool",
                        "--no-started": "bool",
                        "--page-size": "value",
                        "--pending": "bool",
                        "--region": "value",
                        "--running": "bool",
                        "--sort-by": "value",
                        "--started": "bool",
                        "--succeeded": "bool",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {
                    "--region": "value"
                  }
                }
              },
              "flags": {
                "--region": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--namespace": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "logs": {
              "commands": {
                "read": {
                  "commands": {},
                  "flags": {
                    "--freshness": "value",
                    "--limit": "value",
                    "--log-filter": "value",
                    "--order": [
                      "asc",
                      "desc"
                    ],
                    "--region": "value"
                  }
                }
              },
              "flags": {
                "--region": "value"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--region": "value",
                "--role": "dynamic"
              }
            },
            "replace": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-cloudsql-instances": "value",
                "--add-volume": "value",
                "--add-volume-mount": "value",
                "--args": "value",
                "--async": "bool",
                "--binary-authorization": "value",
                "--breakglass": "value",
                "--clear-binary-authorization": "bool",
                "--clear-cloudsql-instances": "bool",
                "--clear-env-vars": "bool",
                "--clear-labels": "bool",
                "--clear-network": "bool",
                "--clear-network-tags": "bool",
                "--clear-secrets": "bool",
                "--clear-volume-mounts": "bool",
                "--clear-volumes": "bool",
                "--clear-vpc-connector": "bool",
                "--command": "value",
                "--cpu": "value",
                "--env-vars-file": "value",
                "--execute-now": "bool",
                "--image": "value",
                "--key": "value",
                "--labels": "value",
                "--max-retries": "value",
                "--memory": "value",
                "--network": "value",
                "--network-tags": "value",
                "--parallelism": "value",
                "--region": "value",
                "--remove-cloudsql-instances": "value",
                "--remove-env-vars": "value",
                "--remove-labels": "value",
                "--remove-secrets": "value",
                "--remove-volume": "value",
                "--remove-volume-mount": "value",
                "--service-account": "value",
                "--set-cloudsql-instances": "value",
                "--set-env-vars": "value",
                "--set-secrets": "value",
                "--subnet": "value",
                "--task-timeout": "value",
                "--tasks": "value",
                "--update-env-vars": "value",
                "--update-labels": "value",
                "--update-secrets": "value",
                "--vpc-connector": "value",
                "--vpc-egress": [
                  "all",
                  "all-traffic",
                  "private-ranges-only"
                ],
                "--wait": "bool"
              }
            }
          },
          "flags": {
            "--region": "value"
          }
        },
        "regions": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "revisions": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--namespace": "value",
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--namespace": "value",
                "--region": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--service": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {
            "--region": "value"
          }
        },
        "services": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--region": "value",
                "--role": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--namespace": "value",
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--namespace": "value",
                "--region": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "logs": {
              "commands": {
                "read": {
                  "commands": {},
                  "flags": {
                    "--freshness": "value",
                    "--limit": "value",
                    "--log-filter": "value",
                    "--order": [
                      "asc",
                      "desc"
                    ],
                    "--region": "value"
                  }
                }
              },
              "flags": {
                "--region": "value"
              }
            },
            "proxy": {
              "commands": {},
              "flags": {
                "--namespace": "value",
                "--port": "value",
                "--region": "value",
                "--tag": "value",
                "--token": "value"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--member": "value",
                "--region": "value",
                "--role": "dynamic"
              }
            },
            "replace": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--dry-run": "bool",
                "--region": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-cloudsql-instances": "value",
                "--add-custom-audiences": "value",
                "--add-volume": "value",
                "--add-volume-mount": "value",
                "--args": "value",
                "--async": "bool",
                "--binary-authorization": "value",
                "--breakglass": "value",
                "--clear-binary-authorization": "bool",
                "--clear-cloudsql-instances": "bool",
                "--clear-config-maps": "bool",
                "--clear-custom-audiences": "bool",
                "--clear-encryption-key-shutdown-hours": "bool",
                "--clear-env-vars": "bool",
                "--clear-key": "bool",
                "--clear-labels": "bool",
                "--clear-network": "bool",
                "--clear-network-tags": "bool",
                "--clear-post-key-revocation-action-type": "bool",
                "--clear-secrets": "bool",
                "--clear-volume-mounts": "bool",
                "--clear-volumes": "bool",
                "--clear-vpc-connector": "bool",
                "--command": "value",
                "--concurrency": "value",
                "--container": "value",
                "--cpu": "value",
                "--cpu-boost": "bool",
                "--cpu-throttling": "bool",
                "--depends-on": "value",
                "--encryption-key-shutdown-hours": "value",
                "--env-vars-file": "value",
                "--execution-environment": [
                  "gen1",
                  "gen2"
                ],
                "--image": "value",
                "--ingress": [
                  "all",
                  "internal",
                  "internal-and-cloud-load-balancing"
                ],
                "--invoker-iam-check": "bool",
                "--key": "value",
                "--labels": "value",
                "--max-instances": "value",
                "--memory": "value",
                "--min": "value",
                "--min-instances": "value",
                "--namespace": "value",
                "--network": "value",
                "--network-tags": "value",
                "--no-traffic": "bool",
                "--port": "value",
                "--post-key-revocation-action-type": [
                  "prevent-new",
                  "shut-down"
                ],
                "--region": "value",
                "--remove-cloudsql-instances": "value",
                "--remove-config-maps": "value",
                "--remove-containers": "value",
                "--remove-custom-audiences": "value",
                "--remove-env-vars": "value",
                "--remove-labels": "value",
                "--remove-secrets": "value",
                "--remove-volume": "value",
                "--remove-volume-mount": "value",
                "--revision-suffix": "value",
                "--service-account": "value",
                "--session-affinity": "bool",
                "--set-cloudsql-instances": "value",
                "--set-config-maps": "value",
                "--set-custom-audiences": "value",
                "--set-env-vars": "value",
                "--set-secrets": "value",
                "--subnet": "value",
                "--tag": "value",
                "--timeout": "value",
                "--update-config-maps": "value",
                "--update-env-vars": "value",
                "--update-labels": "value",
                "--update-secrets": "value",
                "--use-http2": "bool",
                "--vpc-connector": "value",
                "--vpc-egress": [
                  "all",
                  "all-traffic",
                  "private-ranges-only"
                ]
              }
            },
            "update-traffic": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-tags": "bool",
                "--namespace": "value",
                "--region": "value",
                "--remove-tags": "value",
                "--set-tags": "value",
                "--to-latest": "bool",
                "--to-revisions": "value",
                "--to-tags": "value",
                "--update-tags": "value"
              }
            }
          },
          "flags": {
            "--region": "value"
          }
        }
      },
      "flags": {}
    },
    "scc": {
      "commands": {
        "assets": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--asset": "value",
                "--resource-name": "value"
              }
            },
            "get-parent": {
              "commands": {},
              "flags": {
                "--asset": "value",
                "--resource-name": "value"
              }
            },
            "get-project": {
              "commands": {},
              "flags": {
                "--asset": "value",
                "--resource-name": "value"
              }
            },
            "group": {
              "commands": {},
              "flags": {
                "--compare-duration": "value",
                "--filter": "value",
                "--group-by": "value",
                "--page-size": "value",
                "--page-token": "value",
                "--read-time": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--compare-duration": "value",
                "--field-mask": "value",
                "--filter": "value",
                "--limit": "value",
                "--order-by": "value",
                "--page-size": "value",
                "--page-token": "value",
                "--read-time": "value",
                "--sort-by": "value"
              }
            },
            "list-marks": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--organization": "value",
                "--page-size": "value",
                "--page-token": "value",
                "--read-time": "value",
                "--sort-by": "value"
              }
            },
            "run-discovery": {
              "commands": {},
              "flags": {}
            },
            "update-marks": {
              "commands": {},
              "flags": {
                "--organization": "value",
                "--security-marks": "value",
                "--start-time": "value",
                "--update-mask": "value"
              }
            }
          },
          "flags": {}
        },
        "bqexports": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--description": "value",
                "--filter": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "get": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--location": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--dataset": "value",
                "--description": "value",
                "--filter": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "value",
                "--update-mask": "value"
              }
            }
          },
          "flags": {}
        },
        "custom-modules": {
          "commands": {
            "sha": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--custom-config-from-file": "value",
                    "--display-name": "value",
                    "--enablement-state": [
                      "disabled",
                      "enabled",
                      "enablement-state-unspecified",
                      "inherited"
                    ],
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "get": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "get-effective": {
                  "commands": {},
                  "flags": {
                    "--folder": "value",
                    "--organization": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list-descendant": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "list-effective": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--organization": "value",
                    "--page-size": "value",
                    "--sort-by": "value"
                  }
                },
                "simulate": {
                  "commands": {},
                  "flags": {
                    "--custom-config-from-file": "value",
                    "--folder": "value",
                    "--organization": "value",
                    "--resource-from-file": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--custom-config-from-file": "value",
                    "--enablement-state": [
                      "disabled",
                      "enabled",
                      "enablement-state-unspecified",
                      "inherited"
                    ],
                    "--folder": "value",
                    "--organization": "value",
                    "--update-mask": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "findings": {
          "commands": {
            "bulk-mute": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--folder": "value",
                "--location": "value",
                "--mute-state": [
                  "muted",
                  "undefined"
                ],
                "--organization": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--category": "value",
                "--event-time": "value",
                "--external-uri": "value",
                "--location": "value",
                "--organization": "value",
                "--resource-name": "value",
                "--source": "value",
                "--source-properties": "value",
                "--state": [
                  "active",
                  "inactive",
                  "state-unspecified"
                ]
              }
            },
            "group": {
              "commands": {},
              "flags": {
                "--compare-duration": "value",
                "--filter": "value",
                "--group-by": "value",
                "--location": "value",
                "--page-size": "value",
                "--page-token": "value",
                "--read-time": "value",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--compare-duration": "value",
                "--field-mask": "value",
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--order-by": "value",
                "--page-size": "value",
                "--page-token": "value",
                "--read-time": "value",
                "--sort-by": "value",
                "--source": "value"
              }
            },
            "list-marks": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--organization": "value",
                "--page-size": "value",
                "--page-token": "value",
                "--read-time": "value",
                "--sort-by": "value",
                "--source": "value"
              }
            },
            "set-mute": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--location": "value",
                "--mute": [
                  "muted",
                  "undefined",
                  "unmuted"
                ],
                "--organization": "value",
                "--source": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--event-time": "value",
                "--external-uri": "value",
                "--location": "value",
                "--organization": "value",
                "--source": "value",
                "--source-properties": "value",
                "--state": [
                  "active",
                  "inactive",
                  "state-unspecified"
                ],
                "--update-mask": "value"
              }
            },
            "update-marks": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--organization": "value",
                "--security-marks": "value",
                "--source": "value",
                "--start-time": "value",
                "--update-mask": "value"
              }
            }
          },
          "flags": {}
        },
        "iac-validation-reports": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--tf-plan-file": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            }
          },
          "flags": {}
        },
        "manage": {
          "commands": {
            "custom-modules": {
              "commands": {
                "etd": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--custom-config-file": "value",
                        "--display-name": "value",
                        "--enablement-state": "value",
                        "--folder": "value",
                        "--module-type": "value",
                        "--organization": "dynamic",
                        "--parent": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--folder": "value",
                        "--organization": "dynamic",
                        "--parent": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--folder": "value",
                        "--organization": "dynamic",
                        "--parent": "value"
                      }
                    },
                    "describe-effective": {
                      "commands": {},
                      "flags": {
                        "--folder": "value",
                        "--organization": "dynamic",
                        "--parent": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--folder": "value",
                        "--limit": "value",
                        "--organization": "dynamic",
                        "--page-size": "value",
                        "--parent": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list-descendant": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--folder": "value",
                        "--limit": "value",
                        "--organization": "dynamic",
                        "--page-size": "value",
                        "--parent": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list-effective": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--folder": "value",
                        "--limit": "value",
                        "--organization": "dynamic",
                        "--page-size": "value",
                        "--parent": "value",
                        "--sort-by": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--custom-config-file": "value",
                        "--enablement-state": "value",
                        "--folder": "value",
                        "--organization": "dynamic",
                        "--parent": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "validate": {
                      "commands": {},
                      "flags": {
                        "--custom-config-file": "value",
                        "--folder": "value",
                        "--module-type": "value",
                        "--organization": "dynamic",
                        "--parent": "value"
                      }
                    }
                  },
                  "flags": {}
                },
                "sha": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--custom-config-from-file": "value",
                        "--display-name": "value",
                        "--enablement-state": "value",
                        "--folder": "value",
                        "--organization": "dynamic",
                        "--parent": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "delete": {
                      "commands": {},
                      "flags": {
                        "--folder": "value",
                        "--organization": "dynamic",
                        "--parent": "value",
                        "--validate-only": "bool"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--folder": "value",
                        "--organization": "dynamic",
                        "--parent": "value"
                      }
                    },
                    "describe-effective": {
                      "commands": {},
                      "flags": {
                        "--folder": "value",
                        "--organization": "dynamic",
                        "--parent": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--folder": "value",
                        "--limit": "value",
                        "--organization": "dynamic",
                        "--page-size": "value",
                        "--parent": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list-descendant": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--folder": "value",
                        "--limit": "value",
                        "--organization": "dynamic",
                        "--page-size": "value",
                        "--parent": "value",
                        "--sort-by": "value"
                      }
                    },
                    "list-effective": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--folder": "value",
                        "--limit": "value",
                        "--organization": "dynamic",
                        "--page-size": "value",
                        "--parent": "value",
                        "--sort-by": "value"
                      }
                    },
                    "simulate": {
                      "commands": {},
                      "flags": {
                        "--custom-config-from-file": "value",
                        "--folder": "value",
                        "--organization": "dynamic",
                        "--parent": "value",
                        "--resource-from-file": "value"
                      }
                    },
                    "update": {
                      "commands": {},
                      "flags": {
                        "--custom-config-file": "value",
                        "--enablement-state": "value",
                        "--folder": "value",
                        "--organization": "dynamic",
                        "--parent": "value",
                        "--validate-only": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "services": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--filter-modules": "value",
                    "--folder": "value",
                    "--organization": "dynamic",
                    "--parent": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--folder": "value",
                    "--limit": "value",
                    "--organization": "dynamic",
                    "--page-size": "value",
                    "--parent": "value",
                    "--sort-by": "value"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--enablement-state": "value",
                    "--folder": "value",
                    "--module-config-file": "value",
                    "--organization": "dynamic",
                    "--parent": "value",
                    "--validate-only": "bool"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "muteconfigs": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--expiry-time": "value",
                "--filter": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "value",
                "--type": [
                  "dynamic",
                  "static"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "get": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--folder": "value",
                "--limit": "value",
                "--location": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--expiry-time": "value",
                "--filter": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "value",
                "--update-mask": "value"
              }
            }
          },
          "flags": {}
        },
        "notifications": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--filter": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "value",
                "--pubsub-topic": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--folder": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--description": "value",
                "--filter": "value",
                "--folder": "value",
                "--location": "value",
                "--organization": "value",
                "--pubsub-topic": "value"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--organization": "value"
              }
            }
          },
          "flags": {}
        },
        "posture-deployments": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--location": "value",
                "--organization": "value",
                "--posture-name": "value",
                "--posture-revision-id": "value",
                "--target-resource": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--etag": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--organization": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--etag": "value",
                "--location": "value",
                "--organization": "value",
                "--posture-id": "value",
                "--posture-revision-id": "value",
                "--update-mask": "value"
              }
            }
          },
          "flags": {}
        },
        "posture-operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            }
          },
          "flags": {}
        },
        "posture-templates": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--organization": "value",
                "--revision-id": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            }
          },
          "flags": {}
        },
        "postures": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--organization": "value",
                "--posture-from-file": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--etag": "value",
                "--location": "value",
                "--organization": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--organization": "value",
                "--revision-id": "value"
              }
            },
            "extract": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--organization": "value",
                "--workload": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list-revisions": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--organization": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--organization": "value",
                "--posture-from-file": "value",
                "--revision-id": "value",
                "--update-mask": "value"
              }
            }
          },
          "flags": {}
        },
        "sources": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--source": "value",
                "--source-display-name": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "scheduler": {
      "commands": {
        "jobs": {
          "commands": {
            "create": {
              "commands": {
                "app-engine": {
                  "commands": {},
                  "flags": {
                    "--attempt-deadline": "value",
                    "--description": "value",
                    "--headers": "value",
                    "--http-method": [
                      "delete",
                      "get",
                      "head",
                      "post",
                      "put"
                    ],
                    "--location": "value",
                    "--max-backoff": "value",
                    "--max-doublings": "value",
                    "--max-retry-attempts": "value",
                    "--max-retry-duration": "value",
                    "--message-body": "value",
                    "--message-body-from-file": "value",
                    "--min-backoff": "value",
                    "--relative-url": "value",
                    "--schedule": "value",
                    "--service": "value",
                    "--time-zone": "value"
                  }
                },
                "http": {
                  "commands": {},
                  "flags": {
                    "--attempt-deadline": "value",
                    "--description": "value",
                    "--headers": "value",
                    "--http-method": [
                      "delete",
                      "get",
                      "head",
                      "post",
                      "put"
                    ],
                    "--location": "value",
                    "--max-backoff": "value",
                    "--max-doublings": "value",
                    "--max-retry-attempts": "value",
                    "--max-retry-duration": "value",
                    "--message-body": "value",
                    "--message-body-from-file": "value",
                    "--min-backoff": "value",
                    "--oauth-service-account-email": "value",
                    "--oauth-token-scope": "value",
                    "--oidc-service-account-email": "value",
                    "--oidc-token-audience": "value",
                    "--schedule": "value",
                    "--time-zone": "value",
                    "--uri": "value"
                  }
                },
                "pubsub": {
                  "commands": {},
                  "flags": {
                    "--attributes": "value",
                    "--description": "value",
                    "--location": "value",
                    "--max-backoff": "value",
                    "--max-doublings": "value",
                    "--max-retry-attempts": "value",
                    "--max-retry-duration": "value",
                    "--message-body": "value",
                    "--message-body-from-file": "value",
                    "--min-backoff": "value",
                    "--schedule": "value",
                    "--time-zone": "value",
                    "--topic": "value"
                  }
                }
              },
              "flags": {}
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "pause": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "resume": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "run": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "update": {
              "commands": {
                "app-engine": {
                  "commands": {},
                  "flags": {
                    "--attempt-deadline": "value",
                    "--clear-headers": "bool",
                    "--clear-max-backoff": "bool",
                    "--clear-max-doublings": "bool",
                    "--clear-max-retry-attempts": "bool",
                    "--clear-max-retry-duration": "bool",
                    "--clear-message-body": "bool",
                    "--clear-min-backoff": "bool",
                    "--clear-relative-url": "bool",
                    "--clear-service": "bool",
                    "--clear-time-zone": "bool",
                    "--description": "value",
                    "--http-method": [
                      "delete",
                      "get",
                      "head",
                      "post",
                      "put"
                    ],
                    "--location": "value",
                    "--max-backoff": "value",
                    "--max-doublings": "value",
                    "--max-retry-attempts": "value",
                    "--max-retry-duration": "value",
                    "--message-body": "value",
                    "--message-body-from-file": "value",
                    "--min-backoff": "value",
                    "--relative-url": "value",
                    "--remove-headers": "value",
                    "--schedule": "value",
                    "--service": "value",
                    "--time-zone": "value",
                    "--update-headers": "value"
                  }
                },
                "http": {
                  "commands": {},
                  "flags": {
                    "--attempt-deadline": "value",
                    "--clear-auth-token": "bool",
                    "--clear-headers": "bool",
                    "--clear-max-backoff": "bool",
                    "--clear-max-doublings": "bool",
                    "--clear-max-retry-attempts": "bool",
                    "--clear-max-retry-duration": "bool",
                    "--clear-message-body": "bool",
                    "--clear-min-backoff": "bool",
                    "--clear-time-zone": "bool",
                    "--description": "value",
                    "--http-method": [
                      "delete",
                      "get",
                      "head",
                      "post",
                      "put"
                    ],
                    "--location": "value",
                    "--max-backoff": "value",
                    "--max-doublings": "value",
                    "--max-retry-attempts": "value",
                    "--max-retry-duration": "value",
                    "--message-body": "value",
                    "--message-body-from-file": "value",
                    "--min-backoff": "value",
                    "--oauth-service-account-email": "value",
                    "--oauth-token-scope": "value",
                    "--oidc-service-account-email": "value",
                    "--oidc-token-audience": "value",
                    "--remove-headers": "value",
                    "--schedule": "value",
                    "--time-zone": "value",
                    "--update-headers": "value",
                    "--uri": "value"
                  }
                },
                "pubsub": {
                  "commands": {},
                  "flags": {
                    "--clear-attributes": "bool",
                    "--clear-max-backoff": "bool",
                    "--clear-max-doublings": "bool",
                    "--clear-max-retry-attempts": "bool",
                    "--clear-max-retry-duration": "bool",
                    "--clear-min-backoff": "bool",
                    "--clear-time-zone": "bool",
                    "--description": "value",
                    "--location": "value",
                    "--max-backoff": "value",
                    "--max-doublings": "value",
                    "--max-retry-attempts": "value",
                    "--max-retry-duration": "value",
                    "--message-body": "value",
                    "--message-body-from-file": "value",
                    "--min-backoff": "value",
                    "--remove-attributes": "value",
                    "--schedule": "value",
                    "--time-zone": "value",
                    "--topic": "value",
                    "--update-attributes": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "locations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "secrets": {
      "commands": {
        "add-iam-policy-binding": {
          "commands": {},
          "flags": {
            "--condition": "value",
            "--condition-from-file": "value",
            "--location": "dynamic",
            "--member": "value",
            "--role": "value"
          }
        },
        "create": {
          "commands": {},
          "flags": {
            "--data-file": "value",
            "--expire-time": "value",
            "--kms-key-name": "value",
            "--labels": "value",
            "--location": "dynamic",
            "--locations": "value",
            "--next-rotation-time": "value",
            "--regional-kms-key-name": "value",
            "--replication-policy": "value",
            "--replication-policy-file": "value",
            "--rotation-period": "value",
            "--set-annotations": "value",
            "--topics": "value",
            "--ttl": "value",
            "--version-destroy-ttl": "value"
          }
        },
        "delete": {
          "commands": {},
          "flags": {
            "--etag": "value",
            "--location": "dynamic"
          }
        },
        "describe": {
          "commands": {},
          "flags": {
            "--location": "dynamic"
          }
        },
        "get-iam-policy": {
          "commands": {},
          "flags": {
            "--filter": "value",
            "--limit": "value",
            "--location": "dynamic",
            "--page-size": "value",
            "--sort-by": "value"
          }
        },
        "list": {
          "commands": {},
          "flags": {
            "--filter": "value",
            "--limit": "value",
            "--location": "dynamic",
            "--page-size": "value",
            "--sort-by": "value",
            "--uri": "bool"
          }
        },
        "locations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "remove-iam-policy-binding": {
          "commands": {},
          "flags": {
            "--all": "bool",
            "--condition": "value",
            "--condition-from-file": "value",
            "--location": "dynamic",
            "--member": "value",
            "--role": "value"
          }
        },
        "replication": {
          "commands": {
            "get": {
              "commands": {},
              "flags": {}
            },
            "set": {
              "commands": {},
              "flags": {
                "--replication-policy-file": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--remove-cmek": "bool",
                "--set-kms-key": "value"
              }
            }
          },
          "flags": {}
        },
        "set-iam-policy": {
          "commands": {},
          "flags": {
            "--location": "dynamic"
          }
        },
        "update": {
          "commands": {},
          "flags": {
            "--add-topics": "value",
            "--clear-annotations": "bool",
            "--clear-labels": "bool",
            "--clear-topics": "bool",
            "--clear-version-aliases": "bool",
            "--etag": "value",
            "--expire-time": "value",
            "--location": "dynamic",
            "--next-rotation-time": "value",
            "--regional-kms-key-name": "value",
            "--remove-annotations": "value",
            "--remove-expiration": "bool",
            "--remove-labels": "value",
            "--remove-next-rotation-time": "bool",
            "--remove-regional-kms-key-name": "bool",
            "--remove-rotation-period": "bool",
            "--remove-rotation-schedule": "bool",
            "--remove-topics": "value",
            "--remove-version-aliases": "value",
            "--remove-version-destroy-ttl": "bool",
            "--rotation-period": "value",
            "--ttl": "value",
            "--update-annotations": "value",
            "--update-labels": "value",
            "--update-version-aliases": "value",
            "--version-destroy-ttl": "value"
          }
        },
        "versions": {
          "commands": {
            "access": {
              "commands": {},
              "flags": {
                "--location": "dynamic",
                "--out-file": "value",
                "--secret": "dynamic"
              }
            },
            "add": {
              "commands": {},
              "flags": {
                "--data-file": "value",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic",
                "--secret": "dynamic"
              }
            },
            "destroy": {
              "commands": {},
              "flags": {
                "--etag": "value",
                "--location": "dynamic",
                "--secret": "dynamic"
              }
            },
            "disable": {
              "commands": {},
              "flags": {
                "--etag": "value",
                "--location": "dynamic",
                "--secret": "dynamic"
              }
            },
            "enable": {
              "commands": {},
              "flags": {
                "--etag": "value",
                "--location": "dynamic",
                "--secret": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "service-directory": {
      "commands": {
        "endpoints": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--address": "value",
                "--annotations": "value",
                "--location": "value",
                "--namespace": "value",
                "--network": "value",
                "--port": "value",
                "--service": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--namespace": "value",
                "--service": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--namespace": "value",
                "--service": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--location": "value",
                "--namespace": "value",
                "--page-size": "value",
                "--service": "value",
                "--sort-by": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--address": "value",
                "--annotations": "value",
                "--location": "value",
                "--namespace": "value",
                "--port": "value",
                "--service": "value"
              }
            }
          },
          "flags": {}
        },
        "locations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {}
            }
          },
          "flags": {}
        },
        "namespaces": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--labels": "value",
                "--location": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--labels": "value",
                "--location": "value"
              }
            }
          },
          "flags": {}
        },
        "services": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--namespace": "value",
                "--role": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--annotations": "value",
                "--location": "value",
                "--namespace": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--namespace": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--namespace": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--namespace": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--location": "value",
                "--namespace": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--namespace": "value",
                "--role": "value"
              }
            },
            "resolve": {
              "commands": {},
              "flags": {
                "--endpoint-filter": "value",
                "--location": "value",
                "--max-endpoints": "value",
                "--namespace": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--namespace": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--annotations": "value",
                "--location": "value",
                "--namespace": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "service-extensions": {
      "commands": {
        "lb-route-extensions": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "lb-traffic-extensions": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value",
                "--source": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "services": {
      "commands": {
        "api-keys": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--allowed-application": "value",
                "--allowed-bundle-ids": "value",
                "--allowed-ips": "value",
                "--allowed-referrers": "value",
                "--annotations": "value",
                "--api-target": "value",
                "--async": "bool",
                "--display-name": "value",
                "--key-id": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "get-key-string": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--show-deleted": "bool",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "lookup": {
              "commands": {},
              "flags": {}
            },
            "undelete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--key-string": "value",
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--allowed-application": "value",
                "--allowed-bundle-ids": "value",
                "--allowed-ips": "value",
                "--allowed-referrers": "value",
                "--annotations": "value",
                "--api-target": "value",
                "--async": "bool",
                "--clear-annotations": "bool",
                "--clear-restrictions": "bool",
                "--display-name": "value",
                "--location": "value"
              }
            }
          },
          "flags": {}
        },
        "disable": {
          "commands": {},
          "flags": {
            "--async": "bool",
            "--force": "bool"
          }
        },
        "enable": {
          "commands": {},
          "flags": {
            "--async": "bool"
          }
        },
        "list": {
          "commands": {},
          "flags": {
            "--available": "bool",
            "--enabled": "bool",
            "--filter": "value",
            "--limit": "value",
            "--page-size": "value",
            "--sort-by": "value"
          }
        },
        "operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--full": "value"
              }
            },
            "wait": {
              "commands": {},
              "flags": {}
            }
          },
          "flags": {}
        },
        "peered-dns-domains": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--dns-suffix": "value",
                "--network": "value",
                "--service": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--network": "value",
                "--service": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--network": "value",
                "--service": "value"
              }
            }
          },
          "flags": {}
        },
        "vpc-peerings": {
          "commands": {
            "connect": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--network": "value",
                "--ranges": "value",
                "--service": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--network": "value",
                "--service": "value"
              }
            },
            "disable-vpc-service-controls": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--network": "value",
                "--service": "value"
              }
            },
            "enable-vpc-service-controls": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--network": "value",
                "--service": "value"
              }
            },
            "get-vpc-service-controls": {
              "commands": {},
              "flags": {
                "--network": "value",
                "--service": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--network": "value",
                "--service": "value"
              }
            },
            "operations": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--name": "value"
                  }
                },
                "wait": {
                  "commands": {},
                  "flags": {
                    "--name": "value"
                  }
                }
              },
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--force": "bool",
                "--network": "value",
                "--ranges": "value",
                "--service": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "source": {
      "commands": {
        "project-configs": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-topic": "value",
                "--disable-pushblock": "bool",
                "--enable-pushblock": "bool",
                "--message-format": [
                  "json",
                  "protobuf"
                ],
                "--remove-topic": "value",
                "--service-account": "value",
                "--topic-project": "value",
                "--update-topic": "value"
              }
            }
          },
          "flags": {}
        },
        "repos": {
          "commands": {
            "clone": {
              "commands": {},
              "flags": {
                "--dry-run": "bool"
              }
            },
            "create": {
              "commands": {},
              "flags": {}
            },
            "delete": {
              "commands": {},
              "flags": {
                "--force": "bool"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--add-topic": "value",
                "--message-format": [
                  "json",
                  "protobuf"
                ],
                "--remove-topic": "value",
                "--service-account": "value",
                "--topic-project": "value",
                "--update-topic": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "spanner": {
      "commands": {
        "backup-schedules": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--database": "dynamic",
                "--instance": "dynamic",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--backup-type": "value",
                "--cron": "value",
                "--database": "value",
                "--encryption-type": [
                  "customer-managed-encryption",
                  "google-default-encryption",
                  "use-database-encryption"
                ],
                "--instance": "value",
                "--kms-key": "value",
                "--kms-keyring": "value",
                "--kms-keys": "value",
                "--kms-location": "value",
                "--kms-project": "value",
                "--retention-duration": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--database": "value",
                "--instance": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--database": "value",
                "--instance": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--database": "dynamic",
                "--filter": "value",
                "--instance": "dynamic",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--database": "value",
                "--filter": "value",
                "--instance": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--database": "dynamic",
                "--instance": "dynamic",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--database": "dynamic",
                "--instance": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--cron": "value",
                "--database": "value",
                "--encryption-type": [
                  "customer-managed-encryption",
                  "google-default-encryption",
                  "use-database-encryption"
                ],
                "--instance": "value",
                "--kms-key": "value",
                "--kms-keyring": "value",
                "--kms-keys": "value",
                "--kms-location": "value",
                "--kms-project": "value",
                "--retention-duration": "value"
              }
            }
          },
          "flags": {}
        },
        "backups": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--instance": "dynamic",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "copy": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--destination-backup": "value",
                "--destination-instance": "value",
                "--encryption-type": [
                  "customer-managed-encryption",
                  "google-default-encryption",
                  "use-config-default-or-backup-encryption"
                ],
                "--expiration-date": "value",
                "--kms-key": "value",
                "--kms-keyring": "value",
                "--kms-keys": "value",
                "--kms-location": "value",
                "--kms-project": "value",
                "--retention-period": "value",
                "--source-backup": "value",
                "--source-instance": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--database": "value",
                "--encryption-type": [
                  "customer-managed-encryption",
                  "google-default-encryption",
                  "use-database-encryption"
                ],
                "--expiration-date": "value",
                "--instance": "value",
                "--kms-key": "value",
                "--kms-keyring": "value",
                "--kms-keys": "value",
                "--kms-location": "value",
                "--kms-project": "value",
                "--retention-period": "value",
                "--version-time": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--instance": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--instance": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--instance": "dynamic",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--database": "value",
                "--filter": "value",
                "--instance": "dynamic",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--instance": "dynamic",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--instance": "dynamic"
              }
            },
            "update-metadata": {
              "commands": {},
              "flags": {
                "--expiration-date": "value",
                "--instance": "dynamic",
                "--retention-period": "value"
              }
            }
          },
          "flags": {}
        },
        "databases": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--instance": "dynamic",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "change-quorum": {
              "commands": {},
              "flags": {
                "--dual-region": "bool",
                "--etag": "value",
                "--instance": "value",
                "--serving-location": "value",
                "--single-region": "bool"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--database-dialect": [
                  "GOOGLE_STANDARD_SQL",
                  "POSTGRESQL"
                ],
                "--ddl": "value",
                "--ddl-file": "dynamic",
                "--instance": "value",
                "--kms-key": "value",
                "--kms-keyring": "value",
                "--kms-keys": "value",
                "--kms-location": "value",
                "--kms-project": "value",
                "--proto-descriptors-file": "dynamic"
              }
            },
            "ddl": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--include-proto-descriptors": "bool",
                    "--instance": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--ddl": "value",
                    "--ddl-file": "dynamic",
                    "--instance": "value",
                    "--proto-descriptors-file": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "delete": {
              "commands": {},
              "flags": {
                "--instance": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--instance": "value"
              }
            },
            "execute-sql": {
              "commands": {},
              "flags": {
                "--database-role": "value",
                "--enable-partitioned-dml": "bool",
                "--instance": "value",
                "--priority": [
                  "high",
                  "low",
                  "medium",
                  "unspecified"
                ],
                "--query-mode": [
                  "NORMAL",
                  "PLAN",
                  "PROFILE"
                ],
                "--read-timestamp": "value",
                "--sql": "value",
                "--strong": "bool",
                "--timeout": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--instance": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--instance": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--instance": "dynamic",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "restore": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--destination-database": "value",
                "--destination-instance": "value",
                "--encryption-type": [
                  "customer-managed-encryption",
                  "google-default-encryption",
                  "use-config-default-or-backup-encryption"
                ],
                "--kms-key": "value",
                "--kms-keyring": "value",
                "--kms-keys": "value",
                "--kms-location": "value",
                "--kms-project": "value",
                "--source-backup": "value",
                "--source-instance": "value"
              }
            },
            "roles": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--database": "value",
                    "--filter": "value",
                    "--instance": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "sessions": {
              "commands": {
                "delete": {
                  "commands": {},
                  "flags": {
                    "--database": "value",
                    "--instance": "value"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--database": "value",
                    "--filter": "value",
                    "--instance": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--server-filter": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--instance": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--enable-drop-protection": "bool",
                "--instance": "value"
              }
            }
          },
          "flags": {}
        },
        "instance-configs": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--add-replicas": "value",
                "--async": "bool",
                "--base-config": "value",
                "--clone-config": "dynamic",
                "--display-name": "value",
                "--etag": "value",
                "--labels": "value",
                "--replicas": "value",
                "--skip-replicas": "value",
                "--validate-only": "bool"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--etag": "value",
                "--validate-only": "bool"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-labels": "bool",
                "--display-name": "value",
                "--etag": "value",
                "--remove-labels": "value",
                "--update-labels": "value",
                "--validate-only": "bool"
              }
            }
          },
          "flags": {}
        },
        "instances": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--asymmetric-autoscaling-option": "value",
                "--async": "bool",
                "--autoscaling-high-priority-cpu-target": "value",
                "--autoscaling-max-nodes": "value",
                "--autoscaling-max-processing-units": "value",
                "--autoscaling-min-nodes": "value",
                "--autoscaling-min-processing-units": "value",
                "--autoscaling-storage-target": "value",
                "--config": "dynamic",
                "--default-backup-schedule-type": [
                  "AUTOMATIC",
                  "DEFAULT_BACKUP_SCHEDULE_TYPE_UNSPECIFIED",
                  "NONE"
                ],
                "--description": "value",
                "--edition": [
                  "EDITION_UNSPECIFIED",
                  "ENTERPRISE",
                  "ENTERPRISE_PLUS",
                  "STANDARD"
                ],
                "--expire-behavior": [
                  "free-to-provisioned",
                  "remove-after-grace-period"
                ],
                "--instance-type": [
                  "free-instance",
                  "provisioned"
                ],
                "--nodes": "value",
                "--processing-units": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "get-locations": {
              "commands": {},
              "flags": {
                "--verbose": "bool"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "move": {
              "commands": {},
              "flags": {
                "--target-config": "dynamic"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--asymmetric-autoscaling-option": "value",
                "--async": "bool",
                "--autoscaling-high-priority-cpu-target": "value",
                "--autoscaling-max-nodes": "value",
                "--autoscaling-max-processing-units": "value",
                "--autoscaling-min-nodes": "value",
                "--autoscaling-min-processing-units": "value",
                "--autoscaling-storage-target": "value",
                "--clear-asymmetric-autoscaling-option": "value",
                "--default-backup-schedule-type": [
                  "AUTOMATIC",
                  "DEFAULT_BACKUP_SCHEDULE_TYPE_UNSPECIFIED",
                  "NONE"
                ],
                "--description": "value",
                "--edition": "value",
                "--expire-behavior": [
                  "free-to-provisioned",
                  "remove-after-grace-period"
                ],
                "--instance-type": [
                  "free-instance",
                  "provisioned"
                ],
                "--nodes": "value",
                "--processing-units": "value"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {
                "--backup": "dynamic",
                "--database": "dynamic",
                "--instance": "dynamic",
                "--instance-config": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--backup": "dynamic",
                "--database": "dynamic",
                "--instance": "dynamic",
                "--instance-config": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--backup": "dynamic",
                "--database": "dynamic",
                "--filter": "value",
                "--instance": "dynamic",
                "--instance-config": "dynamic",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--type": [
                  "BACKUP",
                  "DATABASE",
                  "DATABASE_CHANGE_QUORUM",
                  "DATABASE_CREATE",
                  "DATABASE_RESTORE",
                  "DATABASE_UPDATE_DDL",
                  "INSTANCE",
                  "INSTANCE_CONFIG_CREATE",
                  "INSTANCE_CONFIG_UPDATE"
                ],
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "rows": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--database": "value",
                "--instance": "value",
                "--keys": "value",
                "--table": "value"
              }
            },
            "insert": {
              "commands": {},
              "flags": {
                "--data": "value",
                "--database": "value",
                "--instance": "value",
                "--table": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--data": "value",
                "--database": "value",
                "--instance": "value",
                "--table": "value"
              }
            }
          },
          "flags": {}
        },
        "samples": {
          "commands": {
            "backend": {
              "commands": {},
              "flags": {
                "--database-id": "value",
                "--duration": "value",
                "--instance-id": "value",
                "--port": "value"
              }
            },
            "init": {
              "commands": {},
              "flags": {
                "--database-id": "value",
                "--instance-id": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "run": {
              "commands": {},
              "flags": {
                "--cleanup": "bool",
                "--database-id": "value",
                "--duration": "value",
                "--instance-id": "value",
                "--skip-init": "bool"
              }
            },
            "workload": {
              "commands": {},
              "flags": {
                "--duration": "value",
                "--port": "value",
                "--target-qps": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "sql": {
      "commands": {
        "backups": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--instance": "dynamic",
                "--location": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--instance": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--instance": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--instance": "dynamic",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "restore": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--backup-instance": "dynamic",
                "--backup-project": "value",
                "--restore-instance": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "connect": {
          "commands": {},
          "flags": {
            "--database": "value",
            "--user": "value"
          }
        },
        "databases": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--charset": "value",
                "--collation": "value",
                "--instance": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--instance": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--instance": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--instance": "dynamic",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "patch": {
              "commands": {},
              "flags": {
                "--charset": "value",
                "--collation": "value",
                "--diff": "bool",
                "--instance": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "export": {
          "commands": {
            "bak": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--bak-type": [
                  "DIFF",
                  "FULL",
                  "TLOG"
                ],
                "--database": "value",
                "--differential-base": "bool",
                "--export-log-end-time": "value",
                "--export-log-start-time": "value",
                "--stripe_count": "value",
                "--striped": "bool"
              }
            },
            "csv": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--database": "value",
                "--escape": "value",
                "--fields-terminated-by": "value",
                "--lines-terminated-by": "value",
                "--offload": "bool",
                "--query": "value",
                "--quote": "value"
              }
            },
            "sql": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clean": "bool",
                "--database": "value",
                "--if-exists": "bool",
                "--offload": "bool",
                "--parallel": "bool",
                "--table": "value",
                "--threads": "value"
              }
            }
          },
          "flags": {}
        },
        "flags": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--database-version": [
                  "MYSQL_5_6",
                  "MYSQL_5_7",
                  "MYSQL_8_0",
                  "MYSQL_8_4",
                  "POSTGRES_10",
                  "POSTGRES_11",
                  "POSTGRES_12",
                  "POSTGRES_13",
                  "POSTGRES_14",
                  "POSTGRES_15",
                  "POSTGRES_16",
                  "POSTGRES_17",
                  "POSTGRES_9_6",
                  "SQLSERVER_2017_ENTERPRISE",
                  "SQLSERVER_2017_EXPRESS",
                  "SQLSERVER_2017_STANDARD",
                  "SQLSERVER_2017_WEB",
                  "SQLSERVER_2019_ENTERPRISE",
                  "SQLSERVER_2019_EXPRESS",
                  "SQLSERVER_2019_STANDARD",
                  "SQLSERVER_2019_WEB",
                  "SQLSERVER_2022_ENTERPRISE",
                  "SQLSERVER_2022_EXPRESS",
                  "SQLSERVER_2022_STANDARD",
                  "SQLSERVER_2022_WEB"
                ],
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "generate-login-token": {
          "commands": {},
          "flags": {
            "--application-default-credential": "bool",
            "--instance": "dynamic"
          }
        },
        "import": {
          "commands": {
            "bak": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--bak-type": [
                  "DIFF",
                  "FULL",
                  "TLOG"
                ],
                "--cert-path": "value",
                "--database": "value",
                "--no-recovery": "bool",
                "--prompt-for-pvk-password": "bool",
                "--pvk-password": "value",
                "--pvk-path": "value",
                "--recovery-only": "bool",
                "--stop-at": "value",
                "--stop-at-mark": "value",
                "--striped": "bool"
              }
            },
            "csv": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--columns": "value",
                "--database": "value",
                "--escape": "value",
                "--fields-terminated-by": "value",
                "--lines-terminated-by": "value",
                "--quote": "value",
                "--table": "value",
                "--user": "value"
              }
            },
            "sql": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clean": "bool",
                "--database": "value",
                "--if-exists": "bool",
                "--parallel": "bool",
                "--threads": "value",
                "--user": "value"
              }
            }
          },
          "flags": {}
        },
        "instances": {
          "commands": {
            "acquire-ssrs-lease": {
              "commands": {},
              "flags": {
                "--duration": "value",
                "--report-database": "value",
                "--service-login": "value",
                "--setup-login": "value"
              }
            },
            "clone": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--bin-log-file-name": "value",
                "--bin-log-position": "value",
                "--point-in-time": "value",
                "--preferred-secondary-zone": "value",
                "--preferred-zone": "value",
                "--restore-database-name": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--activation-policy": [
                  "always",
                  "never"
                ],
                "--active-directory-domain": "value",
                "--allowed-psc-projects": "value",
                "--assign-ip": "bool",
                "--async": "bool",
                "--audit-bucket-path": "value",
                "--audit-retention-interval": "value",
                "--audit-upload-interval": "value",
                "--authorized-networks": "value",
                "--availability-type": [
                  "regional",
                  "zonal"
                ],
                "--backup": "bool",
                "--backup-location": "value",
                "--backup-start-time": "value",
                "--cascadable-replica": "bool",
                "--collation": "value",
                "--connector-enforcement": [
                  "CONNECTOR_ENFORCEMENT_UNSPECIFIED",
                  "NOT_REQUIRED",
                  "REQUIRED"
                ],
                "--cpu": "value",
                "--database-flags": "value",
                "--database-version": [
                  "MYSQL_5_6",
                  "MYSQL_5_7",
                  "MYSQL_8_0",
                  "MYSQL_8_4",
                  "POSTGRES_10",
                  "POSTGRES_11",
                  "POSTGRES_12",
                  "POSTGRES_13",
                  "POSTGRES_14",
                  "POSTGRES_15",
                  "POSTGRES_16",
                  "POSTGRES_17",
                  "POSTGRES_9_6",
                  "SQLSERVER_2017_ENTERPRISE",
                  "SQLSERVER_2017_EXPRESS",
                  "SQLSERVER_2017_STANDARD",
                  "SQLSERVER_2017_WEB",
                  "SQLSERVER_2019_ENTERPRISE",
                  "SQLSERVER_2019_EXPRESS",
                  "SQLSERVER_2019_STANDARD",
                  "SQLSERVER_2019_WEB",
                  "SQLSERVER_2022_ENTERPRISE",
                  "SQLSERVER_2022_EXPRESS",
                  "SQLSERVER_2022_STANDARD",
                  "SQLSERVER_2022_WEB"
                ],
                "--deletion-protection": "bool",
                "--deny-maintenance-period-end-date": "value",
                "--deny-maintenance-period-start-date": "value",
                "--deny-maintenance-period-time": "value",
                "--disk-encryption-key": "dynamic",
                "--disk-encryption-key-keyring": "dynamic",
                "--disk-encryption-key-location": "dynamic",
                "--disk-encryption-key-project": "dynamic",
                "--edition": [
                  "enterprise",
                  "enterprise-plus"
                ],
                "--enable-bin-log": "bool",
                "--enable-data-cache": "bool",
                "--enable-dataplex-integration": "bool",
                "--enable-google-ml-integration": "bool",
                "--enable-google-private-path": "bool",
                "--enable-password-policy": "bool",
                "--enable-point-in-time-recovery": "bool",
                "--enable-private-service-connect": "bool",
                "--failover-replica-name": "value",
                "--gce-zone": "value",
                "--insights-config-query-insights-enabled": "bool",
                "--insights-config-query-plans-per-minute": "value",
                "--insights-config-query-string-length": "value",
                "--insights-config-record-application-tags": "bool",
                "--insights-config-record-client-address": "bool",
                "--maintenance-release-channel": [
                  "preview",
                  "production",
                  "week5"
                ],
                "--maintenance-window-day": [
                  "FRI",
                  "MON",
                  "SAT",
                  "SUN",
                  "THU",
                  "TUE",
                  "WED"
                ],
                "--maintenance-window-hour": "value",
                "--master-instance-name": "value",
                "--memory": "value",
                "--network": "value",
                "--password-policy-complexity": [
                  "COMPLEXITY_DEFAULT",
                  "COMPLEXITY_UNSPECIFIED"
                ],
                "--password-policy-disallow-username-substring": "bool",
                "--password-policy-min-length": "value",
                "--password-policy-password-change-interval": "value",
                "--password-policy-reuse-interval": "value",
                "--psc-auto-connections": "value",
                "--recreate-replicas-on-primary-crash": "bool",
                "--region": "value",
                "--replica-type": [
                  "FAILOVER",
                  "READ"
                ],
                "--replication": [
                  "asynchronous",
                  "synchronous"
                ],
                "--require-ssl": "bool",
                "--retained-backups-count": "value",
                "--retained-transaction-log-days": "value",
                "--root-password": "value",
                "--secondary-zone": "value",
                "--server-ca-mode": [
                  "CUSTOMER_MANAGED_CAS_CA",
                  "GOOGLE_MANAGED_CAS_CA",
                  "GOOGLE_MANAGED_INTERNAL_CA"
                ],
                "--ssl-mode": [
                  "ALLOW_UNENCRYPTED_AND_ENCRYPTED",
                  "ENCRYPTED_ONLY",
                  "TRUSTED_CLIENT_CERTIFICATE_REQUIRED"
                ],
                "--storage-auto-increase": "bool",
                "--storage-size": "value",
                "--storage-type": [
                  "HDD",
                  "SSD"
                ],
                "--threads-per-core": "value",
                "--tier": "value",
                "--time-zone": "value",
                "--timeout": "value",
                "--zone": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "export": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--database": "value",
                "--table": "value"
              }
            },
            "failover": {
              "commands": {},
              "flags": {
                "--async": "bool"
              }
            },
            "get-latest-recovery-time": {
              "commands": {},
              "flags": {}
            },
            "import": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--database": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--show-edition": "bool",
                "--show-sql-network-architecture": "bool",
                "--show-transactional-log-storage-state": "bool",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "patch": {
              "commands": {},
              "flags": {
                "--activation-policy": [
                  "always",
                  "never"
                ],
                "--active-directory-domain": "value",
                "--allowed-psc-projects": "value",
                "--assign-ip": "bool",
                "--async": "bool",
                "--audit-bucket-path": "value",
                "--audit-retention-interval": "value",
                "--audit-upload-interval": "value",
                "--authorized-gae-apps": "value",
                "--authorized-networks": "value",
                "--availability-type": [
                  "regional",
                  "zonal"
                ],
                "--backup-location": "value",
                "--backup-start-time": "value",
                "--clear-allowed-psc-projects": "bool",
                "--clear-authorized-networks": "bool",
                "--clear-database-flags": "bool",
                "--clear-failover-dr-replica-name": "bool",
                "--clear-gae-apps": "bool",
                "--clear-password-policy": "bool",
                "--connector-enforcement": [
                  "CONNECTOR_ENFORCEMENT_UNSPECIFIED",
                  "NOT_REQUIRED",
                  "REQUIRED"
                ],
                "--cpu": "value",
                "--database-flags": "value",
                "--database-version": [
                  "MYSQL_5_6",
                  "MYSQL_5_7",
                  "MYSQL_8_0",
                  "MYSQL_8_4",
                  "POSTGRES_10",
                  "POSTGRES_11",
                  "POSTGRES_12",
                  "POSTGRES_13",
                  "POSTGRES_14",
                  "POSTGRES_15",
                  "POSTGRES_16",
                  "POSTGRES_17",
                  "POSTGRES_9_6",
                  "SQLSERVER_2017_ENTERPRISE",
                  "SQLSERVER_2017_EXPRESS",
                  "SQLSERVER_2017_STANDARD",
                  "SQLSERVER_2017_WEB",
                  "SQLSERVER_2019_ENTERPRISE",
                  "SQLSERVER_2019_EXPRESS",
                  "SQLSERVER_2019_STANDARD",
                  "SQLSERVER_2019_WEB",
                  "SQLSERVER_2022_ENTERPRISE",
                  "SQLSERVER_2022_EXPRESS",
                  "SQLSERVER_2022_STANDARD",
                  "SQLSERVER_2022_WEB"
                ],
                "--deletion-protection": "bool",
                "--deny-maintenance-period-end-date": "value",
                "--deny-maintenance-period-start-date": "value",
                "--deny-maintenance-period-time": "value",
                "--diff": "bool",
                "--edition": [
                  "enterprise",
                  "enterprise-plus"
                ],
                "--enable-bin-log": "bool",
                "--enable-data-cache": "bool",
                "--enable-database-replication": "bool",
                "--enable-dataplex-integration": "bool",
                "--enable-google-ml-integration": "bool",
                "--enable-google-private-path": "bool",
                "--enable-password-policy": "bool",
                "--enable-point-in-time-recovery": "bool",
                "--failover-dr-replica-name": "value",
                "--follow-gae-app": "value",
                "--gce-zone": "value",
                "--insights-config-query-insights-enabled": "bool",
                "--insights-config-query-plans-per-minute": "value",
                "--insights-config-query-string-length": "value",
                "--insights-config-record-application-tags": "bool",
                "--insights-config-record-client-address": "bool",
                "--maintenance-release-channel": [
                  "preview",
                  "production",
                  "week5"
                ],
                "--maintenance-version": "value",
                "--maintenance-window-any": "bool",
                "--maintenance-window-day": [
                  "FRI",
                  "MON",
                  "SAT",
                  "SUN",
                  "THU",
                  "TUE",
                  "WED"
                ],
                "--maintenance-window-hour": "value",
                "--memory": "value",
                "--network": "value",
                "--no-backup": "bool",
                "--password-policy-complexity": [
                  "COMPLEXITY_DEFAULT",
                  "COMPLEXITY_UNSPECIFIED"
                ],
                "--password-policy-disallow-username-substring": "bool",
                "--password-policy-min-length": "value",
                "--password-policy-password-change-interval": "value",
                "--password-policy-reuse-interval": "value",
                "--pricing-plan": [
                  "PACKAGE",
                  "PER_USE"
                ],
                "--recreate-replicas-on-primary-crash": "bool",
                "--remove-deny-maintenance-period": "bool",
                "--replication": [
                  "asynchronous",
                  "synchronous"
                ],
                "--require-ssl": "bool",
                "--retained-backups-count": "value",
                "--retained-transaction-log-days": "value",
                "--secondary-zone": "value",
                "--simulate-maintenance-event": "bool",
                "--ssl-mode": [
                  "ALLOW_UNENCRYPTED_AND_ENCRYPTED",
                  "ENCRYPTED_ONLY",
                  "TRUSTED_CLIENT_CERTIFICATE_REQUIRED"
                ],
                "--storage-auto-increase": "bool",
                "--storage-size": "value",
                "--switch-transaction-logs-to-cloud-storage": "bool",
                "--threads-per-core": "value",
                "--tier": "value",
                "--time-zone": "value",
                "--upgrade-sql-network-architecture": "bool",
                "--zone": "value"
              }
            },
            "promote-replica": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--failover": "bool"
              }
            },
            "reencrypt": {
              "commands": {},
              "flags": {
                "--async": "bool"
              }
            },
            "release-ssrs-lease": {
              "commands": {},
              "flags": {}
            },
            "reset-ssl-config": {
              "commands": {},
              "flags": {
                "--async": "bool"
              }
            },
            "restart": {
              "commands": {},
              "flags": {
                "--async": "bool"
              }
            },
            "restore-backup": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--backup-id": "value",
                "--backup-instance": "dynamic"
              }
            },
            "switchover": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--db-timeout": "value"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--instance": "dynamic",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "wait": {
              "commands": {},
              "flags": {
                "--timeout": "value"
              }
            }
          },
          "flags": {}
        },
        "reschedule-maintenance": {
          "commands": {},
          "flags": {
            "--reschedule-type": [
              "IMMEDIATE",
              "NEXT_AVAILABLE_WINDOW",
              "SPECIFIC_TIME"
            ],
            "--schedule-time": "value"
          }
        },
        "ssl": {
          "commands": {
            "client-certs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--instance": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--instance": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "server-ca-certs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--instance": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "rollback": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--instance": "dynamic"
                  }
                },
                "rotate": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--instance": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "server-certs": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--instance": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--instance": "dynamic",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "rollback": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--instance": "dynamic"
                  }
                },
                "rotate": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--instance": "dynamic"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "ssl-certs": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--instance": "dynamic"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--instance": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--instance": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--instance": "dynamic",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "tiers": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--show-edition": "bool",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "users": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--host": "value",
                "--instance": "dynamic",
                "--password": "value",
                "--password-policy-allowed-failed-attempts": "value",
                "--password-policy-enable-failed-attempts-check": "bool",
                "--password-policy-enable-password-verification": "bool",
                "--password-policy-password-expiration-duration": "value",
                "--type": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--host": "value",
                "--instance": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--host": "value",
                "--instance": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--instance": "dynamic",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "set-password": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--discard-dual-password": "bool",
                "--host": "value",
                "--instance": "dynamic",
                "--password": "value",
                "--prompt-for-password": "bool",
                "--retain-password": "bool"
              }
            },
            "set-password-policy": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--clear-password-policy": "bool",
                "--host": "value",
                "--instance": "dynamic",
                "--password-policy-allowed-failed-attempts": "value",
                "--password-policy-enable-failed-attempts-check": "bool",
                "--password-policy-enable-password-verification": "bool",
                "--password-policy-password-expiration-duration": "value"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "storage": {
      "commands": {
        "buckets": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--additional-headers": "value",
                "--autoclass-terminal-storage-class": "value",
                "--default-encryption-key": "value",
                "--default-storage-class": "value",
                "--enable-autoclass": "bool",
                "--enable-hierarchical-namespace": "bool",
                "--enable-per-object-retention": "bool",
                "--location": "value",
                "--pap": "bool",
                "--placement": "value",
                "--public-access-prevention": "bool",
                "--recovery-point-objective": [
                  "ASYNC_TURBO",
                  "DEFAULT"
                ],
                "--retention-period": "value",
                "--rpo": [
                  "ASYNC_TURBO",
                  "DEFAULT"
                ],
                "--soft-delete-duration": "value",
                "--uniform-bucket-level-access": "bool"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--additional-headers": "value",
                "--continue-on-error": "bool"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--additional-headers": "value",
                "--raw": "bool"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--additional-headers": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--raw": "bool",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "notifications": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--custom-attributes": "value",
                    "--event-types": "value",
                    "--object-prefix": "value",
                    "--payload-format": [
                      "json",
                      "none"
                    ],
                    "--skip-topic-setup": "bool",
                    "--topic": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {}
                },
                "describe": {
                  "commands": {},
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--continue-on-error": "bool",
                "--etag": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--acl-file": "value",
                "--add-acl-grant": "value",
                "--add-default-object-acl-grant": "value",
                "--additional-headers": "value",
                "--autoclass-terminal-storage-class": "value",
                "--canned-acl": "value",
                "--clear-cors": "bool",
                "--clear-default-encryption-key": "bool",
                "--clear-labels": "bool",
                "--clear-lifecycle": "bool",
                "--clear-log-bucket": "bool",
                "--clear-log-object-prefix": "bool",
                "--clear-pap": "bool",
                "--clear-public-access-prevention": "bool",
                "--clear-retention-period": "bool",
                "--clear-soft-delete": "bool",
                "--clear-web-error-page": "bool",
                "--clear-web-main-page-suffix": "bool",
                "--continue-on-error": "bool",
                "--cors-file": "value",
                "--default-encryption-key": "value",
                "--default-event-based-hold": "bool",
                "--default-object-acl-file": "value",
                "--default-storage-class": "value",
                "--enable-autoclass": "bool",
                "--labels-file": "value",
                "--lifecycle-file": "value",
                "--lock-retention-period": "bool",
                "--log-bucket": "value",
                "--log-object-prefix": "value",
                "--pap": "bool",
                "--predefined-acl": "value",
                "--predefined-default-object-acl": "value",
                "--public-access-prevention": "bool",
                "--read-paths-from-stdin": "bool",
                "--recovery-point-objective": [
                  "ASYNC_TURBO",
                  "DEFAULT"
                ],
                "--remove-acl-grant": "value",
                "--remove-default-object-acl-grant": "value",
                "--remove-labels": "value",
                "--requester-pays": "bool",
                "--retention-period": "value",
                "--rpo": [
                  "ASYNC_TURBO",
                  "DEFAULT"
                ],
                "--soft-delete-duration": "value",
                "--uniform-bucket-level-access": "bool",
                "--update-labels": "value",
                "--versioning": "bool",
                "--web-error-page": "value",
                "--web-main-page-suffix": "value"
              }
            }
          },
          "flags": {}
        },
        "cat": {
          "commands": {},
          "flags": {
            "--additional-headers": "value",
            "--decryption-keys": "value",
            "--display-url": "bool",
            "--range": "value"
          }
        },
        "cp": {
          "commands": {},
          "flags": {
            "--additional-headers": "value",
            "--all-versions": "bool",
            "--cache-control": "value",
            "--canned-acl": "value",
            "--clear-custom-metadata": "bool",
            "--content-disposition": "value",
            "--content-encoding": "value",
            "--content-language": "value",
            "--content-md5": "value",
            "--content-type": "value",
            "--continue-on-error": "bool",
            "--custom-metadata": "value",
            "--custom-time": "value",
            "--daisy-chain": "bool",
            "--decryption-keys": "value",
            "--do-not-decompress": "bool",
            "--encryption-key": "value",
            "--gzip-in-flight": "value",
            "--gzip-in-flight-all": "bool",
            "--gzip-local": "value",
            "--gzip-local-all": "bool",
            "--if-generation-match": "value",
            "--if-metageneration-match": "value",
            "--ignore-symlinks": "bool",
            "--include-managed-folders": "bool",
            "--manifest-path": "value",
            "--no-clobber": "bool",
            "--predefined-acl": "value",
            "--preserve-acl": "bool",
            "--preserve-posix": "bool",
            "--preserve-symlinks": "bool",
            "--print-created-message": "bool",
            "--read-paths-from-stdin": "bool",
            "--recursive": "bool",
            "--remove-custom-metadata": "value",
            "--retain-until": "value",
            "--retention-mode": [
              "Locked",
              "Unlocked"
            ],
            "--skip-unsupported": "bool",
            "--storage-class": "value",
            "--update-custom-metadata": "value"
          }
        },
        "du": {
          "commands": {},
          "flags": {
            "--additional-headers": "value",
            "--all-versions": "bool",
            "--exclude-name-pattern": "value",
            "--exclude-name-pattern-file": "value",
            "--readable-sizes": "bool",
            "--summarize": "bool",
            "--total": "bool",
            "--zero-terminator": "bool"
          }
        },
        "folders": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--additional-headers": "value",
                "--recursive": "bool"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--additional-headers": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--additional-headers": "value",
                "--raw": "bool"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--additional-headers": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--raw": "bool",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "hash": {
          "commands": {},
          "flags": {
            "--additional-headers": "value",
            "--decryption-keys": "value",
            "--hex": "bool",
            "--skip-crc32c": "bool",
            "--skip-md5": "bool"
          }
        },
        "hmac": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {}
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--filter": "value",
                "--limit": "value",
                "--long": "bool",
                "--page-size": "value",
                "--service-account": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--activate": "bool",
                "--deactivate": "bool",
                "--etag": "value"
              }
            }
          },
          "flags": {}
        },
        "insights": {
          "commands": {
            "inventory-reports": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--csv-delimiter": "value",
                    "--csv-header": "bool",
                    "--csv-separator": [
                      "\\n",
                      "\\r\\n"
                    ],
                    "--destination": "value",
                    "--display-name": "value",
                    "--metadata-fields": "value",
                    "--parquet": "bool",
                    "--schedule-repeats": [
                      "daily",
                      "weekly"
                    ],
                    "--schedule-repeats-until": "value",
                    "--schedule-starts": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--force": "bool",
                    "--location": "value"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "value"
                  }
                },
                "details": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "value",
                        "--report-config": "value"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "value",
                        "--page-size": "value",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "value",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--source": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--add-metadata-fields": "value",
                    "--csv-delimiter": "value",
                    "--csv-header": "bool",
                    "--csv-separator": [
                      "\\n",
                      "\\r\\n"
                    ],
                    "--destination": "value",
                    "--display-name": "value",
                    "--location": "value",
                    "--metadata-fields": "value",
                    "--parquet": "bool",
                    "--remove-metadata-fields": "value",
                    "--schedule-repeats": [
                      "daily",
                      "weekly"
                    ],
                    "--schedule-repeats-until": "value",
                    "--schedule-starts": "value"
                  }
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "ls": {
          "commands": {},
          "flags": {
            "--additional-headers": "value",
            "--all-versions": "bool",
            "--buckets": "bool",
            "--decryption-keys": "value",
            "--etag": "bool",
            "--exhaustive": "bool",
            "--fetch-encrypted-object-hashes": "bool",
            "--full": "bool",
            "--json": "bool",
            "--long": "bool",
            "--next-page-token": "value",
            "--read-paths-from-stdin": "bool",
            "--readable-sizes": "bool",
            "--recursive": "bool",
            "--soft-deleted": "bool"
          }
        },
        "managed-folders": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "value"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--additional-headers": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--additional-headers": "value",
                "--continue-on-error": "bool"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--additional-headers": "value",
                "--raw": "bool"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--additional-headers": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--raw": "bool",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--condition": "value",
                "--condition-from-file": "value",
                "--member": "value",
                "--role": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--continue-on-error": "bool",
                "--etag": "value"
              }
            }
          },
          "flags": {}
        },
        "mv": {
          "commands": {},
          "flags": {
            "--additional-headers": "value",
            "--all-versions": "bool",
            "--cache-control": "value",
            "--canned-acl": "value",
            "--clear-custom-metadata": "bool",
            "--content-disposition": "value",
            "--content-encoding": "value",
            "--content-language": "value",
            "--content-md5": "value",
            "--content-type": "value",
            "--continue-on-error": "bool",
            "--custom-metadata": "value",
            "--custom-time": "value",
            "--daisy-chain": "bool",
            "--decryption-keys": "value",
            "--do-not-decompress": "bool",
            "--encryption-key": "value",
            "--gzip-in-flight": "value",
            "--gzip-in-flight-all": "bool",
            "--gzip-local": "value",
            "--gzip-local-all": "bool",
            "--if-generation-match": "value",
            "--if-metageneration-match": "value",
            "--ignore-symlinks": "bool",
            "--include-managed-folders": "bool",
            "--manifest-path": "value",
            "--no-clobber": "bool",
            "--predefined-acl": "value",
            "--preserve-acl": "bool",
            "--preserve-posix": "bool",
            "--preserve-symlinks": "bool",
            "--print-created-message": "bool",
            "--read-paths-from-stdin": "bool",
            "--remove-custom-metadata": "value",
            "--retain-until": "value",
            "--retention-mode": [
              "Locked",
              "Unlocked"
            ],
            "--skip-unsupported": "bool",
            "--storage-class": "value",
            "--update-custom-metadata": "value"
          }
        },
        "objects": {
          "commands": {
            "compose": {
              "commands": {},
              "flags": {
                "--additional-headers": "value",
                "--if-generation-match": "value",
                "--if-metageneration-match": "value",
                "--retain-until": "value",
                "--retention-mode": [
                  "Locked",
                  "Unlocked"
                ]
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--additional-headers": "value",
                "--decryption-keys": "value",
                "--fetch-encrypted-object-hashes": "bool",
                "--raw": "bool",
                "--soft-deleted": "bool"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--additional-headers": "value",
                "--decryption-keys": "value",
                "--exhaustive": "bool",
                "--fetch-encrypted-object-hashes": "bool",
                "--filter": "value",
                "--limit": "value",
                "--next-page-token": "value",
                "--page-size": "value",
                "--raw": "bool",
                "--soft-deleted": "bool",
                "--sort-by": "value",
                "--stat": "bool",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--acl-file": "value",
                "--add-acl-grant": "value",
                "--additional-headers": "value",
                "--all-versions": "bool",
                "--cache-control": "value",
                "--canned-acl": "value",
                "--clear-cache-control": "bool",
                "--clear-content-disposition": "bool",
                "--clear-content-encoding": "bool",
                "--clear-content-language": "bool",
                "--clear-content-type": "bool",
                "--clear-custom-metadata": "bool",
                "--clear-custom-time": "bool",
                "--clear-encryption-key": "bool",
                "--clear-retention": "bool",
                "--content-disposition": "value",
                "--content-encoding": "value",
                "--content-language": "value",
                "--content-type": "value",
                "--continue-on-error": "bool",
                "--custom-metadata": "value",
                "--custom-time": "value",
                "--decryption-keys": "value",
                "--encryption-key": "value",
                "--event-based-hold": "bool",
                "--if-generation-match": "value",
                "--if-metageneration-match": "value",
                "--override-unlocked-retention": "bool",
                "--predefined-acl": "value",
                "--preserve-acl": "bool",
                "--read-paths-from-stdin": "bool",
                "--recursive": "bool",
                "--remove-acl-grant": "value",
                "--remove-custom-metadata": "value",
                "--retain-until": "value",
                "--retention-mode": [
                  "Locked",
                  "Unlocked"
                ],
                "--storage-class": "value",
                "--temporary-hold": "bool",
                "--update-custom-metadata": "value"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--server-filter": "value",
                "--sort-by": "value"
              }
            }
          },
          "flags": {}
        },
        "restore": {
          "commands": {},
          "flags": {
            "--all-versions": "bool",
            "--allow-overwrite": "bool",
            "--async": "bool",
            "--deleted-after-time": "value",
            "--deleted-before-time": "value",
            "--if-generation-match": "value",
            "--if-metageneration-match": "value",
            "--preserve-acl": "bool",
            "--read-paths-from-stdin": "bool"
          }
        },
        "rm": {
          "commands": {},
          "flags": {
            "--additional-headers": "value",
            "--all-versions": "bool",
            "--continue-on-error": "bool",
            "--exclude-managed-folders": "bool",
            "--if-generation-match": "value",
            "--if-metageneration-match": "value",
            "--read-paths-from-stdin": "bool",
            "--recursive": "bool"
          }
        },
        "rsync": {
          "commands": {},
          "flags": {
            "--additional-headers": "value",
            "--cache-control": "value",
            "--canned-acl": "value",
            "--checksums-only": "bool",
            "--clear-custom-metadata": "bool",
            "--content-disposition": "value",
            "--content-encoding": "value",
            "--content-language": "value",
            "--content-md5": "value",
            "--content-type": "value",
            "--continue-on-error": "bool",
            "--custom-metadata": "value",
            "--custom-time": "value",
            "--decryption-keys": "value",
            "--delete-unmatched-destination-objects": "bool",
            "--dry-run": "bool",
            "--encryption-key": "value",
            "--exclude": "value",
            "--gzip-in-flight": "value",
            "--gzip-in-flight-all": "bool",
            "--if-generation-match": "value",
            "--if-metageneration-match": "value",
            "--ignore-symlinks": "bool",
            "--include-managed-folders": "bool",
            "--no-clobber": "bool",
            "--predefined-acl": "value",
            "--preserve-posix": "bool",
            "--recursive": "bool",
            "--remove-custom-metadata": "value",
            "--skip-if-dest-has-newer-mtime": "bool",
            "--skip-unsupported": "bool",
            "--update-custom-metadata": "value"
          }
        },
        "service-agent": {
          "commands": {},
          "flags": {
            "--authorize-cmek": "value"
          }
        },
        "sign-url": {
          "commands": {},
          "flags": {
            "--duration": "value",
            "--headers": "value",
            "--http-verb": "value",
            "--private-key-file": "value",
            "--private-key-password": "value",
            "--query-params": "value",
            "--region": "value"
          }
        }
      },
      "flags": {}
    },
    "survey": {
      "commands": {},
      "flags": {}
    },
    "tasks": {
      "commands": {
        "buffer": {
          "commands": {},
          "flags": {
            "--location": "value",
            "--queue": "value",
            "--task-id": "value"
          }
        },
        "cmek-config": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-kms-key": "bool",
                "--kms-key-name": "value",
                "--kms-keyring": "value",
                "--kms-project": "value",
                "--location": "value"
              }
            }
          },
          "flags": {}
        },
        "create-app-engine-task": {
          "commands": {},
          "flags": {
            "--body-content": "value",
            "--body-file": "value",
            "--header": "value",
            "--location": "value",
            "--method": "value",
            "--queue": "value",
            "--relative-uri": "value",
            "--routing": "value",
            "--schedule-time": "value"
          }
        },
        "create-http-task": {
          "commands": {},
          "flags": {
            "--body-content": "value",
            "--body-file": "value",
            "--header": "value",
            "--location": "value",
            "--method": "value",
            "--oauth-service-account-email": "value",
            "--oauth-token-scope": "value",
            "--oidc-service-account-email": "value",
            "--oidc-token-audience": "value",
            "--queue": "value",
            "--schedule-time": "value",
            "--url": "value"
          }
        },
        "delete": {
          "commands": {},
          "flags": {
            "--location": "value",
            "--queue": "value"
          }
        },
        "describe": {
          "commands": {},
          "flags": {
            "--location": "value",
            "--queue": "value",
            "--response-view": [
              "basic",
              "full",
              "view-unspecified"
            ]
          }
        },
        "list": {
          "commands": {},
          "flags": {
            "--filter": "value",
            "--limit": "value",
            "--location": "value",
            "--page-size": "value",
            "--queue": "value",
            "--sort-by": "value",
            "--uri": "bool"
          }
        },
        "locations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "queues": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--http-header-override": "value",
                "--http-method-override": "value",
                "--http-oauth-service-account-email-override": "value",
                "--http-oauth-token-scope-override": "value",
                "--http-oidc-service-account-email-override": "value",
                "--http-oidc-token-audience-override": "value",
                "--http-uri-override": "value",
                "--location": "value",
                "--log-sampling-ratio": "value",
                "--max-attempts": "value",
                "--max-backoff": "value",
                "--max-concurrent-dispatches": "value",
                "--max-dispatches-per-second": "value",
                "--max-doublings": "value",
                "--max-retry-duration": "value",
                "--min-backoff": "value",
                "--routing-override": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "pause": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "purge": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "resume": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-http-header-override": "bool",
                "--clear-http-method-override": "bool",
                "--clear-http-oauth-service-account-email-override": "bool",
                "--clear-http-oauth-token-scope-override": "bool",
                "--clear-http-oidc-service-account-email-override": "bool",
                "--clear-http-oidc-token-audience-override": "bool",
                "--clear-http-uri-override": "bool",
                "--clear-log-sampling-ratio": "bool",
                "--clear-max-attempts": "bool",
                "--clear-max-backoff": "bool",
                "--clear-max-concurrent-dispatches": "bool",
                "--clear-max-dispatches-per-second": "bool",
                "--clear-max-doublings": "bool",
                "--clear-max-retry-duration": "bool",
                "--clear-min-backoff": "bool",
                "--clear-routing-override": "bool",
                "--http-header-override": "value",
                "--http-method-override": "value",
                "--http-oauth-service-account-email-override": "value",
                "--http-oauth-token-scope-override": "value",
                "--http-oidc-service-account-email-override": "value",
                "--http-oidc-token-audience-override": "value",
                "--http-uri-override": "value",
                "--location": "value",
                "--log-sampling-ratio": "value",
                "--max-attempts": "value",
                "--max-backoff": "value",
                "--max-concurrent-dispatches": "value",
                "--max-dispatches-per-second": "value",
                "--max-doublings": "value",
                "--max-retry-duration": "value",
                "--min-backoff": "value",
                "--routing-override": "value"
              }
            }
          },
          "flags": {}
        },
        "run": {
          "commands": {},
          "flags": {
            "--location": "value",
            "--queue": "value"
          }
        }
      },
      "flags": {}
    },
    "telco-automation": {
      "commands": {
        "operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "wait": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "orchestration-cluster": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--cidr-blocks": "value",
                "--cluster-cidr-block": "value",
                "--cluster-named-range": "value",
                "--full-management-config": "bool",
                "--location": "value",
                "--master-ipv4-cidr-block": "value",
                "--network": "value",
                "--services-cidr-block": "value",
                "--services-named-range": "value",
                "--subnet": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "topic": {
      "commands": {
        "accessibility": {
          "commands": {},
          "flags": {}
        },
        "arg-files": {
          "commands": {},
          "flags": {}
        },
        "cli-trees": {
          "commands": {},
          "flags": {}
        },
        "client-certificate": {
          "commands": {},
          "flags": {}
        },
        "command-conventions": {
          "commands": {},
          "flags": {}
        },
        "configurations": {
          "commands": {},
          "flags": {}
        },
        "datetimes": {
          "commands": {},
          "flags": {}
        },
        "endpoint-override": {
          "commands": {},
          "flags": {}
        },
        "escaping": {
          "commands": {},
          "flags": {}
        },
        "filters": {
          "commands": {},
          "flags": {}
        },
        "flags-file": {
          "commands": {},
          "flags": {}
        },
        "formats": {
          "commands": {},
          "flags": {}
        },
        "gcloudignore": {
          "commands": {},
          "flags": {}
        },
        "offline-help": {
          "commands": {},
          "flags": {}
        },
        "projections": {
          "commands": {},
          "flags": {}
        },
        "resource-keys": {
          "commands": {},
          "flags": {}
        },
        "startup": {
          "commands": {},
          "flags": {}
        },
        "uninstall": {
          "commands": {},
          "flags": {}
        }
      },
      "flags": {}
    },
    "transcoder": {
      "commands": {
        "jobs": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--batch-mode-priority": "value",
                "--file": "value",
                "--input-uri": "value",
                "--json": "value",
                "--labels": "value",
                "--location": "value",
                "--mode": [
                  "PROCESSING_MODE_BATCH",
                  "PROCESSING_MODE_INTERACTIVE"
                ],
                "--optimization": [
                  "AUTODETECT",
                  "DISABLED"
                ],
                "--output-uri": "value",
                "--template-id": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "templates": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--file": "value",
                "--json": "value",
                "--labels": "value",
                "--location": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "transfer": {
      "commands": {
        "agent-pools": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--bandwidth-limit": "value",
                "--display-name": "value",
                "--no-async": "bool"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--limit": "value",
                "--names": "value",
                "--page-size": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--bandwidth-limit": "value",
                "--clear-bandwidth-limit": "bool",
                "--clear-display-name": "bool",
                "--display-name": "value"
              }
            }
          },
          "flags": {}
        },
        "agents": {
          "commands": {
            "delete": {
              "commands": {},
              "flags": {
                "--all": "bool",
                "--ids": "value",
                "--uninstall": "bool"
              }
            },
            "install": {
              "commands": {},
              "flags": {
                "--count": "value",
                "--creds-file": "value",
                "--docker-network": "value",
                "--enable-multipart": "bool",
                "--hdfs-data-transfer-protection": [
                  "authentication",
                  "integrity",
                  "privacy"
                ],
                "--hdfs-namenode-uri": "value",
                "--hdfs-username": "value",
                "--id-prefix": "value",
                "--kerberos-config-file": "value",
                "--kerberos-keytab-file": "value",
                "--kerberos-service-principal": "value",
                "--kerberos-user-principal": "value",
                "--logs-directory": "value",
                "--memlock-limit": "value",
                "--mount-directories": "value",
                "--pool": "value",
                "--proxy": "value",
                "--s3-compatible-mode": "bool"
              }
            }
          },
          "flags": {}
        },
        "authorize": {
          "commands": {},
          "flags": {
            "--add-missing": "bool",
            "--creds-file": "value"
          }
        },
        "jobs": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--custom-storage-class": "value",
                "--delete-from": [
                  "destination-if-unique",
                  "source-after-transfer"
                ],
                "--description": "value",
                "--destination-agent-pool": "value",
                "--do-not-run": "bool",
                "--enable-posix-transfer-logs": "bool",
                "--event-stream-expires": "value",
                "--event-stream-name": "value",
                "--event-stream-starts": "value",
                "--exclude-prefixes": "value",
                "--include-modified-after-absolute": "value",
                "--include-modified-after-relative": "value",
                "--include-modified-before-absolute": "value",
                "--include-modified-before-relative": "value",
                "--include-prefixes": "value",
                "--intermediate-storage-path": "value",
                "--log-action-states": "value",
                "--log-actions": "value",
                "--manifest-file": "value",
                "--name": "value",
                "--no-async": "bool",
                "--notification-event-types": "value",
                "--notification-payload-format": [
                  "json",
                  "none"
                ],
                "--notification-pubsub-topic": "value",
                "--overwrite-when": [
                  "always",
                  "different",
                  "never"
                ],
                "--preserve-metadata": "value",
                "--schedule-repeats-every": "value",
                "--schedule-repeats-until": "value",
                "--schedule-starts": "value",
                "--source-agent-pool": "value",
                "--source-auth-method": [
                  "AWS_SIGNATURE_V2",
                  "AWS_SIGNATURE_V4"
                ],
                "--source-creds-file": "value",
                "--source-endpoint": "value",
                "--source-list-api": [
                  "LIST_OBJECTS",
                  "LIST_OBJECTS_V2"
                ],
                "--source-network-protocol": [
                  "HTTP",
                  "HTTPS"
                ],
                "--source-request-model": [
                  "PATH_STYLE",
                  "VIRTUAL_HOSTED_STYLE"
                ],
                "--source-signing-region": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--expand-table": "bool",
                "--job-names": "value",
                "--job-statuses": "value",
                "--limit": "value",
                "--page-size": "value"
              }
            },
            "monitor": {
              "commands": {},
              "flags": {}
            },
            "run": {
              "commands": {},
              "flags": {
                "--no-async": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--clear-custom-storage-class": "bool",
                "--clear-delete-from": "bool",
                "--clear-description": "bool",
                "--clear-destination-agent-pool": "bool",
                "--clear-event-stream": "bool",
                "--clear-exclude-prefixes": "bool",
                "--clear-include-modified-after-absolute": "bool",
                "--clear-include-modified-after-relative": "bool",
                "--clear-include-modified-before-absolute": "bool",
                "--clear-include-modified-before-relative": "bool",
                "--clear-include-prefixes": "bool",
                "--clear-intermediate-storage-path": "bool",
                "--clear-log-config": "bool",
                "--clear-manifest-file": "bool",
                "--clear-notification-config": "bool",
                "--clear-notification-event-types": "bool",
                "--clear-preserve-metadata": "bool",
                "--clear-schedule": "bool",
                "--clear-source-agent-pool": "bool",
                "--clear-source-auth-method": "bool",
                "--clear-source-creds-file": "bool",
                "--clear-source-endpoint": "bool",
                "--clear-source-list-api": "bool",
                "--clear-source-network-protocol": "bool",
                "--clear-source-request-model": "bool",
                "--clear-source-signing-region": "bool",
                "--custom-storage-class": "value",
                "--delete-from": [
                  "destination-if-unique",
                  "source-after-transfer"
                ],
                "--description": "value",
                "--destination": "value",
                "--destination-agent-pool": "value",
                "--enable-posix-transfer-logs": "bool",
                "--event-stream-expires": "value",
                "--event-stream-name": "value",
                "--event-stream-starts": "value",
                "--exclude-prefixes": "value",
                "--include-modified-after-absolute": "value",
                "--include-modified-after-relative": "value",
                "--include-modified-before-absolute": "value",
                "--include-modified-before-relative": "value",
                "--include-prefixes": "value",
                "--intermediate-storage-path": "value",
                "--log-action-states": "value",
                "--log-actions": "value",
                "--manifest-file": "value",
                "--notification-event-types": "value",
                "--notification-payload-format": [
                  "json",
                  "none"
                ],
                "--notification-pubsub-topic": "value",
                "--overwrite-when": [
                  "always",
                  "different",
                  "never"
                ],
                "--preserve-metadata": "value",
                "--schedule-repeats-every": "value",
                "--schedule-repeats-until": "value",
                "--schedule-starts": "value",
                "--source": "value",
                "--source-agent-pool": "value",
                "--source-auth-method": [
                  "AWS_SIGNATURE_V2",
                  "AWS_SIGNATURE_V4"
                ],
                "--source-creds-file": "value",
                "--source-endpoint": "value",
                "--source-list-api": [
                  "LIST_OBJECTS",
                  "LIST_OBJECTS_V2"
                ],
                "--source-network-protocol": [
                  "HTTP",
                  "HTTPS"
                ],
                "--source-request-model": [
                  "PATH_STYLE",
                  "VIRTUAL_HOSTED_STYLE"
                ],
                "--source-signing-region": "value",
                "--status": [
                  "deleted",
                  "disabled",
                  "enabled"
                ]
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {}
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--expand-table": "bool",
                "--job-names": "value",
                "--limit": "value",
                "--operation-names": "value",
                "--operation-statuses": "value",
                "--page-size": "value"
              }
            },
            "monitor": {
              "commands": {},
              "flags": {}
            },
            "pause": {
              "commands": {},
              "flags": {}
            },
            "resume": {
              "commands": {},
              "flags": {}
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "version": {
      "commands": {},
      "flags": {}
    },
    "vmware": {
      "commands": {
        "dns-bind-permission": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {}
            },
            "grant": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--service-account": "value",
                "--user": "value"
              }
            },
            "revoke": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--service-account": "value",
                "--user": "value"
              }
            }
          },
          "flags": {}
        },
        "locations": {
          "commands": {
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "network-peerings": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--exchange-subnet-routes": "bool",
                "--export-custom-routes": "bool",
                "--export-custom-routes-with-public-ip": "bool",
                "--import-custom-routes": "bool",
                "--import-custom-routes-with-public-ip": "bool",
                "--location": "dynamic",
                "--peer-mtu": "value",
                "--peer-network": "value",
                "--peer-network-type": [
                  "DELL_POWERSCALE",
                  "GOOGLE_CLOUD_NETAPP_VOLUMES",
                  "NETAPP_CLOUD_VOLUMES",
                  "PEER_NETWORK_TYPE_UNSPECIFIED",
                  "PRIVATE_SERVICES_ACCESS",
                  "STANDARD",
                  "THIRD_PARTY_SERVICE",
                  "VMWARE_ENGINE_NETWORK"
                ],
                "--peer-project": "value",
                "--vmware-engine-network": "value",
                "--vmware-engine-network-project": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "routes": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--network-peering": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--location": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "network-policies": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--edge-services-cidr": "value",
                "--external-ip-access": "bool",
                "--internet-access": "bool",
                "--location": "dynamic",
                "--vmware-engine-network": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "external-access-rules": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--action": [
                      "ALLOW",
                      "DENY"
                    ],
                    "--async": "bool",
                    "--description": "value",
                    "--destination-ports": "value",
                    "--destination-ranges": "value",
                    "--ip-protocol": [
                      "ICMP",
                      "TCP",
                      "UDP"
                    ],
                    "--location": "dynamic",
                    "--network-policy": "dynamic",
                    "--priority": "value",
                    "--source-ports": "value",
                    "--source-ranges": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic",
                    "--network-policy": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic",
                    "--network-policy": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--network-policy": "dynamic",
                    "--page-size": "value",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--action": [
                      "ALLOW",
                      "DENY"
                    ],
                    "--async": "bool",
                    "--description": "value",
                    "--destination-ports": "value",
                    "--destination-ranges": "value",
                    "--ip-protocol": [
                      "ICMP",
                      "TCP",
                      "UDP"
                    ],
                    "--location": "dynamic",
                    "--network-policy": "dynamic",
                    "--priority": "value",
                    "--source-ports": "value",
                    "--source-ranges": "value"
                  }
                }
              },
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--edge-services-cidr": "value",
                "--external-ip-access": "bool",
                "--internet-access": "bool",
                "--location": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "networks": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--location": "dynamic",
                "--type": [
                  "LEGACY",
                  "STANDARD"
                ]
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--location": "dynamic"
              }
            }
          },
          "flags": {}
        },
        "node-types": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "operations": {
          "commands": {
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            }
          },
          "flags": {}
        },
        "private-clouds": {
          "commands": {
            "clusters": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic",
                    "--node-type-config": "value",
                    "--private-cloud": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic",
                    "--private-cloud": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic",
                    "--private-cloud": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--private-cloud": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "nodes": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--cluster": "dynamic",
                        "--location": "dynamic",
                        "--private-cloud": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--cluster": "dynamic",
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--private-cloud": "dynamic",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--autoscaling-cool-down-period": "value",
                    "--autoscaling-max-cluster-node-count": "value",
                    "--autoscaling-min-cluster-node-count": "value",
                    "--autoscaling-settings-from-file": "value",
                    "--location": "dynamic",
                    "--node-type-config": "value",
                    "--private-cloud": "dynamic",
                    "--remove-autoscaling-policy": "value",
                    "--remove-nodes-config": "value",
                    "--update-autoscaling-policy": "value",
                    "--update-nodes-config": "value"
                  }
                }
              },
              "flags": {}
            },
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--cluster": "dynamic",
                "--description": "value",
                "--location": "dynamic",
                "--management-range": "value",
                "--node-type-config": "value",
                "--preferred-zone": "value",
                "--secondary-zone": "value",
                "--type": [
                  "STANDARD",
                  "STRETCHED",
                  "TIME_LIMITED"
                ],
                "--vmware-engine-network": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--delay-hours": [
                  0,
                  1,
                  2,
                  3,
                  4,
                  5,
                  6,
                  7,
                  8
                ],
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "dns-forwarding": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic",
                    "--private-cloud": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic",
                    "--private-cloud": "dynamic",
                    "--rule": "value"
                  }
                }
              },
              "flags": {}
            },
            "external-addresses": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--internal-ip": "value",
                    "--location": "dynamic",
                    "--private-cloud": "dynamic"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic",
                    "--private-cloud": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic",
                    "--private-cloud": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--private-cloud": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--internal-ip": "value",
                    "--location": "dynamic",
                    "--private-cloud": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "hcx": {
              "commands": {
                "activationkeys": {
                  "commands": {
                    "create": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "dynamic",
                        "--private-cloud": "dynamic"
                      }
                    },
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic",
                        "--private-cloud": "dynamic"
                      }
                    },
                    "list": {
                      "commands": {},
                      "flags": {
                        "--filter": "value",
                        "--limit": "value",
                        "--location": "dynamic",
                        "--page-size": "value",
                        "--private-cloud": "dynamic",
                        "--sort-by": "value",
                        "--uri": "bool"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "logging-servers": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--hostname": "value",
                    "--location": "dynamic",
                    "--port": "value",
                    "--private-cloud": "dynamic",
                    "--protocol": [
                      "RELP",
                      "SSL",
                      "TCP",
                      "TLS",
                      "UDP"
                    ],
                    "--source-type": [
                      "ESXI",
                      "VCSA"
                    ]
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic",
                    "--private-cloud": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic",
                    "--private-cloud": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--private-cloud": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--hostname": "value",
                    "--location": "dynamic",
                    "--port": "value",
                    "--private-cloud": "dynamic",
                    "--protocol": [
                      "RELP",
                      "SSL",
                      "TCP",
                      "TLS",
                      "UDP"
                    ],
                    "--source-type": [
                      "ESXI",
                      "VCSA"
                    ]
                  }
                }
              },
              "flags": {}
            },
            "management-dns-zone-bindings": {
              "commands": {
                "create": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--location": "dynamic",
                    "--private-cloud": "dynamic",
                    "--vmware-engine-network": "value",
                    "--vpc-network": "value"
                  }
                },
                "delete": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic",
                    "--private-cloud": "dynamic"
                  }
                },
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic",
                    "--private-cloud": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--private-cloud": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "repair": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--location": "dynamic",
                    "--private-cloud": "dynamic"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--async": "bool",
                    "--description": "value",
                    "--location": "dynamic",
                    "--private-cloud": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "nsx": {
              "commands": {
                "credentials": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic",
                        "--private-cloud": "dynamic"
                      }
                    },
                    "reset": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "dynamic",
                        "--private-cloud": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            },
            "subnets": {
              "commands": {
                "describe": {
                  "commands": {},
                  "flags": {
                    "--location": "dynamic",
                    "--private-cloud": "dynamic"
                  }
                },
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--private-cloud": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                },
                "update": {
                  "commands": {},
                  "flags": {
                    "--ip-cidr-range": "value",
                    "--location": "dynamic",
                    "--private-cloud": "dynamic"
                  }
                }
              },
              "flags": {}
            },
            "undelete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--location": "dynamic"
              }
            },
            "vcenter": {
              "commands": {
                "credentials": {
                  "commands": {
                    "describe": {
                      "commands": {},
                      "flags": {
                        "--location": "dynamic",
                        "--private-cloud": "dynamic"
                      }
                    },
                    "reset": {
                      "commands": {},
                      "flags": {
                        "--async": "bool",
                        "--location": "dynamic",
                        "--private-cloud": "dynamic"
                      }
                    }
                  },
                  "flags": {}
                }
              },
              "flags": {}
            }
          },
          "flags": {}
        },
        "private-connections": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--location": "dynamic",
                "--routing-mode": [
                  "GLOBAL",
                  "REGIONAL"
                ],
                "--service-network": "value",
                "--service-project": "value",
                "--type": [
                  "DELL_POWERSCALE",
                  "NETAPP_CLOUD_VOLUMES",
                  "PRIVATE_SERVICE_ACCESS",
                  "THIRD_PARTY_SERVICE"
                ],
                "--vmware-engine-network": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "routes": {
              "commands": {
                "list": {
                  "commands": {},
                  "flags": {
                    "--filter": "value",
                    "--limit": "value",
                    "--location": "dynamic",
                    "--page-size": "value",
                    "--private-connection": "dynamic",
                    "--sort-by": "value",
                    "--uri": "bool"
                  }
                }
              },
              "flags": {}
            },
            "update": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--description": "value",
                "--location": "dynamic",
                "--routing-mode": [
                  "GLOBAL",
                  "REGIONAL"
                ]
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "workbench": {
      "commands": {
        "instances": {
          "commands": {
            "add-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "dynamic",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "check-instance-upgradability": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "create": {
              "commands": {},
              "flags": {
                "--accelerator-core-count": "value",
                "--accelerator-type": [
                  "NVIDIA_A100_80GB",
                  "NVIDIA_H100_80GB",
                  "NVIDIA_H100_MEGA_80GB",
                  "NVIDIA_L4",
                  "NVIDIA_TESLA_A100",
                  "NVIDIA_TESLA_K80",
                  "NVIDIA_TESLA_P100",
                  "NVIDIA_TESLA_P100_VWS",
                  "NVIDIA_TESLA_P4",
                  "NVIDIA_TESLA_P4_VWS",
                  "NVIDIA_TESLA_T4",
                  "NVIDIA_TESLA_T4_VWS",
                  "NVIDIA_TESLA_V100"
                ],
                "--async": "bool",
                "--boot-disk-encryption": [
                  "CMEK",
                  "GMEK"
                ],
                "--boot-disk-encryption-key-keyring": "dynamic",
                "--boot-disk-encryption-key-location": "dynamic",
                "--boot-disk-encryption-key-project": "dynamic",
                "--boot-disk-kms-key": "dynamic",
                "--boot-disk-size": "value",
                "--boot-disk-type": [
                  "PD_BALANCED",
                  "PD_EXTREME",
                  "PD_SSD",
                  "PD_STANDARD"
                ],
                "--container-repository": "value",
                "--container-tag": "value",
                "--custom-gpu-driver-path": "value",
                "--data-disk-encryption": [
                  "CMEK",
                  "GMEK"
                ],
                "--data-disk-encryption-key-keyring": "dynamic",
                "--data-disk-encryption-key-location": "dynamic",
                "--data-disk-encryption-key-project": "dynamic",
                "--data-disk-kms-key": "dynamic",
                "--data-disk-size": "value",
                "--data-disk-type": [
                  "PD_BALANCED",
                  "PD_EXTREME",
                  "PD_SSD",
                  "PD_STANDARD"
                ],
                "--disable-proxy-access": "bool",
                "--disable-public-ip": "bool",
                "--enable-ip-forwarding": "bool",
                "--enable-third-party-identity": "bool",
                "--install-gpu-driver": "bool",
                "--instance-owners": "value",
                "--labels": "value",
                "--location": "dynamic",
                "--machine-type": "value",
                "--metadata": "value",
                "--min-cpu-platform": "value",
                "--network": "dynamic",
                "--nic-type": [
                  "GVNIC",
                  "VIRTIGO_NET"
                ],
                "--service-account-email": "value",
                "--shielded-integrity-monitoring": "value",
                "--shielded-secure-boot": "value",
                "--shielded-vtpm": "value",
                "--subnet": "dynamic",
                "--subnet-region": "dynamic",
                "--tags": "value",
                "--vm-image-family": "value",
                "--vm-image-name": "value",
                "--vm-image-project": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "diagnose": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--enable-copy-home-files": "bool",
                "--enable-packet-capture": "bool",
                "--enable-repair": "bool",
                "--gcs-bucket": "value",
                "--location": "dynamic",
                "--relative-path": "value"
              }
            },
            "get-config": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "dynamic",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "remove-iam-policy-binding": {
              "commands": {},
              "flags": {
                "--location": "dynamic",
                "--member": "value",
                "--role": "dynamic"
              }
            },
            "reset": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "resize-disk": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--boot-disk-size": "value",
                "--data-disk-size": "value",
                "--location": "dynamic"
              }
            },
            "restore": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic",
                "--snapshot": "value",
                "--snapshot-project": "value"
              }
            },
            "rollback": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic",
                "--target-snapshot": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--location": "dynamic"
              }
            },
            "start": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "stop": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--accelerator-core-count": "value",
                "--accelerator-type": [
                  "NVIDIA_A100_80GB",
                  "NVIDIA_H100_80GB",
                  "NVIDIA_H100_MEGA_80GB",
                  "NVIDIA_L4",
                  "NVIDIA_TESLA_A100",
                  "NVIDIA_TESLA_K80",
                  "NVIDIA_TESLA_P100",
                  "NVIDIA_TESLA_P100_VWS",
                  "NVIDIA_TESLA_P4",
                  "NVIDIA_TESLA_P4_VWS",
                  "NVIDIA_TESLA_T4",
                  "NVIDIA_TESLA_T4_VWS",
                  "NVIDIA_TESLA_V100"
                ],
                "--async": "bool",
                "--custom-gpu-driver-path": "value",
                "--install-gpu-driver": "value",
                "--labels": "value",
                "--location": "dynamic",
                "--machine-type": "value",
                "--metadata": "value",
                "--shielded-integrity-monitoring": "value",
                "--shielded-secure-boot": "value",
                "--shielded-vtpm": "value",
                "--tags": "value"
              }
            },
            "upgrade": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--location": "dynamic"
              }
            }
          },
          "flags": {}
        }
      },
      "flags": {}
    },
    "workflows": {
      "commands": {
        "delete": {
          "commands": {},
          "flags": {
            "--async": "bool",
            "--location": "value"
          }
        },
        "deploy": {
          "commands": {},
          "flags": {
            "--async": "bool",
            "--call-log-level": [
              "log-all-calls",
              "log-errors-only",
              "log-none",
              "none"
            ],
            "--description": "value",
            "--labels": "value",
            "--location": "value",
            "--service-account": "value",
            "--source": "value"
          }
        },
        "describe": {
          "commands": {},
          "flags": {
            "--location": "value",
            "--revision-id": "value"
          }
        },
        "execute": {
          "commands": {},
          "flags": {
            "--call-log-level": [
              "log-all-calls",
              "log-errors-only",
              "log-none",
              "none"
            ],
            "--data": "value",
            "--disable-concurrency-quota-overflow-buffering": "bool",
            "--labels": "value",
            "--location": "value"
          }
        },
        "executions": {
          "commands": {
            "cancel": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--workflow": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--workflow": "value"
              }
            },
            "describe-last": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--location": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "wait": {
              "commands": {},
              "flags": {
                "--location": "value",
                "--workflow": "value"
              }
            },
            "wait-last": {
              "commands": {},
              "flags": {}
            }
          },
          "flags": {}
        },
        "list": {
          "commands": {},
          "flags": {
            "--filter": "value",
            "--limit": "value",
            "--location": "value",
            "--page-size": "value",
            "--sort-by": "value",
            "--uri": "bool"
          }
        },
        "run": {
          "commands": {},
          "flags": {
            "--call-log-level": [
              "log-all-calls",
              "log-errors-only",
              "log-none",
              "none"
            ],
            "--data": "value",
            "--disable-concurrency-quota-overflow-buffering": "bool",
            "--labels": "value",
            "--location": "value"
          }
        }
      },
      "flags": {}
    },
    "workspace-add-ons": {
      "commands": {
        "deployments": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--deployment-file": "value",
                "--deployment-object": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--etag": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {}
            },
            "install": {
              "commands": {},
              "flags": {}
            },
            "install-status": {
              "commands": {},
              "flags": {}
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--sort-by": "value",
                "--uri": "bool"
              }
            },
            "replace": {
              "commands": {},
              "flags": {
                "--deployment-file": "value",
                "--deployment-object": "value",
                "--etag": "value"
              }
            },
            "uninstall": {
              "commands": {},
              "flags": {}
            }
          },
          "flags": {}
        },
        "get-authorization": {
          "commands": {},
          "flags": {}
        }
      },
      "flags": {}
    },
    "workstations": {
      "commands": {
        "clusters": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--domain": "value",
                "--enable-private-endpoint": "bool",
                "--labels": "value",
                "--network": "value",
                "--region": "value",
                "--subnetwork": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--region": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value"
              }
            }
          },
          "flags": {}
        },
        "configs": {
          "commands": {
            "create": {
              "commands": {},
              "flags": {
                "--accelerator-count": "value",
                "--accelerator-type": "value",
                "--allowed-ports": "value",
                "--async": "bool",
                "--boot-disk-size": "value",
                "--cluster": "dynamic",
                "--container-args": "value",
                "--container-command": "value",
                "--container-custom-image": "value",
                "--container-env": "value",
                "--container-predefined-image": [
                  "base-image",
                  "clion",
                  "codeoss",
                  "codeoss-cuda",
                  "goland",
                  "intellij",
                  "phpstorm",
                  "pycharm",
                  "rider",
                  "rubymine",
                  "webstorm"
                ],
                "--container-run-as-user": "value",
                "--container-working-dir": "value",
                "--disable-public-ip-addresses": "bool",
                "--disable-ssh-to-vm": "bool",
                "--disable-tcp-connections": "bool",
                "--enable-audit-agent": "bool",
                "--enable-confidential-compute": "bool",
                "--enable-nested-virtualization": "bool",
                "--enable-ssh-to-vm": "bool",
                "--ephemeral-directory": "value",
                "--grant-workstation-admin-role-on-create": "bool",
                "--idle-timeout": "value",
                "--kms-key": "value",
                "--kms-key-service-account": "value",
                "--labels": "value",
                "--machine-type": "value",
                "--max-usable-workstations-count": "value",
                "--network-tags": "value",
                "--pd-disk-size": [
                  10,
                  50,
                  100,
                  200,
                  500,
                  1000
                ],
                "--pd-disk-type": [
                  "pd-balanced",
                  "pd-ssd",
                  "pd-standard"
                ],
                "--pd-reclaim-policy": [
                  "delete",
                  "retain"
                ],
                "--pd-source-snapshot": "value",
                "--pool-size": "value",
                "--region": "value",
                "--replica-zones": "value",
                "--running-timeout": "value",
                "--service-account": "value",
                "--service-account-scopes": "value",
                "--shielded-integrity-monitoring": "bool",
                "--shielded-secure-boot": "bool",
                "--shielded-vtpm": "bool",
                "--vm-tags": "value"
              }
            },
            "delete": {
              "commands": {},
              "flags": {
                "--async": "bool",
                "--cluster": "value",
                "--region": "value"
              }
            },
            "describe": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--region": "value"
              }
            },
            "get-iam-policy": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value"
              }
            },
            "list": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--filter": "value",
                "--limit": "value",
                "--page-size": "value",
                "--region": "value",
                "--sort-by": "value"
              }
            },
            "set-iam-policy": {
              "commands": {},
              "flags": {
                "--cluster": "value",
                "--region": "value"
              }
            },
            "update": {
              "commands": {},
              "flags": {
                "--accelerator-count": "value",
                "--accelerator-type": "value",
                "--allowed-ports": "value",
                "--async": "bool",
                "--boot-disk-size": "value",
                "--cluster": "dynamic",
                "--container-args": "value",
                "--container-command": "value",
                "--container-custom-image": "value",
                "--container-env": "value",
                "--container-predefined-image": [
                  "base-image",
                  "clion",
                  "codeoss",
                  "codeoss-cuda",
                  "goland",
                  "intellij",
                  "phpstorm",
                  "pycharm",
                  "rider",
                  "rubymine",
                  "webstorm"
                ],
                "--container-run-as-user": "value",
                "--container-working-dir": "value",
                "--disable-public-ip-addresses": "bool",
                "--disable-ssh-to-vm": "bool",
                "--disable-tcp-connections": "bool",
                "--enable-audit-agent": "bool",
                "--enable-confidential-compute": "bool",
                "--enable-nested-virtualization": "bool",
                "--enable-ssh-to-vm": "bool",
                "--enable-tcp-connections": "bool",
                "--grant-workstation-admin-role-on-create": "bool",
                "--idle-timeout": "value",
                "--labels": "value",
                "--machine-type": "value",
                "--max-usable-workstations-count": "value",
                "--network-tags": "value",
                "--pd-source-snapshot": "value",
                "--pool-size": "value",
                "--region": "value",
                "--running-timeout": "value",
                "--service-account": "value",
                "--service-account-scopes": "value",
                "--shielded-integrity-monitoring": "bool",
                "--shielded-secure-boot": "bool",
                "--shielded-vtpm": "bool",
                "--vm-tags": "value"
              }
            }
          },
          "flags": {}
        },
        "create": {
          "commands": {},
          "flags": {
            "--async": "bool",
            "--cluster": "value",
            "--config": "value",
            "--env": "value",
            "--labels": "value",
            "--region": "value",
            "--source-workstation": "value"
          }
        },
        "delete": {
          "commands": {},
          "flags": {
            "--async": "bool",
            "--cluster": "value",
            "--config": "value",
            "--region": "value"
          }
        },
        "describe": {
          "commands": {},
          "flags": {
            "--cluster": "value",
            "--config": "value",
            "--region": "value"
          }
        },
        "get-iam-policy": {
          "commands": {},
          "flags": {
            "--cluster": "value",
            "--config": "value",
            "--filter": "value",
            "--limit": "value",
            "--page-size": "value",
            "--region": "value",
            "--sort-by": "value"
          }
        },
        "list": {
          "commands": {},
          "flags": {
            "--cluster": "value",
            "--config": "value",
            "--filter": "value",
            "--limit": "value",
            "--page-size": "value",
            "--region": "value",
            "--sort-by": "value"
          }
        },
        "list-usable": {
          "commands": {},
          "flags": {
            "--cluster": "dynamic",
            "--config": "dynamic",
            "--filter": "value",
            "--limit": "value",
            "--page-size": "value",
            "--region": "value",
            "--sort-by": "value"
          }
        },
        "set-iam-policy": {
          "commands": {},
          "flags": {
            "--cluster": "value",
            "--config": "value",
            "--region": "value"
          }
        },
        "ssh": {
          "commands": {},
          "flags": {
            "--cluster": "value",
            "--command": "value",
            "--config": "value",
            "--local-host-port": "value",
            "--port": "value",
            "--region": "value",
            "--user": "value"
          }
        },
        "start": {
          "commands": {},
          "flags": {
            "--async": "bool",
            "--cluster": "value",
            "--config": "value",
            "--region": "value"
          }
        },
        "start-tcp-tunnel": {
          "commands": {},
          "flags": {
            "--cluster": "value",
            "--config": "value",
            "--local-host-port": "value",
            "--region": "value"
          }
        },
        "stop": {
          "commands": {},
          "flags": {
            "--async": "bool",
            "--cluster": "value",
            "--config": "value",
            "--region": "value"
          }
        }
      },
      "flags": {}
    }
  },
  "flags": {
    "--access-token-file": "value",
    "--account": "value",
    "--billing-project": "value",
    "--configuration": "value",
    "--flags-file": "value",
    "--flatten": "value",
    "--format": "value",
    "--help": "bool",
    "--impersonate-service-account": "value",
    "--log-http": "bool",
    "--project": "dynamic",
    "--quiet": "bool",
    "--trace-token": "value",
    "--user-output-enabled": "bool",
    "--verbosity": [
      "critical",
      "debug",
      "error",
      "info",
      "none",
      "warning"
    ],
    "--version": "bool"
  }
}
